/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var X=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/platform","vs/base/common/path","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/platform/log/common/log","vs/base/common/resources","vs/base/common/types","vs/base/common/network","vs/base/node/pfs","vs/base/common/strings","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/platform/userDataSync/common/userDataSync","vs/base/common/arrays","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/base/common/json","vs/base/common/process","os","vs/base/parts/ipc/common/ipc","vs/platform/configuration/common/configurationRegistry","vs/base/common/map","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/base/common/extpath","child_process","vs/base/common/errorMessage","vs/platform/product/common/product","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/codicons","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/common/glob","vs/base/node/decoder","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","util","path","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],Q=function(G){for(var e=[],p=0,L=G.length;p<L;p++)e[p]=X[G[p]];return e};define(X[87],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(L,D){if(!L)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=p}),define(X[63],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const p=Object.prototype.hasOwnProperty;function L(n){const y=[];for(let v in n)p.call(n,v)&&y.push(n[v]);return y}e.values=L;function D(n,y){for(let v in n)if(p.call(n,v)&&y({key:v,value:n[v]},function(){delete n[v]})===!1)return}e.forEach=D;function k(n,y){const v=Object.create(null);for(const m of n){const h=y(m);let C=v[h];C||(C=v[h]=[]),C.push(m)}return v}e.groupBy=k;function A(n){const y=Object.create(null);return n&&n.forEach((v,m)=>{y[m]=v}),y}e.fromMap=A;function R(n,y){const v=[],m=[];for(let h of n)y.has(h)||v.push(h);for(let h of y)n.has(h)||m.push(h);return{removed:v,added:m}}e.diffSets=R;function S(n,y){const v=[],m=[];for(let[h,C]of n)y.has(h)||v.push(C);for(let[h,C]of y)n.has(h)||m.push(C);return{removed:v,added:m}}e.diffMaps=S;class w{constructor(){this.map=new Map}add(y,v){let m=this.map.get(y);m||(m=new Set,this.map.set(y,m)),m.add(v)}delete(y,v){const m=this.map.get(y);!m||(m.delete(v),m.size===0&&this.map.delete(y))}forEach(y,v){const m=this.map.get(y);!m||m.forEach(v)}}e.SetMap=w}),define(X[64],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(A){return(R,S,w)=>{let n=null,y=null;if(typeof w.value=="function"?(n="value",y=w.value):typeof w.get=="function"&&(n="get",y=w.get),!y)throw new Error("not supported");w[n]=A(y,S)}}e.createDecorator=p;function L(A,R,S){let w=null,n=null;if(typeof S.value=="function"?(w="value",n=S.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(w="get",n=S.get),!n)throw new Error("not supported");const y=`$memoize$${R}`;S[w]=function(...v){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,v)}),this[y]}}e.memoize=L;function D(A,R,S){return p((w,n)=>{const y=`$debounce$${n}`,v=`$debounce$result$${n}`;return function(...m){this[v]||(this[v]=S?S():void 0),clearTimeout(this[y]),R&&(this[v]=R(this[v],...m),m=[this[v]]),this[y]=setTimeout(()=>{w.apply(this,m),this[v]=S?S():void 0},A)}})}e.debounce=D;function k(A,R,S){return p((w,n)=>{const y=`$throttle$timer$${n}`,v=`$throttle$result$${n}`,m=`$throttle$lastRun$${n}`,h=`$throttle$pending$${n}`;return function(...C){if(this[v]||(this[v]=S?S():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),R&&(this[v]=R(this[v],...C)),this[h])return;const P=this[m]+A;P<=Date.now()?(this[m]=Date.now(),w.apply(this,[this[v]]),this[v]=S?S():void 0):(this[h]=!0,this[y]=setTimeout(()=>{this[h]=!1,this[m]=Date.now(),w.apply(this,[this[v]]),this[v]=S?S():void 0},P-Date.now()))}})}e.throttle=k}),define(X[9],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=p,e.errorHandler=new p;function L(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=L;function D(c){S(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=D;function k(c){S(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=k;function A(c){if(c instanceof Error){let{name:t,message:r}=c;const i=c.stacktrace||c.stack;return{$isError:!0,name:t,message:r,stack:i}}return c}e.transformErrorForSerialization=A;const R="Canceled";function S(c){return c instanceof Error&&c.name===R&&c.message===R}e.isPromiseCanceledError=S;class w extends Error{constructor(){super(R);this.name=this.message}}e.CancellationError=w;function n(){const c=new Error(R);return c.name=c.message,c}e.canceled=n;function y(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=y;function v(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=v;function m(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function h(c){const t=new Error(`${c} has been disposed`);return t.name="DISPOSED",t}e.disposed=h;function C(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=C;class P extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=P;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class I extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=I;function f(c){const t=c;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=f;function s(c,t=Object.create(null)){const r=new Error(c);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=s}),define(X[23],Q([0,1,9]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(F,U=0){return F[F.length-(1+U)]}e.tail=L;function D(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=D;function k(F,U,x=(q,H)=>q===H){if(F===U)return!0;if(!F||!U||F.length!==U.length)return!1;for(let q=0,H=F.length;q<H;q++)if(!x(F[q],U[q]))return!1;return!0}e.equals=k;function A(F,U,x){let q=0,H=F.length-1;for(;q<=H;){const Y=(q+H)/2|0,te=x(F[Y],U);if(te<0)q=Y+1;else if(te>0)H=Y-1;else return Y}return-(q+1)}e.binarySearch=A;function R(F,U){let x=0,q=F.length;if(q===0)return 0;for(;x<q;){const H=Math.floor((x+q)/2);U(F[H])?q=H:x=H+1}return x}e.findFirstInSorted=R;function S(F,U,x){if(F=F|0,F>=U.length)throw new TypeError("invalid index");let q=U[Math.floor(U.length*Math.random())],H=[],Y=[],te=[];for(let ne of U){const se=x(ne,q);se<0?H.push(ne):se>0?Y.push(ne):te.push(ne)}return F<H.length?S(F,H,x):F<H.length+te.length?te[0]:S(F-(H.length+te.length),Y,x)}e.quickSelect=S;function w(F,U){const x=[];let q;for(const H of F.slice(0).sort(U))!q||U(q[0],H)!==0?(q=[H],x.push(q)):q.push(H);return x}e.groupBy=w;function n(F,U,x){const q=[];function H(ne,se,ee){if(se===0&&ee.length===0)return;const he=q[q.length-1];he&&he.start+he.deleteCount===ne?(he.deleteCount+=se,he.toInsert.push(...ee)):q.push({start:ne,deleteCount:se,toInsert:ee})}let Y=0,te=0;for(;;){if(Y===F.length){H(Y,0,U.slice(te));break}if(te===U.length){H(Y,F.length-Y,[]);break}const ne=F[Y],se=U[te],ee=x(ne,se);ee===0?(Y+=1,te+=1):ee<0?(H(Y,1,[]),Y+=1):ee>0&&(H(Y,0,[se]),te+=1)}return q}e.sortedDiff=n;function y(F,U,x){const q=n(F,U,x),H=[],Y=[];for(const te of q)H.push(...F.slice(te.start,te.start+te.deleteCount)),Y.push(...te.toInsert);return{removed:H,added:Y}}e.delta=y;function v(F,U,x){if(x===0)return[];const q=F.slice(0,x).sort(U);return h(F,U,q,x,F.length),q}e.top=v;function m(F,U,x,q,H){return x===0?Promise.resolve([]):new Promise((Y,te)=>{(async()=>{const ne=F.length,se=F.slice(0,x).sort(U);for(let ee=x,he=Math.min(x+q,ne);ee<ne;ee=he,he=Math.min(he+q,ne)){if(ee>x&&await new Promise(de=>setTimeout(de)),H&&H.isCancellationRequested)throw(0,p.canceled)();h(F,U,se,ee,he)}return se})().then(Y,te)})}e.topAsync=m;function h(F,U,x,q,H){for(const Y=x.length;q<H;q++){const te=F[q];if(U(te,x[Y-1])<0){x.pop();const ne=R(x,se=>U(te,se)<0);x.splice(ne,0,te)}}}function C(F){return F.filter(U=>!!U)}e.coalesce=C;function P(F){let U=0;for(let x=0;x<F.length;x++)F[x]&&(F[U]=F[x],U+=1);F.length=U}e.coalesceInPlace=P;function b(F,U,x){F.splice(x,0,F.splice(U,1)[0])}e.move=b;function I(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=I;function f(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=f;function s(F,U){if(!U)return F.filter((q,H)=>F.indexOf(q)===H);const x=Object.create(null);return F.filter(q=>{const H=U(q);return x[H]?!1:(x[H]=!0,!0)})}e.distinct=s;function c(F){const U=new Set;return F.filter(x=>U.has(x)?!1:(U.add(x),!0))}e.distinctES6=c;function t(F){const U=Object.create(null);return x=>{const q=F(x);return U[q]?!1:(U[q]=!0,!0)}}e.uniqueFilter=t;function r(F,U){for(let x=F.length-1;x>=0;x--){const q=F[x];if(U(q))return x}return-1}e.lastIndex=r;function i(F,U){return F.length>0?F[0]:U}e.firstOrDefault=i;function o(F,U,x=(q,H)=>q===H){let q=0;for(let H=0,Y=Math.min(F.length,U.length);H<Y&&x(F[H],U[H]);H++)q++;return q}e.commonPrefixLength=o;function u(F){return[].concat(...F)}e.flatten=u;function a(F,U){let x=typeof U=="number"?F:0;typeof U=="number"?x=F:(x=0,U=F);const q=[];if(x<=U)for(let H=x;H<U;H++)q.push(H);else for(let H=x;H>U;H--)q.push(H);return q}e.range=a;function l(F,U,x){return F.reduce((q,H)=>(q[U(H)]=x?x(H):H,q),Object.create(null))}e.index=l;function g(F,U){return F.push(U),()=>E(F,U)}e.insert=g;function E(F,U){const x=F.indexOf(U);if(x>-1)return F.splice(x,1),U}e.remove=E;function d(F,U,x){const q=F.slice(0,U),H=F.slice(U);return q.concat(x,H)}e.arrayInsert=d;function T(F,U){let x;if(typeof U=="number"){let q=U;x=()=>{const H=Math.sin(q++)*179426549;return H-Math.floor(H)}}else x=Math.random;for(let q=F.length-1;q>0;q-=1){const H=Math.floor(x()*(q+1)),Y=F[q];F[q]=F[H],F[H]=Y}}e.shuffle=T;function O(F,U){const x=F.indexOf(U);x>-1&&(F.splice(x,1),F.unshift(U))}e.pushToStart=O;function $(F,U){const x=F.indexOf(U);x>-1&&(F.splice(x,1),F.push(U))}e.pushToEnd=$;function z(F,U){return Array.isArray(F)?F.map(U):U(F)}e.mapArrayOrNot=z;function V(F){return Array.isArray(F)?F:[F]}e.asArray=V;function B(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=B;function M(F,U){for(const x of F){const q=U(x);if(q!==void 0)return q}}e.mapFind=M;function _(F,U){let x=Number.MAX_SAFE_INTEGER,q=0;return F.forEach((H,Y)=>{const te=U(H);te<x&&(x=te,q=Y)}),q}e.minIndex=_;function N(F,U){let x=Number.MIN_SAFE_INTEGER,q=0;return F.forEach((H,Y)=>{const te=U(H);te>x&&(x=te,q=Y)}),q}e.maxIndex=N;class j{constructor(U){this.items=U,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(U){let x=this.firstIdx;for(;x<this.items.length&&U(this.items[x]);)x++;const q=x===this.firstIdx?null:this.items.slice(this.firstIdx,x);return this.firstIdx=x,q}takeFromEndWhile(U){let x=this.lastIdx;for(;x>=0&&U(this.items[x]);)x--;const q=x===this.lastIdx?null:this.items.slice(x+1,this.lastIdx+1);return this.lastIdx=x,q}}e.ArrayQueue=j}),define(X[65],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(L){const D=this;let k=!1,A;return function(){return k||(k=!0,A=L.apply(D,arguments)),A}}e.once=p}),define(X[53],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(L){function D(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}L.is=D;const k=Object.freeze([]);function A(){return k}L.empty=A;function*R(c){yield c}L.single=R;function S(c){return c||k}L.from=S;function w(c){return!c||c[Symbol.iterator]().next().done===!0}L.isEmpty=w;function n(c){return c[Symbol.iterator]().next().value}L.first=n;function y(c,t){for(const r of c)if(t(r))return!0;return!1}L.some=y;function v(c,t){for(const r of c)if(t(r))return r}L.find=v;function*m(c,t){for(const r of c)t(r)&&(yield r)}L.filter=m;function*h(c,t){let r=0;for(const i of c)yield t(i,r++)}L.map=h;function*C(...c){for(const t of c)for(const r of t)yield r}L.concat=C;function*P(c){for(const t of c)for(const r of t)yield r}L.concatNested=P;function b(c,t,r){let i=r;for(const o of c)i=t(i,o);return i}L.reduce=b;function*I(c,t,r=c.length){for(t<0&&(t+=c.length),r<0?r+=c.length:r>c.length&&(r=c.length);t<r;t++)yield c[t]}L.slice=I;function f(c,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,c];const i=c[Symbol.iterator]();for(let o=0;o<t;o++){const u=i.next();if(u.done)return[r,L.empty()];r.push(u.value)}return[r,{[Symbol.iterator](){return i}}]}L.consume=f;function s(c,t,r=(i,o)=>i===o){const i=c[Symbol.iterator](),o=t[Symbol.iterator]();for(;;){const u=i.next(),a=o.next();if(u.done!==a.done)return!1;if(u.done)return!0;if(!r(u.value,a.value))return!1}}L.equals=s})(p=e.Iterable||(e.Iterable={}))}),define(X[33],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(t){t.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function A(t,r=!1){let i=0,o=t.length,u="",a=0,l=16,g=0;function E(B){let M=0,_=0;for(;M<B;){const N=t.charCodeAt(i);if(N>=48&&N<=57)_=_*16+N-48;else if(N>=65&&N<=70)_=_*16+N-65+10;else if(N>=97&&N<=102)_=_*16+N-97+10;else break;i++,M++}return M<B&&(_=-1),_}function d(B){i=B,u="",a=0,l=16,g=0}function T(){const B=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&w(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&w(t.charCodeAt(i)))for(i++;i<t.length&&w(t.charCodeAt(i));)i++;else return g=3,t.substring(B,i);let M=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&w(t.charCodeAt(i))){for(i++;i<t.length&&w(t.charCodeAt(i));)i++;M=i}else g=3;return t.substring(B,M)}function O(){let B="",M=i;for(;;){if(i>=o){B+=t.substring(M,i),g=2;break}const _=t.charCodeAt(i);if(_===34){B+=t.substring(M,i),i++;break}if(_===92){if(B+=t.substring(M,i),i++,i>=o){g=2;break}switch(t.charCodeAt(i++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:const j=E(4);j>=0?B+=String.fromCharCode(j):g=4;break;default:g=5}M=i;continue}if(_>=0&&_<=31)if(S(_)){B+=t.substring(M,i),g=2;break}else g=6;i++}return B}function $(){if(u="",g=0,a=i,i>=o)return a=o,l=17;let B=t.charCodeAt(i);if(R(B)){do i++,u+=String.fromCharCode(B),B=t.charCodeAt(i);while(R(B));return l=15}if(S(B))return i++,u+=String.fromCharCode(B),B===13&&t.charCodeAt(i)===10&&(i++,u+=`
`),l=14;switch(B){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,u=O(),l=10;case 47:const M=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<o&&!S(t.charCodeAt(i));)i++;return u=t.substring(M,i),l=12}if(t.charCodeAt(i+1)===42){i+=2;const _=o-1;let N=!1;for(;i<_;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,N=!0;break}i++}return N||(i++,g=1),u=t.substring(M,i),l=13}return u+=String.fromCharCode(B),i++,l=16;case 45:if(u+=String.fromCharCode(B),i++,i===o||!w(t.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=T(),l=11;default:for(;i<o&&z(B);)i++,B=t.charCodeAt(i);if(a!==i){switch(u=t.substring(a,i),u){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return u+=String.fromCharCode(B),i++,l=16}}function z(B){if(R(B)||S(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let B;do B=$();while(B>=12&&B<=15);return B}return{setPosition:d,getPosition:()=>i,scan:r?V:$,getToken:()=>l,getTokenValue:()=>u,getTokenOffset:()=>a,getTokenLength:()=>i-a,getTokenError:()=>g}}e.createScanner=A;function R(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function w(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function y(t,r){const i=[],o=new Object;let u;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function g(E,d,T,O){a.value=E,a.offset=d,a.length=T,a.type=O,a.colonOffset=void 0,u=a}try{f(t,{onObjectBegin:(E,d)=>{if(r<=E)throw o;u=void 0,l=r>E,i.push("")},onObjectProperty:(E,d,T)=>{if(r<d||(g(E,d,T,"property"),i[i.length-1]=E,r<=d+T))throw o},onObjectEnd:(E,d)=>{if(r<=E)throw o;u=void 0,i.pop()},onArrayBegin:(E,d)=>{if(r<=E)throw o;u=void 0,i.push(0)},onArrayEnd:(E,d)=>{if(r<=E)throw o;u=void 0,i.pop()},onLiteralValue:(E,d,T)=>{if(r<d||(g(E,d,T,c(E)),r<=d+T))throw o},onSeparator:(E,d,T)=>{if(r<=d)throw o;if(E===":"&&u&&u.type==="property")u.colonOffset=d,l=!1,u=void 0;else if(E===","){const O=i[i.length-1];typeof O=="number"?i[i.length-1]=O+1:(l=!0,i[i.length-1]=""),u=void 0}}})}catch(E){if(E!==o)throw E}return{path:i,previousNode:u,isAtPropertyKey:l,matches:E=>{let d=0;for(let T=0;d<E.length&&T<i.length;T++)if(E[d]===i[T]||E[d]==="*")d++;else if(E[d]!=="**")return!1;return d===E.length}}}e.getLocation=y;function v(t,r=[],i=k.DEFAULT){let o=null,u=[];const a=[];function l(E){Array.isArray(u)?u.push(E):o!==null&&(u[o]=E)}return f(t,{onObjectBegin:()=>{const E={};l(E),a.push(u),u=E,o=null},onObjectProperty:E=>{o=E},onObjectEnd:()=>{u=a.pop()},onArrayBegin:()=>{const E=[];l(E),a.push(u),u=E,o=null},onArrayEnd:()=>{u=a.pop()},onLiteralValue:l,onError:(E,d,T)=>{r.push({error:E,offset:d,length:T})}},i),u[0]}e.parse=v;function m(t,r=[],i=k.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(E){o.type==="property"&&(o.length=E-o.offset,o=o.parent)}function a(E){return o.children.push(E),E}f(t,{onObjectBegin:E=>{o=a({type:"object",offset:E,length:-1,parent:o,children:[]})},onObjectProperty:(E,d,T)=>{o=a({type:"property",offset:d,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:E,offset:d,length:T,parent:o})},onObjectEnd:(E,d)=>{o.length=E+d-o.offset,o=o.parent,u(E+d)},onArrayBegin:(E,d)=>{o=a({type:"array",offset:E,length:-1,parent:o,children:[]})},onArrayEnd:(E,d)=>{o.length=E+d-o.offset,o=o.parent,u(E+d)},onLiteralValue:(E,d,T)=>{a({type:c(E),offset:d,length:T,parent:o,value:E}),u(d+T)},onSeparator:(E,d,T)=>{o.type==="property"&&(E===":"?o.colonOffset=d:E===","&&u(d))},onError:(E,d,T)=>{r.push({error:E,offset:d,length:T})}},i);const g=o.children[0];return g&&delete g.parent,g}e.parseTree=m;function h(t,r){if(!t)return;let i=t;for(let o of r)if(typeof o=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let u=!1;for(const a of i.children)if(Array.isArray(a.children)&&a.children[0].value===o){i=a.children[1],u=!0;break}if(!u)return}else{const u=o;if(i.type!=="array"||u<0||!Array.isArray(i.children)||u>=i.children.length)return;i=i.children[u]}return i}e.findNodeAtLocation=h;function C(t){if(!t.parent||!t.parent.children)return[];const r=C(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;r.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&r.push(i)}return r}e.getNodePath=C;function P(t){switch(t.type){case"array":return t.children.map(P);case"object":const r=Object.create(null);for(let i of t.children){const o=i.children[1];o&&(r[i.children[0].value]=P(o))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=P;function b(t,r,i=!1){return r>=t.offset&&r<t.offset+t.length||i&&r===t.offset+t.length}e.contains=b;function I(t,r,i=!1){if(b(t,r,i)){const o=t.children;if(Array.isArray(o))for(let u=0;u<o.length&&o[u].offset<=r;u++){const a=I(o[u],r,i);if(a)return a}return t}}e.findNodeAtOffset=I;function f(t,r,i=k.DEFAULT){const o=A(t,!1);function u(Y){return Y?()=>Y(o.getTokenOffset(),o.getTokenLength()):()=>!0}function a(Y){return Y?te=>Y(te,o.getTokenOffset(),o.getTokenLength()):()=>!0}const l=u(r.onObjectBegin),g=a(r.onObjectProperty),E=u(r.onObjectEnd),d=u(r.onArrayBegin),T=u(r.onArrayEnd),O=a(r.onLiteralValue),$=a(r.onSeparator),z=u(r.onComment),V=a(r.onError),B=i&&i.disallowComments,M=i&&i.allowTrailingComma;function _(){for(;;){const Y=o.scan();switch(o.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:B||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(Y){case 12:case 13:B?N(10):z();break;case 16:N(1);break;case 15:case 14:break;default:return Y}}}function N(Y,te=[],ne=[]){if(V(Y),te.length+ne.length>0){let se=o.getToken();for(;se!==17;){if(te.indexOf(se)!==-1){_();break}else if(ne.indexOf(se)!==-1)break;se=_()}}}function j(Y){const te=o.getTokenValue();return Y?O(te):g(te),_(),!0}function F(){switch(o.getToken()){case 11:let Y=0;try{Y=JSON.parse(o.getTokenValue()),typeof Y!="number"&&(N(2),Y=0)}catch(te){N(2)}O(Y);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return _(),!0}function U(){return o.getToken()!==10?(N(3,[],[2,5]),!1):(j(!1),o.getToken()===6?($(":"),_(),H()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function x(){l(),_();let Y=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(Y||N(4,[],[]),$(","),_(),o.getToken()===2&&M)break}else Y&&N(6,[],[]);U()||N(4,[],[2,5]),Y=!0}return E(),o.getToken()!==2?N(7,[2],[]):_(),!0}function q(){d(),_();let Y=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(Y||N(4,[],[]),$(","),_(),o.getToken()===4&&M)break}else Y&&N(6,[],[]);H()||N(4,[],[4,5]),Y=!0}return T(),o.getToken()!==4?N(8,[4],[]):_(),!0}function H(){switch(o.getToken()){case 3:return q();case 1:return x();case 10:return j(!0);default:return F()}}return _(),o.getToken()===17?i.allowEmptyContent?!0:(N(4,[],[]),!1):H()?(o.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}e.visit=f;function s(t,r){let i=A(t),o=[],u,a=0,l;do switch(l=i.getPosition(),u=i.scan(),u){case 12:case 13:case 17:a!==l&&o.push(t.substring(a,l)),r!==void 0&&o.push(i.getTokenValue().replace(/[^\r\n]/g,r)),a=i.getPosition();break}while(u!==17);return o.join("")}e.stripComments=s;function c(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(X[47],Q([0,1,33]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(S,w,n){let y,v,m,h,C;if(w){for(h=w.offset,C=h+w.length,m=h;m>0&&!R(S,m-1);)m--;let a=C;for(;a<S.length&&!R(S,a);)a++;v=S.substring(m,a),y=k(v,n)}else v=S,y=0,m=0,h=0,C=S.length;const P=A(n,S);let b=!1,I=0,f;n.insertSpaces?f=D(" ",n.tabSize||4):f="	";const s=(0,p.createScanner)(v,!1);let c=!1;function t(){return P+D(f,y+I)}function r(){let a=s.scan();for(b=!1;a===15||a===14;)b=b||a===14,a=s.scan();return c=a===16||s.getTokenError()!==0,a}const i=[];function o(a,l,g){!c&&l<C&&g>h&&S.substring(l,g)!==a&&i.push({offset:l,length:g-l,content:a})}let u=r();if(u!==17){const a=s.getTokenOffset()+m,l=D(f,y);o(l,m,a)}for(;u!==17;){let a=s.getTokenOffset()+s.getTokenLength()+m,l=r(),g="";for(;!b&&(l===12||l===13);){const d=s.getTokenOffset()+m;o(" ",a,d),a=s.getTokenOffset()+s.getTokenLength()+m,g=l===12?t():"",l=r()}if(l===2)u!==1&&(I--,g=t());else if(l===4)u!==3&&(I--,g=t());else{switch(u){case 3:case 1:I++,g=t();break;case 5:case 12:g=t();break;case 13:b?g=t():g=" ";break;case 6:g=" ";break;case 10:if(l===6){g="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?g=" ":l!==5&&l!==17&&(c=!0);break;case 16:c=!0;break}b&&(l===12||l===13)&&(g=t())}const E=s.getTokenOffset()+m;o(g,a,E),u=l}return i}e.format=L;function D(S,w){let n="";for(let y=0;y<w;y++)n+=S;return n}function k(S,w){let n=0,y=0;const v=w.tabSize||4;for(;n<S.length;){const m=S.charAt(n);if(m===" ")y++;else if(m==="	")y+=v;else break;n++}return Math.floor(y/v)}function A(S,w){for(let n=0;n<w.length;n++){const y=w.charAt(n);if(y==="\r")return n+1<w.length&&w.charAt(n+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=A;function R(S,w){return`\r
`.indexOf(S.charAt(w))!==-1}e.isEOL=R}),define(X[40],Q([0,1,33,47]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(w,n,y){return k(w,n,void 0,y)}e.removeProperty=D;function k(w,n,y,v,m){const h=n.slice(),C=[],P=(0,p.parseTree)(w,C);let b,I;for(;h.length>0&&(I=h.pop(),b=(0,p.findNodeAtLocation)(P,h),b===void 0&&y!==void 0);)typeof I=="string"?y={[I]:y}:y=[y];if(b)if(b.type==="object"&&typeof I=="string"&&Array.isArray(b.children)){const f=(0,p.findNodeAtLocation)(b,[I]);if(f!==void 0)if(y===void 0){if(!f.parent)throw new Error("Malformed AST");const s=b.children.indexOf(f.parent);let c,t=f.parent.offset+f.parent.length;if(s>0){const r=b.children[s-1];c=r.offset+r.length}else c=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return A(w,{offset:c,length:t-c,content:""},v)}else return A(w,{offset:f.offset,length:f.length,content:JSON.stringify(y)},v);else{if(y===void 0)return[];const s=`${JSON.stringify(I)}: ${JSON.stringify(y)}`,c=m?m(b.children.map(r=>r.children[0].value)):b.children.length;let t;if(c>0){const r=b.children[c-1];t={offset:r.offset+r.length,length:0,content:","+s}}else b.children.length===0?t={offset:b.offset+1,length:0,content:s}:t={offset:b.offset+1,length:0,content:s+","};return A(w,t,v)}}else if(b.type==="array"&&typeof I=="number"&&Array.isArray(b.children))if(y!==void 0){const f=`${JSON.stringify(y)}`;let s;if(b.children.length===0||I===0)s={offset:b.offset+1,length:0,content:b.children.length===0?f:f+","};else{const c=I===-1||I>b.children.length?b.children.length:I,t=b.children[c-1];s={offset:t.offset+t.length,length:0,content:","+f}}return A(w,s,v)}else{const f=I,s=b.children[f];let c;if(b.children.length===1)c={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===f){const t=b.children[f-1],r=t.offset+t.length,i=b.offset+b.length;c={offset:r,length:i-2-r,content:""}}else c={offset:s.offset,length:b.children[f+1].offset-s.offset,content:""};return A(w,c,v)}else throw new Error(`Can not add ${typeof I!="number"?"index":"property"} to parent of type ${b.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return A(w,{offset:P?P.offset:0,length:P?P.length:0,content:JSON.stringify(y)},v)}}e.setProperty=k;function A(w,n,y){let v=R(w,n),m=n.offset,h=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;m>0&&!(0,L.isEOL)(v,m-1);)m--;for(;h<v.length&&!(0,L.isEOL)(v,h);)h++}const C=(0,L.format)(v,{offset:m,length:h-m},y);for(let b=C.length-1;b>=0;b--){const I=C[b];v=R(v,I),m=Math.min(m,I.offset),h=Math.max(h,I.offset+I.length),h+=I.content.length-I.length}const P=w.length-(v.length-h)-m;return[{offset:m,length:P,content:v.substring(m,h)}]}e.withFormatting=A;function R(w,n){return w.substring(0,n.offset)+n.content+w.substring(n.offset+n.length)}e.applyEdit=R;function S(w,n){let y=n.slice(0).sort((m,h)=>{const C=m.offset-h.offset;return C===0?m.length-h.length:C}),v=w.length;for(let m=y.length-1;m>=0;m--){let h=y[m];if(h.offset+h.length<=v)w=R(w,h);else throw new Error("Overlapping edit");v=h.offset}return w}e.applyEdits=S}),define(X[2],Q([0,1,65,53]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let k=null;function A(r){k=r}if(e.setDisposableTracker=A,D){const r="__is_disposable_tracked__";A(new class{trackDisposable(i){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[r]||console.log(o)},3e3)}setParent(i,o){if(i&&i!==I.None)try{i[r]=!0}catch{}}markAsDisposed(i){if(i&&i!==I.None)try{i[r]=!0}catch{}}markAsSingleton(i){}})}function R(r){return k?.trackDisposable(r),r}function S(r){k?.markAsDisposed(r)}function w(r,i){k?.setParent(r,i)}function n(r,i){if(!!k)for(const o of r)k.setParent(o,i)}function y(r){return k?.markAsSingleton(r),r}e.markAsSingleton=y;class v extends Error{constructor(i){super(`Encountered errors while disposing of store. Errors: [${i.join(", ")}]`);this.errors=i}}e.MultiDisposeError=v;function m(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=m;function h(r){if(L.Iterable.is(r)){let i=[];for(const o of r)if(o)try{o.dispose()}catch(u){i.push(u)}if(i.length===1)throw i[0];if(i.length>1)throw new v(i);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=h;function C(...r){const i=P(()=>h(r));return n(r,i),i}e.combinedDisposable=C;function P(r){const i=R({dispose:(0,p.once)(()=>{S(i),r()})});return i}e.toDisposable=P;class b{constructor(){this._toDispose=new Set,this._isDisposed=!1,R(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return w(i,this),this._isDisposed?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}e.DisposableStore=b,b.DISABLE_DISPOSED_WARNING=!1;class I{constructor(){this._store=new b,R(this),w(this._store,this)}dispose(){S(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}e.Disposable=I,I.None=Object.freeze({dispose(){}});class f{constructor(){this._isDisposed=!1,R(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&w(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&w(i,null),i}}e.MutableDisposable=f;class s{constructor(){this.references=new Map}acquire(i,...o){let u=this.references.get(i);u||(u={counter:0,object:this.createReferencedObject(i,...o)},this.references.set(i,u));const{object:a}=u,l=(0,p.once)(()=>{--u.counter==0&&(this.destroyReferencedObject(i,u.object),this.references.delete(i))});return u.counter++,{object:a,dispose:l}}}e.ReferenceCollection=s;class c{constructor(i){this.referenceCollection=i}async acquire(i,...o){const u=this.referenceCollection.acquire(i,...o);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(a){throw u.dispose(),a}}}e.AsyncReferenceCollection=c;class t{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=t}),define(X[88],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(k){this.element=k,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class L{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let k=this._first;for(;k!==p.Undefined;){const A=k.next;k.prev=p.Undefined,k.next=p.Undefined,k=A}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,A){const R=new p(k);if(this._first===p.Undefined)this._first=R,this._last=R;else if(A){const w=this._last;this._last=R,R.prev=w,w.next=R}else{const w=this._first;this._first=R,R.next=w,w.prev=R}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(R))}}shift(){if(this._first!==p.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==p.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==p.Undefined&&k.next!==p.Undefined){const A=k.prev;A.next=k.next,k.next.prev=A}else k.prev===p.Undefined&&k.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):k.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):k.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==p.Undefined;)yield k.element,k=k.next}}e.LinkedList=L}),function(){function G(D){const k=[];typeof D=="number"&&k.push("code/timeOrigin",D);function A(S){k.push(S,Date.now())}function R(){const S=[];for(let w=0;w<k.length;w+=2)S.push({name:k[w],startTime:k[w+1]});return S}return{mark:A,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const A of performance.getEntriesByType("mark"))k.push({name:A.name,startTime:Math.round(D+A.startTime)});return k}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function p(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=p(L))}(),define(X[7],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const p="en";let L=!1,D=!1,k=!1,A=!1,R=!1,S=!1,w=!1,n,y=p,v,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const C=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=C&&h?.sandboxed,e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const i=h?.env.VSCODE_BROWSER_CODE_LOADING;if(typeof i=="string")return i==="none"||i==="code"||i==="bypassHeatCheck"||i==="bypassHeatCheckAndEagerCompile"?i:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!C)m=navigator.userAgent,L=m.indexOf("Windows")>=0,D=m.indexOf("Macintosh")>=0,w=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=m.indexOf("Linux")>=0,S=!0,n=navigator.language,y=n;else if(typeof h=="object"){L=h.platform==="win32",D=h.platform==="darwin",k=h.platform==="linux",A=k&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,n=p,y=p;const i=h.env.VSCODE_NLS_CONFIG;if(i)try{const o=JSON.parse(i),u=o.availableLanguages["*"];n=o.locale,y=u||p,v=o._translationsConfigFile}catch(o){}R=!0}else console.error("Unable to resolve platform.");var P;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(P=e.Platform||(e.Platform={}));function b(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let I=0;D?I=1:L?I=3:k&&(I=2),e.isWindows=L,e.isMacintosh=D,e.isLinux=k,e.isLinuxSnap=A,e.isNative=R,e.isWeb=S,e.isIOS=w,e.platform=I,e.userAgent=m,e.language=y;var f;(function(i){function o(){return e.language}i.value=o;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=u;function a(){return e.language==="en"}i.isDefault=a})(f=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=v,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let u=[];e.globals.addEventListener("message",l=>{if(l.data&&l.data.vscodeSetImmediateId)for(let g=0,E=u.length;g<E;g++){const d=u[g];if(d.id===l.data.vscodeSetImmediateId){u.splice(g,1),d.callback();return}}});let a=0;return l=>{const g=++a;u.push({id:g,callback:l}),e.globals.postMessage({vscodeSetImmediateId:g},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const o=Promise.resolve();return u=>o.then(u)}();var s;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||w?2:L?1:3;let c=!0,t=!1;function r(){if(!t){t=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,c=new Uint16Array(i.buffer)[0]===(2<<8)+1}return c}e.isLittleEndian=r}),define(X[34],Q([0,1,7]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const D=p.globals.vscode.process;L={get platform(){return D.platform},get env(){return D.env},cwd(){return D.cwd()},nextTick(k){return(0,p.setImmediate)(k)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:L={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},nextTick(D){return(0,p.setImmediate)(D)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick}),define(X[8],Q([0,1,34]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,D=97,k=90,A=122,R=46,S=47,w=92,n=58,y=63;class v extends Error{constructor(s,c,t){let r;typeof c=="string"&&c.indexOf("not ")===0?(r="must not be",c=c.replace(/^not /,"")):r="must be";const i=s.indexOf(".")!==-1?"property":"argument";let o=`The "${s}" ${i} ${r} of type ${c}`;o+=`. Received type ${typeof t}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function m(f,s){if(typeof f!="string")throw new v(s,"string",f)}function h(f){return f===S||f===w}function C(f){return f===S}function P(f){return f>=L&&f<=k||f>=D&&f<=A}function b(f,s,c,t){let r="",i=0,o=-1,u=0,a=0;for(let l=0;l<=f.length;++l){if(l<f.length)a=f.charCodeAt(l);else{if(t(a))break;a=S}if(t(a)){if(!(o===l-1||u===1))if(u===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==R||r.charCodeAt(r.length-2)!==R){if(r.length>2){const g=r.lastIndexOf(c);g===-1?(r="",i=0):(r=r.slice(0,g),i=r.length-1-r.lastIndexOf(c)),o=l,u=0;continue}else if(r.length!==0){r="",i=0,o=l,u=0;continue}}s&&(r+=r.length>0?`${c}..`:"..",i=2)}else r.length>0?r+=`${c}${f.slice(o+1,l)}`:r=f.slice(o+1,l),i=l-o-1;o=l,u=0}else a===R&&u!==-1?++u:u=-1}return r}function I(f,s){if(s===null||typeof s!="object")throw new v("pathObject","Object",s);const c=s.dir||s.root,t=s.base||`${s.name||""}${s.ext||""}`;return c?c===s.root?`${c}${t}`:`${c}${f}${t}`:t}e.win32={resolve(...f){let s="",c="",t=!1;for(let r=f.length-1;r>=-1;r--){let i;if(r>=0){if(i=f[r],m(i,"path"),i.length===0)continue}else s.length===0?i=p.cwd():(i=p.env[`=${s}`]||p.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==s.toLowerCase()&&i.charCodeAt(2)===w)&&(i=`${s}\\`));const o=i.length;let u=0,a="",l=!1;const g=i.charCodeAt(0);if(o===1)h(g)&&(u=1,l=!0);else if(h(g))if(l=!0,h(i.charCodeAt(1))){let E=2,d=E;for(;E<o&&!h(i.charCodeAt(E));)E++;if(E<o&&E!==d){const T=i.slice(d,E);for(d=E;E<o&&h(i.charCodeAt(E));)E++;if(E<o&&E!==d){for(d=E;E<o&&!h(i.charCodeAt(E));)E++;(E===o||E!==d)&&(a=`\\\\${T}\\${i.slice(d,E)}`,u=E)}}}else u=1;else P(g)&&i.charCodeAt(1)===n&&(a=i.slice(0,2),u=2,o>2&&h(i.charCodeAt(2))&&(l=!0,u=3));if(a.length>0)if(s.length>0){if(a.toLowerCase()!==s.toLowerCase())continue}else s=a;if(t){if(s.length>0)break}else if(c=`${i.slice(u)}\\${c}`,t=l,l&&s.length>0)break}return c=b(c,!t,"\\",h),t?`${s}\\${c}`:`${s}${c}`||"."},normalize(f){m(f,"path");const s=f.length;if(s===0)return".";let c=0,t,r=!1;const i=f.charCodeAt(0);if(s===1)return C(i)?"\\":f;if(h(i))if(r=!0,h(f.charCodeAt(1))){let u=2,a=u;for(;u<s&&!h(f.charCodeAt(u));)u++;if(u<s&&u!==a){const l=f.slice(a,u);for(a=u;u<s&&h(f.charCodeAt(u));)u++;if(u<s&&u!==a){for(a=u;u<s&&!h(f.charCodeAt(u));)u++;if(u===s)return`\\\\${l}\\${f.slice(a)}\\`;u!==a&&(t=`\\\\${l}\\${f.slice(a,u)}`,c=u)}}}else c=1;else P(i)&&f.charCodeAt(1)===n&&(t=f.slice(0,2),c=2,s>2&&h(f.charCodeAt(2))&&(r=!0,c=3));let o=c<s?b(f.slice(c),!r,"\\",h):"";return o.length===0&&!r&&(o="."),o.length>0&&h(f.charCodeAt(s-1))&&(o+="\\"),t===void 0?r?`\\${o}`:o:r?`${t}\\${o}`:`${t}${o}`},isAbsolute(f){m(f,"path");const s=f.length;if(s===0)return!1;const c=f.charCodeAt(0);return h(c)||s>2&&P(c)&&f.charCodeAt(1)===n&&h(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let s,c;for(let i=0;i<f.length;++i){const o=f[i];m(o,"path"),o.length>0&&(s===void 0?s=c=o:s+=`\\${o}`)}if(s===void 0)return".";let t=!0,r=0;if(typeof c=="string"&&h(c.charCodeAt(0))){++r;const i=c.length;i>1&&h(c.charCodeAt(1))&&(++r,i>2&&(h(c.charCodeAt(2))?++r:t=!1))}if(t){for(;r<s.length&&h(s.charCodeAt(r));)r++;r>=2&&(s=`\\${s.slice(r)}`)}return e.win32.normalize(s)},relative(f,s){if(m(f,"from"),m(s,"to"),f===s)return"";const c=e.win32.resolve(f),t=e.win32.resolve(s);if(c===t||(f=c.toLowerCase(),s=t.toLowerCase(),f===s))return"";let r=0;for(;r<f.length&&f.charCodeAt(r)===w;)r++;let i=f.length;for(;i-1>r&&f.charCodeAt(i-1)===w;)i--;const o=i-r;let u=0;for(;u<s.length&&s.charCodeAt(u)===w;)u++;let a=s.length;for(;a-1>u&&s.charCodeAt(a-1)===w;)a--;const l=a-u,g=o<l?o:l;let E=-1,d=0;for(;d<g;d++){const O=f.charCodeAt(r+d);if(O!==s.charCodeAt(u+d))break;O===w&&(E=d)}if(d!==g){if(E===-1)return t}else{if(l>g){if(s.charCodeAt(u+d)===w)return t.slice(u+d+1);if(d===2)return t.slice(u+d)}o>g&&(f.charCodeAt(r+d)===w?E=d:d===2&&(E=3)),E===-1&&(E=0)}let T="";for(d=r+E+1;d<=i;++d)(d===i||f.charCodeAt(d)===w)&&(T+=T.length===0?"..":"\\..");return u+=E,T.length>0?`${T}${t.slice(u,a)}`:(t.charCodeAt(u)===w&&++u,t.slice(u,a))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const s=e.win32.resolve(f);if(s.length<=2)return f;if(s.charCodeAt(0)===w){if(s.charCodeAt(1)===w){const c=s.charCodeAt(2);if(c!==y&&c!==R)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(P(s.charCodeAt(0))&&s.charCodeAt(1)===n&&s.charCodeAt(2)===w)return`\\\\?\\${s}`;return f},dirname(f){m(f,"path");const s=f.length;if(s===0)return".";let c=-1,t=0;const r=f.charCodeAt(0);if(s===1)return h(r)?f:".";if(h(r)){if(c=t=1,h(f.charCodeAt(1))){let u=2,a=u;for(;u<s&&!h(f.charCodeAt(u));)u++;if(u<s&&u!==a){for(a=u;u<s&&h(f.charCodeAt(u));)u++;if(u<s&&u!==a){for(a=u;u<s&&!h(f.charCodeAt(u));)u++;if(u===s)return f;u!==a&&(c=t=u+1)}}}}else P(r)&&f.charCodeAt(1)===n&&(c=s>2&&h(f.charCodeAt(2))?3:2,t=c);let i=-1,o=!0;for(let u=s-1;u>=t;--u)if(h(f.charCodeAt(u))){if(!o){i=u;break}}else o=!1;if(i===-1){if(c===-1)return".";i=c}return f.slice(0,i)},basename(f,s){s!==void 0&&m(s,"ext"),m(f,"path");let c=0,t=-1,r=!0,i;if(f.length>=2&&P(f.charCodeAt(0))&&f.charCodeAt(1)===n&&(c=2),s!==void 0&&s.length>0&&s.length<=f.length){if(s===f)return"";let o=s.length-1,u=-1;for(i=f.length-1;i>=c;--i){const a=f.charCodeAt(i);if(h(a)){if(!r){c=i+1;break}}else u===-1&&(r=!1,u=i+1),o>=0&&(a===s.charCodeAt(o)?--o==-1&&(t=i):(o=-1,t=u))}return c===t?t=u:t===-1&&(t=f.length),f.slice(c,t)}for(i=f.length-1;i>=c;--i)if(h(f.charCodeAt(i))){if(!r){c=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":f.slice(c,t)},extname(f){m(f,"path");let s=0,c=-1,t=0,r=-1,i=!0,o=0;f.length>=2&&f.charCodeAt(1)===n&&P(f.charCodeAt(0))&&(s=t=2);for(let u=f.length-1;u>=s;--u){const a=f.charCodeAt(u);if(h(a)){if(!i){t=u+1;break}continue}r===-1&&(i=!1,r=u+1),a===R?c===-1?c=u:o!==1&&(o=1):c!==-1&&(o=-1)}return c===-1||r===-1||o===0||o===1&&c===r-1&&c===t+1?"":f.slice(c,r)},format:I.bind(null,"\\"),parse(f){m(f,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return s;const c=f.length;let t=0,r=f.charCodeAt(0);if(c===1)return h(r)?(s.root=s.dir=f,s):(s.base=s.name=f,s);if(h(r)){if(t=1,h(f.charCodeAt(1))){let E=2,d=E;for(;E<c&&!h(f.charCodeAt(E));)E++;if(E<c&&E!==d){for(d=E;E<c&&h(f.charCodeAt(E));)E++;if(E<c&&E!==d){for(d=E;E<c&&!h(f.charCodeAt(E));)E++;E===c?t=E:E!==d&&(t=E+1)}}}}else if(P(r)&&f.charCodeAt(1)===n){if(c<=2)return s.root=s.dir=f,s;if(t=2,h(f.charCodeAt(2))){if(c===3)return s.root=s.dir=f,s;t=3}}t>0&&(s.root=f.slice(0,t));let i=-1,o=t,u=-1,a=!0,l=f.length-1,g=0;for(;l>=t;--l){if(r=f.charCodeAt(l),h(r)){if(!a){o=l+1;break}continue}u===-1&&(a=!1,u=l+1),r===R?i===-1?i=l:g!==1&&(g=1):i!==-1&&(g=-1)}return u!==-1&&(i===-1||g===0||g===1&&i===u-1&&i===o+1?s.base=s.name=f.slice(o,u):(s.name=f.slice(o,i),s.base=f.slice(o,u),s.ext=f.slice(i,u))),o>0&&o!==t?s.dir=f.slice(0,o-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let s="",c=!1;for(let t=f.length-1;t>=-1&&!c;t--){const r=t>=0?f[t]:p.cwd();m(r,"path"),r.length!==0&&(s=`${r}/${s}`,c=r.charCodeAt(0)===S)}return s=b(s,!c,"/",C),c?`/${s}`:s.length>0?s:"."},normalize(f){if(m(f,"path"),f.length===0)return".";const s=f.charCodeAt(0)===S,c=f.charCodeAt(f.length-1)===S;return f=b(f,!s,"/",C),f.length===0?s?"/":c?"./":".":(c&&(f+="/"),s?`/${f}`:f)},isAbsolute(f){return m(f,"path"),f.length>0&&f.charCodeAt(0)===S},join(...f){if(f.length===0)return".";let s;for(let c=0;c<f.length;++c){const t=f[c];m(t,"path"),t.length>0&&(s===void 0?s=t:s+=`/${t}`)}return s===void 0?".":e.posix.normalize(s)},relative(f,s){if(m(f,"from"),m(s,"to"),f===s||(f=e.posix.resolve(f),s=e.posix.resolve(s),f===s))return"";const c=1,t=f.length,r=t-c,i=1,o=s.length-i,u=r<o?r:o;let a=-1,l=0;for(;l<u;l++){const E=f.charCodeAt(c+l);if(E!==s.charCodeAt(i+l))break;E===S&&(a=l)}if(l===u)if(o>u){if(s.charCodeAt(i+l)===S)return s.slice(i+l+1);if(l===0)return s.slice(i+l)}else r>u&&(f.charCodeAt(c+l)===S?a=l:l===0&&(a=0));let g="";for(l=c+a+1;l<=t;++l)(l===t||f.charCodeAt(l)===S)&&(g+=g.length===0?"..":"/..");return`${g}${s.slice(i+a)}`},toNamespacedPath(f){return f},dirname(f){if(m(f,"path"),f.length===0)return".";const s=f.charCodeAt(0)===S;let c=-1,t=!0;for(let r=f.length-1;r>=1;--r)if(f.charCodeAt(r)===S){if(!t){c=r;break}}else t=!1;return c===-1?s?"/":".":s&&c===1?"//":f.slice(0,c)},basename(f,s){s!==void 0&&m(s,"ext"),m(f,"path");let c=0,t=-1,r=!0,i;if(s!==void 0&&s.length>0&&s.length<=f.length){if(s===f)return"";let o=s.length-1,u=-1;for(i=f.length-1;i>=0;--i){const a=f.charCodeAt(i);if(a===S){if(!r){c=i+1;break}}else u===-1&&(r=!1,u=i+1),o>=0&&(a===s.charCodeAt(o)?--o==-1&&(t=i):(o=-1,t=u))}return c===t?t=u:t===-1&&(t=f.length),f.slice(c,t)}for(i=f.length-1;i>=0;--i)if(f.charCodeAt(i)===S){if(!r){c=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":f.slice(c,t)},extname(f){m(f,"path");let s=-1,c=0,t=-1,r=!0,i=0;for(let o=f.length-1;o>=0;--o){const u=f.charCodeAt(o);if(u===S){if(!r){c=o+1;break}continue}t===-1&&(r=!1,t=o+1),u===R?s===-1?s=o:i!==1&&(i=1):s!==-1&&(i=-1)}return s===-1||t===-1||i===0||i===1&&s===t-1&&s===c+1?"":f.slice(s,t)},format:I.bind(null,"/"),parse(f){m(f,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return s;const c=f.charCodeAt(0)===S;let t;c?(s.root="/",t=1):t=0;let r=-1,i=0,o=-1,u=!0,a=f.length-1,l=0;for(;a>=t;--a){const g=f.charCodeAt(a);if(g===S){if(!u){i=a+1;break}continue}o===-1&&(u=!1,o=a+1),g===R?r===-1?r=a:l!==1&&(l=1):r!==-1&&(l=-1)}if(o!==-1){const g=i===0&&c?1:i;r===-1||l===0||l===1&&r===o-1&&r===i+1?s.base=s.name=f.slice(g,o):(s.name=f.slice(g,r),s.base=f.slice(g,o),s.ext=f.slice(r,o))}return i>0?s.dir=f.slice(0,i-1):c&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var p=e();for(var L in p)(typeof exports=="object"?exports:G)[L]=p[L]}}(typeof self!="undefined"?self:this,function(){return function(G){var e={};function p(L){if(e[L])return e[L].exports;var D=e[L]={i:L,l:!1,exports:{}};return G[L].call(D.exports,D,D.exports,p),D.l=!0,D.exports}return p.m=G,p.c=e,p.d=function(L,D,k){p.o(L,D)||Object.defineProperty(L,D,{enumerable:!0,get:k})},p.r=function(L){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},p.t=function(L,D){if(1&D&&(L=p(L)),8&D||4&D&&typeof L=="object"&&L&&L.__esModule)return L;var k=Object.create(null);if(p.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:L}),2&D&&typeof L!="string")for(var A in L)p.d(k,A,function(R){return L[R]}.bind(null,A));return k},p.n=function(L){var D=L&&L.__esModule?function(){return L.default}:function(){return L};return p.d(D,"a",D),D},p.o=function(L,D){return Object.prototype.hasOwnProperty.call(L,D)},p.p="",p(p.s=0)}([function(G,e,p){(function(L){var D;e=G.exports=ne,D=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],S=e.src=[],w=0,n=w++;S[n]="0|[1-9]\\d*";var y=w++;S[y]="[0-9]+";var v=w++;S[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=w++;S[m]="("+S[n]+")\\.("+S[n]+")\\.("+S[n]+")";var h=w++;S[h]="("+S[y]+")\\.("+S[y]+")\\.("+S[y]+")";var C=w++;S[C]="(?:"+S[n]+"|"+S[v]+")";var P=w++;S[P]="(?:"+S[y]+"|"+S[v]+")";var b=w++;S[b]="(?:-("+S[C]+"(?:\\."+S[C]+")*))";var I=w++;S[I]="(?:-?("+S[P]+"(?:\\."+S[P]+")*))";var f=w++;S[f]="[0-9A-Za-z-]+";var s=w++;S[s]="(?:\\+("+S[f]+"(?:\\."+S[f]+")*))";var c=w++,t="v?"+S[m]+S[b]+"?"+S[s]+"?";S[c]="^"+t+"$";var r="[v=\\s]*"+S[h]+S[I]+"?"+S[s]+"?",i=w++;S[i]="^"+r+"$";var o=w++;S[o]="((?:<|>)?=?)";var u=w++;S[u]=S[y]+"|x|X|\\*";var a=w++;S[a]=S[n]+"|x|X|\\*";var l=w++;S[l]="[v=\\s]*("+S[a]+")(?:\\.("+S[a]+")(?:\\.("+S[a]+")(?:"+S[b]+")?"+S[s]+"?)?)?";var g=w++;S[g]="[v=\\s]*("+S[u]+")(?:\\.("+S[u]+")(?:\\.("+S[u]+")(?:"+S[I]+")?"+S[s]+"?)?)?";var E=w++;S[E]="^"+S[o]+"\\s*"+S[l]+"$";var d=w++;S[d]="^"+S[o]+"\\s*"+S[g]+"$";var T=w++;S[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=w++;S[O]="(?:~>?)";var $=w++;S[$]="(\\s*)"+S[O]+"\\s+",R[$]=new RegExp(S[$],"g");var z=w++;S[z]="^"+S[O]+S[l]+"$";var V=w++;S[V]="^"+S[O]+S[g]+"$";var B=w++;S[B]="(?:\\^)";var M=w++;S[M]="(\\s*)"+S[B]+"\\s+",R[M]=new RegExp(S[M],"g");var _=w++;S[_]="^"+S[B]+S[l]+"$";var N=w++;S[N]="^"+S[B]+S[g]+"$";var j=w++;S[j]="^"+S[o]+"\\s*("+r+")$|^$";var F=w++;S[F]="^"+S[o]+"\\s*("+t+")$|^$";var U=w++;S[U]="(\\s*)"+S[o]+"\\s*("+r+"|"+S[l]+")",R[U]=new RegExp(S[U],"g");var x=w++;S[x]="^\\s*("+S[l]+")\\s+-\\s+("+S[l]+")\\s*$";var q=w++;S[q]="^\\s*("+S[g]+")\\s+-\\s+("+S[g]+")\\s*$";var H=w++;S[H]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)D(Y,S[Y]),R[Y]||(R[Y]=new RegExp(S[Y]));function te(J,ie){if(J instanceof ne)return J;if(typeof J!="string"||J.length>k||!(ie?R[i]:R[c]).test(J))return null;try{return new ne(J,ie)}catch(re){return null}}function ne(J,ie){if(J instanceof ne){if(J.loose===ie)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof ne))return new ne(J,ie);D("SemVer",J,ie),this.loose=ie;var re=J.trim().match(ie?R[i]:R[c]);if(!re)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+re[1],this.minor=+re[2],this.patch=+re[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");re[4]?this.prerelease=re[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var ve=+me;if(ve>=0&&ve<A)return ve}return me}):this.prerelease=[],this.build=re[5]?re[5].split("."):[],this.format()}e.parse=te,e.valid=function(J,ie){var re=te(J,ie);return re?re.version:null},e.clean=function(J,ie){var re=te(J.trim().replace(/^[=v]+/,""),ie);return re?re.version:null},e.SemVer=ne,ne.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ne.prototype.toString=function(){return this.version},ne.prototype.compare=function(J){return D("SemVer.compare",this.version,this.loose,J),J instanceof ne||(J=new ne(J,this.loose)),this.compareMain(J)||this.comparePre(J)},ne.prototype.compareMain=function(J){return J instanceof ne||(J=new ne(J,this.loose)),ee(this.major,J.major)||ee(this.minor,J.minor)||ee(this.patch,J.patch)},ne.prototype.comparePre=function(J){if(J instanceof ne||(J=new ne(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var ie=0;do{var re=this.prerelease[ie],me=J.prerelease[ie];if(D("prerelease compare",ie,re,me),re===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(re===void 0)return-1;if(re!==me)return ee(re,me)}while(++ie)},ne.prototype.inc=function(J,ie){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ie);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ie);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ie),this.inc("pre",ie);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ie),this.inc("pre",ie);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var re=this.prerelease.length;--re>=0;)typeof this.prerelease[re]=="number"&&(this.prerelease[re]++,re=-2);re===-1&&this.prerelease.push(0)}ie&&(this.prerelease[0]===ie?isNaN(this.prerelease[1])&&(this.prerelease=[ie,0]):this.prerelease=[ie,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,ie,re,me){typeof re=="string"&&(me=re,re=void 0);try{return new ne(J,re).inc(ie,me).version}catch(ve){return null}},e.diff=function(J,ie){if(Se(J,ie))return null;var re=te(J),me=te(ie);if(re.prerelease.length||me.prerelease.length){for(var ve in re)if((ve==="major"||ve==="minor"||ve==="patch")&&re[ve]!==me[ve])return"pre"+ve;return"prerelease"}for(var ve in re)if((ve==="major"||ve==="minor"||ve==="patch")&&re[ve]!==me[ve])return ve},e.compareIdentifiers=ee;var se=/^[0-9]+$/;function ee(J,ie){var re=se.test(J),me=se.test(ie);return re&&me&&(J=+J,ie=+ie),re&&!me?-1:me&&!re?1:J<ie?-1:J>ie?1:0}function he(J,ie,re){return new ne(J,re).compare(new ne(ie,re))}function de(J,ie,re){return he(J,ie,re)>0}function ye(J,ie,re){return he(J,ie,re)<0}function Se(J,ie,re){return he(J,ie,re)===0}function De(J,ie,re){return he(J,ie,re)!==0}function Te(J,ie,re){return he(J,ie,re)>=0}function Me(J,ie,re){return he(J,ie,re)<=0}function Oe(J,ie,re,me){var ve;switch(ie){case"===":typeof J=="object"&&(J=J.version),typeof re=="object"&&(re=re.version),ve=J===re;break;case"!==":typeof J=="object"&&(J=J.version),typeof re=="object"&&(re=re.version),ve=J!==re;break;case"":case"=":case"==":ve=Se(J,re,me);break;case"!=":ve=De(J,re,me);break;case">":ve=de(J,re,me);break;case">=":ve=Te(J,re,me);break;case"<":ve=ye(J,re,me);break;case"<=":ve=Me(J,re,me);break;default:throw new TypeError("Invalid operator: "+ie)}return ve}function Le(J,ie){if(J instanceof Le){if(J.loose===ie)return J;J=J.value}if(!(this instanceof Le))return new Le(J,ie);D("comparator",J,ie),this.loose=ie,this.parse(J),this.semver===_e?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(J,ie){return ee(ie,J)},e.major=function(J,ie){return new ne(J,ie).major},e.minor=function(J,ie){return new ne(J,ie).minor},e.patch=function(J,ie){return new ne(J,ie).patch},e.compare=he,e.compareLoose=function(J,ie){return he(J,ie,!0)},e.rcompare=function(J,ie,re){return he(ie,J,re)},e.sort=function(J,ie){return J.sort(function(re,me){return e.compare(re,me,ie)})},e.rsort=function(J,ie){return J.sort(function(re,me){return e.rcompare(re,me,ie)})},e.gt=de,e.lt=ye,e.eq=Se,e.neq=De,e.gte=Te,e.lte=Me,e.cmp=Oe,e.Comparator=Le;var _e={};function be(J,ie){if(J instanceof be)return J.loose===ie?J:new be(J.raw,ie);if(J instanceof Le)return new be(J.value,ie);if(!(this instanceof be))return new be(J,ie);if(this.loose=ie,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(re){return this.parseRange(re.trim())},this).filter(function(re){return re.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function ke(J){return!J||J.toLowerCase()==="x"||J==="*"}function Ke(J,ie,re,me,ve,Pe,we,Ae,Ce,Re,Ue,W,Z){return((ie=ke(re)?"":ke(me)?">="+re+".0.0":ke(ve)?">="+re+"."+me+".0":">="+ie)+" "+(Ae=ke(Ce)?"":ke(Re)?"<"+(+Ce+1)+".0.0":ke(Ue)?"<"+Ce+"."+(+Re+1)+".0":W?"<="+Ce+"."+Re+"."+Ue+"-"+W:"<="+Ae)).trim()}function Ye(J,ie){for(var re=0;re<J.length;re++)if(!J[re].test(ie))return!1;if(ie.prerelease.length){for(re=0;re<J.length;re++)if(D(J[re].semver),J[re].semver!==_e&&J[re].semver.prerelease.length>0){var me=J[re].semver;if(me.major===ie.major&&me.minor===ie.minor&&me.patch===ie.patch)return!0}return!1}return!0}function $e(J,ie,re){try{ie=new be(ie,re)}catch(me){return!1}return ie.test(J)}function je(J,ie,re,me){var ve,Pe,we,Ae,Ce;switch(J=new ne(J,me),ie=new be(ie,me),re){case">":ve=de,Pe=Me,we=ye,Ae=">",Ce=">=";break;case"<":ve=ye,Pe=Te,we=de,Ae="<",Ce="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(J,ie,me))return!1;for(var Re=0;Re<ie.set.length;++Re){var Ue=ie.set[Re],W=null,Z=null;if(Ue.forEach(function(ae){ae.semver===_e&&(ae=new Le(">=0.0.0")),W=W||ae,Z=Z||ae,ve(ae.semver,W.semver,me)?W=ae:we(ae.semver,Z.semver,me)&&(Z=ae)}),W.operator===Ae||W.operator===Ce||(!Z.operator||Z.operator===Ae)&&Pe(J,Z.semver)||Z.operator===Ce&&we(J,Z.semver))return!1}return!0}Le.prototype.parse=function(J){var ie=this.loose?R[j]:R[F],re=J.match(ie);if(!re)throw new TypeError("Invalid comparator: "+J);this.operator=re[1],this.operator==="="&&(this.operator=""),re[2]?this.semver=new ne(re[2],this.loose):this.semver=_e},Le.prototype.toString=function(){return this.value},Le.prototype.test=function(J){return D("Comparator.test",J,this.loose),this.semver===_e||(typeof J=="string"&&(J=new ne(J,this.loose)),Oe(J,this.operator,this.semver,this.loose))},Le.prototype.intersects=function(J,ie){if(!(J instanceof Le))throw new TypeError("a Comparator is required");var re;if(this.operator==="")return re=new be(J.value,ie),$e(this.value,re,ie);if(J.operator==="")return re=new be(this.value,ie),$e(J.semver,re,ie);var me=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),Pe=this.semver.version===J.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),Ae=Oe(this.semver,"<",J.semver,ie)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),Ce=Oe(this.semver,">",J.semver,ie)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return me||ve||Pe&&we||Ae||Ce},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(J){var ie=this.loose;J=J.trim(),D("range",J,ie);var re=ie?R[q]:R[x];J=J.replace(re,Ke),D("hyphen replace",J),J=J.replace(R[U],"$1$2$3"),D("comparator trim",J,R[U]),J=(J=(J=J.replace(R[$],"$1~")).replace(R[M],"$1^")).split(/\s+/).join(" ");var me=ie?R[j]:R[F],ve=J.split(" ").map(function(Pe){return function(we,Ae){return D("comp",we),we=function(Ce,Re){return Ce.trim().split(/\s+/).map(function(Ue){return function(W,Z){D("caret",W,Z);var ae=Z?R[N]:R[_];return W.replace(ae,function(ce,oe,ue,ge,pe){var le;return D("caret",W,ce,oe,ue,ge,pe),ke(oe)?le="":ke(ue)?le=">="+oe+".0.0 <"+(+oe+1)+".0.0":ke(ge)?le=oe==="0"?">="+oe+"."+ue+".0 <"+oe+"."+(+ue+1)+".0":">="+oe+"."+ue+".0 <"+(+oe+1)+".0.0":pe?(D("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),le=oe==="0"?ue==="0"?">="+oe+"."+ue+"."+ge+pe+" <"+oe+"."+ue+"."+(+ge+1):">="+oe+"."+ue+"."+ge+pe+" <"+oe+"."+(+ue+1)+".0":">="+oe+"."+ue+"."+ge+pe+" <"+(+oe+1)+".0.0"):(D("no pr"),le=oe==="0"?ue==="0"?">="+oe+"."+ue+"."+ge+" <"+oe+"."+ue+"."+(+ge+1):">="+oe+"."+ue+"."+ge+" <"+oe+"."+(+ue+1)+".0":">="+oe+"."+ue+"."+ge+" <"+(+oe+1)+".0.0"),D("caret return",le),le})}(Ue,Re)}).join(" ")}(we,Ae),D("caret",we),we=function(Ce,Re){return Ce.trim().split(/\s+/).map(function(Ue){return function(W,Z){var ae=Z?R[V]:R[z];return W.replace(ae,function(ce,oe,ue,ge,pe){var le;return D("tilde",W,ce,oe,ue,ge,pe),ke(oe)?le="":ke(ue)?le=">="+oe+".0.0 <"+(+oe+1)+".0.0":ke(ge)?le=">="+oe+"."+ue+".0 <"+oe+"."+(+ue+1)+".0":pe?(D("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),le=">="+oe+"."+ue+"."+ge+pe+" <"+oe+"."+(+ue+1)+".0"):le=">="+oe+"."+ue+"."+ge+" <"+oe+"."+(+ue+1)+".0",D("tilde return",le),le})}(Ue,Re)}).join(" ")}(we,Ae),D("tildes",we),we=function(Ce,Re){return D("replaceXRanges",Ce,Re),Ce.split(/\s+/).map(function(Ue){return function(W,Z){W=W.trim();var ae=Z?R[d]:R[E];return W.replace(ae,function(ce,oe,ue,ge,pe,le){D("xRange",W,ce,oe,ue,ge,pe,le);var Ee=ke(ue),Ie=Ee||ke(ge),Fe=Ie||ke(pe);return oe==="="&&Fe&&(oe=""),Ee?ce=oe===">"||oe==="<"?"<0.0.0":"*":oe&&Fe?(Ie&&(ge=0),Fe&&(pe=0),oe===">"?(oe=">=",Ie?(ue=+ue+1,ge=0,pe=0):Fe&&(ge=+ge+1,pe=0)):oe==="<="&&(oe="<",Ie?ue=+ue+1:ge=+ge+1),ce=oe+ue+"."+ge+"."+pe):Ie?ce=">="+ue+".0.0 <"+(+ue+1)+".0.0":Fe&&(ce=">="+ue+"."+ge+".0 <"+ue+"."+(+ge+1)+".0"),D("xRange return",ce),ce})}(Ue,Re)}).join(" ")}(we,Ae),D("xrange",we),we=function(Ce,Re){return D("replaceStars",Ce,Re),Ce.trim().replace(R[H],"")}(we,Ae),D("stars",we),we}(Pe,ie)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(Pe){return!!Pe.match(me)})),ve=ve.map(function(Pe){return new Le(Pe,ie)})},be.prototype.intersects=function(J,ie){if(!(J instanceof be))throw new TypeError("a Range is required");return this.set.some(function(re){return re.every(function(me){return J.set.some(function(ve){return ve.every(function(Pe){return me.intersects(Pe,ie)})})})})},e.toComparators=function(J,ie){return new be(J,ie).set.map(function(re){return re.map(function(me){return me.value}).join(" ").trim().split(" ")})},be.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new ne(J,this.loose));for(var ie=0;ie<this.set.length;ie++)if(Ye(this.set[ie],J))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(J,ie,re){var me=null,ve=null;try{var Pe=new be(ie,re)}catch(we){return null}return J.forEach(function(we){Pe.test(we)&&(me&&ve.compare(we)!==-1||(ve=new ne(me=we,re)))}),me},e.minSatisfying=function(J,ie,re){var me=null,ve=null;try{var Pe=new be(ie,re)}catch(we){return null}return J.forEach(function(we){Pe.test(we)&&(me&&ve.compare(we)!==1||(ve=new ne(me=we,re)))}),me},e.validRange=function(J,ie){try{return new be(J,ie).range||"*"}catch(re){return null}},e.ltr=function(J,ie,re){return je(J,ie,"<",re)},e.gtr=function(J,ie,re){return je(J,ie,">",re)},e.outside=je,e.prerelease=function(J,ie){var re=te(J,ie);return re&&re.prerelease.length?re.prerelease:null},e.intersects=function(J,ie,re){return J=new be(J,re),ie=new be(ie,re),J.intersects(ie)},e.coerce=function(J){if(J instanceof ne)return J;if(typeof J!="string")return null;var ie=J.match(R[T]);return ie==null?null:te((ie[1]||"0")+"."+(ie[2]||"0")+"."+(ie[3]||"0"))}}).call(this,p(1))},function(G,e){var p,L,D=G.exports={};function k(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function R(P){if(p===setTimeout)return setTimeout(P,0);if((p===k||!p)&&setTimeout)return p=setTimeout,setTimeout(P,0);try{return p(P,0)}catch(b){try{return p.call(null,P,0)}catch(I){return p.call(this,P,0)}}}(function(){try{p=typeof setTimeout=="function"?setTimeout:k}catch(P){p=k}try{L=typeof clearTimeout=="function"?clearTimeout:A}catch(P){L=A}})();var S,w=[],n=!1,y=-1;function v(){n&&S&&(n=!1,S.length?w=S.concat(w):y=-1,w.length&&m())}function m(){if(!n){var P=R(v);n=!0;for(var b=w.length;b;){for(S=w,w=[];++y<b;)S&&S[y].run();y=-1,b=w.length}S=null,n=!1,function(I){if(L===clearTimeout)return clearTimeout(I);if((L===A||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(I);try{L(I)}catch(f){try{return L.call(null,I)}catch(s){return L.call(this,I)}}}(P)}}function h(P,b){this.fun=P,this.array=b}function C(){}D.nextTick=function(P){var b=new Array(arguments.length-1);if(arguments.length>1)for(var I=1;I<arguments.length;I++)b[I-1]=arguments[I];w.push(new h(P,b)),w.length!==1||n||R(m)},h.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=C,D.addListener=C,D.once=C,D.off=C,D.removeListener=C,D.removeAllListeners=C,D.emit=C,D.prependListener=C,D.prependOnceListener=C,D.listeners=function(P){return[]},D.binding=function(P){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(P){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(X[89],Q([0,1,7]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=p.globals.performance&&typeof p.globals.performance.now=="function";class D{constructor(A){this._highResolution=L&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new D(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=D}),define(X[3],Q([0,1,9,65,2,88,89]),function(G,e,p,L,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var R;(function(f){f.None=()=>D.Disposable.None;function s(B){return(M,_=null,N)=>{let j=!1,F;return F=B(U=>{if(!j)return F?F.dispose():j=!0,M.call(_,U)},null,N),j&&F.dispose(),F}}f.once=s;function c(B,M){return a((_,N=null,j)=>B(F=>_.call(N,M(F)),null,j))}f.map=c;function t(B,M){return a((_,N=null,j)=>B(F=>{M(F),_.call(N,F)},null,j))}f.forEach=t;function r(B,M){return a((_,N=null,j)=>B(F=>M(F)&&_.call(N,F),null,j))}f.filter=r;function i(B){return B}f.signal=i;function o(...B){return(M,_=null,N)=>(0,D.combinedDisposable)(...B.map(j=>j(F=>M.call(_,F),null,N)))}f.any=o;function u(B,M,_){let N=_;return c(B,j=>(N=M(N,j),N))}f.reduce=u;function a(B){let M;const _=new v({onFirstListenerAdd(){M=B(_.fire,_)},onLastListenerRemove(){M.dispose()}});return _.event}function l(B,M,_=100,N=!1,j){let F,U,x,q=0;const H=new v({leakWarningThreshold:j,onFirstListenerAdd(){F=B(Y=>{q++,U=M(U,Y),N&&!x&&(H.fire(U),U=void 0),clearTimeout(x),x=setTimeout(()=>{const te=U;U=void 0,x=void 0,(!N||q>1)&&H.fire(te),q=0},_)})},onLastListenerRemove(){F.dispose()}});return H.event}f.debounce=l;function g(B,M=(_,N)=>_===N){let _=!0,N;return r(B,j=>{const F=_||!M(j,N);return _=!1,N=j,F})}f.latch=g;function E(B,M){return[f.filter(B,M),f.filter(B,_=>!M(_))]}f.split=E;function d(B,M=!1,_=[]){let N=_.slice(),j=B(x=>{N?N.push(x):U.fire(x)});const F=()=>{N&&N.forEach(x=>U.fire(x)),N=null},U=new v({onFirstListenerAdd(){j||(j=B(x=>U.fire(x)))},onFirstListenerDidAdd(){N&&(M?setTimeout(F):F())},onLastListenerRemove(){j&&j.dispose(),j=null}});return U.event}f.buffer=d;class T{constructor(M){this.event=M}map(M){return new T(c(this.event,M))}forEach(M){return new T(t(this.event,M))}filter(M){return new T(r(this.event,M))}reduce(M,_){return new T(u(this.event,M,_))}latch(){return new T(g(this.event))}debounce(M,_=100,N=!1,j){return new T(l(this.event,M,_,N,j))}on(M,_,N){return this.event(M,_,N)}once(M,_,N){return s(this.event)(M,_,N)}}function O(B){return new T(B)}f.chain=O;function $(B,M,_=N=>N){const N=(...x)=>U.fire(_(...x)),j=()=>B.on(M,N),F=()=>B.removeListener(M,N),U=new v({onFirstListenerAdd:j,onLastListenerRemove:F});return U.event}f.fromNodeEventEmitter=$;function z(B,M,_=N=>N){const N=(...x)=>U.fire(_(...x)),j=()=>B.addEventListener(M,N),F=()=>B.removeEventListener(M,N),U=new v({onFirstListenerAdd:j,onLastListenerRemove:F});return U.event}f.fromDOMEventEmitter=z;function V(B){return new Promise(M=>s(B)(M))}f.toPromise=V})(R=e.Event||(e.Event={}));class S{constructor(s){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${s}_${S._idPool++}`}start(s){this._stopWatch=new A.StopWatch(!0),this._listenerCount=s}stop(){if(this._stopWatch){const s=this._stopWatch.elapsed();this._elapsedOverall+=s,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${s.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let w=-1;function n(f){const s=w;return w=f,{dispose(){w=s}}}e.setGlobalLeakWarningThreshold=n;class y{constructor(s,c=Math.random().toString(18).slice(2,5)){this.customThreshold=s,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(s){let c=w;if(typeof this.customThreshold=="number"&&(c=this.customThreshold),c<=0||s<c)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(t)||0;if(this._stacks.set(t,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=c*.5;let i,o=0;for(const[u,a]of this._stacks)(!i||o<a)&&(i=u,o=a);console.warn(`[${this.name}] potential listener LEAK detected, having ${s} listeners already. MOST frequent listener (${o}):`),console.warn(i)}return()=>{const i=this._stacks.get(t)||0;this._stacks.set(t,i-1)}}}class v{constructor(s){this._disposed=!1,this._options=s,this._leakageMon=w>0?new y(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(s,c,t)=>{this._listeners||(this._listeners=new k.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(c?[s,c]:s);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,s,c);const o=this._leakageMon?.check(this._listeners.size),u=(0,D.toDisposable)(()=>{o&&o(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof D.DisposableStore?t.add(u):Array.isArray(t)&&t.push(u),u}),this._event}fire(s){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new k.LinkedList);for(let c of this._listeners)this._deliveryQueue.push([c,s]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[c,t]=this._deliveryQueue.shift();try{typeof c=="function"?c.call(void 0,t):c[0].call(c[1],t)}catch(r){(0,p.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=v;class m extends v{async fireAsync(s,c,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,s]);for(;this._asyncDeliveryQueue.size>0&&!c.isCancellationRequested;){const[r,i]=this._asyncDeliveryQueue.shift(),o=[],u={...i,waitUntil:a=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");t&&(a=t(a,typeof r=="function"?r:r[0])),o.push(a)}};try{typeof r=="function"?r.call(void 0,u):r[0].call(r[1],u)}catch(a){(0,p.onUnexpectedError)(a);continue}Object.freeze(o),await Promise.allSettled(o).then(a=>{for(const l of a)l.status==="rejected"&&(0,p.onUnexpectedError)(l.reason)})}}}}e.AsyncEmitter=m;class h extends v{constructor(s){super(s);this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=s?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const s=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(s))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(s){this._listeners&&(this._isPaused!==0?this._eventQueue.push(s):super.fire(s))}}e.PauseableEmitter=h;class C extends h{constructor(s){super(s);this._delay=s.delay??100}fire(s){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(s)}}e.DebounceEmitter=C;class P{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(s){const c={event:s,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const t=()=>{this.hasListeners&&this.unhook(c);const r=this.events.indexOf(c);this.events.splice(r,1)};return(0,D.toDisposable)((0,L.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(s=>this.hook(s))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(s=>this.unhook(s))}hook(s){s.listener=s.event(c=>this.emitter.fire(c))}unhook(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=P;class b{constructor(){this.buffers=[]}wrapEvent(s){return(c,t,r)=>s(i=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>c.call(t,i)):c.call(t,i)},void 0,r)}bufferEvents(s){const c=[];this.buffers.push(c);const t=s();return this.buffers.pop(),c.forEach(r=>r()),t}}e.EventBufferer=b;class I{constructor(){this.listening=!1,this.inputEvent=R.None,this.inputEventListener=D.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(s){this.inputEvent=s,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=s(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=I}),define(X[29],Q([0,1,3]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(R,S){const w=setTimeout(R.bind(S),0);return{dispose(){clearTimeout(w)}}});var D;(function(R){function S(w){return w===R.None||w===R.Cancelled||w instanceof k?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}R.isCancellationToken=S,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(D=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=D.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=A}),define(X[54],Q([0,1,3]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new p.Emitter}add(y){const v=this._icons.get(y.id);v?y.description?v.description=y.description:console.error(`Duplicate registration of codicon ${y.id}`):(this._icons.set(y.id,y),this._onDidRegister.fire(y))}get(y){return this._icons.get(y)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new L;e.iconRegistry=D;function k(n,y){return new R(n,y)}e.registerCodicon=k;function A(n){return n?n.replace(/\$\((.*?)\)/g,(y,v)=>` ${v} `).trim():""}e.getCodiconAriaLabel=A;class R{constructor(y,v,m){this.id=y,this.definition=v,this.description=m,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=R;function S(n,y){const v=["codicon","codicon-"+n];return y&&v.push("codicon-modifier-"+y),v}e.getClassNamesArray=S;var w;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const y=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function v(C){if(C instanceof R)return["codicon","codicon-"+C.id];const P=y.exec(C.id);if(!P)return v(R.error);let[,b,I]=P;const f=["codicon","codicon-"+b];return I&&f.push("codicon-modifier-"+I.substr(1)),f}n.asClassNameArray=v;function m(C){return v(C).join(" ")}n.asClassName=m;function h(C){return"."+v(C).join(".")}n.asCSSSelector=h})(w=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(R=e.Codicon||(e.Codicon={}))}),define(X[48],Q([0,1,9,2]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(f){const s=f;return s?[s.on,s.pause,s.resume,s.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=D;function k(f){const s=f;return s?D(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=k;function A(f,s){return new R(f,s)}e.newWriteableStream=A;class R{constructor(s,c){this.reducer=s,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(c=>c(s))}emitError(s){this.listeners.error.length===0?(0,p.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(c=>c(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,c){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(s,c){if(this.state.destroyed)return;let t;switch(s){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(c);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(f,s){const c=[];let t;for(;(t=f.read())!==null;)c.push(t);return s(c)}e.consumeReadable=S;function w(f,s,c){const t=[];let r;for(;(r=f.read())!==null&&t.length<c;)t.push(r);return r===null&&t.length>0?s(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const i=r;return r=void 0,i}return f.read()}}}e.peekReadable=w;function n(f,s){return new Promise((c,t)=>{const r=[];y(f,{onData:i=>{s&&r.push(i)},onError:i=>{s?t(i):c(void 0)},onEnd:()=>{c(s?s(r):void 0)}})})}e.consumeStream=n;function y(f,s){f.on("error",c=>s.onError(c)),f.on("end",()=>s.onEnd()),f.on("data",c=>s.onData(c))}e.listenStream=y;function v(f,s){return new Promise((c,t)=>{const r=new L.DisposableStore,i=[],o=l=>{if(i.push(l),i.length>s)return r.dispose(),f.pause(),c({stream:f,buffer:i,ended:!1})},u=l=>t(l),a=()=>c({stream:f,buffer:i,ended:!0});r.add((0,L.toDisposable)(()=>f.removeListener("error",u))),f.on("error",u),r.add((0,L.toDisposable)(()=>f.removeListener("end",a))),f.on("end",a),r.add((0,L.toDisposable)(()=>f.removeListener("data",o))),f.on("data",o)})}e.peekStream=v;function m(f,s){const c=A(s);return c.end(f),c}e.toStream=m;function h(){const f=A(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=h;function C(f){let s=!1;return{read:()=>s?null:(s=!0,f)}}e.toReadable=C;function P(f,s,c){const t=A(c);return y(f,{onData:r=>t.write(s.data(r)),onError:r=>t.error(s.error?s.error(r):r),onEnd:()=>t.end()}),t}e.transform=P;function b(f,s,c){let t=!1;return{read:()=>{const r=s.read();return t?r:(t=!0,r!==null?c([f,r]):f)}}}e.prefixedReadable=b;function I(f,s,c){let t=!1;const r=A(c);return y(s,{onData:i=>t?r.write(i):(t=!0,r.write(c([f,i]))),onError:i=>r.error(i),onEnd:()=>{t||(t=!0,r.write(f)),r.end()}}),r}e.prefixedStream=I}),define(X[19],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function p(W){return!W||typeof W!="string"?!0:W.trim().length===0}e.isFalsyOrWhitespace=p;const L=/{(\d+)}/g;function D(W,...Z){return Z.length===0?W:W.replace(L,function(ae,ce){const oe=parseInt(ce,10);return isNaN(oe)||oe<0||oe>=Z.length?ae:Z[oe]})}e.format=D;const k=/{([^}]+)}/g;function A(W,Z){return W.replace(k,(ae,ce)=>Z[ce]??ae)}e.format2=A;function R(W){return W.replace(/[<>&]/g,function(Z){switch(Z){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Z}})}e.escape=R;function S(W){return W.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function w(W,Z){let ae=0;const ce=Z.charCodeAt(0);for(let oe=W.length-1;oe>=0;oe--)W.charCodeAt(oe)===ce&&ae++;return ae}e.count=w;function n(W,Z,ae="\u2026"){return W.length<=Z?W:`${W.substr(0,Z)}${ae}`}e.truncate=n;function y(W,Z=" "){const ae=v(W,Z);return m(ae,Z)}e.trim=y;function v(W,Z){if(!W||!Z)return W;const ae=Z.length;if(ae===0||W.length===0)return W;let ce=0;for(;W.indexOf(Z,ce)===ce;)ce=ce+ae;return W.substring(ce)}e.ltrim=v;function m(W,Z){if(!W||!Z)return W;const ae=Z.length,ce=W.length;if(ae===0||ce===0)return W;let oe=ce,ue=-1;for(;ue=W.lastIndexOf(Z,oe-1),!(ue===-1||ue+ae!==oe);){if(ue===0)return"";oe=ue}return W.substring(0,oe)}e.rtrim=m;function h(W){return W.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function C(W){return W.replace(/\*/g,"")}e.stripWildcards=C;function P(W,Z,ae={}){if(!W)throw new Error("Cannot create regex from empty string");Z||(W=S(W)),ae.wholeWord&&(/\B/.test(W.charAt(0))||(W="\\b"+W),/\B/.test(W.charAt(W.length-1))||(W=W+"\\b"));let ce="";return ae.global&&(ce+="g"),ae.matchCase||(ce+="i"),ae.multiline&&(ce+="m"),ae.unicode&&(ce+="u"),new RegExp(W,ce)}e.createRegExp=P;function b(W){return W.source==="^"||W.source==="^$"||W.source==="$"||W.source==="^\\s*$"?!1:!!(W.exec("")&&W.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function I(W){return!!W.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=I;function f(W){return(W.global?"g":"")+(W.ignoreCase?"i":"")+(W.multiline?"m":"")+(W.unicode?"u":"")}e.regExpFlags=f;function s(W){return W.split(/\r\n|\r|\n/)}e.splitLines=s;function c(W){for(let Z=0,ae=W.length;Z<ae;Z++){const ce=W.charCodeAt(Z);if(ce!==32&&ce!==9)return Z}return-1}e.firstNonWhitespaceIndex=c;function t(W,Z=0,ae=W.length){for(let ce=Z;ce<ae;ce++){const oe=W.charCodeAt(ce);if(oe!==32&&oe!==9)return W.substring(Z,ce)}return W.substring(Z,ae)}e.getLeadingWhitespace=t;function r(W,Z=W.length-1){for(let ae=Z;ae>=0;ae--){const ce=W.charCodeAt(ae);if(ce!==32&&ce!==9)return ae}return-1}e.lastNonWhitespaceIndex=r;function i(W,Z){return W<Z?-1:W>Z?1:0}e.compare=i;function o(W,Z,ae=0,ce=W.length,oe=0,ue=Z.length){for(;ae<ce&&oe<ue;ae++,oe++){let le=W.charCodeAt(ae),Ee=Z.charCodeAt(oe);if(le<Ee)return-1;if(le>Ee)return 1}const ge=ce-ae,pe=ue-oe;return ge<pe?-1:ge>pe?1:0}e.compareSubstring=o;function u(W,Z){return a(W,Z,0,W.length,0,Z.length)}e.compareIgnoreCase=u;function a(W,Z,ae=0,ce=W.length,oe=0,ue=Z.length){for(;ae<ce&&oe<ue;ae++,oe++){let le=W.charCodeAt(ae),Ee=Z.charCodeAt(oe);if(le===Ee)continue;const Ie=le-Ee;if(!(Ie===32&&g(Ee))&&!(Ie===-32&&g(le)))return l(le)&&l(Ee)?Ie:o(W.toLowerCase(),Z.toLowerCase(),ae,ce,oe,ue)}const ge=ce-ae,pe=ue-oe;return ge<pe?-1:ge>pe?1:0}e.compareSubstringIgnoreCase=a;function l(W){return W>=97&&W<=122}e.isLowerAsciiLetter=l;function g(W){return W>=65&&W<=90}e.isUpperAsciiLetter=g;function E(W){return l(W)||g(W)}function d(W,Z){return W.length===Z.length&&T(W,Z)}e.equalsIgnoreCase=d;function T(W,Z,ae=W.length){for(let ce=0;ce<ae;ce++){const oe=W.charCodeAt(ce),ue=Z.charCodeAt(ce);if(oe!==ue){if(E(oe)&&E(ue)){const ge=Math.abs(oe-ue);if(ge!==0&&ge!==32)return!1}else if(String.fromCharCode(oe).toLowerCase()!==String.fromCharCode(ue).toLowerCase())return!1}}return!0}function O(W,Z){const ae=Z.length;return Z.length>W.length?!1:T(W,Z,ae)}e.startsWithIgnoreCase=O;function $(W,Z){let ae,ce=Math.min(W.length,Z.length);for(ae=0;ae<ce;ae++)if(W.charCodeAt(ae)!==Z.charCodeAt(ae))return ae;return ce}e.commonPrefixLength=$;function z(W,Z){let ae,ce=Math.min(W.length,Z.length);const oe=W.length-1,ue=Z.length-1;for(ae=0;ae<ce;ae++)if(W.charCodeAt(oe-ae)!==Z.charCodeAt(ue-ae))return ae;return ce}e.commonSuffixLength=z;function V(W){return 55296<=W&&W<=56319}e.isHighSurrogate=V;function B(W){return 56320<=W&&W<=57343}e.isLowSurrogate=B;function M(W,Z){return(W-55296<<10)+(Z-56320)+65536}e.computeCodePoint=M;function _(W,Z,ae){const ce=W.charCodeAt(ae);if(V(ce)&&ae+1<Z){const oe=W.charCodeAt(ae+1);if(B(oe))return M(ce,oe)}return ce}e.getNextCodePoint=_;function N(W,Z){const ae=W.charCodeAt(Z-1);if(B(ae)&&Z>1){const ce=W.charCodeAt(Z-2);if(V(ce))return M(ce,ae)}return ae}function j(W,Z){const ae=ve.getInstance(),ce=Z,oe=W.length,ue=_(W,oe,Z);Z+=ue>=65536?2:1;let ge=ae.getGraphemeBreakType(ue);for(;Z<oe;){const pe=_(W,oe,Z),le=ae.getGraphemeBreakType(pe);if(re(ge,le))break;Z+=pe>=65536?2:1,ge=le}return Z-ce}e.nextCharLength=j;function F(W,Z){const ae=ve.getInstance(),ce=Z,oe=N(W,Z);Z-=oe>=65536?2:1;let ue=ae.getGraphemeBreakType(oe);for(;Z>0;){const ge=N(W,Z),pe=ae.getGraphemeBreakType(ge);if(re(pe,ue))break;Z-=ge>=65536?2:1,ue=pe}return ce-Z}e.prevCharLength=F;function U(W,Z){const ae=ve.getInstance(),ce=W.length,oe=Z,ue=_(W,ce,Z),ge=ae.getGraphemeBreakType(ue);Z+=ue>=65536?2:1;let pe=ge;for(;Z<ce;){const Ee=_(W,ce,Z),Ie=ae.getGraphemeBreakType(Ee);if(re(pe,Ie))break;Z+=Ee>=65536?2:1,pe=Ie}const le=Z;for(Z=oe,pe=ge;Z>0;){const Ee=N(W,Z),Ie=ae.getGraphemeBreakType(Ee);if(re(Ie,pe))break;Z-=Ee>=65536?2:1,pe=Ie}return[Z,le]}function x(W,Z){return Z>0&&B(W.charCodeAt(Z))?U(W,Z-1):U(W,Z)}e.getCharContainingOffset=x;function q(W){const Z=W.length;let ae=0,ce=0;for(;ce<Z;){const ge=_(W,Z,ce);ce+=ge>=65536?2:1,ge<128?ae+=1:ge<2048?ae+=2:ge<65536?ae+=3:ae+=4}const oe=new Uint8Array(ae);ce=0;let ue=0;for(;ce<Z;){const ge=_(W,Z,ce);ce+=ge>=65536?2:1,ge<128?oe[ue++]=ge:ge<2048?(oe[ue++]=192|(ge&1984)>>>6,oe[ue++]=128|(ge&63)>>>0):ge<65536?(oe[ue++]=224|(ge&61440)>>>12,oe[ue++]=128|(ge&4032)>>>6,oe[ue++]=128|(ge&63)>>>0):(oe[ue++]=240|(ge&1835008)>>>18,oe[ue++]=128|(ge&258048)>>>12,oe[ue++]=128|(ge&4032)>>>6,oe[ue++]=128|(ge&63)>>>0)}return oe}e.encodeUTF8=q;function H(W){const Z=W.byteLength,ae=[];let ce=0;for(;ce<Z;){const oe=W[ce];let ue;if(oe>=240&&ce+3<Z?ue=(W[ce++]&7)<<18>>>0|(W[ce++]&63)<<12>>>0|(W[ce++]&63)<<6>>>0|(W[ce++]&63)<<0>>>0:oe>=224&&ce+2<Z?ue=(W[ce++]&15)<<12>>>0|(W[ce++]&63)<<6>>>0|(W[ce++]&63)<<0>>>0:oe>=192&&ce+1<Z?ue=(W[ce++]&31)<<6>>>0|(W[ce++]&63)<<0>>>0:ue=W[ce++],ue>=0&&ue<=55295||ue>=57344&&ue<=65535)ae.push(String.fromCharCode(ue));else if(ue>=65536&&ue<=1114111){const ge=ue-65536,pe=55296+((ge&1047552)>>>10),le=56320+((ge&1023)>>>0);ae.push(String.fromCharCode(pe)),ae.push(String.fromCharCode(le))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=H;const Y=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function te(W){return Y.test(W)}e.containsRTL=te;const ne=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function se(W){return ne.test(W)}e.containsEmoji=se;const ee=/^[\t\n\r\x20-\x7E]*$/;function he(W){return ee.test(W)}e.isBasicASCII=he,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function de(W){return e.UNUSUAL_LINE_TERMINATORS.test(W)}e.containsUnusualLineTerminators=de;function ye(W){for(let Z=0,ae=W.length;Z<ae;Z++)if(Se(W.charCodeAt(Z)))return!0;return!1}e.containsFullWidthCharacter=ye;function Se(W){return W=+W,W>=11904&&W<=55215||W>=63744&&W<=64255||W>=65281&&W<=65374}e.isFullWidthCharacter=Se;function De(W){return W>=127462&&W<=127487||W===8986||W===8987||W===9200||W===9203||W>=9728&&W<=10175||W===11088||W===11093||W>=127744&&W<=128591||W>=128640&&W<=128764||W>=128992&&W<=129003||W>=129280&&W<=129535||W>=129648&&W<=129750}e.isEmojiImprecise=De;function Te(W,Z){if(W.length<Z)return W;const ae=/\b/g;let ce=0;for(;ae.test(W)&&!(W.length-ae.lastIndex<Z);)ce=ae.lastIndex,ae.lastIndex+=1;return W.substring(ce).replace(/^\s/,"")}e.lcut=Te;const Me=/\x1B\x5B[12]?K/g,Oe=/\x1b\[\d+m/g,Le=/\x1b\[0?m/g;function _e(W){return W&&(W=W.replace(Me,""),W=W.replace(Oe,""),W=W.replace(Le,"")),W}e.removeAnsiEscapeCodes=_e,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function be(W){return!!(W&&W.length>0&&W.charCodeAt(0)===65279)}e.startsWithUTF8BOM=be;function ke(W){return be(W)?W.substr(1):W}e.stripUTF8BOM=ke;function Ke(W,Z){if(!W||!Z||W.length<Z.length)return!1;const ae=Z.length,ce=W.toLowerCase();let oe=0,ue=-1;for(;oe<ae;){const ge=ce.indexOf(Z[oe],ue+1);if(ge<0)return!1;ue=ge,oe++}return!0}e.fuzzyContains=Ke;function Ye(W,Z=!1){return W?(Z&&(W=W.replace(/\\./g,"")),W.toLowerCase()!==W):!1}e.containsUppercaseCharacter=Ye;function $e(W){return W.charAt(0).toUpperCase()+W.slice(1)}e.uppercaseFirstLetter=$e;function je(W,Z=1){if(Z===0)return"";let ae=-1;do ae=W.indexOf(`
`,ae+1),Z--;while(Z>0&&ae>=0);return ae===-1?W:(W[ae-1]==="\r"&&ae--,W.substr(0,ae))}e.getNLines=je;function J(W){const Z=90-65+1;return W=W%(2*Z),W<Z?String.fromCharCode(97+W):String.fromCharCode(65+W-Z)}e.singleLetterHash=J;function ie(W){return ve.getInstance().getGraphemeBreakType(W)}e.getGraphemeBreakType=ie;function re(W,Z){return W===0?Z!==5&&Z!==7:W===2&&Z===3?!1:W===4||W===2||W===3||Z===4||Z===2||Z===3?!0:!(W===8&&(Z===8||Z===9||Z===11||Z===12)||(W===11||W===9)&&(Z===9||Z===10)||(W===12||W===10)&&Z===10||Z===5||Z===13||Z===7||W===1||W===13&&Z===14||W===6&&Z===6)}e.breakBetweenGraphemeBreakType=re;var me;(function(W){W[W.Other=0]="Other",W[W.Prepend=1]="Prepend",W[W.CR=2]="CR",W[W.LF=3]="LF",W[W.Control=4]="Control",W[W.Extend=5]="Extend",W[W.Regional_Indicator=6]="Regional_Indicator",W[W.SpacingMark=7]="SpacingMark",W[W.L=8]="L",W[W.V=9]="V",W[W.T=10]="T",W[W.LV=11]="LV",W[W.LVT=12]="LVT",W[W.ZWJ=13]="ZWJ",W[W.Extended_Pictographic=14]="Extended_Pictographic"})(me=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ve{constructor(){this._data=Pe()}static getInstance(){return ve._INSTANCE||(ve._INSTANCE=new ve),ve._INSTANCE}getGraphemeBreakType(Z){if(Z<32)return Z===10?3:Z===13?2:4;if(Z<127)return 0;const ae=this._data,ce=ae.length/3;let oe=1;for(;oe<=ce;)if(Z<ae[3*oe])oe=2*oe;else if(Z>ae[3*oe+1])oe=2*oe+1;else return ae[3*oe+2];return 0}}ve._INSTANCE=null;function Pe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function we(W,Z){if(W===0)return 0;const ae=Ae(W,Z);if(ae!==void 0)return ae;const ce=N(Z,W);return W-=Ce(ce),W}e.getLeftDeleteOffset=we;function Ae(W,Z){let ae=N(Z,W);for(W-=Ce(ae);Re(ae)||ae===65039||ae===8419;){if(W===0)return;ae=N(Z,W),W-=Ce(ae)}if(!!De(ae)){if(W>=0){const ce=N(Z,W);ce===8205&&(W-=Ce(ce))}return W}}function Ce(W){return W>=65536?2:1}function Re(W){return 127995<=W&&W<=127999}var Ue;(function(W){W[W.zwj=8205]="zwj",W[W.emojiVariantSelector=65039]="emojiVariantSelector",W[W.enclosingKeyCap=8419]="enclosingKeyCap"})(Ue||(Ue={}))}),define(X[25],Q([0,1,19,48]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer!="undefined",k=typeof TextEncoder!="undefined",A=typeof TextDecoder!="undefined";let R,S;class w{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return D?new w(Buffer.allocUnsafe(l)):new w(new Uint8Array(l))}static wrap(l){return D&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new w(l)}static fromString(l,g){return!(g?.dontUseNodeBuffer||!1)&&D?new w(Buffer.from(l)):k?(R||(R=new TextEncoder),new w(R.encode(l))):new w(p.encodeUTF8(l))}static concat(l,g){if(typeof g=="undefined"){g=0;for(let T=0,O=l.length;T<O;T++)g+=l[T].byteLength}const E=w.alloc(g);let d=0;for(let T=0,O=l.length;T<O;T++){const $=l[T];E.set($,d),d+=$.byteLength}return E}toString(){return D?this.buffer.toString():A?(S||(S=new TextDecoder),S.decode(this.buffer)):p.decodeUTF8(this.buffer)}slice(l,g){return new w(this.buffer.subarray(l,g))}set(l,g){l instanceof w?this.buffer.set(l.buffer,g):this.buffer.set(l,g)}readUInt32BE(l){return v(this.buffer,l)}writeUInt32BE(l,g){m(this.buffer,l,g)}readUInt32LE(l){return h(this.buffer,l)}writeUInt32LE(l,g){C(this.buffer,l,g)}readUInt8(l){return P(this.buffer,l)}writeUInt8(l,g){b(this.buffer,l,g)}}e.VSBuffer=w;function n(a,l){return a[l+0]<<0>>>0|a[l+1]<<8>>>0}e.readUInt16LE=n;function y(a,l,g){a[g+0]=l&255,l=l>>>8,a[g+1]=l&255}e.writeUInt16LE=y;function v(a,l){return a[l]*2**24+a[l+1]*2**16+a[l+2]*2**8+a[l+3]}e.readUInt32BE=v;function m(a,l,g){a[g+3]=l,l=l>>>8,a[g+2]=l,l=l>>>8,a[g+1]=l,l=l>>>8,a[g]=l}e.writeUInt32BE=m;function h(a,l){return a[l+0]<<0>>>0|a[l+1]<<8>>>0|a[l+2]<<16>>>0|a[l+3]<<24>>>0}e.readUInt32LE=h;function C(a,l,g){a[g+0]=l&255,l=l>>>8,a[g+1]=l&255,l=l>>>8,a[g+2]=l&255,l=l>>>8,a[g+3]=l&255}e.writeUInt32LE=C;function P(a,l){return a[l]}e.readUInt8=P;function b(a,l,g){a[g]=l}e.writeUInt8=b;function I(a){return L.consumeReadable(a,l=>w.concat(l))}e.readableToBuffer=I;function f(a){return L.toReadable(a)}e.bufferToReadable=f;function s(a){return L.consumeStream(a,l=>w.concat(l))}e.streamToBuffer=s;async function c(a){return a.ended?w.concat(a.buffer):w.concat([...a.buffer,await s(a.stream)])}e.bufferedStreamToBuffer=c;function t(a){return L.toStream(a,l=>w.concat(l))}e.bufferToStream=t;function r(a){return L.transform(a,{data:l=>typeof l=="string"?w.fromString(l):w.wrap(l)},l=>w.concat(l))}e.streamToBufferReadableStream=r;function i(a){return L.newWriteableStream(l=>w.concat(l),a)}e.newWriteableBufferStream=i;function o(a,l){return L.prefixedReadable(a,l,g=>w.concat(g))}e.prefixedBufferReadable=o;function u(a,l){return L.prefixedStream(a,l,g=>w.concat(g))}e.prefixedBufferStream=u}),define(X[16],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(l){return Array.isArray(l)}e.isArray=p;function L(l){return typeof l=="string"}e.isString=L;function D(l){return Array.isArray(l)&&l.every(g=>L(g))}e.isStringArray=D;function k(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.isObject=k;function A(l){return typeof l=="number"&&!isNaN(l)}e.isNumber=A;function R(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.isIterable=R;function S(l){return l===!0||l===!1}e.isBoolean=S;function w(l){return typeof l=="undefined"}e.isUndefined=w;function n(l){return!y(l)}e.isDefined=n;function y(l){return w(l)||l===null}e.isUndefinedOrNull=y;function v(l,g){if(!l)throw new Error(g?`Unexpected type, expected '${g}'`:"Unexpected type")}e.assertType=v;function m(l){if(y(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.assertIsDefined=m;function h(...l){const g=[];for(let E=0;E<l.length;E++){const d=l[E];if(y(d))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);g.push(d)}return g}e.assertAllDefined=h;const C=Object.prototype.hasOwnProperty;function P(l){if(!k(l))return!1;for(let g in l)if(C.call(l,g))return!1;return!0}e.isEmptyObject=P;function b(l){return typeof l=="function"}e.isFunction=b;function I(...l){return l.length>0&&l.every(b)}e.areFunctions=I;function f(l,g){const E=Math.min(l.length,g.length);for(let d=0;d<E;d++)s(l[d],g[d])}e.validateConstraints=f;function s(l,g){if(L(g)){if(typeof l!==g)throw new Error(`argument does not match constraint: typeof ${g}`)}else if(b(g)){try{if(l instanceof g)return}catch{}if(!y(l)&&l.constructor===g||g.length===1&&g.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=s;function c(l){let g=[],E=Object.getPrototypeOf(l);for(;Object.prototype!==E;)g=g.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return g}e.getAllPropertyNames=c;function t(l){const g=[];for(const E of c(l))typeof l[E]=="function"&&g.push(E);return g}e.getAllMethodNames=t;function r(l,g){const E=T=>function(){const O=Array.prototype.slice.call(arguments,0);return g(T,O)};let d={};for(const T of l)d[T]=E(T);return d}e.createProxyObject=r;function i(l){return l===null?void 0:l}e.withNullAsUndefined=i;function o(l){return typeof l=="undefined"?null:l}e.withUndefinedAsNull=o;function u(l){return class{constructor(){return new Proxy({},{get(g,E){if(g[E])return g[E];throw new Error(`Not Implemented: ${l}->${String(E)}`)}})}}}e.NotImplementedProxy=u;function a(l,g="Unreachable"){throw new Error(g)}e.assertNever=a}),define(X[41],Q([0,1,7,19,8,16]),function(G,e,p,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(i){return i===47||i===92}e.isPathSeparator=A;function R(i){return i.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=R;function S(i){return i.indexOf("/")===-1&&(i=R(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=S;function w(i,o=D.posix.sep){if(!i)return"";const u=i.length,a=i.charCodeAt(0);if(A(a)){if(A(i.charCodeAt(1))&&!A(i.charCodeAt(2))){let g=3;const E=g;for(;g<u&&!A(i.charCodeAt(g));g++);if(E!==g&&!A(i.charCodeAt(g+1))){for(g+=1;g<u;g++)if(A(i.charCodeAt(g)))return i.slice(0,g+1).replace(/[\\/]/g,o)}}return o}else if(b(a)&&i.charCodeAt(1)===58)return A(i.charCodeAt(2))?i.slice(0,2)+o:i.slice(0,2);let l=i.indexOf("://");if(l!==-1){for(l+=3;l<u;l++)if(A(i.charCodeAt(l)))return i.slice(0,l+1)}return""}e.getRoot=w;function n(i){if(!p.isWindows||!i||i.length<5)return!1;let o=i.charCodeAt(0);if(o!==92||(o=i.charCodeAt(1),o!==92))return!1;let u=2;const a=u;for(;u<i.length&&(o=i.charCodeAt(u),o!==92);u++);return!(a===u||(o=i.charCodeAt(u+1),isNaN(o)||o===92))}e.isUNC=n;const y=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(i,o=p.isWindows){const u=o?y:v;return!(!i||i.length===0||/^\s+$/.test(i)||(u.lastIndex=0,u.test(i))||o&&m.test(i)||i==="."||i===".."||o&&i[i.length-1]==="."||o&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=h;function C(i,o,u){const a=i===o;return!u||a?a:!i||!o?!1:(0,L.equalsIgnoreCase)(i,o)}e.isEqual=C;function P(i,o,u,a=D.sep){if(i===o)return!0;if(!i||!o||o.length>i.length)return!1;if(u){if(!(0,L.startsWithIgnoreCase)(i,o))return!1;if(o.length===i.length)return!0;let g=o.length;return o.charAt(o.length-1)===a&&g--,i.charAt(g)===a}return o.charAt(o.length-1)!==a&&(o+=a),i.indexOf(o)===0}e.isEqualOrParent=P;function b(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=b;function I(i,o){return p.isWindows&&i.endsWith(":")&&(i+=D.sep),(0,D.isAbsolute)(i)||(i=(0,D.join)(o,i)),i=(0,D.normalize)(i),p.isWindows?(i=(0,L.rtrim)(i,D.sep),i.endsWith(":")&&(i+=D.sep)):(i=(0,L.rtrim)(i,D.sep),i||(i=D.sep)),i}e.sanitizeFilePath=I;function f(i){const o=(0,D.normalize)(i);return p.isWindows?i.length>3?!1:s(o)&&(i.length===2||o.charCodeAt(2)===92):o===D.posix.sep}e.isRootOrDriveLetter=f;function s(i){return p.isWindows?b(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=s;function c(i){return s(i)?i[0]:void 0}e.getDriveLetter=c;function t(i,o,u){return o.length>i.length?-1:i===o?0:(u&&(i=i.toLowerCase(),o=o.toLowerCase()),i.indexOf(o))}e.indexOfPath=t;function r(i){const o=i.split(":");let u,a,l;if(o.forEach(g=>{const E=Number(g);(0,k.isNumber)(E)?a===void 0?a=E:l===void 0&&(l=E):u=u?[u,g].join(":"):g}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:a!==void 0?a:void 0,column:l!==void 0?l:a!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(X[26],Q([0,1,16]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(C){if(!C||typeof C!="object"||C instanceof RegExp)return C;const P=Array.isArray(C)?[]:{};return Object.keys(C).forEach(b=>{C[b]&&typeof C[b]=="object"?P[b]=L(C[b]):P[b]=C[b]}),P}e.deepClone=L;function D(C){if(!C||typeof C!="object")return C;const P=[C];for(;P.length>0;){const b=P.shift();Object.freeze(b);for(const I in b)if(k.call(b,I)){const f=b[I];typeof f=="object"&&!Object.isFrozen(f)&&P.push(f)}}return C}e.deepFreeze=D;const k=Object.prototype.hasOwnProperty;function A(C,P){return R(C,P,new Set)}e.cloneAndChange=A;function R(C,P,b){if((0,p.isUndefinedOrNull)(C))return C;const I=P(C);if(typeof I!="undefined")return I;if((0,p.isArray)(C)){const f=[];for(const s of C)f.push(R(s,P,b));return f}if((0,p.isObject)(C)){if(b.has(C))throw new Error("Cannot clone recursive data-structure");b.add(C);const f={};for(let s in C)k.call(C,s)&&(f[s]=R(C[s],P,b));return b.delete(C),f}return C}function S(C,P,b=!0){return(0,p.isObject)(C)?((0,p.isObject)(P)&&Object.keys(P).forEach(I=>{I in C?b&&((0,p.isObject)(C[I])&&(0,p.isObject)(P[I])?S(C[I],P[I],b):C[I]=P[I]):C[I]=P[I]}),C):P}e.mixin=S;function w(C,P){if(C===P)return!0;if(C==null||P===null||P===void 0||typeof C!=typeof P||typeof C!="object"||Array.isArray(C)!==Array.isArray(P))return!1;let b,I;if(Array.isArray(C)){if(C.length!==P.length)return!1;for(b=0;b<C.length;b++)if(!w(C[b],P[b]))return!1}else{const f=[];for(I in C)f.push(I);f.sort();const s=[];for(I in P)s.push(I);if(s.sort(),!w(f,s))return!1;for(b=0;b<f.length;b++)if(!w(C[f[b]],P[f[b]]))return!1}return!0}e.equals=w;function n(C){const P=new Set;return JSON.stringify(C,(b,I)=>{if((0,p.isObject)(I)||Array.isArray(I)){if(P.has(I))return"[Circular]";P.add(I)}return I})}e.safeStringify=n;function y(C,P,b){const I=P(C);return typeof I=="undefined"?b:I}e.getOrDefault=y;function v(C,P){const b=Object.create(null);return!C||!P||Object.keys(P).forEach(f=>{const s=C[f],c=P[f];w(s,c)||(b[f]=c)}),b}e.distinct=v;function m(C,P){const b=P.toLowerCase(),I=Object.keys(C).find(f=>f.toLowerCase()===b);return I?C[I]:C[P]}e.getCaseInsensitive=m;function h(C,P){const b=Object.create(null);for(const I of Object.keys(C))P(I,C[I])&&(b[I]=C[I]);return b}e.filter=h}),define(X[4],Q([0,1,7,8]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,k=/^\//,A=/^\/\//;function R(i,o){if(!i.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!D.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!k.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(i,o){return!i&&!o?"file":i}function w(i,o){switch(i){case"https":case"http":case"file":o?o[0]!==y&&(o=y+o):o=y;break}return o}const n="",y="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(o,u,a,l,g,E=!1){typeof o=="object"?(this.scheme=o.scheme||n,this.authority=o.authority||n,this.path=o.path||n,this.query=o.query||n,this.fragment=o.fragment||n):(this.scheme=S(o,E),this.authority=u||n,this.path=w(this.scheme,a||n),this.query=l||n,this.fragment=g||n,R(this,E))}static isUri(o){return o instanceof m?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return f(this,!1)}with(o){if(!o)return this;let{scheme:u,authority:a,path:l,query:g,fragment:E}=o;return u===void 0?u=this.scheme:u===null&&(u=n),a===void 0?a=this.authority:a===null&&(a=n),l===void 0?l=this.path:l===null&&(l=n),g===void 0?g=this.query:g===null&&(g=n),E===void 0?E=this.fragment:E===null&&(E=n),u===this.scheme&&a===this.authority&&l===this.path&&g===this.query&&E===this.fragment?this:new C(u,a,l,g,E)}static parse(o,u=!1){const a=v.exec(o);return a?new C(a[2]||n,r(a[4]||n),r(a[5]||n),r(a[7]||n),r(a[9]||n),u):new C(n,n,n,n,n)}static file(o){let u=n;if(p.isWindows&&(o=o.replace(/\\/g,y)),o[0]===y&&o[1]===y){const a=o.indexOf(y,2);a===-1?(u=o.substring(2),o=y):(u=o.substring(2,a),o=o.substring(a)||y)}return new C("file",u,o,n,n)}static from(o){const u=new C(o.scheme,o.authority,o.path,o.query,o.fragment);return R(u,!0),u}static joinPath(o,...u){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return p.isWindows&&o.scheme==="file"?a=m.file(L.win32.join(f(o,!0),...u)).path:a=L.posix.join(o.path,...u),o.with({path:a})}toString(o=!1){return s(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof m)return o;{const u=new C(o);return u._formatted=o.external,u._fsPath=o._sep===h?o.fsPath:null,u}}else return o}}e.URI=m;const h=p.isWindows?1:void 0;class C extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(o=!1){return o?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=h),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const P={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(i,o){let u,a=-1;for(let l=0;l<i.length;l++){const g=i.charCodeAt(l);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||o&&g===47)a!==-1&&(u+=encodeURIComponent(i.substring(a,l)),a=-1),u!==void 0&&(u+=i.charAt(l));else{u===void 0&&(u=i.substr(0,l));const E=P[g];E!==void 0?(a!==-1&&(u+=encodeURIComponent(i.substring(a,l)),a=-1),u+=E):a===-1&&(a=l)}}return a!==-1&&(u+=encodeURIComponent(i.substring(a))),u!==void 0?u:i}function I(i){let o;for(let u=0;u<i.length;u++){const a=i.charCodeAt(u);a===35||a===63?(o===void 0&&(o=i.substr(0,u)),o+=P[a]):o!==void 0&&(o+=i[u])}return o!==void 0?o:i}function f(i,o){let u;return i.authority&&i.path.length>1&&i.scheme==="file"?u=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?o?u=i.path.substr(1):u=i.path[1].toLowerCase()+i.path.substr(2):u=i.path,p.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=f;function s(i,o){const u=o?I:b;let a="",{scheme:l,authority:g,path:E,query:d,fragment:T}=i;if(l&&(a+=l,a+=":"),(g||l==="file")&&(a+=y,a+=y),g){let O=g.indexOf("@");if(O!==-1){const $=g.substr(0,O);g=g.substr(O+1),O=$.indexOf(":"),O===-1?a+=u($,!1):(a+=u($.substr(0,O),!1),a+=":",a+=u($.substr(O+1),!1)),a+="@"}g=g.toLowerCase(),O=g.indexOf(":"),O===-1?a+=u(g,!1):(a+=u(g.substr(0,O),!1),a+=g.substr(O))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const O=E.charCodeAt(1);O>=65&&O<=90&&(E=`/${String.fromCharCode(O+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const O=E.charCodeAt(0);O>=65&&O<=90&&(E=`${String.fromCharCode(O+32)}:${E.substr(2)}`)}a+=u(E,!0)}return d&&(a+="?",a+=u(d,!1)),T&&(a+="#",a+=o?T:b(T,!1)),a}function c(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+c(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(t)?i.replace(t,o=>c(o)):i}}),define(X[90],Q([0,1,4]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(w){const n=w;return n&&typeof n.type=="string"&&typeof n.severity=="string"}e.isRemoteConsoleLog=L;function D(w){const n=[];let y;try{const v=JSON.parse(w.arguments),m=v[v.length-1];m&&m.__$stack&&(v.pop(),y=m.__$stack),n.push(...v)}catch(v){n.push("Unable to log remote console arguments",w.arguments)}return{args:n,stack:y}}e.parse=D;function k(w){if(typeof w!="string")return k(D(w).stack);const n=w;if(n){const y=A(n),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(v&&v.length===4)return{uri:p.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=k;function A(w){if(!w)return w;const n=w.indexOf(`
`);return n===-1?w:w.substring(0,n)}function R(w,n){const{args:y,stack:v}=D(w),m=typeof y[0]=="string"&&y.length===1;let h=A(v);h&&(h=`(${h.trim()})`);let C=[];if(typeof y[0]=="string"?h&&m?C=[`%c[${n}] %c${y[0]} %c${h}`,S("blue"),S(""),S("grey")]:C=[`%c[${n}] %c${y[0]}`,S("blue"),S(""),...y.slice(1)]:C=[`%c[${n}]%`,S("blue"),...y],h&&!m&&C.push(h),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,C)}e.log=R;function S(w){return`color: ${w}`}});var ut=this&&this.__classPrivateFieldSet||function(G,e,p,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!D:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(G,p):D?D.value=p:e.set(G,p),p},xe=this&&this.__classPrivateFieldGet||function(G,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!L:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(G):L?L.value:e.get(G)};define(X[38],Q([0,1,4,19]),function(G,e,p,L){"use strict";var D,k,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function R(t,r,i){let o=t.get(r);return o===void 0&&(o=i,t.set(r,o)),o}e.getOrSet=R;function S(t){const r=[];return t.forEach((i,o)=>{r.push(`${o} => ${i}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=S;function w(t){const r=[];return t.forEach(i=>{r.push(i)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=w;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const i=r.charCodeAt(0),o=this._value.charCodeAt(this._pos);return i-o}value(){return this._value[this._pos]}}e.StringIterator=n;class y{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=y;class v{constructor(r=!0,i=!0){this._splitOnBackslash=r,this._caseSensitive=i}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=v;var m;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(m||(m={}));class h{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new v(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,L.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class C{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class P{constructor(r){this._iter=r}static forUris(r=()=>!1){return new P(new h(r))}static forPaths(){return new P(new v)}static forStrings(){return new P(new n)}static forConfigKeys(){return new P(new y)}clear(){this._root=void 0}set(r,i){const o=this._iter.reset(r);let u;for(this._root||(this._root=new C,this._root.segment=o.value()),u=this._root;;){const l=o.cmp(u.segment);if(l>0)u.left||(u.left=new C,u.left.segment=o.value()),u=u.left;else if(l<0)u.right||(u.right=new C,u.right.segment=o.value()),u=u.right;else if(o.hasNext())o.next(),u.mid||(u.mid=new C,u.mid.segment=o.value()),u=u.mid;else break}const a=u.value;return u.value=i,u.key=r,a}get(r){return this._getNode(r)?.value}_getNode(r){const i=this._iter.reset(r);let o=this._root;for(;o;){const u=i.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(i.hasNext())i.next(),o=o.mid;else break}return o}has(r){const i=this._getNode(r);return!(i?.value===void 0&&i?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,i){const o=this._iter.reset(r),u=[];let a=this._root;for(;a;){const l=o.cmp(a.segment);if(l>0)u.push([1,a]),a=a.left;else if(l<0)u.push([-1,a]),a=a.right;else if(o.hasNext())o.next(),u.push([0,a]),a=a.mid;else{for(i?(a.left=void 0,a.mid=void 0,a.right=void 0):a.value=void 0;u.length>0&&a.isEmpty();){let[g,E]=u.pop();switch(g){case 1:E.left=void 0;break;case 0:E.mid=void 0;break;case-1:E.right=void 0;break}a=E}break}}}findSubstr(r){const i=this._iter.reset(r);let o=this._root,u;for(;o;){const a=i.cmp(o.segment);if(a>0)o=o.left;else if(a<0)o=o.right;else if(i.hasNext())i.next(),u=o.value||u,o=o.mid;else break}return o&&o.value||u}findSuperstr(r){const i=this._iter.reset(r);let o=this._root;for(;o;){const u=i.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(i.hasNext())i.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(r){for(const[i,o]of this)r(o,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const i=[r];for(;i.length>0;){const o=i.pop();o&&(o.value&&(yield[o.key,o.value]),o.left&&i.push(o.left),o.mid&&i.push(o.mid),o.right&&i.push(o.right))}}}e.TernarySearchTree=P;class b{constructor(r,i){this[D]="ResourceMap",r instanceof b?(this.map=new Map(r.map),this.toKey=i??b.defaultToKey):(this.map=new Map,this.toKey=r??b.defaultToKey)}set(r,i){return this.map.set(this.toKey(r),i),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,i){typeof i!="undefined"&&(r=r.bind(i));for(let[o,u]of this.map)r(u,p.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield p.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[p.URI.parse(r[0]),r[1]]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[p.URI.parse(r[0]),r[1]]}}e.ResourceMap=b,b.defaultToKey=t=>t.toString();var I;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(I=e.Touch||(e.Touch={}));class f{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,i=0){const o=this._map.get(r);if(!!o)return i!==0&&this.touch(o,i),o.value}set(r,i,o=0){let u=this._map.get(r);if(u)u.value=i,o!==0&&this.touch(u,o);else{switch(u={key:r,value:i,next:void 0,previous:void 0},o){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(r,u),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this._map.get(r);if(!!i)return this._map.delete(r),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,i){const o=this._state;let u=this._head;for(;u;){if(i?r.bind(i)(u.value,u.key,this):r(u.value,u.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const r=this,i=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const a={value:o.key,done:!1};return o=o.next,a}else return{value:void 0,done:!0}}};return u}values(){const r=this,i=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const a={value:o.value,done:!1};return o=o.next,a}else return{value:void 0,done:!0}}};return u}entries(){const r=this,i=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const a={value:[o.key,o.value],done:!1};return o=o.next,a}else return{value:void 0,done:!0}}};return u}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this._head,o=this.size;for(;i&&o>r;)this._map.delete(i.key),i=i.next,o--;this._head=i,this._size=o,i&&(i.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const i=r.next,o=r.previous;if(!i||!o)throw new Error("Invalid list");i.previous=o,o.next=i}r.next=void 0,r.previous=void 0,this._state++}touch(r,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(r===this._head)return;const o=r.next,u=r.previous;r===this._tail?(u.next=void 0,this._tail=u):(o.previous=u,u.next=o),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(i===2){if(r===this._tail)return;const o=r.next,u=r.previous;r===this._head?(o.previous=void 0,this._head=o):(o.previous=u,u.next=o),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((i,o)=>{r.push([o,i])}),r}fromJSON(r){this.clear();for(const[i,o]of r)this.set(i,o)}}e.LinkedMap=f;class s extends f{constructor(r,i=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,i=2){return super.get(r,i)}peek(r){return super.get(r,0)}set(r,i){return super.set(r,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s;class c{constructor(r){A.set(this,void 0),ut(this,A,r,"f")}get size(){return xe(this,A,"f").size}forEach(r,i){xe(this,A,"f").forEach(r,i)}get(r){return xe(this,A,"f").get(r)}has(r){return xe(this,A,"f").has(r)}entries(){return xe(this,A,"f").entries()}keys(){return xe(this,A,"f").keys()}values(){return xe(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return xe(this,A,"f").entries()}}e.ReadonlyMapView=c}),define(X[91],Q([0,1,25,19,4]),function(G,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function k(n){return JSON.stringify(n,S)}e.stringify=k;function A(n){let y=JSON.parse(n);return y=w(y),y}e.parse=A;var R;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(R=e.MarshalledId||(e.MarshalledId={}));function S(n,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:(0,L.regExpFlags)(y)}:y}function w(n,y=0){if(!n||y>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return D.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof p.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let v=0;v<n.length;++v)n[v]=w(n[v],y+1);else for(const v in n)Object.hasOwnProperty.call(n,v)&&(n[v]=w(n[v],y+1))}return n}e.revive=w}),define(X[17],Q([0,1,4,7]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(R){R.inMemory="inmemory",R.vscode="vscode",R.internal="private",R.walkThrough="walkThrough",R.walkThroughSnippet="walkThroughSnippet",R.http="http",R.https="https",R.file="file",R.mailto="mailto",R.untitled="untitled",R.data="data",R.command="command",R.vscodeRemote="vscode-remote",R.vscodeRemoteResource="vscode-remote-resource",R.userData="vscode-userdata",R.vscodeCustomEditor="vscode-custom-editor",R.vscodeNotebook="vscode-notebook",R.vscodeNotebookCell="vscode-notebook-cell",R.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",R.vscodeNotebookCellOutput="vscode-notebook-cell-output",R.vscodeInteractive="vscode-interactive",R.vscodeInteractiveInput="vscode-interactive-input",R.vscodeSettings="vscode-settings",R.vscodeWorkspaceTrust="vscode-workspace-trust",R.vscodeTerminal="vscode-terminal",R.webviewPanel="webview-panel",R.vscodeWebview="vscode-webview",R.extension="extension",R.vscodeFileResource="vscode-file",R.tmp="tmp"})(D=e.Schemas||(e.Schemas={}));class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,w,n){this._hosts[S]=w,this._ports[S]=n}setConnectionToken(S,w){this._connectionTokens[S]=w}rewrite(S){if(this._delegate)return this._delegate(S);const w=S.authority;let n=this._hosts[w];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const y=this._ports[w],v=this._connectionTokens[w];let m=`path=${encodeURIComponent(S.path)}`;return typeof v=="string"&&(m+=`&tkn=${encodeURIComponent(v)}`),p.URI.from({scheme:L.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${n}:${y}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new k;class A{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(S,w,n){const y=this.toUri(S,w);if(y.scheme===D.vscodeRemote)return e.RemoteAuthorities.rewrite(y);let v=!1;return L.isNative&&(n||L.isPreferringBrowserCodeLoad)&&y.scheme===D.file&&(v=!0),y.scheme===D.file&&typeof L.globals.importScripts=="function"&&L.globals.origin==="vscode-file://vscode-app"&&(v=!0),v?y.with({scheme:D.vscodeFileResource,authority:y.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):y}asFileUri(S,w){const n=this.toUri(S,w);return n.scheme===D.vscodeFileResource?n.with({scheme:D.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(S,w){return p.URI.isUri(S)?S:p.URI.parse(w.toUrl(S))}}e.FileAccess=new A}),define(X[66],Q([0,1,38]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new p.LRUCache(1e4);function D(w){return S(w,"NFC",L)}e.normalizeNFC=D;const k=new p.LRUCache(1e4);function A(w){return S(w,"NFD",k)}e.normalizeNFD=A;const R=/[^\u0000-\u0080]/;function S(w,n,y){if(!w)return w;const v=y.get(w);if(v)return v;let m;return R.test(w)?m=w.normalize(n):m=w,y.set(w,m),m}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(n){return A(n).replace(w,"")}}()}),define(X[15],Q([0,1,41,8,4,19,17,7]),function(G,e,p,L,D,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(m){return(0,D.uriToFsPath)(m,!0)}e.originalFSPath=S;class w{constructor(h){this._ignorePathCasing=h}compare(h,C,P=!1){return h===C?0:(0,k.compare)(this.getComparisonKey(h,P),this.getComparisonKey(C,P))}isEqual(h,C,P=!1){return h===C?!0:!h||!C?!1:this.getComparisonKey(h,P)===this.getComparisonKey(C,P)}getComparisonKey(h,C=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:C?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,C,P=!1){if(h.scheme===C.scheme){if(h.scheme===A.Schemas.file)return p.isEqualOrParent(S(h),S(C),this._ignorePathCasing(h))&&h.query===C.query&&(P||h.fragment===C.fragment);if((0,e.isEqualAuthority)(h.authority,C.authority))return p.isEqualOrParent(h.path,C.path,this._ignorePathCasing(h),"/")&&h.query===C.query&&(P||h.fragment===C.fragment)}return!1}joinPath(h,...C){return D.URI.joinPath(h,...C)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return L.posix.basename(h.path)}extname(h){return L.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let C;return h.scheme===A.Schemas.file?C=D.URI.file(L.dirname(S(h))).path:(C=L.posix.dirname(h.path),h.authority&&C.length&&C.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),C="/")),h.with({path:C})}normalizePath(h){if(!h.path.length)return h;let C;return h.scheme===A.Schemas.file?C=D.URI.file(L.normalize(S(h))).path:C=L.posix.normalize(h.path),h.with({path:C})}relativePath(h,C){if(h.scheme!==C.scheme||!(0,e.isEqualAuthority)(h.authority,C.authority))return;if(h.scheme===A.Schemas.file){const I=L.relative(S(h),S(C));return R.isWindows?p.toSlashes(I):I}let P=h.path||"/",b=C.path||"/";if(this._ignorePathCasing(h)){let I=0;for(const f=Math.min(P.length,b.length);I<f&&!(P.charCodeAt(I)!==b.charCodeAt(I)&&P.charAt(I).toLowerCase()!==b.charAt(I).toLowerCase());I++);P=b.substr(0,I)+P.substr(I)}return L.posix.relative(P,b)}resolvePath(h,C){if(h.scheme===A.Schemas.file){const P=D.URI.file(L.resolve(S(h),C));return h.with({authority:P.authority,path:P.path})}return C=p.toPosixPath(C),h.with({path:L.posix.resolve(h.path,C)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,C){return h===C||(0,k.equalsIgnoreCase)(h,C)}hasTrailingPathSeparator(h,C=L.sep){if(h.scheme===A.Schemas.file){const P=S(h);return P.length>p.getRoot(P).length&&P[P.length-1]===C}else{const P=h.path;return P.length>1&&P.charCodeAt(P.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,C=L.sep){return(0,e.hasTrailingPathSeparator)(h,C)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,C=L.sep){let P=!1;if(h.scheme===A.Schemas.file){const b=S(h);P=b!==void 0&&b.length===p.getRoot(b).length&&b[b.length-1]===C}else{C="/";const b=h.path;P=b.length===1&&b.charCodeAt(b.length-1)===47}return!P&&!(0,e.hasTrailingPathSeparator)(h,C)?h.with({path:h.path+"/"}):h}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(m=>m.scheme===A.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new w(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(m,h){const C=[];for(let P=0;P<m.length;P++){const b=h(m[P]);m.some((I,f)=>f===P?!1:(0,e.isEqualOrParent)(b,h(I)))||C.push(m[P])}return C}e.distinctParents=n;var y;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function h(C){const P=new Map;C.path.substring(C.path.indexOf(";")+1,C.path.lastIndexOf(";")).split(";").forEach(f=>{const[s,c]=f.split(":");s&&c&&P.set(s,c)});const I=C.path.substring(0,C.path.indexOf(";"));return I&&P.set(m.META_DATA_MIME,I),P}m.parseMetaData=h})(y=e.DataUri||(e.DataUri={}));function v(m,h,C){if(h){let P=m.path;return P&&P[0]!==L.posix.sep&&(P=L.posix.sep+P),m.with({scheme:C,authority:h,path:P})}return m.with({scheme:C})}e.toLocalResource=v}),define(X[6],Q([0,1,29,9,3,2,15]),function(G,e,p,L,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function R(_){return!!_&&typeof _.then=="function"}e.isThenable=R;function S(_){const N=new p.CancellationTokenSource,j=_(N.token),F=new Promise((U,x)=>{const q=N.token.onCancellationRequested(()=>{q.dispose(),N.dispose(),x((0,L.canceled)())});Promise.resolve(j).then(H=>{q.dispose(),N.dispose(),U(H)},H=>{q.dispose(),N.dispose(),x(H)})});return new class{cancel(){N.cancel()}then(U,x){return F.then(U,x)}catch(U){return this.then(void 0,U)}finally(U){return F.finally(U)}}}e.createCancelablePromise=S;function w(_,N,j){return Promise.race([_,new Promise(F=>N.onCancellationRequested(()=>F(j)))])}e.raceCancellation=w;async function n(_){let N=-1;const j=_.map((U,x)=>U.then(q=>(N=x,q))),F=await Promise.race(j);return _.forEach((U,x)=>{x!==N&&U.cancel()}),F}e.raceCancellablePromises=n;function y(_,N,j){let F;const U=setTimeout(()=>{F?.(void 0),j?.()},N);return Promise.race([_.finally(()=>clearTimeout(U)),new Promise(x=>F=x)])}e.raceTimeout=y;function v(_){return new Promise((N,j)=>{const F=_();R(F)?F.then(N,j):N(F)})}e.asPromise=v;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const j=()=>{this.queuedPromise=null;const F=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,F};this.queuedPromise=new Promise(F=>{this.activePromise.then(j,j).then(F)})}return new Promise((j,F)=>{this.queuedPromise.then(j,F)})}return this.activePromise=N(),new Promise((j,F)=>{this.activePromise.then(U=>{this.activePromise=null,j(U)},U=>{this.activePromise=null,F(U)})})}}e.Throttler=m;class h{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}e.Sequencer=h;class C{constructor(){this.promiseMap=new Map}queue(N,j){const U=(this.promiseMap.get(N)??Promise.resolve()).catch(()=>{}).then(j).finally(()=>{this.promiseMap.get(N)===U&&this.promiseMap.delete(N)});return this.promiseMap.set(N,U),U}}e.SequencerByKey=C;class P{constructor(N){this.defaultDelay=N,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,j=this.defaultDelay){return this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((F,U)=>{this.doResolve=F,this.doReject=U}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const F=this.task;return this.task=null,F()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},j),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=P;class b{constructor(N){this.delayer=new P(N),this.throttler=new m}trigger(N,j){return this.delayer.trigger(()=>this.throttler.queue(N),j)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class I{constructor(){this._isOpen=!1,this._promise=new Promise((N,j)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=I;class f extends I{constructor(N){super();this._timeout=setTimeout(()=>this.open(),N)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=f;function s(_,N){return N?new Promise((j,F)=>{const U=setTimeout(()=>{x.dispose(),j()},_),x=N.onCancellationRequested(()=>{clearTimeout(U),x.dispose(),F((0,L.canceled)())})}):S(j=>s(_,j))}e.timeout=s;function c(_,N=0){const j=setTimeout(_,N);return(0,k.toDisposable)(()=>clearTimeout(j))}e.disposableTimeout=c;function t(_){const N=[];let j=0;const F=_.length;function U(){return j<F?_[j++]():null}function x(q){q!=null&&N.push(q);const H=U();return H?H.then(x):Promise.resolve(N)}return Promise.resolve(null).then(x)}e.sequence=t;function r(_,N=F=>!!F,j=null){let F=0;const U=_.length,x=()=>{if(F>=U)return Promise.resolve(j);const q=_[F++];return Promise.resolve(q()).then(Y=>N(Y)?Promise.resolve(Y):x())};return x()}e.first=r;function i(_,N=F=>!!F,j=null){if(_.length===0)return Promise.resolve(j);let F=_.length;const U=()=>{F=-1;for(const x of _)x.cancel?.()};return new Promise((x,q)=>{for(const H of _)H.then(Y=>{--F>=0&&N(Y)?(U(),x(Y)):F===0&&x(j)}).catch(Y=>{--F>=0&&(U(),q(Y))})})}e.firstParallel=i;class o{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(N){return this._size++,new Promise((j,F)=>{this.outstandingPromises.push({factory:N,c:j,e:F}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const j=N.factory();j.then(N.c,N.e),j.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=o;class u extends o{constructor(){super(1)}}e.Queue=u;class a{constructor(){this.queues=new Map}queueFor(N,j=A.extUri){const F=j.getComparisonKey(N);let U=this.queues.get(F);return U||(U=new u,D.Event.once(U.onFinished)(()=>{U?.dispose(),this.queues.delete(F)}),this.queues.set(F,U)),U}dispose(){this.queues.forEach(N=>N.dispose()),this.queues.clear()}}e.ResourceQueue=a;class l{constructor(N,j){this._token=-1,typeof N=="function"&&typeof j=="number"&&this.setIfNotSet(N,j)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,j){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},j)}setIfNotSet(N,j){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},j))}}e.TimeoutTimer=l;class g{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,j){this.cancel(),this._token=setInterval(()=>{N()},j)}}e.IntervalTimer=g;class E{constructor(N,j){this.timeoutToken=-1,this.runner=N,this.timeout=j,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=E;class d extends E{constructor(N,j){super(N,j);this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner&&this.runner(N)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=d;class T extends k.Disposable{constructor(N,j,F,U){super();this.maxWorkChunkSize=N,this.maxPendingWork=j,this.throttleDelay=F,this.handler=U,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(N){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+N.length>this.maxPendingWork)return!1}else if(this.pending+N.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...N),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new E(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=T,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const _=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=N=>{const j=setTimeout(()=>N(_));let F=!1;return{dispose(){F||(F=!0,clearTimeout(j))}}}}else e.runWhenIdle=(_,N)=>{const j=requestIdleCallback(_,typeof N=="number"?{timeout:N}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(j))}}}}();class O{constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch(j){this._error=j}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=O;async function $(_,N,j){let F;for(let U=0;U<j;U++)try{return await _()}catch(x){F=x,await s(N)}throw F}e.retry=$;class z{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(N,j,F){return this._pending={taskId:N,cancel:()=>F?.(),promise:j},j.then(()=>this.donePending(N),()=>this.donePending(N)),j}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let j,F;const U=new Promise((x,q)=>{j=x,F=q});this._next={run:N,promise:U,promiseResolve:j,promiseReject:F}}return this._next.promise}}e.TaskSequentializer=z;class V{constructor(N){this.interval=N,this.lastIncrementTime=0,this.value=0}increment(){const N=Date.now();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}e.IntervalCounter=V;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,j)=>{this.completeCallback=N,this.errorCallback=j})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(N){return new Promise(j=>{this.completeCallback(N),this.resolved=!0,j()})}error(N){return new Promise(j=>{this.errorCallback(N),this.rejected=!0,j()})}cancel(){new Promise(N=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,N()})}}e.DeferredPromise=B;var M;(function(_){async function N(j){let F;const U=await Promise.all(j.map(x=>x.then(q=>q,q=>{F||(F=q)})));if(typeof F!="undefined")throw F;return U}_.settled=N})(M=e.Promises||(e.Promises={}))}),define(X[67],Q([0,1,19,41,8,38,6]),function(G,e,p,L,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function R(){return Object.create(null)}e.getEmptyExpression=R;const S="**",w="/",n="[/\\\\]",y="[^/\\\\]",v=/\//g;function m(U){switch(U){case 0:return"";case 1:return`${y}*?`;default:return`(?:${n}|${y}+${n}|${n}${y}+)*?`}}function h(U,x){if(!U)return[];const q=[];let H=!1,Y=!1,te="";for(const ne of U){switch(ne){case x:if(!H&&!Y){q.push(te),te="";continue}break;case"{":H=!0;break;case"}":H=!1;break;case"[":Y=!0;break;case"]":Y=!1;break}te+=ne}return te&&q.push(te),q}e.splitGlobAware=h;function C(U){if(!U)return"";let x="";const q=h(U,w);if(q.every(H=>H===S))x=".*";else{let H=!1;q.forEach((Y,te)=>{if(Y===S){H||(x+=m(2),H=!0);return}let ne=!1,se="",ee=!1,he="";for(const de of Y){if(de!=="}"&&ne){se+=de;continue}if(ee&&(de!=="]"||!he)){let ye;de==="-"?ye=de:(de==="^"||de==="!")&&!he?ye="^":de===w?ye="":ye=p.escapeRegExpCharacters(de),he+=ye;continue}switch(de){case"{":ne=!0;continue;case"[":ee=!0;continue;case"}":x+=`(?:${h(se,",").map(De=>C(De)).join("|")})`,ne=!1,se="";break;case"]":x+="["+he+"]",ee=!1,he="";break;case"?":x+=y;continue;case"*":x+=m(1);continue;default:x+=p.escapeRegExpCharacters(de)}}te<q.length-1&&(q[te+1]!==S||te+2<q.length)&&(x+=n),H=!1})}return x}const P=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,I=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,f=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new k.LRUCache(1e4),r=function(){return!1},i=function(){return null};function o(U,x){if(!U)return i;let q;typeof U!="string"?q=U.pattern:q=U,q=q.trim();const H=`${q}_${!!x.trimForExclusions}`;let Y=t.get(H);if(Y)return u(Y,U);let te;if(P.test(q)){const ne=q.substr(4);Y=function(se,ee){return typeof se=="string"&&se.endsWith(ne)?q:null}}else(te=b.exec(a(q,x)))?Y=l(te[1],q):(x.trimForExclusions?f:I).test(q)?Y=g(q,x):(te=s.exec(a(q,x)))?Y=E(te[1].substr(1),q,!0):(te=c.exec(a(q,x)))?Y=E(te[1],q,!1):Y=d(q);return t.set(H,Y),u(Y,U)}function u(U,x){return typeof x=="string"?U:function(q,H){return L.isEqualOrParent(q,x.base)?U(D.relative(x.base,q),H):null}}function a(U,x){return x.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function l(U,x){const q=`/${U}`,H=`\\${U}`,Y=function(ne,se){return typeof ne!="string"?null:se?se===U?x:null:ne===U||ne.endsWith(q)||ne.endsWith(H)?x:null},te=[U];return Y.basenames=te,Y.patterns=[x],Y.allBasenames=te,Y}function g(U,x){const q=F(U.slice(1,-1).split(",").map(se=>o(se,x)).filter(se=>se!==i),U),H=q.length;if(!H)return i;if(H===1)return q[0];const Y=function(se,ee){for(let he=0,de=q.length;he<de;he++)if(q[he](se,ee))return U;return null},te=q.find(se=>!!se.allBasenames);te&&(Y.allBasenames=te.allBasenames);const ne=q.reduce((se,ee)=>ee.allPaths?se.concat(ee.allPaths):se,[]);return ne.length&&(Y.allPaths=ne),Y}function E(U,x,q){const H=D.sep===D.posix.sep,Y=H?U:U.replace(v,D.sep),te=D.sep+Y,ne=D.posix.sep+U,se=q?function(ee,he){return typeof ee=="string"&&(ee===Y||ee.endsWith(te)||!H&&(ee===U||ee.endsWith(ne)))?x:null}:function(ee,he){return typeof ee=="string"&&(ee===Y||!H&&ee===U)?x:null};return se.allPaths=[(q?"*/":"./")+U],se}function d(U){try{const x=new RegExp(`^${C(U)}$`);return function(q){return x.lastIndex=0,typeof q=="string"&&x.test(q)?U:null}}catch(x){return i}}function T(U,x,q){return!U||typeof x!="string"?!1:O(U)(x,void 0,q)}e.match=T;function O(U,x={}){if(!U)return r;if(typeof U=="string"||B(U)){const q=o(U,x);if(q===i)return r;const H=function(Y,te){return!!q(Y,te)};return q.allBasenames&&(H.allBasenames=q.allBasenames),q.allPaths&&(H.allPaths=q.allPaths),H}return N(U,x)}e.parse=O;function $(U){if(!U)return;let x;return q=>(x||(x=(U()||Promise.resolve([])).then(H=>H?V(H):{})),x.then(H=>!!H[q]))}e.hasSiblingPromiseFn=$;function z(U){if(!U)return;let x;return q=>{if(!x){const H=U();x=H?V(H):{}}return!!x[q]}}e.hasSiblingFn=z;function V(U){const x={};for(const q of U)x[q]=!0;return x}function B(U){const x=U;return x&&typeof x.base=="string"&&typeof x.pattern=="string"}e.isRelativePattern=B;function M(U){return U.allBasenames||[]}e.getBasenameTerms=M;function _(U){return U.allPaths||[]}e.getPathTerms=_;function N(U,x){const q=F(Object.getOwnPropertyNames(U).map(se=>j(se,U[se],x)).filter(se=>se!==i)),H=q.length;if(!H)return i;if(!q.some(se=>!!se.requiresSiblings)){if(H===1)return q[0];const se=function(de,ye){for(let Se=0,De=q.length;Se<De;Se++){const Te=q[Se](de,ye);if(Te)return Te}return null},ee=q.find(de=>!!de.allBasenames);ee&&(se.allBasenames=ee.allBasenames);const he=q.reduce((de,ye)=>ye.allPaths?de.concat(ye.allPaths):de,[]);return he.length&&(se.allPaths=he),se}const Y=function(se,ee,he){let de;for(let ye=0,Se=q.length;ye<Se;ye++){const De=q[ye];De.requiresSiblings&&he&&(ee||(ee=D.basename(se)),de||(de=ee.substr(0,ee.length-D.extname(se).length)));const Te=De(se,ee,de,he);if(Te)return Te}return null},te=q.find(se=>!!se.allBasenames);te&&(Y.allBasenames=te.allBasenames);const ne=q.reduce((se,ee)=>ee.allPaths?se.concat(ee.allPaths):se,[]);return ne.length&&(Y.allPaths=ne),Y}function j(U,x,q){if(x===!1)return i;const H=o(U,q);if(H===i)return i;if(typeof x=="boolean")return H;if(x){const Y=x.when;if(typeof Y=="string"){const te=(ne,se,ee,he)=>{if(!he||!H(ne,se))return null;const de=Y.replace("$(basename)",ee),ye=he(de);return(0,A.isThenable)(ye)?ye.then(Se=>Se?U:null):ye?U:null};return te.requiresSiblings=!0,te}}return H}function F(U,x){const q=U.filter(se=>!!se.basenames);if(q.length<2)return U;const H=q.reduce((se,ee)=>{const he=ee.basenames;return he?se.concat(he):se},[]);let Y;if(x){Y=[];for(let se=0,ee=H.length;se<ee;se++)Y.push(x)}else Y=q.reduce((se,ee)=>{const he=ee.patterns;return he?se.concat(he):se},[]);const te=function(se,ee){if(typeof se!="string")return null;if(!ee){let de;for(de=se.length;de>0;de--){const ye=se.charCodeAt(de-1);if(ye===47||ye===92)break}ee=se.substr(de)}const he=H.indexOf(ee);return he!==-1?Y[he]:null};te.basenames=H,te.patterns=Y,te.allBasenames=H;const ne=U.filter(se=>!se.basenames);return ne.push(te),ne}}),define(X[92],Q([0,1,8,19,67,17,15]),function(G,e,p,L,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var R;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown"})(R=e.Mimes||(e.Mimes={}));let S=[],w=[],n=[];function y(r,i=!1){const o=v(r);S.push(o),o.userConfigured?n.push(o):w.push(o),i&&!o.userConfigured&&S.forEach(u=>{u.mime===o.mime||u.userConfigured||(o.extension&&u.extension===o.extension&&console.warn(`Overwriting extension <<${o.extension}>> to now point to mime <<${o.mime}>>`),o.filename&&u.filename===o.filename&&console.warn(`Overwriting filename <<${o.filename}>> to now point to mime <<${o.mime}>>`),o.filepattern&&u.filepattern===o.filepattern&&console.warn(`Overwriting filepattern <<${o.filepattern}>> to now point to mime <<${o.mime}>>`),o.firstline&&u.firstline===o.firstline&&console.warn(`Overwriting firstline <<${o.firstline}>> to now point to mime <<${o.mime}>>`))})}e.registerTextMime=y;function v(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?r.filepattern.toLowerCase():void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(p.posix.sep)>=0:!1}}function m(r){r?(S=S.filter(i=>!i.userConfigured),n=[]):(S=[],w=[],n=[])}e.clearTextMimes=m;function h(r,i){let o;if(r)switch(r.scheme){case k.Schemas.file:o=r.fsPath;break;case k.Schemas.data:o=A.DataUri.parseMetaData(r).get(A.DataUri.META_DATA_LABEL);break;default:o=r.path}if(!o)return[R.unknown];o=o.toLowerCase();const u=(0,p.basename)(o),a=C(o,u,n);if(a)return[a,R.text];const l=C(o,u,w);if(l)return[l,R.text];if(i){const g=P(i);if(g)return[g,R.text]}return[R.unknown]}e.guessMimeTypes=h;function C(r,i,o){let u=null,a=null,l=null;for(let g=o.length-1;g>=0;g--){const E=o[g];if(i===E.filenameLowercase){u=E;break}if(E.filepattern&&(!a||E.filepattern.length>a.filepattern.length)){const d=E.filepatternOnPath?r:i;(0,D.match)(E.filepatternLowercase,d)&&(a=E)}E.extension&&(!l||E.extension.length>l.extension.length)&&i.endsWith(E.extensionLowercase)&&(l=E)}return u?u.mime:a?a.mime:l?l.mime:null}function P(r){if((0,L.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let i=S.length-1;i>=0;i--){const o=S[i];if(!o.firstline)continue;const u=r.match(o.firstline);if(u&&u.length>0)return o.mime}return null}function b(r){return r?typeof r=="string"?r===R.binary||r===R.text||r===R.unknown:r.length===1&&b(r[0]):!0}e.isUnspecific=b;const I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function f(r){const i=(0,p.extname)(r);return I[i.toLowerCase()]}e.getMediaMime=f;function s(r){for(const i in I)if(I[i]===r)return i}e.getExtensionForMimeType=s;const c=/^(.+)\/(.+?)(;.+)?$/;function t(r,i){const o=c.exec(r);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:i?void 0:r}e.normalizeMimeType=t}),define(X[93],Q([0,1,4]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(n){return n.toJSON()}class D{constructor(y){this._uriTransformer=y}transformIncoming(y){const v=this._uriTransformer.transformIncoming(y);return v===y?y:L(p.URI.from(v))}transformOutgoing(y){const v=this._uriTransformer.transformOutgoing(y);return v===y?y:L(p.URI.from(v))}transformOutgoingURI(y){const v=this._uriTransformer.transformOutgoing(y);return v===y?y:p.URI.from(v)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function k(n,y,v){if(!n||v>200)return null;if(typeof n=="object"){if(n instanceof p.URI)return y.transformOutgoing(n);for(let m in n)if(Object.hasOwnProperty.call(n,m)){const h=k(n[m],y,v+1);h!==null&&(n[m]=h)}}return null}function A(n,y){const v=k(n,y,0);return v===null?n:v}e.transformOutgoingURIs=A;function R(n,y,v,m){if(!n||m>200)return null;if(typeof n=="object"){if(n.$mid===1)return v?p.URI.revive(y.transformIncoming(n)):y.transformIncoming(n);for(let h in n)if(Object.hasOwnProperty.call(n,h)){const C=R(n[h],y,v,m+1);C!==null&&(n[h]=C)}}return null}function S(n,y){const v=R(n,y,!1,0);return v===null?n:v}e.transformIncomingURIs=S;function w(n,y){const v=R(n,y,!0,0);return v===null?n:v}e.transformAndReviveIncomingURIs=w}),define(X[30],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(S){return p.test(S)}e.isUUID=L;const D=new Uint8Array(16),k=[];for(let S=0;S<256;S++)k.push(S.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(S){for(let w=0;w<S.length;w++)S[w]=Math.floor(Math.random()*256);return S};function R(){A(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let S=0,w="";return w+=k[D[S++]],w+=k[D[S++]],w+=k[D[S++]],w+=k[D[S++]],w+="-",w+=k[D[S++]],w+=k[D[S++]],w+="-",w+=k[D[S++]],w+=k[D[S++]],w+="-",w+=k[D[S++]],w+=k[D[S++]],w+="-",w+=k[D[S++]],w+=k[D[S++]],w+=k[D[S++]],w+=k[D[S++]],w+=k[D[S++]],w+=k[D[S++]],w}e.generateUuid=R}),define(X[68],Q([0,1,209]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(k="utf8"){this.stringDecoder=new p.StringDecoder(k),this.remaining=null}write(k){const A=[],R=this.remaining?this.remaining+this.stringDecoder.write(k):this.stringDecoder.write(k);if(R.length<1)return A;let S=0,w,n=S;for(;n<R.length;)if(w=R.charCodeAt(n),w===13||w===10){if(A.push(R.substring(S,n)),n++,n<R.length){const y=w;w=R.charCodeAt(n),(y===13&&w===10||y===10&&w===13)&&n++}S=n}else n++;return this.remaining=S<R.length?R.substr(S):null,A}end(){return this.remaining}}e.LineDecoder=L}),define(X[94],Q([0,1,35]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(R){const S=R.replace(/\-/g,":").toLowerCase();return!L.has(S)}function k(){return new Promise(async(R,S)=>{const w=setTimeout(()=>S("Unable to retrieve mac address (timeout after 10s)"),1e4);try{R(await A())}catch(n){S(n)}finally{clearTimeout(w)}})}e.getMac=k;function A(){return new Promise((R,S)=>{try{const w=(0,p.networkInterfaces)();for(let n in w){const y=w[n];if(y){for(const{mac:v}of y)if(D(v))return R(v)}}S("Unable to retrieve mac address (unexpected format)")}catch(w){S(w)}})}}),define(X[95],Q([0,1,9,30,35,38,94]),function(G,e,p,L,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(n){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(n)}value(){if(this._value===void 0){let n=0,y=0;const v=(0,D.networkInterfaces)();for(let m in v){const h=v[m];if(h)for(const{mac:C,internal:P}of h)P||(y+=1,this._isVirtualMachineMacAdress(C.toUpperCase())&&(n+=1))}this._value=y>0?n/y:0}return this._value}};let R;async function S(){return R||(R=(async()=>await w()||L.generateUuid())()),R}e.getMachineId=S;async function w(){try{const n=await new Promise((v,m)=>{G(["crypto"],v,m)}),y=await(0,A.getMac)();return n.createHash("sha256").update(y,"utf8").digest("hex")}catch(n){p.onUnexpectedError(n);return}}}),define(X[18],Q([0,1,49,35,210,8,6,7,41,30,66,15,4]),function(G,e,p,L,D,k,A,R,S,w,n,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function h(M,_=m.UNLINK){if((0,S.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return _===m.UNLINK?P(M):C(M)}async function C(M){try{const _=(0,k.join)((0,L.tmpdir)(),(0,w.generateUuid)());try{await e.Promises.rename(M,_)}catch(N){return P(M)}P(_).catch(N=>{})}catch(_){if(_.code!=="ENOENT")throw _}}async function P(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function b(M){if((0,S.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");p.rmdirSync(M,{recursive:!0})}e.rimrafSync=b;async function I(M,_){return c(await(_?f(M):(0,D.promisify)(p.readdir)(M)))}async function f(M){try{return await(0,D.promisify)(p.readdir)(M,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const _=[],N=await I(M);for(const j of N){let F=!1,U=!1,x=!1;try{const q=await e.Promises.lstat((0,k.join)(M,j));F=q.isFile(),U=q.isDirectory(),x=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}_.push({name:j,isFile:()=>F,isDirectory:()=>U,isSymbolicLink:()=>x})}return _}function s(M){return c(p.readdirSync(M))}e.readdirSync=s;function c(M){return M.map(_=>typeof _=="string"?R.isMacintosh?(0,n.normalizeNFC)(_):_:(_.name=R.isMacintosh?(0,n.normalizeNFC)(_.name):_.name,_))}async function t(M){const _=await I(M),N=[];for(const j of _)await i.existsDirectory((0,k.join)(M,j))&&N.push(j);return N}function r(M,_=1e3){return new Promise(N=>{let j=!1;const F=setInterval(()=>{j||(j=!0,p.access(M,U=>{j=!1,U&&(clearInterval(F),N(void 0))}))},_)})}e.whenDeleted=r;var i;(function(M){async function _(F){let U;try{if(U=await e.Promises.lstat(F),!U.isSymbolicLink())return{stat:U}}catch(x){}try{return{stat:await e.Promises.stat(F),symbolicLink:U?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};if(R.isWindows&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(F)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};throw q}throw x}}M.stat=_;async function N(F){try{const{stat:U,symbolicLink:x}=await M.stat(F);return U.isFile()&&x?.dangling!==!0}catch(U){}return!1}M.existsFile=N;async function j(F){try{const{stat:U,symbolicLink:x}=await M.stat(F);return U.isDirectory()&&x?.dangling!==!0}catch(U){}return!1}M.existsDirectory=j})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new A.ResourceQueue;function u(M,_,N){return o.queueFor(v.URI.file(M),y.extUriBiasedIgnorePathCase).queue(()=>{const j=E(N);return new Promise((F,U)=>l(M,_,j,x=>x?U(x):F()))})}let a=!0;function l(M,_,N,j){if(!a)return p.writeFile(M,_,{mode:N.mode,flag:N.flag},j);p.open(M,N.flag,N.mode,(F,U)=>{if(F)return j(F);p.writeFile(U,_,x=>{if(x)return p.close(U,()=>j(x));p.fdatasync(U,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),a=!1),p.close(U,H=>j(H))))})})}function g(M,_,N){const j=E(N);if(!a)return p.writeFileSync(M,_,{mode:j.mode,flag:j.flag});const F=p.openSync(M,j.flag,j.mode);try{p.writeFileSync(F,_);try{p.fdatasyncSync(F)}catch(U){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",U),a=!1}}finally{p.closeSync(F)}}e.writeFileSync=g;function E(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function d(M,_){if(M===_)return;async function N(j){try{const F=await e.Promises.lstat(j);if(F.isDirectory()||F.isSymbolicLink())return;await e.Promises.utimes(j,F.atime,new Date)}catch(F){}}try{await e.Promises.rename(M,_),await N(_)}catch(j){if(M.toLowerCase()!==_.toLowerCase()&&j.code==="EXDEV"||M.endsWith("."))await T(M,_,{preserveSymlinks:!1}),await h(M,m.MOVE),await N(_);else throw j}}async function T(M,_,N){return $(M,_,{root:{source:M,target:_},options:N,handledSourcePaths:new Set})}const O=511;async function $(M,_,N){if(N.handledSourcePaths.has(M))return;N.handledSourcePaths.add(M);const{stat:j,symbolicLink:F}=await i.stat(M);if(F){if(N.options.preserveSymlinks)try{return await B(M,_,N)}catch(U){console.warn("[node.js fs] copy of symlink failed: ",U)}if(F.dangling)return}return j.isDirectory()?z(M,_,j.mode&O,N):V(M,_,j.mode&O)}async function z(M,_,N,j){await e.Promises.mkdir(_,{recursive:!0,mode:N});const F=await I(M);for(const U of F)await $((0,k.join)(M,U),(0,k.join)(_,U),j)}async function V(M,_,N){await e.Promises.copyFile(M,_),await e.Promises.chmod(_,N)}async function B(M,_,N){let j=await e.Promises.readlink(M);(0,S.isEqualOrParent)(j,N.root.source,!R.isLinux)&&(j=(0,k.join)(N.root.target,j.substr(N.root.source.length+1))),await e.Promises.symlink(j,_)}e.Promises=new class{get access(){return(0,D.promisify)(p.access)}get stat(){return(0,D.promisify)(p.stat)}get lstat(){return(0,D.promisify)(p.lstat)}get utimes(){return(0,D.promisify)(p.utimes)}get read(){return(0,D.promisify)(p.read)}get readFile(){return(0,D.promisify)(p.readFile)}get write(){return(0,D.promisify)(p.write)}get appendFile(){return(0,D.promisify)(p.appendFile)}get fdatasync(){return(0,D.promisify)(p.fdatasync)}get truncate(){return(0,D.promisify)(p.truncate)}get rename(){return(0,D.promisify)(p.rename)}get copyFile(){return(0,D.promisify)(p.copyFile)}get open(){return(0,D.promisify)(p.open)}get close(){return(0,D.promisify)(p.close)}get symlink(){return(0,D.promisify)(p.symlink)}get readlink(){return(0,D.promisify)(p.readlink)}get chmod(){return(0,D.promisify)(p.chmod)}get mkdir(){return(0,D.promisify)(p.mkdir)}get unlink(){return(0,D.promisify)(p.unlink)}get rmdir(){return(0,D.promisify)(p.rmdir)}get realpath(){return(0,D.promisify)(p.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return I}get readDirsInDir(){return t}get writeFile(){return u}get rm(){return h}get move(){return d}get copy(){return T}}}),define(X[96],Q([0,1,49,19,8,18]),function(G,e,p,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(n){const y=(0,D.dirname)(n);if(n===y)return n;const v=((0,D.basename)(n)||n).toLowerCase();try{const h=(0,k.readdirSync)(y).filter(C=>C.toLowerCase()===v);if(h.length===1){const C=A(y);if(C)return(0,D.join)(C,h[0])}else if(h.length>1){const C=h.indexOf(v);if(C>=0){const P=A(y);if(P)return(0,D.join)(P,h[C])}}}catch(m){}return null}e.realcaseSync=A;async function R(n){try{return await k.Promises.realpath(n)}catch(y){const v=w(n);return await k.Promises.access(v,p.constants.R_OK),v}}e.realpath=R;function S(n){try{return p.realpathSync(n)}catch(y){const v=w(n);return p.accessSync(v,p.constants.R_OK),v}}e.realpathSync=S;function w(n){return(0,L.rtrim)((0,D.normalize)(n),D.sep)}}),define(X[97],Q([0,1,18,35,8]),function(G,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,A=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var S;(function(s){s[s.x64=0]="x64",s[s.x86=1]="x86",s[s.ARM=2]="ARM"})(S||(S={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let n;process.env.PROCESSOR_ARCHITEW6432?n=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?n=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?n=1:n=0;class y{constructor(c,t,r){this.exePath=c,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await p.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function v({useAlternateBitness:s=!1}={}){return s?w===0?process.env["ProgramFiles(x86)"]||null:n===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:s=!1,findPreview:c=!1}={}){const t=v({useAlternateBitness:s});if(!t)return null;const r=D.join(t,"PowerShell");if(!await p.SymlinkSupport.existsDirectory(r))return null;let i=-1,o=null;for(const l of await p.Promises.readdir(r)){let g=-1;if(c){const d=l.indexOf("-");if(d<0)continue;const T=l.substring(0,d);if(!k.test(T)||l.substring(d+1)!=="preview")continue;g=parseInt(T,10)}else{if(!k.test(l))continue;g=parseInt(l,10)}if(g<=i)continue;const E=D.join(r,l,"pwsh.exe");!await p.SymlinkSupport.existsFile(E)||(o=E,i=g)}if(!o)return null;const u=t.includes("x86")?" (x86)":"",a=c?" Preview":"";return new y(o,`PowerShell${a}${u}`,!0)}async function h({findPreview:s}={}){if(!process.env.LOCALAPPDATA)return null;const c=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await p.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=s?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const i of await p.Promises.readdir(c))if(t.test(i)){const o=D.join(c,i,"pwsh.exe");return new y(o,r)}return null}function C(){const s=D.join(L.homedir(),".dotnet","tools","pwsh.exe");return new y(s,".NET Core PowerShell Global Tool")}function P(){const s=D.join(process.env.windir,w===1&&n!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(s,"Windows PowerShell",!0)}async function*b(){let s=await m();s&&(yield s),s=await m({useAlternateBitness:!0}),s&&(yield s),s=await h(),s&&(yield s),s=C(),s&&(yield s),s=await m({findPreview:!0}),s&&(yield s),s=await h({findPreview:!0}),s&&(yield s),s=await m({useAlternateBitness:!0,findPreview:!0}),s&&(yield s),s=P(),s&&(yield s)}async function*I(){for await(const s of b())await s.exists()&&(yield s)}e.enumeratePowerShellInstallations=I;async function f(){for await(const s of I())return s;return null}e.getFirstAvailablePowerShellInstallation=f}),define(X[98],Q([0,1,42,17]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(A){return new Promise((R,S)=>{let w;const n=new Map;function y(m,h,C,P,b){const I=n.get(h);if(m===A||I){const f={name:v(C),cmd:C,pid:m,ppid:h,load:P,mem:b};n.set(m,f),m===A&&(w=f),I&&(I.children||(I.children=[]),I.children.push(f),I.children.length>1&&(I.children=I.children.sort((s,c)=>s.pid-c.pid)))}}function v(m){const h=/--disable-blink-features=Auxclick/,C=/\\watcher\\win32\\CodeHelper\.exe/,P=/--crashes-directory/,b=/\\pipe\\winpty-control/,I=/conhost\.exe/,f=/--type=([a-zA-Z-]+)/;if(C.exec(m))return"watcherService ";if(P.exec(m))return"electron-crash-reporter";if(b.exec(m))return"winpty-process";if(I.exec(m))return"console-window-host (Windows internal process)";let s=f.exec(m);if(s&&s.length===2)return s[1]==="renderer"?h.exec(m)?"shared-process":"window":s[1];const c=/[a-zA-Z-]+\.js/g;let t="";do s=c.exec(m),s&&(t+=s+" ");while(s);return t&&m.indexOf("node ")<0&&m.indexOf("node.exe")<0?`electron_node ${t}`:m}if(process.platform==="win32"){const m=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,C)=>{G(["windows-process-tree"],h,C)}).then(h=>{h.getProcessList(A,C=>{h.getProcessCpuUsage(C,P=>{const b=new Map;P.forEach(I=>{const f=m(I.commandLine||"");b.set(I.pid,{name:v(f),cmd:f,pid:I.pid,ppid:I.ppid,load:I.cpu||0,mem:I.memory||0})}),w=b.get(A),w?(b.forEach(I=>{const f=b.get(I.ppid);f&&(f.children||(f.children=[]),f.children.push(I))}),b.forEach(I=>{I.children&&(I.children=I.children.sort((f,s)=>f.pid-s.pid))}),R(w)):S(new Error(`Root process ${A} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let m=function(){let h=[w];const C=[];for(;h.length;){const b=h.shift();b&&(C.push(b.pid),b.children&&(h=h.concat(b.children)))}let P=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",G).fsPath);P+=" "+C.join(" "),(0,p.exec)(P,{},(b,I,f)=>{if(b||f)S(b||new Error(f.toString()));else{const s=I.toString().split(`
`);for(let c=0;c<C.length;c++){const t=n.get(C[c]);t.load=parseFloat(s[c])}if(!w){S(new Error(`Root process ${A} not found`));return}R(w)}})};(0,p.exec)("which ps",{},(h,C,P)=>{if(h||P)if(process.platform!=="linux")S(h||new Error(P.toString()));else{const b=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",G).fsPath);(0,p.exec)(b,{},(I,f,s)=>{I||s?S(I||new Error(s.toString())):(k(f,y),m())})}else{const b=C.toString().trim(),I="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,p.exec)(`${b} ${I}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,s,c)=>{f||c&&!c.includes("screen size is bogus")?S(f||new Error(c.toString())):(k(s,y),process.platform==="linux"?m():w?R(w):S(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=D;function k(A,R){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=A.toString().split(`
`);for(const n of w){const y=S.exec(n.trim());y&&y.length===6&&R(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(X[99],Q([0,1,8,49,7,66,2,18]),function(G,e,p,L,D,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function S(y,v,m){return n({path:y,isDirectory:!1},v,m)}e.watchFile=S;function w(y,v,m){return n({path:y,isDirectory:!0},v,m)}e.watchFolder=w,e.CHANGE_BUFFER_DELAY=100;function n(y,v,m){const h=(0,p.basename)(y.path),C=new Map;let P=!1,b=[(0,A.toDisposable)(()=>{C.forEach(I=>(0,A.dispose)(I)),C.clear()})];try{const I=(0,L.watch)(y.path);b.push((0,A.toDisposable)(()=>{I.removeAllListeners(),I.close()}));const f=new Set;y.isDirectory&&R.Promises.readdir(y.path).then(s=>s.forEach(c=>f.add(c))),I.on("error",(s,c)=>{P||m(`Failed to watch ${y.path} for changes using fs.watch() (${s}, ${c})`)}),I.on("change",(s,c)=>{if(P)return;let t="";if(c&&(t=c.toString(),D.isMacintosh&&(t=(0,k.normalizeNFC)(t))),!t||s!=="change"&&s!=="rename")return;const r=y.isDirectory?(0,p.join)(y.path,t):y.path;if(y.isDirectory)if(s==="rename"){const i=C.get(r);i&&(0,A.dispose)(i);const o=setTimeout(async()=>{C.delete(r);const u=await R.Promises.exists(r);if(P)return;let a;u?f.has(t)?a="changed":(a="added",f.add(t)):(f.delete(t),a="deleted"),v(a,r)},e.CHANGE_BUFFER_DELAY);C.set(r,(0,A.toDisposable)(()=>clearTimeout(o)))}else{let i;f.has(t)?i="changed":(i="added",f.add(t)),v(i,r)}else if(s==="rename"||t!==h){const i=setTimeout(async()=>{const o=await R.Promises.exists(r);P||(o?(v("changed",r),b=[n(y,v,m)]):v("deleted",r))},e.CHANGE_BUFFER_DELAY);(0,A.dispose)(b),b=[(0,A.toDisposable)(()=>clearTimeout(i))]}else v("changed",r)})}catch(I){R.Promises.exists(y.path).then(f=>{f&&!P&&m(`Failed to watch ${y.path} for changes using fs.watch() (${I.toString()})`)})}return(0,A.toDisposable)(()=>{P=!0,b=(0,A.dispose)(b)})}});var fe=this&&this.__decorate||function(G,e,p,L){var D=arguments.length,k=D<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,p):L,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(G,e,p,L);else for(var R=G.length-1;R>=0;R--)(A=G[R])&&(k=(D<3?A(k):D>3?A(e,p,k):A(e,p))||k);return D>3&&k&&Object.defineProperty(e,p,k),k};define(X[36],Q([0,1,3,2,6,29,9,25,23,16,91,19,64]),function(G,e,p,L,D,k,A,R,S,w,n,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var m;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(m=e.RequestType||(e.RequestType={}));function h(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var C;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(C=e.ResponseType||(e.ResponseType={}));function P(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(b||(b={}));class I{constructor(U){this.buffer=U,this.pos=0}read(U){const x=this.buffer.slice(this.pos,this.pos+U);return this.pos+=x.byteLength,x}}class f{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(U){this.buffers.push(U)}}var s;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(s||(s={}));function c(F){const U=R.VSBuffer.alloc(4);return U.writeUInt32BE(F,0),U}function t(F){return F.read(4).readUInt32BE(0)}function r(F){const U=R.VSBuffer.alloc(1);return U.writeUInt8(F,0),U}const i={Undefined:r(s.Undefined),String:r(s.String),Buffer:r(s.Buffer),VSBuffer:r(s.VSBuffer),Array:r(s.Array),Object:r(s.Object)},o=typeof Buffer!="undefined";function u(F,U){if(typeof U=="undefined")F.write(i.Undefined);else if(typeof U=="string"){const x=R.VSBuffer.fromString(U);F.write(i.String),F.write(c(x.byteLength)),F.write(x)}else if(o&&Buffer.isBuffer(U)){const x=R.VSBuffer.wrap(U);F.write(i.Buffer),F.write(c(x.byteLength)),F.write(x)}else if(U instanceof R.VSBuffer)F.write(i.VSBuffer),F.write(c(U.byteLength)),F.write(U);else if(Array.isArray(U)){F.write(i.Array),F.write(c(U.length));for(const x of U)u(F,x)}else{const x=R.VSBuffer.fromString(JSON.stringify(U));F.write(i.Object),F.write(c(x.byteLength)),F.write(x)}}function a(F){switch(F.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return F.read(t(F)).toString();case s.Buffer:return F.read(t(F)).buffer;case s.VSBuffer:return F.read(t(F));case s.Array:{const x=t(F),q=[];for(let H=0;H<x;H++)q.push(a(F));return q}case s.Object:return JSON.parse(F.read(t(F)).toString())}}class l{constructor(U,x,q=null,H=1e3){this.protocol=U,this.ctx=x,this.logger=q,this.timeoutDelay=H,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Y=>this.onRawMessage(Y)),this.sendResponse({type:200})}registerChannel(U,x){this.channels.set(U,x),setTimeout(()=>this.flushPendingRequests(U),0)}sendResponse(U){switch(U.type){case 200:{const x=this.send([U.type]);this.logger&&this.logger.logOutgoing(x,0,1,P(U.type));return}case 201:case 202:case 204:case 203:{const x=this.send([U.type,U.id],U.data);this.logger&&this.logger.logOutgoing(x,U.id,1,P(U.type),U.data);return}}}send(U,x=void 0){const q=new f;return u(q,U),u(q,x),this.sendBuffer(q.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch(x){return 0}}onRawMessage(U){const x=new I(U),q=a(x),H=a(x),Y=q[0];switch(Y){case 100:return this.logger&&this.logger.logIncoming(U.byteLength,q[1],1,`${h(Y)}: ${q[2]}.${q[3]}`,H),this.onPromise({type:Y,id:q[1],channelName:q[2],name:q[3],arg:H});case 102:return this.logger&&this.logger.logIncoming(U.byteLength,q[1],1,`${h(Y)}: ${q[2]}.${q[3]}`,H),this.onEventListen({type:Y,id:q[1],channelName:q[2],name:q[3],arg:H});case 101:return this.logger&&this.logger.logIncoming(U.byteLength,q[1],1,`${h(Y)}`),this.disposeActiveRequest({type:Y,id:q[1]});case 103:return this.logger&&this.logger.logIncoming(U.byteLength,q[1],1,`${h(Y)}`),this.disposeActiveRequest({type:Y,id:q[1]})}}onPromise(U){const x=this.channels.get(U.channelName);if(!x){this.collectPendingRequest(U);return}const q=new k.CancellationTokenSource;let H;try{H=x.call(this.ctx,U.name,U.arg,q.token)}catch(ne){H=Promise.reject(ne)}const Y=U.id;H.then(ne=>{this.sendResponse({id:Y,data:ne,type:201}),this.activeRequests.delete(U.id)},ne=>{ne instanceof Error?this.sendResponse({id:Y,data:{message:ne.message,name:ne.name,stack:ne.stack?ne.stack.split?ne.stack.split(`
`):ne.stack:void 0},type:202}):this.sendResponse({id:Y,data:ne,type:203}),this.activeRequests.delete(U.id)});const te=(0,L.toDisposable)(()=>q.cancel());this.activeRequests.set(U.id,te)}onEventListen(U){const x=this.channels.get(U.channelName);if(!x){this.collectPendingRequest(U);return}const q=U.id,Y=x.listen(this.ctx,U.name,U.arg)(te=>this.sendResponse({id:q,data:te,type:204}));this.activeRequests.set(U.id,Y)}disposeActiveRequest(U){const x=this.activeRequests.get(U.id);x&&(x.dispose(),this.activeRequests.delete(U.id))}collectPendingRequest(U){let x=this.pendingRequests.get(U.channelName);x||(x=[],this.pendingRequests.set(U.channelName,x));const q=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.sendResponse({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);x.push({request:U,timeoutTimer:q})}flushPendingRequests(U){const x=this.pendingRequests.get(U);if(x){for(const q of x)switch(clearTimeout(q.timeoutTimer),q.request.type){case 100:this.onPromise(q.request);break;case 102:this.onEventListen(q.request);break}this.pendingRequests.delete(U)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}e.ChannelServer=l;var g;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(U,x=null){this.protocol=U,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(q=>this.onBuffer(q)),this.logger=x}getChannel(U){const x=this;return{call(q,H,Y){return x.isDisposed?Promise.reject(A.canceled()):x.requestPromise(U,q,H,Y)},listen(q,H){return x.isDisposed?Promise.reject(A.canceled()):x.requestEvent(U,q,H)}}}requestPromise(U,x,q,H=k.CancellationToken.None){const Y=this.lastRequestId++,ne={id:Y,type:100,channelName:U,name:x,arg:q};if(H.isCancellationRequested)return Promise.reject(A.canceled());let se;return new Promise((he,de)=>{if(H.isCancellationRequested)return de(A.canceled());const ye=()=>{const Me=Oe=>{switch(Oe.type){case 201:this.handlers.delete(Y),he(Oe.data);break;case 202:this.handlers.delete(Y);const Le=new Error(Oe.data.message);Le.stack=Oe.data.stack,Le.name=Oe.data.name,de(Le);break;case 203:this.handlers.delete(Y),de(Oe.data);break}};this.handlers.set(Y,Me),this.sendRequest(ne)};let Se=null;this.state===b.Idle?ye():(Se=(0,D.createCancelablePromise)(Me=>this.whenInitialized()),Se.then(()=>{Se=null,ye()}));const De=()=>{Se?(Se.cancel(),Se=null):this.sendRequest({id:Y,type:101}),de(A.canceled())},Te=H.onCancellationRequested(De);se=(0,L.combinedDisposable)((0,L.toDisposable)(De),Te),this.activeRequests.add(se)}).finally(()=>{this.activeRequests.delete(se)})}requestEvent(U,x,q){const H=this.lastRequestId++,te={id:H,type:102,channelName:U,name:x,arg:q};let ne=null;const se=new p.Emitter({onFirstListenerAdd:()=>{ne=(0,D.createCancelablePromise)(he=>this.whenInitialized()),ne.then(()=>{ne=null,this.activeRequests.add(se),this.sendRequest(te)})},onLastListenerRemove:()=>{ne?(ne.cancel(),ne=null):(this.activeRequests.delete(se),this.sendRequest({id:H,type:103}))}}),ee=he=>se.fire(he.data);return this.handlers.set(H,ee),se.event}sendRequest(U){switch(U.type){case 100:case 102:{const x=this.send([U.type,U.id,U.channelName,U.name],U.arg);this.logger&&this.logger.logOutgoing(x,U.id,0,`${h(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const x=this.send([U.type,U.id]);this.logger&&this.logger.logOutgoing(x,U.id,0,h(U.type));return}}}send(U,x=void 0){const q=new f;return u(q,U),u(q,x),this.sendBuffer(q.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch(x){return 0}}onBuffer(U){const x=new I(U),q=a(x),H=a(x),Y=q[0];switch(Y){case 200:return this.logger&&this.logger.logIncoming(U.byteLength,0,0,P(Y)),this.onResponse({type:q[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(U.byteLength,q[1],0,P(Y),H),this.onResponse({type:q[0],id:q[1],data:H})}}onResponse(U){if(U.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const x=this.handlers.get(U.id);x&&x(U)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}fe([v.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class d{constructor(U){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,U(({protocol:x,onDidClientDisconnect:q})=>{p.Event.once(x.onMessage)(Y=>{const te=new I(Y),ne=a(te),se=new l(x,ne),ee=new E(x);this.channels.forEach((de,ye)=>se.registerChannel(ye,de));const he={channelServer:se,channelClient:ee,ctx:ne};this._connections.add(he),this._onDidAddConnection.fire(he),q(()=>{se.dispose(),ee.dispose(),this._connections.delete(he),this._onDidRemoveConnection.fire(he)})})})}get connections(){const U=[];return this._connections.forEach(x=>U.push(x)),U}getChannel(U,x){const q=this;return{call(H,Y,te){let ne;if((0,w.isFunction)(x)){let ee=(0,S.getRandomElement)(q.connections.filter(x));ne=ee?Promise.resolve(ee):p.Event.toPromise(p.Event.filter(q.onDidAddConnection,x))}else ne=x.routeCall(q,H,Y);const se=ne.then(ee=>ee.channelClient.getChannel(U));return O(se).call(H,Y,te)},listen(H,Y){if((0,w.isFunction)(x))return q.getMulticastEvent(U,x,H,Y);const te=x.routeEvent(q,H,Y).then(ne=>ne.channelClient.getChannel(U));return O(te).listen(H,Y)}}}getMulticastEvent(U,x,q,H){const Y=this;let te=new L.DisposableStore;const ne=new p.Emitter({onFirstListenerAdd:()=>{te=new L.DisposableStore;const se=new p.EventMultiplexer,ee=new Map,he=ye=>{const De=ye.channelClient.getChannel(U).listen(q,H),Te=se.add(De);ee.set(ye,Te)},de=ye=>{const Se=ee.get(ye);!Se||(Se.dispose(),ee.delete(ye))};Y.connections.filter(x).forEach(he),p.Event.filter(Y.onDidAddConnection,x)(he,void 0,te),Y.onDidRemoveConnection(de,void 0,te),se.event(ne.fire,ne,te),te.add(se)},onLastListenerRemove:()=>{te.dispose()}});return ne.event}registerChannel(U,x){this.channels.set(U,x),this._connections.forEach(q=>{q.channelServer.registerChannel(U,x)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=d;class T{constructor(U,x,q=null){const H=new f;u(H,x),U.send(H.buffer),this.channelClient=new E(U,q),this.channelServer=new l(U,x,q)}getChannel(U){return this.channelClient.getChannel(U)}registerChannel(U,x){this.channelServer.registerChannel(U,x)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function O(F){return{call(U,x,q){return F.then(H=>H.call(U,x,q))},listen(U,x){const q=new p.Relay;return F.then(H=>q.input=H.listen(U,x)),q.event}}}e.getDelayedChannel=O;function $(F){let U=!1;return{call(x,q,H){return U?F.call(x,q,H):(0,D.timeout)(0).then(()=>U=!0).then(()=>F.call(x,q,H))},listen(x,q){if(U)return F.listen(x,q);const H=new p.Relay;return(0,D.timeout)(0).then(()=>U=!0).then(()=>H.input=F.listen(x,q)),H.event}}}e.getNextTickChannel=$;class z{constructor(U){this.fn=U}routeCall(U){return this.route(U)}routeEvent(U){return this.route(U)}async route(U){for(const x of U.connections)if(await Promise.resolve(this.fn(x.ctx)))return Promise.resolve(x);return await p.Event.toPromise(U.onDidAddConnection),await this.route(U)}}e.StaticRouter=z;var V;(function(F){function U(H,Y){const te=H,ne=Y&&Y.disableMarshalling,se=new Map;for(const ee in te)q(ee)&&se.set(ee,p.Event.buffer(te[ee],!0));return new class{listen(ee,he){const de=se.get(he);if(de)return de;throw new Error(`Event not found: ${he}`)}call(ee,he,de){const ye=te[he];if(typeof ye=="function"){if(!ne&&Array.isArray(de))for(let Se=0;Se<de.length;Se++)de[Se]=(0,n.revive)(de[Se]);return ye.apply(te,de)}throw new Error(`Method not found: ${he}`)}}}F.fromService=U;function x(H,Y){const te=Y&&Y.disableMarshalling;return new Proxy({},{get(ne,se){if(typeof se=="string")return Y?.properties?.has(se)?Y.properties.get(se):q(se)?H.listen(se):async function(...ee){let he;Y&&!(0,w.isUndefinedOrNull)(Y.context)?he=[Y.context,...ee]:he=ee;const de=await H.call(se,he);return te?de:(0,n.revive)(de)};throw new Error(`Property not found: ${String(se)}`)}})}F.toService=x;function q(H){return H[0]==="o"&&H[1]==="n"&&y.isUpperAsciiLetter(H.charCodeAt(2))}})(V=e.ProxyChannel||(e.ProxyChannel={}));const B=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let U=F.toString();if(U!=="[object Object]")return U}return F}function _(F){return Array.isArray(F)?F.map(M):M(F)}function N(F,U,x,q,H,Y,te){te=_(te);const ne=B[H],se=ne[q%ne.length];let ee=[`%c[${F}]%c[${String(U).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(q).padStart(5," ")} - ${Y}`,"color: darkgreen","color: grey","color: grey",`color: ${se}`];/\($/.test(Y)?(ee=ee.concat(te),ee.push(")")):ee.push(te),console.log.apply(console,ee)}e.logWithColors=N;class j{constructor(U,x){this._outgoingPrefix=U,this._incomingPrefix=x,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(U,x,q,H,Y){this._totalOutgoing+=U,N(this._outgoingPrefix,this._totalOutgoing,U,x,q,H,Y)}logIncoming(U,x,q,H,Y){this._totalIncoming+=U,N(this._incomingPrefix,this._totalIncoming,U,x,q,H,Y)}}e.IPCLogger=j}),define(X[100],Q([0,1,3,36,25]),function(G,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(S){this.port=S,this.onMessage=p.Event.fromDOMEventEmitter(this.port,"message",w=>D.VSBuffer.wrap(w.data)),S.start()}send(S){this.port.postMessage(S.buffer)}disconnect(){this.port.close()}}e.Protocol=k;class A extends L.IPCClient{constructor(S,w){const n=new k(S);super(n,w);this.protocol=n}dispose(){this.protocol.disconnect()}}e.Client=A}),define(X[101],Q([0,1,102,3,36,100]),function(G,e,p,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends D.IPCServer{static getOnDidClientConnect(){const S=L.Event.fromNodeEventEmitter(p.ipcRenderer,"vscode:createMessageChannel",(w,n)=>n);return L.Event.map(S,w=>{const{port1:n,port2:y}=new MessageChannel,m={protocol:new k.Protocol(n),onDidClientDisconnect:L.Event.fromDOMEventEmitter(n,"close")};return p.ipcRenderer.postMessage("vscode:createMessageChannelResult",w,[y]),m})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(X[103],Q([0,1,9,25]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function D(R,S){R.proxyAuthorization&&(R.headers={...R.headers||{},"Proxy-Authorization":R.proxyAuthorization});const w=new XMLHttpRequest;return new Promise((n,y)=>{w.open(R.type||"GET",R.url||"",!0,R.user,R.password),k(w,R),w.responseType="arraybuffer",w.onerror=v=>y(new Error(w.statusText&&"XHR failed: "+w.statusText||"XHR failed")),w.onload=v=>{n({res:{statusCode:w.status,headers:A(w)},stream:(0,L.bufferToStream)(L.VSBuffer.wrap(new Uint8Array(w.response)))})},w.ontimeout=v=>y(new Error(`XHR timeout: ${R.timeout}ms`)),R.timeout&&(w.timeout=R.timeout),w.send(R.data),S.onCancellationRequested(()=>{w.abort(),y((0,p.canceled)())})})}e.request=D;function k(R,S){if(S.headers){e:for(let w in S.headers){switch(w){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}R.setRequestHeader(w,S.headers[w])}}}function A(R){const S=Object.create(null);for(const w of R.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(w){const n=w.indexOf(":");S[w.substr(0,n).trim().toLowerCase()]=w.substr(n+1).trim()}return S}}),define(X[69],Q([0,1,2,3,6,16]),function(G,e,p,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var A;(function(n){n[n.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));var R;(function(n){n[n.None=0]="None",n[n.Initialized=1]="Initialized",n[n.Closed=2]="Closed"})(R||(R={}));class S extends p.Disposable{constructor(y,v=Object.create(null)){super();this.database=y,this.options=v,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=R.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(S.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(y=>this.onDidChangeItemsExternal(y)))}onDidChangeItemsExternal(y){y.changed?.forEach((v,m)=>this.accept(m,v)),y.deleted?.forEach(v=>this.accept(v,void 0))}accept(y,v){if(this.state===R.Closed)return;let m=!1;(0,k.isUndefinedOrNull)(v)?m=this.cache.delete(y):this.cache.get(y)!==v&&(this.cache.set(y,v),m=!0),m&&this._onDidChangeStorage.fire(y)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===R.None&&(this.state=R.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(y,v){const m=this.cache.get(y);return(0,k.isUndefinedOrNull)(m)?v:m}getBoolean(y,v){const m=this.get(y);return(0,k.isUndefinedOrNull)(m)?v:m==="true"}getNumber(y,v){const m=this.get(y);return(0,k.isUndefinedOrNull)(m)?v:parseInt(m,10)}async set(y,v){if(this.state===R.Closed)return;if((0,k.isUndefinedOrNull)(v))return this.delete(y);const m=String(v);if(this.cache.get(y)!==m)return this.cache.set(y,m),this.pendingInserts.set(y,m),this.pendingDeletes.delete(y),this._onDidChangeStorage.fire(y),this.flushDelayer.trigger(()=>this.flushPending())}async delete(y){if(!(this.state===R.Closed||!this.cache.delete(y)))return this.pendingDeletes.has(y)||this.pendingDeletes.add(y),this.pendingInserts.delete(y),this._onDidChangeStorage.fire(y),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=R.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(y){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const y={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(y).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(y=>this.whenFlushedCallbacks.push(y))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=S,S.DEFAULT_FLUSH_DELAY=100;class w{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(y){y.insert&&y.insert.forEach((v,m)=>this.items.set(m,v)),y.delete&&y.delete.forEach(v=>this.items.delete(v))}async close(){}}e.InMemoryStorageDatabase=w}),define(X[104],Q([10,11]),function(G,e){return G.create("vs/base/common/date",e)}),define(X[55],Q([0,1,104]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,D=L*60,k=D*24,A=k*7,R=k*30,S=k*365;function w(y,v){typeof y!="number"&&(y=y.getTime());const m=Math.round((new Date().getTime()-y)/1e3);if(m<-30)return(0,p.localize)(0,null,w(new Date().getTime()+m*1e3,!1));if(m<30)return(0,p.localize)(1,null);let h;return m<L?(h=m,v?h===1?(0,p.localize)(2,null,h):(0,p.localize)(3,null,h):h===1?(0,p.localize)(4,null,h):(0,p.localize)(5,null,h)):m<D?(h=Math.floor(m/L),v?h===1?(0,p.localize)(6,null,h):(0,p.localize)(7,null,h):h===1?(0,p.localize)(8,null,h):(0,p.localize)(9,null,h)):m<k?(h=Math.floor(m/D),v?h===1?(0,p.localize)(10,null,h):(0,p.localize)(11,null,h):h===1?(0,p.localize)(12,null,h):(0,p.localize)(13,null,h)):m<A?(h=Math.floor(m/k),v?h===1?(0,p.localize)(14,null,h):(0,p.localize)(15,null,h):h===1?(0,p.localize)(16,null,h):(0,p.localize)(17,null,h)):m<R?(h=Math.floor(m/A),v?h===1?(0,p.localize)(18,null,h):(0,p.localize)(19,null,h):h===1?(0,p.localize)(20,null,h):(0,p.localize)(21,null,h)):m<S?(h=Math.floor(m/R),v?h===1?(0,p.localize)(22,null,h):(0,p.localize)(23,null,h):h===1?(0,p.localize)(24,null,h):(0,p.localize)(25,null,h)):(h=Math.floor(m/S),v?h===1?(0,p.localize)(26,null,h):(0,p.localize)(27,null,h):h===1?(0,p.localize)(28,null,h):(0,p.localize)(29,null,h))}e.fromNow=w;function n(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(X[105],Q([10,11]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(X[43],Q([0,1,105,16,23]),function(G,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function k(w,n){return n&&(w.stack||w.stacktrace)?p.localize(0,null,R(w),A(w.stack)||A(w.stacktrace)):R(w)}function A(w){return Array.isArray(w)?w.join(`
`):w}function R(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?p.localize(1,null,w.message):w.message||p.localize(2,null)}function S(w=null,n=!1){if(!w)return p.localize(3,null);if(Array.isArray(w)){const y=D.coalesce(w),v=S(y[0],n);return y.length>1?p.localize(4,null,v,y.length):v}if(L.isString(w))return w;if(w.detail){const y=w.detail;if(y.error)return k(y.error,n);if(y.exception)return k(y.exception,n)}return w.stack?k(w,n):w.message?w.message:p.localize(5,null)}e.toErrorMessage=S}),define(X[106],Q([10,11]),function(G,e){return G.create("vs/base/node/processes",e)}),define(X[107],Q([0,1,8,18,42,106,34,16,26,41,7,68,17]),function(G,e,p,L,D,k,A,R,S,w,n,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function m(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(s,c){if(n.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};c&&(t.cwd=c);const r=D.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],t);return new Promise(i=>{r.once("error",o=>{i({success:!1,error:o})}),r.once("exit",(o,u)=>{i(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?m(t.status):1})}else if(n.isLinux||n.isMacintosh)try{const t=v.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",G).fsPath;return new Promise(r=>{D.execFile(t,[s.pid.toString()],{encoding:"utf8",shell:!0},(i,o,u)=>{r(i?{success:!1,error:i}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function C(s=A.env){return s.comspec||"cmd.exe"}e.getWindowsShell=C;class P{constructor(c,t,r,i){if(t!==void 0&&r!==void 0&&i!==void 0)this.cmd=c,this.args=t,this.shell=r,this.options=i;else{const o=c;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(A.env).forEach(u=>{o[u]=A.env[u]}),Object.keys(this.options.env).forEach(u=>{o[u]=this.options.env[u]}),this.options.env=o}}getSanitizedCommand(){let c=this.cmd.toLowerCase();const t=c.lastIndexOf(p.sep);return t!==-1&&(c=c.substring(t+1)),P.WellKnowCommands[c]?c:"other"}start(c){return n.isWindows&&(this.options&&this.options.cwd&&w.isUNC(this.options.cwd)||!this.options&&w.isUNC(A.cwd()))?Promise.reject(new Error(k.localize(0,null))):this.useExec().then(t=>{let r,i;const o=new Promise((u,a)=>{r=u,i=a});if(t){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=D.exec(u,this.options,(a,l,g)=>{this.childProcess=null;const E=a;E&&E.killed?i({killed:this.terminateRequested,stdout:l.toString(),stderr:g.toString()}):this.handleExec(r,c,a,l,g)})}else{let u=null;const a=l=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(l,r,c,i);const g={terminated:this.terminateRequested};R.isNumber(l)&&(g.cmdCode=l),r(g)};if(this.shell&&n.isWindows){const l=S.deepClone(this.options);l.windowsVerbatimArguments=!0,l.detached=!1;let g=!1,E=!1;const d=[];let T=this.ensureQuotes(this.cmd);d.push(T.value),g=T.quoted,this.args&&this.args.forEach($=>{T=this.ensureQuotes($),d.push(T.value),E=E&&T.quoted});const O=["/s","/c"];g?E?O.push('"'+d.join(" ")+'"'):d.length>1?O.push('"'+d[0]+'" '+d.slice(1).join(" ")):O.push('"'+d[0]+'"'):O.push(d.join(" ")),u=D.spawn(C(),O,l)}else this.cmd&&(u=D.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(R.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",l=>{this.childProcess=null,i({terminated:this.terminateRequested,error:l})}),u.pid&&(this.childProcess.on("close",a),this.handleSpawn(u,r,c,i,!0)))}return o})}handleClose(c,t,r,i){}ensureQuotes(c){return P.regexp.test(c)?{value:'"'+c+'"',quoted:!0}:{value:c,quoted:c.length>0&&c[0]==='"'&&c[c.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(c=>c.pid,c=>-1):new Promise(c=>{this.pidResolve=c})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(c=>(this.terminateRequested=!0,h(c,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),c=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(c=>{if(!this.shell||!n.isWindows)return c(!1);const t=D.spawn(C(),["/s","/c"]);t.on("error",r=>c(!0)),t.on("exit",r=>c(!1))})}}e.AbstractProcess=P,P.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},P.regexp=/^[^"].* .*[^"]/;class b extends P{constructor(c,t,r,i){super(c,t,r,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(c,t,r,i,o){[i,o].forEach((u,a)=>{const l=new y.LineDecoder;l.write(u).forEach(d=>{t({line:d,source:a===0?0:1})});const E=l.end();E&&t({line:E,source:a===0?0:1})}),c({terminated:this.terminateRequested,error:r})}handleSpawn(c,t,r,i,o){const u=new y.LineDecoder,a=new y.LineDecoder;c.stdout.on("data",l=>{u.write(l).forEach(E=>r({line:E,source:0}))}),c.stderr.on("data",l=>{a.write(l).forEach(E=>r({line:E,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=a}handleClose(c,t,r,i){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&r({line:o,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&r({line:u,source:1})}}e.LineProcess=b;function I(s){let c=[],t=!1;const r=function(i){if(t){c.push(i);return}(!s.send(i,u=>{if(u&&console.error(u),t=!1,c.length>0){const a=c.slice(0);c=[],a.forEach(l=>r(l))}})||n.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=I;var f;(function(s){async function c(t,r,i){if(p.isAbsolute(t))return t;if(r===void 0&&(r=A.cwd()),p.dirname(t)!=="."||(i===void 0&&R.isString(A.env.PATH)&&(i=A.env.PATH.split(p.delimiter)),i===void 0||i.length===0))return p.join(r,t);async function u(a){return await L.Promises.exists(a)?!(await L.Promises.stat(a)).isDirectory():!1}for(let a of i){let l;if(p.isAbsolute(a)?l=p.join(a,t):l=p.join(r,a,t),await u(l))return l;let g=l+".com";if(await u(g)||(g=l+".exe",await u(g)))return g}return p.join(r,t)}s.findExecutable=c})(f=e.win32||(e.win32={}))}),define(X[50],Q([0,1,42,2,6,26,3,107,36,90,29,9,25,7]),function(G,e,p,L,D,k,A,R,S,w,n,y,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends S.ChannelServer{constructor(b){super({send:I=>{try{process.send&&process.send(I.buffer.toString("base64"))}catch(f){}},onMessage:A.Event.fromNodeEventEmitter(process,"message",I=>v.VSBuffer.wrap(Buffer.from(I,"base64")))},b);process.once("disconnect",()=>this.dispose())}}e.Server=h;class C{constructor(b,I){this.modulePath=b,this.options=I,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new A.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=I&&I.timeout?I.timeout:6e4;this.disposeDelayer=new D.Delayer(f),this.child=null,this._client=null}getChannel(b){const I=this;return{call(f,s,c){return I.requestPromise(b,f,s,c)},listen(f,s){return I.requestEvent(b,f,s)}}}requestPromise(b,I,f,s=n.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(y.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(b),t=(0,D.createCancelablePromise)(o=>c.call(I,f,o)),r=s.onCancellationRequested(()=>t.cancel()),i=(0,L.toDisposable)(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(b,I,f){if(!this.disposeDelayer)return A.Event.None;this.disposeDelayer.cancel();let s;const c=new A.Emitter({onFirstListenerAdd:()=>{s=this.getCachedChannel(b).listen(I,f)(c.fire,c),this.activeRequests.add(s)},onLastListenerRemove:()=>{this.activeRequests.delete(s),s.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],I=Object.create(null);I.env={...(0,k.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(I.env={...I.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(I.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(I.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(I.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),I.execArgv===void 0&&(I.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u))),m.isMacintosh&&I.env&&delete I.env.DYLD_LIBRARY_PATH,this.child=(0,p.fork)(this.modulePath,b,I);const f=new A.Emitter;A.Event.fromNodeEventEmitter(this.child,"message",u=>u)(u=>{if((0,w.isRemoteConsoleLog)(u)){(0,w.log)(u,`IPC Library: ${this.options.serverName}`);return}f.fire(v.VSBuffer.wrap(Buffer.from(u,"base64")))});const c=this.options.useQueue?(0,R.createQueuedSender)(this.child):this.child,t=u=>this.child&&this.child.connected&&c.send(u.buffer.toString("base64")),r=f.event,i={send:t,onMessage:r};this._client=new S.ChannelClient(i);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",u=>console.warn('IPC "'+this.options.serverName+'" errored with '+u)),this.child.on("exit",(u,a)=>{process.removeListener("exit",o),this.activeRequests.forEach(l=>(0,L.dispose)(l)),this.activeRequests.clear(),u!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+u+" and signal "+a),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:u,signal:a})})}return this._client}getCachedChannel(b){let I=this.channels.get(b);return I||(I=this.client.getChannel(b),this.channels.set(b,I)),I}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=C}),define(X[108],Q([10,11]),function(G,e){return G.create("vs/base/node/zip",e)}),define(X[109],Q([10,11]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(X[110],Q([10,11]),function(G,e){return G.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(X[111],Q([10,11]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(X[112],Q([10,11]),function(G,e){return G.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(X[113],Q([10,11]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(X[114],Q([10,11]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(X[115],Q([10,11]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(X[116],Q([10,11]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(X[117],Q([10,11]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(X[118],Q([10,11]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(X[119],Q([10,11]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(X[120],Q([10,11]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(X[121],Q([10,11]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(X[122],Q([10,11]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(X[123],Q([10,11]),function(G,e){return G.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(X[124],Q([10,11]),function(G,e){return G.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(X[125],Q([10,11]),function(G,e){return G.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(X[126],Q([10,11]),function(G,e){return G.create("vs/platform/userDataSync/common/settingsSync",e)}),define(X[127],Q([10,11]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(X[128],Q([10,11]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataSync",e)}),define(X[129],Q([10,11]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(X[130],Q([0,1,8,15,64,55,17,4,34]),function(G,e,p,L,D,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class w{constructor(h,C,P){this._args=h,this.paths=C,this.productService=P}get appRoot(){return(0,p.dirname)(A.FileAccess.asFileUri("",G).fsPath)}get userHome(){return R.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return R.URI.file((0,p.join)(this.userDataPath,"User"))}get tmpDir(){return R.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,L.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,p.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return R.URI.file((0,p.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,L.joinPath)(R.URI.file((0,p.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return R.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return R.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=S.env.VSCODE_PORTABLE;return h?R.URI.file((0,p.join)(h,"argv.json")):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,L.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return R.URI.file((0,p.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,p.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,p.resolve)(h):(0,p.normalize)((0,p.join)(A.FileAccess.asFileUri("",G).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,p.resolve)(h):(0,p.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,p.resolve)(h);const C=S.env.VSCODE_EXTENSIONS;if(C)return C;const P=S.env.VSCODE_PORTABLE;return P?(0,p.join)(P,"extensions"):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(C=>/^[^:/?#]+?:\/\//.test(C)?R.URI.parse(C):R.URI.file((0,p.normalize)(C)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?R.URI.parse(h):R.URI.file((0,p.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return n(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!S.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,L.joinPath)(R.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return R.URI.file((0,p.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}fe([D.memoize],w.prototype,"appRoot",null),fe([D.memoize],w.prototype,"userHome",null),fe([D.memoize],w.prototype,"userDataPath",null),fe([D.memoize],w.prototype,"appSettingsHome",null),fe([D.memoize],w.prototype,"tmpDir",null),fe([D.memoize],w.prototype,"userRoamingDataHome",null),fe([D.memoize],w.prototype,"settingsResource",null),fe([D.memoize],w.prototype,"userDataSyncHome",null),fe([D.memoize],w.prototype,"userDataSyncLogResource",null),fe([D.memoize],w.prototype,"sync",null),fe([D.memoize],w.prototype,"machineSettingsResource",null),fe([D.memoize],w.prototype,"globalStorageHome",null),fe([D.memoize],w.prototype,"workspaceStorageHome",null),fe([D.memoize],w.prototype,"keybindingsResource",null),fe([D.memoize],w.prototype,"keyboardLayoutResource",null),fe([D.memoize],w.prototype,"argvResource",null),fe([D.memoize],w.prototype,"snippetsHome",null),fe([D.memoize],w.prototype,"isExtensionDevelopment",null),fe([D.memoize],w.prototype,"untitledWorkspacesHome",null),fe([D.memoize],w.prototype,"installSourcePath",null),fe([D.memoize],w.prototype,"builtinExtensionsPath",null),fe([D.memoize],w.prototype,"extensionsPath",null),fe([D.memoize],w.prototype,"extensionDevelopmentLocationURI",null),fe([D.memoize],w.prototype,"extensionDevelopmentKind",null),fe([D.memoize],w.prototype,"extensionTestsLocationURI",null),fe([D.memoize],w.prototype,"debugExtensionHost",null),fe([D.memoize],w.prototype,"serviceMachineIdResource",null),fe([D.memoize],w.prototype,"telemetryLogResource",null),fe([D.memoize],w.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=w;function n(m,h){return v(m["inspect-extensions"],m["inspect-brk-extensions"],5870,h,m.debugId)}e.parseExtensionHostPort=n;function y(m,h){return v(m["inspect-search"],m["inspect-brk-search"],5876,h)}e.parseSearchPort=y;function v(m,h,C,P,b){const f=Number(h||m)||(P?null:C),s=f?Boolean(!!h):!1;return{port:f,break:s,debugId:b}}}),function(){"use strict";function G(e,p,L,D){function k(R){const S=A(R),w=[S];return e.isAbsolute(S)||w.unshift(D),e.resolve(...w)}function A(R){const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,L);const n=R["user-data-dir"];if(n)return n;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(y,"AppData","Roaming")}break;case"darwin":w=e.join(p.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(p.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,L)}return{getUserDataPath:k}}if(typeof define=="function")define(X[131],Q([0,211,35,17,15,34]),function(e,p,L,D,k,A){const R=k.dirname(D.FileAccess.asFileUri("",e)),S=e.__$__nodeRequire(k.joinPath(R,"package.json").fsPath);return G(p,L,S.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),p=require("path"),L=require("os");module.exports=G(p,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(X[132],Q([0,1,35,131,130]),function(G,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends D.AbstractNativeEnvironmentService{constructor(R,S){super(R,{homeDir:(0,p.homedir)(),tmpDir:(0,p.tmpdir)(),userDataDir:(0,L.getUserDataPath)(R)},S)}}e.NativeEnvironmentService=k}),define(X[133],Q([0,1,4]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const L=/^([^@:]+@)?([^:]+):/,D=/^([^@:]+@)?([^:]+):(.+)$/,k=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,S=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function w(P){const b=P.match(A);return b?b[1]:null}function n(P){if(P.indexOf("://")===-1){const b=P.match(L);return b?w(b[2]):null}try{const b=p.URI.parse(P);if(b.authority)return w(b.authority)}catch(b){}return null}function y(P,b){const I=new Set;let f;for(;f=R.exec(P);){const c=n(f[1]);c&&I.add(c)}const s=new Set(b);return Array.from(I).map(c=>s.has(c)?c:c.replace(S,"a"))}e.getDomainsOfRemotes=y;function v(P){const b=P.match(k);return b?b[2]:null}function m(P,b,I){return P&&b?(I&&b.endsWith(".git")&&(b=b.substr(0,b.length-4)),b.indexOf("/")===0?`${P}${b}`:`${P}/${b}`):null}function h(P,b){if(P.indexOf("://")===-1){const I=P.match(D);if(I)return m(I[2],I[3],b)}try{const I=p.URI.parse(P);if(I.authority)return m(v(I.authority),I.path,b)}catch(I){}return null}function C(P,b=!1){const I=[];let f;for(;f=R.exec(P);){const s=h(f[1],b);s&&I.push(s)}return I}e.getRemotes=C}),define(X[134],Q([0,1,3,4,93,26,2]),function(G,e,p,L,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function R(h,C){return L.URI.revive(C?C.transformIncoming(h):h)}function S(h,C){return C?C.transformOutgoingURI(h):h}function w(h,C){C=C||D.DefaultURITransformer;const P=h.manifest;return{...(0,D.transformAndReviveIncomingURIs)({...h,manifest:void 0},C),manifest:P}}function n(h,C){return C?(0,k.cloneAndChange)(h,P=>P instanceof L.URI?C.transformOutgoingURI(P):void 0):h}class y{constructor(C,P){this.service=C,this.getUriTransformer=P,this.onInstallExtension=p.Event.buffer(C.onInstallExtension,!0),this.onDidInstallExtensions=p.Event.buffer(C.onDidInstallExtensions,!0),this.onUninstallExtension=p.Event.buffer(C.onUninstallExtension,!0),this.onDidUninstallExtension=p.Event.buffer(C.onDidUninstallExtension,!0)}listen(C,P){const b=this.getUriTransformer(C);switch(P){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return p.Event.map(this.onDidInstallExtensions,I=>I.map(f=>({...f,local:f.local?n(f.local,b):f.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(C,P,b){const I=this.getUriTransformer(C);switch(P){case"zip":return this.service.zip(w(b[0],I)).then(f=>S(f,I));case"unzip":return this.service.unzip(R(b[0],I));case"install":return this.service.install(R(b[0],I),b[1]);case"getManifest":return this.service.getManifest(R(b[0],I));case"canInstall":return this.service.canInstall(b[0]);case"installFromGallery":return this.service.installFromGallery(b[0],b[1]);case"uninstall":return this.service.uninstall(w(b[0],I),b[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(w(b[0],I));case"getInstalled":return this.service.getInstalled(b[0]).then(f=>f.map(s=>n(s,I)));case"updateMetadata":return this.service.updateMetadata(w(b[0],I),b[1]).then(f=>n(f,I));case"updateExtensionScope":return this.service.updateExtensionScope(w(b[0],I),b[1]).then(f=>n(f,I));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=y;class v extends A.Disposable{constructor(C){super();this.channel=C,this._onInstallExtension=this._register(new p.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new p.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new p.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new p.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(P=>this._onInstallExtension.fire({identifier:P.identifier,source:this.isUriComponents(P.source)?L.URI.revive(P.source):P.source}))),this._register(this.channel.listen("onDidInstallExtensions")(P=>this._onDidInstallExtensions.fire(P.map(b=>({...b,local:b.local?w(b.local,null):b.local,source:this.isUriComponents(b.source)?L.URI.revive(b.source):b.source}))))),this._register(this.channel.listen("onUninstallExtension")(P=>this._onUninstallExtension.fire(P))),this._register(this.channel.listen("onDidUninstallExtension")(P=>this._onDidUninstallExtension.fire(P)))}isUriComponents(C){return C?typeof C.path=="string"&&typeof C.scheme=="string":!1}zip(C){return Promise.resolve(this.channel.call("zip",[C]).then(P=>L.URI.revive(P)))}unzip(C){return Promise.resolve(this.channel.call("unzip",[C]))}install(C,P){return Promise.resolve(this.channel.call("install",[C,P])).then(b=>w(b,null))}getManifest(C){return Promise.resolve(this.channel.call("getManifest",[C]))}async canInstall(C){return!0}installFromGallery(C,P){return Promise.resolve(this.channel.call("installFromGallery",[C,P])).then(b=>w(b,null))}uninstall(C,P){return Promise.resolve(this.channel.call("uninstall",[C,P]))}reinstallFromGallery(C){return Promise.resolve(this.channel.call("reinstallFromGallery",[C]))}getInstalled(C=null){return Promise.resolve(this.channel.call("getInstalled",[C])).then(P=>P.map(b=>w(b,null)))}updateMetadata(C,P){return Promise.resolve(this.channel.call("updateMetadata",[C,P])).then(b=>w(b,null))}updateExtensionScope(C,P){return Promise.resolve(this.channel.call("updateExtensionScope",[C,P])).then(b=>w(b,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=v;class m{constructor(C){this.service=C}listen(C,P){throw new Error("Invalid listen")}call(C,P,b){switch(P){case"getConfigBasedTips":return this.service.getConfigBasedTips(L.URI.revive(b[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=m}),define(X[135],Q([0,1,26]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const L=/^%([\w\d.-]+)%$/i;function D(k,A){const R=S=>{if(typeof S!="string")return;const w=L.exec(S);if(!w)return;const n=A[w[1]]??S;return typeof n=="string"?n:typeof n.message=="string"?n.message:S};return(0,p.cloneAndChange)(k,R)}e.localizeManifest=D}),define(X[136],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class p{constructor(k){this.channel=k}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(k,A,R,S){return this.channel.call("promptImportantExtensionsInstallNotification",[k,A,R,S])}promptWorkspaceRecommendations(k){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=p;class L{constructor(k){this.service=k}listen(k,A){throw new Error(`Event not found: ${A}`)}call(k,A,R){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=L}),define(X[70],Q([0,1,116]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function k(v){return v=v.trim(),v==="*"||L.test(v)}e.isValidVersionStr=k;function A(v){if(!k(v))return null;if(v=v.trim(),v==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=v.match(L);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=A;function R(v){if(!v)return null;let m=v.majorBase,h=v.majorMustEqual,C=v.minorBase,P=v.minorMustEqual,b=v.patchBase,I=v.patchMustEqual;v.hasCaret&&(m===0||(P=!1),I=!1);let f=0;if(v.preRelease){const s=D.exec(v.preRelease);if(s){const[,c,t,r]=s;f=Date.UTC(Number(c),Number(t)-1,Number(r))}}return{majorBase:m,majorMustEqual:h,minorBase:C,minorMustEqual:P,patchBase:b,patchMustEqual:I,isMinimum:v.hasGreaterEquals,notBefore:f}}e.normalizeVersion=R;function S(v,m,h){let C;typeof v=="string"?C=R(A(v)):C=v;let P;m instanceof Date?P=m.getTime():typeof m=="string"&&(P=new Date(m).getTime());let b;if(typeof h=="string"?b=R(A(h)):b=h,!C||!b)return!1;let I=C.majorBase,f=C.minorBase,s=C.patchBase,c=b.majorBase,t=b.minorBase,r=b.patchBase,i=b.notBefore,o=b.majorMustEqual,u=b.minorMustEqual,a=b.patchMustEqual;return b.isMinimum?I>c?!0:I<c?!1:f>t?!0:f<t||P&&P<i?!1:s>=r:(I===1&&c===0&&(!o||!u||!a)&&(c=1,t=0,r=0,o=!0,u=!1,a=!1),I<c?!1:I>c?!o:f<t?!1:f>t?!u:s<r?!1:s>r?!a:!(P&&P<i))}e.isValidVersion=S;function w(v,m,h,C){return h.isBuiltin||typeof h.main=="undefined"?!0:y(v,m,h.engines.vscode,C)}e.isValidExtensionVersion=w;function n(v,m,h){return v==="*"||y(m,h,v)}e.isEngineValid=n;function y(v,m,h,C=[]){let P=R(A(h));if(!P)return C.push(p.localize(0,null,h)),!1;if(P.majorBase===0){if(!P.majorMustEqual||!P.minorMustEqual)return C.push(p.localize(1,null,h)),!1}else if(!P.majorMustEqual)return C.push(p.localize(2,null,h)),!1;return S(v,m,P)?!0:(C.push(p.localize(3,null,v,h)),!1)}}),define(X[137],Q([0,1,36,50,2,17]),function(G,e,p,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends D.Disposable{constructor(S,w,n,y){super();this.folders=S,this.onDidFilesChange=w,this.onLogMessage=n,this.verboseLogging=y,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const S=this._register(new L.Client(k.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(S.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=p.ProxyChannel.toService((0,p.getNextTickChannel)(S.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.setFolders(this.folders)}setVerboseLogging(S){this.verboseLogging=S,!this.isDisposed&&this.service&&this.service.setVerboseLogging(S)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${S}`})}setFolders(S){this.folders=S,this.service&&this.service.setRoots(S)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(X[138],Q([0,1,36,50,2,17]),function(G,e,p,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends D.Disposable{constructor(S,w,n,y,v={}){super();this.folders=S,this.onDidFilesChange=w,this.onLogMessage=n,this.verboseLogging=y,this.watcherOptions=v,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const S=this._register(new L.Client(k.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(S.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=p.ProxyChannel.toService((0,p.getNextTickChannel)(S.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.service.setRoots(this.folders)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${S}`})}setVerboseLogging(S){this.verboseLogging=S,this.service&&this.service.setVerboseLogging(S)}setFolders(S){this.folders=S,this.service&&this.service.setRoots(S)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(X[139],Q([0,1,42,68,67,17]),function(G,e,p,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class A{constructor(S,w,n,y,v){this.watchedFolder=S,this.eventCallback=n,this.logCallback=y,this.verboseLogging=v,this.restartCounter=0,Array.isArray(w)?this.ignored=w.map(m=>(0,D.parse)(m)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${S}, excludes: ${w.join(",")}`),this.startWatcher()}startWatcher(){const S=[this.watchedFolder];this.verboseLogging&&S.push("-verbose"),this.handle=(0,p.spawn)(k.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",G).fsPath,S);const w=new L.LineDecoder;this.handle.stdout.on("data",n=>{const y=[];for(const v of w.write(n)){const m=v.split("|");if(m.length===2){const h=Number(m[0]),C=m[1];if(h>=0&&h<3){if(this.ignored&&this.ignored.some(P=>P(C))){this.verboseLogging&&this.log(C);continue}y.push({type:A.changeTypeMap[h],path:C})}else this.log(m[1])}}y.length>0&&this.eventCallback(y)}),this.handle.on("error",n=>this.onError(n)),this.handle.stderr.on("data",n=>this.onError(n)),this.handle.on("exit",(n,y)=>this.onExit(n,y))}onError(S){this.error("process error: "+S.toString())}onExit(S,w){this.handle&&(this.error(`terminated unexpectedly (code: ${S}, signal: ${w})`),this.restartCounter<=A.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(S){this.logCallback({type:"error",message:`[File Watcher (C#)] ${S}`})}log(S){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${S}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=A,A.MAX_RESTARTS=5,A.changeTypeMap=[0,1,2]}),define(X[140],Q([0,1,139,8,19]),function(G,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k{constructor(R,S,w,n){this.onDidFilesChange=S,this.onLogMessage=w,this.verboseLogging=n,this.service=void 0,this.folder=R[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(L.posix.sep)&&(this.folder.path=(0,D.rtrim)(this.folder.path,L.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new p.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,R=>this.onFileEvents(R),R=>this.onLogMessage(R),this.verboseLogging)}setVerboseLogging(R){this.verboseLogging=R,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(R){this.isDisposed||R.length>0&&this.onDidFilesChange(R)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=k}),define(X[51],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class p{constructor(D,k=[],A=!1){this.ctor=D,this.staticArguments=k,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=p}),define(X[141],Q([0,1,51]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function D(A,R,S){R instanceof p.SyncDescriptor||(R=new p.SyncDescriptor(R,[],S)),L.push([A,R])}e.registerSingleton=D;function k(){return L}e.getSingletonServiceDescriptors=k}),define(X[142],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(k){this.incoming=new Map,this.outgoing=new Map,this.data=k}}e.Node=p;class L{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(let A of this._nodes.values())A.outgoing.size===0&&k.push(A);return k}insertEdge(k,A){const R=this.lookupOrInsertNode(k),S=this.lookupOrInsertNode(A);R.outgoing.set(this._hashFn(A),S),S.incoming.set(this._hashFn(k),R)}removeNode(k){const A=this._hashFn(k);this._nodes.delete(A);for(let R of this._nodes.values())R.outgoing.delete(A),R.incoming.delete(A)}lookupOrInsertNode(k){const A=this._hashFn(k);let R=this._nodes.get(A);return R||(R=new p(k),this._nodes.set(A,R)),R}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){let k=[];for(let[A,R]of this._nodes)k.push(`${A}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return k.join(`
`)}findCycleSlow(){for(let[k,A]of this._nodes){const R=new Set([k]),S=this._findCycle(A,R);if(S)return S}}_findCycle(k,A){for(let[R,S]of k.outgoing){if(A.has(R))return[...A,R].join(" -> ");A.add(R);const w=this._findCycle(S,A);if(w)return w;A.delete(R)}}}e.Graph=L}),define(X[5],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function S(w){return w[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=S})(p=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function L(R,S,w,n){S[p.DI_TARGET]===S?S[p.DI_DEPENDENCIES].push({id:R,index:w,optional:n}):(S[p.DI_DEPENDENCIES]=[{id:R,index:w,optional:n}],S[p.DI_TARGET]=S)}function D(R){if(p.serviceIds.has(R))return p.serviceIds.get(R);const S=function(w,n,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(S,w,y,!1)};return S.toString=()=>R,p.serviceIds.set(R,S),S}e.createDecorator=D;function k(R){return R}e.refineServiceDecorator=k;function A(R){return function(S,w,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(R,S,n,!0)}}e.optional=A}),define(X[143],Q([0,1,5]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,p.createDecorator)("checksumService")}),define(X[144],Q([0,1,19,5,7]),function(G,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let k=D.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",D.isMacintosh),A.set("isLinux",D.isLinux),A.set("isWindows",D.isWindows),A.set("isWeb",D.isWeb),A.set("isMacNative",D.isMacintosh&&!D.isWeb),A.set("isEdge",k.indexOf("Edg/")>=0),A.set("isFirefox",k.indexOf("Firefox")>=0),A.set("isChrome",k.indexOf("Chrome")>=0),A.set("isSafari",k.indexOf("Safari")>=0);const R=Object.prototype.hasOwnProperty;var S;(function(E){E[E.False=0]="False",E[E.True=1]="True",E[E.Defined=2]="Defined",E[E.Not=3]="Not",E[E.Equals=4]="Equals",E[E.NotEquals=5]="NotEquals",E[E.And=6]="And",E[E.Regex=7]="Regex",E[E.NotRegex=8]="NotRegex",E[E.Or=9]="Or",E[E.In=10]="In",E[E.NotIn=11]="NotIn",E[E.Greater=12]="Greater",E[E.GreaterEquals=13]="GreaterEquals",E[E.Smaller=14]="Smaller",E[E.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class w{static false(){return y.INSTANCE}static true(){return v.INSTANCE}static has(d){return m.create(d)}static equals(d,T){return h.create(d,T)}static notEquals(d,T){return b.create(d,T)}static regex(d,T){return r.create(d,T)}static in(d,T){return C.create(d,T)}static not(d){return I.create(d)}static and(...d){return o.create(d)}static or(...d){return u.create(d)}static greater(d,T){return f.create(d,T)}static less(d,T){return c.create(d,T)}static deserialize(d,T=!1){if(!!d)return this._deserializeOrExpression(d,T)}static _deserializeOrExpression(d,T){let O=d.split("||");return u.create(O.map($=>this._deserializeAndExpression($,T)))}static _deserializeAndExpression(d,T){let O=d.split("&&");return o.create(O.map($=>this._deserializeOne($,T)))}static _deserializeOne(d,T){if(d=d.trim(),d.indexOf("!=")>=0){let O=d.split("!=");return b.create(O[0].trim(),this._deserializeValue(O[1],T))}if(d.indexOf("==")>=0){let O=d.split("==");return h.create(O[0].trim(),this._deserializeValue(O[1],T))}if(d.indexOf("=~")>=0){let O=d.split("=~");return r.create(O[0].trim(),this._deserializeRegexValue(O[1],T))}if(d.indexOf(" in ")>=0){let O=d.split(" in ");return C.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(d)){const O=d.split(">=");return s.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(d)){const O=d.split(">");return f.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(d)){const O=d.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(d)){const O=d.split("<");return c.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(d)?I.create(d.substr(1).trim()):m.create(d)}static _deserializeValue(d,T){if(d=d.trim(),d==="true")return!0;if(d==="false")return!1;let O=/^'([^']*)'$/.exec(d);return O?O[1].trim():d}static _deserializeRegexValue(d,T){if((0,p.isFalsyOrWhitespace)(d)){if(T)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=d.indexOf("/"),$=d.lastIndexOf("/");if(O===$||O<0){if(T)throw new Error(`bad regexp-value '${d}', missing /-enclosure`);return console.warn(`bad regexp-value '${d}', missing /-enclosure`),null}let z=d.slice(O+1,$),V=d[$+1]==="i"?"i":"";try{return new RegExp(z,V)}catch(B){if(T)throw new Error(`bad regexp-value '${d}', parse error: ${B}`);return console.warn(`bad regexp-value '${d}', parse error: ${B}`),null}}}e.ContextKeyExpr=w;function n(E,d){return E.cmp(d)}class y{constructor(){this.type=0}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}evaluate(d){return!1}serialize(){return"false"}keys(){return[]}map(d){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=y,y.INSTANCE=new y;class v{constructor(){this.type=1}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}evaluate(d){return!0}serialize(){return"true"}keys(){return[]}map(d){return this}negate(){return y.INSTANCE}}e.ContextKeyTrueExpr=v,v.INSTANCE=new v;class m{constructor(d){this.key=d,this.type=2}static create(d){const T=A.get(d);return typeof T=="boolean"?T?v.INSTANCE:y.INSTANCE:new m(d)}cmp(d){return d.type!==this.type?this.type-d.type:l(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}evaluate(d){return!!d.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(d){return d.mapDefined(this.key)}negate(){return I.create(this.key)}}e.ContextKeyDefinedExpr=m;class h{constructor(d,T){this.key=d,this.value=T,this.type=4}static create(d,T){if(typeof T=="boolean")return T?m.create(d):I.create(d);const O=A.get(d);return typeof O=="boolean"?T===(O?"true":"false")?v.INSTANCE:y.INSTANCE:new h(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:g(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return d.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(d){return d.mapEquals(this.key,this.value)}negate(){return b.create(this.key,this.value)}}e.ContextKeyEqualsExpr=h;class C{constructor(d,T){this.key=d,this.valueKey=T,this.type=10}static create(d,T){return new C(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:g(this.key,this.valueKey,d.key,d.valueKey)}equals(d){return d.type===this.type?this.key===d.key&&this.valueKey===d.valueKey:!1}evaluate(d){const T=d.getValue(this.valueKey),O=d.getValue(this.key);return Array.isArray(T)?T.indexOf(O)>=0:typeof O=="string"&&typeof T=="object"&&T!==null?R.call(T,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(d){return d.mapIn(this.key,this.valueKey)}negate(){return P.create(this)}}e.ContextKeyInExpr=C;class P{constructor(d){this._actual=d,this.type=11}static create(d){return new P(d)}cmp(d){return d.type!==this.type?this.type-d.type:this._actual.cmp(d._actual)}equals(d){return d.type===this.type?this._actual.equals(d._actual):!1}evaluate(d){return!this._actual.evaluate(d)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(d){return new P(this._actual.map(d))}negate(){return this._actual}}e.ContextKeyNotInExpr=P;class b{constructor(d,T){this.key=d,this.value=T,this.type=5}static create(d,T){if(typeof T=="boolean")return T?I.create(d):m.create(d);const O=A.get(d);return typeof O=="boolean"?T===(O?"true":"false")?y.INSTANCE:v.INSTANCE:new b(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:g(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return d.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(d){return d.mapNotEquals(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=b;class I{constructor(d){this.key=d,this.type=3}static create(d){const T=A.get(d);return typeof T=="boolean"?T?y.INSTANCE:v.INSTANCE:new I(d)}cmp(d){return d.type!==this.type?this.type-d.type:l(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}evaluate(d){return!d.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(d){return d.mapNot(this.key)}negate(){return m.create(this.key)}}e.ContextKeyNotExpr=I;class f{constructor(d,T){this.key=d,this.value=T,this.type=12}static create(d,T){return new f(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:g(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(d){return d.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=f;class s{constructor(d,T){this.key=d,this.value=T,this.type=13}static create(d,T){return new s(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:g(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(d){return d.mapGreaterEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=s;class c{constructor(d,T){this.key=d,this.value=T,this.type=14}static create(d,T){return new c(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:g(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(d){return d.mapSmaller(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeySmallerExpr=c;class t{constructor(d,T){this.key=d,this.value=T,this.type=15}static create(d,T){return new t(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:g(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(d){return d.mapSmallerEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(d,T){this.key=d,this.regexp=T,this.type=7}static create(d,T){return new r(d,T)}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.key<d.key)return-1;if(this.key>d.key)return 1;const T=this.regexp?this.regexp.source:"",O=d.regexp?d.regexp.source:"";return T<O?-1:T>O?1:0}equals(d){if(d.type===this.type){const T=this.regexp?this.regexp.source:"",O=d.regexp?d.regexp.source:"";return this.key===d.key&&T===O}return!1}evaluate(d){let T=d.getValue(this.key);return this.regexp?this.regexp.test(T):!1}serialize(){const d=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${d}`}keys(){return[this.key]}map(d){return d.mapRegex(this.key,this.regexp)}negate(){return i.create(this)}}e.ContextKeyRegexExpr=r;class i{constructor(d){this._actual=d,this.type=8}static create(d){return new i(d)}cmp(d){return d.type!==this.type?this.type-d.type:this._actual.cmp(d._actual)}equals(d){return d.type===this.type?this._actual.equals(d._actual):!1}evaluate(d){return!this._actual.evaluate(d)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(d){return new i(this._actual.map(d))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;class o{constructor(d){this.expr=d,this.type=6}static create(d){return o._normalizeArr(d)}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let T=0,O=this.expr.length;T<O;T++){const $=n(this.expr[T],d.expr[T]);if($!==0)return $}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let T=0,O=this.expr.length;T<O;T++)if(!this.expr[T].equals(d.expr[T]))return!1;return!0}return!1}evaluate(d){for(let T=0,O=this.expr.length;T<O;T++)if(!this.expr[T].evaluate(d))return!1;return!0}static _normalizeArr(d){const T=[];let O=!1;for(const $ of d)if(!!$){if($.type===1){O=!0;continue}if($.type===0)return y.INSTANCE;if($.type===6){T.push(...$.expr);continue}T.push($)}if(T.length===0&&O)return v.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];for(T.sort(n);T.length>1;){const $=T[T.length-1];if($.type!==9)break;T.pop();const z=T.pop(),V=u.create($.expr.map(B=>o.create([B,z])));V&&(T.push(V),T.sort(n))}return T.length===1?T[0]:new o(T)}}serialize(){return this.expr.map(d=>d.serialize()).join(" && ")}keys(){const d=[];for(let T of this.expr)d.push(...T.keys());return d}map(d){return new o(this.expr.map(T=>T.map(d)))}negate(){let d=[];for(let T of this.expr)d.push(T.negate());return u.create(d)}}e.ContextKeyAndExpr=o;class u{constructor(d){this.expr=d,this.type=9}static create(d){const T=u._normalizeArr(d);if(T.length!==0)return T.length===1?T[0]:new u(T)}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let T=0,O=this.expr.length;T<O;T++){const $=n(this.expr[T],d.expr[T]);if($!==0)return $}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let T=0,O=this.expr.length;T<O;T++)if(!this.expr[T].equals(d.expr[T]))return!1;return!0}return!1}evaluate(d){for(let T=0,O=this.expr.length;T<O;T++)if(this.expr[T].evaluate(d))return!0;return!1}static _normalizeArr(d){let T=[],O=!1;if(d){for(let $=0,z=d.length;$<z;$++){const V=d[$];if(!!V){if(V.type===0){O=!0;continue}if(V.type===1)return[v.INSTANCE];if(V.type===9){T=T.concat(V.expr);continue}T.push(V)}}if(T.length===0&&O)return[y.INSTANCE];T.sort(n)}return T}serialize(){return this.expr.map(d=>d.serialize()).join(" || ")}keys(){const d=[];for(let T of this.expr)d.push(...T.keys());return d}map(d){return new u(this.expr.map(T=>T.map(d)))}negate(){let d=[];for(let O of this.expr)d.push(O.negate());const T=O=>O.type===9?O.expr:[O];for(;d.length>1;){const O=d.shift(),$=d.shift(),z=[];for(const V of T(O))for(const B of T($))z.push(w.and(V,B));d.unshift(w.or(...z))}return d[0]}}e.ContextKeyOrExpr=u;class a extends m{constructor(d,T,O){super(d);this._defaultValue=T,typeof O=="object"?a._info.push({...O,key:d}):O!==!0&&a._info.push({key:d,description:O,type:T!=null?typeof T:void 0})}static all(){return a._info.values()}bindTo(d){return d.createKey(this.key,this._defaultValue)}getValue(d){return d.getContextKeyValue(this.key)}toNegated(){return w.not(this.key)}isEqualTo(d){return w.equals(this.key,d)}notEqualsTo(d){return w.notEquals(this.key,d)}}e.RawContextKey=a,a._info=[],e.IContextKeyService=(0,L.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function l(E,d){return E<d?-1:E>d?1:0}function g(E,d,T,O){return E<T?-1:E>T?1:d<O?-1:d>O?1:0}}),define(X[71],Q([0,1,5]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,p.createDecorator)(e.ID);function L(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=L}),define(X[72],Q([0,1,5]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,p.createDecorator)("downloadService")}),define(X[12],Q([0,1,5]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,p.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,p.refineServiceDecorator)(e.IEnvironmentService)}),define(X[27],Q([0,1,111,5,17]),function(G,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}e.isIExtensionIdentifier=k;var A;(function(y){y[y.NoneOrRelevance=0]="NoneOrRelevance",y[y.LastUpdatedDate=1]="LastUpdatedDate",y[y.Title=2]="Title",y[y.PublisherName=3]="PublisherName",y[y.InstallCount=4]="InstallCount",y[y.PublishedDate=5]="PublishedDate",y[y.AverageRating=6]="AverageRating",y[y.WeightedRating=12]="WeightedRating"})(A=e.SortBy||(e.SortBy={}));var R;(function(y){y[y.Default=0]="Default",y[y.Ascending=1]="Ascending",y[y.Descending=2]="Descending"})(R=e.SortOrder||(e.SortOrder={}));var S;(function(y){y.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var w;(function(y){y[y.None=0]="None",y[y.Install=1]="Install",y[y.Update=2]="Update"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class n extends Error{constructor(v,m){super(v);this.code=m,this.name=m}}e.ExtensionManagementError=n,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",G).toString(!0),e.ExtensionsLabel=(0,p.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,p.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,L.createDecorator)("IExtensionManagementCLIService")});var K=this&&this.__param||function(G,e){return function(p,L){e(p,L,G)}};define(X[145],Q([0,1,2,27]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let D=class extends p.Disposable{constructor(A){super();this.extensionManagementService=A,this._register(A),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};D=fe([K(0,L.IExtensionManagementService)],D),e.DeprecatedExtensionsCleaner=D}),define(X[73],Q([0,1,5]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var L;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(L=e.RecommendationSource||(e.RecommendationSource={}));function D(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=D;var k;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(k=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,p.createDecorator)("IExtensionRecommendationNotificationService")}),define(X[74],Q([0,1,19,5]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function D(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=D;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class R{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,v){if(typeof y=="undefined"||y===null)return typeof v=="undefined"||v===null;if(typeof v=="undefined"||v===null)return!1;if(typeof y=="string"||typeof v=="string"){let m=typeof y=="string"?y:y.value,h=typeof v=="string"?v:v.value;return p.equalsIgnoreCase(m,h)}return y._lower===v._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.ExtensionIdentifier=R;function S(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function w(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=w,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(X[31],Q([0,1,19,74]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(h,C){return h.uuid&&C.uuid?h.uuid===C.uuid:h.id===C.id?!0:(0,p.compareIgnoreCase)(h.id,C.id)===0}e.areSameExtensions=D;class k{constructor(C,P){this.version=P,this.id=C.id,this.uuid=C.uuid}key(){return`${this.id}-${this.version}`}equals(C){return C instanceof k?D(this,C)&&this.version===C.version:!1}}e.ExtensionIdentifierWithVersion=k;function A(h,C){return`${h}.${C}`}e.getExtensionId=A;function R(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=R;function S(h,C){return R(A(h,C))}e.getGalleryExtensionId=S;function w(h,C){const P=[],b=I=>{for(const f of P)if(f.some(s=>D(C(s),C(I))))return f;return null};for(const I of h){const f=b(I);f?f.push(I):P.push([I])}return P}e.groupByExtension=w;function n(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function y(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function v(h){const C=new Set;for(const P of h)P.malicious&&C.add(P.id.id);return C}e.getMaliciousExtensionsSet=v;function m(h,C){const P=[],b=C.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const I=b.shift();if(I&&P.every(f=>!D(f.identifier,{id:I}))){const f=h.filter(s=>D(s.identifier,{id:I}));f.length===1&&(P.push(f[0]),b.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return P}e.getExtensionDependencies=m}),define(X[146],Q([0,1,2,8,74,18]),function(G,e,p,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends p.Disposable{constructor(S,w){super();this.environmentService=S,this.extensionsManifestCache=(0,L.join)(this.environmentService.userDataPath,D.MANIFEST_CACHE_FOLDER,D.USER_MANIFEST_CACHE_FILE),this._register(w.onDidInstallExtensions(n=>this.onDidInstallExtensions(n))),this._register(w.onDidUninstallExtension(n=>this.onDidUnInstallExtension(n)))}onDidInstallExtensions(S){S.some(w=>!!w.local)&&this.invalidate()}onDidUnInstallExtension(S){S.error||this.invalidate()}invalidate(){k.Promises.rm(this.extensionsManifestCache,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(X[13],Q([0,1,118,8,4,5,19,16,38]),function(G,e,p,L,D,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,k.createDecorator)("fileService");function w(M){return M.create===!0}e.isFileOpenForWriteOptions=w;var n;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var y;(function(M){M[M.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var v;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(v=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=m;function h(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=h;function C(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=C;function P(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=P;var b;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class I extends Error{constructor(_,N){super(_);this.code=N}}e.FileSystemProviderError=I;function f(M,_){const N=new I(M.toString(),_);return c(N,_),N}e.createFileSystemProviderError=f;function s(M){return M||f((0,p.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=s;function c(M,_){return M.name=_?`${_} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=c;function t(M){if(!M)return b.Unknown;if(M instanceof I)return M.code;const _=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!_)return b.Unknown;switch(_[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=t;function r(M){if(M instanceof g)return M.fileOperationResult;switch(t(M)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var i;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class o{constructor(_,N,j){this.resource=_,this.operation=N,this.target=j}isOperation(_){return this.operation===_}}e.FileOperationEvent=o;var u;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class a{constructor(_,N){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const j of _)switch(j.type){case 1:this.added||(this.added=S.TernarySearchTree.forUris(()=>N)),this.added.set(j.resource,j);break;case 0:this.updated||(this.updated=S.TernarySearchTree.forUris(()=>N)),this.updated.set(j.resource,j);break;case 2:this.deleted||(this.deleted=S.TernarySearchTree.forUris(()=>N)),this.deleted.set(j.resource,j);break}}contains(_,...N){return this.doContains(_,{includeChildren:!1},...N)}affects(_,...N){return this.doContains(_,{includeChildren:!0},...N)}doContains(_,N,...j){if(!_)return!1;const F=j.length>0;return!!((!F||j.includes(1))&&(this.added?.get(_)||N.includeChildren&&this.added?.findSuperstr(_))||(!F||j.includes(0))&&(this.updated?.get(_)||N.includeChildren&&this.updated?.findSuperstr(_))||(!F||j.includes(2))&&(this.deleted?.findSubstr(_)||N.includeChildren&&this.deleted?.findSuperstr(_)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=a;function l(M,_,N){return!M||!_||M===_||_.length>M.length?!1:(_.charAt(_.length-1)!==L.sep&&(_+=L.sep),N?(0,A.startsWithIgnoreCase)(M,_):M.indexOf(_)===0)}e.isParent=l;class g extends Error{constructor(_,N,j){super(_);this.fileOperationResult=N,this.options=j}}e.FileOperationError=g;class E extends g{constructor(_,N,j){super(_,2,j);this.stat=N}}e.NotModifiedSinceFileOperationError=E;var d;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(d=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var T;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(T=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=O;async function $(M,_){if(!_.canHandleResource(D.URI.from({scheme:M.scheme})))return new Promise(N=>{const j=_.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===M.scheme&&F.added&&(j.dispose(),N())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize(_){return(0,R.isNumber)(_)||(_=0),_<z.KB?(0,p.localize)(1,null,_.toFixed(0)):_<z.MB?(0,p.localize)(2,null,(_/z.KB).toFixed(2)):_<z.GB?(0,p.localize)(3,null,(_/z.MB).toFixed(2)):_<z.TB?(0,p.localize)(4,null,(_/z.GB).toFixed(2)):(0,p.localize)(5,null,(_/z.TB).toFixed(2))}}e.ByteSize=z,z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB;var V;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function B(M){return{maxFileSize:M===0?300*z.MB:16*z.GB,maxHeapSize:M===0?700*z.MB:2*700*z.MB}}e.getPlatformLimits=B}),define(X[147],Q([0,1,148,48,13]),function(G,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let k=class{constructor(R){this.fileService=R}checksum(R){return new Promise(async(S,w)=>{const n=(0,p.createHash)("md5"),y=(await this.fileService.readFileStream(R)).value;(0,L.listenStream)(y,{onData:v=>n.update(v.buffer),onError:v=>w(v),onEnd:()=>S(n.digest("base64").replace(/=+$/,""))})})}};k=fe([K(0,D.IFileService)],k),e.ChecksumService=k}),define(X[75],Q([0,1,4,13,7]),function(G,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function k(S){return S.map(w=>({type:w.type,resource:p.URI.file(w.path)}))}e.toFileChanges=k;function A(S){const w=new R;for(const n of S)w.processEvent(n);return w.normalize()}e.normalizeFileChanges=A;class R{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(w){const n=this.mapPathToChange.get(w.path);if(n){const y=n.type,v=w.type;y===1&&v===2?(this.mapPathToChange.delete(w.path),this.normalized.splice(this.normalized.indexOf(n),1)):y===2&&v===1?n.type=0:y===1&&v===0||(n.type=v)}else this.normalized.push(w),this.mapPathToChange.set(w.path,w)}normalize(){const w=[],n=[];return this.normalized.filter(y=>y.type!==2?(w.push(y),!1):!0).sort((y,v)=>y.path.length-v.path.length).filter(y=>n.some(v=>(0,L.isParent)(y.path,v,!D.isLinux))?!1:(n.push(y.path),!0)).concat(w)}}}),define(X[149],Q([0,1,75,2,18,96,99,6,8]),function(G,e,p,L,D,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class w extends L.Disposable{constructor(y,v,m,h){super();this.path=y,this.onDidFilesChange=v,this.onLogMessage=m,this.verboseLogging=h,this.fileChangesDelayer=this._register(new R.ThrottledDelayer(A.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(y){this.verboseLogging=y}async startWatching(){try{const{stat:y,symbolicLink:v}=await D.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let m=this.path;if(v)try{m=await(0,k.realpath)(m)}catch(h){if(this.onError(h),v.dangling)return}y.isDirectory()?this._register((0,A.watchFolder)(m,(h,C)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,S.join)(this.path,(0,S.basename)(C))})},h=>this.onError(h))):this._register((0,A.watchFile)(m,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(y){y.code!=="ENOENT"&&this.onError(y)}}onFileChange(y){this.fileChangesBuffer.push(y),this.verboseLogging&&this.onVerbose(`${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`),this.fileChangesDelayer.trigger(async()=>{const v=this.fileChangesBuffer;this.fileChangesBuffer=[];const m=(0,p.normalizeFileChanges)(v);if(this.verboseLogging)for(const h of m)this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);m.length>0&&this.onDidFilesChange(m)})}onError(y){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${y}`})}onVerbose(y){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${y}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=w}),define(X[76],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...D){this._entries=new Map;for(let[k,A]of D)this.set(k,A)}set(D,k){const A=this._entries.get(D);return this._entries.set(D,k),A}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=p}),define(X[150],Q([0,1,9,142,51,5,76,6]),function(G,e,p,L,D,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class w extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class n{constructor(h=new A.ServiceCollection,C=!1,P){this._activeInstantiations=new Set,this._services=h,this._strict=C,this._parent=P,this._services.set(k.IInstantiationService,this)}createChild(h){return new n(h,this._strict,this)}invokeFunction(h,...C){let P=v.traceInvocation(h),b=!1;try{return h({get:(f,s)=>{if(b)throw(0,p.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(f,P);if(!c&&s!==k.optional)throw new Error(`[invokeFunction] unknown service '${f}'`);return c}},...C)}finally{b=!0,P.stop()}}createInstance(h,...C){let P,b;return h instanceof D.SyncDescriptor?(P=v.traceCreation(h.ctor),b=this._createInstance(h.ctor,h.staticArguments.concat(C),P)):(P=v.traceCreation(h),b=this._createInstance(h,C,P)),P.stop(),b}_createInstance(h,C=[],P){let b=k._util.getServiceDependencies(h).sort((s,c)=>s.index-c.index),I=[];for(const s of b){let c=this._getOrCreateServiceInstance(s.id,P);if(!c&&this._strict&&!s.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${s.id}.`);I.push(c)}let f=b.length>0?b[0].index:C.length;if(C.length!==f){console.warn(`[createInstance] First service dependency of ${h.name} at position ${f+1} conflicts with ${C.length} static arguments`);let s=f-C.length;s>0?C=C.concat(new Array(s)):C=C.slice(0,f)}return new h(...[...C,...I])}_setServiceInstance(h,C){if(this._services.get(h)instanceof D.SyncDescriptor)this._services.set(h,C);else if(this._parent)this._parent._setServiceInstance(h,C);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let C=this._services.get(h);return!C&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):C}_getOrCreateServiceInstance(h,C){let P=this._getServiceInstanceOrDescriptor(h);return P instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,P,C.branch(h,!0)):(C.branch(h,!1),P)}_safeCreateAndCacheServiceInstance(h,C,P){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,C,P)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,C,P){const b=new L.Graph(s=>s.id.toString());let I=0;const f=[{id:h,desc:C,_trace:P}];for(;f.length;){const s=f.pop();if(b.lookupOrInsertNode(s),I++>1e3)throw new w(b);for(let c of k._util.getServiceDependencies(s.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(c.id);if(!t&&!c.optional&&console.warn(`[createInstance] ${h} depends on ${c.id} which is NOT registered.`),t instanceof D.SyncDescriptor){const r={id:c.id,desc:t,_trace:s._trace.branch(c.id,!0)};b.insertEdge(s,r),f.push(r)}}}for(;;){const s=b.roots();if(s.length===0){if(!b.isEmpty())throw new w(b);break}for(const{data:c}of s){if(this._getServiceInstanceOrDescriptor(c.id)instanceof D.SyncDescriptor){const r=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,r)}b.removeNode(c)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,C,P=[],b,I){if(this._services.get(h)instanceof D.SyncDescriptor)return this._createServiceInstance(C,P,b,I);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,C,P,b,I);throw new Error(`illegalState - creating UNKNOWN service instance ${C.name}`)}_createServiceInstance(h,C=[],P,b){if(P){const I=new R.IdleValue(()=>this._createInstance(h,C,b));return new Proxy(Object.create(null),{get(f,s){if(s in f)return f[s];let c=I.value,t=c[s];return typeof t!="function"||(t=t.bind(c),f[s]=t),t},set(f,s,c){return I.value[s]=c,!0}})}else return this._createInstance(h,C,b)}}e.InstantiationService=n;var y;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(y||(y={}));class v{constructor(h,C){this.type=h,this.name=C,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return S?new v(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):v._None}static traceCreation(h){return S?new v(0,h.name):v._None}branch(h,C){let P=new v(2,h.toString());return this._dep.push([h,C,P]),P}stop(){let h=Date.now()-this._start;v._totals+=h;let C=!1;function P(I,f){let s=[],c=new Array(I+1).join("	");for(const[t,r,i]of f._dep)if(r&&i){C=!0,s.push(`${c}CREATES -> ${t}`);let o=P(I+1,i);o&&s.push(o)}else s.push(`${c}uses -> ${t}`);return s.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${P(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${v._totals.toFixed(2)}ms)`];(h>2||C)&&console.log(b.join(`
`))}}v._None=new class extends v{constructor(){super(-1,null)}stop(){}branch(){return this}},v._totals=0}),define(X[151],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class p{constructor(D,k){this.server=D,this.router=k}getChannel(D){return this.server.getChannel(D,this.router)}registerChannel(D,k){this.server.registerChannel(D,k)}}e.MessagePortMainProcessService=p}),define(X[152],Q([0,1,36,51,141,5]),function(G,e,p,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(m,h,C){const P=C.getChannel(m);return R(h)?new h.channelClientCtor(P):p.ProxyChannel.toService(P,h?.proxyOptions)}}function R(v){return!!v?.channelClientCtor}e.IMainProcessService=(0,k.createDecorator)("mainProcessService");let S=class extends A{constructor(m,h,C){super(m,h,C)}};S=fe([K(2,e.IMainProcessService)],S);function w(v,m,h){(0,D.registerSingleton)(v,new L.SyncDescriptor(S,[m,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=w,e.ISharedProcessService=(0,k.createDecorator)("sharedProcessService");let n=class extends A{constructor(m,h,C){super(m,h,C)}};n=fe([K(2,e.ISharedProcessService)],n);function y(v,m,h){(0,D.registerSingleton)(v,new L.SyncDescriptor(n,[m,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=y}),define(X[56],Q([0,1,5]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,p.createDecorator)("localizationsService");function L(D){if(typeof D.languageId!="string"||!Array.isArray(D.translations)||D.translations.length===0)return!1;for(const k of D.translations)if(typeof k.id!="string"||typeof k.path!="string")return!1;return!(D.languageName&&typeof D.languageName!="string"||D.localizedLanguageName&&typeof D.localizedLanguageName!="string")}e.isValidLocalization=L}),define(X[153],Q([0,1,2,56]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let D=class extends p.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};D=fe([K(0,L.ILocalizationsService)],D),e.LocalizationsUpdater=D}),define(X[14],Q([0,1,5,2,7,3,43]),function(G,e,p,L,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,p.createDecorator)("logService"),e.ILoggerService=(0,p.createDecorator)("loggerService");function R(){return new Date().toISOString()}var S;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class w extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new k.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class n extends w{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(S.Error))if(t instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=t.stack,this.log(S.Error,this.format(i))}else this.log(S.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let i=0;i<t.length;i++){let o=t[i];if(typeof o=="object")try{o=JSON.stringify(o)}catch(u){}r+=(i>0?" ":"")+o}return r}}e.AbstractMessageLogger=n;class y extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!D.isWindows}trace(t,...r){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,t,...r):console.log(`[main ${R()}]`,t,...r))}debug(t,...r){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,t,...r):console.log(`[main ${R()}]`,t,...r))}info(t,...r){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,t,...r):console.log(`[main ${R()}]`,t,...r))}warn(t,...r){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,t,...r):console.warn(`[main ${R()}]`,t,...r))}error(t,...r){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,t,...r):console.error(`[main ${R()}]`,t,...r))}critical(t,...r){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,t,...r):console.error(`[main ${R()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class v extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=v;class m extends w{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,A.toErrorMessage)(t,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class h extends w{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const i of this.logServices)i.trace(t,...r)}debug(t,...r){for(const i of this.logServices)i.debug(t,...r)}info(t,...r){for(const i of this.logServices)i.info(t,...r)}warn(t,...r){for(const i of this.logServices)i.warn(t,...r)}error(t,...r){for(const i of this.logServices)i.error(t,...r)}critical(t,...r){for(const i of this.logServices)i.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=h;class C extends L.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=C;class P extends L.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(i))}))}createLogger(t,r){let i=this.loggers.get(t.toString());return i||(i=this.doCreateLogger(t,r?.always?S.Trace:this.logLevel,r),this.loggers.set(t.toString(),i),r?.always||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=P;class b{constructor(){this.onDidChangeLogLevel=new k.Emitter().event}setLevel(t){}getLevel(){return S.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=b;function I(c){if(c.verbose)return S.Trace;if(typeof c.logLevel=="string"){const t=f(c.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=I;function f(c){switch(c){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=f;function s(c){switch(c){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=s}),define(X[154],Q([0,1,12,8,18,9,2,6,14]),function(G,e,p,L,D,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let w=class extends A.Disposable{constructor(y,v){super();this.environmentService=y,this.logService=v,this._register(new R.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.info("[logs cleanup]: Starting to clean up old logs.");try{const y=(0,L.basename)(this.environmentService.logsPath),v=(0,L.dirname)(this.environmentService.logsPath),C=(await D.Promises.readdir(v)).filter(b=>/^\d{8}T\d{6}$/.test(b)).sort().filter(b=>b!==y),P=C.slice(0,Math.max(0,C.length-9));P.length>0&&(this.logService.info(`[logs cleanup]: Removing log folders '${P.join(", ")}'`),await Promise.all(P.map(b=>D.Promises.rm((0,L.join)(v,b)))))}catch(y){(0,k.onUnexpectedError)(y)}}};w=fe([K(0,p.IEnvironmentService),K(1,S.ILogService)],w),e.LogsDataCleaner=w}),define(X[155],Q([0,1,12,8,18,9,2,6,14]),function(G,e,p,L,D,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let w=class lt extends A.Disposable{constructor(y,v,m){super();this.backupWorkspacesPath=y,this.environmentService=v,this.logService=m,this._register(new R.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.info("[storage cleanup]: Starting to clean up storage folders.");try{const y=await D.Promises.readFile(this.backupWorkspacesPath,"utf8"),m=JSON.parse(y).emptyWorkspaceInfos.map(C=>C.backupFolder),h=await D.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async C=>{C.length!==lt.NON_EMPTY_WORKSPACE_ID_LENGTH&&m.indexOf(C)===-1&&(this.logService.info(`[storage cleanup]: Deleting storage folder ${C}.`),await D.Promises.rm((0,L.join)(this.environmentService.workspaceStorageHome.fsPath,C)))}))}catch(y){(0,k.onUnexpectedError)(y)}}};w.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,w=fe([K(1,p.INativeEnvironmentService),K(2,S.ILogService)],w),e.StorageDataCleaner=w}),define(X[156],Q([0,1,18,2,13,27,12,4,15,31,14,30,57,7,6,9]),function(G,e,p,L,D,k,A,R,S,w,n,y,v,m,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let b=class extends L.Disposable{constructor(f,s,c,t){super();this.fileService=s,this.extensionGalleryService=c,this.logService=t,this.extensionsDownloadDir=R.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,s){await this.cleanUpPromise;const c=this.getName(f),t=(0,S.joinPath)(this.extensionsDownloadDir,c);if(!await this.fileService.exists(t)){const r=(0,S.joinPath)(this.extensionsDownloadDir,`.${(0,y.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(f,r,s);try{await this.rename(r,t,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(r)}catch(o){}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,C.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,r.path),i}}return t}async delete(f){}async rename(f,s,c){try{await p.Promises.rename(f.fsPath,s.fsPath)}catch(t){if(m.isWindows&&t&&t.code==="EPERM"&&Date.now()<c)return this.logService.info(`Failed renaming ${f} to ${s} with 'EPERM' error. Trying again...`),this.rename(f,s,c);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const s=[],c=[];for(const i of f.children){const o=this.parse(i.name);o&&c.push([o,i])}const t=(0,w.groupByExtension)(c,([i])=>i),r=[];for(const i of t)i.sort((o,u)=>v.rcompare(o[0].version,u[0].version)),s.push(...i.slice(1).map(o=>o[1].resource)),r.push(i[0][1]);r.sort((i,o)=>i.mtime-o.mtime),s.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(i=>i.resource)),await h.Promises.settled(s.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?new w.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase():(0,y.generateUuid)()}parse(f){const s=P.exec(f);return s&&s[1]&&s[2]?new w.ExtensionIdentifierWithVersion({id:s[1]},s[2]):null}};b=fe([K(0,A.INativeEnvironmentService),K(1,D.IFileService),K(2,k.IExtensionGalleryService),K(3,n.ILogService)],b),e.ExtensionsDownloader=b}),define(X[157],Q([0,1,2,14,42,43,8,6,3,17,18,12]),function(G,e,p,L,D,k,A,R,S,w,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let v=class extends p.Disposable{constructor(h,C){super();this.environmentService=h,this.logService=C,this.processesLimiter=new R.Limiter(5)}async postUninstall(h){const C=this.parseScript(h,"uninstall");return C&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(C.script,"uninstall",C.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),P=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${P}`)))),n.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,P=>this.logService.error("Error while removing extension storage path",P))}parseScript(h,C){const P=`vscode:${C}`;if(h.location.scheme===w.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[P]=="string"){const b=h.manifest.scripts[P].split(" ");return b.length<2||b[0]!=="node"||!b[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${P} should be a node script`),null):{script:(0,A.join)(h.location.fsPath,b[1]),args:b.slice(2)||[]}}return null}runLifecycleHook(h,C,P,b,I){return new Promise((f,s)=>{const c=this.start(h,C,P,I);let t;const r=i=>{t&&(clearTimeout(t),t=null),i?s(i):f(void 0)};c.on("error",i=>{r((0,k.toErrorMessage)(i)||"Unknown")}),c.on("exit",(i,o)=>{r(i?`post-${C} process exited with code ${i}`:void 0)}),b&&(t=setTimeout(()=>{t=null,c.kill(),s("timed out")},5e3))})}start(h,C,P,b){const I={silent:!0,execArgv:void 0},f=(0,D.fork)(h,[`--type=extension-post-${C}`,...P],I);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const s=S.Event.fromNodeEventEmitter(f.stdout,"data"),c=S.Event.fromNodeEventEmitter(f.stderr,"data");s(i=>this.logService.info(b.identifier.id,b.manifest.version,`post-${C}`,i)),c(i=>this.logService.error(b.identifier.id,b.manifest.version,`post-${C}`,i));const t=S.Event.any(S.Event.map(s,i=>({data:`%c${i}`,format:[""]})),S.Event.map(c,i=>({data:`%c${i}`,format:["color: red"]})));return S.Event.debounce(t,(i,o)=>i?{data:i.data+o.data,format:[...i.format,...o.format]}:{data:o.data,format:o.format},100)(i=>{console.group(b.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),f}getExtensionStoragePath(h){return(0,A.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};v=fe([K(0,y.IEnvironmentService),K(1,L.ILogService)],v),e.ExtensionsLifecycle=v}),define(X[158],Q([0,1,2,12,3,13,4,31,15,14]),function(G,e,p,L,D,k,A,R,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let n=class extends p.Disposable{constructor(v,m,h,C){super();this.extensionsManagementService=v,this.logService=C,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(I=>{this.installedExtensions=I.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(v.onInstallExtension(I=>this.onInstallExtension(I))),this._register(v.onDidInstallExtensions(I=>this.onDidInstallExtensions(I))),this._register(v.onDidUninstallExtension(I=>this.onDidUninstallExtension(I)));const P=A.URI.file(h.extensionsPath),b=new S.ExtUri(I=>!m.hasCapability(I,1024));this._register(m.watch(P)),this._register(D.Event.filter(m.onDidChangeFilesRaw,I=>I.changes.some(f=>this.doesChangeAffects(f,P,b)))(()=>this.onDidChange()))}doesChangeAffects(v,m,h){return h.isEqual(h.dirname(v.resource),m)?h.isEqual(v.resource,h.joinPath(m,".obsolete"))?!0:!(v.type!==1&&v.type!==2||h.basename(v.resource).startsWith(".")):!1}onInstallExtension(v){this.addInstallingExtension(v.identifier)}onDidInstallExtensions(v){for(const m of v)this.removeInstallingExtension(m.identifier),m.local&&this.addInstalledExtension(m.identifier)}onDidUninstallExtension(v){v.error||this.removeInstalledExtension(v.identifier)}addInstallingExtension(v){this.removeInstallingExtension(v),this.installingExtensions.push(v)}removeInstallingExtension(v){this.installingExtensions=this.installingExtensions.filter(m=>!(0,R.areSameExtensions)(m,v))}addInstalledExtension(v){this.installedExtensions&&(this.removeInstalledExtension(v),this.installedExtensions.push(v))}removeInstalledExtension(v){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(m=>!(0,R.areSameExtensions)(m,v)))}async onDidChange(){if(this.installedExtensions){const v=await this.extensionsManagementService.getInstalled(1),m=v.filter(C=>[...this.installingExtensions,...this.installedExtensions].some(P=>(0,R.areSameExtensions)(P,C.identifier))?!1:C.installedTimestamp&&C.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",C.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",C.identifier.id),!1)),h=this.installedExtensions.filter(C=>this.installingExtensions.some(P=>(0,R.areSameExtensions)(P,C))?!1:v.every(P=>!(0,R.areSameExtensions)(P.identifier,C))?(this.logService.info("Detected extension removed from another source",C.id),!0):!1);this.installedExtensions=v.map(C=>C.identifier),(m.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:m,removed:h})}}};n=fe([K(1,k.IFileService),K(2,L.INativeEnvironmentService),K(3,w.ILogService)],n),e.ExtensionsWatcher=n}),define(X[159],Q([0,1,18,148,27,2,12,6,31,14,56,23,17,8]),function(G,e,p,L,D,k,A,R,S,w,n,y,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let h=class extends k.Disposable{constructor(b,I,f){super();this.extensionManagementService=b,this.logService=f,this.cache=this._register(new C(I,f)),this.extensionManagementService.registerParticipant({postInstall:async s=>this.postInstallExtension(s),postUninstall:async s=>this.postUninstallExtension(s)})}async getLanguageIds(){const b=await this.cache.getLanguagePacks(),I=["en",...Object.keys(b)];return(0,y.distinct)(I)}async postInstallExtension(b){b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",b.identifier.id),await this.update())}async postUninstallExtension(b){const I=await this.cache.getLanguagePacks();Object.keys(I).some(f=>I[f]&&I[f].extensions.some(s=>(0,S.areSameExtensions)(s.extensionIdentifier,b.identifier)))&&(this.logService.info("Removing language packs from the extension",b.identifier.id),await this.update())}async update(){const[b,I]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(I);return!(0,y.equals)(Object.keys(b),Object.keys(f))}};h=fe([K(0,D.IExtensionManagementService),K(1,A.INativeEnvironmentService),K(2,w.ILogService)],h),e.LocalizationsService=h;let C=class extends k.Disposable{constructor(b,I){super();this.logService=I,this.languagePacks={},this.languagePacksFilePath=(0,m.join)(b.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(b){return this.withLanguagePacks(I=>{Object.keys(I).forEach(f=>delete I[f]),this.createLanguagePacksFromExtensions(I,...b)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(b,...I){for(const f of I)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(b,f);Object.keys(b).forEach(f=>this.updateHash(b[f]))}createLanguagePacksFromExtension(b,I){const f=I.identifier,s=I.manifest.contributes&&I.manifest.contributes.localizations?I.manifest.contributes.localizations:[];for(const c of s)if(I.location.scheme===v.Schemas.file&&(0,n.isValidLocalization)(c)){let t=b[c.languageId];t||(t={hash:"",extensions:[],translations:{}},b[c.languageId]=t);let r=t.extensions.filter(i=>(0,S.areSameExtensions)(i.extensionIdentifier,f))[0];r?r.version=I.manifest.version:t.extensions.push({extensionIdentifier:f,version:I.manifest.version});for(const i of c.translations)t.translations[i.id]=(0,m.join)(I.location.fsPath,i.path)}}updateHash(b){if(b){const I=(0,L.createHash)("md5");for(const f of b.extensions)I.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);b.hash=I.digest("hex")}}withLanguagePacks(b=()=>null){return this.languagePacksFileLimiter.queue(()=>{let I=null;return p.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch(s){return{}}}).then(f=>(I=b(f),f)).then(f=>{for(const c of Object.keys(f))f[c]||delete f[c];this.languagePacks=f,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),p.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>I,f=>this.logService.error(f))})}};C=fe([K(0,A.INativeEnvironmentService),K(1,w.ILogService)],C)}),define(X[77],Q([0,1,14,3,4]),function(G,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class k{constructor(v){this.service=v,this.onDidChangeLogLevel=L.Event.buffer(v.onDidChangeLogLevel,!0)}listen(v,m){switch(m){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${m}`)}async call(v,m,h){switch(m){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${m}`)}}e.LogLevelChannel=k;class A{constructor(v){this.channel=v}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(v){A.setLevel(this.channel,v)}static setLevel(v,m){return v.call("setLevel",m)}}e.LogLevelChannelClient=A;class R{constructor(v){this.loggerService=v,this.loggers=new Map}listen(v,m){throw new Error(`Event not found: ${m}`)}async call(v,m,h){switch(m){case"createLogger":this.createLogger(D.URI.revive(h[0]),h[1]);return;case"log":return this.log(D.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${m}`)}createLogger(v,m){this.loggers.set(v.toString(),this.loggerService.createLogger(v,m))}consoleLog(v,m){let h=console.log;switch(v){case p.LogLevel.Error:h=console.error;break;case p.LogLevel.Warning:h=console.warn;break;case p.LogLevel.Info:h=console.info;break}h.call(console,...m)}log(v,m){const h=this.loggers.get(v.toString());if(!h)throw new Error("Create the logger before logging");for(const[C,P]of m)switch(C){case p.LogLevel.Trace:h.trace(P);break;case p.LogLevel.Debug:h.debug(P);break;case p.LogLevel.Info:h.info(P);break;case p.LogLevel.Warning:h.warn(P);break;case p.LogLevel.Error:h.error(P);break;case p.LogLevel.Critical:h.critical(P);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=R;class S extends p.AbstractLoggerService{constructor(v,m,h){super(v,m);this.channel=h}createConsoleMainLogger(){return new p.AdapterLogger({log:(v,m)=>{this.channel.call("consoleLog",[v,m])}})}doCreateLogger(v,m,h){return new w(this.channel,v,m,h)}}e.LoggerChannelClient=S;class w extends p.AbstractMessageLogger{constructor(v,m,h,C){super(C?.always);this.channel=v,this.file=m,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[m,C]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(v,m){const h=[[v,m]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(v){this.channel.call("log",[this.file,v])}}class n extends p.LogService{constructor(v,m){super(m);this.parent=v,this._register(v.onDidChangeLogLevel(h=>m.setLevel(h)))}setLevel(v){super.setLevel(v),this.parent.setLevel(v)}}e.FollowerLogService=n}),define(X[58],Q([0,1,5]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,p.createDecorator)("nativeHostService")}),define(X[44],Q([0,1,17,7,34,15]),function(G,e,p,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const R=L.globals.vscode.context.configuration();if(R)A=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof G?.__$__nodeRequire=="function"){const R=(0,k.dirname)(p.FileAccess.asFileUri("",G));A=G.__$__nodeRequire((0,k.joinPath)(R,"product.json").fsPath);const S=G.__$__nodeRequire((0,k.joinPath)(R,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:S.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.59.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A}),define(X[78],Q([0,1,119,25,13,9,44]),function(G,e,p,L,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function R(y,v,m,h,C,P){let b;try{await S(y,v,m,h,C,P)}catch(I){b=I}finally{b&&C.errorTransformer&&(b=C.errorTransformer(b)),typeof b!="undefined"&&m.error(b),m.end()}}e.readFileIntoStream=R;async function S(y,v,m,h,C,P){w(P);const b=await y.open(v,{create:!1});try{w(P);let I=0,f=0,s=C&&typeof C.length=="number"?C.length:void 0,c=L.VSBuffer.alloc(Math.min(C.bufferSize,typeof s=="number"?s:C.bufferSize)),t=C&&typeof C.position=="number"?C.position:0,r=0;do f=await y.read(b,t,c.buffer,r,c.byteLength-r),t+=f,r+=f,I+=f,typeof s=="number"&&(s-=f),r===c.byteLength&&(await m.write(h(c)),c=L.VSBuffer.alloc(Math.min(C.bufferSize,typeof s=="number"?s:C.bufferSize)),r=0);while(f>0&&(typeof s!="number"||s>0)&&w(P)&&n(I,C));if(r>0){let i=r;typeof s=="number"&&(i=Math.min(r,s)),m.write(h(c.slice(0,i)))}}catch(I){throw(0,D.ensureFileSystemProviderError)(I)}finally{await y.close(b)}}function w(y){if(y.isCancellationRequested)throw(0,k.canceled)();return!0}function n(y,v){if(v?.limits){if(typeof v.limits.memory=="number"&&y>v.limits.memory)throw(0,D.createFileSystemProviderError)((0,p.localize)(0,null,A.default.nameShort),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof v.limits.size=="number"&&y>v.limits.size)throw(0,D.createFileSystemProviderError)((0,p.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(X[160],Q([0,1,117,161,2,13,3,15,38,23,14,25,48,6,29,17,78,53]),function(G,e,p,L,D,k,A,R,S,w,n,y,v,m,h,C,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let I=class ze extends D.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new A.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new m.ThrottledWorker(ze.FILE_EVENTS_THROTTLING.maxChangesChunkSize,ze.FILE_EVENTS_THROTTLING.maxChangesBufferSize,ze.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new k.FileChangesEvent(c,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new m.ThrottledWorker(ze.FILE_EVENTS_THROTTLING.maxChangesChunkSize,ze.FILE_EVENTS_THROTTLING.maxChangesBufferSize,ze.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new k.FileChangesEvent(c,!0)))),this.watchedResources=S.TernarySearchTree.forUris(c=>{const t=this.getProvider(c.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new m.ResourceQueue)}registerProvider(s,c){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,L.mark)(`code/registerFilesystem/${s}`),this.provider.set(s,c),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:c});const t=new D.DisposableStore;return t.add(c.onDidChangeFile(r=>this.onDidChangeFile(r,this.isPathCaseSensitive(c)))),t.add(c.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:c,scheme:s}))),typeof c.onDidErrorOccur=="function"&&t.add(c.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),(0,D.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:c}),this.provider.delete(s),(0,D.dispose)(t)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const c=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(t){c.push(t)}}),!this.provider.has(s)&&await m.Promises.settled(c)}canHandleResource(s){return this.provider.has(s.scheme)}hasCapability(s,c){const t=this.provider.get(s.scheme);return!!(t&&t.capabilities&c)}listCapabilities(){return b.Iterable.map(this.provider,([s,c])=>({scheme:s,capabilities:c.capabilities}))}async withProvider(s){if(!(0,R.isAbsolutePath)(s))throw new k.FileOperationError((0,p.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const c=this.provider.get(s.scheme);if(!c){const t=new Error;throw t.name="ENOPRO",t.message=(0,p.localize)(1,null,s.toString()),t}return c}async withReadProvider(s){const c=await this.withProvider(s);if((0,k.hasOpenReadWriteCloseCapability)(c)||(0,k.hasReadWriteCapability)(c)||(0,k.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const c=await this.withProvider(s);if((0,k.hasOpenReadWriteCloseCapability)(c)||(0,k.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,c){try{return await this.doResolveFile(s,c)}catch(t){throw(0,k.toFileSystemProviderErrorCode)(t)===k.FileSystemProviderErrorCode.FileNotFound?new k.FileOperationError((0,p.localize)(2,null,this.resourceForError(s)),1):(0,k.ensureFileSystemProviderError)(t)}}async doResolveFile(s,c){const t=await this.withProvider(s),r=this.isPathCaseSensitive(t),i=c?.resolveTo,o=c?.resolveSingleChildDescendants,u=c?.resolveMetadata,a=await t.stat(s);let l;return this.toFileStat(t,s,a,void 0,!!u,(g,E)=>(l||(l=S.TernarySearchTree.forUris(()=>!r),l.set(s,!0),(0,w.isNonEmptyArray)(i)&&i.forEach(d=>l.set(d,!0))),Boolean(l.findSuperstr(g.resource)||l.get(g.resource))?!0:g.isDirectory&&o?E===1:!1))}async toFileStat(s,c,t,r,i,o){const{providerExtUri:u}=this.getExtUri(s),a={resource:c,name:u.basename(c),isFile:(t.type&k.FileType.File)!=0,isDirectory:(t.type&k.FileType.Directory)!=0,isSymbolicLink:(t.type&k.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&k.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,k.etag)({mtime:t.mtime,size:t.size})};if(a.isDirectory&&o(a,r)){try{const l=await s.readdir(c),g=await m.Promises.settled(l.map(async([E,d])=>{try{const T=u.joinPath(c,E),O=i?await s.stat(T):{type:d};return await this.toFileStat(s,T,O,l.length,i,o)}catch(T){return this.logService.trace(T),null}}));a.children=(0,w.coalesce)(g)}catch(l){this.logService.trace(l),a.children=[]}return a}return a}async resolveAll(s){return m.Promises.settled(s.map(async c=>{try{return{stat:await this.doResolveFile(c.resource,c.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(s){const c=await this.withProvider(s);try{return!!await c.stat(s)}catch(t){return!1}}async canCreateFile(s,c){try{await this.doValidateCreateFile(s,c)}catch(t){return t}return!0}async doValidateCreateFile(s,c){if(!c?.overwrite&&await this.exists(s))throw new k.FileOperationError((0,p.localize)(3,null,this.resourceForError(s)),3,c)}async createFile(s,c=y.VSBuffer.fromString(""),t){await this.doValidateCreateFile(s,t);const r=await this.writeFile(s,c);return this._onDidRunOperation.fire(new k.FileOperationEvent(s,0,r)),r}async writeFile(s,c,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:i}=this.getExtUri(r);try{await this.validateWriteFile(r,s,t)||await this.mkdirp(r,i.dirname(s));let u;if((0,k.hasReadWriteCapability)(r)&&!(c instanceof y.VSBuffer))if((0,v.isReadableStream)(c)){const a=await(0,v.peekStream)(c,3);a.ended?u=y.VSBuffer.concat(a.buffer):u=a}else u=(0,v.peekReadable)(c,a=>y.VSBuffer.concat(a),3);else u=c;!(0,k.hasOpenReadWriteCloseCapability)(r)||(0,k.hasReadWriteCapability)(r)&&u instanceof y.VSBuffer?await this.doWriteUnbuffered(r,s,t,u):await this.doWriteBuffered(r,s,t,u instanceof y.VSBuffer?(0,y.bufferToReadable)(u):u)}catch(o){throw new k.FileOperationError((0,p.localize)(4,null,this.resourceForError(s),(0,k.ensureFileSystemProviderError)(o).toString()),(0,k.toFileOperationResult)(o),t)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,c,t){if(!!t?.unlock&&!(s.capabilities&8192))throw new Error((0,p.localize)(5,null,this.resourceForError(c)));let i;try{i=await s.stat(c)}catch(o){return}if((i.type&k.FileType.Directory)!=0)throw new k.FileOperationError((0,p.localize)(6,null,this.resourceForError(c)),0,t);if(this.throwIfFileIsReadonly(c,i),t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==k.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&t.mtime<i.mtime&&t.etag!==(0,k.etag)({mtime:t.mtime,size:i.size}))throw new k.FileOperationError((0,p.localize)(7,null),3,t);return i}async readFile(s,c){const t=await this.withReadProvider(s);return c?.atomic?this.doReadFileAtomic(t,s,c):this.doReadFile(t,s,c)}async doReadFileAtomic(s,c,t){return new Promise((r,i)=>{this.writeQueue.queueFor(c,this.getExtUri(s).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(s,c,t);r(o)}catch(o){i(o)}})})}async doReadFile(s,c,t){const r=await this.doReadFileStream(s,c,{...t,preferUnbuffered:!0});return{...r,value:await(0,y.streamToBuffer)(r.value)}}async readFileStream(s,c){const t=await this.withReadProvider(s);return this.doReadFileStream(t,s,c)}async doReadFileStream(s,c,t){const r=new h.CancellationTokenSource,i=this.validateReadFile(c,t).then(u=>u,u=>{throw r.cancel(),u});let o;try{return t&&typeof t.etag=="string"&&t.etag!==k.ETAG_DISABLED&&await i,!((0,k.hasOpenReadWriteCloseCapability)(s)||(0,k.hasFileReadStreamCapability)(s))||(0,k.hasReadWriteCapability)(s)&&t?.preferUnbuffered?o=this.readFileUnbuffered(s,c,t):(0,k.hasFileReadStreamCapability)(s)?o=this.readFileStreamed(s,c,r.token,t):o=this.readFileBuffered(s,c,r.token,t),{...await i,value:o}}catch(u){o&&await(0,v.consumeStream)(o);const a=(0,p.localize)(8,null,this.resourceForError(c),(0,k.ensureFileSystemProviderError)(u).toString());throw u instanceof k.NotModifiedSinceFileOperationError?new k.NotModifiedSinceFileOperationError(a,u.stat,t):new k.FileOperationError(a,(0,k.toFileOperationResult)(u),t)}}readFileStreamed(s,c,t,r=Object.create(null)){const i=s.readFileStream(c,r,t);return(0,v.transform)(i,{data:o=>o instanceof y.VSBuffer?o:y.VSBuffer.wrap(o),error:o=>new k.FileOperationError((0,p.localize)(9,null,this.resourceForError(c),(0,k.ensureFileSystemProviderError)(o).toString()),(0,k.toFileOperationResult)(o),r)},o=>y.VSBuffer.concat(o))}readFileBuffered(s,c,t,r=Object.create(null)){const i=(0,y.newWriteableBufferStream)();return(0,P.readFileIntoStream)(s,c,i,o=>o,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new k.FileOperationError((0,p.localize)(10,null,this.resourceForError(c),(0,k.ensureFileSystemProviderError)(o).toString()),(0,k.toFileOperationResult)(o),r)},t),i}readFileUnbuffered(s,c,t){const r=(0,v.newWriteableStream)(i=>y.VSBuffer.concat(i));return(async()=>{try{let i=await s.readFile(c);t&&typeof t.position=="number"&&(i=i.slice(t.position)),t&&typeof t.length=="number"&&(i=i.slice(0,t.length)),this.validateReadFileLimits(c,i.byteLength,t),r.end(y.VSBuffer.wrap(i))}catch(i){r.error(i),r.end()}})(),r}async validateReadFile(s,c){const t=await this.resolve(s,{resolveMetadata:!0});if(t.isDirectory)throw new k.FileOperationError((0,p.localize)(11,null,this.resourceForError(s)),0,c);if(c&&typeof c.etag=="string"&&c.etag!==k.ETAG_DISABLED&&c.etag===t.etag)throw new k.NotModifiedSinceFileOperationError((0,p.localize)(12,null),t,c);return this.validateReadFileLimits(s,t.size,c),t}validateReadFileLimits(s,c,t){if(t?.limits){let r;if(typeof t.limits.memory=="number"&&c>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&c>t.limits.size&&(r=7),typeof r=="number")throw new k.FileOperationError((0,p.localize)(13,null,this.resourceForError(s)),r)}}async canMove(s,c,t){return this.doCanMoveCopy(s,c,"move",t)}async canCopy(s,c,t){return this.doCanMoveCopy(s,c,"copy",t)}async doCanMoveCopy(s,c,t,r){if(s.toString()!==c.toString())try{const i=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c);await this.doValidateMoveCopy(i,s,o,c,t,r)}catch(i){return i}return!0}async move(s,c,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),o=await this.doMoveCopy(r,s,i,c,"move",!!t),u=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new k.FileOperationEvent(s,o==="move"?2:3,u)),u}async copy(s,c,t){const r=await this.withReadProvider(s),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),o=await this.doMoveCopy(r,s,i,c,"copy",!!t),u=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new k.FileOperationEvent(s,o==="copy"?3:2,u)),u}async doMoveCopy(s,c,t,r,i,o){if(c.toString()===r.toString())return i;const{exists:u,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(s,c,t,r,i,o);if(u&&!a&&o&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),i==="copy"){if(s===t&&(0,k.hasFileFolderCopyCapability)(s))await s.copy(c,r,{overwrite:o});else{const l=await this.resolve(c);l.isDirectory?await this.doCopyFolder(s,l,t,r):await this.doCopyFile(s,c,t,r)}return i}else return s===t?(await s.rename(c,r,{overwrite:o}),i):(await this.doMoveCopy(s,c,t,r,"copy",o),await this.del(c,{recursive:!0}),"copy")}async doCopyFile(s,c,t,r){if((0,k.hasOpenReadWriteCloseCapability)(s)&&(0,k.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(s,c,t,r);if((0,k.hasOpenReadWriteCloseCapability)(s)&&(0,k.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(s,c,t,r);if((0,k.hasReadWriteCapability)(s)&&(0,k.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(s,c,t,r);if((0,k.hasReadWriteCapability)(s)&&(0,k.hasReadWriteCapability)(t))return this.doPipeUnbuffered(s,c,t,r)}async doCopyFolder(s,c,t,r){await t.mkdir(r),Array.isArray(c.children)&&await m.Promises.settled(c.children.map(async i=>{const o=this.getExtUri(t).providerExtUri.joinPath(r,i.name);return i.isDirectory?this.doCopyFolder(s,await this.resolve(i.resource),t,o):this.doCopyFile(s,i.resource,t,o)}))}async doValidateMoveCopy(s,c,t,r,i,o){let u=!1;if(s===t){const{providerExtUri:l,isPathCaseSensitive:g}=this.getExtUri(s);if(g||(u=l.isEqual(c,r)),u&&i==="copy")throw new Error((0,p.localize)(14,null,this.resourceForError(c),this.resourceForError(r)));if(!u&&l.isEqualOrParent(r,c))throw new Error((0,p.localize)(15,null,this.resourceForError(c),this.resourceForError(r)))}const a=await this.exists(r);if(a&&!u){if(!o)throw new k.FileOperationError((0,p.localize)(16,null,this.resourceForError(c),this.resourceForError(r)),4);if(s===t){const{providerExtUri:l}=this.getExtUri(s);if(l.isEqualOrParent(c,r))throw new Error((0,p.localize)(17,null,this.resourceForError(c),this.resourceForError(r)))}}return{exists:a,isSameResourceWithDifferentPathCase:u}}getExtUri(s){const c=this.isPathCaseSensitive(s);return{providerExtUri:c?R.extUri:R.extUriIgnorePathCase,isPathCaseSensitive:c}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(c,s);const t=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new k.FileOperationEvent(s,0,t)),t}async mkdirp(s,c){const t=[],{providerExtUri:r}=this.getExtUri(s);for(;!r.isEqual(c,r.dirname(c));)try{if(((await s.stat(c)).type&k.FileType.Directory)==0)throw new Error((0,p.localize)(18,null,this.resourceForError(c)));break}catch(i){if((0,k.toFileSystemProviderErrorCode)(i)!==k.FileSystemProviderErrorCode.FileNotFound)throw i;t.push(r.basename(c)),c=r.dirname(c)}for(let i=t.length-1;i>=0;i--){c=r.joinPath(c,t[i]);try{await s.mkdir(c)}catch(o){if((0,k.toFileSystemProviderErrorCode)(o)!==k.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,c){try{await this.doValidateDelete(s,c)}catch(t){return t}return!0}async doValidateDelete(s,c){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!c?.useTrash&&!(t.capabilities&4096))throw new Error((0,p.localize)(19,null,this.resourceForError(s)));let i;try{i=await t.stat(s)}catch(u){}if(i)this.throwIfFileIsReadonly(s,i);else throw new k.FileOperationError((0,p.localize)(20,null,this.resourceForError(s)),1);if(!!!c?.recursive){const u=await this.resolve(s);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error((0,p.localize)(21,null,this.resourceForError(s)))}return t}async del(s,c){const t=await this.doValidateDelete(s,c),r=!!c?.useTrash,i=!!c?.recursive;await t.delete(s,{recursive:i,useTrash:r}),this._onDidRunOperation.fire(new k.FileOperationEvent(s,1))}onDidChangeFile(s,c){this._onDidChangeFilesRaw.fire({changes:s});let t,r;{for(const i of s)this.watchedResources.has(i.resource)?(t||(t=[]),t.push(i)):(r||(r=[]),r.push(i));t&&this._onDidFilesChange.fire(new k.FileChangesEvent(t,!c))}if(r){const i=c?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(r)&&ze.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(s,c={recursive:!1,excludes:[]}){const t=new D.DisposableStore;{let r=!1,i=()=>{r=!0};t.add((0,D.toDisposable)(()=>i())),this.doWatch(s,c).then(o=>{r?(0,D.dispose)(o):i=()=>(0,D.dispose)(o)},o=>this.logService.error(o))}return c.recursive||(this.watchedResources.set(s,(this.watchedResources.get(s)??0)+1),t.add((0,D.toDisposable)(()=>{const r=this.watchedResources.get(s);typeof r=="number"&&(r<=1?this.watchedResources.delete(s):this.watchedResources.set(s,r-1))}))),t}async doWatch(s,c){const t=await this.withProvider(s),r=this.toWatchKey(t,s,c),i=this.activeWatchers.get(r)||{count:0,disposable:t.watch(s,c)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,i),i.count+=1,(0,D.toDisposable)(()=>{i.count--,i.count===0&&((0,D.dispose)(i.disposable),this.activeWatchers.delete(r))})}toWatchKey(s,c,t){const{providerExtUri:r}=this.getExtUri(s);return[r.getComparisonKey(c),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(s=>(0,D.dispose)(s.disposable)),this.activeWatchers.clear()}async doWriteBuffered(s,c,t,r){return this.writeQueue.queueFor(c,this.getExtUri(s).providerExtUri).queue(async()=>{const i=await s.open(c,{create:!0,unlock:t?.unlock??!1});try{(0,v.isReadableStream)(r)||(0,v.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(s,i,r):await this.doWriteReadableBufferedQueued(s,i,r)}catch(o){throw(0,k.ensureFileSystemProviderError)(o)}finally{await s.close(i)}})}async doWriteStreamBufferedQueued(s,c,t){let r=0,i;if((0,v.isReadableBufferedStream)(t)){if(t.buffer.length>0){const o=y.VSBuffer.concat(t.buffer);await this.doWriteBuffer(s,c,o,o.byteLength,r,0),r+=o.byteLength}if(t.ended)return;i=t.stream}else i=t;return new Promise(async(o,u)=>{(0,v.listenStream)(i,{onData:async a=>{i.pause();try{await this.doWriteBuffer(s,c,a,a.byteLength,r,0)}catch(l){return u(l)}r+=a.byteLength,setTimeout(()=>i.resume())},onError:a=>u(a),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,c,t){let r=0,i;for(;(i=t.read())!==null;)await this.doWriteBuffer(s,c,i,i.byteLength,r,0),r+=i.byteLength}async doWriteBuffer(s,c,t,r,i,o){let u=0;for(;u<r;)u+=await s.write(c,i+u,t.buffer,o+u,r-u)}async doWriteUnbuffered(s,c,t,r){return this.writeQueue.queueFor(c,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,c,t,r))}async doWriteUnbufferedQueued(s,c,t,r){let i;r instanceof y.VSBuffer?i=r:(0,v.isReadableStream)(r)?i=await(0,y.streamToBuffer)(r):(0,v.isReadableBufferedStream)(r)?i=await(0,y.bufferedStreamToBuffer)(r):i=(0,y.readableToBuffer)(r),await s.writeFile(c,i.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(s,c,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,c,t,r))}async doPipeBufferedQueued(s,c,t,r){let i,o;try{i=await s.open(c,{create:!1}),o=await t.open(r,{create:!0,unlock:!1});const u=y.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,l=0,g=0;do g=await s.read(i,a,u.buffer,l,u.byteLength-l),await this.doWriteBuffer(t,o,u,g,a,l),a+=g,l+=g,l===u.byteLength&&(l=0);while(g>0)}catch(u){throw(0,k.ensureFileSystemProviderError)(u)}finally{await m.Promises.settled([typeof i=="number"?s.close(i):Promise.resolve(),typeof o=="number"?t.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,c,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,c,t,r))}async doPipeUnbufferedQueued(s,c,t,r){return t.writeFile(r,await s.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,c,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,c,t,r))}async doPipeUnbufferedToBufferedQueued(s,c,t,r){const i=await t.open(r,{create:!0,unlock:!1});try{const o=await s.readFile(c);await this.doWriteBuffer(t,i,y.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,k.ensureFileSystemProviderError)(o)}finally{await t.close(i)}}async doPipeBufferedToUnbuffered(s,c,t,r){const i=await(0,y.streamToBuffer)(this.readFileBuffered(s,c,h.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,i)}throwIfFileSystemIsReadonly(s,c){if(s.capabilities&2048)throw new k.FileOperationError((0,p.localize)(22,null,this.resourceForError(c)),6);return s}throwIfFileIsReadonly(s,c){if((c.permissions??0)&k.FilePermission.Readonly)throw new k.FileOperationError((0,p.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===C.Schemas.file?s.fsPath:s.toString(!0)}};I.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},I=fe([K(0,n.ILogService)],I),e.FileService=I}),define(X[162],Q([0,1,2,13,3,7,18,8,15,41,6,14,120,75,138,140,137,149,48,78,23,25]),function(G,e,p,L,D,k,A,R,S,w,n,y,v,m,h,C,P,b,I,f,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends p.Disposable{constructor(i,o){super();this.logService=i,this.options=o,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=D.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new D.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,k.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:o,symbolicLink:u}=await A.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(o,u),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.toFileSystemProviderError(o)}}async readdir(i){try{const o=await A.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),u=[];return await Promise.all(o.map(async a=>{try{let l;a.isSymbolicLink()?l=(await this.stat((0,S.joinPath)(i,a.name))).type:l=this.toType(a),u.push([a.name,l])}catch(l){this.logService.trace(l)}})),u}catch(o){throw this.toFileSystemProviderError(o)}}toType(i,o){let u;return o?.dangling?u=L.FileType.Unknown:i.isFile()?u=L.FileType.File:i.isDirectory()?u=L.FileType.Directory:u=L.FileType.Unknown,o&&(u|=L.FileType.SymbolicLink),u}async readFile(i){try{const o=this.toFilePath(i);return await A.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}}readFileStream(i,o,u){const a=(0,I.newWriteableStream)(l=>c.VSBuffer.concat(l.map(g=>c.VSBuffer.wrap(g))).buffer);return(0,f.readFileIntoStream)(this,i,a,l=>l.buffer,{...o,bufferSize:this.BUFFER_SIZE},u),a}async writeFile(i,o,u){let a;try{const l=this.toFilePath(i);if(!u.create||!u.overwrite){if(await A.Promises.exists(l)){if(!u.overwrite)throw(0,L.createFileSystemProviderError)((0,v.localize)(0,null),L.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw(0,L.createFileSystemProviderError)((0,v.localize)(1,null),L.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(i,{create:!0,unlock:u.unlock}),await this.write(a,0,o,0,o.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(i,l)}finally{typeof a=="number"&&await this.close(a)}}async open(i,o){try{const u=this.toFilePath(i);if((0,L.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:g}=await A.SymlinkSupport.stat(u);g.mode&128||await A.Promises.chmod(u,g.mode|128)}catch(g){this.logService.trace(g)}let a;if((0,L.isFileOpenForWriteOptions)(o)){if(k.isWindows)try{await A.Promises.truncate(u,0),a="r+"}catch(g){g.code!=="ENOENT"&&this.logService.trace(g)}a||(a="w")}else a="r";const l=await A.Promises.open(u,a);return this.mapHandleToPos.set(l,0),(0,L.isFileOpenForWriteOptions)(o)&&this.writeHandles.set(l,i),l}catch(u){throw(0,L.isFileOpenForWriteOptions)(o)?await this.toFileSystemProviderWriteError(i,u):this.toFileSystemProviderError(u)}}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await A.Promises.fdatasync(i)}catch(o){this.canFlush=!1,this.logService.error(o)}return await A.Promises.close(i)}catch(o){throw this.toFileSystemProviderError(o)}}async read(i,o,u,a,l){const g=this.normalizePos(i,o);let E=null;try{const d=await A.Promises.read(i,u,a,l,g);return typeof d=="number"?E=d:E=d.bytesRead,E}catch(d){throw this.toFileSystemProviderError(d)}finally{this.updatePos(i,g,E)}}normalizePos(i,o){return o===this.mapHandleToPos.get(i)?null:o}updatePos(i,o,u){const a=this.mapHandleToPos.get(i);typeof a=="number"&&(typeof o=="number"||(typeof u=="number"?this.mapHandleToPos.set(i,a+u):this.mapHandleToPos.delete(i)))}async write(i,o,u,a,l){return(0,n.retry)(()=>this.doWrite(i,o,u,a,l),100,3)}async doWrite(i,o,u,a,l){const g=this.normalizePos(i,o);let E=null;try{const d=await A.Promises.write(i,u,a,l,g);return typeof d=="number"?E=d:E=d.bytesWritten,E}catch(d){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),d)}finally{this.updatePos(i,g,E)}}async mkdir(i){try{await A.Promises.mkdir(this.toFilePath(i))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(i,o){try{const u=this.toFilePath(i);await this.doDelete(u,o)}catch(u){throw this.toFileSystemProviderError(u)}}async doDelete(i,o){o.recursive?await A.Promises.rm(i,A.RimRafMode.MOVE):await A.Promises.unlink(i)}async rename(i,o,u){const a=this.toFilePath(i),l=this.toFilePath(o);if(a!==l)try{await this.validateTargetDeleted(i,o,"move",u.overwrite),await A.Promises.move(a,l)}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,v.localize)(2,null,(0,R.basename)(a),(0,R.basename)((0,R.dirname)(l)),g.toString()))),this.toFileSystemProviderError(g)}}async copy(i,o,u){const a=this.toFilePath(i),l=this.toFilePath(o);if(a!==l)try{await this.validateTargetDeleted(i,o,"copy",u.overwrite),await A.Promises.copy(a,l,{preserveSymlinks:!0})}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,v.localize)(3,null,(0,R.basename)(a),(0,R.basename)((0,R.dirname)(l)),g.toString()))),this.toFileSystemProviderError(g)}}async validateTargetDeleted(i,o,u,a){const l=this.toFilePath(i),g=this.toFilePath(o);let E=!1;if(!!(this.capabilities&1024)||(E=(0,w.isEqual)(l,g,!0)),E&&u==="copy")throw(0,L.createFileSystemProviderError)((0,v.localize)(4,null),L.FileSystemProviderErrorCode.FileExists);if(!E&&await A.Promises.exists(g)){if(!a)throw(0,L.createFileSystemProviderError)((0,v.localize)(5,null),L.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}watch(i,o){return o.recursive?this.watchRecursive(i,o.excludes):this.watchNonRecursive(i)}watchRecursive(i,o){const u={path:this.toFilePath(i),excludes:o},a=(0,s.insert)(this.recursiveFoldersToWatch,u);return this.refreshRecursiveWatchers(),(0,p.toDisposable)(()=>{a(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof P.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,p.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let i,o;this.options?.watcher?.usePolling?(i=h.FileWatcher,o=this.options?.watcher):this.recursiveFoldersToWatch.length===1?k.isWindows?i=C.FileWatcher:i=h.FileWatcher:i=P.FileWatcher,this.recursiveWatcher=new i(this.recursiveFoldersToWatch,u=>this._onDidChangeFile.fire((0,m.toFileChanges)(u)),u=>{u.type==="error"&&this._onDidWatchErrorOccur.fire(u.message),this.logService[u.type](u.message)},this.logService.getLevel()===y.LogLevel.Trace,o),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)}))}}watchNonRecursive(i){const o=new b.FileWatcher(this.toFilePath(i),a=>this._onDidChangeFile.fire((0,m.toFileChanges)(a)),a=>{a.type==="error"&&this._onDidWatchErrorOccur.fire(a.message),this.logService[a.type](a.message)},this.logService.getLevel()===y.LogLevel.Trace),u=this.logService.onDidChangeLogLevel(()=>{o.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)});return(0,p.combinedDisposable)(o,u)}toFilePath(i){return(0,R.normalize)(i.fsPath)}toFileSystemProviderError(i){if(i instanceof L.FileSystemProviderError)return i;let o;switch(i.code){case"ENOENT":o=L.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=L.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=L.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=L.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=L.FileSystemProviderErrorCode.NoPermissions;break;default:o=L.FileSystemProviderErrorCode.Unknown}return(0,L.createFileSystemProviderError)(i,o)}async toFileSystemProviderWriteError(i,o){let u=this.toFileSystemProviderError(o);if(i&&u.code===L.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await A.SymlinkSupport.stat(this.toFilePath(i));a.mode&128||(u=(0,L.createFileSystemProviderError)(o,L.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return u}dispose(){super.dispose(),(0,p.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,p.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(X[28],Q([0,1,5]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,p.createDecorator)("productService")}),define(X[163],Q([0,1,8,9,2,18,28,6,14]),function(G,e,p,L,D,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let w=class extends D.Disposable{constructor(y,v,m){super();this.productService=v,this.logService=m,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,y&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpCodeCaches(y)},30*1e3)).schedule()}async cleanUpCodeCaches(y){this.logService.info("[code cache cleanup]: Starting to clean up old code cache folders.");try{const v=Date.now(),m=(0,p.dirname)(y),h=(0,p.basename)(y),C=await k.Promises.readdir(m);await Promise.all(C.map(async P=>{if(P===h)return;const b=(0,p.join)(m,P),I=await k.Promises.stat(b);if(I.isDirectory()&&v-I.mtime.getTime()>this._DataMaxAge)return this.logService.info(`[code cache cleanup]: Removing code cache folder ${P}.`),k.Promises.rm(b)}))}catch(v){(0,L.onUnexpectedError)(v)}}};w=fe([K(1,A.IProductService),K(2,S.ILogService)],w),e.CodeCacheCleaner=w}),define(X[164],Q([0,1,8,18,28,2,9,14,12,6]),function(G,e,p,L,D,k,A,R,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let n=class extends k.Disposable{constructor(v,m,h){super();this.environmentService=v,this.logService=m,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new w.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.info("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const v=Object.create(null),m=JSON.parse(await L.Promises.readFile((0,p.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let I of Object.keys(m)){const f=m[I];v[`${f.hash}.${I}`]=!0}const h=(0,p.join)(this.environmentService.userDataPath,"clp");if(!await L.Promises.exists(h))return;const P=await L.Promises.readdir(h);for(const I of P){if(v[I]){this.logService.info(`[language pack cache cleanup]: Skipping folder ${I}. Language pack still in use.`);continue}this.logService.info(`[language pack cache cleanup]: Removing unused language pack: ${I}`),await L.Promises.rm((0,p.join)(h,I))}const b=Date.now();for(const I of Object.keys(v)){const f=(0,p.join)(h,I),s=await L.Promises.readdir(f);for(const c of s){if(c==="tcf.json")continue;const t=(0,p.join)(f,c),r=await L.Promises.stat(t);r.isDirectory()&&b-r.mtime.getTime()>this._DataMaxAge&&(this.logService.info(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,p.join)(I,c)}`),await L.Promises.rm(t))}}}catch(v){(0,A.onUnexpectedError)(v)}}};n=fe([K(0,S.INativeEnvironmentService),K(1,R.ILogService),K(2,D.IProductService)],n),e.LanguagePackCachedDataCleaner=n}),define(X[32],Q([0,1,16,87]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(A,R){L.ok(p.isString(A)),L.ok(p.isObject(R)),L.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,R)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new D}),define(X[79],Q([0,1,32,3]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class k{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,w){this.schemasById[D(S)]=w,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new k;p.Registry.add(e.Extensions.JSONContribution,A)}),define(X[37],Q([0,1,109,3,32,16,79]),function(G,e,p,L,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var R;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(R=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var S;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const w=D.Registry.as(A.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:p.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(I,f=!0){this.registerConfigurations([I],f)}registerConfigurations(I,f=!0){const s=[];I.forEach(c=>{s.push(...this.validateAndRegisterProperties(c,f,c.extensionInfo)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterConfigurations(I){const f=[],s=c=>{if(c.properties)for(const t in c.properties)f.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,c.properties[t]);c.allOf&&c.allOf.forEach(t=>s(t))};for(const c of I){s(c);const t=this.configurationContributors.indexOf(c);t!==-1&&this.configurationContributors.splice(t,1)}w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}registerDefaultConfigurations(I){const f=[],s=[];for(const c of I)for(const t in c)if(f.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...c[t]};const r={type:"object",default:this.defaultValues[t],description:p.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};s.push(v(t)),this.configurationProperties[t]=r,this.defaultLanguageConfigurationOverridesNode.properties[t]=r}else{this.defaultValues[t]=c[t];const r=this.configurationProperties[t];r&&(this.updatePropertyDefaultValue(t,r),this.updateSchema(t,r))}this.registerOverrideIdentifiers(s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}deregisterDefaultConfigurations(I){const f=[];for(const s of I)for(const c in s)if(f.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const t=this.configurationProperties[c];t&&(this.updatePropertyDefaultValue(c,t),this.updateSchema(c,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}notifyConfigurationSchemaUpdated(...I){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(I){for(const f of I)this.overrideIdentifiers.add(f);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(I,f=!0,s,c=3){c=k.isUndefinedOrNull(I.scope)?c:I.scope;let t=[],r=I.properties;if(r)for(let o in r){if(f&&C(o)){delete r[o];continue}const u=r[o];if(this.updatePropertyDefaultValue(o,u),e.OVERRIDE_PROPERTY_PATTERN.test(o)?u.scope=void 0:(u.scope=k.isUndefinedOrNull(u.scope)?c:u.scope,u.restricted=k.isUndefinedOrNull(u.restricted)?!!s?.restrictedConfigurations?.includes(o):u.restricted),r[o].hasOwnProperty("included")&&!r[o].included){this.excludedConfigurationProperties[o]=r[o],delete r[o];continue}else this.configurationProperties[o]=r[o];!r[o].deprecationMessage&&r[o].markdownDeprecationMessage&&(r[o].deprecationMessage=r[o].markdownDeprecationMessage),t.push(o)}let i=I.allOf;if(i)for(let o of i)t.push(...this.validateAndRegisterProperties(o,f,s,c));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(I){const f=s=>{let c=s.properties;if(c)for(const r in c)this.updateSchema(r,c[r]);let t=s.allOf;t&&t.forEach(f)};f(I)}updateSchema(I,f){switch(e.allSettings.properties[I]=f,f.scope){case 1:e.applicationSettings.properties[I]=f;break;case 2:e.machineSettings.properties[I]=f;break;case 6:e.machineOverridableSettings.properties[I]=f;break;case 3:e.windowSettings.properties[I]=f;break;case 4:e.resourceSettings.properties[I]=f;break;case 5:e.resourceSettings.properties[I]=f,this.resourceLanguageSettingsSchema.properties[I]=f;break}}removeFromSchema(I,f){switch(delete e.allSettings.properties[I],f.scope){case 1:delete e.applicationSettings.properties[I];break;case 2:delete e.machineSettings.properties[I];break;case 6:delete e.machineOverridableSettings.properties[I];break;case 3:delete e.windowSettings.properties[I];break;case 4:case 5:delete e.resourceSettings.properties[I];break}}updateOverridePropertyPatternKey(){for(const I of this.overrideIdentifiers.values()){const f=`[${I}]`,s={type:"object",description:p.localize(2,null),errorMessage:p.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(f,s),e.allSettings.properties[f]=s,e.applicationSettings.properties[f]=s,e.machineSettings.properties[f]=s,e.machineOverridableSettings.properties[f]=s,e.windowSettings.properties[f]=s,e.resourceSettings.properties[f]=s}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(I,f){let s=this.defaultValues[I];k.isUndefined(s)&&(s=f.default),k.isUndefined(s)&&(s=m(f.type)),f.default=s}}const y="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(y);function v(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=v;function m(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const h=new n;D.Registry.add(e.Extensions.Configuration,h);function C(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?p.localize(5,null,b):h.getConfigurationProperties()[b]!==void 0?p.localize(6,null,b):null:p.localize(4,null)}e.validateProperty=C;function P(){const b=[],I=h.getConfigurationProperties();for(const f of Object.keys(I))b.push([f,I[f].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=P}),define(X[24],Q([0,1,26,16,4,32,5,37]),function(G,e,p,L,D,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function S(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof D.URI)}e.isConfigurationOverrides=S;var w;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(w=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function y(r,i){const o=i?r?i.keys.filter(T=>r.keys.indexOf(T)===-1):[...i.keys]:[],u=r?i?r.keys.filter(T=>i.keys.indexOf(T)===-1):[...r.keys]:[],a=[];if(i&&r){for(const T of r.keys)if(i.keys.indexOf(T)!==-1){const O=b(r.contents,T),$=b(i.contents,T);p.equals(O,$)||a.push(T)}}const l=[],g=T=>{const O={};for(const $ of T)for(const z of $.identifiers)O[c(z)]=$;return O},E=i?g(i.overrides):{},d=r?g(r.overrides):{};if(Object.keys(E).length)for(const T of o){const O=E[T];O&&l.push([(0,R.overrideIdentifierFromKey)(T),O.keys])}if(Object.keys(d).length)for(const T of u){const O=d[T];O&&l.push([(0,R.overrideIdentifierFromKey)(T),O.keys])}if(Object.keys(E).length&&Object.keys(d).length)for(const T of a){const O=d[T],$=E[T];if(O&&$){const z=y({contents:O.contents,keys:O.keys,overrides:[]},{contents:$.contents,keys:$.keys,overrides:[]});l.push([(0,R.overrideIdentifierFromKey)(T),[...z.added,...z.removed,...z.updated]])}}return{added:o,removed:u,updated:a,overrides:l}}e.compare=y;function v(r,i){const o=[];for(const u of Object.keys(r))if(R.OVERRIDE_PROPERTY_PATTERN.test(u)){const a={};for(const l in r[u])a[l]=r[u][l];o.push({identifiers:[(0,R.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(a),contents:m(a,i)})}return o}e.toOverrides=v;function m(r,i){const o=Object.create(null);for(let u in r)h(o,u,r[u],i);return o}e.toValuesTree=m;function h(r,i,o,u){const a=i.split("."),l=a.pop();let g=r;for(let E=0;E<a.length;E++){let d=a[E],T=g[d];switch(typeof T){case"undefined":T=g[d]=Object.create(null);break;case"object":break;default:u(`Ignoring ${i} as ${a.slice(0,E+1).join(".")} is ${JSON.stringify(T)}`);return}g=T}if(typeof g=="object"&&g!==null)try{g[l]=o}catch(E){u(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(g)}`)}else u(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(g)}`)}e.addToValueTree=h;function C(r,i){const o=i.split(".");P(r,o)}e.removeFromValueTree=C;function P(r,i){const o=i.shift();if(i.length===0){delete r[o];return}if(Object.keys(r).indexOf(o)!==-1){const u=r[o];typeof u=="object"&&!Array.isArray(u)&&(P(u,i),Object.keys(u).length===0&&delete r[o])}}function b(r,i,o){function u(g,E){let d=g;for(const T of E){if(typeof d!="object"||d===null)return;d=d[T]}return d}const a=i.split("."),l=u(r,a);return typeof l=="undefined"?o:l}e.getConfigurationValue=b;function I(r,i,o){Object.keys(i).forEach(u=>{u!=="__proto__"&&(u in r?L.isObject(r[u])&&L.isObject(i[u])?I(r[u],i[u],o):o&&(r[u]=i[u]):r[u]=i[u])})}e.merge=I;function f(){const r=k.Registry.as(R.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=f;function s(){const r=Object.create(null),i=k.Registry.as(R.Extensions.Configuration).getConfigurationProperties();for(let o in i){let u=i[o].default;h(r,o,u,a=>console.error(`Conflict in default settings: ${a}`))}return r}e.getDefaultValues=s;function c(r){return`[${r}]`}e.keyFromOverrideIdentifier=c;function t(r,i,o){const u=r.inspect(i),a=r.inspect(o);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:u.defaultValue}e.getMigratedSettingValue=t}),define(X[165],Q([0,1,33,38,23,16,26,4,37,24,32,2,3]),function(G,e,p,L,D,k,A,R,S,w,n,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(t={},r=[],i=[]){this._contents=t,this._keys=r,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,w.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const i=this.getContentsForOverrideIdentifer(r);return i?t?(0,w.getConfigurationValue)(i,t):i:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let i={};for(const o of D.distinct([...Object.keys(this.contents),...Object.keys(r)])){let u=this.contents[o],a=r[o];a&&(typeof u=="object"&&typeof a=="object"?(u=A.deepClone(u),this.mergeContents(u,a)):u=a),i[o]=u}return new m(i,this.keys,this.overrides)}merge(...t){const r=A.deepClone(this.contents),i=A.deepClone(this.overrides),o=[...this.keys];for(const u of t){this.mergeContents(r,u.contents);for(const a of u.overrides){const[l]=i.filter(g=>D.equals(g.identifiers,a.identifiers));l?this.mergeContents(l.contents,a.contents):i.push(A.deepClone(a))}for(const a of u.keys)o.indexOf(a)===-1&&o.push(a)}return new m(r,o,i)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const i of Object.keys(r)){if(i in t&&k.isObject(t[i])&&k.isObject(r[i])){this.mergeContents(t[i],r[i]);continue}t[i]=A.deepClone(r[i])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?A.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,w.addToValueTree)(this.contents,t,r,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&(0,w.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let i=0;i<r;i++)t.indexOf(this.keys[i])===0&&(r=i);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=m;class h extends m{constructor(){const t=(0,w.getDefaultValues)(),r=(0,w.getConfigurationKeys)(),i=[];for(const o of Object.keys(t))S.OVERRIDE_PROPERTY_PATTERN.test(o)&&i.push({identifiers:[(0,S.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(t[o]),contents:(0,w.toValuesTree)(t[o],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,r,i)}}e.DefaultConfigurationModel=h;class C{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!k.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:i,keys:o,overrides:u,restricted:a}=this.doParseRaw(t,r);this._configurationModel=new m(i,o,u),this._restrictedConfigurations=a||[]}doParseContent(t){let r={},i=null,o=[],u=[],a=[];function l(E){Array.isArray(o)?o.push(E):i&&(o[i]=E)}let g={onObjectBegin:()=>{let E={};l(E),u.push(o),o=E,i=null},onObjectProperty:E=>{i=E},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{let E=[];l(E),u.push(o),o=E,i=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:l,onError:(E,d,T)=>{a.push({error:E,offset:d,length:T})}};if(t)try{p.visit(t,g),r=o[0]||{}}catch(E){console.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return r}doParseRaw(t,r){const i=n.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),o=this.filter(t,i,!0,r);t=o.raw;const u=(0,w.toValuesTree)(t,g=>console.error(`Conflict in settings file ${this._name}: ${g}`)),a=Object.keys(t),l=(0,w.toOverrides)(t,g=>console.error(`Conflict in settings file ${this._name}: ${g}`));return{contents:u,keys:a,overrides:l,restricted:o.restricted}}filter(t,r,i,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:t,restricted:[]};const u={},a=[];for(let l in t)if(S.OVERRIDE_PROPERTY_PATTERN.test(l)&&i){const g=this.filter(t[l],r,!1,o);u[l]=g.raw,a.push(...g.restricted)}else{const g=r[l],E=g?typeof g.scope!="undefined"?g.scope:3:void 0;g?.restricted&&a.push(l),(E===void 0||o.scopes===void 0||o.scopes.includes(E))&&(o.skipRestricted&&g?.restricted||(u[l]=t[l]))}return{raw:u,restricted:a}}}e.ConfigurationModelParser=C;class P extends y.Disposable{constructor(t,r,i,o){super();this.userSettingsResource=t,this.scopes=r,this.fileService=o,this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new C(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(v.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=P;class b{constructor(t,r,i=new m,o=new m,u=new L.ResourceMap,a=new m,l=new L.ResourceMap,g=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=i,this._workspaceConfiguration=o,this._folderConfigurations=u,this._memoryConfiguration=a,this._memoryConfigurationByResource=l,this._freeze=g,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(t,r,i){return this.getConsolidateConfigurationModel(r,i).getValue(t)}updateValue(t,r,i={}){let o;i.resource?(o=this._memoryConfigurationByResource.get(i.resource),o||(o=new m,this._memoryConfigurationByResource.set(i.resource,o))):o=this._memoryConfiguration,r===void 0?o.removeValue(t):o.setValue(t,r),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,i){const o=this.getConsolidateConfigurationModel(r,i),u=this.getFolderConfigurationModelForResource(r.resource,i),a=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,l=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),g=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),E=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),d=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),T=i?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=u?r.overrideIdentifier?u.freeze().override(r.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,$=r.overrideIdentifier?a.override(r.overrideIdentifier).getValue(t):a.getValue(t),z=o.getValue(t),V=D.distinct(D.flatten(o.overrides.map(B=>B.identifiers))).filter(B=>o.getOverrideValue(t,B)!==void 0);return{defaultValue:l,userValue:g,userLocalValue:E,userRemoteValue:d,workspaceValue:T,workspaceFolderValue:O,memoryValue:$,value:z,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:g!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:E!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:d!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:T!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:u?.freeze().getValue(t),override:r.overrideIdentifier?u?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:$!==void 0?{value:a.getValue(t),override:r.overrideIdentifier?a.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const i=r.filter(o=>S.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const u=(0,S.overrideIdentifierFromKey)(o),a=this._defaultConfiguration.getKeysForOverrideIdentifier(u),l=t.getKeysForOverrideIdentifier(u),g=[...l.filter(E=>a.indexOf(E)===-1),...a.filter(E=>l.indexOf(E)===-1),...a.filter(E=>!A.equals(this._defaultConfiguration.override(u).getValue(E),t.override(u).getValue(E)))];return[u,g]});return this.updateDefaultConfiguration(t),{keys:r,overrides:i}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:i,removed:o,overrides:u}=(0,w.compare)(this.localUserConfiguration,t),a=[...r,...i,...o];return a.length&&this.updateLocalUserConfiguration(t),{keys:a,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:i,removed:o,overrides:u}=(0,w.compare)(this.remoteUserConfiguration,t);let a=[...r,...i,...o];return a.length&&this.updateRemoteUserConfiguration(t),{keys:a,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:i,removed:o,overrides:u}=(0,w.compare)(this.workspaceConfiguration,t);let a=[...r,...i,...o];return a.length&&this.updateWorkspaceConfiguration(t),{keys:a,overrides:u}}compareAndUpdateFolderConfiguration(t,r){const i=this.folderConfigurations.get(t),{added:o,updated:u,removed:a,overrides:l}=(0,w.compare)(i,r);let g=[...o,...u,...a];return(g.length||!i)&&this.updateFolderConfiguration(t,r),{keys:g,overrides:l}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:o,removed:u,overrides:a}=(0,w.compare)(r,void 0);return{keys:[...i,...o,...u],overrides:a}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let i=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?i.override(t.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:t},r){let i=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const o=r.getFolder(t);o&&(i=this.getFolderConsolidatedConfiguration(o.uri)||i);const u=this._memoryConfigurationByResource.get(t);u&&(i=i.merge(u))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const i=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(r=i.merge(o),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=i}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const i=r.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:i,overrides:o,keys:u}=this._folderConfigurations.get(r);return t.push([r,{contents:i,overrides:o,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.user),o=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((a,l)=>(a.set(R.URI.revive(l[0]),this.parseConfigurationModel(l[1])),a),new L.ResourceMap);return new b(r,i,new m,o,u,new m,new L.ResourceMap,!1)}static parseConfigurationModel(t){return new m(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function I(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const t=new Set,r=new Map;for(const o of c)o.keys.forEach(u=>t.add(u)),o.overrides.forEach(([u,a])=>{const l=(0,L.getOrSet)(r,u,new Set);a.forEach(g=>l.add(g))});const i=[];return r.forEach((o,u)=>i.push([u,[...o.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=I;class f{constructor(t,r,i,o){this.change=t,this.previous=r,this.currentConfiguraiton=i,this.currentWorkspace=o,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(l=>u.add(l)),t.overrides.forEach(([,l])=>l.forEach(g=>u.add(g))),this.affectedKeys=[...u.values()];const a=new m;this.affectedKeys.forEach(l=>a.setValue(l,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!A.equals(i,o)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let i=(0,w.toValuesTree)({[r]:!0},()=>{}),o;for(;typeof i=="object"&&(o=Object.keys(i)[0]);){if(t=t[o],!t)return!1;i=i[o]}return!0}}e.ConfigurationChangeEvent=f;class s extends f{constructor(t,r,i,o){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=i,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=s}),define(X[166],Q([0,1,32,37,2,24,165,3,6,15]),function(G,e,p,L,D,k,A,R,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class n extends D.Disposable{constructor(v,m){super();this.settingsResource=v,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new A.UserSettings(this.settingsResource,void 0,w.extUriBiasedIgnorePathCase,m)),this.configuration=new A.Configuration(new A.DefaultConfigurationModel,new A.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new S.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(p.Registry.as(L.Extensions.Configuration).onDidUpdateConfiguration(h=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const v=await this.userConfiguration.loadConfiguration();this.configuration=new A.Configuration(new A.DefaultConfigurationModel,v)}getConfigurationData(){return this.configuration.toData()}getValue(v,m){const h=typeof v=="string"?v:void 0,C=(0,k.isConfigurationOverrides)(v)?v:(0,k.isConfigurationOverrides)(m)?m:{};return this.configuration.getValue(h,C,void 0)}updateValue(v,m,h,C){return Promise.reject(new Error("not supported"))}inspect(v){return this.configuration.inspect(v,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const v=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(v)}onDidChangeUserConfiguration(v){const m=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(v);this.trigger(h,m,1)}onDidDefaultConfigurationChange(v){const m=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new A.DefaultConfigurationModel,v);this.trigger(h,m,6)}trigger(v,m,h){const C=new A.ConfigurationChangeEvent(v,{data:m},this.configuration);C.source=h,C.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(C)}getTargetConfiguration(v){switch(v){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=n}),define(X[167],Q([0,1,24,14,103]),function(G,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let k=class{constructor(R,S){this.configurationService=R,this.logService=S}request(R,S){return this.logService.trace("RequestService#request",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,D.request)(R,S)}async resolveProxy(R){}};k=fe([K(0,p.IConfigurationService),K(1,L.ILogService)],k),e.RequestService=k}),define(X[39],Q([0,1,121,5,37,32,25]),function(G,e,p,L,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function R(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=R;function S(h){return h.res.statusCode===204}async function w(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);return S(h)?null:(await(0,A.streamToBuffer)(h.stream)).toString()}e.asText=w;async function n(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);if(S(h))return null;const P=(await(0,A.streamToBuffer)(h.stream)).toString();try{return JSON.parse(P)}catch(b){throw b.message+=`:
`+P,b}}e.asJson=n;function y(h){m(h)}e.updateProxyConfigurationsScope=y;let v;function m(h){const C=k.Registry.as(D.Extensions.Configuration);v&&C.deregisterConfigurations([v]),v={id:"http",order:15,title:(0,p.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,p.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,p.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,p.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,p.localize)(4,null),(0,p.localize)(5,null),(0,p.localize)(6,null),(0,p.localize)(7,null)],default:"override",description:(0,p.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,p.localize)(9,null),restricted:!0}}},C.registerConfiguration(v)}m(2)}),define(X[168],Q([0,1,39,29,13,17]),function(G,e,p,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(S,w){this.requestService=S,this.fileService=w}async download(S,w,n=L.CancellationToken.None){if(S.scheme===k.Schemas.file||S.scheme===k.Schemas.vscodeRemote){await this.fileService.copy(S,w);return}const y={type:"GET",url:S.toString()},v=await this.requestService.request(y,n);if(v.res.statusCode===200)await this.fileService.writeFile(w,v.stream);else{const m=await(0,p.asText)(v);throw new Error(`Expected 200, got back ${v.res.statusCode} instead.

${m}`)}}};A=fe([K(0,p.IRequestService),K(1,D.IFileService)],A),e.DownloadService=A}),define(X[169],Q([0,1,28,13,23,63,39,29,14,15,133,2]),function(G,e,p,L,D,k,A,R,S,w,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let v=class extends y.Disposable{constructor(h,C,P,b){super();this.fileService=h,this.productService=C,this.requestService=P,this.logService=b,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,k.forEach)(this.productService.configBasedExtensionTips,({value:I})=>this.allConfigBasedTips.set(I.configPath,I))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const C=[];for(const[P,b]of this.allConfigBasedTips)try{const I=await this.fileService.readFile((0,w.joinPath)(h,P)),f=new Map;(0,k.forEach)(b.recommendations,({key:c,value:t})=>{if((0,D.isNonEmptyArray)(t.remotes))for(const r of t.remotes)f.set(r,{extensionId:c,extensionName:t.name,configName:b.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else C.push({extensionId:c,extensionName:t.name,configName:b.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const s=(0,n.getDomainsOfRemotes)(I.value.toString(),[...f.keys()]);for(const c of s){const t=f.get(c);t&&C.push(t)}}catch(I){}return C}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},R.CancellationToken.None);if(h.res.statusCode!==200)return[];const C=await(0,A.asJson)(h);return C?C.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};v=fe([K(0,L.IFileService),K(1,p.IProductService),K(2,A.IRequestService),K(3,S.ILogService)],v),e.ExtensionTipsService=v}),define(X[45],Q([0,1,30,25]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(k,A,R){let S=R&&R.get("storage.serviceMachineId",0)||null;if(S)return S;try{const n=(await A.readFile(k.serviceMachineIdResource)).value.toString();S=(0,p.isUUID)(n)?n:null}catch(w){S=null}if(!S){S=(0,p.generateUuid)();try{await A.writeFile(k.serviceMachineIdResource,L.VSBuffer.fromString(S))}catch(w){}}return R&&R.store("storage.serviceMachineId",S,0,1),S}e.getServiceMachineId=D}),define(X[20],Q([0,1,5,3,2,16,69,6]),function(G,e,p,L,D,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const S="__$__targetStorageMarker";e.IStorageService=(0,p.createDecorator)("storageService");var w;(function(C){C[C.NONE=0]="NONE",C[C.SHUTDOWN=1]="SHUTDOWN"})(w=e.WillSaveStateReason||(e.WillSaveStateReason={}));var n;(function(C){C[C.GLOBAL=0]="GLOBAL",C[C.WORKSPACE=1]="WORKSPACE"})(n=e.StorageScope||(e.StorageScope={}));var y;(function(C){C[C.USER=0]="USER",C[C.MACHINE=1]="MACHINE"})(y=e.StorageTarget||(e.StorageTarget={}));class v extends D.Disposable{constructor(P={flushInterval:v.DEFAULT_FLUSH_INTERVAL}){super();this.options=P,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(P,b){b===S?(P===0?this._globalKeyTargets=void 0:P===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:P})):this._onDidChangeValue.fire({scope:P,key:b,target:this.getKeyTargets(P)[b]})}emitWillSaveState(P){this._onWillSaveState.fire({reason:P})}get(P,b,I){return this.getStorage(b)?.get(P,I)}getBoolean(P,b,I){return this.getStorage(b)?.getBoolean(P,I)}getNumber(P,b,I){return this.getStorage(b)?.getNumber(P,I)}store(P,b,I,f){if((0,k.isUndefinedOrNull)(b)){this.remove(P,I);return}this.withPausedEmitters(()=>{this.updateKeyTarget(P,I,f),this.getStorage(I)?.set(P,b)})}remove(P,b){this.withPausedEmitters(()=>{this.updateKeyTarget(P,b,void 0),this.getStorage(b)?.delete(P)})}withPausedEmitters(P){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{P()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(P,b){const I=[],f=this.getKeyTargets(P);for(const s of Object.keys(f))f[s]===b&&I.push(s);return I}updateKeyTarget(P,b,I){const f=this.getKeyTargets(b);typeof I=="number"?f[P]!==I&&(f[P]=I,this.getStorage(b)?.set(S,JSON.stringify(f))):typeof f[P]=="number"&&(delete f[P],this.getStorage(b)?.set(S,JSON.stringify(f)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(P){return P===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(P){const b=this.get(S,P);if(b)try{return JSON.parse(b)}catch(I){}return Object.create(null)}isNew(P){return this.getBoolean(e.IS_NEW_KEY,P)===!0}async flush(){this._onWillSaveState.fire({reason:w.NONE}),await R.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const P=this.getStorage(0)?.items??new Map,b=this.getStorage(1)?.items??new Map;return h(P,b,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=v,v.DEFAULT_FLUSH_INTERVAL=60*1e3;class m extends v{constructor(){super();this.globalStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(P=>this.emitDidChangeValue(1,P))),this._register(this.globalStorage.onDidChangeStorage(P=>this.emitDidChangeValue(0,P)))}getStorage(P){return P===0?this.globalStorage:this.workspaceStorage}getLogDetails(P){return P===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(P){}}e.InMemoryStorageService=m;async function h(C,P,b,I){const f=u=>{try{return JSON.parse(u)}catch(a){return u}},s=new Map,c=new Map;C.forEach((u,a)=>{s.set(a,u),c.set(a,f(u))});const t=new Map,r=new Map;P.forEach((u,a)=>{t.set(a,u),r.set(a,f(u))}),console.group(`Storage: Global (path: ${b})`);let i=[];s.forEach((u,a)=>{i.push({key:a,value:u})}),console.table(i),console.groupEnd(),console.log(c),console.group(`Storage: Workspace (path: ${I})`);let o=[];t.forEach((u,a)=>{o.push({key:a,value:u})}),console.table(o),console.groupEnd(),console.log(r)}e.logStorage=h}),define(X[170],Q([0,1,3,2,27,31,20,16]),function(G,e,p,L,D,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let S=class extends L.Disposable{constructor(y){super();this._onDidChangeEnablement=new p.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new w(y)),this._register(this.storageManger.onDidChange(v=>this._onDidChangeEnablement.fire({extensions:v,source:"storage"})))}async enableExtension(y,v){return this._removeFromDisabledExtensions(y)?(this._onDidChangeEnablement.fire({extensions:[y],source:v}),!0):!1}async disableExtension(y,v){return this._addToDisabledExtensions(y)?(this._onDidChangeEnablement.fire({extensions:[y],source:v}),!0):!1}getDisabledExtensions(){return this._getExtensions(D.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(y){let v=this.getDisabledExtensions();return v.every(m=>!(0,k.areSameExtensions)(m,y))?(v.push(y),this._setDisabledExtensions(v),!0):!1}_removeFromDisabledExtensions(y){let v=this.getDisabledExtensions();for(let m=0;m<v.length;m++){const h=v[m];if((0,k.areSameExtensions)(h,y))return v.splice(m,1),this._setDisabledExtensions(v),!0}return!1}_setDisabledExtensions(y){this._setExtensions(D.DISABLED_EXTENSIONS_STORAGE_PATH,y)}_getExtensions(y){return this.storageManger.get(y,0)}_setExtensions(y,v){this.storageManger.set(y,v,0)}};S=fe([K(0,A.IStorageService)],S),e.GlobalExtensionEnablementService=S;class w extends L.Disposable{constructor(y){super();this.storageService=y,this.storage=Object.create(null),this._onDidChange=this._register(new p.Emitter),this.onDidChange=this._onDidChange.event,this._register(y.onDidChangeValue(v=>this.onDidStorageChange(v)))}get(y,v){let m;return v===0?((0,R.isUndefinedOrNull)(this.storage[y])&&(this.storage[y]=this._get(y,v)),m=this.storage[y]):m=this._get(y,v),JSON.parse(m)}set(y,v,m){let h=JSON.stringify(v.map(({id:P,uuid:b})=>({id:P,uuid:b})));this._get(y,m)!==h&&(m===0&&(v.length?this.storage[y]=h:delete this.storage[y]),this._set(y,v.length?h:void 0,m))}onDidStorageChange(y){if(y.scope===0&&!(0,R.isUndefinedOrNull)(this.storage[y.key])&&this._get(y.key,y.scope)!==this.storage[y.key]){const m=this.get(y.key,y.scope);delete this.storage[y.key];const h=this.get(y.key,y.scope),C=m.filter(b=>!h.some(I=>(0,k.areSameExtensions)(b,I))),P=h.filter(b=>!m.some(I=>(0,k.areSameExtensions)(I,b)));(C.length||P.length)&&this._onDidChange.fire([...C,...P])}}_get(y,v){return this.storageService.get(y,v,"[]")}_set(y,v,m){v?this.storageService.store(y,v,m,1):this.storageService.remove(y,m)}}e.StorageManager=w}),define(X[171],Q([0,1,3,2]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class D extends L.Disposable{constructor(w,n){super();this.channel=w,this.workspace=n}async getItems(){const w={workspace:this.workspace},n=await this.channel.call("getItems",w);return new Map(n)}updateItems(w){const n={workspace:this.workspace};return w.insert&&(n.insert=Array.from(w.insert.entries())),w.delete&&(n.delete=Array.from(w.delete.values())),this.channel.call("updateItems",n)}}class k extends D{constructor(w){super(w,void 0);this._onDidChangeItemsExternal=this._register(new p.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(w=>this.onDidChangeGlobalStorage(w)))}onDidChangeGlobalStorage(w){(Array.isArray(w.changed)||Array.isArray(w.deleted))&&this._onDidChangeItemsExternal.fire({changed:w.changed?new Map(w.changed):void 0,deleted:w.deleted?new Set(w.deleted):void 0})}async close(){this.dispose()}}class A extends D{constructor(w,n){super(w,n);this.onDidChangeItemsExternal=p.Event.None}async close(){const w={workspace:this.workspace};return this.channel.call("close",w)}}class R extends L.Disposable{constructor(w,n){super();this.channel=w,this.workspace=n,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new k(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new A(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=R}),define(X[172],Q([0,1,2,20,69,6,161,171,15]),function(G,e,p,L,D,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class w extends L.AbstractStorageService{constructor(y,v,m){super();this.mainProcessService=v,this.environmentService=m,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new p.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(y)}createGlobalStorage(){const y=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),v=new D.Storage(y.globalStorage);return this._register(v.onDidChangeStorage(m=>this.emitDidChangeValue(0,m))),v}createWorkspaceStorage(y){const v=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),y);if(v.workspaceStorage){const m=new D.Storage(v.workspaceStorage);return this.workspaceStorageDisposable.value=m.onDidChangeStorage(h=>this.emitDidChangeValue(1,h)),this.workspaceStorageId=y?.id,m}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){(0,A.mark)("code/willInitStorage");try{await k.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}finally{(0,A.mark)("code/didInitStorage")}}getStorage(y){return y===0?this.globalStorage:this.workspaceStorage}getLogDetails(y){return y===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,S.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(L.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(y){const v=this.workspaceStorage,m=v?.items??new Map;v&&(await v.close(),v.dispose()),this.workspaceStorage=this.createWorkspaceStorage(y),await this.workspaceStorage.init();for(const[h,C]of m)this.workspaceStorage.set(h,C)}}e.NativeStorageService=w}),define(X[173],Q([0,1,7,34,30,4]),function(G,e,p,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(w){if(p.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function R(w,n,y,v,m,h,C,P,b,I){const f=Object.create(null);f["common.machineId"]=C,f.sessionID=(0,D.generateUuid)()+Date.now(),f.commitHash=m,f.version=h,f["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,p.PlatformToString)(p.platform),f["common.nodePlatform"]=L.platform,f["common.nodeArch"]=v,f["common.product"]=I||"desktop";const s=S(P||[]);s&&(f["common.msftInternal"]=s);let c=0;const t=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),p.isLinuxSnap&&(f["common.snap"]="true");const r=A(y);r&&(f["common.platformDetail"]=r);try{const i=await w.readFile(k.URI.file(b));f["common.source"]=i.value.toString().slice(0,30)}catch(i){}return f}e.resolveCommonProperties=R;function S(w){const n=L.env.USERDNSDOMAIN;if(!n)return!1;const y=n.toLowerCase();return w.some(v=>y===v)}e.verifyMicrosoftInternalDomain=S}),define(X[21],Q([0,1,5]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,p.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,p.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(X[174],Q([0,1,35,95,71,8,33,98,28,7,4,21,53,17,13,18]),function(G,e,p,L,D,k,A,R,S,w,n,y,v,m,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function P(c,t){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],i=new Map,o=new Map,u=2e4;function a(E,d,T,O){const $=d.substring(E.length+1);return new Promise(async z=>{let V;try{V=await C.Promises.readdir(d,{withFileTypes:!0})}catch(_){z();return}if(O.count>=u){O.count+=V.length,O.maxReached=!0,z();return}let B=V.length;if(B===0){z();return}let M=V;O.count+V.length>u&&(O.maxReached=!0,B=u-O.count,M=V.slice(0,B)),O.count+=V.length;for(const _ of M)if(_.isDirectory()){if(T.includes(_.name)||await a(E,(0,k.join)(d,_.name),T,O),--B==0){z();return}}else{const N=_.name.lastIndexOf(".");if(N>=0){const j=_.name.substring(N+1);j&&i.set(j,(i.get(j)??0)+1)}for(const j of r)j.relativePathPattern?.test($)!==!1&&j.filePattern.test(_.name)&&o.set(j.tag,(o.get(j.tag)??0)+1);if(--B==0){z();return}}})}const l={count:0,maxReached:!1};await a(c,c,t,l);const g=await f(c);return{configFiles:b(o),fileTypes:b(i),fileCount:l.count,maxFilesReached:l.maxReached,launchConfigFiles:g}}e.collectWorkspaceStats=P;function b(c){return[...v.Iterable.map(c.entries(),([t,r])=>({name:t,count:r}))].sort((t,r)=>r.count-t.count)}function I(){const c={os:`${p.type()} ${p.arch()} ${p.release()}`,memory:`${(p.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(L.virtualMachineHint.value()*100)}%`},t=p.cpus();return t&&t.length>0&&(c.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),c}e.getMachineInfo=I;async function f(c){try{const t=new Map,r=(0,k.join)(c,".vscode","launch.json"),i=await C.Promises.readFile(r),o=[],u=(0,A.parse)(i.toString(),o);if(o.length)return console.log(`Unable to parse ${r}`),[];if((0,A.getNodeType)(u)==="object"&&u.configurations)for(const a of u.configurations){const l=a.type;l&&(t.has(l)?t.set(l,t.get(l)+1):t.set(l,1))}return b(t)}catch(t){return[]}}e.collectLaunchConfigs=f;let s=class{constructor(t,r){this.telemetryService=t,this.productService=r}formatMachineInfo(t){const r=[];return r.push(`OS Version:       ${t.os}`),r.push(`CPUs:             ${t.cpus}`),r.push(`Memory (System):  ${t.memory}`),r.push(`VM:               ${t.vmHint}`),r.join(`
`)}formatEnvironment(t){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${p.type()} ${p.arch()} ${p.release()}`);const i=p.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(p.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),w.isWindows||r.push(`Load (avg):       ${p.loadavg().map(o=>Math.round(o)).join(", ")}`),r.push(`VM:               ${Math.round(L.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${t.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(t,r){return Promise.all([(0,R.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async i=>{let[o,u]=i,a=this.formatProcessList(t,o);return r.forEach(l=>{if((0,D.isRemoteDiagnosticError)(l))a+=`
${l.errorMessage}`,u+=`
${l.errorMessage}`;else if(a+=`

Remote: ${l.hostName}`,l.processes&&(a+=`
${this.formatProcessList(t,l.processes)}`),l.workspaceMetadata){u+=`
|  Remote: ${l.hostName}`;for(const g of Object.keys(l.workspaceMetadata)){const E=l.workspaceMetadata[g];let d=`${E.fileCount} files`;E.maxFilesReached&&(d=`more than ${d}`),u+=`|    Folder (${g}): ${d}`,u+=this.formatWorkspaceStats(E)}}}),{processInfo:a,workspaceInfo:u}})}async getSystemInfo(t,r){const{memory:i,vmHint:o,os:u,cpus:a}=I(),l={os:u,memory:i,cpus:a,vmHint:o,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:r};return w.isWindows||(l.load=`${p.loadavg().map(g=>Math.round(g)).join(", ")}`),w.isLinux&&(l.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(l)}async getDiagnostics(t,r){const i=[];return(0,R.listProcesses)(t.mainPID).then(async o=>(i.push(""),i.push(this.formatEnvironment(t)),i.push(""),i.push(this.formatProcessList(t,o)),t.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(t))),r.forEach(u=>{if((0,D.isRemoteDiagnosticError)(u))i.push(`
${u.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${u.hostName}`),i.push(this.formatMachineInfo(u.machineInfo)),u.processes&&i.push(this.formatProcessList(t,u.processes)),u.workspaceMetadata)for(const a of Object.keys(u.workspaceMetadata)){const l=u.workspaceMetadata[a];let g=`${l.fileCount} files`;l.maxFilesReached&&(g=`more than ${g}`),i.push(`Folder (${a}): ${g}`),i.push(this.formatWorkspaceStats(l))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(t){const r=[],i=60;let o=0;const u=(E,d)=>{const T=` ${E}(${d})`;o+T.length>i?(r.push(a),a="|                 ",o=a.length):o+=T.length,a+=T};let a="|      File types:";const l=10;let g=t.fileTypes.length>l?l:t.fileTypes.length;for(let E=0;E<g;E++){const d=t.fileTypes[E];u(d.name,d.count)}if(r.push(a),t.configFiles.length>=0&&(a="|      Conf files:",o=0,t.configFiles.forEach(E=>{u(E.name,E.count)}),r.push(a)),t.launchConfigFiles.length>0){let E="|      Launch Configs:";t.launchConfigFiles.forEach(d=>{E+=d.count>1?` ${d.name}(${d.count})`:` ${d.name}`}),r.push(E)}return r.join(`
`)}expandGPUFeatures(t){const r=Math.max(...Object.keys(t).map(i=>i.length));return Object.keys(t).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${t[i]}`).join(`
                  `)}formatWorkspaceMetadata(t){const r=[],i=[];return t.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(r.push(`|  Window (${o.title})`),o.folderURIs.forEach(u=>{const a=n.URI.revive(u);if(a.scheme===m.Schemas.file){const l=a.fsPath;i.push(P(l,["node_modules",".git"]).then(g=>{let E=`${g.fileCount} files`;g.maxFilesReached&&(E=`more than ${E}`),r.push(`|    Folder (${(0,k.basename)(l)}): ${E}`),r.push(this.formatWorkspaceStats(g))}).catch(g=>{r.push(`|      Error: Unable to collect workspace stats for folder ${l} (${g.toString()})`)}))}else r.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(o=>r.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(t,r){const i=new Map;t.windows.forEach(u=>i.set(u.pid,u.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(t.mainPID,i,o,r,0),o.join(`
`)}formatProcessItem(t,r,i,o,u){const a=u===0;let l;a?l=o.pid===t?`${this.productService.applicationName} main`:"remote agent":(l=`${"  ".repeat(u)} ${o.name}`,o.name==="window"&&(l=`${l} (${r.get(o.pid)})`));const g=process.platform==="win32"?o.mem:p.totalmem()*(o.mem/100);i.push(`${o.load.toFixed(0).padStart(5," ")}	${(g/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${l}`),Array.isArray(o.children)&&o.children.forEach(E=>this.formatProcessItem(t,r,i,E,u+1))}async reportWorkspaceStats(t){for(const{uri:r}of t.folders){const i=n.URI.revive(r);if(i.scheme!==m.Schemas.file)continue;const o=i.fsPath;try{const u=await P(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),u.fileTypes.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:a.name,count:a.count})}),u.launchConfigFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:a.name,count:a.count})}),u.configFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};s=fe([K(0,y.ITelemetryService),K(1,S.IProductService)],s),e.DiagnosticsService=s}),define(X[175],Q([0,1,110,2,27,31,3,44,14,21,29,9,4,6]),function(G,e,p,L,D,k,A,R,S,w,n,y,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.INSTALL_ERROR_LOCAL=e.ERROR_UNKNOWN=e.INSTALL_ERROR_VALIDATING=void 0,e.INSTALL_ERROR_VALIDATING="validating",e.ERROR_UNKNOWN="unknown",e.INSTALL_ERROR_LOCAL="local";let h=class extends L.Disposable{constructor(f,s,c){super();this.galleryService=f,this.telemetryService=s,this.logService=c,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,L.toDisposable)(()=>{this.installingExtensions.forEach(t=>t.cancel()),this.uninstallingExtensions.forEach(t=>t.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async installFromGallery(f,s={}){if(!this.galleryService.isEnabled())throw new Error(p.localize(0,null));try{f=await this.checkAndGetCompatibleVersion(f)}catch(t){throw this.logService.error((0,y.getErrorMessage)(t)),P(this.telemetryService,"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(f),void 0,t),t}if(!await this.canInstall(f)){const t=new D.ExtensionManagementError("Not supported",e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Canno install extension as it is not supported.",f.identifier.id,t.message),P(this.telemetryService,"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(f),void 0,t),t}const c=await this.galleryService.getManifest(f,n.CancellationToken.None);if(c===null){const t=new D.ExtensionManagementError(`Missing manifest for extension ${f.identifier.id}`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",f.identifier.id,t.message),P(this.telemetryService,"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(f),void 0,t),t}return this.installExtension(c,f,s)}async uninstall(f,s={}){return this.logService.trace("ExtensionManagementService#uninstall",f.identifier.id),this.unininstallExtension(f,s)}async reinstallFromGallery(f){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",f.identifier.id),!this.galleryService.isEnabled())throw new Error(p.localize(1,null));const s=await this.findGalleryExtension(f);if(!s)throw new Error(p.localize(2,null));await this.createUninstallExtensionTask(f,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(s)}getExtensionsReport(){const f=new Date().getTime();return(!this.reportedExtensions||f-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=f),this.reportedExtensions}registerParticipant(f){this.participants.push(f)}async installExtension(f,s,c){if(!v.URI.isUri(s)){let u=this.installingExtensions.get(new k.ExtensionIdentifierWithVersion(s.identifier,s.version).key());if(u)return this.logService.info("Extensions is already requested to install",s.identifier.id),u.waitUntilTaskIsFinished();c={...c,installOnlyNewlyAddedFromExtensionPack:!0}}const t=[],r=[],i=this.createInstallExtensionTask(f,s,c);v.URI.isUri(s)||this.installingExtensions.set(new k.ExtensionIdentifierWithVersion(i.identifier,f.version).key(),i),this._onInstallExtension.fire({identifier:i.identifier,source:s}),this.logService.info("Installing extension:",i.identifier.id),t.push({task:i,manifest:f});let o=!1;try{if(c.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",i.identifier.id);else try{const a=await this.getAllDepsAndPackExtensionsToInstall(i.identifier,f,!!c.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:l,manifest:g}of a)if(o=o||!!g.extensionDependencies?.some(E=>(0,k.areSameExtensions)({id:E},i.identifier)),this.installingExtensions.has(new k.ExtensionIdentifierWithVersion(l.identifier,l.version).key()))this.logService.info("Extension is already requested to install",l.identifier.id);else{const E=this.createInstallExtensionTask(g,l,{...c,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new k.ExtensionIdentifierWithVersion(E.identifier,g.version).key(),E),this._onInstallExtension.fire({identifier:E.identifier,source:l}),this.logService.info("Installing extension:",E.identifier.id),t.push({task:E,manifest:g})}}catch(a){throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",i.identifier.id),this.logService.error(a),a}const u=t.reduce((a,{task:l,manifest:g})=>(a.set(l.identifier.id.toLowerCase(),{task:l,manifest:g}),a),new Map);for(;u.size;){let a;const l=[...u.values()].filter(({manifest:g})=>!g.extensionDependencies?.some(E=>u.has(E.toLowerCase())));l.length?a=u.size===1?l:l.filter(({task:g})=>!(g===i&&!o)):(this.logService.info("Found extensions with circular dependencies",l.map(({task:g})=>g.identifier.id)),a=[...u.values()]),await this.joinAllSettled(a.map(async({task:g})=>{const E=new Date().getTime();try{const d=await g.run();await this.joinAllSettled(this.participants.map(T=>T.postInstall(d,g.source,c,n.CancellationToken.None))),v.URI.isUri(g.source)||P(this.telemetryService,g.operation===2?"extensionGallery:update":"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(g.source),new Date().getTime()-E,void 0),r.push({local:d,identifier:g.identifier,operation:g.operation,source:g.source})}catch(d){throw v.URI.isUri(g.source)||P(this.telemetryService,g.operation===2?"extensionGallery:update":"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(g.source),new Date().getTime()-E,d),this.logService.error("Error while installing the extension:",g.identifier.id),this.logService.error(d),d}finally{u.delete(g.identifier.id.toLowerCase())}}))}return r.forEach(({identifier:a})=>this.logService.info("Extension installed successfully:",a.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:a})=>(0,k.areSameExtensions)(a,i.identifier))[0].local}catch(u){if(t.forEach(({task:a})=>a.cancel()),r.length)try{const a=await Promise.allSettled(r.map(({local:l})=>this.createUninstallExtensionTask(l,{versionOnly:!0}).run()));for(let l=0;l<a.length;l++){const g=a[l],{identifier:E}=r[l];g.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",E.id):this.logService.warn("Rollback: Error while uninstalling extension",E.id,(0,y.getErrorMessage)(g.reason))}}catch(a){this.logService.warn("Error while rolling back extensions",(0,y.getErrorMessage)(a),r.map(({identifier:l})=>l.id))}throw this.logService.error("Failed to install extension:",i.identifier.id,(0,y.getErrorMessage)(u)),this._onDidInstallExtensions.fire(t.map(({task:a})=>({identifier:a.identifier,operation:1,source:a.source}))),u instanceof Error&&(u.name=u&&u.code?u.code:e.ERROR_UNKNOWN),u}finally{for(const{task:u,manifest:a}of t)if(!v.URI.isUri(u.source)){const l=new k.ExtensionIdentifierWithVersion(u.identifier,a.version).key();this.installingExtensions.delete(l)||this.logService.warn("Installation task is not found in the cache",l)}}}async joinAllSettled(f){const s=[],c=[],t=await Promise.allSettled(f);for(const r of t)r.status==="fulfilled"?s.push(r.value):c.push(r.reason);if(c.length)throw C(c);return s}async getAllDepsAndPackExtensionsToInstall(f,s,c){if(!this.galleryService.isEnabled())return[];let t=await this.getInstalled();const r=[f,...t.map(u=>u.identifier)],i=[],o=async(u,a)=>{const l=a.extensionDependencies||[];if(a.extensionPack){const g=c?t.find(E=>(0,k.areSameExtensions)(E.identifier,u)):void 0;for(const E of a.extensionPack)g&&g.manifest.extensionPack&&g.manifest.extensionPack.some(d=>(0,k.areSameExtensions)({id:d},{id:E}))||l.every(d=>!(0,k.areSameExtensions)({id:d},{id:E}))&&l.push(E)}if(l.length){const g=[...r,...i.map(d=>d.gallery.identifier)],E=l.filter(d=>g.every(T=>!(0,k.areSameExtensions)(T,{id:d})));if(E.length){const d=await this.galleryService.query({names:E,pageSize:l.length},n.CancellationToken.None);for(const T of d.firstPage){if(g.find(z=>(0,k.areSameExtensions)(z,T.identifier)))continue;const O=await this.checkAndGetCompatibleVersion(T);if(!await this.canInstall(O)){this.logService.info("Skipping the extension as it cannot be installed",O.identifier.id);continue}const $=await this.galleryService.getManifest(O,n.CancellationToken.None);if($===null)throw new D.ExtensionManagementError(`Missing manifest for extension ${O.identifier.id}`,e.INSTALL_ERROR_VALIDATING);i.push({gallery:O,manifest:$}),await o(O.identifier,$)}}}};return await o(f,s),t=await this.getInstalled(),i.filter(u=>!t.some(a=>(0,k.areSameExtensions)(a.identifier,u.gallery.identifier)))}async checkAndGetCompatibleVersion(f){if(await this.isMalicious(f))throw new D.ExtensionManagementError(p.localize(3,null,f.identifier.id),D.INSTALL_ERROR_MALICIOUS);const s=await this.galleryService.getCompatibleExtension(f);if(!s)throw new D.ExtensionManagementError(p.localize(4,null,f.identifier.id,R.default.version),D.INSTALL_ERROR_INCOMPATIBLE);return s}async isMalicious(f){const s=await this.getExtensionsReport();return(0,k.getMaliciousExtensionsSet)(s).has(f.identifier.id)}async unininstallExtension(f,s){const c=this.uninstallingExtensions.get(f.identifier.id.toLowerCase());if(c)return this.logService.info("Extensions is already requested to uninstall",f.identifier.id),c.waitUntilTaskIsFinished();const t=(u,a)=>{const l=this.createUninstallExtensionTask(u,a);return this.uninstallingExtensions.set(l.extension.identifier.id.toLowerCase(),l),this.logService.info("Uninstalling extension:",u.identifier.id),this._onUninstallExtension.fire(u.identifier),l},r=(u,a)=>{a?this.logService.error("Failed to uninstall extension:",u.identifier.id,a.message):this.logService.info("Successfully uninstalled extension:",u.identifier.id),P(this.telemetryService,"extensionGallery:uninstall",(0,k.getLocalExtensionTelemetryData)(u),void 0,a),this._onDidUninstallExtension.fire({identifier:u.identifier,error:a?.code})},i=[],o=[];try{i.push(t(f,{}));const u=await this.getInstalled(1);if(s.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",f.identifier.id);else{const a=this.getAllPackExtensionsToUninstall(f,u);for(const l of a)this.uninstallingExtensions.has(l.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",l.identifier.id):i.push(t(l,{}))}s.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",f.identifier.id):this.checkForDependents(i.map(a=>a.extension),u,f),await this.joinAllSettled(i.map(async a=>{try{if(await a.run(),await this.joinAllSettled(this.participants.map(l=>l.postUninstall(a.extension,s,n.CancellationToken.None))),a.extension.identifier.uuid)try{await this.galleryService.reportStatistic(a.extension.manifest.publisher,a.extension.manifest.name,a.extension.manifest.version,"uninstall")}catch(l){}r(a.extension)}catch(l){const g=l instanceof D.ExtensionManagementError?l:new D.ExtensionManagementError((0,y.getErrorMessage)(l),e.ERROR_UNKNOWN);throw r(a.extension,g),g}finally{o.push(a)}}))}catch(u){const a=u instanceof D.ExtensionManagementError?u:new D.ExtensionManagementError((0,y.getErrorMessage)(u),e.ERROR_UNKNOWN);for(const l of i){try{l.cancel()}catch(g){}o.includes(l)||r(l.extension,a)}throw a}finally{for(const u of i)this.uninstallingExtensions.delete(u.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",u.extension.identifier.id)}}checkForDependents(f,s,c){for(const t of f){const r=this.getDependents(t,s);if(r.length){const i=r.filter(o=>f.indexOf(o)===-1);if(i.length)throw new Error(this.getDependentsErrorMessage(t,i,c))}}}getDependentsErrorMessage(f,s,c){return c===f?s.length===1?p.localize(5,null,c.manifest.displayName||c.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?p.localize(6,null,c.manifest.displayName||c.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):p.localize(7,null,c.manifest.displayName||c.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?p.localize(8,null,c.manifest.displayName||c.manifest.name,f.manifest.displayName||f.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?p.localize(9,null,c.manifest.displayName||c.manifest.name,f.manifest.displayName||f.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):p.localize(10,null,c.manifest.displayName||c.manifest.name,f.manifest.displayName||f.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}getAllPackExtensionsToUninstall(f,s,c=[]){if(c.indexOf(f)!==-1)return[];c.push(f);const t=f.manifest.extensionPack?f.manifest.extensionPack:[];if(t.length){const r=s.filter(o=>!o.isBuiltin&&t.some(u=>(0,k.areSameExtensions)({id:u},o.identifier))),i=[];for(const o of r)i.push(...this.getAllPackExtensionsToUninstall(o,s,c));return[...r,...i]}return[]}getDependents(f,s){return s.filter(c=>c.manifest.extensionDependencies&&c.manifest.extensionDependencies.some(t=>(0,k.areSameExtensions)({id:t},f.identifier)))}async findGalleryExtension(f){if(f.identifier.uuid){const s=await this.findGalleryExtensionById(f.identifier.uuid);return s||this.findGalleryExtensionByName(f.identifier.id)}return this.findGalleryExtensionByName(f.identifier.id)}async findGalleryExtensionById(f){return(await this.galleryService.query({ids:[f],pageSize:1},n.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(f){return(await this.galleryService.query({names:[f],pageSize:1},n.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const f=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${f.length} reported extensions from service`),f}catch(f){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};h=fe([K(0,D.IExtensionGalleryService),K(1,w.ITelemetryService),K(2,S.ILogService)],h),e.AbstractExtensionManagementService=h;function C(I){const f=Array.isArray(I)?I:[I];return f.length===1?f[0]instanceof Error?f[0]:new Error(f[0]):f.reduce((s,c)=>new Error(`${s.message}${s.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}e.joinErrors=C;function P(I,f,s,c,t){const r=t?t instanceof D.ExtensionManagementError?t.code:e.ERROR_UNKNOWN:void 0;I.publicLogError(f,{...s,success:!t,duration:c,errorcode:r})}e.reportTelemetry=P;class b{constructor(){this.barrier=new m.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,m.createCancelablePromise)(f=>this.doRun(f))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,m.createCancelablePromise)(f=>new Promise((s,c)=>{const t=f.onCancellationRequested(()=>{t.dispose(),c((0,y.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=b}),define(X[176],Q([0,1,9,27,31,26,21,39,70,12,29,14,13,4,28,20,45,5]),function(G,e,p,L,D,k,A,R,S,w,n,y,v,m,h,C,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var I;(function(_){_[_.None=0]="None",_[_.IncludeVersions=1]="IncludeVersions",_[_.IncludeFiles=2]="IncludeFiles",_[_.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",_[_.IncludeSharedAccounts=8]="IncludeSharedAccounts",_[_.IncludeVersionProperties=16]="IncludeVersionProperties",_[_.ExcludeNonValidated=32]="ExcludeNonValidated",_[_.IncludeInstallationTargets=64]="IncludeInstallationTargets",_[_.IncludeAssetUri=128]="IncludeAssetUri",_[_.IncludeStatistics=256]="IncludeStatistics",_[_.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",_[_.Unpublished=4096]="Unpublished"})(I||(I={}));function f(..._){return String(_.reduce((N,j)=>N|j,0))}var s;(function(_){_[_.Tag=1]="Tag",_[_.ExtensionId=4]="ExtensionId",_[_.Category=5]="Category",_[_.ExtensionName=7]="ExtensionName",_[_.Target=8]="Target",_[_.Featured=9]="Featured",_[_.SearchText=10]="SearchText",_[_.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const c={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},t={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},i={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:I.None,criteria:[],assetTypes:[]};class o{constructor(N=i){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,j=this.state.pageSize){return new o({...this.state,pageNumber:N,pageSize:j})}withFilter(N,...j){const F=[...this.state.criteria,...j.length?j.map(U=>({filterType:N,value:U})):[{filterType:N}]];return new o({...this.state,criteria:F})}withSortBy(N){return new o({...this.state,sortBy:N})}withSortOrder(N){return new o({...this.state,sortOrder:N})}withFlags(...N){return new o({...this.state,flags:N.reduce((j,F)=>j|F,0)})}withAssetTypes(...N){return new o({...this.state,assetTypes:N})}get raw(){const{criteria:N,pageNumber:j,pageSize:F,sortBy:U,sortOrder:x,flags:q,assetTypes:H}=this.state;return{filters:[{criteria:N,pageNumber:j,pageSize:F,sortBy:U,sortOrder:x}],assetTypes:H,flags:q}}get searchText(){const N=this.state.criteria.filter(j=>j.filterType===s.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function u(_,N){const j=(_||[]).filter(F=>F.statisticName===N)[0];return j?j.value:0}function a(_){const N="Microsoft.VisualStudio.Code.Translation.";return _.files.filter(F=>F.assetType.indexOf(N)===0).reduce((F,U)=>{const x=d(_,U.assetType);return x&&F.push([U.assetType.substring(N.length),x]),F},[])}function l(_){if(_.properties){const N=_.properties.filter(U=>U.key===c.Repository),j=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),F=N.filter(U=>j.test(U.value))[0];return F?{uri:F.value,fallbackUri:F.value}:null}return d(_,c.Repository)}function g(_){return{uri:`${_.fallbackAssetUri}/${c.VSIX}?redirect=true`,fallbackUri:`${_.fallbackAssetUri}/${c.VSIX}`}}function E(_){const N=d(_,c.Icon);if(N)return N;const j=L.DefaultIconPath;return{uri:j,fallbackUri:j}}function d(_,N){return _.files.filter(F=>F.assetType===N)[0]?{uri:`${_.assetUri}/${N}`,fallbackUri:`${_.fallbackAssetUri}/${N}`}:null}function T(_,N){const j=_.properties?_.properties.filter(U=>U.key===N):[],F=j.length>0&&j[0].value;return F?F.split(",").map(U=>(0,D.adoptToGalleryExtensionId)(U)):[]}function O(_){const N=_.properties?_.properties.filter(j=>j.key===t.Engine):[];return N.length>0&&N[0].value||""}function $(_){const N=_.properties?_.properties.filter(F=>F.key===t.LocalizedLanguages):[],j=N.length>0&&N[0].value||"";return j?j.split(","):[]}function z(_){return _.indexOf("preview")!==-1}function V(_,N,j,F,U){const x={manifest:d(N,c.Manifest),readme:d(N,c.Details),changelog:d(N,c.Changelog),license:d(N,c.License),repository:l(N),download:g(N),icon:E(N),coreTranslations:a(N)};return{identifier:{id:(0,D.getGalleryExtensionId)(_.publisher.publisherName,_.extensionName),uuid:_.extensionId},name:_.extensionName,version:N.version,date:N.lastUpdated,displayName:_.displayName,publisherId:_.publisher.publisherId,publisher:_.publisher.publisherName,publisherDisplayName:_.publisher.displayName,description:_.shortDescription||"",installCount:u(_.statistics,"install"),rating:u(_.statistics,"averagerating"),ratingCount:u(_.statistics,"ratingcount"),assetUri:m.URI.parse(N.assetUri),webExtension:!!_.tags?.includes(L.WEB_EXTENSION_TAG),assetTypes:N.files.map(({assetType:q})=>q),assets:x,properties:{dependencies:T(N,t.Dependency),extensionPack:T(N,t.ExtensionPack),engine:O(N),localizedLanguages:$(N)},telemetryData:{index:(F.pageNumber-1)*F.pageSize+j,querySource:U},preview:z(_.flags)}}let B=class{constructor(N,j,F,U,x,q,H){this.requestService=N,this.logService=j,this.environmentService=F,this.telemetryService=U,this.fileService=x,this.productService=q;const Y=q.extensionsGallery;this.extensionsGalleryUrl=Y&&Y.serviceUrl,this.extensionsControlUrl=Y&&Y.controlUrl,this.commonHeadersPromise=M(q.version,this.environmentService,this.fileService,H)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,j){const F=[];let{total:U,firstPage:x,getPage:q}=await this.query({names:N,pageSize:N.length},j);F.push(...x);for(let H=1;F.length<U&&(x=await q(H,j),x.length);H++)F.push(...x);return F}async getCompatibleExtension(N,j){return this.getCompatibleExtensionByEngine(N,j)}async getCompatibleExtensionByEngine(N,j){const F=(0,L.isIExtensionIdentifier)(N)?null:N;if(F&&F.properties.engine&&(0,S.isEngineValid)(F.properties.engine,this.productService.version,this.productService.date))return F;const{id:U,uuid:x}=F?F.identifier:N;let q=new o().withFlags(I.IncludeAssetUri,I.IncludeStatistics,I.IncludeCategoryAndTags,I.IncludeFiles,I.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");x?q=q.withFilter(s.ExtensionId,x):q=q.withFilter(s.ExtensionName,U);const{galleryExtensions:H}=await this.queryGallery(q,n.CancellationToken.None),[Y]=H;if(!Y||!Y.versions.length)return null;if(j){const ne=Y.versions.filter(se=>se.version===j)[0];if(ne){const se=V(Y,ne,0,q);if(se.properties.engine&&(0,S.isEngineValid)(se.properties.engine,this.productService.version,this.productService.date))return se}return null}const te=await this.getLastValidExtensionVersion(Y,Y.versions);return te?V(Y,te,0,q):null}async query(N,j){const F=n.CancellationToken.isCancellationToken(N)?{}:N,U=n.CancellationToken.isCancellationToken(N)?N:j;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let x=F.text||"";const q=(0,k.getOrDefault)(F,ee=>ee.pageSize,50);let H=new o().withFlags(I.IncludeLatestVersionOnly,I.IncludeAssetUri,I.IncludeStatistics,I.IncludeCategoryAndTags,I.IncludeFiles,I.IncludeVersionProperties).withPage(1,q).withFilter(s.Target,"Microsoft.VisualStudio.Code");x?(x=x.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ee,he,de)=>(H=H.withFilter(s.Category,de||he),"")),x=x.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ee,he,de)=>(H=H.withFilter(s.Tag,de||he),"")),x=x.replace(/\bfeatured(\s+|\b|$)/g,()=>(H=H.withFilter(s.Featured),"")),x=x.trim(),x&&(x=x.length<200?x:x.substring(0,200),H=H.withFilter(s.SearchText,x)),H=H.withSortBy(0)):F.ids?H=H.withFilter(s.ExtensionId,...F.ids):F.names?H=H.withFilter(s.ExtensionName,...F.names):H=H.withSortBy(4),typeof F.sortBy=="number"&&(H=H.withSortBy(F.sortBy)),typeof F.sortOrder=="number"&&(H=H.withSortOrder(F.sortOrder));const{galleryExtensions:Y,total:te}=await this.queryGallery(H,U),ne=Y.map((ee,he)=>V(ee,ee.versions[0],he,H,F.source)),se=async(ee,he)=>{if(he.isCancellationRequested)throw(0,p.canceled)();const de=H.withPage(ee+1),{galleryExtensions:ye}=await this.queryGallery(de,he);return ye.map((Se,De)=>V(Se,Se.versions[0],De,de,F.source))};return{firstPage:ne,total:te,pageSize:H.pageSize,getPage:se}}async queryGallery(N,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,I.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,f(I.Unpublished));const F=await this.commonHeadersPromise,U=JSON.stringify(N.raw),x={...F,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(U.length)},q=new Date().getTime();let H,Y,te=0;try{if(H=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:U,headers:x},j),H.res.statusCode&&H.res.statusCode>=400&&H.res.statusCode<500)return{galleryExtensions:[],total:te};const ne=await(0,R.asJson)(H);if(ne){const se=ne.results[0],ee=se.extensions,he=se.resultMetadata&&se.resultMetadata.filter(de=>de.metadataType==="ResultCount")[0];return te=he&&he.metadataItems.filter(de=>de.name==="TotalCount")[0].count||0,{galleryExtensions:ee,total:te}}return{galleryExtensions:[],total:te}}catch(ne){throw Y=ne,ne}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(U.length),duration:new Date().getTime()-q,success:!!H&&(0,R.isSuccess)(H),responseBodySize:H?.res.headers["Content-Length"],statusCode:H?String(H.res.statusCode):void 0,errorCode:Y?(0,p.isPromiseCanceledError)(Y)?"canceled":(0,p.getErrorMessage)(Y).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(te)})}}async reportStatistic(N,j,F,U){if(!this.isEnabled())return;const q={...await this.commonHeadersPromise,Accept:"*/*;api-version=4.0-preview.1"};try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${N}/extensions/${j}/${F}/stats?statType=${U}`),headers:q},n.CancellationToken.None)}catch(H){}}async download(N,j,F){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const U=(0,D.getGalleryExtensionTelemetryData)(N),x=new Date().getTime(),q=ne=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...U,duration:ne}),H=F===1?"install":F===2?"update":"",Y=H?{uri:`${N.assets.download.uri}&${H}=true`,fallbackUri:`${N.assets.download.fallbackUri}?${H}=true`}:N.assets.download,te=await this.getAsset(Y);await this.fileService.writeFile(j,te.stream),q(new Date().getTime()-x)}async getReadme(N,j){if(N.assets.readme){const F=await this.getAsset(N.assets.readme,{},j);return await(0,R.asText)(F)||""}return""}async getManifest(N,j){if(N.assets.manifest){const F=await this.getAsset(N.assets.manifest,{},j),U=await(0,R.asText)(F);return U?JSON.parse(U):null}return null}async getCoreTranslation(N,j){const F=N.assets.coreTranslations.filter(U=>U[0]===j.toUpperCase())[0];if(F){const U=await this.getAsset(F[1]),x=await(0,R.asText)(U);return x?JSON.parse(x):null}return null}async getChangelog(N,j){if(N.assets.changelog){const F=await this.getAsset(N.assets.changelog,{},j);return await(0,R.asText)(F)||""}return""}async getAllVersions(N,j){let F=new o().withFlags(I.IncludeVersions,I.IncludeCategoryAndTags,I.IncludeFiles,I.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");N.identifier.uuid?F=F.withFilter(s.ExtensionId,N.identifier.uuid):F=F.withFilter(s.ExtensionName,N.identifier.id);const U=[],{galleryExtensions:x}=await this.queryGallery(F,n.CancellationToken.None);return x.length&&(j?await Promise.all(x[0].versions.map(async q=>{let H;try{H=await this.getEngine(q)}catch(Y){}H&&(0,S.isEngineValid)(H,this.productService.version,this.productService.date)&&U.push({version:q.version,date:q.lastUpdated})})):U.push(...x[0].versions.map(q=>({version:q.version,date:q.lastUpdated})))),U}async getAsset(N,j={},F=n.CancellationToken.None){const U=await this.commonHeadersPromise,x={type:"GET"},q={...U,...j.headers||{}};j={...j,...x,headers:q};const H=N.uri,Y=N.fallbackUri,te={...j,url:H};try{const ne=await this.requestService.request(te,F);if(ne.res.statusCode===200)return ne;const se=await(0,R.asText)(ne);throw new Error(`Expected 200, got back ${ne.res.statusCode} instead.

${se}`)}catch(ne){if((0,p.isPromiseCanceledError)(ne))throw ne;const se=(0,p.getErrorMessage)(ne);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:H,message:se});const ee={...j,url:Y};return this.requestService.request(ee,F)}}async getLastValidExtensionVersion(N,j){const F=this.getLastValidExtensionVersionFromProperties(N,j);return F||this.getLastValidExtensionVersionRecursively(N,j)}getLastValidExtensionVersionFromProperties(N,j){for(const F of j){const U=O(F);if(!U)return null;if((0,S.isEngineValid)(U,this.productService.version,this.productService.date))return F}return null}async getEngine(N){const j=O(N);if(j)return j;const F=d(N,c.Manifest);if(!F)throw new Error("Manifest was not found");const U={"Accept-Encoding":"gzip"},x=await this.getAsset(F,{headers:U}),q=await(0,R.asJson)(x);if(q)return q.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(N,j){if(!j.length)return null;const F=j[0],U=await this.getEngine(F);return(0,S.isEngineValid)(U,this.productService.version,this.productService.date)?{...F,properties:[...F.properties||[],{key:t.Engine,value:U}]}:this.getLastValidExtensionVersionRecursively(N,j.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const j=await(0,R.asJson)(N),F=new Map;if(j)for(const U of j.malicious){const x=F.get(U)||{id:{id:U},malicious:!0,slow:!1};x.malicious=!0,F.set(U,x)}return[...F.values()]}};B=fe([K(0,R.IRequestService),K(1,y.ILogService),K(2,w.IEnvironmentService),K(3,A.ITelemetryService),K(4,v.IFileService),K(5,h.IProductService),K(6,(0,b.optional)(C.IStorageService))],B),e.ExtensionGalleryService=B;async function M(_,N,j,F){const U={"X-Market-Client-Id":`VSCode ${_}`,"User-Agent":`VSCode ${_}`},x=await(0,P.getServiceMachineId)(N,j,F);return U["X-Market-User-Id"]=x,U}e.resolveMarketplaceHeaders=M}),define(X[177],Q([0,1,4,8,28,12,34,13,7,23,27,63,39,14,169,6,21,73,112,20,3,58]),function(G,e,p,L,D,k,A,R,S,w,n,y,v,m,h,C,P,b,I,f,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",r="extensionTips/lastPromptedMediumImpExeTime";let i=class extends h.ExtensionTipsService{constructor(u,a,l,g,E,d,T,O,$,z){super(T,O,$,z);this.environmentService=u,this.telemetryService=a,this.extensionManagementService=l,this.storageService=g,this.nativeHostService=E,this.extensionRecommendationNotificationService=d,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&(0,y.forEach)(O.exeBasedExtensionTips,({key:V,value:B})=>{const M=[],_=[],N=[];(0,y.forEach)(B.recommendations,({key:j,value:F})=>{F.important?B.important?M.push({extensionId:j,extensionName:F.name,isExtensionPack:!!F.isExtensionPack}):_.push({extensionId:j,extensionName:F.name,isExtensionPack:!!F.isExtensionPack}):N.push({extensionId:j,extensionName:F.name,isExtensionPack:!!F.isExtensionPack})}),M.length&&this.highImportanceExecutableTips.set(V,{exeFriendlyName:B.friendlyName,windowsPath:B.windowsPath,recommendations:M}),_.length&&this.mediumImportanceExecutableTips.set(V,{exeFriendlyName:B.friendlyName,windowsPath:B.windowsPath,recommendations:_}),N.length&&this.allOtherExecutableTips.set(V,{exeFriendlyName:B.friendlyName,windowsPath:B.windowsPath,recommendations:N})}),(0,C.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),a=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...u,...a]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),a=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),l=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(u,l),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(a,l)}groupImportantTipsByExe(u,a){const l=new Map;u.forEach(O=>l.set(O.extensionId.toLowerCase(),O));const{installed:g,uninstalled:E}=this.groupByInstalled([...l.keys()],a);for(const O of g){const $=l.get(O);$&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:$.exeName})}for(const O of E){const $=l.get(O);$&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:$.exeName})}const d=this.getPromptedExecutableTips(),T=new Map;for(const O of E){const $=l.get(O);if($&&(!d[$.exeName]||!d[$.exeName].includes($.extensionId))){let z=T.get($.exeName);z||(z=[],T.set($.exeName,z)),z.push($)}}return T}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[u,a]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(a).then(l=>{switch(l){case"reacted":this.addToRecommendedExecutables(a[0].exeName,a);break;case"ignored":this.highImportanceTipsByExe.delete(u);break;case"incompatibleWindow":const g=s.Event.once(s.Event.latch(s.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(g(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const E=this._register((0,C.disposableTimeout)(()=>{E.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const u=this.getLastPromptedMediumExeTime(),a=Date.now()-u,l=7*24*60*60*1e3;if(a<l){const d=this._register((0,C.disposableTimeout)(()=>{d.dispose(),this.promptMediumImportanceExeBasedTip()},l-a));return}const[g,E]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(E).then(d=>{switch(d){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(g),this.addToRecommendedExecutables(E[0].exeName,E);const T=this._register((0,C.disposableTimeout)(()=>{T.dispose(),this.promptMediumImportanceExeBasedTip()},l));break;case"ignored":this.mediumImportanceTipsByExe.delete(g),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const O=s.Event.once(s.Event.latch(s.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(O(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const $=this._register((0,C.disposableTimeout)(()=>{$.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(u){const a=u.map(({extensionId:g})=>g.toLowerCase()),l=(0,I.localize)(0,null,u[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(a,l,`@exe:"${u[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let u=this.storageService.getNumber(r,0);return u||(u=Date.now(),this.updateLastPromptedMediumExeTime(u)),u}updateLastPromptedMediumExeTime(u){this.storageService.store(r,u,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(u,a){const l=this.getPromptedExecutableTips();l[u]=a.map(({extensionId:g})=>g.toLowerCase()),this.storageService.store(t,JSON.stringify(l),0,0)}groupByInstalled(u,a){const l=[],g=[],E=a.reduce((d,T)=>(d.add(T.identifier.id.toLowerCase()),d),new Set);return u.forEach(d=>{E.has(d.toLowerCase())?l.push(d):g.push(d)}),{installed:l,uninstalled:g}}async getValidExecutableBasedExtensionTips(u){const a=[],l=new Map;for(const g of u.keys()){const E=u.get(g);if(!E||!(0,w.isNonEmptyArray)(E.recommendations))continue;const d=[];S.isWindows?E.windowsPath&&d.push(E.windowsPath.replace("%USERPROFILE%",A.env.USERPROFILE).replace("%ProgramFiles(x86)%",A.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",A.env.ProgramFiles).replace("%APPDATA%",A.env.APPDATA).replace("%WINDIR%",A.env.WINDIR)):(d.push((0,L.join)("/usr/local/bin",g)),d.push((0,L.join)("/usr/bin",g)),d.push((0,L.join)(this.environmentService.userHome.fsPath,g)));for(const T of d){let O=l.get(T);if(O===void 0&&(O=await this.fileService.exists(p.URI.file(T)),l.set(T,O)),O)for(const{extensionId:$,extensionName:z,isExtensionPack:V}of E.recommendations)a.push({extensionId:$,extensionName:z,isExtensionPack:V,exeName:g,exeFriendlyName:E.exeFriendlyName,windowsPath:E.windowsPath})}}return a}};i=fe([K(0,k.INativeEnvironmentService),K(1,P.ITelemetryService),K(2,n.IExtensionManagementService),K(3,f.IStorageService),K(4,c.INativeHostService),K(5,b.IExtensionRecommendationNotificationService),K(6,R.IFileService),K(7,D.IProductService),K(8,v.IRequestService),K(9,m.ILogService)],i),e.ExtensionTipsService=i}),define(X[80],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class p{constructor(k){this.appender=k}listen(k,A){throw new Error(`Event not found: ${A}`)}call(k,A,{eventName:R,data:S}){return this.appender.log(R,S),Promise.resolve(null)}}e.TelemetryAppenderChannel=p;class L{constructor(k){this.channel=k}log(k,A){return this.channel.call("log",{eventName:k,data:A}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(X[81],Q([0,1,44,122,19,5,24,37,2,26,32]),function(G,e,p,L,D,k,A,R,S,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{constructor(h,C){this._configurationService=C,this._experimentProperties={},this._disposables=new S.DisposableStore,this._cleanupPatterns=[],this._appender=h.appender,this._commonProperties=h.commonProperties||Promise.resolve({}),this._piiPaths=h.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!h.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(P),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(P=>{const b=/^[a-f0-9]+$/i.test(P["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!b})}))}setExperimentProperty(h,C){this._experimentProperties[h]=C}setEnabled(h){this._enabled=h}_updateUserOptIn(){const h=this._configurationService?.getValue(v);this._userOptIn=h?h.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const h=await this._commonProperties;let C=h.sessionID,P=h["common.instanceId"],b=h["common.machineId"],I=h["common.firstSessionDate"],f=h["common.msftInternal"];return{sessionId:C,instanceId:P,machineId:b,firstSessionDate:I,msftInternal:f}}dispose(){this._disposables.dispose()}publicLog(h,C,P){return this.isOptedIn?this._commonProperties.then(b=>{C=(0,w.mixin)(C,b),C=(0,w.mixin)(C,this._experimentProperties),C=(0,w.cloneAndChange)(C,I=>{if(typeof I=="string")return this._cleanupInfo(I,P)}),this._appender.log(h,C)},b=>{console.error(b)}):Promise.resolve(void 0)}publicLog2(h,C,P){return this.publicLog(h,C,P)}publicLogError(h,C){return this.sendErrorTelemetry?this.publicLog(h,C,!0):Promise.resolve(void 0)}publicLogError2(h,C){return this.publicLogError(h,C)}_cleanupInfo(h,C){let P=h;if(C){const b=[];for(let c of this._cleanupPatterns)for(;;){const t=c.exec(h);if(!t)break;b.push([t.index,c.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,f=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(P="";;){const c=f.exec(h);if(!c)break;!I.test(c[0])&&b.every(([t,r])=>c.index<t||c.index>=r)&&(P+=h.substring(s,c.index)+"<REDACTED: user-file-path>",s=f.lastIndex)}s<h.length&&(P+=h.substr(s))}for(let b of this._cleanupPatterns)P=P.replace(b,"");return P}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=fe([K(1,(0,k.optional)(A.IConfigurationService))],y),e.TelemetryService=y;const v="telemetry";n.Registry.as(R.Extensions.Configuration).registerConfiguration({id:v,order:110,type:"object",title:(0,L.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:p.default.privacyStatementUrl?(0,L.localize)(2,null,p.default.privacyStatementUrl):(0,L.localize)(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(X[59],Q([0,1,24,26,16,6]),function(G,e,p,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(h,C){return Promise.resolve(void 0)}publicLog2(h,C){return this.publicLog(h,C)}publicLogError(h,C){return Promise.resolve(void 0)}publicLogError2(h,C){return this.publicLogError(h,C)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class A{async publicLog(C,P,b){}async publicLogError(C,P,b){}}e.NullEndpointTelemetryService=A;function R(...h){return{log:(C,P)=>h.forEach(b=>b.log(C,P)),flush:()=>k.Promises.settled(h.map(C=>C.flush()))}}e.combinedAppender=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(h,C){return C.onDidChangeConfiguration(P=>{P.source!==6&&h.publicLog2("updateConfiguration",{configurationSource:(0,p.ConfigurationTargetToString)(P.source),configurationKeys:v(P.sourceConfig)})})}e.configurationTelemetry=S;function w(h){const C=Object.create(null),P=Object.create(null),b=Object.create(null);y(h,b);for(let I in b){I=I.length>150?I.substr(I.length-149):I;const f=b[I];typeof f=="number"?P[I]=f:typeof f=="boolean"?P[I]=f?1:0:typeof f=="string"?C[I]=f.substring(0,1023):typeof f!="undefined"&&f!==null&&(C[I]=f)}return{properties:C,measurements:P}}e.validateTelemetryData=w;function n(h){if(!h)return"none";let C="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(b=>{h.indexOf(`${b}+`)===0&&(C=b)}),C}e.cleanRemoteAuthority=n;function y(h,C,P=0,b){if(!!h)for(let I of Object.getOwnPropertyNames(h)){const f=h[I],s=b?b+I:I;Array.isArray(f)?C[s]=(0,L.safeStringify)(f):f instanceof Date?C[s]=f.toISOString():(0,D.isObject)(f)?P<2?y(f,C,P+1,s+"."):C[s]=(0,L.safeStringify)(f):C[s]=f}}function v(h){if(!h)return[];const C=[];return m(C,"",h),C}function m(h,C,P){P&&typeof P=="object"&&!Array.isArray(P)?Object.keys(P).forEach(b=>m(h,C?`${C}.${b}`:b,P[b])):h.push(C)}}),define(X[178],Q([0,1,2,12,14,59]),function(G,e,p,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends p.Disposable{constructor(S,w){super();this.logger=this._register(S.createLogger(w.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}flush(){return Promise.resolve(void 0)}log(S,w){this.logger.trace(`telemetry/${S}`,(0,k.validateTelemetryData)(w))}};A=fe([K(0,D.ILoggerService),K(1,L.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(X[179],Q([0,1,9,26,59]),function(G,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function k(R){const S=await new Promise((n,y)=>{G(["applicationinsights"],n,y)});let w;return S.defaultClient?(w=new S.TelemetryClient(R),w.channel.setUseDiskRetryCaching(!0)):(S.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),w=S.defaultClient),R.indexOf("AIF-")===0&&(w.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),w}class A{constructor(S,w,n){this._eventPrefix=S,this._defaultData=w,this._defaultData||(this._defaultData=Object.create(null)),typeof n=="function"?this._aiClient=n():this._aiClient=n,this._asyncAIClient=null}_withAIClient(S){if(!!this._aiClient){if(typeof this._aiClient!="string"){S(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=k(this._aiClient)),this._asyncAIClient.then(w=>{S(w)},w=>{(0,p.onUnexpectedError)(w),console.error(w)})}}log(S,w){!this._aiClient||(w=(0,L.mixin)(w,this._defaultData),w=(0,D.validateTelemetryData)(w),this._withAIClient(n=>n.trackEvent({name:this._eventPrefix+"/"+S,properties:w.properties,measurements:w.measurements})))}flush(){return this._aiClient?new Promise(S=>{this._withAIClient(w=>{w.flush({callback:()=>{this._aiClient=void 0,S(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(X[180],Q([0,1,50,80,17,81,24,21]),function(G,e,p,L,D,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let S=class{constructor(n,y){this.configurationService=n,this.telemetryService=y,this.customTelemetryServices=new Map}async getCustomTelemetryService(n){if(!this.customTelemetryServices.has(n.id)){const{machineId:y,sessionId:v}=await this.telemetryService.getTelemetryInfo(),m=Object.create(null);m["common.vscodemachineid"]=y,m["common.vscodesessionid"]=v;const h=[n.id,JSON.stringify(m),n.aiKey],P=new p.Client(D.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:h,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),b=new L.TelemetryAppenderClient(P);this.customTelemetryServices.set(n.id,new k.TelemetryService({appender:b,sendErrorTelemetry:n.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(n.id)}async publicLog(n,y,v){await(await this.getCustomTelemetryService(n)).publicLog(y,v)}async publicLogError(n,y,v){await(await this.getCustomTelemetryService(n)).publicLogError(y,v)}};S=fe([K(0,A.IConfigurationService),K(1,R.ITelemetryService)],S),e.CustomEndpointTelemetryService=S}),define(X[82],Q([0,1,5]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var L;(function(m){m.Shell="terminal.integrated.shell.",m.ShellArgs="terminal.integrated.shellArgs.",m.DefaultProfile="terminal.integrated.defaultProfile.",m.Profiles="terminal.integrated.profiles."})(L=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(m){m.ShellLinux="terminal.integrated.shell.linux",m.ShellMacOs="terminal.integrated.shell.osx",m.ShellWindows="terminal.integrated.shell.windows",m.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",m.AutomationShellLinux="terminal.integrated.automationShell.linux",m.AutomationShellMacOs="terminal.integrated.automationShell.osx",m.AutomationShellWindows="terminal.integrated.automationShell.windows",m.ShellArgsLinux="terminal.integrated.shellArgs.linux",m.ShellArgsMacOs="terminal.integrated.shellArgs.osx",m.ShellArgsWindows="terminal.integrated.shellArgs.windows",m.ProfilesWindows="terminal.integrated.profiles.windows",m.ProfilesMacOs="terminal.integrated.profiles.osx",m.ProfilesLinux="terminal.integrated.profiles.linux",m.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",m.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",m.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",m.UseWslProfiles="terminal.integrated.useWslProfiles",m.TabsEnabled="terminal.integrated.tabs.enabled",m.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",m.TabsHideCondition="terminal.integrated.tabs.hideCondition",m.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",m.TabsShowActions="terminal.integrated.tabs.showActions",m.TabsLocation="terminal.integrated.tabs.location",m.TabsFocusMode="terminal.integrated.tabs.focusMode",m.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",m.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",m.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",m.CopyOnSelection="terminal.integrated.copyOnSelection",m.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",m.FontFamily="terminal.integrated.fontFamily",m.FontSize="terminal.integrated.fontSize",m.LetterSpacing="terminal.integrated.letterSpacing",m.LineHeight="terminal.integrated.lineHeight",m.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",m.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",m.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",m.BellDuration="terminal.integrated.bellDuration",m.FontWeight="terminal.integrated.fontWeight",m.FontWeightBold="terminal.integrated.fontWeightBold",m.CursorBlinking="terminal.integrated.cursorBlinking",m.CursorStyle="terminal.integrated.cursorStyle",m.CursorWidth="terminal.integrated.cursorWidth",m.Scrollback="terminal.integrated.scrollback",m.DetectLocale="terminal.integrated.detectLocale",m.DefaultLocation="terminal.integrated.defaultLocation",m.GpuAcceleration="terminal.integrated.gpuAcceleration",m.RightClickBehavior="terminal.integrated.rightClickBehavior",m.Cwd="terminal.integrated.cwd",m.ConfirmOnExit="terminal.integrated.confirmOnExit",m.EnableBell="terminal.integrated.enableBell",m.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",m.AllowChords="terminal.integrated.allowChords",m.AllowMnemonics="terminal.integrated.allowMnemonics",m.EnvMacOs="terminal.integrated.env.osx",m.EnvLinux="terminal.integrated.env.linux",m.EnvWindows="terminal.integrated.env.windows",m.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",m.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",m.ShowExitAlert="terminal.integrated.showExitAlert",m.SplitCwd="terminal.integrated.splitCwd",m.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",m.WordSeparators="terminal.integrated.wordSeparators",m.TitleMode="terminal.integrated.titleMode",m.EnableFileLinks="terminal.integrated.enableFileLinks",m.UnicodeVersion="terminal.integrated.unicodeVersion",m.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",m.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",m.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",m.LocalEchoStyle="terminal.integrated.localEchoStyle",m.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",m.InheritEnv="terminal.integrated.inheritEnv",m.ShowLinkHover="terminal.integrated.showLinkHover"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var k;(function(m){m.CommandPrompt="cmd",m.PowerShell="pwsh",m.Wsl="wsl",m.GitBash="gitbash"})(k=e.WindowsShellType||(e.WindowsShellType={}));var A;(function(m){m[m.Api=0]="Api",m[m.Process=1]="Process",m[m.Sequence=2]="Sequence"})(A=e.TitleEventSource||(e.TitleEventSource={}));var R;(function(m){m.LocalPty="localPty",m.PtyHost="ptyHost",m.Log="log",m.Heartbeat="heartbeat"})(R=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,p.createDecorator)("ptyService");var S;(function(m){m[m.BeatInterval=5e3]="BeatInterval",m[m.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",m[m.SecondWaitMultiplier=1]="SecondWaitMultiplier",m[m.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(S=e.HeartbeatConstants||(e.HeartbeatConstants={}));var w;(function(m){m.TerminalView="view",m.Editor="editor"})(w=e.TerminalLocation||(e.TerminalLocation={}));var n;(function(m){m[m.GraceTime=6e4]="GraceTime",m[m.ShortGraceTime=6e3]="ShortGraceTime"})(n=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var y;(function(m){m[m.HighWatermarkChars=1e5]="HighWatermarkChars",m[m.LowWatermarkChars=5e3]="LowWatermarkChars",m[m.CharCountAckSize=5e3]="CharCountAckSize"})(y=e.FlowControlConstants||(e.FlowControlConstants={}));var v;(function(m){m.GitBash="Git Bash",m.Pwsh="PowerShell"})(v=e.ProfileSource||(e.ProfileSource={}))}),define(X[181],Q([0,1,5]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,p.createDecorator)("localPtyService")}),define(X[182],Q([0,1,35,8,34,18,16,26,7]),function(G,e,p,L,D,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function w(){const y=/(\d+)\.(\d+)\.(\d+)/g.exec(p.release());let v=0;return y&&y.length===4&&(v=parseInt(y[3])),v}e.getWindowsBuildNumber=w;async function n(y,v,m,h=D.env,C=k.Promises.exists){if(L.isAbsolute(y))return await C(y)?y:void 0;if(v===void 0&&(v=D.cwd()),L.dirname(y)!=="."){const f=L.join(v,y);return await C(f)?f:void 0}const b=(0,R.getCaseInsensitive)(h,"PATH");if(m===void 0&&(0,A.isString)(b)&&(m=b.split(L.delimiter)),m===void 0||m.length===0){const f=L.join(v,y);return await C(f)?f:void 0}for(let f of m){let s;if(L.isAbsolute(f)?s=L.join(f,y):s=L.join(v,f,y),await C(s))return s;if(S.isWindows){let c=s+".com";if(await C(c)||(c=s+".exe",await C(c)))return c}}const I=L.join(v,y);return await C(I)?I:void 0}e.findExecutable=n}),define(X[183],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var p;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(p=e.ColorScheme||(e.ColorScheme={}))}),define(X[83],Q([0,1,5,2,32,3,183,54]),function(G,e,p,L,D,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,p.createDecorator)("themeService");var S;(function(P){function b(I){return I&&typeof I=="object"&&typeof I.id=="string"}P.isThemeColor=b})(S=e.ThemeColor||(e.ThemeColor={}));function w(P){return{id:P}}e.themeColorFromId=w;var n;(function(P){function b(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||S.isThemeColor(r.color))}P.isThemeIcon=b;const I=new RegExp(`^\\$\\((${R.CSSIcon.iconNameExpression}(?:${R.CSSIcon.iconModifierExpression})?)\\)$`);function f(r){const i=I.exec(r);if(!i)return;let[,o]=i;return{id:o}}P.fromString=f;function s(r,i){let o=r.id;const u=o.lastIndexOf("~");return u!==-1&&(o=o.substring(0,u)),i&&(o=`${o}~${i}`),{id:o}}P.modify=s;function c(r,i){return r.id===i.id&&r.color?.id===i.color?.id}P.isEqual=c;function t(r,i){return{id:r.id,color:i?w(i):void 0}}P.asThemeIcon=t,P.asClassNameArray=R.CSSIcon.asClassNameArray,P.asClassName=R.CSSIcon.asClassName,P.asCSSSelector=R.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=R.Codicon.file,e.FolderThemeIcon=R.Codicon.folder;function y(P){switch(P){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class v{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new k.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),(0,L.toDisposable)(()=>{const I=this.themingParticipants.indexOf(b);this.themingParticipants.splice(I,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new v;D.Registry.add(e.Extensions.ThemingContribution,m);function h(P){return m.onColorThemeChange(P)}e.registerThemingParticipant=h;class C extends L.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(I=>this.onThemeChange(I)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,I){let f=this.theme.getColor(b);return f&&I&&(f=I(f,this.theme)),f?f.toString():null}}e.Themable=C}),define(X[184],Q([0,1,37,123,32,54,83]),function(G,e,p,L,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const R={args:{description:(0,L.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,L.localize)(1,null),type:"boolean"},icon:{description:(0,L.localize)(2,null),type:"string",enum:Array.from(k.iconRegistry.all,b=>b.id),markdownEnumDescriptions:Array.from(k.iconRegistry.all,b=>`$(${b.id})`)},color:{description:(0,L.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,L.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},S={type:"object",required:["path"],properties:{path:{description:(0,L.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},w=(0,L.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),n=(0,L.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),y=(0,L.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),v={id:"terminal",order:100,title:(0,L.localize)(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:n},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(15,null),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:w},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:n},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,L.localize)(19,null)}},{type:"string",markdownDescription:(0,L.localize)(20,null)}],default:[],markdownDeprecationMessage:y},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,L.localize)(22,null),enum:["PowerShell","Git Bash"]},...R}},{type:"null"},S]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(23,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"null"},S]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(24,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"null"},S]}},["terminal.integrated.useWslProfiles"]:{description:(0,L.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,L.localize)(26,null),type:"boolean",default:!0},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,L.localize)(27,null),type:"boolean",default:!0}}};function m(){D.Registry.as(p.Extensions.Configuration).registerConfiguration(v),C()}e.registerTerminalPlatformConfiguration=m;let h;function C(b){const I=D.Registry.as(p.Extensions.Configuration);h&&I.deregisterConfigurations([h]);let f,s;if(b){const c=b.profiles.map(t=>({name:t.profileName,description:P(t)}));f=c.map(t=>t.name),s=c.map(t=>t.description)}h={id:"terminal",order:100,title:(0,L.localize)(28,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(29,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:b?.os===3?f:void 0,markdownEnumDescriptions:b?.os===3?s:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(30,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:b?.os===2?f:void 0,markdownEnumDescriptions:b?.os===2?s:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(31,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:b?.os===1?f:void 0,markdownEnumDescriptions:b?.os===1?s:void 0}}},I.registerConfiguration(h)}e.registerTerminalDefaultProfileConfiguration=C;function P(b){let I=`$(${A.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:k.Codicon.terminal.id}) ${b.profileName}
- path: ${b.path}`;return b.args&&(typeof b.args=="string"?I+=`
- args: "${b.args}"`:I+=`
- args: [${b.args.length===0?"":b.args.join("','")}]`),b.overrideName!==void 0&&(I+=`
- overrideName: ${b.overrideName}`),b.color&&(I+=`
- color: ${b.color}`),b.env&&(I+=`
- env: ${JSON.stringify(b.env)}`),I}}),define(X[185],Q([0,1,8,97,182,42,18,54,7,83]),function(G,e,p,L,D,k,A,R,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let n;function y(t,r,i,o,u,a,l,g){return u=u||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},S.isWindows?v(i,u,a,o.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:o.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:o.getValue("terminal.integrated.defaultProfile.windows"),g,l):f(u,a,i,t&&typeof t=="object"?{...t}:o.getValue(S.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:o.getValue(S.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),g,l)}e.detectAvailableProfiles=y;async function v(t,r,i,o,u,a,l,g){const E=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),d=`${process.env.windir}\\${E?"Sysnative":"System32"}`;let T=!1;(0,D.getWindowsBuildNumber)()>=16299&&(T=!0),await C(l);const O=new Map;t&&(O.set("PowerShell",{source:"PowerShell",icon:R.Codicon.terminalPowershell,isAutoDetected:!0}),O.set("Windows PowerShell",{path:`${d}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:R.Codicon.terminalPowershell,isAutoDetected:!0}),O.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),O.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),O.set("Command Prompt",{path:`${d}\\cmd.exe`,icon:R.Codicon.terminalCmd,isAutoDetected:!0})),s(u,O);const $=await m(O.entries(),a,r,i,g);if(t||!t&&o)try{const z=await b(`${d}\\${T?"wsl":"bash"}.exe`,a);for(const V of z)(!u||!(V.profileName in u))&&$.push(V)}catch(z){i?.info("WSL is not installed, so could not detect WSL profiles")}return $}async function m(t,r,i,o,u){const a=[];for(const[l,g]of t){if(g===null)continue;let E,d,T;if("source"in g){const z=n?.get(g.source);if(!z)continue;E=z.paths,d=g.args||z.args,g.icon?T=h(g.icon):z.icon&&(T=z.icon)}else E=Array.isArray(g.path)?g.path:[g.path],d=S.isWindows||Array.isArray(g.args)?g.args:void 0,T=h(g.icon)||void 0;const O=await u?.(E)||E.slice(),$=await c(l,r,O,i,d,g.env,g.overrideName,g.isAutoDetected,o);$?($.isAutoDetected=g.isAutoDetected,$.icon=T,$.color=g.color,a.push($)):o?.trace("profile not validated",l,E)}return a}function h(t){return typeof t=="string"?{id:t}:t}async function C(t){n&&!t||(n=new Map,n.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),n.set("PowerShell",{profileName:"PowerShell",paths:t||await P(),icon:w.ThemeIcon.asThemeIcon(R.Codicon.terminalPowershell)}))}async function P(){const t=[];for await(const r of(0,L.enumeratePowerShellInstallations)())t.push(r.exePath);return t}async function b(t,r){const i=[],o=await new Promise((l,g)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le"},(E,d)=>{if(E)return g("Problem occurred when getting wsl distros");l(d)})});if(!o)return[];const u=new RegExp(/[\r?\n]/),a=o.split(u).filter(l=>l.trim().length>0&&l!=="");for(const l of a){if(l===""||l.startsWith("docker-desktop"))continue;const g=`${l} (WSL)`,E={profileName:g,path:t,args:["-d",`${l}`],isDefault:g===r,icon:I(l)};i.push(E)}return i}function I(t){return t.includes("Ubuntu")?w.ThemeIcon.asThemeIcon(R.Codicon.terminalUbuntu):t.includes("Debian")?w.ThemeIcon.asThemeIcon(R.Codicon.terminalDebian):w.ThemeIcon.asThemeIcon(R.Codicon.terminalLinux)}async function f(t,r,i,o,u,a,l){const g=new Map;if(i){const E=(await t.readFile("/etc/shells")).toString(),d=a||E.split(`
`).filter(O=>O.trim().indexOf("#")!==0&&O.trim().length>0),T=new Map;for(const O of d){let $=(0,p.basename)(O),z=T.get($)||0;z++,z>1&&($=`${$} (${z})`),T.set($,z),g.set($,{path:O,isAutoDetected:!0})}}return s(o,g),await m(g.entries(),u,t,r,l)}function s(t,r){if(!!t)for(const[i,o]of Object.entries(t))o===null||!("path"in o)&&!("source"in o)?r.delete(i):r.set(i,o)}async function c(t,r,i,o,u,a,l,g,E){if(i.length===0)return Promise.resolve(void 0);const d=i.shift();if(d==="")return c(t,r,i,o,u,a,l,g);const T={profileName:t,path:d,args:u,env:a,overrideName:l,isAutoDetected:g,isDefault:t===r};if((0,p.basename)(d)===d){const $=process.env.PATH?process.env.PATH.split(p.delimiter):void 0;return await(0,D.findExecutable)(d,void 0,$,void 0,o.existsFile)?T:c(t,r,i,o,u)}return await o.existsFile((0,p.normalize)(d))?T:c(t,r,i,o,u,a,l,g)}}),define(X[186],Q([0,1,2,14,82,50,17,36,3,77,21,185,24,184]),function(G,e,p,L,D,k,A,R,S,w,n,y,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var h;(function(I){I[I.MaxRestarts=5]="MaxRestarts"})(h||(h={}));let C=0,P=0,b=class extends p.Disposable{constructor(f,s,c,t){super();this._reconnectConstants=f,this._configurationService=s,this._logService=c,this._telemetryService=t,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new S.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new S.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new S.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new S.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new S.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new S.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new S.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new S.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new S.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new S.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new S.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new S.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new S.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new S.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._pendingResolveVariablesRequests=new Map,(0,m.registerTerminalPlatformConfiguration)(),this._register((0,p.toDisposable)(()=>this._disposePtyHost())),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const f=new k.Client(A.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:C,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.GraceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.ShortGraceTime}});this._onPtyHostStart.fire(),R.ProxyChannel.toService(f.getChannel(D.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(f.onDidProcessExit(r=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(r.code),this._isDisposed||(this._restartCount<=h.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}, giving up`))}));const c=f.getChannel(D.TerminalIpcChannels.Log);w.LogLevelChannelClient.setLevel(c,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{w.LogLevelChannelClient.setLevel(c,this._logService.getLevel())}));const t=R.ProxyChannel.toService(f.getChannel(D.TerminalIpcChannels.PtyHost));return this._register(t.onProcessData(r=>this._onProcessData.fire(r))),this._register(t.onProcessExit(r=>this._onProcessExit.fire(r))),this._register(t.onProcessReady(r=>this._onProcessReady.fire(r))),this._register(t.onProcessTitleChanged(r=>this._onProcessTitleChanged.fire(r))),this._register(t.onProcessShellTypeChanged(r=>this._onProcessShellTypeChanged.fire(r))),this._register(t.onProcessOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r))),this._register(t.onProcessResolvedShellLaunchConfig(r=>this._onProcessResolvedShellLaunchConfig.fire(r))),this._register(t.onProcessReplay(r=>this._onProcessReplay.fire(r))),this._register(t.onProcessOrphanQuestion(r=>this._onProcessOrphanQuestion.fire(r))),[f,t]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(f,s,c,t,r,i,o,u,a,l){const g=setTimeout(()=>this._handleUnresponsiveCreateProcess(),D.HeartbeatConstants.CreateProcessTimeout),E=await this._proxy.createProcess(f,s,c,t,r,i,o,u,a,l);return clearTimeout(g),C=Math.max(C,E),E}updateTitle(f,s,c){return this._proxy.updateTitle(f,s,c)}updateIcon(f,s,c){return this._proxy.updateIcon(f,s,c)}attachToProcess(f){return this._proxy.attachToProcess(f)}detachFromProcess(f){return this._proxy.detachFromProcess(f)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(f){return this._proxy.start(f)}shutdown(f,s){return this._proxy.shutdown(f,s)}input(f,s){return this._proxy.input(f,s)}processBinary(f,s){return this._proxy.processBinary(f,s)}resize(f,s,c){return this._proxy.resize(f,s,c)}acknowledgeDataEvent(f,s){return this._proxy.acknowledgeDataEvent(f,s)}getInitialCwd(f){return this._proxy.getInitialCwd(f)}getCwd(f){return this._proxy.getCwd(f)}getLatency(f){return this._proxy.getLatency(f)}orphanQuestionReply(f){return this._proxy.orphanQuestionReply(f)}getDefaultSystemShell(f){return this._proxy.getDefaultSystemShell(f)}async getProfiles(f,s,c,t=!1){return(0,y.detectAvailableProfiles)(s,c,t,this._configurationService,void 0,this._logService,this._resolveVariables.bind(this,f))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(f){return this._proxy.getWslPath(f)}setTerminalLayoutInfo(f){return this._proxy.setTerminalLayoutInfo(f)}async getTerminalLayoutInfo(f){return await this._proxy.getTerminalLayoutInfo(f)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),D.HeartbeatConstants.BeatInterval*D.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${D.HeartbeatConstants.BeatInterval*D.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),D.HeartbeatConstants.BeatInterval*D.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(D.HeartbeatConstants.BeatInterval*D.HeartbeatConstants.FirstWaitMultiplier+D.HeartbeatConstants.BeatInterval*D.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${D.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(f,s){return new Promise(c=>{const t=++P;this._pendingResolveVariablesRequests.set(t,c),this._onPtyHostRequestResolveVariables.fire({id:t,workspaceId:f,originalText:s})})}async acceptPtyHostResolvedVariables(f,s){const c=this._pendingResolveVariablesRequests.get(f);c?(c(s),this._pendingResolveVariablesRequests.delete(f)):this._logService.warn(`Resolved variables received without matching request ${f}`)}};b=fe([K(1,v.IConfigurationService),K(2,L.ILogService),K(3,n.ITelemetryService)],b),e.PtyHostService=b}),define(X[52],Q([0,1,40]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function L(A,R,S,w){const n=(0,p.setProperty)(A,R,S,w)[0];return n&&(A=A.substring(0,n.offset)+n.content+A.substring(n.offset+n.length)),A}e.edit=L;function D(A,R,S){let w=S;for(;w>=0;){if(A.charAt(w)===R.charAt(R.length-1)&&R.length===1)return w+1;if(w--,R.length===2&&w>=0&&A.charAt(w)===R.charAt(0))return w+2}return 0}e.getLineStartOffset=D;function k(A,R,S){let w=S;for(;w>=0;)if(A.charAt(w)===R.charAt(R.length-1)&&R.length===1||(w++,R.length===2&&w>=0&&A.charAt(w)===R.charAt(1)))return w;return A.length-1}e.getLineEndOffset=k}),define(X[187],Q([0,1,26,57]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(y,v,m,h,C){const P=[],b=[],I=[];if(!v){const T=y.filter(({identifier:O})=>C.every($=>$.toLowerCase()!==O.id.toLowerCase()));return{local:{added:P,removed:b,updated:I},remote:T.length>0?{added:T,updated:[],removed:[],all:T}:null}}y=y.map(w),v=v.map(w),m=m?m.map(w):null;const f=new Map,s=T=>{T.uuid&&f.set(T.id.toLowerCase(),T.uuid)};y.forEach(({identifier:T})=>s(T)),v.forEach(({identifier:T})=>s(T)),m&&m.forEach(({identifier:T})=>s(T));const c=T=>{const O=T.identifier.uuid||f.get(T.identifier.id.toLowerCase());return O?`uuid:${O}`:`id:${T.identifier.id.toLowerCase()}`},t=(T,O)=>(T.set(c(O),O),T),r=y.reduce(t,new Map),i=v.reduce(t,new Map),o=v.reduce((T,O)=>{const $=c(O);O=(0,p.deepClone)(O);const z=r.get($);return z&&(z.installed&&(O.installed=!0),O.version||(O.version=z.version)),t(T,O)},new Map),u=m?m.reduce(t,new Map):null,a=h.reduce(t,new Map),l=C.reduce((T,O)=>{const $=f.get(O.toLowerCase());return T.add($?`uuid:${$}`:`id:${O.toLowerCase()}`)},new Set),g=k(r,i,l);if(g.added.size>0||g.removed.size>0||g.updated.size>0){const T=k(u,r,l),O=k(u,i,l),$=(z,V)=>{const B=r.get(z);if(B){const M=i.get(z);return{...V?M:B,version:(M.version&&L.gt(M.version,B.version),B.version),state:A(B,M,u?.get(z))}}};for(const z of O.removed.values()){const V=r.get(z);V&&b.push(V.identifier)}for(const z of O.added.values())if(T.added.has(z)){if(g.updated.has(z)){const V=$(z,!0);V&&(I.push(n(V,z)),o.set(z,V))}}else{const V=i.get(z);V.installed&&P.push(n(V,z))}for(const z of O.updated.values()){const V=$(z,!0);V&&(I.push(n(V,z)),o.set(z,V))}for(const z of T.added.values())O.added.has(z)||o.set(z,r.get(z));for(const z of T.updated.values())if(!O.removed.has(z)&&!O.updated.has(z)){const V=$(z,!1);V&&(o.get(z)?.installed&&(V.installed=!0),o.set(z,V))}for(const z of T.removed.values())!a.has(z)&&!O.updated.has(z)&&u?.get(z)?.installed&&o.delete(z)}const E=[],d=k(i,o,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(d.added.size>0||d.updated.size>0||d.removed.size>0)&&o.forEach((T,O)=>E.push(n(T,O))),{local:{added:P,removed:b,updated:I},remote:E.length?{added:[...d.added].map(T=>o.get(T)),updated:[...d.updated].map(T=>o.get(T)),removed:[...d.removed].map(T=>i.get(T)),all:E}:null}}e.merge=D;function k(y,v,m,{checkInstalledProperty:h,checkVersionProperty:C}={checkInstalledProperty:!1,checkVersionProperty:!1}){const P=y?[...y.keys()].filter(c=>!m.has(c)):[],b=[...v.keys()].filter(c=>!m.has(c)),I=b.filter(c=>P.indexOf(c)===-1).reduce((c,t)=>(c.add(t),c),new Set),f=P.filter(c=>b.indexOf(c)===-1).reduce((c,t)=>(c.add(t),c),new Set),s=new Set;for(const c of P){if(f.has(c))continue;const t=y.get(c),r=v.get(c);(!r||t.disabled!==r.disabled||!S(t.state,r.state)||C&&t.version!==r.version||h&&t.installed!==r.installed)&&s.add(c)}return{added:I,removed:f,updated:s}}function A(y,v,m){const h=y.state,C=v.state,P=m?.state;if(!v.version||h&&L.gt(y.version,v.version))return h;if(C&&L.gt(v.version,y.version)||!h)return C;if(!C)return h;const b=(0,p.deepClone)(h),I=P?R(P,C):{added:Object.keys(C).reduce((s,c)=>(s.add(c),s),new Set),removed:new Set,updated:new Set},f=P?R(P,h):{added:Object.keys(h).reduce((s,c)=>(s.add(c),s),new Set),removed:new Set,updated:new Set};for(const s of[...I.added.values(),...I.updated.values()])b[s]=C[s];for(const s of I.removed.values())f.updated.has(s)||delete b[s];return b}function R(y,v){const m=Object.keys(y),h=Object.keys(v),C=h.filter(I=>m.indexOf(I)===-1).reduce((I,f)=>(I.add(f),I),new Set),P=m.filter(I=>h.indexOf(I)===-1).reduce((I,f)=>(I.add(f),I),new Set),b=new Set;for(const I of m){if(P.has(I))continue;const f=y[I],s=v[I];(0,p.equals)(f,s)||b.add(I)}return{added:C,removed:P,updated:b}}function S(y={},v={}){const{added:m,removed:h,updated:C}=R(y,v);return m.size===0&&h.size===0&&C.size===0}function w(y){return{...y,disabled:!!y.disabled,installed:!!y.installed}}function n(y,v){const m={identifier:{id:y.identifier.id,uuid:v.startsWith("uuid:")?v.substring("uuid:".length):void 0}};return y.version&&(m.version=y.version),y.disabled&&(m.disabled=!0),y.installed&&(m.installed=!0),y.state&&(m.state=y.state),m}}),define(X[84],Q([0,1,23,3,2,31,5,28,20]),function(G,e,p,L,D,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,A.createDecorator)("IExtensionsStorageSyncService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let n=class Ze extends D.Disposable{constructor(v,m){super();this.storageService=v,this.productService=m,this._onDidChangeExtensionsStorage=this._register(new L.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(v){return`extensionKeys/${(0,k.adoptToGalleryExtensionId)(v.id)}@${v.version}`}static fromKey(v){const m=w.exec(v);if(m&&m[1])return{id:m[1],version:m[2]}}initialize(){const v=this.storageService.keys(0,1);for(const m of v){const h=Ze.fromKey(m);h&&this.extensionsWithKeysForSync.add(h.id.toLowerCase())}}onDidChangeStorageValue(v){if(v.scope!==0)return;if(this.extensionsWithKeysForSync.has(v.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const m=Ze.fromKey(v.key);if(m){this.extensionsWithKeysForSync.add(m.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(v,m){this.storageService.store(Ze.toKey(v),JSON.stringify(m),0,1)}getKeysForSync(v){const m=this.productService.extensionSyncedKeys?.[v.id.toLowerCase()],h=this.storageService.get(Ze.toKey(v),0),C=h?JSON.parse(h):void 0;return C&&m?(0,p.distinct)([...C,...m]):C||m}};n=fe([K(0,S.IStorageService),K(1,R.IProductService)],n),e.ExtensionsStorageSyncService=n}),define(X[85],Q([0,1,23,24,5]),function(G,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,D.createDecorator)("IIgnoredExtensionsManagementService");let k=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,S){let w=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return w=w.filter(n=>n!==R&&n!==`-${R}`),S&&w.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,1)}updateSynchronizedExtensions(R,S){let w=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return w=w.filter(n=>n!==R&&n!==`-${R}`),S&&w.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,1)}getIgnoredExtensions(R){const S=R.filter(v=>v.isMachineScoped).map(v=>v.identifier.id.toLowerCase()),w=this.getConfiguredIgnoredExtensions().map(v=>v.toLowerCase()),n=[],y=[];if(Array.isArray(w))for(const v of w)v.startsWith("-")?y.push(v.substring(1)):n.push(v);return(0,p.distinct)([...S,...n].filter(v=>y.indexOf(v)===-1))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(S=>S.toLowerCase())}};k=fe([K(0,L.IConfigurationService)],k),e.IgnoredExtensionsManagementService=k}),define(X[188],Q([0,1,26,33,23,144,52]),function(G,e,p,L,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function R(s){return(0,L.parse)(s)||[]}e.parseKeybindings=R;async function S(s,c,t,r,i){const o=R(s),u=R(c),a=t?R(t):null,l=[...o,...u,...a||[]].map(_=>_.key),g=await i.resolveUserBindings(l);let E=n(o,u,a,g);if(!E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:s,hasChanges:!1,hasConflicts:!1};if(!E.hasLocalForwarded&&E.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};if(E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:s,hasChanges:!0,hasConflicts:!1};const d=v(o),T=v(u),O=a?v(a):null,$=h(d,T,g),z=O?h(O,d,g):{added:[...d.keys()].reduce((_,N)=>(_.add(N),_),new Set),removed:new Set,updated:new Set},V=O?h(O,T,g):{added:[...T.keys()].reduce((_,N)=>(_.add(N),_),new Set),removed:new Set,updated:new Set},B=w($,z,V);let M=s;for(const _ of B.removed.values())B.conflicts.has(_)||(M=I(M,_,r));for(const _ of B.added.values()){if(B.conflicts.has(_))continue;const N=T.get(_);if(N.some(j=>j.command!==`-${_}`&&E.conflicts.has(g[j.key]))){B.conflicts.add(_);continue}M=b(M,N,r)}for(const _ of B.updated.values()){if(B.conflicts.has(_))continue;const N=T.get(_);if(N.some(j=>j.command!==`-${_}`&&E.conflicts.has(g[j.key]))){B.conflicts.add(_);continue}M=f(M,_,N,r)}return{mergeContent:M,hasChanges:!0,hasConflicts:B.conflicts.size>0}}e.merge=S;function w(s,c,t){const r=new Set,i=new Set,o=new Set,u=new Set;for(const a of c.removed.values())t.updated.has(a)&&u.add(a);for(const a of t.removed.values())u.has(a)||(c.updated.has(a)?u.add(a):i.add(a));for(const a of c.added.values())u.has(a)||t.added.has(a)&&s.updated.has(a)&&u.add(a);for(const a of t.added.values())u.has(a)||(c.added.has(a)?s.updated.has(a)&&u.add(a):r.add(a));for(const a of c.updated.values())u.has(a)||t.updated.has(a)&&s.updated.has(a)&&u.add(a);for(const a of t.updated.values())u.has(a)||(c.updated.has(a)?s.updated.has(a)&&u.add(a):o.add(a));return{added:r,removed:i,updated:o,conflicts:u}}function n(s,c,t,r){const i=new Set,o=y(s,r),u=y(c,r),a=t?y(t,r):null,l=m(o,u);if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const g=a?m(a,o):{added:[...o.keys()].reduce((z,V)=>(z.add(V),z),new Set),removed:new Set,updated:new Set};if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const E=a?m(a,u):{added:[...u.keys()].reduce((z,V)=>(z.add(V),z),new Set),removed:new Set,updated:new Set};if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:d,removed:T,updated:O,conflicts:$}=w(l,g,E);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:d,removed:T,updated:O,conflicts:$}}function y(s,c){const t=new Map;for(const r of s){const i=c[r.key];let o=t.get(i);o||(o=[],t.set(i,o)),o.push(r)}return t}function v(s){const c=new Map;for(const t of s){const r=t.command[0]==="-"?t.command.substring(1):t.command;let i=c.get(r);i||(i=[],c.set(r,i)),i.push(t)}return c}function m(s,c){const t=[...s.keys()],r=[...c.keys()],i=r.filter(a=>t.indexOf(a)===-1).reduce((a,l)=>(a.add(l),a),new Set),o=t.filter(a=>r.indexOf(a)===-1).reduce((a,l)=>(a.add(l),a),new Set),u=new Set;for(const a of t){if(o.has(a))continue;const l=s.get(a).map(E=>({...E,key:a})),g=c.get(a).map(E=>({...E,key:a}));(0,D.equals)(l,g,(E,d)=>P(E,d))||u.add(a)}return{added:i,removed:o,updated:u}}function h(s,c,t){const r=[...s.keys()],i=[...c.keys()],o=i.filter(l=>r.indexOf(l)===-1).reduce((l,g)=>(l.add(g),l),new Set),u=r.filter(l=>i.indexOf(l)===-1).reduce((l,g)=>(l.add(g),l),new Set),a=new Set;for(const l of r){if(u.has(l))continue;const g=s.get(l).map(d=>({...d,key:t[d.key]})),E=c.get(l).map(d=>({...d,key:t[d.key]}));C(g,E)||a.add(l)}return{added:o,removed:u,updated:a}}function C(s,c){return!(!(0,D.equals)(s.filter(({command:t})=>t[0]!=="-"),c.filter(({command:t})=>t[0]!=="-"),(t,r)=>P(t,r))||!(0,D.equals)(s.filter(({command:t})=>t[0]==="-"),c.filter(({command:t})=>t[0]==="-"),(t,r)=>P(t,r)))}function P(s,c){if(s.command!==c.command||s.key!==c.key)return!1;const t=k.ContextKeyExpr.deserialize(s.when),r=k.ContextKeyExpr.deserialize(c.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!p.equals(s.args,c.args))}function b(s,c,t){for(const r of c)s=A.edit(s,[-1],r,t);return s}function I(s,c,t){const r=R(s);for(let i=r.length-1;i>=0;i--)(r[i].command===c||r[i].command===`-${c}`)&&(s=A.edit(s,[i],void 0,t));return s}function f(s,c,t,r){const i=R(s),o=i.findIndex(u=>u.command===c||u.command===`-${c}`);for(let u=i.length-1;u>=0;u--)(i[u].command===c||i[u].command===`-${c}`)&&(s=A.edit(s,[u],void 0,r));for(let u=t.length-1;u>=0;u--)s=A.edit(s,[o],t[u],r);return s}}),define(X[189],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function p(k,A,R){const S={},w={},n=new Set;if(!A)return{local:{added:S,updated:w,removed:[...n.values()]},remote:{added:k,updated:{},removed:[]},conflicts:[]};const y=L(k,A);if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{local:{added:S,updated:w,removed:[...n.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const v=L(R,k),m=L(R,A),h={},C={},P=new Set,b=new Set;for(const I of v.removed.values())m.updated.has(I)?S[I]=A[I]:P.add(I);for(const I of m.removed.values())b.has(I)||(v.updated.has(I)?b.add(I):n.add(I));for(const I of v.updated.values())b.has(I)||(m.updated.has(I)?y.updated.has(I)&&b.add(I):C[I]=k[I]);for(const I of m.updated.values())b.has(I)||(v.updated.has(I)?y.updated.has(I)&&b.add(I):k[I]!==void 0&&(w[I]=A[I]));for(const I of v.added.values())b.has(I)||(m.added.has(I)?y.updated.has(I)&&b.add(I):h[I]=k[I]);for(const I of m.added.values())b.has(I)||(v.added.has(I)?y.updated.has(I)&&b.add(I):S[I]=A[I]);return{local:{added:S,removed:[...n.values()],updated:w},remote:{added:h,removed:[...P.values()],updated:C},conflicts:[...b.values()]}}e.merge=p;function L(k,A){const R=k?Object.keys(k):[],S=A?Object.keys(A):[],w=S.filter(v=>R.indexOf(v)===-1).reduce((v,m)=>(v.add(m),v),new Set),n=R.filter(v=>S.indexOf(v)===-1).reduce((v,m)=>(v.add(m),v),new Set),y=new Set;for(const v of R){if(n.has(v))continue;const m=k[v],h=A[v];m!==h&&y.add(v)}return{added:w,removed:n,updated:y}}function D(k,A){const{added:R,removed:S,updated:w}=L(k,A);return R.size===0&&S.size===0&&w.size===0}e.areSame=D}),define(X[22],Q([0,1,5,27,32,37,128,79,15,23,16]),function(G,e,p,L,D,k,A,R,S,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function y(){const a=D.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(a).filter(l=>!!a[l].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=y;function v(){const a=D.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(a).filter(d=>!!a[d].ignoreSync),g=Object.keys(a).filter(d=>a[d].scope===2||a[d].scope===6),E=y();return(0,w.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...l,...g,...E])}e.getDefaultIgnoredSettings=v;function m(){const a="vscode://schemas/ignoredSettings",l=D.Registry.as(k.Extensions.Configuration);l.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:a,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const g=D.Registry.as(R.Extensions.JSONContribution),E=()=>{const d=y(),T=v().filter(V=>V!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(k.allSettings.properties).filter(V=>T.indexOf(V)===-1),$=T.filter(V=>d.indexOf(V)===-1),z={items:{type:"string",enum:[...O,...$.map(V=>`-${V}`)]}};g.registerSchema(a,z)};return l.onDidUpdateConfiguration(()=>E())}e.registerConfiguration=m;function h(a){return a&&(0,n.isObject)(a)&&(0,n.isString)(a.id)&&(0,n.isArray)(a.scopes)}e.isAuthenticationProvider=h;var C;(function(a){a.Settings="settings",a.Keybindings="keybindings",a.Snippets="snippets",a.Extensions="extensions",a.GlobalState="globalState"})(C=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function P(a,l,g){return g.joinPath(l.userDataSyncHome,a,`lastSync${a}.json`)}e.getLastSyncResourceUri=P,e.IUserDataSyncStoreManagementService=(0,p.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,p.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,p.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function b(a){const l={};return l[e.HEADER_EXECUTION_ID]=a,l}e.createSyncHeaders=b;var I;(function(a){a.Unauthorized="Unauthorized",a.Conflict="Conflict",a.Gone="Gone",a.PreconditionFailed="PreconditionFailed",a.TooLarge="TooLarge",a.UpgradeRequired="UpgradeRequired",a.PreconditionRequired="PreconditionRequired",a.TooManyRequests="RemoteTooManyRequests",a.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",a.RequestFailed="RequestFailed",a.RequestCanceled="RequestCanceled",a.RequestTimeout="RequestTimeout",a.NoRef="NoRef",a.TurnedOff="TurnedOff",a.SessionExpired="SessionExpired",a.ServiceChanged="ServiceChanged",a.DefaultServiceChanged="DefaultServiceChanged",a.LocalTooManyRequests="LocalTooManyRequests",a.LocalPreconditionFailed="LocalPreconditionFailed",a.LocalInvalidContent="LocalInvalidContent",a.LocalError="LocalError",a.IncompatibleLocalContent="IncompatibleLocalContent",a.IncompatibleRemoteContent="IncompatibleRemoteContent",a.UnresolvedConflicts="UnresolvedConflicts",a.Unknown="Unknown"})(I=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class f extends Error{constructor(l,g,E,d){super(l);this.code=g,this.resource=E,this.operationId=d,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=f;class s extends f{constructor(l,g,E,d){super(l,E,void 0,d);this.url=g}}e.UserDataSyncStoreError=s;class c extends f{constructor(l,g){super(l,g)}}e.UserDataAutoSyncError=c,function(a){function l(g){if(g instanceof a)return g;const E=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(g.name);if(E&&E[1]){const d=E[2]==="unknown"?void 0:E[2],T=E[3]==="unknown"?void 0:E[3];return new a(g.message,E[1],d,T)}return new a(g.message,I.Unknown)}a.toUserDataSyncError=l}(f=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(a){a.Uninitialized="uninitialized",a.Idle="idle",a.Syncing="syncing",a.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var r;(function(a){a[a.None=0]="None",a[a.Added=1]="Added",a[a.Modified=2]="Modified",a[a.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var i;(function(a){a.Preview="preview",a.Conflict="conflict",a.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function o(a){return`sync.enable.${a}`}e.getEnablementKey=o,e.IUserDataSyncResourceEnablementService=(0,p.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,p.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,p.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,p.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,p.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,p.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function u(a,l){if(a.scheme!==e.USER_DATA_SYNC_SCHEME)return a=a.with({scheme:l.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(g=>(0,S.isEqualOrParent)(a,(0,S.joinPath)(l.userDataSyncHome,g,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=u}),define(X[46],Q([0,1,2,13,25,4,22,12,15,6,3,21,33,124,24,16,19,23,45,20,29]),function(G,e,p,L,D,k,A,R,S,w,n,y,v,m,h,C,P,b,I,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function c(u){return!!(u&&u.version!==void 0&&typeof u.version=="number"&&u.content!==void 0&&typeof u.content=="string"&&(Object.keys(u).length===2||Object.keys(u).length===3&&u.machineId!==void 0&&typeof u.machineId=="string"))}e.isSyncData=c;let t=class extends p.Disposable{constructor(a,l,g,E,d,T,O,$,z,V){super();this.resource=a,this.fileService=l,this.environmentService=g,this.userDataSyncStoreService=d,this.userDataSyncBackupStoreService=T,this.userDataSyncResourceEnablementService=O,this.telemetryService=$,this.logService=z,this.configurationService=V,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new n.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new n.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new w.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new n.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,P.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(g.userDataSyncHome,1024)?S.extUri:S.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(g.userDataSyncHome,a),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,A.PREVIEW_DIR_NAME),this.lastSyncResource=(0,A.getLastSyncResourceUri)(a,g,this.extUri),this.currentMachineIdPromise=(0,I.getServiceMachineId)(g,l,E)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const a=await this.syncPreviewPromise;this.syncPreviewPromise=null;const l=await this.performSync(a.remoteUserData,a.lastSyncUserData,!0);this.setStatus(l)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const a=await this.getLastSyncUserData();(a?(await this.doGenerateSyncResourcePreview(a,a,!0,s.CancellationToken.None)).resourcePreviews.some(({remoteChange:g})=>g!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(a){if(this._status!==a){const l=this._status;a==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),l==="hasConflicts"&&a==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=a,this._onDidChangStatus.fire(a)}}async sync(a,l={}){await this._sync(a,!0,l)}async preview(a,l={}){return this._sync(a,!1,l)}async apply(a,l={}){try{this.syncHeaders={...l};const g=await this.doApply(a);return this.setStatus(g),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(a,l,g){try{if(this.syncHeaders={...g},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let E="idle";try{const d=await this.getLastSyncUserData(),T=await this.getLatestRemoteUserData(a,d);return E=await this.performSync(T,d,l),E==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):E==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(E)}}finally{this.syncHeaders={}}}async replace(a){const l=await this.resolveContent(a);if(!l)return!1;const g=this.parseSyncData(l);if(!g)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const E=await this.getLastSyncUserData(),d=await this.getLatestRemoteUserData(null,E),T=await this.isRemoteDataFromCurrentMachine(d),O=await this.generateSyncPreview({ref:d.ref,syncData:g},E,T,s.CancellationToken.None),$=[];for(const z of O){const V=await this.getAcceptResult(z,z.remoteResource,void 0,s.CancellationToken.None),{remoteChange:B}=await this.getAcceptResult(z,z.previewResource,z.remoteContent,s.CancellationToken.None);$.push([z,{...V,remoteChange:B!==0?B:2}])}await this.applyResult(d,E,$,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(a){const l=await this.currentMachineIdPromise;return!!a.syncData?.machineId&&a.syncData.machineId===l}async getLatestRemoteUserData(a,l){if(l){const g=a&&a.latest?a.latest[this.resource]:void 0;if(l.ref===g||g===void 0&&l.syncData===null)return l}return this.getRemoteUserData(l)}async performSync(a,l,g){if(a.syncData&&a.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new A.UserDataSyncError((0,m.localize)(0,null,this.resource,this.version,a.syncData.version),A.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.doSync(a,l,g)}catch(E){if(E instanceof A.UserDataSyncError)switch(E.code){case A.UserDataSyncErrorCode.LocalPreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(a,l,g);case A.UserDataSyncErrorCode.Conflict:case A.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),a=await this.getRemoteUserData(null),l=await this.getLastSyncUserData(),this.performSync(a,l,g)}throw E}}async doSync(a,l,g){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,w.createCancelablePromise)(d=>this.doGenerateSyncResourcePreview(a,l,g,d)));const E=await this.syncPreviewPromise;return this.updateConflicts(E.resourcePreviews),E.resourcePreviews.some(({mergeState:d})=>d==="conflict")?"hasConflicts":g?await this.doApply(!1):"syncing"}catch(E){throw this.syncPreviewPromise=null,E}}async merge(a){return await this.updateSyncResourcePreview(a,async l=>{const g=await this.getMergeResult(l,s.CancellationToken.None);await this.fileService.writeFile(l.previewResource,D.VSBuffer.fromString(g?.content||""));const E=g&&!g.hasConflicts?await this.getAcceptResult(l,l.previewResource,void 0,s.CancellationToken.None):void 0;return l.acceptResult=E,l.mergeState=g.hasConflicts?"conflict":E?"accepted":"preview",l.localChange=E?E.localChange:g.localChange,l.remoteChange=E?E.remoteChange:g.remoteChange,l}),this.syncPreviewPromise}async accept(a,l){return await this.updateSyncResourcePreview(a,async g=>{const E=await this.getAcceptResult(g,a,l,s.CancellationToken.None);return g.acceptResult=E,g.mergeState="accepted",g.localChange=E.localChange,g.remoteChange=E.remoteChange,g}),this.syncPreviewPromise}async discard(a){return await this.updateSyncResourcePreview(a,async l=>{const g=await this.getMergeResult(l,s.CancellationToken.None);return await this.fileService.writeFile(l.previewResource,D.VSBuffer.fromString(g.content||"")),l.acceptResult=void 0,l.mergeState="preview",l.localChange=g.localChange,l.remoteChange=g.remoteChange,l}),this.syncPreviewPromise}async updateSyncResourcePreview(a,l){if(!this.syncPreviewPromise)return;let g=await this.syncPreviewPromise;const E=g.resourcePreviews.findIndex(({localResource:d,remoteResource:T,previewResource:O})=>this.extUri.isEqual(d,a)||this.extUri.isEqual(T,a)||this.extUri.isEqual(O,a));E!==-1&&(this.syncPreviewPromise=(0,w.createCancelablePromise)(async d=>{const T=[...g.resourcePreviews];return T[E]=await l(T[E]),{...g,resourcePreviews:T}}),g=await this.syncPreviewPromise,this.updateConflicts(g.resourcePreviews),g.resourcePreviews.some(({mergeState:d})=>d==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(a){if(!this.syncPreviewPromise)return"idle";const l=await this.syncPreviewPromise;return l.resourcePreviews.some(({mergeState:g})=>g==="conflict")?"hasConflicts":l.resourcePreviews.some(({mergeState:g})=>g!=="accepted")?"syncing":(await this.applyResult(l.remoteUserData,l.lastSyncUserData,l.resourcePreviews.map(g=>[g,g.acceptResult]),a),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(a){}}updateConflicts(a){const l=a.filter(({mergeState:g})=>g==="conflict");(0,b.equals)(this._conflicts,l,(g,E)=>this.extUri.isEqual(g.previewResource,E.previewResource))||(this._conflicts=l,this._onDidChangeConflicts.fire(l))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:l,ref:g})=>({created:l,uri:this.toRemoteBackupResource(g)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:l,ref:g})=>({created:l,uri:this.toLocalBackupResource(g)}))}toRemoteBackupResource(a){return k.URI.from({scheme:A.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${a}`})}toLocalBackupResource(a){return k.URI.from({scheme:A.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${a}`})}async getMachineId({uri:a}){const l=this.extUri.basename(a);if(this.extUri.isEqual(a,this.toRemoteBackupResource(l))){const{content:g}=await this.getUserData(l);if(g)return this.parseSyncData(g)?.machineId}}async resolveContent(a){const l=this.extUri.basename(a);if(this.extUri.isEqual(a,this.toRemoteBackupResource(l))){const{content:g}=await this.getUserData(l);return g}return this.extUri.isEqual(a,this.toLocalBackupResource(l))?this.userDataSyncBackupStoreService.resolveContent(this.resource,l):null}async resolvePreviewContent(a){const l=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(l)for(const g of l.resourcePreviews){if(this.extUri.isEqual(g.acceptedResource,a))return g.acceptResult?g.acceptResult.content:null;if(this.extUri.isEqual(g.remoteResource,a))return g.remoteContent;if(this.extUri.isEqual(g.localResource,a))return g.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(a){}}async doGenerateSyncResourcePreview(a,l,g,E){const d=await this.isRemoteDataFromCurrentMachine(a),T=await this.generateSyncPreview(a,l,d,E),O=[];for(const $ of T){const z=$.previewResource.with({scheme:A.USER_DATA_SYNC_SCHEME,authority:"accepted"});if($.localChange===0&&$.remoteChange===0)O.push({...$,acceptedResource:z,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const V=g?await this.getMergeResult($,E):void 0;if(E.isCancellationRequested)break;await this.fileService.writeFile($.previewResource,D.VSBuffer.fromString(V?.content||""));const B=V&&!V.hasConflicts?await this.getAcceptResult($,$.previewResource,void 0,E):void 0;O.push({...$,acceptResult:B,mergeState:V?.hasConflicts?"conflict":B?"accepted":"preview",localChange:B?B.localChange:V?V.localChange:$.localChange,remoteChange:B?B.remoteChange:V?V.remoteChange:$.remoteChange})}}return{remoteUserData:a,lastSyncUserData:l,resourcePreviews:O,isLastSyncFromCurrentMachine:d}}async getLastSyncUserData(){try{const a=await this.fileService.readFile(this.lastSyncResource),l=JSON.parse(a.value.toString()),g=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=l.version&&g&&l.version!==g,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${l.version} is not compatible with current sync state version ${g}.`),await this.resetLocal(),null;const E=l;if(E.content===null)return{ref:l.ref,syncData:null};const d=JSON.parse(E.content);if(c(d))return{...l,syncData:d,content:void 0}}catch(a){a instanceof L.FileOperationError&&a.fileOperationResult===1||this.logService.error(a)}return null}async updateLastSyncUserData(a,l={}){if(l.ref||l.content||l.version)throw new Error("Cannot have core properties as additional");const g=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),E={ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null,version:g,...l};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(E)))}async getRemoteUserData(a){const{ref:l,content:g}=await this.getUserData(a);let E=null;return g!==null&&(E=this.parseSyncData(g)),{ref:l,syncData:E}}parseSyncData(a){try{const l=JSON.parse(a);if(c(l))return l}catch(l){this.logService.error(l)}throw new A.UserDataSyncError((0,m.localize)(1,null),A.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async getUserData(a){if((0,C.isString)(a)){const l=await this.userDataSyncStoreService.resolveContent(this.resource,a);return{ref:a,content:l}}else{const l=a?{ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,l,this.syncHeaders)}}async updateRemoteUserData(a,l){const g=await this.currentMachineIdPromise,E={version:this.version,machineId:g,content:a};return l=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(E),l,this.syncHeaders),{ref:l,syncData:E}}async backupLocal(a){const l={version:this.version,content:a};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(l))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};t=fe([K(1,L.IFileService),K(2,R.IEnvironmentService),K(3,f.IStorageService),K(4,A.IUserDataSyncStoreService),K(5,A.IUserDataSyncBackupStoreService),K(6,A.IUserDataSyncResourceEnablementService),K(7,y.ITelemetryService),K(8,A.IUserDataSyncLogService),K(9,h.IConfigurationService)],t),e.AbstractSynchroniser=t;let r=class extends t{constructor(a,l,g,E,d,T,O,$,z,V,B){super(l,g,E,d,T,O,$,z,V,B);this.file=a,this._register(this.fileService.watch(this.extUri.dirname(a))),this._register(this.fileService.onDidFilesChange(M=>this.onFileChanges(M)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(a){return null}}async updateLocalFileContent(a,l,g){try{l?await this.fileService.writeFile(this.file,D.VSBuffer.fromString(a),g?void 0:l):await this.fileService.createFile(this.file,D.VSBuffer.fromString(a),{overwrite:g})}catch(E){throw E instanceof L.FileOperationError&&E.fileOperationResult===1||E instanceof L.FileOperationError&&E.fileOperationResult===3?new A.UserDataSyncError(E.message,A.UserDataSyncErrorCode.LocalPreconditionFailed):E}}onFileChanges(a){!a.contains(this.file)||this.triggerLocalChange()}};r=fe([K(2,L.IFileService),K(3,R.IEnvironmentService),K(4,f.IStorageService),K(5,A.IUserDataSyncStoreService),K(6,A.IUserDataSyncBackupStoreService),K(7,A.IUserDataSyncResourceEnablementService),K(8,y.ITelemetryService),K(9,A.IUserDataSyncLogService),K(10,h.IConfigurationService)],r),e.AbstractFileSynchroniser=r;let i=class extends r{constructor(a,l,g,E,d,T,O,$,z,V,B,M){super(a,l,g,E,d,T,O,$,z,V,M);this.userDataSyncUtilService=B,this._formattingOptions=void 0}hasErrors(a){const l=[];return(0,v.parse)(a,l,{allowEmptyContent:!0,allowTrailingComma:!0}),l.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};i=fe([K(2,L.IFileService),K(3,R.IEnvironmentService),K(4,f.IStorageService),K(5,A.IUserDataSyncStoreService),K(6,A.IUserDataSyncBackupStoreService),K(7,A.IUserDataSyncResourceEnablementService),K(8,y.ITelemetryService),K(9,A.IUserDataSyncLogService),K(10,A.IUserDataSyncUtilService),K(11,h.IConfigurationService)],i),e.AbstractJsonFileSynchroniser=i;let o=class{constructor(a,l,g,E){this.resource=a,this.environmentService=l,this.logService=g,this.fileService=E,this.extUri=this.fileService.hasCapability(l.userDataSyncHome,1024)?S.extUri:S.extUriIgnorePathCase,this.lastSyncResource=(0,A.getLastSyncResourceUri)(this.resource,l,S.extUri)}async initialize({ref:a,content:l}){if(!l){this.logService.info("Remote content does not exist.",this.resource);return}const g=this.parseSyncData(l);if(!g)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:a,syncData:g})}catch(d){this.logService.error(d)}}parseSyncData(a){try{const l=JSON.parse(a);if(c(l))return l}catch(l){this.logService.error(l)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(a,l={}){const g={ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null,...l};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(g)))}};o=fe([K(1,R.IEnvironmentService),K(2,A.IUserDataSyncLogService),K(3,L.IFileService)],o),e.AbstractInitializer=o}),define(X[190],Q([0,1,22,3,12,27,31,13,24,187,46,21,4,47,40,19,20,85,9,84,6]),function(G,e,p,L,D,k,A,R,S,w,n,y,v,m,h,C,P,b,I,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function c(u,a){const l=JSON.parse(u.content);if(u.version===1||u.version===2){const g=(await a.getInstalled(0)).filter(E=>E.isBuiltin);for(const E of l)u.version===1&&(E.enabled===!1&&(E.disabled=!0),delete E.enabled),u.version===2&&g.every(d=>!(0,A.areSameExtensions)(d.identifier,E.identifier))&&(E.installed=!0)}return l}function t(u,a,l){const g=l.get((0,A.getExtensionId)(u,a),0)||"{}";return JSON.parse(g)}e.getExtensionStorageState=t;function r(u,a,l,g){g.store((0,A.getExtensionId)(u,a),JSON.stringify(l),0,1)}e.storeExtensionStorageState=r;let i=class at extends n.AbstractSynchroniser{constructor(a,l,g,E,d,T,O,$,z,V,B,M,_,N){super("extensions",l,a,g,E,d,M,_,z,B);this.storageService=g,this.extensionManagementService=T,this.extensionEnablementService=O,this.ignoredExtensionsManagementService=$,this.extensionGalleryService=V,this.extensionsStorageSyncService=N,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.debounce(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,j=>j.some(({local:F})=>!!F)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,j=>!j.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(a,l){const g=a.syncData?await c(a.syncData,this.extensionManagementService):null,E=l?.skippedExtensions||[],d=l?.syncData?await c(l.syncData,this.extensionManagementService):null,T=await this.extensionManagementService.getInstalled(),O=this.getLocalExtensions(T),$=this.ignoredExtensionsManagementService.getIgnoredExtensions(T);g?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:V}=(0,w.merge)(O,g,d,E,$),B={local:z,remote:V,content:this.getPreviewContent(O,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?2:0,remoteChange:V!==null?2:0};return[{skippedExtensions:E,localResource:this.localResource,localContent:this.format(O),localExtensions:O,remoteResource:this.remoteResource,remoteContent:g?this.format(g):null,previewResource:this.previewResource,previewResult:B,localChange:B.localChange,remoteChange:B.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(a,l,g,E){const d=[...l,...g],T=new Set,O=$=>{T.add($.id.toLowerCase()),$.uuid&&T.add($.uuid)};d.forEach(({identifier:$})=>O($)),E.forEach(O);for(const $ of a)T.has($.identifier.id.toLowerCase())||$.identifier.uuid&&T.has($.identifier.uuid)||d.push($);return this.format(d)}async getMergeResult(a,l){return{...a.previewResult,hasConflicts:!1}}async getAcceptResult(a,l,g,E){if(this.extUri.isEqual(l,this.localResource))return this.acceptLocal(a);if(this.extUri.isEqual(l,this.remoteResource))return this.acceptRemote(a);if(this.extUri.isEqual(l,this.previewResource))return a.previewResult;throw new Error(`Invalid Resource: ${l.toString()}`)}async acceptLocal(a){const l=await this.extensionManagementService.getInstalled(),g=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),E=(0,w.merge)(a.localExtensions,null,null,a.skippedExtensions,g),{local:d,remote:T}=E;return{content:a.localContent,local:d,remote:T,localChange:d.added.length>0||d.removed.length>0||d.updated.length>0?2:0,remoteChange:T!==null?2:0}}async acceptRemote(a){const l=await this.extensionManagementService.getInstalled(),g=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),E=a.remoteContent?JSON.parse(a.remoteContent):null;if(E!==null){const d=(0,w.merge)(a.localExtensions,E,a.localExtensions,[],g),{local:T,remote:O}=d;return{content:a.remoteContent,local:T,remote:O,localChange:T.added.length>0||T.removed.length>0||T.updated.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:a.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(a,l,g,E){let{skippedExtensions:d,localExtensions:T}=g[0][0],{local:O,remote:$,localChange:z,remoteChange:V}=g[0][1];if(z===0&&V===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),z!==0&&(await this.backupLocal(JSON.stringify(T)),d=await this.updateLocalExtensions(O.added,O.removed,O.updated,d)),$){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const B=JSON.stringify($.all);a=await this.updateRemoteUserData(B,E?null:a.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${$.added.length?` Added: ${JSON.stringify($.added.map(M=>M.identifier.id))}.`:""}${$.updated.length?` Updated: ${JSON.stringify($.updated.map(M=>M.identifier.id))}.`:""}${$.removed.length?` Removed: ${JSON.stringify($.removed.map(M=>M.identifier.id))}.`:""}`)}l?.ref!==a.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(a,{skippedExtensions:d}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${d.length?` Skipped: ${JSON.stringify(d.map(B=>B.identifier.id))}.`:""}`))}async getAssociatedResources({uri:a}){return[{resource:this.extUri.joinPath(a,"extensions.json"),comparableResource:at.EXTENSIONS_DATA_URI}]}async resolveContent(a){if(this.extUri.isEqual(a,at.EXTENSIONS_DATA_URI)){const g=await this.extensionManagementService.getInstalled(),E=this.ignoredExtensionsManagementService.getIgnoredExtensions(g),d=this.getLocalExtensions(g).filter(T=>!E.some(O=>(0,A.areSameExtensions)({id:O},T.identifier)));return this.format(d)}if(this.extUri.isEqual(this.remoteResource,a)||this.extUri.isEqual(this.localResource,a)||this.extUri.isEqual(this.acceptedResource,a))return this.resolvePreviewContent(a);let l=await super.resolveContent(a);if(l)return l;if(l=await super.resolveContent(this.extUri.dirname(a)),l){const g=this.parseSyncData(l);if(g)switch(this.extUri.basename(a)){case"extensions.json":return this.format(this.parseExtensions(g))}}return null}format(a){a.sort((E,d)=>!E.identifier.uuid&&d.identifier.uuid?-1:E.identifier.uuid&&!d.identifier.uuid?1:(0,C.compare)(E.identifier.id,d.identifier.id));const l=JSON.stringify(a),g=(0,m.format)(l,void 0,{});return(0,h.applyEdits)(l,g)}async hasLocalData(){try{const a=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(a).some(g=>g.installed||g.disabled))return!0}catch(a){}return!1}async updateLocalExtensions(a,l,g,E){const d=[],T=[],O=await this.extensionManagementService.getInstalled();if(l.length){const z=O.filter(({identifier:V,isBuiltin:B})=>!B&&l.some(M=>(0,A.areSameExtensions)(V,M)));await s.Promises.settled(z.map(async V=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,V.identifier.id),await this.extensionManagementService.uninstall(V,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,V.identifier.id),d.push(V.identifier)}))}(a.length||g.length)&&await s.Promises.settled([...a,...g].map(async z=>{const V=O.find(M=>(0,A.areSameExtensions)(M.identifier,z.identifier));if(V&&V.isBuiltin){z.state&&V.manifest.version===z.version&&this.updateExtensionState(z.state,V.manifest.publisher,V.manifest.name,V.manifest.version),z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id),await this.extensionEnablementService.disableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id),await this.extensionEnablementService.enableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id)),d.push(z.identifier);return}const B=await this.extensionGalleryService.getCompatibleExtension(z.identifier);if(z.state&&(V?V.manifest.version===z.version:!!B)){const M=V?V.manifest.publisher:B.publisher,_=V?V.manifest.name:B.name;this.updateExtensionState(z.state,M,_,V?.manifest.version)}if(B)try{z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id,B.version),await this.extensionEnablementService.disableExtension(B.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id,B.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id,B.version),await this.extensionEnablementService.enableExtension(B.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id,B.version)),V||(await this.extensionManagementService.canInstall(B)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,z.identifier.id,B.version),await this.extensionManagementService.installFromGallery(B,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,z.identifier.id,B.version),d.push(B.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,B.displayName||B.identifier.id),T.push(z)))}catch(M){T.push(z),this.logService.error(M),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,B.displayName||B.identifier.id)}else this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,z.identifier.id),T.push(z)}));const $=[];for(const z of E)d.some(V=>(0,A.areSameExtensions)(V,z.identifier))||$.push(z);for(const z of T)$.some(V=>(0,A.areSameExtensions)(V.identifier,z.identifier))||$.push(z);return $}updateExtensionState(a,l,g,E){const d=t(l,g,this.storageService),T=E?this.extensionsStorageSyncService.getKeysForSync({id:(0,A.getGalleryExtensionId)(l,g),version:E}):void 0;T?T.forEach(O=>{d[O]=a[O]}):Object.keys(a).forEach(O=>d[O]=a[O]),r(l,g,d,this.storageService)}parseExtensions(a){return JSON.parse(a.content)}getLocalExtensions(a){const l=this.extensionEnablementService.getDisabledExtensions();return a.map(({identifier:g,isBuiltin:E,manifest:d})=>{const T={identifier:g,version:d.version};l.some(O=>(0,A.areSameExtensions)(O,g))&&(T.disabled=!0),E||(T.installed=!0);try{const O=this.extensionsStorageSyncService.getKeysForSync({id:g.id,version:d.version});if(O){const $=t(d.publisher,d.name,this.storageService);T.state=Object.keys($).reduce((z,V)=>(O.includes(V)&&(z[V]=$[V]),z),{})}}catch(O){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,I.getErrorMessage)(O))}return T})}};i.EXTENSIONS_DATA_URI=v.URI.from({scheme:p.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=fe([K(0,D.IEnvironmentService),K(1,R.IFileService),K(2,P.IStorageService),K(3,p.IUserDataSyncStoreService),K(4,p.IUserDataSyncBackupStoreService),K(5,k.IExtensionManagementService),K(6,k.IGlobalExtensionEnablementService),K(7,b.IIgnoredExtensionsManagementService),K(8,p.IUserDataSyncLogService),K(9,k.IExtensionGalleryService),K(10,S.IConfigurationService),K(11,p.IUserDataSyncResourceEnablementService),K(12,y.ITelemetryService),K(13,f.IExtensionsStorageSyncService)],i),e.ExtensionsSynchroniser=i;let o=class extends n.AbstractInitializer{constructor(a,l,g,E,d){super("extensions",E,d,g);this.extensionManagementService=a,this.ignoredExtensionsManagementService=l}async parseExtensions(a){return a.syncData?await c(a.syncData,this.extensionManagementService):null}generatePreview(a,l){const g=[],E=[],d=[];for(const T of a){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(T.identifier.id))continue;const O=l.find($=>(0,A.areSameExtensions)($.identifier,T.identifier));O?(g.push(O),T.disabled&&d.push(T.identifier)):T.installed&&(E.push(T.identifier),T.disabled&&d.push(T.identifier))}return{installedExtensions:g,newExtensions:E,disabledExtensions:d,remoteExtensions:a}}};o=fe([K(0,k.IExtensionManagementService),K(1,b.IIgnoredExtensionsManagementService),K(2,R.IFileService),K(3,D.IEnvironmentService),K(4,p.IUserDataSyncLogService)],o),e.AbstractExtensionsInitializer=o}),define(X[191],Q([0,1,26,22]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(R,S,w,n,y){if(!S)return{remote:Object.keys(R).length>0?R:null,local:{added:{},removed:[],updated:{}}};const v=k(R,S);if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const m=w?k(w,S):{added:Object.keys(S).reduce((I,f)=>(I.add(f),I),new Set),removed:new Set,updated:new Set},h=w?k(w,R):{added:Object.keys(R).reduce((I,f)=>(I.add(f),I),new Set),removed:new Set,updated:new Set},C={added:{},removed:[],updated:{}},P=p.deepClone(S),b=!w;for(const I of h.added.values())I!==L.SYNC_SERVICE_URL_TYPE&&b&&m.added.has(I)||(P[I]=R[I]);for(const I of h.updated.values())P[I]=R[I];for(const I of h.removed.values())n.unregistered.includes(I)||delete P[I];for(const I of m.added.values()){const f=S[I];if(n.machine.includes(I)){y.info(`GlobalState: Skipped adding ${I} in local storage because it is declared as machine scoped.`);continue}if(w&&h.added.has(I))continue;const s=R[I];s&&s.value===f.value||I===L.SYNC_SERVICE_URL_TYPE&&b&&h.added.has(I)||(s?C.updated[I]=f:C.added[I]=f)}for(const I of m.updated.values()){const f=S[I];if(n.machine.includes(I)){y.info(`GlobalState: Skipped updating ${I} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(I)||h.removed.has(I))continue;const s=R[I];s&&s.value===f.value||(C.updated[I]=f)}for(const I of m.removed.values()){if(n.machine.includes(I)){y.trace(`GlobalState: Skipped removing ${I} in local storage because it is declared as machine scoped.`);continue}h.updated.has(I)||h.removed.has(I)||C.removed.push(I)}return{local:C,remote:A(P,S)?null:P}}e.merge=D;function k(R,S){const w=Object.keys(R),n=Object.keys(S),y=n.filter(h=>w.indexOf(h)===-1).reduce((h,C)=>(h.add(C),h),new Set),v=w.filter(h=>n.indexOf(h)===-1).reduce((h,C)=>(h.add(C),h),new Set),m=new Set;for(const h of w){if(v.has(h))continue;const C=R[h],P=S[h];p.equals(C,P)||m.add(h)}return{added:y,removed:v,updated:m}}function A(R,S){const{added:w,removed:n,updated:y}=k(R,S);return w.size===0&&n.size===0&&y.size===0}}),define(X[192],Q([0,1,22,25,3,12,13,52,191,33,46,21,24,4,47,40,20,7,45,30,14]),function(G,e,p,L,D,k,A,R,S,w,n,y,v,m,h,C,P,b,I,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const c="globalState.argv.",t=["locale"];function r(l){const g=l.storage?Object.keys(l.storage).sort():[],E={};g.forEach(O=>E[O]=l.storage[O]),l.storage=E;const d=JSON.stringify(l),T=(0,h.format)(d,void 0,{});return(0,C.applyEdits)(d,T)}const i=1;let o=class ot extends n.AbstractSynchroniser{constructor(g,E,d,T,O,$,z,V,B){super("globalState",g,O,B,E,d,$,z,T,V);this.storageService=B,this.version=i,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(g.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(D.Event.any(D.Event.filter(g.onDidFilesChange,M=>M.contains(this.environmentService.argvResource)),D.Event.filter(B.onDidChangeValue,M=>M.scope===0&&M.target!==void 0?M.target===0:B.keys(0,0).includes(M.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(g,E,d,T){const O=g.syncData?JSON.parse(g.syncData.content):null;E=E===null&&d?g:E;const $=E&&E.syncData?JSON.parse(E.syncData.content):null,z=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const V=this.getStorageKeys($),{local:B,remote:M}=(0,S.merge)(z.storage,O?O.storage:null,$?$.storage:null,V,this.logService),_={content:null,local:B,remote:M,localChange:Object.keys(B.added).length>0||Object.keys(B.updated).length>0||B.removed.length>0?2:0,remoteChange:M!==null?2:0};return[{localResource:this.localResource,localContent:r(z),localUserData:z,remoteResource:this.remoteResource,remoteContent:O?r(O):null,previewResource:this.previewResource,previewResult:_,localChange:_.localChange,remoteChange:_.remoteChange,acceptedResource:this.acceptedResource,storageKeys:V}]}async getMergeResult(g,E){return{...g.previewResult,hasConflicts:!1}}async getAcceptResult(g,E,d,T){if(this.extUri.isEqual(E,this.localResource))return this.acceptLocal(g);if(this.extUri.isEqual(E,this.remoteResource))return this.acceptRemote(g);if(this.extUri.isEqual(E,this.previewResource))return g.previewResult;throw new Error(`Invalid Resource: ${E.toString()}`)}async acceptLocal(g){return{content:g.localContent,local:{added:{},removed:[],updated:{}},remote:g.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(g){if(g.remoteContent!==null){const E=JSON.parse(g.remoteContent),{local:d,remote:T}=(0,S.merge)(g.localUserData.storage,E.storage,null,g.storageKeys,this.logService);return{content:g.remoteContent,local:d,remote:T,localChange:Object.keys(d.added).length>0||Object.keys(d.updated).length>0||d.removed.length>0?2:0,remoteChange:T!==null?2:0}}else return{content:g.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(g,E,d,T){let{localUserData:O}=d[0][0],{local:$,remote:z,localChange:V,remoteChange:B}=d[0][1];if(V===0&&B===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),V!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(O)),await this.writeLocalGlobalState($),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),B!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const M=JSON.stringify({storage:z});g=await this.updateRemoteUserData(M,T?null:g.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}E?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:g}){return[{resource:this.extUri.joinPath(g,"globalState.json"),comparableResource:ot.GLOBAL_STATE_DATA_URI}]}async resolveContent(g){if(this.extUri.isEqual(g,ot.GLOBAL_STATE_DATA_URI)){const d=await this.getLocalGlobalState();return r(d)}if(this.extUri.isEqual(this.remoteResource,g)||this.extUri.isEqual(this.localResource,g)||this.extUri.isEqual(this.acceptedResource,g))return this.resolvePreviewContent(g);let E=await super.resolveContent(g);if(E)return E;if(E=await super.resolveContent(this.extUri.dirname(g)),E){const d=this.parseSyncData(E);if(d)switch(this.extUri.basename(g)){case"globalState.json":return r(JSON.parse(d.content))}}return null}async hasLocalData(){try{const{storage:g}=await this.getLocalGlobalState();if(Object.keys(g).length>1||g[`${c}.locale`]?.value!=="en")return!0}catch(g){}return!1}async getLocalGlobalState(){const g={},E=await this.getLocalArgvContent(),d=(0,w.parse)(E);for(const T of t)d[T]!==void 0&&(g[`${c}${T}`]={version:1,value:d[T]});for(const T of this.storageService.keys(0,0)){const O=this.storageService.get(T,0);O&&(g[T]={version:1,value:O})}return{storage:g}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(g){}return"{}"}async writeLocalGlobalState({added:g,removed:E,updated:d}){const T={},O={},$=(V,B)=>{for(const M of V){if(M.startsWith(c)){T[M.substring(c.length)]=B?B[M].value:void 0;continue}if(B){const _=B[M];_.value!==String(this.storageService.get(M,0))&&(O[M]=_.value)}else this.storageService.get(M,0)!==void 0&&(O[M]=void 0)}};if($(Object.keys(g),g),$(Object.keys(d),d),$(E),Object.keys(T).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(T),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(O).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const V of Object.keys(O))this.storageService.store(V,O[V],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(O))}}async updateArgv(g){const E=await this.getLocalArgvContent();let d=E;for(const T of Object.keys(g))d=(0,R.edit)(d,[T],g[T],{});E!==d&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(d)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(g){const E=this.storageService.keys(0,0),d=this.storageService.keys(0,1),T=[...E,...d],O=g?.storage?Object.keys(g.storage).filter($=>!$.startsWith(c)&&!T.includes($)&&this.storageService.get($,0)!==void 0):[];if(!b.isWeb){const $=[...p.ALL_SYNC_RESOURCES.map(z=>(0,p.getEnablementKey)(z)),p.SYNC_SERVICE_URL_TYPE];O.push(...$),d.push(...$)}return{user:E,machine:d,unregistered:O}}};o.GLOBAL_STATE_DATA_URI=m.URI.from({scheme:p.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),o=fe([K(0,A.IFileService),K(1,p.IUserDataSyncStoreService),K(2,p.IUserDataSyncBackupStoreService),K(3,p.IUserDataSyncLogService),K(4,k.IEnvironmentService),K(5,p.IUserDataSyncResourceEnablementService),K(6,y.ITelemetryService),K(7,v.IConfigurationService),K(8,P.IStorageService)],o),e.GlobalStateSynchroniser=o;let u=class extends n.AbstractInitializer{constructor(g,E,d,T){super("globalState",d,T,E);this.storageService=g}async doInitialize(g){const E=g.syncData?JSON.parse(g.syncData.content):null;if(!E){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const d={},T={};for(const O of Object.keys(E.storage))O.startsWith(c)?d[O.substring(c.length)]=E.storage[O].value:this.storageService.get(O,0)===void 0&&(T[O]=E.storage[O].value);if(Object.keys(d).length){let O="{}";try{O=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch($){}for(const $ of Object.keys(d))O=(0,R.edit)(O,[$],d[$],{});await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(O))}if(Object.keys(T).length)for(const O of Object.keys(T))this.storageService.store(O,T[O],0,0)}};u=fe([K(0,P.IStorageService),K(1,A.IFileService),K(2,k.IEnvironmentService),K(3,p.IUserDataSyncLogService)],u),e.GlobalStateInitializer=u;let a=class{constructor(g,E,d,T,O){this.userDataSyncStoreClient=g,this.storageService=E,this.environmentService=d,this.fileService=T,this.logService=O}getSyncStoreType(g){return this.parseGlobalState(g)?.storage[p.SYNC_SERVICE_URL_TYPE]?.value}async sync(g){const E=(0,p.createSyncHeaders)((0,f.generateUuid)());try{return await this.doSync(g,E)}catch(d){if(d instanceof p.UserDataSyncError)switch(d.code){case p.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(g,E)}throw d}}async doSync(g,E){const d=await this.userDataSyncStoreClient.read("globalState",null,E),T=this.parseGlobalState(d)||{storage:{}};T.storage[p.SYNC_SERVICE_URL_TYPE]={value:g,version:i};const O=await(0,I.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),$={version:i,machineId:O,content:r(T)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify($),d.ref,E)}parseGlobalState({content:g}){if(!g)return null;const E=JSON.parse(g);if((0,n.isSyncData)(E))return E?JSON.parse(E.content):null;throw new Error("Invalid remote data")}};a=fe([K(1,P.IStorageService),K(2,k.IEnvironmentService),K(3,A.IFileService),K(4,s.ILogService)],a),e.UserDataSyncStoreTypeSynchronizer=a}),define(X[193],Q([0,1,13,22,188,33,125,12,24,7,16,23,46,21,20,25,3]),function(G,e,p,L,D,k,A,R,S,w,n,y,v,m,h,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function b(s,c){const t=JSON.parse(s);if(!c)return(0,n.isUndefined)(t.all)?null:t.all;switch(w.OS){case 2:return(0,n.isUndefined)(t.mac)?null:t.mac;case 3:return(0,n.isUndefined)(t.linux)?null:t.linux;case 1:return(0,n.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=b;let I=class extends v.AbstractJsonFileSynchroniser{constructor(c,t,r,i,o,u,a,l,g,E){super(a.keybindingsResource,"keybindings",u,a,l,c,t,o,E,r,g,i);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(P.Event.filter(i.onDidChangeConfiguration,d=>d.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(c,t,r,i){const o=c.syncData?this.getKeybindingsContentFromSyncContent(c.syncData.content):null;t=t===null&&r?c:t;const u=t?this.getKeybindingsContentFromLastSyncUserData(t):null,a=await this.getLocalFileContent(),l=await this.getFormattingOptions();let g=null,E=!1,d=!1,T=!1;if(o){let $=a?a.value.toString():"[]";if($=$||"[]",this.hasErrors($))throw new L.UserDataSyncError((0,A.localize)(0,null),L.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!u||u!==$||u!==o){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const z=await(0,D.merge)($,o,u,l,this.userDataSyncUtilService);z.hasChanges&&(g=z.mergeContent,T=z.hasConflicts,E=T||z.mergeContent!==$,d=T||z.mergeContent!==o)}}else a&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),g=a.value.toString(),d=!0);const O={content:g,localChange:E?a?2:1:0,remoteChange:d?2:0,hasConflicts:T};return[{fileContent:a,localResource:this.localResource,localContent:a?a.value.toString():null,localChange:O.localChange,remoteResource:this.remoteResource,remoteContent:o,remoteChange:O.remoteChange,previewResource:this.previewResource,previewResult:O,acceptedResource:this.acceptedResource}]}async getMergeResult(c,t){return c.previewResult}async getAcceptResult(c,t,r,i){if(this.extUri.isEqual(t,this.localResource))return{content:c.fileContent?c.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:c.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return r===void 0?{content:c.previewResult.content,localChange:c.previewResult.localChange,remoteChange:c.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(c,t,r,i){const{fileContent:o}=r[0][0];let{content:u,localChange:a,remoteChange:l}=r[0][1];if(a===0&&l===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),u!==null&&(u=u.trim(),u=u||"[]",this.hasErrors(u)))throw new L.UserDataSyncError((0,A.localize)(1,null),L.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(a!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),o&&await this.backupLocal(this.toSyncContent(o.value.toString())),await this.updateLocalFileContent(u||"[]",o,i),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),l!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const g=this.toSyncContent(u||"[]",c.syncData?.content);c=await this.updateRemoteUserData(g,i?null:c.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(g){}t?.ref!==c.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(c,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const c=await this.getLocalFileContent();if(c){const t=(0,k.parse)(c.value.toString());if((0,y.isNonEmptyArray)(t))return!0}}catch(c){if(c.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:c}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(c,"keybindings.json"),comparableResource:t}]}async resolveContent(c){if(this.extUri.isEqual(this.remoteResource,c)||this.extUri.isEqual(this.localResource,c)||this.extUri.isEqual(this.acceptedResource,c))return this.resolvePreviewContent(c);let t=await super.resolveContent(c);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(c)),t){const r=this.parseSyncData(t);if(r)switch(this.extUri.basename(c)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(r.content)}}return null}getKeybindingsContentFromLastSyncUserData(c){return!c.syncData||c.platformSpecific!==void 0&&c.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(c.syncData.content)}getKeybindingsContentFromSyncContent(c){try{return b(c,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(c,t){let r={};try{r=JSON.parse(t||"{}")}catch(i){this.logService.error(i)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=c,w.OS){case 2:r.mac=c;break;case 3:r.linux=c;break;case 1:r.windows=c;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){let c=!!this.configurationService.inspect("settingsSync.keybindingsPerPlatform").userValue;return c!==void 0||(c=!!this.configurationService.inspect("sync.keybindingsPerPlatform").userValue,c!==void 0)?c:!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};I=fe([K(0,L.IUserDataSyncStoreService),K(1,L.IUserDataSyncBackupStoreService),K(2,L.IUserDataSyncLogService),K(3,S.IConfigurationService),K(4,L.IUserDataSyncResourceEnablementService),K(5,p.IFileService),K(6,R.IEnvironmentService),K(7,h.IStorageService),K(8,L.IUserDataSyncUtilService),K(9,m.ITelemetryService)],I),e.KeybindingsSynchroniser=I;let f=class extends v.AbstractInitializer{constructor(c,t,r){super("keybindings",t,r,c)}async doInitialize(c){const t=c.syncData?this.getKeybindingsContentFromSyncContent(c.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,C.VSBuffer.fromString(t)),await this.updateLastSyncUserData(c)}async isEmpty(){try{const c=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,k.parse)(c.value.toString());return!(0,y.isNonEmptyArray)(t)}catch(c){return c.fileOperationResult===1}}getKeybindingsContentFromSyncContent(c){try{return b(c,!0)}catch(t){return this.logService.error(t),null}}};f=fe([K(0,p.IFileService),K(1,R.IEnvironmentService),K(2,L.IUserDataSyncLogService)],f),e.KeybindingsInitializer=f}),define(X[194],Q([0,1,26,33,40,47,52,22,23]),function(G,e,p,L,D,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function w(a,l,g){let E=[];g?E=y(g):E=n(l);const d=[],T=[...(0,R.getDisallowedIgnoredSettings)()];if(Array.isArray(E))for(const O of E)O.startsWith("-")?T.push(O.substring(1)):d.push(O);return(0,S.distinct)([...a,...d].filter(O=>T.indexOf(O)===-1))}e.getIgnoredSettings=w;function n(a){let l=a.inspect("settingsSync.ignoredSettings").userValue;return l!==void 0||(l=a.inspect("sync.ignoredSettings").userValue,l!==void 0)?l:a.getValue("settingsSync.ignoredSettings")||[]}function y(a){const l=(0,L.parse)(a);return l?l["settingsSync.ignoredSettings"]||l["sync.ignoredSettings"]||[]:[]}function v(a,l,g,E){if(g.length){const d=u(l),T=(0,L.parse)(l),O=(0,L.parse)(a),$=[];for(const z of g){const V=T[z],B=O[z];V===void 0?a=A.edit(a,[z],void 0,E):B!==void 0?a=A.edit(a,[z],V,E):$.push(c(z,d))}$.sort((z,V)=>z.startOffset-V.startOffset),$.forEach(z=>a=b(z.setting.key,l,a,E))}return a}e.updateIgnoredSettings=v;function m(a,l,g,E,d,T){const O=v(a,l,E,T),$=g!==O,z=g!==l;if(!$&&!z)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if($&&!z)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(z&&!$)return{conflictsSettings:[],localContent:v(l,a,E,T),remoteContent:null,hasConflicts:!1};if(g===null&&C(a)){const ee=h(a,l,E)?null:v(l,a,E,T);return{conflictsSettings:[],localContent:ee,remoteContent:null,hasConflicts:!1}}let V=a,B=l;const M=(0,L.parse)(a),_=(0,L.parse)(l),N=g?(0,L.parse)(g):null,j=E.reduce((ee,he)=>(ee.add(he),ee),new Set),F=P(M,_,j),U=P(N,M,j),x=P(N,_,j),q=new Map,H=new Set,Y=ee=>{H.add(ee);const he=d.filter(({key:de})=>de===ee)[0];he?(V=A.edit(V,[ee],he.value,T),B=A.edit(B,[ee],he.value,T)):q.set(ee,{key:ee,localValue:M[ee],remoteValue:_[ee]})};for(const ee of U.removed.values())x.updated.has(ee)?Y(ee):B=A.edit(B,[ee],void 0,T);for(const ee of x.removed.values())H.has(ee)||(U.updated.has(ee)?Y(ee):V=A.edit(V,[ee],void 0,T));for(const ee of U.updated.values())H.has(ee)||(x.updated.has(ee)?F.updated.has(ee)&&Y(ee):B=A.edit(B,[ee],M[ee],T));for(const ee of x.updated.values())H.has(ee)||(U.updated.has(ee)?F.updated.has(ee)&&Y(ee):V=A.edit(V,[ee],_[ee],T));for(const ee of U.added.values())H.has(ee)||(x.added.has(ee)?F.updated.has(ee)&&Y(ee):B=b(ee,V,B,T));for(const ee of x.added.values())H.has(ee)||(U.added.has(ee)?F.updated.has(ee)&&Y(ee):V=b(ee,B,V,T));const te=q.size>0||!h(V,B,E),ne=te||!h(V,a,[]),se=te||!h(B,l,[]);return{localContent:ne?V:null,remoteContent:se?B:null,conflictsSettings:[...q.values()],hasConflicts:te}}e.merge=m;function h(a,l,g){if(a===l)return!0;const E=(0,L.parse)(a),d=(0,L.parse)(l),T=g.reduce((z,V)=>(z.add(V),z),new Set),O=u(a).filter(z=>!(z.setting&&T.has(z.setting.key))),$=u(l).filter(z=>!(z.setting&&T.has(z.setting.key)));if(O.length!==$.length)return!1;for(let z=0;z<O.length;z++){const V=O[z],B=$[z];if(V.setting&&B.setting){if(V.setting.key!==B.setting.key||!p.equals(E[V.setting.key],d[V.setting.key]))return!1}else if(!V.setting&&!B.setting){if(V.value!==B.value)return!1}else return!1}return!0}e.areSame=h;function C(a){return a?u(a).length===0:!0}e.isEmpty=C;function P(a,l,g){const E=a?Object.keys(a).filter(z=>!g.has(z)):[],d=Object.keys(l).filter(z=>!g.has(z)),T=d.filter(z=>E.indexOf(z)===-1).reduce((z,V)=>(z.add(V),z),new Set),O=E.filter(z=>d.indexOf(z)===-1).reduce((z,V)=>(z.add(V),z),new Set),$=new Set;if(a)for(const z of E){if(O.has(z))continue;const V=a[z],B=l[z];p.equals(V,B)||$.add(z)}return{added:T,removed:O,updated:$}}function b(a,l,g,E){const d=(0,L.parse)(l),T=u(l),O=u(g),$=I(a,T,O);return f(g,a,d[a],$,O,E)}e.addSetting=b;function I(a,l,g){const E=l.findIndex(T=>T.setting?.key===a),d=l[E-1];if(d){if(d.setting){const O=c(d.setting.key,g);if(O)return{index:g.indexOf(O),insertAfter:!0}}else{const O=t(E,l);if(O){const $=c(O.setting.key,g);if($){const z=r(g.indexOf($),g),V=i(l,O,l[E]);if(z){const B=i(g,$,z),M=o(V,B);return M?{index:g.indexOf(M),insertAfter:!0}:{index:g.indexOf(z),insertAfter:!1}}else{const B=i(g,$,g[g.length-1]),M=o(V,B);return M?{index:g.indexOf(M),insertAfter:!0}:{index:g.length-1,insertAfter:!0}}}}}const T=l[E+1];if(T)if(T.setting){const O=c(T.setting.key,g);if(O)return{index:g.indexOf(O),insertAfter:!1}}else{const O=r(E,l);if(O){const $=c(O.setting.key,g);if($){const z=t(g.indexOf($),g),V=i(l,l[E],O);if(z){const B=i(g,z,$),M=o(V.reverse(),B.reverse());return M?{index:g.indexOf(M),insertAfter:!1}:{index:g.indexOf(z),insertAfter:!0}}else{const B=i(g,g[0],$),M=o(V.reverse(),B.reverse());return M?{index:g.indexOf(M),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:g.length-1,insertAfter:!0}}function f(a,l,g,E,d,T){let O;return E.index===-1?O=(0,D.setProperty)(a,[l],g,T):O=s(a,l,g,E,d,T).map($=>(0,D.withFormatting)(a,$,T)[0]),(0,D.applyEdits)(a,O)}function s(a,l,g,E,d,T){const O=`${JSON.stringify(l)}: ${JSON.stringify(g)}`,$=(0,k.getEOL)(T,a),z=d[E.index];if(E.insertAfter){const V=[];if(z.setting)V.push({offset:z.endOffset,length:0,content:","+O});else{const B=r(E.index,d),M=t(E.index,d),_=M?.setting?.commaOffset;M&&_===void 0&&V.push({offset:M.endOffset,length:0,content:","});const N=_!==void 0&&_>z.endOffset;V.push({offset:N?_+1:z.endOffset,length:0,content:B?$+O+",":$+O})}return V}else{if(z.setting)return[{offset:z.startOffset,length:0,content:O+","}];const V=(d[E.index-1]&&!d[E.index-1].setting?$:"")+O+(r(E.index,d)?",":"")+$;return[{offset:z.startOffset,length:0,content:V}]}}function c(a,l){return l.filter(g=>g.setting?.key===a)[0]}function t(a,l){for(let g=a-1;g>=0;g--)if(l[g].setting)return l[g]}function r(a,l){for(let g=a+1;g<l.length;g++)if(l[g].setting)return l[g]}function i(a,l,g){const E=a.indexOf(l),d=a.indexOf(g);return a.filter((T,O)=>E<O&&O<d)}function o(a,l){if(a.length&&l.length){let g=0;for(;g<l.length&&g<a.length;g++)if(a[g].value!==l[g].value)return l[g-1];return l[g-1]}}function u(a){const l=[];let g=-1,E,d;const T={onObjectBegin:O=>{g++},onObjectProperty:(O,$,z)=>{g===0&&(E=$,d=O)},onObjectEnd:(O,$)=>{g--,g===0&&l.push({startOffset:E,endOffset:O+$,value:a.substring(E,O+$),setting:{key:d,commaOffset:void 0}})},onArrayBegin:(O,$)=>{g++},onArrayEnd:(O,$)=>{g--,g===0&&l.push({startOffset:E,endOffset:O+$,value:a.substring(E,O+$),setting:{key:d,commaOffset:void 0}})},onLiteralValue:(O,$,z)=>{g===0&&l.push({startOffset:E,endOffset:$+z,value:a.substring(E,$+z),setting:{key:d,commaOffset:void 0}})},onSeparator:(O,$,z)=>{if(g===0&&O===","){let V=l.length-1;for(;V>=0&&!l[V].setting;V--);const B=l[V];B&&l.splice(V,1,{startOffset:B.startOffset,endOffset:B.endOffset,value:B.value,setting:{key:B.setting.key,commaOffset:$}})}},onComment:(O,$)=>{g===0&&l.push({startOffset:O,endOffset:O+$,value:a.substring(O,O+$)})}};return(0,L.visit)(a,T),l}}),define(X[195],Q([0,1,13,22,25,126,3,12,24,194,52,46,21,27,20,40]),function(G,e,p,L,D,k,A,R,S,w,n,y,v,m,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function P(c){return c&&c.settings&&typeof c.settings=="string"&&Object.keys(c).length===1}function b(c){const t=JSON.parse(c);return P(t)?t:{settings:c}}e.parseSettingsSyncContent=b;let I=class extends y.AbstractJsonFileSynchroniser{constructor(t,r,i,o,u,a,l,g,E,d,T){super(r.settingsResource,"settings",t,r,i,o,u,E,d,a,l,g);this.extensionManagementService=T,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,r,i,o){const u=await this.getLocalFileContent(),a=await this.getFormattingOptions(),l=this.getSettingsSyncContent(t);r=r===null&&i?t:r;const g=r?this.getSettingsSyncContent(r):null,E=await this.getIgnoredSettings();let d=null,T=!1,O=!1,$=!1;if(l){let V=u?u.value.toString().trim():"{}";V=V||"{}",this.validateContent(V),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const B=(0,w.merge)(V,l.settings,g?g.settings:null,E,[],a);d=B.localContent||B.remoteContent,T=B.localContent!==null,O=B.remoteContent!==null,$=B.hasConflicts}else u&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),d=u.value.toString(),O=!0);const z={content:d,localChange:T?2:0,remoteChange:O?2:0,hasConflicts:$};return[{fileContent:u,localResource:this.localResource,localContent:u?u.value.toString():null,localChange:z.localChange,remoteResource:this.remoteResource,remoteContent:l?l.settings:null,remoteChange:z.remoteChange,previewResource:this.previewResource,previewResult:z,acceptedResource:this.acceptedResource}]}async getMergeResult(t,r){const i=await this.getFormattingOptions(),o=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,w.updateIgnoredSettings)(t.previewResult.content,"{}",o,i):null}}async getAcceptResult(t,r,i,o){const u=await this.getFormattingOptions(),a=await this.getIgnoredSettings();if(this.extUri.isEqual(r,this.localResource))return{content:t.fileContent?(0,w.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",a,u):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?(0,w.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",a,u):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return i===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:i!==null?(0,w.updateIgnoredSettings)(i,t.fileContent?t.fileContent.value.toString():"{}",a,u):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(t,r,i,o){const{fileContent:u}=i[0][0];let{content:a,localChange:l,remoteChange:g}=i[0][1];if(l===0&&g===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),a=a?a.trim():"{}",a=a||"{}",this.validateContent(a),l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),u&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(u.value.toString()))),await this.updateLocalFileContent(a,u,o),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),g!==0){const E=await this.getFormattingOptions(),d=this.getSettingsSyncContent(t),T=await this.getIgnoredSettings(a);a=(0,w.updateIgnoredSettings)(a,d?d.settings:"{}",T,E),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(a)),o?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(E){}r?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const r=await this.getFormattingOptions(),i=(0,n.edit)(t.value.toString(),[L.CONFIGURATION_SYNC_STORE_KEY],void 0,r);return!(0,w.isEmpty)(i)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const r=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:r}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let r=await super.resolveContent(t);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(t)),r){const i=this.parseSyncData(r);if(i){const o=this.parseSettingsSyncContent(i.content);if(o)switch(this.extUri.basename(t)){case"settings.json":return o.settings}}}return null}async resolvePreviewContent(t){let r=await super.resolvePreviewContent(t);if(r){const i=await this.getFormattingOptions(),o=await this.getIgnoredSettings();r=(0,w.updateIgnoredSettings)(r,"{}",o,i)}return r}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return b(t)}catch(r){this.logService.error(r)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=A.Event.any(A.Event.filter(this.extensionManagementService.onDidInstallExtensions,o=>o.some(({local:u})=>!!u)),A.Event.filter(this.extensionManagementService.onDidUninstallExtension,o=>!o.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const r=await this._defaultIgnoredSettings;return(0,w.getIgnoredSettings)(r,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new L.UserDataSyncError((0,k.localize)(0,null),L.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const r=JSON.parse(t.value.toString());if(!s(r))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const i=this.parseSettingsSyncContent(r.content);if(!i||!i.settings)return;let o=i.settings;const u=await this.getFormattingOptions();for(const a in r)if(["version","content","machineId"].indexOf(a)===-1&&r[a]!==void 0){const l=(0,C.setProperty)(o,[a],r[a],u);l.length&&(o=(0,C.applyEdits)(o,l))}await this.fileService.writeFile(this.file,D.VSBuffer.fromString(o))}catch(t){}}};I=fe([K(0,p.IFileService),K(1,R.IEnvironmentService),K(2,h.IStorageService),K(3,L.IUserDataSyncStoreService),K(4,L.IUserDataSyncBackupStoreService),K(5,L.IUserDataSyncLogService),K(6,L.IUserDataSyncUtilService),K(7,S.IConfigurationService),K(8,L.IUserDataSyncResourceEnablementService),K(9,v.ITelemetryService),K(10,m.IExtensionManagementService)],I),e.SettingsSynchroniser=I;let f=class extends y.AbstractInitializer{constructor(t,r,i){super("settings",r,i,t)}async doInitialize(t){const r=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!r){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,D.VSBuffer.fromString(r.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,w.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return b(t)}catch(r){this.logService.error(r)}return null}};f=fe([K(0,p.IFileService),K(1,R.IEnvironmentService),K(2,L.IUserDataSyncLogService)],f),e.SettingsInitializer=f;function s(c){return!!(c&&c.version!==void 0&&typeof c.version=="number"&&c.content!==void 0&&typeof c.content=="string"&&c.machineId!==void 0&&typeof c.machineId=="string")}}),define(X[196],Q([0,1,22,12,13,24,46,21,25,189,20,26,3]),function(G,e,p,L,D,k,A,R,S,w,n,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let m=class extends A.AbstractSynchroniser{constructor(P,b,I,f,s,c,t,r,i){super("snippets",b,P,I,f,s,r,i,c,t);this.version=1,this.snippetsFolder=P.snippetsHome,this._register(this.fileService.watch(P.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(v.Event.filter(this.fileService.onDidFilesChange,o=>o.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(P,b,I,f){const s=await this.getSnippetsFileContents(),c=this.toSnippetsContents(s),t=P.syncData?this.parseSnippets(P.syncData):null;b=b===null&&I?P:b;const r=b&&b.syncData?this.parseSnippets(b.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,w.merge)(c,t,r);return this.getResourcePreviews(i,s,t||{})}async getMergeResult(P,b){return P.previewResult}async getAcceptResult(P,b,I,f){if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:P.fileContent?P.fileContent.value.toString():null,localChange:0,remoteChange:P.fileContent?P.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:P.remoteContent,localChange:P.remoteContent!==null?P.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder))return I===void 0?{content:P.previewResult.content,localChange:P.previewResult.localChange,remoteChange:P.previewResult.remoteChange}:{content:I,localChange:I===null?P.fileContent!==null?3:0:2,remoteChange:I===null?P.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${b.toString()}`)}async applyResult(P,b,I,f){const s=I.map(([c,t])=>({...c,acceptResult:t}));s.every(({localChange:c,remoteChange:t})=>c===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),s.some(({localChange:c})=>c!==0)&&(await this.updateLocalBackup(s),await this.updateLocalSnippets(s,f)),s.some(({remoteChange:c})=>c!==0)&&(P=await this.updateRemoteSnippets(s,P,f)),b?.ref!==P.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(P),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:c}of s)try{await this.fileService.del(c)}catch(t){}}getResourcePreviews(P,b,I){const f=new Map;for(const s of Object.keys(P.local.added)){const c={content:P.local.added[s],hasConflicts:!1,localChange:1,remoteChange:0};f.set(s,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(P.local.updated)){const c={content:P.local.updated[s],hasConflicts:!1,localChange:2,remoteChange:0};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s],localContent:b[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of P.local.removed){const c={content:null,hasConflicts:!1,localChange:3,remoteChange:0};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s],localContent:b[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(P.remote.added)){const c={content:P.remote.added[s],hasConflicts:!1,localChange:0,remoteChange:1};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s],localContent:b[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(P.remote.updated)){const c={content:P.remote.updated[s],hasConflicts:!1,localChange:0,remoteChange:2};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s],localContent:b[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of P.remote.removed){const c={content:null,hasConflicts:!1,localChange:0,remoteChange:3};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of P.conflicts){const c={content:b[s]?b[s].value.toString():null,hasConflicts:!0,localChange:b[s]?2:1,remoteChange:I[s]?2:1};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s]||null,localContent:b[s]?b[s].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(b))if(!f.has(s)){const c={content:b[s]?b[s].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s]||null,localContent:b[s]?b[s].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...f.values()]}async getAssociatedResources({uri:P}){let b=await super.resolveContent(P);if(b){const I=this.parseSyncData(b);if(I){const f=this.parseSnippets(I),s=[];for(const c of Object.keys(f)){const t=this.extUri.joinPath(P,c),r=this.extUri.joinPath(this.snippetsFolder,c),i=await this.fileService.exists(r);s.push({resource:t,comparableResource:i?r:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})})}return s}}return[]}async resolveContent(P){if(this.extUri.isEqualOrParent(P,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(P,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(P,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(P);let b=await super.resolveContent(P);if(b)return b;if(b=await super.resolveContent(this.extUri.dirname(P)),b){const I=this.parseSyncData(b);if(I)return this.parseSnippets(I)[this.extUri.basename(P)]||null}return null}async hasLocalData(){try{const P=await this.getSnippetsFileContents();if(Object.keys(P).length)return!0}catch(P){}return!1}async updateLocalBackup(P){const b={};for(const I of P)I.fileContent&&(b[this.extUri.basename(I.localResource)]=I.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(b)))}async updateLocalSnippets(P,b){for(const{fileContent:I,acceptResult:f,localResource:s,remoteResource:c,localChange:t}of P)if(t!==0){const r=c?this.extUri.basename(c):this.extUri.basename(s),i=this.extUri.joinPath(this.snippetsFolder,r);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(i)),await this.fileService.del(i),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(i))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(i)),await this.fileService.createFile(i,S.VSBuffer.fromString(f.content),{overwrite:b}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(i))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(i)),await this.fileService.writeFile(i,S.VSBuffer.fromString(f.content),b?void 0:I),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(i)))}}async updateRemoteSnippets(P,b,I){const f=b.syncData?this.parseSnippets(b.syncData):{},s=(0,y.deepClone)(f);for(const{acceptResult:c,localResource:t,remoteResource:r,remoteChange:i}of P)if(i!==0){const o=t?this.extUri.basename(t):this.extUri.basename(r);i===3?delete s[o]:s[o]=c.content}return(0,w.areSame)(f,s)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),b=await this.updateRemoteUserData(JSON.stringify(s),I?null:b.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),b}parseSnippets(P){return JSON.parse(P.content)}toSnippetsContents(P){const b={};for(const I of Object.keys(P))b[I]=P[I].value.toString();return b}async getSnippetsFileContents(){const P={};let b;try{b=await this.fileService.resolve(this.snippetsFolder)}catch(I){if(I instanceof D.FileOperationError&&I.fileOperationResult===1)return P;throw I}for(const I of b.children||[]){const f=I.resource,s=this.extUri.extname(f);if(s===".json"||s===".code-snippets"){const c=this.extUri.relativePath(this.snippetsFolder,f),t=await this.fileService.readFile(f);P[c]=t}}return P}};m=fe([K(0,L.IEnvironmentService),K(1,D.IFileService),K(2,n.IStorageService),K(3,p.IUserDataSyncStoreService),K(4,p.IUserDataSyncBackupStoreService),K(5,p.IUserDataSyncLogService),K(6,k.IConfigurationService),K(7,p.IUserDataSyncResourceEnablementService),K(8,R.ITelemetryService)],m),e.SnippetsSynchroniser=m;let h=class extends A.AbstractInitializer{constructor(P,b,I){super("snippets",b,I,P)}async doInitialize(P){const b=P.syncData?JSON.parse(P.syncData.content):null;if(!b){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const f of Object.keys(b)){const s=b[f];if(s){const c=this.extUri.joinPath(this.environmentService.snippetsHome,f);await this.fileService.createFile(c,S.VSBuffer.fromString(s)),this.logService.info("Created snippet",this.extUri.basename(c))}}await this.updateLastSyncUserData(P)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(P){return P.fileOperationResult===1}}};h=fe([K(0,D.IFileService),K(1,L.IEnvironmentService),K(2,p.IUserDataSyncLogService)],h),e.SnippetsInitializer=h}),define(X[60],Q([0,1,5,3,2,22]),function(G,e,p,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,p.createDecorator)("IUserDataSyncAccountService");let A=class extends D.Disposable{constructor(S){super();this.userDataSyncStoreService=S,this._onDidChangeAccount=this._register(new L.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(S.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(S.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(S){(S&&this._account?S.token!==this._account.token||S.authenticationProviderId!==this._account.authenticationProviderId:S!==this._account)&&(this._account=S,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(S))}};A=fe([K(0,k.IUserDataSyncStoreService)],A),e.UserDataSyncAccountService=A}),define(X[197],Q([0,1,2,22,15,24,13,12,55,25,6]),function(G,e,p,L,D,k,A,R,S,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let y=class extends p.Disposable{constructor(m,h,C,P){super();this.environmentService=m,this.fileService=h,this.configurationService=C,this.logService=P,L.ALL_SYNC_RESOURCES.forEach(b=>this.cleanUpBackup(b))}async getAllRefs(m){const h=(0,D.joinPath)(this.environmentService.userDataSyncHome,m),C=await this.fileService.resolve(h);return C.children?C.children.filter(b=>b.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(b.name)).sort().reverse().map(b=>({ref:b.name,created:this.getCreationTime(b)})):[]}async resolveContent(m,h){if(!h){const C=await this.getAllRefs(m);C.length&&(h=C[C.length-1].ref)}if(h){const C=(0,D.joinPath)(this.environmentService.userDataSyncHome,m,h);return(await this.fileService.readFile(C)).value.toString()}return null}async backup(m,h){const C=(0,D.joinPath)(this.environmentService.userDataSyncHome,m),P=(0,D.joinPath)(C,`${(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(P,w.VSBuffer.fromString(h))}catch(b){this.logService.error(b)}try{this.cleanUpBackup(m)}catch(b){}}async cleanUpBackup(m){const h=(0,D.joinPath)(this.environmentService.userDataSyncHome,m);try{try{if(!await this.fileService.exists(h))return}catch(P){return}const C=await this.fileService.resolve(h);if(C.children){const P=C.children.filter(s=>s.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(s.name)).sort(),b=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let I=P.filter(s=>Date.now()-this.getCreationTime(s)>b);const f=P.length-I.length;f<10&&(I=I.slice(10-f)),await n.Promises.settled(I.map(async s=>{this.logService.info("Deleting from backup",s.resource.path),await this.fileService.del(s.resource)}))}}catch(C){this.logService.error(C)}}getCreationTime(m){return m.ctime||new Date(parseInt(m.name.substring(0,4)),parseInt(m.name.substring(4,6))-1,parseInt(m.name.substring(6,8)),parseInt(m.name.substring(9,11)),parseInt(m.name.substring(11,13)),parseInt(m.name.substring(13,15))).getTime()}};y=fe([K(0,R.IEnvironmentService),K(1,A.IFileService),K(2,k.IConfigurationService),K(3,L.IUserDataSyncLogService)],y),e.UserDataSyncBackupStoreService=y}),define(X[198],Q([0,1,4,2]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class D{constructor(v){this.service=v}listen(v,m){switch(m){case"onError":return this.service.onError}throw new Error(`Event not found: ${m}`)}call(v,m,h){switch(m){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=D;class k{constructor(v){this.service=v}listen(v,m){throw new Error(`Event not found: ${m}`)}call(v,m,h){switch(m){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(p.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=k;class A{constructor(v){this.channel=v}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(v){return this.channel.call("resolveUserKeybindings",[v])}async resolveFormattingOptions(v){return this.channel.call("resolveFormattingOptions",[v])}}e.UserDataSyncUtilServiceClient=A;class R{constructor(v){this.service=v}listen(v,m){switch(m){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${m}`)}async call(v,m,h){switch(m){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class S{constructor(v){this.service=v}listen(v,m){switch(m){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${m}`)}call(v,m,h){switch(m){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=S;class w{constructor(v){this.service=v}listen(v,m){switch(m){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${m}`)}call(v,m,h){switch(m){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=w;class n extends L.Disposable{constructor(v){super();this.channel=v,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(v){return this.channel.call("switch",[v])}async getPreviousUserDataSyncStore(){const v=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(v)}revive(v){return{url:p.URI.revive(v.url),type:v.type,defaultUrl:p.URI.revive(v.defaultUrl),insidersUrl:p.URI.revive(v.insidersUrl),stableUrl:p.URI.revive(v.stableUrl),canSwitch:v.canSwitch,authenticationProviders:v.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=n}),define(X[199],Q([0,1,14,12]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let D=class extends p.AbstractLogger{constructor(A,R){super();this.logger=this._register(A.createLogger(R.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...R){this.logger.trace(A,...R)}debug(A,...R){this.logger.debug(A,...R)}info(A,...R){this.logger.info(A,...R)}warn(A,...R){this.logger.warn(A,...R)}error(A,...R){this.logger.error(A,...R)}critical(A,...R){this.logger.critical(A,...R)}flush(){this.logger.flush()}};D=fe([K(0,p.ILoggerService),K(1,L.IEnvironmentService)],D),e.UserDataSyncLogService=D}),define(X[61],Q([0,1,5,2,45,12,13,20,22,129,28,7,19,3]),function(G,e,p,L,D,k,A,R,S,w,n,y,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,p.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName";let C=class Ge extends L.Disposable{constructor(b,I,f,s,c,t){super();this.storageService=f,this.userDataSyncStoreService=s,this.logService=c,this.productService=t,this._onDidChange=this._register(new m.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,D.getServiceMachineId)(b,I,f)}async getMachines(b){const I=await this.currentMachineIdPromise;return(await this.readMachinesData(b)).machines.map(s=>({...s,isCurrent:s.id===I}))}async addCurrentMachine(b){const I=await this.currentMachineIdPromise,f=await this.readMachinesData(b);f.machines.some(({id:s})=>s===I)||(f.machines.push({id:I,name:this.computeCurrentMachineName(f.machines)}),await this.writeMachinesData(f))}async removeCurrentMachine(b){const I=await this.currentMachineIdPromise,f=await this.readMachinesData(b),s=f.machines.filter(({id:c})=>c!==I);s.length!==f.machines.length&&(f.machines=s,await this.writeMachinesData(f))}async renameMachine(b,I,f){const s=await this.currentMachineIdPromise,c=await this.readMachinesData(f),t=c.machines.find(({id:r})=>r===b);t&&(t.name=I,await this.writeMachinesData(c),c.machines.some(({id:r})=>r===s)&&this.storageService.store(h,I,0,1))}async setEnablement(b,I){const f=await this.readMachinesData(),s=f.machines.find(({id:c})=>c===b);s&&(s.disabled=I?void 0:!0,await this.writeMachinesData(f))}computeCurrentMachineName(b){const I=this.storageService.get(h,0);if(I)return I;const f=`${this.productService.nameLong} (${(0,y.PlatformToString)(y.isWeb?0:y.platform)})`,s=new RegExp(`${(0,v.escapeRegExpCharacters)(f)}\\s#(\\d+)`);let c=0;for(const t of b){const r=s.exec(t.name),i=r?parseInt(r[1]):0;c=i>c?i:c}return`${f} #${c+1}`}async readMachinesData(b){this.userData=await this.readUserData(b);const I=this.parse(this.userData);if(I.version!==Ge.VERSION)throw new Error((0,w.localize)(0,null,this.productService.nameLong));return I}async writeMachinesData(b){const I=JSON.stringify(b),f=await this.userDataSyncStoreService.write(Ge.RESOURCE,I,this.userData?.ref||null);this.userData={ref:f,content:I},this._onDidChange.fire()}async readUserData(b){if(this.userData){const I=b&&b.latest?b.latest[Ge.RESOURCE]:void 0;if(this.userData.ref===I)return this.userData;if(I===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ge.RESOURCE,this.userData)}parse(b){if(b.content!==null)try{return JSON.parse(b.content)}catch(I){this.logService.error(I)}return{version:Ge.VERSION,machines:[]}}};C.VERSION=1,C.RESOURCE="machines",C=fe([K(0,k.IEnvironmentService),K(1,A.IFileService),K(2,R.IStorageService),K(3,S.IUserDataSyncStoreService),K(4,S.IUserDataSyncLogService),K(5,n.IProductService)],C),e.UserDataSyncMachinesService=C}),define(X[86],Q([0,1,6,3,2,22,60,21,9,20,12,61,127,55,4,15,7,28]),function(G,e,p,L,D,k,A,R,S,w,n,y,v,m,h,C,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const I="sync.enable",f="sync.disableMachineEventually",s="sync.sessionId",c="sync.storeUrl",t="sync.productQuality";let r=class extends D.Disposable{constructor(a,l,g){super();this.storageService=a,this.environmentService=l,this.userDataSyncStoreManagementService=g,this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(a.onDidChangeValue(E=>this.onDidStorageChange(E)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(I,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(a){a&&!this.canToggleEnablement()||this.storageService.store(I,a,0,1)}onDidStorageChange(a){if(a.scope===0&&I===a.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};r=fe([K(0,w.IStorageService),K(1,n.IEnvironmentService),K(2,k.IUserDataSyncStoreManagementService)],r),e.UserDataAutoSyncEnablementService=r;let i=class extends D.Disposable{constructor(a,l,g,E,d,T,O,$,z,V,B){super();this.userDataSyncStoreManagementService=l,this.userDataSyncStoreService=g,this.userDataSyncResourceEnablementService=E,this.userDataSyncService=d,this.logService=T,this.userDataSyncAccountService=O,this.telemetryService=$,this.userDataSyncMachinesService=z,this.storageService=V,this.autoSync=this._register(new D.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new L.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=B,this.syncTriggerDelayer=this._register(new p.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=l.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=a.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(l.onDidChangeUserDataSyncStore(()=>{(0,C.isEqual)(this.syncUrl,l.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=l.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(O.onDidChangeAccount(()=>this.updateAutoSync())),this._register(g.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(L.Event.debounce(d.onDidChangeLocal,(M,_)=>M?[...M,_]:[_],1e3)(M=>this.triggerSync(M,!1,!1))),this._register(L.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const a=this.storageService.get(c,0);return a?h.URI.parse(a):void 0}set syncUrl(a){a?this.storageService.store(c,a.toString(),0,1):this.storageService.remove(c,0)}get productQuality(){return this.storageService.get(t,0)}set productQuality(a){a?this.storageService.store(t,a,0,1):this.storageService.remove(t,0)}updateAutoSync(){const{enabled:a,message:l}=this.isAutoSyncEnabled();a?this.autoSync.value===void 0&&(this.autoSync.value=new o(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(g=>this.onDidFinishSync(g))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(l&&this.logService.info(l),this.autoSync.clear()):l&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(l))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,m.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(a,l,g){try{this.userDataSyncAccountService.account&&!g&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(s,0),a?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(E){if(l)this.logService.error(E),this.updateEnablement(!1);else throw E}}updateEnablement(a){this.userDataAutoSyncEnablementService.isEnabled()!==a&&(this.telemetryService.publicLog2(I,{enabled:a}),this.userDataAutoSyncEnablementService.setEnablement(a),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(a){if(!a){this.successiveFailures=0;return}const l=k.UserDataSyncError.toUserDataSyncError(a);l instanceof k.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:l.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),l.code===k.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):l.code===k.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):l.code===k.UserDataSyncErrorCode.LocalTooManyRequests||l.code===k.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):l.code===k.UserDataSyncErrorCode.UpgradeRequired||l.code===k.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):l.code===k.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${l.resource} content with newer version than of client. Requires client upgrade.`)):l.code===k.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${l.resource} content with older version than of client. Requires server reset.`)):l.code===k.UserDataSyncErrorCode.ServiceChanged||l.code===k.UserDataSyncErrorCode.DefaultServiceChanged?P.isWeb&&l.code===k.UserDataSyncErrorCode.DefaultServiceChanged&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(l),this.successiveFailures++),this._onError.fire(l)}async disableMachineEventually(){this.storageService.store(f,!0,0,1),await(0,p.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(f,0,!1)}stopDisableMachineEventually(){this.storageService.remove(f,0)}async triggerSync(a,l,g){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(l&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...a),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",g)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};i=fe([K(0,b.IProductService),K(1,k.IUserDataSyncStoreManagementService),K(2,k.IUserDataSyncStoreService),K(3,k.IUserDataSyncResourceEnablementService),K(4,k.IUserDataSyncService),K(5,k.IUserDataSyncLogService),K(6,A.IUserDataSyncAccountService),K(7,R.ITelemetryService),K(8,y.IUserDataSyncMachinesService),K(9,w.IStorageService),K(10,k.IUserDataAutoSyncEnablementService)],i),e.UserDataAutoSyncService=i;class o extends D.Disposable{constructor(a,l,g,E,d,T,O,$){super();this.lastSyncUrl=a,this.interval=l,this.userDataSyncStoreManagementService=g,this.userDataSyncStoreService=E,this.userDataSyncService=d,this.userDataSyncMachinesService=T,this.logService=O,this.storageService=$,this.intervalHandler=this._register(new D.MutableDisposable),this._onDidStartSync=this._register(new L.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new L.Emitter),this.onDidFinishSync=this._onDidFinishSync.event}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,D.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(o.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,p.disposableTimeout)(()=>this.sync(o.INTERVAL_SYNCING,!1),this.interval)}sync(a,l){const g=(0,p.createCancelablePromise)(async E=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(d){if((0,S.isPromiseCanceledError)(d))return}return this.doSync(a,l,E)});return this.syncPromise=g,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,C.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const a=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),l=this.userDataSyncStoreManagementService.userDataSyncStore;return!!l&&!!a&&(!(0,C.isEqual)(l.defaultUrl,a.defaultUrl)||!(0,C.isEqual)(l.insidersUrl,a.insidersUrl)||!(0,C.isEqual)(l.stableUrl,a.stableUrl))}async doSync(a,l,g){this.logService.info(`Auto Sync: Triggered by ${a}`),this._onDidStartSync.fire();let E;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(l),g.isCancellationRequested)return;let d=this.syncTask.manifest;if(d===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new k.UserDataAutoSyncError((0,v.localize)(0,null),k.UserDataSyncErrorCode.DefaultServiceChanged):new k.UserDataAutoSyncError((0,v.localize)(1,null),k.UserDataSyncErrorCode.ServiceChanged):new k.UserDataAutoSyncError((0,v.localize)(2,null),k.UserDataSyncErrorCode.TurnedOff);const T=this.storageService.get(s,0);if(T&&d&&T!==d.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new k.UserDataAutoSyncError((0,v.localize)(3,null),k.UserDataSyncErrorCode.DefaultServiceChanged):new k.UserDataAutoSyncError((0,v.localize)(4,null),k.UserDataSyncErrorCode.ServiceChanged):new k.UserDataAutoSyncError((0,v.localize)(5,null),k.UserDataSyncErrorCode.SessionExpired);const O=await this.userDataSyncMachinesService.getMachines(d||void 0);if(g.isCancellationRequested)return;const $=O.find(z=>z.isCurrent);if($?.disabled)throw new k.UserDataAutoSyncError((0,v.localize)(6,null),k.UserDataSyncErrorCode.TurnedOff);if(await this.syncTask.run(),d===null&&(d=await this.userDataSyncStoreService.manifest()),d&&d.session!==T&&this.storageService.store(s,d.session,0,1),g.isCancellationRequested)return;$||await this.userDataSyncMachinesService.addCurrentMachine(d||void 0)}catch(d){this.logService.error(d),E=d}this._onDidFinishSync.fire(E)}register(a){return super._register(a)}}o.INTERVAL_SYNCING="Interval"}),define(X[200],Q([0,1,22,2,3,20,21,7]),function(G,e,p,L,D,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let S=class extends L.Disposable{constructor(n,y){super();this.storageService=n,this.telemetryService=y,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(n.onDidChangeValue(v=>this.onDidStorageChange(v)))}isResourceEnabled(n){return this.storageService.getBoolean((0,p.getEnablementKey)(n),0,!0)}setResourceEnablement(n,y){if(this.isResourceEnabled(n)!==y){const v=(0,p.getEnablementKey)(n);this.telemetryService.publicLog2(v,{enabled:y}),this.storeResourceEnablement(v,y)}}getResourceSyncStateVersion(n){}storeResourceEnablement(n,y){this.storageService.store(n,y,0,R.isWeb?0:1)}onDidStorageChange(n){if(n.scope===0){const y=p.ALL_SYNC_RESOURCES.filter(v=>(0,p.getEnablementKey)(v)===n.key)[0];if(y){this._onDidChangeResourceEnablement.fire([y,this.isResourceEnabled(y)]);return}}}};S=fe([K(0,k.IStorageService),K(1,A.ITelemetryService)],S),e.UserDataSyncResourceEnablementService=S}),define(X[201],Q([0,1,22,2,5,3,190,193,192,43,21,23,20,195,15,196,30,6,9]),function(G,e,p,L,D,k,A,R,S,w,n,y,v,m,h,C,P,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const f="sync.lastSyncTime";let s=class extends L.Disposable{constructor(i,o,u,a,l,g){super();this.userDataSyncStoreService=i,this.userDataSyncStoreManagementService=o,this.instantiationService=u,this.logService=a,this.telemetryService=l,this.storageService=g,this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new k.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new k.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(m.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(R.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(C.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(S.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(A.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(k.Event.any(...this.synchronisers.map(E=>k.Event.map(E.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(k.Event.any(...this.synchronisers.map(E=>k.Event.map(E.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(f,0,void 0),this.onDidChangeLocal=k.Event.any(...this.synchronisers.map(E=>k.Event.map(E.onDidChangeLocal,()=>E.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(i){await this.checkEnablement();const o=(0,P.generateUuid)();let u;try{const E=(0,p.createSyncHeaders)(o);i&&(E["Cache-Control"]="no-cache"),u=await this.userDataSyncStoreService.manifest(E)}catch(E){const d=p.UserDataSyncError.toUserDataSyncError(E);throw this.reportUserDataSyncError(d,o),d}let a=!1;const l=this;let g;return{manifest:u,run(){if(a)throw new Error("Can run a task only once");return g=(0,b.createCancelablePromise)(E=>l.sync(u,o,E)),g.finally(()=>g=void 0)},async stop(){if(g&&g.cancel(),l.status!=="idle")return l.stop()}}}async createManualSyncTask(){await this.checkEnablement();const i=(0,P.generateUuid)(),o=(0,p.createSyncHeaders)(i);let u;try{u=await this.userDataSyncStoreService.manifest(o)}catch(a){const l=p.UserDataSyncError.toUserDataSyncError(a);throw this.reportUserDataSyncError(l,i),l}return new c(i,u,o,this.synchronisers,this.logService)}async sync(i,o,u){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),u.isCancellationRequested)return;const a=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const l=(0,p.createSyncHeaders)(o);for(const g of this.synchronisers){if(u.isCancellationRequested)return;try{await g.sync(i,l)}catch(E){if(E instanceof p.UserDataSyncError)switch(E.code){case p.UserDataSyncErrorCode.TooLarge:throw new p.UserDataSyncError(E.message,E.code,g.resource);case p.UserDataSyncErrorCode.TooManyRequests:case p.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case p.UserDataSyncErrorCode.LocalTooManyRequests:case p.UserDataSyncErrorCode.Gone:case p.UserDataSyncErrorCode.UpgradeRequired:case p.UserDataSyncErrorCode.IncompatibleRemoteContent:case p.UserDataSyncErrorCode.IncompatibleLocalContent:throw E}const d=p.UserDataSyncError.toUserDataSyncError(E);this.reportUserDataSyncError(d,o),this.logService.error(E),this.logService.error(`${g.resource}: ${(0,w.toErrorMessage)(E)}`),this._syncErrors.push([g.resource,d])}}this.logService.info(`Sync done. Took ${new Date().getTime()-a}ms`),this.updateLastSyncTime()}catch(l){const g=p.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(g,o),g}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const i of this.synchronisers)try{i.status!=="idle"&&await i.stop()}catch(o){this.logService.error(o)}}async replace(i){await this.checkEnablement();for(const o of this.synchronisers)if(await o.replace(i))return}async accept(i,o,u,a){await this.checkEnablement();const l=this.getSynchroniser(i);await l.accept(o,u),a&&await l.apply(!1,(0,p.createSyncHeaders)((0,P.generateUuid)()))}async resolveContent(i){for(const o of this.synchronisers){const u=await o.resolveContent(i);if(u)return u}return null}getRemoteSyncResourceHandles(i){return this.getSynchroniser(i).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(i){return this.getSynchroniser(i).getLocalSyncResourceHandles()}getAssociatedResources(i,o){return this.getSynchroniser(i).getAssociatedResources(o)}getMachineId(i,o){return this.getSynchroniser(i).getMachineId(o)}async hasLocalData(){const i=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const o of i)if(await o.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(i){this.logService.error(i)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(f,0);for(const i of this.synchronisers)try{await i.resetLocal()}catch(o){this.logService.error(`${i.resource}: ${(0,w.toErrorMessage)(o)}`),this.logService.error(o)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const i of this.synchronisers)if(await i.hasPreviouslySynced())return!0;return!1}setStatus(i){const o=this._status;this._status!==i&&(this._status=i,this._onDidChangeStatus.fire(i),o==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const i=this.computeStatus();this.setStatus(i)}updateConflicts(){const i=this.computeConflicts();(0,y.equals)(this._conflicts,i,([o,u],[a,l])=>o===o&&(0,y.equals)(u,l,(g,E)=>(0,h.isEqual)(g.previewResource,E.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(i))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(f,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(i,o){this.telemetryService.publicLog2("sync/error",{code:i.code,url:i instanceof p.UserDataSyncStoreError?i.url:void 0,resource:i.resource,executionId:o,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(i=>i.status==="hasConflicts").map(i=>[i.resource,i.conflicts.map(t)])}getSynchroniser(i){return this.synchronisers.find(o=>o.resource===i)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};s=fe([K(0,p.IUserDataSyncStoreService),K(1,p.IUserDataSyncStoreManagementService),K(2,D.IInstantiationService),K(3,p.IUserDataSyncLogService),K(4,n.ITelemetryService),K(5,v.IStorageService)],s),e.UserDataSyncService=s;class c extends L.Disposable{constructor(i,o,u,a,l){super();this.id=i,this.manifest=o,this.syncHeaders=u,this.synchronisers=a,this.logService=l,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new k.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,b.createCancelablePromise)(i=>this.getPreviews(i))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(i){throw this.logService.error(i),i}}async accept(i,o){try{return await this.performAction(i,u=>u.accept(i,o))}catch(u){throw this.logService.error(u),u}}async merge(i){try{return i?await this.performAction(i,o=>o.merge(i)):await this.mergeAll()}catch(o){throw this.logService.error(o),o}}async discard(i){try{return await this.performAction(i,o=>o.discard(i))}catch(o){throw this.logService.error(o),o}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const i=[];for(const[,o]of this.previews)for(const u of o.resourcePreviews)u.mergeState==="conflict"&&i.push(u.previewResource);for(const o of i)await this.discard(o);return this.previews}catch(i){throw this.logService.error(i),i}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const i=[];for(const[o,u]of this.previews){this.synchronizingResources.push([o,u.resourcePreviews.map(g=>g.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const a=this.synchronisers.find(g=>g.resource===o);for(const g of u.resourcePreviews)(g.localChange!==0||g.remoteChange!==0)&&g.mergeState==="preview"&&await a.merge(g.previewResource);const l=await a.apply(!1,this.syncHeaders);l&&i.push(this.toSyncResourcePreview(a.resource,l)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(g=>g[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}catch(i){throw this.logService.error(i),i}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,o]of this.previews){this.synchronizingResources.push([i,o.resourcePreviews.map(a=>a.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(a=>a.resource===i);for(const a of o.resourcePreviews)await u.accept(a.remoteResource);await u.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(a=>a[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,o]of this.previews){this.synchronizingResources.push([i,o.resourcePreviews.map(a=>a.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(a=>a.resource===i);for(const a of o.resourcePreviews)await u.accept(a.localResource);await u.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(a=>a[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async stop(){for(const i of this.synchronisers)try{await i.stop()}catch(o){(0,I.isPromiseCanceledError)(o)||this.logService.error(o)}this.reset()}async performAction(i,o){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const u=this.previews.findIndex(([,$])=>$.resourcePreviews.some(({localResource:z,previewResource:V,remoteResource:B})=>(0,h.isEqual)(i,z)||(0,h.isEqual)(i,V)||(0,h.isEqual)(i,B)));if(u===-1)return this.previews;const[a,l]=this.previews[u],g=l.resourcePreviews.find(({localResource:$,remoteResource:z,previewResource:V})=>(0,h.isEqual)($,i)||(0,h.isEqual)(z,i)||(0,h.isEqual)(V,i));if(!g)return this.previews;let E=this.synchronizingResources.find($=>$[0]===a);E||(E=[a,[]],this.synchronizingResources.push(E)),E[1].some($=>(0,h.isEqual)($,g.localResource))||(E[1].push(g.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const d=this.synchronisers.find($=>$.resource===this.previews[u][0]),T=await o(d);T?this.previews.splice(u,1,this.toSyncResourcePreview(d.resource,T)):this.previews.splice(u,1);const O=this.synchronizingResources.findIndex($=>$[0]===a);return this.synchronizingResources[O][1].splice(E[1].findIndex($=>(0,h.isEqual)($,g.localResource)),1),E[1].length||(this.synchronizingResources.splice(O,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const i=[];for(const[o,u]of this.previews){this.synchronizingResources.push([o,u.resourcePreviews.map(g=>g.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const a=this.synchronisers.find(g=>g.resource===o);let l=u;for(const g of u.resourcePreviews)(g.localChange!==0||g.remoteChange!==0)&&g.mergeState==="preview"&&(l=await a.merge(g.previewResource));l&&i.push(this.toSyncResourcePreview(a.resource,l)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(g=>g[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}async getPreviews(i){const o=[];for(const u of this.synchronisers){if(i.isCancellationRequested)return[];const a=await u.preview(this.manifest,this.syncHeaders);a&&o.push(this.toSyncResourcePreview(u.resource,a))}return o}toSyncResourcePreview(i,o){return[i,{isLastSyncFromCurrentMachine:o.isLastSyncFromCurrentMachine,resourcePreviews:o.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(r){return{localResource:r.localResource,previewResource:r.previewResource,remoteResource:r.remoteResource,acceptedResource:r.acceptedResource,localChange:r.localChange,remoteChange:r.remoteChange,mergeState:r.mergeState}}}),define(X[202],Q([0,1,3,22,4,2,16]),function(G,e,p,L,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class R{constructor(y,v){this.service=y,this.logService=v,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new p.Emitter}listen(y,v){switch(v){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${v}`)}async call(y,v,m){try{return await this._call(y,v,m)}catch(h){throw this.logService.error(h),h}}async _call(y,v,m){switch(v){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(D.URI.revive(m[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(m[0],D.URI.revive(m[1]),m[2],m[3]);case"resolveContent":return this.service.resolveContent(D.URI.revive(m[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(m[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(m[0]);case"getAssociatedResources":return this.service.getAssociatedResources(m[0],{created:m[1].created,uri:D.URI.revive(m[1].uri)});case"getMachineId":return this.service.getMachineId(m[0],{created:m[1].created,uri:D.URI.revive(m[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(v.startsWith("manualSync/")){const h=v.substring("manualSync/".length),C=m[0],P=this.getManualSyncTask(C);switch(m=m.slice(1),h){case"preview":return P.preview();case"accept":return P.accept(D.URI.revive(m[0]),m[1]);case"merge":return P.merge(D.URI.revive(m[0]));case"discard":return P.discard(D.URI.revive(m[0]));case"discardConflicts":return P.discardConflicts();case"apply":return P.apply();case"pull":return P.pull();case"push":return P.push();case"stop":return P.stop();case"_getStatus":return P.status;case"dispose":return this.disposeManualSyncTask(P)}}throw new Error("Invalid call")}getManualSyncTask(y){const v=this.manualSyncTasks.get(this.createKey(y));if(!v)throw new Error(`Manual sync taks not found: ${y}`);return v.manualSyncTask}async createManualSyncTask(){const y=new k.DisposableStore,v=y.add(await this.service.createManualSyncTask());return y.add(v.onSynchronizeResources(m=>this.onManualSynchronizeResources.fire({manualSyncTaskId:v.id,data:m}))),this.manualSyncTasks.set(this.createKey(v.id),{manualSyncTask:v,disposables:y}),{id:v.id,manifest:v.manifest,status:v.status}}disposeManualSyncTask(y){y.dispose();const v=this.createKey(y.id);this.manualSyncTasks.get(v)?.disposables.dispose(),this.manualSyncTasks.delete(v)}createKey(y){return`manualSyncTask-${y}`}}e.UserDataSyncChannel=R;class S extends k.Disposable{constructor(y){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new p.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new p.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new p.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new p.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(v,m,h){return y.call(v,m,h).then(null,C=>{throw L.UserDataSyncError.toUserDataSyncError(C)})},listen(v,m){return y.listen(v,m)}},this.channel.call("_getInitialData").then(([v,m,h])=>{this.updateStatus(v),this.updateConflicts(m),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(C=>this.updateStatus(C))),this._register(this.channel.listen("onDidChangeLastSyncTime")(C=>this.updateLastSyncTime(C)))}),this._register(this.channel.listen("onDidChangeConflicts")(v=>this.updateConflicts(v))),this._register(this.channel.listen("onSyncErrors")(v=>this._onSyncErrors.fire(v.map(([m,h])=>[m,L.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:y,manifest:v,status:m}=await this.channel.call("createManualSyncTask"),h=this,C=new w(y,v,m,{async call(P,b,I){return h.channel.call(`manualSync/${P}`,[y,...(0,A.isArray)(b)?b:[b]],I)},listen(P,b){return p.Event.map(p.Event.filter(h.channel.listen(`manualSync/${P}`,b),I=>!C.isDiposed()&&I.manualSyncTaskId===y),I=>I.data)}});return C}replace(y){return this.channel.call("replace",[y])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(y,v,m,h){return this.channel.call("accept",[y,v,m,h])}resolveContent(y){return this.channel.call("resolveContent",[y])}async getLocalSyncResourceHandles(y){return(await this.channel.call("getLocalSyncResourceHandles",[y])).map(({created:m,uri:h})=>({created:m,uri:D.URI.revive(h)}))}async getRemoteSyncResourceHandles(y){return(await this.channel.call("getRemoteSyncResourceHandles",[y])).map(({created:m,uri:h})=>({created:m,uri:D.URI.revive(h)}))}async getAssociatedResources(y,v){return(await this.channel.call("getAssociatedResources",[y,v])).map(({resource:h,comparableResource:C})=>({resource:D.URI.revive(h),comparableResource:D.URI.revive(C)}))}async getMachineId(y,v){return this.channel.call("getMachineId",[y,v])}async updateStatus(y){this._status=y,this._onDidChangeStatus.fire(y)}async updateConflicts(y){this._conflicts=y.map(([v,m])=>[v,m.map(h=>({...h,localResource:D.URI.revive(h.localResource),remoteResource:D.URI.revive(h.remoteResource),previewResource:D.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(y){this._lastSyncTime!==y&&(this._lastSyncTime=y,this._onDidChangeLastSyncTime.fire(y))}}e.UserDataSyncChannelClient=S;class w extends k.Disposable{constructor(y,v,m,h){super();this.id=y,this.manifest=v,this._disposed=!1,this._status=m;const C=this;this.channel={async call(P,b,I){try{const f=await h.call(P,b,I);return C.isDiposed()||(C._status=await h.call("_getStatus")),f}catch(f){throw L.UserDataSyncError.toUserDataSyncError(f)}},listen(P,b){return h.listen(P,b)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const y=await this.channel.call("preview");return this.deserializePreviews(y)}async accept(y,v){const m=await this.channel.call("accept",[y,v]);return this.deserializePreviews(m)}async merge(y){const v=await this.channel.call("merge",[y]);return this.deserializePreviews(v)}async discard(y){const v=await this.channel.call("discard",[y]);return this.deserializePreviews(v)}async discardConflicts(){const y=await this.channel.call("discardConflicts");return this.deserializePreviews(y)}async apply(){const y=await this.channel.call("apply");return this.deserializePreviews(y)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(y){return y.map(([v,m])=>[v,{isLastSyncFromCurrentMachine:m.isLastSyncFromCurrentMachine,resourcePreviews:m.resourcePreviews.map(h=>({...h,localResource:D.URI.revive(h.localResource),remoteResource:D.URI.revive(h.remoteResource),previewResource:D.URI.revive(h.previewResource),acceptedResource:D.URI.revive(h.acceptedResource)}))}])}}}),define(X[203],Q([0,1,2,22,39,15,29,24,28,45,12,13,20,30,7,3,6,16,4,9,92]),function(G,e,p,L,D,k,A,R,S,w,n,y,v,m,h,C,P,b,I,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const c="sync.previous.store",t="sync.donot-make-requests-until",r="sync.user-session-id",i="sync.machine-session-id",o=100,u=1e3*60*5;let a=class extends p.Disposable{constructor(O,$,z){super();this.productService=O,this.configurationService=$,this.storageService=z,this._onDidChangeUserDataSyncStore=this._register(new C.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(C.Event.filter(z.onDidChangeValue,V=>V.key===L.SYNC_SERVICE_URL_TYPE&&V.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(L.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(L.SYNC_SERVICE_URL_TYPE,O,0,h.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[L.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(L.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,$){O=h.isWeb&&O?.web?{...O,...O.web}:O;const z={...O||{},...$||{}};if(z&&(0,b.isString)(z.url)&&(0,b.isObject)(z.authenticationProviders)&&Object.keys(z.authenticationProviders).every(V=>(0,b.isArray)(z.authenticationProviders[V].scopes))){const V=z,B=!!V.canSwitch&&!$?.url,M=V.url===V.insidersUrl?"insiders":"stable",_=(B?this.userDataSyncStoreType:void 0)||M,N=$?.url||(_==="insiders"?V.insidersUrl:_==="stable"?V.stableUrl:V.url);return{url:I.URI.parse(N),type:_,defaultType:M,defaultUrl:I.URI.parse(V.url),stableUrl:I.URI.parse(V.stableUrl),insidersUrl:I.URI.parse(V.insidersUrl),canSwitch:B,authenticationProviders:Object.keys(V.authenticationProviders).reduce((j,F)=>(j.push({id:F,scopes:V.authenticationProviders[F].scopes}),j),[])}}}};a=fe([K(0,S.IProductService),K(1,R.IConfigurationService),K(2,v.IStorageService)],a),e.AbstractUserDataSyncStoreManagementService=a;let l=class extends a{constructor(O,$,z){super(O,$,z);const V=this.storageService.get(c,0);V&&(this.previousConfigurationSyncStore=JSON.parse(V));const B=this.productService[L.CONFIGURATION_SYNC_STORE_KEY];B?this.storageService.store(c,JSON.stringify(B),0,1):this.storageService.remove(c,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};l=fe([K(0,S.IProductService),K(1,R.IConfigurationService),K(2,v.IStorageService)],l),e.UserDataSyncStoreManagementService=l;let g=class extends p.Disposable{constructor(O,$,z,V,B,M,_){super();this.requestService=z,this.logService=V,this.storageService=_,this._onTokenFailed=this._register(new C.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new C.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new C.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,w.getServiceMachineId)(B,M,_).then(N=>{const j={"X-Client-Name":`${$.applicationName}${h.isWeb?"-web":""}`,"X-Client-Version":$.version,"X-Machine-Id":N};return $.commit&&(j["X-Client-Commit"]=$.commit),j}),this.session=new d(o,u,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,p.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,$){this.authToken={token:O,type:$}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,k.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(t,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,P.createCancelablePromise)($=>(0,P.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),$).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,$=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O),z={},V=await this.request($.toString(),{type:"GET",headers:z},[],A.CancellationToken.None);return(await(0,D.asJson)(V)||[]).map(({url:M,created:_})=>({ref:(0,k.relativePath)($,$.with({path:M})),created:_*1e3}))}async resolveContent(O,$){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O,$).toString(),V={};V["Cache-Control"]="no-cache";const B=await this.request(z,{type:"GET",headers:V},[],A.CancellationToken.None);return await(0,D.asText)(B)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),z={};await this.request($,{type:"DELETE",headers:z},[],A.CancellationToken.None)}async read(O,$,z={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const V=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();z={...z},z["Cache-Control"]="no-cache",$&&(z["If-None-Match"]=$.ref);const B=await this.request(V,{type:"GET",headers:z},[304],A.CancellationToken.None);if(B.res.statusCode===304)return $;const M=B.res.headers.etag;if(!M)throw new L.UserDataSyncStoreError("Server did not return the ref",V,L.UserDataSyncErrorCode.NoRef,B.res.headers[L.HEADER_OPERATION_ID]);const _=await(0,D.asText)(B);return{ref:M,content:_}}async write(O,$,z,V={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const B=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();V={...V},V["Content-Type"]=s.Mimes.text,z&&(V["If-Match"]=z);const M=await this.request(B,{type:"POST",data:$,headers:V},[],A.CancellationToken.None),_=M.res.headers.etag;if(!_)throw new L.UserDataSyncStoreError("Server did not return the ref",B,L.UserDataSyncErrorCode.NoRef,M.res.headers[L.HEADER_OPERATION_ID]);return _}async manifest(O={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,k.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();O={...O},O["Content-Type"]="application/json";const z=await this.request($,{type:"GET",headers:O},[],A.CancellationToken.None),V=await(0,D.asJson)(z),B=this.storageService.get(r,0);return B&&V&&B!==V.session&&this.clearSession(),V===null&&B&&this.clearSession(),V&&this.storageService.store(r,V.session,0,1),V}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),$={"Content-Type":s.Mimes.text};await this.request(O,{type:"DELETE",headers:$},[],A.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(r,0),this.storageService.remove(i,0)}async request(O,$,z,V){if(!this.authToken)throw new L.UserDataSyncStoreError("No Auth Token Available",O,L.UserDataSyncErrorCode.Unauthorized,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new L.UserDataSyncStoreError(`${$.type} request '${O}' failed because of too many requests (429).`,O,L.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0);this.setDonotMakeRequestsUntil(void 0);const B=await this.commonHeadersPromise;$.headers={...$.headers||{},...B,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders($.headers),this.logService.trace("Sending request to server",{url:O,type:$.type,headers:{...$.headers,authorization:void 0}});let M;try{M=await this.session.request(O,$,V)}catch(F){if(!(F instanceof L.UserDataSyncStoreError)){const U=(0,f.isPromiseCanceledError)(F)?L.UserDataSyncErrorCode.RequestCanceled:(0,f.getErrorMessage)(F).startsWith("XHR timeout")?L.UserDataSyncErrorCode.RequestTimeout:L.UserDataSyncErrorCode.RequestFailed;F=new L.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,U,void 0)}throw this.logService.info("Request failed",O),F}const _=M.res.headers[L.HEADER_OPERATION_ID],N={url:O,status:M.res.statusCode,"execution-id":$.headers[L.HEADER_EXECUTION_ID],"operation-id":_},j=(0,D.isSuccess)(M)||M.res.statusCode&&z.indexOf(M.res.statusCode)!==-1;if(j?this.logService.trace("Request succeeded",N):this.logService.info("Request failed",N),M.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new L.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,L.UserDataSyncErrorCode.Unauthorized,_);if(this._onTokenSucceed.fire(),M.res.statusCode===409)throw new L.UserDataSyncStoreError(`${$.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,L.UserDataSyncErrorCode.Conflict,_);if(M.res.statusCode===410)throw new L.UserDataSyncStoreError(`${$.type} request '${O}' failed because the requested resource is not longer available (410).`,O,L.UserDataSyncErrorCode.Gone,_);if(M.res.statusCode===412)throw new L.UserDataSyncStoreError(`${$.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,L.UserDataSyncErrorCode.PreconditionFailed,_);if(M.res.statusCode===413)throw new L.UserDataSyncStoreError(`${$.type} request '${O}' failed because of too large payload (413).`,O,L.UserDataSyncErrorCode.TooLarge,_);if(M.res.statusCode===426)throw new L.UserDataSyncStoreError(`${$.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,L.UserDataSyncErrorCode.UpgradeRequired,_);if(M.res.statusCode===429){const F=M.res.headers["retry-after"];throw F?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(F)*1e3)),new L.UserDataSyncStoreError(`${$.type} request '${O}' failed because of too many requests (429).`,O,L.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,_)):new L.UserDataSyncStoreError(`${$.type} request '${O}' failed because of too many requests (429).`,O,L.UserDataSyncErrorCode.TooManyRequests,_)}if(!j)throw new L.UserDataSyncStoreError("Server returned "+M.res.statusCode,O,L.UserDataSyncErrorCode.Unknown,_);return M}addSessionHeaders(O){let $=this.storageService.get(i,0);$===void 0&&($=(0,m.generateUuid)(),this.storageService.store(i,$,0,1)),O["X-Machine-Session-Id"]=$;const z=this.storageService.get(r,0);z!==void 0&&(O["X-User-Session-Id"]=z)}};g=fe([K(1,S.IProductService),K(2,D.IRequestService),K(3,L.IUserDataSyncLogService),K(4,n.IEnvironmentService),K(5,y.IFileService),K(6,v.IStorageService)],g),e.UserDataSyncStoreClient=g;let E=class extends g{constructor(O,$,z,V,B,M,_){super(O.userDataSyncStore?.url,$,z,V,B,M,_);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};E=fe([K(0,L.IUserDataSyncStoreManagementService),K(1,S.IProductService),K(2,D.IRequestService),K(3,L.IUserDataSyncLogService),K(4,n.IEnvironmentService),K(5,y.IFileService),K(6,v.IStorageService)],E),e.UserDataSyncStoreService=E;class d{constructor(O,$,z,V){this.limit=O,this.interval=$,this.requestService=z,this.logService=V,this.requests=[],this.startTime=void 0}request(O,$,z){if(this.isExpired()&&this.reset(),$.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new L.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,L.UserDataSyncErrorCode.LocalTooManyRequests,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request($,z)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=d}),define(X[204],Q([0,1,22,3,58,86,60,21,20,61,28]),function(G,e,p,L,D,k,A,R,S,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let y=class extends k.UserDataAutoSyncService{constructor(m,h,C,P,b,I,f,s,c,t,r,i){super(m,h,C,P,b,f,s,c,t,r,i);this._register(L.Event.debounce(L.Event.any(L.Event.map(I.onDidFocusWindow,()=>"windowFocus"),L.Event.map(I.onDidOpenWindow,()=>"windowOpen")),(o,u)=>o?[...o,u]:[u],1e3)(o=>this.triggerSync(o,!0,!1)))}};y=fe([K(0,n.IProductService),K(1,p.IUserDataSyncStoreManagementService),K(2,p.IUserDataSyncStoreService),K(3,p.IUserDataSyncResourceEnablementService),K(4,p.IUserDataSyncService),K(5,D.INativeHostService),K(6,p.IUserDataSyncLogService),K(7,A.IUserDataSyncAccountService),K(8,R.ITelemetryService),K(9,w.IUserDataSyncMachinesService),K(10,S.IStorageService),K(11,p.IUserDataAutoSyncEnablementService)],y),e.UserDataAutoSyncService=y}),define(X[205],Q([0,1,3,2,6]),function(G,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends L.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:S,getActiveWindowId:w}){super();this.disposables=this._register(new L.DisposableStore),p.Event.latch(p.Event.any(R,S))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>w()),(async()=>{try{const y=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:y}catch(y){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=k}),define(X[62],Q([0,1,108,8,49,6,18,212,213,16]),function(G,e,p,L,D,k,A,R,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class n extends Error{constructor(t,r){let i=r.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=t,this.cause=r}}e.ExtractError=n;function y(c){const t=c.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,i)=>r+i,t&61440)}function v(c){if(c instanceof n)return c;let t;return/end of central directory record signature not found/.test(c.message)&&(t="CorruptZip"),new n(t,c)}function m(c,t,r,i,o,u){const a=L.dirname(t),l=L.join(i,a);if(!l.startsWith(i))return Promise.reject(new Error(p.localize(0,null,t)));const g=L.join(i,t);let E;return u.onCancellationRequested(()=>{E&&E.destroy()}),Promise.resolve(A.Promises.mkdir(l,{recursive:!0})).then(()=>new Promise((d,T)=>{if(!u.isCancellationRequested)try{E=(0,D.createWriteStream)(g,{mode:r}),E.once("close",()=>d()),E.once("error",T),c.once("error",T),c.pipe(E)}catch(O){T(O)}}))}function h(c,t,r,i){let o=(0,k.createCancelablePromise)(()=>Promise.resolve()),u=0;return i.onCancellationRequested(()=>{o.cancel(),c.close()}),new Promise((a,l)=>{const g=new k.Sequencer,E=d=>{d.isCancellationRequested||(u++,c.readEntry())};c.once("error",l),c.once("close",()=>o.then(()=>{i.isCancellationRequested||c.entryCount===u?a():l(new n("Incomplete",new Error(p.localize(1,null,u,c.entryCount))))},l)),c.readEntry(),c.on("entry",d=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(d.fileName)){E(i);return}const T=d.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(T)){const z=L.join(t,T);o=(0,k.createCancelablePromise)(V=>A.Promises.mkdir(z,{recursive:!0}).then(()=>E(V)).then(void 0,l));return}const O=P(c,d),$=y(d);o=(0,k.createCancelablePromise)(z=>g.queue(()=>O.then(V=>m(V,T,$,t,r,z).then(()=>E(z)))).then(null,l))})})}function C(c,t=!1){return new Promise((r,i)=>{(0,R.open)(c,t?{lazyEntries:!0}:void 0,(o,u)=>{o?i(v(o)):r((0,w.assertIsDefined)(u))})})}function P(c,t){return new Promise((r,i)=>{c.openReadStream(t,(o,u)=>{o?i(v(o)):r((0,w.assertIsDefined)(u))})})}function b(c,t){return new Promise((r,i)=>{const o=new S.ZipFile;t.forEach(a=>{a.contents?o.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&o.addFile(a.localPath,a.path)}),o.end();const u=(0,D.createWriteStream)(c);o.outputStream.pipe(u),o.outputStream.once("error",i),u.once("error",i),u.once("finish",()=>r(c))})}e.zip=b;function I(c,t,r={},i){const o=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let u=C(c,!0);return r.overwrite&&(u=u.then(a=>A.Promises.rm(t).then(()=>a))),u.then(a=>h(a,t,{sourcePathRegex:o},i))}e.extract=I;function f(c,t){return C(c).then(r=>new Promise((i,o)=>{r.on("entry",u=>{u.fileName===t&&P(r,u).then(a=>i(a),a=>o(a))}),r.once("close",()=>o(new Error(p.localize(2,null,t))))}))}function s(c,t){return f(c,t).then(r=>new Promise((i,o)=>{const u=[];r.once("error",o),r.on("data",a=>u.push(a)),r.on("end",()=>i(Buffer.concat(u)))}))}e.buffer=s}),define(X[206],Q([0,1,62,114]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(k){return(0,p.buffer)(k,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch(R){throw new Error((0,L.localize)(0,null))}})}e.getManifest=D}),define(X[207],Q([0,1,57,2,18,8,14,27,31,6,4,12,135,115,28,62,7,23,17,13,15,30,9]),function(G,e,p,L,D,k,A,R,S,w,n,y,v,m,h,C,P,b,I,f,s,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const r="scanningSystem",i="scanningUser",o="extracting",u="deleting",a="renaming";let l=class extends L.Disposable{constructor(E,d,T,O,$){super();this.beforeRemovingExtension=E,this.fileService=d,this.logService=T,this.environmentService=O,this.productService=$,this._devSystemExtensionsPath=null,this.systemExtensionsPath=O.builtinExtensionsPath,this.extensionsPath=O.extensionsPath,this.uninstalledPath=k.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new w.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(E){const d=[];(E===null||E===0)&&d.push(this.scanSystemExtensions().then(null,T=>Promise.reject(new R.ExtensionManagementError(this.joinErrors(T).message,r)))),(E===null||E===1)&&d.push(this.scanUserExtensions(!0).then(null,T=>Promise.reject(new R.ExtensionManagementError(this.joinErrors(T).message,i))));try{const T=await Promise.all(d);return(0,b.flatten)(T)}catch(T){throw this.joinErrors(T)}}async scanUserExtensions(E){this.logService.trace("Started scanning user extensions");let[d,T]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return T=T.filter(O=>!d[new S.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]),E&&(T=(0,S.groupByExtension)(T,$=>$.identifier).map($=>$.sort((z,V)=>p.rcompare(z.manifest.version,V.manifest.version))[0])),this.logService.trace("Scanned user extensions:",T.length),T}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(E,d,T){const O=E.key(),$=k.join(this.extensionsPath,`.${(0,c.generateUuid)()}`),z=k.join(this.extensionsPath,O);try{await D.Promises.rm(z)}catch(B){try{await D.Promises.rm(z)}catch(M){}throw new R.ExtensionManagementError((0,m.localize)(0,null,z,E.id),u)}await this.extractAtLocation(E,d,$,T);let V=await this.scanExtension(n.URI.file($),1);if(!V)throw new Error((0,m.localize)(1,null,$));await this.storeMetadata(V,{installedTimestamp:Date.now()});try{await this.rename(E,$,z,Date.now()+2*60*1e3),this.logService.info("Renamed to",z)}catch(B){try{await D.Promises.rm($)}catch(M){}if(B.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",E.id);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(B)}. Deleted from extracted location`,$),B}try{V=await this.scanExtension(n.URI.file(z),1)}catch(B){}if(V)return V;throw new Error((0,m.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(E,d){return this.setMetadata(E,d),await this.storeMetadata(E,{...d,installedTimestamp:E.installedTimestamp}),E}async storeMetadata(E,d){d.isMachineScoped=d.isMachineScoped||void 0,d.isBuiltin=d.isBuiltin||void 0,d.installedTimestamp=d.installedTimestamp||void 0;const T=k.join(E.location.fsPath,"package.json"),O=await D.Promises.readFile(T,"utf8"),{manifest:$}=await this.parseManifest(O);return $.__metadata=d,await D.Promises.writeFile(T,JSON.stringify($,null,"	")),E}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...E){const d=E.map(T=>new S.ExtensionIdentifierWithVersion(T.identifier,T.manifest.version));await this.withUninstalledExtensions(T=>{d.forEach(O=>T[O.key()]=!0)})}async setInstalled(E){await this.withUninstalledExtensions(O=>delete O[E.key()]);const T=(await this.scanExtensions(1)).find(O=>new S.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).equals(E))||null;return T?(await this.storeMetadata(T,{installedTimestamp:Date.now()}),this.scanExtension(T.location,1)):null}async withUninstalledExtensions(E){return this.uninstalledFileLimiter.queue(async()=>{let d;try{d=await D.Promises.readFile(this.uninstalledPath,"utf8")}catch(O){if(O.code!=="ENOENT")throw O}let T={};if(d)try{T=JSON.parse(d)}catch(O){}return E&&(E(T),Object.keys(T).length?await D.Promises.writeFile(this.uninstalledPath,JSON.stringify(T)):await D.Promises.rm(this.uninstalledPath)),T})}async removeExtension(E,d){this.logService.trace(`Deleting ${d} extension from disk`,E.identifier.id,E.location.fsPath),await D.Promises.rm(E.location.fsPath),this.logService.info("Deleted from disk",E.identifier.id,E.location.fsPath)}async removeUninstalledExtension(E){await this.removeExtension(E,"uninstalled"),await this.withUninstalledExtensions(d=>delete d[new S.ExtensionIdentifierWithVersion(E.identifier,E.manifest.version).key()])}async extractAtLocation(E,d,T,O){this.logService.trace(`Started extracting the extension from ${d} to ${T}`);try{await D.Promises.rm(T)}catch($){throw new R.ExtensionManagementError(this.joinErrors($).message,u)}try{await(0,C.extract)(d,T,{sourcePath:"extension",overwrite:!0},O),this.logService.info(`Extracted extension to ${T}:`,E.id)}catch($){try{await D.Promises.rm(T)}catch(z){}throw new R.ExtensionManagementError($.message,$ instanceof C.ExtractError&&$.type?$.type:o)}}async rename(E,d,T,O){try{await D.Promises.rename(d,T)}catch($){if(P.isWindows&&$&&$.code==="EPERM"&&Date.now()<O)return this.logService.info(`Failed renaming ${d} to ${T} with 'EPERM' error. Trying again...`,E.id),this.rename(E,d,T,O);throw new R.ExtensionManagementError($.message||(0,m.localize)(3,null,d,T),$.code||a)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const E=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return E;const d=this.scanDevSystemExtensions(),[T,O]=await Promise.all([E,d]);return[...T,...O]}async scanExtensionsInDir(E,d){const T=new w.Limiter(10),O=await this.fileService.resolve(n.URI.file(E));return O.children?(await Promise.all(O.children.filter(z=>z.isDirectory).map(z=>T.queue(async()=>d===1&&(0,s.basename)(z.resource).indexOf(".")===0?null:this.scanExtension(z.resource,d))))).filter(z=>z&&z.identifier):[]}async scanExtension(E,d){try{const T=await this.fileService.resolve(E);if(T.children){const{manifest:O,metadata:$}=await this.readManifest(E.fsPath),z=T.children.find(({name:_})=>/^readme(\.txt|\.md|)$/i.test(_))?.resource,V=T.children.find(({name:_})=>/^changelog(\.txt|\.md|)$/i.test(_))?.resource,B={id:(0,S.getGalleryExtensionId)(O.publisher,O.name)},M={type:d,identifier:B,manifest:O,location:E,readmeUrl:z,changelogUrl:V,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:d===0};return $&&(this.setMetadata(M,$),M.installedTimestamp=$.installedTimestamp),M}}catch(T){d!==0&&this.logService.trace(T)}return null}async scanDefaultSystemExtensions(){const E=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",E.length),E}async scanDevSystemExtensions(){const E=this.getDevSystemExtensionsList();if(E.length){const d=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",d.length),d.filter(T=>E.some(O=>(0,S.areSameExtensions)(T.identifier,{id:O})))}else return[]}setMetadata(E,d){E.publisherDisplayName=d.publisherDisplayName||null,E.publisherId=d.publisherId||null,E.identifier.uuid=d.id,E.isMachineScoped=!!d.isMachineScoped,E.isBuiltin=E.type===0||!!d.isBuiltin}async removeUninstalledExtensions(){const E=await this.getUninstalledExtensions(),d=await this.scanAllUserExtensions(),T=new Set;for(const z of d)E[new S.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version).key()]||T.add(z.identifier.id.toLowerCase());const O=(0,S.groupByExtension)(d,z=>z.identifier);await w.Promises.settled(O.map(async z=>{const V=z.sort((B,M)=>p.rcompare(B.manifest.version,M.manifest.version))[0];T.has(V.identifier.id.toLowerCase())||await this.beforeRemovingExtension(V)}));const $=d.filter(z=>E[new S.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version).key()]);await w.Promises.settled($.map(z=>this.removeUninstalledExtension(z)))}async removeOutdatedExtensions(){const E=await this.scanAllUserExtensions(),d=[],T=(0,S.groupByExtension)(E,O=>O.identifier);d.push(...(0,b.flatten)(T.map(O=>O.sort(($,z)=>p.rcompare($.manifest.version,z.manifest.version)).slice(1)))),await w.Promises.settled(d.map(O=>this.removeExtension(O,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(E=>E.name)}joinErrors(E){const d=Array.isArray(E)?E:[E];return d.length===1?d[0]instanceof Error?d[0]:new Error(d[0]):d.reduce((T,O)=>new Error(`${T.message}${T.message?",":""}${O instanceof Error?O.message:O}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=k.normalize(k.join(I.FileAccess.asFileUri("",G).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(E){const d=[D.Promises.readFile(k.join(E,"package.json"),"utf8").then(z=>this.parseManifest(z)),D.Promises.readFile(k.join(E,"package.nls.json"),"utf8").then(void 0,z=>z.code!=="ENOENT"?Promise.reject(z):"{}").then(z=>JSON.parse(z))],[{manifest:T,metadata:O},$]=await Promise.all(d);return{manifest:(0,v.localizeManifest)(T,$),metadata:O}}parseManifest(E){return new Promise((d,T)=>{try{const O=JSON.parse(E),$=O.__metadata||null;d({manifest:O,metadata:$})}catch(O){T(new Error((0,m.localize)(4,null)))}})}};l=fe([K(1,f.IFileService),K(2,A.ILogService),K(3,y.INativeEnvironmentService),K(4,h.IProductService)],l),e.ExtensionsScanner=l}),define(X[208],Q([0,1,113,8,18,62,27,31,12,57,4,44,7,14,146,43,21,70,15,30,72,5,17,206,156,207,157,158,13,175]),function(G,e,p,L,D,k,A,R,S,w,n,y,v,m,h,C,P,b,I,f,s,c,t,r,i,o,u,a,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const E="unsetUninstalled",d="downloading";let T=class extends g.AbstractExtensionManagementService{constructor(M,_,N,j,F,U,x){super(M,_,N);this.environmentService=j,this.downloadService=F;const q=this._register(U.createInstance(u.ExtensionsLifecycle));this.extensionsScanner=this._register(U.createInstance(o.ExtensionsScanner,Y=>q.postUninstall(Y))),this.manifestCache=this._register(new h.ExtensionsManifestCache(j,this)),this.extensionsDownloader=this._register(U.createInstance(i.ExtensionsDownloader));const H=this._register(new a.ExtensionsWatcher(this,x,j,N));this._register(H.onDidChangeExtensionsByAnotherSource(({added:Y,removed:te})=>{Y.length&&this._onDidInstallExtensions.fire(Y.map(ne=>({identifier:ne.identifier,operation:0,local:ne}))),te.forEach(ne=>this._onDidUninstallExtension.fire({identifier:ne}))}))}async zip(M){this.logService.trace("ExtensionManagementService#zip",M.identifier.id);const _=await this.collectFiles(M),N=await(0,k.zip)((0,I.joinPath)(this.environmentService.tmpDir,(0,f.generateUuid)()).fsPath,_);return n.URI.file(N)}async unzip(M){return this.logService.trace("ExtensionManagementService#unzip",M.toString()),(await this.install(M)).identifier}async getManifest(M){const _=await this.downloadVsix(M),N=L.resolve(_.fsPath);return(0,r.getManifest)(N)}getInstalled(M=null){return this.extensionsScanner.scanExtensions(M)}async canInstall(M){return!0}async install(M,_={}){this.logService.trace("ExtensionManagementService#install",M.toString());const N=await this.downloadVsix(M),j=await(0,r.getManifest)(L.resolve(N.fsPath));if(j.engines&&j.engines.vscode&&!(0,b.isEngineValid)(j.engines.vscode,y.default.version,y.default.date))throw new Error(p.localize(0,null,(0,R.getGalleryExtensionId)(j.publisher,j.name),y.default.version));return this.installExtension(j,N,_)}async updateMetadata(M,_){return this.logService.trace("ExtensionManagementService#updateMetadata",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,{...M.manifest.__metadata||{},..._}),this.manifestCache.invalidate(),M}async updateExtensionScope(M,_){return this.logService.trace("ExtensionManagementService#updateExtensionScope",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,{...M.manifest.__metadata||{},isMachineScoped:_}),this.manifestCache.invalidate(),M}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(M){if(M.scheme===t.Schemas.file)return M;if(!this.downloadService)throw new Error("Download service is not available");const _=(0,I.joinPath)(this.environmentService.tmpDir,(0,f.generateUuid)());return await this.downloadService.download(M,_),_}createInstallExtensionTask(M,_,N){return n.URI.isUri(_)?new z(M,_,N,this.galleryService,this.extensionsScanner,this.logService):new $(_,N,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(M,_){return new V(M,_,this.extensionsScanner)}async collectFiles(M){const _=async j=>{let F=await D.Promises.readdir(j);F=F.map(q=>L.join(j,q));const U=await Promise.all(F.map(q=>D.Promises.stat(q)));let x=Promise.resolve([]);return U.forEach((q,H)=>{const Y=F[H];q.isFile()&&(x=x.then(te=>[...te,Y])),q.isDirectory()&&(x=x.then(te=>_(Y).then(ne=>[...te,...ne])))}),x};return(await _(M.location.fsPath)).map(j=>({path:`extension/${L.relative(M.location.fsPath,j)}`,localPath:j}))}};T=fe([K(0,A.IExtensionGalleryService),K(1,P.ITelemetryService),K(2,m.ILogService),K(3,S.INativeEnvironmentService),K(4,(0,c.optional)(s.IDownloadService)),K(5,c.IInstantiationService),K(6,l.IFileService)],T),e.ExtensionManagementService=T;class O extends g.AbstractExtensionTask{constructor(M,_,N,j){super();this.identifier=M,this.source=_,this.extensionsScanner=N,this.logService=j,this._operation=1}get operation(){return this._operation}async installExtension(M,_){try{const N=await this.unsetUninstalledAndGetLocal(M.identifierWithVersion);if(N)return M.metadata?this.extensionsScanner.saveMetadataForLocalExtension(N,M.metadata):N}catch(N){throw v.isMacintosh?new A.ExtensionManagementError(p.localize(1,null),E):new A.ExtensionManagementError(p.localize(2,null),E)}return this.extract(M,_)}async unsetUninstalledAndGetLocal(M){if(!await this.isUninstalled(M))return null;this.logService.trace("Removing the extension from uninstalled list:",M.id);const N=await this.extensionsScanner.setInstalled(M);return this.logService.info("Removed the extension from uninstalled list:",M.id),N}async isUninstalled(M){return!!(await this.extensionsScanner.getUninstalledExtensions())[M.key()]}async extract({zipPath:M,identifierWithVersion:_,metadata:N},j){let F=await this.extensionsScanner.extractUserExtension(_,M,j);return this.logService.info("Extracting completed.",_.id),N&&(F=await this.extensionsScanner.saveMetadataForLocalExtension(F,N)),F}}class $ extends O{constructor(M,_,N,j,F){super(M.identifier,M,j,F);this.gallery=M,this.options=_,this.extensionsDownloader=N}async doRun(M){const N=(await this.extensionsScanner.scanExtensions(null)).find(U=>(0,R.areSameExtensions)(U.identifier,this.gallery.identifier));N&&(this._operation=2);const j=await this.downloadInstallableExtension(this.gallery,this._operation);j.metadata.isMachineScoped=this.options.isMachineScoped||N?.isMachineScoped,j.metadata.isBuiltin=this.options.isBuiltin||N?.isBuiltin;const F=await this.installExtension(j,M);N&&w.neq(N.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(N);try{await this.extensionsDownloader.delete(n.URI.file(j.zipPath))}catch(U){}return F}async downloadInstallableExtension(M,_){const N={id:M.identifier.uuid,publisherId:M.publisherId,publisherDisplayName:M.publisherDisplayName};let j;try{this.logService.trace("Started downloading extension:",M.identifier.id),j=(await this.extensionsDownloader.downloadExtension(M,_)).fsPath,this.logService.info("Downloaded extension:",M.identifier.id,j)}catch(F){throw new A.ExtensionManagementError((0,g.joinErrors)(F).message,d)}try{const F=await(0,r.getManifest)(j);return{zipPath:j,identifierWithVersion:new R.ExtensionIdentifierWithVersion(M.identifier,F.version),metadata:N}}catch(F){throw new A.ExtensionManagementError((0,g.joinErrors)(F).message,g.INSTALL_ERROR_VALIDATING)}}}class z extends O{constructor(M,_,N,j,F,U){super({id:(0,R.getGalleryExtensionId)(M.publisher,M.name)},_,F,U);this.manifest=M,this.location=_,this.options=N,this.galleryService=j}async doRun(M){const _=new R.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),j=(await this.extensionsScanner.scanExtensions(1)).find(U=>(0,R.areSameExtensions)(this.identifier,U.identifier)),F=await this.getMetadata(this.identifier.id,M);if(j)if(F.isMachineScoped=this.options.isMachineScoped||j.isMachineScoped,F.isBuiltin=this.options.isBuiltin||j.isBuiltin,this._operation=2,_.equals(new R.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version)))try{await this.extensionsScanner.removeExtension(j,"existing")}catch(U){throw new Error(p.localize(3,null,this.manifest.displayName||this.manifest.name))}else w.gt(j.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(j);else{const U=await this.unsetUninstalledAndGetLocal(_);if(U)try{await this.extensionsScanner.removeExtension(U,"existing")}catch(x){throw new Error(p.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:L.resolve(this.location.fsPath),identifierWithVersion:_,metadata:F},M)}async getMetadata(M,_){try{const N=(await this.galleryService.query({names:[M],pageSize:1},_)).firstPage[0];if(N)return{id:N.identifier.uuid,publisherDisplayName:N.publisherDisplayName,publisherId:N.publisherId}}catch(N){}return{}}}class V extends g.AbstractExtensionTask{constructor(M,_,N){super();this.extension=M,this.options=_,this.extensionsScanner=N}async doRun(M){const _=[],N=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const j=new R.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);_.push(...N.filter(F=>j.equals(new R.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version))))}else _.push(...N.filter(j=>(0,R.areSameExtensions)(j.identifier,this.extension.identifier)));if(!_.length)throw new Error(p.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(..._),this.options.remove)for(const j of _)try{M.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(j)}catch(F){throw new Error(p.localize(6,null,(0,C.toErrorMessage)(F)))}}}}),define(X[214],Q([0,1,49,35,215,102,44,101,36,76,51,150,12,132,134,27,208,176,24,166,39,167,21,59,173,80,81,179,14,77,159,56,2,168,72,163,164,155,154,152,151,174,71,160,13,162,17,28,22,201,203,198,58,199,204,172,20,170,200,60,197,177,61,73,136,205,178,86,85,84,5,153,145,9,43,82,186,181,202,143,147,180,4,15]),function(G,e,p,L,D,k,A,R,S,w,n,y,v,m,h,C,P,b,I,f,s,c,t,r,i,o,u,a,l,g,E,d,T,O,$,z,V,B,M,_,N,j,F,U,x,q,H,Y,te,ne,se,ee,he,de,ye,Se,De,Te,Me,Oe,Le,_e,be,ke,Ke,Ye,$e,je,J,ie,re,me,ve,Pe,we,Ae,Ce,Re,Ue,W,Z,ae,ce,oe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ue extends T.Disposable{constructor(le){super();this.configuration=le,this.server=this._register(new R.Server),(0,D.gracefulify)(p),this.registerListeners()}registerListeners(){const le=()=>this.dispose();process.once("exit",le),k.ipcRenderer.once("vscode:electron-main->shared-process=exit",le)}async open(){const le=await this.initServices();(0,te.registerConfiguration)(),le.invokeFunction(Ee=>{const Ie=Ee.get(l.ILogService);Ie.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ee),this.registerErrorHandler(Ie)}),this._register((0,T.combinedDisposable)(le.createInstance(z.CodeCacheCleaner,this.configuration.codeCachePath),le.createInstance(V.LanguagePackCachedDataCleaner),le.createInstance(B.StorageDataCleaner,this.configuration.backupWorkspacesPath),le.createInstance(M.LogsDataCleaner),le.createInstance(me.LocalizationsUpdater),le.createInstance(ve.DeprecatedExtensionsCleaner)))}async initServices(){const le=new w.ServiceCollection,Ee={_serviceBrand:void 0,...A.default};le.set(Y.IProductService,Ee);const Ie=new S.StaticRouter(We=>We==="main"),Fe=new N.MessagePortMainProcessService(this.server,Ie);le.set(_.IMainProcessService,Fe);const Ne=new m.NativeEnvironmentService(this.configuration.args,Ee);le.set(v.INativeEnvironmentService,Ne);const et=new g.LogLevelChannelClient(this.server.getChannel("logLevel",Ie)),Je=new g.LoggerChannelClient(this.configuration.logLevel,et.onDidChangeLogLevel,Fe.getChannel("logger"));le.set(l.ILoggerService,Je);const nt=this._register(new l.MultiplexLogService([this._register(new l.ConsoleLogger(this.configuration.logLevel)),this._register(Je.createLogger((0,oe.joinPath)(ce.URI.file(Ne.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Be=this._register(new g.FollowerLogService(et,nt));le.set(l.ILogService,Be);const Ve=this._register(new U.FileService(Be));le.set(x.IFileService,Ve);const it=this._register(new q.DiskFileSystemProvider(Be));Ve.registerProvider(H.Schemas.file,it);const qe=this._register(new f.ConfigurationService(Ne.settingsResource,Ve));le.set(I.IConfigurationService,qe),await qe.initialize();const Xe=new Se.NativeStorageService(void 0,Fe,Ne);le.set(De.IStorageService,Xe),await Xe.initialize(),this._register((0,T.toDisposable)(()=>Xe.flush())),le.set(s.IRequestService,new n.SyncDescriptor(c.RequestService)),le.set(W.IChecksumService,new n.SyncDescriptor(Z.ChecksumService));const tt=S.ProxyChannel.toService(Fe.getChannel("nativeHost"),{context:this.configuration.windowId});le.set(he.INativeHostService,tt),le.set($.IDownloadService,new n.SyncDescriptor(O.DownloadService));const rt=this._register(new Ye.ActiveWindowManager(tt)),ht=new S.StaticRouter(We=>rt.getActiveClientId().then(st=>We===st));le.set(ke.IExtensionRecommendationNotificationService,new Ke.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ht)));let Qe,He;if(!Ne.isExtensionDevelopment&&!Ne.disableTelemetry&&Ee.enableTelemetry){He=new $e.TelemetryLogAppender(Je,Ne);const{appRoot:We,extensionsPath:st,isBuilt:dt,installSourcePath:gt}=Ne;if(Ee.aiConfig&&Ee.aiConfig.asimovKey&&dt){const ct=new a.AppInsightsAppender("monacoworkbench",null,Ee.aiConfig.asimovKey);this._register((0,T.toDisposable)(()=>ct.flush())),He=(0,r.combinedAppender)(ct,He)}Qe=new u.TelemetryService({appender:He,commonProperties:(0,i.resolveCommonProperties)(Ve,(0,L.release)(),(0,L.hostname)(),process.arch,Ee.commit,Ee.version,this.configuration.machineId,Ee.msftInternalDomains,gt),sendErrorTelemetry:!0,piiPaths:[We,st]},qe)}else Qe=r.NullTelemetryService,He=r.NullAppender;this.server.registerChannel("telemetryAppender",new o.TelemetryAppenderChannel(He)),le.set(t.ITelemetryService,Qe);const ft=new ae.CustomEndpointTelemetryService(qe,Qe);return le.set(t.ICustomEndpointTelemetryService,ft),le.set(C.IExtensionManagementService,new n.SyncDescriptor(P.ExtensionManagementService)),le.set(C.IExtensionGalleryService,new n.SyncDescriptor(b.ExtensionGalleryService)),le.set(C.IExtensionTipsService,new n.SyncDescriptor(_e.ExtensionTipsService)),le.set(d.ILocalizationsService,new n.SyncDescriptor(E.LocalizationsService)),le.set(F.IDiagnosticsService,new n.SyncDescriptor(j.DiagnosticsService)),le.set(Oe.IUserDataSyncAccountService,new n.SyncDescriptor(Oe.UserDataSyncAccountService)),le.set(te.IUserDataSyncLogService,new n.SyncDescriptor(de.UserDataSyncLogService)),le.set(te.IUserDataSyncUtilService,new ee.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",We=>We.ctx!=="main"))),le.set(C.IGlobalExtensionEnablementService,new n.SyncDescriptor(Te.GlobalExtensionEnablementService)),le.set(J.IIgnoredExtensionsManagementService,new n.SyncDescriptor(J.IgnoredExtensionsManagementService)),le.set(ie.IExtensionsStorageSyncService,new n.SyncDescriptor(ie.ExtensionsStorageSyncService)),le.set(te.IUserDataSyncStoreManagementService,new n.SyncDescriptor(se.UserDataSyncStoreManagementService)),le.set(te.IUserDataSyncStoreService,new n.SyncDescriptor(se.UserDataSyncStoreService)),le.set(be.IUserDataSyncMachinesService,new n.SyncDescriptor(be.UserDataSyncMachinesService)),le.set(te.IUserDataSyncBackupStoreService,new n.SyncDescriptor(Le.UserDataSyncBackupStoreService)),le.set(te.IUserDataAutoSyncEnablementService,new n.SyncDescriptor(je.UserDataAutoSyncEnablementService)),le.set(te.IUserDataSyncResourceEnablementService,new n.SyncDescriptor(Me.UserDataSyncResourceEnablementService)),le.set(te.IUserDataSyncService,new n.SyncDescriptor(ne.UserDataSyncService)),le.set(Re.ILocalPtyService,this._register(new Ce.PtyHostService({GraceTime:6e4,ShortGraceTime:6e3},qe,Be,Qe))),new y.InstantiationService(le)}initChannels(le){const Ee=new h.ExtensionManagementChannel(le.get(C.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ee);const Ie=S.ProxyChannel.fromService(le.get(d.ILocalizationsService));this.server.registerChannel("localizations",Ie);const Fe=S.ProxyChannel.fromService(le.get(F.IDiagnosticsService));this.server.registerChannel("diagnostics",Fe);const Ne=new h.ExtensionTipsChannel(le.get(C.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Ne);const et=S.ProxyChannel.fromService(le.get(W.IChecksumService));this.server.registerChannel("checksum",et);const Je=new ee.UserDataSyncMachinesServiceChannel(le.get(be.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Je);const nt=S.ProxyChannel.fromService(le.get(t.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",nt);const Be=new ee.UserDataSyncAccountServiceChannel(le.get(Oe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Be);const Ve=new ee.UserDataSyncStoreManagementServiceChannel(le.get(te.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Ve);const it=new Ue.UserDataSyncChannel(le.get(te.IUserDataSyncService),le.get(l.ILogService));this.server.registerChannel("userDataSync",it);const qe=this._register(le.get(re.IInstantiationService).createInstance(ye.UserDataAutoSyncService)),Xe=new ee.UserDataAutoSyncChannel(qe);this.server.registerChannel("userDataAutoSync",Xe);const tt=le.get(Re.ILocalPtyService),rt=S.ProxyChannel.fromService(tt);this.server.registerChannel(Ae.TerminalIpcChannels.LocalPty,rt)}registerErrorHandler(le){window.addEventListener("unhandledrejection",Ee=>{(0,Pe.onUnexpectedError)(Ee.reason),Ee.preventDefault()}),(0,Pe.setUnexpectedErrorHandler)(Ee=>{const Ie=(0,we.toErrorMessage)(Ee,!0);!Ie||le.error(`[uncaught exception in sharedProcess]: ${Ie}`)})}}async function ge(pe){const le=new ue(pe);k.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await le.open(),k.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/50b3811fdc5b5c80ca516a2edfffedcbd464b033/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
