/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Y=["require","exports","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/uri","vs/base/common/errors","vs/base/common/network","vs/base/node/pfs","vs/platform/instantiation/common/instantiation","vs/base/common/types","vs/base/common/event","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/objects","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/arrays","vs/platform/registry/common/platform","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/configuration/common/configurationRegistry","os","child_process","vs/base/common/process","vs/platform/product/common/product","vs/platform/telemetry/common/telemetry","vs/base/common/stream","vs/base/common/extpath","fs","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/productService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/map","vs/base/node/decoder","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/common/assert","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","vs/platform/environment/node/argvHelper","crypto","vs/base/common/performance","vs/base/common/iterator","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],ee=function(_){for(var t=[],m=0,O=_.length;m<O;m++)t[m]=Y[_[m]];return t};define(Y[57],ee([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function m(O,E){if(!O)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}t.ok=m}),define(Y[44],ee([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function m(T){return(L,u,d)=>{let y=null,v=null;if(typeof d.value=="function"?(y="value",v=d.value):typeof d.get=="function"&&(y="get",v=d.get),!v)throw new Error("not supported");d[y]=T(v,u)}}t.createDecorator=m;function O(T,L,u){let d=null,y=null;if(typeof u.value=="function"?(d="value",y=u.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(d="get",y=u.get),!y)throw new Error("not supported");const v=`$memoize$${L}`;u[d]=function(...w){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,w)}),this[v]}}t.memoize=O;function E(T,L,u){return m((d,y)=>{const v=`$debounce$${y}`,w=`$debounce$result$${y}`;return function(...F){this[w]||(this[w]=u?u():void 0),clearTimeout(this[v]),L&&(this[w]=L(this[w],...F),F=[this[w]]),this[v]=setTimeout(()=>{d.apply(this,F),this[w]=u?u():void 0},T)}})}t.debounce=E;function P(T,L,u){return m((d,y)=>{const v=`$throttle$timer$${y}`,w=`$throttle$result$${y}`,F=`$throttle$lastRun$${y}`,c=`$throttle$pending$${y}`;return function(...f){if(this[w]||(this[w]=u?u():void 0),(this[F]===null||this[F]===void 0)&&(this[F]=-Number.MAX_VALUE),L&&(this[w]=L(this[w],...f)),this[c])return;const D=this[F]+T;D<=Date.now()?(this[F]=Date.now(),d.apply(this,[this[w]]),this[w]=u?u():void 0):(this[c]=!0,this[v]=setTimeout(()=>{this[c]=!1,this[F]=Date.now(),d.apply(this,[this[w]]),this[w]=u?u():void 0},D-Date.now()))}})}t.throttle=P}),define(Y[24],ee([0,1,8]),function(_,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayQueue=t.maxIndex=t.minIndex=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function O(S,g=0){return S[S.length-(1+g)]}t.tail=O;function E(S){if(S.length===0)throw new Error("Invalid tail call");return[S.slice(0,S.length-1),S[S.length-1]]}t.tail2=E;function P(S,g,R=(A,k)=>A===k){if(S===g)return!0;if(!S||!g||S.length!==g.length)return!1;for(let A=0,k=S.length;A<k;A++)if(!R(S[A],g[A]))return!1;return!0}t.equals=P;function T(S,g,R){let A=0,k=S.length-1;for(;A<=k;){const U=(A+k)/2|0,B=R(S[U],g);if(B<0)A=U+1;else if(B>0)k=U-1;else return U}return-(A+1)}t.binarySearch=T;function L(S,g){let R=0,A=S.length;if(A===0)return 0;for(;R<A;){const k=Math.floor((R+A)/2);g(S[k])?A=k:R=k+1}return R}t.findFirstInSorted=L;function u(S,g,R){if(S=S|0,S>=g.length)throw new TypeError("invalid index");let A=g[Math.floor(g.length*Math.random())],k=[],U=[],B=[];for(let $ of g){const H=R($,A);H<0?k.push($):H>0?U.push($):B.push($)}return S<k.length?u(S,k,R):S<k.length+B.length?B[0]:u(S-(k.length+B.length),U,R)}t.quickSelect=u;function d(S,g){const R=[];let A;for(const k of S.slice(0).sort(g))!A||g(A[0],k)!==0?(A=[k],R.push(A)):A.push(k);return R}t.groupBy=d;function y(S,g,R){const A=[];function k($,H,J){if(H===0&&J.length===0)return;const te=A[A.length-1];te&&te.start+te.deleteCount===$?(te.deleteCount+=H,te.toInsert.push(...J)):A.push({start:$,deleteCount:H,toInsert:J})}let U=0,B=0;for(;;){if(U===S.length){k(U,0,g.slice(B));break}if(B===g.length){k(U,S.length-U,[]);break}const $=S[U],H=g[B],J=R($,H);J===0?(U+=1,B+=1):J<0?(k(U,1,[]),U+=1):J>0&&(k(U,0,[H]),B+=1)}return A}t.sortedDiff=y;function v(S,g,R){const A=y(S,g,R),k=[],U=[];for(const B of A)k.push(...S.slice(B.start,B.start+B.deleteCount)),U.push(...B.toInsert);return{removed:k,added:U}}t.delta=v;function w(S,g,R){if(R===0)return[];const A=S.slice(0,R).sort(g);return c(S,g,A,R,S.length),A}t.top=w;function F(S,g,R,A,k){return R===0?Promise.resolve([]):new Promise((U,B)=>{(async()=>{const $=S.length,H=S.slice(0,R).sort(g);for(let J=R,te=Math.min(R+A,$);J<$;J=te,te=Math.min(te+A,$)){if(J>R&&await new Promise(ne=>setTimeout(ne)),k&&k.isCancellationRequested)throw(0,m.canceled)();c(S,g,H,J,te)}return H})().then(U,B)})}t.topAsync=F;function c(S,g,R,A,k){for(const U=R.length;A<k;A++){const B=S[A];if(g(B,R[U-1])<0){R.pop();const $=L(R,H=>g(B,H)<0);R.splice($,0,B)}}}function f(S){return S.filter(g=>!!g)}t.coalesce=f;function D(S){let g=0;for(let R=0;R<S.length;R++)S[R]&&(S[g]=S[R],g+=1);S.length=g}t.coalesceInPlace=D;function I(S,g,R){S.splice(R,0,S.splice(g,1)[0])}t.move=I;function b(S){return!Array.isArray(S)||S.length===0}t.isFalsyOrEmpty=b;function l(S){return Array.isArray(S)&&S.length>0}t.isNonEmptyArray=l;function r(S,g){if(!g)return S.filter((A,k)=>S.indexOf(A)===k);const R=Object.create(null);return S.filter(A=>{const k=g(A);return R[k]?!1:(R[k]=!0,!0)})}t.distinct=r;function s(S){const g=new Set;return S.filter(R=>g.has(R)?!1:(g.add(R),!0))}t.distinctES6=s;function e(S){const g=Object.create(null);return R=>{const A=S(R);return g[A]?!1:(g[A]=!0,!0)}}t.uniqueFilter=e;function i(S,g){for(let R=S.length-1;R>=0;R--){const A=S[R];if(g(A))return R}return-1}t.lastIndex=i;function n(S,g){return S.length>0?S[0]:g}t.firstOrDefault=n;function o(S,g,R=(A,k)=>A===k){let A=0;for(let k=0,U=Math.min(S.length,g.length);k<U&&R(S[k],g[k]);k++)A++;return A}t.commonPrefixLength=o;function a(S){return[].concat(...S)}t.flatten=a;function h(S,g){let R=typeof g=="number"?S:0;typeof g=="number"?R=S:(R=0,g=S);const A=[];if(R<=g)for(let k=R;k<g;k++)A.push(k);else for(let k=R;k>g;k--)A.push(k);return A}t.range=h;function p(S,g,R){return S.reduce((A,k)=>(A[g(k)]=R?R(k):k,A),Object.create(null))}t.index=p;function M(S,g){return S.push(g),()=>C(S,g)}t.insert=M;function C(S,g){const R=S.indexOf(g);if(R>-1)return S.splice(R,1),g}t.remove=C;function N(S,g,R){const A=S.slice(0,g),k=S.slice(g);return A.concat(R,k)}t.arrayInsert=N;function V(S,g){let R;if(typeof g=="number"){let A=g;R=()=>{const k=Math.sin(A++)*179426549;return k-Math.floor(k)}}else R=Math.random;for(let A=S.length-1;A>0;A-=1){const k=Math.floor(R()*(A+1)),U=S[A];S[A]=S[k],S[k]=U}}t.shuffle=V;function W(S,g){const R=S.indexOf(g);R>-1&&(S.splice(R,1),S.unshift(g))}t.pushToStart=W;function Q(S,g){const R=S.indexOf(g);R>-1&&(S.splice(R,1),S.push(g))}t.pushToEnd=Q;function ie(S,g){return Array.isArray(S)?S.map(g):g(S)}t.mapArrayOrNot=ie;function re(S){return Array.isArray(S)?S:[S]}t.asArray=re;function Z(S){return S[Math.floor(Math.random()*S.length)]}t.getRandomElement=Z;function X(S,g){for(const R of S){const A=g(R);if(A!==void 0)return A}}t.mapFind=X;function j(S,g){let R=Number.MAX_SAFE_INTEGER,A=0;return S.forEach((k,U)=>{const B=g(k);B<R&&(R=B,A=U)}),A}t.minIndex=j;function x(S,g){let R=Number.MIN_SAFE_INTEGER,A=0;return S.forEach((k,U)=>{const B=g(k);B>R&&(R=B,A=U)}),A}t.maxIndex=x;class q{constructor(g){this.items=g,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(g){let R=this.firstIdx;for(;R<this.items.length&&g(this.items[R]);)R++;const A=R===this.firstIdx?null:this.items.slice(this.firstIdx,R);return this.firstIdx=R,A}takeFromEndWhile(g){let R=this.lastIdx;for(;R>=0&&g(this.items[R]);)R--;const A=R===this.lastIdx?null:this.items.slice(R+1,this.lastIdx+1);return this.lastIdx=R,A}}t.ArrayQueue=q}),define(Y[58],ee([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var m;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(m=t.ScanError||(t.ScanError={}));var O;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(O=t.SyntaxKind||(t.SyntaxKind={}));var E;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(E=t.ParseErrorCode||(t.ParseErrorCode={}));var P;(function(e){e.DEFAULT={allowTrailingComma:!0}})(P=t.ParseOptions||(t.ParseOptions={}));function T(e,i=!1){let n=0,o=e.length,a="",h=0,p=16,M=0;function C(Z){let X=0,j=0;for(;X<Z;){const x=e.charCodeAt(n);if(x>=48&&x<=57)j=j*16+x-48;else if(x>=65&&x<=70)j=j*16+x-65+10;else if(x>=97&&x<=102)j=j*16+x-97+10;else break;n++,X++}return X<Z&&(j=-1),j}function N(Z){n=Z,a="",h=0,p=16,M=0}function V(){const Z=n;if(e.charCodeAt(n)===48)n++;else for(n++;n<e.length&&d(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===46)if(n++,n<e.length&&d(e.charCodeAt(n)))for(n++;n<e.length&&d(e.charCodeAt(n));)n++;else return M=3,e.substring(Z,n);let X=n;if(n<e.length&&(e.charCodeAt(n)===69||e.charCodeAt(n)===101))if(n++,(n<e.length&&e.charCodeAt(n)===43||e.charCodeAt(n)===45)&&n++,n<e.length&&d(e.charCodeAt(n))){for(n++;n<e.length&&d(e.charCodeAt(n));)n++;X=n}else M=3;return e.substring(Z,X)}function W(){let Z="",X=n;for(;;){if(n>=o){Z+=e.substring(X,n),M=2;break}const j=e.charCodeAt(n);if(j===34){Z+=e.substring(X,n),n++;break}if(j===92){if(Z+=e.substring(X,n),n++,n>=o){M=2;break}switch(e.charCodeAt(n++)){case 34:Z+='"';break;case 92:Z+="\\";break;case 47:Z+="/";break;case 98:Z+="\b";break;case 102:Z+="\f";break;case 110:Z+=`
`;break;case 114:Z+="\r";break;case 116:Z+="	";break;case 117:const q=C(4);q>=0?Z+=String.fromCharCode(q):M=4;break;default:M=5}X=n;continue}if(j>=0&&j<=31)if(u(j)){Z+=e.substring(X,n),M=2;break}else M=6;n++}return Z}function Q(){if(a="",M=0,h=n,n>=o)return h=o,p=17;let Z=e.charCodeAt(n);if(L(Z)){do n++,a+=String.fromCharCode(Z),Z=e.charCodeAt(n);while(L(Z));return p=15}if(u(Z))return n++,a+=String.fromCharCode(Z),Z===13&&e.charCodeAt(n)===10&&(n++,a+=`
`),p=14;switch(Z){case 123:return n++,p=1;case 125:return n++,p=2;case 91:return n++,p=3;case 93:return n++,p=4;case 58:return n++,p=6;case 44:return n++,p=5;case 34:return n++,a=W(),p=10;case 47:const X=n-1;if(e.charCodeAt(n+1)===47){for(n+=2;n<o&&!u(e.charCodeAt(n));)n++;return a=e.substring(X,n),p=12}if(e.charCodeAt(n+1)===42){n+=2;const j=o-1;let x=!1;for(;n<j;){if(e.charCodeAt(n)===42&&e.charCodeAt(n+1)===47){n+=2,x=!0;break}n++}return x||(n++,M=1),a=e.substring(X,n),p=13}return a+=String.fromCharCode(Z),n++,p=16;case 45:if(a+=String.fromCharCode(Z),n++,n===o||!d(e.charCodeAt(n)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=V(),p=11;default:for(;n<o&&ie(Z);)n++,Z=e.charCodeAt(n);if(h!==n){switch(a=e.substring(h,n),a){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return a+=String.fromCharCode(Z),n++,p=16}}function ie(Z){if(L(Z)||u(Z))return!1;switch(Z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let Z;do Z=Q();while(Z>=12&&Z<=15);return Z}return{setPosition:N,getPosition:()=>n,scan:i?re:Q,getToken:()=>p,getTokenValue:()=>a,getTokenOffset:()=>h,getTokenLength:()=>n-h,getTokenError:()=>M}}t.createScanner=T;function L(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function u(e){return e===10||e===13||e===8232||e===8233}function d(e){return e>=48&&e<=57}var y;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(y||(y={}));function v(e,i){const n=[],o=new Object;let a;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function M(C,N,V,W){h.value=C,h.offset=N,h.length=V,h.type=W,h.colonOffset=void 0,a=h}try{l(e,{onObjectBegin:(C,N)=>{if(i<=C)throw o;a=void 0,p=i>C,n.push("")},onObjectProperty:(C,N,V)=>{if(i<N||(M(C,N,V,"property"),n[n.length-1]=C,i<=N+V))throw o},onObjectEnd:(C,N)=>{if(i<=C)throw o;a=void 0,n.pop()},onArrayBegin:(C,N)=>{if(i<=C)throw o;a=void 0,n.push(0)},onArrayEnd:(C,N)=>{if(i<=C)throw o;a=void 0,n.pop()},onLiteralValue:(C,N,V)=>{if(i<N||(M(C,N,V,s(C)),i<=N+V))throw o},onSeparator:(C,N,V)=>{if(i<=N)throw o;if(C===":"&&a&&a.type==="property")a.colonOffset=N,p=!1,a=void 0;else if(C===","){const W=n[n.length-1];typeof W=="number"?n[n.length-1]=W+1:(p=!0,n[n.length-1]=""),a=void 0}}})}catch(C){if(C!==o)throw C}return{path:n,previousNode:a,isAtPropertyKey:p,matches:C=>{let N=0;for(let V=0;N<C.length&&V<n.length;V++)if(C[N]===n[V]||C[N]==="*")N++;else if(C[N]!=="**")return!1;return N===C.length}}}t.getLocation=v;function w(e,i=[],n=P.DEFAULT){let o=null,a=[];const h=[];function p(C){Array.isArray(a)?a.push(C):o!==null&&(a[o]=C)}return l(e,{onObjectBegin:()=>{const C={};p(C),h.push(a),a=C,o=null},onObjectProperty:C=>{o=C},onObjectEnd:()=>{a=h.pop()},onArrayBegin:()=>{const C=[];p(C),h.push(a),a=C,o=null},onArrayEnd:()=>{a=h.pop()},onLiteralValue:p,onError:(C,N,V)=>{i.push({error:C,offset:N,length:V})}},n),a[0]}t.parse=w;function F(e,i=[],n=P.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(C){o.type==="property"&&(o.length=C-o.offset,o=o.parent)}function h(C){return o.children.push(C),C}l(e,{onObjectBegin:C=>{o=h({type:"object",offset:C,length:-1,parent:o,children:[]})},onObjectProperty:(C,N,V)=>{o=h({type:"property",offset:N,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:C,offset:N,length:V,parent:o})},onObjectEnd:(C,N)=>{o.length=C+N-o.offset,o=o.parent,a(C+N)},onArrayBegin:(C,N)=>{o=h({type:"array",offset:C,length:-1,parent:o,children:[]})},onArrayEnd:(C,N)=>{o.length=C+N-o.offset,o=o.parent,a(C+N)},onLiteralValue:(C,N,V)=>{h({type:s(C),offset:N,length:V,parent:o,value:C}),a(N+V)},onSeparator:(C,N,V)=>{o.type==="property"&&(C===":"?o.colonOffset=N:C===","&&a(N))},onError:(C,N,V)=>{i.push({error:C,offset:N,length:V})}},n);const M=o.children[0];return M&&delete M.parent,M}t.parseTree=F;function c(e,i){if(!e)return;let n=e;for(let o of i)if(typeof o=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let a=!1;for(const h of n.children)if(Array.isArray(h.children)&&h.children[0].value===o){n=h.children[1],a=!0;break}if(!a)return}else{const a=o;if(n.type!=="array"||a<0||!Array.isArray(n.children)||a>=n.children.length)return;n=n.children[a]}return n}t.findNodeAtLocation=c;function f(e){if(!e.parent||!e.parent.children)return[];const i=f(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;i.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&i.push(n)}return i}t.getNodePath=f;function D(e){switch(e.type){case"array":return e.children.map(D);case"object":const i=Object.create(null);for(let n of e.children){const o=n.children[1];o&&(i[n.children[0].value]=D(o))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=D;function I(e,i,n=!1){return i>=e.offset&&i<e.offset+e.length||n&&i===e.offset+e.length}t.contains=I;function b(e,i,n=!1){if(I(e,i,n)){const o=e.children;if(Array.isArray(o))for(let a=0;a<o.length&&o[a].offset<=i;a++){const h=b(o[a],i,n);if(h)return h}return e}}t.findNodeAtOffset=b;function l(e,i,n=P.DEFAULT){const o=T(e,!1);function a(U){return U?()=>U(o.getTokenOffset(),o.getTokenLength()):()=>!0}function h(U){return U?B=>U(B,o.getTokenOffset(),o.getTokenLength()):()=>!0}const p=a(i.onObjectBegin),M=h(i.onObjectProperty),C=a(i.onObjectEnd),N=a(i.onArrayBegin),V=a(i.onArrayEnd),W=h(i.onLiteralValue),Q=h(i.onSeparator),ie=a(i.onComment),re=h(i.onError),Z=n&&n.disallowComments,X=n&&n.allowTrailingComma;function j(){for(;;){const U=o.scan();switch(o.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:Z||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(U){case 12:case 13:Z?x(10):ie();break;case 16:x(1);break;case 15:case 14:break;default:return U}}}function x(U,B=[],$=[]){if(re(U),B.length+$.length>0){let H=o.getToken();for(;H!==17;){if(B.indexOf(H)!==-1){j();break}else if($.indexOf(H)!==-1)break;H=j()}}}function q(U){const B=o.getTokenValue();return U?W(B):M(B),j(),!0}function S(){switch(o.getToken()){case 11:let U=0;try{U=JSON.parse(o.getTokenValue()),typeof U!="number"&&(x(2),U=0)}catch(B){x(2)}W(U);break;case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return j(),!0}function g(){return o.getToken()!==10?(x(3,[],[2,5]),!1):(q(!1),o.getToken()===6?(Q(":"),j(),k()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function R(){p(),j();let U=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(U||x(4,[],[]),Q(","),j(),o.getToken()===2&&X)break}else U&&x(6,[],[]);g()||x(4,[],[2,5]),U=!0}return C(),o.getToken()!==2?x(7,[2],[]):j(),!0}function A(){N(),j();let U=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(U||x(4,[],[]),Q(","),j(),o.getToken()===4&&X)break}else U&&x(6,[],[]);k()||x(4,[],[4,5]),U=!0}return V(),o.getToken()!==4?x(8,[4],[]):j(),!0}function k(){switch(o.getToken()){case 3:return A();case 1:return R();case 10:return q(!0);default:return S()}}return j(),o.getToken()===17?n.allowEmptyContent?!0:(x(4,[],[]),!1):k()?(o.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}t.visit=l;function r(e,i){let n=T(e),o=[],a,h=0,p;do switch(p=n.getPosition(),a=n.scan(),a){case 12:case 13:case 17:h!==p&&o.push(e.substring(h,p)),i!==void 0&&o.push(n.getTokenValue().replace(/[^\r\n]/g,i)),h=n.getPosition();break}while(a!==17);return o.join("")}t.stripComments=r;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=s}),function(){function _(E){const P=[];typeof E=="number"&&P.push("code/timeOrigin",E);function T(u){P.push(u,Date.now())}function L(){const u=[];for(let d=0;d<P.length;d+=2)u.push({name:P[d],startTime:P[d+1]});return u}return{mark:T,getMarks:L}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?_():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const T of performance.getEntriesByType("mark"))P.push({name:T.name,startTime:Math.round(E+T.startTime)});return P}};if(typeof process=="object"){const E=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return _(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),_()}function m(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=t()),E.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=m(O))}(),function(_,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var m=t();for(var O in m)(typeof exports=="object"?exports:_)[O]=m[O]}}(typeof self!="undefined"?self:this,function(){return function(_){var t={};function m(O){if(t[O])return t[O].exports;var E=t[O]={i:O,l:!1,exports:{}};return _[O].call(E.exports,E,E.exports,m),E.l=!0,E.exports}return m.m=_,m.c=t,m.d=function(O,E,P){m.o(O,E)||Object.defineProperty(O,E,{enumerable:!0,get:P})},m.r=function(O){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},m.t=function(O,E){if(1&E&&(O=m(O)),8&E||4&E&&typeof O=="object"&&O&&O.__esModule)return O;var P=Object.create(null);if(m.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:O}),2&E&&typeof O!="string")for(var T in O)m.d(P,T,function(L){return O[L]}.bind(null,T));return P},m.n=function(O){var E=O&&O.__esModule?function(){return O.default}:function(){return O};return m.d(E,"a",E),E},m.o=function(O,E){return Object.prototype.hasOwnProperty.call(O,E)},m.p="",m(m.s=0)}([function(_,t,m){(function(O){var E;t=_.exports=$,E=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var P=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,L=t.re=[],u=t.src=[],d=0,y=d++;u[y]="0|[1-9]\\d*";var v=d++;u[v]="[0-9]+";var w=d++;u[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var F=d++;u[F]="("+u[y]+")\\.("+u[y]+")\\.("+u[y]+")";var c=d++;u[c]="("+u[v]+")\\.("+u[v]+")\\.("+u[v]+")";var f=d++;u[f]="(?:"+u[y]+"|"+u[w]+")";var D=d++;u[D]="(?:"+u[v]+"|"+u[w]+")";var I=d++;u[I]="(?:-("+u[f]+"(?:\\."+u[f]+")*))";var b=d++;u[b]="(?:-?("+u[D]+"(?:\\."+u[D]+")*))";var l=d++;u[l]="[0-9A-Za-z-]+";var r=d++;u[r]="(?:\\+("+u[l]+"(?:\\."+u[l]+")*))";var s=d++,e="v?"+u[F]+u[I]+"?"+u[r]+"?";u[s]="^"+e+"$";var i="[v=\\s]*"+u[c]+u[b]+"?"+u[r]+"?",n=d++;u[n]="^"+i+"$";var o=d++;u[o]="((?:<|>)?=?)";var a=d++;u[a]=u[v]+"|x|X|\\*";var h=d++;u[h]=u[y]+"|x|X|\\*";var p=d++;u[p]="[v=\\s]*("+u[h]+")(?:\\.("+u[h]+")(?:\\.("+u[h]+")(?:"+u[I]+")?"+u[r]+"?)?)?";var M=d++;u[M]="[v=\\s]*("+u[a]+")(?:\\.("+u[a]+")(?:\\.("+u[a]+")(?:"+u[b]+")?"+u[r]+"?)?)?";var C=d++;u[C]="^"+u[o]+"\\s*"+u[p]+"$";var N=d++;u[N]="^"+u[o]+"\\s*"+u[M]+"$";var V=d++;u[V]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var W=d++;u[W]="(?:~>?)";var Q=d++;u[Q]="(\\s*)"+u[W]+"\\s+",L[Q]=new RegExp(u[Q],"g");var ie=d++;u[ie]="^"+u[W]+u[p]+"$";var re=d++;u[re]="^"+u[W]+u[M]+"$";var Z=d++;u[Z]="(?:\\^)";var X=d++;u[X]="(\\s*)"+u[Z]+"\\s+",L[X]=new RegExp(u[X],"g");var j=d++;u[j]="^"+u[Z]+u[p]+"$";var x=d++;u[x]="^"+u[Z]+u[M]+"$";var q=d++;u[q]="^"+u[o]+"\\s*("+i+")$|^$";var S=d++;u[S]="^"+u[o]+"\\s*("+e+")$|^$";var g=d++;u[g]="(\\s*)"+u[o]+"\\s*("+i+"|"+u[p]+")",L[g]=new RegExp(u[g],"g");var R=d++;u[R]="^\\s*("+u[p]+")\\s+-\\s+("+u[p]+")\\s*$";var A=d++;u[A]="^\\s*("+u[M]+")\\s+-\\s+("+u[M]+")\\s*$";var k=d++;u[k]="(<|>)?=?\\s*\\*";for(var U=0;U<35;U++)E(U,u[U]),L[U]||(L[U]=new RegExp(u[U]));function B(z,G){if(z instanceof $)return z;if(typeof z!="string"||z.length>P||!(G?L[n]:L[s]).test(z))return null;try{return new $(z,G)}catch(K){return null}}function $(z,G){if(z instanceof $){if(z.loose===G)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof $))return new $(z,G);E("SemVer",z,G),this.loose=G;var K=z.trim().match(G?L[n]:L[s]);if(!K)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(se){if(/^[0-9]+$/.test(se)){var oe=+se;if(oe>=0&&oe<T)return oe}return se}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}t.parse=B,t.valid=function(z,G){var K=B(z,G);return K?K.version:null},t.clean=function(z,G){var K=B(z.trim().replace(/^[=v]+/,""),G);return K?K.version:null},t.SemVer=$,$.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},$.prototype.toString=function(){return this.version},$.prototype.compare=function(z){return E("SemVer.compare",this.version,this.loose,z),z instanceof $||(z=new $(z,this.loose)),this.compareMain(z)||this.comparePre(z)},$.prototype.compareMain=function(z){return z instanceof $||(z=new $(z,this.loose)),J(this.major,z.major)||J(this.minor,z.minor)||J(this.patch,z.patch)},$.prototype.comparePre=function(z){if(z instanceof $||(z=new $(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var G=0;do{var K=this.prerelease[G],se=z.prerelease[G];if(E("prerelease compare",G,K,se),K===void 0&&se===void 0)return 0;if(se===void 0)return 1;if(K===void 0)return-1;if(K!==se)return J(K,se)}while(++G)},$.prototype.inc=function(z,G){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},t.inc=function(z,G,K,se){typeof K=="string"&&(se=K,K=void 0);try{return new $(z,K).inc(G,se).version}catch(oe){return null}},t.diff=function(z,G){if(he(z,G))return null;var K=B(z),se=B(G);if(K.prerelease.length||se.prerelease.length){for(var oe in K)if((oe==="major"||oe==="minor"||oe==="patch")&&K[oe]!==se[oe])return"pre"+oe;return"prerelease"}for(var oe in K)if((oe==="major"||oe==="minor"||oe==="patch")&&K[oe]!==se[oe])return oe},t.compareIdentifiers=J;var H=/^[0-9]+$/;function J(z,G){var K=H.test(z),se=H.test(G);return K&&se&&(z=+z,G=+G),K&&!se?-1:se&&!K?1:z<G?-1:z>G?1:0}function te(z,G,K){return new $(z,K).compare(new $(G,K))}function ne(z,G,K){return te(z,G,K)>0}function ae(z,G,K){return te(z,G,K)<0}function he(z,G,K){return te(z,G,K)===0}function ve(z,G,K){return te(z,G,K)!==0}function De(z,G,K){return te(z,G,K)>=0}function ke(z,G,K){return te(z,G,K)<=0}function Te(z,G,K,se){var oe;switch(G){case"===":typeof z=="object"&&(z=z.version),typeof K=="object"&&(K=K.version),oe=z===K;break;case"!==":typeof z=="object"&&(z=z.version),typeof K=="object"&&(K=K.version),oe=z!==K;break;case"":case"=":case"==":oe=he(z,K,se);break;case"!=":oe=ve(z,K,se);break;case">":oe=ne(z,K,se);break;case">=":oe=De(z,K,se);break;case"<":oe=ae(z,K,se);break;case"<=":oe=ke(z,K,se);break;default:throw new TypeError("Invalid operator: "+G)}return oe}function we(z,G){if(z instanceof we){if(z.loose===G)return z;z=z.value}if(!(this instanceof we))return new we(z,G);E("comparator",z,G),this.loose=G,this.parse(z),this.semver===Fe?this.value="":this.value=this.operator+this.semver.version,E("comp",this)}t.rcompareIdentifiers=function(z,G){return J(G,z)},t.major=function(z,G){return new $(z,G).major},t.minor=function(z,G){return new $(z,G).minor},t.patch=function(z,G){return new $(z,G).patch},t.compare=te,t.compareLoose=function(z,G){return te(z,G,!0)},t.rcompare=function(z,G,K){return te(G,z,K)},t.sort=function(z,G){return z.sort(function(K,se){return t.compare(K,se,G)})},t.rsort=function(z,G){return z.sort(function(K,se){return t.rcompare(K,se,G)})},t.gt=ne,t.lt=ae,t.eq=he,t.neq=ve,t.gte=De,t.lte=ke,t.cmp=Te,t.Comparator=we;var Fe={};function pe(z,G){if(z instanceof pe)return z.loose===G?z:new pe(z.raw,G);if(z instanceof we)return new pe(z.value,G);if(!(this instanceof pe))return new pe(z,G);if(this.loose=G,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function Re(z){return!z||z.toLowerCase()==="x"||z==="*"}function je(z,G,K,se,oe,Se,de,Le,ye,Pe,Ae,Ee,be){return((G=Re(K)?"":Re(se)?">="+K+".0.0":Re(oe)?">="+K+"."+se+".0":">="+G)+" "+(Le=Re(ye)?"":Re(Pe)?"<"+(+ye+1)+".0.0":Re(Ae)?"<"+ye+"."+(+Pe+1)+".0":Ee?"<="+ye+"."+Pe+"."+Ae+"-"+Ee:"<="+Le)).trim()}function Be(z,G){for(var K=0;K<z.length;K++)if(!z[K].test(G))return!1;if(G.prerelease.length){for(K=0;K<z.length;K++)if(E(z[K].semver),z[K].semver!==Fe&&z[K].semver.prerelease.length>0){var se=z[K].semver;if(se.major===G.major&&se.minor===G.minor&&se.patch===G.patch)return!0}return!1}return!0}function xe(z,G,K){try{G=new pe(G,K)}catch(se){return!1}return G.test(z)}function ze(z,G,K,se){var oe,Se,de,Le,ye;switch(z=new $(z,se),G=new pe(G,se),K){case">":oe=ne,Se=ke,de=ae,Le=">",ye=">=";break;case"<":oe=ae,Se=De,de=ne,Le="<",ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(xe(z,G,se))return!1;for(var Pe=0;Pe<G.set.length;++Pe){var Ae=G.set[Pe],Ee=null,be=null;if(Ae.forEach(function(Ce){Ce.semver===Fe&&(Ce=new we(">=0.0.0")),Ee=Ee||Ce,be=be||Ce,oe(Ce.semver,Ee.semver,se)?Ee=Ce:de(Ce.semver,be.semver,se)&&(be=Ce)}),Ee.operator===Le||Ee.operator===ye||(!be.operator||be.operator===Le)&&Se(z,be.semver)||be.operator===ye&&de(z,be.semver))return!1}return!0}we.prototype.parse=function(z){var G=this.loose?L[q]:L[S],K=z.match(G);if(!K)throw new TypeError("Invalid comparator: "+z);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new $(K[2],this.loose):this.semver=Fe},we.prototype.toString=function(){return this.value},we.prototype.test=function(z){return E("Comparator.test",z,this.loose),this.semver===Fe||(typeof z=="string"&&(z=new $(z,this.loose)),Te(z,this.operator,this.semver,this.loose))},we.prototype.intersects=function(z,G){if(!(z instanceof we))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new pe(z.value,G),xe(this.value,K,G);if(z.operator==="")return K=new pe(this.value,G),xe(z.semver,K,G);var se=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),oe=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Se=this.semver.version===z.semver.version,de=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Le=Te(this.semver,"<",z.semver,G)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),ye=Te(this.semver,">",z.semver,G)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return se||oe||Se&&de||Le||ye},t.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(z){var G=this.loose;z=z.trim(),E("range",z,G);var K=G?L[A]:L[R];z=z.replace(K,je),E("hyphen replace",z),z=z.replace(L[g],"$1$2$3"),E("comparator trim",z,L[g]),z=(z=(z=z.replace(L[Q],"$1~")).replace(L[X],"$1^")).split(/\s+/).join(" ");var se=G?L[q]:L[S],oe=z.split(" ").map(function(Se){return function(de,Le){return E("comp",de),de=function(ye,Pe){return ye.trim().split(/\s+/).map(function(Ae){return function(Ee,be){E("caret",Ee,be);var Ce=be?L[x]:L[j];return Ee.replace(Ce,function(Oe,le,fe,ge,me){var Ie;return E("caret",Ee,Oe,le,fe,ge,me),Re(le)?Ie="":Re(fe)?Ie=">="+le+".0.0 <"+(+le+1)+".0.0":Re(ge)?Ie=le==="0"?">="+le+"."+fe+".0 <"+le+"."+(+fe+1)+".0":">="+le+"."+fe+".0 <"+(+le+1)+".0.0":me?(E("replaceCaret pr",me),me.charAt(0)!=="-"&&(me="-"+me),Ie=le==="0"?fe==="0"?">="+le+"."+fe+"."+ge+me+" <"+le+"."+fe+"."+(+ge+1):">="+le+"."+fe+"."+ge+me+" <"+le+"."+(+fe+1)+".0":">="+le+"."+fe+"."+ge+me+" <"+(+le+1)+".0.0"):(E("no pr"),Ie=le==="0"?fe==="0"?">="+le+"."+fe+"."+ge+" <"+le+"."+fe+"."+(+ge+1):">="+le+"."+fe+"."+ge+" <"+le+"."+(+fe+1)+".0":">="+le+"."+fe+"."+ge+" <"+(+le+1)+".0.0"),E("caret return",Ie),Ie})}(Ae,Pe)}).join(" ")}(de,Le),E("caret",de),de=function(ye,Pe){return ye.trim().split(/\s+/).map(function(Ae){return function(Ee,be){var Ce=be?L[re]:L[ie];return Ee.replace(Ce,function(Oe,le,fe,ge,me){var Ie;return E("tilde",Ee,Oe,le,fe,ge,me),Re(le)?Ie="":Re(fe)?Ie=">="+le+".0.0 <"+(+le+1)+".0.0":Re(ge)?Ie=">="+le+"."+fe+".0 <"+le+"."+(+fe+1)+".0":me?(E("replaceTilde pr",me),me.charAt(0)!=="-"&&(me="-"+me),Ie=">="+le+"."+fe+"."+ge+me+" <"+le+"."+(+fe+1)+".0"):Ie=">="+le+"."+fe+"."+ge+" <"+le+"."+(+fe+1)+".0",E("tilde return",Ie),Ie})}(Ae,Pe)}).join(" ")}(de,Le),E("tildes",de),de=function(ye,Pe){return E("replaceXRanges",ye,Pe),ye.split(/\s+/).map(function(Ae){return function(Ee,be){Ee=Ee.trim();var Ce=be?L[N]:L[C];return Ee.replace(Ce,function(Oe,le,fe,ge,me,Ie){E("xRange",Ee,Oe,le,fe,ge,me,Ie);var Ve=Re(fe),Me=Ve||Re(ge),Ue=Me||Re(me);return le==="="&&Ue&&(le=""),Ve?Oe=le===">"||le==="<"?"<0.0.0":"*":le&&Ue?(Me&&(ge=0),Ue&&(me=0),le===">"?(le=">=",Me?(fe=+fe+1,ge=0,me=0):Ue&&(ge=+ge+1,me=0)):le==="<="&&(le="<",Me?fe=+fe+1:ge=+ge+1),Oe=le+fe+"."+ge+"."+me):Me?Oe=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ue&&(Oe=">="+fe+"."+ge+".0 <"+fe+"."+(+ge+1)+".0"),E("xRange return",Oe),Oe})}(Ae,Pe)}).join(" ")}(de,Le),E("xrange",de),de=function(ye,Pe){return E("replaceStars",ye,Pe),ye.trim().replace(L[k],"")}(de,Le),E("stars",de),de}(Se,G)}).join(" ").split(/\s+/);return this.loose&&(oe=oe.filter(function(Se){return!!Se.match(se)})),oe=oe.map(function(Se){return new we(Se,G)})},pe.prototype.intersects=function(z,G){if(!(z instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(se){return z.set.some(function(oe){return oe.every(function(Se){return se.intersects(Se,G)})})})})},t.toComparators=function(z,G){return new pe(z,G).set.map(function(K){return K.map(function(se){return se.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new $(z,this.loose));for(var G=0;G<this.set.length;G++)if(Be(this.set[G],z))return!0;return!1},t.satisfies=xe,t.maxSatisfying=function(z,G,K){var se=null,oe=null;try{var Se=new pe(G,K)}catch(de){return null}return z.forEach(function(de){Se.test(de)&&(se&&oe.compare(de)!==-1||(oe=new $(se=de,K)))}),se},t.minSatisfying=function(z,G,K){var se=null,oe=null;try{var Se=new pe(G,K)}catch(de){return null}return z.forEach(function(de){Se.test(de)&&(se&&oe.compare(de)!==1||(oe=new $(se=de,K)))}),se},t.validRange=function(z,G){try{return new pe(z,G).range||"*"}catch(K){return null}},t.ltr=function(z,G,K){return ze(z,G,"<",K)},t.gtr=function(z,G,K){return ze(z,G,">",K)},t.outside=ze,t.prerelease=function(z,G){var K=B(z,G);return K&&K.prerelease.length?K.prerelease:null},t.intersects=function(z,G,K){return z=new pe(z,K),G=new pe(G,K),z.intersects(G)},t.coerce=function(z){if(z instanceof $)return z;if(typeof z!="string")return null;var G=z.match(L[V]);return G==null?null:B((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,m(1))},function(_,t){var m,O,E=_.exports={};function P(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function L(D){if(m===setTimeout)return setTimeout(D,0);if((m===P||!m)&&setTimeout)return m=setTimeout,setTimeout(D,0);try{return m(D,0)}catch(I){try{return m.call(null,D,0)}catch(b){return m.call(this,D,0)}}}(function(){try{m=typeof setTimeout=="function"?setTimeout:P}catch(D){m=P}try{O=typeof clearTimeout=="function"?clearTimeout:T}catch(D){O=T}})();var u,d=[],y=!1,v=-1;function w(){y&&u&&(y=!1,u.length?d=u.concat(d):v=-1,d.length&&F())}function F(){if(!y){var D=L(w);y=!0;for(var I=d.length;I;){for(u=d,d=[];++v<I;)u&&u[v].run();v=-1,I=d.length}u=null,y=!1,function(b){if(O===clearTimeout)return clearTimeout(b);if((O===T||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(b);try{O(b)}catch(l){try{return O.call(null,b)}catch(r){return O.call(this,b)}}}(D)}}function c(D,I){this.fun=D,this.array=I}function f(){}E.nextTick=function(D){var I=new Array(arguments.length-1);if(arguments.length>1)for(var b=1;b<arguments.length;b++)I[b-1]=arguments[b];d.push(new c(D,I)),d.length!==1||y||L(F)},c.prototype.run=function(){this.fun.apply(null,this.array)},E.title="browser",E.browser=!0,E.env={},E.argv=[],E.version="",E.versions={},E.on=f,E.addListener=f,E.once=f,E.off=f,E.removeListener=f,E.removeAllListeners=f,E.emit=f,E.prependListener=f,E.prependOnceListener=f,E.listeners=function(D){return[]},E.binding=function(D){throw new Error("process.binding is not supported")},E.cwd=function(){return"/"},E.chdir=function(D){throw new Error("process.chdir is not supported")},E.umask=function(){return 0}}])}),define(Y[36],ee([0,1,8,2]),function(_,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function E(l){const r=l;return r?[r.on,r.pause,r.resume,r.destroy].every(s=>typeof s=="function"):!1}t.isReadableStream=E;function P(l){const r=l;return r?E(r.stream)&&Array.isArray(r.buffer)&&typeof r.ended=="boolean":!1}t.isReadableBufferedStream=P;function T(l,r){return new L(l,r)}t.newWriteableStream=T;class L{constructor(r,s){this.reducer=r,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(r){if(!this.state.destroyed){if(this.state.flowing)this.emitData(r);else if(this.buffer.data.push(r),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(r){this.state.destroyed||(this.state.flowing?this.emitError(r):this.buffer.error.push(r))}end(r){this.state.destroyed||(typeof r!="undefined"&&this.write(r),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(r){this.listeners.data.slice(0).forEach(s=>s(r))}emitError(r){this.listeners.error.length===0?(0,m.onUnexpectedError)(r):this.listeners.error.slice(0).forEach(s=>s(r))}emitEnd(){this.listeners.end.slice(0).forEach(r=>r())}on(r,s){if(!this.state.destroyed)switch(r){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(r,s){if(this.state.destroyed)return;let e;switch(r){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(s);i>=0&&e.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const r=this.reducer(this.buffer.data);this.emitData(r),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const r of this.buffer.error)this.emitError(r);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function u(l,r){const s=[];let e;for(;(e=l.read())!==null;)s.push(e);return r(s)}t.consumeReadable=u;function d(l,r,s){const e=[];let i;for(;(i=l.read())!==null&&e.length<s;)e.push(i);return i===null&&e.length>0?r(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return l.read()}}}t.peekReadable=d;function y(l,r){return new Promise((s,e)=>{const i=[];v(l,{onData:n=>{r&&i.push(n)},onError:n=>{r?e(n):s(void 0)},onEnd:()=>{s(r?r(i):void 0)}})})}t.consumeStream=y;function v(l,r){l.on("error",s=>r.onError(s)),l.on("end",()=>r.onEnd()),l.on("data",s=>r.onData(s))}t.listenStream=v;function w(l,r){return new Promise((s,e)=>{const i=new O.DisposableStore,n=[],o=p=>{if(n.push(p),n.length>r)return i.dispose(),l.pause(),s({stream:l,buffer:n,ended:!1})},a=p=>e(p),h=()=>s({stream:l,buffer:n,ended:!0});i.add((0,O.toDisposable)(()=>l.removeListener("error",a))),l.on("error",a),i.add((0,O.toDisposable)(()=>l.removeListener("end",h))),l.on("end",h),i.add((0,O.toDisposable)(()=>l.removeListener("data",o))),l.on("data",o)})}t.peekStream=w;function F(l,r){const s=T(r);return s.end(l),s}t.toStream=F;function c(){const l=T(()=>{throw new Error("not supported")});return l.end(),l}t.emptyStream=c;function f(l){let r=!1;return{read:()=>r?null:(r=!0,l)}}t.toReadable=f;function D(l,r,s){const e=T(s);return v(l,{onData:i=>e.write(r.data(i)),onError:i=>e.error(r.error?r.error(i):i),onEnd:()=>e.end()}),e}t.transform=D;function I(l,r,s){let e=!1;return{read:()=>{const i=r.read();return e?i:(e=!0,i!==null?s([l,i]):l)}}}t.prefixedReadable=I;function b(l,r,s){let e=!1;const i=T(s);return v(r,{onData:n=>e?i.write(n):(e=!0,i.write(s([l,n]))),onError:n=>i.error(n),onEnd:()=>{e||(e=!0,i.write(l)),i.end()}}),i}t.prefixedStream=b}),define(Y[16],ee([0,1,18,36]),function(_,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const E=typeof Buffer!="undefined",P=typeof TextEncoder!="undefined",T=typeof TextDecoder!="undefined";let L,u;class d{constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}static alloc(p){return E?new d(Buffer.allocUnsafe(p)):new d(new Uint8Array(p))}static wrap(p){return E&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new d(p)}static fromString(p,M){return!(M?.dontUseNodeBuffer||!1)&&E?new d(Buffer.from(p)):P?(L||(L=new TextEncoder),new d(L.encode(p))):new d(m.encodeUTF8(p))}static concat(p,M){if(typeof M=="undefined"){M=0;for(let V=0,W=p.length;V<W;V++)M+=p[V].byteLength}const C=d.alloc(M);let N=0;for(let V=0,W=p.length;V<W;V++){const Q=p[V];C.set(Q,N),N+=Q.byteLength}return C}toString(){return E?this.buffer.toString():T?(u||(u=new TextDecoder),u.decode(this.buffer)):m.decodeUTF8(this.buffer)}slice(p,M){return new d(this.buffer.subarray(p,M))}set(p,M){p instanceof d?this.buffer.set(p.buffer,M):this.buffer.set(p,M)}readUInt32BE(p){return w(this.buffer,p)}writeUInt32BE(p,M){F(this.buffer,p,M)}readUInt32LE(p){return c(this.buffer,p)}writeUInt32LE(p,M){f(this.buffer,p,M)}readUInt8(p){return D(this.buffer,p)}writeUInt8(p,M){I(this.buffer,p,M)}}t.VSBuffer=d;function y(h,p){return h[p+0]<<0>>>0|h[p+1]<<8>>>0}t.readUInt16LE=y;function v(h,p,M){h[M+0]=p&255,p=p>>>8,h[M+1]=p&255}t.writeUInt16LE=v;function w(h,p){return h[p]*2**24+h[p+1]*2**16+h[p+2]*2**8+h[p+3]}t.readUInt32BE=w;function F(h,p,M){h[M+3]=p,p=p>>>8,h[M+2]=p,p=p>>>8,h[M+1]=p,p=p>>>8,h[M]=p}t.writeUInt32BE=F;function c(h,p){return h[p+0]<<0>>>0|h[p+1]<<8>>>0|h[p+2]<<16>>>0|h[p+3]<<24>>>0}t.readUInt32LE=c;function f(h,p,M){h[M+0]=p&255,p=p>>>8,h[M+1]=p&255,p=p>>>8,h[M+2]=p&255,p=p>>>8,h[M+3]=p&255}t.writeUInt32LE=f;function D(h,p){return h[p]}t.readUInt8=D;function I(h,p,M){h[M]=p}t.writeUInt8=I;function b(h){return O.consumeReadable(h,p=>d.concat(p))}t.readableToBuffer=b;function l(h){return O.toReadable(h)}t.bufferToReadable=l;function r(h){return O.consumeStream(h,p=>d.concat(p))}t.streamToBuffer=r;async function s(h){return h.ended?d.concat(h.buffer):d.concat([...h.buffer,await r(h.stream)])}t.bufferedStreamToBuffer=s;function e(h){return O.toStream(h,p=>d.concat(p))}t.bufferToStream=e;function i(h){return O.transform(h,{data:p=>typeof p=="string"?d.fromString(p):d.wrap(p)},p=>d.concat(p))}t.streamToBufferReadableStream=i;function n(h){return O.newWriteableStream(p=>d.concat(p),h)}t.newWriteableBufferStream=n;function o(h,p){return O.prefixedReadable(h,p,M=>d.concat(M))}t.prefixedBufferReadable=o;function a(h,p){return O.prefixedStream(h,p,M=>d.concat(M))}t.prefixedBufferStream=a}),define(Y[19],ee([0,1,12]),function(_,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function O(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const D=Array.isArray(f)?[]:{};return Object.keys(f).forEach(I=>{f[I]&&typeof f[I]=="object"?D[I]=O(f[I]):D[I]=f[I]}),D}t.deepClone=O;function E(f){if(!f||typeof f!="object")return f;const D=[f];for(;D.length>0;){const I=D.shift();Object.freeze(I);for(const b in I)if(P.call(I,b)){const l=I[b];typeof l=="object"&&!Object.isFrozen(l)&&D.push(l)}}return f}t.deepFreeze=E;const P=Object.prototype.hasOwnProperty;function T(f,D){return L(f,D,new Set)}t.cloneAndChange=T;function L(f,D,I){if((0,m.isUndefinedOrNull)(f))return f;const b=D(f);if(typeof b!="undefined")return b;if((0,m.isArray)(f)){const l=[];for(const r of f)l.push(L(r,D,I));return l}if((0,m.isObject)(f)){if(I.has(f))throw new Error("Cannot clone recursive data-structure");I.add(f);const l={};for(let r in f)P.call(f,r)&&(l[r]=L(f[r],D,I));return I.delete(f),l}return f}function u(f,D,I=!0){return(0,m.isObject)(f)?((0,m.isObject)(D)&&Object.keys(D).forEach(b=>{b in f?I&&((0,m.isObject)(f[b])&&(0,m.isObject)(D[b])?u(f[b],D[b],I):f[b]=D[b]):f[b]=D[b]}),f):D}t.mixin=u;function d(f,D){if(f===D)return!0;if(f==null||D===null||D===void 0||typeof f!=typeof D||typeof f!="object"||Array.isArray(f)!==Array.isArray(D))return!1;let I,b;if(Array.isArray(f)){if(f.length!==D.length)return!1;for(I=0;I<f.length;I++)if(!d(f[I],D[I]))return!1}else{const l=[];for(b in f)l.push(b);l.sort();const r=[];for(b in D)r.push(b);if(r.sort(),!d(l,r))return!1;for(I=0;I<l.length;I++)if(!d(f[l[I]],D[l[I]]))return!1}return!0}t.equals=d;function y(f){const D=new Set;return JSON.stringify(f,(I,b)=>{if((0,m.isObject)(b)||Array.isArray(b)){if(D.has(b))return"[Circular]";D.add(b)}return b})}t.safeStringify=y;function v(f,D,I){const b=D(f);return typeof b=="undefined"?I:b}t.getOrDefault=v;function w(f,D){const I=Object.create(null);return!f||!D||Object.keys(D).forEach(l=>{const r=f[l],s=D[l];d(r,s)||(I[l]=s)}),I}t.distinct=w;function F(f,D){const I=D.toLowerCase(),b=Object.keys(f).find(l=>l.toLowerCase()===I);return b?f[b]:f[D]}t.getCaseInsensitive=F;function c(f,D){const I=Object.create(null);for(const b of Object.keys(f))D(b,f[b])&&(I[b]=f[b]);return I}t.filter=c}),define(Y[59],ee([0,1,7]),function(_,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function O(d){const y=d;return y&&typeof y.type=="string"&&typeof y.severity=="string"}t.isRemoteConsoleLog=O;function E(d){const y=[];let v;try{const w=JSON.parse(d.arguments),F=w[w.length-1];F&&F.__$stack&&(w.pop(),v=F.__$stack),y.push(...w)}catch(w){y.push("Unable to log remote console arguments",d.arguments)}return{args:y,stack:v}}t.parse=E;function P(d){if(typeof d!="string")return P(E(d).stack);const y=d;if(y){const v=T(y),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(w&&w.length===4)return{uri:m.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}t.getFirstFrame=P;function T(d){if(!d)return d;const y=d.indexOf(`
`);return y===-1?d:d.substring(0,y)}function L(d,y){const{args:v,stack:w}=E(d),F=typeof v[0]=="string"&&v.length===1;let c=T(w);c&&(c=`(${c.trim()})`);let f=[];if(typeof v[0]=="string"?c&&F?f=[`%c[${y}] %c${v[0]} %c${c}`,u("blue"),u(""),u("grey")]:f=[`%c[${y}] %c${v[0]}`,u("blue"),u(""),...v.slice(1)]:f=[`%c[${y}]%`,u("blue"),...v],c&&!F&&f.push(c),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,f)}t.log=L;function u(d){return`color: ${d}`}}),define(Y[60],ee([0,1,16,18,7]),function(_,t,m,O,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function P(y){return JSON.stringify(y,u)}t.stringify=P;function T(y){let v=JSON.parse(y);return v=d(v),v}t.parse=T;var L;(function(y){y[y.Uri=1]="Uri",y[y.Regexp=2]="Regexp",y[y.ScmResource=3]="ScmResource",y[y.ScmResourceGroup=4]="ScmResourceGroup",y[y.ScmProvider=5]="ScmProvider",y[y.CommentController=6]="CommentController",y[y.CommentThread=7]="CommentThread",y[y.CommentThreadReply=8]="CommentThreadReply",y[y.CommentNode=9]="CommentNode",y[y.CommentThreadNode=10]="CommentThreadNode",y[y.TimelineActionContext=11]="TimelineActionContext",y[y.NotebookCellActionContext=12]="NotebookCellActionContext",y[y.TestItemContext=13]="TestItemContext"})(L=t.MarshalledId||(t.MarshalledId={}));function u(y,v){return v instanceof RegExp?{$mid:2,source:v.source,flags:(0,O.regExpFlags)(v)}:v}function d(y,v=0){if(!y||v>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return E.URI.revive(y);case 2:return new RegExp(y.source,y.flags)}if(y instanceof m.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let w=0;w<y.length;++w)y[w]=d(y[w],v+1);else for(const w in y)Object.hasOwnProperty.call(y,w)&&(y[w]=d(y[w],v+1))}return y}t.revive=d}),define(Y[61],ee([0,1,18,37,3,45,4]),function(_,t,m,O,E,P,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function L(){return Object.create(null)}t.getEmptyExpression=L;const u="**",d="/",y="[/\\\\]",v="[^/\\\\]",w=/\//g;function F(g){switch(g){case 0:return"";case 1:return`${v}*?`;default:return`(?:${y}|${v}+${y}|${y}${v}+)*?`}}function c(g,R){if(!g)return[];const A=[];let k=!1,U=!1,B="";for(const $ of g){switch($){case R:if(!k&&!U){A.push(B),B="";continue}break;case"{":k=!0;break;case"}":k=!1;break;case"[":U=!0;break;case"]":U=!1;break}B+=$}return B&&A.push(B),A}t.splitGlobAware=c;function f(g){if(!g)return"";let R="";const A=c(g,d);if(A.every(k=>k===u))R=".*";else{let k=!1;A.forEach((U,B)=>{if(U===u){k||(R+=F(2),k=!0);return}let $=!1,H="",J=!1,te="";for(const ne of U){if(ne!=="}"&&$){H+=ne;continue}if(J&&(ne!=="]"||!te)){let ae;ne==="-"?ae=ne:(ne==="^"||ne==="!")&&!te?ae="^":ne===d?ae="":ae=m.escapeRegExpCharacters(ne),te+=ae;continue}switch(ne){case"{":$=!0;continue;case"[":J=!0;continue;case"}":R+=`(?:${c(H,",").map(ve=>f(ve)).join("|")})`,$=!1,H="";break;case"]":R+="["+te+"]",J=!1,te="";break;case"?":R+=v;continue;case"*":R+=F(1);continue;default:R+=m.escapeRegExpCharacters(ne)}}B<A.length-1&&(A[B+1]!==u||B+2<A.length)&&(R+=y),k=!1})}return R}const D=/^\*\*\/\*\.[\w\.-]+$/,I=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,l=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new P.LRUCache(1e4),i=function(){return!1},n=function(){return null};function o(g,R){if(!g)return n;let A;typeof g!="string"?A=g.pattern:A=g,A=A.trim();const k=`${A}_${!!R.trimForExclusions}`;let U=e.get(k);if(U)return a(U,g);let B;if(D.test(A)){const $=A.substr(4);U=function(H,J){return typeof H=="string"&&H.endsWith($)?A:null}}else(B=I.exec(h(A,R)))?U=p(B[1],A):(R.trimForExclusions?l:b).test(A)?U=M(A,R):(B=r.exec(h(A,R)))?U=C(B[1].substr(1),A,!0):(B=s.exec(h(A,R)))?U=C(B[1],A,!1):U=N(A);return e.set(k,U),a(U,g)}function a(g,R){return typeof R=="string"?g:function(A,k){return O.isEqualOrParent(A,R.base)?g(E.relative(R.base,A),k):null}}function h(g,R){return R.trimForExclusions&&g.endsWith("/**")?g.substr(0,g.length-2):g}function p(g,R){const A=`/${g}`,k=`\\${g}`,U=function($,H){return typeof $!="string"?null:H?H===g?R:null:$===g||$.endsWith(A)||$.endsWith(k)?R:null},B=[g];return U.basenames=B,U.patterns=[R],U.allBasenames=B,U}function M(g,R){const A=S(g.slice(1,-1).split(",").map(H=>o(H,R)).filter(H=>H!==n),g),k=A.length;if(!k)return n;if(k===1)return A[0];const U=function(H,J){for(let te=0,ne=A.length;te<ne;te++)if(A[te](H,J))return g;return null},B=A.find(H=>!!H.allBasenames);B&&(U.allBasenames=B.allBasenames);const $=A.reduce((H,J)=>J.allPaths?H.concat(J.allPaths):H,[]);return $.length&&(U.allPaths=$),U}function C(g,R,A){const k=E.sep===E.posix.sep,U=k?g:g.replace(w,E.sep),B=E.sep+U,$=E.posix.sep+g,H=A?function(J,te){return typeof J=="string"&&(J===U||J.endsWith(B)||!k&&(J===g||J.endsWith($)))?R:null}:function(J,te){return typeof J=="string"&&(J===U||!k&&J===g)?R:null};return H.allPaths=[(A?"*/":"./")+g],H}function N(g){try{const R=new RegExp(`^${f(g)}$`);return function(A){return R.lastIndex=0,typeof A=="string"&&R.test(A)?g:null}}catch(R){return n}}function V(g,R,A){return!g||typeof R!="string"?!1:W(g)(R,void 0,A)}t.match=V;function W(g,R={}){if(!g)return i;if(typeof g=="string"||Z(g)){const A=o(g,R);if(A===n)return i;const k=function(U,B){return!!A(U,B)};return A.allBasenames&&(k.allBasenames=A.allBasenames),A.allPaths&&(k.allPaths=A.allPaths),k}return x(g,R)}t.parse=W;function Q(g){if(!g)return;let R;return A=>(R||(R=(g()||Promise.resolve([])).then(k=>k?re(k):{})),R.then(k=>!!k[A]))}t.hasSiblingPromiseFn=Q;function ie(g){if(!g)return;let R;return A=>{if(!R){const k=g();R=k?re(k):{}}return!!R[A]}}t.hasSiblingFn=ie;function re(g){const R={};for(const A of g)R[A]=!0;return R}function Z(g){const R=g;return R&&typeof R.base=="string"&&typeof R.pattern=="string"}t.isRelativePattern=Z;function X(g){return g.allBasenames||[]}t.getBasenameTerms=X;function j(g){return g.allPaths||[]}t.getPathTerms=j;function x(g,R){const A=S(Object.getOwnPropertyNames(g).map(H=>q(H,g[H],R)).filter(H=>H!==n)),k=A.length;if(!k)return n;if(!A.some(H=>!!H.requiresSiblings)){if(k===1)return A[0];const H=function(ne,ae){for(let he=0,ve=A.length;he<ve;he++){const De=A[he](ne,ae);if(De)return De}return null},J=A.find(ne=>!!ne.allBasenames);J&&(H.allBasenames=J.allBasenames);const te=A.reduce((ne,ae)=>ae.allPaths?ne.concat(ae.allPaths):ne,[]);return te.length&&(H.allPaths=te),H}const U=function(H,J,te){let ne;for(let ae=0,he=A.length;ae<he;ae++){const ve=A[ae];ve.requiresSiblings&&te&&(J||(J=E.basename(H)),ne||(ne=J.substr(0,J.length-E.extname(H).length)));const De=ve(H,J,ne,te);if(De)return De}return null},B=A.find(H=>!!H.allBasenames);B&&(U.allBasenames=B.allBasenames);const $=A.reduce((H,J)=>J.allPaths?H.concat(J.allPaths):H,[]);return $.length&&(U.allPaths=$),U}function q(g,R,A){if(R===!1)return n;const k=o(g,A);if(k===n)return n;if(typeof R=="boolean")return k;if(R){const U=R.when;if(typeof U=="string"){const B=($,H,J,te)=>{if(!te||!k($,H))return null;const ne=U.replace("$(basename)",J),ae=te(ne);return(0,T.isThenable)(ae)?ae.then(he=>he?g:null):ae?g:null};return B.requiresSiblings=!0,B}}return k}function S(g,R){const A=g.filter(H=>!!H.basenames);if(A.length<2)return g;const k=A.reduce((H,J)=>{const te=J.basenames;return te?H.concat(te):H},[]);let U;if(R){U=[];for(let H=0,J=k.length;H<J;H++)U.push(R)}else U=A.reduce((H,J)=>{const te=J.patterns;return te?H.concat(te):H},[]);const B=function(H,J){if(typeof H!="string")return null;if(!J){let ne;for(ne=H.length;ne>0;ne--){const ae=H.charCodeAt(ne-1);if(ae===47||ae===92)break}J=H.substr(ne)}const te=k.indexOf(J);return te!==-1?U[te]:null};B.basenames=k,B.patterns=U,B.allBasenames=k;const $=g.filter(H=>!H.basenames);return $.push(B),$}}),define(Y[62],ee([0,1,7,3,18,9,15,20,37]),function(_,t,m,O,E,P,T,L,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function d(o,a,h){if(typeof o=="string"&&(o=m.URI.file(o)),h){const M=h.getWorkspaceFolder(o);if(M){const C=h.getWorkspace().folders.length>1;let N;if((0,L.isEqual)(M.uri,o)?N="":N=(0,L.relativePath)(M.uri,o),C){const V=M.name?M.name:(0,L.basename)(M.uri);N=N?V+" \u2022 "+N:V}return N}}if(o.scheme!==P.Schemas.file&&o.scheme!==P.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if((0,u.hasDriveLetter)(o.fsPath))return(0,O.normalize)(v(o.fsPath));let p=(0,O.normalize)(o.fsPath);return!T.isWindows&&a?.userHome&&(p=F(p,a.userHome.fsPath)),p}t.getPathLabel=d;function y(o){if(!o)return;typeof o=="string"&&(o=m.URI.file(o));const a=(0,L.basename)(o)||(o.scheme===P.Schemas.file?o.fsPath:o.path);return T.isWindows&&(0,u.isRootOrDriveLetter)(a)?v(a):a}t.getBaseLabel=y;function v(o){return(0,u.hasDriveLetter)(o)?o.charAt(0).toUpperCase()+o.slice(1):o}t.normalizeDriveLetter=v;let w=Object.create(null);function F(o,a){if(T.isWindows||!o||!a)return o;let h=w.original===a?w.normalized:void 0;return h||(h=`${(0,E.rtrim)(a,O.posix.sep)}${O.posix.sep}`,w={original:a,normalized:h}),(T.isLinux?o.startsWith(h):(0,E.startsWithIgnoreCase)(o,h))&&(o=`~/${o.substr(h.length)}`),o}t.tildify=F;function c(o,a){return o.replace(/^~($|\/|\\)/,`${a}$1`)}t.untildify=c;const f="\u2026",D="\\\\",I="~";function b(o,a=O.sep){const h=new Array(o.length);let p=!1;for(let M=0;M<o.length;M++){let C=o[M];if(C===""){h[M]=`.${a}`;continue}if(!C){h[M]=C;continue}p=!0;let N="";C.indexOf(D)===0?(N=C.substr(0,C.indexOf(D)+D.length),C=C.substr(C.indexOf(D)+D.length)):C.indexOf(a)===0?(N=C.substr(0,C.indexOf(a)+a.length),C=C.substr(C.indexOf(a)+a.length)):C.indexOf(I)===0&&(N=C.substr(0,C.indexOf(I)+I.length),C=C.substr(C.indexOf(I)+I.length));const V=C.split(a);for(let W=1;p&&W<=V.length;W++)for(let Q=V.length-W;p&&Q>=0;Q--){p=!1;let ie=V.slice(Q,Q+W).join(a);for(let re=0;!p&&re<o.length;re++)if(re!==M&&o[re]&&o[re].indexOf(ie)>-1){const Z=Q+W===V.length,X=Q>0&&o[re].indexOf(a)>-1?a+ie:ie,j=o[re].endsWith(X);p=!Z||j}if(!p){let re="";(V[0].endsWith(":")||N!=="")&&(Q===1&&(Q=0,W++,ie=V[0]+a+ie),Q>0&&(re=V[0]+a),re=N+re),Q>0&&(re=re+f+a),re=re+ie,Q+W<V.length&&(re=re+a+f),h[M]=re}}p&&(h[M]=C)}return h}t.shorten=b;var l;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function r(o,a=Object.create(null)){const h=[];let p=!1,M="";for(const C of o)if(C==="$"||p&&C==="{")M&&h.push({value:M,type:l.TEXT}),M="",p=!0;else if(C==="}"&&p){const N=a[M];if(typeof N=="string")N.length&&h.push({value:N,type:l.VARIABLE});else if(N){const V=h[h.length-1];(!V||V.type!==l.SEPARATOR)&&h.push({value:N.label,type:l.SEPARATOR})}M="",p=!1}else M+=C;return M&&!p&&h.push({value:M,type:l.TEXT}),h.filter((C,N)=>{if(C.type===l.SEPARATOR){const V=h[N-1],W=h[N+1];return[V,W].every(Q=>Q&&(Q.type===l.VARIABLE||Q.type===l.TEXT)&&Q.value.length>0)}return!0}).map(C=>C.value).join("")}t.template=r;function s(o,a){return T.isMacintosh||a?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):o.replace(/&&|&/g,h=>h==="&"?"&&":"&")}t.mnemonicMenuLabel=s;function e(o,a){return T.isMacintosh||a?o.replace(/\(&&\w\)|&&/g,""):T.isWindows?o.replace(/&&|&/g,h=>h==="&"?"&&":"&"):o.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(o){return o.replace(/&/g,"&&")}t.unmnemonicLabel=i;function n(o){const a=o.indexOf("/")!==-1?O.posix:O.win32,h=a.basename(o),p=a.dirname(o);return h.length?{name:h,parentPath:p}:{name:p,parentPath:""}}t.splitName=n}),define(Y[46],ee([0,1,126]),function(_,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class O{constructor(P="utf8"){this.stringDecoder=new m.StringDecoder(P),this.remaining=null}write(P){const T=[],L=this.remaining?this.remaining+this.stringDecoder.write(P):this.stringDecoder.write(P);if(L.length<1)return T;let u=0,d,y=u;for(;y<L.length;)if(d=L.charCodeAt(y),d===13||d===10){if(T.push(L.substring(u,y)),y++,y<L.length){const v=d;d=L.charCodeAt(y),(v===13&&d===10||v===10&&d===13)&&y++}u=y}else y++;return this.remaining=u<L.length?L.substr(u):null,T}end(){return this.remaining}}t.LineDecoder=O}),define(Y[63],ee([0,1,38,18,3,10]),function(_,t,m,O,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function T(y){const v=(0,E.dirname)(y);if(y===v)return y;const w=((0,E.basename)(y)||y).toLowerCase();try{const c=(0,P.readdirSync)(v).filter(f=>f.toLowerCase()===w);if(c.length===1){const f=T(v);if(f)return(0,E.join)(f,c[0])}else if(c.length>1){const f=c.indexOf(w);if(f>=0){const D=T(v);if(D)return(0,E.join)(D,c[f])}}}catch(F){}return null}t.realcaseSync=T;async function L(y){try{return await P.Promises.realpath(y)}catch(v){const w=d(y);return await P.Promises.access(w,m.constants.R_OK),w}}t.realpath=L;function u(y){try{return m.realpathSync(y)}catch(v){const w=d(y);return m.accessSync(w,m.constants.R_OK),w}}t.realpathSync=u;function d(y){return(0,O.rtrim)((0,E.normalize)(y),E.sep)}}),define(Y[64],ee([0,1,10,31,3]),function(_,t,m,O,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const P=/^\d+$/,T=/^Microsoft.PowerShell_.*/,L=/^Microsoft.PowerShellPreview_.*/;var u;(function(r){r[r.x64=0]="x64",r[r.x86=1]="x86",r[r.ARM=2]="ARM"})(u||(u={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class v{constructor(s,e,i){this.exePath=s,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await m.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function w({useAlternateBitness:r=!1}={}){return r?d===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function F({useAlternateBitness:r=!1,findPreview:s=!1}={}){const e=w({useAlternateBitness:r});if(!e)return null;const i=E.join(e,"PowerShell");if(!await m.SymlinkSupport.existsDirectory(i))return null;let n=-1,o=null;for(const p of await m.Promises.readdir(i)){let M=-1;if(s){const N=p.indexOf("-");if(N<0)continue;const V=p.substring(0,N);if(!P.test(V)||p.substring(N+1)!=="preview")continue;M=parseInt(V,10)}else{if(!P.test(p))continue;M=parseInt(p,10)}if(M<=n)continue;const C=E.join(i,p,"pwsh.exe");!await m.SymlinkSupport.existsFile(C)||(o=C,n=M)}if(!o)return null;const a=e.includes("x86")?" (x86)":"",h=s?" Preview":"";return new v(o,`PowerShell${h}${a}`,!0)}async function c({findPreview:r}={}){if(!process.env.LOCALAPPDATA)return null;const s=E.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await m.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=r?{pwshMsixDirRegex:L,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const n of await m.Promises.readdir(s))if(e.test(n)){const o=E.join(s,n,"pwsh.exe");return new v(o,i)}return null}function f(){const r=E.join(O.homedir(),".dotnet","tools","pwsh.exe");return new v(r,".NET Core PowerShell Global Tool")}function D(){const r=E.join(process.env.windir,d===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(r,"Windows PowerShell",!0)}async function*I(){let r=await F();r&&(yield r),r=await F({useAlternateBitness:!0}),r&&(yield r),r=await c(),r&&(yield r),r=f(),r&&(yield r),r=await F({findPreview:!0}),r&&(yield r),r=await c({findPreview:!0}),r&&(yield r),r=await F({useAlternateBitness:!0,findPreview:!0}),r&&(yield r),r=D(),r&&(yield r)}async function*b(){for await(const r of I())await r.exists()&&(yield r)}t.enumeratePowerShellInstallations=b;async function l(){for await(const r of b())return r;return null}t.getFirstAvailablePowerShellInstallation=l}),define(Y[65],ee([0,1,3,38,15,127,2,10]),function(_,t,m,O,E,P,T,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function u(v,w,F){return y({path:v,isDirectory:!1},w,F)}t.watchFile=u;function d(v,w,F){return y({path:v,isDirectory:!0},w,F)}t.watchFolder=d,t.CHANGE_BUFFER_DELAY=100;function y(v,w,F){const c=(0,m.basename)(v.path),f=new Map;let D=!1,I=[(0,T.toDisposable)(()=>{f.forEach(b=>(0,T.dispose)(b)),f.clear()})];try{const b=(0,O.watch)(v.path);I.push((0,T.toDisposable)(()=>{b.removeAllListeners(),b.close()}));const l=new Set;v.isDirectory&&L.Promises.readdir(v.path).then(r=>r.forEach(s=>l.add(s))),b.on("error",(r,s)=>{D||F(`Failed to watch ${v.path} for changes using fs.watch() (${r}, ${s})`)}),b.on("change",(r,s)=>{if(D)return;let e="";if(s&&(e=s.toString(),E.isMacintosh&&(e=(0,P.normalizeNFC)(e))),!e||r!=="change"&&r!=="rename")return;const i=v.isDirectory?(0,m.join)(v.path,e):v.path;if(v.isDirectory)if(r==="rename"){const n=f.get(i);n&&(0,T.dispose)(n);const o=setTimeout(async()=>{f.delete(i);const a=await L.Promises.exists(i);if(D)return;let h;a?l.has(e)?h="changed":(h="added",l.add(e)):(l.delete(e),h="deleted"),w(h,i)},t.CHANGE_BUFFER_DELAY);f.set(i,(0,T.toDisposable)(()=>clearTimeout(o)))}else{let n;l.has(e)?n="changed":(n="added",l.add(e)),w(n,i)}else if(r==="rename"||e!==c){const n=setTimeout(async()=>{const o=await L.Promises.exists(i);D||(o?(w("changed",i),I=[y(v,w,F)]):w("deleted",i))},t.CHANGE_BUFFER_DELAY);(0,T.dispose)(I),I=[(0,T.toDisposable)(()=>clearTimeout(n))]}else w("changed",i)})}catch(b){L.Promises.exists(v.path).then(l=>{l&&!D&&F(`Failed to watch ${v.path} for changes using fs.watch() (${b.toString()})`)})}return(0,T.toDisposable)(()=>{D=!0,I=(0,T.dispose)(I)})}});var ce=this&&this.__decorate||function(_,t,m,O){var E=arguments.length,P=E<3?t:O===null?O=Object.getOwnPropertyDescriptor(t,m):O,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(_,t,m,O);else for(var L=_.length-1;L>=0;L--)(T=_[L])&&(P=(E<3?T(P):E>3?T(t,m,P):T(t,m))||P);return E>3&&P&&Object.defineProperty(t,m,P),P};define(Y[39],ee([0,1,13,2,4,26,8,16,24,12,60,18,44]),function(_,t,m,O,E,P,T,L,u,d,y,v,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var F;(function(S){S[S.Promise=100]="Promise",S[S.PromiseCancel=101]="PromiseCancel",S[S.EventListen=102]="EventListen",S[S.EventDispose=103]="EventDispose"})(F=t.RequestType||(t.RequestType={}));function c(S){switch(S){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function(S){S[S.Initialize=200]="Initialize",S[S.PromiseSuccess=201]="PromiseSuccess",S[S.PromiseError=202]="PromiseError",S[S.PromiseErrorObj=203]="PromiseErrorObj",S[S.EventFire=204]="EventFire"})(f=t.ResponseType||(t.ResponseType={}));function D(S){switch(S){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var I;(function(S){S[S.Uninitialized=0]="Uninitialized",S[S.Idle=1]="Idle"})(I||(I={}));class b{constructor(g){this.buffer=g,this.pos=0}read(g){const R=this.buffer.slice(this.pos,this.pos+g);return this.pos+=R.byteLength,R}}class l{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(g){this.buffers.push(g)}}var r;(function(S){S[S.Undefined=0]="Undefined",S[S.String=1]="String",S[S.Buffer=2]="Buffer",S[S.VSBuffer=3]="VSBuffer",S[S.Array=4]="Array",S[S.Object=5]="Object"})(r||(r={}));function s(S){const g=L.VSBuffer.alloc(4);return g.writeUInt32BE(S,0),g}function e(S){return S.read(4).readUInt32BE(0)}function i(S){const g=L.VSBuffer.alloc(1);return g.writeUInt8(S,0),g}const n={Undefined:i(r.Undefined),String:i(r.String),Buffer:i(r.Buffer),VSBuffer:i(r.VSBuffer),Array:i(r.Array),Object:i(r.Object)},o=typeof Buffer!="undefined";function a(S,g){if(typeof g=="undefined")S.write(n.Undefined);else if(typeof g=="string"){const R=L.VSBuffer.fromString(g);S.write(n.String),S.write(s(R.byteLength)),S.write(R)}else if(o&&Buffer.isBuffer(g)){const R=L.VSBuffer.wrap(g);S.write(n.Buffer),S.write(s(R.byteLength)),S.write(R)}else if(g instanceof L.VSBuffer)S.write(n.VSBuffer),S.write(s(g.byteLength)),S.write(g);else if(Array.isArray(g)){S.write(n.Array),S.write(s(g.length));for(const R of g)a(S,R)}else{const R=L.VSBuffer.fromString(JSON.stringify(g));S.write(n.Object),S.write(s(R.byteLength)),S.write(R)}}function h(S){switch(S.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return S.read(e(S)).toString();case r.Buffer:return S.read(e(S)).buffer;case r.VSBuffer:return S.read(e(S));case r.Array:{const R=e(S),A=[];for(let k=0;k<R;k++)A.push(h(S));return A}case r.Object:return JSON.parse(S.read(e(S)).toString())}}class p{constructor(g,R,A=null,k=1e3){this.protocol=g,this.ctx=R,this.logger=A,this.timeoutDelay=k,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(U=>this.onRawMessage(U)),this.sendResponse({type:200})}registerChannel(g,R){this.channels.set(g,R),setTimeout(()=>this.flushPendingRequests(g),0)}sendResponse(g){switch(g.type){case 200:{const R=this.send([g.type]);this.logger&&this.logger.logOutgoing(R,0,1,D(g.type));return}case 201:case 202:case 204:case 203:{const R=this.send([g.type,g.id],g.data);this.logger&&this.logger.logOutgoing(R,g.id,1,D(g.type),g.data);return}}}send(g,R=void 0){const A=new l;return a(A,g),a(A,R),this.sendBuffer(A.buffer)}sendBuffer(g){try{return this.protocol.send(g),g.byteLength}catch(R){return 0}}onRawMessage(g){const R=new b(g),A=h(R),k=h(R),U=A[0];switch(U){case 100:return this.logger&&this.logger.logIncoming(g.byteLength,A[1],1,`${c(U)}: ${A[2]}.${A[3]}`,k),this.onPromise({type:U,id:A[1],channelName:A[2],name:A[3],arg:k});case 102:return this.logger&&this.logger.logIncoming(g.byteLength,A[1],1,`${c(U)}: ${A[2]}.${A[3]}`,k),this.onEventListen({type:U,id:A[1],channelName:A[2],name:A[3],arg:k});case 101:return this.logger&&this.logger.logIncoming(g.byteLength,A[1],1,`${c(U)}`),this.disposeActiveRequest({type:U,id:A[1]});case 103:return this.logger&&this.logger.logIncoming(g.byteLength,A[1],1,`${c(U)}`),this.disposeActiveRequest({type:U,id:A[1]})}}onPromise(g){const R=this.channels.get(g.channelName);if(!R){this.collectPendingRequest(g);return}const A=new P.CancellationTokenSource;let k;try{k=R.call(this.ctx,g.name,g.arg,A.token)}catch($){k=Promise.reject($)}const U=g.id;k.then($=>{this.sendResponse({id:U,data:$,type:201}),this.activeRequests.delete(g.id)},$=>{$ instanceof Error?this.sendResponse({id:U,data:{message:$.message,name:$.name,stack:$.stack?$.stack.split?$.stack.split(`
`):$.stack:void 0},type:202}):this.sendResponse({id:U,data:$,type:203}),this.activeRequests.delete(g.id)});const B=(0,O.toDisposable)(()=>A.cancel());this.activeRequests.set(g.id,B)}onEventListen(g){const R=this.channels.get(g.channelName);if(!R){this.collectPendingRequest(g);return}const A=g.id,U=R.listen(this.ctx,g.name,g.arg)(B=>this.sendResponse({id:A,data:B,type:204}));this.activeRequests.set(g.id,U)}disposeActiveRequest(g){const R=this.activeRequests.get(g.id);R&&(R.dispose(),this.activeRequests.delete(g.id))}collectPendingRequest(g){let R=this.pendingRequests.get(g.channelName);R||(R=[],this.pendingRequests.set(g.channelName,R));const A=setTimeout(()=>{console.error(`Unknown channel: ${g.channelName}`),g.type===100&&this.sendResponse({id:g.id,data:{name:"Unknown channel",message:`Channel name '${g.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);R.push({request:g,timeoutTimer:A})}flushPendingRequests(g){const R=this.pendingRequests.get(g);if(R){for(const A of R)switch(clearTimeout(A.timeoutTimer),A.request.type){case 100:this.onPromise(A.request);break;case 102:this.onEventListen(A.request);break}this.pendingRequests.delete(g)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(g=>g.dispose()),this.activeRequests.clear()}}t.ChannelServer=p;var M;(function(S){S[S.LocalSide=0]="LocalSide",S[S.OtherSide=1]="OtherSide"})(M=t.RequestInitiator||(t.RequestInitiator={}));class C{constructor(g,R=null){this.protocol=g,this.isDisposed=!1,this.state=I.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(A=>this.onBuffer(A)),this.logger=R}getChannel(g){const R=this;return{call(A,k,U){return R.isDisposed?Promise.reject(T.canceled()):R.requestPromise(g,A,k,U)},listen(A,k){return R.isDisposed?Promise.reject(T.canceled()):R.requestEvent(g,A,k)}}}requestPromise(g,R,A,k=P.CancellationToken.None){const U=this.lastRequestId++,$={id:U,type:100,channelName:g,name:R,arg:A};if(k.isCancellationRequested)return Promise.reject(T.canceled());let H;return new Promise((te,ne)=>{if(k.isCancellationRequested)return ne(T.canceled());const ae=()=>{const ke=Te=>{switch(Te.type){case 201:this.handlers.delete(U),te(Te.data);break;case 202:this.handlers.delete(U);const we=new Error(Te.data.message);we.stack=Te.data.stack,we.name=Te.data.name,ne(we);break;case 203:this.handlers.delete(U),ne(Te.data);break}};this.handlers.set(U,ke),this.sendRequest($)};let he=null;this.state===I.Idle?ae():(he=(0,E.createCancelablePromise)(ke=>this.whenInitialized()),he.then(()=>{he=null,ae()}));const ve=()=>{he?(he.cancel(),he=null):this.sendRequest({id:U,type:101}),ne(T.canceled())},De=k.onCancellationRequested(ve);H=(0,O.combinedDisposable)((0,O.toDisposable)(ve),De),this.activeRequests.add(H)}).finally(()=>{this.activeRequests.delete(H)})}requestEvent(g,R,A){const k=this.lastRequestId++,B={id:k,type:102,channelName:g,name:R,arg:A};let $=null;const H=new m.Emitter({onFirstListenerAdd:()=>{$=(0,E.createCancelablePromise)(te=>this.whenInitialized()),$.then(()=>{$=null,this.activeRequests.add(H),this.sendRequest(B)})},onLastListenerRemove:()=>{$?($.cancel(),$=null):(this.activeRequests.delete(H),this.sendRequest({id:k,type:103}))}}),J=te=>H.fire(te.data);return this.handlers.set(k,J),H.event}sendRequest(g){switch(g.type){case 100:case 102:{const R=this.send([g.type,g.id,g.channelName,g.name],g.arg);this.logger&&this.logger.logOutgoing(R,g.id,0,`${c(g.type)}: ${g.channelName}.${g.name}`,g.arg);return}case 101:case 103:{const R=this.send([g.type,g.id]);this.logger&&this.logger.logOutgoing(R,g.id,0,c(g.type));return}}}send(g,R=void 0){const A=new l;return a(A,g),a(A,R),this.sendBuffer(A.buffer)}sendBuffer(g){try{return this.protocol.send(g),g.byteLength}catch(R){return 0}}onBuffer(g){const R=new b(g),A=h(R),k=h(R),U=A[0];switch(U){case 200:return this.logger&&this.logger.logIncoming(g.byteLength,0,0,D(U)),this.onResponse({type:A[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(g.byteLength,A[1],0,D(U),k),this.onResponse({type:A[0],id:A[1],data:k})}}onResponse(g){if(g.type===200){this.state=I.Idle,this._onDidInitialize.fire();return}const R=this.handlers.get(g.id);R&&R(g)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===I.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(g=>g.dispose()),this.activeRequests.clear()}}ce([w.memoize],C.prototype,"onDidInitializePromise",null),t.ChannelClient=C;class N{constructor(g){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,g(({protocol:R,onDidClientDisconnect:A})=>{m.Event.once(R.onMessage)(U=>{const B=new b(U),$=h(B),H=new p(R,$),J=new C(R);this.channels.forEach((ne,ae)=>H.registerChannel(ae,ne));const te={channelServer:H,channelClient:J,ctx:$};this._connections.add(te),this._onDidAddConnection.fire(te),A(()=>{H.dispose(),J.dispose(),this._connections.delete(te),this._onDidRemoveConnection.fire(te)})})})}get connections(){const g=[];return this._connections.forEach(R=>g.push(R)),g}getChannel(g,R){const A=this;return{call(k,U,B){let $;if((0,d.isFunction)(R)){let J=(0,u.getRandomElement)(A.connections.filter(R));$=J?Promise.resolve(J):m.Event.toPromise(m.Event.filter(A.onDidAddConnection,R))}else $=R.routeCall(A,k,U);const H=$.then(J=>J.channelClient.getChannel(g));return W(H).call(k,U,B)},listen(k,U){if((0,d.isFunction)(R))return A.getMulticastEvent(g,R,k,U);const B=R.routeEvent(A,k,U).then($=>$.channelClient.getChannel(g));return W(B).listen(k,U)}}}getMulticastEvent(g,R,A,k){const U=this;let B=new O.DisposableStore;const $=new m.Emitter({onFirstListenerAdd:()=>{B=new O.DisposableStore;const H=new m.EventMultiplexer,J=new Map,te=ae=>{const ve=ae.channelClient.getChannel(g).listen(A,k),De=H.add(ve);J.set(ae,De)},ne=ae=>{const he=J.get(ae);!he||(he.dispose(),J.delete(ae))};U.connections.filter(R).forEach(te),m.Event.filter(U.onDidAddConnection,R)(te,void 0,B),U.onDidRemoveConnection(ne,void 0,B),H.event($.fire,$,B),B.add(H)},onLastListenerRemove:()=>{B.dispose()}});return $.event}registerChannel(g,R){this.channels.set(g,R),this._connections.forEach(A=>{A.channelServer.registerChannel(g,R)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=N;class V{constructor(g,R,A=null){const k=new l;a(k,R),g.send(k.buffer),this.channelClient=new C(g,A),this.channelServer=new p(g,R,A)}getChannel(g){return this.channelClient.getChannel(g)}registerChannel(g,R){this.channelServer.registerChannel(g,R)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=V;function W(S){return{call(g,R,A){return S.then(k=>k.call(g,R,A))},listen(g,R){const A=new m.Relay;return S.then(k=>A.input=k.listen(g,R)),A.event}}}t.getDelayedChannel=W;function Q(S){let g=!1;return{call(R,A,k){return g?S.call(R,A,k):(0,E.timeout)(0).then(()=>g=!0).then(()=>S.call(R,A,k))},listen(R,A){if(g)return S.listen(R,A);const k=new m.Relay;return(0,E.timeout)(0).then(()=>g=!0).then(()=>k.input=S.listen(R,A)),k.event}}}t.getNextTickChannel=Q;class ie{constructor(g){this.fn=g}routeCall(g){return this.route(g)}routeEvent(g){return this.route(g)}async route(g){for(const R of g.connections)if(await Promise.resolve(this.fn(R.ctx)))return Promise.resolve(R);return await m.Event.toPromise(g.onDidAddConnection),await this.route(g)}}t.StaticRouter=ie;var re;(function(S){function g(k,U){const B=k,$=U&&U.disableMarshalling,H=new Map;for(const J in B)A(J)&&H.set(J,m.Event.buffer(B[J],!0));return new class{listen(J,te){const ne=H.get(te);if(ne)return ne;throw new Error(`Event not found: ${te}`)}call(J,te,ne){const ae=B[te];if(typeof ae=="function"){if(!$&&Array.isArray(ne))for(let he=0;he<ne.length;he++)ne[he]=(0,y.revive)(ne[he]);return ae.apply(B,ne)}throw new Error(`Method not found: ${te}`)}}}S.fromService=g;function R(k,U){const B=U&&U.disableMarshalling;return new Proxy({},{get($,H){if(typeof H=="string")return U?.properties?.has(H)?U.properties.get(H):A(H)?k.listen(H):async function(...J){let te;U&&!(0,d.isUndefinedOrNull)(U.context)?te=[U.context,...J]:te=J;const ne=await k.call(H,te);return B?ne:(0,y.revive)(ne)};throw new Error(`Property not found: ${String(H)}`)}})}S.toService=R;function A(k){return k[0]==="o"&&k[1]==="n"&&v.isUpperAsciiLetter(k.charCodeAt(2))}})(re=t.ProxyChannel||(t.ProxyChannel={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function X(S){if(Array.isArray(S))return S;if(S&&typeof S=="object"&&typeof S.toString=="function"){let g=S.toString();if(g!=="[object Object]")return g}return S}function j(S){return Array.isArray(S)?S.map(X):X(S)}function x(S,g,R,A,k,U,B){B=j(B);const $=Z[k],H=$[A%$.length];let J=[`%c[${S}]%c[${String(g).padStart(7," ")}]%c[len: ${String(R).padStart(5," ")}]%c${String(A).padStart(5," ")} - ${U}`,"color: darkgreen","color: grey","color: grey",`color: ${H}`];/\($/.test(U)?(J=J.concat(B),J.push(")")):J.push(B),console.log.apply(console,J)}t.logWithColors=x;class q{constructor(g,R){this._outgoingPrefix=g,this._incomingPrefix=R,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(g,R,A,k,U){this._totalOutgoing+=g,x(this._outgoingPrefix,this._totalOutgoing,g,R,A,k,U)}logIncoming(g,R,A,k,U){this._totalIncoming+=g,x(this._incomingPrefix,this._totalIncoming,g,R,A,k,U)}}t.IPCLogger=q}),define(Y[66],ee([0,1,2,13,4,12]),function(_,t,m,O,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageHint=void 0;var T;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=t.StorageHint||(t.StorageHint={}));var L;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(L||(L={}));class u extends m.Disposable{constructor(v,w=Object.create(null)){super();this.database=v,this.options=w,this._onDidChangeStorage=this._register(new O.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=L.None,this.cache=new Map,this.flushDelayer=new E.ThrottledDelayer(u.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(v=>this.onDidChangeItemsExternal(v)))}onDidChangeItemsExternal(v){v.changed?.forEach((w,F)=>this.accept(F,w)),v.deleted?.forEach(w=>this.accept(w,void 0))}accept(v,w){if(this.state===L.Closed)return;let F=!1;(0,P.isUndefinedOrNull)(w)?F=this.cache.delete(v):this.cache.get(v)!==w&&(this.cache.set(v,w),F=!0),F&&this._onDidChangeStorage.fire(v)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===L.None&&(this.state=L.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(v,w){const F=this.cache.get(v);return(0,P.isUndefinedOrNull)(F)?w:F}getBoolean(v,w){const F=this.get(v);return(0,P.isUndefinedOrNull)(F)?w:F==="true"}getNumber(v,w){const F=this.get(v);return(0,P.isUndefinedOrNull)(F)?w:parseInt(F,10)}async set(v,w){if(this.state===L.Closed)return;if((0,P.isUndefinedOrNull)(w))return this.delete(v);const F=String(w);if(this.cache.get(v)!==F)return this.cache.set(v,F),this.pendingInserts.set(v,F),this.pendingDeletes.delete(v),this._onDidChangeStorage.fire(v),this.flushDelayer.trigger(()=>this.flushPending())}async delete(v){if(!(this.state===L.Closed||!this.cache.delete(v)))return this.pendingDeletes.has(v)||this.pendingDeletes.add(v),this.pendingInserts.delete(v),this._onDidChangeStorage.fire(v),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=L.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(v){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const v={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(v).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(v=>this.whenFlushedCallbacks.push(v))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=u,u.DEFAULT_FLUSH_DELAY=100;class d{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(v){v.insert&&v.insert.forEach((w,F)=>this.items.set(F,w)),v.delete&&v.delete.forEach(w=>this.items.delete(w))}async close(){}}t.InMemoryStorageDatabase=d}),define(Y[67],ee([5,6]),function(_,t){return _.create("vs/base/common/date",t)}),define(Y[68],ee([0,1,67]),function(_,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const O=60,E=O*60,P=E*24,T=P*7,L=P*30,u=P*365;function d(v,w){typeof v!="number"&&(v=v.getTime());const F=Math.round((new Date().getTime()-v)/1e3);if(F<-30)return(0,m.localize)(0,null,d(new Date().getTime()+F*1e3,!1));if(F<30)return(0,m.localize)(1,null);let c;return F<O?(c=F,w?c===1?(0,m.localize)(2,null,c):(0,m.localize)(3,null,c):c===1?(0,m.localize)(4,null,c):(0,m.localize)(5,null,c)):F<E?(c=Math.floor(F/O),w?c===1?(0,m.localize)(6,null,c):(0,m.localize)(7,null,c):c===1?(0,m.localize)(8,null,c):(0,m.localize)(9,null,c)):F<P?(c=Math.floor(F/E),w?c===1?(0,m.localize)(10,null,c):(0,m.localize)(11,null,c):c===1?(0,m.localize)(12,null,c):(0,m.localize)(13,null,c)):F<T?(c=Math.floor(F/P),w?c===1?(0,m.localize)(14,null,c):(0,m.localize)(15,null,c):c===1?(0,m.localize)(16,null,c):(0,m.localize)(17,null,c)):F<L?(c=Math.floor(F/T),w?c===1?(0,m.localize)(18,null,c):(0,m.localize)(19,null,c):c===1?(0,m.localize)(20,null,c):(0,m.localize)(21,null,c)):F<u?(c=Math.floor(F/L),w?c===1?(0,m.localize)(22,null,c):(0,m.localize)(23,null,c):c===1?(0,m.localize)(24,null,c):(0,m.localize)(25,null,c)):(c=Math.floor(F/u),w?c===1?(0,m.localize)(26,null,c):(0,m.localize)(27,null,c):c===1?(0,m.localize)(28,null,c):(0,m.localize)(29,null,c))}t.fromNow=d;function y(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=y}),define(Y[69],ee([5,6]),function(_,t){return _.create("vs/base/common/errorMessage",t)}),define(Y[28],ee([0,1,69,12,24]),function(_,t,m,O,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function P(d,y){return y&&(d.stack||d.stacktrace)?m.localize(0,null,L(d),T(d.stack)||T(d.stacktrace)):L(d)}function T(d){return Array.isArray(d)?d.join(`
`):d}function L(d){return typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?m.localize(1,null,d.message):d.message||m.localize(2,null)}function u(d=null,y=!1){if(!d)return m.localize(3,null);if(Array.isArray(d)){const v=E.coalesce(d),w=u(v[0],y);return v.length>1?m.localize(4,null,w,v.length):w}if(O.isString(d))return d;if(d.detail){const v=d.detail;if(v.error)return P(v.error,y);if(v.exception)return P(v.exception,y)}return d.stack?P(d,y):d.message?d.message:m.localize(5,null)}t.toErrorMessage=u}),define(Y[70],ee([5,6]),function(_,t){return _.create("vs/base/node/processes",t)}),define(Y[47],ee([0,1,3,10,32,70,33,12,19,37,15,46,9]),function(_,t,m,O,E,P,T,L,u,d,y,v,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function F(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(r,s){if(y.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};s&&(e.cwd=s);const i=E.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],e);return new Promise(n=>{i.once("error",o=>{n({success:!1,error:o})}),i.once("exit",(o,a)=>{n(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?F(e.status):1})}else if(y.isLinux||y.isMacintosh)try{const e=w.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",_).fsPath;return new Promise(i=>{E.execFile(e,[r.pid.toString()],{encoding:"utf8",shell:!0},(n,o,a)=>{i(n?{success:!1,error:n}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function f(r=T.env){return r.comspec||"cmd.exe"}t.getWindowsShell=f;class D{constructor(s,e,i,n){if(e!==void 0&&i!==void 0&&n!==void 0)this.cmd=s,this.args=e,this.shell=i,this.options=n;else{const o=s;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(T.env).forEach(a=>{o[a]=T.env[a]}),Object.keys(this.options.env).forEach(a=>{o[a]=this.options.env[a]}),this.options.env=o}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const e=s.lastIndexOf(m.sep);return e!==-1&&(s=s.substring(e+1)),D.WellKnowCommands[s]?s:"other"}start(s){return y.isWindows&&(this.options&&this.options.cwd&&d.isUNC(this.options.cwd)||!this.options&&d.isUNC(T.cwd()))?Promise.reject(new Error(P.localize(0,null))):this.useExec().then(e=>{let i,n;const o=new Promise((a,h)=>{i=a,n=h});if(e){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=E.exec(a,this.options,(h,p,M)=>{this.childProcess=null;const C=h;C&&C.killed?n({killed:this.terminateRequested,stdout:p.toString(),stderr:M.toString()}):this.handleExec(i,s,h,p,M)})}else{let a=null;const h=p=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(p,i,s,n);const M={terminated:this.terminateRequested};L.isNumber(p)&&(M.cmdCode=p),i(M)};if(this.shell&&y.isWindows){const p=u.deepClone(this.options);p.windowsVerbatimArguments=!0,p.detached=!1;let M=!1,C=!1;const N=[];let V=this.ensureQuotes(this.cmd);N.push(V.value),M=V.quoted,this.args&&this.args.forEach(Q=>{V=this.ensureQuotes(Q),N.push(V.value),C=C&&V.quoted});const W=["/s","/c"];M?C?W.push('"'+N.join(" ")+'"'):N.length>1?W.push('"'+N[0]+'" '+N.slice(1).join(" ")):W.push('"'+N[0]+'"'):W.push(N.join(" ")),a=E.spawn(f(),W,p)}else this.cmd&&(a=E.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(L.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",p=>{this.childProcess=null,n({terminated:this.terminateRequested,error:p})}),a.pid&&(this.childProcess.on("close",h),this.handleSpawn(a,i,s,n,!0)))}return o})}handleClose(s,e,i,n){}ensureQuotes(s){return D.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,c(s,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!y.isWindows)return s(!1);const e=E.spawn(f(),["/s","/c"]);e.on("error",i=>s(!0)),e.on("exit",i=>s(!1))})}}t.AbstractProcess=D,D.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},D.regexp=/^[^"].* .*[^"]/;class I extends D{constructor(s,e,i,n){super(s,e,i,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,e,i,n,o){[n,o].forEach((a,h)=>{const p=new v.LineDecoder;p.write(a).forEach(N=>{e({line:N,source:h===0?0:1})});const C=p.end();C&&e({line:C,source:h===0?0:1})}),s({terminated:this.terminateRequested,error:i})}handleSpawn(s,e,i,n,o){const a=new v.LineDecoder,h=new v.LineDecoder;s.stdout.on("data",p=>{a.write(p).forEach(C=>i({line:C,source:0}))}),s.stderr.on("data",p=>{h.write(p).forEach(C=>i({line:C,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=h}handleClose(s,e,i,n){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&i({line:o,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&i({line:a,source:1})}}t.LineProcess=I;function b(r){let s=[],e=!1;const i=function(n){if(e){s.push(n);return}(!r.send(n,a=>{if(a&&console.error(a),e=!1,s.length>0){const h=s.slice(0);s=[],h.forEach(p=>i(p))}})||y.isWindows)&&(e=!0)};return{send:i}}t.createQueuedSender=b;var l;(function(r){async function s(e,i,n){if(m.isAbsolute(e))return e;if(i===void 0&&(i=T.cwd()),m.dirname(e)!=="."||(n===void 0&&L.isString(T.env.PATH)&&(n=T.env.PATH.split(m.delimiter)),n===void 0||n.length===0))return m.join(i,e);async function a(h){return await O.Promises.exists(h)?!(await O.Promises.stat(h)).isDirectory():!1}for(let h of n){let p;if(m.isAbsolute(h)?p=m.join(h,e):p=m.join(i,h,e),await a(p))return p;let M=p+".com";if(await a(M)||(M=p+".exe",await a(M)))return M}return m.join(i,e)}r.findExecutable=s})(l=t.win32||(t.win32={}))}),define(Y[71],ee([0,1,31,15,64,47]),function(_,t,m,O,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function T(F,c){return F===1?O.isWindows?v():P.getWindowsShell(c):d(F,c)}t.getSystemShell=T;function L(F,c){return F===1?O.isWindows?w(c):P.getWindowsShell(c):d(F,c)}t.getSystemShellSync=L;let u=null;function d(F,c){if(O.isLinux&&F===2||O.isMacintosh&&F===3)return"/bin/bash";if(!u){let f;if(O.isWindows)f="/bin/bash";else{if(f=c.SHELL,!f)try{f=(0,m.userInfo)().shell}catch(D){}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}u=f}return u}let y=null;async function v(){return y||(y=(await(0,E.getFirstAvailablePowerShellInstallation)()).exePath),y}function w(F){if(y)return y;const c=O.isWindows&&parseFloat((0,m.release)())>=10,f=F.hasOwnProperty("PROCESSOR_ARCHITEW6432"),D=`${F.windir}\\${f?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return c?D:P.getWindowsShell(F)}}),define(Y[48],ee([0,1,32,2,4,19,13,47,39,59,26,8,16,15]),function(_,t,m,O,E,P,T,L,u,d,y,v,w,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class c extends u.ChannelServer{constructor(I){super({send:b=>{try{process.send&&process.send(b.buffer.toString("base64"))}catch(l){}},onMessage:T.Event.fromNodeEventEmitter(process,"message",b=>w.VSBuffer.wrap(Buffer.from(b,"base64")))},I);process.once("disconnect",()=>this.dispose())}}t.Server=c;class f{constructor(I,b){this.modulePath=I,this.options=b,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new T.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const l=b&&b.timeout?b.timeout:6e4;this.disposeDelayer=new E.Delayer(l),this.child=null,this._client=null}getChannel(I){const b=this;return{call(l,r,s){return b.requestPromise(I,l,r,s)},listen(l,r){return b.requestEvent(I,l,r)}}}requestPromise(I,b,l,r=y.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(v.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(I),e=(0,E.createCancelablePromise)(o=>s.call(b,l,o)),i=r.onCancellationRequested(()=>e.cancel()),n=(0,O.toDisposable)(()=>e.cancel());return this.activeRequests.add(n),e.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(I,b,l){if(!this.disposeDelayer)return T.Event.None;this.disposeDelayer.cancel();let r;const s=new T.Emitter({onFirstListenerAdd:()=>{r=this.getCachedChannel(I).listen(b,l)(s.fire,s),this.activeRequests.add(r)},onLastListenerRemove:()=>{this.activeRequests.delete(r),r.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const I=this.options&&this.options.args?this.options.args:[],b=Object.create(null);b.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(b.env={...b.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(b.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(b.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(b.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),b.execArgv===void 0&&(b.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),F.isMacintosh&&b.env&&delete b.env.DYLD_LIBRARY_PATH,this.child=(0,m.fork)(this.modulePath,I,b);const l=new T.Emitter;T.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,d.isRemoteConsoleLog)(a)){(0,d.log)(a,`IPC Library: ${this.options.serverName}`);return}l.fire(w.VSBuffer.wrap(Buffer.from(a,"base64")))});const s=this.options.useQueue?(0,L.createQueuedSender)(this.child):this.child,e=a=>this.child&&this.child.connected&&s.send(a.buffer.toString("base64")),i=l.event,n={send:e,onMessage:i};this._client=new u.ChannelClient(n);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,h)=>{process.removeListener("exit",o),this.activeRequests.forEach(p=>(0,O.dispose)(p)),this.activeRequests.clear(),a!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+h),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:h})})}return this._client}getCachedChannel(I){let b=this.channels.get(I);return b||(b=this.client.getChannel(I),this.channels.set(I,b)),b}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=f}),define(Y[72],ee([5,6]),function(_,t){return _.create("vs/base/node/zip",t)}),define(Y[73],ee([5,6]),function(_,t){return _.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Y[74],ee([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(Y[75],ee([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Y[76],ee([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Y[77],ee([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Y[78],ee([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Y[79],ee([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Y[80],ee([5,6]),function(_,t){return _.create("vs/platform/extensions/common/extensionValidator",t)}),define(Y[81],ee([5,6]),function(_,t){return _.create("vs/platform/files/common/fileService",t)}),define(Y[82],ee([5,6]),function(_,t){return _.create("vs/platform/files/common/io",t)}),define(Y[83],ee([5,6]),function(_,t){return _.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Y[84],ee([5,6]),function(_,t){return _.create("vs/platform/request/common/request",t)}),define(Y[85],ee([5,6]),function(_,t){return _.create("vs/platform/telemetry/common/telemetryService",t)}),define(Y[86],ee([0,1,3,20,44,68,9,7,33]),function(_,t,m,O,E,P,T,L,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class d{constructor(c,f,D){this._args=c,this.paths=f,this.productService=D}get appRoot(){return(0,m.dirname)(T.FileAccess.asFileUri("",_).fsPath)}get userHome(){return L.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return L.URI.file((0,m.join)(this.userDataPath,"User"))}get tmpDir(){return L.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,O.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,O.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const c=(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,m.join)(this.userDataPath,"logs",c)}return this.args.logsPath}get userDataSyncLogResource(){return L.URI.file((0,m.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,O.joinPath)(L.URI.file((0,m.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return L.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return L.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,O.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,O.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=u.env.VSCODE_PORTABLE;return c?L.URI.file((0,m.join)(c,"argv.json")):(0,O.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,O.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return L.URI.file((0,m.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,m.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?(0,m.resolve)(c):(0,m.normalize)((0,m.join)(T.FileAccess.asFileUri("",_).fsPath,"..","extensions"))}get extensionsDownloadPath(){const c=this.args["extensions-download-dir"];return c?(0,m.resolve)(c):(0,m.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return(0,m.resolve)(c);const f=u.env.VSCODE_EXTENSIONS;if(f)return f;const D=u.env.VSCODE_PORTABLE;return D?(0,m.join)(D,"extensions"):(0,O.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map(f=>/^[^:/?#]+?:\/\//.test(f)?L.URI.parse(f):L.URI.file((0,m.normalize)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(c=>c==="ui"||c==="workspace"||c==="web"?c:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?L.URI.parse(c):L.URI.file((0,m.normalize)(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!u.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,O.joinPath)(L.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return L.URI.file((0,m.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ce([E.memoize],d.prototype,"appRoot",null),ce([E.memoize],d.prototype,"userHome",null),ce([E.memoize],d.prototype,"userDataPath",null),ce([E.memoize],d.prototype,"appSettingsHome",null),ce([E.memoize],d.prototype,"tmpDir",null),ce([E.memoize],d.prototype,"userRoamingDataHome",null),ce([E.memoize],d.prototype,"settingsResource",null),ce([E.memoize],d.prototype,"userDataSyncHome",null),ce([E.memoize],d.prototype,"userDataSyncLogResource",null),ce([E.memoize],d.prototype,"sync",null),ce([E.memoize],d.prototype,"machineSettingsResource",null),ce([E.memoize],d.prototype,"globalStorageHome",null),ce([E.memoize],d.prototype,"workspaceStorageHome",null),ce([E.memoize],d.prototype,"keybindingsResource",null),ce([E.memoize],d.prototype,"keyboardLayoutResource",null),ce([E.memoize],d.prototype,"argvResource",null),ce([E.memoize],d.prototype,"snippetsHome",null),ce([E.memoize],d.prototype,"isExtensionDevelopment",null),ce([E.memoize],d.prototype,"untitledWorkspacesHome",null),ce([E.memoize],d.prototype,"installSourcePath",null),ce([E.memoize],d.prototype,"builtinExtensionsPath",null),ce([E.memoize],d.prototype,"extensionsPath",null),ce([E.memoize],d.prototype,"extensionDevelopmentLocationURI",null),ce([E.memoize],d.prototype,"extensionDevelopmentKind",null),ce([E.memoize],d.prototype,"extensionTestsLocationURI",null),ce([E.memoize],d.prototype,"debugExtensionHost",null),ce([E.memoize],d.prototype,"serviceMachineIdResource",null),ce([E.memoize],d.prototype,"telemetryLogResource",null),ce([E.memoize],d.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=d;function y(F,c){return w(F["inspect-extensions"],F["inspect-brk-extensions"],5870,c,F.debugId)}t.parseExtensionHostPort=y;function v(F,c){return w(F["inspect-search"],F["inspect-brk-search"],5876,c)}t.parseSearchPort=v;function w(F,c,f,D,I){const l=Number(c||F)||(D?null:f),r=l?Boolean(!!c):!1;return{port:l,break:r,debugId:I}}}),function(){"use strict";function _(t,m,O,E){function P(L){const u=T(L),d=[u];return t.isAbsolute(u)||d.unshift(E),t.resolve(...d)}function T(L){const u=process.env.VSCODE_PORTABLE;if(u)return t.join(u,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return t.join(d,O);const y=L["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=t.join(v,"AppData","Roaming")}break;case"darwin":d=t.join(m.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||t.join(m.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(d,O)}return{getUserDataPath:P}}if(typeof define=="function")define(Y[87],ee([0,88,31,9,20,33]),function(t,m,O,E,P,T){const L=P.dirname(E.FileAccess.asFileUri("",t)),u=t.__$__nodeRequire(P.joinPath(L,"package.json").fsPath);return _(m,O,u.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),m=require("path"),O=require("os");module.exports=_(m,O,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Y[89],ee([0,1,31,87,86]),function(_,t,m,O,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class P extends E.AbstractNativeEnvironmentService{constructor(L,u){super(L,{homeDir:(0,m.homedir)(),tmpDir:(0,m.tmpdir)(),userDataDir:(0,O.getUserDataPath)(L)},u)}}t.NativeEnvironmentService=P}),define(Y[90],ee([0,1,19]),function(_,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const O=/^%([\w\d.-]+)%$/i;function E(P,T){const L=u=>{if(typeof u!="string")return;const d=O.exec(u);if(!d)return;const y=T[d[1]]??u;return typeof y=="string"?y:typeof y.message=="string"?y.message:u};return(0,m.cloneAndChange)(P,L)}t.localizeManifest=E}),define(Y[49],ee([0,1,80]),function(_,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function P(w){return w=w.trim(),w==="*"||O.test(w)}t.isValidVersionStr=P;function T(w){if(!P(w))return null;if(w=w.trim(),w==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let F=w.match(O);return F?{hasCaret:F[1]==="^",hasGreaterEquals:F[1]===">=",majorBase:F[2]==="x"?0:parseInt(F[2],10),majorMustEqual:F[2]!=="x",minorBase:F[4]==="x"?0:parseInt(F[4],10),minorMustEqual:F[4]!=="x",patchBase:F[6]==="x"?0:parseInt(F[6],10),patchMustEqual:F[6]!=="x",preRelease:F[8]||null}:null}t.parseVersion=T;function L(w){if(!w)return null;let F=w.majorBase,c=w.majorMustEqual,f=w.minorBase,D=w.minorMustEqual,I=w.patchBase,b=w.patchMustEqual;w.hasCaret&&(F===0||(D=!1),b=!1);let l=0;if(w.preRelease){const r=E.exec(w.preRelease);if(r){const[,s,e,i]=r;l=Date.UTC(Number(s),Number(e)-1,Number(i))}}return{majorBase:F,majorMustEqual:c,minorBase:f,minorMustEqual:D,patchBase:I,patchMustEqual:b,isMinimum:w.hasGreaterEquals,notBefore:l}}t.normalizeVersion=L;function u(w,F,c){let f;typeof w=="string"?f=L(T(w)):f=w;let D;F instanceof Date?D=F.getTime():typeof F=="string"&&(D=new Date(F).getTime());let I;if(typeof c=="string"?I=L(T(c)):I=c,!f||!I)return!1;let b=f.majorBase,l=f.minorBase,r=f.patchBase,s=I.majorBase,e=I.minorBase,i=I.patchBase,n=I.notBefore,o=I.majorMustEqual,a=I.minorMustEqual,h=I.patchMustEqual;return I.isMinimum?b>s?!0:b<s?!1:l>e?!0:l<e||D&&D<n?!1:r>=i:(b===1&&s===0&&(!o||!a||!h)&&(s=1,e=0,i=0,o=!0,a=!1,h=!1),b<s?!1:b>s?!o:l<e?!1:l>e?!a:r<i?!1:r>i?!h:!(D&&D<n))}t.isValidVersion=u;function d(w,F,c,f){return c.isBuiltin||typeof c.main=="undefined"?!0:v(w,F,c.engines.vscode,f)}t.isValidExtensionVersion=d;function y(w,F,c){return w==="*"||v(F,c,w)}t.isEngineValid=y;function v(w,F,c,f=[]){let D=L(T(c));if(!D)return f.push(m.localize(0,null,c)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return f.push(m.localize(1,null,c)),!1}else if(!D.majorMustEqual)return f.push(m.localize(2,null,c)),!1;return u(w,F,D)?!0:(f.push(m.localize(3,null,w,c)),!1)}}),define(Y[91],ee([0,1,39,48,2,9]),function(_,t,m,O,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class T extends E.Disposable{constructor(u,d,y,v){super();this.folders=u,this.onDidFilesChange=d,this.onLogMessage=y,this.verboseLogging=v,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const u=this._register(new O.Client(P.FileAccess.asFileUri("bootstrap-fork",_).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(u.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=T.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService((0,m.getNextTickChannel)(u.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d))),this.setFolders(this.folders)}setVerboseLogging(u){this.verboseLogging=u,!this.isDisposed&&this.service&&this.service.setVerboseLogging(u)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${u}`})}setFolders(u){this.folders=u,this.service&&this.service.setRoots(u)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=T,T.MAX_RESTARTS=5}),define(Y[92],ee([0,1,39,48,2,9]),function(_,t,m,O,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class T extends E.Disposable{constructor(u,d,y,v,w={}){super();this.folders=u,this.onDidFilesChange=d,this.onLogMessage=y,this.verboseLogging=v,this.watcherOptions=w,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const u=this._register(new O.Client(P.FileAccess.asFileUri("bootstrap-fork",_).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(u.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=T.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService((0,m.getNextTickChannel)(u.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d))),this.service.setRoots(this.folders)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${u}`})}setVerboseLogging(u){this.verboseLogging=u,this.service&&this.service.setVerboseLogging(u)}setFolders(u){this.folders=u,this.service&&this.service.setRoots(u)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=T,T.MAX_RESTARTS=5}),define(Y[93],ee([0,1,32,46,61,9]),function(_,t,m,O,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class T{constructor(u,d,y,v,w){this.watchedFolder=u,this.eventCallback=y,this.logCallback=v,this.verboseLogging=w,this.restartCounter=0,Array.isArray(d)?this.ignored=d.map(F=>(0,E.parse)(F)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${u}, excludes: ${d.join(",")}`),this.startWatcher()}startWatcher(){const u=[this.watchedFolder];this.verboseLogging&&u.push("-verbose"),this.handle=(0,m.spawn)(P.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",_).fsPath,u);const d=new O.LineDecoder;this.handle.stdout.on("data",y=>{const v=[];for(const w of d.write(y)){const F=w.split("|");if(F.length===2){const c=Number(F[0]),f=F[1];if(c>=0&&c<3){if(this.ignored&&this.ignored.some(D=>D(f))){this.verboseLogging&&this.log(f);continue}v.push({type:T.changeTypeMap[c],path:f})}else this.log(F[1])}}v.length>0&&this.eventCallback(v)}),this.handle.on("error",y=>this.onError(y)),this.handle.stderr.on("data",y=>this.onError(y)),this.handle.on("exit",(y,v)=>this.onExit(y,v))}onError(u){this.error("process error: "+u.toString())}onExit(u,d){this.handle&&(this.error(`terminated unexpectedly (code: ${u}, signal: ${d})`),this.restartCounter<=T.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(u){this.logCallback({type:"error",message:`[File Watcher (C#)] ${u}`})}log(u){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${u}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=T,T.MAX_RESTARTS=5,T.changeTypeMap=[0,1,2]}),define(Y[94],ee([0,1,93,3,18]),function(_,t,m,O,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class P{constructor(L,u,d,y){this.onDidFilesChange=u,this.onLogMessage=d,this.verboseLogging=y,this.service=void 0,this.folder=L[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(O.posix.sep)&&(this.folder.path=(0,E.rtrim)(this.folder.path,O.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new m.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,L=>this.onFileEvents(L),L=>this.onLogMessage(L),this.verboseLogging)}setVerboseLogging(L){this.verboseLogging=L,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(L){this.isDisposed||L.length>0&&this.onDidFilesChange(L)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=P}),define(Y[50],ee([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class m{constructor(E,P=[],T=!1){this.ctor=E,this.staticArguments=P,this.supportsDelayedInstantiation=T}}t.SyncDescriptor=m}),define(Y[95],ee([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class m{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}t.Node=m;class O{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(let T of this._nodes.values())T.outgoing.size===0&&P.push(T);return P}insertEdge(P,T){const L=this.lookupOrInsertNode(P),u=this.lookupOrInsertNode(T);L.outgoing.set(this._hashFn(T),u),u.incoming.set(this._hashFn(P),L)}removeNode(P){const T=this._hashFn(P);this._nodes.delete(T);for(let L of this._nodes.values())L.outgoing.delete(T),L.incoming.delete(T)}lookupOrInsertNode(P){const T=this._hashFn(P);let L=this._nodes.get(T);return L||(L=new m(P),this._nodes.set(T,L)),L}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){let P=[];for(let[T,L]of this._nodes)P.push(`${T}, (incoming)[${[...L.incoming.keys()].join(", ")}], (outgoing)[${[...L.outgoing.keys()].join(",")}]`);return P.join(`
`)}findCycleSlow(){for(let[P,T]of this._nodes){const L=new Set([P]),u=this._findCycle(T,L);if(u)return u}}_findCycle(P,T){for(let[L,u]of P.outgoing){if(T.has(L))return[...T,L].join(" -> ");T.add(L);const d=this._findCycle(u,T);if(d)return d;T.delete(L)}}}t.Graph=O}),define(Y[96],ee([0,1,11]),function(_,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,m.createDecorator)("downloadService")}),define(Y[21],ee([0,1,11]),function(_,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,m.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,m.refineServiceDecorator)(t.IEnvironmentService)}),define(Y[22],ee([0,1,75,11,9]),function(_,t,m,O,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";function P(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}t.isIExtensionIdentifier=P;var T;(function(v){v[v.NoneOrRelevance=0]="NoneOrRelevance",v[v.LastUpdatedDate=1]="LastUpdatedDate",v[v.Title=2]="Title",v[v.PublisherName=3]="PublisherName",v[v.InstallCount=4]="InstallCount",v[v.PublishedDate=5]="PublishedDate",v[v.AverageRating=6]="AverageRating",v[v.WeightedRating=12]="WeightedRating"})(T=t.SortBy||(t.SortBy={}));var L;(function(v){v[v.Default=0]="Default",v[v.Ascending=1]="Ascending",v[v.Descending=2]="Descending"})(L=t.SortOrder||(t.SortOrder={}));var u;(function(v){v.Uninstall="uninstall"})(u=t.StatisticType||(t.StatisticType={}));var d;(function(v){v[v.None=0]="None",v[v.Install=1]="Install",v[v.Update=2]="Update"})(d=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class y extends Error{constructor(w,F){super(w);this.code=F,this.name=F}}t.ExtensionManagementError=y,t.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=E.FileAccess.asBrowserUri("./media/defaultIcon.png",_).toString(!0),t.ExtensionsLabel=(0,m.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,m.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,O.createDecorator)("IExtensionManagementCLIService")}),define(Y[40],ee([0,1,18,11]),function(_,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin";function E(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}t.getWorkspaceSupportTypeMessage=E;function P(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}t.isIExtensionIdentifier=P,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(T=t.ExtensionType||(t.ExtensionType={}));class L{constructor(v){this.value=v,this._lower=v.toLowerCase()}static equals(v,w){if(typeof v=="undefined"||v===null)return typeof w=="undefined"||w===null;if(typeof w=="undefined"||w===null)return!1;if(typeof v=="string"||typeof w=="string"){let F=typeof v=="string"?v:v.value,c=typeof w=="string"?w:w.value;return m.equalsIgnoreCase(F,c)}return v._lower===w._lower}static toKey(v){return typeof v=="string"?v.toLowerCase():v._lower}}t.ExtensionIdentifier=L;function u(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}t.isLanguagePackExtension=u;function d(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=d,t.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(Y[23],ee([0,1,18,40]),function(_,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function E(c,f){return c.uuid&&f.uuid?c.uuid===f.uuid:c.id===f.id?!0:(0,m.compareIgnoreCase)(c.id,f.id)===0}t.areSameExtensions=E;class P{constructor(f,D){this.version=D,this.id=f.id,this.uuid=f.uuid}key(){return`${this.id}-${this.version}`}equals(f){return f instanceof P?E(this,f)&&this.version===f.version:!1}}t.ExtensionIdentifierWithVersion=P;function T(c,f){return`${c}.${f}`}t.getExtensionId=T;function L(c){return c.toLocaleLowerCase()}t.adoptToGalleryExtensionId=L;function u(c,f){return L(T(c,f))}t.getGalleryExtensionId=u;function d(c,f){const D=[],I=b=>{for(const l of D)if(l.some(r=>E(f(r),f(b))))return l;return null};for(const b of c){const l=I(b);l?l.push(b):D.push([b])}return D}t.groupByExtension=d;function y(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=y;function v(c){return{id:c.identifier.id,name:c.name,galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),...c.telemetryData}}t.getGalleryExtensionTelemetryData=v,t.BetterMergeId=new O.ExtensionIdentifier("pprice.better-merge");function w(c){const f=new Set;for(const D of c)D.malicious&&f.add(D.id.id);return f}t.getMaliciousExtensionsSet=w;function F(c,f){const D=[],I=f.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const b=I.shift();if(b&&D.every(l=>!E(l.identifier,{id:b}))){const l=c.filter(r=>E(r.identifier,{id:b}));l.length===1&&(D.push(l[0]),I.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return D}t.getExtensionDependencies=F});var ue=this&&this.__param||function(_,t){return function(m,O){t(m,O,_)}};define(Y[97],ee([0,1,76,8,7,41,22,23,40,62,26,9]),function(_,t,m,O,E,P,T,L,u,d,y,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const w=b=>(0,m.localize)(0,null,b),F=(0,m.localize)(1,null,"ms-dotnettools.csharp");function c(b,l){return l?`${b.publisher}.${b.name}@${b.version}`:`${b.publisher}.${b.name}`}const f=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function D(b){const l=f.exec(b);return l&&l[1]?[(0,L.adoptToGalleryExtensionId)(l[1]),l[2]]:[(0,L.adoptToGalleryExtensionId)(b),void 0]}t.getIdAndVersion=D;let I=class{constructor(l,r){this.extensionManagementService=l,this.extensionGalleryService=r}get location(){}async listExtensions(l,r,s=console){let e=await this.extensionManagementService.getInstalled(1);const i=u.EXTENSION_CATEGORIES.map(o=>o.toLowerCase());if(r&&r!==""){if(i.indexOf(r.toLowerCase())<0){s.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(o=>o.manifest.categories?o.manifest.categories.map(h=>h.toLowerCase()).indexOf(r.toLowerCase())>-1:!1)}else if(r===""){s.log("Possible Categories: "),i.forEach(o=>{s.log(o)});return}this.location&&s.log((0,m.localize)(2,null,this.location)),e=e.sort((o,a)=>o.identifier.id.localeCompare(a.identifier.id));let n;for(let o of e)n!==o.identifier.id&&(n=o.identifier.id,s.log(c(o.manifest,l)))}async installExtensions(l,r,s,e,i=console){const n=[],o=[];l.length&&i.log(this.location?(0,m.localize)(3,null,this.location):(0,m.localize)(4,null));const a=await this.extensionManagementService.getInstalled(1),h=(C,N)=>{const V=a.find(W=>(0,L.areSameExtensions)(W.identifier,{id:C}));if(V){if(!N&&!e)return i.log((0,m.localize)(5,null,C,V.manifest.version,C)),!1;if(N&&V.manifest.version===N)return i.log((0,m.localize)(6,null,`${C}@${N}`)),!1}return!0},p=[],M=[];for(const C of l)if(C instanceof E.URI)p.push(C);else{const[N,V]=D(C);h(N,V)&&M.push({id:N,version:V,installOptions:{isBuiltin:!1,isMachineScoped:s}})}for(const C of r){const[N,V]=D(C);h(N,V)&&M.push({id:N,version:V,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(p.length&&await Promise.all(p.map(async C=>{try{const N=await this.installVSIX(C,{isBuiltin:!1,isMachineScoped:s},e,i);N&&o.push(N)}catch(N){i.error(N.message||N.stack||N),n.push(C.toString())}})),M.length){const C=await this.getGalleryExtensions(M);await Promise.all(M.map(async N=>{const V=C.get(N.id.toLowerCase());if(V)try{const W=await this.installFromGallery(N,V,a,e,i);W&&o.push(W)}catch(W){i.error(W.message||W.stack||W),n.push(N.id)}else i.error(`${w(N.version?`${N.id}@${N.version}`:N.id)}
${F}`),n.push(N.id)}))}if(n.length)throw new Error((0,m.localize)(7,null,n.join(", ")))}async installVSIX(l,r,s,e){const i=await this.extensionManagementService.getManifest(l);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,s,e))try{return await this.extensionManagementService.install(l,r),e.log((0,m.localize)(8,null,(0,d.getBaseLabel)(l))),i}catch(o){if((0,O.isPromiseCanceledError)(o))return e.log((0,m.localize)(9,null,(0,d.getBaseLabel)(l))),null;throw o}return null}async getGalleryExtensions(l){const r=l.filter(({version:i})=>i===void 0).map(({id:i})=>i),s=l.filter(({version:i})=>i!==void 0),e=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(r,y.CancellationToken.None)).forEach(n=>e.set(n.identifier.id.toLowerCase(),n))})(),Promise.all(s.map(async({id:i,version:n})=>{const o=await this.extensionGalleryService.getCompatibleExtension({id:i},n);o&&e.set(o.identifier.id.toLowerCase(),o)}))]),e}async installFromGallery({id:l,version:r,installOptions:s},e,i,n,o){const a=await this.extensionGalleryService.getManifest(e,y.CancellationToken.None);if(a&&!this.validateExtensionKind(a,o))return null;const h=i.find(p=>(0,L.areSameExtensions)(p.identifier,e.identifier));if(h){if(e.version===h.manifest.version)return o.log((0,m.localize)(10,null,r?`${l}@${r}`:l)),null;o.log((0,m.localize)(11,null,l,e.version))}try{return s.isBuiltin?o.log(r?(0,m.localize)(12,null,l,r):(0,m.localize)(13,null,l)):o.log(r?(0,m.localize)(14,null,l,r):(0,m.localize)(15,null,l)),await this.extensionManagementService.installFromGallery(e,s),o.log((0,m.localize)(16,null,l,e.version)),a}catch(p){if((0,O.isPromiseCanceledError)(p))return o.log((0,m.localize)(17,null,l)),null;throw p}}validateExtensionKind(l,r){return!0}async validateVSIX(l,r,s){const e={id:(0,L.getGalleryExtensionId)(l.publisher,l.name)},n=(await this.extensionManagementService.getInstalled(1)).find(o=>(0,L.areSameExtensions)(e,o.identifier)&&(0,P.gt)(o.manifest.version,l.version));return n&&!r?(s.log((0,m.localize)(18,null,n.identifier.id,n.manifest.version,l.version)),!1):this.validateExtensionKind(l,s)}async uninstallExtensions(l,r,s=console){const e=async n=>{if(n instanceof E.URI){const o=await this.extensionManagementService.getManifest(n);return c(o)}return n},i=[];for(const n of l){const o=await e(n),h=(await this.extensionManagementService.getInstalled()).filter(p=>(0,L.areSameExtensions)(p.identifier,{id:o}));if(!h.length)throw new Error(`${this.notInstalled(o)}
${F}`);if(h.some(p=>p.type===0)){s.log((0,m.localize)(19,null,o));return}if(!r&&h.some(p=>p.isBuiltin)){s.log((0,m.localize)(20,null,o));return}s.log((0,m.localize)(21,null,o));for(const p of h)await this.extensionManagementService.uninstall(p),i.push(p);this.location?s.log((0,m.localize)(22,null,o,this.location)):s.log((0,m.localize)(23,null,o))}}async locateExtension(l,r=console){const s=await this.extensionManagementService.getInstalled();l.forEach(e=>{s.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===v.Schemas.file){r.log(i.location.fsPath);return}})})}notInstalled(l){return this.location?(0,m.localize)(24,null,l,this.location):(0,m.localize)(25,null,l)}};I=ce([ue(0,T.IExtensionManagementService),ue(1,T.IExtensionGalleryService)],I),t.ExtensionManagementCLIService=I}),define(Y[98],ee([0,1,2,3,40,10]),function(_,t,m,O,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class T extends m.Disposable{constructor(u,d){super();this.environmentService=u,this.extensionsManifestCache=(0,O.join)(this.environmentService.userDataPath,E.MANIFEST_CACHE_FOLDER,E.USER_MANIFEST_CACHE_FILE),this._register(d.onDidInstallExtensions(y=>this.onDidInstallExtensions(y))),this._register(d.onDidUninstallExtension(y=>this.onDidUnInstallExtension(y)))}onDidInstallExtensions(u){u.some(d=>!!d.local)&&this.invalidate()}onDidUnInstallExtension(u){u.error||this.invalidate()}invalidate(){P.Promises.rm(this.extensionsManifestCache,P.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=T}),define(Y[99],ee([0,1,88,32,29,15,128,28,71,26,8]),function(_,t,m,O,E,P,T,L,u,d,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function v(c,f,D){return f["force-disable-user-env"]?(c.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):P.isWindows?(c.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,T.isLaunchedFromCli)(D)&&!f["force-user-env"]?(c.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,T.isLaunchedFromCli)(D)?c.trace("resolveShellEnv(): running (--force-user-env)"):c.trace("resolveShellEnv(): running (macOS/Linux)"),w||(w=new Promise(async I=>{const b=new d.CancellationTokenSource,l=setTimeout(()=>{c.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),b.dispose(!0),I({})},1e4);try{const r=await F(c,b.token);I(r)}catch(r){(0,y.isPromiseCanceledError)(r)||c.error(`[resolve shell env] Unable to resolve shell environment (${r}). Proceeding without shell environment...`),I({})}finally{clearTimeout(l),b.dispose()}})),w)}t.resolveShellEnv=v;let w;async function F(c,f){const D=new Promise(async(I,b)=>{const l=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",l);const r=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",r);const s=(0,E.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(s+"(.*)"+s),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};c.trace("getUnixShellEnvironment#env",i);const n=await(0,u.getSystemShell)(P.OS,i);if(c.trace("getUnixShellEnvironment#shell",n),f.isCancellationRequested)return b(y.canceled);const o=m.basename(n);let a,h;/^pwsh(-preview)?$/.test(o)?(a=`& '${process.execPath}' -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,h=["-Login","-Command"]):(a=`'${process.execPath}' -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,h=["-ilc"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),a);const p=(0,O.spawn)(n,[...h,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});f.onCancellationRequested(()=>(p.kill(),b(y.canceled))),p.on("error",N=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(N)),I({})});const M=[];p.stdout.on("data",N=>M.push(N));const C=[];p.stderr.on("data",N=>C.push(N)),p.on("close",(N,V)=>{const W=Buffer.concat(M).toString("utf8");c.trace("getUnixShellEnvironment#raw",W);const Q=Buffer.concat(C).toString("utf8");if(Q.trim()&&c.trace("getUnixShellEnvironment#stderr",Q),N||V)return b(new Error(`Failed to get environment (code ${N}, signal ${V})`));const ie=e.exec(W),re=ie?ie[1]:"{}";try{const Z=JSON.parse(re);l?Z.ELECTRON_RUN_AS_NODE=l:delete Z.ELECTRON_RUN_AS_NODE,r?Z.ELECTRON_NO_ATTACH_CONSOLE=r:delete Z.ELECTRON_NO_ATTACH_CONSOLE,delete Z.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",Z),I(Z)}catch(Z){c.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(Z)),b(Z)}})});try{return await D}catch(I){return c.error("getUnixShellEnvironment#error",(0,L.toErrorMessage)(I)),{}}}}),define(Y[51],ee([0,1,7,17,15]),function(_,t,m,O,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function P(u){return u.map(d=>({type:d.type,resource:m.URI.file(d.path)}))}t.toFileChanges=P;function T(u){const d=new L;for(const y of u)d.processEvent(y);return d.normalize()}t.normalizeFileChanges=T;class L{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(d){const y=this.mapPathToChange.get(d.path);if(y){const v=y.type,w=d.type;v===1&&w===2?(this.mapPathToChange.delete(d.path),this.normalized.splice(this.normalized.indexOf(y),1)):v===2&&w===1?y.type=0:v===1&&w===0||(y.type=w)}else this.normalized.push(d),this.mapPathToChange.set(d.path,d)}normalize(){const d=[],y=[];return this.normalized.filter(v=>v.type!==2?(d.push(v),!1):!0).sort((v,w)=>v.path.length-w.path.length).filter(v=>y.some(w=>(0,O.isParent)(v.path,w,!E.isLinux))?!1:(y.push(v.path),!0)).concat(d)}}}),define(Y[100],ee([0,1,51,2,10,63,65,4,3]),function(_,t,m,O,E,P,T,L,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class d extends O.Disposable{constructor(v,w,F,c){super();this.path=v,this.onDidFilesChange=w,this.onLogMessage=F,this.verboseLogging=c,this.fileChangesDelayer=this._register(new L.ThrottledDelayer(T.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(v){this.verboseLogging=v}async startWatching(){try{const{stat:v,symbolicLink:w}=await E.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let F=this.path;if(w)try{F=await(0,P.realpath)(F)}catch(c){if(this.onError(c),w.dangling)return}v.isDirectory()?this._register((0,T.watchFolder)(F,(c,f)=>{this.onFileChange({type:c==="changed"?0:c==="added"?1:2,path:(0,u.join)(this.path,(0,u.basename)(f))})},c=>this.onError(c))):this._register((0,T.watchFile)(F,c=>{this.onFileChange({type:c==="changed"?0:2,path:this.path})},c=>this.onError(c)))}catch(v){v.code!=="ENOENT"&&this.onError(v)}}onFileChange(v){this.fileChangesBuffer.push(v),this.verboseLogging&&this.onVerbose(`${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`),this.fileChangesDelayer.trigger(async()=>{const w=this.fileChangesBuffer;this.fileChangesBuffer=[];const F=(0,m.normalizeFileChanges)(w);if(this.verboseLogging)for(const c of F)this.onVerbose(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);F.length>0&&this.onDidFilesChange(F)})}onError(v){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${v}`})}onVerbose(v){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${v}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=d}),define(Y[52],ee([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class m{constructor(...E){this._entries=new Map;for(let[P,T]of E)this.set(P,T)}set(E,P){const T=this._entries.get(E);return this._entries.set(E,P),T}has(E){return this._entries.has(E)}get(E){return this._entries.get(E)}}t.ServiceCollection=m}),define(Y[101],ee([0,1,8,95,50,11,52,4]),function(_,t,m,O,E,P,T,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const u=!1;class d extends Error{constructor(c){super("cyclic dependency between services");this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class y{constructor(c=new T.ServiceCollection,f=!1,D){this._activeInstantiations=new Set,this._services=c,this._strict=f,this._parent=D,this._services.set(P.IInstantiationService,this)}createChild(c){return new y(c,this._strict,this)}invokeFunction(c,...f){let D=w.traceInvocation(c),I=!1;try{return c({get:(l,r)=>{if(I)throw(0,m.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(l,D);if(!s&&r!==P.optional)throw new Error(`[invokeFunction] unknown service '${l}'`);return s}},...f)}finally{I=!0,D.stop()}}createInstance(c,...f){let D,I;return c instanceof E.SyncDescriptor?(D=w.traceCreation(c.ctor),I=this._createInstance(c.ctor,c.staticArguments.concat(f),D)):(D=w.traceCreation(c),I=this._createInstance(c,f,D)),D.stop(),I}_createInstance(c,f=[],D){let I=P._util.getServiceDependencies(c).sort((r,s)=>r.index-s.index),b=[];for(const r of I){let s=this._getOrCreateServiceInstance(r.id,D);if(!s&&this._strict&&!r.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${r.id}.`);b.push(s)}let l=I.length>0?I[0].index:f.length;if(f.length!==l){console.warn(`[createInstance] First service dependency of ${c.name} at position ${l+1} conflicts with ${f.length} static arguments`);let r=l-f.length;r>0?f=f.concat(new Array(r)):f=f.slice(0,l)}return new c(...[...f,...b])}_setServiceInstance(c,f){if(this._services.get(c)instanceof E.SyncDescriptor)this._services.set(c,f);else if(this._parent)this._parent._setServiceInstance(c,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let f=this._services.get(c);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):f}_getOrCreateServiceInstance(c,f){let D=this._getServiceInstanceOrDescriptor(c);return D instanceof E.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,D,f.branch(c,!0)):(f.branch(c,!1),D)}_safeCreateAndCacheServiceInstance(c,f,D){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,f,D)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,f,D){const I=new O.Graph(r=>r.id.toString());let b=0;const l=[{id:c,desc:f,_trace:D}];for(;l.length;){const r=l.pop();if(I.lookupOrInsertNode(r),b++>1e3)throw new d(I);for(let s of P._util.getServiceDependencies(r.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(s.id);if(!e&&!s.optional&&console.warn(`[createInstance] ${c} depends on ${s.id} which is NOT registered.`),e instanceof E.SyncDescriptor){const i={id:s.id,desc:e,_trace:r._trace.branch(s.id,!0)};I.insertEdge(r,i),l.push(i)}}}for(;;){const r=I.roots();if(r.length===0){if(!I.isEmpty())throw new d(I);break}for(const{data:s}of r){if(this._getServiceInstanceOrDescriptor(s.id)instanceof E.SyncDescriptor){const i=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,i)}I.removeNode(s)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,f,D=[],I,b){if(this._services.get(c)instanceof E.SyncDescriptor)return this._createServiceInstance(f,D,I,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,f,D,I,b);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(c,f=[],D,I){if(D){const b=new L.IdleValue(()=>this._createInstance(c,f,I));return new Proxy(Object.create(null),{get(l,r){if(r in l)return l[r];let s=b.value,e=s[r];return typeof e!="function"||(e=e.bind(s),l[r]=e),e},set(l,r,s){return b.value[r]=s,!0}})}else return this._createInstance(c,f,I)}}t.InstantiationService=y;var v;(function(F){F[F.Creation=0]="Creation",F[F.Invocation=1]="Invocation",F[F.Branch=2]="Branch"})(v||(v={}));class w{constructor(c,f){this.type=c,this.name=f,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return u?new w(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):w._None}static traceCreation(c){return u?new w(0,c.name):w._None}branch(c,f){let D=new w(2,c.toString());return this._dep.push([c,f,D]),D}stop(){let c=Date.now()-this._start;w._totals+=c;let f=!1;function D(b,l){let r=[],s=new Array(b+1).join("	");for(const[e,i,n]of l._dep)if(i&&n){f=!0,r.push(`${s}CREATES -> ${e}`);let o=D(b+1,n);o&&r.push(o)}else r.push(`${s}uses -> ${e}`);return r.join(`
`)}let I=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${D(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${w._totals.toFixed(2)}ms)`];(c>2||f)&&console.log(I.join(`
`))}}w._None=new class extends w{constructor(){super(-1,null)}stop(){}branch(){return this}},w._totals=0}),define(Y[53],ee([0,1,11]),function(_,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,m.createDecorator)("localizationsService");function O(E){if(typeof E.languageId!="string"||!Array.isArray(E.translations)||E.translations.length===0)return!1;for(const P of E.translations)if(typeof P.id!="string"||typeof P.path!="string")return!1;return!(E.languageName&&typeof E.languageName!="string"||E.localizedLanguageName&&typeof E.localizedLanguageName!="string")}t.isValidLocalization=O}),define(Y[14],ee([0,1,11,2,15,13,28]),function(_,t,m,O,E,P,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,m.createDecorator)("logService"),t.ILoggerService=(0,m.createDecorator)("loggerService");function L(){return new Date().toISOString()}var u;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(u=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=u.Info;class d extends O.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=d;class y extends d{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(u.Trace)&&this.log(u.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(u.Debug)&&this.log(u.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(u.Info)&&this.log(u.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(u.Warning)&&this.log(u.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(u.Error))if(e instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=e.stack,this.log(u.Error,this.format(n))}else this.log(u.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(u.Critical)&&this.log(u.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let n=0;n<e.length;n++){let o=e[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch(a){}i+=(n>0?" ":"")+o}return i}}t.AbstractMessageLogger=y;class v extends d{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!E.isWindows}trace(e,...i){this.getLevel()<=u.Trace&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...i):console.log(`[main ${L()}]`,e,...i))}debug(e,...i){this.getLevel()<=u.Debug&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...i):console.log(`[main ${L()}]`,e,...i))}info(e,...i){this.getLevel()<=u.Info&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...i):console.log(`[main ${L()}]`,e,...i))}warn(e,...i){this.getLevel()<=u.Warning&&(this.useColors?console.warn(`[93m[main ${L()}][0m`,e,...i):console.warn(`[main ${L()}]`,e,...i))}error(e,...i){this.getLevel()<=u.Error&&(this.useColors?console.error(`[91m[main ${L()}][0m`,e,...i):console.error(`[main ${L()}]`,e,...i))}critical(e,...i){this.getLevel()<=u.Critical&&(this.useColors?console.error(`[90m[main ${L()}][0m`,e,...i):console.error(`[main ${L()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=v;class w extends d{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=u.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=u.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=u.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=u.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=u.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=u.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=w;class F extends d{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=u.Trace&&this.adapter.log(u.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=u.Debug&&this.adapter.log(u.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=u.Info&&this.adapter.log(u.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=u.Warning&&this.adapter.log(u.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=u.Error&&this.adapter.log(u.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=u.Critical&&this.adapter.log(u.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:(0,T.toErrorMessage)(e,this.getLevel()<=u.Trace)}dispose(){}flush(){}}t.AdapterLogger=F;class c extends d{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const n of this.logServices)n.trace(e,...i)}debug(e,...i){for(const n of this.logServices)n.debug(e,...i)}info(e,...i){for(const n of this.logServices)n.info(e,...i)}warn(e,...i){for(const n of this.logServices)n.warn(e,...i)}error(e,...i){for(const n of this.logServices)n.error(e,...i)}critical(e,...i){for(const n of this.logServices)n.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=c;class f extends O.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=f;class D extends O.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(n))}))}createLogger(e,i){let n=this.loggers.get(e.toString());return n||(n=this.doCreateLogger(e,i?.always?u.Trace:this.logLevel,i),this.loggers.set(e.toString(),n),i?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=D;class I{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(e){}getLevel(){return u.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=I;function b(s){if(s.verbose)return u.Trace;if(typeof s.logLevel=="string"){const e=l(s.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=b;function l(s){switch(s){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Critical;case"off":return u.Off}}t.parseLogLevel=l;function r(s){switch(s){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Critical:return"critical";case u.Off:return"off"}}t.LogLevelToString=r}),define(Y[102],ee([0,1,10,2,17,22,21,7,20,23,14,29,41,15,4,8]),function(_,t,m,O,E,P,T,L,u,d,y,v,w,F,c,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let I=class extends O.Disposable{constructor(l,r,s,e){super();this.fileService=r,this.extensionGalleryService=s,this.logService=e,this.extensionsDownloadDir=L.URI.file(l.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(l,r){await this.cleanUpPromise;const s=this.getName(l),e=(0,u.joinPath)(this.extensionsDownloadDir,s);if(!await this.fileService.exists(e)){const i=(0,u.joinPath)(this.extensionsDownloadDir,`.${(0,v.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(l,i,r);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(o){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",l.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,f.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return e}async delete(l){}async rename(l,r,s){try{await m.Promises.rename(l.fsPath,r.fsPath)}catch(e){if(F.isWindows&&e&&e.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${l} to ${r} with 'EPERM' error. Trying again...`),this.rename(l,r,s);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const l=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(l.children){const r=[],s=[];for(const n of l.children){const o=this.parse(n.name);o&&s.push([o,n])}const e=(0,d.groupByExtension)(s,([n])=>n),i=[];for(const n of e)n.sort((o,a)=>w.rcompare(o[0].version,a[0].version)),r.push(...n.slice(1).map(o=>o[1].resource)),i.push(n[0][1]);i.sort((n,o)=>n.mtime-o.mtime),r.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await c.Promises.settled(r.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(l){this.logService.error(l)}}getName(l){return this.cache?new d.ExtensionIdentifierWithVersion(l.identifier,l.version).key().toLowerCase():(0,v.generateUuid)()}parse(l){const r=D.exec(l);return r&&r[1]&&r[2]?new d.ExtensionIdentifierWithVersion({id:r[1]},r[2]):null}};I=ce([ue(0,T.INativeEnvironmentService),ue(1,E.IFileService),ue(2,P.IExtensionGalleryService),ue(3,y.ILogService)],I),t.ExtensionsDownloader=I}),define(Y[103],ee([0,1,2,14,32,28,3,4,13,9,10,21]),function(_,t,m,O,E,P,T,L,u,d,y,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let w=class extends m.Disposable{constructor(c,f){super();this.environmentService=c,this.logService=f,this.processesLimiter=new L.Limiter(5)}async postUninstall(c){const f=this.parseScript(c,"uninstall");return f&&(this.logService.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(f.script,"uninstall",f.args,!0,c).then(()=>this.logService.info(c.identifier.id,c.manifest.version,"Finished running post uninstall script"),D=>this.logService.error(c.identifier.id,c.manifest.version,`Failed to run post uninstall script: ${D}`)))),y.Promises.rm(this.getExtensionStoragePath(c)).then(void 0,D=>this.logService.error("Error while removing extension storage path",D))}parseScript(c,f){const D=`vscode:${f}`;if(c.location.scheme===d.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[D]=="string"){const I=c.manifest.scripts[D].split(" ");return I.length<2||I[0]!=="node"||!I[1]?(this.logService.warn(c.identifier.id,c.manifest.version,`${D} should be a node script`),null):{script:(0,T.join)(c.location.fsPath,I[1]),args:I.slice(2)||[]}}return null}runLifecycleHook(c,f,D,I,b){return new Promise((l,r)=>{const s=this.start(c,f,D,b);let e;const i=n=>{e&&(clearTimeout(e),e=null),n?r(n):l(void 0)};s.on("error",n=>{i((0,P.toErrorMessage)(n)||"Unknown")}),s.on("exit",(n,o)=>{i(n?`post-${f} process exited with code ${n}`:void 0)}),I&&(e=setTimeout(()=>{e=null,s.kill(),r("timed out")},5e3))})}start(c,f,D,I){const b={silent:!0,execArgv:void 0},l=(0,E.fork)(c,[`--type=extension-post-${f}`,...D],b);l.stdout.setEncoding("utf8"),l.stderr.setEncoding("utf8");const r=u.Event.fromNodeEventEmitter(l.stdout,"data"),s=u.Event.fromNodeEventEmitter(l.stderr,"data");r(n=>this.logService.info(I.identifier.id,I.manifest.version,`post-${f}`,n)),s(n=>this.logService.error(I.identifier.id,I.manifest.version,`post-${f}`,n));const e=u.Event.any(u.Event.map(r,n=>({data:`%c${n}`,format:[""]})),u.Event.map(s,n=>({data:`%c${n}`,format:["color: red"]})));return u.Event.debounce(e,(n,o)=>n?{data:n.data+o.data,format:[...n.format,...o.format]}:{data:o.data,format:o.format},100)(n=>{console.group(I.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),l}getExtensionStoragePath(c){return(0,T.join)(this.environmentService.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};w=ce([ue(0,v.IEnvironmentService),ue(1,O.ILogService)],w),t.ExtensionsLifecycle=w}),define(Y[104],ee([0,1,2,21,13,17,7,23,20,14]),function(_,t,m,O,E,P,T,L,u,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let y=class extends m.Disposable{constructor(w,F,c,f){super();this.extensionsManagementService=w,this.logService=f,this._onDidChangeExtensionsByAnotherSource=this._register(new E.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(b=>{this.installedExtensions=b.map(l=>l.identifier),this.startTimestamp=Date.now()}),this._register(w.onInstallExtension(b=>this.onInstallExtension(b))),this._register(w.onDidInstallExtensions(b=>this.onDidInstallExtensions(b))),this._register(w.onDidUninstallExtension(b=>this.onDidUninstallExtension(b)));const D=T.URI.file(c.extensionsPath),I=new u.ExtUri(b=>!F.hasCapability(b,1024));this._register(F.watch(D)),this._register(E.Event.filter(F.onDidChangeFilesRaw,b=>b.changes.some(l=>this.doesChangeAffects(l,D,I)))(()=>this.onDidChange()))}doesChangeAffects(w,F,c){return c.isEqual(c.dirname(w.resource),F)?c.isEqual(w.resource,c.joinPath(F,".obsolete"))?!0:!(w.type!==1&&w.type!==2||c.basename(w.resource).startsWith(".")):!1}onInstallExtension(w){this.addInstallingExtension(w.identifier)}onDidInstallExtensions(w){for(const F of w)this.removeInstallingExtension(F.identifier),F.local&&this.addInstalledExtension(F.identifier)}onDidUninstallExtension(w){w.error||this.removeInstalledExtension(w.identifier)}addInstallingExtension(w){this.removeInstallingExtension(w),this.installingExtensions.push(w)}removeInstallingExtension(w){this.installingExtensions=this.installingExtensions.filter(F=>!(0,L.areSameExtensions)(F,w))}addInstalledExtension(w){this.installedExtensions&&(this.removeInstalledExtension(w),this.installedExtensions.push(w))}removeInstalledExtension(w){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(F=>!(0,L.areSameExtensions)(F,w)))}async onDidChange(){if(this.installedExtensions){const w=await this.extensionsManagementService.getInstalled(1),F=w.filter(f=>[...this.installingExtensions,...this.installedExtensions].some(D=>(0,L.areSameExtensions)(D,f.identifier))?!1:f.installedTimestamp&&f.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",f.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",f.identifier.id),!1)),c=this.installedExtensions.filter(f=>this.installingExtensions.some(D=>(0,L.areSameExtensions)(D,f))?!1:w.every(D=>!(0,L.areSameExtensions)(D.identifier,f))?(this.logService.info("Detected extension removed from another source",f.id),!0):!1);this.installedExtensions=w.map(f=>f.identifier),(F.length||c.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:F,removed:c})}}};y=ce([ue(1,P.IFileService),ue(2,O.INativeEnvironmentService),ue(3,d.ILogService)],y),t.ExtensionsWatcher=y}),define(Y[105],ee([0,1,10,129,22,2,21,4,23,14,53,24,9,3]),function(_,t,m,O,E,P,T,L,u,d,y,v,w,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let c=class extends P.Disposable{constructor(I,b,l){super();this.extensionManagementService=I,this.logService=l,this.cache=this._register(new f(b,l)),this.extensionManagementService.registerParticipant({postInstall:async r=>this.postInstallExtension(r),postUninstall:async r=>this.postUninstallExtension(r)})}async getLanguageIds(){const I=await this.cache.getLanguagePacks(),b=["en",...Object.keys(I)];return(0,v.distinct)(b)}async postInstallExtension(I){I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",I.identifier.id),await this.update())}async postUninstallExtension(I){const b=await this.cache.getLanguagePacks();Object.keys(b).some(l=>b[l]&&b[l].extensions.some(r=>(0,u.areSameExtensions)(r.extensionIdentifier,I.identifier)))&&(this.logService.info("Removing language packs from the extension",I.identifier.id),await this.update())}async update(){const[I,b]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),l=await this.cache.update(b);return!(0,v.equals)(Object.keys(I),Object.keys(l))}};c=ce([ue(0,E.IExtensionManagementService),ue(1,T.INativeEnvironmentService),ue(2,d.ILogService)],c),t.LocalizationsService=c;let f=class extends P.Disposable{constructor(I,b){super();this.logService=b,this.languagePacks={},this.languagePacksFilePath=(0,F.join)(I.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new L.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(I){return this.withLanguagePacks(b=>{Object.keys(b).forEach(l=>delete b[l]),this.createLanguagePacksFromExtensions(b,...I)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(I,...b){for(const l of b)l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(I,l);Object.keys(I).forEach(l=>this.updateHash(I[l]))}createLanguagePacksFromExtension(I,b){const l=b.identifier,r=b.manifest.contributes&&b.manifest.contributes.localizations?b.manifest.contributes.localizations:[];for(const s of r)if(b.location.scheme===w.Schemas.file&&(0,y.isValidLocalization)(s)){let e=I[s.languageId];e||(e={hash:"",extensions:[],translations:{}},I[s.languageId]=e);let i=e.extensions.filter(n=>(0,u.areSameExtensions)(n.extensionIdentifier,l))[0];i?i.version=b.manifest.version:e.extensions.push({extensionIdentifier:l,version:b.manifest.version});for(const n of s.translations)e.translations[n.id]=(0,F.join)(b.location.fsPath,n.path)}}updateHash(I){if(I){const b=(0,O.createHash)("md5");for(const l of I.extensions)b.update(l.extensionIdentifier.uuid||l.extensionIdentifier.id).update(l.version);I.hash=b.digest("hex")}}withLanguagePacks(I=()=>null){return this.languagePacksFileLimiter.queue(()=>{let b=null;return m.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,l=>l.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(l)).then(l=>{try{return JSON.parse(l)}catch(r){return{}}}).then(l=>(b=I(l),l)).then(l=>{for(const s of Object.keys(l))l[s]||delete l[s];this.languagePacks=l,this.initializedCache=!0;const r=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",r),m.Promises.writeFile(this.languagePacksFilePath,r)}).then(()=>b,l=>this.logService.error(l))})}};f=ce([ue(0,T.INativeEnvironmentService),ue(1,d.ILogService)],f)}),define(Y[106],ee([0,1,14,17]),function(_,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function E(u,d,y,v){try{const w=await new Promise((F,c)=>{_(["spdlog"],F,c)});return w.setFlushOn(m.LogLevel.Trace),w.createAsyncRotatingLogger(u,d,y,v)}catch(w){console.error(w)}return null}function P(u,d,y,v){const w=_.__$__nodeRequire("spdlog");return w.setFlushOn(m.LogLevel.Trace),w.createRotatingLogger(u,d,y,v)}t.createRotatingLogger=P;function T(u,d,y){switch(d){case m.LogLevel.Trace:u.trace(y);break;case m.LogLevel.Debug:u.debug(y);break;case m.LogLevel.Info:u.info(y);break;case m.LogLevel.Warning:u.warn(y);break;case m.LogLevel.Error:u.error(y);break;case m.LogLevel.Critical:u.critical(y);break;default:throw new Error("Invalid log level")}}class L extends m.AbstractMessageLogger{constructor(d,y,v,w){super();this.name=d,this.filepath=y,this.rotating=v,this.buffer=[],this.setLevel(w),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(F=>{this._logger&&this._logger.setLevel(F)}))}_createSpdLogLogger(){const d=this.rotating?6:1,y=30/d*O.ByteSize.MB;return E(this.name,this.filepath,y,d).then(v=>{if(v){this._logger=v,this._logger.setLevel(this.getLevel());for(const{level:w,message:F}of this.buffer)T(this._logger,w,F);this.buffer=[]}})}log(d,y){this._logger?T(this._logger,d,y):this.getLevel()<=d&&this.buffer.push({level:d,message:y})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=L}),define(Y[54],ee([0,1,82,16,17,8,34]),function(_,t,m,O,E,P,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function L(v,w,F,c,f,D){let I;try{await u(v,w,F,c,f,D)}catch(b){I=b}finally{I&&f.errorTransformer&&(I=f.errorTransformer(I)),typeof I!="undefined"&&F.error(I),F.end()}}t.readFileIntoStream=L;async function u(v,w,F,c,f,D){d(D);const I=await v.open(w,{create:!1});try{d(D);let b=0,l=0,r=f&&typeof f.length=="number"?f.length:void 0,s=O.VSBuffer.alloc(Math.min(f.bufferSize,typeof r=="number"?r:f.bufferSize)),e=f&&typeof f.position=="number"?f.position:0,i=0;do l=await v.read(I,e,s.buffer,i,s.byteLength-i),e+=l,i+=l,b+=l,typeof r=="number"&&(r-=l),i===s.byteLength&&(await F.write(c(s)),s=O.VSBuffer.alloc(Math.min(f.bufferSize,typeof r=="number"?r:f.bufferSize)),i=0);while(l>0&&(typeof r!="number"||r>0)&&d(D)&&y(b,f));if(i>0){let n=i;typeof r=="number"&&(n=Math.min(i,r)),F.write(c(s.slice(0,n)))}}catch(b){throw(0,E.ensureFileSystemProviderError)(b)}finally{await v.close(I)}}function d(v){if(v.isCancellationRequested)throw(0,P.canceled)();return!0}function y(v,w){if(w?.limits){if(typeof w.limits.memory=="number"&&v>w.limits.memory)throw(0,E.createFileSystemProviderError)((0,m.localize)(0,null,T.default.nameShort),E.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof w.limits.size=="number"&&v>w.limits.size)throw(0,E.createFileSystemProviderError)((0,m.localize)(1,null),E.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Y[107],ee([0,1,81,130,2,17,13,20,45,24,14,16,36,4,26,9,54,131]),function(_,t,m,O,E,P,T,L,u,d,y,v,w,F,c,f,D,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let b=class Ne extends E.Disposable{constructor(r){super();this.logService=r,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new T.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new F.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new P.FileChangesEvent(s,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new F.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new P.FileChangesEvent(s,!0)))),this.watchedResources=u.TernarySearchTree.forUris(s=>{const e=this.getProvider(s.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new F.ResourceQueue)}registerProvider(r,s){if(this.provider.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,O.mark)(`code/registerFilesystem/${r}`),this.provider.set(r,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:r,provider:s});const e=new E.DisposableStore;return e.add(s.onDidChangeFile(i=>this.onDidChangeFile(i,this.isPathCaseSensitive(s)))),e.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:r}))),typeof s.onDidErrorOccur=="function"&&e.add(s.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,E.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:r,provider:s}),this.provider.delete(r),(0,E.dispose)(e)})}getProvider(r){return this.provider.get(r)}async activateProvider(r){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:r,join(e){s.push(e)}}),!this.provider.has(r)&&await F.Promises.settled(s)}canHandleResource(r){return this.provider.has(r.scheme)}hasCapability(r,s){const e=this.provider.get(r.scheme);return!!(e&&e.capabilities&s)}listCapabilities(){return I.Iterable.map(this.provider,([r,s])=>({scheme:r,capabilities:s.capabilities}))}async withProvider(r){if(!(0,L.isAbsolutePath)(r))throw new P.FileOperationError((0,m.localize)(0,null,this.resourceForError(r)),8);await this.activateProvider(r.scheme);const s=this.provider.get(r.scheme);if(!s){const e=new Error;throw e.name="ENOPRO",e.message=(0,m.localize)(1,null,r.toString()),e}return s}async withReadProvider(r){const s=await this.withProvider(r);if((0,P.hasOpenReadWriteCloseCapability)(s)||(0,P.hasReadWriteCapability)(s)||(0,P.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(r){const s=await this.withProvider(r);if((0,P.hasOpenReadWriteCloseCapability)(s)||(0,P.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,s){try{return await this.doResolveFile(r,s)}catch(e){throw(0,P.toFileSystemProviderErrorCode)(e)===P.FileSystemProviderErrorCode.FileNotFound?new P.FileOperationError((0,m.localize)(2,null,this.resourceForError(r)),1):(0,P.ensureFileSystemProviderError)(e)}}async doResolveFile(r,s){const e=await this.withProvider(r),i=this.isPathCaseSensitive(e),n=s?.resolveTo,o=s?.resolveSingleChildDescendants,a=s?.resolveMetadata,h=await e.stat(r);let p;return this.toFileStat(e,r,h,void 0,!!a,(M,C)=>(p||(p=u.TernarySearchTree.forUris(()=>!i),p.set(r,!0),(0,d.isNonEmptyArray)(n)&&n.forEach(N=>p.set(N,!0))),Boolean(p.findSuperstr(M.resource)||p.get(M.resource))?!0:M.isDirectory&&o?C===1:!1))}async toFileStat(r,s,e,i,n,o){const{providerExtUri:a}=this.getExtUri(r),h={resource:s,name:a.basename(s),isFile:(e.type&P.FileType.File)!=0,isDirectory:(e.type&P.FileType.Directory)!=0,isSymbolicLink:(e.type&P.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&P.FilePermission.Readonly)||Boolean(r.capabilities&2048),etag:(0,P.etag)({mtime:e.mtime,size:e.size})};if(h.isDirectory&&o(h,i)){try{const p=await r.readdir(s),M=await F.Promises.settled(p.map(async([C,N])=>{try{const V=a.joinPath(s,C),W=n?await r.stat(V):{type:N};return await this.toFileStat(r,V,W,p.length,n,o)}catch(V){return this.logService.trace(V),null}}));h.children=(0,d.coalesce)(M)}catch(p){this.logService.trace(p),h.children=[]}return h}return h}async resolveAll(r){return F.Promises.settled(r.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(r){const s=await this.withProvider(r);try{return!!await s.stat(r)}catch(e){return!1}}async canCreateFile(r,s){try{await this.doValidateCreateFile(r,s)}catch(e){return e}return!0}async doValidateCreateFile(r,s){if(!s?.overwrite&&await this.exists(r))throw new P.FileOperationError((0,m.localize)(3,null,this.resourceForError(r)),3,s)}async createFile(r,s=v.VSBuffer.fromString(""),e){await this.doValidateCreateFile(r,e);const i=await this.writeFile(r,s);return this._onDidRunOperation.fire(new P.FileOperationEvent(r,0,i)),i}async writeFile(r,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,r,e)||await this.mkdirp(i,n.dirname(r));let a;if((0,P.hasReadWriteCapability)(i)&&!(s instanceof v.VSBuffer))if((0,w.isReadableStream)(s)){const h=await(0,w.peekStream)(s,3);h.ended?a=v.VSBuffer.concat(h.buffer):a=h}else a=(0,w.peekReadable)(s,h=>v.VSBuffer.concat(h),3);else a=s;!(0,P.hasOpenReadWriteCloseCapability)(i)||(0,P.hasReadWriteCapability)(i)&&a instanceof v.VSBuffer?await this.doWriteUnbuffered(i,r,e,a):await this.doWriteBuffered(i,r,e,a instanceof v.VSBuffer?(0,v.bufferToReadable)(a):a)}catch(o){throw new P.FileOperationError((0,m.localize)(4,null,this.resourceForError(r),(0,P.ensureFileSystemProviderError)(o).toString()),(0,P.toFileOperationResult)(o),e)}return this.resolve(r,{resolveMetadata:!0})}async validateWriteFile(r,s,e){if(!!e?.unlock&&!(r.capabilities&8192))throw new Error((0,m.localize)(5,null,this.resourceForError(s)));let n;try{n=await r.stat(s)}catch(o){return}if((n.type&P.FileType.Directory)!=0)throw new P.FileOperationError((0,m.localize)(6,null,this.resourceForError(s)),0,e);if(this.throwIfFileIsReadonly(s,n),e&&typeof e.mtime=="number"&&typeof e.etag=="string"&&e.etag!==P.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==(0,P.etag)({mtime:e.mtime,size:n.size}))throw new P.FileOperationError((0,m.localize)(7,null),3,e);return n}async readFile(r,s){const e=await this.withReadProvider(r);return s?.atomic?this.doReadFileAtomic(e,r,s):this.doReadFile(e,r,s)}async doReadFileAtomic(r,s,e){return new Promise((i,n)=>{this.writeQueue.queueFor(s,this.getExtUri(r).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(r,s,e);i(o)}catch(o){n(o)}})})}async doReadFile(r,s,e){const i=await this.doReadFileStream(r,s,{...e,preferUnbuffered:!0});return{...i,value:await(0,v.streamToBuffer)(i.value)}}async readFileStream(r,s){const e=await this.withReadProvider(r);return this.doReadFileStream(e,r,s)}async doReadFileStream(r,s,e){const i=new c.CancellationTokenSource,n=this.validateReadFile(s,e).then(a=>a,a=>{throw i.cancel(),a});let o;try{return e&&typeof e.etag=="string"&&e.etag!==P.ETAG_DISABLED&&await n,!((0,P.hasOpenReadWriteCloseCapability)(r)||(0,P.hasFileReadStreamCapability)(r))||(0,P.hasReadWriteCapability)(r)&&e?.preferUnbuffered?o=this.readFileUnbuffered(r,s,e):(0,P.hasFileReadStreamCapability)(r)?o=this.readFileStreamed(r,s,i.token,e):o=this.readFileBuffered(r,s,i.token,e),{...await n,value:o}}catch(a){o&&await(0,w.consumeStream)(o);const h=(0,m.localize)(8,null,this.resourceForError(s),(0,P.ensureFileSystemProviderError)(a).toString());throw a instanceof P.NotModifiedSinceFileOperationError?new P.NotModifiedSinceFileOperationError(h,a.stat,e):new P.FileOperationError(h,(0,P.toFileOperationResult)(a),e)}}readFileStreamed(r,s,e,i=Object.create(null)){const n=r.readFileStream(s,i,e);return(0,w.transform)(n,{data:o=>o instanceof v.VSBuffer?o:v.VSBuffer.wrap(o),error:o=>new P.FileOperationError((0,m.localize)(9,null,this.resourceForError(s),(0,P.ensureFileSystemProviderError)(o).toString()),(0,P.toFileOperationResult)(o),i)},o=>v.VSBuffer.concat(o))}readFileBuffered(r,s,e,i=Object.create(null)){const n=(0,v.newWriteableBufferStream)();return(0,D.readFileIntoStream)(r,s,n,o=>o,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new P.FileOperationError((0,m.localize)(10,null,this.resourceForError(s),(0,P.ensureFileSystemProviderError)(o).toString()),(0,P.toFileOperationResult)(o),i)},e),n}readFileUnbuffered(r,s,e){const i=(0,w.newWriteableStream)(n=>v.VSBuffer.concat(n));return(async()=>{try{let n=await r.readFile(s);e&&typeof e.position=="number"&&(n=n.slice(e.position)),e&&typeof e.length=="number"&&(n=n.slice(0,e.length)),this.validateReadFileLimits(s,n.byteLength,e),i.end(v.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(r,s){const e=await this.resolve(r,{resolveMetadata:!0});if(e.isDirectory)throw new P.FileOperationError((0,m.localize)(11,null,this.resourceForError(r)),0,s);if(s&&typeof s.etag=="string"&&s.etag!==P.ETAG_DISABLED&&s.etag===e.etag)throw new P.NotModifiedSinceFileOperationError((0,m.localize)(12,null),e,s);return this.validateReadFileLimits(r,e.size,s),e}validateReadFileLimits(r,s,e){if(e?.limits){let i;if(typeof e.limits.memory=="number"&&s>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&s>e.limits.size&&(i=7),typeof i=="number")throw new P.FileOperationError((0,m.localize)(13,null,this.resourceForError(r)),i)}}async canMove(r,s,e){return this.doCanMoveCopy(r,s,"move",e)}async canCopy(r,s,e){return this.doCanMoveCopy(r,s,"copy",e)}async doCanMoveCopy(r,s,e,i){if(r.toString()!==s.toString())try{const n=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r):await this.withReadProvider(r),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(n,r,o,s,e,i)}catch(n){return n}return!0}async move(r,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(i,r,n,s,"move",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new P.FileOperationEvent(r,o==="move"?2:3,a)),a}async copy(r,s,e){const i=await this.withReadProvider(r),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(i,r,n,s,"copy",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new P.FileOperationEvent(r,o==="copy"?3:2,a)),a}async doMoveCopy(r,s,e,i,n,o){if(s.toString()===i.toString())return n;const{exists:a,isSameResourceWithDifferentPathCase:h}=await this.doValidateMoveCopy(r,s,e,i,n,o);if(a&&!h&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),n==="copy"){if(r===e&&(0,P.hasFileFolderCopyCapability)(r))await r.copy(s,i,{overwrite:o});else{const p=await this.resolve(s);p.isDirectory?await this.doCopyFolder(r,p,e,i):await this.doCopyFile(r,s,e,i)}return n}else return r===e?(await r.rename(s,i,{overwrite:o}),n):(await this.doMoveCopy(r,s,e,i,"copy",o),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(r,s,e,i){if((0,P.hasOpenReadWriteCloseCapability)(r)&&(0,P.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(r,s,e,i);if((0,P.hasOpenReadWriteCloseCapability)(r)&&(0,P.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(r,s,e,i);if((0,P.hasReadWriteCapability)(r)&&(0,P.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(r,s,e,i);if((0,P.hasReadWriteCapability)(r)&&(0,P.hasReadWriteCapability)(e))return this.doPipeUnbuffered(r,s,e,i)}async doCopyFolder(r,s,e,i){await e.mkdir(i),Array.isArray(s.children)&&await F.Promises.settled(s.children.map(async n=>{const o=this.getExtUri(e).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(r,await this.resolve(n.resource),e,o):this.doCopyFile(r,n.resource,e,o)}))}async doValidateMoveCopy(r,s,e,i,n,o){let a=!1;if(r===e){const{providerExtUri:p,isPathCaseSensitive:M}=this.getExtUri(r);if(M||(a=p.isEqual(s,i)),a&&n==="copy")throw new Error((0,m.localize)(14,null,this.resourceForError(s),this.resourceForError(i)));if(!a&&p.isEqualOrParent(i,s))throw new Error((0,m.localize)(15,null,this.resourceForError(s),this.resourceForError(i)))}const h=await this.exists(i);if(h&&!a){if(!o)throw new P.FileOperationError((0,m.localize)(16,null,this.resourceForError(s),this.resourceForError(i)),4);if(r===e){const{providerExtUri:p}=this.getExtUri(r);if(p.isEqualOrParent(s,i))throw new Error((0,m.localize)(17,null,this.resourceForError(s),this.resourceForError(i)))}}return{exists:h,isSameResourceWithDifferentPathCase:a}}getExtUri(r){const s=this.isPathCaseSensitive(r);return{providerExtUri:s?L.extUri:L.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(r){return!!(r.capabilities&1024)}async createFolder(r){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r);await this.mkdirp(s,r);const e=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new P.FileOperationEvent(r,0,e)),e}async mkdirp(r,s){const e=[],{providerExtUri:i}=this.getExtUri(r);for(;!i.isEqual(s,i.dirname(s));)try{if(((await r.stat(s)).type&P.FileType.Directory)==0)throw new Error((0,m.localize)(18,null,this.resourceForError(s)));break}catch(n){if((0,P.toFileSystemProviderErrorCode)(n)!==P.FileSystemProviderErrorCode.FileNotFound)throw n;e.push(i.basename(s)),s=i.dirname(s)}for(let n=e.length-1;n>=0;n--){s=i.joinPath(s,e[n]);try{await r.mkdir(s)}catch(o){if((0,P.toFileSystemProviderErrorCode)(o)!==P.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(r,s){try{await this.doValidateDelete(r,s)}catch(e){return e}return!0}async doValidateDelete(r,s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r);if(!!s?.useTrash&&!(e.capabilities&4096))throw new Error((0,m.localize)(19,null,this.resourceForError(r)));let n;try{n=await e.stat(r)}catch(a){}if(n)this.throwIfFileIsReadonly(r,n);else throw new P.FileOperationError((0,m.localize)(20,null,this.resourceForError(r)),1);if(!!!s?.recursive){const a=await this.resolve(r);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,m.localize)(21,null,this.resourceForError(r)))}return e}async del(r,s){const e=await this.doValidateDelete(r,s),i=!!s?.useTrash,n=!!s?.recursive;await e.delete(r,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new P.FileOperationEvent(r,1))}onDidChangeFile(r,s){this._onDidChangeFilesRaw.fire({changes:r});let e,i;{for(const n of r)this.watchedResources.has(n.resource)?(e||(e=[]),e.push(n)):(i||(i=[]),i.push(n));e&&this._onDidFilesChange.fire(new P.FileChangesEvent(e,!s))}if(i){const n=s?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(i)&&Ne.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(r,s={recursive:!1,excludes:[]}){const e=new E.DisposableStore;{let i=!1,n=()=>{i=!0};e.add((0,E.toDisposable)(()=>n())),this.doWatch(r,s).then(o=>{i?(0,E.dispose)(o):n=()=>(0,E.dispose)(o)},o=>this.logService.error(o))}return s.recursive||(this.watchedResources.set(r,(this.watchedResources.get(r)??0)+1),e.add((0,E.toDisposable)(()=>{const i=this.watchedResources.get(r);typeof i=="number"&&(i<=1?this.watchedResources.delete(r):this.watchedResources.set(r,i-1))}))),e}async doWatch(r,s){const e=await this.withProvider(r),i=this.toWatchKey(e,r,s),n=this.activeWatchers.get(i)||{count:0,disposable:e.watch(r,s)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,(0,E.toDisposable)(()=>{n.count--,n.count===0&&((0,E.dispose)(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(r,s,e){const{providerExtUri:i}=this.getExtUri(r);return[i.getComparisonKey(s),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(r=>(0,E.dispose)(r.disposable)),this.activeWatchers.clear()}async doWriteBuffered(r,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(r).providerExtUri).queue(async()=>{const n=await r.open(s,{create:!0,unlock:e?.unlock??!1});try{(0,w.isReadableStream)(i)||(0,w.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(r,n,i):await this.doWriteReadableBufferedQueued(r,n,i)}catch(o){throw(0,P.ensureFileSystemProviderError)(o)}finally{await r.close(n)}})}async doWriteStreamBufferedQueued(r,s,e){let i=0,n;if((0,w.isReadableBufferedStream)(e)){if(e.buffer.length>0){const o=v.VSBuffer.concat(e.buffer);await this.doWriteBuffer(r,s,o,o.byteLength,i,0),i+=o.byteLength}if(e.ended)return;n=e.stream}else n=e;return new Promise(async(o,a)=>{(0,w.listenStream)(n,{onData:async h=>{n.pause();try{await this.doWriteBuffer(r,s,h,h.byteLength,i,0)}catch(p){return a(p)}i+=h.byteLength,setTimeout(()=>n.resume())},onError:h=>a(h),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(r,s,e){let i=0,n;for(;(n=e.read())!==null;)await this.doWriteBuffer(r,s,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(r,s,e,i,n,o){let a=0;for(;a<i;)a+=await r.write(s,n+a,e.buffer,o+a,i-a)}async doWriteUnbuffered(r,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(r).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(r,s,e,i))}async doWriteUnbufferedQueued(r,s,e,i){let n;i instanceof v.VSBuffer?n=i:(0,w.isReadableStream)(i)?n=await(0,v.streamToBuffer)(i):(0,w.isReadableBufferedStream)(i)?n=await(0,v.bufferedStreamToBuffer)(i):n=(0,v.readableToBuffer)(i),await r.writeFile(s,n.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(r,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(r,s,e,i))}async doPipeBufferedQueued(r,s,e,i){let n,o;try{n=await r.open(s,{create:!1}),o=await e.open(i,{create:!0,unlock:!1});const a=v.VSBuffer.alloc(this.BUFFER_SIZE);let h=0,p=0,M=0;do M=await r.read(n,h,a.buffer,p,a.byteLength-p),await this.doWriteBuffer(e,o,a,M,h,p),h+=M,p+=M,p===a.byteLength&&(p=0);while(M>0)}catch(a){throw(0,P.ensureFileSystemProviderError)(a)}finally{await F.Promises.settled([typeof n=="number"?r.close(n):Promise.resolve(),typeof o=="number"?e.close(o):Promise.resolve()])}}async doPipeUnbuffered(r,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(r,s,e,i))}async doPipeUnbufferedQueued(r,s,e,i){return e.writeFile(i,await r.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(r,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(r,s,e,i))}async doPipeUnbufferedToBufferedQueued(r,s,e,i){const n=await e.open(i,{create:!0,unlock:!1});try{const o=await r.readFile(s);await this.doWriteBuffer(e,n,v.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,P.ensureFileSystemProviderError)(o)}finally{await e.close(n)}}async doPipeBufferedToUnbuffered(r,s,e,i){const n=await(0,v.streamToBuffer)(this.readFileBuffered(r,s,c.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,n)}throwIfFileSystemIsReadonly(r,s){if(r.capabilities&2048)throw new P.FileOperationError((0,m.localize)(22,null,this.resourceForError(s)),6);return r}throwIfFileIsReadonly(r,s){if((s.permissions??0)&P.FilePermission.Readonly)throw new P.FileOperationError((0,m.localize)(23,null,this.resourceForError(r)),6)}resourceForError(r){return r.scheme===f.Schemas.file?r.fsPath:r.toString(!0)}};b.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},b=ce([ue(0,y.ILogService)],b),t.FileService=b}),define(Y[108],ee([0,1,2,17,13,15,10,3,20,37,4,14,83,51,92,94,91,100,36,54,24,16]),function(_,t,m,O,E,P,T,L,u,d,y,v,w,F,c,f,D,I,b,l,r,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class e extends m.Disposable{constructor(n,o){super();this.logService=n,this.options=o,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=E.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new E.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new E.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new y.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,P.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:o,symbolicLink:a}=await T.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(o,a),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.toFileSystemProviderError(o)}}async readdir(n){try{const o=await T.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),a=[];return await Promise.all(o.map(async h=>{try{let p;h.isSymbolicLink()?p=(await this.stat((0,u.joinPath)(n,h.name))).type:p=this.toType(h),a.push([h.name,p])}catch(p){this.logService.trace(p)}})),a}catch(o){throw this.toFileSystemProviderError(o)}}toType(n,o){let a;return o?.dangling?a=O.FileType.Unknown:n.isFile()?a=O.FileType.File:n.isDirectory()?a=O.FileType.Directory:a=O.FileType.Unknown,o&&(a|=O.FileType.SymbolicLink),a}async readFile(n){try{const o=this.toFilePath(n);return await T.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}}readFileStream(n,o,a){const h=(0,b.newWriteableStream)(p=>s.VSBuffer.concat(p.map(M=>s.VSBuffer.wrap(M))).buffer);return(0,l.readFileIntoStream)(this,n,h,p=>p.buffer,{...o,bufferSize:this.BUFFER_SIZE},a),h}async writeFile(n,o,a){let h;try{const p=this.toFilePath(n);if(!a.create||!a.overwrite){if(await T.Promises.exists(p)){if(!a.overwrite)throw(0,O.createFileSystemProviderError)((0,w.localize)(0,null),O.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,O.createFileSystemProviderError)((0,w.localize)(1,null),O.FileSystemProviderErrorCode.FileNotFound)}h=await this.open(n,{create:!0,unlock:a.unlock}),await this.write(h,0,o,0,o.byteLength)}catch(p){throw await this.toFileSystemProviderWriteError(n,p)}finally{typeof h=="number"&&await this.close(h)}}async open(n,o){try{const a=this.toFilePath(n);if((0,O.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:M}=await T.SymlinkSupport.stat(a);M.mode&128||await T.Promises.chmod(a,M.mode|128)}catch(M){this.logService.trace(M)}let h;if((0,O.isFileOpenForWriteOptions)(o)){if(P.isWindows)try{await T.Promises.truncate(a,0),h="r+"}catch(M){M.code!=="ENOENT"&&this.logService.trace(M)}h||(h="w")}else h="r";const p=await T.Promises.open(a,h);return this.mapHandleToPos.set(p,0),(0,O.isFileOpenForWriteOptions)(o)&&this.writeHandles.set(p,n),p}catch(a){throw(0,O.isFileOpenForWriteOptions)(o)?await this.toFileSystemProviderWriteError(n,a):this.toFileSystemProviderError(a)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await T.Promises.fdatasync(n)}catch(o){this.canFlush=!1,this.logService.error(o)}return await T.Promises.close(n)}catch(o){throw this.toFileSystemProviderError(o)}}async read(n,o,a,h,p){const M=this.normalizePos(n,o);let C=null;try{const N=await T.Promises.read(n,a,h,p,M);return typeof N=="number"?C=N:C=N.bytesRead,C}catch(N){throw this.toFileSystemProviderError(N)}finally{this.updatePos(n,M,C)}}normalizePos(n,o){return o===this.mapHandleToPos.get(n)?null:o}updatePos(n,o,a){const h=this.mapHandleToPos.get(n);typeof h=="number"&&(typeof o=="number"||(typeof a=="number"?this.mapHandleToPos.set(n,h+a):this.mapHandleToPos.delete(n)))}async write(n,o,a,h,p){return(0,y.retry)(()=>this.doWrite(n,o,a,h,p),100,3)}async doWrite(n,o,a,h,p){const M=this.normalizePos(n,o);let C=null;try{const N=await T.Promises.write(n,a,h,p,M);return typeof N=="number"?C=N:C=N.bytesWritten,C}catch(N){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),N)}finally{this.updatePos(n,M,C)}}async mkdir(n){try{await T.Promises.mkdir(this.toFilePath(n))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(n,o){try{const a=this.toFilePath(n);await this.doDelete(a,o)}catch(a){throw this.toFileSystemProviderError(a)}}async doDelete(n,o){o.recursive?await T.Promises.rm(n,T.RimRafMode.MOVE):await T.Promises.unlink(n)}async rename(n,o,a){const h=this.toFilePath(n),p=this.toFilePath(o);if(h!==p)try{await this.validateTargetDeleted(n,o,"move",a.overwrite),await T.Promises.move(h,p)}catch(M){throw(M.code==="EINVAL"||M.code==="EBUSY"||M.code==="ENAMETOOLONG")&&(M=new Error((0,w.localize)(2,null,(0,L.basename)(h),(0,L.basename)((0,L.dirname)(p)),M.toString()))),this.toFileSystemProviderError(M)}}async copy(n,o,a){const h=this.toFilePath(n),p=this.toFilePath(o);if(h!==p)try{await this.validateTargetDeleted(n,o,"copy",a.overwrite),await T.Promises.copy(h,p,{preserveSymlinks:!0})}catch(M){throw(M.code==="EINVAL"||M.code==="EBUSY"||M.code==="ENAMETOOLONG")&&(M=new Error((0,w.localize)(3,null,(0,L.basename)(h),(0,L.basename)((0,L.dirname)(p)),M.toString()))),this.toFileSystemProviderError(M)}}async validateTargetDeleted(n,o,a,h){const p=this.toFilePath(n),M=this.toFilePath(o);let C=!1;if(!!(this.capabilities&1024)||(C=(0,d.isEqual)(p,M,!0)),C&&a==="copy")throw(0,O.createFileSystemProviderError)((0,w.localize)(4,null),O.FileSystemProviderErrorCode.FileExists);if(!C&&await T.Promises.exists(M)){if(!h)throw(0,O.createFileSystemProviderError)((0,w.localize)(5,null),O.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}watch(n,o){return o.recursive?this.watchRecursive(n,o.excludes):this.watchNonRecursive(n)}watchRecursive(n,o){const a={path:this.toFilePath(n),excludes:o},h=(0,r.insert)(this.recursiveFoldersToWatch,a);return this.refreshRecursiveWatchers(),(0,m.toDisposable)(()=>{h(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof D.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,m.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let n,o;this.options?.watcher?.usePolling?(n=c.FileWatcher,o=this.options?.watcher):this.recursiveFoldersToWatch.length===1?P.isWindows?n=f.FileWatcher:n=c.FileWatcher:n=D.FileWatcher,this.recursiveWatcher=new n(this.recursiveFoldersToWatch,a=>this._onDidChangeFile.fire((0,F.toFileChanges)(a)),a=>{a.type==="error"&&this._onDidWatchErrorOccur.fire(a.message),this.logService[a.type](a.message)},this.logService.getLevel()===v.LogLevel.Trace,o),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)}))}}watchNonRecursive(n){const o=new I.FileWatcher(this.toFilePath(n),h=>this._onDidChangeFile.fire((0,F.toFileChanges)(h)),h=>{h.type==="error"&&this._onDidWatchErrorOccur.fire(h.message),this.logService[h.type](h.message)},this.logService.getLevel()===v.LogLevel.Trace),a=this.logService.onDidChangeLogLevel(()=>{o.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)});return(0,m.combinedDisposable)(o,a)}toFilePath(n){return(0,L.normalize)(n.fsPath)}toFileSystemProviderError(n){if(n instanceof O.FileSystemProviderError)return n;let o;switch(n.code){case"ENOENT":o=O.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=O.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=O.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=O.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=O.FileSystemProviderErrorCode.NoPermissions;break;default:o=O.FileSystemProviderErrorCode.Unknown}return(0,O.createFileSystemProviderError)(n,o)}async toFileSystemProviderWriteError(n,o){let a=this.toFileSystemProviderError(o);if(n&&a.code===O.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await T.SymlinkSupport.stat(this.toFilePath(n));h.mode&128||(a=(0,O.createFileSystemProviderError)(o,O.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.logService.trace(h)}return a}dispose(){super.dispose(),(0,m.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,m.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=e}),define(Y[42],ee([0,1,11]),function(_,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,m.createDecorator)("productService")}),define(Y[25],ee([0,1,12,57]),function(_,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class E{constructor(){this.data=new Map}add(T,L){O.ok(m.isString(T)),O.ok(m.isObject(L)),O.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,L)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}t.Registry=new E}),define(Y[109],ee([0,1,25,13]),function(_,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function E(L){return L.length>0&&L.charAt(L.length-1)==="#"?L.substring(0,L.length-1):L}class P{constructor(){this._onDidChangeSchema=new O.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(u,d){this.schemasById[E(u)]=d,this._onDidChangeSchema.fire(u)}notifySchemaChanged(u){this._onDidChangeSchema.fire(u)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new P;m.Registry.add(t.Extensions.JSONContribution,T)}),define(Y[30],ee([0,1,73,13,25,12,109]),function(_,t,m,O,E,P,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var L;(function(I){I.Multiline="multilineText",I.Singleline="singlelineText"})(L=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var u;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(u=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const d=E.Registry.as(T.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new O.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new O.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:m.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},d.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(b,l=!0){this.registerConfigurations([b],l)}registerConfigurations(b,l=!0){const r=[];b.forEach(s=>{r.push(...this.validateAndRegisterProperties(s,l,s.extensionInfo)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),d.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(r)}deregisterConfigurations(b){const l=[],r=s=>{if(s.properties)for(const e in s.properties)l.push(e),delete this.configurationProperties[e],this.removeFromSchema(e,s.properties[e]);s.allOf&&s.allOf.forEach(e=>r(e))};for(const s of b){r(s);const e=this.configurationContributors.indexOf(s);e!==-1&&this.configurationContributors.splice(e,1)}d.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}registerDefaultConfigurations(b){const l=[],r=[];for(const s of b)for(const e in s)if(l.push(e),t.OVERRIDE_PROPERTY_PATTERN.test(e)){this.defaultValues[e]={...this.defaultValues[e]||{},...s[e]};const i={type:"object",default:this.defaultValues[e],description:m.localize(1,null,e),$ref:t.resourceLanguageSettingsSchemaId};r.push(w(e)),this.configurationProperties[e]=i,this.defaultLanguageConfigurationOverridesNode.properties[e]=i}else{this.defaultValues[e]=s[e];const i=this.configurationProperties[e];i&&(this.updatePropertyDefaultValue(e,i),this.updateSchema(e,i))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterDefaultConfigurations(b){const l=[];for(const r of b)for(const s in r)if(l.push(s),delete this.defaultValues[s],t.OVERRIDE_PROPERTY_PATTERN.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const e=this.configurationProperties[s];e&&(this.updatePropertyDefaultValue(s,e),this.updateSchema(s,e))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}notifyConfigurationSchemaUpdated(...b){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(b){for(const l of b)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(b,l=!0,r,s=3){s=P.isUndefinedOrNull(b.scope)?s:b.scope;let e=[],i=b.properties;if(i)for(let o in i){if(l&&f(o)){delete i[o];continue}const a=i[o];if(this.updatePropertyDefaultValue(o,a),t.OVERRIDE_PROPERTY_PATTERN.test(o)?a.scope=void 0:(a.scope=P.isUndefinedOrNull(a.scope)?s:a.scope,a.restricted=P.isUndefinedOrNull(a.restricted)?!!r?.restrictedConfigurations?.includes(o):a.restricted),i[o].hasOwnProperty("included")&&!i[o].included){this.excludedConfigurationProperties[o]=i[o],delete i[o];continue}else this.configurationProperties[o]=i[o];!i[o].deprecationMessage&&i[o].markdownDeprecationMessage&&(i[o].deprecationMessage=i[o].markdownDeprecationMessage),e.push(o)}let n=b.allOf;if(n)for(let o of n)e.push(...this.validateAndRegisterProperties(o,l,r,s));return e}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(b){const l=r=>{let s=r.properties;if(s)for(const i in s)this.updateSchema(i,s[i]);let e=r.allOf;e&&e.forEach(l)};l(b)}updateSchema(b,l){switch(t.allSettings.properties[b]=l,l.scope){case 1:t.applicationSettings.properties[b]=l;break;case 2:t.machineSettings.properties[b]=l;break;case 6:t.machineOverridableSettings.properties[b]=l;break;case 3:t.windowSettings.properties[b]=l;break;case 4:t.resourceSettings.properties[b]=l;break;case 5:t.resourceSettings.properties[b]=l,this.resourceLanguageSettingsSchema.properties[b]=l;break}}removeFromSchema(b,l){switch(delete t.allSettings.properties[b],l.scope){case 1:delete t.applicationSettings.properties[b];break;case 2:delete t.machineSettings.properties[b];break;case 6:delete t.machineOverridableSettings.properties[b];break;case 3:delete t.windowSettings.properties[b];break;case 4:case 5:delete t.resourceSettings.properties[b];break}}updateOverridePropertyPatternKey(){for(const b of this.overrideIdentifiers.values()){const l=`[${b}]`,r={type:"object",description:m.localize(2,null),errorMessage:m.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,r),t.allSettings.properties[l]=r,t.applicationSettings.properties[l]=r,t.machineSettings.properties[l]=r,t.machineOverridableSettings.properties[l]=r,t.windowSettings.properties[l]=r,t.resourceSettings.properties[l]=r}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(b,l){let r=this.defaultValues[b];P.isUndefined(r)&&(r=l.default),P.isUndefined(r)&&(r=F(l.type)),l.default=r}}const v="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(v);function w(I){return I.substring(1,I.length-1)}t.overrideIdentifierFromKey=w;function F(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=F;const c=new y;E.Registry.add(t.Extensions.Configuration,c);function f(I){return I.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(I)?m.localize(5,null,I):c.getConfigurationProperties()[I]!==void 0?m.localize(6,null,I):null:m.localize(4,null)}t.validateProperty=f;function D(){const I=[],b=c.getConfigurationProperties();for(const l of Object.keys(b))I.push([l,b[l].scope]);return I.push(["launch",4]),I.push(["task",4]),I}t.getScopes=D}),define(Y[27],ee([0,1,19,12,7,25,11,30]),function(_,t,m,O,E,P,T,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,T.createDecorator)("configurationService");function u(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof E.URI)}t.isConfigurationOverrides=u;var d;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(d=t.ConfigurationTarget||(t.ConfigurationTarget={}));function y(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=y;function v(i,n){const o=n?i?n.keys.filter(V=>i.keys.indexOf(V)===-1):[...n.keys]:[],a=i?n?i.keys.filter(V=>n.keys.indexOf(V)===-1):[...i.keys]:[],h=[];if(n&&i){for(const V of i.keys)if(n.keys.indexOf(V)!==-1){const W=I(i.contents,V),Q=I(n.contents,V);m.equals(W,Q)||h.push(V)}}const p=[],M=V=>{const W={};for(const Q of V)for(const ie of Q.identifiers)W[s(ie)]=Q;return W},C=n?M(n.overrides):{},N=i?M(i.overrides):{};if(Object.keys(C).length)for(const V of o){const W=C[V];W&&p.push([(0,L.overrideIdentifierFromKey)(V),W.keys])}if(Object.keys(N).length)for(const V of a){const W=N[V];W&&p.push([(0,L.overrideIdentifierFromKey)(V),W.keys])}if(Object.keys(C).length&&Object.keys(N).length)for(const V of h){const W=N[V],Q=C[V];if(W&&Q){const ie=v({contents:W.contents,keys:W.keys,overrides:[]},{contents:Q.contents,keys:Q.keys,overrides:[]});p.push([(0,L.overrideIdentifierFromKey)(V),[...ie.added,...ie.removed,...ie.updated]])}}return{added:o,removed:a,updated:h,overrides:p}}t.compare=v;function w(i,n){const o=[];for(const a of Object.keys(i))if(L.OVERRIDE_PROPERTY_PATTERN.test(a)){const h={};for(const p in i[a])h[p]=i[a][p];o.push({identifiers:[(0,L.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(h),contents:F(h,n)})}return o}t.toOverrides=w;function F(i,n){const o=Object.create(null);for(let a in i)c(o,a,i[a],n);return o}t.toValuesTree=F;function c(i,n,o,a){const h=n.split("."),p=h.pop();let M=i;for(let C=0;C<h.length;C++){let N=h[C],V=M[N];switch(typeof V){case"undefined":V=M[N]=Object.create(null);break;case"object":break;default:a(`Ignoring ${n} as ${h.slice(0,C+1).join(".")} is ${JSON.stringify(V)}`);return}M=V}if(typeof M=="object"&&M!==null)try{M[p]=o}catch(C){a(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(M)}`)}else a(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(M)}`)}t.addToValueTree=c;function f(i,n){const o=n.split(".");D(i,o)}t.removeFromValueTree=f;function D(i,n){const o=n.shift();if(n.length===0){delete i[o];return}if(Object.keys(i).indexOf(o)!==-1){const a=i[o];typeof a=="object"&&!Array.isArray(a)&&(D(a,n),Object.keys(a).length===0&&delete i[o])}}function I(i,n,o){function a(M,C){let N=M;for(const V of C){if(typeof N!="object"||N===null)return;N=N[V]}return N}const h=n.split("."),p=a(i,h);return typeof p=="undefined"?o:p}t.getConfigurationValue=I;function b(i,n,o){Object.keys(n).forEach(a=>{a!=="__proto__"&&(a in i?O.isObject(i[a])&&O.isObject(n[a])?b(i[a],n[a],o):o&&(i[a]=n[a]):i[a]=n[a])})}t.merge=b;function l(){const i=P.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=l;function r(){const i=Object.create(null),n=P.Registry.as(L.Extensions.Configuration).getConfigurationProperties();for(let o in n){let a=n[o].default;c(i,o,a,h=>console.error(`Conflict in default settings: ${h}`))}return i}t.getDefaultValues=r;function s(i){return`[${i}]`}t.keyFromOverrideIdentifier=s;function e(i,n,o){const a=i.inspect(n),h=i.inspect(o);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:a.defaultValue}t.getMigratedSettingValue=e}),define(Y[110],ee([0,1,58,45,24,12,19,7,30,27,25,2,13]),function(_,t,m,O,E,P,T,L,u,d,y,v,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class F{constructor(e={},i=[],n=[]){this._contents=e,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,d.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const n=this.getContentsForOverrideIdentifer(i);return n?e?(0,d.getConfigurationValue)(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const o of E.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[o],h=i[o];h&&(typeof a=="object"&&typeof h=="object"?(a=T.deepClone(a),this.mergeContents(a,h)):a=h),n[o]=a}return new F(n,this.keys,this.overrides)}merge(...e){const i=T.deepClone(this.contents),n=T.deepClone(this.overrides),o=[...this.keys];for(const a of e){this.mergeContents(i,a.contents);for(const h of a.overrides){const[p]=n.filter(M=>E.equals(M.identifiers,h.identifiers));p?this.mergeContents(p.contents,h.contents):n.push(T.deepClone(h))}for(const h of a.keys)o.indexOf(h)===-1&&o.push(h)}return new F(i,o,n)}freeze(){return this.isFrozen=!0,this}mergeContents(e,i){for(const n of Object.keys(i)){if(n in e&&P.isObject(e[n])&&P.isObject(i[n])){this.mergeContents(e[n],i[n]);continue}e[n]=T.deepClone(i[n])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?T.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,d.addToValueTree)(this.contents,e,i,n=>{throw new Error(n)})}removeValue(e){this.removeKey(e)&&(0,d.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let n=0;n<i;n++)e.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=F;class c extends F{constructor(){const e=(0,d.getDefaultValues)(),i=(0,d.getConfigurationKeys)(),n=[];for(const o of Object.keys(e))u.OVERRIDE_PROPERTY_PATTERN.test(o)&&n.push({identifiers:[(0,u.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(e[o]),contents:(0,d.toValuesTree)(e[o],a=>console.error(`Conflict in default settings file: ${a}`))});super(e,i,n)}}t.DefaultConfigurationModel=c;class f{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new F}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!P.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:n,keys:o,overrides:a,restricted:h}=this.doParseRaw(e,i);this._configurationModel=new F(n,o,a),this._restrictedConfigurations=h||[]}doParseContent(e){let i={},n=null,o=[],a=[],h=[];function p(C){Array.isArray(o)?o.push(C):n&&(o[n]=C)}let M={onObjectBegin:()=>{let C={};p(C),a.push(o),o=C,n=null},onObjectProperty:C=>{n=C},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{let C=[];p(C),a.push(o),o=C,n=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:p,onError:(C,N,V)=>{h.push({error:C,offset:N,length:V})}};if(e)try{m.visit(e,M),i=o[0]||{}}catch(C){console.error(`Error while parsing settings file ${this._name}: ${C}`),this._parseErrors=[C]}return i}doParseRaw(e,i){const n=y.Registry.as(u.Extensions.Configuration).getConfigurationProperties(),o=this.filter(e,n,!0,i);e=o.raw;const a=(0,d.toValuesTree)(e,M=>console.error(`Conflict in settings file ${this._name}: ${M}`)),h=Object.keys(e),p=(0,d.toOverrides)(e,M=>console.error(`Conflict in settings file ${this._name}: ${M}`));return{contents:a,keys:h,overrides:p,restricted:o.restricted}}filter(e,i,n,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:e,restricted:[]};const a={},h=[];for(let p in e)if(u.OVERRIDE_PROPERTY_PATTERN.test(p)&&n){const M=this.filter(e[p],i,!1,o);a[p]=M.raw,h.push(...M.restricted)}else{const M=i[p],C=M?typeof M.scope!="undefined"?M.scope:3:void 0;M?.restricted&&h.push(p),(C===void 0||o.scopes===void 0||o.scopes.includes(C))&&(o.skipRestricted&&M?.restricted||(a[p]=e[p]))}return{raw:a,restricted:h}}}t.ConfigurationModelParser=f;class D extends v.Disposable{constructor(e,i,n,o){super();this.userSettingsResource=e,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new w.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(w.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new F}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=D;class I{constructor(e,i,n=new F,o=new F,a=new O.ResourceMap,h=new F,p=new O.ResourceMap,M=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=o,this._folderConfigurations=a,this._memoryConfiguration=h,this._memoryConfigurationByResource=p,this._freeze=M,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new O.ResourceMap,this._userConfiguration=null}getValue(e,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(e)}updateValue(e,i,n={}){let o;n.resource?(o=this._memoryConfigurationByResource.get(n.resource),o||(o=new F,this._memoryConfigurationByResource.set(n.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(e):o.setValue(e,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,n){const o=this.getConsolidateConfigurationModel(i,n),a=this.getFolderConfigurationModelForResource(i.resource,n),h=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,p=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),M=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),C=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),N=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),V=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,W=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(e):a.freeze().getValue(e):void 0,Q=i.overrideIdentifier?h.override(i.overrideIdentifier).getValue(e):h.getValue(e),ie=o.getValue(e),re=E.distinct(E.flatten(o.overrides.map(Z=>Z.identifiers))).filter(Z=>o.getOverrideValue(e,Z)!==void 0);return{defaultValue:p,userValue:M,userLocalValue:C,userRemoteValue:N,workspaceValue:V,workspaceFolderValue:W,memoryValue:Q,value:ie,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:M!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:C!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:N!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:V!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:W!==void 0?{value:a?.freeze().getValue(e),override:i.overrideIdentifier?a?.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:Q!==void 0?{value:h.getValue(e),override:i.overrideIdentifier?h.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:re.length?re:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const n=i.filter(o=>u.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const a=(0,u.overrideIdentifierFromKey)(o),h=this._defaultConfiguration.getKeysForOverrideIdentifier(a),p=e.getKeysForOverrideIdentifier(a),M=[...p.filter(C=>h.indexOf(C)===-1),...h.filter(C=>p.indexOf(C)===-1),...h.filter(C=>!T.equals(this._defaultConfiguration.override(a).getValue(C),e.override(a).getValue(C)))];return[a,M]});return this.updateDefaultConfiguration(e),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:n,removed:o,overrides:a}=(0,d.compare)(this.localUserConfiguration,e),h=[...i,...n,...o];return h.length&&this.updateLocalUserConfiguration(e),{keys:h,overrides:a}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:n,removed:o,overrides:a}=(0,d.compare)(this.remoteUserConfiguration,e);let h=[...i,...n,...o];return h.length&&this.updateRemoteUserConfiguration(e),{keys:h,overrides:a}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:n,removed:o,overrides:a}=(0,d.compare)(this.workspaceConfiguration,e);let h=[...i,...n,...o];return h.length&&this.updateWorkspaceConfiguration(e),{keys:h,overrides:a}}compareAndUpdateFolderConfiguration(e,i){const n=this.folderConfigurations.get(e),{added:o,updated:a,removed:h,overrides:p}=(0,d.compare)(n,i);let M=[...o,...a,...h];return(M.length||!n)&&this.updateFolderConfiguration(e,i),{keys:M,overrides:p}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:o,removed:a,overrides:h}=(0,d.compare)(i,void 0);return{keys:[...n,...o,...a],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let n=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const o=i.getFolder(e);o&&(n=this.getFolderConsolidatedConfiguration(o.uri)||n);const a=this._memoryConfigurationByResource.get(e);a&&(n=n.merge(a))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(e);o?(i=n.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=n}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const n=i.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:n,overrides:o,keys:a}=this._folderConfigurations.get(i);return e.push([i,{contents:n,overrides:o,keys:a}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>e.add(n))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(o=>i.add(o))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),o=this.parseConfigurationModel(e.workspace),a=e.folders.reduce((h,p)=>(h.set(L.URI.revive(p[0]),this.parseConfigurationModel(p[1])),h),new O.ResourceMap);return new I(i,n,new F,o,a,new F,new O.ResourceMap,!1)}static parseConfigurationModel(e){return new F(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=I;function b(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,i=new Map;for(const o of s)o.keys.forEach(a=>e.add(a)),o.overrides.forEach(([a,h])=>{const p=(0,O.getOrSet)(i,a,new Set);h.forEach(M=>p.add(M))});const n=[];return i.forEach((o,a)=>n.push([a,[...o.values()]])),{keys:[...e.values()],overrides:n}}t.mergeChanges=b;class l{constructor(e,i,n,o){this.change=e,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=o,this._previousConfiguration=void 0;const a=new Set;e.keys.forEach(p=>a.add(p)),e.overrides.forEach(([,p])=>p.forEach(M=>a.add(M))),this.affectedKeys=[...a.values()];const h=new F;this.affectedKeys.forEach(p=>h.setValue(p,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=I.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(e,i,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!T.equals(n,o)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let n=(0,d.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof n=="object"&&(o=Object.keys(n)[0]);){if(e=e[o],!e)return!1;n=n[o]}return!0}}t.ConfigurationChangeEvent=l;class r extends l{constructor(e,i,n,o){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=n,this.sourceConfig=o}}t.AllKeysConfigurationChangeEvent=r}),define(Y[111],ee([0,1,25,30,2,27,110,13,4,20]),function(_,t,m,O,E,P,T,L,u,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class y extends E.Disposable{constructor(w,F){super();this.settingsResource=w,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new T.UserSettings(this.settingsResource,void 0,d.extUriBiasedIgnorePathCase,F)),this.configuration=new T.Configuration(new T.DefaultConfigurationModel,new T.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new u.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(O.Extensions.Configuration).onDidUpdateConfiguration(c=>this.onDidDefaultConfigurationChange(c))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const w=await this.userConfiguration.loadConfiguration();this.configuration=new T.Configuration(new T.DefaultConfigurationModel,w)}getConfigurationData(){return this.configuration.toData()}getValue(w,F){const c=typeof w=="string"?w:void 0,f=(0,P.isConfigurationOverrides)(w)?w:(0,P.isConfigurationOverrides)(F)?F:{};return this.configuration.getValue(c,f,void 0)}updateValue(w,F,c,f){return Promise.reject(new Error("not supported"))}inspect(w){return this.configuration.inspect(w,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const w=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(w)}onDidChangeUserConfiguration(w){const F=this.configuration.toData(),c=this.configuration.compareAndUpdateLocalUserConfiguration(w);this.trigger(c,F,1)}onDidDefaultConfigurationChange(w){const F=this.configuration.toData(),c=this.configuration.compareAndUpdateDefaultConfiguration(new T.DefaultConfigurationModel,w);this.trigger(c,F,6)}trigger(w,F,c){const f=new T.ConfigurationChangeEvent(w,{data:F},this.configuration);f.source=c,f.sourceConfig=this.getTargetConfiguration(c),this._onDidChangeConfiguration.fire(f)}getTargetConfiguration(w){switch(w){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=y}),define(Y[55],ee([0,1,84,11,30,25,16]),function(_,t,m,O,E,P,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,O.createDecorator)("requestService");function L(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}t.isSuccess=L;function u(c){return c.res.statusCode===204}async function d(c){if(!L(c))throw new Error("Server returned "+c.res.statusCode);return u(c)?null:(await(0,T.streamToBuffer)(c.stream)).toString()}t.asText=d;async function y(c){if(!L(c))throw new Error("Server returned "+c.res.statusCode);if(u(c))return null;const D=(await(0,T.streamToBuffer)(c.stream)).toString();try{return JSON.parse(D)}catch(I){throw I.message+=`:
`+D,I}}t.asJson=y;function v(c){F(c)}t.updateProxyConfigurationsScope=v;let w;function F(c){const f=P.Registry.as(E.Extensions.Configuration);w&&f.deregisterConfigurations([w]),w={id:"http",order:15,title:(0,m.localize)(0,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,m.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,m.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,m.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,m.localize)(4,null),(0,m.localize)(5,null),(0,m.localize)(6,null),(0,m.localize)(7,null)],default:"override",description:(0,m.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,m.localize)(9,null),restricted:!0}}},f.registerConfiguration(w)}F(2)}),define(Y[112],ee([0,1,113,12]),function(_,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function E(T,L){return T.protocol==="http:"?L.HTTP_PROXY||L.http_proxy||null:T.protocol==="https:"&&(L.HTTPS_PROXY||L.https_proxy||L.HTTP_PROXY||L.http_proxy)||null}async function P(T,L,u={}){const d=(0,m.parse)(T),y=u.proxyUrl||E(d,L);if(!y)return null;const v=(0,m.parse)(y);if(!/^https?:$/.test(v.protocol||""))return null;const w={host:v.hostname||"",port:v.port||(v.protocol==="https"?"443":"80"),auth:v.auth,rejectUnauthorized:(0,O.isBoolean)(u.strictSSL)?u.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((F,c)=>{_(["http-proxy-agent"],F,c)}))(w):new(await new Promise((F,c)=>{_(["https-proxy-agent"],F,c)}))(w)}t.getProxyAgent=P}),define(Y[114],ee([0,1,29,16]),function(_,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function E(P,T,L){let u=L&&L.get("storage.serviceMachineId",0)||null;if(u)return u;try{const y=(await T.readFile(P.serviceMachineIdResource)).value.toString();u=(0,m.isUUID)(y)?y:null}catch(d){u=null}if(!u){u=(0,m.generateUuid)();try{await T.writeFile(P.serviceMachineIdResource,O.VSBuffer.fromString(u))}catch(d){}}return L&&L.store("storage.serviceMachineId",u,0,1),u}t.getServiceMachineId=E}),define(Y[115],ee([0,1,11,13,2,12,66,4]),function(_,t,m,O,E,P,T,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const u="__$__targetStorageMarker";t.IStorageService=(0,m.createDecorator)("storageService");var d;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(d=t.WillSaveStateReason||(t.WillSaveStateReason={}));var y;(function(f){f[f.GLOBAL=0]="GLOBAL",f[f.WORKSPACE=1]="WORKSPACE"})(y=t.StorageScope||(t.StorageScope={}));var v;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(v=t.StorageTarget||(t.StorageTarget={}));class w extends E.Disposable{constructor(D={flushInterval:w.DEFAULT_FLUSH_INTERVAL}){super();this.options=D,this._onDidChangeValue=this._register(new O.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new O.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new O.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new L.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new E.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,L.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,E.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(D,I){I===u?(D===0?this._globalKeyTargets=void 0:D===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:D})):this._onDidChangeValue.fire({scope:D,key:I,target:this.getKeyTargets(D)[I]})}emitWillSaveState(D){this._onWillSaveState.fire({reason:D})}get(D,I,b){return this.getStorage(I)?.get(D,b)}getBoolean(D,I,b){return this.getStorage(I)?.getBoolean(D,b)}getNumber(D,I,b){return this.getStorage(I)?.getNumber(D,b)}store(D,I,b,l){if((0,P.isUndefinedOrNull)(I)){this.remove(D,b);return}this.withPausedEmitters(()=>{this.updateKeyTarget(D,b,l),this.getStorage(b)?.set(D,I)})}remove(D,I){this.withPausedEmitters(()=>{this.updateKeyTarget(D,I,void 0),this.getStorage(I)?.delete(D)})}withPausedEmitters(D){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{D()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(D,I){const b=[],l=this.getKeyTargets(D);for(const r of Object.keys(l))l[r]===I&&b.push(r);return b}updateKeyTarget(D,I,b){const l=this.getKeyTargets(I);typeof b=="number"?l[D]!==b&&(l[D]=b,this.getStorage(I)?.set(u,JSON.stringify(l))):typeof l[D]=="number"&&(delete l[D],this.getStorage(I)?.set(u,JSON.stringify(l)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(D){return D===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(D){const I=this.get(u,D);if(I)try{return JSON.parse(I)}catch(b){}return Object.create(null)}isNew(D){return this.getBoolean(t.IS_NEW_KEY,D)===!0}async flush(){this._onWillSaveState.fire({reason:d.NONE}),await L.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const D=this.getStorage(0)?.items??new Map,I=this.getStorage(1)?.items??new Map;return c(D,I,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=w,w.DEFAULT_FLUSH_INTERVAL=60*1e3;class F extends w{constructor(){super();this.globalStorage=this._register(new T.Storage(new T.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new T.Storage(new T.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(D=>this.emitDidChangeValue(1,D))),this._register(this.globalStorage.onDidChangeStorage(D=>this.emitDidChangeValue(0,D)))}getStorage(D){return D===0?this.globalStorage:this.workspaceStorage}getLogDetails(D){return D===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(D){}}t.InMemoryStorageService=F;async function c(f,D,I,b){const l=a=>{try{return JSON.parse(a)}catch(h){return a}},r=new Map,s=new Map;f.forEach((a,h)=>{r.set(h,a),s.set(h,l(a))});const e=new Map,i=new Map;D.forEach((a,h)=>{e.set(h,a),i.set(h,l(a))}),console.group(`Storage: Global (path: ${I})`);let n=[];r.forEach((a,h)=>{n.push({key:h,value:a})}),console.table(n),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${b})`);let o=[];e.forEach((a,h)=>{o.push({key:h,value:a})}),console.table(o),console.groupEnd(),console.log(i)}t.logStorage=c}),define(Y[116],ee([0,1,15,33,29,7]),function(_,t,m,O,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function T(d){if(m.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function L(d,y,v,w,F,c,f,D,I,b){const l=Object.create(null);l["common.machineId"]=f,l.sessionID=(0,E.generateUuid)()+Date.now(),l.commitHash=F,l.version=c,l["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,m.PlatformToString)(m.platform),l["common.nodePlatform"]=O.platform,l["common.nodeArch"]=w,l["common.product"]=b||"desktop";const r=u(D||[]);r&&(l["common.msftInternal"]=r);let s=0;const e=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),m.isLinuxSnap&&(l["common.snap"]="true");const i=T(v);i&&(l["common.platformDetail"]=i);try{const n=await d.readFile(P.URI.file(I));l["common.source"]=n.value.toString().slice(0,30)}catch(n){}return l}t.resolveCommonProperties=L;function u(d){const y=O.env.USERDNSDOMAIN;if(!y)return!1;const v=y.toLowerCase();return d.some(w=>v===w)}t.verifyMicrosoftInternalDomain=u}),define(Y[35],ee([0,1,11]),function(_,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,m.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,m.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(Y[117],ee([0,1,74,2,22,23,13,34,14,35,26,8,7,4]),function(_,t,m,O,E,P,T,L,u,d,y,v,w,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=t.INSTALL_ERROR_LOCAL=t.ERROR_UNKNOWN=t.INSTALL_ERROR_VALIDATING=void 0,t.INSTALL_ERROR_VALIDATING="validating",t.ERROR_UNKNOWN="unknown",t.INSTALL_ERROR_LOCAL="local";let c=class extends O.Disposable{constructor(l,r,s){super();this.galleryService=l,this.telemetryService=r,this.logService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,O.toDisposable)(()=>{this.installingExtensions.forEach(e=>e.cancel()),this.uninstallingExtensions.forEach(e=>e.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async installFromGallery(l,r={}){if(!this.galleryService.isEnabled())throw new Error(m.localize(0,null));try{l=await this.checkAndGetCompatibleVersion(l)}catch(e){throw this.logService.error((0,v.getErrorMessage)(e)),D(this.telemetryService,"extensionGallery:install",(0,P.getGalleryExtensionTelemetryData)(l),void 0,e),e}if(!await this.canInstall(l)){const e=new E.ExtensionManagementError("Not supported",t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Canno install extension as it is not supported.",l.identifier.id,e.message),D(this.telemetryService,"extensionGallery:install",(0,P.getGalleryExtensionTelemetryData)(l),void 0,e),e}const s=await this.galleryService.getManifest(l,y.CancellationToken.None);if(s===null){const e=new E.ExtensionManagementError(`Missing manifest for extension ${l.identifier.id}`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",l.identifier.id,e.message),D(this.telemetryService,"extensionGallery:install",(0,P.getGalleryExtensionTelemetryData)(l),void 0,e),e}return this.installExtension(s,l,r)}async uninstall(l,r={}){return this.logService.trace("ExtensionManagementService#uninstall",l.identifier.id),this.unininstallExtension(l,r)}async reinstallFromGallery(l){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",l.identifier.id),!this.galleryService.isEnabled())throw new Error(m.localize(1,null));const r=await this.findGalleryExtension(l);if(!r)throw new Error(m.localize(2,null));await this.createUninstallExtensionTask(l,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(r)}getExtensionsReport(){const l=new Date().getTime();return(!this.reportedExtensions||l-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=l),this.reportedExtensions}registerParticipant(l){this.participants.push(l)}async installExtension(l,r,s){if(!w.URI.isUri(r)){let a=this.installingExtensions.get(new P.ExtensionIdentifierWithVersion(r.identifier,r.version).key());if(a)return this.logService.info("Extensions is already requested to install",r.identifier.id),a.waitUntilTaskIsFinished();s={...s,installOnlyNewlyAddedFromExtensionPack:!0}}const e=[],i=[],n=this.createInstallExtensionTask(l,r,s);w.URI.isUri(r)||this.installingExtensions.set(new P.ExtensionIdentifierWithVersion(n.identifier,l.version).key(),n),this._onInstallExtension.fire({identifier:n.identifier,source:r}),this.logService.info("Installing extension:",n.identifier.id),e.push({task:n,manifest:l});let o=!1;try{if(s.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",n.identifier.id);else try{const h=await this.getAllDepsAndPackExtensionsToInstall(n.identifier,l,!!s.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:p,manifest:M}of h)if(o=o||!!M.extensionDependencies?.some(C=>(0,P.areSameExtensions)({id:C},n.identifier)),this.installingExtensions.has(new P.ExtensionIdentifierWithVersion(p.identifier,p.version).key()))this.logService.info("Extension is already requested to install",p.identifier.id);else{const C=this.createInstallExtensionTask(M,p,{...s,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new P.ExtensionIdentifierWithVersion(C.identifier,M.version).key(),C),this._onInstallExtension.fire({identifier:C.identifier,source:p}),this.logService.info("Installing extension:",C.identifier.id),e.push({task:C,manifest:M})}}catch(h){throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",n.identifier.id),this.logService.error(h),h}const a=e.reduce((h,{task:p,manifest:M})=>(h.set(p.identifier.id.toLowerCase(),{task:p,manifest:M}),h),new Map);for(;a.size;){let h;const p=[...a.values()].filter(({manifest:M})=>!M.extensionDependencies?.some(C=>a.has(C.toLowerCase())));p.length?h=a.size===1?p:p.filter(({task:M})=>!(M===n&&!o)):(this.logService.info("Found extensions with circular dependencies",p.map(({task:M})=>M.identifier.id)),h=[...a.values()]),await this.joinAllSettled(h.map(async({task:M})=>{const C=new Date().getTime();try{const N=await M.run();await this.joinAllSettled(this.participants.map(V=>V.postInstall(N,M.source,s,y.CancellationToken.None))),w.URI.isUri(M.source)||D(this.telemetryService,M.operation===2?"extensionGallery:update":"extensionGallery:install",(0,P.getGalleryExtensionTelemetryData)(M.source),new Date().getTime()-C,void 0),i.push({local:N,identifier:M.identifier,operation:M.operation,source:M.source})}catch(N){throw w.URI.isUri(M.source)||D(this.telemetryService,M.operation===2?"extensionGallery:update":"extensionGallery:install",(0,P.getGalleryExtensionTelemetryData)(M.source),new Date().getTime()-C,N),this.logService.error("Error while installing the extension:",M.identifier.id),this.logService.error(N),N}finally{a.delete(M.identifier.id.toLowerCase())}}))}return i.forEach(({identifier:h})=>this.logService.info("Extension installed successfully:",h.id)),this._onDidInstallExtensions.fire(i),i.filter(({identifier:h})=>(0,P.areSameExtensions)(h,n.identifier))[0].local}catch(a){if(e.forEach(({task:h})=>h.cancel()),i.length)try{const h=await Promise.allSettled(i.map(({local:p})=>this.createUninstallExtensionTask(p,{versionOnly:!0}).run()));for(let p=0;p<h.length;p++){const M=h[p],{identifier:C}=i[p];M.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",C.id):this.logService.warn("Rollback: Error while uninstalling extension",C.id,(0,v.getErrorMessage)(M.reason))}}catch(h){this.logService.warn("Error while rolling back extensions",(0,v.getErrorMessage)(h),i.map(({identifier:p})=>p.id))}throw this.logService.error("Failed to install extension:",n.identifier.id,(0,v.getErrorMessage)(a)),this._onDidInstallExtensions.fire(e.map(({task:h})=>({identifier:h.identifier,operation:1,source:h.source}))),a instanceof Error&&(a.name=a&&a.code?a.code:t.ERROR_UNKNOWN),a}finally{for(const{task:a,manifest:h}of e)if(!w.URI.isUri(a.source)){const p=new P.ExtensionIdentifierWithVersion(a.identifier,h.version).key();this.installingExtensions.delete(p)||this.logService.warn("Installation task is not found in the cache",p)}}}async joinAllSettled(l){const r=[],s=[],e=await Promise.allSettled(l);for(const i of e)i.status==="fulfilled"?r.push(i.value):s.push(i.reason);if(s.length)throw f(s);return r}async getAllDepsAndPackExtensionsToInstall(l,r,s){if(!this.galleryService.isEnabled())return[];let e=await this.getInstalled();const i=[l,...e.map(a=>a.identifier)],n=[],o=async(a,h)=>{const p=h.extensionDependencies||[];if(h.extensionPack){const M=s?e.find(C=>(0,P.areSameExtensions)(C.identifier,a)):void 0;for(const C of h.extensionPack)M&&M.manifest.extensionPack&&M.manifest.extensionPack.some(N=>(0,P.areSameExtensions)({id:N},{id:C}))||p.every(N=>!(0,P.areSameExtensions)({id:N},{id:C}))&&p.push(C)}if(p.length){const M=[...i,...n.map(N=>N.gallery.identifier)],C=p.filter(N=>M.every(V=>!(0,P.areSameExtensions)(V,{id:N})));if(C.length){const N=await this.galleryService.query({names:C,pageSize:p.length},y.CancellationToken.None);for(const V of N.firstPage){if(M.find(ie=>(0,P.areSameExtensions)(ie,V.identifier)))continue;const W=await this.checkAndGetCompatibleVersion(V);if(!await this.canInstall(W)){this.logService.info("Skipping the extension as it cannot be installed",W.identifier.id);continue}const Q=await this.galleryService.getManifest(W,y.CancellationToken.None);if(Q===null)throw new E.ExtensionManagementError(`Missing manifest for extension ${W.identifier.id}`,t.INSTALL_ERROR_VALIDATING);n.push({gallery:W,manifest:Q}),await o(W.identifier,Q)}}}};return await o(l,r),e=await this.getInstalled(),n.filter(a=>!e.some(h=>(0,P.areSameExtensions)(h.identifier,a.gallery.identifier)))}async checkAndGetCompatibleVersion(l){if(await this.isMalicious(l))throw new E.ExtensionManagementError(m.localize(3,null,l.identifier.id),E.INSTALL_ERROR_MALICIOUS);const r=await this.galleryService.getCompatibleExtension(l);if(!r)throw new E.ExtensionManagementError(m.localize(4,null,l.identifier.id,L.default.version),E.INSTALL_ERROR_INCOMPATIBLE);return r}async isMalicious(l){const r=await this.getExtensionsReport();return(0,P.getMaliciousExtensionsSet)(r).has(l.identifier.id)}async unininstallExtension(l,r){const s=this.uninstallingExtensions.get(l.identifier.id.toLowerCase());if(s)return this.logService.info("Extensions is already requested to uninstall",l.identifier.id),s.waitUntilTaskIsFinished();const e=(a,h)=>{const p=this.createUninstallExtensionTask(a,h);return this.uninstallingExtensions.set(p.extension.identifier.id.toLowerCase(),p),this.logService.info("Uninstalling extension:",a.identifier.id),this._onUninstallExtension.fire(a.identifier),p},i=(a,h)=>{h?this.logService.error("Failed to uninstall extension:",a.identifier.id,h.message):this.logService.info("Successfully uninstalled extension:",a.identifier.id),D(this.telemetryService,"extensionGallery:uninstall",(0,P.getLocalExtensionTelemetryData)(a),void 0,h),this._onDidUninstallExtension.fire({identifier:a.identifier,error:h?.code})},n=[],o=[];try{n.push(e(l,{}));const a=await this.getInstalled(1);if(r.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",l.identifier.id);else{const h=this.getAllPackExtensionsToUninstall(l,a);for(const p of h)this.uninstallingExtensions.has(p.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",p.identifier.id):n.push(e(p,{}))}r.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",l.identifier.id):this.checkForDependents(n.map(h=>h.extension),a,l),await this.joinAllSettled(n.map(async h=>{try{if(await h.run(),await this.joinAllSettled(this.participants.map(p=>p.postUninstall(h.extension,r,y.CancellationToken.None))),h.extension.identifier.uuid)try{await this.galleryService.reportStatistic(h.extension.manifest.publisher,h.extension.manifest.name,h.extension.manifest.version,"uninstall")}catch(p){}i(h.extension)}catch(p){const M=p instanceof E.ExtensionManagementError?p:new E.ExtensionManagementError((0,v.getErrorMessage)(p),t.ERROR_UNKNOWN);throw i(h.extension,M),M}finally{o.push(h)}}))}catch(a){const h=a instanceof E.ExtensionManagementError?a:new E.ExtensionManagementError((0,v.getErrorMessage)(a),t.ERROR_UNKNOWN);for(const p of n){try{p.cancel()}catch(M){}o.includes(p)||i(p.extension,h)}throw h}finally{for(const a of n)this.uninstallingExtensions.delete(a.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",a.extension.identifier.id)}}checkForDependents(l,r,s){for(const e of l){const i=this.getDependents(e,r);if(i.length){const n=i.filter(o=>l.indexOf(o)===-1);if(n.length)throw new Error(this.getDependentsErrorMessage(e,n,s))}}}getDependentsErrorMessage(l,r,s){return s===l?r.length===1?m.localize(5,null,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?m.localize(6,null,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):m.localize(7,null,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?m.localize(8,null,s.manifest.displayName||s.manifest.name,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?m.localize(9,null,s.manifest.displayName||s.manifest.name,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):m.localize(10,null,s.manifest.displayName||s.manifest.name,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(l,r,s=[]){if(s.indexOf(l)!==-1)return[];s.push(l);const e=l.manifest.extensionPack?l.manifest.extensionPack:[];if(e.length){const i=r.filter(o=>!o.isBuiltin&&e.some(a=>(0,P.areSameExtensions)({id:a},o.identifier))),n=[];for(const o of i)n.push(...this.getAllPackExtensionsToUninstall(o,r,s));return[...i,...n]}return[]}getDependents(l,r){return r.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(e=>(0,P.areSameExtensions)({id:e},l.identifier)))}async findGalleryExtension(l){if(l.identifier.uuid){const r=await this.findGalleryExtensionById(l.identifier.uuid);return r||this.findGalleryExtensionByName(l.identifier.id)}return this.findGalleryExtensionByName(l.identifier.id)}async findGalleryExtensionById(l){return(await this.galleryService.query({ids:[l],pageSize:1},y.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(l){return(await this.galleryService.query({names:[l],pageSize:1},y.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const l=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${l.length} reported extensions from service`),l}catch(l){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};c=ce([ue(0,E.IExtensionGalleryService),ue(1,d.ITelemetryService),ue(2,u.ILogService)],c),t.AbstractExtensionManagementService=c;function f(b){const l=Array.isArray(b)?b:[b];return l.length===1?l[0]instanceof Error?l[0]:new Error(l[0]):l.reduce((r,s)=>new Error(`${r.message}${r.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}t.joinErrors=f;function D(b,l,r,s,e){const i=e?e instanceof E.ExtensionManagementError?e.code:t.ERROR_UNKNOWN:void 0;b.publicLogError(l,{...r,success:!e,duration:s,errorcode:i})}t.reportTelemetry=D;class I{constructor(){this.barrier=new F.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,F.createCancelablePromise)(l=>this.doRun(l))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,F.createCancelablePromise)(l=>new Promise((r,s)=>{const e=l.onCancellationRequested(()=>{e.dispose(),s((0,v.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=I}),define(Y[118],ee([0,1,8,22,23,19,35,55,49,21,26,14,17,7,42,115,114,11]),function(_,t,m,O,E,P,T,L,u,d,y,v,w,F,c,f,D,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0;var b;(function(j){j[j.None=0]="None",j[j.IncludeVersions=1]="IncludeVersions",j[j.IncludeFiles=2]="IncludeFiles",j[j.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",j[j.IncludeSharedAccounts=8]="IncludeSharedAccounts",j[j.IncludeVersionProperties=16]="IncludeVersionProperties",j[j.ExcludeNonValidated=32]="ExcludeNonValidated",j[j.IncludeInstallationTargets=64]="IncludeInstallationTargets",j[j.IncludeAssetUri=128]="IncludeAssetUri",j[j.IncludeStatistics=256]="IncludeStatistics",j[j.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",j[j.Unpublished=4096]="Unpublished"})(b||(b={}));function l(...j){return String(j.reduce((x,q)=>x|q,0))}var r;(function(j){j[j.Tag=1]="Tag",j[j.ExtensionId=4]="ExtensionId",j[j.Category=5]="Category",j[j.ExtensionName=7]="ExtensionName",j[j.Target=8]="Target",j[j.Featured=9]="Featured",j[j.SearchText=10]="SearchText",j[j.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},e={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},n={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:b.None,criteria:[],assetTypes:[]};class o{constructor(x=n){this.state=x}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(x,q=this.state.pageSize){return new o({...this.state,pageNumber:x,pageSize:q})}withFilter(x,...q){const S=[...this.state.criteria,...q.length?q.map(g=>({filterType:x,value:g})):[{filterType:x}]];return new o({...this.state,criteria:S})}withSortBy(x){return new o({...this.state,sortBy:x})}withSortOrder(x){return new o({...this.state,sortOrder:x})}withFlags(...x){return new o({...this.state,flags:x.reduce((q,S)=>q|S,0)})}withAssetTypes(...x){return new o({...this.state,assetTypes:x})}get raw(){const{criteria:x,pageNumber:q,pageSize:S,sortBy:g,sortOrder:R,flags:A,assetTypes:k}=this.state;return{filters:[{criteria:x,pageNumber:q,pageSize:S,sortBy:g,sortOrder:R}],assetTypes:k,flags:A}}get searchText(){const x=this.state.criteria.filter(q=>q.filterType===r.SearchText)[0];return x&&x.value?x.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(x=>String(x.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function a(j,x){const q=(j||[]).filter(S=>S.statisticName===x)[0];return q?q.value:0}function h(j){const x="Microsoft.VisualStudio.Code.Translation.";return j.files.filter(S=>S.assetType.indexOf(x)===0).reduce((S,g)=>{const R=N(j,g.assetType);return R&&S.push([g.assetType.substring(x.length),R]),S},[])}function p(j){if(j.properties){const x=j.properties.filter(g=>g.key===s.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),S=x.filter(g=>q.test(g.value))[0];return S?{uri:S.value,fallbackUri:S.value}:null}return N(j,s.Repository)}function M(j){return{uri:`${j.fallbackAssetUri}/${s.VSIX}?redirect=true`,fallbackUri:`${j.fallbackAssetUri}/${s.VSIX}`}}function C(j){const x=N(j,s.Icon);if(x)return x;const q=O.DefaultIconPath;return{uri:q,fallbackUri:q}}function N(j,x){return j.files.filter(S=>S.assetType===x)[0]?{uri:`${j.assetUri}/${x}`,fallbackUri:`${j.fallbackAssetUri}/${x}`}:null}function V(j,x){const q=j.properties?j.properties.filter(g=>g.key===x):[],S=q.length>0&&q[0].value;return S?S.split(",").map(g=>(0,E.adoptToGalleryExtensionId)(g)):[]}function W(j){const x=j.properties?j.properties.filter(q=>q.key===e.Engine):[];return x.length>0&&x[0].value||""}function Q(j){const x=j.properties?j.properties.filter(S=>S.key===e.LocalizedLanguages):[],q=x.length>0&&x[0].value||"";return q?q.split(","):[]}function ie(j){return j.indexOf("preview")!==-1}function re(j,x,q,S,g){const R={manifest:N(x,s.Manifest),readme:N(x,s.Details),changelog:N(x,s.Changelog),license:N(x,s.License),repository:p(x),download:M(x),icon:C(x),coreTranslations:h(x)};return{identifier:{id:(0,E.getGalleryExtensionId)(j.publisher.publisherName,j.extensionName),uuid:j.extensionId},name:j.extensionName,version:x.version,date:x.lastUpdated,displayName:j.displayName,publisherId:j.publisher.publisherId,publisher:j.publisher.publisherName,publisherDisplayName:j.publisher.displayName,description:j.shortDescription||"",installCount:a(j.statistics,"install"),rating:a(j.statistics,"averagerating"),ratingCount:a(j.statistics,"ratingcount"),assetUri:F.URI.parse(x.assetUri),webExtension:!!j.tags?.includes(O.WEB_EXTENSION_TAG),assetTypes:x.files.map(({assetType:A})=>A),assets:R,properties:{dependencies:V(x,e.Dependency),extensionPack:V(x,e.ExtensionPack),engine:W(x),localizedLanguages:Q(x)},telemetryData:{index:(S.pageNumber-1)*S.pageSize+q,querySource:g},preview:ie(j.flags)}}let Z=class{constructor(x,q,S,g,R,A,k){this.requestService=x,this.logService=q,this.environmentService=S,this.telemetryService=g,this.fileService=R,this.productService=A;const U=A.extensionsGallery;this.extensionsGalleryUrl=U&&U.serviceUrl,this.extensionsControlUrl=U&&U.controlUrl,this.commonHeadersPromise=X(A.version,this.environmentService,this.fileService,k)}api(x=""){return`${this.extensionsGalleryUrl}${x}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(x,q){const S=[];let{total:g,firstPage:R,getPage:A}=await this.query({names:x,pageSize:x.length},q);S.push(...R);for(let k=1;S.length<g&&(R=await A(k,q),R.length);k++)S.push(...R);return S}async getCompatibleExtension(x,q){return this.getCompatibleExtensionByEngine(x,q)}async getCompatibleExtensionByEngine(x,q){const S=(0,O.isIExtensionIdentifier)(x)?null:x;if(S&&S.properties.engine&&(0,u.isEngineValid)(S.properties.engine,this.productService.version,this.productService.date))return S;const{id:g,uuid:R}=S?S.identifier:x;let A=new o().withFlags(b.IncludeAssetUri,b.IncludeStatistics,b.IncludeCategoryAndTags,b.IncludeFiles,b.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");R?A=A.withFilter(r.ExtensionId,R):A=A.withFilter(r.ExtensionName,g);const{galleryExtensions:k}=await this.queryGallery(A,y.CancellationToken.None),[U]=k;if(!U||!U.versions.length)return null;if(q){const $=U.versions.filter(H=>H.version===q)[0];if($){const H=re(U,$,0,A);if(H.properties.engine&&(0,u.isEngineValid)(H.properties.engine,this.productService.version,this.productService.date))return H}return null}const B=await this.getLastValidExtensionVersion(U,U.versions);return B?re(U,B,0,A):null}async query(x,q){const S=y.CancellationToken.isCancellationToken(x)?{}:x,g=y.CancellationToken.isCancellationToken(x)?x:q;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let R=S.text||"";const A=(0,P.getOrDefault)(S,J=>J.pageSize,50);let k=new o().withFlags(b.IncludeLatestVersionOnly,b.IncludeAssetUri,b.IncludeStatistics,b.IncludeCategoryAndTags,b.IncludeFiles,b.IncludeVersionProperties).withPage(1,A).withFilter(r.Target,"Microsoft.VisualStudio.Code");R?(R=R.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(J,te,ne)=>(k=k.withFilter(r.Category,ne||te),"")),R=R.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(J,te,ne)=>(k=k.withFilter(r.Tag,ne||te),"")),R=R.replace(/\bfeatured(\s+|\b|$)/g,()=>(k=k.withFilter(r.Featured),"")),R=R.trim(),R&&(R=R.length<200?R:R.substring(0,200),k=k.withFilter(r.SearchText,R)),k=k.withSortBy(0)):S.ids?k=k.withFilter(r.ExtensionId,...S.ids):S.names?k=k.withFilter(r.ExtensionName,...S.names):k=k.withSortBy(4),typeof S.sortBy=="number"&&(k=k.withSortBy(S.sortBy)),typeof S.sortOrder=="number"&&(k=k.withSortOrder(S.sortOrder));const{galleryExtensions:U,total:B}=await this.queryGallery(k,g),$=U.map((J,te)=>re(J,J.versions[0],te,k,S.source)),H=async(J,te)=>{if(te.isCancellationRequested)throw(0,m.canceled)();const ne=k.withPage(J+1),{galleryExtensions:ae}=await this.queryGallery(ne,te);return ae.map((he,ve)=>re(he,he.versions[0],ve,ne,S.source))};return{firstPage:$,total:B,pageSize:k.pageSize,getPage:H}}async queryGallery(x,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");x=x.withFlags(x.flags,b.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,l(b.Unpublished));const S=await this.commonHeadersPromise,g=JSON.stringify(x.raw),R={...S,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(g.length)},A=new Date().getTime();let k,U,B=0;try{if(k=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:g,headers:R},q),k.res.statusCode&&k.res.statusCode>=400&&k.res.statusCode<500)return{galleryExtensions:[],total:B};const $=await(0,L.asJson)(k);if($){const H=$.results[0],J=H.extensions,te=H.resultMetadata&&H.resultMetadata.filter(ne=>ne.metadataType==="ResultCount")[0];return B=te&&te.metadataItems.filter(ne=>ne.name==="TotalCount")[0].count||0,{galleryExtensions:J,total:B}}return{galleryExtensions:[],total:B}}catch($){throw U=$,$}finally{this.telemetryService.publicLog2("galleryService:query",{...x.telemetryData,requestBodySize:String(g.length),duration:new Date().getTime()-A,success:!!k&&(0,L.isSuccess)(k),responseBodySize:k?.res.headers["Content-Length"],statusCode:k?String(k.res.statusCode):void 0,errorCode:U?(0,m.isPromiseCanceledError)(U)?"canceled":(0,m.getErrorMessage)(U).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(B)})}}async reportStatistic(x,q,S,g){if(!this.isEnabled())return;const A={...await this.commonHeadersPromise,Accept:"*/*;api-version=4.0-preview.1"};try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${x}/extensions/${q}/${S}/stats?statType=${g}`),headers:A},y.CancellationToken.None)}catch(k){}}async download(x,q,S){this.logService.trace("ExtensionGalleryService#download",x.identifier.id);const g=(0,E.getGalleryExtensionTelemetryData)(x),R=new Date().getTime(),A=$=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...g,duration:$}),k=S===1?"install":S===2?"update":"",U=k?{uri:`${x.assets.download.uri}&${k}=true`,fallbackUri:`${x.assets.download.fallbackUri}?${k}=true`}:x.assets.download,B=await this.getAsset(U);await this.fileService.writeFile(q,B.stream),A(new Date().getTime()-R)}async getReadme(x,q){if(x.assets.readme){const S=await this.getAsset(x.assets.readme,{},q);return await(0,L.asText)(S)||""}return""}async getManifest(x,q){if(x.assets.manifest){const S=await this.getAsset(x.assets.manifest,{},q),g=await(0,L.asText)(S);return g?JSON.parse(g):null}return null}async getCoreTranslation(x,q){const S=x.assets.coreTranslations.filter(g=>g[0]===q.toUpperCase())[0];if(S){const g=await this.getAsset(S[1]),R=await(0,L.asText)(g);return R?JSON.parse(R):null}return null}async getChangelog(x,q){if(x.assets.changelog){const S=await this.getAsset(x.assets.changelog,{},q);return await(0,L.asText)(S)||""}return""}async getAllVersions(x,q){let S=new o().withFlags(b.IncludeVersions,b.IncludeCategoryAndTags,b.IncludeFiles,b.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");x.identifier.uuid?S=S.withFilter(r.ExtensionId,x.identifier.uuid):S=S.withFilter(r.ExtensionName,x.identifier.id);const g=[],{galleryExtensions:R}=await this.queryGallery(S,y.CancellationToken.None);return R.length&&(q?await Promise.all(R[0].versions.map(async A=>{let k;try{k=await this.getEngine(A)}catch(U){}k&&(0,u.isEngineValid)(k,this.productService.version,this.productService.date)&&g.push({version:A.version,date:A.lastUpdated})})):g.push(...R[0].versions.map(A=>({version:A.version,date:A.lastUpdated})))),g}async getAsset(x,q={},S=y.CancellationToken.None){const g=await this.commonHeadersPromise,R={type:"GET"},A={...g,...q.headers||{}};q={...q,...R,headers:A};const k=x.uri,U=x.fallbackUri,B={...q,url:k};try{const $=await this.requestService.request(B,S);if($.res.statusCode===200)return $;const H=await(0,L.asText)($);throw new Error(`Expected 200, got back ${$.res.statusCode} instead.

${H}`)}catch($){if((0,m.isPromiseCanceledError)($))throw $;const H=(0,m.getErrorMessage)($);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:k,message:H});const J={...q,url:U};return this.requestService.request(J,S)}}async getLastValidExtensionVersion(x,q){const S=this.getLastValidExtensionVersionFromProperties(x,q);return S||this.getLastValidExtensionVersionRecursively(x,q)}getLastValidExtensionVersionFromProperties(x,q){for(const S of q){const g=W(S);if(!g)return null;if((0,u.isEngineValid)(g,this.productService.version,this.productService.date))return S}return null}async getEngine(x){const q=W(x);if(q)return q;const S=N(x,s.Manifest);if(!S)throw new Error("Manifest was not found");const g={"Accept-Encoding":"gzip"},R=await this.getAsset(S,{headers:g}),A=await(0,L.asJson)(R);if(A)return A.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(x,q){if(!q.length)return null;const S=q[0],g=await this.getEngine(S);return(0,u.isEngineValid)(g,this.productService.version,this.productService.date)?{...S,properties:[...S.properties||[],{key:e.Engine,value:g}]}:this.getLastValidExtensionVersionRecursively(x,q.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const x=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},y.CancellationToken.None);if(x.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,L.asJson)(x),S=new Map;if(q)for(const g of q.malicious){const R=S.get(g)||{id:{id:g},malicious:!0,slow:!1};R.malicious=!0,S.set(g,R)}return[...S.values()]}};Z=ce([ue(0,L.IRequestService),ue(1,v.ILogService),ue(2,d.IEnvironmentService),ue(3,T.ITelemetryService),ue(4,w.IFileService),ue(5,c.IProductService),ue(6,(0,I.optional)(f.IStorageService))],Z),t.ExtensionGalleryService=Z;async function X(j,x,q,S){const g={"X-Market-Client-Id":`VSCode ${j}`,"User-Agent":`VSCode ${j}`},R=await(0,D.getServiceMachineId)(x,q,S);return g["X-Market-User-Id"]=R,g}t.resolveMarketplaceHeaders=X}),define(Y[119],ee([0,1,34,85,18,11,27,30,2,19,25]),function(_,t,m,O,E,P,T,L,u,d,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let v=class{constructor(c,f){this._configurationService=f,this._experimentProperties={},this._disposables=new u.DisposableStore,this._cleanupPatterns=[],this._appender=c.appender,this._commonProperties=c.commonProperties||Promise.resolve({}),this._piiPaths=c.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!c.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let D of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,E.escapeRegExpCharacters)(D),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(D=>{const I=/^[a-f0-9]+$/i.test(D["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!I})}))}setExperimentProperty(c,f){this._experimentProperties[c]=f}setEnabled(c){this._enabled=c}_updateUserOptIn(){const c=this._configurationService?.getValue(w);this._userOptIn=c?c.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const c=await this._commonProperties;let f=c.sessionID,D=c["common.instanceId"],I=c["common.machineId"],b=c["common.firstSessionDate"],l=c["common.msftInternal"];return{sessionId:f,instanceId:D,machineId:I,firstSessionDate:b,msftInternal:l}}dispose(){this._disposables.dispose()}publicLog(c,f,D){return this.isOptedIn?this._commonProperties.then(I=>{f=(0,d.mixin)(f,I),f=(0,d.mixin)(f,this._experimentProperties),f=(0,d.cloneAndChange)(f,b=>{if(typeof b=="string")return this._cleanupInfo(b,D)}),this._appender.log(c,f)},I=>{console.error(I)}):Promise.resolve(void 0)}publicLog2(c,f,D){return this.publicLog(c,f,D)}publicLogError(c,f){return this.sendErrorTelemetry?this.publicLog(c,f,!0):Promise.resolve(void 0)}publicLogError2(c,f){return this.publicLogError(c,f)}_cleanupInfo(c,f){let D=c;if(f){const I=[];for(let s of this._cleanupPatterns)for(;;){const e=s.exec(c);if(!e)break;I.push([e.index,s.lastIndex])}const b=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let r=0;for(D="";;){const s=l.exec(c);if(!s)break;!b.test(s[0])&&I.every(([e,i])=>s.index<e||s.index>=i)&&(D+=c.substring(r,s.index)+"<REDACTED: user-file-path>",r=l.lastIndex)}r<c.length&&(D+=c.substr(r))}for(let I of this._cleanupPatterns)D=D.replace(I,"");return D}};v.IDLE_START_EVENT_NAME="UserIdleStart",v.IDLE_STOP_EVENT_NAME="UserIdleStop",v=ce([ue(1,(0,P.optional)(T.IConfigurationService))],v),t.TelemetryService=v;const w="telemetry";y.Registry.as(L.Extensions.Configuration).registerConfiguration({id:w,order:110,type:"object",title:(0,O.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,O.localize)(2,null,m.default.privacyStatementUrl):(0,O.localize)(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Y[56],ee([0,1,27,19,12,4]),function(_,t,m,O,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(c,f){return Promise.resolve(void 0)}publicLog2(c,f){return this.publicLog(c,f)}publicLogError(c,f){return Promise.resolve(void 0)}publicLogError2(c,f){return this.publicLogError(c,f)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class T{async publicLog(f,D,I){}async publicLogError(f,D,I){}}t.NullEndpointTelemetryService=T;function L(...c){return{log:(f,D)=>c.forEach(I=>I.log(f,D)),flush:()=>P.Promises.settled(c.map(f=>f.flush()))}}t.combinedAppender=L,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function u(c,f){return f.onDidChangeConfiguration(D=>{D.source!==6&&c.publicLog2("updateConfiguration",{configurationSource:(0,m.ConfigurationTargetToString)(D.source),configurationKeys:w(D.sourceConfig)})})}t.configurationTelemetry=u;function d(c){const f=Object.create(null),D=Object.create(null),I=Object.create(null);v(c,I);for(let b in I){b=b.length>150?b.substr(b.length-149):b;const l=I[b];typeof l=="number"?D[b]=l:typeof l=="boolean"?D[b]=l?1:0:typeof l=="string"?f[b]=l.substring(0,1023):typeof l!="undefined"&&l!==null&&(f[b]=l)}return{properties:f,measurements:D}}t.validateTelemetryData=d;function y(c){if(!c)return"none";let f="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(I=>{c.indexOf(`${I}+`)===0&&(f=I)}),f}t.cleanRemoteAuthority=y;function v(c,f,D=0,I){if(!!c)for(let b of Object.getOwnPropertyNames(c)){const l=c[b],r=I?I+b:b;Array.isArray(l)?f[r]=(0,O.safeStringify)(l):l instanceof Date?f[r]=l.toISOString():(0,E.isObject)(l)?D<2?v(l,f,D+1,r+"."):f[r]=(0,O.safeStringify)(l):f[r]=l}}function w(c){if(!c)return[];const f=[];return F(f,"",c),f}function F(c,f,D){D&&typeof D=="object"&&!Array.isArray(D)?Object.keys(D).forEach(I=>F(c,f?`${f}.${I}`:I,D[I])):c.push(f)}}),define(Y[120],ee([0,1,8,19,56]),function(_,t,m,O,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function P(L){const u=await new Promise((y,v)=>{_(["applicationinsights"],y,v)});let d;return u.defaultClient?(d=new u.TelemetryClient(L),d.channel.setUseDiskRetryCaching(!0)):(u.setup(L).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),d=u.defaultClient),L.indexOf("AIF-")===0&&(d.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),d}class T{constructor(u,d,y){this._eventPrefix=u,this._defaultData=d,this._defaultData||(this._defaultData=Object.create(null)),typeof y=="function"?this._aiClient=y():this._aiClient=y,this._asyncAIClient=null}_withAIClient(u){if(!!this._aiClient){if(typeof this._aiClient!="string"){u(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=P(this._aiClient)),this._asyncAIClient.then(d=>{u(d)},d=>{(0,m.onUnexpectedError)(d),console.error(d)})}}log(u,d){!this._aiClient||(d=(0,O.mixin)(d,this._defaultData),d=(0,E.validateTelemetryData)(d),this._withAIClient(y=>y.trackEvent({name:this._eventPrefix+"/"+u,properties:d.properties,measurements:d.measurements})))}flush(){return this._aiClient?new Promise(u=>{this._withAIClient(d=>{d.flush({callback:()=>{this._aiClient=void 0,u(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=T}),define(Y[121],ee([0,1,10,3]),function(_,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function E(P,T){const L=Object.create(null),u=(y,v)=>{const w=JSON.parse(y);L[v]=w};if(T){const y=[],v=await m.Promises.readdir(T);for(const F of v)try{(await m.Promises.stat((0,O.join)(T,F))).isDirectory()&&y.push(F)}catch{}const w=[];for(const F of y)(await m.Promises.readdir((0,O.join)(T,F))).filter(f=>f==="telemetry.json").length===1&&w.push(F);for(const F of w){const c=(await m.Promises.readFile((0,O.join)(T,F,"telemetry.json"))).toString();u(c,F)}}let d=(await m.Promises.readFile((0,O.join)(P,"telemetry-core.json"))).toString();return u(d,"vscode-core"),d=(await m.Promises.readFile((0,O.join)(P,"telemetry-extensions.json"))).toString(),u(d,"vscode-extensions"),JSON.stringify(L,null,4)}t.buildTelemetryMessage=E}),define(Y[43],ee([0,1,72,3,38,4,10,132,133,12]),function(_,t,m,O,E,P,T,L,u,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class y extends Error{constructor(e,i){let n=i.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=e,this.cause=i}}t.ExtractError=y;function v(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,n)=>i+n,e&61440)}function w(s){if(s instanceof y)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new y(e,s)}function F(s,e,i,n,o,a){const h=O.dirname(e),p=O.join(n,h);if(!p.startsWith(n))return Promise.reject(new Error(m.localize(0,null,e)));const M=O.join(n,e);let C;return a.onCancellationRequested(()=>{C&&C.destroy()}),Promise.resolve(T.Promises.mkdir(p,{recursive:!0})).then(()=>new Promise((N,V)=>{if(!a.isCancellationRequested)try{C=(0,E.createWriteStream)(M,{mode:i}),C.once("close",()=>N()),C.once("error",V),s.once("error",V),s.pipe(C)}catch(W){V(W)}}))}function c(s,e,i,n){let o=(0,P.createCancelablePromise)(()=>Promise.resolve()),a=0;return n.onCancellationRequested(()=>{o.cancel(),s.close()}),new Promise((h,p)=>{const M=new P.Sequencer,C=N=>{N.isCancellationRequested||(a++,s.readEntry())};s.once("error",p),s.once("close",()=>o.then(()=>{n.isCancellationRequested||s.entryCount===a?h():p(new y("Incomplete",new Error(m.localize(1,null,a,s.entryCount))))},p)),s.readEntry(),s.on("entry",N=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(N.fileName)){C(n);return}const V=N.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(V)){const ie=O.join(e,V);o=(0,P.createCancelablePromise)(re=>T.Promises.mkdir(ie,{recursive:!0}).then(()=>C(re)).then(void 0,p));return}const W=D(s,N),Q=v(N);o=(0,P.createCancelablePromise)(ie=>M.queue(()=>W.then(re=>F(re,V,Q,e,i,ie).then(()=>C(ie)))).then(null,p))})})}function f(s,e=!1){return new Promise((i,n)=>{(0,L.open)(s,e?{lazyEntries:!0}:void 0,(o,a)=>{o?n(w(o)):i((0,d.assertIsDefined)(a))})})}function D(s,e){return new Promise((i,n)=>{s.openReadStream(e,(o,a)=>{o?n(w(o)):i((0,d.assertIsDefined)(a))})})}function I(s,e){return new Promise((i,n)=>{const o=new u.ZipFile;e.forEach(h=>{h.contents?o.addBuffer(typeof h.contents=="string"?Buffer.from(h.contents,"utf8"):h.contents,h.path):h.localPath&&o.addFile(h.localPath,h.path)}),o.end();const a=(0,E.createWriteStream)(s);o.outputStream.pipe(a),o.outputStream.once("error",n),a.once("error",n),a.once("finish",()=>i(s))})}t.zip=I;function b(s,e,i={},n){const o=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let a=f(s,!0);return i.overwrite&&(a=a.then(h=>T.Promises.rm(e).then(()=>h))),a.then(h=>c(h,e,{sourcePathRegex:o},n))}t.extract=b;function l(s,e){return f(s).then(i=>new Promise((n,o)=>{i.on("entry",a=>{a.fileName===e&&D(i,a).then(h=>n(h),h=>o(h))}),i.once("close",()=>o(new Error(m.localize(2,null,e))))}))}function r(s,e){return l(s,e).then(i=>new Promise((n,o)=>{const a=[];i.once("error",o),i.on("data",h=>a.push(h)),i.on("end",()=>n(Buffer.concat(a)))}))}t.buffer=r}),define(Y[122],ee([0,1,43,78]),function(_,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function E(P){return(0,m.buffer)(P,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch(L){throw new Error((0,O.localize)(0,null))}})}t.getManifest=E}),define(Y[123],ee([0,1,41,2,10,3,14,22,23,4,7,21,90,79,42,43,15,24,9,17,20,29,8]),function(_,t,m,O,E,P,T,L,u,d,y,v,w,F,c,f,D,I,b,l,r,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const i="scanningSystem",n="scanningUser",o="extracting",a="deleting",h="renaming";let p=class extends O.Disposable{constructor(C,N,V,W,Q){super();this.beforeRemovingExtension=C,this.fileService=N,this.logService=V,this.environmentService=W,this.productService=Q,this._devSystemExtensionsPath=null,this.systemExtensionsPath=W.builtinExtensionsPath,this.extensionsPath=W.extensionsPath,this.uninstalledPath=P.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new d.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(C){const N=[];(C===null||C===0)&&N.push(this.scanSystemExtensions().then(null,V=>Promise.reject(new L.ExtensionManagementError(this.joinErrors(V).message,i)))),(C===null||C===1)&&N.push(this.scanUserExtensions(!0).then(null,V=>Promise.reject(new L.ExtensionManagementError(this.joinErrors(V).message,n))));try{const V=await Promise.all(N);return(0,I.flatten)(V)}catch(V){throw this.joinErrors(V)}}async scanUserExtensions(C){this.logService.trace("Started scanning user extensions");let[N,V]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return V=V.filter(W=>!N[new u.ExtensionIdentifierWithVersion(W.identifier,W.manifest.version).key()]),C&&(V=(0,u.groupByExtension)(V,Q=>Q.identifier).map(Q=>Q.sort((ie,re)=>m.rcompare(ie.manifest.version,re.manifest.version))[0])),this.logService.trace("Scanned user extensions:",V.length),V}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(C,N,V){const W=C.key(),Q=P.join(this.extensionsPath,`.${(0,s.generateUuid)()}`),ie=P.join(this.extensionsPath,W);try{await E.Promises.rm(ie)}catch(Z){try{await E.Promises.rm(ie)}catch(X){}throw new L.ExtensionManagementError((0,F.localize)(0,null,ie,C.id),a)}await this.extractAtLocation(C,N,Q,V);let re=await this.scanExtension(y.URI.file(Q),1);if(!re)throw new Error((0,F.localize)(1,null,Q));await this.storeMetadata(re,{installedTimestamp:Date.now()});try{await this.rename(C,Q,ie,Date.now()+2*60*1e3),this.logService.info("Renamed to",ie)}catch(Z){try{await E.Promises.rm(Q)}catch(X){}if(Z.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",C.id);else throw this.logService.info(`Rename failed because of ${(0,e.getErrorMessage)(Z)}. Deleted from extracted location`,Q),Z}try{re=await this.scanExtension(y.URI.file(ie),1)}catch(Z){}if(re)return re;throw new Error((0,F.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(C,N){return this.setMetadata(C,N),await this.storeMetadata(C,{...N,installedTimestamp:C.installedTimestamp}),C}async storeMetadata(C,N){N.isMachineScoped=N.isMachineScoped||void 0,N.isBuiltin=N.isBuiltin||void 0,N.installedTimestamp=N.installedTimestamp||void 0;const V=P.join(C.location.fsPath,"package.json"),W=await E.Promises.readFile(V,"utf8"),{manifest:Q}=await this.parseManifest(W);return Q.__metadata=N,await E.Promises.writeFile(V,JSON.stringify(Q,null,"	")),C}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...C){const N=C.map(V=>new u.ExtensionIdentifierWithVersion(V.identifier,V.manifest.version));await this.withUninstalledExtensions(V=>{N.forEach(W=>V[W.key()]=!0)})}async setInstalled(C){await this.withUninstalledExtensions(W=>delete W[C.key()]);const V=(await this.scanExtensions(1)).find(W=>new u.ExtensionIdentifierWithVersion(W.identifier,W.manifest.version).equals(C))||null;return V?(await this.storeMetadata(V,{installedTimestamp:Date.now()}),this.scanExtension(V.location,1)):null}async withUninstalledExtensions(C){return this.uninstalledFileLimiter.queue(async()=>{let N;try{N=await E.Promises.readFile(this.uninstalledPath,"utf8")}catch(W){if(W.code!=="ENOENT")throw W}let V={};if(N)try{V=JSON.parse(N)}catch(W){}return C&&(C(V),Object.keys(V).length?await E.Promises.writeFile(this.uninstalledPath,JSON.stringify(V)):await E.Promises.rm(this.uninstalledPath)),V})}async removeExtension(C,N){this.logService.trace(`Deleting ${N} extension from disk`,C.identifier.id,C.location.fsPath),await E.Promises.rm(C.location.fsPath),this.logService.info("Deleted from disk",C.identifier.id,C.location.fsPath)}async removeUninstalledExtension(C){await this.removeExtension(C,"uninstalled"),await this.withUninstalledExtensions(N=>delete N[new u.ExtensionIdentifierWithVersion(C.identifier,C.manifest.version).key()])}async extractAtLocation(C,N,V,W){this.logService.trace(`Started extracting the extension from ${N} to ${V}`);try{await E.Promises.rm(V)}catch(Q){throw new L.ExtensionManagementError(this.joinErrors(Q).message,a)}try{await(0,f.extract)(N,V,{sourcePath:"extension",overwrite:!0},W),this.logService.info(`Extracted extension to ${V}:`,C.id)}catch(Q){try{await E.Promises.rm(V)}catch(ie){}throw new L.ExtensionManagementError(Q.message,Q instanceof f.ExtractError&&Q.type?Q.type:o)}}async rename(C,N,V,W){try{await E.Promises.rename(N,V)}catch(Q){if(D.isWindows&&Q&&Q.code==="EPERM"&&Date.now()<W)return this.logService.info(`Failed renaming ${N} to ${V} with 'EPERM' error. Trying again...`,C.id),this.rename(C,N,V,W);throw new L.ExtensionManagementError(Q.message||(0,F.localize)(3,null,N,V),Q.code||h)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const C=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return C;const N=this.scanDevSystemExtensions(),[V,W]=await Promise.all([C,N]);return[...V,...W]}async scanExtensionsInDir(C,N){const V=new d.Limiter(10),W=await this.fileService.resolve(y.URI.file(C));return W.children?(await Promise.all(W.children.filter(ie=>ie.isDirectory).map(ie=>V.queue(async()=>N===1&&(0,r.basename)(ie.resource).indexOf(".")===0?null:this.scanExtension(ie.resource,N))))).filter(ie=>ie&&ie.identifier):[]}async scanExtension(C,N){try{const V=await this.fileService.resolve(C);if(V.children){const{manifest:W,metadata:Q}=await this.readManifest(C.fsPath),ie=V.children.find(({name:j})=>/^readme(\.txt|\.md|)$/i.test(j))?.resource,re=V.children.find(({name:j})=>/^changelog(\.txt|\.md|)$/i.test(j))?.resource,Z={id:(0,u.getGalleryExtensionId)(W.publisher,W.name)},X={type:N,identifier:Z,manifest:W,location:C,readmeUrl:ie,changelogUrl:re,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:N===0};return Q&&(this.setMetadata(X,Q),X.installedTimestamp=Q.installedTimestamp),X}}catch(V){N!==0&&this.logService.trace(V)}return null}async scanDefaultSystemExtensions(){const C=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",C.length),C}async scanDevSystemExtensions(){const C=this.getDevSystemExtensionsList();if(C.length){const N=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",N.length),N.filter(V=>C.some(W=>(0,u.areSameExtensions)(V.identifier,{id:W})))}else return[]}setMetadata(C,N){C.publisherDisplayName=N.publisherDisplayName||null,C.publisherId=N.publisherId||null,C.identifier.uuid=N.id,C.isMachineScoped=!!N.isMachineScoped,C.isBuiltin=C.type===0||!!N.isBuiltin}async removeUninstalledExtensions(){const C=await this.getUninstalledExtensions(),N=await this.scanAllUserExtensions(),V=new Set;for(const ie of N)C[new u.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]||V.add(ie.identifier.id.toLowerCase());const W=(0,u.groupByExtension)(N,ie=>ie.identifier);await d.Promises.settled(W.map(async ie=>{const re=ie.sort((Z,X)=>m.rcompare(Z.manifest.version,X.manifest.version))[0];V.has(re.identifier.id.toLowerCase())||await this.beforeRemovingExtension(re)}));const Q=N.filter(ie=>C[new u.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]);await d.Promises.settled(Q.map(ie=>this.removeUninstalledExtension(ie)))}async removeOutdatedExtensions(){const C=await this.scanAllUserExtensions(),N=[],V=(0,u.groupByExtension)(C,W=>W.identifier);N.push(...(0,I.flatten)(V.map(W=>W.sort((Q,ie)=>m.rcompare(Q.manifest.version,ie.manifest.version)).slice(1)))),await d.Promises.settled(N.map(W=>this.removeExtension(W,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(C=>C.name)}joinErrors(C){const N=Array.isArray(C)?C:[C];return N.length===1?N[0]instanceof Error?N[0]:new Error(N[0]):N.reduce((V,W)=>new Error(`${V.message}${V.message?",":""}${W instanceof Error?W.message:W}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=P.normalize(P.join(b.FileAccess.asFileUri("",_).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(C){const N=[E.Promises.readFile(P.join(C,"package.json"),"utf8").then(ie=>this.parseManifest(ie)),E.Promises.readFile(P.join(C,"package.nls.json"),"utf8").then(void 0,ie=>ie.code!=="ENOENT"?Promise.reject(ie):"{}").then(ie=>JSON.parse(ie))],[{manifest:V,metadata:W},Q]=await Promise.all(N);return{manifest:(0,w.localizeManifest)(V,Q),metadata:W}}parseManifest(C){return new Promise((N,V)=>{try{const W=JSON.parse(C),Q=W.__metadata||null;N({manifest:W,metadata:Q})}catch(W){V(new Error((0,F.localize)(4,null)))}})}};p=ce([ue(1,l.IFileService),ue(2,T.ILogService),ue(3,v.INativeEnvironmentService),ue(4,c.IProductService)],p),t.ExtensionsScanner=p}),define(Y[124],ee([0,1,77,3,10,43,22,23,21,41,7,34,15,14,98,28,35,49,20,29,96,11,9,122,102,123,103,104,17,117]),function(_,t,m,O,E,P,T,L,u,d,y,v,w,F,c,f,D,I,b,l,r,s,e,i,n,o,a,h,p,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const C="unsetUninstalled",N="downloading";let V=class extends M.AbstractExtensionManagementService{constructor(X,j,x,q,S,g,R){super(X,j,x);this.environmentService=q,this.downloadService=S;const A=this._register(g.createInstance(a.ExtensionsLifecycle));this.extensionsScanner=this._register(g.createInstance(o.ExtensionsScanner,U=>A.postUninstall(U))),this.manifestCache=this._register(new c.ExtensionsManifestCache(q,this)),this.extensionsDownloader=this._register(g.createInstance(n.ExtensionsDownloader));const k=this._register(new h.ExtensionsWatcher(this,R,q,x));this._register(k.onDidChangeExtensionsByAnotherSource(({added:U,removed:B})=>{U.length&&this._onDidInstallExtensions.fire(U.map($=>({identifier:$.identifier,operation:0,local:$}))),B.forEach($=>this._onDidUninstallExtension.fire({identifier:$}))}))}async zip(X){this.logService.trace("ExtensionManagementService#zip",X.identifier.id);const j=await this.collectFiles(X),x=await(0,P.zip)((0,b.joinPath)(this.environmentService.tmpDir,(0,l.generateUuid)()).fsPath,j);return y.URI.file(x)}async unzip(X){return this.logService.trace("ExtensionManagementService#unzip",X.toString()),(await this.install(X)).identifier}async getManifest(X){const j=await this.downloadVsix(X),x=O.resolve(j.fsPath);return(0,i.getManifest)(x)}getInstalled(X=null){return this.extensionsScanner.scanExtensions(X)}async canInstall(X){return!0}async install(X,j={}){this.logService.trace("ExtensionManagementService#install",X.toString());const x=await this.downloadVsix(X),q=await(0,i.getManifest)(O.resolve(x.fsPath));if(q.engines&&q.engines.vscode&&!(0,I.isEngineValid)(q.engines.vscode,v.default.version,v.default.date))throw new Error(m.localize(0,null,(0,L.getGalleryExtensionId)(q.publisher,q.name),v.default.version));return this.installExtension(q,x,j)}async updateMetadata(X,j){return this.logService.trace("ExtensionManagementService#updateMetadata",X.identifier.id),X=await this.extensionsScanner.saveMetadataForLocalExtension(X,{...X.manifest.__metadata||{},...j}),this.manifestCache.invalidate(),X}async updateExtensionScope(X,j){return this.logService.trace("ExtensionManagementService#updateExtensionScope",X.identifier.id),X=await this.extensionsScanner.saveMetadataForLocalExtension(X,{...X.manifest.__metadata||{},isMachineScoped:j}),this.manifestCache.invalidate(),X}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(X){if(X.scheme===e.Schemas.file)return X;if(!this.downloadService)throw new Error("Download service is not available");const j=(0,b.joinPath)(this.environmentService.tmpDir,(0,l.generateUuid)());return await this.downloadService.download(X,j),j}createInstallExtensionTask(X,j,x){return y.URI.isUri(j)?new ie(X,j,x,this.galleryService,this.extensionsScanner,this.logService):new Q(j,x,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(X,j){return new re(X,j,this.extensionsScanner)}async collectFiles(X){const j=async q=>{let S=await E.Promises.readdir(q);S=S.map(A=>O.join(q,A));const g=await Promise.all(S.map(A=>E.Promises.stat(A)));let R=Promise.resolve([]);return g.forEach((A,k)=>{const U=S[k];A.isFile()&&(R=R.then(B=>[...B,U])),A.isDirectory()&&(R=R.then(B=>j(U).then($=>[...B,...$])))}),R};return(await j(X.location.fsPath)).map(q=>({path:`extension/${O.relative(X.location.fsPath,q)}`,localPath:q}))}};V=ce([ue(0,T.IExtensionGalleryService),ue(1,D.ITelemetryService),ue(2,F.ILogService),ue(3,u.INativeEnvironmentService),ue(4,(0,s.optional)(r.IDownloadService)),ue(5,s.IInstantiationService),ue(6,p.IFileService)],V),t.ExtensionManagementService=V;class W extends M.AbstractExtensionTask{constructor(X,j,x,q){super();this.identifier=X,this.source=j,this.extensionsScanner=x,this.logService=q,this._operation=1}get operation(){return this._operation}async installExtension(X,j){try{const x=await this.unsetUninstalledAndGetLocal(X.identifierWithVersion);if(x)return X.metadata?this.extensionsScanner.saveMetadataForLocalExtension(x,X.metadata):x}catch(x){throw w.isMacintosh?new T.ExtensionManagementError(m.localize(1,null),C):new T.ExtensionManagementError(m.localize(2,null),C)}return this.extract(X,j)}async unsetUninstalledAndGetLocal(X){if(!await this.isUninstalled(X))return null;this.logService.trace("Removing the extension from uninstalled list:",X.id);const x=await this.extensionsScanner.setInstalled(X);return this.logService.info("Removed the extension from uninstalled list:",X.id),x}async isUninstalled(X){return!!(await this.extensionsScanner.getUninstalledExtensions())[X.key()]}async extract({zipPath:X,identifierWithVersion:j,metadata:x},q){let S=await this.extensionsScanner.extractUserExtension(j,X,q);return this.logService.info("Extracting completed.",j.id),x&&(S=await this.extensionsScanner.saveMetadataForLocalExtension(S,x)),S}}class Q extends W{constructor(X,j,x,q,S){super(X.identifier,X,q,S);this.gallery=X,this.options=j,this.extensionsDownloader=x}async doRun(X){const x=(await this.extensionsScanner.scanExtensions(null)).find(g=>(0,L.areSameExtensions)(g.identifier,this.gallery.identifier));x&&(this._operation=2);const q=await this.downloadInstallableExtension(this.gallery,this._operation);q.metadata.isMachineScoped=this.options.isMachineScoped||x?.isMachineScoped,q.metadata.isBuiltin=this.options.isBuiltin||x?.isBuiltin;const S=await this.installExtension(q,X);x&&d.neq(x.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(x);try{await this.extensionsDownloader.delete(y.URI.file(q.zipPath))}catch(g){}return S}async downloadInstallableExtension(X,j){const x={id:X.identifier.uuid,publisherId:X.publisherId,publisherDisplayName:X.publisherDisplayName};let q;try{this.logService.trace("Started downloading extension:",X.identifier.id),q=(await this.extensionsDownloader.downloadExtension(X,j)).fsPath,this.logService.info("Downloaded extension:",X.identifier.id,q)}catch(S){throw new T.ExtensionManagementError((0,M.joinErrors)(S).message,N)}try{const S=await(0,i.getManifest)(q);return{zipPath:q,identifierWithVersion:new L.ExtensionIdentifierWithVersion(X.identifier,S.version),metadata:x}}catch(S){throw new T.ExtensionManagementError((0,M.joinErrors)(S).message,M.INSTALL_ERROR_VALIDATING)}}}class ie extends W{constructor(X,j,x,q,S,g){super({id:(0,L.getGalleryExtensionId)(X.publisher,X.name)},j,S,g);this.manifest=X,this.location=j,this.options=x,this.galleryService=q}async doRun(X){const j=new L.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),q=(await this.extensionsScanner.scanExtensions(1)).find(g=>(0,L.areSameExtensions)(this.identifier,g.identifier)),S=await this.getMetadata(this.identifier.id,X);if(q)if(S.isMachineScoped=this.options.isMachineScoped||q.isMachineScoped,S.isBuiltin=this.options.isBuiltin||q.isBuiltin,this._operation=2,j.equals(new L.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version)))try{await this.extensionsScanner.removeExtension(q,"existing")}catch(g){throw new Error(m.localize(3,null,this.manifest.displayName||this.manifest.name))}else d.gt(q.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(q);else{const g=await this.unsetUninstalledAndGetLocal(j);if(g)try{await this.extensionsScanner.removeExtension(g,"existing")}catch(R){throw new Error(m.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:O.resolve(this.location.fsPath),identifierWithVersion:j,metadata:S},X)}async getMetadata(X,j){try{const x=(await this.galleryService.query({names:[X],pageSize:1},j)).firstPage[0];if(x)return{id:x.identifier.uuid,publisherDisplayName:x.publisherDisplayName,publisherId:x.publisherId}}catch(x){}return{}}}class re extends M.AbstractExtensionTask{constructor(X,j,x){super();this.extension=X,this.options=j,this.extensionsScanner=x}async doRun(X){const j=[],x=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const q=new L.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);j.push(...x.filter(S=>q.equals(new L.ExtensionIdentifierWithVersion(S.identifier,S.manifest.version))))}else j.push(...x.filter(q=>(0,L.areSameExtensions)(q.identifier,this.extension.identifier)));if(!j.length)throw new Error(m.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...j),this.options.remove)for(const q of j)try{X.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(q)}catch(S){throw new Error(m.localize(6,null,(0,f.toErrorMessage)(S)))}}}}),define(Y[125],ee([0,1,134,113,2,12,8,112,27,14,16,21,99]),function(_,t,m,O,E,P,T,L,u,d,y,v,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let F=class extends E.Disposable{constructor(f,D,I){super();this.environmentService=D,this.logService=I,this.configure(f.getValue()),this._register(f.onDidChangeConfiguration(()=>this.configure(f.getValue()),this))}configure(f){this.proxyUrl=f.http&&f.http.proxy,this.strictSSL=!!(f.http&&f.http.proxyStrictSSL),this.authorization=f.http&&f.http.proxyAuthorization}async request(f,D){this.logService.trace("RequestService#request",f.url);const{proxyUrl:I,strictSSL:b}=this,l={...process.env,...await(0,w.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},r=f.agent?f.agent:await(0,L.getProxyAgent)(f.url||"",l,{proxyUrl:I,strictSSL:b});return f.agent=r,f.strictSSL=b,this.authorization&&(f.headers={...f.headers||{},"Proxy-Authorization":this.authorization}),this._request(f,D)}async getNodeRequest(f){return((0,O.parse)(f.url).protocol==="https:"?await new Promise((b,l)=>{_(["https"],b,l)}):await new Promise((b,l)=>{_(["http"],b,l)})).request}_request(f,D){return new Promise(async(I,b)=>{let l;const r=(0,O.parse)(f.url),s=f.getRawRequest?f.getRawRequest(f):await this.getNodeRequest(f),e={hostname:r.hostname,port:r.port?parseInt(r.port):r.protocol==="https:"?443:80,protocol:r.protocol,path:r.path,method:f.type||"GET",headers:f.headers,agent:f.agent,rejectUnauthorized:(0,P.isBoolean)(f.strictSSL)?f.strictSSL:!0};f.user&&f.password&&(e.auth=f.user+":"+f.password),l=s(e,i=>{const n=(0,P.isNumber)(f.followRedirects)?f.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...f,url:i.headers.location,followRedirects:n-1},D).then(I,b);else{let o=i;i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,m.createGunzip)())),I({res:i,stream:(0,y.streamToBufferReadableStream)(o)})}}),l.on("error",b),f.timeout&&l.setTimeout(f.timeout),f.data&&typeof f.data=="string"&&l.write(f.data),l.end(),D.onCancellationRequested(()=>{l.abort(),b((0,T.canceled)())})})}async resolveProxy(f){}};F=ce([ue(0,u.IConfigurationService),ue(1,v.INativeEnvironmentService),ue(2,d.ILogService)],F),t.RequestService=F}),define(Y[135],ee([0,1,31,38,136,10,3,4,34,52,50,101,21,89,22,124,118,35,56,119,116,55,125,27,111,120,14,9,106,121,107,17,108,2,42,97,7,105,53,8,28,16,33]),function(_,t,m,O,E,P,T,L,u,d,y,v,w,F,c,f,D,I,b,l,r,s,e,i,n,o,a,h,p,M,C,N,V,W,Q,ie,re,Z,X,j,x,q,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class g extends W.Disposable{constructor(k){super();this.argv=k,(0,E.gracefulify)(O),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[k,U]=await this.initServices();return k.invokeFunction(async B=>{const $=B.get(a.ILogService),H=B.get(N.IFileService),J=B.get(w.INativeEnvironmentService),te=B.get(c.IExtensionManagementCLIService);return $.info("CLI main",this.argv),this.registerErrorHandler($),await this.doRun(J,te,H),(0,L.raceTimeout)((0,b.combinedAppender)(...U).flush(),1e3)})}async initServices(){const k=new d.ServiceCollection,U={_serviceBrand:void 0,...u.default};k.set(Q.IProductService,U);const B=new F.NativeEnvironmentService(this.argv,U);k.set(w.INativeEnvironmentService,B),await Promise.all([B.appSettingsHome.fsPath,B.extensionsPath].map(ve=>ve?P.Promises.mkdir(ve,{recursive:!0}):void 0));const $=(0,a.getLogLevel)(B),H=[];H.push(new p.SpdLogLogger("cli",(0,T.join)(B.logsPath,"cli.log"),!0,$)),$===a.LogLevel.Trace&&H.push(new a.ConsoleLogger($));const J=this._register(new a.MultiplexLogService(H));k.set(a.ILogService,J);const te=this._register(new C.FileService(J));k.set(N.IFileService,te);const ne=this._register(new V.DiskFileSystemProvider(J));te.registerProvider(h.Schemas.file,ne);const ae=this._register(new n.ConfigurationService(B.settingsResource,te));k.set(i.IConfigurationService,ae),await ae.initialize(),k.set(s.IRequestService,new y.SyncDescriptor(e.RequestService)),k.set(c.IExtensionManagementService,new y.SyncDescriptor(f.ExtensionManagementService)),k.set(c.IExtensionGalleryService,new y.SyncDescriptor(D.ExtensionGalleryService)),k.set(c.IExtensionManagementCLIService,new y.SyncDescriptor(ie.ExtensionManagementCLIService)),k.set(X.ILocalizationsService,new y.SyncDescriptor(Z.LocalizationsService));const he=[];if(B.isBuilt&&!B.isExtensionDevelopment&&!B.disableTelemetry&&U.enableTelemetry){U.aiConfig&&U.aiConfig.asimovKey&&he.push(new o.AppInsightsAppender("monacoworkbench",null,U.aiConfig.asimovKey));const{appRoot:ve,extensionsPath:De,installSourcePath:ke}=B,Te={appender:(0,b.combinedAppender)(...he),sendErrorTelemetry:!1,commonProperties:(async()=>{let we;try{const Fe=await P.Promises.readFile((0,T.join)(B.userDataPath,"storage.json"));we=JSON.parse(Fe.toString())[I.machineIdKey]}catch(Fe){Fe.code!=="ENOENT"&&J.error(Fe)}return(0,r.resolveCommonProperties)(te,(0,m.release)(),(0,m.hostname)(),process.arch,U.commit,U.version,we,U.msftInternalDomains,ke)})(),piiPaths:[ve,De]};k.set(I.ITelemetryService,new y.SyncDescriptor(l.TelemetryService,[Te]))}else k.set(I.ITelemetryService,b.NullTelemetryService);return[new v.InstantiationService(k),he]}registerErrorHandler(k){(0,j.setUnexpectedErrorHandler)(U=>{const B=(0,x.toErrorMessage)(U,!0);!B||k.error(`[uncaught exception in CLI]: ${B}`)})}async doRun(k,U,B){if(this.argv["install-source"])return this.setInstallSource(k,B,this.argv["install-source"]);if(this.argv["list-extensions"])return U.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return U.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return U.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return U.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(k.appRoot,k.extensionsPath))}asExtensionIdOrVSIX(k){return k.map(U=>/\.vsix$/i.test(U)?re.URI.file((0,T.isAbsolute)(U)?U:(0,T.join)((0,S.cwd)(),U)):U)}async setInstallSource(k,U,B){await U.writeFile(re.URI.file(k.installSourcePath),q.VSBuffer.fromString(B.slice(0,30)))}}async function R(A){const k=new g(A);try{await k.run()}finally{k.dispose()}}t.main=R})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/50b3811fdc5b5c80ca516a2edfffedcbd464b033/core/vs/code/node/cliProcessMain.js.map
