/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var he=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/base/common/errors","vs/workbench/api/common/extHostTypeConverters","vs/base/common/async","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/map","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","fs","vs/editor/common/core/position","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/hash","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/errorMessage","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/codicons","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","os","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/tunnel","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","path","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],fe=function(X){for(var e=[],p=0,L=X.length;p<L;p++)e[p]=he[X[p]];return e};define(he[52],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(L,C){if(!L)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=p}),define(he[69],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const p=Object.prototype.hasOwnProperty;function L(i){const P=[];for(let c in i)p.call(i,c)&&P.push(i[c]);return P}e.values=L;function C(i,P){for(let c in i)if(p.call(i,c)&&P({key:c,value:i[c]},function(){delete i[c]})===!1)return}e.forEach=C;function y(i,P){const c=Object.create(null);for(const u of i){const a=P(u);let g=c[a];g||(g=c[a]=[]),g.push(u)}return c}e.groupBy=y;function T(i){const P=Object.create(null);return i&&i.forEach((c,u)=>{P[u]=c}),P}e.fromMap=T;function I(i,P){const c=[],u=[];for(let a of i)P.has(a)||c.push(a);for(let a of P)i.has(a)||u.push(a);return{removed:c,added:u}}e.diffSets=I;function D(i,P){const c=[],u=[];for(let[a,g]of i)P.has(a)||c.push(g);for(let[a,g]of P)i.has(a)||u.push(g);return{removed:c,added:u}}e.diffMaps=D;class A{constructor(){this.map=new Map}add(P,c){let u=this.map.get(P);u||(u=new Set,this.map.set(P,u)),u.add(c)}delete(P,c){const u=this.map.get(P);!u||(u.delete(c),u.size===0&&this.map.delete(P))}forEach(P,c){const u=this.map.get(P);!u||u.forEach(c)}}e.SetMap=A}),define(he[53],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(T){return(I,D,A)=>{let i=null,P=null;if(typeof A.value=="function"?(i="value",P=A.value):typeof A.get=="function"&&(i="get",P=A.get),!P)throw new Error("not supported");A[i]=T(P,D)}}e.createDecorator=p;function L(T,I,D){let A=null,i=null;if(typeof D.value=="function"?(A="value",i=D.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(A="get",i=D.get),!i)throw new Error("not supported");const P=`$memoize$${I}`;D[A]=function(...c){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,c)}),this[P]}}e.memoize=L;function C(T,I,D){return p((A,i)=>{const P=`$debounce$${i}`,c=`$debounce$result$${i}`;return function(...u){this[c]||(this[c]=D?D():void 0),clearTimeout(this[P]),I&&(this[c]=I(this[c],...u),u=[this[c]]),this[P]=setTimeout(()=>{A.apply(this,u),this[c]=D?D():void 0},T)}})}e.debounce=C;function y(T,I,D){return p((A,i)=>{const P=`$throttle$timer$${i}`,c=`$throttle$result$${i}`,u=`$throttle$lastRun$${i}`,a=`$throttle$pending$${i}`;return function(...g){if(this[c]||(this[c]=D?D():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),I&&(this[c]=I(this[c],...g)),this[a])return;const w=this[u]+T;w<=Date.now()?(this[u]=Date.now(),A.apply(this,[this[c]]),this[c]=D?D():void 0):(this[a]=!0,this[P]=setTimeout(()=>{this[a]=!1,this[u]=Date.now(),A.apply(this,[this[c]]),this[c]=D?D():void 0},w-Date.now()))}})}e.throttle=y}),define(he[15],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(s=>{s(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=p,e.errorHandler=new p;function L(v){e.errorHandler.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=L;function C(v){D(v)||e.errorHandler.onUnexpectedError(v)}e.onUnexpectedError=C;function y(v){D(v)||e.errorHandler.onUnexpectedExternalError(v)}e.onUnexpectedExternalError=y;function T(v){if(v instanceof Error){let{name:t,message:s}=v;const r=v.stacktrace||v.stack;return{$isError:!0,name:t,message:s,stack:r}}return v}e.transformErrorForSerialization=T;const I="Canceled";function D(v){return v instanceof Error&&v.name===I&&v.message===I}e.isPromiseCanceledError=D;class A extends Error{constructor(){super(I);this.name=this.message}}e.CancellationError=A;function i(){const v=new Error(I);return v.name=v.message,v}e.canceled=i;function P(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.illegalArgument=P;function c(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.illegalState=c;function u(v){return v?new Error(`readonly property '${v} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=u;function a(v){const t=new Error(`${v} has been disposed`);return t.name="DISPOSED",t}e.disposed=a;function g(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.getErrorMessage=g;class w extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=w;class _ extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=_;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function d(v){const t=v;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=d;function h(v,t=Object.create(null)){const s=new Error(v);return t.actions&&(s.actions=t.actions),s}e.createErrorWithActions=h}),define(he[18],fe([0,1,15]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(F,M=0){return F[F.length-(1+M)]}e.tail=L;function C(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=C;function y(F,M,B=(W,Q)=>W===Q){if(F===M)return!0;if(!F||!M||F.length!==M.length)return!1;for(let W=0,Q=F.length;W<Q;W++)if(!B(F[W],M[W]))return!1;return!0}e.equals=y;function T(F,M,B){let W=0,Q=F.length-1;for(;W<=Q;){const ae=(W+Q)/2|0,_e=B(F[ae],M);if(_e<0)W=ae+1;else if(_e>0)Q=ae-1;else return ae}return-(W+1)}e.binarySearch=T;function I(F,M){let B=0,W=F.length;if(W===0)return 0;for(;B<W;){const Q=Math.floor((B+W)/2);M(F[Q])?W=Q:B=Q+1}return B}e.findFirstInSorted=I;function D(F,M,B){if(F=F|0,F>=M.length)throw new TypeError("invalid index");let W=M[Math.floor(M.length*Math.random())],Q=[],ae=[],_e=[];for(let Fe of M){const Ae=B(Fe,W);Ae<0?Q.push(Fe):Ae>0?ae.push(Fe):_e.push(Fe)}return F<Q.length?D(F,Q,B):F<Q.length+_e.length?_e[0]:D(F-(Q.length+_e.length),ae,B)}e.quickSelect=D;function A(F,M){const B=[];let W;for(const Q of F.slice(0).sort(M))!W||M(W[0],Q)!==0?(W=[Q],B.push(W)):W.push(Q);return B}e.groupBy=A;function i(F,M,B){const W=[];function Q(Fe,Ae,Me){if(Ae===0&&Me.length===0)return;const Ve=W[W.length-1];Ve&&Ve.start+Ve.deleteCount===Fe?(Ve.deleteCount+=Ae,Ve.toInsert.push(...Me)):W.push({start:Fe,deleteCount:Ae,toInsert:Me})}let ae=0,_e=0;for(;;){if(ae===F.length){Q(ae,0,M.slice(_e));break}if(_e===M.length){Q(ae,F.length-ae,[]);break}const Fe=F[ae],Ae=M[_e],Me=B(Fe,Ae);Me===0?(ae+=1,_e+=1):Me<0?(Q(ae,1,[]),ae+=1):Me>0&&(Q(ae,0,[Ae]),_e+=1)}return W}e.sortedDiff=i;function P(F,M,B){const W=i(F,M,B),Q=[],ae=[];for(const _e of W)Q.push(...F.slice(_e.start,_e.start+_e.deleteCount)),ae.push(..._e.toInsert);return{removed:Q,added:ae}}e.delta=P;function c(F,M,B){if(B===0)return[];const W=F.slice(0,B).sort(M);return a(F,M,W,B,F.length),W}e.top=c;function u(F,M,B,W,Q){return B===0?Promise.resolve([]):new Promise((ae,_e)=>{(async()=>{const Fe=F.length,Ae=F.slice(0,B).sort(M);for(let Me=B,Ve=Math.min(B+W,Fe);Me<Fe;Me=Ve,Ve=Math.min(Ve+W,Fe)){if(Me>B&&await new Promise(He=>setTimeout(He)),Q&&Q.isCancellationRequested)throw(0,p.canceled)();a(F,M,Ae,Me,Ve)}return Ae})().then(ae,_e)})}e.topAsync=u;function a(F,M,B,W,Q){for(const ae=B.length;W<Q;W++){const _e=F[W];if(M(_e,B[ae-1])<0){B.pop();const Fe=I(B,Ae=>M(_e,Ae)<0);B.splice(Fe,0,_e)}}}function g(F){return F.filter(M=>!!M)}e.coalesce=g;function w(F){let M=0;for(let B=0;B<F.length;B++)F[B]&&(F[M]=F[B],M+=1);F.length=M}e.coalesceInPlace=w;function _(F,M,B){F.splice(B,0,F.splice(M,1)[0])}e.move=_;function b(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=b;function d(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=d;function h(F,M){if(!M)return F.filter((W,Q)=>F.indexOf(W)===Q);const B=Object.create(null);return F.filter(W=>{const Q=M(W);return B[Q]?!1:(B[Q]=!0,!0)})}e.distinct=h;function v(F){const M=new Set;return F.filter(B=>M.has(B)?!1:(M.add(B),!0))}e.distinctES6=v;function t(F){const M=Object.create(null);return B=>{const W=F(B);return M[W]?!1:(M[W]=!0,!0)}}e.uniqueFilter=t;function s(F,M){for(let B=F.length-1;B>=0;B--){const W=F[B];if(M(W))return B}return-1}e.lastIndex=s;function r(F,M){return F.length>0?F[0]:M}e.firstOrDefault=r;function n(F,M,B=(W,Q)=>W===Q){let W=0;for(let Q=0,ae=Math.min(F.length,M.length);Q<ae&&B(F[Q],M[Q]);Q++)W++;return W}e.commonPrefixLength=n;function l(F){return[].concat(...F)}e.flatten=l;function f(F,M){let B=typeof M=="number"?F:0;typeof M=="number"?B=F:(B=0,M=F);const W=[];if(B<=M)for(let Q=B;Q<M;Q++)W.push(Q);else for(let Q=B;Q>M;Q--)W.push(Q);return W}e.range=f;function m(F,M,B){return F.reduce((W,Q)=>(W[M(Q)]=B?B(Q):Q,W),Object.create(null))}e.index=m;function E(F,M){return F.push(M),()=>S(F,M)}e.insert=E;function S(F,M){const B=F.indexOf(M);if(B>-1)return F.splice(B,1),M}e.remove=S;function o(F,M,B){const W=F.slice(0,M),Q=F.slice(M);return W.concat(B,Q)}e.arrayInsert=o;function k(F,M){let B;if(typeof M=="number"){let W=M;B=()=>{const Q=Math.sin(W++)*179426549;return Q-Math.floor(Q)}}else B=Math.random;for(let W=F.length-1;W>0;W-=1){const Q=Math.floor(B()*(W+1)),ae=F[W];F[W]=F[Q],F[Q]=ae}}e.shuffle=k;function O(F,M){const B=F.indexOf(M);B>-1&&(F.splice(B,1),F.unshift(M))}e.pushToStart=O;function $(F,M){const B=F.indexOf(M);B>-1&&(F.splice(B,1),F.push(M))}e.pushToEnd=$;function G(F,M){return Array.isArray(F)?F.map(M):M(F)}e.mapArrayOrNot=G;function re(F){return Array.isArray(F)?F:[F]}e.asArray=re;function j(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=j;function N(F,M){for(const B of F){const W=M(B);if(W!==void 0)return W}}e.mapFind=N;function x(F,M){let B=Number.MAX_SAFE_INTEGER,W=0;return F.forEach((Q,ae)=>{const _e=M(Q);_e<B&&(B=_e,W=ae)}),W}e.minIndex=x;function R(F,M){let B=Number.MIN_SAFE_INTEGER,W=0;return F.forEach((Q,ae)=>{const _e=M(Q);_e>B&&(B=_e,W=ae)}),W}e.maxIndex=R;class V{constructor(M){this.items=M,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(M){let B=this.firstIdx;for(;B<this.items.length&&M(this.items[B]);)B++;const W=B===this.firstIdx?null:this.items.slice(this.firstIdx,B);return this.firstIdx=B,W}takeFromEndWhile(M){let B=this.lastIdx;for(;B>=0&&M(this.items[B]);)B--;const W=B===this.lastIdx?null:this.items.slice(B+1,this.lastIdx+1);return this.lastIdx=B,W}}e.ArrayQueue=V}),define(he[70],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(L){const C=this;let y=!1,T;return function(){return y||(y=!0,T=L.apply(C,arguments)),T}}e.once=p}),define(he[71],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class p{constructor(C){this._prefix=C,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=p,e.defaultGenerator=new p("id#")}),define(he[72],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(L){function C(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}L.is=C;const y=Object.freeze([]);function T(){return y}L.empty=T;function*I(v){yield v}L.single=I;function D(v){return v||y}L.from=D;function A(v){return!v||v[Symbol.iterator]().next().done===!0}L.isEmpty=A;function i(v){return v[Symbol.iterator]().next().value}L.first=i;function P(v,t){for(const s of v)if(t(s))return!0;return!1}L.some=P;function c(v,t){for(const s of v)if(t(s))return s}L.find=c;function*u(v,t){for(const s of v)t(s)&&(yield s)}L.filter=u;function*a(v,t){let s=0;for(const r of v)yield t(r,s++)}L.map=a;function*g(...v){for(const t of v)for(const s of t)yield s}L.concat=g;function*w(v){for(const t of v)for(const s of t)yield s}L.concatNested=w;function _(v,t,s){let r=s;for(const n of v)r=t(r,n);return r}L.reduce=_;function*b(v,t,s=v.length){for(t<0&&(t+=v.length),s<0?s+=v.length:s>v.length&&(s=v.length);t<s;t++)yield v[t]}L.slice=b;function d(v,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,v];const r=v[Symbol.iterator]();for(let n=0;n<t;n++){const l=r.next();if(l.done)return[s,L.empty()];s.push(l.value)}return[s,{[Symbol.iterator](){return r}}]}L.consume=d;function h(v,t,s=(r,n)=>r===n){const r=v[Symbol.iterator](),n=t[Symbol.iterator]();for(;;){const l=r.next(),f=n.next();if(l.done!==f.done)return!1;if(l.done)return!0;if(!s(l.value,f.value))return!1}}L.equals=h})(p=e.Iterable||(e.Iterable={}))}),define(he[54],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var y;(function(t){t.DEFAULT={allowTrailingComma:!0}})(y=e.ParseOptions||(e.ParseOptions={}));function T(t,s=!1){let r=0,n=t.length,l="",f=0,m=16,E=0;function S(j){let N=0,x=0;for(;N<j;){const R=t.charCodeAt(r);if(R>=48&&R<=57)x=x*16+R-48;else if(R>=65&&R<=70)x=x*16+R-65+10;else if(R>=97&&R<=102)x=x*16+R-97+10;else break;r++,N++}return N<j&&(x=-1),x}function o(j){r=j,l="",f=0,m=16,E=0}function k(){const j=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&A(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&A(t.charCodeAt(r)))for(r++;r<t.length&&A(t.charCodeAt(r));)r++;else return E=3,t.substring(j,r);let N=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&A(t.charCodeAt(r))){for(r++;r<t.length&&A(t.charCodeAt(r));)r++;N=r}else E=3;return t.substring(j,N)}function O(){let j="",N=r;for(;;){if(r>=n){j+=t.substring(N,r),E=2;break}const x=t.charCodeAt(r);if(x===34){j+=t.substring(N,r),r++;break}if(x===92){if(j+=t.substring(N,r),r++,r>=n){E=2;break}switch(t.charCodeAt(r++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:const V=S(4);V>=0?j+=String.fromCharCode(V):E=4;break;default:E=5}N=r;continue}if(x>=0&&x<=31)if(D(x)){j+=t.substring(N,r),E=2;break}else E=6;r++}return j}function $(){if(l="",E=0,f=r,r>=n)return f=n,m=17;let j=t.charCodeAt(r);if(I(j)){do r++,l+=String.fromCharCode(j),j=t.charCodeAt(r);while(I(j));return m=15}if(D(j))return r++,l+=String.fromCharCode(j),j===13&&t.charCodeAt(r)===10&&(r++,l+=`
`),m=14;switch(j){case 123:return r++,m=1;case 125:return r++,m=2;case 91:return r++,m=3;case 93:return r++,m=4;case 58:return r++,m=6;case 44:return r++,m=5;case 34:return r++,l=O(),m=10;case 47:const N=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<n&&!D(t.charCodeAt(r));)r++;return l=t.substring(N,r),m=12}if(t.charCodeAt(r+1)===42){r+=2;const x=n-1;let R=!1;for(;r<x;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,R=!0;break}r++}return R||(r++,E=1),l=t.substring(N,r),m=13}return l+=String.fromCharCode(j),r++,m=16;case 45:if(l+=String.fromCharCode(j),r++,r===n||!A(t.charCodeAt(r)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=k(),m=11;default:for(;r<n&&G(j);)r++,j=t.charCodeAt(r);if(f!==r){switch(l=t.substring(f,r),l){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return l+=String.fromCharCode(j),r++,m=16}}function G(j){if(I(j)||D(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let j;do j=$();while(j>=12&&j<=15);return j}return{setPosition:o,getPosition:()=>r,scan:s?re:$,getToken:()=>m,getTokenValue:()=>l,getTokenOffset:()=>f,getTokenLength:()=>r-f,getTokenError:()=>E}}e.createScanner=T;function I(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function A(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function P(t,s){const r=[],n=new Object;let l;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function E(S,o,k,O){f.value=S,f.offset=o,f.length=k,f.type=O,f.colonOffset=void 0,l=f}try{d(t,{onObjectBegin:(S,o)=>{if(s<=S)throw n;l=void 0,m=s>S,r.push("")},onObjectProperty:(S,o,k)=>{if(s<o||(E(S,o,k,"property"),r[r.length-1]=S,s<=o+k))throw n},onObjectEnd:(S,o)=>{if(s<=S)throw n;l=void 0,r.pop()},onArrayBegin:(S,o)=>{if(s<=S)throw n;l=void 0,r.push(0)},onArrayEnd:(S,o)=>{if(s<=S)throw n;l=void 0,r.pop()},onLiteralValue:(S,o,k)=>{if(s<o||(E(S,o,k,v(S)),s<=o+k))throw n},onSeparator:(S,o,k)=>{if(s<=o)throw n;if(S===":"&&l&&l.type==="property")l.colonOffset=o,m=!1,l=void 0;else if(S===","){const O=r[r.length-1];typeof O=="number"?r[r.length-1]=O+1:(m=!0,r[r.length-1]=""),l=void 0}}})}catch(S){if(S!==n)throw S}return{path:r,previousNode:l,isAtPropertyKey:m,matches:S=>{let o=0;for(let k=0;o<S.length&&k<r.length;k++)if(S[o]===r[k]||S[o]==="*")o++;else if(S[o]!=="**")return!1;return o===S.length}}}e.getLocation=P;function c(t,s=[],r=y.DEFAULT){let n=null,l=[];const f=[];function m(S){Array.isArray(l)?l.push(S):n!==null&&(l[n]=S)}return d(t,{onObjectBegin:()=>{const S={};m(S),f.push(l),l=S,n=null},onObjectProperty:S=>{n=S},onObjectEnd:()=>{l=f.pop()},onArrayBegin:()=>{const S=[];m(S),f.push(l),l=S,n=null},onArrayEnd:()=>{l=f.pop()},onLiteralValue:m,onError:(S,o,k)=>{s.push({error:S,offset:o,length:k})}},r),l[0]}e.parse=c;function u(t,s=[],r=y.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(S){n.type==="property"&&(n.length=S-n.offset,n=n.parent)}function f(S){return n.children.push(S),S}d(t,{onObjectBegin:S=>{n=f({type:"object",offset:S,length:-1,parent:n,children:[]})},onObjectProperty:(S,o,k)=>{n=f({type:"property",offset:o,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:S,offset:o,length:k,parent:n})},onObjectEnd:(S,o)=>{n.length=S+o-n.offset,n=n.parent,l(S+o)},onArrayBegin:(S,o)=>{n=f({type:"array",offset:S,length:-1,parent:n,children:[]})},onArrayEnd:(S,o)=>{n.length=S+o-n.offset,n=n.parent,l(S+o)},onLiteralValue:(S,o,k)=>{f({type:v(S),offset:o,length:k,parent:n,value:S}),l(o+k)},onSeparator:(S,o,k)=>{n.type==="property"&&(S===":"?n.colonOffset=o:S===","&&l(o))},onError:(S,o,k)=>{s.push({error:S,offset:o,length:k})}},r);const E=n.children[0];return E&&delete E.parent,E}e.parseTree=u;function a(t,s){if(!t)return;let r=t;for(let n of s)if(typeof n=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let l=!1;for(const f of r.children)if(Array.isArray(f.children)&&f.children[0].value===n){r=f.children[1],l=!0;break}if(!l)return}else{const l=n;if(r.type!=="array"||l<0||!Array.isArray(r.children)||l>=r.children.length)return;r=r.children[l]}return r}e.findNodeAtLocation=a;function g(t){if(!t.parent||!t.parent.children)return[];const s=g(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;s.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&s.push(r)}return s}e.getNodePath=g;function w(t){switch(t.type){case"array":return t.children.map(w);case"object":const s=Object.create(null);for(let r of t.children){const n=r.children[1];n&&(s[r.children[0].value]=w(n))}return s;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=w;function _(t,s,r=!1){return s>=t.offset&&s<t.offset+t.length||r&&s===t.offset+t.length}e.contains=_;function b(t,s,r=!1){if(_(t,s,r)){const n=t.children;if(Array.isArray(n))for(let l=0;l<n.length&&n[l].offset<=s;l++){const f=b(n[l],s,r);if(f)return f}return t}}e.findNodeAtOffset=b;function d(t,s,r=y.DEFAULT){const n=T(t,!1);function l(ae){return ae?()=>ae(n.getTokenOffset(),n.getTokenLength()):()=>!0}function f(ae){return ae?_e=>ae(_e,n.getTokenOffset(),n.getTokenLength()):()=>!0}const m=l(s.onObjectBegin),E=f(s.onObjectProperty),S=l(s.onObjectEnd),o=l(s.onArrayBegin),k=l(s.onArrayEnd),O=f(s.onLiteralValue),$=f(s.onSeparator),G=l(s.onComment),re=f(s.onError),j=r&&r.disallowComments,N=r&&r.allowTrailingComma;function x(){for(;;){const ae=n.scan();switch(n.getTokenError()){case 4:R(14);break;case 5:R(15);break;case 3:R(13);break;case 1:j||R(11);break;case 2:R(12);break;case 6:R(16);break}switch(ae){case 12:case 13:j?R(10):G();break;case 16:R(1);break;case 15:case 14:break;default:return ae}}}function R(ae,_e=[],Fe=[]){if(re(ae),_e.length+Fe.length>0){let Ae=n.getToken();for(;Ae!==17;){if(_e.indexOf(Ae)!==-1){x();break}else if(Fe.indexOf(Ae)!==-1)break;Ae=x()}}}function V(ae){const _e=n.getTokenValue();return ae?O(_e):E(_e),x(),!0}function F(){switch(n.getToken()){case 11:let ae=0;try{ae=JSON.parse(n.getTokenValue()),typeof ae!="number"&&(R(2),ae=0)}catch(_e){R(2)}O(ae);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return x(),!0}function M(){return n.getToken()!==10?(R(3,[],[2,5]),!1):(V(!1),n.getToken()===6?($(":"),x(),Q()||R(4,[],[2,5])):R(5,[],[2,5]),!0)}function B(){m(),x();let ae=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ae||R(4,[],[]),$(","),x(),n.getToken()===2&&N)break}else ae&&R(6,[],[]);M()||R(4,[],[2,5]),ae=!0}return S(),n.getToken()!==2?R(7,[2],[]):x(),!0}function W(){o(),x();let ae=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ae||R(4,[],[]),$(","),x(),n.getToken()===4&&N)break}else ae&&R(6,[],[]);Q()||R(4,[],[4,5]),ae=!0}return k(),n.getToken()!==4?R(8,[4],[]):x(),!0}function Q(){switch(n.getToken()){case 3:return W();case 1:return B();case 10:return V(!0);default:return F()}}return x(),n.getToken()===17?r.allowEmptyContent?!0:(R(4,[],[]),!1):Q()?(n.getToken()!==17&&R(9,[],[]),!0):(R(4,[],[]),!1)}e.visit=d;function h(t,s){let r=T(t),n=[],l,f=0,m;do switch(m=r.getPosition(),l=r.scan(),l){case 12:case 13:case 17:f!==m&&n.push(t.substring(f,m)),s!==void 0&&n.push(r.getTokenValue().replace(/[^\r\n]/g,s)),f=r.getPosition();break}while(l!==17);return n.join("")}e.stripComments=h;function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(he[134],fe([0,1,54]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(D,A,i){let P,c,u,a,g;if(A){for(a=A.offset,g=a+A.length,u=a;u>0&&!I(D,u-1);)u--;let f=g;for(;f<D.length&&!I(D,f);)f++;c=D.substring(u,f),P=y(c,i)}else c=D,P=0,u=0,a=0,g=D.length;const w=T(i,D);let _=!1,b=0,d;i.insertSpaces?d=C(" ",i.tabSize||4):d="	";const h=(0,p.createScanner)(c,!1);let v=!1;function t(){return w+C(d,P+b)}function s(){let f=h.scan();for(_=!1;f===15||f===14;)_=_||f===14,f=h.scan();return v=f===16||h.getTokenError()!==0,f}const r=[];function n(f,m,E){!v&&m<g&&E>a&&D.substring(m,E)!==f&&r.push({offset:m,length:E-m,content:f})}let l=s();if(l!==17){const f=h.getTokenOffset()+u,m=C(d,P);n(m,u,f)}for(;l!==17;){let f=h.getTokenOffset()+h.getTokenLength()+u,m=s(),E="";for(;!_&&(m===12||m===13);){const o=h.getTokenOffset()+u;n(" ",f,o),f=h.getTokenOffset()+h.getTokenLength()+u,E=m===12?t():"",m=s()}if(m===2)l!==1&&(b--,E=t());else if(m===4)l!==3&&(b--,E=t());else{switch(l){case 3:case 1:b++,E=t();break;case 5:case 12:E=t();break;case 13:_?E=t():E=" ";break;case 6:E=" ";break;case 10:if(m===6){E="";break}case 7:case 8:case 9:case 11:case 2:case 4:m===12||m===13?E=" ":m!==5&&m!==17&&(v=!0);break;case 16:v=!0;break}_&&(m===12||m===13)&&(E=t())}const S=h.getTokenOffset()+u;n(E,f,S),l=m}return r}e.format=L;function C(D,A){let i="";for(let P=0;P<A;P++)i+=D;return i}function y(D,A){let i=0,P=0;const c=A.tabSize||4;for(;i<D.length;){const u=D.charAt(i);if(u===" ")P++;else if(u==="	")P+=c;else break;i++}return Math.floor(P/c)}function T(D,A){for(let i=0;i<A.length;i++){const P=A.charAt(i);if(P==="\r")return i+1<A.length&&A.charAt(i+1)===`
`?`\r
`:"\r";if(P===`
`)return`
`}return D&&D.eol||`
`}e.getEOL=T;function I(D,A){return`\r
`.indexOf(D.charAt(A))!==-1}e.isEOL=I}),define(he[135],fe([0,1,54,134]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function C(A,i,P){return y(A,i,void 0,P)}e.removeProperty=C;function y(A,i,P,c,u){const a=i.slice(),g=[],w=(0,p.parseTree)(A,g);let _,b;for(;a.length>0&&(b=a.pop(),_=(0,p.findNodeAtLocation)(w,a),_===void 0&&P!==void 0);)typeof b=="string"?P={[b]:P}:P=[P];if(_)if(_.type==="object"&&typeof b=="string"&&Array.isArray(_.children)){const d=(0,p.findNodeAtLocation)(_,[b]);if(d!==void 0)if(P===void 0){if(!d.parent)throw new Error("Malformed AST");const h=_.children.indexOf(d.parent);let v,t=d.parent.offset+d.parent.length;if(h>0){const s=_.children[h-1];v=s.offset+s.length}else v=_.offset+1,_.children.length>1&&(t=_.children[1].offset);return T(A,{offset:v,length:t-v,content:""},c)}else return T(A,{offset:d.offset,length:d.length,content:JSON.stringify(P)},c);else{if(P===void 0)return[];const h=`${JSON.stringify(b)}: ${JSON.stringify(P)}`,v=u?u(_.children.map(s=>s.children[0].value)):_.children.length;let t;if(v>0){const s=_.children[v-1];t={offset:s.offset+s.length,length:0,content:","+h}}else _.children.length===0?t={offset:_.offset+1,length:0,content:h}:t={offset:_.offset+1,length:0,content:h+","};return T(A,t,c)}}else if(_.type==="array"&&typeof b=="number"&&Array.isArray(_.children))if(P!==void 0){const d=`${JSON.stringify(P)}`;let h;if(_.children.length===0||b===0)h={offset:_.offset+1,length:0,content:_.children.length===0?d:d+","};else{const v=b===-1||b>_.children.length?_.children.length:b,t=_.children[v-1];h={offset:t.offset+t.length,length:0,content:","+d}}return T(A,h,c)}else{const d=b,h=_.children[d];let v;if(_.children.length===1)v={offset:_.offset+1,length:_.length-2,content:""};else if(_.children.length-1===d){const t=_.children[d-1],s=t.offset+t.length,r=_.offset+_.length;v={offset:s,length:r-2-s,content:""}}else v={offset:h.offset,length:_.children[d+1].offset-h.offset,content:""};return T(A,v,c)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${_.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return T(A,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(P)},c)}}e.setProperty=y;function T(A,i,P){let c=I(A,i),u=i.offset,a=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;u>0&&!(0,L.isEOL)(c,u-1);)u--;for(;a<c.length&&!(0,L.isEOL)(c,a);)a++}const g=(0,L.format)(c,{offset:u,length:a-u},P);for(let _=g.length-1;_>=0;_--){const b=g[_];c=I(c,b),u=Math.min(u,b.offset),a=Math.max(a,b.offset+b.length),a+=b.content.length-b.length}const w=A.length-(c.length-a)-u;return[{offset:u,length:w,content:c.substring(u,a)}]}e.withFormatting=T;function I(A,i){return A.substring(0,i.offset)+i.content+A.substring(i.offset+i.length)}e.applyEdit=I;function D(A,i){let P=i.slice(0).sort((u,a)=>{const g=u.offset-a.offset;return g===0?u.length-a.length:g}),c=A.length;for(let u=P.length-1;u>=0;u--){let a=P[u];if(a.offset+a.length<=c)A=I(A,a);else throw new Error("Overlapping edit");c=a.offset}return A}e.applyEdits=D}),define(he[136],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class p{constructor(C){this.executor=C,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(C){this._error=C}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(C){return new p(()=>C(this.getValue()))}}e.Lazy=p}),define(he[6],fe([0,1,70,72]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const C=!1;let y=null;function T(s){y=s}if(e.setDisposableTracker=T,C){const s="__is_disposable_tracked__";T(new class{trackDisposable(r){const n=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[s]||console.log(n)},3e3)}setParent(r,n){if(r&&r!==b.None)try{r[s]=!0}catch{}}markAsDisposed(r){if(r&&r!==b.None)try{r[s]=!0}catch{}}markAsSingleton(r){}})}function I(s){return y?.trackDisposable(s),s}function D(s){y?.markAsDisposed(s)}function A(s,r){y?.setParent(s,r)}function i(s,r){if(!!y)for(const n of s)y.setParent(n,r)}function P(s){return y?.markAsSingleton(s),s}e.markAsSingleton=P;class c extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=c;function u(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=u;function a(s){if(L.Iterable.is(s)){let r=[];for(const n of s)if(n)try{n.dispose()}catch(l){r.push(l)}if(r.length===1)throw r[0];if(r.length>1)throw new c(r);return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=a;function g(...s){const r=w(()=>a(s));return i(s,r),r}e.combinedDisposable=g;function w(s){const r=I({dispose:(0,p.once)(()=>{D(r),s()})});return r}e.toDisposable=w;class _{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(D(this),this._isDisposed=!0,this.clear())}clear(){try{a(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return A(r,this),this._isDisposed?_.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=_,_.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this._store=new _,I(this),A(this._store,this)}dispose(){D(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=b,b.None=Object.freeze({dispose(){}});class d{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&A(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,D(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&A(r,null),r}}e.MutableDisposable=d;class h{constructor(){this.references=new Map}acquire(r,...n){let l=this.references.get(r);l||(l={counter:0,object:this.createReferencedObject(r,...n)},this.references.set(r,l));const{object:f}=l,m=(0,p.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(r,l.object),this.references.delete(r))});return l.counter++,{object:f,dispose:m}}}e.ReferenceCollection=h;class v{constructor(r){this.referenceCollection=r}async acquire(r,...n){const l=this.referenceCollection.acquire(r,...n);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(f){throw l.dispose(),f}}}e.AsyncReferenceCollection=v;class t{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=t}),define(he[92],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(y){this.element=y,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class L{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let y=this._first;for(;y!==p.Undefined;){const T=y.next;y.prev=p.Undefined,y.next=p.Undefined,y=T}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(y){return this._insert(y,!1)}push(y){return this._insert(y,!0)}_insert(y,T){const I=new p(y);if(this._first===p.Undefined)this._first=I,this._last=I;else if(T){const A=this._last;this._last=I,I.prev=A,A.next=I}else{const A=this._first;this._first=I,I.next=A,A.prev=I}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(I))}}shift(){if(this._first!==p.Undefined){const y=this._first.element;return this._remove(this._first),y}}pop(){if(this._last!==p.Undefined){const y=this._last.element;return this._remove(this._last),y}}_remove(y){if(y.prev!==p.Undefined&&y.next!==p.Undefined){const T=y.prev;T.next=y.next,y.next.prev=T}else y.prev===p.Undefined&&y.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):y.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):y.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let y=this._first;for(;y!==p.Undefined;)yield y.element,y=y.next}}e.LinkedList=L}),function(X,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(X=typeof globalThis!="undefined"?globalThis:X||self,X.marked=e())}(this,function(){"use strict";function X(ke,Ce){for(var Re=0;Re<Ce.length;Re++){var se=Ce[Re];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(ke,se.key,se)}}function e(ke,Ce,Re){return Ce&&X(ke.prototype,Ce),Re&&X(ke,Re),ke}function p(ke,Ce){if(!!ke){if(typeof ke=="string")return L(ke,Ce);var Re=Object.prototype.toString.call(ke).slice(8,-1);if(Re==="Object"&&ke.constructor&&(Re=ke.constructor.name),Re==="Map"||Re==="Set")return Array.from(ke);if(Re==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Re))return L(ke,Ce)}}function L(ke,Ce){(Ce==null||Ce>ke.length)&&(Ce=ke.length);for(var Re=0,se=new Array(Ce);Re<Ce;Re++)se[Re]=ke[Re];return se}function C(ke,Ce){var Re;if(typeof Symbol=="undefined"||ke[Symbol.iterator]==null){if(Array.isArray(ke)||(Re=p(ke))||Ce&&ke&&typeof ke.length=="number"){Re&&(ke=Re);var se=0;return function(){return se>=ke.length?{done:!0}:{done:!1,value:ke[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Re=ke[Symbol.iterator](),Re.next.bind(Re)}function y(ke){var Ce={exports:{}};return ke(Ce,Ce.exports),Ce.exports}var T=y(function(ke){function Ce(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Re(se){ke.exports.defaults=se}ke.exports={defaults:Ce(),getDefaults:Ce,changeDefaults:Re}}),I=/[&<>"']/,D=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,i=/[<>"']|&(?!#?\w+;)/g,P={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},c=function(Ce){return P[Ce]};function u(ke,Ce){if(Ce){if(I.test(ke))return ke.replace(D,c)}else if(A.test(ke))return ke.replace(i,c);return ke}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(ke){return ke.replace(a,function(Ce,Re){return Re=Re.toLowerCase(),Re==="colon"?":":Re.charAt(0)==="#"?Re.charAt(1)==="x"?String.fromCharCode(parseInt(Re.substring(2),16)):String.fromCharCode(+Re.substring(1)):""})}var w=/(^|[^\[])\^/g;function _(ke,Ce){ke=ke.source||ke,Ce=Ce||"";var Re={replace:function(le,me){return me=me.source||me,me=me.replace(w,"$1"),ke=ke.replace(le,me),Re},getRegex:function(){return new RegExp(ke,Ce)}};return Re}var b=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(ke,Ce,Re){if(ke){var se;try{se=decodeURIComponent(g(Re)).replace(b,"").toLowerCase()}catch(le){return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}Ce&&!d.test(Re)&&(Re=n(Ce,Re));try{Re=encodeURI(Re).replace(/%25/g,"%")}catch(le){return null}return Re}var v={},t=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(ke,Ce){v[" "+ke]||(t.test(ke)?v[" "+ke]=ke+"/":v[" "+ke]=E(ke,"/",!0)),ke=v[" "+ke];var Re=ke.indexOf(":")===-1;return Ce.substring(0,2)==="//"?Re?Ce:ke.replace(s,"$1")+Ce:Ce.charAt(0)==="/"?Re?Ce:ke.replace(r,"$1")+Ce:ke+Ce}var l={exec:function(){}};function f(ke){for(var Ce=1,Re,se;Ce<arguments.length;Ce++){Re=arguments[Ce];for(se in Re)Object.prototype.hasOwnProperty.call(Re,se)&&(ke[se]=Re[se])}return ke}function m(ke,Ce){var Re=ke.replace(/\|/g,function(me,be,q){for(var ge=!1,ye=be;--ye>=0&&q[ye]==="\\";)ge=!ge;return ge?"|":" |"}),se=Re.split(/ \|/),le=0;if(se.length>Ce)se.splice(Ce);else for(;se.length<Ce;)se.push("");for(;le<se.length;le++)se[le]=se[le].trim().replace(/\\\|/g,"|");return se}function E(ke,Ce,Re){var se=ke.length;if(se===0)return"";for(var le=0;le<se;){var me=ke.charAt(se-le-1);if(me===Ce&&!Re)le++;else if(me!==Ce&&Re)le++;else break}return ke.substr(0,se-le)}function S(ke,Ce){if(ke.indexOf(Ce[1])===-1)return-1;for(var Re=ke.length,se=0,le=0;le<Re;le++)if(ke[le]==="\\")le++;else if(ke[le]===Ce[0])se++;else if(ke[le]===Ce[1]&&(se--,se<0))return le;return-1}function o(ke){ke&&ke.sanitize&&!ke.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function k(ke,Ce){if(Ce<1)return"";for(var Re="";Ce>1;)Ce&1&&(Re+=ke),Ce>>=1,ke+=ke;return Re+ke}var O={escape:u,unescape:g,edit:_,cleanUrl:h,resolveUrl:n,noopTest:l,merge:f,splitCells:m,rtrim:E,findClosingBracket:S,checkSanitizeDeprecation:o,repeatString:k},$=T.defaults,G=O.rtrim,re=O.splitCells,j=O.escape,N=O.findClosingBracket;function x(ke,Ce,Re){var se=Ce.href,le=Ce.title?j(Ce.title):null,me=ke[1].replace(/\\([\[\]])/g,"$1");return ke[0].charAt(0)!=="!"?{type:"link",raw:Re,href:se,title:le,text:me}:{type:"image",raw:Re,href:se,title:le,text:j(me)}}function R(ke,Ce){var Re=ke.match(/^(\s+)(?:```)/);if(Re===null)return Ce;var se=Re[1];return Ce.split(`
`).map(function(le){var me=le.match(/^\s+/);if(me===null)return le;var be=me[0];return be.length>=se.length?le.slice(se.length):le}).join(`
`)}var V=function(){function ke(Re){this.options=Re||$}var Ce=ke.prototype;return Ce.space=function(se){var le=this.rules.block.newline.exec(se);if(le)return le[0].length>1?{type:"space",raw:le[0]}:{raw:`
`}},Ce.code=function(se){var le=this.rules.block.code.exec(se);if(le){var me=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?me:G(me,`
`)}}},Ce.fences=function(se){var le=this.rules.block.fences.exec(se);if(le){var me=le[0],be=R(me,le[3]||"");return{type:"code",raw:me,lang:le[2]?le[2].trim():le[2],text:be}}},Ce.heading=function(se){var le=this.rules.block.heading.exec(se);if(le){var me=le[2].trim();if(/#$/.test(me)){var be=G(me,"#");(this.options.pedantic||!be||/ $/.test(be))&&(me=be.trim())}return{type:"heading",raw:le[0],depth:le[1].length,text:me}}},Ce.nptable=function(se){var le=this.rules.block.nptable.exec(se);if(le){var me={type:"table",header:re(le[1].replace(/^ *| *\| *$/g,"")),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:le[3]?le[3].replace(/\n$/,"").split(`
`):[],raw:le[0]};if(me.header.length===me.align.length){var be=me.align.length,q;for(q=0;q<be;q++)/^ *-+: *$/.test(me.align[q])?me.align[q]="right":/^ *:-+: *$/.test(me.align[q])?me.align[q]="center":/^ *:-+ *$/.test(me.align[q])?me.align[q]="left":me.align[q]=null;for(be=me.cells.length,q=0;q<be;q++)me.cells[q]=re(me.cells[q],me.header.length);return me}}},Ce.hr=function(se){var le=this.rules.block.hr.exec(se);if(le)return{type:"hr",raw:le[0]}},Ce.blockquote=function(se){var le=this.rules.block.blockquote.exec(se);if(le){var me=le[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:le[0],text:me}}},Ce.list=function(se){var le=this.rules.block.list.exec(se);if(le){var me=le[0],be=le[2],q=be.length>1,ge={type:"list",raw:me,ordered:q,start:q?+be.slice(0,-1):"",loose:!1,items:[]},ye=le[0].match(this.rules.block.item),Te=!1,Oe,Ge,Ze,Qe,Xe,at,ut,bt,ve=ye.length;Ze=this.rules.block.listItemStart.exec(ye[0]);for(var De=0;De<ve;De++){if(Oe=ye[De],me=Oe,De!==ve-1){if(Qe=this.rules.block.listItemStart.exec(ye[De+1]),this.options.pedantic?Qe[1].length>Ze[1].length:Qe[1].length>Ze[0].length||Qe[1].length>3){ye.splice(De,2,ye[De]+`
`+ye[De+1]),De--,ve--;continue}else(!this.options.pedantic||this.options.smartLists?Qe[2][Qe[2].length-1]!==be[be.length-1]:q===(Qe[2].length===1))&&(Xe=ye.slice(De+1).join(`
`),ge.raw=ge.raw.substring(0,ge.raw.length-Xe.length),De=ve-1);Ze=Qe}Ge=Oe.length,Oe=Oe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Oe.indexOf(`
 `)&&(Ge-=Oe.length,Oe=this.options.pedantic?Oe.replace(/^ {1,4}/gm,""):Oe.replace(new RegExp("^ {1,"+Ge+"}","gm"),"")),at=Te||/\n\n(?!\s*$)/.test(Oe),De!==ve-1&&(Te=Oe.charAt(Oe.length-1)===`
`,at||(at=Te)),at&&(ge.loose=!0),this.options.gfm&&(ut=/^\[[ xX]\] /.test(Oe),bt=void 0,ut&&(bt=Oe[1]!==" ",Oe=Oe.replace(/^\[[ xX]\] +/,""))),ge.items.push({type:"list_item",raw:me,task:ut,checked:bt,loose:at,text:Oe})}return ge}},Ce.html=function(se){var le=this.rules.block.html.exec(se);if(le)return{type:this.options.sanitize?"paragraph":"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):j(le[0]):le[0]}},Ce.def=function(se){var le=this.rules.block.def.exec(se);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var me=le[1].toLowerCase().replace(/\s+/g," ");return{tag:me,raw:le[0],href:le[2],title:le[3]}}},Ce.table=function(se){var le=this.rules.block.table.exec(se);if(le){var me={type:"table",header:re(le[1].replace(/^ *| *\| *$/g,"")),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:le[3]?le[3].replace(/\n$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=le[0];var be=me.align.length,q;for(q=0;q<be;q++)/^ *-+: *$/.test(me.align[q])?me.align[q]="right":/^ *:-+: *$/.test(me.align[q])?me.align[q]="center":/^ *:-+ *$/.test(me.align[q])?me.align[q]="left":me.align[q]=null;for(be=me.cells.length,q=0;q<be;q++)me.cells[q]=re(me.cells[q].replace(/^ *\| *| *\| *$/g,""),me.header.length);return me}}},Ce.lheading=function(se){var le=this.rules.block.lheading.exec(se);if(le)return{type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1]}},Ce.paragraph=function(se){var le=this.rules.block.paragraph.exec(se);if(le)return{type:"paragraph",raw:le[0],text:le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1]}},Ce.text=function(se){var le=this.rules.block.text.exec(se);if(le)return{type:"text",raw:le[0],text:le[0]}},Ce.escape=function(se){var le=this.rules.inline.escape.exec(se);if(le)return{type:"escape",raw:le[0],text:j(le[1])}},Ce.tag=function(se,le,me){var be=this.rules.inline.tag.exec(se);if(be)return!le&&/^<a /i.test(be[0])?le=!0:le&&/^<\/a>/i.test(be[0])&&(le=!1),!me&&/^<(pre|code|kbd|script)(\s|>)/i.test(be[0])?me=!0:me&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(be[0])&&(me=!1),{type:this.options.sanitize?"text":"html",raw:be[0],inLink:le,inRawBlock:me,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(be[0]):j(be[0]):be[0]}},Ce.link=function(se){var le=this.rules.inline.link.exec(se);if(le){var me=le[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var be=G(me.slice(0,-1),"\\");if((me.length-be.length)%2==0)return}else{var q=N(le[2],"()");if(q>-1){var ge=le[0].indexOf("!")===0?5:4,ye=ge+le[1].length+q;le[2]=le[2].substring(0,q),le[0]=le[0].substring(0,ye).trim(),le[3]=""}}var Te=le[2],Oe="";if(this.options.pedantic){var Ge=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Te);Ge&&(Te=Ge[1],Oe=Ge[3])}else Oe=le[3]?le[3].slice(1,-1):"";return Te=Te.trim(),/^</.test(Te)&&(this.options.pedantic&&!/>$/.test(me)?Te=Te.slice(1):Te=Te.slice(1,-1)),x(le,{href:Te&&Te.replace(this.rules.inline._escapes,"$1"),title:Oe&&Oe.replace(this.rules.inline._escapes,"$1")},le[0])}},Ce.reflink=function(se,le){var me;if((me=this.rules.inline.reflink.exec(se))||(me=this.rules.inline.nolink.exec(se))){var be=(me[2]||me[1]).replace(/\s+/g," ");if(be=le[be.toLowerCase()],!be||!be.href){var q=me[0].charAt(0);return{type:"text",raw:q,text:q}}return x(me,be,me[0])}},Ce.emStrong=function(se,le,me){me===void 0&&(me="");var be=this.rules.inline.emStrong.lDelim.exec(se);if(!!be&&!(be[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var q=be[1]||be[2]||"";if(!q||q&&(me===""||this.rules.inline.punctuation.exec(me))){var ge=be[0].length-1,ye,Te,Oe=ge,Ge=0,Ze=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ze.lastIndex=0,le=le.slice(-1*se.length+ge);(be=Ze.exec(le))!=null;)if(ye=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!ye){if(Te=ye.length,be[3]||be[4]){Oe+=Te;continue}else if((be[5]||be[6])&&ge%3&&!((ge+Te)%3)){Ge+=Te;continue}if(Oe-=Te,!(Oe>0)){if(Oe+Ge-Te<=0&&!le.slice(Ze.lastIndex).match(Ze)&&(Te=Math.min(Te,Te+Oe+Ge)),Math.min(ge,Te)%2)return{type:"em",raw:se.slice(0,ge+be.index+Te+1),text:se.slice(1,ge+be.index+Te)};if(Math.min(ge,Te)%2==0)return{type:"strong",raw:se.slice(0,ge+be.index+Te+1),text:se.slice(2,ge+be.index+Te-1)}}}}}},Ce.codespan=function(se){var le=this.rules.inline.code.exec(se);if(le){var me=le[2].replace(/\n/g," "),be=/[^ ]/.test(me),q=/^ /.test(me)&&/ $/.test(me);return be&&q&&(me=me.substring(1,me.length-1)),me=j(me,!0),{type:"codespan",raw:le[0],text:me}}},Ce.br=function(se){var le=this.rules.inline.br.exec(se);if(le)return{type:"br",raw:le[0]}},Ce.del=function(se){var le=this.rules.inline.del.exec(se);if(le)return{type:"del",raw:le[0],text:le[2]}},Ce.autolink=function(se,le){var me=this.rules.inline.autolink.exec(se);if(me){var be,q;return me[2]==="@"?(be=j(this.options.mangle?le(me[1]):me[1]),q="mailto:"+be):(be=j(me[1]),q=be),{type:"link",raw:me[0],text:be,href:q,tokens:[{type:"text",raw:be,text:be}]}}},Ce.url=function(se,le){var me;if(me=this.rules.inline.url.exec(se)){var be,q;if(me[2]==="@")be=j(this.options.mangle?le(me[0]):me[0]),q="mailto:"+be;else{var ge;do ge=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(ge!==me[0]);be=j(me[0]),me[1]==="www."?q="http://"+be:q=be}return{type:"link",raw:me[0],text:be,href:q,tokens:[{type:"text",raw:be,text:be}]}}},Ce.inlineText=function(se,le,me){var be=this.rules.inline.text.exec(se);if(be){var q;return le?q=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(be[0]):j(be[0]):be[0]:q=j(this.options.smartypants?me(be[0]):be[0]),{type:"text",raw:be[0],text:q}}},ke}(),F=O.noopTest,M=O.edit,B=O.merge,W={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:F,table:F,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};W._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,W._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,W.def=M(W.def).replace("label",W._label).replace("title",W._title).getRegex(),W.bullet=/(?:[*+-]|\d{1,9}[.)])/,W.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,W.item=M(W.item,"gm").replace(/bull/g,W.bullet).getRegex(),W.listItemStart=M(/^( *)(bull)/).replace("bull",W.bullet).getRegex(),W.list=M(W.list).replace(/bull/g,W.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+W.def.source+")").getRegex(),W._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",W._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,W.html=M(W.html,"i").replace("comment",W._comment).replace("tag",W._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),W.paragraph=M(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",W._tag).getRegex(),W.blockquote=M(W.blockquote).replace("paragraph",W.paragraph).getRegex(),W.normal=B({},W),W.gfm=B({},W.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),W.gfm.nptable=M(W.gfm.nptable).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",W._tag).getRegex(),W.gfm.table=M(W.gfm.table).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",W._tag).getRegex(),W.pedantic=B({},W.normal,{html:M(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",W._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:F,paragraph:M(W.normal._paragraph).replace("hr",W.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",W.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:F,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:F,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=M(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=M(W._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=M(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=M(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=M(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=M(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=M(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=M(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=M(Q.reflink).replace("label",Q._label).getRegex(),Q.reflinkSearch=M(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=B({},Q),Q.pedantic=B({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:M(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:M(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=B({},Q.normal,{escape:M(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),Q.gfm.url=M(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=B({},Q.gfm,{br:M(Q.br).replace("{2,}","*").getRegex(),text:M(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ae={block:W,inline:Q},_e=T.defaults,Fe=ae.block,Ae=ae.inline,Me=O.repeatString;function Ve(ke){return ke.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function He(ke){var Ce="",Re,se,le=ke.length;for(Re=0;Re<le;Re++)se=ke.charCodeAt(Re),Math.random()>.5&&(se="x"+se.toString(16)),Ce+="&#"+se+";";return Ce}var z=function(){function ke(Re){this.tokens=[],this.tokens.links=Object.create(null),this.options=Re||_e,this.options.tokenizer=this.options.tokenizer||new V,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var se={block:Fe.normal,inline:Ae.normal};this.options.pedantic?(se.block=Fe.pedantic,se.inline=Ae.pedantic):this.options.gfm&&(se.block=Fe.gfm,this.options.breaks?se.inline=Ae.breaks:se.inline=Ae.gfm),this.tokenizer.rules=se}ke.lex=function(se,le){var me=new ke(le);return me.lex(se)},ke.lexInline=function(se,le){var me=new ke(le);return me.inlineTokens(se)};var Ce=ke.prototype;return Ce.lex=function(se){return se=se.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(se,this.tokens,!0),this.inline(this.tokens),this.tokens},Ce.blockTokens=function(se,le,me){le===void 0&&(le=[]),me===void 0&&(me=!0),this.options.pedantic&&(se=se.replace(/^ +$/gm,""));for(var be,q,ge,ye;se;){if(be=this.tokenizer.space(se)){se=se.substring(be.raw.length),be.type&&le.push(be);continue}if(be=this.tokenizer.code(se)){se=se.substring(be.raw.length),ye=le[le.length-1],ye&&ye.type==="paragraph"?(ye.raw+=`
`+be.raw,ye.text+=`
`+be.text):le.push(be);continue}if(be=this.tokenizer.fences(se)){se=se.substring(be.raw.length),le.push(be);continue}if(be=this.tokenizer.heading(se)){se=se.substring(be.raw.length),le.push(be);continue}if(be=this.tokenizer.nptable(se)){se=se.substring(be.raw.length),le.push(be);continue}if(be=this.tokenizer.hr(se)){se=se.substring(be.raw.length),le.push(be);continue}if(be=this.tokenizer.blockquote(se)){se=se.substring(be.raw.length),be.tokens=this.blockTokens(be.text,[],me),le.push(be);continue}if(be=this.tokenizer.list(se)){for(se=se.substring(be.raw.length),ge=be.items.length,q=0;q<ge;q++)be.items[q].tokens=this.blockTokens(be.items[q].text,[],!1);le.push(be);continue}if(be=this.tokenizer.html(se)){se=se.substring(be.raw.length),le.push(be);continue}if(me&&(be=this.tokenizer.def(se))){se=se.substring(be.raw.length),this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(se)){se=se.substring(be.raw.length),le.push(be);continue}if(be=this.tokenizer.lheading(se)){se=se.substring(be.raw.length),le.push(be);continue}if(me&&(be=this.tokenizer.paragraph(se))){se=se.substring(be.raw.length),le.push(be);continue}if(be=this.tokenizer.text(se)){se=se.substring(be.raw.length),ye=le[le.length-1],ye&&ye.type==="text"?(ye.raw+=`
`+be.raw,ye.text+=`
`+be.text):le.push(be);continue}if(se){var Te="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(Te);break}else throw new Error(Te)}}return le},Ce.inline=function(se){var le,me,be,q,ge,ye,Te=se.length;for(le=0;le<Te;le++)switch(ye=se[le],ye.type){case"paragraph":case"text":case"heading":{ye.tokens=[],this.inlineTokens(ye.text,ye.tokens);break}case"table":{for(ye.tokens={header:[],cells:[]},q=ye.header.length,me=0;me<q;me++)ye.tokens.header[me]=[],this.inlineTokens(ye.header[me],ye.tokens.header[me]);for(q=ye.cells.length,me=0;me<q;me++)for(ge=ye.cells[me],ye.tokens.cells[me]=[],be=0;be<ge.length;be++)ye.tokens.cells[me][be]=[],this.inlineTokens(ge[be],ye.tokens.cells[me][be]);break}case"blockquote":{this.inline(ye.tokens);break}case"list":{for(q=ye.items.length,me=0;me<q;me++)this.inline(ye.items[me].tokens);break}}return se},Ce.inlineTokens=function(se,le,me,be){le===void 0&&(le=[]),me===void 0&&(me=!1),be===void 0&&(be=!1);var q,ge,ye=se,Te,Oe,Ge;if(this.tokens.links){var Ze=Object.keys(this.tokens.links);if(Ze.length>0)for(;(Te=this.tokenizer.rules.inline.reflinkSearch.exec(ye))!=null;)Ze.includes(Te[0].slice(Te[0].lastIndexOf("[")+1,-1))&&(ye=ye.slice(0,Te.index)+"["+Me("a",Te[0].length-2)+"]"+ye.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Te=this.tokenizer.rules.inline.blockSkip.exec(ye))!=null;)ye=ye.slice(0,Te.index)+"["+Me("a",Te[0].length-2)+"]"+ye.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Te=this.tokenizer.rules.inline.escapedEmSt.exec(ye))!=null;)ye=ye.slice(0,Te.index)+"++"+ye.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;){if(Oe||(Ge=""),Oe=!1,q=this.tokenizer.escape(se)){se=se.substring(q.raw.length),le.push(q);continue}if(q=this.tokenizer.tag(se,me,be)){se=se.substring(q.raw.length),me=q.inLink,be=q.inRawBlock;var Qe=le[le.length-1];Qe&&q.type==="text"&&Qe.type==="text"?(Qe.raw+=q.raw,Qe.text+=q.text):le.push(q);continue}if(q=this.tokenizer.link(se)){se=se.substring(q.raw.length),q.type==="link"&&(q.tokens=this.inlineTokens(q.text,[],!0,be)),le.push(q);continue}if(q=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(q.raw.length);var Xe=le[le.length-1];q.type==="link"?(q.tokens=this.inlineTokens(q.text,[],!0,be),le.push(q)):Xe&&q.type==="text"&&Xe.type==="text"?(Xe.raw+=q.raw,Xe.text+=q.text):le.push(q);continue}if(q=this.tokenizer.emStrong(se,ye,Ge)){se=se.substring(q.raw.length),q.tokens=this.inlineTokens(q.text,[],me,be),le.push(q);continue}if(q=this.tokenizer.codespan(se)){se=se.substring(q.raw.length),le.push(q);continue}if(q=this.tokenizer.br(se)){se=se.substring(q.raw.length),le.push(q);continue}if(q=this.tokenizer.del(se)){se=se.substring(q.raw.length),q.tokens=this.inlineTokens(q.text,[],me,be),le.push(q);continue}if(q=this.tokenizer.autolink(se,He)){se=se.substring(q.raw.length),le.push(q);continue}if(!me&&(q=this.tokenizer.url(se,He))){se=se.substring(q.raw.length),le.push(q);continue}if(q=this.tokenizer.inlineText(se,be,Ve)){se=se.substring(q.raw.length),q.raw.slice(-1)!=="_"&&(Ge=q.raw.slice(-1)),Oe=!0,ge=le[le.length-1],ge&&ge.type==="text"?(ge.raw+=q.raw,ge.text+=q.text):le.push(q);continue}if(se){var at="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(at);break}else throw new Error(at)}}return le},e(ke,null,[{key:"rules",get:function(){return{block:Fe,inline:Ae}}}]),ke}(),J=T.defaults,ne=O.cleanUrl,oe=O.escape,we=function(){function ke(Re){this.options=Re||J}var Ce=ke.prototype;return Ce.code=function(se,le,me){var be=(le||"").match(/\S*/)[0];if(this.options.highlight){var q=this.options.highlight(se,be);q!=null&&q!==se&&(me=!0,se=q)}return se=se.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+oe(be,!0)+'">'+(me?se:oe(se,!0))+`</code></pre>
`:"<pre><code>"+(me?se:oe(se,!0))+`</code></pre>
`},Ce.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},Ce.html=function(se){return se},Ce.heading=function(se,le,me,be){return this.options.headerIds?"<h"+le+' id="'+this.options.headerPrefix+be.slug(me)+'">'+se+"</h"+le+`>
`:"<h"+le+">"+se+"</h"+le+`>
`},Ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ce.list=function(se,le,me){var be=le?"ol":"ul",q=le&&me!==1?' start="'+me+'"':"";return"<"+be+q+`>
`+se+"</"+be+`>
`},Ce.listitem=function(se){return"<li>"+se+`</li>
`},Ce.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ce.paragraph=function(se){return"<p>"+se+`</p>
`},Ce.table=function(se,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+le+`</table>
`},Ce.tablerow=function(se){return`<tr>
`+se+`</tr>
`},Ce.tablecell=function(se,le){var me=le.header?"th":"td",be=le.align?"<"+me+' align="'+le.align+'">':"<"+me+">";return be+se+"</"+me+`>
`},Ce.strong=function(se){return"<strong>"+se+"</strong>"},Ce.em=function(se){return"<em>"+se+"</em>"},Ce.codespan=function(se){return"<code>"+se+"</code>"},Ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ce.del=function(se){return"<del>"+se+"</del>"},Ce.link=function(se,le,me){if(se=ne(this.options.sanitize,this.options.baseUrl,se),se===null)return me;var be='<a href="'+oe(se)+'"';return le&&(be+=' title="'+le+'"'),be+=">"+me+"</a>",be},Ce.image=function(se,le,me){if(se=ne(this.options.sanitize,this.options.baseUrl,se),se===null)return me;var be='<img src="'+se+'" alt="'+me+'"';return le&&(be+=' title="'+le+'"'),be+=this.options.xhtml?"/>":">",be},Ce.text=function(se){return se},ke}(),Z=function(){function ke(){}var Ce=ke.prototype;return Ce.strong=function(se){return se},Ce.em=function(se){return se},Ce.codespan=function(se){return se},Ce.del=function(se){return se},Ce.html=function(se){return se},Ce.text=function(se){return se},Ce.link=function(se,le,me){return""+me},Ce.image=function(se,le,me){return""+me},Ce.br=function(){return""},ke}(),de=function(){function ke(){this.seen={}}var Ce=ke.prototype;return Ce.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ce.getNextSafeSlug=function(se,le){var me=se,be=0;if(this.seen.hasOwnProperty(me)){be=this.seen[se];do be++,me=se+"-"+be;while(this.seen.hasOwnProperty(me))}return le||(this.seen[se]=be,this.seen[me]=0),me},Ce.slug=function(se,le){le===void 0&&(le={});var me=this.serialize(se);return this.getNextSafeSlug(me,le.dryrun)},ke}(),Ie=T.defaults,Be=O.unescape,qe=function(){function ke(Re){this.options=Re||Ie,this.options.renderer=this.options.renderer||new we,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Z,this.slugger=new de}ke.parse=function(se,le){var me=new ke(le);return me.parse(se)},ke.parseInline=function(se,le){var me=new ke(le);return me.parseInline(se)};var Ce=ke.prototype;return Ce.parse=function(se,le){le===void 0&&(le=!0);var me="",be,q,ge,ye,Te,Oe,Ge,Ze,Qe,Xe,at,ut,bt,ve,De,ce,Y,Se,ze=se.length;for(be=0;be<ze;be++)switch(Xe=se[be],Xe.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(Xe.tokens),Xe.depth,Be(this.parseInline(Xe.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(Xe.text,Xe.lang,Xe.escaped);continue}case"table":{for(Ze="",Ge="",ye=Xe.header.length,q=0;q<ye;q++)Ge+=this.renderer.tablecell(this.parseInline(Xe.tokens.header[q]),{header:!0,align:Xe.align[q]});for(Ze+=this.renderer.tablerow(Ge),Qe="",ye=Xe.cells.length,q=0;q<ye;q++){for(Oe=Xe.tokens.cells[q],Ge="",Te=Oe.length,ge=0;ge<Te;ge++)Ge+=this.renderer.tablecell(this.parseInline(Oe[ge]),{header:!1,align:Xe.align[ge]});Qe+=this.renderer.tablerow(Ge)}me+=this.renderer.table(Ze,Qe);continue}case"blockquote":{Qe=this.parse(Xe.tokens),me+=this.renderer.blockquote(Qe);continue}case"list":{for(at=Xe.ordered,ut=Xe.start,bt=Xe.loose,ye=Xe.items.length,Qe="",q=0;q<ye;q++)De=Xe.items[q],ce=De.checked,Y=De.task,ve="",De.task&&(Se=this.renderer.checkbox(ce),bt?De.tokens.length>0&&De.tokens[0].type==="text"?(De.tokens[0].text=Se+" "+De.tokens[0].text,De.tokens[0].tokens&&De.tokens[0].tokens.length>0&&De.tokens[0].tokens[0].type==="text"&&(De.tokens[0].tokens[0].text=Se+" "+De.tokens[0].tokens[0].text)):De.tokens.unshift({type:"text",text:Se}):ve+=Se),ve+=this.parse(De.tokens,bt),Qe+=this.renderer.listitem(ve,Y,ce);me+=this.renderer.list(Qe,at,ut);continue}case"html":{me+=this.renderer.html(Xe.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(Xe.tokens));continue}case"text":{for(Qe=Xe.tokens?this.parseInline(Xe.tokens):Xe.text;be+1<ze&&se[be+1].type==="text";)Xe=se[++be],Qe+=`
`+(Xe.tokens?this.parseInline(Xe.tokens):Xe.text);me+=le?this.renderer.paragraph(Qe):Qe;continue}default:{var Je='Token with "'+Xe.type+'" type was not found.';if(this.options.silent){console.error(Je);return}else throw new Error(Je)}}return me},Ce.parseInline=function(se,le){le=le||this.renderer;var me="",be,q,ge=se.length;for(be=0;be<ge;be++)switch(q=se[be],q.type){case"escape":{me+=le.text(q.text);break}case"html":{me+=le.html(q.text);break}case"link":{me+=le.link(q.href,q.title,this.parseInline(q.tokens,le));break}case"image":{me+=le.image(q.href,q.title,q.text);break}case"strong":{me+=le.strong(this.parseInline(q.tokens,le));break}case"em":{me+=le.em(this.parseInline(q.tokens,le));break}case"codespan":{me+=le.codespan(q.text);break}case"br":{me+=le.br();break}case"del":{me+=le.del(this.parseInline(q.tokens,le));break}case"text":{me+=le.text(q.text);break}default:{var ye='Token with "'+q.type+'" type was not found.';if(this.options.silent){console.error(ye);return}else throw new Error(ye)}}return me},ke}(),Ee=O.merge,tt=O.checkSanitizeDeprecation,K=O.escape,ee=T.getDefaults,pe=T.changeDefaults,xe=T.defaults;function $e(ke,Ce,Re){if(typeof ke=="undefined"||ke===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");if(typeof Ce=="function"&&(Re=Ce,Ce=null),Ce=Ee({},$e.defaults,Ce||{}),tt(Ce),Re){var se=Ce.highlight,le;try{le=z.lex(ke,Ce)}catch(ge){return Re(ge)}var me=function(ye){var Te;if(!ye)try{Te=qe.parse(le,Ce)}catch(Oe){ye=Oe}return Ce.highlight=se,ye?Re(ye):Re(null,Te)};if(!se||se.length<3||(delete Ce.highlight,!le.length))return me();var be=0;$e.walkTokens(le,function(ge){ge.type==="code"&&(be++,setTimeout(function(){se(ge.text,ge.lang,function(ye,Te){if(ye)return me(ye);Te!=null&&Te!==ge.text&&(ge.text=Te,ge.escaped=!0),be--,be===0&&me()})},0))}),be===0&&me();return}try{var q=z.lex(ke,Ce);return Ce.walkTokens&&$e.walkTokens(q,Ce.walkTokens),qe.parse(q,Ce)}catch(ge){if(ge.message+=`
Please report this to https://github.com/markedjs/marked.`,Ce.silent)return"<p>An error occurred:</p><pre>"+K(ge.message+"",!0)+"</pre>";throw ge}}$e.options=$e.setOptions=function(ke){return Ee($e.defaults,ke),pe($e.defaults),$e},$e.getDefaults=ee,$e.defaults=xe,$e.use=function(ke){var Ce=Ee({},ke);if(ke.renderer&&function(){var se=$e.defaults.renderer||new we,le=function(q){var ge=se[q];se[q]=function(){for(var ye=arguments.length,Te=new Array(ye),Oe=0;Oe<ye;Oe++)Te[Oe]=arguments[Oe];var Ge=ke.renderer[q].apply(se,Te);return Ge===!1&&(Ge=ge.apply(se,Te)),Ge}};for(var me in ke.renderer)le(me);Ce.renderer=se}(),ke.tokenizer&&function(){var se=$e.defaults.tokenizer||new V,le=function(q){var ge=se[q];se[q]=function(){for(var ye=arguments.length,Te=new Array(ye),Oe=0;Oe<ye;Oe++)Te[Oe]=arguments[Oe];var Ge=ke.tokenizer[q].apply(se,Te);return Ge===!1&&(Ge=ge.apply(se,Te)),Ge}};for(var me in ke.tokenizer)le(me);Ce.tokenizer=se}(),ke.walkTokens){var Re=$e.defaults.walkTokens;Ce.walkTokens=function(se){ke.walkTokens(se),Re&&Re(se)}}$e.setOptions(Ce)},$e.walkTokens=function(ke,Ce){for(var Re=C(ke),se;!(se=Re()).done;){var le=se.value;switch(Ce(le),le.type){case"table":{for(var me=C(le.tokens.header),be;!(be=me()).done;){var q=be.value;$e.walkTokens(q,Ce)}for(var ge=C(le.tokens.cells),ye;!(ye=ge()).done;)for(var Te=ye.value,Oe=C(Te),Ge;!(Ge=Oe()).done;){var Ze=Ge.value;$e.walkTokens(Ze,Ce)}break}case"list":{$e.walkTokens(le.items,Ce);break}default:le.tokens&&$e.walkTokens(le.tokens,Ce)}}},$e.parseInline=function(ke,Ce){if(typeof ke=="undefined"||ke===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");Ce=Ee({},$e.defaults,Ce||{}),tt(Ce);try{var Re=z.lexInline(ke,Ce);return Ce.walkTokens&&$e.walkTokens(Re,Ce.walkTokens),qe.parseInline(Re,Ce)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,Ce.silent)return"<p>An error occurred:</p><pre>"+K(se.message+"",!0)+"</pre>";throw se}},$e.Parser=qe,$e.parser=qe.parse,$e.Renderer=we,$e.TextRenderer=Z,$e.Lexer=z,$e.lexer=z.lex,$e.Tokenizer=V,$e.Slugger=de,$e.parse=$e;var et=$e;return et}),define(he[73],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function p(T,I,D){return Math.min(Math.max(T,I),D)}e.clamp=p;function L(T,I){return(I+T%I)%I}e.rot=L;class C{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=C;class y{constructor(){this._n=1,this._val=0}update(I){return this._val=this._val+(I-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=y}),function(){function X(C){const y=[];typeof C=="number"&&y.push("code/timeOrigin",C);function T(D){y.push(D,Date.now())}function I(){const D=[];for(let A=0;A<y.length;A+=2)D.push({name:y[A],startTime:y[A+1]});return D}return{mark:T,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const y=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const T of performance.getEntriesByType("mark"))y.push({name:T.name,startTime:Math.round(C+T.startTime)});return y}};if(typeof process=="object"){const C=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function p(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=p(L))}(),define(he[11],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const p="en";let L=!1,C=!1,y=!1,T=!1,I=!1,D=!1,A=!1,i,P=p,c,u;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?a=e.globals.vscode.process:typeof process!="undefined"&&(a=process);const g=typeof a?.versions?.electron=="string"&&a.type==="renderer";if(e.isElectronSandboxed=g&&a?.sandboxed,e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=a?.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!g)u=navigator.userAgent,L=u.indexOf("Windows")>=0,C=u.indexOf("Macintosh")>=0,A=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=u.indexOf("Linux")>=0,D=!0,i=navigator.language,P=i;else if(typeof a=="object"){L=a.platform==="win32",C=a.platform==="darwin",y=a.platform==="linux",T=y&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,i=p,P=p;const r=a.env.VSCODE_NLS_CONFIG;if(r)try{const n=JSON.parse(r),l=n.availableLanguages["*"];i=n.locale,P=l||p,c=n._translationsConfigFile}catch(n){}I=!0}else console.error("Unable to resolve platform.");var w;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function _(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=_;let b=0;C?b=1:L?b=3:y&&(b=2),e.isWindows=L,e.isMacintosh=C,e.isLinux=y,e.isLinuxSnap=T,e.isNative=I,e.isWeb=D,e.isIOS=A,e.platform=b,e.userAgent=u,e.language=P;var d;(function(r){function n(){return e.language}r.value=n;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=l;function f(){return e.language==="en"}r.isDefault=f})(d=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=c,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",m=>{if(m.data&&m.data.vscodeSetImmediateId)for(let E=0,S=l.length;E<S;E++){const o=l[E];if(o.id===m.data.vscodeSetImmediateId){l.splice(E,1),o.callback();return}}});let f=0;return m=>{const E=++f;l.push({id:E,callback:m}),e.globals.postMessage({vscodeSetImmediateId:E},"*")}}if(typeof a?.nextTick=="function")return a.nextTick.bind(a);const n=Promise.resolve();return l=>n.then(l)}();var h;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(h=e.OperatingSystem||(e.OperatingSystem={})),e.OS=C||A?2:L?1:3;let v=!0,t=!1;function s(){if(!t){t=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,v=new Uint16Array(r.buffer)[0]===(2<<8)+1}return v}e.isLittleEndian=s}),define(he[37],fe([0,1,11]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const C=p.globals.vscode.process;L={get platform(){return C.platform},get env(){return C.env},cwd(){return C.cwd()},nextTick(y){return(0,p.setImmediate)(y)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(C){return process.nextTick(C)}}:L={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},nextTick(C){return(0,p.setImmediate)(C)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick}),define(he[9],fe([0,1,37]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,C=97,y=90,T=122,I=46,D=47,A=92,i=58,P=63;class c extends Error{constructor(h,v,t){let s;typeof v=="string"&&v.indexOf("not ")===0?(s="must not be",v=v.replace(/^not /,"")):s="must be";const r=h.indexOf(".")!==-1?"property":"argument";let n=`The "${h}" ${r} ${s} of type ${v}`;n+=`. Received type ${typeof t}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function u(d,h){if(typeof d!="string")throw new c(h,"string",d)}function a(d){return d===D||d===A}function g(d){return d===D}function w(d){return d>=L&&d<=y||d>=C&&d<=T}function _(d,h,v,t){let s="",r=0,n=-1,l=0,f=0;for(let m=0;m<=d.length;++m){if(m<d.length)f=d.charCodeAt(m);else{if(t(f))break;f=D}if(t(f)){if(!(n===m-1||l===1))if(l===2){if(s.length<2||r!==2||s.charCodeAt(s.length-1)!==I||s.charCodeAt(s.length-2)!==I){if(s.length>2){const E=s.lastIndexOf(v);E===-1?(s="",r=0):(s=s.slice(0,E),r=s.length-1-s.lastIndexOf(v)),n=m,l=0;continue}else if(s.length!==0){s="",r=0,n=m,l=0;continue}}h&&(s+=s.length>0?`${v}..`:"..",r=2)}else s.length>0?s+=`${v}${d.slice(n+1,m)}`:s=d.slice(n+1,m),r=m-n-1;n=m,l=0}else f===I&&l!==-1?++l:l=-1}return s}function b(d,h){if(h===null||typeof h!="object")throw new c("pathObject","Object",h);const v=h.dir||h.root,t=h.base||`${h.name||""}${h.ext||""}`;return v?v===h.root?`${v}${t}`:`${v}${d}${t}`:t}e.win32={resolve(...d){let h="",v="",t=!1;for(let s=d.length-1;s>=-1;s--){let r;if(s>=0){if(r=d[s],u(r,"path"),r.length===0)continue}else h.length===0?r=p.cwd():(r=p.env[`=${h}`]||p.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==h.toLowerCase()&&r.charCodeAt(2)===A)&&(r=`${h}\\`));const n=r.length;let l=0,f="",m=!1;const E=r.charCodeAt(0);if(n===1)a(E)&&(l=1,m=!0);else if(a(E))if(m=!0,a(r.charCodeAt(1))){let S=2,o=S;for(;S<n&&!a(r.charCodeAt(S));)S++;if(S<n&&S!==o){const k=r.slice(o,S);for(o=S;S<n&&a(r.charCodeAt(S));)S++;if(S<n&&S!==o){for(o=S;S<n&&!a(r.charCodeAt(S));)S++;(S===n||S!==o)&&(f=`\\\\${k}\\${r.slice(o,S)}`,l=S)}}}else l=1;else w(E)&&r.charCodeAt(1)===i&&(f=r.slice(0,2),l=2,n>2&&a(r.charCodeAt(2))&&(m=!0,l=3));if(f.length>0)if(h.length>0){if(f.toLowerCase()!==h.toLowerCase())continue}else h=f;if(t){if(h.length>0)break}else if(v=`${r.slice(l)}\\${v}`,t=m,m&&h.length>0)break}return v=_(v,!t,"\\",a),t?`${h}\\${v}`:`${h}${v}`||"."},normalize(d){u(d,"path");const h=d.length;if(h===0)return".";let v=0,t,s=!1;const r=d.charCodeAt(0);if(h===1)return g(r)?"\\":d;if(a(r))if(s=!0,a(d.charCodeAt(1))){let l=2,f=l;for(;l<h&&!a(d.charCodeAt(l));)l++;if(l<h&&l!==f){const m=d.slice(f,l);for(f=l;l<h&&a(d.charCodeAt(l));)l++;if(l<h&&l!==f){for(f=l;l<h&&!a(d.charCodeAt(l));)l++;if(l===h)return`\\\\${m}\\${d.slice(f)}\\`;l!==f&&(t=`\\\\${m}\\${d.slice(f,l)}`,v=l)}}}else v=1;else w(r)&&d.charCodeAt(1)===i&&(t=d.slice(0,2),v=2,h>2&&a(d.charCodeAt(2))&&(s=!0,v=3));let n=v<h?_(d.slice(v),!s,"\\",a):"";return n.length===0&&!s&&(n="."),n.length>0&&a(d.charCodeAt(h-1))&&(n+="\\"),t===void 0?s?`\\${n}`:n:s?`${t}\\${n}`:`${t}${n}`},isAbsolute(d){u(d,"path");const h=d.length;if(h===0)return!1;const v=d.charCodeAt(0);return a(v)||h>2&&w(v)&&d.charCodeAt(1)===i&&a(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let h,v;for(let r=0;r<d.length;++r){const n=d[r];u(n,"path"),n.length>0&&(h===void 0?h=v=n:h+=`\\${n}`)}if(h===void 0)return".";let t=!0,s=0;if(typeof v=="string"&&a(v.charCodeAt(0))){++s;const r=v.length;r>1&&a(v.charCodeAt(1))&&(++s,r>2&&(a(v.charCodeAt(2))?++s:t=!1))}if(t){for(;s<h.length&&a(h.charCodeAt(s));)s++;s>=2&&(h=`\\${h.slice(s)}`)}return e.win32.normalize(h)},relative(d,h){if(u(d,"from"),u(h,"to"),d===h)return"";const v=e.win32.resolve(d),t=e.win32.resolve(h);if(v===t||(d=v.toLowerCase(),h=t.toLowerCase(),d===h))return"";let s=0;for(;s<d.length&&d.charCodeAt(s)===A;)s++;let r=d.length;for(;r-1>s&&d.charCodeAt(r-1)===A;)r--;const n=r-s;let l=0;for(;l<h.length&&h.charCodeAt(l)===A;)l++;let f=h.length;for(;f-1>l&&h.charCodeAt(f-1)===A;)f--;const m=f-l,E=n<m?n:m;let S=-1,o=0;for(;o<E;o++){const O=d.charCodeAt(s+o);if(O!==h.charCodeAt(l+o))break;O===A&&(S=o)}if(o!==E){if(S===-1)return t}else{if(m>E){if(h.charCodeAt(l+o)===A)return t.slice(l+o+1);if(o===2)return t.slice(l+o)}n>E&&(d.charCodeAt(s+o)===A?S=o:o===2&&(S=3)),S===-1&&(S=0)}let k="";for(o=s+S+1;o<=r;++o)(o===r||d.charCodeAt(o)===A)&&(k+=k.length===0?"..":"\\..");return l+=S,k.length>0?`${k}${t.slice(l,f)}`:(t.charCodeAt(l)===A&&++l,t.slice(l,f))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const h=e.win32.resolve(d);if(h.length<=2)return d;if(h.charCodeAt(0)===A){if(h.charCodeAt(1)===A){const v=h.charCodeAt(2);if(v!==P&&v!==I)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(w(h.charCodeAt(0))&&h.charCodeAt(1)===i&&h.charCodeAt(2)===A)return`\\\\?\\${h}`;return d},dirname(d){u(d,"path");const h=d.length;if(h===0)return".";let v=-1,t=0;const s=d.charCodeAt(0);if(h===1)return a(s)?d:".";if(a(s)){if(v=t=1,a(d.charCodeAt(1))){let l=2,f=l;for(;l<h&&!a(d.charCodeAt(l));)l++;if(l<h&&l!==f){for(f=l;l<h&&a(d.charCodeAt(l));)l++;if(l<h&&l!==f){for(f=l;l<h&&!a(d.charCodeAt(l));)l++;if(l===h)return d;l!==f&&(v=t=l+1)}}}}else w(s)&&d.charCodeAt(1)===i&&(v=h>2&&a(d.charCodeAt(2))?3:2,t=v);let r=-1,n=!0;for(let l=h-1;l>=t;--l)if(a(d.charCodeAt(l))){if(!n){r=l;break}}else n=!1;if(r===-1){if(v===-1)return".";r=v}return d.slice(0,r)},basename(d,h){h!==void 0&&u(h,"ext"),u(d,"path");let v=0,t=-1,s=!0,r;if(d.length>=2&&w(d.charCodeAt(0))&&d.charCodeAt(1)===i&&(v=2),h!==void 0&&h.length>0&&h.length<=d.length){if(h===d)return"";let n=h.length-1,l=-1;for(r=d.length-1;r>=v;--r){const f=d.charCodeAt(r);if(a(f)){if(!s){v=r+1;break}}else l===-1&&(s=!1,l=r+1),n>=0&&(f===h.charCodeAt(n)?--n==-1&&(t=r):(n=-1,t=l))}return v===t?t=l:t===-1&&(t=d.length),d.slice(v,t)}for(r=d.length-1;r>=v;--r)if(a(d.charCodeAt(r))){if(!s){v=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":d.slice(v,t)},extname(d){u(d,"path");let h=0,v=-1,t=0,s=-1,r=!0,n=0;d.length>=2&&d.charCodeAt(1)===i&&w(d.charCodeAt(0))&&(h=t=2);for(let l=d.length-1;l>=h;--l){const f=d.charCodeAt(l);if(a(f)){if(!r){t=l+1;break}continue}s===-1&&(r=!1,s=l+1),f===I?v===-1?v=l:n!==1&&(n=1):v!==-1&&(n=-1)}return v===-1||s===-1||n===0||n===1&&v===s-1&&v===t+1?"":d.slice(v,s)},format:b.bind(null,"\\"),parse(d){u(d,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return h;const v=d.length;let t=0,s=d.charCodeAt(0);if(v===1)return a(s)?(h.root=h.dir=d,h):(h.base=h.name=d,h);if(a(s)){if(t=1,a(d.charCodeAt(1))){let S=2,o=S;for(;S<v&&!a(d.charCodeAt(S));)S++;if(S<v&&S!==o){for(o=S;S<v&&a(d.charCodeAt(S));)S++;if(S<v&&S!==o){for(o=S;S<v&&!a(d.charCodeAt(S));)S++;S===v?t=S:S!==o&&(t=S+1)}}}}else if(w(s)&&d.charCodeAt(1)===i){if(v<=2)return h.root=h.dir=d,h;if(t=2,a(d.charCodeAt(2))){if(v===3)return h.root=h.dir=d,h;t=3}}t>0&&(h.root=d.slice(0,t));let r=-1,n=t,l=-1,f=!0,m=d.length-1,E=0;for(;m>=t;--m){if(s=d.charCodeAt(m),a(s)){if(!f){n=m+1;break}continue}l===-1&&(f=!1,l=m+1),s===I?r===-1?r=m:E!==1&&(E=1):r!==-1&&(E=-1)}return l!==-1&&(r===-1||E===0||E===1&&r===l-1&&r===n+1?h.base=h.name=d.slice(n,l):(h.name=d.slice(n,r),h.base=d.slice(n,l),h.ext=d.slice(r,l))),n>0&&n!==t?h.dir=d.slice(0,n-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let h="",v=!1;for(let t=d.length-1;t>=-1&&!v;t--){const s=t>=0?d[t]:p.cwd();u(s,"path"),s.length!==0&&(h=`${s}/${h}`,v=s.charCodeAt(0)===D)}return h=_(h,!v,"/",g),v?`/${h}`:h.length>0?h:"."},normalize(d){if(u(d,"path"),d.length===0)return".";const h=d.charCodeAt(0)===D,v=d.charCodeAt(d.length-1)===D;return d=_(d,!h,"/",g),d.length===0?h?"/":v?"./":".":(v&&(d+="/"),h?`/${d}`:d)},isAbsolute(d){return u(d,"path"),d.length>0&&d.charCodeAt(0)===D},join(...d){if(d.length===0)return".";let h;for(let v=0;v<d.length;++v){const t=d[v];u(t,"path"),t.length>0&&(h===void 0?h=t:h+=`/${t}`)}return h===void 0?".":e.posix.normalize(h)},relative(d,h){if(u(d,"from"),u(h,"to"),d===h||(d=e.posix.resolve(d),h=e.posix.resolve(h),d===h))return"";const v=1,t=d.length,s=t-v,r=1,n=h.length-r,l=s<n?s:n;let f=-1,m=0;for(;m<l;m++){const S=d.charCodeAt(v+m);if(S!==h.charCodeAt(r+m))break;S===D&&(f=m)}if(m===l)if(n>l){if(h.charCodeAt(r+m)===D)return h.slice(r+m+1);if(m===0)return h.slice(r+m)}else s>l&&(d.charCodeAt(v+m)===D?f=m:m===0&&(f=0));let E="";for(m=v+f+1;m<=t;++m)(m===t||d.charCodeAt(m)===D)&&(E+=E.length===0?"..":"/..");return`${E}${h.slice(r+f)}`},toNamespacedPath(d){return d},dirname(d){if(u(d,"path"),d.length===0)return".";const h=d.charCodeAt(0)===D;let v=-1,t=!0;for(let s=d.length-1;s>=1;--s)if(d.charCodeAt(s)===D){if(!t){v=s;break}}else t=!1;return v===-1?h?"/":".":h&&v===1?"//":d.slice(0,v)},basename(d,h){h!==void 0&&u(h,"ext"),u(d,"path");let v=0,t=-1,s=!0,r;if(h!==void 0&&h.length>0&&h.length<=d.length){if(h===d)return"";let n=h.length-1,l=-1;for(r=d.length-1;r>=0;--r){const f=d.charCodeAt(r);if(f===D){if(!s){v=r+1;break}}else l===-1&&(s=!1,l=r+1),n>=0&&(f===h.charCodeAt(n)?--n==-1&&(t=r):(n=-1,t=l))}return v===t?t=l:t===-1&&(t=d.length),d.slice(v,t)}for(r=d.length-1;r>=0;--r)if(d.charCodeAt(r)===D){if(!s){v=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":d.slice(v,t)},extname(d){u(d,"path");let h=-1,v=0,t=-1,s=!0,r=0;for(let n=d.length-1;n>=0;--n){const l=d.charCodeAt(n);if(l===D){if(!s){v=n+1;break}continue}t===-1&&(s=!1,t=n+1),l===I?h===-1?h=n:r!==1&&(r=1):h!==-1&&(r=-1)}return h===-1||t===-1||r===0||r===1&&h===t-1&&h===v+1?"":d.slice(h,t)},format:b.bind(null,"/"),parse(d){u(d,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return h;const v=d.charCodeAt(0)===D;let t;v?(h.root="/",t=1):t=0;let s=-1,r=0,n=-1,l=!0,f=d.length-1,m=0;for(;f>=t;--f){const E=d.charCodeAt(f);if(E===D){if(!l){r=f+1;break}continue}n===-1&&(l=!1,n=f+1),E===I?s===-1?s=f:m!==1&&(m=1):s!==-1&&(m=-1)}if(n!==-1){const E=r===0&&v?1:r;s===-1||m===0||m===1&&s===n-1&&s===r+1?h.base=h.name=d.slice(E,n):(h.name=d.slice(E,s),h.base=d.slice(E,n),h.ext=d.slice(s,n))}return r>0?h.dir=d.slice(0,r-1):v&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(he[137],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var p;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(p=e.Source||(e.Source={}));var L;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(y,...T){const I=T.reduce((i,P)=>(i[P]=!0,i),{}),D=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(i=>!I[i]).forEach(i=>{for(let P=0;P<D.length;P++)if(i.search(D[P])!==-1){delete y[i];break}})}e.sanitizeProcessEnvironment=C}),define(he[44],fe([0,1,11]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=p.globals.performance&&typeof p.globals.performance.now=="function";class C{constructor(T){this._highResolution=L&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new C(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=C}),define(he[3],fe([0,1,15,70,6,92,44]),function(X,e,p,L,C,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var I;(function(d){d.None=()=>C.Disposable.None;function h(j){return(N,x=null,R)=>{let V=!1,F;return F=j(M=>{if(!V)return F?F.dispose():V=!0,N.call(x,M)},null,R),V&&F.dispose(),F}}d.once=h;function v(j,N){return f((x,R=null,V)=>j(F=>x.call(R,N(F)),null,V))}d.map=v;function t(j,N){return f((x,R=null,V)=>j(F=>{N(F),x.call(R,F)},null,V))}d.forEach=t;function s(j,N){return f((x,R=null,V)=>j(F=>N(F)&&x.call(R,F),null,V))}d.filter=s;function r(j){return j}d.signal=r;function n(...j){return(N,x=null,R)=>(0,C.combinedDisposable)(...j.map(V=>V(F=>N.call(x,F),null,R)))}d.any=n;function l(j,N,x){let R=x;return v(j,V=>(R=N(R,V),R))}d.reduce=l;function f(j){let N;const x=new c({onFirstListenerAdd(){N=j(x.fire,x)},onLastListenerRemove(){N.dispose()}});return x.event}function m(j,N,x=100,R=!1,V){let F,M,B,W=0;const Q=new c({leakWarningThreshold:V,onFirstListenerAdd(){F=j(ae=>{W++,M=N(M,ae),R&&!B&&(Q.fire(M),M=void 0),clearTimeout(B),B=setTimeout(()=>{const _e=M;M=void 0,B=void 0,(!R||W>1)&&Q.fire(_e),W=0},x)})},onLastListenerRemove(){F.dispose()}});return Q.event}d.debounce=m;function E(j,N=(x,R)=>x===R){let x=!0,R;return s(j,V=>{const F=x||!N(V,R);return x=!1,R=V,F})}d.latch=E;function S(j,N){return[d.filter(j,N),d.filter(j,x=>!N(x))]}d.split=S;function o(j,N=!1,x=[]){let R=x.slice(),V=j(B=>{R?R.push(B):M.fire(B)});const F=()=>{R&&R.forEach(B=>M.fire(B)),R=null},M=new c({onFirstListenerAdd(){V||(V=j(B=>M.fire(B)))},onFirstListenerDidAdd(){R&&(N?setTimeout(F):F())},onLastListenerRemove(){V&&V.dispose(),V=null}});return M.event}d.buffer=o;class k{constructor(N){this.event=N}map(N){return new k(v(this.event,N))}forEach(N){return new k(t(this.event,N))}filter(N){return new k(s(this.event,N))}reduce(N,x){return new k(l(this.event,N,x))}latch(){return new k(E(this.event))}debounce(N,x=100,R=!1,V){return new k(m(this.event,N,x,R,V))}on(N,x,R){return this.event(N,x,R)}once(N,x,R){return h(this.event)(N,x,R)}}function O(j){return new k(j)}d.chain=O;function $(j,N,x=R=>R){const R=(...B)=>M.fire(x(...B)),V=()=>j.on(N,R),F=()=>j.removeListener(N,R),M=new c({onFirstListenerAdd:V,onLastListenerRemove:F});return M.event}d.fromNodeEventEmitter=$;function G(j,N,x=R=>R){const R=(...B)=>M.fire(x(...B)),V=()=>j.addEventListener(N,R),F=()=>j.removeEventListener(N,R),M=new c({onFirstListenerAdd:V,onLastListenerRemove:F});return M.event}d.fromDOMEventEmitter=G;function re(j){return new Promise(N=>h(j)(N))}d.toPromise=re})(I=e.Event||(e.Event={}));class D{constructor(h){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${h}_${D._idPool++}`}start(h){this._stopWatch=new T.StopWatch(!0),this._listenerCount=h}stop(){if(this._stopWatch){const h=this._stopWatch.elapsed();this._elapsedOverall+=h,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${h.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let A=-1;function i(d){const h=A;return A=d,{dispose(){A=h}}}e.setGlobalLeakWarningThreshold=i;class P{constructor(h,v=Math.random().toString(18).slice(2,5)){this.customThreshold=h,this.name=v,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(h){let v=A;if(typeof this.customThreshold=="number"&&(v=this.customThreshold),v<=0||h<v)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(t)||0;if(this._stacks.set(t,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=v*.5;let r,n=0;for(const[l,f]of this._stacks)(!r||n<f)&&(r=l,n=f);console.warn(`[${this.name}] potential listener LEAK detected, having ${h} listeners already. MOST frequent listener (${n}):`),console.warn(r)}return()=>{const r=this._stacks.get(t)||0;this._stacks.set(t,r-1)}}}class c{constructor(h){this._disposed=!1,this._options=h,this._leakageMon=A>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(h,v,t)=>{this._listeners||(this._listeners=new y.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(v?[h,v]:h);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,h,v);const n=this._leakageMon?.check(this._listeners.size),l=(0,C.toDisposable)(()=>{n&&n(),this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof C.DisposableStore?t.add(l):Array.isArray(t)&&t.push(l),l}),this._event}fire(h){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new y.LinkedList);for(let v of this._listeners)this._deliveryQueue.push([v,h]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[v,t]=this._deliveryQueue.shift();try{typeof v=="function"?v.call(void 0,t):v[0].call(v[1],t)}catch(s){(0,p.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=c;class u extends c{async fireAsync(h,v,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,h]);for(;this._asyncDeliveryQueue.size>0&&!v.isCancellationRequested;){const[s,r]=this._asyncDeliveryQueue.shift(),n=[],l={...r,waitUntil:f=>{if(Object.isFrozen(n))throw new Error("waitUntil can NOT be called asynchronous");t&&(f=t(f,typeof s=="function"?s:s[0])),n.push(f)}};try{typeof s=="function"?s.call(void 0,l):s[0].call(s[1],l)}catch(f){(0,p.onUnexpectedError)(f);continue}Object.freeze(n),await Promise.allSettled(n).then(f=>{for(const m of f)m.status==="rejected"&&(0,p.onUnexpectedError)(m.reason)})}}}}e.AsyncEmitter=u;class a extends c{constructor(h){super(h);this._isPaused=0,this._eventQueue=new y.LinkedList,this._mergeFn=h?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const h=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(h))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(h){this._listeners&&(this._isPaused!==0?this._eventQueue.push(h):super.fire(h))}}e.PauseableEmitter=a;class g extends a{constructor(h){super(h);this._delay=h.delay??100}fire(h){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(h)}}e.DebounceEmitter=g;class w{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(h){const v={event:h,listener:null};this.events.push(v),this.hasListeners&&this.hook(v);const t=()=>{this.hasListeners&&this.unhook(v);const s=this.events.indexOf(v);this.events.splice(s,1)};return(0,C.toDisposable)((0,L.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(h=>this.hook(h))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(h=>this.unhook(h))}hook(h){h.listener=h.event(v=>this.emitter.fire(v))}unhook(h){h.listener&&h.listener.dispose(),h.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=w;class _{constructor(){this.buffers=[]}wrapEvent(h){return(v,t,s)=>h(r=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>v.call(t,r)):v.call(t,r)},void 0,s)}bufferEvents(h){const v=[];this.buffers.push(v);const t=h();return this.buffers.pop(),v.forEach(s=>s()),t}}e.EventBufferer=_;class b{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=C.Disposable.None,this.emitter=new c({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(h){this.inputEvent=h,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=h(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=b}),define(he[21],fe([0,1,3]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(I,D){const A=setTimeout(I.bind(D),0);return{dispose(){clearTimeout(A)}}});var C;(function(I){function D(A){return A===I.None||A===I.Cancelled||A instanceof y?!0:!A||typeof A!="object"?!1:typeof A.isCancellationRequested=="boolean"&&typeof A.onCancellationRequested=="function"}I.isCancellationToken=D,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(C=e.CancellationToken||(e.CancellationToken={}));class y{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new y),this._token}cancel(){this._token?this._token instanceof y&&this._token.cancel():this._token=C.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof y&&this._token.dispose():this._token=C.None}}e.CancellationTokenSource=T}),define(he[74],fe([0,1,3]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new p.Emitter}add(P){const c=this._icons.get(P.id);c?P.description?c.description=P.description:console.error(`Duplicate registration of codicon ${P.id}`):(this._icons.set(P.id,P),this._onDidRegister.fire(P))}get(P){return this._icons.get(P)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const C=new L;e.iconRegistry=C;function y(i,P){return new I(i,P)}e.registerCodicon=y;function T(i){return i?i.replace(/\$\((.*?)\)/g,(P,c)=>` ${c} `).trim():""}e.getCodiconAriaLabel=T;class I{constructor(P,c,u){this.id=P,this.definition=c,this.description=u,C.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=I;function D(i,P){const c=["codicon","codicon-"+i];return P&&c.push("codicon-modifier-"+P),c}e.getClassNamesArray=D;var A;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const P=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function c(g){if(g instanceof I)return["codicon","codicon-"+g.id];const w=P.exec(g.id);if(!w)return c(I.error);let[,_,b]=w;const d=["codicon","codicon-"+_];return b&&d.push("codicon-modifier-"+b.substr(1)),d}i.asClassNameArray=c;function u(g){return c(g).join(" ")}i.asClassName=u;function a(g){return"."+c(g).join(".")}i.asCSSSelector=a})(A=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(I=e.Codicon||(e.Codicon={}))}),define(he[93],fe([0,1,15,6]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function C(d){const h=d;return h?[h.on,h.pause,h.resume,h.destroy].every(v=>typeof v=="function"):!1}e.isReadableStream=C;function y(d){const h=d;return h?C(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.isReadableBufferedStream=y;function T(d,h){return new I(d,h)}e.newWriteableStream=T;class I{constructor(h,v){this.reducer=h,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(h){if(!this.state.destroyed){if(this.state.flowing)this.emitData(h);else if(this.buffer.data.push(h),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(v=>this.pendingWritePromises.push(v))}}error(h){this.state.destroyed||(this.state.flowing?this.emitError(h):this.buffer.error.push(h))}end(h){this.state.destroyed||(typeof h!="undefined"&&this.write(h),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(h){this.listeners.data.slice(0).forEach(v=>v(h))}emitError(h){this.listeners.error.length===0?(0,p.onUnexpectedError)(h):this.listeners.error.slice(0).forEach(v=>v(h))}emitEnd(){this.listeners.end.slice(0).forEach(h=>h())}on(h,v){if(!this.state.destroyed)switch(h){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(h,v){if(this.state.destroyed)return;let t;switch(h){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const s=t.indexOf(v);s>=0&&t.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const h=this.reducer(this.buffer.data);this.emitData(h),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const h of this.buffer.error)this.emitError(h);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(d,h){const v=[];let t;for(;(t=d.read())!==null;)v.push(t);return h(v)}e.consumeReadable=D;function A(d,h,v){const t=[];let s;for(;(s=d.read())!==null&&t.length<v;)t.push(s);return s===null&&t.length>0?h(t):{read:()=>{if(t.length>0)return t.shift();if(typeof s!="undefined"){const r=s;return s=void 0,r}return d.read()}}}e.peekReadable=A;function i(d,h){return new Promise((v,t)=>{const s=[];P(d,{onData:r=>{h&&s.push(r)},onError:r=>{h?t(r):v(void 0)},onEnd:()=>{v(h?h(s):void 0)}})})}e.consumeStream=i;function P(d,h){d.on("error",v=>h.onError(v)),d.on("end",()=>h.onEnd()),d.on("data",v=>h.onData(v))}e.listenStream=P;function c(d,h){return new Promise((v,t)=>{const s=new L.DisposableStore,r=[],n=m=>{if(r.push(m),r.length>h)return s.dispose(),d.pause(),v({stream:d,buffer:r,ended:!1})},l=m=>t(m),f=()=>v({stream:d,buffer:r,ended:!0});s.add((0,L.toDisposable)(()=>d.removeListener("error",l))),d.on("error",l),s.add((0,L.toDisposable)(()=>d.removeListener("end",f))),d.on("end",f),s.add((0,L.toDisposable)(()=>d.removeListener("data",n))),d.on("data",n)})}e.peekStream=c;function u(d,h){const v=T(h);return v.end(d),v}e.toStream=u;function a(){const d=T(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=a;function g(d){let h=!1;return{read:()=>h?null:(h=!0,d)}}e.toReadable=g;function w(d,h,v){const t=T(v);return P(d,{onData:s=>t.write(h.data(s)),onError:s=>t.error(h.error?h.error(s):s),onEnd:()=>t.end()}),t}e.transform=w;function _(d,h,v){let t=!1;return{read:()=>{const s=h.read();return t?s:(t=!0,s!==null?v([d,s]):d)}}}e.prefixedReadable=_;function b(d,h,v){let t=!1;const s=T(v);return P(h,{onData:r=>t?s.write(r):(t=!0,s.write(v([d,r]))),onError:r=>s.error(r),onEnd:()=>{t||(t=!0,s.write(d)),s.end()}}),s}e.prefixedStream=b}),define(he[8],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function p(q){return!q||typeof q!="string"?!0:q.trim().length===0}e.isFalsyOrWhitespace=p;const L=/{(\d+)}/g;function C(q,...ge){return ge.length===0?q:q.replace(L,function(ye,Te){const Oe=parseInt(Te,10);return isNaN(Oe)||Oe<0||Oe>=ge.length?ye:ge[Oe]})}e.format=C;const y=/{([^}]+)}/g;function T(q,ge){return q.replace(y,(ye,Te)=>ge[Te]??ye)}e.format2=T;function I(q){return q.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}e.escape=I;function D(q){return q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=D;function A(q,ge){let ye=0;const Te=ge.charCodeAt(0);for(let Oe=q.length-1;Oe>=0;Oe--)q.charCodeAt(Oe)===Te&&ye++;return ye}e.count=A;function i(q,ge,ye="\u2026"){return q.length<=ge?q:`${q.substr(0,ge)}${ye}`}e.truncate=i;function P(q,ge=" "){const ye=c(q,ge);return u(ye,ge)}e.trim=P;function c(q,ge){if(!q||!ge)return q;const ye=ge.length;if(ye===0||q.length===0)return q;let Te=0;for(;q.indexOf(ge,Te)===Te;)Te=Te+ye;return q.substring(Te)}e.ltrim=c;function u(q,ge){if(!q||!ge)return q;const ye=ge.length,Te=q.length;if(ye===0||Te===0)return q;let Oe=Te,Ge=-1;for(;Ge=q.lastIndexOf(ge,Oe-1),!(Ge===-1||Ge+ye!==Oe);){if(Ge===0)return"";Oe=Ge}return q.substring(0,Oe)}e.rtrim=u;function a(q){return q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=a;function g(q){return q.replace(/\*/g,"")}e.stripWildcards=g;function w(q,ge,ye={}){if(!q)throw new Error("Cannot create regex from empty string");ge||(q=D(q)),ye.wholeWord&&(/\B/.test(q.charAt(0))||(q="\\b"+q),/\B/.test(q.charAt(q.length-1))||(q=q+"\\b"));let Te="";return ye.global&&(Te+="g"),ye.matchCase||(Te+="i"),ye.multiline&&(Te+="m"),ye.unicode&&(Te+="u"),new RegExp(q,Te)}e.createRegExp=w;function _(q){return q.source==="^"||q.source==="^$"||q.source==="$"||q.source==="^\\s*$"?!1:!!(q.exec("")&&q.lastIndex===0)}e.regExpLeadsToEndlessLoop=_;function b(q){return!!q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function d(q){return(q.global?"g":"")+(q.ignoreCase?"i":"")+(q.multiline?"m":"")+(q.unicode?"u":"")}e.regExpFlags=d;function h(q){return q.split(/\r\n|\r|\n/)}e.splitLines=h;function v(q){for(let ge=0,ye=q.length;ge<ye;ge++){const Te=q.charCodeAt(ge);if(Te!==32&&Te!==9)return ge}return-1}e.firstNonWhitespaceIndex=v;function t(q,ge=0,ye=q.length){for(let Te=ge;Te<ye;Te++){const Oe=q.charCodeAt(Te);if(Oe!==32&&Oe!==9)return q.substring(ge,Te)}return q.substring(ge,ye)}e.getLeadingWhitespace=t;function s(q,ge=q.length-1){for(let ye=ge;ye>=0;ye--){const Te=q.charCodeAt(ye);if(Te!==32&&Te!==9)return ye}return-1}e.lastNonWhitespaceIndex=s;function r(q,ge){return q<ge?-1:q>ge?1:0}e.compare=r;function n(q,ge,ye=0,Te=q.length,Oe=0,Ge=ge.length){for(;ye<Te&&Oe<Ge;ye++,Oe++){let Xe=q.charCodeAt(ye),at=ge.charCodeAt(Oe);if(Xe<at)return-1;if(Xe>at)return 1}const Ze=Te-ye,Qe=Ge-Oe;return Ze<Qe?-1:Ze>Qe?1:0}e.compareSubstring=n;function l(q,ge){return f(q,ge,0,q.length,0,ge.length)}e.compareIgnoreCase=l;function f(q,ge,ye=0,Te=q.length,Oe=0,Ge=ge.length){for(;ye<Te&&Oe<Ge;ye++,Oe++){let Xe=q.charCodeAt(ye),at=ge.charCodeAt(Oe);if(Xe===at)continue;const ut=Xe-at;if(!(ut===32&&E(at))&&!(ut===-32&&E(Xe)))return m(Xe)&&m(at)?ut:n(q.toLowerCase(),ge.toLowerCase(),ye,Te,Oe,Ge)}const Ze=Te-ye,Qe=Ge-Oe;return Ze<Qe?-1:Ze>Qe?1:0}e.compareSubstringIgnoreCase=f;function m(q){return q>=97&&q<=122}e.isLowerAsciiLetter=m;function E(q){return q>=65&&q<=90}e.isUpperAsciiLetter=E;function S(q){return m(q)||E(q)}function o(q,ge){return q.length===ge.length&&k(q,ge)}e.equalsIgnoreCase=o;function k(q,ge,ye=q.length){for(let Te=0;Te<ye;Te++){const Oe=q.charCodeAt(Te),Ge=ge.charCodeAt(Te);if(Oe!==Ge){if(S(Oe)&&S(Ge)){const Ze=Math.abs(Oe-Ge);if(Ze!==0&&Ze!==32)return!1}else if(String.fromCharCode(Oe).toLowerCase()!==String.fromCharCode(Ge).toLowerCase())return!1}}return!0}function O(q,ge){const ye=ge.length;return ge.length>q.length?!1:k(q,ge,ye)}e.startsWithIgnoreCase=O;function $(q,ge){let ye,Te=Math.min(q.length,ge.length);for(ye=0;ye<Te;ye++)if(q.charCodeAt(ye)!==ge.charCodeAt(ye))return ye;return Te}e.commonPrefixLength=$;function G(q,ge){let ye,Te=Math.min(q.length,ge.length);const Oe=q.length-1,Ge=ge.length-1;for(ye=0;ye<Te;ye++)if(q.charCodeAt(Oe-ye)!==ge.charCodeAt(Ge-ye))return ye;return Te}e.commonSuffixLength=G;function re(q){return 55296<=q&&q<=56319}e.isHighSurrogate=re;function j(q){return 56320<=q&&q<=57343}e.isLowSurrogate=j;function N(q,ge){return(q-55296<<10)+(ge-56320)+65536}e.computeCodePoint=N;function x(q,ge,ye){const Te=q.charCodeAt(ye);if(re(Te)&&ye+1<ge){const Oe=q.charCodeAt(ye+1);if(j(Oe))return N(Te,Oe)}return Te}e.getNextCodePoint=x;function R(q,ge){const ye=q.charCodeAt(ge-1);if(j(ye)&&ge>1){const Te=q.charCodeAt(ge-2);if(re(Te))return N(Te,ye)}return ye}function V(q,ge){const ye=ke.getInstance(),Te=ge,Oe=q.length,Ge=x(q,Oe,ge);ge+=Ge>=65536?2:1;let Ze=ye.getGraphemeBreakType(Ge);for(;ge<Oe;){const Qe=x(q,Oe,ge),Xe=ye.getGraphemeBreakType(Qe);if($e(Ze,Xe))break;ge+=Qe>=65536?2:1,Ze=Xe}return ge-Te}e.nextCharLength=V;function F(q,ge){const ye=ke.getInstance(),Te=ge,Oe=R(q,ge);ge-=Oe>=65536?2:1;let Ge=ye.getGraphemeBreakType(Oe);for(;ge>0;){const Ze=R(q,ge),Qe=ye.getGraphemeBreakType(Ze);if($e(Qe,Ge))break;ge-=Ze>=65536?2:1,Ge=Qe}return Te-ge}e.prevCharLength=F;function M(q,ge){const ye=ke.getInstance(),Te=q.length,Oe=ge,Ge=x(q,Te,ge),Ze=ye.getGraphemeBreakType(Ge);ge+=Ge>=65536?2:1;let Qe=Ze;for(;ge<Te;){const at=x(q,Te,ge),ut=ye.getGraphemeBreakType(at);if($e(Qe,ut))break;ge+=at>=65536?2:1,Qe=ut}const Xe=ge;for(ge=Oe,Qe=Ze;ge>0;){const at=R(q,ge),ut=ye.getGraphemeBreakType(at);if($e(ut,Qe))break;ge-=at>=65536?2:1,Qe=ut}return[ge,Xe]}function B(q,ge){return ge>0&&j(q.charCodeAt(ge))?M(q,ge-1):M(q,ge)}e.getCharContainingOffset=B;function W(q){const ge=q.length;let ye=0,Te=0;for(;Te<ge;){const Ze=x(q,ge,Te);Te+=Ze>=65536?2:1,Ze<128?ye+=1:Ze<2048?ye+=2:Ze<65536?ye+=3:ye+=4}const Oe=new Uint8Array(ye);Te=0;let Ge=0;for(;Te<ge;){const Ze=x(q,ge,Te);Te+=Ze>=65536?2:1,Ze<128?Oe[Ge++]=Ze:Ze<2048?(Oe[Ge++]=192|(Ze&1984)>>>6,Oe[Ge++]=128|(Ze&63)>>>0):Ze<65536?(Oe[Ge++]=224|(Ze&61440)>>>12,Oe[Ge++]=128|(Ze&4032)>>>6,Oe[Ge++]=128|(Ze&63)>>>0):(Oe[Ge++]=240|(Ze&1835008)>>>18,Oe[Ge++]=128|(Ze&258048)>>>12,Oe[Ge++]=128|(Ze&4032)>>>6,Oe[Ge++]=128|(Ze&63)>>>0)}return Oe}e.encodeUTF8=W;function Q(q){const ge=q.byteLength,ye=[];let Te=0;for(;Te<ge;){const Oe=q[Te];let Ge;if(Oe>=240&&Te+3<ge?Ge=(q[Te++]&7)<<18>>>0|(q[Te++]&63)<<12>>>0|(q[Te++]&63)<<6>>>0|(q[Te++]&63)<<0>>>0:Oe>=224&&Te+2<ge?Ge=(q[Te++]&15)<<12>>>0|(q[Te++]&63)<<6>>>0|(q[Te++]&63)<<0>>>0:Oe>=192&&Te+1<ge?Ge=(q[Te++]&31)<<6>>>0|(q[Te++]&63)<<0>>>0:Ge=q[Te++],Ge>=0&&Ge<=55295||Ge>=57344&&Ge<=65535)ye.push(String.fromCharCode(Ge));else if(Ge>=65536&&Ge<=1114111){const Ze=Ge-65536,Qe=55296+((Ze&1047552)>>>10),Xe=56320+((Ze&1023)>>>0);ye.push(String.fromCharCode(Qe)),ye.push(String.fromCharCode(Xe))}else ye.push(String.fromCharCode(65533))}return ye.join("")}e.decodeUTF8=Q;const ae=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function _e(q){return ae.test(q)}e.containsRTL=_e;const Fe=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Ae(q){return Fe.test(q)}e.containsEmoji=Ae;const Me=/^[\t\n\r\x20-\x7E]*$/;function Ve(q){return Me.test(q)}e.isBasicASCII=Ve,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function He(q){return e.UNUSUAL_LINE_TERMINATORS.test(q)}e.containsUnusualLineTerminators=He;function z(q){for(let ge=0,ye=q.length;ge<ye;ge++)if(J(q.charCodeAt(ge)))return!0;return!1}e.containsFullWidthCharacter=z;function J(q){return q=+q,q>=11904&&q<=55215||q>=63744&&q<=64255||q>=65281&&q<=65374}e.isFullWidthCharacter=J;function ne(q){return q>=127462&&q<=127487||q===8986||q===8987||q===9200||q===9203||q>=9728&&q<=10175||q===11088||q===11093||q>=127744&&q<=128591||q>=128640&&q<=128764||q>=128992&&q<=129003||q>=129280&&q<=129535||q>=129648&&q<=129750}e.isEmojiImprecise=ne;function oe(q,ge){if(q.length<ge)return q;const ye=/\b/g;let Te=0;for(;ye.test(q)&&!(q.length-ye.lastIndex<ge);)Te=ye.lastIndex,ye.lastIndex+=1;return q.substring(Te).replace(/^\s/,"")}e.lcut=oe;const we=/\x1B\x5B[12]?K/g,Z=/\x1b\[\d+m/g,de=/\x1b\[0?m/g;function Ie(q){return q&&(q=q.replace(we,""),q=q.replace(Z,""),q=q.replace(de,"")),q}e.removeAnsiEscapeCodes=Ie,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Be(q){return!!(q&&q.length>0&&q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Be;function qe(q){return Be(q)?q.substr(1):q}e.stripUTF8BOM=qe;function Ee(q,ge){if(!q||!ge||q.length<ge.length)return!1;const ye=ge.length,Te=q.toLowerCase();let Oe=0,Ge=-1;for(;Oe<ye;){const Ze=Te.indexOf(ge[Oe],Ge+1);if(Ze<0)return!1;Ge=Ze,Oe++}return!0}e.fuzzyContains=Ee;function tt(q,ge=!1){return q?(ge&&(q=q.replace(/\\./g,"")),q.toLowerCase()!==q):!1}e.containsUppercaseCharacter=tt;function K(q){return q.charAt(0).toUpperCase()+q.slice(1)}e.uppercaseFirstLetter=K;function ee(q,ge=1){if(ge===0)return"";let ye=-1;do ye=q.indexOf(`
`,ye+1),ge--;while(ge>0&&ye>=0);return ye===-1?q:(q[ye-1]==="\r"&&ye--,q.substr(0,ye))}e.getNLines=ee;function pe(q){const ge=90-65+1;return q=q%(2*ge),q<ge?String.fromCharCode(97+q):String.fromCharCode(65+q-ge)}e.singleLetterHash=pe;function xe(q){return ke.getInstance().getGraphemeBreakType(q)}e.getGraphemeBreakType=xe;function $e(q,ge){return q===0?ge!==5&&ge!==7:q===2&&ge===3?!1:q===4||q===2||q===3||ge===4||ge===2||ge===3?!0:!(q===8&&(ge===8||ge===9||ge===11||ge===12)||(q===11||q===9)&&(ge===9||ge===10)||(q===12||q===10)&&ge===10||ge===5||ge===13||ge===7||q===1||q===13&&ge===14||q===6&&ge===6)}e.breakBetweenGraphemeBreakType=$e;var et;(function(q){q[q.Other=0]="Other",q[q.Prepend=1]="Prepend",q[q.CR=2]="CR",q[q.LF=3]="LF",q[q.Control=4]="Control",q[q.Extend=5]="Extend",q[q.Regional_Indicator=6]="Regional_Indicator",q[q.SpacingMark=7]="SpacingMark",q[q.L=8]="L",q[q.V=9]="V",q[q.T=10]="T",q[q.LV=11]="LV",q[q.LVT=12]="LVT",q[q.ZWJ=13]="ZWJ",q[q.Extended_Pictographic=14]="Extended_Pictographic"})(et=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ke{constructor(){this._data=Ce()}static getInstance(){return ke._INSTANCE||(ke._INSTANCE=new ke),ke._INSTANCE}getGraphemeBreakType(ge){if(ge<32)return ge===10?3:ge===13?2:4;if(ge<127)return 0;const ye=this._data,Te=ye.length/3;let Oe=1;for(;Oe<=Te;)if(ge<ye[3*Oe])Oe=2*Oe;else if(ge>ye[3*Oe+1])Oe=2*Oe+1;else return ye[3*Oe+2];return 0}}ke._INSTANCE=null;function Ce(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Re(q,ge){if(q===0)return 0;const ye=se(q,ge);if(ye!==void 0)return ye;const Te=R(ge,q);return q-=le(Te),q}e.getLeftDeleteOffset=Re;function se(q,ge){let ye=R(ge,q);for(q-=le(ye);me(ye)||ye===65039||ye===8419;){if(q===0)return;ye=R(ge,q),q-=le(ye)}if(!!ne(ye)){if(q>=0){const Te=R(ge,q);Te===8205&&(q-=le(Te))}return q}}function le(q){return q>=65536?2:1}function me(q){return 127995<=q&&q<=127999}var be;(function(q){q[q.zwj=8205]="zwj",q[q.emojiVariantSelector=65039]="emojiVariantSelector",q[q.enclosingKeyCap=8419]="enclosingKeyCap"})(be||(be={}))}),define(he[22],fe([0,1,8,93]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const C=typeof Buffer!="undefined",y=typeof TextEncoder!="undefined",T=typeof TextDecoder!="undefined";let I,D;class A{constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}static alloc(m){return C?new A(Buffer.allocUnsafe(m)):new A(new Uint8Array(m))}static wrap(m){return C&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new A(m)}static fromString(m,E){return!(E?.dontUseNodeBuffer||!1)&&C?new A(Buffer.from(m)):y?(I||(I=new TextEncoder),new A(I.encode(m))):new A(p.encodeUTF8(m))}static concat(m,E){if(typeof E=="undefined"){E=0;for(let k=0,O=m.length;k<O;k++)E+=m[k].byteLength}const S=A.alloc(E);let o=0;for(let k=0,O=m.length;k<O;k++){const $=m[k];S.set($,o),o+=$.byteLength}return S}toString(){return C?this.buffer.toString():T?(D||(D=new TextDecoder),D.decode(this.buffer)):p.decodeUTF8(this.buffer)}slice(m,E){return new A(this.buffer.subarray(m,E))}set(m,E){m instanceof A?this.buffer.set(m.buffer,E):this.buffer.set(m,E)}readUInt32BE(m){return c(this.buffer,m)}writeUInt32BE(m,E){u(this.buffer,m,E)}readUInt32LE(m){return a(this.buffer,m)}writeUInt32LE(m,E){g(this.buffer,m,E)}readUInt8(m){return w(this.buffer,m)}writeUInt8(m,E){_(this.buffer,m,E)}}e.VSBuffer=A;function i(f,m){return f[m+0]<<0>>>0|f[m+1]<<8>>>0}e.readUInt16LE=i;function P(f,m,E){f[E+0]=m&255,m=m>>>8,f[E+1]=m&255}e.writeUInt16LE=P;function c(f,m){return f[m]*2**24+f[m+1]*2**16+f[m+2]*2**8+f[m+3]}e.readUInt32BE=c;function u(f,m,E){f[E+3]=m,m=m>>>8,f[E+2]=m,m=m>>>8,f[E+1]=m,m=m>>>8,f[E]=m}e.writeUInt32BE=u;function a(f,m){return f[m+0]<<0>>>0|f[m+1]<<8>>>0|f[m+2]<<16>>>0|f[m+3]<<24>>>0}e.readUInt32LE=a;function g(f,m,E){f[E+0]=m&255,m=m>>>8,f[E+1]=m&255,m=m>>>8,f[E+2]=m&255,m=m>>>8,f[E+3]=m&255}e.writeUInt32LE=g;function w(f,m){return f[m]}e.readUInt8=w;function _(f,m,E){f[E]=m}e.writeUInt8=_;function b(f){return L.consumeReadable(f,m=>A.concat(m))}e.readableToBuffer=b;function d(f){return L.toReadable(f)}e.bufferToReadable=d;function h(f){return L.consumeStream(f,m=>A.concat(m))}e.streamToBuffer=h;async function v(f){return f.ended?A.concat(f.buffer):A.concat([...f.buffer,await h(f.stream)])}e.bufferedStreamToBuffer=v;function t(f){return L.toStream(f,m=>A.concat(m))}e.bufferToStream=t;function s(f){return L.transform(f,{data:m=>typeof m=="string"?A.fromString(m):A.wrap(m)},m=>A.concat(m))}e.streamToBufferReadableStream=s;function r(f){return L.newWriteableStream(m=>A.concat(m),f)}e.newWriteableBufferStream=r;function n(f,m){return L.prefixedReadable(f,m,E=>A.concat(E))}e.prefixedBufferReadable=n;function l(f,m){return L.prefixedStream(f,m,E=>A.concat(E))}e.prefixedBufferStream=l}),define(he[55],fe([0,1,8]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(_){return C(_,0)}e.hash=L;function C(_,b){switch(typeof _){case"object":return _===null?y(349,b):Array.isArray(_)?D(_,b):A(_,b);case"string":return I(_,b);case"boolean":return T(_,b);case"number":return y(_,b);case"undefined":return y(937,b);default:return y(617,b)}}e.doHash=C;function y(_,b){return(b<<5)-b+_|0}function T(_,b){return y(_?433:863,b)}function I(_,b){b=y(149417,b);for(let d=0,h=_.length;d<h;d++)b=y(_.charCodeAt(d),b);return b}e.stringHash=I;function D(_,b){return b=y(104579,b),_.reduce((d,h)=>C(h,d),b)}function A(_,b){return b=y(181387,b),Object.keys(_).sort().reduce((d,h)=>(d=I(h,d),C(_[h],d)),b)}class i{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=C(b,this._value),this._value}}e.Hasher=i;var P;(function(_){_[_.BLOCK_SIZE=64]="BLOCK_SIZE",_[_.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function c(_,b,d=32){const h=d-b,v=~((1<<h)-1);return(_<<b|(v&_)>>>h)>>>0}function u(_,b=0,d=_.byteLength,h=0){for(let v=0;v<d;v++)_[b+v]=h}function a(_,b,d="0"){for(;_.length<b;)_=d+_;return _}function g(_,b=32){return _ instanceof ArrayBuffer?Array.from(new Uint8Array(_)).map(d=>d.toString(16).padStart(2,"0")).join(""):a((_>>>0).toString(16),b/4)}e.toHexString=g;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const d=b.length;if(d===0)return;const h=this._buff;let v=this._buffLen,t=this._leftoverHighSurrogate,s,r;for(t!==0?(s=t,r=-1,t=0):(s=b.charCodeAt(0),r=0);;){let n=s;if(p.isHighSurrogate(s))if(r+1<d){const l=b.charCodeAt(r+1);p.isLowSurrogate(l)?(r++,n=p.computeCodePoint(s,l)):n=65533}else{t=s;break}else p.isLowSurrogate(s)&&(n=65533);if(v=this._push(h,v,n),r++,r<d)s=b.charCodeAt(r);else break}this._buffLen=v,this._leftoverHighSurrogate=t}_push(b,d,h){return h<128?b[d++]=h:h<2048?(b[d++]=192|(h&1984)>>>6,b[d++]=128|(h&63)>>>0):h<65536?(b[d++]=224|(h&61440)>>>12,b[d++]=128|(h&4032)>>>6,b[d++]=128|(h&63)>>>0):(b[d++]=240|(h&1835008)>>>18,b[d++]=128|(h&258048)>>>12,b[d++]=128|(h&4032)>>>6,b[d++]=128|(h&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,u(this._buff,this._buffLen),this._buffLen>56&&(this._step(),u(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=w._bigBlock32,d=this._buffDV;for(let m=0;m<64;m+=4)b.setUint32(m,d.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)b.setUint32(m,c(b.getUint32(m-12,!1)^b.getUint32(m-32,!1)^b.getUint32(m-56,!1)^b.getUint32(m-64,!1),1),!1);let h=this._h0,v=this._h1,t=this._h2,s=this._h3,r=this._h4,n,l,f;for(let m=0;m<80;m++)m<20?(n=v&t|~v&s,l=1518500249):m<40?(n=v^t^s,l=1859775393):m<60?(n=v&t|v&s|t&s,l=2400959708):(n=v^t^s,l=3395469782),f=c(h,5)+n+r+l+b.getUint32(m*4,!1)&4294967295,r=s,s=t,t=c(v,30),v=h,h=f;this._h0=this._h0+h&4294967295,this._h1=this._h1+v&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))}),define(he[56],fe([0,1,8]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(L||(L={})),function(C){const y="error",T="warning",I="warn",D="info",A="ignore";function i(c){return c?p.equalsIgnoreCase(y,c)?C.Error:p.equalsIgnoreCase(T,c)||p.equalsIgnoreCase(I,c)?C.Warning:p.equalsIgnoreCase(D,c)?C.Info:C.Ignore:C.Ignore}C.fromValue=i;function P(c){switch(c){case C.Error:return y;case C.Warning:return T;case C.Info:return D;default:return A}}C.toString=P}(L||(L={})),e.default=L}),define(he[14],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(m){return Array.isArray(m)}e.isArray=p;function L(m){return typeof m=="string"}e.isString=L;function C(m){return Array.isArray(m)&&m.every(E=>L(E))}e.isStringArray=C;function y(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}e.isObject=y;function T(m){return typeof m=="number"&&!isNaN(m)}e.isNumber=T;function I(m){return!!m&&typeof m[Symbol.iterator]=="function"}e.isIterable=I;function D(m){return m===!0||m===!1}e.isBoolean=D;function A(m){return typeof m=="undefined"}e.isUndefined=A;function i(m){return!P(m)}e.isDefined=i;function P(m){return A(m)||m===null}e.isUndefinedOrNull=P;function c(m,E){if(!m)throw new Error(E?`Unexpected type, expected '${E}'`:"Unexpected type")}e.assertType=c;function u(m){if(P(m))throw new Error("Assertion Failed: argument is undefined or null");return m}e.assertIsDefined=u;function a(...m){const E=[];for(let S=0;S<m.length;S++){const o=m[S];if(P(o))throw new Error(`Assertion Failed: argument at index ${S} is undefined or null`);E.push(o)}return E}e.assertAllDefined=a;const g=Object.prototype.hasOwnProperty;function w(m){if(!y(m))return!1;for(let E in m)if(g.call(m,E))return!1;return!0}e.isEmptyObject=w;function _(m){return typeof m=="function"}e.isFunction=_;function b(...m){return m.length>0&&m.every(_)}e.areFunctions=b;function d(m,E){const S=Math.min(m.length,E.length);for(let o=0;o<S;o++)h(m[o],E[o])}e.validateConstraints=d;function h(m,E){if(L(E)){if(typeof m!==E)throw new Error(`argument does not match constraint: typeof ${E}`)}else if(_(E)){try{if(m instanceof E)return}catch{}if(!P(m)&&m.constructor===E||E.length===1&&E.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function v(m){let E=[],S=Object.getPrototypeOf(m);for(;Object.prototype!==S;)E=E.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return E}e.getAllPropertyNames=v;function t(m){const E=[];for(const S of v(m))typeof m[S]=="function"&&E.push(S);return E}e.getAllMethodNames=t;function s(m,E){const S=k=>function(){const O=Array.prototype.slice.call(arguments,0);return E(k,O)};let o={};for(const k of m)o[k]=S(k);return o}e.createProxyObject=s;function r(m){return m===null?void 0:m}e.withNullAsUndefined=r;function n(m){return typeof m=="undefined"?null:m}e.withUndefinedAsNull=n;function l(m){return class{constructor(){return new Proxy({},{get(E,S){if(E[S])return E[S];throw new Error(`Not Implemented: ${m}->${String(S)}`)}})}}}e.NotImplementedProxy=l;function f(m,E="Unreachable"){throw new Error(E)}e.assertNever=f}),define(he[29],fe([0,1,11,8,9,14]),function(X,e,p,L,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(r){return r===47||r===92}e.isPathSeparator=T;function I(r){return r.replace(/[\\/]/g,C.posix.sep)}e.toSlashes=I;function D(r){return r.indexOf("/")===-1&&(r=I(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=D;function A(r,n=C.posix.sep){if(!r)return"";const l=r.length,f=r.charCodeAt(0);if(T(f)){if(T(r.charCodeAt(1))&&!T(r.charCodeAt(2))){let E=3;const S=E;for(;E<l&&!T(r.charCodeAt(E));E++);if(S!==E&&!T(r.charCodeAt(E+1))){for(E+=1;E<l;E++)if(T(r.charCodeAt(E)))return r.slice(0,E+1).replace(/[\\/]/g,n)}}return n}else if(_(f)&&r.charCodeAt(1)===58)return T(r.charCodeAt(2))?r.slice(0,2)+n:r.slice(0,2);let m=r.indexOf("://");if(m!==-1){for(m+=3;m<l;m++)if(T(r.charCodeAt(m)))return r.slice(0,m+1)}return""}e.getRoot=A;function i(r){if(!p.isWindows||!r||r.length<5)return!1;let n=r.charCodeAt(0);if(n!==92||(n=r.charCodeAt(1),n!==92))return!1;let l=2;const f=l;for(;l<r.length&&(n=r.charCodeAt(l),n!==92);l++);return!(f===l||(n=r.charCodeAt(l+1),isNaN(n)||n===92))}e.isUNC=i;const P=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(r,n=p.isWindows){const l=n?P:c;return!(!r||r.length===0||/^\s+$/.test(r)||(l.lastIndex=0,l.test(r))||n&&u.test(r)||r==="."||r===".."||n&&r[r.length-1]==="."||n&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=a;function g(r,n,l){const f=r===n;return!l||f?f:!r||!n?!1:(0,L.equalsIgnoreCase)(r,n)}e.isEqual=g;function w(r,n,l,f=C.sep){if(r===n)return!0;if(!r||!n||n.length>r.length)return!1;if(l){if(!(0,L.startsWithIgnoreCase)(r,n))return!1;if(n.length===r.length)return!0;let E=n.length;return n.charAt(n.length-1)===f&&E--,r.charAt(E)===f}return n.charAt(n.length-1)!==f&&(n+=f),r.indexOf(n)===0}e.isEqualOrParent=w;function _(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=_;function b(r,n){return p.isWindows&&r.endsWith(":")&&(r+=C.sep),(0,C.isAbsolute)(r)||(r=(0,C.join)(n,r)),r=(0,C.normalize)(r),p.isWindows?(r=(0,L.rtrim)(r,C.sep),r.endsWith(":")&&(r+=C.sep)):(r=(0,L.rtrim)(r,C.sep),r||(r=C.sep)),r}e.sanitizeFilePath=b;function d(r){const n=(0,C.normalize)(r);return p.isWindows?r.length>3?!1:h(n)&&(r.length===2||n.charCodeAt(2)===92):n===C.posix.sep}e.isRootOrDriveLetter=d;function h(r){return p.isWindows?_(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function v(r){return h(r)?r[0]:void 0}e.getDriveLetter=v;function t(r,n,l){return n.length>r.length?-1:r===n?0:(l&&(r=r.toLowerCase(),n=n.toLowerCase()),r.indexOf(n))}e.indexOfPath=t;function s(r){const n=r.split(":");let l,f,m;if(n.forEach(E=>{const S=Number(E);(0,y.isNumber)(S)?f===void 0?f=S:m===void 0&&(m=S):l=l?[l,E].join(":"):E}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:f!==void 0?f:void 0,column:m!==void 0?m:f!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(he[25],fe([0,1,14]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const w=Array.isArray(g)?[]:{};return Object.keys(g).forEach(_=>{g[_]&&typeof g[_]=="object"?w[_]=L(g[_]):w[_]=g[_]}),w}e.deepClone=L;function C(g){if(!g||typeof g!="object")return g;const w=[g];for(;w.length>0;){const _=w.shift();Object.freeze(_);for(const b in _)if(y.call(_,b)){const d=_[b];typeof d=="object"&&!Object.isFrozen(d)&&w.push(d)}}return g}e.deepFreeze=C;const y=Object.prototype.hasOwnProperty;function T(g,w){return I(g,w,new Set)}e.cloneAndChange=T;function I(g,w,_){if((0,p.isUndefinedOrNull)(g))return g;const b=w(g);if(typeof b!="undefined")return b;if((0,p.isArray)(g)){const d=[];for(const h of g)d.push(I(h,w,_));return d}if((0,p.isObject)(g)){if(_.has(g))throw new Error("Cannot clone recursive data-structure");_.add(g);const d={};for(let h in g)y.call(g,h)&&(d[h]=I(g[h],w,_));return _.delete(g),d}return g}function D(g,w,_=!0){return(0,p.isObject)(g)?((0,p.isObject)(w)&&Object.keys(w).forEach(b=>{b in g?_&&((0,p.isObject)(g[b])&&(0,p.isObject)(w[b])?D(g[b],w[b],_):g[b]=w[b]):g[b]=w[b]}),g):w}e.mixin=D;function A(g,w){if(g===w)return!0;if(g==null||w===null||w===void 0||typeof g!=typeof w||typeof g!="object"||Array.isArray(g)!==Array.isArray(w))return!1;let _,b;if(Array.isArray(g)){if(g.length!==w.length)return!1;for(_=0;_<g.length;_++)if(!A(g[_],w[_]))return!1}else{const d=[];for(b in g)d.push(b);d.sort();const h=[];for(b in w)h.push(b);if(h.sort(),!A(d,h))return!1;for(_=0;_<d.length;_++)if(!A(g[d[_]],w[d[_]]))return!1}return!0}e.equals=A;function i(g){const w=new Set;return JSON.stringify(g,(_,b)=>{if((0,p.isObject)(b)||Array.isArray(b)){if(w.has(b))return"[Circular]";w.add(b)}return b})}e.safeStringify=i;function P(g,w,_){const b=w(g);return typeof b=="undefined"?_:b}e.getOrDefault=P;function c(g,w){const _=Object.create(null);return!g||!w||Object.keys(w).forEach(d=>{const h=g[d],v=w[d];A(h,v)||(_[d]=v)}),_}e.distinct=c;function u(g,w){const _=w.toLowerCase(),b=Object.keys(g).find(d=>d.toLowerCase()===_);return b?g[b]:g[w]}e.getCaseInsensitive=u;function a(g,w){const _=Object.create(null);for(const b of Object.keys(g))w(b,g[b])&&(_[b]=g[b]);return _}e.filter=a}),define(he[94],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var p;(function(y){y[y.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",y[y.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",y[y.MAX_UINT_8=255]="MAX_UINT_8",y[y.MAX_UINT_16=65535]="MAX_UINT_16",y[y.MAX_UINT_32=4294967295]="MAX_UINT_32",y[y.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(p=e.Constants||(e.Constants={}));function L(y){return y<0?0:y>255?255:y|0}e.toUint8=L;function C(y){return y<0?0:y>4294967295?4294967295:y|0}e.toUint32=C}),define(he[2],fe([0,1,11,9]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,y=/^\//,T=/^\/\//;function I(r,n){if(!r.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!C.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!y.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(r,n){return!r&&!n?"file":r}function A(r,n){switch(r){case"https":case"http":case"file":n?n[0]!==P&&(n=P+n):n=P;break}return n}const i="",P="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{constructor(n,l,f,m,E,S=!1){typeof n=="object"?(this.scheme=n.scheme||i,this.authority=n.authority||i,this.path=n.path||i,this.query=n.query||i,this.fragment=n.fragment||i):(this.scheme=D(n,S),this.authority=l||i,this.path=A(this.scheme,f||i),this.query=m||i,this.fragment=E||i,I(this,S))}static isUri(n){return n instanceof u?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return d(this,!1)}with(n){if(!n)return this;let{scheme:l,authority:f,path:m,query:E,fragment:S}=n;return l===void 0?l=this.scheme:l===null&&(l=i),f===void 0?f=this.authority:f===null&&(f=i),m===void 0?m=this.path:m===null&&(m=i),E===void 0?E=this.query:E===null&&(E=i),S===void 0?S=this.fragment:S===null&&(S=i),l===this.scheme&&f===this.authority&&m===this.path&&E===this.query&&S===this.fragment?this:new g(l,f,m,E,S)}static parse(n,l=!1){const f=c.exec(n);return f?new g(f[2]||i,s(f[4]||i),s(f[5]||i),s(f[7]||i),s(f[9]||i),l):new g(i,i,i,i,i)}static file(n){let l=i;if(p.isWindows&&(n=n.replace(/\\/g,P)),n[0]===P&&n[1]===P){const f=n.indexOf(P,2);f===-1?(l=n.substring(2),n=P):(l=n.substring(2,f),n=n.substring(f)||P)}return new g("file",l,n,i,i)}static from(n){const l=new g(n.scheme,n.authority,n.path,n.query,n.fragment);return I(l,!0),l}static joinPath(n,...l){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return p.isWindows&&n.scheme==="file"?f=u.file(L.win32.join(d(n,!0),...l)).path:f=L.posix.join(n.path,...l),n.with({path:f})}toString(n=!1){return h(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof u)return n;{const l=new g(n);return l._formatted=n.external,l._fsPath=n._sep===a?n.fsPath:null,l}}else return n}}e.URI=u;const a=p.isWindows?1:void 0;class g extends u{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(n=!1){return n?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=a),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function _(r,n){let l,f=-1;for(let m=0;m<r.length;m++){const E=r.charCodeAt(m);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||n&&E===47)f!==-1&&(l+=encodeURIComponent(r.substring(f,m)),f=-1),l!==void 0&&(l+=r.charAt(m));else{l===void 0&&(l=r.substr(0,m));const S=w[E];S!==void 0?(f!==-1&&(l+=encodeURIComponent(r.substring(f,m)),f=-1),l+=S):f===-1&&(f=m)}}return f!==-1&&(l+=encodeURIComponent(r.substring(f))),l!==void 0?l:r}function b(r){let n;for(let l=0;l<r.length;l++){const f=r.charCodeAt(l);f===35||f===63?(n===void 0&&(n=r.substr(0,l)),n+=w[f]):n!==void 0&&(n+=r[l])}return n!==void 0?n:r}function d(r,n){let l;return r.authority&&r.path.length>1&&r.scheme==="file"?l=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?n?l=r.path.substr(1):l=r.path[1].toLowerCase()+r.path.substr(2):l=r.path,p.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=d;function h(r,n){const l=n?b:_;let f="",{scheme:m,authority:E,path:S,query:o,fragment:k}=r;if(m&&(f+=m,f+=":"),(E||m==="file")&&(f+=P,f+=P),E){let O=E.indexOf("@");if(O!==-1){const $=E.substr(0,O);E=E.substr(O+1),O=$.indexOf(":"),O===-1?f+=l($,!1):(f+=l($.substr(0,O),!1),f+=":",f+=l($.substr(O+1),!1)),f+="@"}E=E.toLowerCase(),O=E.indexOf(":"),O===-1?f+=l(E,!1):(f+=l(E.substr(0,O),!1),f+=E.substr(O))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const O=S.charCodeAt(1);O>=65&&O<=90&&(S=`/${String.fromCharCode(O+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const O=S.charCodeAt(0);O>=65&&O<=90&&(S=`${String.fromCharCode(O+32)}:${S.substr(2)}`)}f+=l(S,!0)}return o&&(f+="?",f+=l(o,!1)),k&&(f+="#",f+=n?k:_(k,!1)),f}function v(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+v(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(t)?r.replace(t,n=>v(n)):r}});var nt=this&&this.__classPrivateFieldSet||function(X,e,p,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!L:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(X):L?L.value:e.get(X)};define(he[23],fe([0,1,2,8]),function(X,e,p,L){"use strict";var C,y,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(t,s,r){let n=t.get(s);return n===void 0&&(n=r,t.set(s,n)),n}e.getOrSet=I;function D(t){const s=[];return t.forEach((r,n)=>{s.push(`${n} => ${r}`)}),`Map(${t.size}) {${s.join(", ")}}`}e.mapToString=D;function A(t){const s=[];return t.forEach(r=>{s.push(r)}),`Set(${t.size}) {${s.join(", ")}}`}e.setToString=A;class i{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const r=s.charCodeAt(0),n=this._value.charCodeAt(this._pos);return r-n}value(){return this._value[this._pos]}}e.StringIterator=i;class P{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,L.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class c{constructor(s=!0,r=!0){this._splitOnBackslash=s,this._caseSensitive=r}reset(s){return this._value=s.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,L.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=c;var u;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(u||(u={}));class a{constructor(s){this._ignorePathCasing=s,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new c(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,L.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=a;class g{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class w{constructor(s){this._iter=s}static forUris(s=()=>!1){return new w(new a(s))}static forPaths(){return new w(new c)}static forStrings(){return new w(new i)}static forConfigKeys(){return new w(new P)}clear(){this._root=void 0}set(s,r){const n=this._iter.reset(s);let l;for(this._root||(this._root=new g,this._root.segment=n.value()),l=this._root;;){const m=n.cmp(l.segment);if(m>0)l.left||(l.left=new g,l.left.segment=n.value()),l=l.left;else if(m<0)l.right||(l.right=new g,l.right.segment=n.value()),l=l.right;else if(n.hasNext())n.next(),l.mid||(l.mid=new g,l.mid.segment=n.value()),l=l.mid;else break}const f=l.value;return l.value=r,l.key=s,f}get(s){return this._getNode(s)?.value}_getNode(s){const r=this._iter.reset(s);let n=this._root;for(;n;){const l=r.cmp(n.segment);if(l>0)n=n.left;else if(l<0)n=n.right;else if(r.hasNext())r.next(),n=n.mid;else break}return n}has(s){const r=this._getNode(s);return!(r?.value===void 0&&r?.mid===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,r){const n=this._iter.reset(s),l=[];let f=this._root;for(;f;){const m=n.cmp(f.segment);if(m>0)l.push([1,f]),f=f.left;else if(m<0)l.push([-1,f]),f=f.right;else if(n.hasNext())n.next(),l.push([0,f]),f=f.mid;else{for(r?(f.left=void 0,f.mid=void 0,f.right=void 0):f.value=void 0;l.length>0&&f.isEmpty();){let[E,S]=l.pop();switch(E){case 1:S.left=void 0;break;case 0:S.mid=void 0;break;case-1:S.right=void 0;break}f=S}break}}}findSubstr(s){const r=this._iter.reset(s);let n=this._root,l;for(;n;){const f=r.cmp(n.segment);if(f>0)n=n.left;else if(f<0)n=n.right;else if(r.hasNext())r.next(),l=n.value||l,n=n.mid;else break}return n&&n.value||l}findSuperstr(s){const r=this._iter.reset(s);let n=this._root;for(;n;){const l=r.cmp(n.segment);if(l>0)n=n.left;else if(l<0)n=n.right;else if(r.hasNext())r.next(),n=n.mid;else return n.mid?this._entries(n.mid):void 0}}forEach(s){for(const[r,n]of this)s(n,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){if(!s)return;const r=[s];for(;r.length>0;){const n=r.pop();n&&(n.value&&(yield[n.key,n.value]),n.left&&r.push(n.left),n.mid&&r.push(n.mid),n.right&&r.push(n.right))}}}e.TernarySearchTree=w;class _{constructor(s,r){this[C]="ResourceMap",s instanceof _?(this.map=new Map(s.map),this.toKey=r??_.defaultToKey):(this.map=new Map,this.toKey=s??_.defaultToKey)}set(s,r){return this.map.set(this.toKey(s),r),this}get(s){return this.map.get(this.toKey(s))}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,r){typeof r!="undefined"&&(s=s.bind(r));for(let[n,l]of this.map)s(l,p.URI.parse(n),this)}values(){return this.map.values()}*keys(){for(let s of this.map.keys())yield p.URI.parse(s)}*entries(){for(let s of this.map.entries())yield[p.URI.parse(s[0]),s[1]]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(let s of this.map)yield[p.URI.parse(s[0]),s[1]]}}e.ResourceMap=_,_.defaultToKey=t=>t.toString();var b;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(b=e.Touch||(e.Touch={}));class d{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,r=0){const n=this._map.get(s);if(!!n)return r!==0&&this.touch(n,r),n.value}set(s,r,n=0){let l=this._map.get(s);if(l)l.value=r,n!==0&&this.touch(l,n);else{switch(l={key:s,value:r,next:void 0,previous:void 0},n){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(s,l),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const r=this._map.get(s);if(!!r)return this._map.delete(s),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,r){const n=this._state;let l=this._head;for(;l;){if(r?s.bind(r)(l.value,l.key,this):s(l.value,l.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const s=this,r=this._state;let n=this._head;const l={[Symbol.iterator](){return l},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const f={value:n.key,done:!1};return n=n.next,f}else return{value:void 0,done:!0}}};return l}values(){const s=this,r=this._state;let n=this._head;const l={[Symbol.iterator](){return l},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const f={value:n.value,done:!1};return n=n.next,f}else return{value:void 0,done:!0}}};return l}entries(){const s=this,r=this._state;let n=this._head;const l={[Symbol.iterator](){return l},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const f={value:[n.key,n.value],done:!1};return n=n.next,f}else return{value:void 0,done:!0}}};return l}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let r=this._head,n=this.size;for(;r&&n>s;)this._map.delete(r.key),r=r.next,n--;this._head=r,this._size=n,r&&(r.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const r=s.next,n=s.previous;if(!r||!n)throw new Error("Invalid list");r.previous=n,n.next=r}s.next=void 0,s.previous=void 0,this._state++}touch(s,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(s===this._head)return;const n=s.next,l=s.previous;s===this._tail?(l.next=void 0,this._tail=l):(n.previous=l,l.next=n),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(r===2){if(s===this._tail)return;const n=s.next,l=s.previous;s===this._head?(n.previous=void 0,this._head=n):(n.previous=l,l.next=n),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((r,n)=>{s.push([n,r])}),s}fromJSON(s){this.clear();for(const[r,n]of s)this.set(r,n)}}e.LinkedMap=d;class h extends d{constructor(s,r=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,r=2){return super.get(s,r)}peek(s){return super.get(s,0)}set(s,r){return super.set(s,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=h;class v{constructor(s){T.set(this,void 0),nt(this,T,s,"f")}get size(){return Ue(this,T,"f").size}forEach(s,r){Ue(this,T,"f").forEach(s,r)}get(s){return Ue(this,T,"f").get(s)}has(s){return Ue(this,T,"f").has(s)}entries(){return Ue(this,T,"f").entries()}keys(){return Ue(this,T,"f").keys()}values(){return Ue(this,T,"f").values()}[(T=new WeakMap,Symbol.iterator)](){return Ue(this,T,"f").entries()}}e.ReadonlyMapView=v}),define(he[95],fe([0,1,23,8]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function C(...Z){return function(de,Ie){for(let Be=0,qe=Z.length;Be<qe;Be++){const Ee=Z[Be](de,Ie);if(Ee)return Ee}return null}}e.or=C,e.matchesStrictPrefix=y.bind(void 0,!1),e.matchesPrefix=y.bind(void 0,!0);function y(Z,de,Ie){if(!Ie||Ie.length<de.length)return null;let Be;return Z?Be=L.startsWithIgnoreCase(Ie,de):Be=Ie.indexOf(de)===0,Be?de.length>0?[{start:0,end:de.length}]:[]:null}function T(Z,de){const Ie=de.toLowerCase().indexOf(Z.toLowerCase());return Ie===-1?null:[{start:Ie,end:Ie+Z.length}]}e.matchesContiguousSubString=T;function I(Z,de){return D(Z.toLowerCase(),de.toLowerCase(),0,0)}e.matchesSubString=I;function D(Z,de,Ie,Be){if(Ie===Z.length)return[];if(Be===de.length)return null;if(Z[Ie]===de[Be]){let qe=null;return(qe=D(Z,de,Ie+1,Be+1))?_({start:Be,end:Be+1},qe):null}return D(Z,de,Ie,Be+1)}function A(Z){return 97<=Z&&Z<=122}function i(Z){return 65<=Z&&Z<=90}e.isUpper=i;function P(Z){return 48<=Z&&Z<=57}function c(Z){return Z===32||Z===9||Z===10||Z===13}const u=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(Z=>u.add(Z.charCodeAt(0)));function a(Z){return c(Z)||u.has(Z)}function g(Z,de){return Z===de||a(Z)&&a(de)}function w(Z){return A(Z)||i(Z)||P(Z)}function _(Z,de){return de.length===0?de=[Z]:Z.end===de[0].start?de[0].start=Z.start:de.unshift(Z),de}function b(Z,de){for(let Ie=de;Ie<Z.length;Ie++){const Be=Z.charCodeAt(Ie);if(i(Be)||P(Be)||Ie>0&&!w(Z.charCodeAt(Ie-1)))return Ie}return Z.length}function d(Z,de,Ie,Be){if(Ie===Z.length)return[];if(Be===de.length)return null;if(Z[Ie]!==de[Be].toLowerCase())return null;{let qe=null,Ee=Be+1;for(qe=d(Z,de,Ie+1,Be+1);!qe&&(Ee=b(de,Ee))<de.length;)qe=d(Z,de,Ie+1,Ee),Ee++;return qe===null?null:_({start:Be,end:Be+1},qe)}}function h(Z){let de=0,Ie=0,Be=0,qe=0,Ee=0;for(let xe=0;xe<Z.length;xe++)Ee=Z.charCodeAt(xe),i(Ee)&&de++,A(Ee)&&Ie++,w(Ee)&&Be++,P(Ee)&&qe++;const tt=de/Z.length,K=Ie/Z.length,ee=Be/Z.length,pe=qe/Z.length;return{upperPercent:tt,lowerPercent:K,alphaPercent:ee,numericPercent:pe}}function v(Z){const{upperPercent:de,lowerPercent:Ie}=Z;return Ie===0&&de>.6}function t(Z){const{upperPercent:de,lowerPercent:Ie,alphaPercent:Be,numericPercent:qe}=Z;return Ie>.2&&de<.8&&Be>.6&&qe<.2}function s(Z){let de=0,Ie=0,Be=0,qe=0;for(let Ee=0;Ee<Z.length;Ee++)Be=Z.charCodeAt(Ee),i(Be)&&de++,A(Be)&&Ie++,c(Be)&&qe++;return(de===0||Ie===0)&&qe===0?Z.length<=30:de<=5}function r(Z,de){if(!de||(de=de.trim(),de.length===0)||!s(Z)||de.length>60)return null;const Ie=h(de);if(!t(Ie)){if(!v(Ie))return null;de=de.toLowerCase()}let Be=null,qe=0;for(Z=Z.toLowerCase();qe<de.length&&(Be=d(Z,de,0,qe))===null;)qe=b(de,qe+1);return Be}e.matchesCamelCase=r;function n(Z,de,Ie=!1){if(!de||de.length===0)return null;let Be=null,qe=0;for(Z=Z.toLowerCase(),de=de.toLowerCase();qe<de.length&&(Be=l(Z,de,0,qe,Ie))===null;)qe=f(de,qe+1);return Be}e.matchesWords=n;function l(Z,de,Ie,Be,qe){if(Ie===Z.length)return[];if(Be===de.length)return null;if(g(Z.charCodeAt(Ie),de.charCodeAt(Be))){let Ee=null,tt=Be+1;if(Ee=l(Z,de,Ie+1,Be+1,qe),!qe)for(;!Ee&&(tt=f(de,tt))<de.length;)Ee=l(Z,de,Ie+1,tt,qe),tt++;return Ee===null?null:_({start:Be,end:Be+1},Ee)}else return null}function f(Z,de){for(let Ie=de;Ie<Z.length;Ie++)if(a(Z.charCodeAt(Ie))||Ie>0&&a(Z.charCodeAt(Ie-1)))return Ie;return Z.length}const m=C(e.matchesPrefix,r,T),E=C(e.matchesPrefix,r,I),S=new p.LRUCache(1e4);function o(Z,de,Ie=!1){if(typeof Z!="string"||typeof de!="string")return null;let Be=S.get(Z);Be||(Be=new RegExp(L.convertSimple2RegExpPattern(Z),"i"),S.set(Z,Be));const qe=Be.exec(de);return qe?[{start:qe.index,end:qe.index+qe[0].length}]:Ie?E(Z,de):m(Z,de)}e.matchesFuzzy=o;function k(Z,de){const Ie=Ve(Z,Z.toLowerCase(),0,de,de.toLowerCase(),0,!0);return Ie?$(Ie):null}e.matchesFuzzy2=k;function O(Z,de,Ie,Be,qe,Ee){const tt=Math.min(13,Z.length);for(;Ie<tt;Ie++){const K=Ve(Z,de,Ie,Be,qe,Ee,!1);if(K)return K}return[0,Ee]}e.anyScore=O;function $(Z){if(typeof Z=="undefined")return[];const de=[],Ie=Z[1];for(let Be=Z.length-1;Be>1;Be--){const qe=Z[Be]+Ie,Ee=de[de.length-1];Ee&&Ee.end===qe?Ee.end=qe+1:de.push({start:qe,end:qe+1})}return de}e.createMatches=$;const G=128;function re(){const Z=[],de=[];for(let Ie=0;Ie<=G;Ie++)de[Ie]=0;for(let Ie=0;Ie<=G;Ie++)Z.push(de.slice(0));return Z}function j(Z){const de=[];for(let Ie=0;Ie<=Z;Ie++)de[Ie]=0;return de}const N=j(2*G),x=j(2*G),R=re(),V=re(),F=re(),M=!1;function B(Z,de,Ie,Be,qe){function Ee(K,ee,pe=" "){for(;K.length<ee;)K=pe+K;return K}let tt=` |   |${Be.split("").map(K=>Ee(K,3)).join("|")}
`;for(let K=0;K<=Ie;K++)K===0?tt+=" |":tt+=`${de[K-1]}|`,tt+=Z[K].slice(0,qe+1).map(ee=>Ee(ee.toString(),3)).join("|")+`
`;return tt}function W(Z,de,Ie,Be){Z=Z.substr(de),Ie=Ie.substr(Be),console.log(B(V,Z,Z.length,Ie,Ie.length)),console.log(B(F,Z,Z.length,Ie,Ie.length)),console.log(B(R,Z,Z.length,Ie,Ie.length))}function Q(Z,de){if(de<0||de>=Z.length)return!1;const Ie=Z.codePointAt(de);switch(Ie){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(Ie)}}function ae(Z,de){if(de<0||de>=Z.length)return!1;switch(Z.charCodeAt(de)){case 32:case 9:return!0;default:return!1}}function _e(Z,de,Ie){return de[Z]!==Ie[Z]}function Fe(Z,de,Ie,Be,qe,Ee,tt=!1){for(;de<Ie&&qe<Ee;)Z[de]===Be[qe]&&(tt&&(N[de]=qe),de+=1),qe+=1;return de===Ie}e.isPatternInWord=Fe;var Ae;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(Ae||(Ae={}));var Me;(function(Z){Z.Default=[-100,0];function de(Ie){return!Ie||Ie.length===2&&Ie[0]===-100&&Ie[1]===0}Z.isDefault=de})(Me=e.FuzzyScore||(e.FuzzyScore={}));function Ve(Z,de,Ie,Be,qe,Ee,tt){const K=Z.length>G?G:Z.length,ee=Be.length>G?G:Be.length;if(Ie>=K||Ee>=ee||K-Ie>ee-Ee||!Fe(de,Ie,K,qe,Ee,ee,!0))return;He(K,ee,Ie,Ee,de,qe);let pe=1,xe=1,$e=Ie,et=Ee;const ke=[!1];for(pe=1,$e=Ie;$e<K;pe++,$e++){const me=N[$e],be=x[$e],q=$e+1<K?x[$e+1]:ee;for(xe=me-Ee+1,et=me;et<q;xe++,et++){let ge=Number.MIN_SAFE_INTEGER,ye=!1;et<=be&&(ge=z(Z,de,$e,Ie,Be,qe,et,ee,Ee,R[pe-1][xe-1]===0,ke));let Te=0;ge!==Number.MAX_SAFE_INTEGER&&(ye=!0,Te=ge+V[pe-1][xe-1]);const Oe=et>me,Ge=Oe?V[pe][xe-1]+(R[pe][xe-1]>0?-5:0):0,Ze=et>me+1&&R[pe][xe-1]>0,Qe=Ze?V[pe][xe-2]+(R[pe][xe-2]>0?-5:0):0;if(Ze&&(!Oe||Qe>=Ge)&&(!ye||Qe>=Te))V[pe][xe]=Qe,F[pe][xe]=3,R[pe][xe]=0;else if(Oe&&(!ye||Ge>=Te))V[pe][xe]=Ge,F[pe][xe]=2,R[pe][xe]=0;else if(ye)V[pe][xe]=Te,F[pe][xe]=1,R[pe][xe]=R[pe-1][xe-1]+1;else throw new Error("not possible")}}if(M&&W(Z,Ie,Be,Ee),!ke[0]&&!tt)return;pe--,xe--;const Ce=[V[pe][xe],Ee];let Re=0,se=0;for(;pe>=1;){let me=xe;do{const be=F[pe][me];if(be===3)me=me-2;else if(be===2)me=me-1;else break}while(me>=1);Re>1&&de[Ie+pe-1]===qe[Ee+xe-1]&&!_e(me+Ee-1,Be,qe)&&Re+1>R[pe][me]&&(me=xe),me===xe?Re++:Re=1,se||(se=me),pe--,xe=me-1,Ce.push(xe)}ee===K&&(Ce[0]+=2);const le=se-K;return Ce[0]-=le,Ce}e.fuzzyScore=Ve;function He(Z,de,Ie,Be,qe,Ee){let tt=Z-1,K=de-1;for(;tt>=Ie&&K>=Be;)qe[tt]===Ee[K]&&(x[tt]=K,tt--),K--}function z(Z,de,Ie,Be,qe,Ee,tt,K,ee,pe,xe){if(de[Ie]!==Ee[tt])return Number.MIN_SAFE_INTEGER;let $e=1,et=!1;return tt===Ie-Be?$e=Z[Ie]===qe[tt]?7:5:_e(tt,qe,Ee)&&(tt===0||!_e(tt-1,qe,Ee))?($e=Z[Ie]===qe[tt]?7:5,et=!0):Q(Ee,tt)&&(tt===0||!Q(Ee,tt-1))?$e=5:(Q(Ee,tt-1)||ae(Ee,tt-1))&&($e=5,et=!0),$e>1&&Ie===Be&&(xe[0]=!0),et||(et=_e(tt,qe,Ee)||Q(Ee,tt-1)||ae(Ee,tt-1)),Ie===Be?tt>ee&&($e-=et?3:5):pe?$e+=et?2:0:$e+=et?0:1,tt+1===K&&($e-=et?3:5),$e}function J(Z,de,Ie,Be,qe,Ee,tt){return oe(Z,de,Ie,Be,qe,Ee,!0,tt)}e.fuzzyScoreGracefulAggressive=J;function ne(Z,de,Ie,Be,qe,Ee,tt){return oe(Z,de,Ie,Be,qe,Ee,!1,tt)}e.fuzzyScoreGraceful=ne;function oe(Z,de,Ie,Be,qe,Ee,tt,K){let ee=Ve(Z,de,Ie,Be,qe,Ee,K);if(ee&&!tt)return ee;if(Z.length>=3){const pe=Math.min(7,Z.length-1);for(let xe=Ie+1;xe<pe;xe++){const $e=we(Z,xe);if($e){const et=Ve($e,$e.toLowerCase(),Ie,Be,qe,Ee,K);et&&(et[0]-=3,(!ee||et[0]>ee[0])&&(ee=et))}}}return ee}function we(Z,de){if(de+1>=Z.length)return;const Ie=Z[de],Be=Z[de+1];if(Ie!==Be)return Z.slice(0,de)+Be+Ie+Z.slice(de+2)}}),define(he[138],fe([0,1,74,95,8]),function(X,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const y=new RegExp(`\\$\\(${p.CSSIcon.iconNameExpression}(?:${p.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${y.source}`,"g");function I(g){return g.replace(T,(w,_)=>_?w:`\\${w}`)}e.escapeIcons=I;const D=new RegExp(`\\\\${y.source}`,"g");function A(g){return g.replace(D,w=>`\\${w}`)}e.markdownEscapeEscapedIcons=A;const i=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function P(g){return g.indexOf(e.iconStartMarker)===-1?g:g.replace(i,(w,_,b,d)=>b?w:_||d||"")}e.stripIcons=P;function c(g){const w=g.indexOf(e.iconStartMarker);return w===-1?{text:g}:u(g,w)}e.parseLabelWithIcons=c;function u(g,w){const _=[];let b="";function d(f){if(f){b+=f;for(const m of f)_.push(t)}}let h=-1,v="",t=0,s,r,n=w;const l=g.length;for(d(g.substr(0,w));n<l;)s=g[n],r=g[n+1],s===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(h=n,d(v),v=e.iconStartMarker,n++):s===")"&&h!==-1?(t+=n-h+1,h=-1,v=""):h!==-1?/^[a-z0-9\-]$/i.test(s)?v+=s:(d(v),h=-1,v=""):d(s),n++;return d(v),{text:b,iconOffsets:_}}function a(g,w,_=!1){const{text:b,iconOffsets:d}=w;if(!d||d.length===0)return(0,L.matchesFuzzy)(g,b,_);const h=(0,C.ltrim)(b," "),v=b.length-h.length,t=(0,L.matchesFuzzy)(g,h,_);if(t)for(const s of t){const r=d[s.start+v]+v;s.start+=r,s.end+=r}return t}e.matchesFuzzyIconAware=a}),define(he[96],fe([0,1,138,15]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var C;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(C=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(u="",a=!1){if(this.value=u,typeof this.value!="string")throw(0,L.illegalArgument)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1)}appendText(u,a=0){return this.value+=A(this.supportThemeIcons?(0,p.escapeIcons)(u):u).replace(/([ \t]+)/g,(g,w)=>"&nbsp;".repeat(w.length)).replace(/^>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,a){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=a,this.value+="\n```\n",this}}e.MarkdownString=y;function T(c){return I(c)?!c.value:Array.isArray(c)?c.every(T):!0}e.isEmptyMarkdownString=T;function I(c){return c instanceof y?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.isMarkdownString=I;function D(c,u){return c===u?!0:!c||!u?!1:c.value===u.value&&c.isTrusted===u.isTrusted&&c.supportThemeIcons===u.supportThemeIcons}e.markdownStringEqual=D;function A(c){return c.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=A;function i(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=i;function P(c){const u=[],a=c.split("|").map(w=>w.trim());c=a[0];const g=a[1];if(g){const w=/height=(\d+)/.exec(g),_=/width=(\d+)/.exec(g),b=w?w[1]:"",d=_?_[1]:"",h=isFinite(parseInt(d)),v=isFinite(parseInt(b));h&&u.push(`width="${d}"`),v&&u.push(`height="${b}"`)}return{href:c,dimensions:u}}e.parseHrefAndDimensions=P}),define(he[57],fe([0,1,22,8,2]),function(X,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function y(i){return JSON.stringify(i,D)}e.stringify=y;function T(i){let P=JSON.parse(i);return P=A(P),P}e.parse=T;var I;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(I=e.MarshalledId||(e.MarshalledId={}));function D(i,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,L.regExpFlags)(P)}:P}function A(i,P=0){if(!i||P>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return C.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof p.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let c=0;c<i.length;++c)i[c]=A(i[c],P+1);else for(const c in i)Object.hasOwnProperty.call(i,c)&&(i[c]=A(i[c],P+1))}return i}e.revive=A}),define(he[10],fe([0,1,2,11]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var C;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp"})(C=e.Schemas||(e.Schemas={}));class y{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,A,i){this._hosts[D]=A,this._ports[D]=i}setConnectionToken(D,A){this._connectionTokens[D]=A}rewrite(D){if(this._delegate)return this._delegate(D);const A=D.authority;let i=this._hosts[A];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const P=this._ports[A],c=this._connectionTokens[A];let u=`path=${encodeURIComponent(D.path)}`;return typeof c=="string"&&(u+=`&tkn=${encodeURIComponent(c)}`),p.URI.from({scheme:L.isWeb?this._preferredWebSchema:C.vscodeRemoteResource,authority:`${i}:${P}`,path:"/vscode-remote-resource",query:u})}}e.RemoteAuthorities=new y;class T{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(D,A,i){const P=this.toUri(D,A);if(P.scheme===C.vscodeRemote)return e.RemoteAuthorities.rewrite(P);let c=!1;return L.isNative&&(i||L.isPreferringBrowserCodeLoad)&&P.scheme===C.file&&(c=!0),P.scheme===C.file&&typeof L.globals.importScripts=="function"&&L.globals.origin==="vscode-file://vscode-app"&&(c=!0),c?P.with({scheme:C.vscodeFileResource,authority:P.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(D,A){const i=this.toUri(D,A);return i.scheme===C.vscodeFileResource?i.with({scheme:C.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(D,A){return p.URI.isUri(D)?D:p.URI.parse(A.toUrl(D))}}e.FileAccess=new T}),define(he[75],fe([0,1,23]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new p.LRUCache(1e4);function C(A){return D(A,"NFC",L)}e.normalizeNFC=C;const y=new p.LRUCache(1e4);function T(A){return D(A,"NFD",y)}e.normalizeNFD=T;const I=/[^\u0000-\u0080]/;function D(A,i,P){if(!A)return A;const c=P.get(A);if(c)return c;let u;return I.test(A)?u=A.normalize(i):u=A,P.set(A,u),u}e.removeAccents=function(){const A=/[\u0300-\u036f]/g;return function(i){return T(i).replace(A,"")}}()}),define(he[24],fe([0,1,29,9,2,8,10,11]),function(X,e,p,L,C,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(u){return(0,C.uriToFsPath)(u,!0)}e.originalFSPath=D;class A{constructor(a){this._ignorePathCasing=a}compare(a,g,w=!1){return a===g?0:(0,y.compare)(this.getComparisonKey(a,w),this.getComparisonKey(g,w))}isEqual(a,g,w=!1){return a===g?!0:!a||!g?!1:this.getComparisonKey(a,w)===this.getComparisonKey(g,w)}getComparisonKey(a,g=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,g,w=!1){if(a.scheme===g.scheme){if(a.scheme===T.Schemas.file)return p.isEqualOrParent(D(a),D(g),this._ignorePathCasing(a))&&a.query===g.query&&(w||a.fragment===g.fragment);if((0,e.isEqualAuthority)(a.authority,g.authority))return p.isEqualOrParent(a.path,g.path,this._ignorePathCasing(a),"/")&&a.query===g.query&&(w||a.fragment===g.fragment)}return!1}joinPath(a,...g){return C.URI.joinPath(a,...g)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return L.posix.basename(a.path)}extname(a){return L.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let g;return a.scheme===T.Schemas.file?g=C.URI.file(L.dirname(D(a))).path:(g=L.posix.dirname(a.path),a.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),g="/")),a.with({path:g})}normalizePath(a){if(!a.path.length)return a;let g;return a.scheme===T.Schemas.file?g=C.URI.file(L.normalize(D(a))).path:g=L.posix.normalize(a.path),a.with({path:g})}relativePath(a,g){if(a.scheme!==g.scheme||!(0,e.isEqualAuthority)(a.authority,g.authority))return;if(a.scheme===T.Schemas.file){const b=L.relative(D(a),D(g));return I.isWindows?p.toSlashes(b):b}let w=a.path||"/",_=g.path||"/";if(this._ignorePathCasing(a)){let b=0;for(const d=Math.min(w.length,_.length);b<d&&!(w.charCodeAt(b)!==_.charCodeAt(b)&&w.charAt(b).toLowerCase()!==_.charAt(b).toLowerCase());b++);w=_.substr(0,b)+w.substr(b)}return L.posix.relative(w,_)}resolvePath(a,g){if(a.scheme===T.Schemas.file){const w=C.URI.file(L.resolve(D(a),g));return a.with({authority:w.authority,path:w.path})}return g=p.toPosixPath(g),a.with({path:L.posix.resolve(a.path,g)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,g){return a===g||(0,y.equalsIgnoreCase)(a,g)}hasTrailingPathSeparator(a,g=L.sep){if(a.scheme===T.Schemas.file){const w=D(a);return w.length>p.getRoot(w).length&&w[w.length-1]===g}else{const w=a.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,g=L.sep){return(0,e.hasTrailingPathSeparator)(a,g)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,g=L.sep){let w=!1;if(a.scheme===T.Schemas.file){const _=D(a);w=_!==void 0&&_.length===p.getRoot(_).length&&_[_.length-1]===g}else{g="/";const _=a.path;w=_.length===1&&_.charCodeAt(_.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(a,g)?a.with({path:a.path+"/"}):a}}e.ExtUri=A,e.extUri=new A(()=>!1),e.extUriBiasedIgnorePathCase=new A(u=>u.scheme===T.Schemas.file?!I.isLinux:!0),e.extUriIgnorePathCase=new A(u=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(u,a){const g=[];for(let w=0;w<u.length;w++){const _=a(u[w]);u.some((b,d)=>d===w?!1:(0,e.isEqualOrParent)(_,a(b)))||g.push(u[w])}return g}e.distinctParents=i;var P;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function a(g){const w=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(d=>{const[h,v]=d.split(":");h&&v&&w.set(h,v)});const b=g.path.substring(0,g.path.indexOf(";"));return b&&w.set(u.META_DATA_MIME,b),w}u.parseMetaData=a})(P=e.DataUri||(e.DataUri={}));function c(u,a,g){if(a){let w=u.path;return w&&w[0]!==L.posix.sep&&(w=L.posix.sep+w),u.with({scheme:g,authority:a,path:w})}return u.with({scheme:g})}e.toLocalResource=c}),define(he[17],fe([0,1,21,15,3,6,24]),function(X,e,p,L,C,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(x){return!!x&&typeof x.then=="function"}e.isThenable=I;function D(x){const R=new p.CancellationTokenSource,V=x(R.token),F=new Promise((M,B)=>{const W=R.token.onCancellationRequested(()=>{W.dispose(),R.dispose(),B((0,L.canceled)())});Promise.resolve(V).then(Q=>{W.dispose(),R.dispose(),M(Q)},Q=>{W.dispose(),R.dispose(),B(Q)})});return new class{cancel(){R.cancel()}then(M,B){return F.then(M,B)}catch(M){return this.then(void 0,M)}finally(M){return F.finally(M)}}}e.createCancelablePromise=D;function A(x,R,V){return Promise.race([x,new Promise(F=>R.onCancellationRequested(()=>F(V)))])}e.raceCancellation=A;async function i(x){let R=-1;const V=x.map((M,B)=>M.then(W=>(R=B,W))),F=await Promise.race(V);return x.forEach((M,B)=>{B!==R&&M.cancel()}),F}e.raceCancellablePromises=i;function P(x,R,V){let F;const M=setTimeout(()=>{F?.(void 0),V?.()},R);return Promise.race([x.finally(()=>clearTimeout(M)),new Promise(B=>F=B)])}e.raceTimeout=P;function c(x){return new Promise((R,V)=>{const F=x();I(F)?F.then(R,V):R(F)})}e.asPromise=c;class u{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(R){if(this.activePromise){if(this.queuedPromiseFactory=R,!this.queuedPromise){const V=()=>{this.queuedPromise=null;const F=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,F};this.queuedPromise=new Promise(F=>{this.activePromise.then(V,V).then(F)})}return new Promise((V,F)=>{this.queuedPromise.then(V,F)})}return this.activePromise=R(),new Promise((V,F)=>{this.activePromise.then(M=>{this.activePromise=null,V(M)},M=>{this.activePromise=null,F(M)})})}}e.Throttler=u;class a{constructor(){this.current=Promise.resolve(null)}queue(R){return this.current=this.current.then(()=>R(),()=>R())}}e.Sequencer=a;class g{constructor(){this.promiseMap=new Map}queue(R,V){const M=(this.promiseMap.get(R)??Promise.resolve()).catch(()=>{}).then(V).finally(()=>{this.promiseMap.get(R)===M&&this.promiseMap.delete(R)});return this.promiseMap.set(R,M),M}}e.SequencerByKey=g;class w{constructor(R){this.defaultDelay=R,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(R,V=this.defaultDelay){return this.task=R,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((F,M)=>{this.doResolve=F,this.doReject=M}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const F=this.task;return this.task=null,F()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},V),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=w;class _{constructor(R){this.delayer=new w(R),this.throttler=new u}trigger(R,V){return this.delayer.trigger(()=>this.throttler.queue(R),V)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=_;class b{constructor(){this._isOpen=!1,this._promise=new Promise((R,V)=>{this._completePromise=R})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=b;class d extends b{constructor(R){super();this._timeout=setTimeout(()=>this.open(),R)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function h(x,R){return R?new Promise((V,F)=>{const M=setTimeout(()=>{B.dispose(),V()},x),B=R.onCancellationRequested(()=>{clearTimeout(M),B.dispose(),F((0,L.canceled)())})}):D(V=>h(x,V))}e.timeout=h;function v(x,R=0){const V=setTimeout(x,R);return(0,y.toDisposable)(()=>clearTimeout(V))}e.disposableTimeout=v;function t(x){const R=[];let V=0;const F=x.length;function M(){return V<F?x[V++]():null}function B(W){W!=null&&R.push(W);const Q=M();return Q?Q.then(B):Promise.resolve(R)}return Promise.resolve(null).then(B)}e.sequence=t;function s(x,R=F=>!!F,V=null){let F=0;const M=x.length,B=()=>{if(F>=M)return Promise.resolve(V);const W=x[F++];return Promise.resolve(W()).then(ae=>R(ae)?Promise.resolve(ae):B())};return B()}e.first=s;function r(x,R=F=>!!F,V=null){if(x.length===0)return Promise.resolve(V);let F=x.length;const M=()=>{F=-1;for(const B of x)B.cancel?.()};return new Promise((B,W)=>{for(const Q of x)Q.then(ae=>{--F>=0&&R(ae)?(M(),B(ae)):F===0&&B(V)}).catch(ae=>{--F>=0&&(M(),W(ae))})})}e.firstParallel=r;class n{constructor(R){this._size=0,this.maxDegreeOfParalellism=R,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new C.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(R){return this._size++,new Promise((V,F)=>{this.outstandingPromises.push({factory:R,c:V,e:F}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const R=this.outstandingPromises.shift();this.runningPromises++;const V=R.factory();V.then(R.c,R.e),V.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=n;class l extends n{constructor(){super(1)}}e.Queue=l;class f{constructor(){this.queues=new Map}queueFor(R,V=T.extUri){const F=V.getComparisonKey(R);let M=this.queues.get(F);return M||(M=new l,C.Event.once(M.onFinished)(()=>{M?.dispose(),this.queues.delete(F)}),this.queues.set(F,M)),M}dispose(){this.queues.forEach(R=>R.dispose()),this.queues.clear()}}e.ResourceQueue=f;class m{constructor(R,V){this._token=-1,typeof R=="function"&&typeof V=="number"&&this.setIfNotSet(R,V)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(R,V){this.cancel(),this._token=setTimeout(()=>{this._token=-1,R()},V)}setIfNotSet(R,V){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,R()},V))}}e.TimeoutTimer=m;class E{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(R,V){this.cancel(),this._token=setInterval(()=>{R()},V)}}e.IntervalTimer=E;class S{constructor(R,V){this.timeoutToken=-1,this.runner=R,this.timeout=V,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(R=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,R)}get delay(){return this.timeout}set delay(R){this.timeout=R}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=S;class o extends S{constructor(R,V){super(R,V);this.units=[]}work(R){this.units.push(R),this.isScheduled()||this.schedule()}doRun(){const R=this.units;this.units=[],this.runner&&this.runner(R)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=o;class k extends y.Disposable{constructor(R,V,F,M){super();this.maxWorkChunkSize=R,this.maxPendingWork=V,this.throttleDelay=F,this.handler=M,this.pendingWork=[],this.throttler=this._register(new y.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(R){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+R.length>this.maxPendingWork)return!1}else if(this.pending+R.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...R),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new S(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=k,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const x=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=R=>{const V=setTimeout(()=>R(x));let F=!1;return{dispose(){F||(F=!0,clearTimeout(V))}}}}else e.runWhenIdle=(x,R)=>{const V=requestIdleCallback(x,typeof R=="number"?{timeout:R}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(V))}}}}();class O{constructor(R){this._didRun=!1,this._executor=()=>{try{this._value=R()}catch(V){this._error=V}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=O;async function $(x,R,V){let F;for(let M=0;M<V;M++)try{return await x()}catch(B){F=B,await h(R)}throw F}e.retry=$;class G{hasPending(R){return this._pending?typeof R=="number"?this._pending.taskId===R:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(R,V,F){return this._pending={taskId:R,cancel:()=>F?.(),promise:V},V.then(()=>this.donePending(R),()=>this.donePending(R)),V}donePending(R){this._pending&&R===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const R=this._next;this._next=void 0,R.run().then(R.promiseResolve,R.promiseReject)}}setNext(R){if(this._next)this._next.run=R;else{let V,F;const M=new Promise((B,W)=>{V=B,F=W});this._next={run:R,promise:M,promiseResolve:V,promiseReject:F}}return this._next.promise}}e.TaskSequentializer=G;class re{constructor(R){this.interval=R,this.lastIncrementTime=0,this.value=0}increment(){const R=Date.now();return R-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=R,this.value=0),this.value++,this.value}}e.IntervalCounter=re;class j{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((R,V)=>{this.completeCallback=R,this.errorCallback=V})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(R){return new Promise(V=>{this.completeCallback(R),this.resolved=!0,V()})}error(R){return new Promise(V=>{this.errorCallback(R),this.rejected=!0,V()})}cancel(){new Promise(R=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,R()})}}e.DeferredPromise=j;var N;(function(x){async function R(V){let F;const M=await Promise.all(V.map(B=>B.then(W=>W,W=>{F||(F=W)})));if(typeof F!="undefined")throw F;return M}x.settled=R})(N=e.Promises||(e.Promises={}))}),define(he[97],fe([0,1,9,17]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const C=new L.IdleValue(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),y=new L.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new L.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function I(S,o,k=!1){const O=S||"",$=o||"",G=C.value.collator.compare(O,$);return C.value.collatorIsNumeric&&G===0&&O!==$?O<$?-1:1:G}e.compareFileNames=I;function D(S,o){const k=y.value.collator;return S=S||"",o=o||"",v(k,S,o)}e.compareFileNamesDefault=D;function A(S,o){const k=y.value.collator;return S=S||"",o=o||"",n(S,o)||v(k,S,o)}e.compareFileNamesUpper=A;function i(S,o){const k=y.value.collator;return S=S||"",o=o||"",r(S,o)||v(k,S,o)}e.compareFileNamesLower=i;function P(S,o){return S=S||"",o=o||"",S===o?0:S<o?-1:1}e.compareFileNamesUnicode=P;function c(S,o,k=!1){k||(S=S&&S.toLowerCase(),o=o&&o.toLowerCase());const[O,$]=d(S),[G,re]=d(o);return O!==G?O<G?-1:1:$===re?0:$<re?-1:1}e.noIntlCompareFileNames=c;function u(S,o){const[k,O]=d(S),[$,G]=d(o);let re=C.value.collator.compare(O,G);if(re===0){if(C.value.collatorIsNumeric&&O!==G)return O<G?-1:1;if(re=C.value.collator.compare(k,$),C.value.collatorIsNumeric&&re===0&&k!==$)return k<$?-1:1}return re}e.compareFileExtensions=u;function a(S,o){S=S||"",o=o||"";const k=h(S),O=h(o),$=y.value.collator,G=T.value.collator;return v(G,k,O)||v($,S,o)}e.compareFileExtensionsDefault=a;function g(S,o){S=S||"",o=o||"";const k=h(S),O=h(o),$=y.value.collator,G=T.value.collator;return v(G,k,O)||n(S,o)||v($,S,o)}e.compareFileExtensionsUpper=g;function w(S,o){S=S||"",o=o||"";const k=h(S),O=h(o),$=y.value.collator,G=T.value.collator;return v(G,k,O)||r(S,o)||v($,S,o)}e.compareFileExtensionsLower=w;function _(S,o){S=S||"",o=o||"";const k=h(S).toLowerCase(),O=h(o).toLowerCase();return k!==O?k<O?-1:1:S!==o?S<o?-1:1:0}e.compareFileExtensionsUnicode=_;const b=/^(.*?)(\.([^.]*))?$/;function d(S,o=!1){const k=S?b.exec(S):[];let O=[k&&k[1]||"",k&&k[3]||""];return o&&(!O[0]&&O[1]||O[0]&&O[0].charAt(0)===".")&&(O=[O[0]+"."+O[1],""]),O}function h(S){const o=S?b.exec(S):[];return o&&o[1]&&o[1].charAt(0)!=="."&&o[3]||""}function v(S,o,k){let O=S.compare(o,k);return O!==0?O:o.length!==k.length?o.length<k.length?-1:1:0}function t(S){const o=S.charAt(0);return o.toLocaleUpperCase()!==o}function s(S){const o=S.charAt(0);return o.toLocaleLowerCase()!==o}function r(S,o){return t(S)&&s(o)?-1:s(S)&&t(o)?1:0}function n(S,o){return s(S)&&t(o)?-1:t(S)&&s(o)?1:0}function l(S,o,k=!1){return k||(S=S&&S.toLowerCase(),o=o&&o.toLowerCase()),S===o?0:S<o?-1:1}function f(S,o,k=!1){const O=S.split(p.sep),$=o.split(p.sep),G=O.length-1,re=$.length-1;let j,N;for(let x=0;;x++){if(j=G===x,N=re===x,j&&N)return I(O[x],$[x],k);if(j)return-1;if(N)return 1;const R=l(O[x],$[x],k);if(R!==0)return R}}e.comparePaths=f;function m(S,o,k){const O=S.toLowerCase(),$=o.toLowerCase(),G=E(S,o,k);if(G)return G;const re=O.endsWith(k),j=$.endsWith(k);if(re!==j)return re?-1:1;const N=I(O,$);return N!==0?N:O.localeCompare($)}e.compareAnything=m;function E(S,o,k){const O=S.toLowerCase(),$=o.toLowerCase(),G=O.startsWith(k),re=$.startsWith(k);if(G!==re)return G?-1:1;if(G&&re){if(O.length<$.length)return-1;if(O.length>$.length)return 1}return 0}e.compareByPrefix=E}),define(he[98],fe([0,1,97,95,9,11,8]),function(X,e,p,L,C,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const I=0,D=[I,[]];function A(j,N,x,R){if(!j||!N)return D;const V=j.length,F=N.length;if(V<F)return D;const M=j.toLowerCase();return!R&&!M.includes(x)?D:i(N,x,F,j,M,V)}e.scoreFuzzy=A;function i(j,N,x,R,V,F){const M=[],B=[];for(let _e=0;_e<x;_e++){const Fe=_e*F,Ae=Fe-F,Me=_e>0,Ve=j[_e],He=N[_e];for(let z=0;z<F;z++){const J=z>0,ne=Fe+z,oe=ne-1,we=Ae+z-1,Z=J?M[oe]:0,de=Me&&J?M[we]:0,Ie=Me&&J?B[we]:0;let Be;!de&&Me?Be=0:Be=P(Ve,He,R,V,z,Ie),Be&&de+Be>=Z?(B[ne]=Ie+1,M[ne]=de+Be):(B[ne]=I,M[ne]=Z)}}const W=[];let Q=x-1,ae=F-1;for(;Q>=0&&ae>=0;){const _e=Q*F+ae;B[_e]===I||(W.push(ae),Q--),ae--}return[M[x*F-1],W.reverse()]}function P(j,N,x,R,V,F){let M=0;if(!c(N,R[V]))return M;if(M+=1,F>0&&(M+=F*5),j===x[V]&&(M+=1),V===0)M+=8;else{const B=u(x.charCodeAt(V-1));B?M+=B:(0,L.isUpper)(x.charCodeAt(V))&&(M+=2)}return M}function c(j,N){return j===N?!0:j==="/"||j==="\\"?N==="/"||N==="\\":!1}function u(j){switch(j){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const a=[void 0,[]];function g(j,N,x=0,R=0){const V=N;return V.values&&V.values.length>1?w(j,V.values,x,R):_(j,N,x,R)}e.scoreFuzzy2=g;function w(j,N,x,R){let V=0;const F=[];for(const M of N){const[B,W]=_(j,M,x,R);if(typeof B!="number")return a;V+=B,F.push(...W)}return[V,f(F)]}function _(j,N,x,R){const V=(0,L.fuzzyScore)(N.original,N.originalLowercase,x,j,j.toLowerCase(),R,!0);return V?[V[0],(0,L.createMatches)(V)]:a}const b=Object.freeze({score:0}),d=1<<18,h=1<<17,v=1<<16;function t(j,N,x,R,V){if(!j||!N.normalized)return b;const F=R.getItemLabel(j);if(!F)return b;const M=R.getItemDescription(j);let B;M?B=`${F}${M}${N.normalized}${Array.isArray(N.values)?N.values.length:""}${x}`:B=`${F}${N.normalized}${Array.isArray(N.values)?N.values.length:""}${x}`;const W=V[B];if(W)return W;const Q=s(F,M,R.getItemPath(j),N,x);return V[B]=Q,Q}e.scoreItemFuzzy=t;function s(j,N,x,R,V){const F=!x||!R.containsPathSeparator;return x&&(y.isLinux?R.pathNormalized===x:(0,T.equalsIgnoreCase)(R.pathNormalized,x))?{score:d,labelMatch:[{start:0,end:j.length}],descriptionMatch:N?[{start:0,end:N.length}]:void 0}:R.values&&R.values.length>1?r(j,N,x,R.values,F,V):n(j,N,x,R,F,V)}function r(j,N,x,R,V,F){let M=0;const B=[],W=[];for(const Q of R){const{score:ae,labelMatch:_e,descriptionMatch:Fe}=n(j,N,x,Q,V,F);if(ae===I)return b;M+=ae,_e&&B.push(..._e),Fe&&W.push(...Fe)}return{score:M,labelMatch:f(B),descriptionMatch:f(W)}}function n(j,N,x,R,V,F){if(V||!N){const[M,B]=A(j,R.normalized,R.normalizedLowercase,F);if(M){const W=(0,L.matchesPrefix)(R.normalized,j);let Q;return W?(Q=h,Q+=Math.round(R.normalized.length/j.length*100)):Q=v,{score:Q+M,labelMatch:W||l(B)}}}if(N){let M=N;x&&(M=`${N}${C.sep}`);const B=M.length,W=`${M}${j}`,[Q,ae]=A(W,R.normalized,R.normalizedLowercase,F);if(Q){const _e=l(ae),Fe=[],Ae=[];return _e.forEach(Me=>{Me.start<B&&Me.end>B?(Fe.push({start:0,end:Me.end-B}),Ae.push({start:Me.start,end:B})):Me.start>=B?Fe.push({start:Me.start-B,end:Me.end-B}):Ae.push(Me)}),{score:Q,labelMatch:Fe,descriptionMatch:Ae}}}return b}function l(j){const N=[];if(!j)return N;let x;for(const R of j)x&&x.end===R?x.end+=1:(x={start:R,end:R+1},N.push(x));return N}function f(j){const N=j.sort((V,F)=>V.start-F.start),x=[];let R;for(const V of N)!R||!m(R,V)?(R=V,x.push(V)):(R.start=Math.min(R.start,V.start),R.end=Math.max(R.end,V.end));return x}function m(j,N){return!(j.end<N.start||N.end<j.start)}function E(j,N,x,R,V,F){const M=t(j,x,R,V,F),B=t(N,x,R,V,F),W=M.score,Q=B.score;if((W===d||Q===d)&&W!==Q)return W===d?-1:1;if(W>v||Q>v){if(W!==Q)return W>Q?-1:1;if(W<h&&Q<h){const He=o(M.labelMatch,B.labelMatch);if(He!==0)return He}const Me=V.getItemLabel(j)||"",Ve=V.getItemLabel(N)||"";if(Me.length!==Ve.length)return Me.length-Ve.length}if(W!==Q)return W>Q?-1:1;const ae=Array.isArray(M.labelMatch)&&M.labelMatch.length>0,_e=Array.isArray(B.labelMatch)&&B.labelMatch.length>0;if(ae&&!_e)return-1;if(_e&&!ae)return 1;const Fe=S(j,M,V),Ae=S(N,B,V);return Fe&&Ae&&Fe!==Ae?Ae>Fe?-1:1:k(j,N,x,V)}e.compareItemsByFuzzyScore=E;function S(j,N,x){let R=-1,V=-1;if(N.descriptionMatch&&N.descriptionMatch.length?R=N.descriptionMatch[0].start:N.labelMatch&&N.labelMatch.length&&(R=N.labelMatch[0].start),N.labelMatch&&N.labelMatch.length){if(V=N.labelMatch[N.labelMatch.length-1].end,N.descriptionMatch&&N.descriptionMatch.length){const F=x.getItemDescription(j);F&&(V+=F.length)}}else N.descriptionMatch&&N.descriptionMatch.length&&(V=N.descriptionMatch[N.descriptionMatch.length-1].end);return V-R}function o(j,N){if(!j&&!N||(!j||!j.length)&&(!N||!N.length))return 0;if(!N||!N.length)return-1;if(!j||!j.length)return 1;const x=j[0].start,V=j[j.length-1].end-x,F=N[0].start,B=N[N.length-1].end-F;return V===B?0:B<V?1:-1}function k(j,N,x,R){const V=R.getItemLabel(j)||"",F=R.getItemLabel(N)||"",M=R.getItemDescription(j),B=R.getItemDescription(N),W=V.length+(M?M.length:0),Q=F.length+(B?B.length:0);if(W!==Q)return W-Q;const ae=R.getItemPath(j),_e=R.getItemPath(N);return ae&&_e&&ae.length!==_e.length?ae.length-_e.length:V!==F?(0,p.compareAnything)(V,F,x.normalized):M&&B&&M!==B?(0,p.compareAnything)(M,B,x.normalized):ae&&_e&&ae!==_e?(0,p.compareAnything)(ae,_e,x.normalized):0}const O=" ";function $(j){typeof j!="string"&&(j="");const N=j.toLowerCase(),{pathNormalized:x,normalized:R,normalizedLowercase:V}=G(j),F=x.indexOf(C.sep)>=0;let M;const B=j.split(O);if(B.length>1)for(const W of B){const{pathNormalized:Q,normalized:ae,normalizedLowercase:_e}=G(W);ae&&(M||(M=[]),M.push({original:W,originalLowercase:W.toLowerCase(),pathNormalized:Q,normalized:ae,normalizedLowercase:_e}))}return{original:j,originalLowercase:N,pathNormalized:x,normalized:R,normalizedLowercase:V,values:M,containsPathSeparator:F}}e.prepareQuery=$;function G(j){let N;y.isWindows?N=j.replace(/\//g,C.sep):N=j.replace(/\\/g,C.sep);const x=(0,T.stripWildcards)(N).replace(/\s/g,"");return{pathNormalized:N,normalized:x,normalizedLowercase:x.toLowerCase()}}function re(j){return Array.isArray(j)?$(j.map(N=>N.original).join(O)):$(j.original)}e.pieceToQuery=re}),define(he[30],fe([0,1,8,29,9,23,17]),function(X,e,p,L,C,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I;const D="**",A="/",i="[/\\\\]",P="[^/\\\\]",c=/\//g;function u(M){switch(M){case 0:return"";case 1:return`${P}*?`;default:return`(?:${i}|${P}+${i}|${i}${P}+)*?`}}function a(M,B){if(!M)return[];const W=[];let Q=!1,ae=!1,_e="";for(const Fe of M){switch(Fe){case B:if(!Q&&!ae){W.push(_e),_e="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}_e+=Fe}return _e&&W.push(_e),W}e.splitGlobAware=a;function g(M){if(!M)return"";let B="";const W=a(M,A);if(W.every(Q=>Q===D))B=".*";else{let Q=!1;W.forEach((ae,_e)=>{if(ae===D){Q||(B+=u(2),Q=!0);return}let Fe=!1,Ae="",Me=!1,Ve="";for(const He of ae){if(He!=="}"&&Fe){Ae+=He;continue}if(Me&&(He!=="]"||!Ve)){let z;He==="-"?z=He:(He==="^"||He==="!")&&!Ve?z="^":He===A?z="":z=p.escapeRegExpCharacters(He),Ve+=z;continue}switch(He){case"{":Fe=!0;continue;case"[":Me=!0;continue;case"}":B+=`(?:${a(Ae,",").map(ne=>g(ne)).join("|")})`,Fe=!1,Ae="";break;case"]":B+="["+Ve+"]",Me=!1,Ve="";break;case"?":B+=P;continue;case"*":B+=u(1);continue;default:B+=p.escapeRegExpCharacters(He)}}_e<W.length-1&&(W[_e+1]!==D||_e+2<W.length)&&(B+=i),Q=!1})}return B}const w=/^\*\*\/\*\.[\w\.-]+$/,_=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,d=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new y.LRUCache(1e4),s=function(){return!1},r=function(){return null};function n(M,B){if(!M)return r;let W;typeof M!="string"?W=M.pattern:W=M,W=W.trim();const Q=`${W}_${!!B.trimForExclusions}`;let ae=t.get(Q);if(ae)return l(ae,M);let _e;if(w.test(W)){const Fe=W.substr(4);ae=function(Ae,Me){return typeof Ae=="string"&&Ae.endsWith(Fe)?W:null}}else(_e=_.exec(f(W,B)))?ae=m(_e[1],W):(B.trimForExclusions?d:b).test(W)?ae=E(W,B):(_e=h.exec(f(W,B)))?ae=S(_e[1].substr(1),W,!0):(_e=v.exec(f(W,B)))?ae=S(_e[1],W,!1):ae=o(W);return t.set(Q,ae),l(ae,M)}function l(M,B){return typeof B=="string"?M:function(W,Q){return L.isEqualOrParent(W,B.base)?M(C.relative(B.base,W),Q):null}}function f(M,B){return B.trimForExclusions&&M.endsWith("/**")?M.substr(0,M.length-2):M}function m(M,B){const W=`/${M}`,Q=`\\${M}`,ae=function(Fe,Ae){return typeof Fe!="string"?null:Ae?Ae===M?B:null:Fe===M||Fe.endsWith(W)||Fe.endsWith(Q)?B:null},_e=[M];return ae.basenames=_e,ae.patterns=[B],ae.allBasenames=_e,ae}function E(M,B){const W=F(M.slice(1,-1).split(",").map(Ae=>n(Ae,B)).filter(Ae=>Ae!==r),M),Q=W.length;if(!Q)return r;if(Q===1)return W[0];const ae=function(Ae,Me){for(let Ve=0,He=W.length;Ve<He;Ve++)if(W[Ve](Ae,Me))return M;return null},_e=W.find(Ae=>!!Ae.allBasenames);_e&&(ae.allBasenames=_e.allBasenames);const Fe=W.reduce((Ae,Me)=>Me.allPaths?Ae.concat(Me.allPaths):Ae,[]);return Fe.length&&(ae.allPaths=Fe),ae}function S(M,B,W){const Q=C.sep===C.posix.sep,ae=Q?M:M.replace(c,C.sep),_e=C.sep+ae,Fe=C.posix.sep+M,Ae=W?function(Me,Ve){return typeof Me=="string"&&(Me===ae||Me.endsWith(_e)||!Q&&(Me===M||Me.endsWith(Fe)))?B:null}:function(Me,Ve){return typeof Me=="string"&&(Me===ae||!Q&&Me===M)?B:null};return Ae.allPaths=[(W?"*/":"./")+M],Ae}function o(M){try{const B=new RegExp(`^${g(M)}$`);return function(W){return B.lastIndex=0,typeof W=="string"&&B.test(W)?M:null}}catch(B){return r}}function k(M,B,W){return!M||typeof B!="string"?!1:O(M)(B,void 0,W)}e.match=k;function O(M,B={}){if(!M)return s;if(typeof M=="string"||j(M)){const W=n(M,B);if(W===r)return s;const Q=function(ae,_e){return!!W(ae,_e)};return W.allBasenames&&(Q.allBasenames=W.allBasenames),W.allPaths&&(Q.allPaths=W.allPaths),Q}return R(M,B)}e.parse=O;function $(M){if(!M)return;let B;return W=>(B||(B=(M()||Promise.resolve([])).then(Q=>Q?re(Q):{})),B.then(Q=>!!Q[W]))}e.hasSiblingPromiseFn=$;function G(M){if(!M)return;let B;return W=>{if(!B){const Q=M();B=Q?re(Q):{}}return!!B[W]}}e.hasSiblingFn=G;function re(M){const B={};for(const W of M)B[W]=!0;return B}function j(M){const B=M;return B&&typeof B.base=="string"&&typeof B.pattern=="string"}e.isRelativePattern=j;function N(M){return M.allBasenames||[]}e.getBasenameTerms=N;function x(M){return M.allPaths||[]}e.getPathTerms=x;function R(M,B){const W=F(Object.getOwnPropertyNames(M).map(Ae=>V(Ae,M[Ae],B)).filter(Ae=>Ae!==r)),Q=W.length;if(!Q)return r;if(!W.some(Ae=>!!Ae.requiresSiblings)){if(Q===1)return W[0];const Ae=function(He,z){for(let J=0,ne=W.length;J<ne;J++){const oe=W[J](He,z);if(oe)return oe}return null},Me=W.find(He=>!!He.allBasenames);Me&&(Ae.allBasenames=Me.allBasenames);const Ve=W.reduce((He,z)=>z.allPaths?He.concat(z.allPaths):He,[]);return Ve.length&&(Ae.allPaths=Ve),Ae}const ae=function(Ae,Me,Ve){let He;for(let z=0,J=W.length;z<J;z++){const ne=W[z];ne.requiresSiblings&&Ve&&(Me||(Me=C.basename(Ae)),He||(He=Me.substr(0,Me.length-C.extname(Ae).length)));const oe=ne(Ae,Me,He,Ve);if(oe)return oe}return null},_e=W.find(Ae=>!!Ae.allBasenames);_e&&(ae.allBasenames=_e.allBasenames);const Fe=W.reduce((Ae,Me)=>Me.allPaths?Ae.concat(Me.allPaths):Ae,[]);return Fe.length&&(ae.allPaths=Fe),ae}function V(M,B,W){if(B===!1)return r;const Q=n(M,W);if(Q===r)return r;if(typeof B=="boolean")return Q;if(B){const ae=B.when;if(typeof ae=="string"){const _e=(Fe,Ae,Me,Ve)=>{if(!Ve||!Q(Fe,Ae))return null;const He=ae.replace("$(basename)",Me),z=Ve(He);return(0,T.isThenable)(z)?z.then(J=>J?M:null):z?M:null};return _e.requiresSiblings=!0,_e}}return Q}function F(M,B){const W=M.filter(Ae=>!!Ae.basenames);if(W.length<2)return M;const Q=W.reduce((Ae,Me)=>{const Ve=Me.basenames;return Ve?Ae.concat(Ve):Ae},[]);let ae;if(B){ae=[];for(let Ae=0,Me=Q.length;Ae<Me;Ae++)ae.push(B)}else ae=W.reduce((Ae,Me)=>{const Ve=Me.patterns;return Ve?Ae.concat(Ve):Ae},[]);const _e=function(Ae,Me){if(typeof Ae!="string")return null;if(!Me){let He;for(He=Ae.length;He>0;He--){const z=Ae.charCodeAt(He-1);if(z===47||z===92)break}Me=Ae.substr(He)}const Ve=Q.indexOf(Me);return Ve!==-1?ae[Ve]:null};_e.basenames=Q,_e.patterns=ae,_e.allBasenames=Q;const Fe=M.filter(Ae=>!Ae.basenames);return Fe.push(_e),Fe}}),define(he[76],fe([0,1,2,9,8,10,11,24,29]),function(X,e,p,L,C,y,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function A(n,l,f){if(typeof n=="string"&&(n=p.URI.file(n)),f){const E=f.getWorkspaceFolder(n);if(E){const S=f.getWorkspace().folders.length>1;let o;if((0,I.isEqual)(E.uri,n)?o="":o=(0,I.relativePath)(E.uri,n),S){const k=E.name?E.name:(0,I.basename)(E.uri);o=o?k+" \u2022 "+o:k}return o}}if(n.scheme!==y.Schemas.file&&n.scheme!==y.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,D.hasDriveLetter)(n.fsPath))return(0,L.normalize)(P(n.fsPath));let m=(0,L.normalize)(n.fsPath);return!T.isWindows&&l?.userHome&&(m=u(m,l.userHome.fsPath)),m}e.getPathLabel=A;function i(n){if(!n)return;typeof n=="string"&&(n=p.URI.file(n));const l=(0,I.basename)(n)||(n.scheme===y.Schemas.file?n.fsPath:n.path);return T.isWindows&&(0,D.isRootOrDriveLetter)(l)?P(l):l}e.getBaseLabel=i;function P(n){return(0,D.hasDriveLetter)(n)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=P;let c=Object.create(null);function u(n,l){if(T.isWindows||!n||!l)return n;let f=c.original===l?c.normalized:void 0;return f||(f=`${(0,C.rtrim)(l,L.posix.sep)}${L.posix.sep}`,c={original:l,normalized:f}),(T.isLinux?n.startsWith(f):(0,C.startsWithIgnoreCase)(n,f))&&(n=`~/${n.substr(f.length)}`),n}e.tildify=u;function a(n,l){return n.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=a;const g="\u2026",w="\\\\",_="~";function b(n,l=L.sep){const f=new Array(n.length);let m=!1;for(let E=0;E<n.length;E++){let S=n[E];if(S===""){f[E]=`.${l}`;continue}if(!S){f[E]=S;continue}m=!0;let o="";S.indexOf(w)===0?(o=S.substr(0,S.indexOf(w)+w.length),S=S.substr(S.indexOf(w)+w.length)):S.indexOf(l)===0?(o=S.substr(0,S.indexOf(l)+l.length),S=S.substr(S.indexOf(l)+l.length)):S.indexOf(_)===0&&(o=S.substr(0,S.indexOf(_)+_.length),S=S.substr(S.indexOf(_)+_.length));const k=S.split(l);for(let O=1;m&&O<=k.length;O++)for(let $=k.length-O;m&&$>=0;$--){m=!1;let G=k.slice($,$+O).join(l);for(let re=0;!m&&re<n.length;re++)if(re!==E&&n[re]&&n[re].indexOf(G)>-1){const j=$+O===k.length,N=$>0&&n[re].indexOf(l)>-1?l+G:G,x=n[re].endsWith(N);m=!j||x}if(!m){let re="";(k[0].endsWith(":")||o!=="")&&($===1&&($=0,O++,G=k[0]+l+G),$>0&&(re=k[0]+l),re=o+re),$>0&&(re=re+g+l),re=re+G,$+O<k.length&&(re=re+l+g),f[E]=re}}m&&(f[E]=S)}return f}e.shorten=b;var d;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function h(n,l=Object.create(null)){const f=[];let m=!1,E="";for(const S of n)if(S==="$"||m&&S==="{")E&&f.push({value:E,type:d.TEXT}),E="",m=!0;else if(S==="}"&&m){const o=l[E];if(typeof o=="string")o.length&&f.push({value:o,type:d.VARIABLE});else if(o){const k=f[f.length-1];(!k||k.type!==d.SEPARATOR)&&f.push({value:o.label,type:d.SEPARATOR})}E="",m=!1}else E+=S;return E&&!m&&f.push({value:E,type:d.TEXT}),f.filter((S,o)=>{if(S.type===d.SEPARATOR){const k=f[o-1],O=f[o+1];return[k,O].every($=>$&&($.type===d.VARIABLE||$.type===d.TEXT)&&$.value.length>0)}return!0}).map(S=>S.value).join("")}e.template=h;function v(n,l){return T.isMacintosh||l?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):n.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=v;function t(n,l){return T.isMacintosh||l?n.replace(/\(&&\w\)|&&/g,""):T.isWindows?n.replace(/&&|&/g,f=>f==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function s(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=s;function r(n){const l=n.indexOf("/")!==-1?L.posix:L.win32,f=l.basename(n),m=l.dirname(n);return f.length?{name:f,parentPath:m}:{name:m,parentPath:""}}e.splitName=r}),define(he[99],fe([0,1,9,8,30,10,24]),function(X,e,p,L,C,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var I;(function(s){s.text="text/plain",s.binary="application/octet-stream",s.unknown="application/unknown",s.markdown="text/markdown"})(I=e.Mimes||(e.Mimes={}));let D=[],A=[],i=[];function P(s,r=!1){const n=c(s);D.push(n),n.userConfigured?i.push(n):A.push(n),r&&!n.userConfigured&&D.forEach(l=>{l.mime===n.mime||l.userConfigured||(n.extension&&l.extension===n.extension&&console.warn(`Overwriting extension <<${n.extension}>> to now point to mime <<${n.mime}>>`),n.filename&&l.filename===n.filename&&console.warn(`Overwriting filename <<${n.filename}>> to now point to mime <<${n.mime}>>`),n.filepattern&&l.filepattern===n.filepattern&&console.warn(`Overwriting filepattern <<${n.filepattern}>> to now point to mime <<${n.mime}>>`),n.firstline&&l.firstline===n.firstline&&console.warn(`Overwriting firstline <<${n.firstline}>> to now point to mime <<${n.mime}>>`))})}e.registerTextMime=P;function c(s){return{id:s.id,mime:s.mime,filename:s.filename,extension:s.extension,filepattern:s.filepattern,firstline:s.firstline,userConfigured:s.userConfigured,filenameLowercase:s.filename?s.filename.toLowerCase():void 0,extensionLowercase:s.extension?s.extension.toLowerCase():void 0,filepatternLowercase:s.filepattern?s.filepattern.toLowerCase():void 0,filepatternOnPath:s.filepattern?s.filepattern.indexOf(p.posix.sep)>=0:!1}}function u(s){s?(D=D.filter(r=>!r.userConfigured),i=[]):(D=[],A=[],i=[])}e.clearTextMimes=u;function a(s,r){let n;if(s)switch(s.scheme){case y.Schemas.file:n=s.fsPath;break;case y.Schemas.data:n=T.DataUri.parseMetaData(s).get(T.DataUri.META_DATA_LABEL);break;default:n=s.path}if(!n)return[I.unknown];n=n.toLowerCase();const l=(0,p.basename)(n),f=g(n,l,i);if(f)return[f,I.text];const m=g(n,l,A);if(m)return[m,I.text];if(r){const E=w(r);if(E)return[E,I.text]}return[I.unknown]}e.guessMimeTypes=a;function g(s,r,n){let l=null,f=null,m=null;for(let E=n.length-1;E>=0;E--){const S=n[E];if(r===S.filenameLowercase){l=S;break}if(S.filepattern&&(!f||S.filepattern.length>f.filepattern.length)){const o=S.filepatternOnPath?s:r;(0,C.match)(S.filepatternLowercase,o)&&(f=S)}S.extension&&(!m||S.extension.length>m.extension.length)&&r.endsWith(S.extensionLowercase)&&(m=S)}return l?l.mime:f?f.mime:m?m.mime:null}function w(s){if((0,L.startsWithUTF8BOM)(s)&&(s=s.substr(1)),s.length>0)for(let r=D.length-1;r>=0;r--){const n=D[r];if(!n.firstline)continue;const l=s.match(n.firstline);if(l&&l.length>0)return n.mime}return null}function _(s){return s?typeof s=="string"?s===I.binary||s===I.text||s===I.unknown:s.length===1&&_(s[0]):!0}e.isUnspecific=_;const b={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function d(s){const r=(0,p.extname)(s);return b[r.toLowerCase()]}e.getMediaMime=d;function h(s){for(const r in b)if(b[r]===s)return r}e.getExtensionForMimeType=h;const v=/^(.+)\/(.+?)(;.+)?$/;function t(s,r){const n=v.exec(s);return n?`${n[1].toLowerCase()}/${n[2].toLowerCase()}${n[3]??""}`:r?void 0:s}e.normalizeMimeType=t}),define(he[100],fe([0,1,2]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(i){return i.toJSON()}class C{constructor(P){this._uriTransformer=P}transformIncoming(P){const c=this._uriTransformer.transformIncoming(P);return c===P?P:L(p.URI.from(c))}transformOutgoing(P){const c=this._uriTransformer.transformOutgoing(P);return c===P?P:L(p.URI.from(c))}transformOutgoingURI(P){const c=this._uriTransformer.transformOutgoing(P);return c===P?P:p.URI.from(c)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function y(i,P,c){if(!i||c>200)return null;if(typeof i=="object"){if(i instanceof p.URI)return P.transformOutgoing(i);for(let u in i)if(Object.hasOwnProperty.call(i,u)){const a=y(i[u],P,c+1);a!==null&&(i[u]=a)}}return null}function T(i,P){const c=y(i,P,0);return c===null?i:c}e.transformOutgoingURIs=T;function I(i,P,c,u){if(!i||u>200)return null;if(typeof i=="object"){if(i.$mid===1)return c?p.URI.revive(P.transformIncoming(i)):P.transformIncoming(i);for(let a in i)if(Object.hasOwnProperty.call(i,a)){const g=I(i[a],P,c,u+1);g!==null&&(i[a]=g)}}return null}function D(i,P){const c=I(i,P,!1,0);return c===null?i:c}e.transformIncomingURIs=D;function A(i,P){const c=I(i,P,!0,0);return c===null?i:c}e.transformAndReviveIncomingURIs=A}),define(he[32],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(D){return p.test(D)}e.isUUID=L;const C=new Uint8Array(16),y=[];for(let D=0;D<256;D++)y.push(D.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(D){for(let A=0;A<D.length;A++)D[A]=Math.floor(Math.random()*256);return D};function I(){T(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let D=0,A="";return A+=y[C[D++]],A+=y[C[D++]],A+=y[C[D++]],A+=y[C[D++]],A+="-",A+=y[C[D++]],A+=y[C[D++]],A+="-",A+=y[C[D++]],A+=y[C[D++]],A+="-",A+=y[C[D++]],A+=y[C[D++]],A+="-",A+=y[C[D++]],A+=y[C[D++]],A+=y[C[D++]],A+=y[C[D++]],A+=y[C[D++]],A+=y[C[D++]],A}e.generateUuid=I}),define(he[139],fe([0,1,101]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(y="utf8"){this.stringDecoder=new p.StringDecoder(y),this.remaining=null}write(y){const T=[],I=this.remaining?this.remaining+this.stringDecoder.write(y):this.stringDecoder.write(y);if(I.length<1)return T;let D=0,A,i=D;for(;i<I.length;)if(A=I.charCodeAt(i),A===13||A===10){if(T.push(I.substring(D,i)),i++,i<I.length){const P=A;A=I.charCodeAt(i),(P===13&&A===10||P===10&&A===13)&&i++}D=i}else i++;return this.remaining=D<I.length?I.substr(D):null,T}end(){return this.remaining}}e.LineDecoder=L}),define(he[28],fe([0,1,45,102,283,9,17,11,29,32,75,24,2]),function(X,e,p,L,C,y,T,I,D,A,i,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var u;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(u=e.RimRafMode||(e.RimRafMode={}));async function a(N,x=u.UNLINK){if((0,D.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return x===u.UNLINK?w(N):g(N)}async function g(N){try{const x=(0,y.join)((0,L.tmpdir)(),(0,A.generateUuid)());try{await e.Promises.rename(N,x)}catch(R){return w(N)}w(x).catch(R=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function w(N){return e.Promises.rmdir(N,{recursive:!0,maxRetries:3})}function _(N){if((0,D.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");p.rmdirSync(N,{recursive:!0})}e.rimrafSync=_;async function b(N,x){return v(await(x?d(N):(0,C.promisify)(p.readdir)(N)))}async function d(N){try{return await(0,C.promisify)(p.readdir)(N,{withFileTypes:!0})}catch(V){console.warn("[node.js fs] readdir with filetypes failed with error: ",V)}const x=[],R=await b(N);for(const V of R){let F=!1,M=!1,B=!1;try{const W=await e.Promises.lstat((0,y.join)(N,V));F=W.isFile(),M=W.isDirectory(),B=W.isSymbolicLink()}catch(W){console.warn("[node.js fs] unexpected error from lstat after readdir: ",W)}x.push({name:V,isFile:()=>F,isDirectory:()=>M,isSymbolicLink:()=>B})}return x}function h(N){return v(p.readdirSync(N))}e.readdirSync=h;function v(N){return N.map(x=>typeof x=="string"?I.isMacintosh?(0,i.normalizeNFC)(x):x:(x.name=I.isMacintosh?(0,i.normalizeNFC)(x.name):x.name,x))}async function t(N){const x=await b(N),R=[];for(const V of x)await r.existsDirectory((0,y.join)(N,V))&&R.push(V);return R}function s(N,x=1e3){return new Promise(R=>{let V=!1;const F=setInterval(()=>{V||(V=!0,p.access(N,M=>{V=!1,M&&(clearInterval(F),R(void 0))}))},x)})}e.whenDeleted=s;var r;(function(N){async function x(F){let M;try{if(M=await e.Promises.lstat(F),!M.isSymbolicLink())return{stat:M}}catch(B){}try{return{stat:await e.Promises.stat(F),symbolicLink:M?.isSymbolicLink()?{dangling:!1}:void 0}}catch(B){if(B.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};if(I.isWindows&&B.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(F)),symbolicLink:{dangling:!1}}}catch(W){if(W.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};throw W}throw B}}N.stat=x;async function R(F){try{const{stat:M,symbolicLink:B}=await N.stat(F);return M.isFile()&&B?.dangling!==!0}catch(M){}return!1}N.existsFile=R;async function V(F){try{const{stat:M,symbolicLink:B}=await N.stat(F);return M.isDirectory()&&B?.dangling!==!0}catch(M){}return!1}N.existsDirectory=V})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new T.ResourceQueue;function l(N,x,R){return n.queueFor(c.URI.file(N),P.extUriBiasedIgnorePathCase).queue(()=>{const V=S(R);return new Promise((F,M)=>m(N,x,V,B=>B?M(B):F()))})}let f=!0;function m(N,x,R,V){if(!f)return p.writeFile(N,x,{mode:R.mode,flag:R.flag},V);p.open(N,R.flag,R.mode,(F,M)=>{if(F)return V(F);p.writeFile(M,x,B=>{if(B)return p.close(M,()=>V(B));p.fdatasync(M,W=>(W&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",W),f=!1),p.close(M,Q=>V(Q))))})})}function E(N,x,R){const V=S(R);if(!f)return p.writeFileSync(N,x,{mode:V.mode,flag:V.flag});const F=p.openSync(N,V.flag,V.mode);try{p.writeFileSync(F,x);try{p.fdatasyncSync(F)}catch(M){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",M),f=!1}}finally{p.closeSync(F)}}e.writeFileSync=E;function S(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function o(N,x){if(N===x)return;async function R(V){try{const F=await e.Promises.lstat(V);if(F.isDirectory()||F.isSymbolicLink())return;await e.Promises.utimes(V,F.atime,new Date)}catch(F){}}try{await e.Promises.rename(N,x),await R(x)}catch(V){if(N.toLowerCase()!==x.toLowerCase()&&V.code==="EXDEV"||N.endsWith("."))await k(N,x,{preserveSymlinks:!1}),await a(N,u.MOVE),await R(x);else throw V}}async function k(N,x,R){return $(N,x,{root:{source:N,target:x},options:R,handledSourcePaths:new Set})}const O=511;async function $(N,x,R){if(R.handledSourcePaths.has(N))return;R.handledSourcePaths.add(N);const{stat:V,symbolicLink:F}=await r.stat(N);if(F){if(R.options.preserveSymlinks)try{return await j(N,x,R)}catch(M){console.warn("[node.js fs] copy of symlink failed: ",M)}if(F.dangling)return}return V.isDirectory()?G(N,x,V.mode&O,R):re(N,x,V.mode&O)}async function G(N,x,R,V){await e.Promises.mkdir(x,{recursive:!0,mode:R});const F=await b(N);for(const M of F)await $((0,y.join)(N,M),(0,y.join)(x,M),V)}async function re(N,x,R){await e.Promises.copyFile(N,x),await e.Promises.chmod(x,R)}async function j(N,x,R){let V=await e.Promises.readlink(N);(0,D.isEqualOrParent)(V,R.root.source,!I.isLinux)&&(V=(0,y.join)(R.root.target,V.substr(R.root.source.length+1))),await e.Promises.symlink(V,x)}e.Promises=new class{get access(){return(0,C.promisify)(p.access)}get stat(){return(0,C.promisify)(p.stat)}get lstat(){return(0,C.promisify)(p.lstat)}get utimes(){return(0,C.promisify)(p.utimes)}get read(){return(0,C.promisify)(p.read)}get readFile(){return(0,C.promisify)(p.readFile)}get write(){return(0,C.promisify)(p.write)}get appendFile(){return(0,C.promisify)(p.appendFile)}get fdatasync(){return(0,C.promisify)(p.fdatasync)}get truncate(){return(0,C.promisify)(p.truncate)}get rename(){return(0,C.promisify)(p.rename)}get copyFile(){return(0,C.promisify)(p.copyFile)}get open(){return(0,C.promisify)(p.open)}get close(){return(0,C.promisify)(p.close)}get symlink(){return(0,C.promisify)(p.symlink)}get readlink(){return(0,C.promisify)(p.readlink)}get chmod(){return(0,C.promisify)(p.chmod)}get mkdir(){return(0,C.promisify)(p.mkdir)}get unlink(){return(0,C.promisify)(p.unlink)}get rmdir(){return(0,C.promisify)(p.rmdir)}get realpath(){return(0,C.promisify)(p.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return t}get writeFile(){return l}get rm(){return a}get move(){return o}get copy(){return k}}}),define(he[103],fe([0,1,45,8,9,28]),function(X,e,p,L,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function T(i){const P=(0,C.dirname)(i);if(i===P)return i;const c=((0,C.basename)(i)||i).toLowerCase();try{const a=(0,y.readdirSync)(P).filter(g=>g.toLowerCase()===c);if(a.length===1){const g=T(P);if(g)return(0,C.join)(g,a[0])}else if(a.length>1){const g=a.indexOf(c);if(g>=0){const w=T(P);if(w)return(0,C.join)(w,a[g])}}}catch(u){}return null}e.realcaseSync=T;async function I(i){try{return await y.Promises.realpath(i)}catch(P){const c=A(i);return await y.Promises.access(c,p.constants.R_OK),c}}e.realpath=I;function D(i){try{return p.realpathSync(i)}catch(P){const c=A(i);return p.accessSync(c,p.constants.R_OK),c}}e.realpathSync=D;function A(i){return(0,L.rtrim)((0,C.normalize)(i),C.sep)}});var je=this&&this.__decorate||function(X,e,p,L){var C=arguments.length,y=C<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,p):L,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")y=Reflect.decorate(X,e,p,L);else for(var I=X.length-1;I>=0;I--)(T=X[I])&&(y=(C<3?T(y):C>3?T(e,p,y):T(e,p))||y);return C>3&&y&&Object.defineProperty(e,p,y),y};define(he[104],fe([0,1,3,6,17,21,15,22,18,14,57,8,53]),function(X,e,p,L,C,y,T,I,D,A,i,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var u;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(u=e.RequestType||(e.RequestType={}));function a(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function w(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var _;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(_||(_={}));class b{constructor(M){this.buffer=M,this.pos=0}read(M){const B=this.buffer.slice(this.pos,this.pos+M);return this.pos+=B.byteLength,B}}class d{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(M){this.buffers.push(M)}}var h;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(h||(h={}));function v(F){const M=I.VSBuffer.alloc(4);return M.writeUInt32BE(F,0),M}function t(F){return F.read(4).readUInt32BE(0)}function s(F){const M=I.VSBuffer.alloc(1);return M.writeUInt8(F,0),M}const r={Undefined:s(h.Undefined),String:s(h.String),Buffer:s(h.Buffer),VSBuffer:s(h.VSBuffer),Array:s(h.Array),Object:s(h.Object)},n=typeof Buffer!="undefined";function l(F,M){if(typeof M=="undefined")F.write(r.Undefined);else if(typeof M=="string"){const B=I.VSBuffer.fromString(M);F.write(r.String),F.write(v(B.byteLength)),F.write(B)}else if(n&&Buffer.isBuffer(M)){const B=I.VSBuffer.wrap(M);F.write(r.Buffer),F.write(v(B.byteLength)),F.write(B)}else if(M instanceof I.VSBuffer)F.write(r.VSBuffer),F.write(v(M.byteLength)),F.write(M);else if(Array.isArray(M)){F.write(r.Array),F.write(v(M.length));for(const B of M)l(F,B)}else{const B=I.VSBuffer.fromString(JSON.stringify(M));F.write(r.Object),F.write(v(B.byteLength)),F.write(B)}}function f(F){switch(F.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return F.read(t(F)).toString();case h.Buffer:return F.read(t(F)).buffer;case h.VSBuffer:return F.read(t(F));case h.Array:{const B=t(F),W=[];for(let Q=0;Q<B;Q++)W.push(f(F));return W}case h.Object:return JSON.parse(F.read(t(F)).toString())}}class m{constructor(M,B,W=null,Q=1e3){this.protocol=M,this.ctx=B,this.logger=W,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ae=>this.onRawMessage(ae)),this.sendResponse({type:200})}registerChannel(M,B){this.channels.set(M,B),setTimeout(()=>this.flushPendingRequests(M),0)}sendResponse(M){switch(M.type){case 200:{const B=this.send([M.type]);this.logger&&this.logger.logOutgoing(B,0,1,w(M.type));return}case 201:case 202:case 204:case 203:{const B=this.send([M.type,M.id],M.data);this.logger&&this.logger.logOutgoing(B,M.id,1,w(M.type),M.data);return}}}send(M,B=void 0){const W=new d;return l(W,M),l(W,B),this.sendBuffer(W.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(B){return 0}}onRawMessage(M){const B=new b(M),W=f(B),Q=f(B),ae=W[0];switch(ae){case 100:return this.logger&&this.logger.logIncoming(M.byteLength,W[1],1,`${a(ae)}: ${W[2]}.${W[3]}`,Q),this.onPromise({type:ae,id:W[1],channelName:W[2],name:W[3],arg:Q});case 102:return this.logger&&this.logger.logIncoming(M.byteLength,W[1],1,`${a(ae)}: ${W[2]}.${W[3]}`,Q),this.onEventListen({type:ae,id:W[1],channelName:W[2],name:W[3],arg:Q});case 101:return this.logger&&this.logger.logIncoming(M.byteLength,W[1],1,`${a(ae)}`),this.disposeActiveRequest({type:ae,id:W[1]});case 103:return this.logger&&this.logger.logIncoming(M.byteLength,W[1],1,`${a(ae)}`),this.disposeActiveRequest({type:ae,id:W[1]})}}onPromise(M){const B=this.channels.get(M.channelName);if(!B){this.collectPendingRequest(M);return}const W=new y.CancellationTokenSource;let Q;try{Q=B.call(this.ctx,M.name,M.arg,W.token)}catch(Fe){Q=Promise.reject(Fe)}const ae=M.id;Q.then(Fe=>{this.sendResponse({id:ae,data:Fe,type:201}),this.activeRequests.delete(M.id)},Fe=>{Fe instanceof Error?this.sendResponse({id:ae,data:{message:Fe.message,name:Fe.name,stack:Fe.stack?Fe.stack.split?Fe.stack.split(`
`):Fe.stack:void 0},type:202}):this.sendResponse({id:ae,data:Fe,type:203}),this.activeRequests.delete(M.id)});const _e=(0,L.toDisposable)(()=>W.cancel());this.activeRequests.set(M.id,_e)}onEventListen(M){const B=this.channels.get(M.channelName);if(!B){this.collectPendingRequest(M);return}const W=M.id,ae=B.listen(this.ctx,M.name,M.arg)(_e=>this.sendResponse({id:W,data:_e,type:204}));this.activeRequests.set(M.id,ae)}disposeActiveRequest(M){const B=this.activeRequests.get(M.id);B&&(B.dispose(),this.activeRequests.delete(M.id))}collectPendingRequest(M){let B=this.pendingRequests.get(M.channelName);B||(B=[],this.pendingRequests.set(M.channelName,B));const W=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.sendResponse({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);B.push({request:M,timeoutTimer:W})}flushPendingRequests(M){const B=this.pendingRequests.get(M);if(B){for(const W of B)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.onPromise(W.request);break;case 102:this.onEventListen(W.request);break}this.pendingRequests.delete(M)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}e.ChannelServer=m;var E;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(E=e.RequestInitiator||(e.RequestInitiator={}));class S{constructor(M,B=null){this.protocol=M,this.isDisposed=!1,this.state=_.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(W=>this.onBuffer(W)),this.logger=B}getChannel(M){const B=this;return{call(W,Q,ae){return B.isDisposed?Promise.reject(T.canceled()):B.requestPromise(M,W,Q,ae)},listen(W,Q){return B.isDisposed?Promise.reject(T.canceled()):B.requestEvent(M,W,Q)}}}requestPromise(M,B,W,Q=y.CancellationToken.None){const ae=this.lastRequestId++,Fe={id:ae,type:100,channelName:M,name:B,arg:W};if(Q.isCancellationRequested)return Promise.reject(T.canceled());let Ae;return new Promise((Ve,He)=>{if(Q.isCancellationRequested)return He(T.canceled());const z=()=>{const we=Z=>{switch(Z.type){case 201:this.handlers.delete(ae),Ve(Z.data);break;case 202:this.handlers.delete(ae);const de=new Error(Z.data.message);de.stack=Z.data.stack,de.name=Z.data.name,He(de);break;case 203:this.handlers.delete(ae),He(Z.data);break}};this.handlers.set(ae,we),this.sendRequest(Fe)};let J=null;this.state===_.Idle?z():(J=(0,C.createCancelablePromise)(we=>this.whenInitialized()),J.then(()=>{J=null,z()}));const ne=()=>{J?(J.cancel(),J=null):this.sendRequest({id:ae,type:101}),He(T.canceled())},oe=Q.onCancellationRequested(ne);Ae=(0,L.combinedDisposable)((0,L.toDisposable)(ne),oe),this.activeRequests.add(Ae)}).finally(()=>{this.activeRequests.delete(Ae)})}requestEvent(M,B,W){const Q=this.lastRequestId++,_e={id:Q,type:102,channelName:M,name:B,arg:W};let Fe=null;const Ae=new p.Emitter({onFirstListenerAdd:()=>{Fe=(0,C.createCancelablePromise)(Ve=>this.whenInitialized()),Fe.then(()=>{Fe=null,this.activeRequests.add(Ae),this.sendRequest(_e)})},onLastListenerRemove:()=>{Fe?(Fe.cancel(),Fe=null):(this.activeRequests.delete(Ae),this.sendRequest({id:Q,type:103}))}}),Me=Ve=>Ae.fire(Ve.data);return this.handlers.set(Q,Me),Ae.event}sendRequest(M){switch(M.type){case 100:case 102:{const B=this.send([M.type,M.id,M.channelName,M.name],M.arg);this.logger&&this.logger.logOutgoing(B,M.id,0,`${a(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const B=this.send([M.type,M.id]);this.logger&&this.logger.logOutgoing(B,M.id,0,a(M.type));return}}}send(M,B=void 0){const W=new d;return l(W,M),l(W,B),this.sendBuffer(W.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(B){return 0}}onBuffer(M){const B=new b(M),W=f(B),Q=f(B),ae=W[0];switch(ae){case 200:return this.logger&&this.logger.logIncoming(M.byteLength,0,0,w(ae)),this.onResponse({type:W[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(M.byteLength,W[1],0,w(ae),Q),this.onResponse({type:W[0],id:W[1],data:Q})}}onResponse(M){if(M.type===200){this.state=_.Idle,this._onDidInitialize.fire();return}const B=this.handlers.get(M.id);B&&B(M)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===_.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}je([c.memoize],S.prototype,"onDidInitializePromise",null),e.ChannelClient=S;class o{constructor(M){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,M(({protocol:B,onDidClientDisconnect:W})=>{p.Event.once(B.onMessage)(ae=>{const _e=new b(ae),Fe=f(_e),Ae=new m(B,Fe),Me=new S(B);this.channels.forEach((He,z)=>Ae.registerChannel(z,He));const Ve={channelServer:Ae,channelClient:Me,ctx:Fe};this._connections.add(Ve),this._onDidAddConnection.fire(Ve),W(()=>{Ae.dispose(),Me.dispose(),this._connections.delete(Ve),this._onDidRemoveConnection.fire(Ve)})})})}get connections(){const M=[];return this._connections.forEach(B=>M.push(B)),M}getChannel(M,B){const W=this;return{call(Q,ae,_e){let Fe;if((0,A.isFunction)(B)){let Me=(0,D.getRandomElement)(W.connections.filter(B));Fe=Me?Promise.resolve(Me):p.Event.toPromise(p.Event.filter(W.onDidAddConnection,B))}else Fe=B.routeCall(W,Q,ae);const Ae=Fe.then(Me=>Me.channelClient.getChannel(M));return O(Ae).call(Q,ae,_e)},listen(Q,ae){if((0,A.isFunction)(B))return W.getMulticastEvent(M,B,Q,ae);const _e=B.routeEvent(W,Q,ae).then(Fe=>Fe.channelClient.getChannel(M));return O(_e).listen(Q,ae)}}}getMulticastEvent(M,B,W,Q){const ae=this;let _e=new L.DisposableStore;const Fe=new p.Emitter({onFirstListenerAdd:()=>{_e=new L.DisposableStore;const Ae=new p.EventMultiplexer,Me=new Map,Ve=z=>{const ne=z.channelClient.getChannel(M).listen(W,Q),oe=Ae.add(ne);Me.set(z,oe)},He=z=>{const J=Me.get(z);!J||(J.dispose(),Me.delete(z))};ae.connections.filter(B).forEach(Ve),p.Event.filter(ae.onDidAddConnection,B)(Ve,void 0,_e),ae.onDidRemoveConnection(He,void 0,_e),Ae.event(Fe.fire,Fe,_e),_e.add(Ae)},onLastListenerRemove:()=>{_e.dispose()}});return Fe.event}registerChannel(M,B){this.channels.set(M,B),this._connections.forEach(W=>{W.channelServer.registerChannel(M,B)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=o;class k{constructor(M,B,W=null){const Q=new d;l(Q,B),M.send(Q.buffer),this.channelClient=new S(M,W),this.channelServer=new m(M,B,W)}getChannel(M){return this.channelClient.getChannel(M)}registerChannel(M,B){this.channelServer.registerChannel(M,B)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=k;function O(F){return{call(M,B,W){return F.then(Q=>Q.call(M,B,W))},listen(M,B){const W=new p.Relay;return F.then(Q=>W.input=Q.listen(M,B)),W.event}}}e.getDelayedChannel=O;function $(F){let M=!1;return{call(B,W,Q){return M?F.call(B,W,Q):(0,C.timeout)(0).then(()=>M=!0).then(()=>F.call(B,W,Q))},listen(B,W){if(M)return F.listen(B,W);const Q=new p.Relay;return(0,C.timeout)(0).then(()=>M=!0).then(()=>Q.input=F.listen(B,W)),Q.event}}}e.getNextTickChannel=$;class G{constructor(M){this.fn=M}routeCall(M){return this.route(M)}routeEvent(M){return this.route(M)}async route(M){for(const B of M.connections)if(await Promise.resolve(this.fn(B.ctx)))return Promise.resolve(B);return await p.Event.toPromise(M.onDidAddConnection),await this.route(M)}}e.StaticRouter=G;var re;(function(F){function M(Q,ae){const _e=Q,Fe=ae&&ae.disableMarshalling,Ae=new Map;for(const Me in _e)W(Me)&&Ae.set(Me,p.Event.buffer(_e[Me],!0));return new class{listen(Me,Ve){const He=Ae.get(Ve);if(He)return He;throw new Error(`Event not found: ${Ve}`)}call(Me,Ve,He){const z=_e[Ve];if(typeof z=="function"){if(!Fe&&Array.isArray(He))for(let J=0;J<He.length;J++)He[J]=(0,i.revive)(He[J]);return z.apply(_e,He)}throw new Error(`Method not found: ${Ve}`)}}}F.fromService=M;function B(Q,ae){const _e=ae&&ae.disableMarshalling;return new Proxy({},{get(Fe,Ae){if(typeof Ae=="string")return ae?.properties?.has(Ae)?ae.properties.get(Ae):W(Ae)?Q.listen(Ae):async function(...Me){let Ve;ae&&!(0,A.isUndefinedOrNull)(ae.context)?Ve=[ae.context,...Me]:Ve=Me;const He=await Q.call(Ae,Ve);return _e?He:(0,i.revive)(He)};throw new Error(`Property not found: ${String(Ae)}`)}})}F.toService=B;function W(Q){return Q[0]==="o"&&Q[1]==="n"&&P.isUpperAsciiLetter(Q.charCodeAt(2))}})(re=e.ProxyChannel||(e.ProxyChannel={}));const j=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let M=F.toString();if(M!=="[object Object]")return M}return F}function x(F){return Array.isArray(F)?F.map(N):N(F)}function R(F,M,B,W,Q,ae,_e){_e=x(_e);const Fe=j[Q],Ae=Fe[W%Fe.length];let Me=[`%c[${F}]%c[${String(M).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${Ae}`];/\($/.test(ae)?(Me=Me.concat(_e),Me.push(")")):Me.push(_e),console.log.apply(console,Me)}e.logWithColors=R;class V{constructor(M,B){this._outgoingPrefix=M,this._incomingPrefix=B,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(M,B,W,Q,ae){this._totalOutgoing+=M,R(this._outgoingPrefix,this._totalOutgoing,M,B,W,Q,ae)}logIncoming(M,B,W,Q,ae){this._totalIncoming+=M,R(this._incomingPrefix,this._totalIncoming,M,B,W,Q,ae)}}e.IPCLogger=V}),define(he[105],fe([0,1,3,104,6,22,11,37]),function(X,e,p,L,C,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var D;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(D=e.SocketCloseEventType||(e.SocketCloseEventType={}));let A=null;function i(){return A||(A=y.VSBuffer.alloc(0)),A}class P{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,l){if(n===0)return i();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const S=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=n),S}if(this._chunks[0].byteLength>n){const S=this._chunks[0].slice(0,n);return l&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),S}let f=y.VSBuffer.alloc(n),m=0,E=0;for(;n>0;){const S=this._chunks[E];if(S.byteLength>n){const o=S.slice(0,n);f.set(o,m),m+=n,l&&(this._chunks[E]=S.slice(n),this._totalLength-=n),n-=n}else f.set(S,m),m+=S.byteLength,l?(this._chunks.shift(),this._totalLength-=S.byteLength):E++,n-=S.byteLength}return f}}e.ChunkStream=P;var c;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(c||(c={}));var u;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(u=e.ProtocolConstants||(e.ProtocolConstants={}));class a{constructor(n,l,f,m){this.type=n,this.id=l,this.ack=f,this.data=m,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends C.Disposable{constructor(n){super();this._onMessage=this._register(new p.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new P,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5);else{const f=this._state.messageType,m=this._state.id,E=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new a(f,m,E,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class w{constructor(n){this._isDisposed=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(n){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=y.VSBuffer.alloc(13);l.writeUInt8(n.type,0),l.writeUInt32BE(n.id,1),l.writeUInt32BE(n.ack,5),l.writeUInt32BE(n.data.byteLength,9),this._writeSoon(l,n.data)}_bufferAdd(n,l){const f=this._totalLength===0;return this._data.push(n,l),this._totalLength+=n.byteLength+l.byteLength,f}_bufferTake(){const n=y.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,l){this._bufferAdd(n,l)&&T.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class _ extends C.Disposable{constructor(n){super();this._onMessage=new p.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new p.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new w(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new a(1,0,0,n))}}e.Protocol=_;class b extends L.IPCClient{constructor(n,l,f=null){super(n,l,f);this.protocol=n}static fromSocket(n,l){return new b(new _(n),l)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=b;class d{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new p.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,I.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=d;class h{constructor(n){this.data=n,this.next=null}}class v{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],l=0,f=this._first;for(;f;)n[l++]=f.data,f=f.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const l=new h(n);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class t{constructor(){this.lastRuns=[];const n=Date.now();for(let l=0;l<t._HISTORY_LENGTH;l++)this.lastRuns[l]=n-1e3*l;setInterval(()=>{for(let l=t._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const n=Date.now(),l=(1+t._HISTORY_LENGTH)*1e3;let f=0;for(let m=0;m<t._HISTORY_LENGTH;m++)n-this.lastRuns[m]<=l&&f++;return 1-f/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class s{constructor(n,l=null){this._loadEstimator=t.getInstance(),this._onControlMessage=new d,this.onControlMessage=this._onControlMessage.event,this._onMessage=new d,this.onMessage=this._onMessage.event,this._onDidDispose=new d,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new d,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new d,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new v,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=n,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),l&&this._socketReader.acceptChunk(l),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,C.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new a(5,0,0,i());this._socketWriter.write(n),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const n=Date.now()-this._socketWriter.lastWriteTime;if(n>=5e3){const l=new a(4,0,0,i());this._socketWriter.write(l),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-n+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const n=Date.now()-this._socketReader.lastReadTime;if(n>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-n,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,l){this._isReconnecting=!0,this._socketDisposables=(0,C.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=n,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1;const n=this._outgoingUnackMsg.toArray();for(let l=0,f=n.length;l<f;l++)this._socketWriter.write(n[l]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(n.type===1){if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new a(6,0,0,i())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data)}else if(n.type===2)this._onControlMessage.fire(n.data);else if(n.type===5)this._onDidDispose.fire();else if(n.type===6){const l=this._outgoingUnackMsg.toArray();for(let f=0,m=l.length;f<m;f++)this._socketWriter.write(l[f]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const f=new a(1,l,this._incomingAckId,n);this._outgoingUnackMsg.push(f),this._isReconnecting||(this._socketWriter.write(f),this._recvAckCheck())}sendControl(n){const l=new a(2,0,0,n);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const n=this._outgoingUnackMsg.peek(),l=Date.now()-n.writtenTime;if(l>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-l,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new a(3,0,this._incomingAckId,i());this._socketWriter.write(n)}}e.PersistentProtocol=s}),define(he[106],fe([0,1,94]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(I){let D=(0,p.toUint8)(I);this._defaultValue=D,this._asciiMap=L._createAsciiMap(D),this._map=new Map}static _createAsciiMap(I){let D=new Uint8Array(256);for(let A=0;A<256;A++)D[A]=I;return D}set(I,D){let A=(0,p.toUint8)(D);I>=0&&I<256?this._asciiMap[I]=A:this._map.set(I,A)}get(I){return I>=0&&I<256?this._asciiMap[I]:this._map.get(I)||this._defaultValue}}e.CharacterClassifier=L;var C;(function(T){T[T.False=0]="False",T[T.True=1]="True"})(C||(C={}));class y{constructor(){this._actual=new L(0)}add(I){this._actual.set(I,1)}has(I){return this._actual.get(I)===1}}e.CharacterSet=y}),define(he[140],fe([0,1,106]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(T){T[T.Regular=0]="Regular",T[T.Whitespace=1]="Whitespace",T[T.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class C extends p.CharacterClassifier{constructor(I){super(0);for(let D=0,A=I.length;D<A;D++)this.set(I.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=C;function y(T){let I={};return D=>(I.hasOwnProperty(D)||(I[D]=T(D)),I[D])}e.getMapForWordSeparators=y(T=>new C(T))}),define(he[46],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class p{constructor(C,y){this.lineNumber=C,this.column=y}with(C=this.lineNumber,y=this.column){return C===this.lineNumber&&y===this.column?this:new p(C,y)}delta(C=0,y=0){return this.with(this.lineNumber+C,this.column+y)}equals(C){return p.equals(this,C)}static equals(C,y){return!C&&!y?!0:!!C&&!!y&&C.lineNumber===y.lineNumber&&C.column===y.column}isBefore(C){return p.isBefore(this,C)}static isBefore(C,y){return C.lineNumber<y.lineNumber?!0:y.lineNumber<C.lineNumber?!1:C.column<y.column}isBeforeOrEqual(C){return p.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,y){return C.lineNumber<y.lineNumber?!0:y.lineNumber<C.lineNumber?!1:C.column<=y.column}static compare(C,y){let T=C.lineNumber|0,I=y.lineNumber|0;if(T===I){let D=C.column|0,A=y.column|0;return D-A}return T-I}clone(){return new p(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new p(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}}e.Position=p}),define(he[40],fe([0,1,46]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(y,T,I,D){y>I||y===I&&T>D?(this.startLineNumber=I,this.startColumn=D,this.endLineNumber=y,this.endColumn=T):(this.startLineNumber=y,this.startColumn=T,this.endLineNumber=I,this.endColumn=D)}isEmpty(){return L.isEmpty(this)}static isEmpty(y){return y.startLineNumber===y.endLineNumber&&y.startColumn===y.endColumn}containsPosition(y){return L.containsPosition(this,y)}static containsPosition(y,T){return!(T.lineNumber<y.startLineNumber||T.lineNumber>y.endLineNumber||T.lineNumber===y.startLineNumber&&T.column<y.startColumn||T.lineNumber===y.endLineNumber&&T.column>y.endColumn)}containsRange(y){return L.containsRange(this,y)}static containsRange(y,T){return!(T.startLineNumber<y.startLineNumber||T.endLineNumber<y.startLineNumber||T.startLineNumber>y.endLineNumber||T.endLineNumber>y.endLineNumber||T.startLineNumber===y.startLineNumber&&T.startColumn<y.startColumn||T.endLineNumber===y.endLineNumber&&T.endColumn>y.endColumn)}strictContainsRange(y){return L.strictContainsRange(this,y)}static strictContainsRange(y,T){return!(T.startLineNumber<y.startLineNumber||T.endLineNumber<y.startLineNumber||T.startLineNumber>y.endLineNumber||T.endLineNumber>y.endLineNumber||T.startLineNumber===y.startLineNumber&&T.startColumn<=y.startColumn||T.endLineNumber===y.endLineNumber&&T.endColumn>=y.endColumn)}plusRange(y){return L.plusRange(this,y)}static plusRange(y,T){let I,D,A,i;return T.startLineNumber<y.startLineNumber?(I=T.startLineNumber,D=T.startColumn):T.startLineNumber===y.startLineNumber?(I=T.startLineNumber,D=Math.min(T.startColumn,y.startColumn)):(I=y.startLineNumber,D=y.startColumn),T.endLineNumber>y.endLineNumber?(A=T.endLineNumber,i=T.endColumn):T.endLineNumber===y.endLineNumber?(A=T.endLineNumber,i=Math.max(T.endColumn,y.endColumn)):(A=y.endLineNumber,i=y.endColumn),new L(I,D,A,i)}intersectRanges(y){return L.intersectRanges(this,y)}static intersectRanges(y,T){let I=y.startLineNumber,D=y.startColumn,A=y.endLineNumber,i=y.endColumn,P=T.startLineNumber,c=T.startColumn,u=T.endLineNumber,a=T.endColumn;return I<P?(I=P,D=c):I===P&&(D=Math.max(D,c)),A>u?(A=u,i=a):A===u&&(i=Math.min(i,a)),I>A||I===A&&D>i?null:new L(I,D,A,i)}equalsRange(y){return L.equalsRange(this,y)}static equalsRange(y,T){return!!y&&!!T&&y.startLineNumber===T.startLineNumber&&y.startColumn===T.startColumn&&y.endLineNumber===T.endLineNumber&&y.endColumn===T.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(y){return new p.Position(y.endLineNumber,y.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(y){return new p.Position(y.startLineNumber,y.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(y,T){return new L(this.startLineNumber,this.startColumn,y,T)}setStartPosition(y,T){return new L(y,T,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(y){return new L(y.startLineNumber,y.startColumn,y.startLineNumber,y.startColumn)}static fromPositions(y,T=y){return new L(y.lineNumber,y.column,T.lineNumber,T.column)}static lift(y){return y?new L(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn):null}static isIRange(y){return y&&typeof y.startLineNumber=="number"&&typeof y.startColumn=="number"&&typeof y.endLineNumber=="number"&&typeof y.endColumn=="number"}static areIntersectingOrTouching(y,T){return!(y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<T.startColumn||T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<y.startColumn)}static areIntersecting(y,T){return!(y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<=T.startColumn||T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<=y.startColumn)}static compareRangesUsingStarts(y,T){if(y&&T){const A=y.startLineNumber|0,i=T.startLineNumber|0;if(A===i){const P=y.startColumn|0,c=T.startColumn|0;if(P===c){const u=y.endLineNumber|0,a=T.endLineNumber|0;if(u===a){const g=y.endColumn|0,w=T.endColumn|0;return g-w}return u-a}return P-c}return A-i}return(y?1:0)-(T?1:0)}static compareRangesUsingEnds(y,T){return y.endLineNumber===T.endLineNumber?y.endColumn===T.endColumn?y.startLineNumber===T.startLineNumber?y.startColumn-T.startColumn:y.startLineNumber-T.startLineNumber:y.endColumn-T.endColumn:y.endLineNumber-T.endLineNumber}static spansMultipleLines(y){return y.endLineNumber>y.startLineNumber}}e.Range=L}),define(he[141],fe([0,1,46,40]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var C;(function(T){T[T.LTR=0]="LTR",T[T.RTL=1]="RTL"})(C=e.SelectionDirection||(e.SelectionDirection={}));class y extends L.Range{constructor(I,D,A,i){super(I,D,A,i);this.selectionStartLineNumber=I,this.selectionStartColumn=D,this.positionLineNumber=A,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(I){return y.selectionsEqual(this,I)}static selectionsEqual(I,D){return I.selectionStartLineNumber===D.selectionStartLineNumber&&I.selectionStartColumn===D.selectionStartColumn&&I.positionLineNumber===D.positionLineNumber&&I.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(I,D){return this.getDirection()===0?new y(this.startLineNumber,this.startColumn,I,D):new y(I,D,this.startLineNumber,this.startColumn)}getPosition(){return new p.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(I,D){return this.getDirection()===0?new y(I,D,this.endLineNumber,this.endColumn):new y(this.endLineNumber,this.endColumn,I,D)}static fromPositions(I,D=I){return new y(I.lineNumber,I.column,D.lineNumber,D.column)}static liftSelection(I){return new y(I.selectionStartLineNumber,I.selectionStartColumn,I.positionLineNumber,I.positionColumn)}static selectionsArrEqual(I,D){if(I&&!D||!I&&D)return!1;if(!I&&!D)return!0;if(I.length!==D.length)return!1;for(let A=0,i=I.length;A<i;A++)if(!this.selectionsEqual(I[A],D[A]))return!1;return!0}static isISelection(I){return I&&typeof I.selectionStartLineNumber=="number"&&typeof I.selectionStartColumn=="number"&&typeof I.positionLineNumber=="number"&&typeof I.positionColumn=="number"}static createWithDirection(I,D,A,i,P){return P===0?new y(I,D,A,i):new y(A,i,I,D)}}e.Selection=y}),define(he[107],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var p;(function(a){a[a.Left=1]="Left",a[a.Center=2]="Center",a[a.Right=4]="Right",a[a.Full=7]="Full"})(p=e.OverviewRulerLane||(e.OverviewRulerLane={}));var L;(function(a){a[a.Inline=1]="Inline",a[a.Gutter=2]="Gutter"})(L=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(a){a[a.TextDefined=0]="TextDefined",a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var y;(function(a){a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(y=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var T;(function(a){a[a.LF=0]="LF",a[a.CRLF=1]="CRLF"})(T=e.EndOfLineSequence||(e.EndOfLineSequence={}));class I{constructor(g){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,g.tabSize|0),this.indentSize=g.tabSize|0,this.insertSpaces=Boolean(g.insertSpaces),this.defaultEOL=g.defaultEOL|0,this.trimAutoWhitespace=Boolean(g.trimAutoWhitespace)}equals(g){return this.tabSize===g.tabSize&&this.indentSize===g.indentSize&&this.insertSpaces===g.insertSpaces&&this.defaultEOL===g.defaultEOL&&this.trimAutoWhitespace===g.trimAutoWhitespace}createChangeEvent(g){return{tabSize:this.tabSize!==g.tabSize,indentSize:this.indentSize!==g.indentSize,insertSpaces:this.insertSpaces!==g.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==g.trimAutoWhitespace}}}e.TextModelResolvedOptions=I;class D{constructor(g,w){this._findMatchBrand=void 0,this.range=g,this.matches=w}}e.FindMatch=D;var A;(function(a){a[a.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",a[a.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",a[a.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",a[a.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(A=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var i;(function(a){a[a.Left=0]="Left",a[a.Right=1]="Right",a[a.None=2]="None"})(i=e.PositionAffinity||(e.PositionAffinity={}));var P;(function(a){a[a.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(P=e.ModelConstants||(e.ModelConstants={}));class c{constructor(g,w,_,b,d,h){this.identifier=g,this.range=w,this.text=_,this.forceMoveMarkers=b,this.isAutoWhitespaceEdit=d,this._isTracked=h}}e.ValidAnnotatedEditOperation=c;class u{constructor(g,w,_){this.reverseEdits=g,this.changes=w,this.trimAutoWhitespaceLineNumbers=_}}e.ApplyEditsResult=u}),define(he[142],fe([0,1,8,140,46,40,107]),function(X,e,p,L,C,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const I=999;class D{constructor(d,h,v,t){this.searchString=d,this.isRegex=h,this.matchCase=v,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let d;this.isRegex?d=A(this.searchString):d=this.searchString.indexOf(`
`)>=0;let h=null;try{h=p.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:d,global:!0,unicode:!0})}catch(t){return null}if(!h)return null;let v=!this.isRegex&&!d;return v&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(v=this.matchCase),new i(h,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,v?this.searchString:null)}}e.SearchParams=D;function A(b){if(!b||b.length===0)return!1;for(let d=0,h=b.length;d<h;d++)if(b.charCodeAt(d)===92){if(d++,d>=h)break;const t=b.charCodeAt(d);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=A;class i{constructor(d,h,v){this.regex=d,this.wordSeparators=h,this.simpleSearch=v}}e.SearchData=i;function P(b,d,h){if(!h)return new T.FindMatch(b,null);let v=[];for(let t=0,s=d.length;t<s;t++)v[t]=d[t];return new T.FindMatch(b,v)}e.createFindMatch=P;class c{constructor(d){let h=[],v=0;for(let t=0,s=d.length;t<s;t++)d.charCodeAt(t)===10&&(h[v++]=t);this._lineFeedsOffsets=h}findLineFeedCountBeforeOffset(d){const h=this._lineFeedsOffsets;let v=0,t=h.length-1;if(t===-1||d<=h[0])return 0;for(;v<t;){const s=v+((t-v)/2>>0);h[s]>=d?t=s-1:h[s+1]>=d?(v=s,t=s):v=s+1}return v+1}}class u{static findMatches(d,h,v,t,s){const r=h.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(d,v,new _(r.wordSeparators,r.regex),t,s):this._doFindMatchesLineByLine(d,v,r,t,s):[]}static _getMultilineMatchRange(d,h,v,t,s,r){let n,l=0;t?(l=t.findLineFeedCountBeforeOffset(s),n=h+s+l):n=h+s;let f;if(t){let o=t.findLineFeedCountBeforeOffset(s+r.length)-l;f=n+r.length+o}else f=n+r.length;const m=d.getPositionAt(n),E=d.getPositionAt(f);return new y.Range(m.lineNumber,m.column,E.lineNumber,E.column)}static _doFindMatchesMultiline(d,h,v,t,s){const r=d.getOffsetAt(h.getStartPosition()),n=d.getValueInRange(h,1),l=d.getEOL()===`\r
`?new c(n):null,f=[];let m=0,E;for(v.reset(0);E=v.next(n);)if(f[m++]=P(this._getMultilineMatchRange(d,r,n,l,E.index,E[0]),E,t),m>=s)return f;return f}static _doFindMatchesLineByLine(d,h,v,t,s){const r=[];let n=0;if(h.startLineNumber===h.endLineNumber){const f=d.getLineContent(h.startLineNumber).substring(h.startColumn-1,h.endColumn-1);return n=this._findMatchesInLine(v,f,h.startLineNumber,h.startColumn-1,n,r,t,s),r}const l=d.getLineContent(h.startLineNumber).substring(h.startColumn-1);n=this._findMatchesInLine(v,l,h.startLineNumber,h.startColumn-1,n,r,t,s);for(let f=h.startLineNumber+1;f<h.endLineNumber&&n<s;f++)n=this._findMatchesInLine(v,d.getLineContent(f),f,0,n,r,t,s);if(n<s){const f=d.getLineContent(h.endLineNumber).substring(0,h.endColumn-1);n=this._findMatchesInLine(v,f,h.endLineNumber,0,n,r,t,s)}return r}static _findMatchesInLine(d,h,v,t,s,r,n,l){const f=d.wordSeparators;if(!n&&d.simpleSearch){const S=d.simpleSearch,o=S.length,k=h.length;let O=-o;for(;(O=h.indexOf(S,O+o))!==-1;)if((!f||w(f,h,k,O,o))&&(r[s++]=new T.FindMatch(new y.Range(v,O+1+t,v,O+1+o+t),null),s>=l))return s;return s}const m=new _(d.wordSeparators,d.regex);let E;m.reset(0);do if(E=m.next(h),E&&(r[s++]=P(new y.Range(v,E.index+1+t,v,E.index+1+E[0].length+t),E,n),s>=l))return s;while(E);return s}static findNextMatch(d,h,v,t){const s=h.parseSearchRequest();if(!s)return null;const r=new _(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindNextMatchMultiline(d,v,r,t):this._doFindNextMatchLineByLine(d,v,r,t)}static _doFindNextMatchMultiline(d,h,v,t){const s=new C.Position(h.lineNumber,1),r=d.getOffsetAt(s),n=d.getLineCount(),l=d.getValueInRange(new y.Range(s.lineNumber,s.column,n,d.getLineMaxColumn(n)),1),f=d.getEOL()===`\r
`?new c(l):null;v.reset(h.column-1);let m=v.next(l);return m?P(this._getMultilineMatchRange(d,r,l,f,m.index,m[0]),m,t):h.lineNumber!==1||h.column!==1?this._doFindNextMatchMultiline(d,new C.Position(1,1),v,t):null}static _doFindNextMatchLineByLine(d,h,v,t){const s=d.getLineCount(),r=h.lineNumber,n=d.getLineContent(r),l=this._findFirstMatchInLine(v,n,r,h.column,t);if(l)return l;for(let f=1;f<=s;f++){const m=(r+f-1)%s,E=d.getLineContent(m+1),S=this._findFirstMatchInLine(v,E,m+1,1,t);if(S)return S}return null}static _findFirstMatchInLine(d,h,v,t,s){d.reset(t-1);const r=d.next(h);return r?P(new y.Range(v,r.index+1,v,r.index+1+r[0].length),r,s):null}static findPreviousMatch(d,h,v,t){const s=h.parseSearchRequest();if(!s)return null;const r=new _(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindPreviousMatchMultiline(d,v,r,t):this._doFindPreviousMatchLineByLine(d,v,r,t)}static _doFindPreviousMatchMultiline(d,h,v,t){const s=this._doFindMatchesMultiline(d,new y.Range(1,1,h.lineNumber,h.column),v,t,10*I);if(s.length>0)return s[s.length-1];const r=d.getLineCount();return h.lineNumber!==r||h.column!==d.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(d,new C.Position(r,d.getLineMaxColumn(r)),v,t):null}static _doFindPreviousMatchLineByLine(d,h,v,t){const s=d.getLineCount(),r=h.lineNumber,n=d.getLineContent(r).substring(0,h.column-1),l=this._findLastMatchInLine(v,n,r,t);if(l)return l;for(let f=1;f<=s;f++){const m=(s+r-f-1)%s,E=d.getLineContent(m+1),S=this._findLastMatchInLine(v,E,m+1,t);if(S)return S}return null}static _findLastMatchInLine(d,h,v,t){let s=null,r;for(d.reset(0);r=d.next(h);)s=P(new y.Range(v,r.index+1,v,r.index+1+r[0].length),r,t);return s}}e.TextModelSearch=u;function a(b,d,h,v,t){if(v===0)return!0;const s=d.charCodeAt(v-1);if(b.get(s)!==0||s===13||s===10)return!0;if(t>0){const r=d.charCodeAt(v);if(b.get(r)!==0)return!0}return!1}function g(b,d,h,v,t){if(v+t===h)return!0;const s=d.charCodeAt(v+t);if(b.get(s)!==0||s===13||s===10)return!0;if(t>0){const r=d.charCodeAt(v+t-1);if(b.get(r)!==0)return!0}return!1}function w(b,d,h,v,t){return a(b,d,h,v,t)&&g(b,d,h,v,t)}e.isValidMatch=w;class _{constructor(d,h){this._wordSeparators=d,this._searchRegex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(d){this._searchRegex.lastIndex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(d){const h=d.length;let v;do{if(this._prevMatchStartIndex+this._prevMatchLength===h||(v=this._searchRegex.exec(d),!v))return null;const t=v.index,s=v[0].length;if(t===this._prevMatchStartIndex&&s===this._prevMatchLength){if(s===0){p.getNextCodePoint(d,h,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=s,!this._wordSeparators||w(this._wordSeparators,d,h,t,s))return v}while(v);return null}}e.Searcher=_}),define(he[108],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function p(I=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const A of e.USUAL_WORD_SEPARATORS)I.indexOf(A)>=0||(D+="\\"+A);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=p();function L(I){let D=e.DEFAULT_WORD_REGEXP;if(I&&I instanceof RegExp)if(I.global)D=I;else{let A="g";I.ignoreCase&&(A+="i"),I.multiline&&(A+="m"),I.unicode&&(A+="u"),D=new RegExp(I.source,A)}return D.lastIndex=0,D}e.ensureValidWordDefinition=L;const C={maxLen:1e3,windowSize:15,timeBudget:150};function y(I,D,A,i,P=C){if(A.length>P.maxLen){let w=I-P.maxLen/2;return w<0?w=0:i+=w,A=A.substring(w,I+P.maxLen/2),y(I,D,A,i,P)}const c=Date.now(),u=I-1-i;let a=-1,g=null;for(let w=1;!(Date.now()-c>=P.timeBudget);w++){const _=u-P.windowSize*w;D.lastIndex=Math.max(0,_);const b=T(D,A,u,a);if(!b&&g||(g=b,_<=0))break;a=_}if(g){let w={word:g[0],startColumn:i+1+g.index,endColumn:i+1+g.index+g[0].length};return D.lastIndex=0,w}return null}e.getWordAtText=y;function T(I,D,A,i){let P;for(;P=I.exec(D);){const c=P.index||0;if(c<=A&&I.lastIndex>=A)return P;if(i>0&&c>i)return null}return null}}),define(he[143],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var p;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(p=e.IndentAction||(e.IndentAction={}));class L{constructor(I){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=I.open,this.close=I.close,this._standardTokenMask=0,Array.isArray(I.notIn))for(let D=0,A=I.notIn.length;D<A;D++)switch(I.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(I){return(this._standardTokenMask&I)==0}}e.StandardAutoClosingPairConditional=L;class C{constructor(I){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of I)y(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),y(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),y(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),y(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&y(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=C;function y(T,I,D){T.has(I)?T.get(I).push(D):T.set(I,[D])}}),define(he[77],fe([0,1,30,9]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function C(y,T,I,D){if(Array.isArray(y)){let A=0;for(const i of y){const P=C(i,T,I,D);if(P===10)return P;P>A&&(A=P)}return A}else{if(typeof y=="string")return D?y==="*"?5:y===I?10:0:0;if(y){const{language:A,pattern:i,scheme:P,hasAccessToAllModels:c}=y;if(!D&&!c)return 0;let u=0;if(P)if(P===T.scheme)u=10;else if(P==="*")u=5;else return 0;if(A)if(A===I)u=10;else if(A==="*")u=Math.max(u,5);else return 0;if(i){let a;if(typeof i=="string"?a=i:a={...i,base:(0,L.normalize)(i.base)},a===T.fsPath||(0,p.match)(a,T.fsPath))u=10;else return 0}return u}else return 0}}e.score=C}),define(he[144],fe([0,1,106]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var L;(function(u){u[u.Invalid=0]="Invalid",u[u.Start=1]="Start",u[u.H=2]="H",u[u.HT=3]="HT",u[u.HTT=4]="HTT",u[u.HTTP=5]="HTTP",u[u.F=6]="F",u[u.FI=7]="FI",u[u.FIL=8]="FIL",u[u.BeforeColon=9]="BeforeColon",u[u.AfterColon=10]="AfterColon",u[u.AlmostThere=11]="AlmostThere",u[u.End=12]="End",u[u.Accept=13]="Accept",u[u.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class C{constructor(a,g,w){const _=new Uint8Array(a*g);for(let b=0,d=a*g;b<d;b++)_[b]=w;this._data=_,this.rows=a,this.cols=g}get(a,g){return this._data[a*this.cols+g]}set(a,g,w){this._data[a*this.cols+g]=w}}e.Uint8Matrix=C;class y{constructor(a){let g=0,w=0;for(let b=0,d=a.length;b<d;b++){let[h,v,t]=a[b];v>g&&(g=v),h>w&&(w=h),t>w&&(w=t)}g++,w++;let _=new C(w,g,0);for(let b=0,d=a.length;b<d;b++){let[h,v,t]=a[b];_.set(h,v,t)}this._states=_,this._maxCharCode=g}nextState(a,g){return g<0||g>=this._maxCharCode?0:this._states.get(a,g)}}e.StateMachine=y;let T=null;function I(){return T===null&&(T=new y([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),T}var D;(function(u){u[u.None=0]="None",u[u.ForceTermination=1]="ForceTermination",u[u.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let A=null;function i(){if(A===null){A=new p.CharacterClassifier(0);const u=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let g=0;g<u.length;g++)A.set(u.charCodeAt(g),1);const a=".,;";for(let g=0;g<a.length;g++)A.set(a.charCodeAt(g),2)}return A}class P{static _createLink(a,g,w,_,b){let d=b-1;do{const h=g.charCodeAt(d);if(a.get(h)!==2)break;d--}while(d>_);if(_>0){const h=g.charCodeAt(_-1),v=g.charCodeAt(d);(h===40&&v===41||h===91&&v===93||h===123&&v===125)&&d--}return{range:{startLineNumber:w,startColumn:_+1,endLineNumber:w,endColumn:d+2},url:g.substring(_,d+1)}}static computeLinks(a,g=I()){const w=i();let _=[];for(let b=1,d=a.getLineCount();b<=d;b++){const h=a.getLineContent(b),v=h.length;let t=0,s=0,r=0,n=1,l=!1,f=!1,m=!1,E=!1;for(;t<v;){let S=!1;const o=h.charCodeAt(t);if(n===13){let k;switch(o){case 40:l=!0,k=0;break;case 41:k=l?0:1;break;case 91:m=!0,f=!0,k=0;break;case 93:m=!1,k=f?0:1;break;case 123:E=!0,k=0;break;case 125:k=E?0:1;break;case 39:k=r===34||r===96?0:1;break;case 34:k=r===39||r===96?0:1;break;case 96:k=r===39||r===34?0:1;break;case 42:k=r===42?1:0;break;case 124:k=r===124?1:0;break;case 32:k=m?0:1;break;default:k=w.get(o)}k===1&&(_.push(P._createLink(w,h,b,s,t)),S=!0)}else if(n===12){let k;o===91?(f=!0,k=0):k=w.get(o),k===1?S=!0:n=13}else n=g.nextState(n,o),n===0&&(S=!0);S&&(n=1,l=!1,f=!1,E=!1,s=t+1,r=o),t++}n===13&&_.push(P._createLink(w,h,b,s,v))}return _}}e.LinkComputer=P;function c(u){return!u||typeof u.getLineCount!="function"||typeof u.getLineContent!="function"?[]:P.computeLinks(u)}e.computeLinks=c}),define(he[145],fe([0,1,3,6]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class C{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new p.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(T){this._onDidChange.fire({changedLanguages:T,changedColorMap:!1})}register(T,I){return this._map.set(T,I),this.fire([T]),(0,L.toDisposable)(()=>{this._map.get(T)===I&&(this._map.delete(T),this.fire([T]))})}registerPromise(T,I){let D=null,A=!1;return this._promises.set(T,I.then(i=>{this._promises.delete(T),!(A||!i)&&(D=this.register(T,i))})),(0,L.toDisposable)(()=>{A=!0,D&&D.dispose()})}getPromise(T){const I=this.get(T);if(I)return Promise.resolve(I);const D=this._promises.get(T);return D?D.then(A=>this.get(T)):null}get(T){return this._map.get(T)||null}setColorMap(T){this._colorMap=T,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=C}),define(he[109],fe([0,1,22,11]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var C;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(C||(C={}));function y(P){for(let c=0,u=P.length;c<u;c+=4){const a=P[c+0],g=P[c+1],w=P[c+2],_=P[c+3];P[c+0]=_,P[c+1]=w,P[c+2]=g,P[c+3]=a}}function T(P){const c=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return L.isLittleEndian()||y(c),p.VSBuffer.wrap(c)}function I(P){const c=P.buffer;if(L.isLittleEndian()||y(c),c.byteOffset%4==0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const u=new Uint8Array(c.byteLength);return u.set(c),new Uint32Array(u.buffer,u.byteOffset,u.length/4)}}function D(P){const c=new Uint32Array(A(P));let u=0;if(c[u++]=P.id,P.type==="full")c[u++]=1,c[u++]=P.data.length,c.set(P.data,u),u+=P.data.length;else{c[u++]=2,c[u++]=P.deltas.length;for(const a of P.deltas)c[u++]=a.start,c[u++]=a.deleteCount,a.data?(c[u++]=a.data.length,c.set(a.data,u),u+=a.data.length):c[u++]=0}return T(c)}e.encodeSemanticTokensDto=D;function A(P){let c=0;if(c+=1+1,P.type==="full")c+=1+P.data.length;else{c+=1,c+=(1+1+1)*P.deltas.length;for(const u of P.deltas)u.data&&(c+=u.data.length)}return c}function i(P){const c=I(P);let u=0;const a=c[u++];if(c[u++]===1){const b=c[u++],d=c.subarray(u,u+b);return u+=b,{id:a,type:"full",data:d}}const w=c[u++];let _=[];for(let b=0;b<w;b++){const d=c[u++],h=c[u++],v=c[u++];let t;v>0&&(t=c.subarray(u,u+v),u+=v),_[b]={start:d,deleteCount:h,data:t}}return{id:a,type:"delta",deltas:_}}e.decodeSemanticTokensDto=i}),define(he[110],fe([0,1,94]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class L{constructor(T,I){this._prefixSumIndexOfResultBrand=void 0,this.index=T,this.remainder=I}}e.PrefixSumIndexOfResult=L;class C{constructor(T){this.values=T,this.prefixSum=new Uint32Array(T.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(T,I){T=(0,p.toUint32)(T);const D=this.values,A=this.prefixSum,i=I.length;return i===0?!1:(this.values=new Uint32Array(D.length+i),this.values.set(D.subarray(0,T),0),this.values.set(D.subarray(T),T+i),this.values.set(I,T),T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(A.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(T,I){return T=(0,p.toUint32)(T),I=(0,p.toUint32)(I),this.values[T]===I?!1:(this.values[T]=I,T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),!0)}removeValues(T,I){T=(0,p.toUint32)(T),I=(0,p.toUint32)(I);const D=this.values,A=this.prefixSum;if(T>=D.length)return!1;let i=D.length-T;return I>=i&&(I=i),I===0?!1:(this.values=new Uint32Array(D.length-I),this.values.set(D.subarray(0,T),0),this.values.set(D.subarray(T+I),T),this.prefixSum=new Uint32Array(this.values.length),T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(A.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(T){return T<0?0:(T=(0,p.toUint32)(T),this._getPrefixSum(T))}_getPrefixSum(T){if(T<=this.prefixSumValidIndex[0])return this.prefixSum[T];let I=this.prefixSumValidIndex[0]+1;I===0&&(this.prefixSum[0]=this.values[0],I++),T>=this.values.length&&(T=this.values.length-1);for(let D=I;D<=T;D++)this.prefixSum[D]=this.prefixSum[D-1]+this.values[D];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],T),this.prefixSum[T]}getIndexOf(T){T=Math.floor(T),this.getTotalSum();let I=0,D=this.values.length-1,A=0,i=0,P=0;for(;I<=D;)if(A=I+(D-I)/2|0,i=this.prefixSum[A],P=i-this.values[A],T<P)D=A-1;else if(T>=i)I=A+1;else break;return new L(A,T-P)}}e.PrefixSumComputer=C}),define(he[146],fe([0,1,8,46,110]),function(X,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class y{constructor(I,D,A,i){this._uri=I,this._lines=D,this._eol=A,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(I){I.eol&&I.eol!==this._eol&&(this._eol=I.eol,this._lineStarts=null);const D=I.changes;for(const A of D)this._acceptDeleteRange(A.range),this._acceptInsertText(new L.Position(A.range.startLineNumber,A.range.startColumn),A.text);this._versionId=I.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const I=this._eol.length,D=this._lines.length,A=new Uint32Array(D);for(let i=0;i<D;i++)A[i]=this._lines[i].length+I;this._lineStarts=new C.PrefixSumComputer(A)}}_setLineText(I,D){this._lines[I]=D,this._lineStarts&&this._lineStarts.changeValue(I,this._lines[I].length+this._eol.length)}_acceptDeleteRange(I){if(I.startLineNumber===I.endLineNumber){if(I.startColumn===I.endColumn)return;this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.startLineNumber-1].substring(I.endColumn-1));return}this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.endLineNumber-1].substring(I.endColumn-1)),this._lines.splice(I.startLineNumber,I.endLineNumber-I.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(I.startLineNumber,I.endLineNumber-I.startLineNumber)}_acceptInsertText(I,D){if(D.length===0)return;let A=(0,p.splitLines)(D);if(A.length===1){this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+A[0]+this._lines[I.lineNumber-1].substring(I.column-1));return}A[A.length-1]+=this._lines[I.lineNumber-1].substring(I.column-1),this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+A[0]);let i=new Uint32Array(A.length-1);for(let P=1;P<A.length;P++)this._lines.splice(I.lineNumber+P-1,0,A[P]),i[P-1]=A[P].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(I.lineNumber,i)}}e.MirrorTextModel=y}),define(he[147],fe([19,20]),function(X,e){return X.create("vs/base/common/date",e)}),define(he[148],fe([0,1,147]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,C=L*60,y=C*24,T=y*7,I=y*30,D=y*365;function A(P,c){typeof P!="number"&&(P=P.getTime());const u=Math.round((new Date().getTime()-P)/1e3);if(u<-30)return(0,p.localize)(0,null,A(new Date().getTime()+u*1e3,!1));if(u<30)return(0,p.localize)(1,null);let a;return u<L?(a=u,c?a===1?(0,p.localize)(2,null,a):(0,p.localize)(3,null,a):a===1?(0,p.localize)(4,null,a):(0,p.localize)(5,null,a)):u<C?(a=Math.floor(u/L),c?a===1?(0,p.localize)(6,null,a):(0,p.localize)(7,null,a):a===1?(0,p.localize)(8,null,a):(0,p.localize)(9,null,a)):u<y?(a=Math.floor(u/C),c?a===1?(0,p.localize)(10,null,a):(0,p.localize)(11,null,a):a===1?(0,p.localize)(12,null,a):(0,p.localize)(13,null,a)):u<T?(a=Math.floor(u/y),c?a===1?(0,p.localize)(14,null,a):(0,p.localize)(15,null,a):a===1?(0,p.localize)(16,null,a):(0,p.localize)(17,null,a)):u<I?(a=Math.floor(u/T),c?a===1?(0,p.localize)(18,null,a):(0,p.localize)(19,null,a):a===1?(0,p.localize)(20,null,a):(0,p.localize)(21,null,a)):u<D?(a=Math.floor(u/I),c?a===1?(0,p.localize)(22,null,a):(0,p.localize)(23,null,a):a===1?(0,p.localize)(24,null,a):(0,p.localize)(25,null,a)):(a=Math.floor(u/D),c?a===1?(0,p.localize)(26,null,a):(0,p.localize)(27,null,a):a===1?(0,p.localize)(28,null,a):(0,p.localize)(29,null,a))}e.fromNow=A;function i(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(he[149],fe([19,20]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(he[58],fe([0,1,149,14,18]),function(X,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function y(A,i){return i&&(A.stack||A.stacktrace)?p.localize(0,null,I(A),T(A.stack)||T(A.stacktrace)):I(A)}function T(A){return Array.isArray(A)?A.join(`
`):A}function I(A){return typeof A.code=="string"&&typeof A.errno=="number"&&typeof A.syscall=="string"?p.localize(1,null,A.message):A.message||p.localize(2,null)}function D(A=null,i=!1){if(!A)return p.localize(3,null);if(Array.isArray(A)){const P=C.coalesce(A),c=D(P[0],i);return P.length>1?p.localize(4,null,c,P.length):c}if(L.isString(A))return A;if(A.detail){const P=A.detail;if(P.error)return y(P.error,i);if(P.exception)return y(P.exception,i)}return A.stack?y(A,i):A.message?A.message:p.localize(5,null)}e.toErrorMessage=D}),define(he[150],fe([19,20]),function(X,e){return X.create("vs/base/node/processes",e)}),define(he[111],fe([0,1,9,28,38,150,37,14,25,29,11,139,10]),function(X,e,p,L,C,y,T,I,D,A,i,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function u(h){switch(h){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function a(h,v){if(i.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};v&&(t.cwd=v);const s=C.execFile("taskkill",["/T","/F","/PID",h.pid.toString()],t);return new Promise(r=>{s.once("error",n=>{r({success:!1,error:n})}),s.once("exit",(n,l)=>{r(n===0?{success:!0}:{success:!1,code:n!==null?n:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?u(t.status):1})}else if(i.isLinux||i.isMacintosh)try{const t=c.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",X).fsPath;return new Promise(s=>{C.execFile(t,[h.pid.toString()],{encoding:"utf8",shell:!0},(r,n,l)=>{s(r?{success:!1,error:r}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else h.kill("SIGKILL");return Promise.resolve({success:!0})}function g(h=T.env){return h.comspec||"cmd.exe"}e.getWindowsShell=g;class w{constructor(v,t,s,r){if(t!==void 0&&s!==void 0&&r!==void 0)this.cmd=v,this.args=t,this.shell=s,this.options=r;else{const n=v;this.cmd=n.command,this.shell=n.isShellCommand,this.args=n.args.slice(0),this.options=n.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const n=Object.create(null);Object.keys(T.env).forEach(l=>{n[l]=T.env[l]}),Object.keys(this.options.env).forEach(l=>{n[l]=this.options.env[l]}),this.options.env=n}}getSanitizedCommand(){let v=this.cmd.toLowerCase();const t=v.lastIndexOf(p.sep);return t!==-1&&(v=v.substring(t+1)),w.WellKnowCommands[v]?v:"other"}start(v){return i.isWindows&&(this.options&&this.options.cwd&&A.isUNC(this.options.cwd)||!this.options&&A.isUNC(T.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(t=>{let s,r;const n=new Promise((l,f)=>{s=l,r=f});if(t){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=C.exec(l,this.options,(f,m,E)=>{this.childProcess=null;const S=f;S&&S.killed?r({killed:this.terminateRequested,stdout:m.toString(),stderr:E.toString()}):this.handleExec(s,v,f,m,E)})}else{let l=null;const f=m=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(m,s,v,r);const E={terminated:this.terminateRequested};I.isNumber(m)&&(E.cmdCode=m),s(E)};if(this.shell&&i.isWindows){const m=D.deepClone(this.options);m.windowsVerbatimArguments=!0,m.detached=!1;let E=!1,S=!1;const o=[];let k=this.ensureQuotes(this.cmd);o.push(k.value),E=k.quoted,this.args&&this.args.forEach($=>{k=this.ensureQuotes($),o.push(k.value),S=S&&k.quoted});const O=["/s","/c"];E?S?O.push('"'+o.join(" ")+'"'):o.length>1?O.push('"'+o[0]+'" '+o.slice(1).join(" ")):O.push('"'+o[0]+'"'):O.push(o.join(" ")),l=C.spawn(g(),O,m)}else this.cmd&&(l=C.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(I.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",m=>{this.childProcess=null,r({terminated:this.terminateRequested,error:m})}),l.pid&&(this.childProcess.on("close",f),this.handleSpawn(l,s,v,r,!0)))}return n})}handleClose(v,t,s,r){}ensureQuotes(v){return w.regexp.test(v)?{value:'"'+v+'"',quoted:!0}:{value:v,quoted:v.length>0&&v[0]==='"'&&v[v.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(v=>v.pid,v=>-1):new Promise(v=>{this.pidResolve=v})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(v=>(this.terminateRequested=!0,a(v,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),v=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(v=>{if(!this.shell||!i.isWindows)return v(!1);const t=C.spawn(g(),["/s","/c"]);t.on("error",s=>v(!0)),t.on("exit",s=>v(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class _ extends w{constructor(v,t,s,r){super(v,t,s,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(v,t,s,r,n){[r,n].forEach((l,f)=>{const m=new P.LineDecoder;m.write(l).forEach(o=>{t({line:o,source:f===0?0:1})});const S=m.end();S&&t({line:S,source:f===0?0:1})}),v({terminated:this.terminateRequested,error:s})}handleSpawn(v,t,s,r,n){const l=new P.LineDecoder,f=new P.LineDecoder;v.stdout.on("data",m=>{l.write(m).forEach(S=>s({line:S,source:0}))}),v.stderr.on("data",m=>{f.write(m).forEach(S=>s({line:S,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=f}handleClose(v,t,s,r){const n=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;n&&s({line:n,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&s({line:l,source:1})}}e.LineProcess=_;function b(h){let v=[],t=!1;const s=function(r){if(t){v.push(r);return}(!h.send(r,l=>{if(l&&console.error(l),t=!1,v.length>0){const f=v.slice(0);v=[],f.forEach(m=>s(m))}})||i.isWindows)&&(t=!0)};return{send:s}}e.createQueuedSender=b;var d;(function(h){async function v(t,s,r){if(p.isAbsolute(t))return t;if(s===void 0&&(s=T.cwd()),p.dirname(t)!=="."||(r===void 0&&I.isString(T.env.PATH)&&(r=T.env.PATH.split(p.delimiter)),r===void 0||r.length===0))return p.join(s,t);async function l(f){return await L.Promises.exists(f)?!(await L.Promises.stat(f)).isDirectory():!1}for(let f of r){let m;if(p.isAbsolute(f)?m=p.join(f,t):m=p.join(s,f,t),await l(m))return m;let E=m+".com";if(await l(E)||(E=m+".exe",await l(E)))return E}return p.join(s,t)}h.findExecutable=v})(d=e.win32||(e.win32={}))}),define(he[151],fe([19,20]),function(X,e){return X.create("vs/editor/common/config/editorOptions",e)}),define(he[112],fe([0,1,151,11,108]),function(X,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(K){K[K.None=0]="None",K[K.Keep=1]="Keep",K[K.Brackets=2]="Brackets",K[K.Advanced=3]="Advanced",K[K.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class T{constructor(ee){this._values=ee}hasChanged(ee){return this._values[ee]}}e.ConfigurationChangedEvent=T;class I{constructor(){this._values=[]}_read(ee){return this._values[ee]}get(ee){return this._values[ee]}_write(ee,pe){this._values[ee]=pe}}e.ValidatedEditorOptions=I;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class A{constructor(ee,pe,xe,$e){this.id=ee,this.name=pe,this.defaultValue=xe,this.schema=$e}compute(ee,pe,xe){return xe}}class i{constructor(ee,pe=null){this.schema=void 0,this.id=ee,this.name="_never_",this.defaultValue=void 0,this.deps=pe}validate(ee){return this.defaultValue}}class P{constructor(ee,pe,xe,$e){this.id=ee,this.name=pe,this.defaultValue=xe,this.schema=$e}validate(ee){return typeof ee=="undefined"?this.defaultValue:ee}compute(ee,pe,xe){return xe}}function c(K,ee){return typeof K=="undefined"?ee:K==="false"?!1:Boolean(K)}e.boolean=c;class u extends P{constructor(ee,pe,xe,$e=void 0){typeof $e!="undefined"&&($e.type="boolean",$e.default=xe),super(ee,pe,xe,$e)}validate(ee){return c(ee,this.defaultValue)}}class a extends P{constructor(ee,pe,xe,$e,et,ke=void 0){typeof ke!="undefined"&&(ke.type="integer",ke.default=xe,ke.minimum=$e,ke.maximum=et),super(ee,pe,xe,ke),this.minimum=$e,this.maximum=et}static clampedInt(ee,pe,xe,$e){if(typeof ee=="undefined")return pe;let et=parseInt(ee,10);return isNaN(et)?pe:(et=Math.max(xe,et),et=Math.min($e,et),et|0)}validate(ee){return a.clampedInt(ee,this.defaultValue,this.minimum,this.maximum)}}class g extends P{constructor(ee,pe,xe,$e,et){typeof et!="undefined"&&(et.type="number",et.default=xe),super(ee,pe,xe,et),this.validationFn=$e}static clamp(ee,pe,xe){return ee<pe?pe:ee>xe?xe:ee}static float(ee,pe){if(typeof ee=="number")return ee;if(typeof ee=="undefined")return pe;const xe=parseFloat(ee);return isNaN(xe)?pe:xe}validate(ee){return this.validationFn(g.float(ee,this.defaultValue))}}class w extends P{static string(ee,pe){return typeof ee!="string"?pe:ee}constructor(ee,pe,xe,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.default=xe),super(ee,pe,xe,$e)}validate(ee){return w.string(ee,this.defaultValue)}}function _(K,ee,pe){return typeof K!="string"||pe.indexOf(K)===-1?ee:K}e.stringSet=_;class b extends P{constructor(ee,pe,xe,$e,et=void 0){typeof et!="undefined"&&(et.type="string",et.enum=$e,et.default=xe),super(ee,pe,xe,et),this._allowedValues=$e}validate(ee){return _(ee,this.defaultValue,this._allowedValues)}}class d extends A{constructor(ee,pe,xe,$e,et,ke,Ce=void 0){typeof Ce!="undefined"&&(Ce.type="string",Ce.enum=et,Ce.default=$e),super(ee,pe,xe,Ce),this._allowedValues=et,this._convert=ke}validate(ee){return typeof ee!="string"?this.defaultValue:this._allowedValues.indexOf(ee)===-1?this.defaultValue:this._convert(ee)}}function h(K){switch(K){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class v extends A{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",description:p.localize(3,null)})}validate(ee){switch(ee){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ee,pe,xe){return xe===0?ee.accessibilitySupport:xe}}class t extends A{constructor(){const ee={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ee,{"editor.comments.insertSpace":{type:"boolean",default:ee.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ee.ignoreEmptyLines,description:p.localize(5,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const pe=ee;return{insertSpace:c(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(K){K[K.Hidden=0]="Hidden",K[K.Blink=1]="Blink",K[K.Smooth=2]="Smooth",K[K.Phase=3]="Phase",K[K.Expand=4]="Expand",K[K.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(K){switch(K){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var n;(function(K){K[K.Line=1]="Line",K[K.Block=2]="Block",K[K.Underline=3]="Underline",K[K.LineThin=4]="LineThin",K[K.BlockOutline=5]="BlockOutline",K[K.UnderlineThin=6]="UnderlineThin"})(n=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function l(K){switch(K){case n.Line:return"line";case n.Block:return"block";case n.Underline:return"underline";case n.LineThin:return"line-thin";case n.BlockOutline:return"block-outline";case n.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=l;function f(K){switch(K){case"line":return n.Line;case"block":return n.Block;case"underline":return n.Underline;case"line-thin":return n.LineThin;case"block-outline":return n.BlockOutline;case"underline-thin":return n.UnderlineThin}}class m extends i{constructor(){super(125,[63,31])}compute(ee,pe,xe){const $e=["monaco-editor"];return pe.get(31)&&$e.push(pe.get(31)),ee.extraEditorClassName&&$e.push(ee.extraEditorClassName),pe.get(63)==="default"?$e.push("mouse-default"):pe.get(63)==="copy"&&$e.push("mouse-copy"),pe.get(98)&&$e.push("showUnused"),pe.get(123)&&$e.push("showDeprecated"),$e.join(" ")}}class E extends u{constructor(){super(30,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(ee,pe,xe){return xe&&ee.emptySelectionClipboard}}class S extends A{constructor(){const ee={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ee,{"editor.find.cursorMoveOnType":{type:"boolean",default:ee.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ee.seedSearchStringFromSelection,description:p.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ee.autoFindInSelection,enumDescriptions:[p.localize(9,null),p.localize(10,null),p.localize(11,null)],description:p.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ee.globalFindClipboard,description:p.localize(13,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ee.addExtraSpaceOnTop,description:p.localize(14,null)},"editor.find.loop":{type:"boolean",default:ee.loop,description:p.localize(15,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const pe=ee;return{cursorMoveOnType:c(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:c(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ee.autoFindInSelection=="boolean"?ee.autoFindInSelection?"always":"never":_(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(pe.loop,this.defaultValue.loop)}}}class o extends A{constructor(){super(41,"fontLigatures",o.OFF,{anyOf:[{type:"boolean",description:p.localize(16,null)},{type:"string",description:p.localize(17,null)}],description:p.localize(18,null),default:!1})}validate(ee){return typeof ee=="undefined"?this.defaultValue:typeof ee=="string"?ee==="false"?o.OFF:ee==="true"?o.ON:ee:Boolean(ee)?o.ON:o.OFF}}e.EditorFontLigatures=o,o.OFF='"liga" off, "calt" off',o.ON='"liga" on, "calt" on';class k extends i{constructor(){super(40)}compute(ee,pe,xe){return ee.fontInfo}}class O extends P{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(19,null)})}validate(ee){let pe=g.float(ee,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(pe,6,100)}compute(ee,pe,xe){return ee.fontInfo.fontSize}}class $ extends A{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:$.MINIMUM_VALUE,maximum:$.MAXIMUM_VALUE,errorMessage:p.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:$.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(21,null)})}validate(ee){return ee==="normal"||ee==="bold"?ee:String(a.clampedInt(ee,e.EDITOR_FONT_DEFAULTS.fontWeight,$.MINIMUM_VALUE,$.MAXIMUM_VALUE))}}$.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],$.MINIMUM_VALUE=1,$.MAXIMUM_VALUE=1e3;class G extends A{constructor(){const ee={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:ee.multiple,enumDescriptions:[p.localize(22,null),p.localize(23,null),p.localize(24,null)]},xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",ee,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(25,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(26,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(27,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:p.localize(28,null),...pe},"editor.gotoLocation.multipleImplementations":{description:p.localize(29,null),...pe},"editor.gotoLocation.multipleReferences":{description:p.localize(30,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ee.alternativeDefinitionCommand,enum:xe,description:p.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ee.alternativeTypeDefinitionCommand,enum:xe,description:p.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ee.alternativeDeclarationCommand,enum:xe,description:p.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ee.alternativeImplementationCommand,enum:xe,description:p.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ee.alternativeReferenceCommand,enum:xe,description:p.localize(35,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const pe=ee;return{multiple:_(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??_(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??_(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??_(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??_(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??_(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:w.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:w.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:w.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:w.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:w.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class re extends A{constructor(){const ee={enabled:!0,delay:300,sticky:!0};super(50,"hover",ee,{"editor.hover.enabled":{type:"boolean",default:ee.enabled,description:p.localize(36,null)},"editor.hover.delay":{type:"number",default:ee.delay,description:p.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ee.sticky,description:p.localize(38,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const pe=ee;return{enabled:c(pe.enabled,this.defaultValue.enabled),delay:a.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:c(pe.sticky,this.defaultValue.sticky)}}}var j;(function(K){K[K.None=0]="None",K[K.Text=1]="Text",K[K.Blocks=2]="Blocks"})(j=e.RenderMinimap||(e.RenderMinimap={}));class N extends i{constructor(){super(128,[46,55,35,62,90,57,58,92,115,118,119,120,2])}compute(ee,pe,xe){return N.computeLayout(pe,{memory:ee.memory,outerWidth:ee.outerWidth,outerHeight:ee.outerHeight,isDominatedByLongLines:ee.isDominatedByLongLines,lineHeight:ee.fontInfo.lineHeight,viewLineCount:ee.viewLineCount,lineNumbersDigitCount:ee.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ee.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ee.fontInfo.maxDigitWidth,pixelRatio:ee.pixelRatio})}static computeContainedMinimapLineCount(ee){const pe=ee.height/ee.lineHeight,xe=ee.scrollBeyondLastLine?pe-1:0,$e=(ee.viewLineCount+xe)/(ee.pixelRatio*ee.height),et=Math.floor(ee.viewLineCount/$e);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:xe,desiredRatio:$e,minimapLineCount:et}}static _computeMinimapLayout(ee,pe){const xe=ee.outerWidth,$e=ee.outerHeight,et=ee.pixelRatio;if(!ee.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(et*$e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:$e};const ke=pe.stableMinimapLayoutInput,Ce=ke&&ee.outerHeight===ke.outerHeight&&ee.lineHeight===ke.lineHeight&&ee.typicalHalfwidthCharacterWidth===ke.typicalHalfwidthCharacterWidth&&ee.pixelRatio===ke.pixelRatio&&ee.scrollBeyondLastLine===ke.scrollBeyondLastLine&&ee.minimap.enabled===ke.minimap.enabled&&ee.minimap.side===ke.minimap.side&&ee.minimap.size===ke.minimap.size&&ee.minimap.showSlider===ke.minimap.showSlider&&ee.minimap.renderCharacters===ke.minimap.renderCharacters&&ee.minimap.maxColumn===ke.minimap.maxColumn&&ee.minimap.scale===ke.minimap.scale&&ee.verticalScrollbarWidth===ke.verticalScrollbarWidth&&ee.isViewportWrapping===ke.isViewportWrapping,Re=ee.lineHeight,se=ee.typicalHalfwidthCharacterWidth,le=ee.scrollBeyondLastLine,me=ee.minimap.renderCharacters;let be=et>=2?Math.round(ee.minimap.scale*2):ee.minimap.scale;const q=ee.minimap.maxColumn,ge=ee.minimap.size,ye=ee.minimap.side,Te=ee.verticalScrollbarWidth,Oe=ee.viewLineCount,Ge=ee.remainingWidth,Ze=ee.isViewportWrapping,Qe=me?2:3;let Xe=Math.floor(et*$e);const at=Xe/et;let ut=!1,bt=!1,ve=Qe*be,De=be/et,ce=1;if(ge==="fill"||ge==="fit"){const{typicalViewportLineCount:ht,extraLinesBeyondLastLine:yt,desiredRatio:Ct,minimapLineCount:Et}=N.computeContainedMinimapLineCount({viewLineCount:Oe,scrollBeyondLastLine:le,height:$e,lineHeight:Re,pixelRatio:et});if(Oe/Et>1)ut=!0,bt=!0,be=1,ve=1,De=be/et;else{let _t=!1,dt=be+1;if(ge==="fit"){const wt=Math.ceil((Oe+yt)*ve);Ze&&Ce&&Ge<=pe.stableFitRemainingWidth?(_t=!0,dt=pe.stableFitMaxMinimapScale):_t=wt>Xe}if(ge==="fill"||_t){ut=!0;const wt=be;ve=Math.min(Re*et,Math.max(1,Math.floor(1/Ct))),Ze&&Ce&&Ge<=pe.stableFitRemainingWidth&&(dt=pe.stableFitMaxMinimapScale),be=Math.min(dt,Math.max(1,Math.floor(ve/Qe))),be>wt&&(ce=Math.min(2,be/wt)),De=be/et/ce,Xe=Math.ceil(Math.max(ht,Oe+yt)*ve),Ze?(pe.stableMinimapLayoutInput=ee,pe.stableFitRemainingWidth=Ge,pe.stableFitMaxMinimapScale=be):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const Y=Math.floor(q*De),Se=Math.min(Y,Math.max(0,Math.floor((Ge-Te-2)*De/(se+De)))+e.MINIMAP_GUTTER_WIDTH);let ze=Math.floor(et*Se);const Je=ze/et;ze=Math.floor(ze*ce);const Ke=me?1:2,lt=ye==="left"?0:xe-Se-Te;return{renderMinimap:Ke,minimapLeft:lt,minimapWidth:Se,minimapHeightIsEditorHeight:ut,minimapIsSampling:bt,minimapScale:be,minimapLineHeight:ve,minimapCanvasInnerWidth:ze,minimapCanvasInnerHeight:Xe,minimapCanvasOuterWidth:Je,minimapCanvasOuterHeight:at}}static computeLayout(ee,pe){const xe=pe.outerWidth|0,$e=pe.outerHeight|0,et=pe.lineHeight|0,ke=pe.lineNumbersDigitCount|0,Ce=pe.typicalHalfwidthCharacterWidth,Re=pe.maxDigitWidth,se=pe.pixelRatio,le=pe.viewLineCount,me=ee.get(120),be=me==="inherit"?ee.get(119):me,q=be==="inherit"?ee.get(115):be,ge=ee.get(118),ye=ee.get(2),Te=pe.isDominatedByLongLines,Oe=ee.get(46),Ge=ee.get(57).renderType!==0,Ze=ee.get(58),Qe=ee.get(92),Xe=ee.get(62),at=ee.get(90),ut=at.verticalScrollbarSize,bt=at.verticalHasArrows,ve=at.arrowSize,De=at.horizontalScrollbarSize,ce=ee.get(55),Y=ee.get(35);let Se;if(typeof ce=="string"&&/^\d+(\.\d+)?ch$/.test(ce)){const Pt=parseFloat(ce.substr(0,ce.length-2));Se=a.clampedInt(Pt*Ce,0,0,1e3)}else Se=a.clampedInt(ce,0,0,1e3);Y&&(Se+=16);let ze=0;if(Ge){const Pt=Math.max(ke,Ze);ze=Math.round(Pt*Re)}let Je=0;Oe&&(Je=et);let Ke=0,lt=Ke+Je,ht=lt+ze,yt=ht+Se;const Ct=xe-Je-ze-Se;let Et=!1,vt=!1,_t=-1;ye!==2&&(be==="inherit"&&Te?(Et=!0,vt=!0):q==="on"||q==="bounded"?vt=!0:q==="wordWrapColumn"&&(_t=ge));const dt=N._computeMinimapLayout({outerWidth:xe,outerHeight:$e,lineHeight:et,typicalHalfwidthCharacterWidth:Ce,pixelRatio:se,scrollBeyondLastLine:Qe,minimap:Xe,verticalScrollbarWidth:ut,viewLineCount:le,remainingWidth:Ct,isViewportWrapping:vt},pe.memory||new D);dt.renderMinimap!==0&&dt.minimapLeft===0&&(Ke+=dt.minimapWidth,lt+=dt.minimapWidth,ht+=dt.minimapWidth,yt+=dt.minimapWidth);const wt=Ct-dt.minimapWidth,ft=Math.max(1,Math.floor((wt-ut-2)/Ce)),Nt=bt?ve:0;return vt&&(_t=Math.max(1,ft),q==="bounded"&&(_t=Math.min(_t,ge))),{width:xe,height:$e,glyphMarginLeft:Ke,glyphMarginWidth:Je,lineNumbersLeft:lt,lineNumbersWidth:ze,decorationsLeft:ht,decorationsWidth:Se,contentLeft:yt,contentWidth:wt,minimap:dt,viewportColumn:ft,isWordWrapMinified:Et,isViewportWrapping:vt,wrappingColumn:_t,verticalScrollbarWidth:ut,horizontalScrollbarHeight:De,overviewRuler:{top:Nt,width:ut,height:$e-2*Nt,right:0}}}}e.EditorLayoutInfoComputer=N;class x extends A{constructor(){const ee={enabled:!0};super(54,"lightbulb",ee,{"editor.lightbulb.enabled":{type:"boolean",default:ee.enabled,description:p.localize(39,null)}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{enabled:c(ee.enabled,this.defaultValue.enabled)}}}class R extends A{constructor(){const ee={enabled:!0,fontSize:0,fontFamily:""};super(124,"inlayHints",ee,{"editor.inlayHints.enabled":{type:"boolean",default:ee.enabled,description:p.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:ee.fontSize,markdownDescription:p.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:ee.fontFamily,description:p.localize(42,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const pe=ee;return{enabled:c(pe.enabled,this.defaultValue.enabled),fontSize:a.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:w.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class V extends g{constructor(){super(56,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ee=>g.clamp(ee,0,150),{markdownDescription:p.localize(43,null)})}compute(ee,pe,xe){return ee.fontInfo.lineHeight}}class F extends A{constructor(){const ee={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(62,"minimap",ee,{"editor.minimap.enabled":{type:"boolean",default:ee.enabled,description:p.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(45,null),p.localize(46,null),p.localize(47,null)],default:ee.size,description:p.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ee.side,description:p.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ee.showSlider,description:p.localize(50,null)},"editor.minimap.scale":{type:"number",default:ee.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ee.renderCharacters,description:p.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ee.maxColumn,description:p.localize(53,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const pe=ee;return{enabled:c(pe.enabled,this.defaultValue.enabled),size:_(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:_(pe.side,this.defaultValue.side,["right","left"]),showSlider:_(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(pe.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(pe.scale,1,1,3),maxColumn:a.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function M(K){return K==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class B extends A{constructor(){super(72,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(55,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const pe=ee;return{top:a.clampedInt(pe.top,0,0,1e3),bottom:a.clampedInt(pe.bottom,0,0,1e3)}}}class W extends A{constructor(){const ee={enabled:!0,cycle:!1};super(73,"parameterHints",ee,{"editor.parameterHints.enabled":{type:"boolean",default:ee.enabled,description:p.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ee.cycle,description:p.localize(57,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const pe=ee;return{enabled:c(pe.enabled,this.defaultValue.enabled),cycle:c(pe.cycle,this.defaultValue.cycle)}}}class Q extends i{constructor(){super(126)}compute(ee,pe,xe){return ee.pixelRatio}}class ae extends A{constructor(){const ee={other:!0,comments:!1,strings:!1};super(76,"quickSuggestions",ee,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ee.strings,description:p.localize(58,null)},comments:{type:"boolean",default:ee.comments,description:p.localize(59,null)},other:{type:"boolean",default:ee.other,description:p.localize(60,null)}}}],default:ee,description:p.localize(61,null)});this.defaultValue=ee}validate(ee){if(typeof ee=="boolean")return ee;if(ee&&typeof ee=="object"){const pe=ee,xe={other:c(pe.other,this.defaultValue.other),comments:c(pe.comments,this.defaultValue.comments),strings:c(pe.strings,this.defaultValue.strings)};return xe.other&&xe.comments&&xe.strings?!0:!xe.other&&!xe.comments&&!xe.strings?!1:xe}return this.defaultValue}}var _e;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval",K[K.Custom=4]="Custom"})(_e=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Fe extends A{constructor(){super(57,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(62,null),p.localize(63,null),p.localize(64,null),p.localize(65,null)],default:"on",description:p.localize(66,null)})}validate(ee){let pe=this.defaultValue.renderType,xe=this.defaultValue.renderFn;return typeof ee!="undefined"&&(typeof ee=="function"?(pe=4,xe=ee):ee==="interval"?pe=3:ee==="relative"?pe=2:ee==="on"?pe=1:pe=0),{renderType:pe,renderFn:xe}}}function Ae(K){const ee=K.get(85);return ee==="editable"?K.get(78):ee!=="on"}e.filterValidationDecorations=Ae;class Me extends A{constructor(){const ee=[],pe={type:"number",description:p.localize(67,null)};super(89,"rulers",ee,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:p.localize(68,null),format:"color-hex"}}}]},default:ee,description:p.localize(69,null)})}validate(ee){if(Array.isArray(ee)){let pe=[];for(let xe of ee)if(typeof xe=="number")pe.push({column:a.clampedInt(xe,0,0,1e4),color:null});else if(xe&&typeof xe=="object"){const $e=xe;pe.push({column:a.clampedInt($e.column,0,0,1e4),color:$e.color})}return pe.sort((xe,$e)=>xe.column-$e.column),pe}return this.defaultValue}}function Ve(K,ee){if(typeof K!="string")return ee;switch(K){case"hidden":return 2;case"visible":return 3;default:return 1}}class He extends A{constructor(){const ee={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(90,"scrollbar",ee,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(70,null),p.localize(71,null),p.localize(72,null)],default:"auto",description:p.localize(73,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(74,null),p.localize(75,null),p.localize(76,null)],default:"auto",description:p.localize(77,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ee.verticalScrollbarSize,description:p.localize(78,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ee.horizontalScrollbarSize,description:p.localize(79,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ee.scrollByPage,description:p.localize(80,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const pe=ee,xe=a.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),$e=a.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ve(pe.vertical,this.defaultValue.vertical),horizontal:Ve(pe.horizontal,this.defaultValue.horizontal),useShadows:c(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:xe,horizontalSliderSize:a.clampedInt(pe.horizontalSliderSize,xe,0,1e3),verticalScrollbarSize:$e,verticalSliderSize:a.clampedInt(pe.verticalSliderSize,$e,0,1e3),scrollByPage:c(pe.scrollByPage,this.defaultValue.scrollByPage)}}}class z extends A{constructor(){const ee={enabled:!1,mode:"subwordSmart"};super(52,"inlineSuggest",ee,{"editor.inlineSuggest.enabled":{type:"boolean",default:ee.enabled,description:p.localize(81,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[p.localize(82,null),p.localize(83,null),p.localize(84,null)],default:ee.mode,description:p.localize(85,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const pe=ee;return{enabled:c(pe.enabled,this.defaultValue.enabled),mode:_(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class J extends A{constructor(){const ee={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(104,"suggest",ee,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(86,null),p.localize(87,null)],default:ee.insertMode,description:p.localize(88,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ee.filterGraceful,description:p.localize(89,null)},"editor.suggest.localityBonus":{type:"boolean",default:ee.localityBonus,description:p.localize(90,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ee.shareSuggestSelections,markdownDescription:p.localize(91,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ee.snippetsPreventQuickSuggestions,description:p.localize(92,null)},"editor.suggest.showIcons":{type:"boolean",default:ee.showIcons,description:p.localize(93,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ee.showStatusBar,description:p.localize(94,null)},"editor.suggest.preview":{type:"boolean",default:ee.preview,description:p.localize(95,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[p.localize(96,null),p.localize(97,null),p.localize(98,null)],default:ee.previewMode,description:p.localize(99,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ee.showInlineDetails,description:p.localize(100,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(101,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(102,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(103,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(104,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(105,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(106,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(107,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(108,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(109,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(110,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(111,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(112,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(113,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(114,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(115,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(116,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(117,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(118,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(119,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(120,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(121,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(122,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(123,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(124,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(125,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(126,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(127,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(128,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(129,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(130,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(131,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const pe=ee;return{insertMode:_(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:c(pe.showIcons,this.defaultValue.showIcons),showStatusBar:c(pe.showStatusBar,this.defaultValue.showStatusBar),preview:c(pe.preview,this.defaultValue.preview),previewMode:_(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:c(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(pe.showMethods,this.defaultValue.showMethods),showFunctions:c(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:c(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:c(pe.showDeprecated,this.defaultValue.showDeprecated),showFields:c(pe.showFields,this.defaultValue.showFields),showVariables:c(pe.showVariables,this.defaultValue.showVariables),showClasses:c(pe.showClasses,this.defaultValue.showClasses),showStructs:c(pe.showStructs,this.defaultValue.showStructs),showInterfaces:c(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:c(pe.showModules,this.defaultValue.showModules),showProperties:c(pe.showProperties,this.defaultValue.showProperties),showEvents:c(pe.showEvents,this.defaultValue.showEvents),showOperators:c(pe.showOperators,this.defaultValue.showOperators),showUnits:c(pe.showUnits,this.defaultValue.showUnits),showValues:c(pe.showValues,this.defaultValue.showValues),showConstants:c(pe.showConstants,this.defaultValue.showConstants),showEnums:c(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:c(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(pe.showKeywords,this.defaultValue.showKeywords),showWords:c(pe.showWords,this.defaultValue.showWords),showColors:c(pe.showColors,this.defaultValue.showColors),showFiles:c(pe.showFiles,this.defaultValue.showFiles),showReferences:c(pe.showReferences,this.defaultValue.showReferences),showFolders:c(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:c(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(pe.showSnippets,this.defaultValue.showSnippets),showUsers:c(pe.showUsers,this.defaultValue.showUsers),showIssues:c(pe.showIssues,this.defaultValue.showIssues)}}}class ne extends A{constructor(){super(100,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(132,null),default:!0,type:"boolean"}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(ee.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class oe extends i{constructor(){super(127,[78])}compute(ee,pe,xe){return pe.get(78)?!0:ee.tabFocusMode}}var we;(function(K){K[K.None=0]="None",K[K.Same=1]="Same",K[K.Indent=2]="Indent",K[K.DeepIndent=3]="DeepIndent"})(we=e.WrappingIndent||(e.WrappingIndent={}));function Z(K){switch(K){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class de extends i{constructor(){super(129,[128])}compute(ee,pe,xe){const $e=pe.get(128);return{isDominatedByLongLines:ee.isDominatedByLongLines,isWordWrapMinified:$e.isWordWrapMinified,isViewportWrapping:$e.isViewportWrapping,wrappingColumn:$e.wrappingColumn}}}const Ie="Consolas, 'Courier New', monospace",Be="Menlo, Monaco, 'Courier New', monospace",qe="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?Be:L.isLinux?qe:Ie,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function Ee(K){return e.editorOptionsRegistry[K.id]=K,K}var tt;(function(K){K[K.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",K[K.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",K[K.accessibilitySupport=2]="accessibilitySupport",K[K.accessibilityPageSize=3]="accessibilityPageSize",K[K.ariaLabel=4]="ariaLabel",K[K.autoClosingBrackets=5]="autoClosingBrackets",K[K.autoClosingDelete=6]="autoClosingDelete",K[K.autoClosingOvertype=7]="autoClosingOvertype",K[K.autoClosingQuotes=8]="autoClosingQuotes",K[K.autoIndent=9]="autoIndent",K[K.automaticLayout=10]="automaticLayout",K[K.autoSurround=11]="autoSurround",K[K.codeLens=12]="codeLens",K[K.codeLensFontFamily=13]="codeLensFontFamily",K[K.codeLensFontSize=14]="codeLensFontSize",K[K.colorDecorators=15]="colorDecorators",K[K.columnSelection=16]="columnSelection",K[K.comments=17]="comments",K[K.contextmenu=18]="contextmenu",K[K.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",K[K.cursorBlinking=20]="cursorBlinking",K[K.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",K[K.cursorStyle=22]="cursorStyle",K[K.cursorSurroundingLines=23]="cursorSurroundingLines",K[K.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",K[K.cursorWidth=25]="cursorWidth",K[K.disableLayerHinting=26]="disableLayerHinting",K[K.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",K[K.domReadOnly=28]="domReadOnly",K[K.dragAndDrop=29]="dragAndDrop",K[K.emptySelectionClipboard=30]="emptySelectionClipboard",K[K.extraEditorClassName=31]="extraEditorClassName",K[K.fastScrollSensitivity=32]="fastScrollSensitivity",K[K.find=33]="find",K[K.fixedOverflowWidgets=34]="fixedOverflowWidgets",K[K.folding=35]="folding",K[K.foldingStrategy=36]="foldingStrategy",K[K.foldingHighlight=37]="foldingHighlight",K[K.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",K[K.fontFamily=39]="fontFamily",K[K.fontInfo=40]="fontInfo",K[K.fontLigatures=41]="fontLigatures",K[K.fontSize=42]="fontSize",K[K.fontWeight=43]="fontWeight",K[K.formatOnPaste=44]="formatOnPaste",K[K.formatOnType=45]="formatOnType",K[K.glyphMargin=46]="glyphMargin",K[K.gotoLocation=47]="gotoLocation",K[K.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",K[K.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",K[K.hover=50]="hover",K[K.inDiffEditor=51]="inDiffEditor",K[K.inlineSuggest=52]="inlineSuggest",K[K.letterSpacing=53]="letterSpacing",K[K.lightbulb=54]="lightbulb",K[K.lineDecorationsWidth=55]="lineDecorationsWidth",K[K.lineHeight=56]="lineHeight",K[K.lineNumbers=57]="lineNumbers",K[K.lineNumbersMinChars=58]="lineNumbersMinChars",K[K.linkedEditing=59]="linkedEditing",K[K.links=60]="links",K[K.matchBrackets=61]="matchBrackets",K[K.minimap=62]="minimap",K[K.mouseStyle=63]="mouseStyle",K[K.mouseWheelScrollSensitivity=64]="mouseWheelScrollSensitivity",K[K.mouseWheelZoom=65]="mouseWheelZoom",K[K.multiCursorMergeOverlapping=66]="multiCursorMergeOverlapping",K[K.multiCursorModifier=67]="multiCursorModifier",K[K.multiCursorPaste=68]="multiCursorPaste",K[K.occurrencesHighlight=69]="occurrencesHighlight",K[K.overviewRulerBorder=70]="overviewRulerBorder",K[K.overviewRulerLanes=71]="overviewRulerLanes",K[K.padding=72]="padding",K[K.parameterHints=73]="parameterHints",K[K.peekWidgetDefaultFocus=74]="peekWidgetDefaultFocus",K[K.definitionLinkOpensInPeek=75]="definitionLinkOpensInPeek",K[K.quickSuggestions=76]="quickSuggestions",K[K.quickSuggestionsDelay=77]="quickSuggestionsDelay",K[K.readOnly=78]="readOnly",K[K.renameOnType=79]="renameOnType",K[K.renderControlCharacters=80]="renderControlCharacters",K[K.renderIndentGuides=81]="renderIndentGuides",K[K.renderFinalNewline=82]="renderFinalNewline",K[K.renderLineHighlight=83]="renderLineHighlight",K[K.renderLineHighlightOnlyWhenFocus=84]="renderLineHighlightOnlyWhenFocus",K[K.renderValidationDecorations=85]="renderValidationDecorations",K[K.renderWhitespace=86]="renderWhitespace",K[K.revealHorizontalRightPadding=87]="revealHorizontalRightPadding",K[K.roundedSelection=88]="roundedSelection",K[K.rulers=89]="rulers",K[K.scrollbar=90]="scrollbar",K[K.scrollBeyondLastColumn=91]="scrollBeyondLastColumn",K[K.scrollBeyondLastLine=92]="scrollBeyondLastLine",K[K.scrollPredominantAxis=93]="scrollPredominantAxis",K[K.selectionClipboard=94]="selectionClipboard",K[K.selectionHighlight=95]="selectionHighlight",K[K.selectOnLineNumbers=96]="selectOnLineNumbers",K[K.showFoldingControls=97]="showFoldingControls",K[K.showUnused=98]="showUnused",K[K.snippetSuggestions=99]="snippetSuggestions",K[K.smartSelect=100]="smartSelect",K[K.smoothScrolling=101]="smoothScrolling",K[K.stickyTabStops=102]="stickyTabStops",K[K.stopRenderingLineAfter=103]="stopRenderingLineAfter",K[K.suggest=104]="suggest",K[K.suggestFontSize=105]="suggestFontSize",K[K.suggestLineHeight=106]="suggestLineHeight",K[K.suggestOnTriggerCharacters=107]="suggestOnTriggerCharacters",K[K.suggestSelection=108]="suggestSelection",K[K.tabCompletion=109]="tabCompletion",K[K.tabIndex=110]="tabIndex",K[K.unusualLineTerminators=111]="unusualLineTerminators",K[K.useShadowDOM=112]="useShadowDOM",K[K.useTabStops=113]="useTabStops",K[K.wordSeparators=114]="wordSeparators",K[K.wordWrap=115]="wordWrap",K[K.wordWrapBreakAfterCharacters=116]="wordWrapBreakAfterCharacters",K[K.wordWrapBreakBeforeCharacters=117]="wordWrapBreakBeforeCharacters",K[K.wordWrapColumn=118]="wordWrapColumn",K[K.wordWrapOverride1=119]="wordWrapOverride1",K[K.wordWrapOverride2=120]="wordWrapOverride2",K[K.wrappingIndent=121]="wrappingIndent",K[K.wrappingStrategy=122]="wrappingStrategy",K[K.showDeprecated=123]="showDeprecated",K[K.inlayHints=124]="inlayHints",K[K.editorClassName=125]="editorClassName",K[K.pixelRatio=126]="pixelRatio",K[K.tabFocusMode=127]="tabFocusMode",K[K.layoutInfo=128]="layoutInfo",K[K.wrappingInfo=129]="wrappingInfo"})(tt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ee(new u(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(133,null)})),acceptSuggestionOnEnter:Ee(new b(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(134,null),""],markdownDescription:p.localize(135,null)})),accessibilitySupport:Ee(new v),accessibilityPageSize:Ee(new a(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(136,null)})),ariaLabel:Ee(new w(4,"ariaLabel",p.localize(137,null))),autoClosingBrackets:Ee(new b(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(138,null),p.localize(139,null),""],description:p.localize(140,null)})),autoClosingDelete:Ee(new b(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(141,null),""],description:p.localize(142,null)})),autoClosingOvertype:Ee(new b(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(143,null),""],description:p.localize(144,null)})),autoClosingQuotes:Ee(new b(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(145,null),p.localize(146,null),""],description:p.localize(147,null)})),autoIndent:Ee(new d(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],h,{enumDescriptions:[p.localize(148,null),p.localize(149,null),p.localize(150,null),p.localize(151,null),p.localize(152,null)],description:p.localize(153,null)})),automaticLayout:Ee(new u(10,"automaticLayout",!1)),autoSurround:Ee(new b(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(154,null),p.localize(155,null),p.localize(156,null),""],description:p.localize(157,null)})),stickyTabStops:Ee(new u(102,"stickyTabStops",!1,{description:p.localize(158,null)})),codeLens:Ee(new u(12,"codeLens",!0,{description:p.localize(159,null)})),codeLensFontFamily:Ee(new w(13,"codeLensFontFamily","",{description:p.localize(160,null)})),codeLensFontSize:Ee(new a(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(161,null)})),colorDecorators:Ee(new u(15,"colorDecorators",!0,{description:p.localize(162,null)})),columnSelection:Ee(new u(16,"columnSelection",!1,{description:p.localize(163,null)})),comments:Ee(new t),contextmenu:Ee(new u(18,"contextmenu",!0)),copyWithSyntaxHighlighting:Ee(new u(19,"copyWithSyntaxHighlighting",!0,{description:p.localize(164,null)})),cursorBlinking:Ee(new d(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:p.localize(165,null)})),cursorSmoothCaretAnimation:Ee(new u(21,"cursorSmoothCaretAnimation",!1,{description:p.localize(166,null)})),cursorStyle:Ee(new d(22,"cursorStyle",n.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],f,{description:p.localize(167,null)})),cursorSurroundingLines:Ee(new a(23,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(168,null)})),cursorSurroundingLinesStyle:Ee(new b(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(169,null),p.localize(170,null)],description:p.localize(171,null)})),cursorWidth:Ee(new a(25,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(172,null)})),disableLayerHinting:Ee(new u(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ee(new u(27,"disableMonospaceOptimizations",!1)),domReadOnly:Ee(new u(28,"domReadOnly",!1)),dragAndDrop:Ee(new u(29,"dragAndDrop",!0,{description:p.localize(173,null)})),emptySelectionClipboard:Ee(new E),extraEditorClassName:Ee(new w(31,"extraEditorClassName","")),fastScrollSensitivity:Ee(new g(32,"fastScrollSensitivity",5,K=>K<=0?5:K,{markdownDescription:p.localize(174,null)})),find:Ee(new S),fixedOverflowWidgets:Ee(new u(34,"fixedOverflowWidgets",!1)),folding:Ee(new u(35,"folding",!0,{description:p.localize(175,null)})),foldingStrategy:Ee(new b(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(176,null),p.localize(177,null)],description:p.localize(178,null)})),foldingHighlight:Ee(new u(37,"foldingHighlight",!0,{description:p.localize(179,null)})),unfoldOnClickAfterEndOfLine:Ee(new u(38,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(180,null)})),fontFamily:Ee(new w(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(181,null)})),fontInfo:Ee(new k),fontLigatures2:Ee(new o),fontSize:Ee(new O),fontWeight:Ee(new $),formatOnPaste:Ee(new u(44,"formatOnPaste",!1,{description:p.localize(182,null)})),formatOnType:Ee(new u(45,"formatOnType",!1,{description:p.localize(183,null)})),glyphMargin:Ee(new u(46,"glyphMargin",!0,{description:p.localize(184,null)})),gotoLocation:Ee(new G),hideCursorInOverviewRuler:Ee(new u(48,"hideCursorInOverviewRuler",!1,{description:p.localize(185,null)})),highlightActiveIndentGuide:Ee(new u(49,"highlightActiveIndentGuide",!0,{description:p.localize(186,null)})),hover:Ee(new re),inDiffEditor:Ee(new u(51,"inDiffEditor",!1)),letterSpacing:Ee(new g(53,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,K=>g.clamp(K,-5,20),{description:p.localize(187,null)})),lightbulb:Ee(new x),lineDecorationsWidth:Ee(new P(55,"lineDecorationsWidth",10)),lineHeight:Ee(new V),lineNumbers:Ee(new Fe),lineNumbersMinChars:Ee(new a(58,"lineNumbersMinChars",5,1,300)),linkedEditing:Ee(new u(59,"linkedEditing",!1,{description:p.localize(188,null)})),links:Ee(new u(60,"links",!0,{description:p.localize(189,null)})),matchBrackets:Ee(new b(61,"matchBrackets","always",["always","near","never"],{description:p.localize(190,null)})),minimap:Ee(new F),mouseStyle:Ee(new b(63,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ee(new g(64,"mouseWheelScrollSensitivity",1,K=>K===0?1:K,{markdownDescription:p.localize(191,null)})),mouseWheelZoom:Ee(new u(65,"mouseWheelZoom",!1,{markdownDescription:p.localize(192,null)})),multiCursorMergeOverlapping:Ee(new u(66,"multiCursorMergeOverlapping",!0,{description:p.localize(193,null)})),multiCursorModifier:Ee(new d(67,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],M,{markdownEnumDescriptions:[p.localize(194,null),p.localize(195,null)],markdownDescription:p.localize(196,null)})),multiCursorPaste:Ee(new b(68,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(197,null),p.localize(198,null)],markdownDescription:p.localize(199,null)})),occurrencesHighlight:Ee(new u(69,"occurrencesHighlight",!0,{description:p.localize(200,null)})),overviewRulerBorder:Ee(new u(70,"overviewRulerBorder",!0,{description:p.localize(201,null)})),overviewRulerLanes:Ee(new a(71,"overviewRulerLanes",3,0,3)),padding:Ee(new B),parameterHints:Ee(new W),peekWidgetDefaultFocus:Ee(new b(74,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(202,null),p.localize(203,null)],description:p.localize(204,null)})),definitionLinkOpensInPeek:Ee(new u(75,"definitionLinkOpensInPeek",!1,{description:p.localize(205,null)})),quickSuggestions:Ee(new ae),quickSuggestionsDelay:Ee(new a(77,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(206,null)})),readOnly:Ee(new u(78,"readOnly",!1)),renameOnType:Ee(new u(79,"renameOnType",!1,{description:p.localize(207,null),markdownDeprecationMessage:p.localize(208,null)})),renderControlCharacters:Ee(new u(80,"renderControlCharacters",!1,{description:p.localize(209,null)})),renderIndentGuides:Ee(new u(81,"renderIndentGuides",!0,{description:p.localize(210,null)})),renderFinalNewline:Ee(new u(82,"renderFinalNewline",!0,{description:p.localize(211,null)})),renderLineHighlight:Ee(new b(83,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(212,null)],description:p.localize(213,null)})),renderLineHighlightOnlyWhenFocus:Ee(new u(84,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(214,null)})),renderValidationDecorations:Ee(new b(85,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ee(new b(86,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(215,null),p.localize(216,null),p.localize(217,null),""],description:p.localize(218,null)})),revealHorizontalRightPadding:Ee(new a(87,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ee(new u(88,"roundedSelection",!0,{description:p.localize(219,null)})),rulers:Ee(new Me),scrollbar:Ee(new He),scrollBeyondLastColumn:Ee(new a(91,"scrollBeyondLastColumn",5,0,1073741824,{description:p.localize(220,null)})),scrollBeyondLastLine:Ee(new u(92,"scrollBeyondLastLine",!0,{description:p.localize(221,null)})),scrollPredominantAxis:Ee(new u(93,"scrollPredominantAxis",!0,{description:p.localize(222,null)})),selectionClipboard:Ee(new u(94,"selectionClipboard",!0,{description:p.localize(223,null),included:L.isLinux})),selectionHighlight:Ee(new u(95,"selectionHighlight",!0,{description:p.localize(224,null)})),selectOnLineNumbers:Ee(new u(96,"selectOnLineNumbers",!0)),showFoldingControls:Ee(new b(97,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[p.localize(225,null),p.localize(226,null)],description:p.localize(227,null)})),showUnused:Ee(new u(98,"showUnused",!0,{description:p.localize(228,null)})),showDeprecated:Ee(new u(123,"showDeprecated",!0,{description:p.localize(229,null)})),inlayHints:Ee(new R),snippetSuggestions:Ee(new b(99,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(230,null),p.localize(231,null),p.localize(232,null),p.localize(233,null)],description:p.localize(234,null)})),smartSelect:Ee(new ne),smoothScrolling:Ee(new u(101,"smoothScrolling",!1,{description:p.localize(235,null)})),stopRenderingLineAfter:Ee(new a(103,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ee(new J),inlineSuggest:Ee(new z),suggestFontSize:Ee(new a(105,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(236,null)})),suggestLineHeight:Ee(new a(106,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(237,null)})),suggestOnTriggerCharacters:Ee(new u(107,"suggestOnTriggerCharacters",!0,{description:p.localize(238,null)})),suggestSelection:Ee(new b(108,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(239,null),p.localize(240,null),p.localize(241,null)],description:p.localize(242,null)})),tabCompletion:Ee(new b(109,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(243,null),p.localize(244,null),p.localize(245,null)],description:p.localize(246,null)})),tabIndex:Ee(new a(110,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Ee(new b(111,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(247,null),p.localize(248,null),p.localize(249,null)],description:p.localize(250,null)})),useShadowDOM:Ee(new u(112,"useShadowDOM",!0)),useTabStops:Ee(new u(113,"useTabStops",!0,{description:p.localize(251,null)})),wordSeparators:Ee(new w(114,"wordSeparators",C.USUAL_WORD_SEPARATORS,{description:p.localize(252,null)})),wordWrap:Ee(new b(115,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(253,null),p.localize(254,null),p.localize(255,null),p.localize(256,null)],description:p.localize(257,null)})),wordWrapBreakAfterCharacters:Ee(new w(116,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ee(new w(117,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ee(new a(118,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(258,null)})),wordWrapOverride1:Ee(new b(119,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ee(new b(120,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ee(new d(121,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Z,{enumDescriptions:[p.localize(259,null),p.localize(260,null),p.localize(261,null),p.localize(262,null)],description:p.localize(263,null)})),wrappingStrategy:Ee(new b(122,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[p.localize(264,null),p.localize(265,null)],description:p.localize(266,null)})),editorClassName:Ee(new m),pixelRatio:Ee(new Q),tabFocusMode:Ee(new oe),layoutInfo:Ee(new N),wrappingInfo:Ee(new de)}}),define(he[152],fe([19,20]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(he[153],fe([19,20]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(he[154],fe([19,20]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(he[155],fe([19,20]),function(X,e){return X.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(he[156],fe([19,20]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(he[157],fe([19,20]),function(X,e){return X.create("vs/platform/markers/common/markers",e)}),define(he[158],fe([19,20]),function(X,e){return X.create("vs/platform/workspaces/common/workspaces",e)}),define(he[159],fe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(he[160],fe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostExtensionService",e)}),define(he[161],fe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostProgress",e)}),define(he[162],fe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostStatusBar",e)}),define(he[163],fe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostTerminalService",e)}),define(he[164],fe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostTreeViews",e)}),define(he[165],fe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostWorkspace",e)}),define(he[166],fe([19,20]),function(X,e){return X.create("vs/workbench/api/node/extHostDebugService",e)}),define(he[167],fe([19,20]),function(X,e){return X.create("vs/workbench/common/editor",e)}),define(he[168],fe([19,20]),function(X,e){return X.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(he[169],fe([19,20]),function(X,e){return X.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(he[170],fe([19,20]),function(X,e){return X.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(he[171],fe([19,20]),function(X,e){return X.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(he[172],fe([19,20]),function(X,e){return X.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(he[173],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var p;(function(T){T[T.ACTIVATE=1]="ACTIVATE",T[T.RESTORE=2]="RESTORE",T[T.PRESERVE=3]="PRESERVE"})(p=e.EditorActivation||(e.EditorActivation={}));var L;(function(T){T[T.PICK=0]="PICK",T[T.DISABLED=1]="DISABLED",T[T.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(L=e.EditorResolution||(e.EditorResolution={}));var C;(function(T){T[T.API=0]="API",T[T.USER=1]="USER"})(C=e.EditorOpenContext||(e.EditorOpenContext={}));var y;(function(T){T[T.Center=0]="Center",T[T.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",T[T.NearTop=2]="NearTop",T[T.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(y=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(he[174],fe([0,1,154]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function y(c){return c=c.trim(),c==="*"||L.test(c)}e.isValidVersionStr=y;function T(c){if(!y(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let u=c.match(L);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.parseVersion=T;function I(c){if(!c)return null;let u=c.majorBase,a=c.majorMustEqual,g=c.minorBase,w=c.minorMustEqual,_=c.patchBase,b=c.patchMustEqual;c.hasCaret&&(u===0||(w=!1),b=!1);let d=0;if(c.preRelease){const h=C.exec(c.preRelease);if(h){const[,v,t,s]=h;d=Date.UTC(Number(v),Number(t)-1,Number(s))}}return{majorBase:u,majorMustEqual:a,minorBase:g,minorMustEqual:w,patchBase:_,patchMustEqual:b,isMinimum:c.hasGreaterEquals,notBefore:d}}e.normalizeVersion=I;function D(c,u,a){let g;typeof c=="string"?g=I(T(c)):g=c;let w;u instanceof Date?w=u.getTime():typeof u=="string"&&(w=new Date(u).getTime());let _;if(typeof a=="string"?_=I(T(a)):_=a,!g||!_)return!1;let b=g.majorBase,d=g.minorBase,h=g.patchBase,v=_.majorBase,t=_.minorBase,s=_.patchBase,r=_.notBefore,n=_.majorMustEqual,l=_.minorMustEqual,f=_.patchMustEqual;return _.isMinimum?b>v?!0:b<v?!1:d>t?!0:d<t||w&&w<r?!1:h>=s:(b===1&&v===0&&(!n||!l||!f)&&(v=1,t=0,s=0,n=!0,l=!1,f=!1),b<v?!1:b>v?!n:d<t?!1:d>t?!l:h<s?!1:h>s?!f:!(w&&w<r))}e.isValidVersion=D;function A(c,u,a,g){return a.isBuiltin||typeof a.main=="undefined"?!0:P(c,u,a.engines.vscode,g)}e.isValidExtensionVersion=A;function i(c,u,a){return c==="*"||P(u,a,c)}e.isEngineValid=i;function P(c,u,a,g=[]){let w=I(T(a));if(!w)return g.push(p.localize(0,null,a)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return g.push(p.localize(1,null,a)),!1}else if(!w.majorMustEqual)return g.push(p.localize(2,null,a)),!1;return D(c,u,w)?!0:(g.push(p.localize(3,null,c,a)),!1)}}),define(he[113],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class p{constructor(C,y=[],T=!1){this.ctor=C,this.staticArguments=y,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=p}),define(he[78],fe([0,1,113]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function C(T,I,D){I instanceof p.SyncDescriptor||(I=new p.SyncDescriptor(I,[],D)),L.push([T,I])}e.registerSingleton=C;function y(){return L}e.getSingletonServiceDescriptors=y}),define(he[175],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(y){this.incoming=new Map,this.outgoing=new Map,this.data=y}}e.Node=p;class L{constructor(y){this._hashFn=y,this._nodes=new Map}roots(){const y=[];for(let T of this._nodes.values())T.outgoing.size===0&&y.push(T);return y}insertEdge(y,T){const I=this.lookupOrInsertNode(y),D=this.lookupOrInsertNode(T);I.outgoing.set(this._hashFn(T),D),D.incoming.set(this._hashFn(y),I)}removeNode(y){const T=this._hashFn(y);this._nodes.delete(T);for(let I of this._nodes.values())I.outgoing.delete(T),I.incoming.delete(T)}lookupOrInsertNode(y){const T=this._hashFn(y);let I=this._nodes.get(T);return I||(I=new p(y),this._nodes.set(T,I)),I}lookup(y){return this._nodes.get(this._hashFn(y))}isEmpty(){return this._nodes.size===0}toString(){let y=[];for(let[T,I]of this._nodes)y.push(`${T}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return y.join(`
`)}findCycleSlow(){for(let[y,T]of this._nodes){const I=new Set([y]),D=this._findCycle(T,I);if(D)return D}}_findCycle(y,T){for(let[I,D]of y.outgoing){if(T.has(I))return[...T,I].join(" -> ");T.add(I);const A=this._findCycle(D,T);if(A)return A;T.delete(I)}}}e.Graph=L}),define(he[4],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function D(A){return A[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=D})(p=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function L(I,D,A,i){D[p.DI_TARGET]===D?D[p.DI_DEPENDENCIES].push({id:I,index:A,optional:i}):(D[p.DI_DEPENDENCIES]=[{id:I,index:A,optional:i}],D[p.DI_TARGET]=D)}function C(I){if(p.serviceIds.has(I))return p.serviceIds.get(I);const D=function(A,i,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(D,A,P,!1)};return D.toString=()=>I,p.serviceIds.set(I,D),D}e.createDecorator=C;function y(I){return I}e.refineServiceDecorator=y;function T(I){return function(D,A,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(I,D,i,!0)}}e.optional=T}),define(he[176],fe([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,p.createDecorator)("modelService");function L(C){return!C.isTooLargeForSyncing()&&!C.isForSimpleWidget}e.shouldSynchronizeModel=L}),define(he[177],fe([0,1,3,55,6,23,73,77,176]),function(X,e,p,L,C,y,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function A(c){return typeof c=="string"?!1:Array.isArray(c)?c.every(A):!!c.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new p.Emitter}get onDidChange(){return this._onDidChange.event}register(u,a){let g={selector:u,provider:a,_score:-1,_time:this._clock++};return this._entries.push(g),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,C.toDisposable)(()=>{if(g){let w=this._entries.indexOf(g);w>=0&&(this._entries.splice(w,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),g=void 0)}})}has(u){return this.all(u).length>0}all(u){if(!u)return[];this._updateScores(u);const a=[];for(let g of this._entries)g._score>0&&a.push(g.provider);return a}ordered(u){const a=[];return this._orderedForEach(u,g=>a.push(g.provider)),a}orderedGroups(u){const a=[];let g,w;return this._orderedForEach(u,_=>{g&&w===_._score?g.push(_.provider):(w=_._score,g=[_.provider],a.push(g))}),a}_orderedForEach(u,a){if(!!u){this._updateScores(u);for(const g of this._entries)g._score>0&&a(g)}}_updateScores(u){let a={uri:u.uri.toString(),language:u.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===a.language&&this._lastCandidate.uri===a.uri)){this._lastCandidate=a;for(let g of this._entries)if(g._score=(0,I.score)(g.selector,u.uri,u.getLanguageIdentifier().language,(0,D.shouldSynchronizeModel)(u)),A(g.selector)&&g._score>0){for(let w of this._entries)w._score=0;g._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(u,a){return u._score<a._score?1:u._score>a._score?-1:u._time<a._time?1:u._time>a._time?-1:0}}e.LanguageFeatureRegistry=i;class P{constructor(u,a,g=Number.MAX_SAFE_INTEGER){this._registry=u,this.min=a,this.max=g,this._cache=new y.LRUCache(50,.7)}_key(u){return u.id+(0,L.hash)(this._registry.all(u))}_clamp(u){return u===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(u*1.3)))}get(u){const a=this._key(u),g=this._cache.get(a);return this._clamp(g?.value)}update(u,a){const g=this._key(u);let w=this._cache.get(g);return w||(w=new T.MovingAverage,this._cache.set(g,w)),w.update(a),this.get(u)}}e.LanguageFeatureRequestDelays=P}),define(he[79],fe([0,1,2,40,177,145,74]),function(X,e,p,L,C,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var I;(function(o){o[o.Null=0]="Null",o[o.PlainText=1]="PlainText"})(I=e.LanguageId||(e.LanguageId={}));class D{constructor(k,O){this.language=k,this.id=O}}e.LanguageIdentifier=D;var A;(function(o){o[o.NotSet=-1]="NotSet",o[o.None=0]="None",o[o.Italic=1]="Italic",o[o.Bold=2]="Bold",o[o.Underline=4]="Underline"})(A=e.FontStyle||(e.FontStyle={}));var i;(function(o){o[o.None=0]="None",o[o.DefaultForeground=1]="DefaultForeground",o[o.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var P;(function(o){o[o.Other=0]="Other",o[o.Comment=1]="Comment",o[o.String=2]="String",o[o.RegEx=4]="RegEx"})(P=e.StandardTokenType||(e.StandardTokenType={}));var c;(function(o){o[o.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",o[o.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",o[o.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",o[o.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",o[o.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",o[o.ITALIC_MASK=2048]="ITALIC_MASK",o[o.BOLD_MASK=4096]="BOLD_MASK",o[o.UNDERLINE_MASK=8192]="UNDERLINE_MASK",o[o.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",o[o.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",o[o.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",o[o.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",o[o.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",o[o.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",o[o.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",o[o.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",o[o.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",o[o.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(c=e.MetadataConsts||(e.MetadataConsts={}));class u{static getLanguageId(k){return(k&255)>>>0}static getTokenType(k){return(k&1792)>>>8}static getFontStyle(k){return(k&14336)>>>11}static getForeground(k){return(k&8372224)>>>14}static getBackground(k){return(k&4286578688)>>>23}static getClassNameFromMetadata(k){let O=this.getForeground(k),$="mtk"+O,G=this.getFontStyle(k);return G&1&&($+=" mtki"),G&2&&($+=" mtkb"),G&4&&($+=" mtku"),$}static getInlineStyleFromMetadata(k,O){const $=this.getForeground(k),G=this.getFontStyle(k);let re=`color: ${O[$]};`;return G&1&&(re+="font-style: italic;"),G&2&&(re+="font-weight: bold;"),G&4&&(re+="text-decoration: underline;"),re}}e.TokenMetadata=u;var a;(function(o){o[o.Method=0]="Method",o[o.Function=1]="Function",o[o.Constructor=2]="Constructor",o[o.Field=3]="Field",o[o.Variable=4]="Variable",o[o.Class=5]="Class",o[o.Struct=6]="Struct",o[o.Interface=7]="Interface",o[o.Module=8]="Module",o[o.Property=9]="Property",o[o.Event=10]="Event",o[o.Operator=11]="Operator",o[o.Unit=12]="Unit",o[o.Value=13]="Value",o[o.Constant=14]="Constant",o[o.Enum=15]="Enum",o[o.EnumMember=16]="EnumMember",o[o.Keyword=17]="Keyword",o[o.Text=18]="Text",o[o.Color=19]="Color",o[o.File=20]="File",o[o.Reference=21]="Reference",o[o.Customcolor=22]="Customcolor",o[o.Folder=23]="Folder",o[o.TypeParameter=24]="TypeParameter",o[o.User=25]="User",o[o.Issue=26]="Issue",o[o.Snippet=27]="Snippet"})(a=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let o=Object.create(null);return o[0]="symbol-method",o[1]="symbol-function",o[2]="symbol-constructor",o[3]="symbol-field",o[4]="symbol-variable",o[5]="symbol-class",o[6]="symbol-struct",o[7]="symbol-interface",o[8]="symbol-module",o[9]="symbol-property",o[10]="symbol-event",o[11]="symbol-operator",o[12]="symbol-unit",o[13]="symbol-value",o[14]="symbol-constant",o[15]="symbol-enum",o[16]="symbol-enum-member",o[17]="symbol-keyword",o[27]="symbol-snippet",o[18]="symbol-text",o[19]="symbol-color",o[20]="symbol-file",o[21]="symbol-reference",o[22]="symbol-customcolor",o[23]="symbol-folder",o[24]="symbol-type-parameter",o[25]="account",o[26]="issues",function(k){const O=o[k];let $=O&&T.iconRegistry.get(O);return $||(console.info("No codicon found for CompletionItemKind "+k),$=T.Codicon.symbolProperty),$.classNames}}(),e.completionKindFromString=function(){let o=Object.create(null);return o.method=0,o.function=1,o.constructor=2,o.field=3,o.variable=4,o.class=5,o.struct=6,o.interface=7,o.module=8,o.property=9,o.event=10,o.operator=11,o.unit=12,o.value=13,o.constant=14,o.enum=15,o["enum-member"]=16,o.enumMember=16,o.keyword=17,o.snippet=27,o.text=18,o.color=19,o.file=20,o.reference=21,o.customcolor=22,o.folder=23,o["type-parameter"]=24,o.typeParameter=24,o.account=25,o.issue=26,function(k,O){let $=o[k];return typeof $=="undefined"&&!O&&($=9),$}}();var g;(function(o){o[o.Deprecated=1]="Deprecated"})(g=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(o){o[o.KeepWhitespace=1]="KeepWhitespace",o[o.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var _;(function(o){o[o.Invoke=0]="Invoke",o[o.TriggerCharacter=1]="TriggerCharacter",o[o.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(_=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var b;(function(o){o[o.Automatic=0]="Automatic",o[o.Explicit=1]="Explicit"})(b=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var d;(function(o){o[o.Invoke=1]="Invoke",o[o.Auto=2]="Auto"})(d=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var h;(function(o){o[o.Invoke=1]="Invoke",o[o.TriggerCharacter=2]="TriggerCharacter",o[o.ContentChange=3]="ContentChange"})(h=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var v;(function(o){o[o.Text=0]="Text",o[o.Read=1]="Read",o[o.Write=2]="Write"})(v=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(o){return o&&p.URI.isUri(o.uri)&&L.Range.isIRange(o.range)&&(L.Range.isIRange(o.originSelectionRange)||L.Range.isIRange(o.targetSelectionRange))}e.isLocationLink=t;var s;(function(o){o[o.File=0]="File",o[o.Module=1]="Module",o[o.Namespace=2]="Namespace",o[o.Package=3]="Package",o[o.Class=4]="Class",o[o.Method=5]="Method",o[o.Property=6]="Property",o[o.Field=7]="Field",o[o.Constructor=8]="Constructor",o[o.Enum=9]="Enum",o[o.Interface=10]="Interface",o[o.Function=11]="Function",o[o.Variable=12]="Variable",o[o.Constant=13]="Constant",o[o.String=14]="String",o[o.Number=15]="Number",o[o.Boolean=16]="Boolean",o[o.Array=17]="Array",o[o.Object=18]="Object",o[o.Key=19]="Key",o[o.Null=20]="Null",o[o.EnumMember=21]="EnumMember",o[o.Struct=22]="Struct",o[o.Event=23]="Event",o[o.Operator=24]="Operator",o[o.TypeParameter=25]="TypeParameter"})(s=e.SymbolKind||(e.SymbolKind={}));var r;(function(o){o[o.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var n;(function(o){const k=new Map;k.set("file",0),k.set("module",1),k.set("namespace",2),k.set("package",3),k.set("class",4),k.set("method",5),k.set("property",6),k.set("field",7),k.set("constructor",8),k.set("enum",9),k.set("interface",10),k.set("function",11),k.set("variable",12),k.set("constant",13),k.set("string",14),k.set("number",15),k.set("boolean",16),k.set("array",17),k.set("object",18),k.set("key",19),k.set("null",20),k.set("enum-member",21),k.set("struct",22),k.set("event",23),k.set("operator",24),k.set("type-parameter",25);const O=new Map;O.set(0,"file"),O.set(1,"module"),O.set(2,"namespace"),O.set(3,"package"),O.set(4,"class"),O.set(5,"method"),O.set(6,"property"),O.set(7,"field"),O.set(8,"constructor"),O.set(9,"enum"),O.set(10,"interface"),O.set(11,"function"),O.set(12,"variable"),O.set(13,"constant"),O.set(14,"string"),O.set(15,"number"),O.set(16,"boolean"),O.set(17,"array"),O.set(18,"object"),O.set(19,"key"),O.set(20,"null"),O.set(21,"enum-member"),O.set(22,"struct"),O.set(23,"event"),O.set(24,"operator"),O.set(25,"type-parameter");function $(j){return k.get(j)}o.fromString=$;function G(j){return O.get(j)}o.toString=G;function re(j,N){const x=O.get(j);let R=x&&T.iconRegistry.get("symbol-"+x);return R||(console.info("No codicon found for SymbolKind "+j),R=T.Codicon.symbolProperty),`${N?"inline":"block"} ${R.classNames}`}o.toCssClassName=re})(n=e.SymbolKinds||(e.SymbolKinds={}));class l{constructor(k){this.value=k}}e.FoldingRangeKind=l,l.Comment=new l("comment"),l.Imports=new l("imports"),l.Region=new l("region");var f;(function(o){o[o.Collapsed=0]="Collapsed",o[o.Expanded=1]="Expanded"})(f=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var m;(function(o){o[o.Editing=0]="Editing",o[o.Preview=1]="Preview"})(m=e.CommentMode||(e.CommentMode={}));var E;(function(o){o[o.Other=0]="Other",o[o.Type=1]="Type",o[o.Parameter=2]="Parameter"})(E=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new C.LanguageFeatureRegistry,e.RenameProviderRegistry=new C.LanguageFeatureRegistry,e.CompletionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new C.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new C.LanguageFeatureRegistry,e.HoverProviderRegistry=new C.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new C.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new C.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new C.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new C.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new C.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.LinkProviderRegistry=new C.LanguageFeatureRegistry,e.ColorProviderRegistry=new C.LanguageFeatureRegistry,e.SelectionRangeRegistry=new C.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.TokenizationRegistry=new y.TokenizationRegistryImpl;var S;(function(o){o[o.None=0]="None",o[o.Option=1]="Option",o[o.Default=2]="Default",o[o.Preferred=3]="Preferred"})(S=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(he[80],fe([0,1,8,4,11]),function(X,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let y=C.userAgent||"";const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",C.isMacintosh),T.set("isLinux",C.isLinux),T.set("isWindows",C.isWindows),T.set("isWeb",C.isWeb),T.set("isMacNative",C.isMacintosh&&!C.isWeb),T.set("isEdge",y.indexOf("Edg/")>=0),T.set("isFirefox",y.indexOf("Firefox")>=0),T.set("isChrome",y.indexOf("Chrome")>=0),T.set("isSafari",y.indexOf("Safari")>=0);const I=Object.prototype.hasOwnProperty;var D;(function(S){S[S.False=0]="False",S[S.True=1]="True",S[S.Defined=2]="Defined",S[S.Not=3]="Not",S[S.Equals=4]="Equals",S[S.NotEquals=5]="NotEquals",S[S.And=6]="And",S[S.Regex=7]="Regex",S[S.NotRegex=8]="NotRegex",S[S.Or=9]="Or",S[S.In=10]="In",S[S.NotIn=11]="NotIn",S[S.Greater=12]="Greater",S[S.GreaterEquals=13]="GreaterEquals",S[S.Smaller=14]="Smaller",S[S.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class A{static false(){return P.INSTANCE}static true(){return c.INSTANCE}static has(o){return u.create(o)}static equals(o,k){return a.create(o,k)}static notEquals(o,k){return _.create(o,k)}static regex(o,k){return s.create(o,k)}static in(o,k){return g.create(o,k)}static not(o){return b.create(o)}static and(...o){return n.create(o)}static or(...o){return l.create(o)}static greater(o,k){return d.create(o,k)}static less(o,k){return v.create(o,k)}static deserialize(o,k=!1){if(!!o)return this._deserializeOrExpression(o,k)}static _deserializeOrExpression(o,k){let O=o.split("||");return l.create(O.map($=>this._deserializeAndExpression($,k)))}static _deserializeAndExpression(o,k){let O=o.split("&&");return n.create(O.map($=>this._deserializeOne($,k)))}static _deserializeOne(o,k){if(o=o.trim(),o.indexOf("!=")>=0){let O=o.split("!=");return _.create(O[0].trim(),this._deserializeValue(O[1],k))}if(o.indexOf("==")>=0){let O=o.split("==");return a.create(O[0].trim(),this._deserializeValue(O[1],k))}if(o.indexOf("=~")>=0){let O=o.split("=~");return s.create(O[0].trim(),this._deserializeRegexValue(O[1],k))}if(o.indexOf(" in ")>=0){let O=o.split(" in ");return g.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(o)){const O=o.split(">=");return h.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(o)){const O=o.split(">");return d.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(o)){const O=o.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(o)){const O=o.split("<");return v.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(o)?b.create(o.substr(1).trim()):u.create(o)}static _deserializeValue(o,k){if(o=o.trim(),o==="true")return!0;if(o==="false")return!1;let O=/^'([^']*)'$/.exec(o);return O?O[1].trim():o}static _deserializeRegexValue(o,k){if((0,p.isFalsyOrWhitespace)(o)){if(k)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=o.indexOf("/"),$=o.lastIndexOf("/");if(O===$||O<0){if(k)throw new Error(`bad regexp-value '${o}', missing /-enclosure`);return console.warn(`bad regexp-value '${o}', missing /-enclosure`),null}let G=o.slice(O+1,$),re=o[$+1]==="i"?"i":"";try{return new RegExp(G,re)}catch(j){if(k)throw new Error(`bad regexp-value '${o}', parse error: ${j}`);return console.warn(`bad regexp-value '${o}', parse error: ${j}`),null}}}e.ContextKeyExpr=A;function i(S,o){return S.cmp(o)}class P{constructor(){this.type=0}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!1}serialize(){return"false"}keys(){return[]}map(o){return this}negate(){return c.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class c{constructor(){this.type=1}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!0}serialize(){return"true"}keys(){return[]}map(o){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=c,c.INSTANCE=new c;class u{constructor(o){this.key=o,this.type=2}static create(o){const k=T.get(o);return typeof k=="boolean"?k?c.INSTANCE:P.INSTANCE:new u(o)}cmp(o){return o.type!==this.type?this.type-o.type:m(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!!o.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(o){return o.mapDefined(this.key)}negate(){return b.create(this.key)}}e.ContextKeyDefinedExpr=u;class a{constructor(o,k){this.key=o,this.value=k,this.type=4}static create(o,k){if(typeof k=="boolean")return k?u.create(o):b.create(o);const O=T.get(o);return typeof O=="boolean"?k===(O?"true":"false")?c.INSTANCE:P.INSTANCE:new a(o,k)}cmp(o){return o.type!==this.type?this.type-o.type:E(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(o){return o.mapEquals(this.key,this.value)}negate(){return _.create(this.key,this.value)}}e.ContextKeyEqualsExpr=a;class g{constructor(o,k){this.key=o,this.valueKey=k,this.type=10}static create(o,k){return new g(o,k)}cmp(o){return o.type!==this.type?this.type-o.type:E(this.key,this.valueKey,o.key,o.valueKey)}equals(o){return o.type===this.type?this.key===o.key&&this.valueKey===o.valueKey:!1}evaluate(o){const k=o.getValue(this.valueKey),O=o.getValue(this.key);return Array.isArray(k)?k.indexOf(O)>=0:typeof O=="string"&&typeof k=="object"&&k!==null?I.call(k,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(o){return o.mapIn(this.key,this.valueKey)}negate(){return w.create(this)}}e.ContextKeyInExpr=g;class w{constructor(o){this._actual=o,this.type=11}static create(o){return new w(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new w(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotInExpr=w;class _{constructor(o,k){this.key=o,this.value=k,this.type=5}static create(o,k){if(typeof k=="boolean")return k?b.create(o):u.create(o);const O=T.get(o);return typeof O=="boolean"?k===(O?"true":"false")?P.INSTANCE:c.INSTANCE:new _(o,k)}cmp(o){return o.type!==this.type?this.type-o.type:E(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(o){return o.mapNotEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=_;class b{constructor(o){this.key=o,this.type=3}static create(o){const k=T.get(o);return typeof k=="boolean"?k?P.INSTANCE:c.INSTANCE:new b(o)}cmp(o){return o.type!==this.type?this.type-o.type:m(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!o.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(o){return o.mapNot(this.key)}negate(){return u.create(this.key)}}e.ContextKeyNotExpr=b;class d{constructor(o,k){this.key=o,this.value=k,this.type=12}static create(o,k){return new d(o,k)}cmp(o){return o.type!==this.type?this.type-o.type:E(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=d;class h{constructor(o,k){this.key=o,this.value=k,this.type=13}static create(o,k){return new h(o,k)}cmp(o){return o.type!==this.type?this.type-o.type:E(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreaterEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=h;class v{constructor(o,k){this.key=o,this.value=k,this.type=14}static create(o,k){return new v(o,k)}cmp(o){return o.type!==this.type?this.type-o.type:E(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmaller(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeySmallerExpr=v;class t{constructor(o,k){this.key=o,this.value=k,this.type=15}static create(o,k){return new t(o,k)}cmp(o){return o.type!==this.type?this.type-o.type:E(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmallerEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class s{constructor(o,k){this.key=o,this.regexp=k,this.type=7}static create(o,k){return new s(o,k)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.key<o.key)return-1;if(this.key>o.key)return 1;const k=this.regexp?this.regexp.source:"",O=o.regexp?o.regexp.source:"";return k<O?-1:k>O?1:0}equals(o){if(o.type===this.type){const k=this.regexp?this.regexp.source:"",O=o.regexp?o.regexp.source:"";return this.key===o.key&&k===O}return!1}evaluate(o){let k=o.getValue(this.key);return this.regexp?this.regexp.test(k):!1}serialize(){const o=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${o}`}keys(){return[this.key]}map(o){return o.mapRegex(this.key,this.regexp)}negate(){return r.create(this)}}e.ContextKeyRegexExpr=s;class r{constructor(o){this._actual=o,this.type=8}static create(o){return new r(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new r(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class n{constructor(o){this.expr=o,this.type=6}static create(o){return n._normalizeArr(o)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let k=0,O=this.expr.length;k<O;k++){const $=i(this.expr[k],o.expr[k]);if($!==0)return $}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let k=0,O=this.expr.length;k<O;k++)if(!this.expr[k].equals(o.expr[k]))return!1;return!0}return!1}evaluate(o){for(let k=0,O=this.expr.length;k<O;k++)if(!this.expr[k].evaluate(o))return!1;return!0}static _normalizeArr(o){const k=[];let O=!1;for(const $ of o)if(!!$){if($.type===1){O=!0;continue}if($.type===0)return P.INSTANCE;if($.type===6){k.push(...$.expr);continue}k.push($)}if(k.length===0&&O)return c.INSTANCE;if(k.length!==0){if(k.length===1)return k[0];for(k.sort(i);k.length>1;){const $=k[k.length-1];if($.type!==9)break;k.pop();const G=k.pop(),re=l.create($.expr.map(j=>n.create([j,G])));re&&(k.push(re),k.sort(i))}return k.length===1?k[0]:new n(k)}}serialize(){return this.expr.map(o=>o.serialize()).join(" && ")}keys(){const o=[];for(let k of this.expr)o.push(...k.keys());return o}map(o){return new n(this.expr.map(k=>k.map(o)))}negate(){let o=[];for(let k of this.expr)o.push(k.negate());return l.create(o)}}e.ContextKeyAndExpr=n;class l{constructor(o){this.expr=o,this.type=9}static create(o){const k=l._normalizeArr(o);if(k.length!==0)return k.length===1?k[0]:new l(k)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let k=0,O=this.expr.length;k<O;k++){const $=i(this.expr[k],o.expr[k]);if($!==0)return $}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let k=0,O=this.expr.length;k<O;k++)if(!this.expr[k].equals(o.expr[k]))return!1;return!0}return!1}evaluate(o){for(let k=0,O=this.expr.length;k<O;k++)if(this.expr[k].evaluate(o))return!0;return!1}static _normalizeArr(o){let k=[],O=!1;if(o){for(let $=0,G=o.length;$<G;$++){const re=o[$];if(!!re){if(re.type===0){O=!0;continue}if(re.type===1)return[c.INSTANCE];if(re.type===9){k=k.concat(re.expr);continue}k.push(re)}}if(k.length===0&&O)return[P.INSTANCE];k.sort(i)}return k}serialize(){return this.expr.map(o=>o.serialize()).join(" || ")}keys(){const o=[];for(let k of this.expr)o.push(...k.keys());return o}map(o){return new l(this.expr.map(k=>k.map(o)))}negate(){let o=[];for(let O of this.expr)o.push(O.negate());const k=O=>O.type===9?O.expr:[O];for(;o.length>1;){const O=o.shift(),$=o.shift(),G=[];for(const re of k(O))for(const j of k($))G.push(A.and(re,j));o.unshift(A.or(...G))}return o[0]}}e.ContextKeyOrExpr=l;class f extends u{constructor(o,k,O){super(o);this._defaultValue=k,typeof O=="object"?f._info.push({...O,key:o}):O!==!0&&f._info.push({key:o,description:O,type:k!=null?typeof k:void 0})}static all(){return f._info.values()}bindTo(o){return o.createKey(this.key,this._defaultValue)}getValue(o){return o.getContextKeyValue(this.key)}toNegated(){return A.not(this.key)}isEqualTo(o){return A.equals(this.key,o)}notEqualsTo(o){return A.notEquals(this.key,o)}}e.RawContextKey=f,f._info=[],e.IContextKeyService=(0,L.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(S,o){return S<o?-1:S>o?1:0}function E(S,o,k,O){return S<k?-1:S>k?1:o<O?-1:o>O?1:0}}),define(he[178],fe([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,p.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,p.refineServiceDecorator)(e.IEnvironmentService)}),define(he[179],fe([0,1,153,4,10]),function(X,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function y(P){return P&&typeof P=="object"&&typeof P.id=="string"&&(!P.uuid||typeof P.uuid=="string")}e.isIExtensionIdentifier=y;var T;(function(P){P[P.NoneOrRelevance=0]="NoneOrRelevance",P[P.LastUpdatedDate=1]="LastUpdatedDate",P[P.Title=2]="Title",P[P.PublisherName=3]="PublisherName",P[P.InstallCount=4]="InstallCount",P[P.PublishedDate=5]="PublishedDate",P[P.AverageRating=6]="AverageRating",P[P.WeightedRating=12]="WeightedRating"})(T=e.SortBy||(e.SortBy={}));var I;(function(P){P[P.Default=0]="Default",P[P.Ascending=1]="Ascending",P[P.Descending=2]="Descending"})(I=e.SortOrder||(e.SortOrder={}));var D;(function(P){P.Uninstall="uninstall"})(D=e.StatisticType||(e.StatisticType={}));var A;(function(P){P[P.None=0]="None",P[P.Install=1]="Install",P[P.Update=2]="Update"})(A=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class i extends Error{constructor(c,u){super(c);this.code=u,this.name=u}}e.ExtensionManagementError=i,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=C.FileAccess.asBrowserUri("./media/defaultIcon.png",X).toString(!0),e.ExtensionsLabel=(0,p.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,p.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,L.createDecorator)("IExtensionManagementCLIService")}),define(he[26],fe([0,1,8,4]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function C(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=C;function y(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class I{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,c){if(typeof P=="undefined"||P===null)return typeof c=="undefined"||c===null;if(typeof c=="undefined"||c===null)return!1;if(typeof P=="string"||typeof c=="string"){let u=typeof P=="string"?P:P.value,a=typeof c=="string"?c:c.value;return p.equalsIgnoreCase(u,a)}return P._lower===c._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}e.ExtensionIdentifier=I;function D(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function A(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=A,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(he[180],fe([0,1,8,26]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function C(a,g){return a.uuid&&g.uuid?a.uuid===g.uuid:a.id===g.id?!0:(0,p.compareIgnoreCase)(a.id,g.id)===0}e.areSameExtensions=C;class y{constructor(g,w){this.version=w,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof y?C(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=y;function T(a,g){return`${a}.${g}`}e.getExtensionId=T;function I(a){return a.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function D(a,g){return I(T(a,g))}e.getGalleryExtensionId=D;function A(a,g){const w=[],_=b=>{for(const d of w)if(d.some(h=>C(g(h),g(b))))return d;return null};for(const b of a){const d=_(b);d?d.push(b):w.push([b])}return w}e.groupByExtension=A;function i(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function P(a){return{id:a.identifier.id,name:a.name,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),...a.telemetryData}}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function c(a){const g=new Set;for(const w of a)w.malicious&&g.add(w.id.id);return g}e.getMaliciousExtensionsSet=c;function u(a,g){const w=[],_=g.manifest.extensionDependencies?.slice(0)??[];for(;_.length;){const b=_.shift();if(b&&w.every(d=>!C(d.identifier,{id:b}))){const d=a.filter(h=>C(h.identifier,{id:b}));d.length===1&&(w.push(d[0]),_.push(...d[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}e.getExtensionDependencies=u}),define(he[181],fe([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,p.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,p.createDecorator)("externalTerminal")}),define(he[182],fe([0,1,38,9,111,155,28,11,181,10,137]),function(X,e,p,L,C,y,T,I,D,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=y.localize(0,null);class c{async getDefaultTerminalForPlatforms(){const h=await g.getDefaultTerminalLinuxReady();return{windows:u.getDefaultTerminalWindows(),linux:h,osx:"xterm"}}}class u extends c{openTerminal(h,v){return this.spawnTerminal(p,h,C.getWindowsShell(),v)}spawnTerminal(h,v,t,s){const r=v.windowsExec||u.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const n=L.basename(r).toLowerCase();if(n==="cmder"||n==="cmder.exe")return h.spawn(r,s?[s]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return r.indexOf(" ")>=0&&l.push('""'),l.push(r),(n==="wt"||n==="wt.exe")&&l.push("-d ."),new Promise((f,m)=>{const E=w(process),S=h.spawn(t,l,{cwd:s,env:E});S.on("error",m),S.on("exit",()=>f())})}runInTerminal(h,v,t,s,r){const n="windowsExec"in r&&r.windowsExec?r.windowsExec:u.getDefaultTerminalWindows();return new Promise((l,f)=>{const m=`"${v} - ${P}"`,E=`""${t.join('" "')}" & pause"`,S=["/c","start",m,"/wait",n,"/c",E],o=Object.assign({},w(process),s);Object.keys(o).filter($=>o[$]===null).forEach($=>delete o[$]);const k={cwd:v,env:o,windowsVerbatimArguments:!0};p.spawn(u.CMD,S,k).on("error",$=>{f(_($))}),l(void 0)})}static getDefaultTerminalWindows(){if(!u._DEFAULT_TERMINAL_WINDOWS){const h=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");u._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${h?"Sysnative":"System32"}\\cmd.exe`}return u._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=u,u.CMD="cmd.exe";class a extends c{openTerminal(h,v){return this.spawnTerminal(p,h,v)}runInTerminal(h,v,t,s,r){const n=r.osxExec||D.DEFAULT_TERMINAL_OSX;return new Promise((l,f)=>{if(n===D.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const m=n===D.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",S=[A.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${m}.scpt`,X).fsPath,"-t",h||P,"-w",v];for(let O of t)S.push("-a"),S.push(O);if(s){const O=Object.assign({},w(process),s);for(let $ in O){const G=O[$];G===null?(S.push("-u"),S.push($)):(S.push("-e"),S.push(`${$}=${G}`))}}let o="";const k=p.spawn(a.OSASCRIPT,S);k.on("error",O=>{f(_(O))}),k.stderr.on("data",O=>{o+=O.toString()}),k.on("exit",O=>{if(O===0)l(void 0);else if(o){const $=o.split(`
`,1);f(new Error($[0]))}else f(new Error(y.localize(1,null,m,O)))})}else f(new Error(y.localize(2,null,n)))})}spawnTerminal(h,v,t){const s=v.osxExec||D.DEFAULT_TERMINAL_OSX;return new Promise((r,n)=>{const l=["-a",s];t&&l.push(t);const f=w(process),m=h.spawn("/usr/bin/open",l,{cwd:t,env:f});m.on("error",n),m.on("exit",()=>r())})}}e.MacExternalTerminalService=a,a.OSASCRIPT="/usr/bin/osascript";class g extends c{openTerminal(h,v){return this.spawnTerminal(p,h,v)}runInTerminal(h,v,t,s,r){const n=r.linuxExec?Promise.resolve(r.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((l,f)=>{let m=[];n.then(E=>{E.indexOf("gnome-terminal")>=0?m.push("-x"):m.push("-e"),m.push("bash"),m.push("-c");const S=`${b(t)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;m.push(`''${S}''`);const o=Object.assign({},w(process),s);Object.keys(o).filter(G=>o[G]===null).forEach(G=>delete o[G]);const k={cwd:v,env:o};let O="";const $=p.spawn(E,m,k);$.on("error",G=>{f(_(G))}),$.stderr.on("data",G=>{O+=G.toString()}),$.on("exit",G=>{if(G===0)l(void 0);else if(O){const re=O.split(`
`,1);f(new Error(re[0]))}else f(new Error(y.localize(4,null,E,G)))})})})}static async getDefaultTerminalLinuxReady(){return g._DEFAULT_TERMINAL_LINUX_READY||(g._DEFAULT_TERMINAL_LINUX_READY=new Promise(async h=>{I.isLinux?await T.Promises.exists("/etc/debian_version")?h("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?h("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?h("konsole"):process.env.COLORTERM?h(process.env.COLORTERM):process.env.TERM?h(process.env.TERM):h("xterm"):h("xterm")})),g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(h,v,t){const s=v.linuxExec?Promise.resolve(v.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((r,n)=>{s.then(l=>{const f=w(process),m=h.spawn(l,[],{cwd:t,env:f});m.on("error",n),m.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=y.localize(3,null);function w(d){const h=d.env;return(0,i.sanitizeProcessEnvironment)(h),h}function _(d){return"errno"in d&&d.errno==="ENOENT"&&"path"in d&&typeof d.path=="string"?new Error(y.localize(5,null,d.path)):d}function b(d){let h="";for(let v of d)v.indexOf(" ")>=0?h+='"'+v+'"':h+=v,h+=" ";return h}}),define(he[41],fe([0,1,156,9,2,4,8,14,23]),function(X,e,p,L,C,y,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function A(N){return N.create===!0}e.isFileOpenForWriteOptions=A;var i;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var P;(function(N){N[N.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var c;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(c=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function u(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=u;function a(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=a;function g(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function w(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=w;var _;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(_=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(x,R){super(x);this.code=R}}e.FileSystemProviderError=b;function d(N,x){const R=new b(N.toString(),x);return v(R,x),R}e.createFileSystemProviderError=d;function h(N){return N||d((0,p.localize)(0,null),_.Unknown)}e.ensureFileSystemProviderError=h;function v(N,x){return N.name=x?`${x} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=v;function t(N){if(!N)return _.Unknown;if(N instanceof b)return N.code;const x=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!x)return _.Unknown;switch(x[1]){case _.FileExists:return _.FileExists;case _.FileIsADirectory:return _.FileIsADirectory;case _.FileNotADirectory:return _.FileNotADirectory;case _.FileNotFound:return _.FileNotFound;case _.FileExceedsMemoryLimit:return _.FileExceedsMemoryLimit;case _.FileTooLarge:return _.FileTooLarge;case _.FileWriteLocked:return _.FileWriteLocked;case _.NoPermissions:return _.NoPermissions;case _.Unavailable:return _.Unavailable}return _.Unknown}e.toFileSystemProviderErrorCode=t;function s(N){if(N instanceof E)return N.fileOperationResult;switch(t(N)){case _.FileNotFound:return 1;case _.FileIsADirectory:return 0;case _.FileNotADirectory:return 10;case _.FileWriteLocked:return 5;case _.NoPermissions:return 6;case _.FileExists:return 4;case _.FileExceedsMemoryLimit:return 9;case _.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var r;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class n{constructor(x,R,V){this.resource=x,this.operation=R,this.target=V}isOperation(x){return this.operation===x}}e.FileOperationEvent=n;var l;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class f{constructor(x,R){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const V of x)switch(V.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>R)),this.added.set(V.resource,V);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>R)),this.updated.set(V.resource,V);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>R)),this.deleted.set(V.resource,V);break}}contains(x,...R){return this.doContains(x,{includeChildren:!1},...R)}affects(x,...R){return this.doContains(x,{includeChildren:!0},...R)}doContains(x,R,...V){if(!x)return!1;const F=V.length>0;return!!((!F||V.includes(1))&&(this.added?.get(x)||R.includeChildren&&this.added?.findSuperstr(x))||(!F||V.includes(0))&&(this.updated?.get(x)||R.includeChildren&&this.updated?.findSuperstr(x))||(!F||V.includes(2))&&(this.deleted?.findSubstr(x)||R.includeChildren&&this.deleted?.findSuperstr(x)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=f;function m(N,x,R){return!N||!x||N===x||x.length>N.length?!1:(x.charAt(x.length-1)!==L.sep&&(x+=L.sep),R?(0,T.startsWithIgnoreCase)(N,x):N.indexOf(x)===0)}e.isParent=m;class E extends Error{constructor(x,R,V){super(x);this.fileOperationResult=R,this.options=V}}e.FileOperationError=E;class S extends E{constructor(x,R,V){super(x,2,V);this.stat=R}}e.NotModifiedSinceFileOperationError=S;var o;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(o=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var k;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(k=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=O;async function $(N,x){if(!x.canHandleResource(C.URI.from({scheme:N.scheme})))return new Promise(R=>{const V=x.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===N.scheme&&F.added&&(V.dispose(),R())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class G{static formatSize(x){return(0,I.isNumber)(x)||(x=0),x<G.KB?(0,p.localize)(1,null,x.toFixed(0)):x<G.MB?(0,p.localize)(2,null,(x/G.KB).toFixed(2)):x<G.GB?(0,p.localize)(3,null,(x/G.MB).toFixed(2)):x<G.TB?(0,p.localize)(4,null,(x/G.GB).toFixed(2)):(0,p.localize)(5,null,(x/G.TB).toFixed(2))}}e.ByteSize=G,G.KB=1024,G.MB=G.KB*G.KB,G.GB=G.MB*G.KB,G.TB=G.GB*G.KB;var re;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(re=e.Arch||(e.Arch={}));function j(N){return{maxFileSize:N===0?300*G.MB:16*G.GB,maxHeapSize:N===0?700*G.MB:2*700*G.MB}}e.getPlatformLimits=j}),define(he[81],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...C){this._entries=new Map;for(let[y,T]of C)this.set(y,T)}set(C,y){const T=this._entries.get(C);return this._entries.set(C,y),T}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=p}),define(he[183],fe([0,1,15,175,113,4,81,17]),function(X,e,p,L,C,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class A extends Error{constructor(a){super("cyclic dependency between services");this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class i{constructor(a=new T.ServiceCollection,g=!1,w){this._activeInstantiations=new Set,this._services=a,this._strict=g,this._parent=w,this._services.set(y.IInstantiationService,this)}createChild(a){return new i(a,this._strict,this)}invokeFunction(a,...g){let w=c.traceInvocation(a),_=!1;try{return a({get:(d,h)=>{if(_)throw(0,p.illegalState)("service accessor is only valid during the invocation of its target method");const v=this._getOrCreateServiceInstance(d,w);if(!v&&h!==y.optional)throw new Error(`[invokeFunction] unknown service '${d}'`);return v}},...g)}finally{_=!0,w.stop()}}createInstance(a,...g){let w,_;return a instanceof C.SyncDescriptor?(w=c.traceCreation(a.ctor),_=this._createInstance(a.ctor,a.staticArguments.concat(g),w)):(w=c.traceCreation(a),_=this._createInstance(a,g,w)),w.stop(),_}_createInstance(a,g=[],w){let _=y._util.getServiceDependencies(a).sort((h,v)=>h.index-v.index),b=[];for(const h of _){let v=this._getOrCreateServiceInstance(h.id,w);if(!v&&this._strict&&!h.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${h.id}.`);b.push(v)}let d=_.length>0?_[0].index:g.length;if(g.length!==d){console.warn(`[createInstance] First service dependency of ${a.name} at position ${d+1} conflicts with ${g.length} static arguments`);let h=d-g.length;h>0?g=g.concat(new Array(h)):g=g.slice(0,d)}return new a(...[...g,...b])}_setServiceInstance(a,g){if(this._services.get(a)instanceof C.SyncDescriptor)this._services.set(a,g);else if(this._parent)this._parent._setServiceInstance(a,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let g=this._services.get(a);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):g}_getOrCreateServiceInstance(a,g){let w=this._getServiceInstanceOrDescriptor(a);return w instanceof C.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,w,g.branch(a,!0)):(g.branch(a,!1),w)}_safeCreateAndCacheServiceInstance(a,g,w){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,g,w)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,g,w){const _=new L.Graph(h=>h.id.toString());let b=0;const d=[{id:a,desc:g,_trace:w}];for(;d.length;){const h=d.pop();if(_.lookupOrInsertNode(h),b++>1e3)throw new A(_);for(let v of y._util.getServiceDependencies(h.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(v.id);if(!t&&!v.optional&&console.warn(`[createInstance] ${a} depends on ${v.id} which is NOT registered.`),t instanceof C.SyncDescriptor){const s={id:v.id,desc:t,_trace:h._trace.branch(v.id,!0)};_.insertEdge(h,s),d.push(s)}}}for(;;){const h=_.roots();if(h.length===0){if(!_.isEmpty())throw new A(_);break}for(const{data:v}of h){if(this._getServiceInstanceOrDescriptor(v.id)instanceof C.SyncDescriptor){const s=this._createServiceInstanceWithOwner(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this._setServiceInstance(v.id,s)}_.removeNode(v)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,g,w=[],_,b){if(this._services.get(a)instanceof C.SyncDescriptor)return this._createServiceInstance(g,w,_,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,g,w,_,b);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(a,g=[],w,_){if(w){const b=new I.IdleValue(()=>this._createInstance(a,g,_));return new Proxy(Object.create(null),{get(d,h){if(h in d)return d[h];let v=b.value,t=v[h];return typeof t!="function"||(t=t.bind(v),d[h]=t),t},set(d,h,v){return b.value[h]=v,!0}})}else return this._createInstance(a,g,_)}}e.InstantiationService=i;var P;(function(u){u[u.Creation=0]="Creation",u[u.Invocation=1]="Invocation",u[u.Branch=2]="Branch"})(P||(P={}));class c{constructor(a,g){this.type=a,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return D?new c(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(a){return D?new c(0,a.name):c._None}branch(a,g){let w=new c(2,a.toString());return this._dep.push([a,g,w]),w}stop(){let a=Date.now()-this._start;c._totals+=a;let g=!1;function w(b,d){let h=[],v=new Array(b+1).join("	");for(const[t,s,r]of d._dep)if(s&&r){g=!0,h.push(`${v}CREATES -> ${t}`);let n=w(b+1,r);n&&h.push(n)}else h.push(`${v}uses -> ${t}`);return h.join(`
`)}let _=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(a>2||g)&&console.log(_.join(`
`))}}c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(he[12],fe([0,1,4,6,11,3,58]),function(X,e,p,L,C,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,p.createDecorator)("logService"),e.ILoggerService=(0,p.createDecorator)("loggerService");function I(){return new Date().toISOString()}var D;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class A extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new y.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=A;class i extends A{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...s){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([t,...s]))}debug(t,...s){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([t,...s]))}info(t,...s){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([t,...s]))}warn(t,...s){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([t,...s]))}error(t,...s){if(this.checkLogLevel(D.Error))if(t instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=t.stack,this.log(D.Error,this.format(r))}else this.log(D.Error,this.format([t,...s]))}critical(t,...s){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([t,...s]))}flush(){}format(t){let s="";for(let r=0;r<t.length;r++){let n=t[r];if(typeof n=="object")try{n=JSON.stringify(n)}catch(l){}s+=(r>0?" ":"")+n}return s}}e.AbstractMessageLogger=i;class P extends A{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!C.isWindows}trace(t,...s){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,t,...s):console.log(`[main ${I()}]`,t,...s))}debug(t,...s){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,t,...s):console.log(`[main ${I()}]`,t,...s))}info(t,...s){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,t,...s):console.log(`[main ${I()}]`,t,...s))}warn(t,...s){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,t,...s):console.warn(`[main ${I()}]`,t,...s))}error(t,...s){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,t,...s):console.error(`[main ${I()}]`,t,...s))}critical(t,...s){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,t,...s):console.error(`[main ${I()}]`,t,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class c extends A{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...s){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",t,...s)}debug(t,...s){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...s)}info(t,...s){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",t,...s)}warn(t,...s){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",t,...s)}error(t,...s){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",t,...s)}critical(t,...s){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...s)}dispose(){}flush(){}}e.ConsoleLogger=c;class u extends A{constructor(t,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(s)}trace(t,...s){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(t),...s])}debug(t,...s){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(t),...s])}info(t,...s){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(t),...s])}warn(t,...s){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(t),...s])}error(t,...s){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(t),...s])}critical(t,...s){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(t),...s])}extractMessage(t){return typeof t=="string"?t:(0,T.toErrorMessage)(t,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=u;class a extends A{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const s of this.logServices)s.setLevel(t);super.setLevel(t)}trace(t,...s){for(const r of this.logServices)r.trace(t,...s)}debug(t,...s){for(const r of this.logServices)r.debug(t,...s)}info(t,...s){for(const r of this.logServices)r.info(t,...s)}warn(t,...s){for(const r of this.logServices)r.warn(t,...s)}error(t,...s){for(const r of this.logServices)r.error(t,...s)}critical(t,...s){for(const r of this.logServices)r.critical(t,...s)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=a;class g extends L.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...s){this.logger.trace(t,...s)}debug(t,...s){this.logger.debug(t,...s)}info(t,...s){this.logger.info(t,...s)}warn(t,...s){this.logger.warn(t,...s)}error(t,...s){this.logger.error(t,...s)}critical(t,...s){this.logger.critical(t,...s)}flush(){this.logger.flush()}}e.LogService=g;class w extends L.Disposable{constructor(t,s){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(n=>n.setLevel(r))}))}createLogger(t,s){let r=this.loggers.get(t.toString());return r||(r=this.doCreateLogger(t,s?.always?D.Trace:this.logLevel,s),this.loggers.set(t.toString(),r),s?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class _{constructor(){this.onDidChangeLogLevel=new y.Emitter().event}setLevel(t){}getLevel(){return D.Info}trace(t,...s){}debug(t,...s){}info(t,...s){}warn(t,...s){}error(t,...s){}critical(t,...s){}dispose(){}flush(){}}e.NullLogService=_;function b(v){if(v.verbose)return D.Trace;if(typeof v.logLevel=="string"){const t=d(v.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=b;function d(v){switch(v){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=d;function h(v){switch(v){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=h}),define(he[114],fe([0,1,12,41]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function C(D,A,i,P){try{const c=await new Promise((u,a)=>{X(["spdlog"],u,a)});return c.setFlushOn(p.LogLevel.Trace),c.createAsyncRotatingLogger(D,A,i,P)}catch(c){console.error(c)}return null}function y(D,A,i,P){const c=X.__$__nodeRequire("spdlog");return c.setFlushOn(p.LogLevel.Trace),c.createRotatingLogger(D,A,i,P)}e.createRotatingLogger=y;function T(D,A,i){switch(A){case p.LogLevel.Trace:D.trace(i);break;case p.LogLevel.Debug:D.debug(i);break;case p.LogLevel.Info:D.info(i);break;case p.LogLevel.Warning:D.warn(i);break;case p.LogLevel.Error:D.error(i);break;case p.LogLevel.Critical:D.critical(i);break;default:throw new Error("Invalid log level")}}class I extends p.AbstractMessageLogger{constructor(A,i,P,c){super();this.name=A,this.filepath=i,this.rotating=P,this.buffer=[],this.setLevel(c),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(u=>{this._logger&&this._logger.setLevel(u)}))}_createSpdLogLogger(){const A=this.rotating?6:1,i=30/A*L.ByteSize.MB;return C(this.name,this.filepath,i,A).then(P=>{if(P){this._logger=P,this._logger.setLevel(this.getLevel());for(const{level:c,message:u}of this.buffer)T(this._logger,c,u);this.buffer=[]}})}log(A,i){this._logger?T(this._logger,A,i):this.getLevel()<=A&&this.buffer.push({level:A,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=I}),define(he[115],fe([0,1,4,157,56]),function(X,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var y;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(y=e.MarkerTag||(e.MarkerTag={}));var T;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(T=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function A(a,g){return g-a}D.compare=A;const i=Object.create(null);i[D.Error]=(0,L.localize)(0,null),i[D.Warning]=(0,L.localize)(1,null),i[D.Info]=(0,L.localize)(2,null);function P(a){return i[a]||""}D.toString=P;function c(a){switch(a){case C.default.Error:return D.Error;case C.default.Warning:return D.Warning;case C.default.Info:return D.Info;case C.default.Ignore:return D.Hint}}D.fromSeverity=c;function u(a){switch(a){case D.Error:return C.default.Error;case D.Warning:return C.default.Warning;case D.Info:return C.default.Info;case D.Hint:return C.default.Ignore}}D.toSeverity=u}(T=e.MarkerSeverity||(e.MarkerSeverity={}));var I;(function(D){const A="";function i(c){return P(c,!0)}D.makeKey=i;function P(c,u){let a=[A];return c.source?a.push(c.source.replace("\xA6","\\\xA6")):a.push(A),c.code?typeof c.code=="string"?a.push(c.code.replace("\xA6","\\\xA6")):a.push(c.code.value.replace("\xA6","\\\xA6")):a.push(A),c.severity!==void 0&&c.severity!==null?a.push(T.toString(c.severity)):a.push(A),c.message&&u?a.push(c.message.replace("\xA6","\\\xA6")):a.push(A),c.startLineNumber!==void 0&&c.startLineNumber!==null?a.push(c.startLineNumber.toString()):a.push(A),c.startColumn!==void 0&&c.startColumn!==null?a.push(c.startColumn.toString()):a.push(A),c.endLineNumber!==void 0&&c.endLineNumber!==null?a.push(c.endLineNumber.toString()):a.push(A),c.endColumn!==void 0&&c.endColumn!==null?a.push(c.endColumn.toString()):a.push(A),a.push(A),a.join("\xA6")}D.makeKeyOptionalMessage=P})(I=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,p.createDecorator)("markerService")}),define(he[184],fe([0,1,56,4,3]),function(X,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=p.default,e.INotificationService=(0,L.createDecorator)("notificationService");var y;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.GLOBAL=1]="GLOBAL"})(y=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var T;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(T=e.NotificationsFilter||(e.NotificationsFilter={}));class I{constructor(){this.progress=new D,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=I;class D{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=D}),define(he[185],fe([0,1,6,8,2,4]),function(X,e,p,L,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,y.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return p.Disposable.None},registerValidator(){return p.Disposable.None},registerExternalUriResolver(){return p.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return p.Disposable.None},async open(){return!1},async resolveExternalUri(I){return{resolved:I,dispose(){}}}});function T(I,D){return C.URI.isUri(I)?(0,L.equalsIgnoreCase)(I.scheme,D):(0,L.startsWithIgnoreCase)(I,D+":")}e.matchesScheme=T}),define(he[186],fe([0,1,10,11,37,24]),function(X,e,p,L,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const I=L.globals.vscode.context.configuration();if(I)T=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof X?.__$__nodeRequire=="function"){const I=(0,y.dirname)(p.FileAccess.asFileUri("",X));T=X.__$__nodeRequire((0,y.joinPath)(I,"product.json").fsPath);const D=X.__$__nodeRequire((0,y.joinPath)(I,"package.json").fsPath);C.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`}),Object.assign(T,{version:D.version})}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.59.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=T});var We=this&&this.__param||function(X,e){return function(p,L){e(p,L,X)}};define(he[116],fe([0,1,4,21,6,17]),function(X,e,p,L,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,p.createDecorator)("progressService");var T;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(T=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class I{constructor(P){this.callback=P}get value(){return this._value}report(P){this._value=P,this.callback(this._value)}}e.Progress=I,I.None=Object.freeze({report(){}});let D=class extends C.Disposable{constructor(P,c){super();this.deferred=new y.DeferredPromise,c.withProgress(P,u=>(this.reporter=u,this.lastStep&&u.report(this.lastStep),this.deferred.p)),this._register((0,C.toDisposable)(()=>this.deferred.complete()))}report(P){this.reporter?this.reporter.report(P):this.lastStep=P}};D=je([We(1,e.IProgressService)],D),e.UnmanagedProgress=D;class A extends C.Disposable{constructor(P){super();this.progressIndicator=P,this.currentOperationId=0,this.currentOperationDisposables=this._register(new C.DisposableStore)}start(P){this.stop();const c=++this.currentOperationId,u=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{c===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},P),this.currentOperationDisposables.add((0,C.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,C.toDisposable)(()=>u.cancel())),this.currentOperationDisposables.add((0,C.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:c,token:u.token,stop:()=>this.doStop(c),isCurrent:()=>this.currentOperationId===c}}stop(){this.doStop(this.currentOperationId)}doStop(P){this.currentOperationId===P&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=A,e.IEditorProgressService=(0,p.createDecorator)("editorProgressService")}),define(he[42],fe([0,1,14,52]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(T,I){L.ok(p.isString(T)),L.ok(p.isObject(I)),L.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,I)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new C}),define(he[187],fe([0,1,42,3]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class y{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,A){this.schemasById[C(D)]=A,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new y;p.Registry.add(e.Extensions.JSONContribution,T)}),define(he[82],fe([0,1,152,3,42,14,187]),function(X,e,p,L,C,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var I;(function(_){_.Multiline="multilineText",_.Singleline="singlelineText"})(I=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(_){_[_.APPLICATION=1]="APPLICATION",_[_.MACHINE=2]="MACHINE",_[_.WINDOW=3]="WINDOW",_[_.RESOURCE=4]="RESOURCE",_[_.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",_[_.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const A=C.Registry.as(T.Extensions.JSONContribution);class i{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:p.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(b,d=!0){this.registerConfigurations([b],d)}registerConfigurations(b,d=!0){const h=[];b.forEach(v=>{h.push(...this.validateAndRegisterProperties(v,d,v.extensionInfo)),this.configurationContributors.push(v),this.registerJSONConfiguration(v)}),A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}deregisterConfigurations(b){const d=[],h=v=>{if(v.properties)for(const t in v.properties)d.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,v.properties[t]);v.allOf&&v.allOf.forEach(t=>h(t))};for(const v of b){h(v);const t=this.configurationContributors.indexOf(v);t!==-1&&this.configurationContributors.splice(t,1)}A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}registerDefaultConfigurations(b){const d=[],h=[];for(const v of b)for(const t in v)if(d.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...v[t]};const s={type:"object",default:this.defaultValues[t],description:p.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};h.push(c(t)),this.configurationProperties[t]=s,this.defaultLanguageConfigurationOverridesNode.properties[t]=s}else{this.defaultValues[t]=v[t];const s=this.configurationProperties[t];s&&(this.updatePropertyDefaultValue(t,s),this.updateSchema(t,s))}this.registerOverrideIdentifiers(h),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterDefaultConfigurations(b){const d=[];for(const h of b)for(const v in h)if(d.push(v),delete this.defaultValues[v],e.OVERRIDE_PROPERTY_PATTERN.test(v))delete this.configurationProperties[v],delete this.defaultLanguageConfigurationOverridesNode.properties[v];else{const t=this.configurationProperties[v];t&&(this.updatePropertyDefaultValue(v,t),this.updateSchema(v,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}notifyConfigurationSchemaUpdated(...b){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(b){for(const d of b)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(b,d=!0,h,v=3){v=y.isUndefinedOrNull(b.scope)?v:b.scope;let t=[],s=b.properties;if(s)for(let n in s){if(d&&g(n)){delete s[n];continue}const l=s[n];if(this.updatePropertyDefaultValue(n,l),e.OVERRIDE_PROPERTY_PATTERN.test(n)?l.scope=void 0:(l.scope=y.isUndefinedOrNull(l.scope)?v:l.scope,l.restricted=y.isUndefinedOrNull(l.restricted)?!!h?.restrictedConfigurations?.includes(n):l.restricted),s[n].hasOwnProperty("included")&&!s[n].included){this.excludedConfigurationProperties[n]=s[n],delete s[n];continue}else this.configurationProperties[n]=s[n];!s[n].deprecationMessage&&s[n].markdownDeprecationMessage&&(s[n].deprecationMessage=s[n].markdownDeprecationMessage),t.push(n)}let r=b.allOf;if(r)for(let n of r)t.push(...this.validateAndRegisterProperties(n,d,h,v));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(b){const d=h=>{let v=h.properties;if(v)for(const s in v)this.updateSchema(s,v[s]);let t=h.allOf;t&&t.forEach(d)};d(b)}updateSchema(b,d){switch(e.allSettings.properties[b]=d,d.scope){case 1:e.applicationSettings.properties[b]=d;break;case 2:e.machineSettings.properties[b]=d;break;case 6:e.machineOverridableSettings.properties[b]=d;break;case 3:e.windowSettings.properties[b]=d;break;case 4:e.resourceSettings.properties[b]=d;break;case 5:e.resourceSettings.properties[b]=d,this.resourceLanguageSettingsSchema.properties[b]=d;break}}removeFromSchema(b,d){switch(delete e.allSettings.properties[b],d.scope){case 1:delete e.applicationSettings.properties[b];break;case 2:delete e.machineSettings.properties[b];break;case 6:delete e.machineOverridableSettings.properties[b];break;case 3:delete e.windowSettings.properties[b];break;case 4:case 5:delete e.resourceSettings.properties[b];break}}updateOverridePropertyPatternKey(){for(const b of this.overrideIdentifiers.values()){const d=`[${b}]`,h={type:"object",description:p.localize(2,null),errorMessage:p.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,h),e.allSettings.properties[d]=h,e.applicationSettings.properties[d]=h,e.machineSettings.properties[d]=h,e.machineOverridableSettings.properties[d]=h,e.windowSettings.properties[d]=h,e.resourceSettings.properties[d]=h}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(b,d){let h=this.defaultValues[b];y.isUndefined(h)&&(h=d.default),y.isUndefined(h)&&(h=u(d.type)),d.default=h}}const P="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(P);function c(_){return _.substring(1,_.length-1)}e.overrideIdentifierFromKey=c;function u(_){switch(Array.isArray(_)?_[0]:_){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const a=new i;C.Registry.add(e.Extensions.Configuration,a);function g(_){return _.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(_)?p.localize(5,null,_):a.getConfigurationProperties()[_]!==void 0?p.localize(6,null,_):null:p.localize(4,null)}e.validateProperty=g;function w(){const _=[],b=a.getConfigurationProperties();for(const d of Object.keys(b))_.push([d,b[d].scope]);return _.push(["launch",4]),_.push(["task",4]),_}e.getScopes=w}),define(he[117],fe([0,1,25,14,2,42,4,82]),function(X,e,p,L,C,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,T.createDecorator)("configurationService");function D(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof C.URI)}e.isConfigurationOverrides=D;var A;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function P(s,r){const n=r?s?r.keys.filter(k=>s.keys.indexOf(k)===-1):[...r.keys]:[],l=s?r?s.keys.filter(k=>r.keys.indexOf(k)===-1):[...s.keys]:[],f=[];if(r&&s){for(const k of s.keys)if(r.keys.indexOf(k)!==-1){const O=_(s.contents,k),$=_(r.contents,k);p.equals(O,$)||f.push(k)}}const m=[],E=k=>{const O={};for(const $ of k)for(const G of $.identifiers)O[v(G)]=$;return O},S=r?E(r.overrides):{},o=s?E(s.overrides):{};if(Object.keys(S).length)for(const k of n){const O=S[k];O&&m.push([(0,I.overrideIdentifierFromKey)(k),O.keys])}if(Object.keys(o).length)for(const k of l){const O=o[k];O&&m.push([(0,I.overrideIdentifierFromKey)(k),O.keys])}if(Object.keys(S).length&&Object.keys(o).length)for(const k of f){const O=o[k],$=S[k];if(O&&$){const G=P({contents:O.contents,keys:O.keys,overrides:[]},{contents:$.contents,keys:$.keys,overrides:[]});m.push([(0,I.overrideIdentifierFromKey)(k),[...G.added,...G.removed,...G.updated]])}}return{added:n,removed:l,updated:f,overrides:m}}e.compare=P;function c(s,r){const n=[];for(const l of Object.keys(s))if(I.OVERRIDE_PROPERTY_PATTERN.test(l)){const f={};for(const m in s[l])f[m]=s[l][m];n.push({identifiers:[(0,I.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(f),contents:u(f,r)})}return n}e.toOverrides=c;function u(s,r){const n=Object.create(null);for(let l in s)a(n,l,s[l],r);return n}e.toValuesTree=u;function a(s,r,n,l){const f=r.split("."),m=f.pop();let E=s;for(let S=0;S<f.length;S++){let o=f[S],k=E[o];switch(typeof k){case"undefined":k=E[o]=Object.create(null);break;case"object":break;default:l(`Ignoring ${r} as ${f.slice(0,S+1).join(".")} is ${JSON.stringify(k)}`);return}E=k}if(typeof E=="object"&&E!==null)try{E[m]=n}catch(S){l(`Ignoring ${r} as ${f.join(".")} is ${JSON.stringify(E)}`)}else l(`Ignoring ${r} as ${f.join(".")} is ${JSON.stringify(E)}`)}e.addToValueTree=a;function g(s,r){const n=r.split(".");w(s,n)}e.removeFromValueTree=g;function w(s,r){const n=r.shift();if(r.length===0){delete s[n];return}if(Object.keys(s).indexOf(n)!==-1){const l=s[n];typeof l=="object"&&!Array.isArray(l)&&(w(l,r),Object.keys(l).length===0&&delete s[n])}}function _(s,r,n){function l(E,S){let o=E;for(const k of S){if(typeof o!="object"||o===null)return;o=o[k]}return o}const f=r.split("."),m=l(s,f);return typeof m=="undefined"?n:m}e.getConfigurationValue=_;function b(s,r,n){Object.keys(r).forEach(l=>{l!=="__proto__"&&(l in s?L.isObject(s[l])&&L.isObject(r[l])?b(s[l],r[l],n):n&&(s[l]=r[l]):s[l]=r[l])})}e.merge=b;function d(){const s=y.Registry.as(I.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=d;function h(){const s=Object.create(null),r=y.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(let n in r){let l=r[n].default;a(s,n,l,f=>console.error(`Conflict in default settings: ${f}`))}return s}e.getDefaultValues=h;function v(s){return`[${s}]`}e.keyFromOverrideIdentifier=v;function t(s,r,n){const l=s.inspect(r),f=s.inspect(n);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:l.defaultValue}e.getMigratedSettingValue=t}),define(he[188],fe([0,1,54,23,18,14,25,2,82,117,42,6,3]),function(X,e,p,L,C,y,T,I,D,A,i,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class u{constructor(t={},s=[],r=[]){this._contents=t,this._keys=s,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,A.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,s){const r=this.getContentsForOverrideIdentifer(s);return r?t?(0,A.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.keys;return[]}override(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let r={};for(const n of C.distinct([...Object.keys(this.contents),...Object.keys(s)])){let l=this.contents[n],f=s[n];f&&(typeof l=="object"&&typeof f=="object"?(l=T.deepClone(l),this.mergeContents(l,f)):l=f),r[n]=l}return new u(r,this.keys,this.overrides)}merge(...t){const s=T.deepClone(this.contents),r=T.deepClone(this.overrides),n=[...this.keys];for(const l of t){this.mergeContents(s,l.contents);for(const f of l.overrides){const[m]=r.filter(E=>C.equals(E.identifiers,f.identifiers));m?this.mergeContents(m.contents,f.contents):r.push(T.deepClone(f))}for(const f of l.keys)n.indexOf(f)===-1&&n.push(f)}return new u(s,n,r)}freeze(){return this.isFrozen=!0,this}mergeContents(t,s){for(const r of Object.keys(s)){if(r in t&&y.isObject(t[r])&&y.isObject(s[r])){this.mergeContents(t[r],s[r]);continue}t[r]=T.deepClone(s[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?T.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,s){this.addKey(t),(0,A.addToValueTree)(this.contents,t,s,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,A.removeFromValueTree)(this.contents,t)}addKey(t){let s=this.keys.length;for(let r=0;r<s;r++)t.indexOf(this.keys[r])===0&&(s=r);this.keys.splice(s,1,t)}removeKey(t){let s=this.keys.indexOf(t);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=u;class a extends u{constructor(){const t=(0,A.getDefaultValues)(),s=(0,A.getConfigurationKeys)(),r=[];for(const n of Object.keys(t))D.OVERRIDE_PROPERTY_PATTERN.test(n)&&r.push({identifiers:[(0,D.overrideIdentifierFromKey)(n).trim()],keys:Object.keys(t[n]),contents:(0,A.toValuesTree)(t[n],l=>console.error(`Conflict in default settings file: ${l}`))});super(t,s,r)}}e.DefaultConfigurationModel=a;class g{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new u}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!y.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:r,keys:n,overrides:l,restricted:f}=this.doParseRaw(t,s);this._configurationModel=new u(r,n,l),this._restrictedConfigurations=f||[]}doParseContent(t){let s={},r=null,n=[],l=[],f=[];function m(S){Array.isArray(n)?n.push(S):r&&(n[r]=S)}let E={onObjectBegin:()=>{let S={};m(S),l.push(n),n=S,r=null},onObjectProperty:S=>{r=S},onObjectEnd:()=>{n=l.pop()},onArrayBegin:()=>{let S=[];m(S),l.push(n),n=S,r=null},onArrayEnd:()=>{n=l.pop()},onLiteralValue:m,onError:(S,o,k)=>{f.push({error:S,offset:o,length:k})}};if(t)try{p.visit(t,E),s=n[0]||{}}catch(S){console.error(`Error while parsing settings file ${this._name}: ${S}`),this._parseErrors=[S]}return s}doParseRaw(t,s){const r=i.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),n=this.filter(t,r,!0,s);t=n.raw;const l=(0,A.toValuesTree)(t,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),f=Object.keys(t),m=(0,A.toOverrides)(t,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:l,keys:f,overrides:m,restricted:n.restricted}}filter(t,s,r,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:t,restricted:[]};const l={},f=[];for(let m in t)if(D.OVERRIDE_PROPERTY_PATTERN.test(m)&&r){const E=this.filter(t[m],s,!1,n);l[m]=E.raw,f.push(...E.restricted)}else{const E=s[m],S=E?typeof E.scope!="undefined"?E.scope:3:void 0;E?.restricted&&f.push(m),(S===void 0||n.scopes===void 0||n.scopes.includes(S))&&(n.skipRestricted&&E?.restricted||(l[m]=t[m]))}return{raw:l,restricted:f}}}e.ConfigurationModelParser=g;class w extends P.Disposable{constructor(t,s,r,n){super();this.userSettingsResource=t,this.scopes=s,this.fileService=n,this._onDidChange=this._register(new c.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(c.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new u}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=w;class _{constructor(t,s,r=new u,n=new u,l=new L.ResourceMap,f=new u,m=new L.ResourceMap,E=!0){this._defaultConfiguration=t,this._localUserConfiguration=s,this._remoteUserConfiguration=r,this._workspaceConfiguration=n,this._folderConfigurations=l,this._memoryConfiguration=f,this._memoryConfigurationByResource=m,this._freeze=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(t,s,r){return this.getConsolidateConfigurationModel(s,r).getValue(t)}updateValue(t,s,r={}){let n;r.resource?(n=this._memoryConfigurationByResource.get(r.resource),n||(n=new u,this._memoryConfigurationByResource.set(r.resource,n))):n=this._memoryConfiguration,s===void 0?n.removeValue(t):n.setValue(t,s),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,r){const n=this.getConsolidateConfigurationModel(s,r),l=this.getFolderConfigurationModelForResource(s.resource,r),f=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,m=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),E=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),S=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),o=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),k=r?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=l?s.overrideIdentifier?l.freeze().override(s.overrideIdentifier).getValue(t):l.freeze().getValue(t):void 0,$=s.overrideIdentifier?f.override(s.overrideIdentifier).getValue(t):f.getValue(t),G=n.getValue(t),re=C.distinct(C.flatten(n.overrides.map(j=>j.identifiers))).filter(j=>n.getOverrideValue(t,j)!==void 0);return{defaultValue:m,userValue:E,userLocalValue:S,userRemoteValue:o,workspaceValue:k,workspaceFolderValue:O,memoryValue:$,value:G,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,user:E!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userLocal:S!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userRemote:o!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspace:k!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:l?.freeze().getValue(t),override:s.overrideIdentifier?l?.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,memory:$!==void 0?{value:f.getValue(t),override:s.overrideIdentifier?f.getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:re.length?re:void 0}}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const r=s.filter(n=>D.OVERRIDE_PROPERTY_PATTERN.test(n)).map(n=>{const l=(0,D.overrideIdentifierFromKey)(n),f=this._defaultConfiguration.getKeysForOverrideIdentifier(l),m=t.getKeysForOverrideIdentifier(l),E=[...m.filter(S=>f.indexOf(S)===-1),...f.filter(S=>m.indexOf(S)===-1),...f.filter(S=>!T.equals(this._defaultConfiguration.override(l).getValue(S),t.override(l).getValue(S)))];return[l,E]});return this.updateDefaultConfiguration(t),{keys:s,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:r,removed:n,overrides:l}=(0,A.compare)(this.localUserConfiguration,t),f=[...s,...r,...n];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:r,removed:n,overrides:l}=(0,A.compare)(this.remoteUserConfiguration,t);let f=[...s,...r,...n];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:r,removed:n,overrides:l}=(0,A.compare)(this.workspaceConfiguration,t);let f=[...s,...r,...n];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:l}}compareAndUpdateFolderConfiguration(t,s){const r=this.folderConfigurations.get(t),{added:n,updated:l,removed:f,overrides:m}=(0,A.compare)(r,s);let E=[...n,...l,...f];return(E.length||!r)&&this.updateFolderConfiguration(t,s),{keys:E,overrides:m}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:n,removed:l,overrides:f}=(0,A.compare)(s,void 0);return{keys:[...r,...n,...l],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,s){let r=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},s){let r=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const n=s.getFolder(t);n&&(r=this.getFolderConsolidatedConfiguration(n.uri)||r);const l=this._memoryConfigurationByResource.get(t);l&&(r=r.merge(l))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const r=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(t);n?(s=r.merge(n),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(t,s)):s=r}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const r=s.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:r,overrides:n,keys:l}=this._folderConfigurations.get(s);return t.push([s,{contents:r,overrides:n,keys:l}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>t.add(s)),this.userConfiguration.freeze().keys.forEach(s=>t.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(n=>s.add(n))),[...s.values()]}static parse(t){const s=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),n=this.parseConfigurationModel(t.workspace),l=t.folders.reduce((f,m)=>(f.set(I.URI.revive(m[0]),this.parseConfigurationModel(m[1])),f),new L.ResourceMap);return new _(s,r,new u,n,l,new u,new L.ResourceMap,!1)}static parseConfigurationModel(t){return new u(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=_;function b(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const t=new Set,s=new Map;for(const n of v)n.keys.forEach(l=>t.add(l)),n.overrides.forEach(([l,f])=>{const m=(0,L.getOrSet)(s,l,new Set);f.forEach(E=>m.add(E))});const r=[];return s.forEach((n,l)=>r.push([l,[...n.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=b;class d{constructor(t,s,r,n){this.change=t,this.previous=s,this.currentConfiguraiton=r,this.currentWorkspace=n,this._previousConfiguration=void 0;const l=new Set;t.keys.forEach(m=>l.add(m)),t.overrides.forEach(([,m])=>m.forEach(E=>l.add(E))),this.affectedKeys=[...l.values()];const f=new u;this.affectedKeys.forEach(m=>f.setValue(m,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=_.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(s){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!T.equals(r,n)}return!0}return!1}doesAffectedKeysTreeContains(t,s){let r=(0,A.toValuesTree)({[s]:!0},()=>{}),n;for(;typeof r=="object"&&(n=Object.keys(r)[0]);){if(t=t[n],!t)return!1;r=r[n]}return!0}}e.ConfigurationChangeEvent=d;class h extends d{constructor(t,s,r,n){super({keys:t.allKeys(),overrides:[]},void 0,t,s);this.source=r,this.sourceConfig=n}}e.AllKeysConfigurationChangeEvent=h}),define(he[118],fe([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,p.createDecorator)("remoteAuthorityResolverService");var L;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class C extends Error{constructor(T,I=L.Unknown,D){super(T);this._message=T,this._code=I,this._detail=D,this.isHandled=I===L.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype)}static isTemporarilyNotAvailable(T){return T instanceof C&&T._code===L.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof C&&T._code===L.NoResolverFound}static isHandled(T){return T instanceof C&&T.isHandled}}e.RemoteAuthorityResolverError=C}),define(he[83],fe([0,1,10]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(A){return A.scheme===p.Schemas.vscodeRemote?A.authority:void 0}e.getRemoteAuthority=L;function C(A){if(!A)return;const i=A.indexOf("+");return i<0?A:A.substr(0,i)}e.getRemoteName=C;function y(A){return A.scheme!==p.Schemas.file&&A.scheme!==p.Schemas.vscodeRemote}e.isVirtualResource=y;function T(A){if(A.folders.length)return A.folders.every(i=>y(i.uri))?A.folders[0].uri:void 0;if(A.configuration&&y(A.configuration))return A.configuration}e.getVirtualWorkspaceLocation=T;function I(A){return T(A)?.scheme}e.getVirtualWorkspaceScheme=I;function D(A){return T(A)!==void 0}e.isVirtualWorkspace=D}),define(he[189],fe([0,1,3,11,4,12]),function(X,e,p,L,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,C.createDecorator)("tunnelService");var T;(function(u){u.Http="http",u.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(u){u[u.Notify=1]="Notify",u[u.OpenBrowser=2]="OpenBrowser",u[u.OpenPreview=3]="OpenPreview",u[u.Silent=4]="Silent",u[u.Ignore=5]="Ignore",u[u.OpenBrowserOnce=6]="OpenBrowserOnce"})(I=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function D(u){if(u.scheme!=="http"&&u.scheme!=="https")return;const a=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(u.authority);if(!!a)return{address:a[1],port:+a[2]}}e.extractLocalHostUriMetaDataForPortMapping=D,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function A(u){return e.LOCALHOST_ADDRESSES.indexOf(u)>=0}e.isLocalhost=A,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function i(u){return e.ALL_INTERFACES_ADDRESSES.indexOf(u)>=0}e.isAllInterfaces=i;function P(u,a){return a?a!==1&&u<1024:!L.isWindows&&u<1024}e.isPortPrivileged=P;let c=class{constructor(a){this.logService=a,this._onTunnelOpened=new p.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new p.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new p.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(a,g){return this._tunnelProvider=a,a?(this._canElevate=g.elevation,this._canMakePublic=g.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async a=>{const g=[],w=Array.from(this._tunnels.values());for(let _ of w){const b=Array.from(_.values());for(let d of b){const h=await d.value;h&&g.push(h)}}a(g)})}async dispose(){for(const a of this._tunnels.values()){for(const{value:g}of a.values())await g.then(w=>w?.dispose());a.clear()}this._tunnels.clear()}openTunnel(a,g,w,_,b=!1,d=!1,h){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${w} on local port ${_}.`),!a)return;g||(g="localhost");const v=this.retainOrCreateTunnel(a,g,w,_,b,d,h);return v?v.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,w);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(t);return(t.tunnelRemoteHost!==g||t.tunnelRemotePort!==w)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),v)}makeTunnel(a){return{tunnelRemotePort:a.tunnelRemotePort,tunnelRemoteHost:a.tunnelRemoteHost,tunnelLocalPort:a.tunnelLocalPort,localAddress:a.localAddress,public:a.public,protocol:a.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${a.tunnelRemoteHost}:${a.tunnelRemotePort} `);const g=this._tunnels.get(a.tunnelRemoteHost);if(g){const w=g.get(a.tunnelRemotePort);w&&(w.refcount--,await this.tryDisposeTunnel(a.tunnelRemoteHost,a.tunnelRemotePort,w))}}}}async tryDisposeTunnel(a,g,w){if(w.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${a}:${g}.`);const _=w.value.then(async b=>{b&&(await b.dispose(!0),this._onTunnelClosed.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this._tunnels.has(a)&&this._tunnels.get(a).delete(g),_}}async closeTunnel(a,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${a}:${g} `);const w=this._tunnels.get(a);if(w&&w.has(g)){const _=w.get(g);_.refcount=0,await this.tryDisposeTunnel(a,g,_)}}addTunnelToMap(a,g,w){this._tunnels.has(a)||this._tunnels.set(a,new Map),this._tunnels.get(a).set(g,{refcount:1,value:w})}async removeEmptyTunnelFromMap(a,g){const w=this._tunnels.get(a);w&&(await w.get(g)||w.delete(g),w.size===0&&this._tunnels.delete(a))}getTunnelFromMap(a,g){let w=[a];A(a)?(w.push(...e.LOCALHOST_ADDRESSES),w.push(...e.ALL_INTERFACES_ADDRESSES)):i(a)&&w.push(...e.ALL_INTERFACES_ADDRESSES);const _=w.map(b=>this._tunnels.get(b));for(const b of _){const d=b?.get(g);if(d)return d}}canTunnel(a){return!!D(a)}createWithProvider(a,g,w,_,b,d,h){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${w} on local port ${_}.`);const t={elevationRequired:b?P(_===void 0?w:_):!1},s={remoteAddress:{host:g,port:w},localAddressPort:_,public:d,protocol:h},r=a.forwardPort(s,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(g,w,r),r}};c=je([We(0,y.ILogService)],c),e.AbstractTunnelService=c}),define(he[190],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class p{vsda(){return new Promise((C,y)=>X(["vsda"],C,y))}async sign(C){try{const y=await this.vsda(),T=new y.signer;if(T)return T.sign(C)}catch(y){}return C}}e.SignService=p}),define(he[191],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class p{constructor(C){this._callback=C,this._terminalBufferMap=new Map}dispose(){for(const C of this._terminalBufferMap.values())C.dispose()}startBuffering(C,y,T=5){let I;return I=y(D=>{const A=typeof D=="string"?D:D.data;let i=this._terminalBufferMap.get(C);if(i){i.data.push(A);return}const P=setTimeout(()=>this.flushBuffer(C),T);i={data:[A],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(C),I.dispose()}},this._terminalBufferMap.set(C,i)}),I}stopBuffering(C){const y=this._terminalBufferMap.get(C);y&&y.dispose()}flushBuffer(C){const y=this._terminalBufferMap.get(C);y&&(this._terminalBufferMap.delete(C),this._callback(C,y.data.join("")))}}e.TerminalDataBufferer=p}),define(he[192],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var p;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(p=e.ColorScheme||(e.ColorScheme={}))}),define(he[193],fe([0,1,4,6,42,3,192,74]),function(X,e,p,L,C,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,p.createDecorator)("themeService");var D;(function(w){function _(b){return b&&typeof b=="object"&&typeof b.id=="string"}w.isThemeColor=_})(D=e.ThemeColor||(e.ThemeColor={}));function A(w){return{id:w}}e.themeColorFromId=A;var i;(function(w){function _(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||D.isThemeColor(s.color))}w.isThemeIcon=_;const b=new RegExp(`^\\$\\((${I.CSSIcon.iconNameExpression}(?:${I.CSSIcon.iconModifierExpression})?)\\)$`);function d(s){const r=b.exec(s);if(!r)return;let[,n]=r;return{id:n}}w.fromString=d;function h(s,r){let n=s.id;const l=n.lastIndexOf("~");return l!==-1&&(n=n.substring(0,l)),r&&(n=`${n}~${r}`),{id:n}}w.modify=h;function v(s,r){return s.id===r.id&&s.color?.id===r.color?.id}w.isEqual=v;function t(s,r){return{id:s.id,color:r?A(r):void 0}}w.asThemeIcon=t,w.asClassNameArray=I.CSSIcon.asClassNameArray,w.asClassName=I.CSSIcon.asClassName,w.asCSSSelector=I.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=I.Codicon.file,e.FolderThemeIcon=I.Codicon.folder;function P(w){switch(w){case T.ColorScheme.DARK:return"vs-dark";case T.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class c{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new y.Emitter}onColorThemeChange(_){return this.themingParticipants.push(_),this.onThemingParticipantAddedEmitter.fire(_),(0,L.toDisposable)(()=>{const b=this.themingParticipants.indexOf(_);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let u=new c;C.Registry.add(e.Extensions.ThemingContribution,u);function a(w){return u.onColorThemeChange(w)}e.registerThemingParticipant=a;class g extends L.Disposable{constructor(_){super();this.themeService=_,this.theme=_.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(_){this.theme=_,this.updateStyles()}updateStyles(){}getColor(_,b){let d=this.theme.getColor(_);return d&&b&&(d=b(d,this.theme)),d?d.toString():null}}e.Themable=g}),define(he[47],fe([0,1,2,24,4,23]),function(X,e,p,L,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var T;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function I(c){const u=c;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}e.isWorkspace=I;function D(c){const u=c;return!!(u&&typeof u=="object"&&p.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}e.isWorkspaceFolder=D;class A{constructor(u,a,g,w){this._id=u,this._configuration=g,this._ignorePathCasing=w,this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=a}update(u){this._id=u.id,this._configuration=u.configuration,this._ignorePathCasing=u._ignorePathCasing,this.folders=u.folders}get folders(){return this._folders}set folders(u){this._folders=u,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(u){this._configuration=u}getFolder(u){return u&&this._foldersMap.findSubstr(u.with({scheme:u.scheme,authority:u.authority,path:u.path}))||null}updateFoldersMap(){this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing);for(const u of this.folders)this._foldersMap.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=A;class i{constructor(u,a){this.raw=a,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,L.joinPath)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function P(c){return new i({uri:c,index:0,name:(0,L.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=P}),define(he[194],fe([0,1,4,158,47,2,11,9,24,135,54,10,76,29,83]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,L.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function w(N){return(typeof N=="string"?(0,I.extname)(N):(0,D.extname)(N))===g}e.hasWorkspaceFileExtension=w,e.IWorkspacesService=(0,p.createDecorator)("workspacesService");function _(N){return N.hasOwnProperty("workspace")}e.isRecentWorkspace=_;function b(N){return N.hasOwnProperty("folderUri")}e.isRecentFolder=b;function d(N){return N.hasOwnProperty("fileUri")}e.isRecentFile=d;function h(N){const x=N;return typeof x?.id=="string"&&y.URI.isUri(x.uri)}e.isSingleFolderWorkspaceIdentifier=h;function v(N){if(N.configuration)return{id:N.id,configPath:N.configuration};if(N.folders.length===1)return{id:N.id,uri:N.folders[0].uri}}e.toWorkspaceIdentifier=v;function t(N){const x=N;return typeof x?.id=="string"&&y.URI.isUri(x.configPath)}e.isWorkspaceIdentifier=t;function s(N){const x=N;if(x?.uri)return{id:x.id,uri:y.URI.revive(x.uri)};const R=N;if(R?.configPath)return{id:R.id,configPath:y.URI.revive(R.configPath)};if(N?.id)return{id:N.id}}e.reviveIdentifier=s;function r(N,x){return D.extUriBiasedIgnorePathCase.isEqualOrParent(N,x.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function n(N){return l(N)||f(N)}e.isStoredWorkspaceFolder=n;function l(N){const x=N;return typeof x?.path=="string"&&(!x.name||typeof x.name=="string")}e.isRawFileWorkspaceFolder=l;function f(N){const x=N;return typeof x?.uri=="string"&&(!x.name||typeof x.name=="string")}e.isRawUriWorkspaceFolder=f;function m(N,x,R,V,F=!T.isWindows,M){if(N.scheme!==V.scheme)return{name:R,uri:N.toString(!0)};let B=x?void 0:M.relativePath(V,N);if(B!==void 0)B.length===0?B=".":T.isWindows&&N.scheme===P.Schemas.file&&!F&&(B=B.replace(/\//g,"\\"));else if(N.scheme===P.Schemas.file)B=N.fsPath,T.isWindows&&(B=(0,c.normalizeDriveLetter)(B),F&&(B=(0,u.toSlashes)(B)));else{if(!M.isEqualAuthority(N.authority,V.authority))return{name:R,uri:N.toString(!0)};B=N.path}return{name:R,path:B}}e.getStoredWorkspaceFolder=m;function E(N,x,R){let V=[],F=new Set;const M=R.dirname(x);for(let B of N){let W;if(l(B))B.path&&(W=R.resolvePath(M,B.path));else if(f(B))try{W=y.URI.parse(B.uri),W.path[0]!=="/"&&(W=W.with({path:"/"+W.path}))}catch(Q){console.warn(Q)}if(W){let Q=R.getComparisonKey(W);if(!F.has(Q)){F.add(Q);const ae=B.name||R.basenameOrAuthority(W);V.push(new C.WorkspaceFolder({uri:W,name:ae,index:V.length},B))}}}return V}e.toWorkspaceFolders=E;function S(N,x,R,V,F){let M=o(x,N);const B=F.dirname(x),W=F.dirname(V),Q=[],ae=k(M.folders);for(const Me of M.folders){const Ve=l(Me)?F.resolvePath(B,Me.path):y.URI.parse(Me.uri);let He;R?He=!1:He=!l(Me)||(0,I.isAbsolute)(Me.path),Q.push(m(Ve,He,Me.name,W,ae,F))}const _e={insertSpaces:!1,tabSize:4,eol:T.isLinux||T.isMacintosh?`
`:`\r
`},Fe=A.setProperty(N,["folders"],Q,_e);let Ae=A.applyEdits(N,Fe);return M.remoteAuthority===(0,a.getRemoteAuthority)(V)&&(Ae=A.applyEdits(Ae,A.removeProperty(Ae,["remoteAuthority"],_e))),Ae}e.rewriteWorkspaceFileForNewLocation=S;function o(N,x){let R=i.parse(x);if(R&&Array.isArray(R.folders))R.folders=R.folders.filter(V=>n(V));else throw new Error(`${N} looks like an invalid workspace file.`);return R}function k(N){return T.isWindows?N.some(x=>l(x)&&x.path.indexOf("/")>=0):!0}e.useSlashForPath=k;function O(N){return N.workspace&&typeof N.workspace=="object"&&typeof N.workspace.id=="string"&&typeof N.workspace.configPath=="string"}function $(N){return typeof N.folderUri=="string"}function G(N){return typeof N.fileUri=="string"}function re(N,x){const R={workspaces:[],files:[]};if(N){const V=function(M,B){for(let W=0;W<M.length;W++)try{B(M[W],W)}catch(Q){x.warn(`Error restoring recent entry ${JSON.stringify(M[W])}: ${Q.toString()}. Skip entry.`)}},F=N;if(Array.isArray(F.entries))V(F.entries,M=>{const B=M.label,W=M.remoteAuthority;O(M)?R.workspaces.push({label:B,remoteAuthority:W,workspace:{id:M.workspace.id,configPath:y.URI.parse(M.workspace.configPath)}}):$(M)?R.workspaces.push({label:B,remoteAuthority:W,folderUri:y.URI.parse(M.folderUri)}):G(M)&&R.files.push({label:B,remoteAuthority:W,fileUri:y.URI.parse(M.fileUri)})});else{const M=N;Array.isArray(M.workspaces3)&&V(M.workspaces3,(B,W)=>{const Q=Array.isArray(M.workspaceLabels)&&M.workspaceLabels[W]||void 0;typeof B=="object"&&typeof B.id=="string"&&typeof B.configURIPath=="string"?R.workspaces.push({label:Q,workspace:{id:B.id,configPath:y.URI.parse(B.configURIPath)}}):typeof B=="string"&&R.workspaces.push({label:Q,folderUri:y.URI.parse(B)})}),Array.isArray(M.files2)&&V(M.files2,(B,W)=>{const Q=Array.isArray(M.fileLabels)&&M.fileLabels[W]||void 0;typeof B=="string"&&R.files.push({label:Q,fileUri:y.URI.parse(B)})})}}return R}e.restoreRecentlyOpened=re;function j(N){const x={entries:[]};for(const R of N.workspaces)b(R)?x.entries.push({folderUri:R.folderUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority}):x.entries.push({workspace:{id:R.workspace.id,configPath:R.workspace.configPath.toString()},label:R.label,remoteAuthority:R.remoteAuthority});for(const R of N.files)x.entries.push({fileUri:R.fileUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority});return x}e.toStoreData=j}),define(he[84],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class p{constructor(C){this.id=C,this._data=new Map,this._idPool=1}add(C){const y=this._idPool++;return this._data.set(y,C),this.logDebugInfo(),y}get(C,y){return this._data.has(C)?this._data.get(C)[y]:void 0}delete(C){this._data.delete(C),this.logDebugInfo()}logDebugInfo(){!p.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=p,p.enableDebugLogging=!1}),define(he[48],fe([0,1,2,3,4]),function(X,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class y{constructor(){this._onDidChangeTabs=new L.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(I){this._tabs=I.map(D=>({name:D.name,group:D.group,resource:p.URI.revive(D.resource),isActive:D.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=y}),define(he[59],fe([0,1,10,4]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(p.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(T,I){I===null?this._providerInfo.delete(T):this._providerInfo.set(T,I)}isFreeScheme(T){return!this._providerInfo.has(T)&&!this._systemSchemes.has(T)}getCapabilities(T){return this._providerInfo.get(T)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=(0,L.createDecorator)("IExtHostFileSystemInfo")}),define(he[27],fe([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,p.createDecorator)("IExtHostInitDataService")}),define(he[195],fe([0,1,2]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class L{constructor(y,T,I){this._extHostNotebooks=T,this._textDocumentsAndEditors=I}$willAddInteractiveDocument(y,T,I,D){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],modeId:I,uri:y,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(p.URI.revive(D))?.apiNotebook}]})}$willRemoveInteractiveDocument(y,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[y]})}}e.ExtHostInteractive=L}),define(he[196],fe([0,1,17]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(T,I,D){this._deferredPromises=new Map,this._id=T,this._shared=I,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(A=>(this._value=A,this)),this._storageListener=this._storage.onDidChangeStorage(A=>{A.shared===this._shared&&A.key===this._id&&(this._value=A.value)}),this._scheduler=new p.RunOnceScheduler(()=>{const A=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of A.values())i.complete()}catch(i){for(const P of A.values())P.error(i)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,I){let D=this._value[T];return typeof D=="undefined"&&(D=I),D}update(T,I){this._value[T]=I;let D=this._deferredPromises.get(T);if(D!==void 0)return D.p;const A=new p.DeferredPromise;return this._deferredPromises.set(T,A),this._scheduler.isScheduled()||this._scheduler.schedule(),A.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class C extends L{constructor(T,I){super(T.identifier.value,!0,I);this._extension=T}setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}}e.ExtensionGlobalMemento=C}),define(he[197],fe([0,1,3,2,12]),function(X,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let y=class{constructor(I,D){this._logService=I,this._notebooksAndEditors=D,this._onDidChangeNotebookDocumentMetadata=new p.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new p.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(I,D,A){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(I)).acceptModelChanged(D,A)}$acceptDirtyStateChanged(I,D){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(I)).acceptDirty(D)}$acceptModelSaved(I){const D=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(I));this._onDidSaveNotebookDocument.fire(D.apiNotebook)}$acceptDocumentPropertiesChanged(I,D){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",I.path,D);const A=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(I));A.acceptDocumentPropertiesChanged(D),D.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:A.apiNotebook})}};y=je([We(0,C.ILogService)],y),e.ExtHostNotebookDocuments=y}),define(he[13],fe([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,p.createDecorator)("IExtHostRpcService");class L{constructor(y){this.getProxy=y.getProxy.bind(y),this.set=y.set.bind(y),this.assertRegistered=y.assertRegistered.bind(y),this.drain=y.drain.bind(y)}}e.ExtHostRpcService=L});var nt=this&&this.__classPrivateFieldSet||function(X,e,p,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!L:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(X):L?L.value:e.get(X)};define(he[198],fe([0,1,26,3]),function(X,e,p,L){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class y{constructor(I,D){C.set(this,void 0),this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=p.ExtensionIdentifier.toKey(I.identifier),nt(this,C,D,"f"),Ue(this,C,"f").onDidChangePassword(A=>{A.extensionId===this._id&&this._onDidChange.fire({key:A.key})})}get(I){return Ue(this,C,"f").get(this._id,I)}store(I,D){return Ue(this,C,"f").store(this._id,I,D)}delete(I){return Ue(this,C,"f").delete(this._id,I)}}e.ExtensionSecrets=y,C=new WeakMap}),define(he[119],fe([0,1,4,3]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class C{constructor(){this._onDidChangeTelemetryEnabled=new L.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(T){this._enabled=T}$onDidChangeTelemetryEnabled(T){this._enabled=T,this._onDidChangeTelemetryEnabled.fire(T)}}e.ExtHostTelemetry=C,e.IExtHostTelemetry=(0,p.createDecorator)("IExtHostTelemetry")}),define(he[85],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemImpl=e.createTestItemCollection=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var p;(function(g){g[g.Upsert=0]="Upsert",g[g.RemoveChild=1]="RemoveChild",g[g.Invalidated=2]="Invalidated",g[g.SetProp=3]="SetProp",g[g.Bulk=4]="Bulk"})(p=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const L=new WeakMap,C=g=>{let w=L.get(g);return w||(w={},L.set(g,w)),w};e.getPrivateApiFor=C;const y=(g,w,_,b)=>{let d=_;return{enumerable:!0,configurable:!1,get(){return d},set(h){b(d,h)||(d=h,g.listener?.({op:3,key:w,value:h}))}}},T=(g,w)=>g===w,I={range:(g,w)=>g===w?!0:!g||!w?!1:g.isEqual(w),label:T,description:T,busy:T,error:T,canResolveChildren:T},D=Object.keys(I),A=(g,w)=>({range:y(g,"range",void 0,I.range),label:y(g,"label",w,I.label),description:y(g,"description",void 0,I.description),canResolveChildren:y(g,"canResolveChildren",!1,I.canResolveChildren),busy:y(g,"busy",!1,I.busy),error:y(g,"error",void 0,I.error)}),i=(g,w)=>{const _=new Map;for(const b of D)I[b](g[b],w[b])||_.set(b,w[b]);return _};e.diffTestItems=i;class P extends Error{constructor(w){super(`Attempted to insert a duplicate test item ID ${w}`)}}e.DuplicateTestItemError=P;class c extends Error{constructor(w){super(`TestItem with ID "${w}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=c;const u=g=>{const w=(0,e.getPrivateApiFor)(g);let _,b=new Map;return{get all(){return _||(_=Object.freeze([...b.values()])),_},set all(d){const h=new Map,v=new Set(b.keys()),t={op:4,ops:[]};for(const s of d){if(!(s instanceof a))throw new c(s.id);if(h.has(s.id))throw new P(s.id);h.set(s.id,s),v.delete(s.id),t.ops.push({op:0,item:s})}for(const s of v.keys())t.ops.push({op:1,id:s});w.listener?.(t),b=h,_=void 0},add(d){if(!(d instanceof a))throw new c(d.id);b.set(d.id,d),_=void 0,w.listener?.({op:0,item:d})},remove(d){b.delete(d)&&(_=void 0,w.listener?.({op:1,id:d}))},get(d){return b.get(d)},toJSON(){return this.all}}};e.createTestItemCollection=u;class a{constructor(w,_,b){const d=(0,e.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:w,enumerable:!0,writable:!1},uri:{value:b,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent}},children:{value:(0,e.createTestItemCollection)(this),enumerable:!0,writable:!1},...A(d,_)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=a}),define(he[49],fe([0,1,4,3,13]),function(X,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var y;(function(I){function D(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,protocol:i.protocol}}I.fromApiTunnel=D;function A(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.public,protocol:i.protocol}}I.fromServiceTunnel=A})(y=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,p.createDecorator)("IExtHostTunnelService");let T=class{constructor(D){this.onDidChangeTunnels=new L.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,A){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,A){return{dispose:()=>{}}}async $providePortAttributes(D,A,i,P,c){return[]}async $forwardPort(D,A){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=je([We(0,C.IExtHostRpcService)],T),e.ExtHostTunnelService=T});var nt=this&&this.__classPrivateFieldSet||function(X,e,p,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!L:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(X):L?L.value:e.get(X)};define(he[7],fe([0,1,18,15,96,23,99,14,2,32,41,118]),function(X,e,p,L,C,y,T,I,D,A,i,P){"use strict";var c,u,a,g,w,_,b,d,h,v,t,s,r,n,l,f,m,E,S,o;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestMessage=e.TestRunRequest=e.TestRunConfigurationGroup=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function k(H){function U(){return Reflect.construct(H,arguments,this.constructor)}return Object.defineProperty(U,"name",Object.getOwnPropertyDescriptor(H,"name")),Object.setPrototypeOf(U,H),Object.setPrototypeOf(U.prototype,H.prototype),U}let O=w=class{constructor(U){c.set(this,void 0),nt(this,c,U,"f")}static from(...U){let ie=U;return new w(function(){if(ie){for(const Pe of ie)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();ie=void 0}})}dispose(){typeof Ue(this,c,"f")=="function"&&(Ue(this,c,"f").call(this),nt(this,c,void 0,"f"))}};c=new WeakMap,O=w=je([k],O),e.Disposable=O;let $=_=class{constructor(U,ie){if(U<0)throw(0,L.illegalArgument)("line must be non-negative");if(ie<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=U,this._character=ie}static Min(...U){if(U.length===0)throw new TypeError;let ie=U[0];for(let Pe=1;Pe<U.length;Pe++){const Ye=U[Pe];Ye.isBefore(ie)&&(ie=Ye)}return ie}static Max(...U){if(U.length===0)throw new TypeError;let ie=U[0];for(let Pe=1;Pe<U.length;Pe++){const Ye=U[Pe];Ye.isAfter(ie)&&(ie=Ye)}return ie}static isPosition(U){if(!U)return!1;if(U instanceof _)return!0;let{line:ie,character:Pe}=U;return typeof ie=="number"&&typeof Pe=="number"}get line(){return this._line}get character(){return this._character}isBefore(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<U._character}isBeforeOrEqual(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<=U._character}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this._line===U._line&&this._character===U._character}compareTo(U){return this._line<U._line?-1:this._line>U.line?1:this._character<U._character?-1:this._character>U._character?1:0}translate(U,ie=0){if(U===null||ie===null)throw(0,L.illegalArgument)();let Pe;return typeof U=="undefined"?Pe=0:typeof U=="number"?Pe=U:(Pe=typeof U.lineDelta=="number"?U.lineDelta:0,ie=typeof U.characterDelta=="number"?U.characterDelta:0),Pe===0&&ie===0?this:new _(this.line+Pe,this.character+ie)}with(U,ie=this.character){if(U===null||ie===null)throw(0,L.illegalArgument)();let Pe;return typeof U=="undefined"?Pe=this.line:typeof U=="number"?Pe=U:(Pe=typeof U.line=="number"?U.line:this.line,ie=typeof U.character=="number"?U.character:this.character),Pe===this.line&&ie===this.character?this:new _(Pe,ie)}toJSON(){return{line:this.line,character:this.character}}};$=_=je([k],$),e.Position=$;let G=b=class{constructor(U,ie,Pe,Ye){let it,st;if(typeof U=="number"&&typeof ie=="number"&&typeof Pe=="number"&&typeof Ye=="number"?(it=new $(U,ie),st=new $(Pe,Ye)):U instanceof $&&ie instanceof $&&(it=U,st=ie),!it||!st)throw new Error("Invalid arguments");it.isBefore(st)?(this._start=it,this._end=st):(this._start=st,this._end=it)}static isRange(U){return U instanceof b?!0:U?$.isPosition(U.start)&&$.isPosition(U.end):!1}get start(){return this._start}get end(){return this._end}contains(U){return U instanceof b?this.contains(U._start)&&this.contains(U._end):U instanceof $?!(U.isBefore(this._start)||this._end.isBefore(U)):!1}isEqual(U){return this._start.isEqual(U._start)&&this._end.isEqual(U._end)}intersection(U){const ie=$.Max(U.start,this._start),Pe=$.Min(U.end,this._end);if(!ie.isAfter(Pe))return new b(ie,Pe)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const ie=$.Min(U.start,this._start),Pe=$.Max(U.end,this.end);return new b(ie,Pe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(U,ie=this.end){if(U===null||ie===null)throw(0,L.illegalArgument)();let Pe;return U?$.isPosition(U)?Pe=U:(Pe=U.start||this.start,ie=U.end||this.end):Pe=this.start,Pe.isEqual(this._start)&&ie.isEqual(this.end)?this:new b(Pe,ie)}toJSON(){return[this.start,this.end]}};G=b=je([k],G),e.Range=G;let re=d=class extends G{constructor(U,ie,Pe,Ye){let it,st;if(typeof U=="number"&&typeof ie=="number"&&typeof Pe=="number"&&typeof Ye=="number"?(it=new $(U,ie),st=new $(Pe,Ye)):U instanceof $&&ie instanceof $&&(it=U,st=ie),!it||!st)throw new Error("Invalid arguments");super(it,st);this._anchor=it,this._active=st}static isSelection(U){return U instanceof d?!0:U?G.isRange(U)&&$.isPosition(U.anchor)&&$.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};re=d=je([k],re),e.Selection=re;class j{constructor(U,ie,Pe){if(typeof U!="string"||U.length===0)throw(0,L.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,L.illegalArgument)("port");if(typeof Pe!="undefined"&&(typeof Pe!="string"||Pe.length===0||!/^[0-9A-Za-z\-]+$/.test(Pe)))throw(0,L.illegalArgument)("connectionToken");this.host=U,this.port=Math.round(ie),this.connectionToken=Pe}}e.ResolvedAuthority=j;class N extends Error{constructor(U,ie=P.RemoteAuthorityResolverErrorCode.Unknown,Pe){super(U);this._message=U,this._code=ie,this._detail=Pe,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,N.prototype)}static NotAvailable(U,ie){return new N(U,P.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(U){return new N(U,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=N;var x;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(x=e.EndOfLine||(e.EndOfLine={}));var R;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(R=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let V=h=class{constructor(U,ie){this._range=U,this._newText=ie}static isTextEdit(U){return U instanceof h?!0:U?G.isRange(U)&&typeof U.newText=="string":!1}static replace(U,ie){return new h(U,ie)}static insert(U,ie){return h.replace(new G(U,U),ie)}static delete(U){return h.replace(U,"")}static setEndOfLine(U){const ie=new h(new G(new $(0,0),new $(0,0)),"");return ie.newEol=U,ie}get range(){return this._range}set range(U){if(U&&!G.isRange(U))throw(0,L.illegalArgument)("range");this._range=U}get newText(){return this._newText||""}set newText(U){if(U&&typeof U!="string")throw(0,L.illegalArgument)("newText");this._newText=U}get newEol(){return this._newEol}set newEol(U){if(U&&typeof U!="number")throw(0,L.illegalArgument)("newEol");this._newEol=U}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};V=h=je([k],V),e.TextEdit=V;var F;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace"})(F=e.FileEditType||(e.FileEditType={}));let M=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(U,ie,Pe,Ye){this._edits.push({_type:1,from:U,to:ie,options:Pe,metadata:Ye})}createFile(U,ie,Pe){this._edits.push({_type:1,from:void 0,to:U,options:ie,metadata:Pe})}deleteFile(U,ie,Pe){this._edits.push({_type:1,from:U,to:void 0,options:ie,metadata:Pe})}replaceNotebookMetadata(U,ie,Pe){this._edits.push({_type:3,metadata:Pe,uri:U,edit:{editType:5,metadata:ie},notebookMetadata:ie})}replaceNotebookCells(U,ie,Pe,Ye,it){let st,ot,St=[],It;if(Bt.isNotebookRange(ie)&&Mt.isNotebookCellDataArray(Pe)&&!Mt.isNotebookCellDataArray(Ye)?(st=ie.start,ot=ie.end,St=Pe,It=Ye):typeof ie=="number"&&typeof Pe=="number"&&Mt.isNotebookCellDataArray(Ye)&&(st=ie,ot=Pe,St=Ye,It=it),st===void 0||ot===void 0)throw new Error("Invalid arguments");(st!==ot||St.length>0)&&this._edits.push({_type:5,uri:U,index:st,count:ot-st,cells:St,metadata:It})}replaceNotebookCellMetadata(U,ie,Pe,Ye){this._edits.push({_type:3,metadata:Ye,uri:U,edit:{editType:8,index:ie,metadata:Pe}})}replace(U,ie,Pe,Ye){this._edits.push({_type:2,uri:U,edit:new V(ie,Pe),metadata:Ye})}insert(U,ie,Pe,Ye){this.replace(U,new G(ie,ie),Pe,Ye)}delete(U,ie,Pe){this.replace(U,ie,"",Pe)}has(U){return this._edits.some(ie=>ie._type===2&&ie.uri.toString()===U.toString())}set(U,ie){if(ie)for(const Pe of ie)Pe&&this._edits.push({_type:2,uri:U,edit:Pe});else{for(let Pe=0;Pe<this._edits.length;Pe++){const Ye=this._edits[Pe];Ye._type===2&&Ye.uri.toString()===U.toString()&&(this._edits[Pe]=void 0)}(0,p.coalesceInPlace)(this._edits)}}get(U){const ie=[];for(let Pe of this._edits)Pe._type===2&&Pe.uri.toString()===U.toString()&&ie.push(Pe.edit);return ie}entries(){const U=new y.ResourceMap;for(let ie of this._edits)if(ie._type===2){let Pe=U.get(ie.uri);Pe||(Pe=[ie.uri,[]],U.set(ie.uri,Pe)),Pe[1].push(ie.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};M=je([k],M),e.WorkspaceEdit=M;let B=v=class{constructor(U){this._tabstop=1,this.value=U||""}static isSnippetString(U){return U instanceof v?!0:U?typeof U.value=="string":!1}static _escape(U){return U.replace(/\$|}|\\/g,"\\$&")}appendText(U){return this.value+=v._escape(U),this}appendTabstop(U=this._tabstop++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,ie=this._tabstop++){if(typeof U=="function"){const Pe=new v;Pe._tabstop=this._tabstop,U(Pe),this._tabstop=Pe._tabstop,U=Pe.value}else U=v._escape(U);return this.value+="${",this.value+=ie,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,ie=this._tabstop++){const Pe=U.map(Ye=>Ye.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable(U,ie){if(typeof ie=="function"){const Pe=new v;Pe._tabstop=this._tabstop,ie(Pe),this._tabstop=Pe._tabstop,ie=Pe.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};B=v=je([k],B),e.SnippetString=B;var W;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(W=e.DiagnosticTag||(e.DiagnosticTag={}));var Q;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(Q=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ae=t=class{constructor(U,ie){if(this.uri=U,ie)if(ie instanceof G)this.range=ie;else if(ie instanceof $)this.range=new G(ie,ie);else throw new Error("Illegal argument")}static isLocation(U){return U instanceof t?!0:U?G.isRange(U.range)&&D.URI.isUri(U.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ae=t=je([k],ae),e.Location=ae;let _e=class{constructor(U,ie){this.location=U,this.message=ie}static is(U){return U?typeof U.message=="string"&&U.location&&G.isRange(U.location.range)&&D.URI.isUri(U.location.uri):!1}static isEqual(U,ie){return U===ie?!0:!U||!ie?!1:U.message===ie.message&&U.location.range.isEqual(ie.location.range)&&U.location.uri.toString()===ie.location.uri.toString()}};_e=je([k],_e),e.DiagnosticRelatedInformation=_e;let Fe=class{constructor(U,ie,Pe=Q.Error){if(!G.isRange(U))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=U,this.message=ie,this.severity=Pe}toJSON(){return{severity:Q[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,ie){return U===ie?!0:!U||!ie?!1:U.message===ie.message&&U.severity===ie.severity&&U.code===ie.code&&U.severity===ie.severity&&U.source===ie.source&&U.range.isEqual(ie.range)&&(0,p.equals)(U.tags,ie.tags)&&(0,p.equals)(U.relatedInformation,ie.relatedInformation,_e.isEqual)}};Fe=je([k],Fe),e.Diagnostic=Fe;let Ae=class{constructor(U,ie){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=ie}};Ae=je([k],Ae),e.Hover=Ae;var Me;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(Me=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ve=class{constructor(U,ie=Me.Text){this.range=U,this.kind=ie}toJSON(){return{range:this.range,kind:Me[this.kind]}}};Ve=je([k],Ve),e.DocumentHighlight=Ve;var He;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(He=e.SymbolKind||(e.SymbolKind={}));var z;(function(H){H[H.Deprecated=1]="Deprecated"})(z=e.SymbolTag||(e.SymbolTag={}));let J=s=class{constructor(U,ie,Pe,Ye,it){this.name=U,this.kind=ie,this.containerName=it,typeof Pe=="string"&&(this.containerName=Pe),Ye instanceof ae?this.location=Ye:Pe instanceof G&&(this.location=new ae(Ye,Pe)),s.validate(this)}static validate(U){if(!U.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:He[this.kind],location:this.location,containerName:this.containerName}}};J=s=je([k],J),e.SymbolInformation=J;let ne=r=class{constructor(U,ie,Pe,Ye,it){this.name=U,this.detail=ie,this.kind=Pe,this.range=Ye,this.selectionRange=it,this.children=[],r.validate(this)}static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children&&U.children.forEach(r.validate)}};ne=r=je([k],ne),e.DocumentSymbol=ne;var oe;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(oe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let we=class{constructor(U,ie){this.title=U,this.kind=ie}};we=je([k],we),e.CodeAction=we;let Z=n=class{constructor(U){this.value=U}append(U){return new n(this.value?this.value+n.sep+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+n.sep)}};Z.sep=".",Z=n=je([k],Z),e.CodeActionKind=Z,Z.Empty=new Z(""),Z.QuickFix=Z.Empty.append("quickfix"),Z.Refactor=Z.Empty.append("refactor"),Z.RefactorExtract=Z.Refactor.append("extract"),Z.RefactorInline=Z.Refactor.append("inline"),Z.RefactorRewrite=Z.Refactor.append("rewrite"),Z.Source=Z.Empty.append("source"),Z.SourceOrganizeImports=Z.Source.append("organizeImports"),Z.SourceFixAll=Z.Source.append("fixAll");let de=class{constructor(U,ie){if(this.range=U,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};de=je([k],de),e.SelectionRange=de;class Ie{constructor(U,ie,Pe,Ye,it,st){this.kind=U,this.name=ie,this.detail=Pe,this.uri=Ye,this.range=it,this.selectionRange=st}}e.CallHierarchyItem=Ie;class Be{constructor(U,ie){this.fromRanges=ie,this.from=U}}e.CallHierarchyIncomingCall=Be;class qe{constructor(U,ie){this.fromRanges=ie,this.to=U}}e.CallHierarchyOutgoingCall=qe;let Ee=class{constructor(U,ie){this.range=U,this.command=ie}get isResolved(){return!!this.command}};Ee=je([k],Ee),e.CodeLens=Ee;let tt=l=class{constructor(U,ie=!1){u.set(this,void 0),nt(this,u,new C.MarkdownString(U,{supportThemeIcons:ie}),"f")}static isMarkdownString(U){return U instanceof l?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}get value(){return Ue(this,u,"f").value}set value(U){Ue(this,u,"f").value=U}get isTrusted(){return Ue(this,u,"f").isTrusted}set isTrusted(U){Ue(this,u,"f").isTrusted=U}get supportThemeIcons(){return Ue(this,u,"f").supportThemeIcons}set supportThemeIcons(U){Ue(this,u,"f").supportThemeIcons=U}appendText(U){return Ue(this,u,"f").appendText(U),this}appendMarkdown(U){return Ue(this,u,"f").appendMarkdown(U),this}appendCodeblock(U,ie){return Ue(this,u,"f").appendCodeblock(ie??"",U),this}};u=new WeakMap,tt=l=je([k],tt),e.MarkdownString=tt;let K=class{constructor(U,ie){this.label=U,this.documentation=ie}};K=je([k],K),e.ParameterInformation=K;let ee=class{constructor(U,ie){this.label=U,this.documentation=ie,this.parameters=[]}};ee=je([k],ee),e.SignatureInformation=ee;let pe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};pe=je([k],pe),e.SignatureHelp=pe;var xe;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(xe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var $e;(function(H){H[H.Other=0]="Other",H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})($e=e.InlayHintKind||(e.InlayHintKind={}));let et=class{constructor(U,ie,Pe){this.text=U,this.position=ie,this.kind=Pe}};et=je([k],et),e.InlayHint=et;var ke;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ke=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ce;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(Ce=e.CompletionItemKind||(e.CompletionItemKind={}));var Re;(function(H){H[H.Deprecated=1]="Deprecated"})(Re=e.CompletionItemTag||(e.CompletionItemTag={}));let se=class{constructor(U,ie){this.label=U,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&Ce[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};se=je([k],se),e.CompletionItem=se;let le=class{constructor(U=[],ie=!1){this.items=U,this.isIncomplete=ie}};le=je([k],le),e.CompletionList=le;let me=class{constructor(U,ie,Pe){this.text=U,this.range=ie,this.command=Pe}};me=je([k],me),e.InlineSuggestion=me;let be=class{constructor(U){this.items=U}};be=je([k],be),e.InlineSuggestions=be;var q;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(q=e.ViewColumn||(e.ViewColumn={}));var ge;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(ge=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ye;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(ye=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Te;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(Te=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Oe;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Oe=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ge;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(Ge=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ze;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(Ze=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Qe;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(Qe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(H){function U(ie){switch(ie){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=U}(Ge=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Xe=class{constructor(U,ie){if(ie&&!D.URI.isUri(ie))throw(0,L.illegalArgument)("target");if(!G.isRange(U)||U.isEmpty)throw(0,L.illegalArgument)("range");this.range=U,this.target=ie}};Xe=je([k],Xe),e.DocumentLink=Xe;let at=class{constructor(U,ie,Pe,Ye){this.red=U,this.green=ie,this.blue=Pe,this.alpha=Ye}};at=je([k],at),e.Color=at;let ut=class{constructor(U,ie){if(ie&&!(ie instanceof at))throw(0,L.illegalArgument)("color");if(!G.isRange(U)||U.isEmpty)throw(0,L.illegalArgument)("range");this.range=U,this.color=ie}};ut=je([k],ut),e.ColorInformation=ut;let bt=class{constructor(U){if(!U||typeof U!="string")throw(0,L.illegalArgument)("label");this.label=U}};bt=je([k],bt),e.ColorPresentation=bt;var ve;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(ve=e.ColorFormat||(e.ColorFormat={}));var De;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(De=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class ce{constructor(U,ie,Pe){if(this.startIndex=U,this.length=ie,this.tooltip=Pe,typeof U!="number"||U<0)throw(0,L.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,L.illegalArgument)("length");if(Pe!==void 0&&typeof Pe!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=ce;class Y{constructor(U){this.options=U,typeof U!="object"&&(0,L.illegalArgument)("options")}}e.TerminalProfile=Y;var Se;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(Se=e.TaskRevealKind||(e.TaskRevealKind={}));var ze;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(ze=e.TaskPanelKind||(e.TaskPanelKind={}));let Je=f=class{constructor(U,ie){if(typeof U!="string"||typeof ie!="string")throw(0,L.illegalArgument)("name");this._id=U}static from(U){switch(U){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}get id(){return this._id}};Je.Clean=new f("clean","Clean"),Je.Build=new f("build","Build"),Je.Rebuild=new f("rebuild","Rebuild"),Je.Test=new f("test","Test"),Je=f=je([k],Je),e.TaskGroup=Je;function Ke(H){let U="";for(let ie=0;ie<H.length;ie++)U+=H[ie].replace(/,/g,",,")+",";return U}let lt=class{constructor(U,ie,Pe){if(typeof U!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=U,ie!==void 0&&(Array.isArray(ie)?(this._args=ie,this._options=Pe):this._options=ie)}get process(){return this._process}set process(U){if(typeof U!="string")throw(0,L.illegalArgument)("process");this._process=U}get args(){return this._args}set args(U){Array.isArray(U)||(U=[]),this._args=U}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("process"),this._process!==void 0&&U.push(this._process),this._args&&this._args.length>0)for(let ie of this._args)U.push(ie);return Ke(U)}};lt=je([k],lt),e.ProcessExecution=lt;let ht=class{constructor(U,ie,Pe){if(this._args=[],Array.isArray(ie)){if(!U)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,L.illegalArgument)("command");this._command=U,this._args=ie,this._options=Pe}else{if(typeof U!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=U,this._options=ie}}get commandLine(){return this._commandLine}set commandLine(U){if(typeof U!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=U}get command(){return this._command?this._command:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,L.illegalArgument)("command");this._command=U}get args(){return this._args}set args(U){this._args=U||[]}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("shell"),this._commandLine!==void 0&&U.push(this._commandLine),this._command!==void 0&&U.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ie of this._args)U.push(typeof ie=="string"?ie:ie.value);return Ke(U)}};ht=je([k],ht),e.ShellExecution=ht;var yt;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(yt=e.ShellQuoting||(e.ShellQuoting={}));var Ct;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(Ct=e.TaskScope||(e.TaskScope={}));class Et{constructor(U){this._callback=U}computeId(){return"customExecution"+(0,A.generateUuid)()}set callback(U){this._callback=U}get callback(){return this._callback}}e.CustomExecution=Et;let vt=m=class{constructor(U,ie,Pe,Ye,it,st){this.__deprecated=!1,this._definition=this.definition=U;let ot;typeof ie=="string"?(this._name=this.name=ie,this._source=this.source=Pe,this.execution=Ye,ot=it,this.__deprecated=!0):ie===Ct.Global||ie===Ct.Workspace?(this.target=ie,this._name=this.name=Pe,this._source=this.source=Ye,this.execution=it,ot=st):(this.target=ie,this._name=this.name=Pe,this._source=this.source=Ye,this.execution=it,ot=st),typeof ot=="string"?(this._problemMatchers=[ot],this._hasDefinedMatchers=!0):Array.isArray(ot)?(this._problemMatchers=ot,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(U){this.__id=U}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof lt?this._definition={type:m.ProcessType,id:this._execution.computeId()}:this._execution instanceof ht?this._definition={type:m.ShellType,id:this._execution.computeId()}:this._execution instanceof Et?this._definition={type:m.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:m.EmptyType,id:(0,A.generateUuid)()}}get definition(){return this._definition}set definition(U){if(U==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=U}get scope(){return this._scope}set target(U){this.clear(),this._scope=U}get name(){return this._name}set name(U){if(typeof U!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=U}get execution(){return this._execution}set execution(U){U===null&&(U=void 0),this.clear(),this._execution=U;const ie=this._definition.type;(m.EmptyType===ie||m.ProcessType===ie||m.ShellType===ie||m.ExtensionCallbackType===ie)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(U){if(Array.isArray(U))this.clear(),this._problemMatchers=U,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.clear(),this._isBackground=U}get source(){return this._source}set source(U){if(typeof U!="string"||U.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=U}get group(){return this._group}set group(U){U===null&&(U=void 0),this.clear(),this._group=U}get detail(){return this._detail}set detail(U){U===null&&(U=void 0),this._detail=U}get presentationOptions(){return this._presentationOptions}set presentationOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._presentationOptions=U}get runOptions(){return this._runOptions}set runOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._runOptions=U}};vt.ExtensionCallbackType="customExecution",vt.ProcessType="process",vt.ShellType="shell",vt.EmptyType="$empty",vt=m=je([k],vt),e.Task=vt;var _t;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(_t=e.ProgressLocation||(e.ProgressLocation={}));let dt=class{constructor(U,ie=wt.None){this.collapsibleState=ie,D.URI.isUri(U)?this.resourceUri=U:this.label=U}};dt=je([k],dt),e.TreeItem=dt;var wt;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(wt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let ft=class{constructor(U,ie){this.id=U,this.color=ie}};ft=je([k],ft),e.ThemeIcon=ft,ft.File=new ft("file"),ft.Folder=new ft("folder");let Nt=class{constructor(U){this.id=U}};Nt=je([k],Nt),e.ThemeColor=Nt;var Pt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(Pt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Kt=class{constructor(U,ie){if(typeof U!="string"&&(!U||!D.URI.isUri(U)&&!D.URI.isUri(U.uri)))throw(0,L.illegalArgument)("base");if(typeof ie!="string")throw(0,L.illegalArgument)("pattern");typeof U=="string"?(this.baseFolder=D.URI.file(U),this.base=U):D.URI.isUri(U)?(this.baseFolder=U,this.base=U.fsPath):(this.baseFolder=U.uri,this.base=U.uri.fsPath),this.pattern=ie}};Kt=je([k],Kt),e.RelativePattern=Kt;let Ut=class{constructor(U,ie,Pe,Ye){this.enabled=typeof U=="boolean"?U:!0,typeof ie=="string"&&(this.condition=ie),typeof Pe=="string"&&(this.hitCondition=Pe),typeof Ye=="string"&&(this.logMessage=Ye)}get id(){return this._id||(this._id=(0,A.generateUuid)()),this._id}};Ut=je([k],Ut),e.Breakpoint=Ut;let kt=class extends Ut{constructor(U,ie,Pe,Ye,it){super(ie,Pe,Ye,it);if(U===null)throw(0,L.illegalArgument)("location");this.location=U}};kt=je([k],kt),e.SourceBreakpoint=kt;let Qt=class extends Ut{constructor(U,ie,Pe,Ye,it){super(ie,Pe,Ye,it);this.functionName=U}};Qt=je([k],Qt),e.FunctionBreakpoint=Qt;let Xt=class extends Ut{constructor(U,ie,Pe,Ye,it,st,ot){super(Ye,it,st,ot);if(!ie)throw(0,L.illegalArgument)("dataId");this.label=U,this.dataId=ie,this.canPersist=Pe}};Xt=je([k],Xt),e.DataBreakpoint=Xt;let mt=class{constructor(U,ie,Pe){this.command=U,this.args=ie||[],this.options=Pe}};mt=je([k],mt),e.DebugAdapterExecutable=mt;let jt=class{constructor(U,ie){this.port=U,this.host=ie}};jt=je([k],jt),e.DebugAdapterServer=jt;let zt=class{constructor(U){this.path=U}};zt=je([k],zt),e.DebugAdapterNamedPipeServer=zt;let Yt=class{constructor(U){this.implementation=U}};Yt=je([k],Yt),e.DebugAdapterInlineImplementation=Yt;let Jt=class{constructor(U,ie){this.range=U,this.expression=ie}};Jt=je([k],Jt),e.EvaluatableExpression=Jt;var At;(function(H){H[H.Automatic=0]="Automatic",H[H.Explicit=1]="Explicit"})(At=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let qt=class{constructor(U,ie){this.range=U,this.text=ie}};qt=je([k],qt),e.InlineValueText=qt;let Zt=class{constructor(U,ie,Pe=!0){this.range=U,this.variableName=ie,this.caseSensitiveLookup=Pe}};Zt=je([k],Zt),e.InlineValueVariableLookup=Zt;let Ht=class{constructor(U,ie){this.range=U,this.expression=ie}};Ht=je([k],Ht),e.InlineValueEvaluatableExpression=Ht;let ct=class{constructor(U,ie){this.frameId=U,this.stoppedLocation=ie}};ct=je([k],ct),e.InlineValueContext=ct;var En;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(En=e.FileChangeType||(e.FileChangeType={}));let Rt=E=class extends Error{constructor(U,ie=i.FileSystemProviderErrorCode.Unknown,Pe){super(D.URI.isUri(U)?U.toString(!0):U);this.code=Pe?.name??"Unknown",(0,i.markAsFileSystemProviderError)(this,ie),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,E.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}static FileExists(U){return new E(U,i.FileSystemProviderErrorCode.FileExists,E.FileExists)}static FileNotFound(U){return new E(U,i.FileSystemProviderErrorCode.FileNotFound,E.FileNotFound)}static FileNotADirectory(U){return new E(U,i.FileSystemProviderErrorCode.FileNotADirectory,E.FileNotADirectory)}static FileIsADirectory(U){return new E(U,i.FileSystemProviderErrorCode.FileIsADirectory,E.FileIsADirectory)}static NoPermissions(U){return new E(U,i.FileSystemProviderErrorCode.NoPermissions,E.NoPermissions)}static Unavailable(U){return new E(U,i.FileSystemProviderErrorCode.Unavailable,E.Unavailable)}};Rt=E=je([k],Rt),e.FileSystemError=Rt;let xt=class{constructor(U,ie,Pe){this.start=U,this.end=ie,this.kind=Pe}};xt=je([k],xt),e.FoldingRange=xt;var un;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(un=e.FoldingRangeKind||(e.FoldingRangeKind={}));var _n;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(_n=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var dn;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(dn=e.CommentMode||(e.CommentMode={}));class Sn{constructor(U,ie=[]){this.tokenTypes=U,this.tokenModifiers=ie}}e.SemanticTokensLegend=Sn;function hn(H){return typeof H=="undefined"||(0,I.isStringArray)(H)}class Vt{constructor(U){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,U){this._hasLegend=!0;for(let ie=0,Pe=U.tokenTypes.length;ie<Pe;ie++)this._tokenTypeStrToInt.set(U.tokenTypes[ie],ie);for(let ie=0,Pe=U.tokenModifiers.length;ie<Pe;ie++)this._tokenModifierStrToInt.set(U.tokenModifiers[ie],ie)}}push(U,ie,Pe,Ye,it){if(typeof U=="number"&&typeof ie=="number"&&typeof Pe=="number"&&typeof Ye=="number"&&(typeof it=="number"||typeof it=="undefined"))return typeof it=="undefined"&&(it=0),this._pushEncoded(U,ie,Pe,Ye,it);if(G.isRange(U)&&typeof ie=="string"&&hn(Pe))return this._push(U,ie,Pe);throw(0,L.illegalArgument)()}_push(U,ie,Pe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ie))throw new Error("`tokenType` is not in the provided legend");const Ye=U.start.line,it=U.start.character,st=U.end.character-U.start.character,ot=this._tokenTypeStrToInt.get(ie);let St=0;if(Pe)for(const It of Pe){if(!this._tokenModifierStrToInt.has(It))throw new Error("`tokenModifier` is not in the provided legend");const Ft=this._tokenModifierStrToInt.get(It);St|=1<<Ft>>>0}this._pushEncoded(Ye,it,st,ot,St)}_pushEncoded(U,ie,Pe,Ye,it){if(this._dataIsSortedAndDeltaEncoded&&(U<this._prevLine||U===this._prevLine&&ie<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let It=0,Ft=0;for(let Ot=0;Ot<St;Ot++){let $t=this._data[5*Ot],ln=this._data[5*Ot+1];$t===0?($t=It,ln+=Ft):$t+=It,this._data[5*Ot]=$t,this._data[5*Ot+1]=ln,It=$t,Ft=ln}}let st=U,ot=ie;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(ot-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=ot,this._data[this._dataLen++]=Pe,this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=it,this._prevLine=U,this._prevChar=ie}static _sortAndDeltaEncode(U){let ie=[];const Pe=U.length/5|0;for(let ot=0;ot<Pe;ot++)ie[ot]=ot;ie.sort((ot,St)=>{const It=U[5*ot],Ft=U[5*St];if(It===Ft){const Ot=U[5*ot+1],$t=U[5*St+1];return Ot-$t}return It-Ft});const Ye=new Uint32Array(U.length);let it=0,st=0;for(let ot=0;ot<Pe;ot++){const St=5*ie[ot],It=U[St+0],Ft=U[St+1],Ot=U[St+2],$t=U[St+3],ln=U[St+4],Nn=It-it,Vn=Nn===0?Ft-st:Ft,cn=5*ot;Ye[cn+0]=Nn,Ye[cn+1]=Vn,Ye[cn+2]=Ot,Ye[cn+3]=$t,Ye[cn+4]=ln,it=It,st=Ft}return Ye}build(U){return this._dataIsSortedAndDeltaEncoded?new en(new Uint32Array(this._data),U):new en(Vt._sortAndDeltaEncode(this._data),U)}}e.SemanticTokensBuilder=Vt;class en{constructor(U,ie){this.resultId=ie,this.data=U}}e.SemanticTokens=en;class tn{constructor(U,ie,Pe){this.start=U,this.deleteCount=ie,this.data=Pe}}e.SemanticTokensEdit=tn;class nn{constructor(U,ie){this.resultId=ie,this.edits=U}}e.SemanticTokensEdits=nn;var yn;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(yn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Dn;(function(H){H[H.Initial=1]="Initial",H[H.Dynamic=2]="Dynamic"})(Dn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Lt=class{constructor(){}};Lt.Back={iconPath:new ft("arrow-left")},Lt=je([k],Lt),e.QuickInputButtons=Lt;var Cn;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(Cn=e.ExtensionKind||(e.ExtensionKind={}));class kn{constructor(U,ie,Pe){this.badge=U,this.tooltip=ie,this.color=Pe}static validate(U){if(U.badge&&U.badge.length!==1&&U.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=kn;let rn=class{constructor(U){this.kind=U}};rn=je([k],rn),e.ColorTheme=rn;var In;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast"})(In=e.ColorThemeKind||(e.ColorThemeKind={}));class Bt{constructor(U,ie){if(U<0)throw(0,L.illegalArgument)("start must be positive");if(ie<0)throw(0,L.illegalArgument)("end must be positive");U<=ie?(this._start=U,this._end=ie):(this._start=ie,this._end=U)}static isNotebookRange(U){return U instanceof Bt?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(U){let ie=this._start,Pe=this._end;return U.start!==void 0&&(ie=U.start),U.end!==void 0&&(Pe=U.end),ie===this._start&&Pe===this._end?this:new Bt(ie,Pe)}}e.NotebookRange=Bt;class Mt{constructor(U,ie,Pe,Ye,it,st,ot){this.kind=U,this.value=ie,this.languageId=Pe,this.mime=Ye,this.outputs=it??[],this.metadata=st,this.executionSummary=ot,Mt.validate(this)}static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(ie=>Mt.isNotebookCellData(ie))}static isNotebookCellData(U){return!0}}e.NotebookCellData=Mt;class fn{constructor(U){this.cells=U}}e.NotebookData=fn;class Tt{constructor(U,ie){this.data=U,this.mime=ie;const Pe=(0,T.normalizeMimeType)(ie,!0);if(!Pe)throw new Error("INVALID mime type, must not be empty or falsy: "+ie);this.mime=Pe}static isNotebookCellOutputItem(U){return U instanceof Tt?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const ie={name:U.name,message:U.message,stack:U.stack};return Tt.json(ie,"application/vnd.code.notebook.error")}static stdout(U){return Tt.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return Tt.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,ie="application/octet-stream"){return new Tt(U,ie)}static text(U,ie=T.Mimes.text){const Pe=Ue(Tt,a,"f",g).encode(String(U));return new Tt(Pe,ie)}static json(U,ie="application/json"){const Pe=JSON.stringify(U,void 0,"	");return Tt.text(Pe,ie)}}e.NotebookCellOutputItem=Tt,a=Tt,g={value:new TextEncoder};class Ne{constructor(U,ie,Pe){this.items=Ne.ensureUniqueMimeTypes(U,!0),typeof ie=="string"?(this.id=ie,this.metadata=Pe):(this.id=(0,A.generateUuid)(),this.metadata=ie??Pe)}static isNotebookCellOutput(U){return U instanceof Ne?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&(0,I.isArray)(U.items)}static ensureUniqueMimeTypes(U,ie=!1){const Pe=new Set,Ye=new Set;for(let it=0;it<U.length;it++){const st=U[it],ot=(0,T.normalizeMimeType)(st.mime);if(!Pe.has(ot)){Pe.add(ot);continue}Ye.add(it),ie&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return Ye.size===0?U:U.filter((it,st)=>!Ye.has(st))}}e.NotebookCellOutput=Ne;var sn;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(sn=e.NotebookCellKind||(e.NotebookCellKind={}));var mn;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(mn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var gt;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(gt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pn;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Pn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class An{constructor(U,ie){this.text=U,this.alignment=ie}}e.NotebookCellStatusBarItem=An;var gn;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(gn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class pn{constructor(U,ie=[]){this.uri=U,this.provides=(0,p.asArray)(ie)}}e.NotebookRendererScript=pn;let on=class{constructor(U,ie){this.label=U,this.timestamp=ie}};on=je([k],on),e.TimelineItem=on;var Tn;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(Tn=e.ExtensionMode||(e.ExtensionMode={}));var Rn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(Rn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ln;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=4]="RegEx"})(Ln=e.StandardTokenType||(e.StandardTokenType={}));class vn{constructor(U,ie){this.ranges=U,this.wordPattern=ie}}e.LinkedEditingRanges=vn;class Fn{constructor(U,ie){this._port=U,this._autoForwardAction=ie}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fn;var Mn;(function(H){H[H.Unset=0]="Unset",H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(Mn=e.TestResultState||(e.TestResultState={}));var wn;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information",H[H.Hint=3]="Hint"})(wn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var On;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(On=e.TestRunConfigurationGroup||(e.TestRunConfigurationGroup={}));let an=class{constructor(U,ie,Pe){this.include=U,this.exclude=ie,this.configuration=Pe}};an=je([k],an),e.TestRunRequest=an;let te=S=class{constructor(U){this.message=U,this.severity=wn.Error}static diff(U,ie,Pe){const Ye=new S(U);return Ye.expectedOutput=ie,Ye.actualOutput=Pe,Ye}};te=S=je([k],te),e.TestMessage=te;let ue=class{constructor(U,ie){this.covered=U,this.total=ie}};ue=je([k],ue),e.CoveredCount=ue;let Le=o=class{constructor(U,ie,Pe,Ye){this.uri=U,this.statementCoverage=ie,this.branchCoverage=Pe,this.functionCoverage=Ye}static fromDetails(U,ie){const Pe=new ue(0,0),Ye=new ue(0,0),it=new ue(0,0);for(const ot of ie)if("branches"in ot){Pe.total+=1,Pe.covered+=ot.executionCount>0?1:0;for(const St of ot.branches)Ye.total+=1,Ye.covered+=St.executionCount>0?1:0}else it.total+=1,it.covered+=ot.executionCount>0?1:0;const st=new o(U,Pe,Ye.total>0?Ye:void 0,it.total>0?it:void 0);return st.detailedCoverage=ie,st}};Le=o=je([k],Le),e.FileCoverage=Le;let rt=class{constructor(U,ie,Pe=[]){this.executionCount=U,this.location=ie,this.branches=Pe}};rt=je([k],rt),e.StatementCoverage=rt;let pt=class{constructor(U,ie){this.executionCount=U,this.location=ie}};pt=je([k],pt),e.BranchCoverage=pt;let Dt=class{constructor(U,ie){this.executionCount=U,this.location=ie}};Dt=je([k],Dt),e.FunctionCoverage=Dt;var Wn;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(Wn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Hn;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(Hn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var zn;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(zn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(he[120],fe([0,1,52,10,8,146,108,7,18]),function(X,e,p,L,C,y,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const A=new Map;function i(a,g){g?A.set(a,g):A.delete(a)}e.setWordDefinitionFor=i;function P(a){return A.get(a)}e.getWordDefinitionFor=P;class c extends y.MirrorTextModel{constructor(g,w,_,b,d,h,v,t){super(w,_,b,d);this._proxy=g,this._languageId=h,this._isDirty=v,this._notebook=t,this._isDisposed=!1}dispose(){(0,p.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(g){return(0,D.equals)(this._lines,g)}get document(){if(!this._document){const g=this;this._document={get uri(){return g._uri},get fileName(){return g._uri.fsPath},get isUntitled(){return g._uri.scheme===L.Schemas.untitled},get languageId(){return g._languageId},get version(){return g._versionId},get isClosed(){return g._isDisposed},get isDirty(){return g._isDirty},get notebook(){return g._notebook},save(){return g._save()},getText(w){return w?g._getTextInRange(w):g.getText()},get eol(){return g._eol===`
`?I.EndOfLine.LF:I.EndOfLine.CRLF},get lineCount(){return g._lines.length},lineAt(w){return g._lineAt(w)},offsetAt(w){return g._offsetAt(w)},positionAt(w){return g._positionAt(w)},validateRange(w){return g._validateRange(w)},validatePosition(w){return g._validatePosition(w)},getWordRangeAtPosition(w,_){return g._getWordRangeAtPosition(w,_)}}}return Object.freeze(this._document)}_acceptLanguageId(g){(0,p.ok)(!this._isDisposed),this._languageId=g}_acceptIsDirty(g){(0,p.ok)(!this._isDisposed),this._isDirty=g}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(g){const w=this._validateRange(g);if(w.isEmpty)return"";if(w.isSingleLine)return this._lines[w.start.line].substring(w.start.character,w.end.character);const _=this._eol,b=w.start.line,d=w.end.line,h=[];h.push(this._lines[b].substring(w.start.character));for(let v=b+1;v<d;v++)h.push(this._lines[v]);return h.push(this._lines[d].substring(0,w.end.character)),h.join(_)}_lineAt(g){let w;if(g instanceof I.Position?w=g.line:typeof g=="number"&&(w=g),typeof w!="number"||w<0||w>=this._lines.length||Math.floor(w)!==w)throw new Error("Illegal value for `line`");return new u(w,this._lines[w],w===this._lines.length-1)}_offsetAt(g){return g=this._validatePosition(g),this._ensureLineStarts(),this._lineStarts.getPrefixSum(g.line-1)+g.character}_positionAt(g){g=Math.floor(g),g=Math.max(0,g),this._ensureLineStarts();const w=this._lineStarts.getIndexOf(g),_=this._lines[w.index].length;return new I.Position(w.index,Math.min(w.remainder,_))}_validateRange(g){if(!(g instanceof I.Range))throw new Error("Invalid argument");const w=this._validatePosition(g.start),_=this._validatePosition(g.end);return w===g.start&&_===g.end?g:new I.Range(w.line,w.character,_.line,_.character)}_validatePosition(g){if(!(g instanceof I.Position))throw new Error("Invalid argument");if(this._lines.length===0)return g.with(0,0);let{line:w,character:_}=g,b=!1;if(w<0)w=0,_=0,b=!0;else if(w>=this._lines.length)w=this._lines.length-1,_=this._lines[w].length,b=!0;else{const d=this._lines[w].length;_<0?(_=0,b=!0):_>d&&(_=d,b=!0)}return b?new I.Position(w,_):g}_getWordRangeAtPosition(g,w){const _=this._validatePosition(g);if(!w)w=P(this._languageId);else if((0,C.regExpLeadsToEndlessLoop)(w))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${w.source}' because it matches the empty string.`);const b=(0,T.getWordAtText)(_.character+1,(0,T.ensureValidWordDefinition)(w),this._lines[_.line],0);if(b)return new I.Range(_.line,b.startColumn-1,_.line,b.endColumn-1)}}e.ExtHostDocumentData=c;class u{constructor(g,w,_){this._line=g,this._text=w,this._isLastLine=_}get lineNumber(){return this._line}get text(){return this._text}get range(){return new I.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new I.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=u}),define(he[199],fe([0,1,7,3,110,6,77,23,2,32]),function(X,e,p,L,C,y,T,I,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(c,u,a,g){this._notebook=a,this._selector=g,this._disposables=new y.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,A.generateUuid)()}),this._init(),this._disposables.add(u.onDidChangeDocument(_=>{const b=this._cellUris.get(_.document.uri);b!==void 0&&(this._cellLengths.changeValue(b,this._cells[b].document.getText().length+1),this._cellLines.changeValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const w=_=>{_===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(c.onDidChangeNotebookCells(_=>w(_.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new I.ResourceMap;const c=[],u=[];for(const a of this._notebook.getCells())a.kind===p.NotebookCellKind.Code&&(!this._selector||(0,T.score)(this._selector,a.document.uri,a.document.languageId,!0))&&(this._cellUris.set(a.document.uri,this._cells.length),this._cells.push(a),c.push(a.document.getText().length+1),u.push(a.document.lineCount));this._cellLengths=new C.PrefixSumComputer(new Uint32Array(c)),this._cellLines=new C.PrefixSumComputer(new Uint32Array(u))}get version(){return this._versionId}getText(c){if(!c){let b="";for(const d of this._cells)b+=d.document.getText()+`
`;return b=b.slice(0,-1),b}if(c.isEmpty)return"";const u=this.locationAt(c.start),a=this.locationAt(c.end),g=this._cellUris.get(u.uri),w=this._cellUris.get(a.uri);if(g===void 0||w===void 0)return"";if(g===w)return this._cells[g].document.getText(new p.Range(u.range.start,a.range.end));const _=[this._cells[g].document.getText(new p.Range(u.range.start,new p.Position(this._cells[g].document.lineCount,0)))];for(let b=g+1;b<w;b++)_.push(this._cells[b].document.getText());return _.push(this._cells[w].document.getText(new p.Range(new p.Position(0,0),a.range.end))),_.join(`
`)}offsetAt(c){const u=this._cellLines.getIndexOf(c.line),a=this._cellLengths.getPrefixSum(u.index-1),g=this._cells[u.index].document.offsetAt(c.with(u.remainder));return a+g}positionAt(c){if(typeof c=="number"){const a=this._cellLengths.getIndexOf(c),g=this._cellLines.getPrefixSum(a.index-1);return this._cells[a.index].document.positionAt(a.remainder).translate(g)}const u=this._cellUris.get(c.uri);if(u!==void 0){const a=this._cellLines.getPrefixSum(u-1);return new p.Position(a+c.range.start.line,c.range.start.character)}return new p.Position(0,0)}locationAt(c){p.Range.isRange(c)||(c=new p.Range(c,c));const u=this._cellLines.getIndexOf(c.start.line);let a=u;c.isEmpty||(a=this._cellLines.getIndexOf(c.end.line));const g=new p.Position(u.remainder,c.start.character),w=new p.Position(a.remainder,c.end.character),_=new p.Range(g,w),b=this._cells[u.index];return new p.Location(b.document.uri,b.document.validateRange(_))}contains(c){return this._cellUris.has(c)}validateRange(c){const u=this.validatePosition(c.start),a=this.validatePosition(c.end);return c.with(u,a)}validatePosition(c){const u=this._cellLines.getIndexOf(c.line),a=new p.Position(u.remainder,c.character),g=this._cells[u.index].document.validatePosition(a),w=this._cellLines.getPrefixSum(u.index-1);return new p.Position(w+g.line,g.character)}}e.ExtHostNotebookConcatDocument=i}),define(he[200],fe([0,1,7,13,3]),function(X,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let y=class{constructor(I){this._actual=new p.ColorTheme(p.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new C.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(I){let D=I==="light"?p.ColorThemeKind.Light:I==="dark"?p.ColorThemeKind.Dark:p.ColorThemeKind.HighContrast;this._actual=new p.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};y=je([We(0,L.IExtHostRpcService)],y),e.ExtHostTheming=y}),define(he[60],fe([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,p.createDecorator)("IURITransformerService");class L{constructor(y){y?(this.transformIncoming=y.transformIncoming.bind(y),this.transformOutgoing=y.transformOutgoing.bind(y),this.transformOutgoingURI=y.transformOutgoingURI.bind(y),this.transformOutgoingScheme=y.transformOutgoingScheme.bind(y)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=L}),define(he[201],fe([0,1,22]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(D){let A=this.buffers.indexOf(D);return A<0&&(A=this.buffers.length,this.buffers.push(D)),A}}function C(I,D){if(D.serializeBuffersForPostMessage){const A=new L,i=(u,a)=>{if(a instanceof ArrayBuffer){const g=A.add(a);return{$$vscode_array_buffer_reference$$:!0,index:g}}else if(ArrayBuffer.isView(a)){const g=y(a);if(g){const w=A.add(a.buffer);return{$$vscode_array_buffer_reference$$:!0,index:w,view:{type:g,byteLength:a.byteLength,byteOffset:a.byteOffset}}}}return a},P=JSON.stringify(I,i),c=A.buffers.map(u=>{const a=new Uint8Array(u);return p.VSBuffer.wrap(a)});return{message:P,buffers:c}}else return{message:JSON.stringify(I),buffers:[]}}e.serializeWebviewMessage=C;function y(I){switch(I.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(I,D){const A=D.map(c=>{const u=new ArrayBuffer(c.byteLength);return new Uint8Array(u).set(c.buffer),u}),i=D.length?(c,u)=>{if(typeof u=="object"&&u.$$vscode_array_buffer_reference$$){const a=u,{index:g}=a,w=A[g];if(a.view)switch(a.view.type){case 1:return new Int8Array(w,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(w,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(w,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(w,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(w,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(w,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(w,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(w,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(w,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(w,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(w,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return w}return u}:void 0;return{message:JSON.parse(I,i),arrayBuffers:A}}e.deserializeWebviewMessage=T}),define(he[86],fe([0,1,10,2]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function C(y,T){return y.scheme===p.Schemas.http||y.scheme===p.Schemas.https?y:(T&&T.authority&&T.isRemote&&y.scheme===p.Schemas.file&&(y=L.URI.from({scheme:p.Schemas.vscodeRemote,authority:T.authority,path:y.path})),L.URI.from({scheme:p.Schemas.https,authority:`${y.scheme}+${y.authority}.${e.webviewRootResourceAuthority}`,path:y.path,fragment:y.fragment,query:y.query}))}e.asWebviewUri=C}),define(he[202],fe([0,1,3,6,86]),function(X,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(I,D,A){this._proxy=I,this._editors=D,this._initData=A,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(D.onDidChangeVisibleTextEditors(()=>{const i=D.getVisibleTextEditors();for(const P of this._insets.values())i.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this._insets.forEach(I=>I.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(I,D,A,i,P){let c;for(const d of this._editors.getVisibleTextEditors(!0))if(d.value===I){c=d;break}if(!c)throw new Error("not a visible editor");const u=this,a=this._handlePool++,g=new p.Emitter,w=new p.Emitter,_=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(d){return(0,C.asWebviewUri)(d,u._initData.remote)}get cspSource(){return C.webviewGenericCspSource}set options(d){this._options=d,u._proxy.$setOptions(a,d)}get options(){return this._options}set html(d){this._html=d,u._proxy.$setHtml(a,d)}get html(){return this._html}get onDidReceiveMessage(){return g.event}postMessage(d){return u._proxy.$postMessage(a,d)}},b=new class{constructor(){this.editor=I,this.line=D,this.height=A,this.webview=_,this.onDidDispose=w.event}dispose(){u._insets.has(a)&&(u._insets.delete(a),u._proxy.$disposeEditorInset(a),w.fire(),w.dispose(),g.dispose())}};return this._proxy.$createEditorInset(a,c.id,c.value.document.uri,D+1,A,i||{},P.identifier,P.extensionLocation),this._insets.set(a,{editor:I,inset:b,onDidReceiveMessage:g}),b}$onDidDispose(I){const D=this._insets.get(I);D&&D.inset.dispose()}$onDidReceiveMessage(I,D){const A=this._insets.get(I);A&&A.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=y}),define(he[203],fe([0,1,167,14,2,6,4,80,42,18,10]),function(X,e,p,L,C,y,T,I,D,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,p.localize)(0,null),providerDisplayName:(0,p.localize)(1,null)},e.ActiveEditorDirtyContext=new I.RawContextKey("activeEditorIsDirty",!1,(0,p.localize)(2,null)),e.ActiveEditorPinnedContext=new I.RawContextKey("activeEditorIsNotPreview",!1,(0,p.localize)(3,null)),e.ActiveEditorStickyContext=new I.RawContextKey("activeEditorIsPinned",!1,(0,p.localize)(4,null)),e.ActiveEditorReadonlyContext=new I.RawContextKey("activeEditorIsReadonly",!1,(0,p.localize)(5,null)),e.ActiveEditorCanRevertContext=new I.RawContextKey("activeEditorCanRevert",!1,(0,p.localize)(6,null)),e.ActiveEditorContext=new I.RawContextKey("activeEditor",null,{type:"string",description:(0,p.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new I.RawContextKey("activeEditorAvailableEditorIds","",(0,p.localize)(8,null)),e.TextCompareEditorVisibleContext=new I.RawContextKey("textCompareEditorVisible",!1,(0,p.localize)(9,null)),e.TextCompareEditorActiveContext=new I.RawContextKey("textCompareEditorActive",!1,(0,p.localize)(10,null)),e.EditorGroupEditorsCountContext=new I.RawContextKey("groupEditorsCount",0,(0,p.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new I.RawContextKey("activeEditorGroupEmpty",!1,(0,p.localize)(12,null)),e.ActiveEditorGroupIndexContext=new I.RawContextKey("activeEditorGroupIndex",0,(0,p.localize)(13,null)),e.ActiveEditorGroupLastContext=new I.RawContextKey("activeEditorGroupLast",!1,(0,p.localize)(14,null)),e.MultipleEditorGroupsContext=new I.RawContextKey("multipleEditorGroups",!1,(0,p.localize)(15,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new I.RawContextKey("editorIsOpen",!1,(0,p.localize)(16,null)),e.InEditorZenModeContext=new I.RawContextKey("inZenMode",!1,(0,p.localize)(17,null)),e.IsCenteredLayoutContext=new I.RawContextKey("isCenteredLayout",!1,(0,p.localize)(18,null)),e.SplitEditorsVertically=new I.RawContextKey("splitEditorsVertically",!1,(0,p.localize)(19,null)),e.EditorAreaVisibleContext=new I.RawContextKey("editorAreaVisible",!0,(0,p.localize)(20,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function P(o){return typeof o?.getViewState=="function"}e.isTextEditorPane=P;function c(o){if(d(o))return!1;const k=o;return C.URI.isUri(k?.resource)}e.isResourceEditorInput=c;function u(o){if(d(o))return!1;const k=o;return k?.original!==void 0&&k.modified!==void 0}e.isResourceDiffEditorInput=u;function a(o){if(d(o))return!1;const k=o;return k?k?.resource===void 0||k.resource.scheme===i.Schemas.untitled||k.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=a;var g;(function(o){o[o.SHORT=0]="SHORT",o[o.MEDIUM=1]="MEDIUM",o[o.LONG=2]="LONG"})(g=e.Verbosity||(e.Verbosity={}));var w;(function(o){o[o.EXPLICIT=1]="EXPLICIT",o[o.AUTO=2]="AUTO",o[o.FOCUS_CHANGE=3]="FOCUS_CHANGE",o[o.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(w=e.SaveReason||(e.SaveReason={}));var _;(function(o){o[o.None=0]="None",o[o.Readonly=2]="Readonly",o[o.Untitled=4]="Untitled",o[o.Singleton=8]="Singleton",o[o.RequiresTrust=16]="RequiresTrust"})(_=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class b extends y.Disposable{}e.AbstractEditorInput=b;function d(o){return o instanceof b}e.isEditorInput=d;function h(o){const k=o;return C.URI.isUri(k?.preferredResource)}function v(o){const k=o;return d(k?.primary)&&d(k?.secondary)}e.isSideBySideEditorInput=v;function t(o){return d(o?.editor)}e.isEditorInputWithOptions=t;function s(o){const k=o;return t(o)&&k?.group!==void 0}e.isEditorInputWithOptionsAndGroup=s;function r(o){const k=o;return typeof k?.groupId=="number"&&d(k.editor)}e.isEditorIdentifier=r;var n;(function(o){o[o.PRIMARY=1]="PRIMARY",o[o.SECONDARY=2]="SECONDARY",o[o.BOTH=3]="BOTH"})(n=e.SideBySideEditor||(e.SideBySideEditor={}));class l{getOriginalUri(k,O){if(!k)return;const $=v(k)?k.primary:u(k)?k.modified:void 0,G=v(k)?k.secondary:u(k)?k.original:void 0;if(O?.supportSideBySide&&$&&G){if(O?.supportSideBySide===n.BOTH)return{primary:this.getOriginalUri($,{filterByScheme:O.filterByScheme}),secondary:this.getOriginalUri(G,{filterByScheme:O.filterByScheme})};k=O.supportSideBySide===n.PRIMARY?$:G}if(u(k))return;const re=h(k)?k.preferredResource:k.resource;return!re||!O||!O.filterByScheme?re:this.filterUri(re,O.filterByScheme)}getCanonicalUri(k,O){if(!k)return;const $=v(k)?k.primary:u(k)?k.modified:void 0,G=v(k)?k.secondary:u(k)?k.original:void 0;if(O?.supportSideBySide&&$&&G){if(O?.supportSideBySide===n.BOTH)return{primary:this.getCanonicalUri($,{filterByScheme:O.filterByScheme}),secondary:this.getCanonicalUri(G,{filterByScheme:O.filterByScheme})};k=O.supportSideBySide===n.PRIMARY?$:G}if(u(k))return;const re=k.resource;return!re||!O||!O.filterByScheme?re:this.filterUri(re,O.filterByScheme)}filterUri(k,O){if(Array.isArray(O)){if(O.some($=>k.scheme===$))return k}else if(O===k.scheme)return k}}e.EditorResourceAccessor=new l;var f;(function(o){o[o.LEFT=0]="LEFT",o[o.RIGHT=1]="RIGHT"})(f=e.CloseDirection||(e.CloseDirection={}));class m{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(k){const O=this.instantiationService=k.get(T.IInstantiationService);for(const[$,G]of this.editorSerializerConstructors)this.createEditorSerializer($,G,O);this.editorSerializerConstructors.clear()}createEditorSerializer(k,O,$){const G=$.createInstance(O);this.editorSerializerInstances.set(k,G)}registerFileEditorFactory(k){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=k}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(k,O){if(this.editorSerializerConstructors.has(k)||this.editorSerializerInstances.has(k))throw new Error(`A editor serializer with type ID '${k}' was already registered.`);return this.instantiationService?this.createEditorSerializer(k,O,this.instantiationService):this.editorSerializerConstructors.set(k,O),(0,y.toDisposable)(()=>{this.editorSerializerConstructors.delete(k),this.editorSerializerInstances.delete(k)})}getEditorSerializer(k){return this.editorSerializerInstances.get(typeof k=="string"?k:k.typeId)}}D.Registry.add(e.EditorExtensions.EditorFactory,new m);async function E(o,k){if(!o||!o.length)return[];const O=await Promise.all(o.map(async $=>{const G=C.URI.revive($.fileUri);if(!G||(await k.activateProvider(G.scheme),!k.canHandleResource(G)))return;const re=typeof $.exists=="boolean"?$.exists:await k.exists(G);if(!re&&$.openOnlyIfExists)return;const j=re&&typeof $.lineNumber=="number"?{selection:{startLineNumber:$.lineNumber,startColumn:$.columnNumber||1},pinned:!0,override:$.editorOverrideId}:{pinned:!0,override:$.editorOverrideId};let N;return re?N={resource:G,options:j,forceFile:!0}:N={resource:G,options:j,forceUntitled:!0},N}));return(0,A.coalesce)(O)}e.pathsToEditors=E;var S;(function(o){o[o.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",o[o.SEQUENTIAL=1]="SEQUENTIAL"})(S=e.EditorsOrder||(e.EditorsOrder={}))}),define(he[121],fe([0,1,3,17,168]),function(X,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class y{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new p.Emitter,this._onExit=new p.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(I){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=I}onEvent(I){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=I}onRequest(I){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=I}sendResponse(I){I.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${I.command}`)):this.internalSend("response",I)}sendRequest(I,D,A,i){const P={command:I};if(D&&Object.keys(D).length>0&&(P.arguments=D),this.internalSend("request",P),typeof i=="number"){const c=setTimeout(()=>{clearTimeout(c);const u=this.pendingRequests.get(P.seq);if(u){this.pendingRequests.delete(P.seq);const a={type:"response",seq:0,request_seq:P.seq,success:!1,command:I,message:(0,C.localize)(0,null,i,I)};u(a)}},i)}return A&&this.pendingRequests.set(P.seq,A),P.seq}acceptMessage(I){this.messageCallback?this.messageCallback(I):(this.queue.push(I),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(I,D){return I.type!=="event"||D.type!=="event"}async processQueue(){let I;for(;this.queue.length;){if((!I||this.needsTaskBoundaryBetween(this.queue[0],I))&&await(0,L.timeout)(0),I=this.queue.shift(),!I)return;switch(I.type){case"event":this.eventCallback&&this.eventCallback(I);break;case"request":this.requestCallback&&this.requestCallback(I);break;case"response":const D=I,A=this.pendingRequests.get(D.request_seq);A&&(this.pendingRequests.delete(D.request_seq),A(D));break}}}internalSend(I,D){D.type=I,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const I=new Map;this.pendingRequests.forEach((D,A)=>I.set(A,D)),await(0,L.timeout)(500),I.forEach((D,A)=>{D({type:"response",seq:0,request_seq:A,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(A)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=y}),define(he[204],fe([0,1,8,2,9,25,10]),function(X,e,p,L,C,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const I=/{([^}]+)}/g;function D(s,r,n){return s.replace(I,function(l,f){return r&&f.length>0&&f[0]!=="_"?l:n&&n.hasOwnProperty(f)?n[f]:l})}e.formatPII=D;function A(s){const r={};for(const n of Object.keys(s))n.startsWith("!")||(r[n]=s[n]);return r}e.filterExceptionsFromTelemetry=A;function i(s){return s.configuration.request==="attach"&&!P(s)&&(!s.parentSession||i(s.parentSession))}e.isSessionAttach=i;function P(s){let r=s.configuration.type;if(!!r)return r==="vslsShare"&&(r=s.configuration.adapterProxy.configuration.type),(0,p.equalsIgnoreCase)(r,"extensionhost")||(0,p.equalsIgnoreCase)(r,"pwa-extensionhost")?s:s.parentSession?P(s.parentSession):void 0}e.getExtensionHostDebugSession=P;function c(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=c;function u(s,r,n){let l,f=0,m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,E=null;for(;E=m.exec(s);){let S=E.index+1,o=S+E[0].length;if(S<=r&&o>=n){l=E[0],f=S;break}}if(l){let S=/\w+/g,o=null;for(;(o=S.exec(l))&&!(o.index+1+f+o[0].length>=n););o&&(l=l.substring(0,S.lastIndex))}return l?{start:f,end:f+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=u;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function g(s){return!!(s&&s.match(a))}e.isUri=g;function w(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(g(s.path))return L.URI.parse(s.path);if((0,C.isAbsolute)(s.path))return L.URI.file(s.path)}return s.path}function _(s){if(typeof s.path=="object"){const r=L.URI.revive(s.path);if(r)return r.scheme===T.Schemas.file?r.fsPath:r.toString()}return s.path}function b(s,r){const n=r?w:_,l=(0,y.deepClone)(s);return h(l,(f,m)=>{f&&m&&(m.path=n(m))}),l}e.convertToDAPaths=b;function d(s,r){const n=r?w:_,l=(0,y.deepClone)(s);return h(l,(f,m)=>{!f&&m&&(m.path=n(m))}),l}e.convertToVSCPaths=d;function h(s,r){switch(s.type){case"event":const n=s;switch(n.event){case"output":r(!1,n.body.source);break;case"loadedSource":r(!1,n.body.source);break;case"breakpoint":r(!1,n.body.breakpoint.source);break;default:break}break;case"request":const l=s;switch(l.command){case"setBreakpoints":r(!0,l.arguments.source);break;case"breakpointLocations":r(!0,l.arguments.source);break;case"source":r(!0,l.arguments.source);break;case"gotoTargets":r(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(m=>r(!1,m));break;default:break}break;case"response":const f=s;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(m=>r(!1,m.source));break;case"loadedSources":f.body.sources.forEach(m=>r(!1,m));break;case"scopes":f.body.scopes.forEach(m=>r(!1,m.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(m=>r(!1,m.source));break;case"setBreakpoints":f.body.breakpoints.forEach(m=>r(!1,m.source));break;default:break}break}}function v(s){return s.filter(r=>!r.presentation?.hidden).sort((r,n)=>r.presentation?n.presentation?r.presentation.group?n.presentation.group?r.presentation.group!==n.presentation.group?r.presentation.group.localeCompare(n.presentation.group):t(r.presentation.order,n.presentation.order):-1:n.presentation.group?1:t(r.presentation.order,n.presentation.order):-1:n.presentation?1:0)}e.getVisibleAndSorted=v;function t(s,r){return typeof s!="number"?typeof r!="number"?0:1:typeof r!="number"?-1:s-r}}),define(he[205],fe([0,1,28,38,169,122,9,8,25,11,179,121]),function(X,e,p,L,C,y,T,I,D,A,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class c extends P.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(b,d){this.outputStream=d,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,b.on("data",h=>this.handleData(h))}sendMessage(b){if(this.outputStream){const d=JSON.stringify(b);this.outputStream.write(`Content-Length: ${Buffer.byteLength(d,"utf8")}${c.TWO_CRLF}${d}`,"utf8")}}handleData(b){for(this.rawData=Buffer.concat([this.rawData,b]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const d=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,d.length>0)try{this.acceptMessage(JSON.parse(d))}catch(h){this._onError.fire(new Error((h.message||h)+`
`+d))}continue}}else{const d=this.rawData.indexOf(c.TWO_CRLF);if(d!==-1){const v=this.rawData.toString("utf8",0,d).split(c.HEADER_LINESEPARATOR);for(const t of v){const s=t.split(c.HEADER_FIELDSEPARATOR);s[0]==="Content-Length"&&(this.contentLength=Number(s[1]))}this.rawData=this.rawData.slice(d+c.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=c,c.TWO_CRLF=`\r
\r
`,c.HEADER_LINESEPARATOR=/\r?\n/,c.HEADER_FIELDSEPARATOR=/: */;class u extends c{startSession(){return new Promise((b,d)=>{let h=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),b(),h=!0}),this.socket.on("close",()=>{h?this._onError.fire(new Error("connection closed")):d(new Error("connection closed"))}),this.socket.on("error",v=>{h?this._onError.fire(v):d(v)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=u;class a extends u{constructor(b){super();this.adapterServer=b}createConnection(b){return y.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",b)}}e.SocketDebugAdapter=a;class g extends u{constructor(b){super();this.adapterServer=b}createConnection(b){return y.createConnection(this.adapterServer.path,b)}}e.NamedPipeDebugAdapter=g;class w extends c{constructor(b,d,h){super();this.adapterExecutable=b,this.debugType=d,this.outputService=h}async startSession(){const b=this.adapterExecutable.command,d=this.adapterExecutable.args,h=this.adapterExecutable.options||{};try{if(b)if(T.isAbsolute(b)){if(!await p.Promises.exists(b))throw new Error(C.localize(0,null,b))}else b.indexOf("/")<0&&b.indexOf("\\")<0;else throw new Error(C.localize(1,null,this.debugType));let v=process.env;if(h.env&&Object.keys(h.env).length>0&&(v=D.mixin(D.deepClone(process.env),h.env)),b==="node")if(Array.isArray(d)&&d.length>0){const s=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:v,execArgv:s?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};h.cwd&&(r.cwd=h.cwd);const n=L.fork(d[0],d.slice(1),r);if(!n.pid)throw new Error(C.localize(2,null,d[0]));this.serverProcess=n}else throw new Error(C.localize(3,null));else{const s={env:v};h.cwd&&(s.cwd=h.cwd),this.serverProcess=L.spawn(b,d,s)}this.serverProcess.on("error",s=>{this._onError.fire(s)}),this.serverProcess.on("exit",(s,r)=>{this._onExit.fire(s)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",s=>{this._onError.fire(s)}),this.serverProcess.stdin.on("error",s=>{this._onError.fire(s)});const t=this.outputService;if(t){const s=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{const n=t.getChannel(i.ExtensionsChannelId);n&&n.append(s(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(v){this._onError.fire(v)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),A.isWindows?new Promise((b,d)=>{const h=L.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(v,t,s){if(v)return d(v)});h.on("exit",b),h.on("error",d)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(b,d){if(!b)return;const h=Object.create(null);b.runtime&&(b.runtime.indexOf("./")===0?h.runtime=T.join(d,b.runtime):h.runtime=b.runtime),b.runtimeArgs&&(h.runtimeArgs=b.runtimeArgs),b.program&&(T.isAbsolute(b.program)?h.program=b.program:h.program=T.join(d,b.program)),b.args&&(h.args=b.args);const v=b;return v.win&&(h.win=w.extract(v.win,d)),v.winx86&&(h.winx86=w.extract(v.winx86,d)),v.windows&&(h.windows=w.extract(v.windows,d)),v.osx&&(h.osx=w.extract(v.osx,d)),v.linux&&(h.linux=w.extract(v.linux,d)),h}static platformAdapterExecutable(b,d){let h=Object.create(null);d=d.toLowerCase();for(const l of b)if(l.contributes){const f=l.contributes.debuggers;f&&f.length>0&&f.filter(m=>typeof m.type=="string"&&I.equalsIgnoreCase(m.type,d)).forEach(m=>{const E=w.extract(m,l.extensionLocation.fsPath);h=D.mixin(h,E,l.isBuiltin)})}let v;A.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?v=h.winx86||h.win||h.windows:A.isWindows?v=h.win||h.windows:A.isMacintosh?v=h.osx:A.isLinux&&(v=h.linux),v=v||h;let t=v.program||h.program;const s=v.args||h.args;let r=v.runtime||h.runtime;const n=v.runtimeArgs||h.runtimeArgs;if(r)return{type:"executable",command:r,args:(n||[]).concat(typeof t=="string"?[t]:[]).concat(s||[])};if(t)return{type:"executable",command:t,args:s||[]}}}e.ExecutableDebugAdapter=w}),define(he[206],fe([0,1,38,11,29,182]),function(X,e,p,L,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function T(c,u){return new Promise((a,g)=>{let w="";const _=p.spawn(c,u);_.pid&&_.stdout.on("data",b=>{w+=b.toString()}),_.on("error",b=>{g(b)}),_.on("close",b=>{a(w)})})}let I;function D(c,u){if(!I)if(L.isWindows)I=new y.WindowsExternalTerminalService;else if(L.isMacintosh)I=new y.MacExternalTerminalService;else if(L.isLinux)I=new y.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const a=u.getConfiguration("terminal");return I.runInTerminal(c.title,c.cwd,c.args,c.env||{},a.external||{})}e.runInExternalTerminal=D;function A(c){return c?L.isWindows?new Promise(async u=>{(await new Promise((g,w)=>{X(["windows-process-tree"],g,w)})).getProcessTree(c,g=>{u(g.children.length>0)})}):T("/usr/bin/pgrep",["-lP",String(c)]).then(u=>{const a=u.trim();return!(a.length===0||a.indexOf(" tmux")>=0)},u=>!0):Promise.resolve(!0)}e.hasChildProcesses=A;var i;(function(c){c[c.cmd=0]="cmd",c[c.powershell=1]="powershell",c[c.bash=2]="bash"})(i||(i={}));function P(c,u,a,g){c=c.trim().toLowerCase();let w;c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0?w=1:c.indexOf("cmd.exe")>=0?w=0:c.indexOf("bash")>=0?w=2:L.isWindows?w=0:w=2;let _,b=" ";switch(w){case 1:if(_=h=>(h=h.replace(/\'/g,"''"),h.length>0&&h.charAt(h.length-1)==="\\"?`'${h}\\'`:`'${h}'`),a){const h=(0,C.getDriveLetter)(a);h&&(b+=`${h}:; `),b+=`cd ${_(a)}; `}if(g)for(let h in g){const v=g[h];v===null?b+=`Remove-Item env:${h}; `:b+=`\${env:${h}}='${v}'; `}if(u.length>0){const h=_(u.shift());b+=h[0]==="'"?`& ${h} `:`${h} `;for(let v of u)b+=`${_(v)} `}break;case 0:if(_=h=>(h=h.replace(/\"/g,'""'),h.indexOf(" ")>=0||h.indexOf('"')>=0||h.length===0?`"${h}"`:h),a){const h=(0,C.getDriveLetter)(a);h&&(b+=`${h}: && `),b+=`cd ${_(a)} && `}if(g){b+='cmd /C "';for(let h in g){let v=g[h];v===null?b+=`set "${h}=" && `:(v=v.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),b+=`set "${h}=${v}" && `)}}for(let h of u)b+=`${_(h)} `;g&&(b+='"');break;case 2:_=h=>(h=h.replace(/(["'\\\$])/g,"\\$1"),h.indexOf(" ")>=0||h.indexOf(";")>=0||h.length===0?`"${h}"`:h);const d=h=>/[^\w@%\/+=,.:^-]/.test(h)?`'${h.replace(/'/g,"'\\''")}'`:h;if(a&&(b+=`cd ${_(a)} ; `),g){b+="/usr/bin/env";for(let h in g){const v=g[h];v===null?b+=` -u ${d(h)}`:b+=` ${d(`${h}=${v}`)}`}b+=" "}for(let h of u)b+=`${_(h)} `;break}return b}e.prepareCommand=P}),define(he[87],fe([0,1,30,99,10,9,11,80]),function(X,e,p,L,C,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var D;(function(o){o[o.Markup=1]="Markup",o[o.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.markdown,"application/json",L.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var A;(function(o){o[o.Running=1]="Running",o[o.Idle=2]="Idle"})(A=e.NotebookRunState||(e.NotebookRunState={}));var i;(function(o){o[o.Pending=2]="Pending",o[o.Executing=3]="Executing"})(i=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var P;(function(o){o[o.WithHardKernelDependency=0]="WithHardKernelDependency",o[o.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",o[o.Pure=2]="Pure",o[o.Never=3]="Never"})(P=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var c;(function(o){o.Always="always",o.Never="never",o.Optional="optional"})(c=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var u;(function(o){o[o.ModelChange=1]="ModelChange",o[o.Move=2]="Move",o[o.ChangeLanguage=5]="ChangeLanguage",o[o.Initialize=6]="Initialize",o[o.ChangeCellMetadata=7]="ChangeCellMetadata",o[o.Output=8]="Output",o[o.OutputItem=9]="OutputItem",o[o.ChangeCellContent=10]="ChangeCellContent",o[o.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",o[o.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",o[o.ChangeCellMime=13]="ChangeCellMime",o[o.Unknown=100]="Unknown"})(u=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var a;(function(o){o[o.Handle=0]="Handle",o[o.Index=1]="Index"})(a=e.SelectionStateType||(e.SelectionStateType={}));var g;(function(o){o[o.Replace=1]="Replace",o[o.Output=2]="Output",o[o.Metadata=3]="Metadata",o[o.CellLanguage=4]="CellLanguage",o[o.DocumentMetadata=5]="DocumentMetadata",o[o.Move=6]="Move",o[o.OutputItems=7]="OutputItems",o[o.PartialMetadata=8]="PartialMetadata",o[o.PartialInternalMetadata=9]="PartialInternalMetadata"})(g=e.CellEditType||(e.CellEditType={}));var w;(function(o){o.scheme=C.Schemas.vscodeNotebookCell;const k=/^ch(\d{7,})/;function O(N,x){return N.with({scheme:o.scheme,fragment:`ch${x.toString().padStart(7,"0")}${N.scheme!==C.Schemas.file?N.scheme:""}`})}o.generate=O;function $(N){if(N.scheme!==o.scheme)return;const x=k.exec(N.fragment);return x?{handle:Number(x[1]),notebook:N.with({scheme:N.fragment.substr(x[0].length)||C.Schemas.file,fragment:null})}:void 0}o.parse=$;function G(N){if(N.scheme!==C.Schemas.vscodeNotebookCellMetadata)return;const x=k.exec(N.fragment);return x?{handle:Number(x[1]),notebook:N.with({scheme:N.fragment.substr(x[0].length)||C.Schemas.file,fragment:null})}:void 0}o.parseCellMetadataUri=G;function re(N,x,R){return N.with({scheme:R,fragment:`ch${x.toString().padStart(7,"0")}${N.scheme!==C.Schemas.file?N.scheme:""}`})}o.generateCellUri=re;function j(N,x){if(N.scheme!==x)return;const R=k.exec(N.fragment);return R?{handle:Number(R[1]),notebook:N.with({scheme:N.fragment.substr(R[0].length)||C.Schemas.file,fragment:null})}:void 0}o.parseCellUri=j})(w=e.CellUri||(e.CellUri={}));const _=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function b(o){return _.get(o)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=b;function d(o){return _.get(o)?.supportedByCore??!1}e.mimeTypeSupportedByCore=d;function h(o){return _.get(o)?.mergeable??!1}e.mimeTypeIsMergeable=h;function v(o,k){return T.isWindows&&(o=o.replace(/\//g,"\\"),k=k.replace(/\//g,"\\")),p.match(o,k)}function t(o,k,O){let $=0;for(let G=0;G<k.length;G++){if(v(k[G],o))return $;$++}for(let G=0;G<O.length;G++){if(v(O[G],o))return $;$++}return $}function s(o,k,O){return o.sort(($,G)=>t($,k,O)-t(G,k,O))}e.sortMimeTypes=s;function r(o,k,O,$=(G,re)=>G===re){const G=[];function re(x,R,V){if(R===0&&V.length===0)return;const F=G[G.length-1];F&&F.start+F.deleteCount===x?(F.deleteCount+=R,F.toInsert.push(...V)):G.push({start:x,deleteCount:R,toInsert:V})}let j=0,N=0;for(;;){if(j===o.length){re(j,0,k.slice(N));break}if(N===k.length){re(j,o.length-j,[]);break}const x=o[j],R=k[N];if($(x,R)){j+=1,N+=1;continue}O(R)?(re(j,1,[]),j+=1):(re(j,0,[R]),N+=1)}return G}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new I.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(o){o.default="default",o.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function l(o){const k=o;return!!((typeof k.include=="string"||p.isRelativePattern(k.include))&&(typeof k.exclude=="string"||p.isRelativePattern(k.exclude)))}e.isDocumentExcludePattern=l;function f(o,k,O){if(Array.isArray(o.viewType)&&o.viewType.indexOf(k)>=0||o.viewType===k)return!0;if(o.filenamePattern){let $=l(o.filenamePattern)?o.filenamePattern.include:o.filenamePattern,G=l(o.filenamePattern)?o.filenamePattern.exclude:void 0;if(p.match($,(0,y.basename)(O.fsPath).toLowerCase()))return!(G&&p.match(G,(0,y.basename)(O.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=f;class m{constructor(k){this.textModel=k}getElements(){const k=new Int32Array(this.textModel.cells.length);for(let O=0;O<this.textModel.cells.length;O++)k[O]=this.textModel.cells[O].getHashValue();return k}}e.CellSequence=m,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted";var E;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(E=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class S{static create(k){return`${S._prefix}${k}`}static parse(k){if(k.startsWith(S._prefix))return k.substr(S._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=S,S._prefix="notebook/"}),define(he[207],fe([0,1,171,4,80]),function(X,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new C.RawContextKey("customExecutionSupported",!0,p.localize(0,null)),e.ShellExecutionSupportedContext=new C.RawContextKey("shellExecutionSupported",!1,p.localize(1,null)),e.ProcessExecutionSupportedContext=new C.RawContextKey("processExecutionSupported",!1,p.localize(2,null)),e.ITaskService=(0,L.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(he[208],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function p(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=p;function L(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=L}),define(he[123],fe([0,1,7]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.testRunConfigurationBitsetList=e.TestRunConfigurationBitset=e.identifyTest=e.TestResultState=void 0,Object.defineProperty(e,"TestResultState",{enumerable:!0,get:function(){return p.TestResultState}});const L=P=>({testId:P.item.extId,controllerId:P.controllerId});e.identifyTest=L;var C;(function(P){P[P.Run=2]="Run",P[P.Debug=4]="Debug",P[P.Coverage=8]="Coverage",P[P.HasNonDefaultConfig=16]="HasNonDefaultConfig",P[P.HasConfigurable=32]="HasConfigurable"})(C=e.TestRunConfigurationBitset||(e.TestRunConfigurationBitset={})),e.testRunConfigurationBitsetList=[2,4,8,16];var y;(function(P){P[P.NotExpandable=0]="NotExpandable",P[P.Expandable=1]="Expandable",P[P.BusyExpanding=2]="BusyExpanding",P[P.Expanded=3]="Expanded"})(y=e.TestItemExpandState||(e.TestItemExpandState={}));const T=(P,c)=>{c.expand!==void 0&&(P.expand=c.expand),c.item!==void 0&&(P.item=P.item?Object.assign(P.item,c.item):c.item)};e.applyTestItemUpdate=T;var I;(function(P){P[P.Function=0]="Function",P[P.Statement=1]="Statement"})(I=e.DetailType||(e.DetailType={}));var D;(function(P){P[P.Add=0]="Add",P[P.Update=1]="Update",P[P.Remove=2]="Remove",P[P.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",P[P.Retire=4]="Retire"})(D=e.TestDiffOpType||(e.TestDiffOpType={}));class A{add(c){}update(c){}remove(c,u){}complete(){}}e.IncrementalChangeCollector=A;class i{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(c){const u=this.createChangeCollector();for(const a of c)switch(a[0]){case 0:{const g=a[1];if(g.parent){if(this.items.has(g.parent)){const w=this.items.get(g.parent);w.children.add(g.item.extId);const _=this.createItem(g,w);this.items.set(g.item.extId,_),u.add(_)}}else{const w=this.createItem(g);this.roots.add(w),this.items.set(g.item.extId,w),u.add(w)}g.expand===2&&this.busyControllerCount++;break}case 1:{const g=a[1],w=this.items.get(g.extId);if(!w)break;g.expand!==void 0&&(w.expand===2&&this.busyControllerCount--,g.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(w,g),u.update(w);break}case 2:{const g=this.items.get(a[1]);if(!g)break;g.parent?this.items.get(g.parent).children.delete(g.item.extId):this.roots.delete(g);const w=[[a[1]]];for(;w.length;)for(const _ of w.pop()){const b=this.items.get(_);b&&(w.push(b.children),this.items.delete(_),u.remove(b,b!==g),b.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(a[1]);break;case 3:this.updatePendingRoots(a[1]);break}u.complete()}retireTest(c){}updatePendingRoots(c){this.pendingRootCount+=c}createChangeCollector(){return new A}}e.AbstractIncrementalTestCollection=i}),define(he[209],fe([0,1,9,37,14,25,11,76,172]),function(X,e,p,L,C,y,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class A{constructor(P,c,u){this._contributedVariables=new Map,this._context=P,this._labelService=c,u&&(this._envVariablesPromise=u.then(a=>this.prepareEnv(a)))}prepareEnv(P){if(T.isWindows){const c=Object.create(null);return Object.keys(P).forEach(u=>{c[u.toLowerCase()]=P[u]}),c}return P}resolveWithEnvironment(P,c,u){return this.recursiveResolve(this.prepareEnv(P),c?c.uri:void 0,u)}async resolveAsync(P,c){return this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,c)}async resolveAnyBase(P,c,u,a){const g=y.deepClone(c);return T.isWindows&&g.windows?Object.keys(g.windows).forEach(w=>g[w]=g.windows[w]):T.isMacintosh&&g.osx?Object.keys(g.osx).forEach(w=>g[w]=g.osx[w]):T.isLinux&&g.linux&&Object.keys(g.linux).forEach(w=>g[w]=g.linux[w]),delete g.windows,delete g.osx,delete g.linux,this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,g,u,a)}async resolveAnyAsync(P,c,u){return this.resolveAnyBase(P,c,u)}async resolveAnyMap(P,c,u){const a=new Map;return{newConfig:await this.resolveAnyBase(P,c,u,a),resolvedVariables:a}}resolveWithInteractionReplace(P,c,u,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,c,u,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,c){if(this._contributedVariables.has(P))throw new Error("Variable "+P+" is contributed twice.");this._contributedVariables.set(P,c)}recursiveResolve(P,c,u,a,g){if(C.isString(u))return this.resolveString(P,c,u,a,g);if(C.isArray(u))return u.map(w=>this.recursiveResolve(P,c,w,a,g));if(C.isObject(u)){let w=Object.create(null);return Object.keys(u).forEach(_=>{const b=this.resolveString(P,c,_,a,g);w[b]=this.recursiveResolve(P,c,u[_],a,g)}),w}return u}resolveString(P,c,u,a,g){return u.replace(A.VARIABLE_REGEXP,(_,b)=>{if(b.includes(A.VARIABLE_LHS))return _;let d=this.evaluateSingleVariable(P,_,b,c,a);return g&&g.set(b,d),d!==_&&C.isString(d)&&d.match(A.VARIABLE_REGEXP)&&(d=this.resolveString(P,c,d,a,g)),d})}fsPath(P){return this._labelService?this._labelService.getUriLabel(P,{noPrefix:!0}):P.fsPath}evaluateSingleVariable(P,c,u,a,g){let w;const _=u.split(":");_.length>1&&(u=_[0],w=_[1]);const b=()=>{const v=this._context.getFilePath();if(v)return v;throw new Error((0,D.localize)(0,null,c))},d=()=>{const v=b();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,D.localize)(1,null,c,p.basename(v)))},h=()=>{if(w){const v=this._context.getFolderUri(w);if(v)return v;throw new Error((0,D.localize)(2,null,c,w))}if(a)return a;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,c)):new Error((0,D.localize)(4,null,c))};switch(u){case"env":if(w){if(P){const v=P[T.isWindows?w.toLowerCase():w];if(C.isString(v))return v}return""}throw new Error((0,D.localize)(5,null,c));case"config":if(w){const v=this._context.getConfigurationValue(a,w);if(C.isUndefinedOrNull(v))throw new Error((0,D.localize)(6,null,c,w));if(C.isObject(v))throw new Error((0,D.localize)(7,null,c,w));return v}throw new Error((0,D.localize)(8,null,c));case"command":return this.resolveFromMap(c,w,g,"command");case"input":return this.resolveFromMap(c,w,g,"input");default:switch(u){case"workspaceRoot":case"workspaceFolder":return(0,I.normalizeDriveLetter)(this.fsPath(h()));case"cwd":return a||w?(0,I.normalizeDriveLetter)(this.fsPath(h())):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return p.basename(this.fsPath(h()));case"lineNumber":const v=this._context.getLineNumber();if(v)return v;throw new Error((0,D.localize)(9,null,c));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,D.localize)(10,null,c));case"file":return b();case"fileWorkspaceFolder":return d();case"relativeFile":return a||w?p.relative(this.fsPath(h()),b()):b();case"relativeFileDirname":const s=p.dirname(b());if(a||w){const f=p.relative(this.fsPath(h()),s);return f.length===0?".":f}return s;case"fileDirname":return p.dirname(b());case"fileExtname":return p.extname(b());case"fileBasename":return p.basename(b());case"fileBasenameNoExtension":const r=p.basename(b());return r.slice(0,r.length-p.extname(r).length);case"fileDirnameBasename":return p.basename(p.dirname(b()));case"execPath":const n=this._context.getExecPath();return n||c;case"execInstallFolder":const l=this._context.getAppRoot();return l||c;case"pathSeparator":return p.sep;default:try{const f=w?`${u}:${w}`:u;return this.resolveFromMap(c,f,g,void 0)}catch(f){return c}}}}resolveFromMap(P,c,u,a){if(c&&u){const g=a===void 0?u[c]:u[a+":"+c];if(typeof g=="string")return g;throw new Error((0,D.localize)(11,null,P))}return P}}e.AbstractVariableResolverService=A,A.VARIABLE_LHS="${",A.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(he[124],fe([0,1,4,203]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,p.createDecorator)("editorGroupsService");var C;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(C=e.GroupDirection||(e.GroupDirection={}));var y;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(y=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var I;(function(g){g[g.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(I=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));function A(g){const w=g;return(0,L.isEditorInput)(w?.editor)&&(0,L.isEditorInput)(w?.replacement)}e.isEditorReplacement=A;var i;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(i=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(g){g[g.GROUP_ACTIVE=0]="GROUP_ACTIVE",g[g.GROUP_INDEX=1]="GROUP_INDEX",g[g.EDITOR_OPEN=2]="EDITOR_OPEN",g[g.EDITOR_CLOSE=3]="EDITOR_CLOSE",g[g.EDITOR_MOVE=4]="EDITOR_MOVE",g[g.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",g[g.EDITOR_LABEL=6]="EDITOR_LABEL",g[g.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",g[g.EDITOR_PIN=8]="EDITOR_PIN",g[g.EDITOR_STICKY=9]="EDITOR_STICKY",g[g.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(P=e.GroupChangeKind||(e.GroupChangeKind={}));var c;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(c=e.OpenEditorContext||(e.OpenEditorContext={}));function u(g){const w=g;return!!w&&typeof w.id=="number"&&Array.isArray(w.editors)}e.isEditorGroup=u;function a(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=a}),define(he[210],fe([0,1,4,124]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,p.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function C(y){const T=y;return typeof y=="number"||(0,L.isEditorGroup)(T)}e.isPreferredGroup=C}),define(he[16],fe([0,1,18,96,284,57,25,14,2,40,79,173,115,85,87,210,7]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var _;(function(ve){function De(Y){const{selectionStartLineNumber:Se,selectionStartColumn:ze,positionLineNumber:Je,positionColumn:Ke}=Y,lt=new w.Position(Se-1,ze-1),ht=new w.Position(Je-1,Ke-1);return new w.Selection(lt,ht)}ve.to=De;function ce(Y){const{anchor:Se,active:ze}=Y;return{selectionStartLineNumber:Se.line+1,selectionStartColumn:Se.character+1,positionLineNumber:ze.line+1,positionColumn:ze.character+1}}ve.from=ce})(_=e.Selection||(e.Selection={}));var b;(function(ve){function De(Y){if(!Y)return;const{start:Se,end:ze}=Y;return{startLineNumber:Se.line+1,startColumn:Se.character+1,endLineNumber:ze.line+1,endColumn:ze.character+1}}ve.from=De;function ce(Y){if(!Y)return;const{startLineNumber:Se,startColumn:ze,endLineNumber:Je,endColumn:Ke}=Y;return new w.Range(Se-1,ze-1,Je-1,Ke-1)}ve.to=ce})(b=e.Range||(e.Range={}));var d;(function(ve){function De(ce){switch(ce){case 1:return w.StandardTokenType.Comment;case 0:return w.StandardTokenType.Other;case 4:return w.StandardTokenType.RegEx;case 2:return w.StandardTokenType.String}}ve.to=De})(d=e.TokenType||(e.TokenType={}));var h;(function(ve){function De(Y){return new w.Position(Y.lineNumber-1,Y.column-1)}ve.to=De;function ce(Y){return{lineNumber:Y.line+1,column:Y.character+1}}ve.from=ce})(h=e.Position||(e.Position={}));var v;(function(ve){function De(Y){switch(Y){case w.DiagnosticTag.Unnecessary:return 1;case w.DiagnosticTag.Deprecated:return 2}}ve.from=De;function ce(Y){switch(Y){case 1:return w.DiagnosticTag.Unnecessary;case 2:return w.DiagnosticTag.Deprecated;default:return}}ve.to=ce})(v=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(ve){function De(Y){let Se;return Y.code&&((0,I.isString)(Y.code)||(0,I.isNumber)(Y.code)?Se=String(Y.code):Se={value:String(Y.code.value),target:Y.code.target}),{...b.from(Y.range),message:Y.message,source:Y.source,code:Se,severity:r.from(Y.severity),relatedInformation:Y.relatedInformation&&Y.relatedInformation.map(s.from),tags:Array.isArray(Y.tags)?(0,p.coalesce)(Y.tags.map(v.from)):void 0}}ve.from=De;function ce(Y){const Se=new w.Diagnostic(b.to(Y),Y.message,r.to(Y.severity));return Se.source=Y.source,Se.code=(0,I.isString)(Y.code)?Y.code:Y.code?.value,Se.relatedInformation=Y.relatedInformation&&Y.relatedInformation.map(s.to),Se.tags=Y.tags&&(0,p.coalesce)(Y.tags.map(v.to)),Se}ve.to=ce})(t=e.Diagnostic||(e.Diagnostic={}));var s;(function(ve){function De(Y){return{...b.from(Y.location.range),message:Y.message,resource:Y.location.uri}}ve.from=De;function ce(Y){return new w.DiagnosticRelatedInformation(new w.Location(Y.resource,b.to(Y)),Y.message)}ve.to=ce})(s=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var r;(function(ve){function De(Y){switch(Y){case w.DiagnosticSeverity.Error:return c.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return c.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return c.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return c.MarkerSeverity.Hint}return c.MarkerSeverity.Error}ve.from=De;function ce(Y){switch(Y){case c.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case c.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case c.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case c.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}ve.to=ce})(r=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var n;(function(ve){function De(Y){return typeof Y=="number"&&Y>=w.ViewColumn.One?Y-1:Y===w.ViewColumn.Beside?g.SIDE_GROUP:g.ACTIVE_GROUP}ve.from=De;function ce(Y){if(typeof Y=="number"&&Y>=0)return Y+1;throw new Error("invalid 'EditorGroupColumn'")}ve.to=ce})(n=e.ViewColumn||(e.ViewColumn={}));function l(ve){return typeof ve.range!="undefined"}function f(ve){return ve.length===0?!0:!!l(ve[0])}e.isDecorationOptionsArr=f;var m;(function(ve){function De(Ke){return Ke.map(ve.from)}ve.fromMany=De;function ce(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function Y(Ke){let lt;if(ce(Ke)){const{language:Et,value:vt}=Ke;lt={value:"```"+Et+`
`+vt+"\n```\n"}}else w.MarkdownString.isMarkdownString(Ke)?lt={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons}:typeof Ke=="string"?lt={value:Ke}:lt={value:""};const ht=Object.create(null);lt.uris=ht;const yt=Et=>{try{let vt=D.URI.parse(Et,!0);vt=vt.with({query:Se(vt.query,ht)}),ht[Et]=vt}catch(vt){}return""},Ct=new C.Renderer;return Ct.link=yt,Ct.image=Et=>yt(L.parseHrefAndDimensions(Et).href),C(lt.value,{renderer:Ct}),lt}ve.from=Y;function Se(Ke,lt){if(!Ke)return Ke;let ht;try{ht=(0,y.parse)(Ke)}catch(Ct){}if(!ht)return Ke;let yt=!1;return ht=(0,T.cloneAndChange)(ht,Ct=>{if(D.URI.isUri(Ct)){const Et=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[Et]=Ct,yt=!0,Et}else return}),yt?JSON.stringify(ht):Ke}function ze(Ke){const lt=new w.MarkdownString(Ke.value,Ke.supportThemeIcons);return lt.isTrusted=Ke.isTrusted,lt}ve.to=ze;function Je(Ke){if(!!Ke)return typeof Ke=="string"?Ke:ve.from(Ke)}ve.fromStrict=Je})(m=e.MarkdownString||(e.MarkdownString={}));function E(ve){return f(ve)?ve.map(De=>({range:b.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?m.fromMany(De.hoverMessage):De.hoverMessage?m.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):ve.map(De=>({range:b.from(De)}))}e.fromRangeOrRangeWithMessage=E;function S(ve){return typeof ve=="undefined"?ve:typeof ve=="string"?D.URI.file(ve):ve}e.pathOrURIToURI=S;var o;(function(ve){function De(ce){return typeof ce=="undefined"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?S(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}ve.from=De})(o=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var k;(function(ve){function De(ce){return typeof ce=="undefined"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?S(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?o.from(ce.before):void 0,after:ce.after?o.from(ce.after):void 0}}ve.from=De})(k=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var O;(function(ve){function De(ce){if(typeof ce=="undefined")return ce;switch(ce){case w.DecorationRangeBehavior.OpenOpen:return 0;case w.DecorationRangeBehavior.ClosedClosed:return 1;case w.DecorationRangeBehavior.OpenClosed:return 2;case w.DecorationRangeBehavior.ClosedOpen:return 3}}ve.from=De})(O=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var $;(function(ve){function De(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?O.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?k.from(ce.light):void 0,dark:ce.dark?k.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?S(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?o.from(ce.before):void 0,after:ce.after?o.from(ce.after):void 0}}ve.from=De})($=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var G;(function(ve){function De(Y){return{text:Y.newText,eol:Y.newEol&&ee.from(Y.newEol),range:b.from(Y.range)}}ve.from=De;function ce(Y){const Se=new w.TextEdit(b.to(Y.range),Y.text);return Se.newEol=typeof Y.eol=="undefined"?void 0:ee.to(Y.eol),Se}ve.to=ce})(G=e.TextEdit||(e.TextEdit={}));var re;(function(ve){function De(Y,Se,ze){const Je={edits:[]};if(Y instanceof w.WorkspaceEdit)for(let Ke of Y._allEntries())if(Ke._type===1)Je.edits.push({_type:1,oldUri:Ke.from,newUri:Ke.to,options:Ke.options,metadata:Ke.metadata});else if(Ke._type===2){const lt=Se?.getDocument(Ke.uri);Je.edits.push({_type:2,resource:Ke.uri,edit:G.from(Ke.edit),modelVersionId:lt?.version,metadata:Ke.metadata})}else Ke._type===3?Je.edits.push({_type:3,metadata:Ke.metadata,resource:Ke.uri,edit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:ze?.getNotebookDocument(Ke.uri,!0)?.apiNotebook.version}):Ke._type===5&&Je.edits.push({_type:3,metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:ze?.getNotebookDocument(Ke.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(be.from)}});return Je}ve.from=De;function ce(Y){const Se=new w.WorkspaceEdit;for(const ze of Y.edits)ze.edit?Se.replace(D.URI.revive(ze.resource),b.to(ze.edit.range),ze.edit.text):Se.renameFile(D.URI.revive(ze.oldUri),D.URI.revive(ze.newUri),ze.options);return Se}ve.to=ce})(re=e.WorkspaceEdit||(e.WorkspaceEdit={}));var j;(function(ve){const De=Object.create(null);De[w.SymbolKind.File]=0,De[w.SymbolKind.Module]=1,De[w.SymbolKind.Namespace]=2,De[w.SymbolKind.Package]=3,De[w.SymbolKind.Class]=4,De[w.SymbolKind.Method]=5,De[w.SymbolKind.Property]=6,De[w.SymbolKind.Field]=7,De[w.SymbolKind.Constructor]=8,De[w.SymbolKind.Enum]=9,De[w.SymbolKind.Interface]=10,De[w.SymbolKind.Function]=11,De[w.SymbolKind.Variable]=12,De[w.SymbolKind.Constant]=13,De[w.SymbolKind.String]=14,De[w.SymbolKind.Number]=15,De[w.SymbolKind.Boolean]=16,De[w.SymbolKind.Array]=17,De[w.SymbolKind.Object]=18,De[w.SymbolKind.Key]=19,De[w.SymbolKind.Null]=20,De[w.SymbolKind.EnumMember]=21,De[w.SymbolKind.Struct]=22,De[w.SymbolKind.Event]=23,De[w.SymbolKind.Operator]=24,De[w.SymbolKind.TypeParameter]=25;function ce(Se){return typeof De[Se]=="number"?De[Se]:6}ve.from=ce;function Y(Se){for(const ze in De)if(De[ze]===Se)return Number(ze);return w.SymbolKind.Property}ve.to=Y})(j=e.SymbolKind||(e.SymbolKind={}));var N;(function(ve){function De(Y){switch(Y){case w.SymbolTag.Deprecated:return 1}}ve.from=De;function ce(Y){switch(Y){case 1:return w.SymbolTag.Deprecated}}ve.to=ce})(N=e.SymbolTag||(e.SymbolTag={}));var x;(function(ve){function De(Y){return{name:Y.name,kind:j.from(Y.kind),tags:Y.tags&&Y.tags.map(N.from),containerName:Y.containerName,location:B.from(Y.location)}}ve.from=De;function ce(Y){const Se=new w.SymbolInformation(Y.name,j.to(Y.kind),Y.containerName,B.to(Y.location));return Se.tags=Y.tags&&Y.tags.map(N.to),Se}ve.to=ce})(x=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var R;(function(ve){function De(Y){const Se={name:Y.name||"!!MISSING: name!!",detail:Y.detail,range:b.from(Y.range),selectionRange:b.from(Y.selectionRange),kind:j.from(Y.kind),tags:Y.tags?.map(N.from)??[]};return Y.children&&(Se.children=Y.children.map(De)),Se}ve.from=De;function ce(Y){const Se=new w.DocumentSymbol(Y.name,Y.detail,j.to(Y.kind),b.to(Y.range),b.to(Y.selectionRange));return(0,p.isNonEmptyArray)(Y.tags)&&(Se.tags=Y.tags.map(N.to)),Y.children&&(Se.children=Y.children.map(ce)),Se}ve.to=ce})(R=e.DocumentSymbol||(e.DocumentSymbol={}));var V;(function(ve){function De(ce){const Y=new w.CallHierarchyItem(j.to(ce.kind),ce.name,ce.detail||"",D.URI.revive(ce.uri),b.to(ce.range),b.to(ce.selectionRange));return Y._sessionId=ce._sessionId,Y._itemId=ce._itemId,Y}ve.to=De})(V=e.CallHierarchyItem||(e.CallHierarchyItem={}));var F;(function(ve){function De(ce){return new w.CallHierarchyIncomingCall(V.to(ce.from),ce.fromRanges.map(Y=>b.to(Y)))}ve.to=De})(F=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var M;(function(ve){function De(ce){return new w.CallHierarchyOutgoingCall(V.to(ce.to),ce.fromRanges.map(Y=>b.to(Y)))}ve.to=De})(M=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var B;(function(ve){function De(Y){return{range:Y.range&&b.from(Y.range),uri:Y.uri}}ve.from=De;function ce(Y){return new w.Location(D.URI.revive(Y.uri),b.to(Y.range))}ve.to=ce})(B=e.location||(e.location={}));var W;(function(ve){function De(Y){const Se=Y,ze=Y;return{originSelectionRange:Se.originSelectionRange?b.from(Se.originSelectionRange):void 0,uri:Se.targetUri?Se.targetUri:ze.uri,range:b.from(Se.targetRange?Se.targetRange:ze.range),targetSelectionRange:Se.targetSelectionRange?b.from(Se.targetSelectionRange):void 0}}ve.from=De;function ce(Y){return{targetUri:D.URI.revive(Y.uri),targetRange:b.to(Y.range),targetSelectionRange:Y.targetSelectionRange?b.to(Y.targetSelectionRange):void 0,originSelectionRange:Y.originSelectionRange?b.to(Y.originSelectionRange):void 0}}ve.to=ce})(W=e.DefinitionLink||(e.DefinitionLink={}));var Q;(function(ve){function De(Y){return{range:b.from(Y.range),contents:m.fromMany(Y.contents)}}ve.from=De;function ce(Y){return new w.Hover(Y.contents.map(m.to),b.to(Y.range))}ve.to=ce})(Q=e.Hover||(e.Hover={}));var ae;(function(ve){function De(Y){return{range:b.from(Y.range),expression:Y.expression}}ve.from=De;function ce(Y){return new w.EvaluatableExpression(b.to(Y.range),Y.expression)}ve.to=ce})(ae=e.EvaluatableExpression||(e.EvaluatableExpression={}));var _e;(function(ve){function De(Y){if(Y instanceof w.InlineValueText)return{type:"text",range:b.from(Y.range),text:Y.text};if(Y instanceof w.InlineValueVariableLookup)return{type:"variable",range:b.from(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};if(Y instanceof w.InlineValueEvaluatableExpression)return{type:"expression",range:b.from(Y.range),expression:Y.expression};throw new Error("Unknown 'InlineValue' type")}ve.from=De;function ce(Y){switch(Y.type){case"text":return{range:b.to(Y.range),text:Y.text};case"variable":return{range:b.to(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};case"expression":return{range:b.to(Y.range),expression:Y.expression}}}ve.to=ce})(_e=e.InlineValue||(e.InlineValue={}));var Fe;(function(ve){function De(Y){return{frameId:Y.frameId,stoppedLocation:b.from(Y.stoppedLocation)}}ve.from=De;function ce(Y){return new w.InlineValueContext(Y.frameId,b.to(Y.stoppedLocation))}ve.to=ce})(Fe=e.InlineValueContext||(e.InlineValueContext={}));var Ae;(function(ve){function De(Y){return{range:b.from(Y.range),kind:Y.kind}}ve.from=De;function ce(Y){return new w.DocumentHighlight(b.to(Y.range),Y.kind)}ve.to=ce})(Ae=e.DocumentHighlight||(e.DocumentHighlight={}));var Me;(function(ve){function De(ce){switch(ce){case 1:return w.CompletionTriggerKind.TriggerCharacter;case 2:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return w.CompletionTriggerKind.Invoke}}ve.to=De})(Me=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ve;(function(ve){function De(ce){return{triggerKind:Me.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}ve.to=De})(Ve=e.CompletionContext||(e.CompletionContext={}));var He;(function(ve){function De(Y){switch(Y){case w.CompletionItemTag.Deprecated:return 1}}ve.from=De;function ce(Y){switch(Y){case 1:return w.CompletionItemTag.Deprecated}}ve.to=ce})(He=e.CompletionItemTag||(e.CompletionItemTag={}));var z;(function(ve){const De=new Map([[w.CompletionItemKind.Method,0],[w.CompletionItemKind.Function,1],[w.CompletionItemKind.Constructor,2],[w.CompletionItemKind.Field,3],[w.CompletionItemKind.Variable,4],[w.CompletionItemKind.Class,5],[w.CompletionItemKind.Interface,7],[w.CompletionItemKind.Struct,6],[w.CompletionItemKind.Module,8],[w.CompletionItemKind.Property,9],[w.CompletionItemKind.Unit,12],[w.CompletionItemKind.Value,13],[w.CompletionItemKind.Constant,14],[w.CompletionItemKind.Enum,15],[w.CompletionItemKind.EnumMember,16],[w.CompletionItemKind.Keyword,17],[w.CompletionItemKind.Snippet,27],[w.CompletionItemKind.Text,18],[w.CompletionItemKind.Color,19],[w.CompletionItemKind.File,20],[w.CompletionItemKind.Reference,21],[w.CompletionItemKind.Folder,23],[w.CompletionItemKind.Event,10],[w.CompletionItemKind.Operator,11],[w.CompletionItemKind.TypeParameter,24],[w.CompletionItemKind.Issue,26],[w.CompletionItemKind.User,25]]);function ce(ze){return De.get(ze)??9}ve.from=ce;const Y=new Map([[0,w.CompletionItemKind.Method],[1,w.CompletionItemKind.Function],[2,w.CompletionItemKind.Constructor],[3,w.CompletionItemKind.Field],[4,w.CompletionItemKind.Variable],[5,w.CompletionItemKind.Class],[7,w.CompletionItemKind.Interface],[6,w.CompletionItemKind.Struct],[8,w.CompletionItemKind.Module],[9,w.CompletionItemKind.Property],[12,w.CompletionItemKind.Unit],[13,w.CompletionItemKind.Value],[14,w.CompletionItemKind.Constant],[15,w.CompletionItemKind.Enum],[16,w.CompletionItemKind.EnumMember],[17,w.CompletionItemKind.Keyword],[27,w.CompletionItemKind.Snippet],[18,w.CompletionItemKind.Text],[19,w.CompletionItemKind.Color],[20,w.CompletionItemKind.File],[21,w.CompletionItemKind.Reference],[23,w.CompletionItemKind.Folder],[10,w.CompletionItemKind.Event],[11,w.CompletionItemKind.Operator],[24,w.CompletionItemKind.TypeParameter],[25,w.CompletionItemKind.User],[26,w.CompletionItemKind.Issue]]);function Se(ze){return Y.get(ze)??w.CompletionItemKind.Property}ve.to=Se})(z=e.CompletionItemKind||(e.CompletionItemKind={}));var J;(function(ve){function De(ce,Y){const Se=new w.CompletionItem(ce.label);return Se.insertText=ce.insertText,Se.kind=z.to(ce.kind),Se.tags=ce.tags?.map(He.to),Se.detail=ce.detail,Se.documentation=L.isMarkdownString(ce.documentation)?m.to(ce.documentation):ce.documentation,Se.sortText=ce.sortText,Se.filterText=ce.filterText,Se.preselect=ce.preselect,Se.commitCharacters=ce.commitCharacters,A.Range.isIRange(ce.range)?Se.range=b.to(ce.range):typeof ce.range=="object"&&(Se.range={inserting:b.to(ce.range.insert),replacing:b.to(ce.range.replace)}),Se.keepWhitespace=typeof ce.insertTextRules=="undefined"?!1:Boolean(ce.insertTextRules&1),typeof ce.insertTextRules!="undefined"&&ce.insertTextRules&4?Se.insertText=new w.SnippetString(ce.insertText):(Se.insertText=ce.insertText,Se.textEdit=Se.range instanceof w.Range?new w.TextEdit(Se.range,Se.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(Se.additionalTextEdits=ce.additionalTextEdits.map(ze=>G.to(ze))),Se.command=Y&&ce.command?Y.fromInternal(ce.command):void 0,Se}ve.to=De})(J=e.CompletionItem||(e.CompletionItem={}));var ne;(function(ve){function De(Y){return{label:Y.label,documentation:Y.documentation?m.fromStrict(Y.documentation):void 0}}ve.from=De;function ce(Y){return{label:Y.label,documentation:L.isMarkdownString(Y.documentation)?m.to(Y.documentation):Y.documentation}}ve.to=ce})(ne=e.ParameterInformation||(e.ParameterInformation={}));var oe;(function(ve){function De(Y){return{label:Y.label,documentation:Y.documentation?m.fromStrict(Y.documentation):void 0,parameters:Array.isArray(Y.parameters)?Y.parameters.map(ne.from):[],activeParameter:Y.activeParameter}}ve.from=De;function ce(Y){return{label:Y.label,documentation:L.isMarkdownString(Y.documentation)?m.to(Y.documentation):Y.documentation,parameters:Array.isArray(Y.parameters)?Y.parameters.map(ne.to):[],activeParameter:Y.activeParameter}}ve.to=ce})(oe=e.SignatureInformation||(e.SignatureInformation={}));var we;(function(ve){function De(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(oe.from):[]}}ve.from=De;function ce(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(oe.to):[]}}ve.to=ce})(we=e.SignatureHelp||(e.SignatureHelp={}));var Z;(function(ve){function De(Y){return{text:Y.text,position:h.from(Y.position),kind:de.from(Y.kind??w.InlayHintKind.Other),whitespaceBefore:Y.whitespaceBefore,whitespaceAfter:Y.whitespaceAfter}}ve.from=De;function ce(Y){const Se=new w.InlayHint(Y.text,h.to(Y.position),de.to(Y.kind));return Se.whitespaceAfter=Y.whitespaceAfter,Se.whitespaceBefore=Y.whitespaceBefore,Se}ve.to=ce})(Z=e.InlayHint||(e.InlayHint={}));var de;(function(ve){function De(Y){return Y}ve.from=De;function ce(Y){return Y}ve.to=ce})(de=e.InlayHintKind||(e.InlayHintKind={}));var Ie;(function(ve){function De(Y){return{range:b.from(Y.range),url:Y.target,tooltip:Y.tooltip}}ve.from=De;function ce(Y){let Se;if(Y.url)try{Se=typeof Y.url=="string"?D.URI.parse(Y.url,!0):D.URI.revive(Y.url)}catch(ze){}return new w.DocumentLink(b.to(Y.range),Se)}ve.to=ce})(Ie=e.DocumentLink||(e.DocumentLink={}));var Be;(function(ve){function De(Y){const Se=new w.ColorPresentation(Y.label);return Y.textEdit&&(Se.textEdit=G.to(Y.textEdit)),Y.additionalTextEdits&&(Se.additionalTextEdits=Y.additionalTextEdits.map(ze=>G.to(ze))),Se}ve.to=De;function ce(Y){return{label:Y.label,textEdit:Y.textEdit?G.from(Y.textEdit):void 0,additionalTextEdits:Y.additionalTextEdits?Y.additionalTextEdits.map(Se=>G.from(Se)):void 0}}ve.from=ce})(Be=e.ColorPresentation||(e.ColorPresentation={}));var qe;(function(ve){function De(Y){return new w.Color(Y[0],Y[1],Y[2],Y[3])}ve.to=De;function ce(Y){return[Y.red,Y.green,Y.blue,Y.alpha]}ve.from=ce})(qe=e.Color||(e.Color={}));var Ee;(function(ve){function De(Y){return{range:b.from(Y.range)}}ve.from=De;function ce(Y){return new w.SelectionRange(b.to(Y.range))}ve.to=ce})(Ee=e.SelectionRange||(e.SelectionRange={}));var tt;(function(ve){function De(ce){switch(ce){case 2:return w.TextDocumentSaveReason.AfterDelay;case 1:return w.TextDocumentSaveReason.Manual;case 3:case 4:return w.TextDocumentSaveReason.FocusOut}}ve.to=De})(tt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var K;(function(ve){function De(Y){switch(Y){case w.TextEditorLineNumbersStyle.Off:return 0;case w.TextEditorLineNumbersStyle.Relative:return 2;case w.TextEditorLineNumbersStyle.On:default:return 1}}ve.from=De;function ce(Y){switch(Y){case 0:return w.TextEditorLineNumbersStyle.Off;case 2:return w.TextEditorLineNumbersStyle.Relative;case 1:default:return w.TextEditorLineNumbersStyle.On}}ve.to=ce})(K=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ee;(function(ve){function De(Y){if(Y===w.EndOfLine.CRLF)return 1;if(Y===w.EndOfLine.LF)return 0}ve.from=De;function ce(Y){if(Y===1)return w.EndOfLine.CRLF;if(Y===0)return w.EndOfLine.LF}ve.to=ce})(ee=e.EndOfLine||(e.EndOfLine={}));var pe;(function(ve){function De(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case w.ProgressLocation.SourceControl:return 3;case w.ProgressLocation.Window:return 10;case w.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ve.from=De})(pe=e.ProgressLocation||(e.ProgressLocation={}));var xe;(function(ve){function De(ce){const Y={start:ce.start+1,end:ce.end+1};return ce.kind&&(Y.kind=$e.from(ce.kind)),Y}ve.from=De})(xe=e.FoldingRange||(e.FoldingRange={}));var $e;(function(ve){function De(ce){if(ce)switch(ce){case w.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case w.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case w.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}ve.from=De})($e=e.FoldingRangeKind||(e.FoldingRangeKind={}));var et;(function(ve){function De(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?b.from(ce.selection):void 0,override:typeof ce.override=="boolean"?P.EditorResolution.DISABLED:void 0}}ve.from=De})(et=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ke;(function(ve){function De(Y){return Y instanceof w.RelativePattern||typeof Y=="string"?Y:ce(Y)?new w.RelativePattern(Y.base,Y.pattern):Y}ve.from=De;function ce(Y){const Se=Y;return Se&&typeof Se.base=="string"&&typeof Se.pattern=="string"}})(ke=e.GlobPattern||(e.GlobPattern={}));var Ce;(function(ve){function De(ce){if(ce){if(Array.isArray(ce))return ce.map(De);if(typeof ce=="string")return ce;{const Y=ce;return{language:Y.language,scheme:Y.scheme,pattern:typeof Y.pattern=="undefined"?void 0:ke.from(Y.pattern),exclusive:Y.exclusive}}}else return}ve.from=De})(Ce=e.LanguageSelector||(e.LanguageSelector={}));var Re;(function(ve){function De(Y){return{start:Y.start,end:Y.end}}ve.from=De;function ce(Y){return new w.NotebookRange(Y.start,Y.end)}ve.to=ce})(Re=e.NotebookRange||(e.NotebookRange={}));var se;(function(ve){function De(Y){return{timing:typeof Y.runStartTime=="number"&&typeof Y.runEndTime=="number"?{startTime:Y.runStartTime,endTime:Y.runEndTime}:void 0,executionOrder:Y.executionOrder,success:Y.lastRunSuccess}}ve.to=De;function ce(Y){return{lastRunSuccess:Y.success,runStartTime:Y.timing?.startTime,runEndTime:Y.timing?.endTime,executionOrder:Y.executionOrder}}ve.from=ce})(se=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var le;(function(ve){function De(Y){switch(Y){case w.NotebookCellKind.Markup:return a.CellKind.Markup;case w.NotebookCellKind.Code:default:return a.CellKind.Code}}ve.from=De;function ce(Y){switch(Y){case a.CellKind.Markup:return w.NotebookCellKind.Markup;case a.CellKind.Code:default:return w.NotebookCellKind.Code}}ve.to=ce})(le=e.NotebookCellKind||(e.NotebookCellKind={}));var me;(function(ve){function De(Y){const Se={metadata:Y.metadata??Object.create(null),cells:[]};for(let ze of Y.cells)w.NotebookCellData.validate(ze),Se.cells.push(be.from(ze));return Se}ve.from=De;function ce(Y){const Se=new w.NotebookData(Y.cells.map(be.to));return(0,I.isEmptyObject)(Y.metadata)||(Se.metadata=Y.metadata),Se}ve.to=ce})(me=e.NotebookData||(e.NotebookData={}));var be;(function(ve){function De(Y){return{cellKind:le.from(Y.kind),language:Y.languageId,mime:Y.mime,source:Y.value,metadata:Y.metadata,internalMetadata:se.from(Y.executionSummary??{}),outputs:Y.outputs?Y.outputs.map(ge.from):[]}}ve.from=De;function ce(Y){return new w.NotebookCellData(le.to(Y.cellKind),Y.source,Y.language,Y.mime,Y.outputs?Y.outputs.map(ge.to):void 0,Y.metadata,Y.internalMetadata?se.to(Y.internalMetadata):void 0)}ve.to=ce})(be=e.NotebookCellData||(e.NotebookCellData={}));var q;(function(ve){function De(Y){return{mime:Y.mime,valueBytes:Array.from(Y.data)}}ve.from=De;function ce(Y){return new w.NotebookCellOutputItem(new Uint8Array(Y.valueBytes),Y.mime)}ve.to=ce})(q=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ge;(function(ve){function De(Y){return{outputId:Y.id,items:Y.items.map(q.from),metadata:Y.metadata}}ve.from=De;function ce(Y){const Se=Y.items.map(q.to);return new w.NotebookCellOutput(Se,Y.outputId,Y.metadata)}ve.to=ce})(ge=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ye;(function(ve){function De(ze){if(ze!=null){if(ze instanceof w.RelativePattern||typeof ze=="string")return ze;if(Se(ze))return new w.RelativePattern(ze.base,ze.pattern);if(Y(ze))return{include:ke.from(ze.include)||void 0,exclude:ke.from(ze.exclude)||void 0}}}ve.from=De;function ce(ze){return typeof ze=="string"?ze:Se(ze)?{base:ze.base,pattern:ze.pattern}:{include:ze.include,exclude:ze.exclude}}ve.to=ce;function Y(ze){const Je=ze,Ke=ke.from(Je.include);if(!(Ke&&Ke instanceof w.RelativePattern||typeof Ke=="string"))return!1;const lt=ke.from(Je.exclude);return!!(lt&&lt instanceof w.RelativePattern||typeof lt=="string")}function Se(ze){const Je=ze;return Je&&typeof Je.base=="string"&&typeof Je.pattern=="string"}})(ye=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Te;(function(ve){function De(ce){return{backgroundColor:ce.backgroundColor,borderColor:ce.borderColor,top:ce.top?o.from(ce.top):void 0}}ve.from=De})(Te=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Oe;(function(ve){function De(ce,Y,Se){const ze=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{alignment:ce.alignment===w.NotebookCellStatusBarAlignment.Left?1:2,command:Y.toInternal(ze,Se),text:ce.text,tooltip:ce.tooltip,accessibilityInformation:ce.accessibilityInformation,priority:ce.priority}}ve.from=De})(Oe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ge;(function(ve){function De(ce){return{transientOutputs:ce?.transientOutputs??!1,transientCellMetadata:ce?.transientCellMetadata??{},transientDocumentMetadata:ce?.transientDocumentMetadata??{}}}ve.from=De})(Ge=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ze;(function(ve){function De(Y){return{uri:Y.uri,provides:Y.provides}}ve.from=De;function ce(Y){return new w.NotebookRendererScript(D.URI.revive(Y.uri),Y.provides)}ve.to=ce})(Ze=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Qe;(function(ve){function De(Y){return{message:m.fromStrict(Y.message)||"",severity:Y.severity,expectedOutput:Y.expectedOutput,actualOutput:Y.actualOutput,location:Y.location?B.from(Y.location):void 0}}ve.from=De;function ce(Y){const Se=new w.TestMessage(typeof Y.message=="string"?Y.message:m.to(Y.message));return Se.severity=Y.severity,Se.actualOutput=Y.actualOutput,Se.expectedOutput=Y.expectedOutput,Se}ve.to=ce})(Qe=e.TestMessage||(e.TestMessage={}));var Xe;(function(ve){function De(Je){return{extId:Je.id,label:Je.label,uri:Je.uri,range:b.from(Je.range)||null,description:Je.description||null,error:Je.error&&m.fromStrict(Je.error)||null}}ve.from=De;function ce(Je){return{extId:Je.id,label:Je.label,uri:Je.uri,range:b.from(Je.range)||null,description:Je.description||null,error:null}}ve.fromResultSnapshot=ce;function Y(Je){return{id:Je.extId,label:Je.label,uri:D.URI.revive(Je.uri),range:b.to(Je.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Je.description||void 0}}ve.toPlain=Y;function Se(Je){const Ke=new u.TestItemImpl(Je.extId,Je.label,D.URI.revive(Je.uri));return Ke.range=b.to(Je.range||void 0),Ke.description=Je.description||void 0,Ke}ve.to=Se;function ze(Je){let Ke;for(const lt of Je.tests){const ht=Se(lt.item);(0,u.getPrivateApiFor)(ht).parent=Ke,Ke=ht}return Ke}ve.toItemFromContext=ze})(Xe=e.TestItem||(e.TestItem={}));var at;(function(ve){const De=(Y,Se)=>({...Xe.toPlain(Y.item),taskStates:Y.tasks.map(ze=>({state:ze.state,duration:ze.duration,messages:ze.messages.map(Qe.to)})),children:Y.children.map(ze=>Se.get(ze)).filter(I.isDefined).map(ze=>De(ze,Se))});function ce(Y){const Se=[],ze=new Map;for(const Je of Y.items)ze.set(Je.item.extId,Je),Y.request.targets.some(Ke=>Ke.controllerId===Je.controllerId&&Ke.testIds.includes(Je.item.extId))&&Se.push(Je);return{completedAt:Y.completedAt,results:Se.map(Je=>De(Je,ze))}}ve.to=ce})(at=e.TestResults||(e.TestResults={}));var ut;(function(ve){function De(ze){return{covered:ze.covered,total:ze.covered}}function ce(ze){return"line"in ze?h.from(ze):b.from(ze)}function Y(ze){return"branches"in ze?{count:ze.executionCount,location:ce(ze.location),type:1,branches:ze.branches.length?ze.branches.map(Je=>({count:Je.executionCount,location:Je.location&&ce(Je.location)})):void 0}:{type:0,count:ze.executionCount,location:ce(ze.location)}}ve.fromDetailed=Y;function Se(ze){return{uri:ze.uri,statement:De(ze.statementCoverage),branch:ze.branchCoverage&&De(ze.branchCoverage),function:ze.functionCoverage&&De(ze.functionCoverage),details:ze.detailedCoverage?.map(Y)}}ve.fromFile=Se})(ut=e.TestCoverage||(e.TestCoverage={}));var bt;(function(ve){function De(ce){switch(ce){case 1:return w.CodeActionTriggerKind.Invoke;case 2:return w.CodeActionTriggerKind.Automatic}}ve.to=De})(bt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(he[211],fe([0,1,2,15,7,16,92]),function(X,e,p,L,C,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class I{constructor(A,i,P,c={timeout:1500,errors:3}){this._logService=A,this._documents=i,this._mainThreadBulkEdits=P,this._thresholds=c,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(A){return(i,P,c)=>{const a={dispose:this._callbacks.push([i,P,A])};return Array.isArray(c)&&c.push(a),a}}async $participateInSave(A,i){const P=p.URI.revive(A);let c=!1;const u=setTimeout(()=>c=!0,this._thresholds.timeout),a=[];try{for(let g of[...this._callbacks]){if(c)break;const w=this._documents.getDocument(P),_=await this._deliverEventAsyncAndBlameBadListeners(g,{document:w,reason:y.TextDocumentSaveReason.to(i)});a.push(_)}}finally{clearTimeout(u)}return a}_deliverEventAsyncAndBlameBadListeners([A,i,P],c){const u=this._badListeners.get(A);return typeof u=="number"&&u>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(P,A,i,c).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const g=this._badListeners.get(A);this._badListeners.set(A,g?g+1:1),typeof g=="number"&&g>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(A,i,P,c){const u=[],a=Date.now(),{document:g,reason:w}=c,{version:_}=g,b=Object.freeze({document:g,reason:w,waitUntil(d){if(Object.isFrozen(u))throw(0,L.illegalState)("waitUntil can not be called async");u.push(Promise.resolve(d))}});try{i.apply(P,[b])}catch(d){return Promise.reject(d)}return Object.freeze(u),new Promise((d,h)=>{const v=setTimeout(()=>h(new Error("timeout")),this._thresholds.timeout);return Promise.all(u).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(v),d(t)}).catch(t=>{clearTimeout(v),h(t)})}).then(d=>{const h={edits:[]};for(const v of d)if(Array.isArray(v)&&v.every(t=>t instanceof C.TextEdit))for(const{newText:t,newEol:s,range:r}of v)h.edits.push({_type:2,resource:g.uri,edit:{range:r&&y.Range.from(r),text:t,eol:s&&y.EndOfLine.from(s)}});if(h.edits.length!==0)return _===g.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(h):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=I}),define(he[212],fe([0,1,3,30,2,16,7]),function(X,e,p,L,C,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class I{constructor(i,P,c,u,a){this._onDidCreate=new p.Emitter,this._onDidChange=new p.Emitter,this._onDidDelete=new p.Emitter,this._config=0,c&&(this._config+=1),u&&(this._config+=2),a&&(this._config+=4);const g=(0,L.parse)(P),w=i(_=>{if(!c)for(let b of _.created){const d=C.URI.revive(b);g(d.fsPath)&&this._onDidCreate.fire(d)}if(!u)for(let b of _.changed){const d=C.URI.revive(b);g(d.fsPath)&&this._onDidChange.fire(d)}if(!a)for(let b of _.deleted){const d=C.URI.revive(b);g(d.fsPath)&&this._onDidDelete.fire(d)}});this._disposable=T.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class D{constructor(i,P,c){this._logService=P,this._extHostDocumentsAndEditors=c,this._onFileSystemEvent=new p.Emitter,this._onDidRenameFile=new p.Emitter,this._onDidCreateFile=new p.Emitter,this._onDidDeleteFile=new p.Emitter,this._onWillRenameFile=new p.AsyncEmitter,this._onWillCreateFile=new p.AsyncEmitter,this._onWillDeleteFile=new p.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(i,P,c,u){return new I(this._onFileSystemEvent.event,i,P,c,u)}$onFileEvent(i){this._onFileSystemEvent.fire(i)}$onDidRunFileOperation(i,P){switch(i){case 2:this._onDidRenameFile.fire(Object.freeze({files:P.map(c=>({oldUri:C.URI.revive(c.source),newUri:C.URI.revive(c.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:P.map(c=>C.URI.revive(c.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:P.map(c=>C.URI.revive(c.target))}));break;default:}}getOnWillRenameFileEvent(i){return this._createWillExecuteEvent(i,this._onWillRenameFile)}getOnWillCreateFileEvent(i){return this._createWillExecuteEvent(i,this._onWillCreateFile)}getOnWillDeleteFileEvent(i){return this._createWillExecuteEvent(i,this._onWillDeleteFile)}_createWillExecuteEvent(i,P){return(c,u,a)=>{const g=function(_){c.call(u,_)};return g.extension=i,P.event(g,void 0,a)}}async $onWillRunFileOperation(i,P,c,u){switch(i){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:P.map(a=>({oldUri:C.URI.revive(a.source),newUri:C.URI.revive(a.target)}))},c,u);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:P.map(a=>C.URI.revive(a.target))},c,u);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:P.map(a=>C.URI.revive(a.target))},c,u)}}async _fireWillEvent(i,P,c,u){const a=new Set,g=[];if(await i.fireAsync(P,u,async(_,b)=>{const d=Date.now(),h=await Promise.resolve(_);h instanceof T.WorkspaceEdit&&(g.push(h),a.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-d>c&&this._logService.warn("SLOW file-participant",b.extension.identifier)}),u.isCancellationRequested||g.length===0)return;const w={edits:[]};for(let _ of g){let{edits:b}=y.WorkspaceEdit.from(_,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(b)}return{edit:w,extensionNames:Array.from(a)}}}e.ExtHostFileSystemEventService=D}),define(he[213],fe([0,1,10,25,2,16,7,87]),function(X,e,p,L,C,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(c,u,a,g){this.start=c,this.deletedCount=u,this.deletedItems=a,this.items=g}static asApiEvents(c){return c.map(u=>({start:u.start,deletedCount:u.deletedCount,deletedItems:u.deletedItems,items:u.items.map(a=>a.apiCell)}))}}class A{constructor(c,u,a){this.notebook=c,this._extHostDocument=u,this._cellData=a,this.handle=a.handle,this.uri=C.URI.revive(a.uri),this.cellKind=a.cellKind,this._outputs=a.outputs.map(y.NotebookCellOutput.to),this._internalMetadata=a.internalMetadata??{},this._metadata=a.metadata??{},this._previousResult=y.NotebookCellExecutionSummary.to(a.internalMetadata??{})}static asModelAddData(c,u){return{EOL:u.eol,lines:u.source,modeId:u.language,uri:u.uri,isDirty:!1,versionId:1,notebook:c}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const c=this,u=this._extHostDocument.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return c.notebook.getCellIndex(c)},notebook:c.notebook.apiNotebook,kind:y.NotebookCellKind.to(this._cellData.cellKind),document:u.document,get mime(){return c._mime},set mime(a){c._mime=a},get outputs(){return c._outputs.slice(0)},get metadata(){return c._metadata},get executionSummary(){return c._previousResult}})}return this._apiCell}setOutputs(c){this._outputs=c.map(y.NotebookCellOutput.to)}setOutputItems(c,u,a){const g=a.map(y.NotebookCellOutputItem.to),w=this._outputs.find(_=>_.id===c);w&&(u||(w.items.length=0),w.items.push(...g))}setMetadata(c){this._metadata=c}setInternalMetadata(c){this._internalMetadata=c,this._previousResult=y.NotebookCellExecutionSummary.to(c)}setMime(c){}}e.ExtHostCell=A;class i{constructor(c,u,a,g,w,_){this._proxy=c,this._textDocumentsAndEditors=u,this._textDocuments=a,this._emitter=g,this.uri=w,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=_.viewType,this._metadata=_.metadata??Object.create(null),this._spliceNotebookCells([[0,0,_.cells]],!0),this._versionId=_.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const c=this;this._notebook={get uri(){return c.uri},get version(){return c._versionId},get notebookType(){return c._notebookType},get isDirty(){return c._isDirty},get isUntitled(){return c.uri.scheme===p.Schemas.untitled},get isClosed(){return c._disposed},get metadata(){return c._metadata},get cellCount(){return c._cells.length},cellAt(u){return u=c._validateIndex(u),c._cells[u].apiCell},getCells(u){return(u?c._getCells(u):c._cells).map(g=>g.apiCell)},save(){return c._save()}}}return this._notebook}updateBackup(c){this._backup?.delete(),this._backup=c}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(c){c.metadata&&(this._metadata={...this._metadata,...c.metadata})}acceptDirty(c){this._isDirty=c}acceptModelChanged(c,u){this._versionId=c.versionId,this._isDirty=u;for(const a of c.rawEvents)a.kind===I.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1):a.kind===I.NotebookCellsChangeType.Move?this._moveCell(a.index,a.newIdx):a.kind===I.NotebookCellsChangeType.Output?this._setCellOutputs(a.index,a.outputs):a.kind===I.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems):a.kind===I.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(a.index,a.language):a.kind===I.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(a.index,a.mime):a.kind===I.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(a.index,a.metadata):a.kind===I.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(a.index,a.internalMetadata)}_validateIndex(c){return c=c|0,c<0?0:c>=this._cells.length?this._cells.length-1:c}_validateRange(c){let u=c.start|0,a=c.end|0;return u<0&&(u=0),a>this._cells.length&&(a=this._cells.length),c.with({start:u,end:a})}_getCells(c){c=this._validateRange(c);const u=[];for(let a=c.start;a<c.end;a++)u.push(this._cells[a]);return u}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(c,u){if(this._disposed)return;const a=[],g=[],w=[];c.reverse().forEach(_=>{const d=_[2].map(t=>{const s=new A(this,this._textDocumentsAndEditors,t);return u||g.push(A.asModelAddData(this.apiNotebook,t)),s}),h=new D(_[0],_[1],[],d),v=this._cells.splice(_[0],_[1],...d);for(const t of v)w.push(t.uri),h.deletedItems.push(t.apiCell);a.push(h)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:w}),u||this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(a)}))}_moveCell(c,u){const a=this._cells.splice(c,1);this._cells.splice(u,0,...a);const g=[new D(c,1,a.map(w=>w.apiCell),[]),new D(u,0,[],a)];this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(g)}))}_setCellOutputs(c,u){const a=this._cells[c];a.setOutputs(u),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[a.apiCell]}))}_setCellOutputItems(c,u,a,g){const w=this._cells[c];w.setOutputItems(u,a,g),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[w.apiCell]}))}_changeCellLanguage(c,u){const a=this._cells[c];a.apiCell.document.languageId!==u&&this._textDocuments.$acceptModelModeChanged(a.uri,u)}_changeCellMime(c,u){const a=this._cells[c];a.apiCell.mime=u}_changeCellMetadata(c,u){const a=this._cells[c],g=a.apiCell.metadata;a.setMetadata(u);const w=a.apiCell.metadata;(0,L.equals)(g,w)||this._emitter.emitCellMetadataChange((0,L.deepFreeze)({document:this.apiNotebook,cell:a.apiCell}))}_changeCellInternalMetadata(c,u){const a=this._cells[c],g=a.internalMetadata;if(a.setInternalMetadata(u),g.runState!==u.runState){const w=u.runState??T.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,L.deepFreeze)({document:this.apiNotebook,cell:a.apiCell,state:w}))}}getCellFromApiCell(c){return this._cells.find(u=>u.apiCell===c)}getCellFromIndex(c){return this._cells[c]}getCell(c){return this._cells.find(u=>u.handle===c)}getCellIndex(c){return this._cells.indexOf(c)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(he[125],fe([0,1,7,16,15]),function(X,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class y{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,A){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:D,metadata:A})}replaceCells(D,A,i){this._throwIfFinalized(),!(D===A&&i.length===0)&&this._collectedEdits.push({editType:1,index:D,count:A-D,cells:i.map(L.NotebookCellData.from)})}}class T{constructor(D,A,i,P,c,u){this.id=D,this._proxy=A,this.notebookData=i,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=c,this._visibleRanges=P,this._viewColumn=u}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.apiNotebook},get selections(){return D._selections},set selections(A){if(!Array.isArray(A)||!A.every(p.NotebookRange.isNotebookRange))throw(0,C.illegalArgument)("selections");D._selections=A,D._trySetSelections(A)},get visibleRanges(){return D._visibleRanges},revealRange(A,i){D._proxy.$tryRevealRange(D.id,L.NotebookRange.from(A),i??p.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(A){const i=new y(this.document.version);return A(i),D._applyEdit(i.finalize())},setDecorations(A,i){return D.setDecorations(A,i)}},T.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_trySetSelections(D){this._proxy.$trySetSelections(this.id,D.map(L.NotebookRange.from))}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const A=[];let i=-1;for(let P=0;P<D.cellEdits.length;P++){if(i<0){A.push(D.cellEdits[P]),i++;continue}const u=A[i],a=D.cellEdits[P];if(u.editType===1&&a.editType===1&&u.index===a.index){u.cells.push(...D.cellEdits[P].cells),u.count+=D.cellEdits[P].count;continue}A.push(D.cellEdits[P]),i++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,A)}setDecorations(D,A){if(!(A.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return A.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,L.NotebookRange.from(A),D.key)}}e.ExtHostNotebookEditor=T,T.apiEditorsToExtHost=new WeakMap}),define(he[214],fe([0,1,16,116,161,21,53]),function(X,e,p,L,C,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class I{constructor(P){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=P}withProgress(P,c,u){const a=this._handles++,{title:g,location:w,cancellable:_}=c,b={label:(0,C.localize)(0,null,P.displayName||P.name),id:P.identifier.value};return this._proxy.$startProgress(a,{location:p.ProgressLocation.from(w),title:g,source:b,cancellable:_},P),this._withProgress(a,u,!!_)}_withProgress(P,c,u){let a;u&&(a=new y.CancellationTokenSource,this._mapHandleToCancellationSource.set(P,a));const g=_=>{this._proxy.$progressEnd(_),this._mapHandleToCancellationSource.delete(_),a&&a.dispose()};let w;try{w=c(new A(this._proxy,P),u&&a?a.token:y.CancellationToken.None)}catch(_){throw g(P),_}return w.then(_=>g(P),_=>g(P)),w}$acceptProgressCanceled(P){const c=this._mapHandleToCancellationSource.get(P);c&&(c.cancel(),this._mapHandleToCancellationSource.delete(P))}}e.ExtHostProgress=I;function D(i,P){return i.message=P.message,typeof P.increment=="number"&&(typeof i.increment=="number"?i.increment+=P.increment:i.increment=P.increment),i}class A extends L.Progress{constructor(P,c){super(u=>this.throttledReport(u));this._proxy=P,this._handle=c}throttledReport(P){this._proxy.$progressReport(this._handle,P)}}je([(0,T.throttle)(100,(i,P)=>D(i,P),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(he[126],fe([0,1,52,15,71,16,7]),function(X,e,p,L,C,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class I{constructor(c,u,a){const g=I._Keys.nextId();c.$registerTextEditorDecorationType(u.identifier,g,y.DecorationRenderOptions.from(a)),this.value=Object.freeze({key:g,dispose(){c.$removeTextEditorDecorationType(g)}})}}e.TextEditorDecorationType=I,I._Keys=new C.IdGenerator("TextEditorDecorationType");class D{constructor(c,u){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=c,this._documentVersionId=c.version,this._undoStopBefore=u.undoStopBefore,this._undoStopAfter=u.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(c,u){this._throwIfFinalized();let a=null;if(c instanceof T.Position)a=new T.Range(c,c);else if(c instanceof T.Range)a=c;else throw new Error("Unrecognized location");this._pushEdit(a,u,!1)}insert(c,u){this._throwIfFinalized(),this._pushEdit(new T.Range(c,c),u,!0)}delete(c){this._throwIfFinalized();let u=null;if(c instanceof T.Range)u=c;else throw new Error("Unrecognized location");this._pushEdit(u,null,!0)}_pushEdit(c,u,a){const g=this._document.validateRange(c);this._collectedEdits.push({range:g,text:u,forceMoveMarkers:a})}setEndOfLine(c){if(this._throwIfFinalized(),c!==T.EndOfLine.LF&&c!==T.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=c}}e.TextEditorEdit=D;class A{constructor(c,u,a,g){this._proxy=c,this._id=u,this._accept(a),this._logService=g;const w=this;this.value={get tabSize(){return w._tabSize},set tabSize(_){w._setTabSize(_)},get insertSpaces(){return w._insertSpaces},set insertSpaces(_){w._setInsertSpaces(_)},get cursorStyle(){return w._cursorStyle},set cursorStyle(_){w._setCursorStyle(_)},get lineNumbers(){return w._lineNumbers},set lineNumbers(_){w._setLineNumbers(_)}}}_accept(c){this._tabSize=c.tabSize,this._insertSpaces=c.insertSpaces,this._cursorStyle=c.cursorStyle,this._lineNumbers=y.TextEditorLineNumbersStyle.to(c.lineNumbers)}_validateTabSize(c){if(c==="auto")return"auto";if(typeof c=="number"){const u=Math.floor(c);return u>0?u:null}if(typeof c=="string"){const u=parseInt(c,10);return isNaN(u)?null:u>0?u:null}return null}_setTabSize(c){const u=this._validateTabSize(c);if(u!==null){if(typeof u=="number"){if(this._tabSize===u)return;this._tabSize=u}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:u}))}}_validateInsertSpaces(c){return c==="auto"?"auto":c==="false"?!1:Boolean(c)}_setInsertSpaces(c){const u=this._validateInsertSpaces(c);if(typeof u=="boolean"){if(this._insertSpaces===u)return;this._insertSpaces=u}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:u}))}_setCursorStyle(c){this._cursorStyle!==c&&(this._cursorStyle=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:c})))}_setLineNumbers(c){this._lineNumbers!==c&&(this._lineNumbers=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:y.TextEditorLineNumbersStyle.from(c)})))}assign(c){const u={};let a=!1;if(typeof c.tabSize!="undefined"){const g=this._validateTabSize(c.tabSize);g==="auto"?(a=!0,u.tabSize=g):typeof g=="number"&&this._tabSize!==g&&(this._tabSize=g,a=!0,u.tabSize=g)}if(typeof c.insertSpaces!="undefined"){const g=this._validateInsertSpaces(c.insertSpaces);g==="auto"?(a=!0,u.insertSpaces=g):this._insertSpaces!==g&&(this._insertSpaces=g,a=!0,u.insertSpaces=g)}typeof c.cursorStyle!="undefined"&&this._cursorStyle!==c.cursorStyle&&(this._cursorStyle=c.cursorStyle,a=!0,u.cursorStyle=c.cursorStyle),typeof c.lineNumbers!="undefined"&&this._lineNumbers!==c.lineNumbers&&(this._lineNumbers=c.lineNumbers,a=!0,u.lineNumbers=y.TextEditorLineNumbersStyle.from(c.lineNumbers)),a&&this._warnOnError(this._proxy.$trySetOptions(this._id,u))}_warnOnError(c){c.catch(u=>this._logService.warn(u))}}e.ExtHostTextEditorOptions=A;class i{constructor(c,u,a,g,w,_,b,d){this.id=c,this._proxy=u,this._logService=a,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=w,this._options=new A(this._proxy,this.id,_,a),this._visibleRanges=b,this._viewColumn=d;const h=this;this.value=Object.freeze({get document(){return g.getValue()},set document(v){throw(0,L.readonly)("document")},get selection(){return h._selections&&h._selections[0]},set selection(v){if(!(v instanceof T.Selection))throw(0,L.illegalArgument)("selection");h._selections=[v],h._trySetSelection()},get selections(){return h._selections},set selections(v){if(!Array.isArray(v)||v.some(t=>!(t instanceof T.Selection)))throw(0,L.illegalArgument)("selections");h._selections=v,h._trySetSelection()},get visibleRanges(){return h._visibleRanges},set visibleRanges(v){throw(0,L.readonly)("visibleRanges")},get options(){return h._options.value},set options(v){h._disposed||h._options.assign(v)},get viewColumn(){return h._viewColumn},set viewColumn(v){throw(0,L.readonly)("viewColumn")},edit(v,t={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new D(g.getValue(),t);return v(s),h._applyEdit(s)},insertSnippet(v,t,s={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=h._selections.map(n=>y.Range.from(n));else if(t instanceof T.Position){const{lineNumber:n,column:l}=y.Position.from(t);r=[{startLineNumber:n,startColumn:l,endLineNumber:n,endColumn:l}]}else if(t instanceof T.Range)r=[y.Range.from(t)];else{r=[];for(const n of t)if(n instanceof T.Range)r.push(y.Range.from(n));else{const{lineNumber:l,column:f}=y.Position.from(n);r.push({startLineNumber:l,startColumn:f,endLineNumber:l,endColumn:f})}}return u.$tryInsertSnippet(c,v.value,r,s)},setDecorations(v,t){const s=t.length===0;s&&!h._hasDecorationsForKey.has(v.key)||(s?h._hasDecorationsForKey.delete(v.key):h._hasDecorationsForKey.add(v.key),h._runOnProxy(()=>{if(y.isDecorationOptionsArr(t))return u.$trySetDecorations(c,v.key,y.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let n=0,l=t.length;n<l;n++){const f=t[n];r[4*n]=f.start.line+1,r[4*n+1]=f.start.character+1,r[4*n+2]=f.end.line+1,r[4*n+3]=f.end.character+1}return u.$trySetDecorationsFast(c,v.key,r)}}))},revealRange(v,t){h._runOnProxy(()=>u.$tryRevealRange(c,y.Range.from(v),t||T.TextEditorRevealType.Default))},show(v){u.$tryShowEditor(c,y.ViewColumn.from(v))},hide(){u.$tryHideEditor(c)}})}dispose(){(0,p.ok)(!this._disposed),this._disposed=!0}_acceptOptions(c){(0,p.ok)(!this._disposed),this._options._accept(c)}_acceptVisibleRanges(c){(0,p.ok)(!this._disposed),this._visibleRanges=c}_acceptViewColumn(c){(0,p.ok)(!this._disposed),this._viewColumn=c}_acceptSelections(c){(0,p.ok)(!this._disposed),this._selections=c}async _trySetSelection(){const c=this._selections.map(y.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,c)),this.value}_applyEdit(c){const u=c.finalize();if(u.edits.length===0&&!u.setEndOfLine)return Promise.resolve(!0);const a=u.edits.map(w=>w.range);a.sort((w,_)=>w.end.line===_.end.line?w.end.character===_.end.character?w.start.line===_.start.line?w.start.character-_.start.character:w.start.line-_.start.line:w.end.character-_.end.character:w.end.line-_.end.line);for(let w=0,_=a.length-1;w<_;w++){const b=a[w].end;if(a[w+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const g=u.edits.map(w=>({range:y.Range.from(w.range),text:w.text,forceMoveMarkers:w.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,u.documentVersionId,g,{setEndOfLine:typeof u.setEndOfLine=="number"?y.EndOfLine.from(u.setEndOfLine):void 0,undoStopBefore:u.undoStopBefore,undoStopAfter:u.undoStopAfter})}_runOnProxy(c){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,u=>(u instanceof Error&&u.name==="DISPOSED"||this._logService.warn(u),null))}}e.ExtHostTextEditor=i}),define(he[215],fe([0,1,164,24,2,3,6,17,7,14,18,16,21]),function(X,e,p,L,C,y,T,I,D,A,i,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function u(w,_){if((0,A.isString)(w))return{label:w};if(w&&typeof w=="object"&&typeof w.label=="string"){let b;return Array.isArray(w.highlights)&&(b=w.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),b=b.length?b:void 0),{label:w.label,highlights:b}}}class a{constructor(_,b,d){this._proxy=_,this.commands=b,this.logService=d,this.treeViews=new Map;function h(v){return v&&v.$treeViewId&&v.$treeItemHandle}b.registerArgumentProcessor({processArgument:v=>h(v)?this.convertArgument(v):Array.isArray(v)&&v.length>0?v.map(t=>h(t)?this.convertArgument(t):t):v})}registerTreeDataProvider(_,b,d){const h=this.createTreeView(_,{treeDataProvider:b},d);return{dispose:()=>h.dispose()}}createTreeView(_,b,d){if(!b||!b.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const h=b.dragAndDropController!==void 0,v=this._proxy.$registerTreeViewDataProvider(_,{showCollapseAll:!!b.showCollapseAll,canSelectMany:!!b.canSelectMany,canDragAndDrop:h}),t=this.createExtHostTreeView(_,b,d);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(s){t.message=s},get title(){return t.title},set title(s){t.title=s},get description(){return t.description},set description(s){t.description=s},reveal:(s,r)=>t.reveal(s,r),dispose:async()=>{await v,this.treeViews.delete(_),t.dispose()}}}$getChildren(_,b){const d=this.treeViews.get(_);return d?d.getChildren(b):Promise.reject(new Error((0,p.localize)(0,null,_)))}$onDrop(_,b,d){const h=this.treeViews.get(_);return h?h.onDrop(b,d):Promise.reject(new Error((0,p.localize)(1,null,_)))}async $hasResolve(_){const b=this.treeViews.get(_);if(!b)throw new Error((0,p.localize)(2,null,_));return b.hasResolve}$resolve(_,b,d){const h=this.treeViews.get(_);if(!h)throw new Error((0,p.localize)(3,null,_));return h.resolveTreeItem(b,d)}$setExpanded(_,b,d){const h=this.treeViews.get(_);if(!h)throw new Error((0,p.localize)(4,null,_));h.setExpanded(b,d)}$setSelection(_,b){const d=this.treeViews.get(_);if(!d)throw new Error((0,p.localize)(5,null,_));d.setSelection(b)}$setVisible(_,b){const d=this.treeViews.get(_);if(!d)throw new Error((0,p.localize)(6,null,_));d.setVisible(b)}createExtHostTreeView(_,b,d){const h=new g(_,b,this._proxy,this.commands.converter,this.logService,d);return this.treeViews.set(_,h),h}convertArgument(_){const b=this.treeViews.get(_.$treeViewId);return b?b.getExtensionElement(_.$treeItemHandle):null}}e.ExtHostTreeViews=a;class g extends T.Disposable{constructor(_,b,d,h,v,t){super();if(this.viewId=_,this.proxy=d,this.commands=h,this.logService=v,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new c.CancellationTokenSource,t.contributes&&t.contributes.views)for(const n in t.contributes.views)for(const l of t.contributes.views[n])l.id===_&&(this._title=l.name);this.dataProvider=b.treeDataProvider,this.dndController=b.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(n=>this._onDidChangeData.fire({message:!1,element:n}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(n=>this._onDidChangeData.fire({message:!1,element:n})));let s,r;this._register(y.Event.debounce(this._onDidChangeData.event,(n,l)=>(n||(n={message:!1,elements:[]}),l.element!==!1&&(s||(s=new Promise(f=>r=f),this.refreshPromise=this.refreshPromise.then(()=>s)),Array.isArray(l.element)?n.elements.push(...l.element):n.elements.push(l.element)),l.message&&(n.message=!0),n),200,!0)(({message:n,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const f=r;return s=null,this.refresh(l).then(()=>f())})),n&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(_=>this.getExtensionElement(_)).filter(_=>!(0,A.isUndefinedOrNull)(_))}getChildren(_){const b=_?this.getExtensionElement(_):void 0;if(_&&!b)return this.logService.error(`No tree item with id '${_}' found.`),Promise.resolve([]);const d=this.getChildrenNodes(_);return(d?Promise.resolve(d):this.fetchChildrenNodes(b)).then(h=>h.map(v=>v.item))}getExtensionElement(_){return this.elements.get(_)}reveal(_,b){b=b||{select:!0,focus:!1};const d=(0,A.isUndefinedOrNull)(b.select)?!0:b.select,h=(0,A.isUndefinedOrNull)(b.focus)?!1:b.focus,v=(0,A.isUndefinedOrNull)(b.expand)?!1:b.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):_?this.refreshPromise.then(()=>this.resolveUnknownParentChain(_)).then(t=>this.resolveTreeNode(_,t[t.length-1]).then(s=>this.proxy.$reveal(this.viewId,{item:s.item,parentChain:t.map(r=>r.item)},{select:d,focus:h,expand:v})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:d,focus:h,expand:v})}get message(){return this._message}set message(_){this._message=_,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(_){this._title=_,this.proxy.$setTitle(this.viewId,_,this._description)}get description(){return this._description}set description(_){this._description=_,this.proxy.$setTitle(this.viewId,this._title,_)}setExpanded(_,b){const d=this.getExtensionElement(_);d&&(b?this._onDidExpandElement.fire(Object.freeze({element:d})):this._onDidCollapseElement.fire(Object.freeze({element:d})))}setSelection(_){(0,i.equals)(this._selectedHandles,_)||(this._selectedHandles=_,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(_){_!==this._visible&&(this._visible=_,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(_,b){const d=_.map(v=>this.getExtensionElement(v)).filter(v=>!(0,A.isUndefinedOrNull)(v)),h=this.getExtensionElement(b);return d&&h?(0,I.asPromise)(()=>this.dndController?.onDrop(d,h)):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(_,b){if(!this.dataProvider.resolveTreeItem)return;const d=this.elements.get(_);if(d){const h=this.nodes.get(d);if(h){const v=await this.dataProvider.resolveTreeItem(h.extensionItem,d,b)??h.extensionItem;return h.item.tooltip=this.getTooltip(v.tooltip),h.item.command=this.getCommand(h.disposableStore,v.command),h.item}}}resolveUnknownParentChain(_){return this.resolveParent(_).then(b=>b?this.resolveUnknownParentChain(b).then(d=>this.resolveTreeNode(b,d[d.length-1]).then(h=>(d.push(h),d))):Promise.resolve([]))}resolveParent(_){const b=this.nodes.get(_);return b?Promise.resolve(b.parent?this.elements.get(b.parent.item.handle):void 0):(0,I.asPromise)(()=>this.dataProvider.getParent(_))}resolveTreeNode(_,b){const d=this.nodes.get(_);return d?Promise.resolve(d):(0,I.asPromise)(()=>this.dataProvider.getTreeItem(_)).then(h=>this.createHandle(_,h,b,!0)).then(h=>this.getChildren(b?b.item.handle:void 0).then(()=>{const v=this.getExtensionElement(h);if(v){const t=this.nodes.get(v);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${h}`)}))}getChildrenNodes(_){if(_){let b;if(typeof _=="string"){const d=this.getExtensionElement(_);b=d?this.nodes.get(d):void 0}else b=_;return b&&b.children||null}return this.roots}async fetchChildrenNodes(_){this.clearChildren(_);const b=new c.CancellationTokenSource(this._refreshCancellationSource.token);try{const d=_?this.nodes.get(_):void 0,h=await this.dataProvider.getChildren(_);if(b.token.isCancellationRequested)return[];const v=await Promise.all((0,i.coalesce)(h||[]).map(async t=>{const s=await this.dataProvider.getTreeItem(t);return s&&!b.token.isCancellationRequested?this.createAndRegisterTreeNode(t,s,d):null}));return b.token.isCancellationRequested?[]:(0,i.coalesce)(v)}finally{b.dispose()}}refresh(_){if(_.some(d=>!d))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new c.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const d=this.getHandlesToRefresh(_);if(d.length)return this.refreshHandles(d)}return Promise.resolve(void 0)}getHandlesToRefresh(_){const b=new Set,d=_.map(v=>this.nodes.get(v));for(const v of d)if(v&&!b.has(v.item.handle)){let t=v;for(;t&&t.parent&&d.findIndex(s=>t&&t.parent&&s&&s.item.handle===t.parent.item.handle)===-1;){const s=this.elements.get(t.parent.item.handle);t=s?this.nodes.get(s):void 0}t&&!t.parent&&b.add(v.item.handle)}const h=[];return b.forEach(v=>{const t=this.elements.get(v);if(t){const s=this.nodes.get(t);s&&(!s.parent||!b.has(s.parent.item.handle))&&h.push(v)}}),h}refreshHandles(_){const b={};return Promise.all(_.map(d=>this.refreshNode(d).then(h=>{h&&(b[d]=h.item)}))).then(()=>Object.keys(b).length?this.proxy.$refresh(this.viewId,b):void 0)}refreshNode(_){const b=this.getExtensionElement(_);if(b){const d=this.nodes.get(b);if(d)return this.clearChildren(b),(0,I.asPromise)(()=>this.dataProvider.getTreeItem(b)).then(h=>{if(h){const v=this.createTreeNode(b,h,d.parent);return this.updateNodeCache(b,v,d,d.parent),d.dispose(),v}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(_,b,d){const h=this.createTreeNode(_,b,d);if(b.id&&this.elements.has(h.item.handle))throw new Error((0,p.localize)(7,null,b.id));return this.addNodeToCache(_,h),this.addNodeToParentCache(h,d),h}getTooltip(_){return D.MarkdownString.isMarkdownString(_)?P.MarkdownString.from(_):_}getCommand(_,b){return b?this.commands.toInternal(b,_):void 0}createTreeNode(_,b,d){const h=new T.DisposableStore,v=this.createHandle(_,b,d),t=this.getLightIconPath(b);return{item:{handle:v,parentHandle:d?d.item.handle:void 0,label:u(b.label,this.extension),description:b.description,resourceUri:b.resourceUri,tooltip:this.getTooltip(b.tooltip),command:this.getCommand(h,b.command),contextValue:b.contextValue,icon:t,iconDark:this.getDarkIconPath(b)||t,themeIcon:this.getThemeIcon(b),collapsibleState:(0,A.isUndefinedOrNull)(b.collapsibleState)?D.TreeItemCollapsibleState.None:b.collapsibleState,accessibilityInformation:b.accessibilityInformation},extensionItem:b,parent:d,children:void 0,disposableStore:h,dispose(){h.dispose()}}}getThemeIcon(_){return _.iconPath instanceof D.ThemeIcon?_.iconPath:void 0}createHandle(_,{id:b,label:d,resourceUri:h},v,t){if(b)return`${g.ID_HANDLE_PREFIX}/${b}`;const s=u(d,this.extension),r=v?v.item.handle:g.LABEL_HANDLE_PREFIX;let n=s?s.label:h?(0,L.basename)(h):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const l=this.nodes.has(_)?this.nodes.get(_).item.handle:void 0,f=this.getChildrenNodes(v)||[];let m,E=0;do{if(m=`${r}/${E}:${n}`,t||!this.elements.has(m)||l===m)break;E++}while(E<=f.length);return m}getLightIconPath(_){if(_.iconPath&&!(_.iconPath instanceof D.ThemeIcon))return typeof _.iconPath=="string"||C.URI.isUri(_.iconPath)?this.getIconPath(_.iconPath):this.getIconPath(_.iconPath.light)}getDarkIconPath(_){if(_.iconPath&&!(_.iconPath instanceof D.ThemeIcon)&&_.iconPath.dark)return this.getIconPath(_.iconPath.dark)}getIconPath(_){return C.URI.isUri(_)?_:C.URI.file(_)}addNodeToCache(_,b){this.elements.set(b.item.handle,_),this.nodes.set(_,b)}updateNodeCache(_,b,d,h){this.elements.delete(b.item.handle),this.nodes.delete(_),b.item.handle!==d.item.handle&&this.elements.delete(d.item.handle),this.addNodeToCache(_,b);const v=this.getChildrenNodes(h)||[],t=v.filter(s=>s.item.handle===d.item.handle)[0];t&&v.splice(v.indexOf(t),1,b)}addNodeToParentCache(_,b){b?(b.children||(b.children=[]),b.children.push(_)):(this.roots||(this.roots=[]),this.roots.push(_))}clearChildren(_){if(_){const b=this.nodes.get(_);if(b){if(b.children)for(const d of b.children){const h=this.elements.get(d.item.handle);h&&this.clear(h)}b.children=void 0}}else this.clearAll()}clear(_){const b=this.nodes.get(_);if(b){if(b.children)for(const d of b.children){const h=this.elements.get(d.item.handle);h&&this.clear(h)}this.nodes.delete(_),this.elements.delete(b.item.handle),b.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(_=>_.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}g.LABEL_HANDLE_PREFIX="0",g.ID_HANDLE_PREFIX="1"}),define(he[216],fe([0,1,17,3,6,14,85,16,123]),function(X,e,p,L,C,y,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=void 0;var A;(function(c){c[c.Disconnected=0]="Disconnected",c[c.IsChild=1]="IsChild",c[c.IsParent=2]="IsParent",c[c.IsSame=3]="IsSame"})(A=e.TestPosition||(e.TestPosition={}));class i{constructor(){this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(u){if(this.map.has(u.actual.id))throw new Error(`Attempted to insert a duplicate test item ID ${u.actual.id}`);this.map.set(u.actual.id,u),u.parent||this._roots.add(u)}has(u){return this.map.has(u)}delete(u){const a=this.map.get(u);return a?(this.map.delete(u),this._roots.delete(a),!0):!1}get(u){return this.map.get(u)}comparePositions(u,a){const g=typeof u=="string"?this.map.get(u):u,w=typeof a=="string"?this.map.get(a):a;if(!g||!w)return 0;if(g===w)return 3;for(let _=this.map.get(w.parent);_;_=this.map.get(_.parent))if(_===g)return 1;for(let _=this.map.get(g.parent);_;_=this.map.get(_.parent))if(_===w)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=i;class P extends C.Disposable{constructor(u){super();this.controllerId=u,this.debounceSendDiff=this._register(new p.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.root=new T.TestItemImpl(`${this.controllerId}Root`,this.controllerId,void 0),this.tree=new i,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.upsertItem(this.root,null)}set resolveHandler(u){this._resolveHandler=u;for(const a of this.tree)this.updateExpandability(a)}collectDiff(){const u=this.diff;return this.diff=[],u}pushDiff(u){const a=this.diff[this.diff.length-1];if(a&&u[0]===1){if(a[0]===1&&a[1].extId===u[1].extId){(0,D.applyTestItemUpdate)(a[1],u[1]);return}if(a[0]===0&&a[1].item.extId===u[1].extId){(0,D.applyTestItemUpdate)(a[1],u[1]);return}}this.diff.push(u),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(u,a){const g=this.tree.get(u);if(!!g){if((g.expandLevels===void 0||a>g.expandLevels)&&(g.expandLevels=a),g.expand===1){const w=this.resolveChildren(g);return w.isOpen()?this.expandChildren(g,a-1):w.wait().then(()=>this.expandChildren(g,a-1))}else if(g.expand===3)return g.resolveBarrier?.isOpen()===!1?g.resolveBarrier.wait().then(()=>this.expandChildren(g,a-1)):this.expandChildren(g,a-1)}}dispose(){for(const u of this.tree)(0,T.getPrivateApiFor)(u.actual).listener=void 0;this.diff=[],super.dispose()}onTestItemEvent(u,a){const g=u?.actual.id;switch(a.op){case 2:this.pushDiff([4,g]);break;case 1:this.removeItem(a.id);break;case 0:this.upsertItem(a.item,u);break;case 4:for(const b of a.ops)this.onTestItemEvent(u,b);break;case 3:const{key:w,value:_}=a;switch(w){case"canResolveChildren":this.updateExpandability(u);break;case"range":this.pushDiff([1,{extId:g,item:{range:I.Range.from(_)}}]);break;case"error":this.pushDiff([1,{extId:g,item:{error:I.MarkdownString.fromStrict(_)||null}}]);break;default:this.pushDiff([1,{extId:g,item:{[w]:_??null}}]);break}break;default:(0,y.assertNever)(a)}}upsertItem(u,a){if(!(u instanceof T.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${u.id} did not`);let g=this.tree.get(u.id);if(g&&g.parent!==a?.actual.id&&((g.actual.parent??this.root).children.remove(u.id),g=void 0),!g){const d=a?a.actual.id:null,h=a?a.expandLevels:1;g={actual:u,parent:d,expandLevels:h?h-1:void 0,expand:0},this.tree.add(g),this.pushDiff([0,{parent:d,controllerId:this.controllerId,expand:g.expand,item:I.TestItem.from(u)}]),this.connectItemAndChildren(u,g,a);return}if(g.actual===u){this.connectItem(u,g,a);return}const w=g.actual.children.all,_=g.actual,b=(0,T.diffTestItems)(_,u);(0,T.getPrivateApiFor)(_).listener=void 0,g.actual=u,g.expand=0;for(const[d,h]of b)this.onTestItemEvent(g,{op:3,key:d,value:h});this.connectItemAndChildren(u,g,a);for(const d of w)!u.children.get(d.id)&&this.tree.get(d.id)?.parent===u.id&&this.removeItem(d.id)}connectItem(u,a,g){const w=(0,T.getPrivateApiFor)(u);w.parent=g&&g.actual!==this.root?g.actual:void 0,w.listener=_=>this.onTestItemEvent(a,_),this.updateExpandability(a)}connectItemAndChildren(u,a,g){this.connectItem(u,a,g);for(const w of u.children.all)this.upsertItem(w,a)}updateExpandability(u){let a;this._resolveHandler?u.resolveBarrier?a=u.resolveBarrier.isOpen()?3:2:a=u.actual.canResolveChildren?1:0:a=0,a!==u.expand&&(u.expand=a,this.pushDiff([1,{extId:u.actual.id,expand:a}]),a===1&&u.expandLevels!==void 0&&this.resolveChildren(u))}expandChildren(u,a){if(a<0)return;const g=u.actual.children.all.map(w=>this.expand(w.id,a)).filter(p.isThenable);if(g.length)return Promise.all(g).then(()=>{})}resolveChildren(u){if(u.resolveBarrier)return u.resolveBarrier;if(!this._resolveHandler){const w=new p.Barrier;return w.open(),w}u.expand=2,this.pushExpandStateUpdate(u);const a=u.resolveBarrier=new p.Barrier;let g;try{g=this._resolveHandler(u.actual)}catch(w){u.actual.error=w.stack||w.message}return(0,p.isThenable)(g)?g.catch(w=>u.actual.error=w.stack||w.message).then(()=>{a.open(),this.updateExpandability(u)}):(a.open(),this.updateExpandability(u)),u.resolveBarrier}pushExpandStateUpdate(u){this.pushDiff([1,{extId:u.actual.id,expand:u.expand}])}removeItem(u){const a=this.tree.get(u);if(!a)throw new Error("attempting to remove non-existent child");this.pushDiff([2,u]);const g=[a];for(;g.length;){const w=g.pop();if(!!w){(0,T.getPrivateApiFor)(w.actual).listener=void 0,this.tree.delete(w.actual.id);for(const _ of w.actual.children.all)g.push(this.tree.get(_.id))}}}flushDiff(){const u=this.collectDiff();u.length&&this.diffOpEmitter.fire(u)}}e.SingleUseTestCollection=P}),define(he[217],fe([0,1,4,178]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,p.refineServiceDecorator)(L.IEnvironmentService)}),define(he[218],fe([0,1,26,3,9]),function(X,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class y{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=y;class T{constructor(i){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(p.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(p.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let P of i.activationEvents)P==="onUri"&&(P=`onUri:${p.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(P)||this._activationMap.set(P,[]),this._activationMap.get(P).push(i)}}keepOnly(i){const P=new Set;i.forEach(c=>P.add(p.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>P.has(p.ExtensionIdentifier.toKey(c.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,P){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const c=T._findLoopingExtensions(this._extensionDescriptions);if(P=P.concat(c.map(u=>u.identifier)),P.length>0){const u=new Set;P.forEach(a=>u.add(p.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>!u.has(p.ExtensionIdentifier.toKey(a.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new y(c)}static _findLoopingExtensions(i){const P=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(w){this._nodesSet.has(w)||(this._nodesSet.add(w),this._nodesArr.push(w))}addArc(w,_){this.addNode(w),this.addNode(_),this._arcs.has(w)?this._arcs.get(w).push(_):this._arcs.set(w,[_])}getArcs(w){return this._arcs.has(w)?this._arcs.get(w):[]}hasOnlyGoodArcs(w,_){const b=P.getArcs(w);for(let d=0;d<b.length;d++)if(!_.has(b[d]))return!1;return!0}getNodes(){return this._nodesArr}};let c=new Map;for(let w of i){const _=p.ExtensionIdentifier.toKey(w.identifier);if(c.set(_,w),w.extensionDependencies)for(let b of w.extensionDependencies){const d=p.ExtensionIdentifier.toKey(b);P.addArc(_,d)}}let u=new Set;P.getNodes().filter(w=>P.getArcs(w).length===0).forEach(w=>u.add(w));let a=P.getNodes().filter(w=>!u.has(w)),g;do{g=!1;for(let w=0;w<a.length;w++){const _=a[w];P.hasOnlyGoodArcs(_,u)&&(a.splice(w,1),w--,u.add(_),g=!0)}}while(g);return a.map(w=>c.get(w))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(p.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const P=this._activationMap.get(i);return P?P.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const P=this._extensionsMap.get(p.ExtensionIdentifier.toKey(i));return P||void 0}}e.ExtensionDescriptionRegistry=T;var I;(function(A){A[A.Builtin=0]="Builtin",A[A.User=1]="User",A[A.Dev=2]="Dev"})(I||(I={}));function D(A,i){const P=A.isBuiltin?0:A.isUnderDevelopment?2:1,c=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(P!==c)return P-c;const u=C.posix.basename(A.extensionLocation.path),a=C.posix.basename(i.extensionLocation.path);return u<a?-1:u>a?1:0}}),define(he[219],fe([0,1,22]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var L;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(L=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var C;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(C=e.MessageType||(e.MessageType={}));function y(I){const D=p.VSBuffer.alloc(1);switch(I){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=y;function T(I,D){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=T}),define(he[34],fe([0,1,3,2,4,26,180]),function(X,e,p,L,C,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new y.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,C.createDecorator)("extensionService");class I{constructor(b){this.dependency=b}}e.MissingExtensionDependency=I;var D;(function(_){_[_.LocalProcess=0]="LocalProcess",_[_.LocalWebWorker=1]="LocalWebWorker",_[_.Remote=2]="Remote"})(D=e.ExtensionHostKind||(e.ExtensionHostKind={}));class A{constructor(b,d,h,v){this.codeLoadingTime=b,this.activateCallTime=d,this.activateResolvedTime=h,this.activationReason=v}}e.ActivationTimes=A;class i{constructor(b,d){this.description=b,this.value=d}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var P;(function(_){_[_.Normal=0]="Normal",_[_.Immediate=1]="Immediate"})(P=e.ActivationKind||(e.ActivationKind={}));function c(_){_.enableProposedApi||u(_)}e.checkProposedApiEnabled=c;function u(_){throw new Error(`[${_.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${_.identifier.value}`)}e.throwProposedApiError=u;function a(_){return{type:_.isBuiltin?0:1,isBuiltin:_.isBuiltin||_.isUserBuiltin,identifier:{id:(0,T.getGalleryExtensionId)(_.publisher,_.name),uuid:_.uuid},manifest:_,location:_.extensionLocation}}e.toExtension=a;function g(_,b){return{identifier:new y.ExtensionIdentifier(_.identifier.id),isBuiltin:_.type===0,isUserBuiltin:_.type===1&&_.isBuiltin,isUnderDevelopment:!!b,extensionLocation:_.location,..._.manifest,uuid:_.identifier.uuid}}e.toExtensionDescription=g;class w{constructor(){this.onDidRegisterExtensions=p.Event.None,this.onDidChangeExtensionsStatus=p.Event.None,this.onDidChangeExtensions=p.Event.None,this.onWillActivateByEvent=p.Event.None,this.onDidChangeResponsiveChange=p.Event.None}activateByEvent(b){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(b){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(b){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(b){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(b,d){return Promise.resolve()}_onWillActivateExtension(b){}_onDidActivateExtension(b,d,h,v,t){}_onDidActivateExtensionError(b,d){}_onExtensionRuntimeError(b,d){}_onExtensionHostExit(b){}}e.NullExtensionService=w}),define(he[220],fe([0,1,26,34,12]),function(X,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const y=Promise.resolve(void 0);class T{constructor(a,g,w,_){this.startup=a,this.codeLoadingTime=g,this.activateCallTime=w,this.activateResolvedTime=_}}e.ExtensionActivationTimes=T,T.NONE=new T(!1,-1,-1,-1);class I{constructor(a){this._startup=a,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(a,g){return a===-1||g===-1?-1:g-a}build(){return new T(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=I;class D{constructor(a,g,w,_,b,d){this.activationFailed=a,this.activationFailedError=g,this.activationTimes=w,this.module=_,this.exports=b,this.subscriptions=d}}e.ActivatedExtension=D;class A extends D{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=A;class i extends D{constructor(){super(!1,null,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class P extends D{constructor(a){super(!0,a,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=P;let c=class{constructor(a,g,w,_,b){this._logService=b,this._registry=a,this._resolvedExtensionsSet=new Set,g.forEach(d=>this._resolvedExtensionsSet.add(p.ExtensionIdentifier.toKey(d))),this._hostExtensionsMap=new Map,w.forEach(d=>this._hostExtensionsMap.set(p.ExtensionIdentifier.toKey(d),d)),this._host=_,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(a){const g=p.ExtensionIdentifier.toKey(a);return this._activatedExtensions.has(g)}getActivatedExtension(a){const g=p.ExtensionIdentifier.toKey(a),w=this._activatedExtensions.get(g);if(!w)throw new Error("Extension `"+a.value+"` is not known or not activated");return w}activateByEvent(a,g){if(this._alreadyActivatedEvents[a])return y;const w=this._registry.getExtensionDescriptionsForActivationEvent(a);return this._activateExtensions(w.map(_=>({id:_.identifier,reason:{startup:g,extensionId:_.identifier,activationEvent:a}}))).then(()=>{this._alreadyActivatedEvents[a]=!0})}activateById(a,g){const w=this._registry.getExtensionDescription(a);if(!w)throw new Error("Extension `"+a+"` is not known");return this._activateExtensions([{id:w.identifier,reason:g}])}_handleActivateRequest(a,g,w){if(this._hostExtensionsMap.has(p.ExtensionIdentifier.toKey(a.id))){g[p.ExtensionIdentifier.toKey(a.id)]=a;return}const _=this._registry.getExtensionDescription(a.id);if(!_){const h=new Error(`Cannot activate unknown extension '${a.id.value}'`);this._host.onExtensionActivationError(a.id,h,new L.MissingExtensionDependency(a.id.value)),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(a.id),new P(h));return}const b=typeof _.extensionDependencies=="undefined"?[]:_.extensionDependencies;let d=!0;for(let h=0,v=b.length;h<v;h++){const t=b[h];if(this._resolvedExtensionsSet.has(p.ExtensionIdentifier.toKey(t)))continue;const s=this._activatedExtensions.get(p.ExtensionIdentifier.toKey(t));if(s&&!s.activationFailed)continue;if(s&&s.activationFailed){const f=_.displayName||_.identifier.value,m=this._registry.getExtensionDescription(t),E=m&&m.displayName||t,S=new Error(`Cannot activate the '${f}' extension because its dependency '${E}' failed to activate`);S.detail=s.activationFailedError,this._host.onExtensionActivationError(_.identifier,S,null),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(_.identifier),new P(S));return}if(this._hostExtensionsMap.has(p.ExtensionIdentifier.toKey(t))){d=!1,g[p.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(p.ExtensionIdentifier.toKey(t)),reason:a.reason};continue}const r=this._registry.getExtensionDescription(t);if(r){d=!1,g[p.ExtensionIdentifier.toKey(t)]={id:r.identifier,reason:a.reason};continue}const n=_.displayName||_.identifier.value,l=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(_.identifier,l,new L.MissingExtensionDependency(t)),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(_.identifier),new P(l));return}d?g[p.ExtensionIdentifier.toKey(_.identifier)]=a:w.push(a)}_activateExtensions(a){if(a.length===0||(a=a.filter(b=>!this._activatedExtensions.has(p.ExtensionIdentifier.toKey(b.id))),a.length===0))return Promise.resolve(void 0);const g=Object.create(null),w=[];for(let b=0,d=a.length;b<d;b++)this._handleActivateRequest(a[b],g,w);for(let b=0,d=w.length;b<d;b++){const h=p.ExtensionIdentifier.toKey(w[b].id);g[h]&&delete g[h]}const _=Object.keys(g).map(b=>g[b]);return w.length===0?Promise.all(_.map(b=>this._activateExtension(b.id,b.reason))).then(b=>{}):this._activateExtensions(_).then(b=>this._activateExtensions(w))}_activateExtension(a,g){const w=p.ExtensionIdentifier.toKey(a);if(this._activatedExtensions.has(w))return Promise.resolve(void 0);const _=this._activatingExtensions.get(w);if(_)return _;const b=this._host.actualActivateExtension(a,g).then(void 0,d=>{const h=new Error;return d&&d.name&&(h.name=d.name),d&&d.message?h.message=`Activating extension '${a.value}' failed: ${d.message}.`:h.message=`Activating extension '${a.value}' failed: ${d}.`,d&&d.stack&&(h.stack=d.stack),this._host.onExtensionActivationError(a,h,null),this._logService.error(`Activating extension ${a.value} failed due to an error:`),this._logService.error(d),new P(d)}).then(d=>{this._activatedExtensions.set(w,d),this._activatingExtensions.delete(w)});return this._activatingExtensions.set(w,b),b}};c=je([We(4,C.ILogService)],c),e.ExtensionsActivator=c}),define(he[221],fe([0,1,12,34,27,10,114]),function(X,e,p,L,C,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let I=class extends p.LogService{constructor(A){if(A.logFile.scheme!==y.Schemas.file)throw new Error("Only file-logging supported");super(new T.SpdLogLogger(L.ExtensionHostLogFileName,A.logFile.fsPath,!0,A.logLevel))}$setLevel(A){this.setLevel(A)}};I=je([We(0,C.IExtHostInitDataService)],I),e.ExtHostLogService=I}),define(he[222],fe([0,1,15]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,T)=>{this._actualOk=y,this._actualErr=T,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):(0,p.onUnexpectedError)(y))}then(y,T){return this._ensureActual().then(y,T)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=L}),define(he[127],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class p{constructor(D,A){this._proxyIdentifierBrand=void 0,this.isMain=D,this.sid=A,this.nid=++p.count}}e.ProxyIdentifier=p,p.count=0;const L=[];function C(I){const D=new p(!0,I);return L[D.nid]=D,D}e.createMainContextProxyIdentifier=C;function y(I){const D=new p(!1,I);return L[D.nid]=D,D}e.createExtHostContextProxyIdentifier=y;function T(I){return L[I].sid}e.getStringIdentifierForProxy=T}),define(he[5],fe([0,1,57,2,127]),function(X,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var y;(function(d){d[d.Desktop=1]="Desktop",d[d.Web=2]="Web"})(y=e.UIKind||(e.UIKind={}));var T;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var A;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(A=e.CellOutputKind||(e.CellOutputKind={}));var i;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var P;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(P=e.CandidatePortSource||(e.CandidatePortSource={}));var c;(function(d){d.name="$ident";function h(t,s){return Object.defineProperty(t,d.name,{value:s,enumerable:!0}),t}d.mixin=h;function v(t){return t[d.name]}d.of=v})(c=e.ObjectIdentifier||(e.ObjectIdentifier={}));class u{static mixin(h){return h._id=u._n++,h}}e.IdObject=u,u._n=0;var a;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.command="m",d.kindModifier="n"})(a=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var g;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(g=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(d){d[d.File=1]="File",d[d.Text=2]="Text",d[d.Cell=3]="Cell"})(w=e.WorkspaceEditType||(e.WorkspaceEditType={}));function _(d){if(d&&d.edits)for(const h of d.edits)typeof h.resource=="object"?h.resource=L.URI.revive(h.resource):(h.newUri=L.URI.revive(h.newUri),h.oldUri=L.URI.revive(h.oldUri)),h.metadata&&h.metadata.iconPath&&(h.metadata=(0,p.revive)(h.metadata));return d}e.reviveWorkspaceEditDto=_;var b;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,C.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,C.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,C.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,C.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,C.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,C.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,C.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,C.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,C.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,C.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,C.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,C.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,C.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,C.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,C.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,C.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,C.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,C.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,C.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,C.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,C.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,C.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,C.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,C.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,C.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,C.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,C.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,C.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,C.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,C.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,C.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,C.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,C.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,C.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,C.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,C.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,C.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,C.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,C.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,C.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,C.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,C.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,C.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,C.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,C.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,C.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,C.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,C.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,C.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,C.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,C.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,C.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,C.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,C.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,C.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,C.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,C.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,C.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,C.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,C.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,C.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,C.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,C.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,C.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,C.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(he[88],fe([0,1,5,3,4]),function(X,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class y{constructor(I){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=I.getProxy(p.MainContext.MainThreadSecretState)}async $onDidChangePassword(I){this._onDidChangePassword.fire(I)}get(I,D){return this._proxy.$getPassword(I,D)}store(I,D,A){return this._proxy.$setPassword(I,D,A)}delete(I,D){return this._proxy.$deletePassword(I,D)}}e.ExtHostSecretState=y,e.IExtHostSecretState=(0,C.createDecorator)("IExtHostSecretState")}),define(he[61],fe([0,1,4,12,5,13]),function(X,e,p,L,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,p.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(D,A){this._extHostLogService=A,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(C.MainContext.MainThreadTelemetry)}report(D,A,i){const P=this.getUsageKey(D,A);this._reportedUsages.has(P)||(this._reportedUsages.add(P),A.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:A.identifier.value,apiId:D}))}getUsageKey(D,A){return`${D}-${A.identifier.value}`}};T=je([We(0,y.IExtHostRpcService),We(1,L.ILogService)],T),e.ExtHostApiDeprecationService=T,e.NullApiDeprecationService=Object.freeze(new class{report(I,D,A){}})}),define(he[223],fe([0,1,3,5,7,26]),function(X,e,p,L,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new p.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}async getSession(D,A,i,P={}){const c=y.ExtensionIdentifier.toKey(D.identifier),u=this._inFlightRequests.get(c)||[],a=[...i].sort().join(" ");let g=u.find(w=>w.scopes===a);if(g)return g.result;{const w=this._getSession(D,c,A,i,P);g={scopes:a,result:w},u.push(g),this._inFlightRequests.set(c,u);try{await w}finally{const _=u.findIndex(b=>b.scopes===a);_>-1&&(u.splice(_),this._inFlightRequests.set(c,u))}return w}}async _getSession(D,A,i,P,c={}){await this._proxy.$ensureProvider(i);const u=D.displayName||D.name;return this._proxy.$getSession(i,P,A,u,c)}async removeSession(D,A){const i=this._authenticationProviders.get(D);return i?i.provider.removeSession(A):this._proxy.$removeSession(D,A)}registerAuthenticationProvider(D,A,i,P){if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:A,provider:i,options:P??{supportsMultipleAccounts:!1}}),this._providers.find(u=>u.id===D)||this._providers.push({id:D,label:A});const c=i.onDidChangeSessions(u=>{this._proxy.$sendDidChangeSessions(D,{added:u.added??[],changed:u.changed??[],removed:u.removed??[]})});return this._proxy.$registerAuthenticationProvider(D,A,P?.supportsMultipleAccounts??!1),new C.Disposable(()=>{c.dispose(),this._authenticationProviders.delete(D);const u=this._providers.findIndex(a=>a.id===D);u>-1&&this._providers.splice(u),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,A){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.createSession(A));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,A){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,A){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,A){return this._onDidChangeSessions.fire({provider:{id:D,label:A}}),Promise.resolve()}}e.ExtHostAuthentication=T}),define(he[224],fe([0,1,5,13,16]),function(X,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let y=class{constructor(I,D){this._extHostDocumentsAndEditors=D,this._proxy=I.getProxy(p.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(I){const D=C.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};y=je([We(0,L.IExtHostRpcService)],y),e.ExtHostBulkEdits=y}),define(he[225],fe([0,1,5]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(y){const T=y.getProxy(p.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(I){return T.$writeText(I)}})}}e.ExtHostClipboard=L}),define(he[50],fe([0,1,14,7,16,25,5,18,12,57,40,46,2,6,4,13]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let w=class{constructor(t,s){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(T.MainContext.MainThreadCommands),this._logService=s,this.converter=new _(this,r=>{const n=this._apiCommands.get(r);return n?.result===d.Void?n:void 0},s),this._argumentProcessors=[{processArgument(r){return(0,A.revive)(r)}},{processArgument(r){return(0,y.cloneAndChange)(r,function(n){if(i.Range.isIRange(n))return C.Range.to(n);if(P.Position.isIPosition(n))return C.Position.to(n);if(i.Range.isIRange(n.range)&&c.URI.isUri(n.uri))return C.location.to(n);if(!Array.isArray(n))return n})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const s=this.registerCommand(!1,t.id,async(...r)=>{const n=t.args.map((f,m)=>{if(!f.validate(r[m]))throw new Error(`Invalid argument '${f.name}' when running '${t.id}', received: ${r[m]}`);return f.convert(r[m])}),l=await this.executeCommand(t.internalId,...n);return t.result.convert(l,r,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new L.Disposable(()=>{s.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,s,r,n,l){if(this._logService.trace("ExtHostCommands#registerCommand",s),!s.trim().length)throw new Error("invalid id");if(this._commands.has(s))throw new Error(`command '${s}' already exists`);return this._commands.set(s,{callback:r,thisArg:n,description:l}),t&&this._proxy.$registerCommand(s),new L.Disposable(()=>{this._commands.delete(s)&&t&&this._proxy.$unregisterCommand(s)})}executeCommand(t,...s){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,s,!0)}async _doExecuteCommand(t,s,r){if(this._commands.has(t))return this._executeContributedCommand(t,s);{const n=(0,y.cloneAndChange)(s,function(l){if(l instanceof L.Position)return C.Position.from(l);if(l instanceof L.Range)return C.Range.from(l);if(l instanceof L.Location)return C.location.from(l);if(L.NotebookRange.isNotebookRange(l))return C.NotebookRange.from(l);if(!Array.isArray(l))return l});try{const l=await this._proxy.$executeCommand(t,n,r);return(0,A.revive)(l)}catch(l){if(l instanceof Error&&l.message==="$executeCommand:retry")return this._doExecuteCommand(t,s,!1);throw l}}}async _executeContributedCommand(t,s){const r=this._commands.get(t);if(!r)throw new Error("Unknown command");let{callback:n,thisArg:l,description:f}=r;if(f)for(let m=0;m<f.args.length;m++)try{(0,p.validateConstraint)(s[m],f.args[m].constraint)}catch(E){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${f.args[m].name}' - ${f.args[m].description}`)}try{return await n.apply(l,s)}catch(m){if(t===this.converter.delegatingCommandId){const E=this.converter.getActualCommand(...s);E&&(t=E.command)}throw this._logService.error(m,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...s){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(s=s.map(r=>this._argumentProcessors.reduce((n,l)=>l.processArgument(n),r)),this._executeContributedCommand(t,s)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(s=>(t&&(s=s.filter(r=>r[0]!=="_")),s))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[s,r]of this._commands){let{description:n}=r;n&&(t[s]=n)}return Promise.resolve(t)}};w=je([We(0,g.IExtHostRpcService),We(1,D.ILogService)],w),e.ExtHostCommands=w,e.IExtHostCommands=(0,a.createDecorator)("IExtHostCommands");class _{constructor(t,s,r){this._commands=t,this._lookupApiCommand=s,this._logService=r,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,s){if(!t)return;const r={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return r;const n=this._lookupApiCommand(t.command);if(n)r.id=n.internalId,r.arguments=n.args.map((l,f)=>l.convert(t.arguments&&t.arguments[f]));else if((0,I.isNonEmptyArray)(t.arguments)){const l=++this._cachIdPool;this._cache.set(l,t),s.add((0,u.toDisposable)(()=>{this._cache.delete(l),this._logService.trace("CommandsConverter#DISPOSE",l)})),r.$ident=l,r.id=this.delegatingCommandId,r.arguments=[l],this._logService.trace("CommandsConverter#CREATE",t.command,l)}return r}fromInternal(t){const s=T.ObjectIdentifier.of(t);return typeof s=="number"?this._cache.get(s):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const s=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],s?s.command:"MISSING"),s?this._commands.executeCommand(s.command,...s.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=_;class b{constructor(t,s,r,n){this.name=t,this.description=s,this.validate=r,this.convert=n}optional(){return new b(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,s){return new b(t??this.name,s??this.description,this.validate,this.convert)}}e.ApiCommandArgument=b,b.Uri=new b("uri","Uri of a text document",v=>c.URI.isUri(v),v=>v),b.Position=new b("position","A position in a text document",v=>L.Position.isPosition(v),C.Position.from),b.Range=new b("range","A range in a text document",v=>L.Range.isRange(v),C.Range.from),b.Selection=new b("selection","A selection in a text document",v=>L.Selection.isSelection(v),C.Selection.from),b.Number=new b("number","",v=>typeof v=="number",v=>v),b.String=new b("string","",v=>typeof v=="string",v=>v),b.CallHierarchyItem=new b("item","A call hierarchy item",v=>v instanceof L.CallHierarchyItem,C.CallHierarchyItem.to);class d{constructor(t,s){this.description=t,this.convert=s}}e.ApiCommandResult=d,d.Void=new d("no result",v=>v);class h{constructor(t,s,r,n,l){this.id=t,this.internalId=s,this.description=r,this.args=n,this.result=l}}e.ApiCommand=h}),define(he[226],fe([0,1,16,7,79,50,18,109]),function(X,e,p,L,C,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",i(p.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,u)=>{if((0,T.isFalsyOrEmpty)(c))return;class a extends L.SymbolInformation{static to(w){const _=new a(w.name,p.SymbolKind.to(w.kind),w.containerName||"",new L.Location(u[0],p.Range.to(w.range)));return _.detail=w.detail,_.range=_.location.range,_.selectionRange=p.Range.to(w.selectionRange),_.children=w.children?w.children.map(a.to):[],_}}return c.map(a.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(p.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(p.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",c=>typeof c=="string",c=>c),new y.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(p.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",i(p.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",i(p.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",c=>Array.isArray(c)&&c.every(u=>L.Position.isPosition(u)),c=>c.map(p.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",c=>c.map(u=>{let a;for(const g of u.reverse())a=new L.SelectionRange(p.Range.to(g),a);return a}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",c=>{const u=[];if(Array.isArray(c))for(let a of c)u.push(...a[1].map(p.WorkspaceSymbol.to));return u})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(p.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(p.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(p.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",c=>{if(!!c){if(c.rejectReason)throw new Error(c.rejectReason);return p.WorkspaceEdit.to(c)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(p.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new L.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const u=(0,I.decodeSemanticTokensDto)(c);if(u.type==="full")return new L.SemanticTokens(u.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new L.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const u=(0,I.decodeSemanticTokensDto)(c);if(u.type==="full")return new L.SemanticTokens(u.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(c,u,a)=>{if(!c)return new L.CompletionList([]);const g=c.suggestions.map(w=>p.CompletionItem.to(w,a));return new L.CompletionList(g,c.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",c=>{if(c)return p.SignatureHelp.to(c)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(c,u,a)=>i(g=>new L.CodeLens(p.Range.to(g.range),g.command&&a.fromInternal(g.command)))(c))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>L.Range.isRange(c),c=>L.Selection.isSelection(c)?p.Selection.from(c):p.Range.from(c)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(c,u,a)=>i(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(g.command)}else{const w=new L.CodeAction(g.title,g.kind?new L.CodeActionKind(g.kind):void 0);return g.edit&&(w.edit=p.WorkspaceEdit.to(g.edit)),g.command&&(w.command=a.fromInternal(g.command)),w.isPreferred=g.isPreferred,w}})(c))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(u=>new L.ColorInformation(p.Range.to(u.range),p.Color.to(u.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",c=>c instanceof L.Color,p.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:p.Range.from(c.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(p.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",c=>c.map(p.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",i(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(u=>p.NotebookExclusiveDocumentPattern.to(u))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",c=>c.map(p.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[p.ViewColumn.from(c.viewColumn),p.TextEditorOpenOptions.from(c)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[p.ViewColumn.from(c.viewColumn),p.TextEditorOpenOptions.from(c)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[p.ViewColumn.from(c.viewColumn),p.TextEditorOpenOptions.from(c)]).optional()],y.ApiCommandResult.Void)];class A{static register(u){D.forEach(u.registerApiCommand,u)}}e.ExtHostApiCommands=A;function i(c){return u=>{if(Array.isArray(u))return u.map(c)}}function P(c){if(!Array.isArray(c))return;const u=[];for(const a of c)C.isLocationLink(a)?u.push(p.DefinitionLink.to(a)):u.push(p.location.to(a));return u}}),define(he[227],fe([0,1,17,53,3,6,2,79,26,16,7,5]),function(X,e,p,L,C,y,T,I,D,A,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function c(u,a,g){const w=u.getProxy(P.MainContext.MainThreadComments);class _{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,a.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const l=this._commentControllers.get(n.handle);return l||n}else if(n&&n.$mid===7){const l=this._commentControllers.get(n.commentControlHandle);if(!l)return n;const f=l.getCommentThread(n.commentThreadHandle);return f||n}else if(n&&n.$mid===8){const l=this._commentControllers.get(n.thread.commentControlHandle);if(!l)return n;const f=l.getCommentThread(n.thread.commentThreadHandle);return f?{thread:f,text:n.text}:n}else if(n&&n.$mid===9){const l=this._commentControllers.get(n.thread.commentControlHandle);if(!l)return n;const f=l.getCommentThread(n.thread.commentThreadHandle);if(!f)return n;let m=n.commentUniqueId,E=f.getCommentByUniqueId(m);return E||n}else if(n&&n.$mid===10){const l=this._commentControllers.get(n.thread.commentControlHandle);if(!l)return n;const f=l.getCommentThread(n.thread.commentThreadHandle);if(!f)return n;let m=n.text,E=n.commentUniqueId,S=f.getCommentByUniqueId(E);return S?(S.body=m,S):n}return n}})}createCommentController(n,l,f){const m=_.handlePool++,E=new d(n,m,l,f);this._commentControllers.set(E.handle,E);const S=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(n.identifier))||[];return S.push(E),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(n.identifier),S),E.value}$createCommentThreadTemplate(n,l,f){const m=this._commentControllers.get(n);!m||m.$createCommentThreadTemplate(l,f)}async $updateCommentThreadTemplate(n,l,f){const m=this._commentControllers.get(n);!m||m.$updateCommentThreadTemplate(l,f)}$deleteCommentThread(n,l){const f=this._commentControllers.get(n);f&&f.$deleteCommentThread(l)}$provideCommentingRanges(n,l,f){const m=this._commentControllers.get(n);if(!m||!m.commentingRangeProvider)return Promise.resolve(void 0);const E=g.getDocument(T.URI.revive(l));return(0,p.asPromise)(()=>m.commentingRangeProvider.provideCommentingRanges(E,f)).then(S=>S?S.map(o=>A.Range.from(o)):void 0)}$toggleReaction(n,l,f,m,E){const S=this._commentControllers.get(n);return!S||!S.reactionHandler?Promise.resolve(void 0):(0,p.asPromise)(()=>{const o=S.getCommentThread(l);if(o){const k=o.getCommentByUniqueId(m.uniqueIdInThread);if(S!==void 0&&k&&S.reactionHandler)return S.reactionHandler(k,t(E))}return Promise.resolve(void 0)})}dispose(){}}_.handlePool=0;class b{constructor(n,l,f,m,E,S,o){this._commentControllerHandle=l,this._id=f,this._uri=m,this._range=E,this._comments=S,this.handle=b._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new C.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputDisposables.value=new y.DisposableStore,this._id===void 0&&(this._id=`${n}.${this.handle}`),w.$createCommentThread(l,this.handle,this._id,this._uri,A.Range.from(this._range),o),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=S,this._localDisposables.push({dispose:()=>{w.$deleteCommentThread(l,this.handle)}});const k=this;this.value={get uri(){return k.uri},get range(){return k.range},set range(O){k.range=O},get comments(){return k.comments},set comments(O){k.comments=O},get collapsibleState(){return k.collapsibleState},set collapsibleState(O){k.collapsibleState=O},get canReply(){return k.canReply},set canReply(O){k.canReply=O},get contextValue(){return k.contextValue},set contextValue(O){k.contextValue=O},get label(){return k.label},set label(O){k.label=O},dispose:()=>{k.dispose()}}}set threadId(n){this._id=n}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(n){n.isEqual(this._range)||(this._range=n,this.modifications.range=n,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(n){this._canReply!==n&&(this._canReply=n,this.modifications.canReply=n,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(n){this._label=n,this.modifications.label=n,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(n){this._contextValue=n,this.modifications.contextValue=n,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(n){this._comments=n,this.modifications.comments=n,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(n){this._collapseState=n,this.modifications.collapsibleState=n,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new y.DisposableStore);const n=f=>Object.prototype.hasOwnProperty.call(this.modifications,f),l={};n("range")&&(l.range=A.Range.from(this._range)),n("label")&&(l.label=this.label),n("contextValue")&&(l.contextValue=this.contextValue),n("comments")&&(l.comments=this._comments.map(f=>h(this,f,this._commentsMap))),n("collapsibleState")&&(l.collapseState=s(this._collapseState)),n("canReply")&&(l.canReply=this.canReply),this.modifications={},w.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,l)}getCommentByUniqueId(n){for(let l of this._commentsMap){let f=l[0],m=l[1];if(n===m)return f}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(n=>n.dispose())}}b._handlePool=0,je([(0,L.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class d{constructor(n,l,f,m){this._extension=n,this._handle=l,this._id=f,this._label=m,this._threads=new Map,w.$registerCommentController(this.handle,f,m);const E=this;this.value=Object.freeze({id:E.id,label:E.label,get options(){return E.options},set options(S){E.options=S},get commentingRangeProvider(){return E.commentingRangeProvider},set commentingRangeProvider(S){E.commentingRangeProvider=S},get reactionHandler(){return E.reactionHandler},set reactionHandler(S){E.reactionHandler=S},createCommentThread(S,o,k){return E.createCommentThread(S,o,k).value},dispose:()=>{E.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{w.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(n){this._reactionHandler=n,w.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!n})}get options(){return this._options}set options(n){this._options=n,w.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(n,l,f,m){if(typeof n=="string"){const E=new b(this.id,this.handle,n,l,f,m,this._extension.identifier);return this._threads.set(E.handle,E),E}else{const E=new b(this.id,this.handle,void 0,n,l,f,this._extension.identifier);return this._threads.set(E.handle,E),E}}$createCommentThreadTemplate(n,l){const f=new b(this.id,this.handle,void 0,T.URI.revive(n),A.Range.to(l),[],this._extension.identifier);return f.collapsibleState=I.CommentThreadCollapsibleState.Expanded,this._threads.set(f.handle,f),f}$updateCommentThreadTemplate(n,l){let f=this._threads.get(n);f&&(f.range=A.Range.to(l))}$deleteCommentThread(n){let l=this._threads.get(n);l&&l.dispose(),this._threads.delete(n)}getCommentThread(n){return this._threads.get(n)}dispose(){this._threads.forEach(n=>{n.dispose()}),this._localDisposables.forEach(n=>n.dispose())}}function h(r,n,l){let f=l.get(n);f||(f=++r.commentHandle,l.set(n,f));const m=n.author&&n.author.iconPath?n.author.iconPath.toString():void 0;return{mode:n.mode,contextValue:n.contextValue,uniqueIdInThread:f,body:A.MarkdownString.from(n.body),userName:n.author.name,userIconPath:m,label:n.label,commentReactions:n.reactions?n.reactions.map(E=>v(E)):void 0}}function v(r){return{label:r.label,iconPath:r.iconPath?A.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function t(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?T.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function s(r){if(r!==void 0)switch(r){case i.CommentThreadCollapsibleState.Expanded:return I.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return I.CommentThreadCollapsibleState.Collapsed}return I.CommentThreadCollapsibleState.Collapsed}return new _}e.createExtHostComments=c}),define(he[128],fe([0,1,2,5,7,4,13,12,18,8,9]),function(X,e,p,L,C,y,T,I,D,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let P=class bn{constructor(u,a){this._logService=a,this._provider=new Map,this._proxy=u.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(u,a){const g=bn._handlePool++;this._provider.set(g,{provider:u,extensionId:a}),this._proxy.$registerDecorationProvider(g,a.value);const w=u.onDidChangeFileDecorations&&u.onDidChangeFileDecorations(_=>{if(!_){this._proxy.$onDidChange(g,null);return}let b=(0,D.asArray)(_);if(b.length<=bn._maxEventSize){this._proxy.$onDidChange(g,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.value,b.length);const d=b.map(t=>({uri:t,rank:(0,A.count)(t.path,"/")})),h=(0,D.groupBy)(d,(t,s)=>t.rank-s.rank||(0,A.compare)(t.uri.path,s.uri.path));let v=[];e:for(let t of h){let s;for(let r of t){let n=(0,i.dirname)(r.uri.path);if(s!==n&&(s=n,v.push(r.uri)>=bn._maxEventSize))break e}}this._proxy.$onDidChange(g,v)});return new C.Disposable(()=>{w?.dispose(),this._proxy.$unregisterDecorationProvider(g),this._provider.delete(g)})}async $provideDecorations(u,a,g){if(!this._provider.has(u))return Object.create(null);const w=Object.create(null),{provider:_,extensionId:b}=this._provider.get(u);return await Promise.all(a.map(async d=>{try{const{uri:h,id:v}=d,t=await Promise.resolve(_.provideFileDecoration(p.URI.revive(h),g));if(!t)return;try{C.FileDecoration.validate(t),w[v]=[t.propagate,t.tooltip,t.badge,t.color]}catch(s){this._logService.warn(`INVALID decoration from extension '${b.value}': ${s}`)}}catch(h){this._logService.error(h)}})),w}};P._handlePool=0,P._maxEventSize=250,P=je([We(0,T.IExtHostRpcService),We(1,I.ILogService)],P),e.ExtHostDecorations=P,e.IExtHostDecorations=(0,y.createDecorator)("IExtHostDecorations")}),define(he[228],fe([0,1,159,115,2,5,7,16,3,12,23]),function(X,e,p,L,C,y,T,I,D,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class P{constructor(a,g,w,_,b){this._name=a,this._owner=g,this._maxDiagnosticsPerFile=w,this._proxy=_,this._onDidChangeDiagnostics=b,this._isDisposed=!1,this._data=new i.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(a,g){if(!a){this.clear();return}this._checkDisposed();let w=[];if(C.URI.isUri(a)){if(!g){this.delete(a);return}this._data.set(a,g.slice()),w=[a]}else if(Array.isArray(a)){w=[];let b;a=[...a].sort(P._compareIndexedTuplesByUri);for(const d of a){const[h,v]=d;if((!b||h.toString()!==b.toString())&&(b&&this._data.get(b).length===0&&this._data.delete(b),b=h,w.push(h),this._data.set(h,[])),v){const t=this._data.get(h);t&&t.push(...v)}else{const t=this._data.get(h);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(w),!this._proxy)return;const _=[];for(let b of w){let d=[];const h=this._data.get(b);if(h)if(h.length>this._maxDiagnosticsPerFile){d=[];const v=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let s of h)if(s.severity===v[t]&&d.push(I.Diagnostic.from(s))===this._maxDiagnosticsPerFile)break e;d.push({severity:L.MarkerSeverity.Info,message:(0,p.localize)(0,null,h.length-this._maxDiagnosticsPerFile),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=h.map(v=>I.Diagnostic.from(v));_.push([b,d])}this._proxy.$changeMany(this._owner,_)}delete(a){this._checkDisposed(),this._onDidChangeDiagnostics.fire([a]),this._data.delete(a),this._proxy&&this._proxy.$changeMany(this._owner,[[a,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(a,g){this._checkDisposed();for(let w of this._data.keys())a.apply(g,[w,this.get(w),this])}get(a){this._checkDisposed();const g=this._data.get(a);return Array.isArray(g)?Object.freeze(g.slice(0)):[]}has(a){return this._checkDisposed(),Array.isArray(this._data.get(a))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(a,g){return a[0].toString()<g[0].toString()?-1:a[0].toString()>g[0].toString()?1:0}}e.DiagnosticCollection=P;let c=class Gt{constructor(a,g){this._logService=g,this._collections=new Map,this._onDidChangeDiagnostics=new D.DebounceEmitter({merge:w=>w.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this._onDidChangeDiagnostics.event,Gt._mapper),this._proxy=a.getProxy(y.MainContext.MainThreadDiagnostics)}static _mapper(a){const g=new i.ResourceMap;for(const w of a)g.set(w,w);return{uris:Object.freeze(Array.from(g.values()))}}createDiagnosticCollection(a,g){const{_collections:w,_proxy:_,_onDidChangeDiagnostics:b,_logService:d}=this,h=new class{$changeMany(s,r){_.$changeMany(s,r),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,s,r.length===0?"CLEARING":r)}$clear(s){_.$clear(s),d.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,s)}dispose(){_.dispose()}};let v;if(!g)g="_generated_diagnostic_collection_name_#"+Gt._idPool++,v=g;else if(!w.has(g))v=g;else{this._logService.warn(`DiagnosticCollection with name '${g}' does already exist.`);do v=g+Gt._idPool++;while(w.has(v))}return new class extends P{constructor(){super(g,v,Gt._maxDiagnosticsPerFile,h,b);w.set(v,this)}dispose(){super.dispose(),w.delete(v)}}}getDiagnostics(a){if(a)return this._getDiagnostics(a);{const g=new Map,w=[];for(const _ of this._collections.values())_.forEach((b,d)=>{let h=g.get(b.toString());typeof h=="undefined"&&(h=w.length,g.set(b.toString(),h),w.push([b,[]])),w[h][1]=w[h][1].concat(...d)});return w}}_getDiagnostics(a){let g=[];for(let w of this._collections.values())w.has(a)&&(g=g.concat(w.get(a)));return g}$acceptMarkersChange(a){if(!this._mirrorCollection){const g="_generated_mirror",w=new P(g,g,Gt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(g,w),this._mirrorCollection=w}for(const[g,w]of a)this._mirrorCollection.set(C.URI.revive(g),w.map(I.Diagnostic.to))}};c._idPool=0,c._maxDiagnosticsPerFile=1e3,c=je([We(1,A.ILogService)],c),e.ExtHostDiagnostics=c}),define(he[229],fe([0,1,2,5]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class C{constructor(T){this._proxy=T.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(T){return this._proxy.$showOpenDialog(T).then(I=>I?I.map(D=>p.URI.revive(D)):void 0)}showSaveDialog(T){return this._proxy.$showSaveDialog(T).then(I=>I?p.URI.revive(I):void 0)}}e.ExtHostDialogs=C}),define(he[230],fe([0,1,15,2,7,5,10,21,8]),function(X,e,p,L,C,y,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class A{constructor(P,c,u){this._documentsAndEditors=c,this._logService=u,this._documentContentProviders=new Map,this._proxy=P.getProxy(y.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,c){if(Object.keys(T.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const u=A._handlePool++;this._documentContentProviders.set(u,c),this._proxy.$registerTextContentProvider(u,P);let a;return typeof c.onDidChange=="function"&&(a=c.onDidChange(g=>{if(g.scheme!==P){this._logService.warn(`Provider for scheme '${P}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(g)&&this.$provideTextDocumentContent(u,g).then(w=>{if(!w&&typeof w!="string")return;const _=this._documentsAndEditors.getDocument(g);if(!_)return;const b=(0,D.splitLines)(w);if(!_.equalLines(b))return this._proxy.$onVirtualDocumentChange(g,w)},p.onUnexpectedError)})),new C.Disposable(()=>{this._documentContentProviders.delete(u)&&this._proxy.$unregisterTextContentProvider(u),a&&(a.dispose(),a=void 0)})}$provideTextDocumentContent(P,c){const u=this._documentContentProviders.get(P);return u?Promise.resolve(u.provideTextDocumentContent(L.URI.revive(c),I.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.ExtHostDocumentContentProvider=A,A._handlePool=0}),define(he[231],fe([0,1,3,6,2,5,120,16,14,25,7]),function(X,e,p,L,C,y,T,I,D,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class P{constructor(u,a){this._onDidAddDocument=new p.Emitter,this._onDidRemoveDocument=new p.Emitter,this._onDidChangeDocument=new p.Emitter,this._onDidSaveDocument=new p.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=u.getProxy(y.MainContext.MainThreadDocuments),this._documentsAndEditors=a,this._documentsAndEditors.onDidRemoveDocuments(g=>{for(const w of g)this._onDidRemoveDocument.fire(w.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(g=>{for(const w of g)this._onDidAddDocument.fire(w.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(u){if(!u)return;const a=this._documentsAndEditors.getDocument(u);if(a)return a}getDocument(u){const a=this.getDocumentData(u);if(!a?.document)throw new Error(`Unable to retrieve document from URI '${u}'`);return a.document}ensureDocumentData(u){const a=this._documentsAndEditors.getDocument(u);if(a)return Promise.resolve(a);let g=this._documentLoader.get(u.toString());return g||(g=this._proxy.$tryOpenDocument(u).then(w=>{this._documentLoader.delete(u.toString());const _=C.URI.revive(w);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(_))},w=>(this._documentLoader.delete(u.toString()),Promise.reject(w))),this._documentLoader.set(u.toString(),g)),g}createDocumentData(u){return this._proxy.$tryCreateDocument(u).then(a=>C.URI.revive(a))}$acceptModelModeChanged(u,a){const g=C.URI.revive(u),w=this._documentsAndEditors.getDocument(g);if(!w)throw new Error("unknown document");this._onDidRemoveDocument.fire(w.document),w._acceptLanguageId(a),this._onDidAddDocument.fire(w.document)}$acceptModelSaved(u){const a=C.URI.revive(u),g=this._documentsAndEditors.getDocument(a);if(!g)throw new Error("unknown document");this.$acceptDirtyStateChanged(u,!1),this._onDidSaveDocument.fire(g.document)}$acceptDirtyStateChanged(u,a){const g=C.URI.revive(u),w=this._documentsAndEditors.getDocument(g);if(!w)throw new Error("unknown document");w._acceptIsDirty(a),this._onDidChangeDocument.fire({document:w.document,contentChanges:[],reason:void 0})}$acceptModelChanged(u,a,g){const w=C.URI.revive(u),_=this._documentsAndEditors.getDocument(w);if(!_)throw new Error("unknown document");_._acceptIsDirty(g),_.onEvents(a);let b;a.isUndoing?b=i.TextDocumentChangeReason.Undo:a.isRedoing&&(b=i.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,A.deepFreeze)({document:_.document,contentChanges:a.changes.map(d=>({range:I.Range.to(d.range),rangeOffset:d.rangeOffset,rangeLength:d.rangeLength,text:d.text})),reason:b}))}setWordDefinitionFor(u,a){(0,T.setWordDefinitionFor)(u,a)}}e.ExtHostDocuments=P}),define(he[43],fe([0,1,52,3,6,2,4,5,120,13,126,16,12,23,10,72,136]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class _{constructor(h){this.value=h,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(h,v){this._extHostRpc=h,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new u.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(h){this.acceptDocumentsAndEditorsDelta(h)}acceptDocumentsAndEditorsDelta(h){const v=[],t=[],s=[];if(h.removedDocuments)for(const r of h.removedDocuments){const n=y.URI.revive(r),l=this._documents.get(n);l?.unref()&&(this._documents.delete(n),v.push(l.value))}if(h.addedDocuments)for(const r of h.addedDocuments){const n=y.URI.revive(r.uri);let l=this._documents.get(n);if(l&&n.scheme!==a.Schemas.vscodeNotebookCell&&n.scheme!==a.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);l||(l=new _(new D.ExtHostDocumentData(this._extHostRpc.getProxy(I.MainContext.MainThreadDocuments),n,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(n,l),t.push(l.value)),l.ref()}if(h.removedEditors)for(const r of h.removedEditors){const n=this._editors.get(r);this._editors.delete(r),n&&s.push(n)}if(h.addedEditors)for(const r of h.addedEditors){const n=y.URI.revive(r.documentUri);p.ok(this._documents.has(n),`document '${n}' does not exist`),p.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const l=this._documents.get(n).value,f=new i.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(I.MainContext.MainThreadTextEditors),this._logService,new w.Lazy(()=>l.document),r.selections.map(P.Selection.to),r.options,r.visibleRanges.map(m=>P.Range.to(m)),typeof r.editorPosition=="number"?P.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,f)}h.newActiveEditor!==void 0&&(p.ok(h.newActiveEditor===null||this._editors.has(h.newActiveEditor),`active editor '${h.newActiveEditor}' does not exist`),this._activeEditorId=h.newActiveEditor),(0,C.dispose)(v),(0,C.dispose)(s),h.removedDocuments&&this._onDidRemoveDocuments.fire(v),h.addedDocuments&&this._onDidAddDocuments.fire(t),(h.removedEditors||h.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),h.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(h){return this._documents.get(h)?.value}allDocuments(){return g.Iterable.map(this._documents.values(),h=>h.value)}getEditor(h){return this._editors.get(h)}activeEditor(h){if(!this._activeEditorId)return;const v=this._editors.get(this._activeEditorId);return h?v:v?.value}allEditors(){return[...this._editors.values()]}};b=je([We(0,A.IExtHostRpcService),We(1,c.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(he[232],fe([0,1,2,5,6,7,16,144,8,22]),function(X,e,p,L,C,y,T,I,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(u){this._stateMachine=void 0,this._schemes.push(u)}delete(u){const a=this._schemes.indexOf(u);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const u=this._schemes.sort(),a=[];let g,w,_=14,b=14;for(const d of u){let h=g?(0,D.commonPrefixLength)(g,d):0;for(h===0?w=1:w=b;h<d.length;h++)h+1===d.length?(_=b,b=9):b+=1,a.push([w,d.toUpperCase().charCodeAt(h),b]),a.push([w,d.toLowerCase().charCodeAt(h),b]),w=b;g=d,b=_}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new I.StateMachine(a)}}provideDocumentLinks(u){this._initStateMachine();const a=[],g=I.LinkComputer.computeLinks({getLineContent(w){return u.lineAt(w-1).text},getLineCount(){return u.lineCount}},this._stateMachine);for(const w of g){const _=T.DocumentLink.to(w);_.target&&a.push(_)}return a}}class P{constructor(u,a){this._extHostLanguageFeatures=a,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=u.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(u,a,g,w={},_){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const b=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(b,g),this._enableProposedApi.set(b,_??!1);let d=2;w.isCaseSensitive&&(d+=1024),w.isReadonly&&(d+=2048),typeof g.copy=="function"&&(d+=8),typeof g.open=="function"&&typeof g.close=="function"&&typeof g.read=="function"&&typeof g.write=="function"&&(d+=4),this._proxy.$registerFileSystemProvider(b,a,d).catch(v=>{console.error(`FAILED to register filesystem provider of ${u.value}-extension for the scheme ${a}`),console.error(v)});const h=g.onDidChangeFile(v=>{const t=[];for(const s of v){let{uri:r,type:n}=s;if(r.scheme!==a)continue;let l;switch(n){case y.FileChangeType.Changed:l=0;break;case y.FileChangeType.Created:l=1;break;case y.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:r,type:l})}this._proxy.$onFileSystemChange(b,t)});return(0,C.toDisposable)(()=>{h.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(b),this._enableProposedApi.delete(b),this._proxy.$unregisterProvider(b)})}static _asIStat(u,a){const{type:g,ctime:w,mtime:_,size:b,permissions:d}=u;return a?{type:g,ctime:w,mtime:_,size:b,permissions:d}:{type:g,ctime:w,mtime:_,size:b}}$stat(u,a){return Promise.resolve(this._getFsProvider(u).stat(p.URI.revive(a))).then(g=>P._asIStat(g,this._enableProposedApi.get(u)??!1))}$readdir(u,a){return Promise.resolve(this._getFsProvider(u).readDirectory(p.URI.revive(a)))}$readFile(u,a){return Promise.resolve(this._getFsProvider(u).readFile(p.URI.revive(a))).then(g=>A.VSBuffer.wrap(g))}$writeFile(u,a,g,w){return Promise.resolve(this._getFsProvider(u).writeFile(p.URI.revive(a),g.buffer,w))}$delete(u,a,g){return Promise.resolve(this._getFsProvider(u).delete(p.URI.revive(a),g))}$rename(u,a,g,w){return Promise.resolve(this._getFsProvider(u).rename(p.URI.revive(a),p.URI.revive(g),w))}$copy(u,a,g,w){const _=this._getFsProvider(u);if(!_.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(_.copy(p.URI.revive(a),p.URI.revive(g),w))}$mkdir(u,a){return Promise.resolve(this._getFsProvider(u).createDirectory(p.URI.revive(a)))}$watch(u,a,g,w){const _=this._getFsProvider(u).watch(p.URI.revive(g),w);this._watches.set(a,_)}$unwatch(u,a){const g=this._watches.get(a);g&&(g.dispose(),this._watches.delete(a))}$open(u,a,g){const w=this._getFsProvider(u);if(!w.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(w.open(p.URI.revive(a),g))}$close(u,a){const g=this._getFsProvider(u);if(!g.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(g.close(a))}$read(u,a,g,w){const _=this._getFsProvider(u);if(!_.read)throw new Error('FileSystemProvider does not implement "read"');const b=A.VSBuffer.alloc(w);return Promise.resolve(_.read(a,g,b.buffer,0,w)).then(d=>b.slice(0,d))}$write(u,a,g,w){const _=this._getFsProvider(u);if(!_.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(_.write(a,g,w.buffer,0,w.byteLength))}_getFsProvider(u){const a=this._fsProvider.get(u);if(!a){const g=new Error;throw g.name="ENOPRO",g.message="no provider",g}return a}}e.ExtHostFileSystem=P}),define(he[89],fe([0,1,5,41,7,22,4,13,59]),function(X,e,p,L,C,y,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let A=class Wt{constructor(P,c){const u=P.getProxy(p.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(a){return u.$stat(a).catch(Wt._handleError)},readDirectory(a){return u.$readdir(a).catch(Wt._handleError)},createDirectory(a){return u.$mkdir(a).catch(Wt._handleError)},async readFile(a){return u.$readFile(a).then(g=>g.buffer).catch(Wt._handleError)},writeFile(a,g){return u.$writeFile(a,y.VSBuffer.wrap(g)).catch(Wt._handleError)},delete(a,g){return u.$delete(a,{recursive:!1,useTrash:!1,...g}).catch(Wt._handleError)},rename(a,g,w){return u.$rename(a,g,{overwrite:!1,...w}).catch(Wt._handleError)},copy(a,g,w){return u.$copy(a,g,{overwrite:!1,...w}).catch(Wt._handleError)},isWritableFileSystem(a){const g=c.getCapabilities(a);if(typeof g=="number")return!(g&2048)}})}static _handleError(P){if(!(P instanceof Error))throw new C.FileSystemError(String(P));if(P.name==="ENOPRO")throw C.FileSystemError.Unavailable(P.message);switch(P.name){case L.FileSystemProviderErrorCode.FileExists:throw C.FileSystemError.FileExists(P.message);case L.FileSystemProviderErrorCode.FileNotFound:throw C.FileSystemError.FileNotFound(P.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw C.FileSystemError.FileNotADirectory(P.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw C.FileSystemError.FileIsADirectory(P.message);case L.FileSystemProviderErrorCode.NoPermissions:throw C.FileSystemError.NoPermissions(P.message);case L.FileSystemProviderErrorCode.Unavailable:throw C.FileSystemError.Unavailable(P.message);default:throw new C.FileSystemError(P.message,P.name)}}};A=je([We(0,I.IExtHostRpcService),We(1,D.IExtHostFileSystemInfo)],A),e.ExtHostConsumerFileSystem=A,e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(he[233],fe([0,1,6,5]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class C{constructor(T){this._handlePool=0,this._proxy=T.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const I=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(I,T),(0,p.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(I)})}}e.ExtHostLabelService=C}),define(he[234],fe([0,1,2,25,16,7,5,8,40,18,14,141,6,109,71,84,44,15,3]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u,a,g,w,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class d{constructor(z,J){this._documents=z,this._provider=J}async provideDocumentSymbols(z,J){const ne=this._documents.getDocument(z),oe=await this._provider.provideDocumentSymbols(ne,J);if(!(0,A.isFalsyOrEmpty)(oe))return oe[0]instanceof y.DocumentSymbol?oe.map(C.DocumentSymbol.from):d._asDocumentSymbolTree(oe)}static _asDocumentSymbolTree(z){z=z.slice(0).sort((oe,we)=>{let Z=oe.location.range.start.compareTo(we.location.range.start);return Z===0&&(Z=we.location.range.end.compareTo(oe.location.range.end)),Z});const J=[],ne=[];for(const oe of z){const we={name:oe.name||"!!MISSING: name!!",kind:C.SymbolKind.from(oe.kind),tags:oe.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:oe.containerName,range:C.Range.from(oe.location.range),selectionRange:C.Range.from(oe.location.range),children:[]};for(;;){if(ne.length===0){ne.push(we),J.push(we);break}const Z=ne[ne.length-1];if(D.Range.containsRange(Z.range,we.range)&&!D.Range.equalsRange(Z.range,we.range)){Z.children&&Z.children.push(we),ne.push(we);break}ne.pop()}}return J}}class h{constructor(z,J,ne){this._documents=z,this._commands=J,this._provider=ne,this._cache=new g.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(z,J){const ne=this._documents.getDocument(z),oe=await this._provider.provideCodeLenses(ne,J);if(!oe||J.isCancellationRequested)return;const we=this._cache.add(oe),Z=new c.DisposableStore;this._disposables.set(we,Z);const de={cacheId:we,lenses:[]};for(let Ie=0;Ie<oe.length;Ie++)de.lenses.push({cacheId:[we,Ie],range:C.Range.from(oe[Ie].range),command:this._commands.toInternal(oe[Ie].command,Z)});return de}async resolveCodeLens(z,J){const ne=z.cacheId&&this._cache.get(...z.cacheId);if(!ne)return;let oe;if(typeof this._provider.resolveCodeLens!="function"||ne.isResolved?oe=ne:oe=await this._provider.resolveCodeLens(ne,J),oe||(oe=ne),J.isCancellationRequested)return;const we=z.cacheId&&this._disposables.get(z.cacheId[0]);if(!!we)return z.command=this._commands.toInternal(oe.command??h._badCmd,we),z}releaseCodeLenses(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}}h._badCmd={command:"missing",title:"!!MISSING: command!!"};function v(He){return Array.isArray(He)?He.map(C.DefinitionLink.from):He?[C.DefinitionLink.from(He)]:[]}class t{constructor(z,J){this._documents=z,this._provider=J}async provideDefinition(z,J,ne){const oe=this._documents.getDocument(z),we=C.Position.to(J),Z=await this._provider.provideDefinition(oe,we,ne);return v(Z)}}class s{constructor(z,J){this._documents=z,this._provider=J}async provideDeclaration(z,J,ne){const oe=this._documents.getDocument(z),we=C.Position.to(J),Z=await this._provider.provideDeclaration(oe,we,ne);return v(Z)}}class r{constructor(z,J){this._documents=z,this._provider=J}async provideImplementation(z,J,ne){const oe=this._documents.getDocument(z),we=C.Position.to(J),Z=await this._provider.provideImplementation(oe,we,ne);return v(Z)}}class n{constructor(z,J){this._documents=z,this._provider=J}async provideTypeDefinition(z,J,ne){const oe=this._documents.getDocument(z),we=C.Position.to(J),Z=await this._provider.provideTypeDefinition(oe,we,ne);return v(Z)}}class l{constructor(z,J){this._documents=z,this._provider=J}async provideHover(z,J,ne){const oe=this._documents.getDocument(z),we=C.Position.to(J),Z=await this._provider.provideHover(oe,we,ne);if(!(!Z||(0,A.isFalsyOrEmpty)(Z.contents)))return Z.range||(Z.range=oe.getWordRangeAtPosition(we)),Z.range||(Z.range=new y.Range(we,we)),C.Hover.from(Z)}}class f{constructor(z,J){this._documents=z,this._provider=J}async provideEvaluatableExpression(z,J,ne){const oe=this._documents.getDocument(z),we=C.Position.to(J),Z=await this._provider.provideEvaluatableExpression(oe,we,ne);if(Z)return C.EvaluatableExpression.from(Z)}}class m{constructor(z,J){this._documents=z,this._provider=J}async provideInlineValues(z,J,ne,oe){const we=this._documents.getDocument(z),Z=await this._provider.provideInlineValues(we,C.Range.to(J),C.InlineValueContext.to(ne),oe);if(Array.isArray(Z))return Z.map(de=>C.InlineValue.from(de))}}class E{constructor(z,J){this._documents=z,this._provider=J}async provideDocumentHighlights(z,J,ne){const oe=this._documents.getDocument(z),we=C.Position.to(J),Z=await this._provider.provideDocumentHighlights(oe,we,ne);if(Array.isArray(Z))return Z.map(C.DocumentHighlight.from)}}class S{constructor(z,J){this._documents=z,this._provider=J}async provideLinkedEditingRanges(z,J,ne){const oe=this._documents.getDocument(z),we=C.Position.to(J),Z=await this._provider.provideLinkedEditingRanges(oe,we,ne);if(Z&&Array.isArray(Z.ranges))return{ranges:(0,A.coalesce)(Z.ranges.map(C.Range.from)),wordPattern:Z.wordPattern}}}class o{constructor(z,J){this._documents=z,this._provider=J}async provideReferences(z,J,ne,oe){const we=this._documents.getDocument(z),Z=C.Position.to(J),de=await this._provider.provideReferences(we,Z,ne,oe);if(Array.isArray(de))return de.map(C.location.from)}}class k{constructor(z,J,ne,oe,we,Z,de){this._documents=z,this._commands=J,this._diagnostics=ne,this._provider=oe,this._logService=we,this._extension=Z,this._apiDeprecation=de,this._cache=new g.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(z,J,ne,oe){const we=this._documents.getDocument(z),Z=P.Selection.isISelection(J)?C.Selection.to(J):C.Range.to(J),de=[];for(const K of this._diagnostics.getDiagnostics(z))if(Z.intersection(K.range)&&de.push(K)>k._maxCodeActionsPerFile)break;const Ie={diagnostics:de,only:ne.only?new y.CodeActionKind(ne.only):void 0,triggerKind:C.CodeActionTriggerKind.to(ne.trigger)},Be=await this._provider.provideCodeActions(we,Z,Ie,oe);if(!(0,A.isNonEmptyArray)(Be)||oe.isCancellationRequested)return;const qe=this._cache.add(Be),Ee=new c.DisposableStore;this._disposables.set(qe,Ee);const tt=[];for(let K=0;K<Be.length;K++){const ee=Be[K];!ee||(k._isCommand(ee)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:ee.title,command:this._commands.toInternal(ee,Ee)})):(Ie.only&&(ee.kind?Ie.only.contains(ee.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ie.only.value} 'requested but returned code action is of kind '${ee.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ie.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),tt.push({cacheId:[qe,K],title:ee.title,command:ee.command&&this._commands.toInternal(ee.command,Ee),diagnostics:ee.diagnostics&&ee.diagnostics.map(C.Diagnostic.from),edit:ee.edit&&C.WorkspaceEdit.from(ee.edit),kind:ee.kind&&ee.kind.value,isPreferred:ee.isPreferred,disabled:ee.disabled?.reason})))}return{cacheId:qe,actions:tt}}async resolveCodeAction(z,J){const[ne,oe]=z,we=this._cache.get(ne,oe);if(!we||k._isCommand(we)||!this._provider.resolveCodeAction)return;const Z=await this._provider.resolveCodeAction(we,J)??we;return Z?.edit?C.WorkspaceEdit.from(Z.edit):void 0}releaseCodeActions(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}static _isCommand(z){return typeof z.command=="string"&&typeof z.title=="string"}}k._maxCodeActionsPerFile=1e3;class O{constructor(z,J){this._documents=z,this._provider=J}async provideDocumentFormattingEdits(z,J,ne){const oe=this._documents.getDocument(z),we=await this._provider.provideDocumentFormattingEdits(oe,J,ne);if(Array.isArray(we))return we.map(C.TextEdit.from)}}class ${constructor(z,J){this._documents=z,this._provider=J}async provideDocumentRangeFormattingEdits(z,J,ne,oe){const we=this._documents.getDocument(z),Z=C.Range.to(J),de=await this._provider.provideDocumentRangeFormattingEdits(we,Z,ne,oe);if(Array.isArray(de))return de.map(C.TextEdit.from)}}class G{constructor(z,J){this._documents=z,this._provider=J,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,J,ne,oe,we){const Z=this._documents.getDocument(z),de=C.Position.to(J),Ie=await this._provider.provideOnTypeFormattingEdits(Z,de,ne,oe,we);if(Array.isArray(Ie))return Ie.map(C.TextEdit.from)}}class re{constructor(z,J){this._provider=z,this._logService=J,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(z,J){const ne=T.IdObject.mixin({symbols:[]}),oe=await this._provider.provideWorkspaceSymbols(z,J);if((0,A.isNonEmptyArray)(oe))for(const we of oe){if(!we)continue;if(!we.name){this._logService.warn("INVALID SymbolInformation, lacks name",we);continue}const Z=T.IdObject.mixin(C.WorkspaceSymbol.from(we));this._symbolCache.set(Z._id,we),ne.symbols.push(Z)}return ne.symbols.length>0&&this._resultCache.set(ne._id,[ne.symbols[0]._id,ne.symbols[ne.symbols.length-1]._id]),ne}async resolveWorkspaceSymbol(z,J){if(typeof this._provider.resolveWorkspaceSymbol!="function")return z;const ne=this._symbolCache.get(z._id);if(ne){const oe=await this._provider.resolveWorkspaceSymbol(ne,J);return oe&&(0,L.mixin)(z,C.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(z){const J=this._resultCache.get(z);if(J){for(let[ne,oe]=J;ne<=oe;ne++)this._symbolCache.delete(ne);this._resultCache.delete(z)}}}class j{constructor(z,J,ne){this._documents=z,this._provider=J,this._logService=ne}static supportsResolving(z){return typeof z.prepareRename=="function"}async provideRenameEdits(z,J,ne,oe){const we=this._documents.getDocument(z),Z=C.Position.to(J);try{const de=await this._provider.provideRenameEdits(we,Z,ne,oe);return de?C.WorkspaceEdit.from(de):void 0}catch(de){const Ie=j._asMessage(de);return Ie?{rejectReason:Ie,edits:void 0}:Promise.reject(de)}}async resolveRenameLocation(z,J,ne){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const oe=this._documents.getDocument(z),we=C.Position.to(J);try{const Z=await this._provider.prepareRename(oe,we,ne);let de,Ie;if(y.Range.isRange(Z)?(de=Z,Ie=oe.getText(Z)):(0,i.isObject)(Z)&&(de=Z.range,Ie=Z.placeholder),!de||!Ie)return;if(de.start.line>we.line||de.end.line<we.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(de),text:Ie}}catch(Z){const de=j._asMessage(Z);return de?{rejectReason:de,range:void 0,text:void 0}:Promise.reject(Z)}}static _asMessage(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class N{constructor(z,J){this.resultId=z,this.tokens=J}}class x{constructor(z,J){this._documents=z,this._provider=J,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(z,J,ne){const oe=this._documents.getDocument(z),we=J!==0?this._previousResults.get(J):null;let Z=typeof we?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(oe,we.resultId,ne):await this._provider.provideDocumentSemanticTokens(oe,ne);return we&&this._previousResults.delete(J),Z?(Z=x._fixProvidedSemanticTokens(Z),this._send(x._convertToEdits(we,Z),Z)):null}async releaseDocumentSemanticColoring(z){this._previousResults.delete(z)}static _fixProvidedSemanticTokens(z){return x._isSemanticTokens(z)?x._isCorrectSemanticTokens(z)?z:new y.SemanticTokens(new Uint32Array(z.data),z.resultId):x._isSemanticTokensEdits(z)?x._isCorrectSemanticTokensEdits(z)?z:new y.SemanticTokensEdits(z.edits.map(J=>new y.SemanticTokensEdit(J.start,J.deleteCount,J.data?new Uint32Array(J.data):J.data)),z.resultId):z}static _isSemanticTokens(z){return z&&!!z.data}static _isCorrectSemanticTokens(z){return z.data instanceof Uint32Array}static _isSemanticTokensEdits(z){return z&&Array.isArray(z.edits)}static _isCorrectSemanticTokensEdits(z){for(const J of z.edits)if(!(J.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(z,J){if(!x._isSemanticTokens(J)||!z||!z.tokens)return J;const ne=z.tokens,oe=ne.length,we=J.data,Z=we.length;let de=0;const Ie=Math.min(oe,Z);for(;de<Ie&&ne[de]===we[de];)de++;if(de===oe&&de===Z)return new y.SemanticTokensEdits([],J.resultId);let Be=0;const qe=Ie-de;for(;Be<qe&&ne[oe-Be-1]===we[Z-Be-1];)Be++;return new y.SemanticTokensEdits([{start:de,deleteCount:oe-de-Be,data:we.subarray(de,Z-Be)}],J.resultId)}_send(z,J){if(x._isSemanticTokens(z)){const ne=this._nextResultId++;return this._previousResults.set(ne,new N(z.resultId,z.data)),(0,u.encodeSemanticTokensDto)({id:ne,type:"full",data:z.data})}if(x._isSemanticTokensEdits(z)){const ne=this._nextResultId++;return x._isSemanticTokens(J)?this._previousResults.set(ne,new N(J.resultId,J.data)):this._previousResults.set(ne,new N(z.resultId)),(0,u.encodeSemanticTokensDto)({id:ne,type:"delta",deltas:(z.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}e.DocumentSemanticTokensAdapter=x;class R{constructor(z,J){this._documents=z,this._provider=J}async provideDocumentRangeSemanticTokens(z,J,ne){const oe=this._documents.getDocument(z),we=await this._provider.provideDocumentRangeSemanticTokens(oe,C.Range.to(J),ne);return we?this._send(we):null}_send(z){return(0,u.encodeSemanticTokensDto)({id:0,type:"full",data:z.data})}}e.DocumentRangeSemanticTokensAdapter=R;class V{constructor(z,J,ne,oe,we){this._documents=z,this._commands=J,this._provider=ne,this._apiDeprecation=oe,this._extension=we,this._cache=new g.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}async provideCompletionItems(z,J,ne,oe){const we=this._documents.getDocument(z),Z=C.Position.to(J),de=we.getWordRangeAtPosition(Z)||new y.Range(Z,Z),Ie=de.with({end:Z}),Be=new w.StopWatch(!0),qe=await this._provider.provideCompletionItems(we,Z,oe,C.CompletionContext.to(ne));if(!qe||oe.isCancellationRequested)return;const Ee=Array.isArray(qe)?new y.CompletionList(qe):qe,tt=V.supportsResolving(this._provider)?this._cache.add(Ee.items):this._cache.add([]),K=new c.DisposableStore;this._disposables.set(tt,K);const ee=[],pe={x:tt,b:ee,a:{replace:C.Range.from(de),insert:C.Range.from(Ie)},c:Ee.isIncomplete||void 0,d:Be.elapsed()};for(let xe=0;xe<Ee.items.length;xe++){const $e=Ee.items[xe],et=this._convertCompletionItem($e,[tt,xe],Ie,de);ee.push(et)}return pe}async resolveCompletionItem(z,J){if(typeof this._provider.resolveCompletionItem!="function")return;const ne=this._cache.get(...z);if(!ne)return;const oe=await this._provider.resolveCompletionItem(ne,J);if(!!oe)return this._convertCompletionItem(oe,z)}releaseCompletionItems(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}_convertCompletionItem(z,J,ne,oe){const we=this._disposables.get(J[0]);if(!we)throw Error("DisposableStore is missing...");const Z={x:J,a:z.label,b:z.kind!==void 0?C.CompletionItemKind.from(z.kind):void 0,n:z.tags&&z.tags.map(C.CompletionItemTag.from),c:z.detail,d:typeof z.documentation=="undefined"?void 0:C.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters,l:z.additionalTextEdits&&z.additionalTextEdits.map(C.TextEdit.from),m:this._commands.toInternal(z.command,we)};z.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Z.h=z.textEdit.newText):typeof z.insertText=="string"?Z.h=z.insertText:z.insertText instanceof y.SnippetString&&(Z.h=z.insertText.value,Z.i|=4);let de;return z.textEdit?de=z.textEdit.range:z.range&&(de=z.range),y.Range.isRange(de)?Z.j=C.Range.from(de):de&&(!ne?.isEqual(de.inserting)||!oe?.isEqual(de.replacing))&&(Z.j={insert:C.Range.from(de.inserting),replace:C.Range.from(de.replacing)}),Z}}class F{constructor(z,J,ne){this._documents=z,this._provider=J,this._commands=ne,this._cache=new g.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(z,J,ne,oe){const we=this._documents.getDocument(z),Z=C.Position.to(J),de=await this._provider.provideInlineCompletionItems(we,Z,ne,oe);if(!de||oe.isCancellationRequested)return;const Ie=(0,i.isArray)(de)?{items:de}:de,Be=this._cache.add(Ie.items);let qe;return{pid:Be,items:Ie.items.map((Ee,tt)=>{let K;return Ee.command&&(qe||(qe=new c.DisposableStore,this._disposables.set(Be,qe)),K=this._commands.toInternal(Ee.command,qe)),{text:Ee.text,range:Ee.range?C.Range.from(Ee.range):void 0,command:K,idx:tt}})}}disposeCompletions(z){this._cache.delete(z);const J=this._disposables.get(z);J&&J.clear(),this._disposables.delete(z)}handleDidShowCompletionItem(z,J){const ne=this._cache.get(z,J);ne&&M.get(this._provider).fireOnDidShowCompletionItem({completionItem:ne})}}class M{constructor(){this._onDidShowCompletionItemEmitter=new b.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(z){let J=M.map.get(z);return J||(J=new M,M.map.set(z,J)),J}fireOnDidShowCompletionItem(z){this._onDidShowCompletionItemEmitter.fire(z)}}e.InlineCompletionController=M,M.map=new WeakMap;class B{constructor(z,J){this._documents=z,this._provider=J,this._cache=new g.Cache("SignatureHelp")}async provideSignatureHelp(z,J,ne,oe){const we=this._documents.getDocument(z),Z=C.Position.to(J),de=this.reviveContext(ne),Ie=await this._provider.provideSignatureHelp(we,Z,oe,de);if(Ie){const Be=this._cache.add([Ie]);return{...C.SignatureHelp.from(Ie),id:Be}}}reviveContext(z){let J;if(z.activeSignatureHelp){const ne=C.SignatureHelp.to(z.activeSignatureHelp),oe=this._cache.get(z.activeSignatureHelp.id,0);oe?(J=oe,J.activeSignature=ne.activeSignature,J.activeParameter=ne.activeParameter):J=ne}return{...z,activeSignatureHelp:J}}releaseSignatureHelp(z){this._cache.delete(z)}}class W{constructor(z,J){this._documents=z,this._provider=J}async provideInlayHints(z,J,ne){const oe=this._documents.getDocument(z),we=await this._provider.provideInlayHints(oe,C.Range.to(J),ne);return we?{hints:we.map(C.InlayHint.from)}:void 0}}class Q{constructor(z,J){this._documents=z,this._provider=J,this._cache=new g.Cache("DocumentLink")}async provideLinks(z,J){const ne=this._documents.getDocument(z),oe=await this._provider.provideDocumentLinks(ne,J);if(!(!Array.isArray(oe)||oe.length===0)&&!J.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:oe.filter(Q._validateLink).map(C.DocumentLink.from)};{const we=this._cache.add(oe),Z={links:[],id:we};for(let de=0;de<oe.length;de++){if(!Q._validateLink(oe[de]))continue;const Ie=C.DocumentLink.from(oe[de]);Ie.cacheId=[we,de],Z.links.push(Ie)}return Z}}}static _validateLink(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,J){if(typeof this._provider.resolveDocumentLink!="function")return;const ne=this._cache.get(...z);if(!ne)return;const oe=await this._provider.resolveDocumentLink(ne,J);if(!(!oe||!Q._validateLink(oe)))return C.DocumentLink.from(oe)}releaseLinks(z){this._cache.delete(z)}}class ae{constructor(z,J){this._documents=z,this._provider=J}async provideColors(z,J){const ne=this._documents.getDocument(z),oe=await this._provider.provideDocumentColors(ne,J);return Array.isArray(oe)?oe.map(Z=>({color:C.Color.from(Z.color),range:C.Range.from(Z.range)})):[]}async provideColorPresentations(z,J,ne){const oe=this._documents.getDocument(z),we=C.Range.to(J.range),Z=C.Color.to(J.color),de=await this._provider.provideColorPresentations(Z,{document:oe,range:we},ne);if(!!Array.isArray(de))return de.map(C.ColorPresentation.from)}}class _e{constructor(z,J){this._documents=z,this._provider=J}async provideFoldingRanges(z,J,ne){const oe=this._documents.getDocument(z),we=await this._provider.provideFoldingRanges(oe,J,ne);if(!!Array.isArray(we))return we.map(C.FoldingRange.from)}}class Fe{constructor(z,J,ne){this._documents=z,this._provider=J,this._logService=ne}async provideSelectionRanges(z,J,ne){const oe=this._documents.getDocument(z),we=J.map(C.Position.to),Z=await this._provider.provideSelectionRanges(oe,we,ne);if(!(0,A.isNonEmptyArray)(Z))return[];if(Z.length!==we.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const de=[];for(let Ie=0;Ie<we.length;Ie++){const Be=[];de.push(Be);let qe=we[Ie],Ee=Z[Ie];for(;;){if(!Ee.range.contains(qe))throw new Error("INVALID selection range, must contain the previous range");if(Be.push(C.SelectionRange.from(Ee)),!Ee.parent)break;qe=Ee.range,Ee=Ee.parent}}return de}}class Ae{constructor(z,J){this._documents=z,this._provider=J,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(z,J,ne){const oe=this._documents.getDocument(z),we=C.Position.to(J),Z=await this._provider.prepareCallHierarchy(oe,we,ne);if(!Z)return;const de=this._idPool.nextId();return this._cache.set(de,new Map),Array.isArray(Z)?Z.map(Ie=>this._cacheAndConvertItem(de,Ie)):[this._cacheAndConvertItem(de,Z)]}async provideCallsTo(z,J,ne){const oe=this._itemFromCache(z,J);if(!oe)throw new Error("missing call hierarchy item");const we=await this._provider.provideCallHierarchyIncomingCalls(oe,ne);if(!!we)return we.map(Z=>({from:this._cacheAndConvertItem(z,Z.from),fromRanges:Z.fromRanges.map(de=>C.Range.from(de))}))}async provideCallsFrom(z,J,ne){const oe=this._itemFromCache(z,J);if(!oe)throw new Error("missing call hierarchy item");const we=await this._provider.provideCallHierarchyOutgoingCalls(oe,ne);if(!!we)return we.map(Z=>({to:this._cacheAndConvertItem(z,Z.to),fromRanges:Z.fromRanges.map(de=>C.Range.from(de))}))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,J){const ne=this._cache.get(z),oe={_sessionId:z,_itemId:ne.size.toString(36),name:J.name,detail:J.detail,kind:C.SymbolKind.from(J.kind),uri:J.uri,range:C.Range.from(J.range),selectionRange:C.Range.from(J.selectionRange),tags:J.tags?.map(C.SymbolTag.from)};return ne.set(oe._itemId,J),oe}_itemFromCache(z,J){return this._cache.get(z)?.get(J)}}class Me{constructor(z,J){this.adapter=z,this.extension=J}}class Ve{constructor(z,J,ne,oe,we,Z,de){this._adapter=new Map,this._uriTransformer=J,this._proxy=z.getProxy(T.MainContext.MainThreadLanguageFeatures),this._documents=ne,this._commands=oe,this._diagnostics=we,this._logService=Z,this._apiDeprecation=de}_transformDocumentSelector(z){return(0,A.coalesce)((0,A.asArray)(z).map(J=>this._doTransformDocumentSelector(J)))}_doTransformDocumentSelector(z){if(typeof z=="string")return{$serialized:!0,language:z};if(z)return{$serialized:!0,language:z.language,scheme:this._transformScheme(z.scheme),pattern:typeof z.pattern=="undefined"?void 0:C.GlobPattern.from(z.pattern),exclusive:z.exclusive}}_transformScheme(z){return this._uriTransformer&&typeof z=="string"?this._uriTransformer.transformOutgoingScheme(z):z}_createDisposable(z){return new y.Disposable(()=>{this._adapter.delete(z),this._proxy.$unregister(z)})}_nextHandle(){return Ve._handlePool++}_withAdapter(z,J,ne,oe,we=!1){const Z=this._adapter.get(z);if(!Z)return Promise.resolve(oe);if(Z.adapter instanceof J){let de;Z.extension&&(de=Date.now(),this._logService.trace(`[${Z.extension.identifier.value}] INVOKE provider '${J.name}'`));const Ie=ne(Z.adapter,Z.extension),Be=Z.extension;return Be&&Promise.resolve(Ie).then(()=>this._logService.trace(`[${Be.identifier.value}] provider DONE after ${Date.now()-de}ms`),qe=>{we&&qe instanceof _.CancellationError||(this._logService.error(`[${Be.identifier.value}] provider FAILED`),this._logService.error(qe))}),Ie}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(z,J){const ne=this._nextHandle();return this._adapter.set(ne,new Me(z,J)),ne}static _extLabel(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,J,ne,oe){const we=this._addNewAdapter(new d(this._documents,ne),z),Z=oe&&oe.label||Ve._extLabel(z);return this._proxy.$registerDocumentSymbolProvider(we,this._transformDocumentSelector(J),Z),this._createDisposable(we)}$provideDocumentSymbols(z,J,ne){return this._withAdapter(z,d,oe=>oe.provideDocumentSymbols(p.URI.revive(J),ne),void 0)}registerCodeLensProvider(z,J,ne){const oe=this._nextHandle(),we=typeof ne.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Me(new h(this._documents,this._commands.converter,ne),z)),this._proxy.$registerCodeLensSupport(oe,this._transformDocumentSelector(J),we);let Z=this._createDisposable(oe);if(we!==void 0){const de=ne.onDidChangeCodeLenses(Ie=>this._proxy.$emitCodeLensEvent(we));Z=y.Disposable.from(Z,de)}return Z}$provideCodeLenses(z,J,ne){return this._withAdapter(z,h,oe=>oe.provideCodeLenses(p.URI.revive(J),ne),void 0)}$resolveCodeLens(z,J,ne){return this._withAdapter(z,h,oe=>oe.resolveCodeLens(J,ne),void 0)}$releaseCodeLenses(z,J){this._withAdapter(z,h,ne=>Promise.resolve(ne.releaseCodeLenses(J)),void 0)}registerDefinitionProvider(z,J,ne){const oe=this._addNewAdapter(new t(this._documents,ne),z);return this._proxy.$registerDefinitionSupport(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideDefinition(z,J,ne,oe){return this._withAdapter(z,t,we=>we.provideDefinition(p.URI.revive(J),ne,oe),[])}registerDeclarationProvider(z,J,ne){const oe=this._addNewAdapter(new s(this._documents,ne),z);return this._proxy.$registerDeclarationSupport(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideDeclaration(z,J,ne,oe){return this._withAdapter(z,s,we=>we.provideDeclaration(p.URI.revive(J),ne,oe),[])}registerImplementationProvider(z,J,ne){const oe=this._addNewAdapter(new r(this._documents,ne),z);return this._proxy.$registerImplementationSupport(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideImplementation(z,J,ne,oe){return this._withAdapter(z,r,we=>we.provideImplementation(p.URI.revive(J),ne,oe),[])}registerTypeDefinitionProvider(z,J,ne){const oe=this._addNewAdapter(new n(this._documents,ne),z);return this._proxy.$registerTypeDefinitionSupport(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideTypeDefinition(z,J,ne,oe){return this._withAdapter(z,n,we=>we.provideTypeDefinition(p.URI.revive(J),ne,oe),[])}registerHoverProvider(z,J,ne,oe){const we=this._addNewAdapter(new l(this._documents,ne),z);return this._proxy.$registerHoverProvider(we,this._transformDocumentSelector(J)),this._createDisposable(we)}$provideHover(z,J,ne,oe){return this._withAdapter(z,l,we=>we.provideHover(p.URI.revive(J),ne,oe),void 0)}registerEvaluatableExpressionProvider(z,J,ne,oe){const we=this._addNewAdapter(new f(this._documents,ne),z);return this._proxy.$registerEvaluatableExpressionProvider(we,this._transformDocumentSelector(J)),this._createDisposable(we)}$provideEvaluatableExpression(z,J,ne,oe){return this._withAdapter(z,f,we=>we.provideEvaluatableExpression(p.URI.revive(J),ne,oe),void 0)}registerInlineValuesProvider(z,J,ne,oe){const we=typeof ne.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Z=this._addNewAdapter(new m(this._documents,ne),z);this._proxy.$registerInlineValuesProvider(Z,this._transformDocumentSelector(J),we);let de=this._createDisposable(Z);if(we!==void 0){const Ie=ne.onDidChangeInlineValues(Be=>this._proxy.$emitInlineValuesEvent(we));de=y.Disposable.from(de,Ie)}return de}$provideInlineValues(z,J,ne,oe,we){return this._withAdapter(z,m,Z=>Z.provideInlineValues(p.URI.revive(J),ne,oe,we),void 0)}registerDocumentHighlightProvider(z,J,ne){const oe=this._addNewAdapter(new E(this._documents,ne),z);return this._proxy.$registerDocumentHighlightProvider(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideDocumentHighlights(z,J,ne,oe){return this._withAdapter(z,E,we=>we.provideDocumentHighlights(p.URI.revive(J),ne,oe),void 0)}registerLinkedEditingRangeProvider(z,J,ne){const oe=this._addNewAdapter(new S(this._documents,ne),z);return this._proxy.$registerLinkedEditingRangeProvider(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideLinkedEditingRanges(z,J,ne,oe){return this._withAdapter(z,S,async we=>{const Z=await we.provideLinkedEditingRanges(p.URI.revive(J),ne,oe);if(Z)return{ranges:Z.ranges,wordPattern:Z.wordPattern?Ve._serializeRegExp(Z.wordPattern):void 0}},void 0)}registerReferenceProvider(z,J,ne){const oe=this._addNewAdapter(new o(this._documents,ne),z);return this._proxy.$registerReferenceSupport(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideReferences(z,J,ne,oe,we){return this._withAdapter(z,o,Z=>Z.provideReferences(p.URI.revive(J),ne,oe,we),void 0)}registerCodeActionProvider(z,J,ne,oe){const we=new c.DisposableStore,Z=this._addNewAdapter(new k(this._documents,this._commands.converter,this._diagnostics,ne,this._logService,z,this._apiDeprecation),z);return this._proxy.$registerQuickFixSupport(Z,this._transformDocumentSelector(J),{providedKinds:oe?.providedCodeActionKinds?.map(de=>de.value),documentation:oe?.documentation?.map(de=>({kind:de.kind.value,command:this._commands.converter.toInternal(de.command,we)}))},Ve._extLabel(z),Boolean(ne.resolveCodeAction)),we.add(this._createDisposable(Z)),we}$provideCodeActions(z,J,ne,oe,we){return this._withAdapter(z,k,Z=>Z.provideCodeActions(p.URI.revive(J),ne,oe,we),void 0)}$resolveCodeAction(z,J,ne){return this._withAdapter(z,k,oe=>oe.resolveCodeAction(J,ne),void 0)}$releaseCodeActions(z,J){this._withAdapter(z,k,ne=>Promise.resolve(ne.releaseCodeActions(J)),void 0)}registerDocumentFormattingEditProvider(z,J,ne){const oe=this._addNewAdapter(new O(this._documents,ne),z);return this._proxy.$registerDocumentFormattingSupport(oe,this._transformDocumentSelector(J),z.identifier,z.displayName||z.name),this._createDisposable(oe)}$provideDocumentFormattingEdits(z,J,ne,oe){return this._withAdapter(z,O,we=>we.provideDocumentFormattingEdits(p.URI.revive(J),ne,oe),void 0)}registerDocumentRangeFormattingEditProvider(z,J,ne){const oe=this._addNewAdapter(new $(this._documents,ne),z);return this._proxy.$registerRangeFormattingSupport(oe,this._transformDocumentSelector(J),z.identifier,z.displayName||z.name),this._createDisposable(oe)}$provideDocumentRangeFormattingEdits(z,J,ne,oe,we){return this._withAdapter(z,$,Z=>Z.provideDocumentRangeFormattingEdits(p.URI.revive(J),ne,oe,we),void 0)}registerOnTypeFormattingEditProvider(z,J,ne,oe){const we=this._addNewAdapter(new G(this._documents,ne),z);return this._proxy.$registerOnTypeFormattingSupport(we,this._transformDocumentSelector(J),oe,z.identifier),this._createDisposable(we)}$provideOnTypeFormattingEdits(z,J,ne,oe,we,Z){return this._withAdapter(z,G,de=>de.provideOnTypeFormattingEdits(p.URI.revive(J),ne,oe,we,Z),void 0)}registerWorkspaceSymbolProvider(z,J){const ne=this._addNewAdapter(new re(J,this._logService),z);return this._proxy.$registerNavigateTypeSupport(ne),this._createDisposable(ne)}$provideWorkspaceSymbols(z,J,ne){return this._withAdapter(z,re,oe=>oe.provideWorkspaceSymbols(J,ne),{symbols:[]})}$resolveWorkspaceSymbol(z,J,ne){return this._withAdapter(z,re,oe=>oe.resolveWorkspaceSymbol(J,ne),void 0)}$releaseWorkspaceSymbols(z,J){this._withAdapter(z,re,ne=>ne.releaseWorkspaceSymbols(J),void 0)}registerRenameProvider(z,J,ne){const oe=this._addNewAdapter(new j(this._documents,ne,this._logService),z);return this._proxy.$registerRenameSupport(oe,this._transformDocumentSelector(J),j.supportsResolving(ne)),this._createDisposable(oe)}$provideRenameEdits(z,J,ne,oe,we){return this._withAdapter(z,j,Z=>Z.provideRenameEdits(p.URI.revive(J),ne,oe,we),void 0)}$resolveRenameLocation(z,J,ne,oe){return this._withAdapter(z,j,we=>we.resolveRenameLocation(p.URI.revive(J),ne,oe),void 0)}registerDocumentSemanticTokensProvider(z,J,ne,oe){const we=this._nextHandle(),Z=typeof ne.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(we,new Me(new x(this._documents,ne),z)),this._proxy.$registerDocumentSemanticTokensProvider(we,this._transformDocumentSelector(J),oe,Z);let de=this._createDisposable(we);if(Z){const Ie=ne.onDidChangeSemanticTokens(Be=>this._proxy.$emitDocumentSemanticTokensEvent(Z));de=y.Disposable.from(de,Ie)}return de}$provideDocumentSemanticTokens(z,J,ne,oe){return this._withAdapter(z,x,we=>we.provideDocumentSemanticTokens(p.URI.revive(J),ne,oe),null,!0)}$releaseDocumentSemanticTokens(z,J){this._withAdapter(z,x,ne=>ne.releaseDocumentSemanticColoring(J),void 0)}registerDocumentRangeSemanticTokensProvider(z,J,ne,oe){const we=this._addNewAdapter(new R(this._documents,ne),z);return this._proxy.$registerDocumentRangeSemanticTokensProvider(we,this._transformDocumentSelector(J),oe),this._createDisposable(we)}$provideDocumentRangeSemanticTokens(z,J,ne,oe){return this._withAdapter(z,R,we=>we.provideDocumentRangeSemanticTokens(p.URI.revive(J),ne,oe),null,!0)}registerCompletionItemProvider(z,J,ne,oe){const we=this._addNewAdapter(new V(this._documents,this._commands.converter,ne,this._apiDeprecation,z),z);return this._proxy.$registerSuggestSupport(we,this._transformDocumentSelector(J),oe,V.supportsResolving(ne),`${z.identifier.value}(${oe.join("")})`),this._createDisposable(we)}$provideCompletionItems(z,J,ne,oe,we){return this._withAdapter(z,V,Z=>Z.provideCompletionItems(p.URI.revive(J),ne,oe,we),void 0)}$resolveCompletionItem(z,J,ne){return this._withAdapter(z,V,oe=>oe.resolveCompletionItem(J,ne),void 0)}$releaseCompletionItems(z,J){this._withAdapter(z,V,ne=>ne.releaseCompletionItems(J),void 0)}registerInlineCompletionsProvider(z,J,ne){const oe=this._addNewAdapter(new F(this._documents,ne,this._commands.converter),z);return this._proxy.$registerInlineCompletionsSupport(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideInlineCompletions(z,J,ne,oe,we){return this._withAdapter(z,F,Z=>Z.provideInlineCompletions(p.URI.revive(J),ne,oe,we),void 0)}$handleInlineCompletionDidShow(z,J,ne){this._withAdapter(z,F,async oe=>{oe.handleDidShowCompletionItem(J,ne)},void 0)}$freeInlineCompletionsList(z,J){this._withAdapter(z,F,async ne=>{ne.disposeCompletions(J)},void 0)}registerSignatureHelpProvider(z,J,ne,oe){const we=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,Z=this._addNewAdapter(new B(this._documents,ne),z);return this._proxy.$registerSignatureHelpProvider(Z,this._transformDocumentSelector(J),we),this._createDisposable(Z)}$provideSignatureHelp(z,J,ne,oe,we){return this._withAdapter(z,B,Z=>Z.provideSignatureHelp(p.URI.revive(J),ne,oe,we),void 0)}$releaseSignatureHelp(z,J){this._withAdapter(z,B,ne=>ne.releaseSignatureHelp(J),void 0)}registerInlayHintsProvider(z,J,ne){const oe=typeof ne.onDidChangeInlayHints=="function"?this._nextHandle():void 0,we=this._addNewAdapter(new W(this._documents,ne),z);this._proxy.$registerInlayHintsProvider(we,this._transformDocumentSelector(J),oe);let Z=this._createDisposable(we);if(oe!==void 0){const de=ne.onDidChangeInlayHints(Ie=>this._proxy.$emitInlayHintsEvent(oe));Z=y.Disposable.from(Z,de)}return Z}$provideInlayHints(z,J,ne,oe){return this._withAdapter(z,W,we=>we.provideInlayHints(p.URI.revive(J),ne,oe),void 0)}registerDocumentLinkProvider(z,J,ne){const oe=this._addNewAdapter(new Q(this._documents,ne),z);return this._proxy.$registerDocumentLinkProvider(oe,this._transformDocumentSelector(J),typeof ne.resolveDocumentLink=="function"),this._createDisposable(oe)}$provideDocumentLinks(z,J,ne){return this._withAdapter(z,Q,oe=>oe.provideLinks(p.URI.revive(J),ne),void 0)}$resolveDocumentLink(z,J,ne){return this._withAdapter(z,Q,oe=>oe.resolveLink(J,ne),void 0)}$releaseDocumentLinks(z,J){this._withAdapter(z,Q,ne=>ne.releaseLinks(J),void 0)}registerColorProvider(z,J,ne){const oe=this._addNewAdapter(new ae(this._documents,ne),z);return this._proxy.$registerDocumentColorProvider(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideDocumentColors(z,J,ne){return this._withAdapter(z,ae,oe=>oe.provideColors(p.URI.revive(J),ne),[])}$provideColorPresentations(z,J,ne,oe){return this._withAdapter(z,ae,we=>we.provideColorPresentations(p.URI.revive(J),ne,oe),void 0)}registerFoldingRangeProvider(z,J,ne){const oe=this._nextHandle(),we=typeof ne.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Me(new _e(this._documents,ne),z)),this._proxy.$registerFoldingRangeProvider(oe,this._transformDocumentSelector(J),we);let Z=this._createDisposable(oe);if(we!==void 0){const de=ne.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(we));Z=y.Disposable.from(Z,de)}return Z}$provideFoldingRanges(z,J,ne,oe){return this._withAdapter(z,_e,we=>we.provideFoldingRanges(p.URI.revive(J),ne,oe),void 0)}registerSelectionRangeProvider(z,J,ne){const oe=this._addNewAdapter(new Fe(this._documents,ne,this._logService),z);return this._proxy.$registerSelectionRangeProvider(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideSelectionRanges(z,J,ne,oe){return this._withAdapter(z,Fe,we=>we.provideSelectionRanges(p.URI.revive(J),ne,oe),[])}registerCallHierarchyProvider(z,J,ne){const oe=this._addNewAdapter(new Ae(this._documents,ne),z);return this._proxy.$registerCallHierarchyProvider(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$prepareCallHierarchy(z,J,ne,oe){return this._withAdapter(z,Ae,we=>Promise.resolve(we.prepareSession(p.URI.revive(J),ne,oe)),void 0)}$provideCallHierarchyIncomingCalls(z,J,ne,oe){return this._withAdapter(z,Ae,we=>we.provideCallsTo(J,ne,oe),void 0)}$provideCallHierarchyOutgoingCalls(z,J,ne,oe){return this._withAdapter(z,Ae,we=>we.provideCallsFrom(J,ne,oe),void 0)}$releaseCallHierarchy(z,J){this._withAdapter(z,Ae,ne=>Promise.resolve(ne.releaseSession(J)),void 0)}static _serializeRegExp(z){return{pattern:z.source,flags:(0,I.regExpFlags)(z)}}static _serializeIndentationRule(z){return{decreaseIndentPattern:Ve._serializeRegExp(z.decreaseIndentPattern),increaseIndentPattern:Ve._serializeRegExp(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Ve._serializeRegExp(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Ve._serializeRegExp(z.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(z){return{beforeText:Ve._serializeRegExp(z.beforeText),afterText:z.afterText?Ve._serializeRegExp(z.afterText):void 0,previousLineText:z.previousLineText?Ve._serializeRegExp(z.previousLineText):void 0,action:z.action}}static _serializeOnEnterRules(z){return z.map(Ve._serializeOnEnterRule)}setLanguageConfiguration(z,J,ne){let{wordPattern:oe}=ne;if(oe&&(0,I.regExpLeadsToEndlessLoop)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this._documents.setWordDefinitionFor(J,oe):this._documents.setWordDefinitionFor(J,void 0),ne.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),ne.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const we=this._nextHandle(),Z={comments:ne.comments,brackets:ne.brackets,wordPattern:ne.wordPattern?Ve._serializeRegExp(ne.wordPattern):void 0,indentationRules:ne.indentationRules?Ve._serializeIndentationRule(ne.indentationRules):void 0,onEnterRules:ne.onEnterRules?Ve._serializeOnEnterRules(ne.onEnterRules):void 0,__electricCharacterSupport:ne.__electricCharacterSupport,__characterPairSupport:ne.__characterPairSupport};return this._proxy.$setLanguageConfiguration(we,J,Z),this._createDisposable(we)}$setWordDefinitions(z){for(const J of z)this._documents.setWordDefinitionFor(J.languageId,new RegExp(J.regexSource,J.regexFlags))}}e.ExtHostLanguageFeatures=Ve,Ve._handlePool=0}),define(he[235],fe([0,1,5,16,7]),function(X,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(I,D){this._proxy=I.getProxy(p.MainContext.MainThreadLanguages),this._documents=D}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(I,D){await this._proxy.$changeLanguage(I,D);const A=this._documents.getDocumentData(I);if(!A)throw new Error(`document '${I.toString}' NOT found`);return A.document}async tokenAtPosition(I,D){const A=I.version,i=L.Position.from(D),P=await this._proxy.$tokensAtPosition(I.uri,i),c={type:C.StandardTokenType.Other,range:I.getWordRangeAtPosition(D)??new C.Range(D.line,D.character,D.line,D.character)};if(!P)return c;const u={range:L.Range.to(P.range),type:L.TokenType.to(P.type)};return!u.range.contains(D)||A!==I.version?c:u}}e.ExtHostLanguages=y}),define(he[236],fe([0,1,5,12,34]),function(X,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function y(I){return I&&I.title}let T=class{constructor(D,A){this._logService=A,this._proxy=D.getProxy(p.MainContext.MainThreadMessageService)}showMessage(D,A,i,P,c){const u={extension:D};let a;typeof P=="string"||y(P)?a=[P,...c]:(u.modal=P?.modal,u.useCustom=P?.useCustom,u.detail=P?.detail,a=c),u.useCustom&&(0,C.checkProposedApiEnabled)(D);const g=[];for(let w=0;w<a.length;w++){const _=a[w];if(typeof _=="string")g.push({title:_,handle:w,isCloseAffordance:!1});else if(typeof _=="object"){let{title:b,isCloseAffordance:d}=_;g.push({title:b,isCloseAffordance:!!d,handle:w})}else this._logService.warn("Invalid message item:",_)}return this._proxy.$showMessage(A,i,u,g).then(w=>{if(typeof w=="number")return a[w]})}};T=je([We(1,L.ILogService)],T),e.ExtHostMessageService=T}),define(he[237],fe([0,1,22,3,55,6,23,8,14,2,84,5,16,7,213,125]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class w{constructor(b,d,h,v,t){this._textDocumentsAndEditors=h,this._textDocuments=v,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new T.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new L.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new L.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new L.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new i.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=b.getProxy(P.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=b.getProxy(P.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=b.getProxy(P.MainContext.MainThreadNotebookEditors),this._commandsConverter=d.converter,d.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const r=s.notebookEditor?.notebookUri,n=s.cell.handle,f=this._documents.get(r)?.getCell(n);if(f)return f.apiCell}return s}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(b=>b.apiEditor)}getEditorById(b){const d=this._editors.get(b);if(!d)throw new Error(`unknown text editor: ${b}. known editors: ${[...this._editors.keys()]} `);return d}getIdByEditor(b){for(const[d,h]of this._editors)if(h.apiEditor===b)return d}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(b,d){const h=this._documents.get(b);if(!h&&!d)throw new Error(`NO notebook document for '${b}'`);return h}_getProviderData(b){const d=this._notebookContentProviders.get(b);if(!d)throw new Error(`NO provider for '${b}'`);return d}registerNotebookContentProvider(b,d,h,v,t){if((0,I.isFalsyOrWhitespace)(d))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(d))throw new Error(`Notebook provider for '${d}' already registered`);this._notebookContentProviders.set(d,{extension:b,provider:h});let s;return h.onDidChangeNotebookContentOptions&&(s=h.onDidChangeNotebookContentOptions(()=>{const r=c.NotebookDocumentContentOptions.from(h.options);this._notebookProxy.$updateNotebookProviderOptions(d,r)})),this._notebookProxy.$registerNotebookProvider({id:b.identifier,location:b.extensionLocation},d,c.NotebookDocumentContentOptions.from(v),w._convertNotebookRegistrationData(b,t)),new u.Disposable(()=>{s?.dispose(),this._notebookContentProviders.delete(d),this._notebookProxy.$unregisterNotebookProvider(d)})}static _convertNotebookRegistrationData(b,d){if(!d)return;const h=d.filenamePattern.map(v=>c.NotebookExclusiveDocumentPattern.from(v)).filter(v=>v!==void 0);if(d.filenamePattern&&!h){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:d.displayName,filenamePattern:h,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,d,h){const v=w._notebookStatusBarItemProviderHandlePool++,t=typeof h.onDidChangeCellStatusBarItems=="function"?w._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(v,h),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(v,t,d);let s;return t!==void 0&&(s=h.onDidChangeCellStatusBarItems(r=>this._notebookProxy.$emitCellStatusBarEvent(t))),new u.Disposable(()=>{this._notebookStatusBarItemProviders.delete(v),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(v,t),s&&s.dispose()})}async createNotebookDocument(b){const d=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:b.viewType,content:b.content&&c.NotebookData.from(b.content)});return A.URI.revive(d)}async openNotebookDocument(b){const d=this._documents.get(b);if(d)return d.apiNotebook;const h=await this._notebookDocumentsProxy.$tryOpenNotebook(b),v=this._documents.get(A.URI.revive(h));return(0,D.assertIsDefined)(v?.apiNotebook)}async showNotebookDocument(b,d){A.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let h;typeof d=="object"?h={position:c.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map(c.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:h={preserveFocus:!1};const v=await this._notebookEditorsProxy.$tryShowNotebookDocument(b.uri,b.notebookType,h),t=v&&this._editors.get(v)?.apiEditor;if(t)return t;throw v?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,d,h,v){const t=this._notebookStatusBarItemProviders.get(b),s=A.URI.revive(d),r=this._documents.get(s);if(!r||!t)return;const n=r.getCellFromIndex(h);if(!n)return;const l=await t.provideCellStatusBarItems(n.apiCell,v);if(!l)return;const f=new y.DisposableStore,m=this._statusBarCache.add([f]),S=(Array.isArray(l)?l:[l]).map(o=>c.NotebookStatusBarItem.from(o,this._commandsConverter,f));return{cacheId:m,items:S}}$releaseNotebookCellStatusBarItems(b){this._statusBarCache.delete(b)}registerNotebookSerializer(b,d,h,v,t){if((0,I.isFalsyOrWhitespace)(d))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,h),this._notebookProxy.$registerNotebookSerializer(s,{id:b.identifier,location:b.extensionLocation},d,c.NotebookDocumentContentOptions.from(v),w._convertNotebookRegistrationData(b,t)),(0,y.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(b,d,h){const v=this._notebookSerializer.get(b);if(!v)throw new Error("NO serializer found");const t=await v.deserializeNotebook(d.buffer,h);return c.NotebookData.from(t)}async $notebookToData(b,d,h){const v=this._notebookSerializer.get(b);if(!v)throw new Error("NO serializer found");const t=await v.serializeNotebook(c.NotebookData.to(d),h);return p.VSBuffer.wrap(t)}async $openNotebook(b,d,h,v,t){const{provider:s}=this._getProviderData(b),r=await s.openNotebook(A.URI.revive(d),{backupId:h,untitledDocumentData:v?.buffer},t);return{metadata:r.metadata??Object.create(null),cells:r.cells.map(c.NotebookCellData.from)}}async $saveNotebook(b,d,h){const v=this.getNotebookDocument(A.URI.revive(d)),{provider:t}=this._getProviderData(b);return await t.saveNotebook(v.apiNotebook,h),!0}async $saveNotebookAs(b,d,h,v){const t=this.getNotebookDocument(A.URI.revive(d)),{provider:s}=this._getProviderData(b);return await s.saveNotebookAs(A.URI.revive(h),t.apiNotebook,v),!0}async $backupNotebook(b,d,h){const v=this.getNotebookDocument(A.URI.revive(d)),t=this._getProviderData(b),s=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension),r=String((0,C.hash)([v.uri.toString(),this._backupIdPool++])),n=A.URI.joinPath(s,r),l=await t.provider.backupNotebook(v.apiNotebook,{destination:n},h);return v.updateBackup(l),l.id}_createExtHostEditor(b,d,h){if(this._editors.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const v=new g.ExtHostNotebookEditor(d,this._notebookEditorsProxy,b,h.visibleRanges.map(c.NotebookRange.to),h.selections.map(c.NotebookRange.to),typeof h.viewColumn=="number"?c.ViewColumn.to(h.viewColumn):void 0);this._editors.set(d,v)}$acceptDocumentAndEditorsDelta(b){if(b.removedDocuments)for(const h of b.removedDocuments){const v=A.URI.revive(h),t=this._documents.get(v);t&&(t.dispose(),this._documents.delete(v),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:t.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(t.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===v.toString()&&this._editors.delete(s.id)}if(b.addedDocuments){const h=[];for(const v of b.addedDocuments){const t=A.URI.revive(v.uri);if(this._documents.has(t))throw new Error(`adding EXISTING notebook ${t} `);const s=this,r=new a.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(n){s._onDidChangeNotebookCells.fire(n)},emitCellOutputsChange(n){s._onDidChangeCellOutputs.fire(n)},emitCellMetadataChange(n){s._onDidChangeCellMetadata.fire(n)},emitCellExecutionStateChange(n){s._onDidChangeCellExecutionState.fire(n)}},t,v);h.push(...v.cells.map(n=>a.ExtHostCell.asModelAddData(r.apiNotebook,n))),this._documents.get(t)?.dispose(),this._documents.set(t,r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:h}),this._onDidOpenNotebookDocument.fire(r.apiNotebook)}}if(b.addedEditors)for(const h of b.addedEditors){if(this._editors.has(h.id))return;const v=A.URI.revive(h.documentUri),t=this._documents.get(v);t&&this._createExtHostEditor(t,h.id,h)}const d=[];if(b.removedEditors)for(const h of b.removedEditors){const v=this._editors.get(h);v&&(this._editors.delete(h),this._activeNotebookEditor?.id===v.id&&(this._activeNotebookEditor=void 0),d.push(v))}if(b.visibleEditors){this._visibleNotebookEditors=b.visibleEditors.map(v=>this._editors.get(v)).filter(v=>!!v);const h=new Set;this._visibleNotebookEditors.forEach(v=>h.add(v.id));for(const v of this._editors.values()){const t=h.has(v.id);v._acceptVisibility(t)}this._visibleNotebookEditors=[...this._editors.values()].map(v=>v).filter(v=>v.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}b.newActiveEditor===null?this._activeNotebookEditor=void 0:b.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(b.newActiveEditor)),b.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=w,w._notebookStatusBarItemProviderHandlePool=0}),define(he[238],fe([0,1,3,71,12,5,13,16]),function(X,e,p,L,C,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class D{constructor(P,c){const u=D._Keys.nextId();P.$registerNotebookEditorDecorationType(u,I.NotebookDecorationRenderOptions.from(c)),this.value={key:u,dispose(){P.$removeNotebookEditorDecorationType(u)}}}}D._Keys=new L.IdGenerator("NotebookEditorDecorationType");let A=class{constructor(P,c,u){this._logService=P,this._extHostRpc=c,this._notebooksAndEditors=u,this._onDidChangeNotebookEditorSelection=new p.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new p.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(P){return new D(this._extHostRpc.getProxy(y.MainContext.MainThreadNotebookEditors),P).value}$acceptEditorPropertiesChanged(P,c){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",P,c);const u=this._notebooksAndEditors.getEditorById(P);c.visibleRanges&&u._acceptVisibleRanges(c.visibleRanges.ranges.map(I.NotebookRange.to)),c.selections&&u._acceptSelections(c.selections.selections.map(I.NotebookRange.to)),c.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:u.apiEditor,visibleRanges:u.apiEditor.visibleRanges}),c.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:u.apiEditor,selections:u.apiEditor.selections}))}$acceptEditorViewColumns(P){for(const c in P)this._notebooksAndEditors.getEditorById(c)._acceptViewColumn(I.ViewColumn.to(P[c]))}};A=je([We(0,C.ILogService),We(1,T.IExtHostRpcService)],A),e.ExtHostNotebookEditors=A}),define(he[239],fe([0,1,3,6,5,26,2,16,86,23,17,87,21,18,12,7,34]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let _=class{constructor(t,s,r,n){this._initData=s,this._extHostNotebook=r,this._logService=n,this._activeExecutions=new A.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(C.MainContext.MainThreadNotebookKernels)}createNotebookController(t,s,r,n,l,f){for(let F of this._kernelData.values())if(F.controller.id===s&&y.ExtensionIdentifier.equals(t.identifier,F.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const m=this._handlePool++,E=this;this._logService.trace(`NotebookController[${m}], CREATED by ${t.identifier.value}, ${s}`);const S=()=>console.warn(`NO execute handler from notebook controller '${G.id}' of extension: '${t.identifier}'`);let o=!1;const k=new L.DisposableStore,O=new p.Emitter,$=new p.Emitter,G={id:`${t.identifier.value}/${s}`,notebookType:r,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:n||t.identifier.value,preloads:f?f.map(I.NotebookRendererScript.from):[]};let re=l??S,j;this._proxy.$addKernel(m,G).catch(F=>{console.log(F),o=!0});let N=0;const x=()=>{if(o)return;const F=++N;Promise.resolve().then(()=>{F===N&&this._proxy.$updateKernel(m,G)})},R=new A.ResourceMap,V={get id(){return s},get notebookType(){return G.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return G.label},set label(F){G.label=F??t.displayName??t.name,x()},get detail(){return G.detail??""},set detail(F){G.detail=F,x()},get description(){return G.description??""},set description(F){G.description=F,x()},get supportedLanguages(){return G.supportedLanguages},set supportedLanguages(F){G.supportedLanguages=F,x()},get supportsExecutionOrder(){return G.supportsExecutionOrder??!1},set supportsExecutionOrder(F){G.supportsExecutionOrder=F,x()},get rendererScripts(){return G.preloads?G.preloads.map(I.NotebookRendererScript.to):[]},get executeHandler(){return re},set executeHandler(F){re=F??S},get interruptHandler(){return j},set interruptHandler(F){j=F,G.supportsInterrupt=Boolean(F),x()},createNotebookCellExecution(F){if(o)throw new Error("notebook controller is DISPOSED");if(!R.has(F.notebook.uri))throw E._logService.trace(`NotebookController[${m}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(R.keys()).map(M=>M.toString())),new Error(`notebook controller is NOT associated to notebook: ${F.notebook.uri.toString()}`);return E._createNotebookCellExecution(F)},dispose:()=>{o||(this._logService.trace(`NotebookController[${m}], DISPOSED`),o=!0,this._kernelData.delete(m),k.dispose(),O.dispose(),$.dispose(),this._proxy.$removeKernel(m))},updateNotebookAffinity(F,M){E._proxy.$updateNotebookPriority(m,F.uri,M)},onDidReceiveMessage:$.event,postMessage(F,M){return(0,w.checkProposedApiEnabled)(t),E._proxy.$postMessage(m,M&&E._extHostNotebook.getIdByEditor(M),F)},asWebviewUri(F){return(0,w.checkProposedApiEnabled)(t),(0,D.asWebviewUri)(F,E._initData.remote)}};return this._kernelData.set(m,{extensionId:t.identifier,controller:V,onDidReceiveMessage:$,onDidChangeSelection:O,associatedNotebooks:R}),V}$acceptNotebookAssociation(t,s,r){const n=this._kernelData.get(t);if(n){const l=this._extHostNotebook.getNotebookDocument(T.URI.revive(s));r?n.associatedNotebooks.set(l.uri,!0):n.associatedNotebooks.delete(l.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,l.uri.toString(),r),n.onDidChangeSelection.fire({selected:r,notebook:l.apiNotebook})}}async $executeCells(t,s,r){const n=this._kernelData.get(t);if(!n)return;const l=this._extHostNotebook.getNotebookDocument(T.URI.revive(s)),f=[];for(let m of r){const E=l.getCell(m);E&&f.push(E.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,l.uri.toString(),f.length),await n.controller.executeHandler.call(n.controller,f,l.apiNotebook,n.controller)}catch(m){this._logService.error(`NotebookController[${t}] execute cells FAILED`,m),console.error(m)}}async $cancelCells(t,s,r){const n=this._kernelData.get(t);if(!n)return;const l=this._extHostNotebook.getNotebookDocument(T.URI.revive(s));if(n.controller.interruptHandler)await n.controller.interruptHandler.call(n.controller,l.apiNotebook);else for(let f of r){const m=l.getCell(f);m&&this._activeExecutions.get(m.uri)?.cancel()}}$acceptKernelMessageFromRenderer(t,s,r){const n=this._kernelData.get(t);if(!n)return;const l=this._extHostNotebook.getEditorById(s);n.onDidReceiveMessage.fire(Object.freeze({editor:l.apiEditor,message:r}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const r=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!r)throw new Error("invalid cell");if(this._activeExecutions.has(r.uri))throw new Error(`duplicate execution for ${r.uri}`);const n=new d(r.notebook,r,this._proxy);this._activeExecutions.set(r.uri,n);const l=n.onDidChangeState(()=>{n.state===b.Resolved&&(n.dispose(),l.dispose(),this._activeExecutions.delete(r.uri))});return n.asApiObject()}};_=je([We(3,a.ILogService)],_),e.ExtHostNotebookKernels=_;var b;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(b||(b={}));class d extends L.Disposable{constructor(t,s,r){super();this._document=t,this._cell=s,this._proxy=r,this._onDidChangeState=new p.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=b.Init,this._tokenSource=this._register(new c.CancellationTokenSource),this._collector=new h(10,n=>this.applyEdits(n)),this._executionOrder=s.internalMetadata.executionOrder,this.mixinMetadata({runState:P.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyExecutionEdits(this._document.uri,t)}verifyStateForOutput(){if(this._state===b.Init)throw new Error("Must call start before modifying cell output");if(this._state===b.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){this.applyEdits([{editType:9,handle:this._cell.handle,internalMetadata:t}])}cellIndexToHandle(t){let s=this._cell;if(t&&(s=this._document.getCellFromApiCell(t)),!s)throw new Error("INVALID cell");return s.handle}validateAndConvertOutputs(t){return t.map(s=>{const r=g.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return r===s.items?I.NotebookCellOutput.from(s):I.NotebookCellOutput.from({items:r,id:s.id,metadata:s.metadata})})}async updateOutputs(t,s,r){const n=this.cellIndexToHandle(s),l=this.validateAndConvertOutputs((0,u.asArray)(t));return this.applyEditSoon({editType:2,handle:n,append:r,outputs:l})}async updateOutputItems(t,s,r){return t=g.NotebookCellOutput.ensureUniqueMimeTypes((0,u.asArray)(t),!0),this.applyEditSoon({editType:7,items:t.map(I.NotebookCellOutputItem.from),outputId:s.id,append:r})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(r){t._executionOrder=r,t.mixinMetadata({executionOrder:r})},start(r){if(t._state===b.Resolved||t._state===b.Started)throw new Error("Cannot call start again");t._state=b.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:P.NotebookCellExecutionState.Executing,runStartTime:r??null})},end(r,n){if(t._state===b.Resolved)throw new Error("Cannot call resolve twice");t._state=b.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:r??null,runEndTime:n??null})},clearOutput(r){return t.verifyStateForOutput(),t.updateOutputs([],r,!1)},appendOutput(r,n){return t.verifyStateForOutput(),t.updateOutputs(r,n,!0)},replaceOutput(r,n){return t.verifyStateForOutput(),t.updateOutputs(r,n,!1)},appendOutputItems(r,n){return t.verifyStateForOutput(),t.updateOutputItems(r,n,!0)},replaceOutputItems(r,n){return t.verifyStateForOutput(),t.updateOutputItems(r,n,!1)}})}}class h{constructor(t,s){this.delay=t,this.callback=s,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=(0,i.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const s=this.batch;return this.batch=[],this.callback(s)})),this.waitPromise}}}),define(he[240],fe([0,1,3,5,125]),function(X,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class y{constructor(I,D){this._extHostNotebook=D,this._rendererMessageEmitters=new Map,this.proxy=I.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(I,D,A){const i=this._extHostNotebook.getEditorById(I);this._rendererMessageEmitters.get(D)?.fire({editor:i.apiEditor,message:A})}createRendererMessaging(I){return{onDidReceiveMessage:(...A)=>this.getOrCreateEmitterFor(I).event(...A),postMessage:(A,i)=>{const P=C.ExtHostNotebookEditor.apiEditorsToExtHost.get(A);if(!P)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(P.id,I,i)}}}getOrCreateEmitterFor(I){let D=this._rendererMessageEmitters.get(I);return D||(D=new p.Emitter({onLastListenerRemove:()=>{D?.dispose(),this._rendererMessageEmitters.delete(I)}}),this._rendererMessageEmitters.set(I,D),D)}}e.ExtHostNotebookRenderers=y}),define(he[62],fe([0,1,5,3,6,22,4,13]),function(X,e,p,L,C,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends C.Disposable{constructor(a,g,w,_,b){super();this._onDidAppend=this._register(new L.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=a,this._proxy=b,this._id=b.$register(this.name,g,w,_),this._disposed=!1,this._offset=0}get name(){return this._name}append(a){this.validate(),this._offset+=a?y.VSBuffer.fromString(a).byteLength:0}update(){this._id.then(a=>this._proxy.$update(a))}appendLine(a){this.validate(),this.append(a+`
`)}clear(){this.validate();const a=this._offset;this._id.then(g=>this._proxy.$clear(g,a))}show(a,g){this.validate(),this._id.then(w=>this._proxy.$reveal(w,!!(typeof a=="boolean"?a:g)))}hide(){this.validate(),this._id.then(a=>this._proxy.$close(a))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(a=>this._proxy.$dispose(a)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class A extends D{constructor(a,g,w){super(a,!1,void 0,g,w)}append(a){super.append(a),this._id.then(g=>this._proxy.$append(g,a)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=A;class i extends D{constructor(a,g,w){super(a,!0,g,void 0,w)}append(a){throw new Error("Not supported")}}class P{constructor(a,g){this.name=a,this._channel=g}append(a){this._channel.then(g=>g.append(a))}appendLine(a){this._channel.then(g=>g.appendLine(a))}clear(){this._channel.then(a=>a.clear())}show(a,g){this._channel.then(w=>w.show(a,g))}hide(){this._channel.then(a=>a.hide())}dispose(){this._channel.then(a=>a.dispose())}}e.LazyOutputChannel=P;let c=class{constructor(a){this._proxy=a.getProxy(p.MainContext.MainThreadOutputService)}$setVisibleChannel(a){}createOutputChannel(a,g){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");return new A(g.identifier.value,a,this._proxy)}createOutputChannelFromLogFile(a,g){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");if(!g)throw new Error("illegal argument `file`. must not be falsy");return new i(a,g,this._proxy)}};c=je([We(0,I.IExtHostRpcService)],c),e.ExtHostOutputService=c,e.IExtHostOutputService=(0,T.createDecorator)("IExtHostOutputService")}),define(he[241],fe([0,1,17,21,3,6,5,2,7,15,18,56]),function(X,e,p,L,C,y,T,I,D,A,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function c(u,a,g){const w=u.getProxy(T.MainContext.MainThreadQuickOpen);class _{constructor(n,l){this._sessions=new Map,this._instances=0,this._workspace=n,this._commands=l}showQuickPick(n,l,f,m=L.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(n),S=++this._instances,o=w.$show(S,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},m),k={},O=o.then(()=>k);return Promise.race([O,E]).then($=>{if($!==k)return E.then(G=>{const re=[];for(let j=0;j<G.length;j++){const N=G[j];let x,R,V,F,M;typeof N=="string"?x=N:(x=N.label,R=N.description,V=N.detail,F=N.picked,M=N.alwaysShow),re.push({label:x,description:R,handle:j,detail:V,picked:F,alwaysShow:M})}return f&&typeof f.onDidSelectItem=="function"&&(this._onDidSelectItem=j=>{f.onDidSelectItem(G[j])}),w.$setItems(S,re),o.then(j=>{if(typeof j=="number")return G[j];if(Array.isArray(j))return j.map(N=>G[N])})})}).then(void 0,$=>{if(!(0,A.isPromiseCanceledError)($))return w.$setError(S,$),Promise.reject($)})}$onItemSelected(n){this._onDidSelectItem&&this._onDidSelectItem(n)}showInput(n,l=L.CancellationToken.None){return this._validateInput=n?n.validateInput:void 0,w.$input(n,typeof this._validateInput=="function",l).then(void 0,f=>{if(!(0,A.isPromiseCanceledError)(f))return Promise.reject(f)})}$validateInput(n){return this._validateInput?(0,p.asPromise)(()=>this._validateInput(n)):Promise.resolve(void 0)}async showWorkspaceFolderPick(n,l=L.CancellationToken.None){const f=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[n]);if(!f)return;const m=await this._workspace.getWorkspaceFolders2();if(!!m)return m.find(E=>E.uri.toString()===f.uri.toString())}createQuickPick(n,l){const f=new t(n,l,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}createInputBox(n){const l=new s(n,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}$onDidChangeValue(n,l){const f=this._sessions.get(n);f&&f._fireDidChangeValue(l)}$onDidAccept(n){const l=this._sessions.get(n);l&&l._fireDidAccept()}$onDidChangeActive(n,l){const f=this._sessions.get(n);f instanceof t&&f._fireDidChangeActive(l)}$onDidChangeSelection(n,l){const f=this._sessions.get(n);f instanceof t&&f._fireDidChangeSelection(l)}$onDidTriggerButton(n,l){const f=this._sessions.get(n);f&&f._fireDidTriggerButton(l)}$onDidHide(n){const l=this._sessions.get(n);l&&l._fireDidHide()}}class b{constructor(n,l){this._extensionId=n,this._onDidDispose=l,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new C.Emitter,this._onDidChangeValueEmitter=new C.Emitter,this._onDidTriggerButtonEmitter=new C.Emitter,this._onDidHideEmitter=new C.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(n){this._title=n,this.update({title:n})}get step(){return this._steps}set step(n){this._steps=n,this.update({step:n})}get totalSteps(){return this._totalSteps}set totalSteps(n){this._totalSteps=n,this.update({totalSteps:n})}get enabled(){return this._enabled}set enabled(n){this._enabled=n,this.update({enabled:n})}get busy(){return this._busy}set busy(n){this._busy=n,this.update({busy:n})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(n){this._ignoreFocusOut=n,this.update({ignoreFocusOut:n})}get value(){return this._value}set value(n){this._value=n,this.update({value:n})}get placeholder(){return this._placeholder}set placeholder(n){this._placeholder=n,this.update({placeholder:n})}get buttons(){return this._buttons}set buttons(n){this._buttons=n.slice(),this._handlesToButtons.clear(),n.forEach((l,f)=>{const m=l===D.QuickInputButtons.Back?-1:f;this._handlesToButtons.set(m,l)}),this.update({buttons:n.map((l,f)=>({iconPath:d(l.iconPath),tooltip:l.tooltip,handle:l===D.QuickInputButtons.Back?-1:f}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(n){this._value=n,this._onDidChangeValueEmitter.fire(n)}_fireDidTriggerButton(n){const l=this._handlesToButtons.get(n);l&&this._onDidTriggerButtonEmitter.fire(l)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,y.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),w.$dispose(this._id))}update(n){if(!this._disposed){for(const l of Object.keys(n)){const f=n[l];this._pendingUpdate[l]=f===void 0?null:f}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){w.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}b._nextId=1;function d(r){if(r instanceof D.ThemeIcon)return{id:r.id};const n=v(r),l=h(r);return{dark:typeof n=="string"?I.URI.file(n):n,light:typeof l=="string"?I.URI.file(l):l}}function h(r){return typeof r=="object"&&"light"in r?r.light:r}function v(r){return typeof r=="object"&&"dark"in r?r.dark:r}class t extends b{constructor(n,l,f){super(n,f);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new C.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new C.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(n){this._items=n.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),n.forEach((l,f)=>{this._handlesToItems.set(f,l),this._itemsToHandles.set(l,f)}),this.update({items:n.map((l,f)=>({label:l.label,description:l.description,handle:f,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(n){this._canSelectMany=n,this.update({canSelectMany:n})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(n){this._matchOnDescription=n,this.update({matchOnDescription:n})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(n){this._matchOnDetail=n,this.update({matchOnDetail:n})}get sortByLabel(){return this._sortByLabel}set sortByLabel(n){this._sortByLabel=n,this.update({sortByLabel:n})}get activeItems(){return this._activeItems}set activeItems(n){this._activeItems=n.filter(l=>this._itemsToHandles.has(l)),this.update({activeItems:this._activeItems.map(l=>this._itemsToHandles.get(l))})}get selectedItems(){return this._selectedItems}set selectedItems(n){this._selectedItems=n.filter(l=>this._itemsToHandles.has(l)),this.update({selectedItems:this._selectedItems.map(l=>this._itemsToHandles.get(l))})}_fireDidChangeActive(n){const l=(0,i.coalesce)(n.map(f=>this._handlesToItems.get(f)));this._activeItems=l,this._onDidChangeActiveEmitter.fire(l)}_fireDidChangeSelection(n){const l=(0,i.coalesce)(n.map(f=>this._handlesToItems.get(f)));this._selectedItems=l,this._onDidChangeSelectionEmitter.fire(l)}}class s extends b{constructor(n,l){super(n,l);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(n){this._password=n,this.update({password:n})}get prompt(){return this._prompt}set prompt(n){this._prompt=n,this.update({prompt:n})}get validationMessage(){return this._validationMessage}set validationMessage(n){this._validationMessage=n,this.update({validationMessage:n,severity:n?P.default.Error:P.default.Ignore})}}return new _(a,g)}e.createExtHostQuickOpen=c}),define(he[242],fe([0,1,2,3,53,6,17,5,18,97,12,26,34,193]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function a(l){if(l)return typeof l.iconPath=="string"?p.URI.file(l.iconPath):p.URI.isUri(l.iconPath)||u.ThemeIcon.isThemeIcon(l.iconPath)?l.iconPath:void 0}function g(l,f){if(!l.iconPath&&!f.iconPath)return 0;if(l.iconPath){if(!f.iconPath)return 1}else return-1;const m=typeof l.iconPath=="string"?l.iconPath:p.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id,E=typeof f.iconPath=="string"?f.iconPath:p.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,A.comparePaths)(m,E)}function w(l,f){let m=0;if(l.strikeThrough!==f.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==f.faded)return l.faded?1:-1;if(l.tooltip!==f.tooltip)return(l.tooltip||"").localeCompare(f.tooltip||"");if(m=g(l,f),m!==0)return m;if(l.light&&f.light)m=g(l.light,f.light);else{if(l.light)return 1;if(f.light)return-1}if(m!==0)return m;if(l.dark&&f.dark)m=g(l.dark,f.dark);else{if(l.dark)return 1;if(f.dark)return-1}return m}function _(l,f){if(l.command!==f.command)return l.command<f.command?-1:1;if(l.title!==f.title)return l.title<f.title?-1:1;if(l.tooltip!==f.tooltip){if(l.tooltip!==void 0&&f.tooltip!==void 0)return l.tooltip<f.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(l.arguments===f.arguments)return 0;if(l.arguments)if(f.arguments){if(l.arguments.length!==f.arguments.length)return l.arguments.length-f.arguments.length}else return 1;else return-1;for(let m=0;m<l.arguments.length;m++){const E=l.arguments[m],S=f.arguments[m];if(E!==S)return E<S?-1:1}return 0}function b(l,f){let m=(0,A.comparePaths)(l.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(m!==0)return m;if(l.command&&f.command)m=_(l.command,f.command);else{if(l.command)return 1;if(f.command)return-1}if(m!==0)return m;if(l.decorations&&f.decorations)m=w(l.decorations,f.decorations);else{if(l.decorations)return 1;if(f.decorations)return-1}return m}function d(l,f){for(let m=0;m<l.length;m++)if(l[m]!==f[m])return!1;return!0}function h(l,f){return l.command===f.command&&l.title===f.title&&l.tooltip===f.tooltip&&(l.arguments&&f.arguments?d(l.arguments,f.arguments):l.arguments===f.arguments)}function v(l,f){return(0,D.equals)(l,f,h)}class t{constructor(f,m,E){this._extension=f,this._proxy=m,this._sourceControlHandle=E,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(f){this._proxy.$setInputBoxValue(this._sourceControlHandle,f),this.updateValue(f)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(f){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,f),this._placeholder=f}get validateInput(){return(0,c.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(f){if((0,c.checkProposedApiEnabled)(this._extension),f&&typeof f!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=f,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!f)}get visible(){return this._visible}set visible(f){f=!!f,this._visible!==f&&(this._visible=f,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,f))}focus(){(0,c.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(f,m){(0,c.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,f,m)}$onInputBoxValueChange(f){this.updateValue(f)}updateValue(f){this._value=f,this._onDidChange.fire(f)}}e.ExtHostSCMInputBox=t;class s{constructor(f,m,E,S,o){this._proxy=f,this._commands=m,this._sourceControlHandle=E,this._id=S,this._label=o,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=s._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(f){this._label=f,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,f)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(f){this._hideWhenEmpty=f,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(f){this._resourceStates=[...f],this._onDidUpdateResourceStates.fire()}getResourceState(f){return this._resourceStatesMap.get(f)}$executeResourceCommand(f,m){const E=this._resourceStatesCommandsMap.get(f);return E?(0,T.asPromise)(()=>this._commands.executeCommand(E.command,...E.arguments||[],m)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this._resourceStates].sort(b),E=(0,D.sortedDiff)(this._resourceSnapshot,f,b).map(k=>{const O=k.toInsert.map($=>{const G=this._resourceHandlePool++;this._resourceStatesMap.set(G,$);const re=$.resourceUri;let j;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const ae=new y.DisposableStore;j=this._commands.converter.toInternal($.command,ae),this._resourceStatesDisposablesMap.set(G,ae)}else this._resourceStatesCommandsMap.set(G,$.command);const N=a($.decorations),x=$.decorations&&a($.decorations.light)||N,R=$.decorations&&a($.decorations.dark)||N,V=[x,R],F=$.decorations&&$.decorations.tooltip||"",M=$.decorations&&!!$.decorations.strikeThrough,B=$.decorations&&!!$.decorations.faded,W=$.contextValue||"";return{rawResource:[G,re,V,F,M,B,W,j],handle:G}});return{start:k.start,deleteCount:k.deleteCount,toInsert:O}}),S=E.map(({start:k,deleteCount:O,toInsert:$})=>[k,O,$.map(G=>G.rawResource)]),o=E.reverse();for(const{start:k,deleteCount:O,toInsert:$}of o){const G=$.map(j=>j.handle),re=this._handlesSnapshot.splice(k,O,...G);for(const j of re)this._resourceStatesMap.delete(j),this._resourceStatesCommandsMap.delete(j),this._resourceStatesDisposablesMap.get(j)?.dispose(),this._resourceStatesDisposablesMap.delete(j)}return this._resourceSnapshot=f,S}dispose(){this._disposed=!0,this._onDidDispose.fire()}}s._handlePool=0;class r{constructor(f,m,E,S,o,k){this._proxy=m,this._commands=E,this._id=S,this._label=o,this._rootUri=k,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new y.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=r._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new t(f,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,S,o,k)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(f){this._count!==f&&(this._count=f,this._proxy.$updateSourceControl(this.handle,{count:f}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(f){this._quickDiffProvider=f,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!f})}get commitTemplate(){return this._commitTemplate}set commitTemplate(f){f!==this._commitTemplate&&(this._commitTemplate=f,this._proxy.$updateSourceControl(this.handle,{commitTemplate:f}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(f){this._acceptInputDisposables.value=new y.DisposableStore,this._acceptInputCommand=f;const m=this._commands.converter.toInternal(f,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:m})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(f){if(this._statusBarCommands&&f&&v(this._statusBarCommands,f))return;this._statusBarDisposables.value=new y.DisposableStore,this._statusBarCommands=f;const m=(f||[]).map(E=>this._commands.converter.toInternal(E,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:m})}get selected(){return this._selected}createResourceGroup(f,m){const E=new s(this._proxy,this._commands,this.handle,f,m),S=L.Event.once(E.onDidDispose)(()=>this.createdResourceGroups.delete(E));return this.createdResourceGroups.set(E,S),this.eventuallyAddResourceGroups(),E}eventuallyAddResourceGroups(){const f=[],m=[];for(const[E,S]of this.createdResourceGroups){S.dispose();const o=E.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(E),this.eventuallyUpdateResourceStates()});L.Event.once(E.onDidDispose)(()=>{this.updatedResourceGroups.delete(E),o.dispose(),this._groups.delete(E.handle),this._proxy.$unregisterGroup(this.handle,E.handle)}),f.push([E.handle,E.id,E.label,E.features]);const k=E._takeResourceStateSnapshot();k.length>0&&m.push([E.handle,k]),this._groups.set(E.handle,E)}this._proxy.$registerGroups(this.handle,f,m),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const f=[];this.updatedResourceGroups.forEach(m=>{const E=m._takeResourceStateSnapshot();E.length!==0&&f.push([m.handle,E])}),f.length>0&&this._proxy.$spliceResourceStates(this.handle,f),this.updatedResourceGroups.clear()}getResourceGroup(f){return this._groups.get(f)}setSelectionState(f){this._selected=f,this._onDidChangeSelection.fire(f)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(f=>f.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}r._handlePool=0,je([(0,C.debounce)(100)],r.prototype,"eventuallyAddResourceGroups",null),je([(0,C.debounce)(100)],r.prototype,"eventuallyUpdateResourceStates",null);let n=class Un{constructor(f,m,E){this._commands=m,this.logService=E,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=f.getProxy(I.MainContext.MainThreadSCM),this._telemetry=f.getProxy(I.MainContext.MainThreadTelemetry),m.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===3){const o=this._sourceControls.get(S.sourceControlHandle);if(!o)return S;const k=o.getResourceGroup(S.groupHandle);return k?k.getResourceState(S.handle):S}else if(S&&S.$mid===4){const o=this._sourceControls.get(S.sourceControlHandle);return o?o.getResourceGroup(S.groupHandle):S}else if(S&&S.$mid===5){const o=this._sourceControls.get(S.handle);return o||S}return S}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(f,m,E,S){this.logService.trace("ExtHostSCM#createSourceControl",f.identifier.value,m,E,S),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const o=Un._handlePool++,k=new r(f,this._proxy,this._commands,m,E,S);this._sourceControls.set(o,k);const O=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(f.identifier))||[];return O.push(k),this._sourceControlsByExtension.set(P.ExtensionIdentifier.toKey(f.identifier),O),k}getLastInputBox(f){this.logService.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const m=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(f.identifier)),E=m&&m[m.length-1];return E&&E.inputBox}$provideOriginalResource(f,m,E){const S=p.URI.revive(m);this.logService.trace("ExtHostSCM#$provideOriginalResource",f,S.toString());const o=this._sourceControls.get(f);return!o||!o.quickDiffProvider||!o.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>o.quickDiffProvider.provideOriginalResource(S,E)).then(k=>k||null)}$onInputBoxValueChange(f,m){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",f);const E=this._sourceControls.get(f);return E&&E.inputBox.$onInputBoxValueChange(m),Promise.resolve(void 0)}$executeResourceCommand(f,m,E,S){this.logService.trace("ExtHostSCM#$executeResourceCommand",f,m,E);const o=this._sourceControls.get(f);if(!o)return Promise.resolve(void 0);const k=o.getResourceGroup(m);return k?k.$executeResourceCommand(E,S):Promise.resolve(void 0)}$validateInput(f,m,E){this.logService.trace("ExtHostSCM#$validateInput",f);const S=this._sourceControls.get(f);return!S||!S.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>S.inputBox.validateInput(m,E)).then(o=>o?Promise.resolve([o.message,o.type]):Promise.resolve(void 0))}$setSelectedSourceControl(f){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this._sourceControls.get(f)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=f,Promise.resolve(void 0)}};n._handlePool=0,n=je([We(2,i.ILogService)],n),e.ExtHostSCM=n});var nt=this&&this.__classPrivateFieldSet||function(X,e,p,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!L:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(X):L?L.value:e.get(X)};define(he[243],fe([0,1,7,5,162,6,16]),function(X,e,p,L,C,y,T){"use strict";var I,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class A{constructor(u,a,g,w,_=p.StatusBarAlignment.Left,b){I.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new y.DisposableStore,nt(this,I,u,"f"),nt(this,D,a,"f"),this._entryId=A.ID_GEN++,this._extension=g,this._id=w,this._alignment=_,this._priority=b}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(u){this._text=u,this.update()}set name(u){this._name=u,this.update()}set tooltip(u){this._tooltip=u,this.update()}set color(u){this._color=u,this.update()}set backgroundColor(u){u&&!A.ALLOWED_BACKGROUND_COLORS.has(u.id)&&(u=void 0),this._backgroundColor=u,this.update()}set command(u){this._command?.fromApi!==u&&(this._internalCommandRegistration.clear(),typeof u=="string"?this._command={fromApi:u,internal:Ue(this,D,"f").toInternal({title:"",command:u},this._internalCommandRegistration)}:u?this._command={fromApi:u,internal:Ue(this,D,"f").toInternal(u,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(u){this._accessibilityInformation=u,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,I,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let u;this._extension?this._id?u=`${this._extension.identifier.value}.${this._id}`:u=this._extension.identifier.value:u=this._id;let a;this._name?a=this._name:a=(0,C.localize)(0,null,this._extension.displayName||this._extension.name);let g=this._color;this._backgroundColor&&(g=A.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const w=this._tooltip?T.MarkdownString.fromStrict(this._tooltip):void 0;Ue(this,I,"f").$setEntry(this._entryId,u,a,this._text,w,this._command?.internal,g,this._backgroundColor,this._alignment===p.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=A,I=new WeakMap,D=new WeakMap,A.ID_GEN=0,A.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new p.ThemeColor("statusBarItem.errorForeground")]]);class i{constructor(u){this._messages=[],this._item=u.createStatusBarEntry(void 0,"status.extensionMessage",p.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,C.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(u){const a={message:u};return this._messages.unshift(a),this._update(),new p.Disposable(()=>{const g=this._messages.indexOf(a);g>=0&&(this._messages.splice(g,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class P{constructor(u,a){this._proxy=u.getProxy(L.MainContext.MainThreadStatusBar),this._commands=a,this._statusMessage=new i(this)}createStatusBarEntry(u,a,g,w){return new A(this._proxy,this._commands,u,a,g,w)}setStatusBarMessage(u,a){const g=this._statusMessage.setMessage(u);let w;return typeof a=="number"?w=setTimeout(()=>g.dispose(),a):typeof a!="undefined"&&a.then(()=>g.dispose(),()=>g.dispose()),new p.Disposable(()=>{g.dispose(),clearTimeout(w)})}}e.ExtHostStatusBar=P}),define(he[90],fe([0,1,5,3,4]),function(X,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class y{constructor(I){this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=I.getProxy(p.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(I,D){this._proxy.$registerExtensionStorageKeysToSync(I,D)}getValue(I,D,A){return this._proxy.$getValue(I,D).then(i=>i||A)}setValue(I,D,A){return this._proxy.$setValue(I,D,A)}$acceptValue(I,D,A){this._onDidChangeStorage.fire({shared:I,key:D,value:A})}}e.ExtHostStorage=y,e.IExtHostStorage=(0,C.createDecorator)("IExtHostStorage")}),define(he[63],fe([0,1,4,27,12,89,2]),function(X,e,p,L,C,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,p.createDecorator)("IExtensionStoragePaths");let I=class{constructor(A,i,P){this._logService=i,this._extHostFileSystem=P,this._workspace=A.workspace??void 0,this._environment=A.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(c=>this._value=c)}async _getWorkspaceStorageURI(A){return T.URI.joinPath(this._environment.workspaceStorageHome,A)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const A=this._workspace.id,i=await this._getWorkspaceStorageURI(A);try{return await this._extHostFileSystem.value.stat(i),this._logService.trace("[ExtHostStorage] storage dir already exists",i),i}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",i),await this._extHostFileSystem.value.createDirectory(i),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(i,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),i}catch(P){this._logService.error("[ExtHostStorage]",P);return}}workspaceValue(A){if(this._value)return T.URI.joinPath(this._value,A.identifier.value)}globalValue(A){return T.URI.joinPath(this._environment.globalStorageHome,A.identifier.value.toLowerCase())}onWillDeactivateAll(){}};I=je([We(0,L.IExtHostInitDataService),We(1,C.ILogService),We(2,y.IExtHostConsumerFileSystem)],I),e.ExtensionStoragePaths=I}),define(he[33],fe([0,1,3,5,4,2,13,6,7,163,15,208,21,32,191,14]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,C.createDecorator)("IExtHostTerminalService");class w{constructor(r,n,l,f){this._proxy=r,this._id=n,this._creationOptions=l,this._name=f,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(E=>this._pidPromiseComplete=E);const m=this;this.value={get name(){return m._name||""},get processId(){return m._pidPromise},get creationOptions(){return m._creationOptions},get exitStatus(){return m._exitStatus},sendText(E,S=!0){m._checkDisposed(),m._proxy.$sendText(m._id,E,S)},show(E){m._checkDisposed(),m._proxy.$show(m._id,E)},hide(){m._checkDisposed(),m._proxy.$hide(m._id)},dispose(){m._disposed||(m._disposed=!0,m._proxy.$dispose(m._id))},get dimensions(){if(!(m._cols===void 0||m._rows===void 0))return{columns:m._cols,rows:m._rows}}}}async create(r,n){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:r.name,shellPath:(0,g.withNullAsUndefined)(r.shellPath),shellArgs:(0,g.withNullAsUndefined)(r.shellArgs),cwd:(0,g.withNullAsUndefined)(r.cwd),env:(0,g.withNullAsUndefined)(r.env),icon:(0,g.withNullAsUndefined)(t(r.iconPath)),initialText:(0,g.withNullAsUndefined)(r.message),strictEnv:(0,g.withNullAsUndefined)(r.strictEnv),hideFromUser:(0,g.withNullAsUndefined)(r.hideFromUser),isFeatureTerminal:(0,g.withNullAsUndefined)(n?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,g.withNullAsUndefined)(n?.useShellEnvironment),isSplitTerminal:n?.isSplitTerminal,target:n?.target})}async createExtensionTerminal(r,n,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:l,isSplitTerminal:r,target:n}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(r){this._name=r}setExitCode(r){this._exitStatus=Object.freeze({code:r})}setDimensions(r,n){return r===this._cols&&n===this._rows||r===0||n===0?!1:(this._cols=r,this._rows=n,!0)}_setProcessId(r){this._pidPromiseComplete?(this._pidPromiseComplete(r),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==r&&(this._pidPromise=Promise.resolve(r))})}}e.ExtHostTerminal=w;class _{constructor(r){this._pty=r,this.id=0,this.shouldPersist=!1,this._onProcessData=new p.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new p.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new p.Emitter,this._onProcessTitleChanged=new p.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new p.Emitter,this._onProcessShellTypeChanged=new p.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(r){this._pty.handleInput&&this._pty.handleInput(r)}resize(r,n){this._pty.setDimensions&&this._pty.setDimensions({columns:r,rows:n})}async processBinary(r){}acknowledgeDataEvent(r){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(r){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(n=>this._onProcessTitleChanged.fire(n)),this._pty.open(r||void 0),this._pty.setDimensions&&r&&this._pty.setDimensions(r),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=_;let b=1,d=class extends I.Disposable{constructor(r,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new p.Emitter,this._onDidOpenTerminal=new p.Emitter,this._onDidChangeActiveTerminal=new p.Emitter,this._onDidChangeTerminalDimensions=new p.Emitter,this._proxy=n.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new a.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new p.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(r),this._register({dispose:()=>{for(const[l,f]of this._terminalProcesses)f.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(r=>r.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(r){return(r?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(r){return(r?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(r,n){const l=new w(this._proxy,(0,u.generateUuid)(),r,r.name),f=new _(r.pty);return l.createExtensionTerminal(n?.isSplitTerminal,n?.target,t(r.iconPath)).then(m=>{const E=this._setupExtHostProcessListeners(m,f);this._terminalProcessDisposables[m]=E}),this._terminals.push(l),l.value}attachPtyToTerminal(r,n){if(!this._getTerminalById(r))throw new Error(`Cannot resolve terminal with id ${r} for virtual process`);const f=new _(n),m=this._setupExtHostProcessListeners(r,f);this._terminalProcessDisposables[r]=m}async $acceptActiveTerminalChanged(r){const n=this._activeTerminal;if(r===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const l=this._getTerminalById(r);l&&(this._activeTerminal=l,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(r,n){const l=this._getTerminalById(r);l&&this._onDidWriteTerminalData.fire({terminal:l.value,data:n})}async $acceptTerminalDimensions(r,n,l){const f=this._getTerminalById(r);f&&f.setDimensions(n,l)&&this._onDidChangeTerminalDimensions.fire({terminal:f.value,dimensions:f.value.dimensions})}async $acceptTerminalMaximumDimensions(r,n,l){this._terminalProcesses.get(r)?.resize(n,l)}async $acceptTerminalTitleChange(r,n){const l=this._getTerminalById(r);l&&(l.name=n)}async $acceptTerminalClosed(r,n){const l=this._getTerminalObjectIndexById(this._terminals,r);if(l!==null){const f=this._terminals.splice(l,1)[0];f.setExitCode(n),this._onDidCloseTerminal.fire(f.value)}}$acceptTerminalOpened(r,n,l,f){if(n){const S=this._getTerminalObjectIndexById(this._terminals,n);if(S!==null){this._terminals[S]._id=r,this._onDidOpenTerminal.fire(this.terminals[S]),this._terminals[S].isOpen=!0;return}}const m={name:f.name,shellPath:f.executable,shellArgs:f.args,cwd:typeof f.cwd=="string"?f.cwd:y.URI.revive(f.cwd),env:f.env,hideFromUser:f.hideFromUser},E=new w(this._proxy,r,m,l);this._terminals.push(E),this._onDidOpenTerminal.fire(E.value),E.isOpen=!0}async $acceptTerminalProcessId(r,n){const l=this._getTerminalById(r);l&&l._setProcessId(n)}async $startExtensionTerminal(r,n){const l=this._getTerminalById(r);if(!l)return{message:(0,A.localize)(0,null,r)};l.isOpen||await new Promise(m=>{const E=this.onDidOpenTerminal(async S=>{S===l.value&&(E.dispose(),m())})});const f=this._terminalProcesses.get(r);f?f.startSendingEvents(n):this._extensionTerminalAwaitingStart[r]={initialDimensions:n}}_setupExtHostProcessListeners(r,n){const l=new I.DisposableStore;l.add(n.onProcessReady(m=>this._proxy.$sendProcessReady(r,m.pid,m.cwd))),l.add(n.onProcessTitleChanged(m=>this._proxy.$sendProcessTitle(r,m))),this._bufferer.startBuffering(r,n.onProcessData),l.add(n.onProcessExit(m=>this._onProcessExit(r,m))),n.onProcessOverrideDimensions&&l.add(n.onProcessOverrideDimensions(m=>this._proxy.$sendOverrideDimensions(r,m))),this._terminalProcesses.set(r,n);const f=this._extensionTerminalAwaitingStart[r];return f&&n instanceof _&&(n.startSendingEvents(f.initialDimensions),delete this._extensionTerminalAwaitingStart[r]),l}$acceptProcessAckDataEvent(r,n){this._terminalProcesses.get(r)?.acknowledgeDataEvent(n)}$acceptProcessInput(r,n){this._terminalProcesses.get(r)?.input(n)}$acceptProcessResize(r,n,l){try{this._terminalProcesses.get(r)?.resize(n,l)}catch(f){if(f.code!=="EPIPE"&&f.code!=="ERR_IPC_CHANNEL_CLOSED")throw f}}$acceptProcessShutdown(r,n){this._terminalProcesses.get(r)?.shutdown(n)}$acceptProcessRequestInitialCwd(r){this._terminalProcesses.get(r)?.getInitialCwd().then(n=>this._proxy.$sendProcessInitialCwd(r,n))}$acceptProcessRequestCwd(r){this._terminalProcesses.get(r)?.getCwd().then(n=>this._proxy.$sendProcessCwd(r,n))}$acceptProcessRequestLatency(r){return r}registerLinkProvider(r){return this._linkProviders.add(r),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(r),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(r,n,l){if(this._profileProviders.has(n))throw new Error(`Terminal profile provider "${n}" already registered`);return this._profileProviders.set(n,l),this._proxy.$registerProfileProvider(n,r.identifier.value),new D.Disposable(()=>{this._profileProviders.delete(n),this._proxy.$unregisterProfileProvider(n)})}async $createContributedProfileTerminal(r,n){const l=new c.CancellationTokenSource().token,f=await this._profileProviders.get(r)?.provideTerminalProfile(l);if(!l.isCancellationRequested){if(!f||!("options"in f))throw new Error(`No terminal profile options provided for id "${r}"`);if("pty"in f.options){this.createExtensionTerminal(f.options,n);return}this.createTerminalFromOptions(f.options,n)}}async $provideLinks(r,n){const l=this._getTerminalById(r);if(!l)return[];this._terminalLinkCache.delete(r);const f=this._terminalLinkCancellationSource.get(r);f&&f.dispose(!0);const m=new c.CancellationTokenSource;this._terminalLinkCancellationSource.set(r,m);const E=[],S={terminal:l.value,line:n},o=[];for(const $ of this._linkProviders)o.push(new Promise(async G=>{m.token.onCancellationRequested(()=>G({provider:$,links:[]}));const re=await $.provideTerminalLinks(S,m.token)||[];m.token.isCancellationRequested||G({provider:$,links:re})}));const k=await Promise.all(o);if(m.token.isCancellationRequested)return[];const O=new Map;for(const $ of k)$&&$.links.length>0&&E.push(...$.links.map(G=>{const re={id:b++,startIndex:G.startIndex,length:G.length,label:G.tooltip};return O.set(re.id,{provider:$.provider,link:G}),re}));return this._terminalLinkCache.set(r,O),E}$activateLink(r,n){const l=this._terminalLinkCache.get(r)?.get(n);!l||l.provider.handleTerminalLink(l.link)}_onProcessExit(r,n){this._bufferer.stopBuffering(r),this._terminalProcesses.delete(r),delete this._extensionTerminalAwaitingStart[r];const l=this._terminalProcessDisposables[r];l&&(l.dispose(),delete this._terminalProcessDisposables[r]),this._proxy.$sendProcessExit(r,n)}_getTerminalById(r){return this._getTerminalObjectById(this._terminals,r)}_getTerminalObjectById(r,n){const l=this._getTerminalObjectIndexById(r,n);return l!==null?r[l]:null}_getTerminalObjectIndexById(r,n){let l=null;return r.some((f,m)=>f._id===n?(l=m,!0):!1),l}getEnvironmentVariableCollection(r){let n=this._environmentVariableCollections.get(r.identifier.value);return n||(n=new h,this._setEnvironmentVariableCollection(r.identifier.value,n)),n}_syncEnvironmentVariableCollection(r,n){const l=(0,P.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(r,n.persistent,l.length===0?void 0:l)}$initEnvironmentVariableCollections(r){r.forEach(n=>{const l=n[0],f=new h(n[1]);this._setEnvironmentVariableCollection(l,f)})}$acceptDefaultProfile(r,n){this._defaultProfile=r,this._defaultAutomationProfile=n}_setEnvironmentVariableCollection(r,n){this._environmentVariableCollections.set(r,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(r,n)})}};d=je([We(1,T.IExtHostRpcService)],d),e.BaseExtHostTerminalService=d;class h{constructor(r){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new p.Emitter,this.map=new Map(r)}get persistent(){return this._persistent}set persistent(r){this._persistent=r,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(r,n){this._setIfDiffers(r,{value:n,type:D.EnvironmentVariableMutatorType.Replace})}append(r,n){this._setIfDiffers(r,{value:n,type:D.EnvironmentVariableMutatorType.Append})}prepend(r,n){this._setIfDiffers(r,{value:n,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(r,n){const l=this.map.get(r);(!l||l.value!==n.value||l.type!==n.type)&&(this.map.set(r,n),this._onDidChangeCollection.fire())}get(r){return this.map.get(r)}forEach(r,n){this.map.forEach((l,f)=>r.call(n,f,l,this))}delete(r){this.map.delete(r),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=h;let v=class extends d{constructor(r){super(!1,r)}createTerminal(r,n,l){throw new i.NotSupportedError}createTerminalFromOptions(r,n){throw new i.NotSupportedError}};v=je([We(0,T.IExtHostRpcService)],v),e.WorkerExtHostTerminalService=v;function t(s){if(!(!s||typeof s=="string"))return"id"in s?{id:s.id,color:s.color}:s}});var nt=this&&this.__classPrivateFieldSet||function(X,e,p,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!L:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(X):L?L.value:e.get(X)};define(he[244],fe([0,1,17,22,21,3,70,55,72,6,25,14,32,5,13,85,16,7,216,123]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u,a,g,w,_,b,d){"use strict";var h,v,t,s,r,n,l;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunConfigurationImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let f=class{constructor(R,V){this.resultsChangedEmitter=new y.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(u.MainContext.MainThreadTesting),this.observer=new re(this.proxy),this.runTracker=new E(this.proxy),V.registerArgumentProcessor({processArgument:F=>F?.$mid===13?w.TestItem.toItemFromContext(F):F})}createTestController(R,V){const F=new A.DisposableStore,M=F.add(new b.SingleUseTestCollection(R)),B=F.add(new p.RunOnceScheduler(()=>M.expand(M.root.id,0),0)),W=new Map,Q=this.proxy,ae={items:M.root.children,get label(){return V},set label(Fe){V=Fe,M.root.label=Fe,Q.$updateControllerLabel(R,V)},get id(){return R},createRunConfiguration:(Fe,Ae,Me,Ve)=>{let He=(0,I.hash)(Fe);for(;W.has(He);)He++;const z=new j(this.proxy,R,He,Fe,Ae,Me,Ve);return W.set(He,z),z},createTestRun:(Fe,Ae,Me=!0)=>this.runTracker.createTestRun(R,M,Fe,Ae,Me),set resolveChildrenHandler(Fe){M.resolveHandler=Fe,Fe&&B.schedule()},get resolveChildrenHandler(){return M.resolveHandler},dispose:()=>{F.dispose()}};ae.createTestITem=this.createTestItem.bind(this),Q.$registerTestController(R,V),F.add((0,A.toDisposable)(()=>Q.$unregisterTestController(R)));const _e={controller:ae,collection:M,configurations:W};return this.controllers.set(R,_e),F.add((0,A.toDisposable)(()=>this.controllers.delete(R))),F.add(M.onDidGenerateDiff(Fe=>Q.$publishDiff(R,Fe))),ae}createTestItem(R,V,F){return new g.TestItemImpl(R,V,F)}createTestObserver(){return this.observer.checkout()}async runTests(R,V=C.CancellationToken.None){const F=S(R);if(!F)throw new Error("The request passed to `vscode.test.runTests` must include a configuration");const M=this.controllers.get(F.controllerId);if(!M)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:R.include?.map(B=>B.id)??[M.collection.root.id],profileGroup:N[F.group],profileId:F.configId,controllerId:F.controllerId}],exclude:R.exclude?.map(B=>({testId:B.id,controllerId:F.controllerId}))},V)}$provideFileCoverage(R,V,F){return D.Iterable.find(this.runTracker.trackers,M=>M.id===R)?.getCoverage(V)?.provideFileCoverage(F)??Promise.resolve([])}$resolveFileCoverage(R,V,F,M){return D.Iterable.find(this.runTracker.trackers,B=>B.id===R)?.getCoverage(V)?.resolveFileCoverage(F,M)??Promise.resolve([])}$configureRunConfig(R,V){this.controllers.get(R)?.configurations.get(V)?.configureHandler?.()}$publishTestResults(R){this.results=Object.freeze(R.map(V=>(0,i.deepFreeze)(w.TestResults.to(V))).concat(this.results).sort((V,F)=>F.completedAt-V.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest({controllerId:R,testId:V},F){const M=this.controllers.get(R)?.collection;M&&(await M.expand(V,F<0?Infinity:F),M.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R)}async $runControllerTests(R,V){const F=this.controllers.get(R.controllerId);if(!F)return;const{collection:M,configurations:B}=F,W=B.get(R.configId);if(!W)return;const Q=R.testIds.map(Ae=>M.tree.get(Ae)).filter(P.isDefined),ae=R.excludeExtIds.map(Ae=>F.collection.tree.get(Ae)).filter(P.isDefined).filter(Ae=>Q.some(Me=>M.tree.comparePositions(Me,Ae)===1));if(!Q.length)return;const _e=new _.TestRunRequest(Q.map(Ae=>Ae.actual),ae.map(Ae=>Ae.actual),W),Fe=this.runTracker.prepareForMainThreadTestRun(_e,o.fromInternal(R,F.collection),V);try{await W.runHandler(_e,V)}finally{Fe.isRunning&&!V.isCancellationRequested&&await y.Event.toPromise(Fe.onEnd),this.runTracker.cancelRunById(R.runId)}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};f=je([We(0,a.IExtHostRpcService)],f),e.ExtHostTesting=f;class m extends A.Disposable{constructor(R,V,F){super();this.dto=R,this.proxy=V,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new y.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new C.CancellationTokenSource(F)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:M}of this.tasks.values())M.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const V=(0,c.generateUuid)(),F=new k(this.proxy,this.dto.id,V),M=new O(R,this.cts.token,V,F,this.dto,this.sharedTestIds,this.proxy,()=>{this.tasks.delete(M.taskId),this.isRunning||this.dispose()});return this.tasks.set(M.taskId,{run:M,coverage:F}),M}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}}class E{constructor(R){this.proxy=R,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(R,V,F){return this.getTracker(R,V,F)}cancelRunById(R){for(const V of this.tracked.values())if(V.id===R){V.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,V,F,M,B){const W=this.tracked.get(F);if(W)return W.createRun(M);const Q=o.fromPublic(R,V,F),ae=S(F);this.proxy.$startedExtensionTestRun({controllerId:R,config:ae&&{group:N[ae.group],id:ae.configId},exclude:F.exclude?.map(Fe=>Fe.id)??[],id:Q.id,include:F.include?.map(Fe=>Fe.id)??[V.root.id],persist:B});const _e=this.getTracker(F,Q);return _e.onEnd(()=>this.proxy.$finishedExtensionTestRun(Q.id)),_e.createRun(M)}getTracker(R,V,F){const M=new m(V,this.proxy,F);return this.tracked.set(R,M),M.onEnd(()=>this.tracked.delete(R)),M}}e.TestRunCoordinator=E;const S=x=>{if(!!x.configuration){if(!(x.configuration instanceof j))throw new Error("TestRunRequest.configuration is not an instance created from TestController.createRunConfiguration");return x.configuration}};class o{constructor(R,V,F,M,B){this.controllerId=R,this.id=V,this.include=F,this.exclude=M,this.colllection=B}static fromPublic(R,V,F){return new o(R,(0,c.generateUuid)(),F.include&&new Set(F.include.map(M=>M.id)),new Set(F.exclude?.map(M=>M.id)??D.Iterable.empty()),V)}static fromInternal(R,V){return new o(R.controllerId,R.runId,R.testIds.includes(V.root.id)?void 0:new Set(R.testIds),new Set(R.excludeExtIds),V)}isIncluded(R){for(let V=R;V;V=V.parent){if(this.include?.has(V.id))return!0;if(this.exclude.has(V.id))return!1}return this.include===void 0}}e.TestRunDto=o;class k{constructor(R,V,F){this.proxy=R,this.runId=V,this.taskId=F}set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(w.TestCoverage.fromFile)??[]}catch(V){throw this.fileCoverage=void 0,V}}async resolveFileCoverage(R,V){const F=await this.fileCoverage;let M=F?.[R];return!this._coverageProvider||!F||!M?[]:(M.detailedCoverage||(M=F[R]=await this._coverageProvider.resolveFileCoverage?.(M,V)??M),M.detailedCoverage?.map(w.TestCoverage.fromDetailed)??[])}}class O{constructor(R,V,F,M,B,W,Q,ae){this.name=R,this.token=V,this.taskId=F,h.set(this,void 0),v.set(this,void 0),t.set(this,void 0),s.set(this,void 0),r.set(this,void 0),n.set(this,!1),nt(this,s,ae,"f"),nt(this,h,Q,"f"),nt(this,v,B,"f"),nt(this,r,M,"f"),nt(this,t,W,"f"),Q.$startedTestRunTask(B.id,{id:this.taskId,name:R,running:!0})}set coverageProvider(R){Ue(this,r,"f").coverageProvider=R}get coverageProvider(){return Ue(this,r,"f").coverageProvider}setState(R,V,F){!Ue(this,n,"f")&&Ue(this,v,"f").isIncluded(R)&&(this.ensureTestIsKnown(R),Ue(this,h,"f").$updateTestStateInRun(Ue(this,v,"f").id,this.taskId,R.id,V,F))}appendMessage(R,V){!Ue(this,n,"f")&&Ue(this,v,"f").isIncluded(R)&&(this.ensureTestIsKnown(R),Ue(this,h,"f").$appendTestMessageInRun(Ue(this,v,"f").id,this.taskId,R.id,w.TestMessage.from(V)))}appendOutput(R){Ue(this,n,"f")||Ue(this,h,"f").$appendOutputToRun(Ue(this,v,"f").id,this.taskId,L.VSBuffer.fromString(R))}end(){Ue(this,n,"f")||(nt(this,n,!0,"f"),Ue(this,h,"f").$finishedTestRunTask(Ue(this,v,"f").id,this.taskId),Ue(this,s,"f").call(this))}ensureTestIsKnown(R){const V=Ue(this,t,"f");if(V.has(R.id))return;const F=[];for(;F.unshift(w.TestItem.from(R)),!(V.has(R.id)||(V.add(R.id),!R.parent));)R=R.parent;const M=Ue(this,v,"f").colllection.root;V.has(M.id)||(V.add(M.id),F.unshift(w.TestItem.from(M))),Ue(this,h,"f").$addTestsToRun(Ue(this,v,"f").controllerId,Ue(this,v,"f").id,F)}}h=new WeakMap,v=new WeakMap,t=new WeakMap,s=new WeakMap,r=new WeakMap,n=new WeakMap;class $ extends d.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,w.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:V,removed:F}=this;return{get added(){return[...R].map(M=>M.revived)},get updated(){return[...V].map(M=>M.revived)},get removed(){return[...F].map(M=>M.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class G extends d.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new y.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,V){return{...R,revived:w.TestItem.toPlain(R.item),depth:V?V.depth+1:0,children:new Set}}createChangeCollector(){return new $(this.changeEmitter)}}e.MirroredTestCollection=G;class re{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(V=>V.revived)},dispose:(0,T.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new G;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class j{constructor(R,V,F,M,B,W,Q=!1){this.controllerId=V,this.configId=F,this._label=M,this.group=B,this.runHandler=W,this._isDefault=Q,l.set(this,void 0),nt(this,l,R,"f");const ae=N[B];if(typeof ae!="number")throw new Error(`Unknown TestRunConfiguration.group ${B}`);Ue(this,l,"f").$publishTestRunConfig({profileId:F,controllerId:V,label:M,group:ae,isDefault:Q,hasConfigurationHandler:!1})}get label(){return this._label}set label(R){R!==this._label&&(this._label=R,Ue(this,l,"f").$updateTestRunConfig(this.controllerId,this.configId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,Ue(this,l,"f").$updateTestRunConfig(this.controllerId,this.configId,{isDefault:R}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,Ue(this,l,"f").$updateTestRunConfig(this.controllerId,this.configId,{hasConfigurationHandler:!!R}))}dispose(){Ue(this,l,"f").$removeTestRunConfig(this.controllerId,this.configId)}}e.TestRunConfigurationImpl=j,l=new WeakMap;const N={[_.TestRunConfigurationGroup.Coverage]:8,[_.TestRunConfigurationGroup.Debug]:4,[_.TestRunConfigurationGroup.Run]:2}}),define(he[245],fe([0,1,3,18,5,126,16,7]),function(X,e,p,L,C,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(i,P){this._extHostDocumentsAndEditors=P,this._onDidChangeTextEditorSelection=new p.Emitter,this._onDidChangeTextEditorOptions=new p.Emitter,this._onDidChangeTextEditorVisibleRanges=new p.Emitter,this._onDidChangeTextEditorViewColumn=new p.Emitter,this._onDidChangeActiveTextEditor=new p.Emitter,this._onDidChangeVisibleTextEditors=new p.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(C.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(c=>this._onDidChangeVisibleTextEditors.fire(c)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(c=>this._onDidChangeActiveTextEditor.fire(c))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const P=this._extHostDocumentsAndEditors.allEditors();return i?P:P.map(c=>c.value)}async showTextDocument(i,P,c){let u;typeof P=="number"?u={position:T.ViewColumn.from(P),preserveFocus:c}:typeof P=="object"?u={position:T.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?T.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:u={preserveFocus:!1};const a=await this._proxy.$tryShowTextDocument(i.uri,u),g=a&&this._extHostDocumentsAndEditors.getEditor(a);if(g)return g.value;throw a?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i,P){return new y.TextEditorDecorationType(this._proxy,i,P).value}$acceptEditorPropertiesChanged(i,P){const c=this._extHostDocumentsAndEditors.getEditor(i);if(!c)throw new Error("unknown text editor");if(P.options&&c._acceptOptions(P.options),P.selections){const u=P.selections.selections.map(T.Selection.to);c._acceptSelections(u)}if(P.visibleRanges){const u=L.coalesce(P.visibleRanges.map(T.Range.to));c._acceptVisibleRanges(u)}if(P.options&&this._onDidChangeTextEditorOptions.fire({textEditor:c.value,options:{...P.options,lineNumbers:T.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const u=I.TextEditorSelectionChangeKind.fromValue(P.selections.source),a=P.selections.selections.map(T.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:c.value,selections:a,kind:u})}if(P.visibleRanges){const u=L.coalesce(P.visibleRanges.map(T.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:c.value,visibleRanges:u})}}$acceptEditorPositionData(i){for(const P in i){const c=this._extHostDocumentsAndEditors.getEditor(P);if(!c)throw new Error("Unknown text editor");const u=T.ViewColumn.to(i[P]);c.value.viewColumn!==u&&(c._acceptViewColumn(u),this._onDidChangeTextEditorViewColumn.fire({textEditor:c.value,viewColumn:u}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=D}),define(he[246],fe([0,1,2,4,5,6,7]),function(X,e,p,L,C,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class I{constructor(i,P){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(C.MainContext.MainThreadTimeline),P.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===11){const u=c.uri===void 0?void 0:p.URI.revive(c.uri);return this._itemsBySourceAndUriMap.get(c.source)?.get(D(u))?.get(c.handle)}return c}})}async $getTimeline(i,P,c,u,a){return this._providers.get(i)?.provideTimeline(p.URI.revive(P),c,u,a)}registerTimelineProvider(i,P,c,u){const a=new y.DisposableStore,g=this.convertTimelineItem(P.id,u,a).bind(this);let w;P.onDidChange&&(w=P.onDidChange(b=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:P.id}),this));const _=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...P,scheme:i,onDidChange:void 0,async provideTimeline(b,d,h,v){v?.resetCache&&(a.clear(),_.get(P.id)?.clear());const t=await P.provideTimeline(b,d,h);if(t==null)return;const s=g(b,v);return{...t,source:P.id,items:t.items.map(s)}},dispose(){for(const b of _.values())b.get(P.id)?.clear();w?.dispose(),a.dispose()}})}convertTimelineItem(i,P,c){return(u,a)=>{let g;if(a?.cacheResults){let w=this._itemsBySourceAndUriMap.get(i);w===void 0&&(w=new Map,this._itemsBySourceAndUriMap.set(i,w));const _=D(u);g=w.get(_),g===void 0&&(g=new Map,w.set(_,g))}return w=>{const{iconPath:_,...b}=w,d=`${i}|${w.id??w.timestamp}`;g?.set(d,w);let h,v,t;return w.iconPath&&(_ instanceof T.ThemeIcon?t={id:_.id,color:_.color}:p.URI.isUri(_)?(h=_,v=_):{light:h,dark:v}=_),{...b,id:b.id??void 0,handle:d,source:i,command:w.command?P.toInternal(w.command,c):void 0,icon:h,iconDark:v,themeIcon:t,accessibilityInformation:w.accessibilityInformation}}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,y.toDisposable)(()=>{for(const c of this._itemsBySourceAndUriMap.values())c.get(i.id)?.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=I;function D(A){return A?.toString()}}),define(he[247],fe([0,1,6,10,2,5]),function(X,e,p,L,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{constructor(D){this._openers=new Map,this._proxy=D.getProxy(y.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,A,i,P){if(this._openers.has(A))throw new Error(`Opener with id '${A}' already registered`);const c=P.schemes.find(u=>!T.supportedSchemes.has(u));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this._openers.set(A,i),this._proxy.$registerUriOpener(A,P.schemes,D,P.label),(0,p.toDisposable)(()=>{this._openers.delete(A),this._proxy.$unregisterUriOpener(A)})}async $canOpenUri(D,A,i){const P=this._openers.get(D);if(!P)throw new Error(`Unknown opener with id: ${D}`);const c=C.URI.revive(A);return P.canOpenExternalUri(c,i)}async $openUri(D,A,i){const P=this._openers.get(D);if(!P)throw new Error(`Unknown opener id: '${D}'`);return P.openExternalUri(C.URI.revive(A.resolvedUri),{sourceUri:C.URI.revive(A.sourceUri)},i)}}e.ExtHostUriOpeners=T,T.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}),define(he[248],fe([0,1,5,2,6,15,26]),function(X,e,p,L,C,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class I{constructor(A){this.handles=new Set,this.handlers=new Map,this._proxy=A.getProxy(p.MainContext.MainThreadUrls)}registerUriHandler(A,i){if(this.handles.has(T.ExtensionIdentifier.toKey(A)))throw new Error(`Protocol handler already registered for extension ${A}`);const P=I.HandlePool++;return this.handles.add(T.ExtensionIdentifier.toKey(A)),this.handlers.set(P,i),this._proxy.$registerUriHandler(P,A),(0,C.toDisposable)(()=>{this.handles.delete(T.ExtensionIdentifier.toKey(A)),this.handlers.delete(P),this._proxy.$unregisterUriHandler(P)})}$handleExternalUri(A,i){const P=this.handlers.get(A);if(!P)return Promise.resolve(void 0);try{P.handleUri(L.URI.revive(i))}catch(c){(0,y.onUnexpectedError)(c)}return Promise.resolve(void 0)}async createAppUri(A){return L.URI.revive(await this._proxy.$createAppUri(A))}}e.ExtHostUrls=I,I.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(X,e,p,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!L:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(X):L?L.value:e.get(X)};define(he[64],fe([0,1,3,2,174,201,86,5]),function(X,e,p,L,C,y,T,I){"use strict";var D,A,i,P,c,u,a,g,w,_,b,d;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class h{constructor(m,E,S,o,k,O,$){D.set(this,void 0),A.set(this,void 0),i.set(this,void 0),P.set(this,void 0),c.set(this,void 0),u.set(this,void 0),a.set(this,""),g.set(this,void 0),w.set(this,!1),_.set(this,!1),b.set(this,!1),this._onMessageEmitter=new p.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,d.set(this,new p.Emitter),this._onDidDispose=Ue(this,d,"f").event,nt(this,D,m,"f"),nt(this,A,E,"f"),nt(this,g,S,"f"),nt(this,P,o,"f"),nt(this,c,k,"f"),nt(this,u,O,"f"),nt(this,b,v(O),"f"),nt(this,i,$,"f")}dispose(){nt(this,w,!0,"f"),Ue(this,d,"f").fire(),Ue(this,d,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return nt(this,_,!0,"f"),(0,T.asWebviewUri)(m,Ue(this,P,"f").remote)}get cspSource(){return T.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ue(this,a,"f")}set html(m){this.assertNotDisposed(),Ue(this,a,"f")!==m&&(nt(this,a,m,"f"),!Ue(this,_,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(nt(this,_,!0,"f"),Ue(this,i,"f").report("Webview vscode-resource: uris",Ue(this,u,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,A,"f").$setHtml(Ue(this,D,"f"),m))}get options(){return this.assertNotDisposed(),Ue(this,g,"f")}set options(m){this.assertNotDisposed(),Ue(this,A,"f").$setOptions(Ue(this,D,"f"),r(Ue(this,u,"f"),Ue(this,c,"f"),m)),nt(this,g,m,"f")}async postMessage(m){if(Ue(this,w,"f"))return!1;const E=(0,y.serializeWebviewMessage)(m,{serializeBuffersForPostMessage:Ue(this,b,"f")});return Ue(this,A,"f").$postMessage(Ue(this,D,"f"),E.message,...E.buffers)}assertNotDisposed(){if(Ue(this,w,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=h,D=new WeakMap,A=new WeakMap,i=new WeakMap,P=new WeakMap,c=new WeakMap,u=new WeakMap,a=new WeakMap,g=new WeakMap,w=new WeakMap,_=new WeakMap,b=new WeakMap,d=new WeakMap;function v(f){try{const m=(0,C.normalizeVersion)((0,C.parseVersion)(f.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=v;class t{constructor(m,E,S,o,k){this.initData=E,this.workspace=S,this._logService=o,this._deprecationService=k,this._webviews=new Map,this._webviewProxy=m.getProxy(I.MainContext.MainThreadWebviews)}$onMessage(m,E,...S){const o=this.getWebview(m);if(o){const{message:k}=(0,y.deserializeWebviewMessage)(E,S);o._onMessageEmitter.fire(k)}}$onMissingCsp(m,E){this._logService.warn(`${E} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,E,S){const o=new h(m,this._webviewProxy,n(E),this.initData,this.workspace,S,this._deprecationService);return this._webviews.set(m,o),o._onDidDispose(()=>{this._webviews.delete(m)}),o}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=t;function s(f){return{id:f.identifier,location:f.extensionLocation}}e.toExtensionData=s;function r(f,m,E){return{enableCommandUris:E.enableCommandUris,enableScripts:E.enableScripts,portMapping:E.portMapping,localResourceRoots:E.localResourceRoots||l(f,m)}}e.serializeWebviewOptions=r;function n(f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots?.map(m=>L.URI.from(m))}}e.reviveOptions=n;function l(f,m){return[...(m?.getWorkspaceFolders()||[]).map(E=>E.uri),f.extensionLocation]}}),define(he[249],fe([0,1,21,55,6,10,24,2,16,64,84,5,7]),function(X,e,p,L,C,y,T,I,D,A,i,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class u{constructor(t,s){this.document=t,this._storagePath=s,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,s){await this.getEdit(t).undo(),s||this.disposeBackup()}async redo(t,s){await this.getEdit(t).redo(),s||this.disposeBackup()}disposeEdits(t){for(const s of t)this._edits.delete(s)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=h(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const s=this._edits.get(t,0);if(!s)throw new Error("No edit found");return s}}class a{constructor(){this._documents=new Map}get(t,s){return this._documents.get(this.key(t,s))}add(t,s,r){const n=this.key(t,s.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${t} resource:${s.uri}`);const l=new u(s,r);return this._documents.set(n,l),l}delete(t,s){const r=this.key(t,s.uri);this._documents.delete(r)}key(t,s){return`${t}@@@${s}`}}var g;(function(v){v[v.Text=0]="Text",v[v.Custom=1]="Custom"})(g||(g={}));class w{constructor(){this._providers=new Map}addTextProvider(t,s,r){return this.add(0,t,s,r)}addCustomProvider(t,s,r){return this.add(1,t,s,r)}get(t){return this._providers.get(t)}add(t,s,r,n){if(this._providers.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this._providers.set(s,{type:t,extension:r,provider:n}),new c.Disposable(()=>this._providers.delete(s))}}class _{constructor(t,s,r,n,l){this._extHostDocuments=s,this._extensionStoragePaths=r,this._extHostWebview=n,this._extHostWebviewPanels=l,this._editorProviders=new w,this._documents=new a,this._proxy=t.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,s,r,n){const l=new C.DisposableStore;return b(r)?(l.add(this._editorProviders.addTextProvider(s,t,r)),this._proxy.$registerTextEditorProvider((0,A.toExtensionData)(t),s,n.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,A.shouldSerializeBuffersForPostMessage)(t))):(l.add(this._editorProviders.addCustomProvider(s,t,r)),this.supportEditing(r)&&l.add(r.onDidChangeCustomDocument(f=>{const m=this.getCustomDocumentEntry(s,f.document.uri);if(d(f)){const E=m.addEdit(f);this._proxy.$onDidEdit(f.document.uri,s,E,f.label)}else this._proxy.$onContentChange(f.document.uri,s)})),this._proxy.$registerCustomEditorProvider((0,A.toExtensionData)(t),s,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,(0,A.shouldSerializeBuffersForPostMessage)(t))),c.Disposable.from(l,new c.Disposable(()=>{this._proxy.$unregisterEditorProvider(s)}))}async $createCustomDocument(t,s,r,n,l){const f=this._editorProviders.get(s);if(!f)throw new Error(`No provider found for '${s}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${s}'`);const m=I.URI.revive(t),E=await f.provider.openCustomDocument(m,{backupId:r,untitledDocumentData:n?.buffer},l);let S;return this.supportEditing(f.provider)&&this._extensionStoragePaths&&(S=this._extensionStoragePaths.workspaceValue(f.extension)??this._extensionStoragePaths.globalValue(f.extension)),this._documents.add(s,E,S),{editable:this.supportEditing(f.provider)}}async $disposeCustomDocument(t,s){const r=this._editorProviders.get(s);if(!r)throw new Error(`No provider found for '${s}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${s}'`);const n=I.URI.revive(t),{document:l}=this.getCustomDocumentEntry(s,n);this._documents.delete(s,l),l.dispose()}async $resolveWebviewEditor(t,s,r,n,l,f){const m=this._editorProviders.get(r);if(!m)throw new Error(`No provider found for '${r}'`);const E=D.ViewColumn.to(l),S=this._extHostWebview.createNewWebview(s,n.webviewOptions,m.extension),o=this._extHostWebviewPanels.createNewWebviewPanel(s,r,n.title,E,n.panelOptions,S),k=I.URI.revive(t);switch(m.type){case 1:{const{document:O}=this.getCustomDocumentEntry(r,k);return m.provider.resolveCustomEditor(O,o,f)}case 0:{const O=this._extHostDocuments.getDocument(k);return m.provider.resolveCustomTextEditor(O,o,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,s,r){this.getCustomDocumentEntry(s,t).disposeEdits(r)}async $onMoveCustomEditor(t,s,r){const n=this._editorProviders.get(r);if(!n)throw new Error(`No provider found for '${r}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const l=this._extHostWebviewPanels.getWebviewPanel(t);if(!l)throw new Error("No webview found");const f=I.URI.revive(s),m=this._extHostDocuments.getDocument(f);await n.provider.moveCustomTextEditor(m,l,p.CancellationToken.None)}async $undo(t,s,r,n){return this.getCustomDocumentEntry(s,t).undo(r,n)}async $redo(t,s,r,n){return this.getCustomDocumentEntry(s,t).redo(r,n)}async $revert(t,s,r){const n=this.getCustomDocumentEntry(s,t);await this.getCustomEditorProvider(s).revertCustomDocument(n.document,r),n.disposeBackup()}async $onSave(t,s,r){const n=this.getCustomDocumentEntry(s,t);await this.getCustomEditorProvider(s).saveCustomDocument(n.document,r),n.disposeBackup()}async $onSaveAs(t,s,r,n){const l=this.getCustomDocumentEntry(s,t);return this.getCustomEditorProvider(s).saveCustomDocumentAs(l.document,I.URI.revive(r),n)}async $backup(t,s,r){const n=this.getCustomDocumentEntry(s,t),f=await this.getCustomEditorProvider(s).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},r);return n.updateBackup(f),f.id}getCustomDocumentEntry(t,s){const r=this._documents.get(t,I.URI.revive(s));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(t){const r=this._editorProviders.get(t)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=_;function b(v){return typeof v.resolveCustomTextEditor=="function"}function d(v){return typeof v.undo=="function"&&typeof v.redo=="function"}function h(v){const t=v.scheme===y.Schemas.file||v.scheme===y.Schemas.untitled?v.fsPath:v.toString();return(0,L.hash)(t)+""}});var nt=this&&this.__classPrivateFieldSet||function(X,e,p,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!L:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(X):L?L.value:e.get(X)};define(he[250],fe([0,1,3,6,2,32,16,64,5,7]),function(X,e,p,L,C,y,T,I,D,A){"use strict";var i,P,c,u,a,g,w,_,b,d,h,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class s extends L.Disposable{constructor(f,m,E,S,o,k,O){super();i.set(this,void 0),P.set(this,void 0),c.set(this,void 0),u.set(this,void 0),a.set(this,void 0),g.set(this,void 0),w.set(this,void 0),_.set(this,void 0),b.set(this,!0),d.set(this,!0),h.set(this,!1),v.set(this,this._register(new p.Emitter)),this.onDidDispose=Ue(this,v,"f").event,t.set(this,this._register(new p.Emitter)),this.onDidChangeViewState=Ue(this,t,"f").event,nt(this,i,f,"f"),nt(this,P,m,"f"),nt(this,c,E,"f"),nt(this,a,k,"f"),nt(this,_,o,"f"),nt(this,g,S,"f"),nt(this,u,O,"f")}dispose(){Ue(this,h,"f")||(nt(this,h,!0,"f"),Ue(this,v,"f").fire(),Ue(this,P,"f").$disposeWebview(Ue(this,i,"f")),Ue(this,u,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,u,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,c,"f")}get title(){return this.assertNotDisposed(),Ue(this,g,"f")}set title(f){this.assertNotDisposed(),Ue(this,g,"f")!==f&&(nt(this,g,f,"f"),Ue(this,P,"f").$setTitle(Ue(this,i,"f"),f))}get iconPath(){return this.assertNotDisposed(),Ue(this,w,"f")}set iconPath(f){this.assertNotDisposed(),Ue(this,w,"f")!==f&&(nt(this,w,f,"f"),Ue(this,P,"f").$setIconPath(Ue(this,i,"f"),C.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return Ue(this,a,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,_,"f")=="number"&&Ue(this,_,"f")<0))return Ue(this,_,"f")}get active(){return this.assertNotDisposed(),Ue(this,d,"f")}get visible(){return this.assertNotDisposed(),Ue(this,b,"f")}_updateViewState(f){Ue(this,h,"f")||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(nt(this,d,f.active,"f"),nt(this,b,f.visible,"f"),nt(this,_,f.viewColumn,"f"),Ue(this,t,"f").fire({webviewPanel:this}))}reveal(f,m){this.assertNotDisposed(),Ue(this,P,"f").$reveal(Ue(this,i,"f"),{viewColumn:f?T.ViewColumn.from(f):void 0,preserveFocus:!!m})}assertNotDisposed(){if(Ue(this,h,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,P=new WeakMap,c=new WeakMap,u=new WeakMap,a=new WeakMap,g=new WeakMap,w=new WeakMap,_=new WeakMap,b=new WeakMap,d=new WeakMap,h=new WeakMap,v=new WeakMap,t=new WeakMap;class r{constructor(f,m,E){this.webviews=m,this.workspace=E,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=f.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,y.generateUuid)()}createWebviewPanel(f,m,E,S,o={}){const k=typeof S=="object"?S.viewColumn:S,O={viewColumn:T.ViewColumn.from(k),preserveFocus:typeof S=="object"&&!!S.preserveFocus},$=(0,I.shouldSerializeBuffersForPostMessage)(f),G=r.newHandle();this._proxy.$createWebviewPanel((0,I.toExtensionData)(f),G,m,{title:E,panelOptions:n(o),webviewOptions:(0,I.serializeWebviewOptions)(f,this.workspace,o),serializeBuffersForPostMessage:$},O);const re=this.webviews.createNewWebview(G,o,f);return this.createNewWebviewPanel(G,m,E,k,o,re)}$onDidChangeWebviewPanelViewStates(f){const m=Object.keys(f);m.sort((E,S)=>{const o=f[E],k=f[S];return o.active?1:k.active?-1:+o.visible-+k.visible});for(const E of m){const S=this.getWebviewPanel(E);if(!S)continue;const o=f[E];S._updateViewState({active:o.active,visible:o.visible,viewColumn:T.ViewColumn.to(o.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this._webviewPanels.delete(f),this.webviews.deleteWebview(f)}registerWebviewPanelSerializer(f,m,E){if(this._serializers.has(m))throw new Error(`Serializer for '${m}' already registered`);return this._serializers.set(m,{serializer:E,extension:f}),this._proxy.$registerSerializer(m,{serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(f)}),new A.Disposable(()=>{this._serializers.delete(m),this._proxy.$unregisterSerializer(m)})}async $deserializeWebviewPanel(f,m,E,S){const o=this._serializers.get(m);if(!o)throw new Error(`No serializer found for '${m}'`);const{serializer:k,extension:O}=o,$=this.webviews.createNewWebview(f,E.webviewOptions,O),G=this.createNewWebviewPanel(f,m,E.title,S,E.panelOptions,$);await k.deserializeWebviewPanel(G,E.state)}createNewWebviewPanel(f,m,E,S,o,k){const O=new s(f,this._proxy,m,E,S,o,k);return this._webviewPanels.set(f,O),O}getWebviewPanel(f){return this._webviewPanels.get(f)}}e.ExtHostWebviewPanels=r;function n(l){return{enableFindWidget:l.enableFindWidget,retainContextWhenHidden:l.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(X,e,p,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!L:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(X):L?L.value:e.get(X)};define(he[251],fe([0,1,3,6,64,5,7]),function(X,e,p,L,C,y,T){"use strict";var I,D,A,i,P,c,u,a,g,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class _ extends L.Disposable{constructor(h,v,t,s,r,n){super();I.set(this,void 0),D.set(this,void 0),A.set(this,void 0),i.set(this,void 0),P.set(this,!1),c.set(this,void 0),u.set(this,void 0),a.set(this,void 0),g.set(this,this._register(new p.Emitter)),this.onDidChangeVisibility=Ue(this,g,"f").event,w.set(this,this._register(new p.Emitter)),this.onDidDispose=Ue(this,w,"f").event,nt(this,A,t,"f"),nt(this,u,s,"f"),nt(this,I,h,"f"),nt(this,D,v,"f"),nt(this,i,r,"f"),nt(this,c,n,"f")}dispose(){Ue(this,P,"f")||(nt(this,P,!0,"f"),Ue(this,w,"f").fire(),Ue(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,u,"f")}set title(h){this.assertNotDisposed(),Ue(this,u,"f")!==h&&(nt(this,u,h,"f"),Ue(this,D,"f").$setWebviewViewTitle(Ue(this,I,"f"),h))}get description(){return this.assertNotDisposed(),Ue(this,a,"f")}set description(h){this.assertNotDisposed(),Ue(this,a,"f")!==h&&(nt(this,a,h,"f"),Ue(this,D,"f").$setWebviewViewDescription(Ue(this,I,"f"),h))}get visible(){return Ue(this,c,"f")}get webview(){return Ue(this,i,"f")}get viewType(){return Ue(this,A,"f")}_setVisible(h){h===Ue(this,c,"f")||Ue(this,P,"f")||(nt(this,c,h,"f"),Ue(this,g,"f").fire())}show(h){this.assertNotDisposed(),Ue(this,D,"f").$show(Ue(this,I,"f"),!!h)}assertNotDisposed(){if(Ue(this,P,"f"))throw new Error("Webview is disposed")}}I=new WeakMap,D=new WeakMap,A=new WeakMap,i=new WeakMap,P=new WeakMap,c=new WeakMap,u=new WeakMap,a=new WeakMap,g=new WeakMap,w=new WeakMap;class b{constructor(h,v){this._extHostWebview=v,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=h.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(h,v,t,s){if(this._viewProviders.has(v))throw new Error(`View provider for '${v}' already registered`);return this._viewProviders.set(v,{provider:t,extension:h}),this._proxy.$registerWebviewViewProvider((0,C.toExtensionData)(h),v,{retainContextWhenHidden:s?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new T.Disposable(()=>{this._viewProviders.delete(v),this._proxy.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(h,v,t,s,r){const n=this._viewProviders.get(v);if(!n)throw new Error(`No view provider found for '${v}'`);const{provider:l,extension:f}=n,m=this._extHostWebview.createNewWebview(h,{},f),E=new _(h,this._proxy,v,t,m,!0);this._webviewViews.set(h,E),await l.resolveWebviewView(E,{state:s},r)}async $onDidChangeWebviewViewVisibility(h,v){this.getWebviewView(h)._setVisible(v)}async $disposeWebviewView(h){const v=this.getWebviewView(h);this._webviewViews.delete(h),v.dispose(),this._extHostWebview.deleteWebview(h)}getWebviewView(h){const v=this._webviewViews.get(h);if(!v)throw new Error("No webview found");return v}}e.ExtHostWebviewViews=b}),define(he[129],fe([0,1,3,5,2,10,8,4,13]),function(X,e,p,L,C,y,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let A=class xn{constructor(P){this._onDidChangeWindowState=new p.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=xn.InitialState,this._proxy=P.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(c=>this.$onDidChangeWindowFocus(c))}get state(){return this._state}$onDidChangeWindowFocus(P){P!==this._state.focused&&(this._state={...this._state,focused:P},this._onDidChangeWindowState.fire(this._state))}openUri(P,c){let u;if(typeof P=="string"){u=P;try{P=C.URI.parse(P)}catch(a){return Promise.reject(`Invalid uri - '${P}'`)}}return(0,T.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===y.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this._proxy.$openUri(P,u,c)}async asExternalUri(P,c){if((0,T.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");const u=await this._proxy.$asExternalUri(P,c);return C.URI.from(u)}};A.InitialState={focused:!0},A=je([We(0,D.IExtHostRpcService)],A),e.ExtHostWindow=A,e.IExtHostWindow=(0,I.createDecorator)("IExtHostWindow")}),define(he[252],fe([0,1,9,102,32,50,6,5,2,13]),function(X,e,p,L,C,y,T,I,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let i=class extends T.Disposable{constructor(c,u){super();const a=c.getProxy(I.MainContext.MainThreadDownloadService);u.registerCommand(!1,"_workbench.downloadResource",async g=>{const w=D.URI.file((0,p.join)((0,L.tmpdir)(),(0,C.generateUuid)()));return await a.$download(g,w),w})}};i=je([We(0,A.IExtHostRpcService),We(1,y.IExtHostCommands)],i),e.ExtHostDownloadService=i}),define(he[253],fe([0,1,2,9,148,28,62,27,13,6,12,114,41]),function(X,e,p,L,C,y,T,I,D,A,i,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class u{constructor(_,b,d){this.name=_,this.file=b,this.appender=d}static async create(_,b){const d=await(0,P.createRotatingLogger)(_,b,30*c.ByteSize.MB,1);return d.clearFormatters(),new u(_,b,d)}append(_){this.appender.critical(_)}flush(){this.appender.flush()}}class a extends T.AbstractExtHostOutputChannel{constructor(_,b,d,h){super(_,!1,p.URI.file(b.file),d,h);this._appender=b}append(_){super.append(_),this._appender.append(_),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(_,b){this._appender.flush(),super.show(_,b)}clear(){this._appender.flush(),super.clear()}}let g=class extends T.ExtHostOutputService{constructor(_,b,d){super(_);this.logService=b,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new A.MutableDisposable,this._logsLocation=d.logsLocation}$setVisibleChannel(_){if(_){const b=this._channels.get(_);b&&(this._visibleChannelDisposable.value=b.onDidAppend(()=>b.update()))}}createOutputChannel(_,b){if(_=_.trim(),!_)throw new Error("illegal argument `name`. must not be falsy");const d=this._doCreateOutChannel(_,b);return d.then(h=>h._id.then(v=>this._channels.set(v,h))),new T.LazyOutputChannel(_,d)}async _doCreateOutChannel(_,b){try{const d=(0,L.join)(this._logsLocation.fsPath,`output_logging_${(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await y.SymlinkSupport.existsDirectory(d)||await y.Promises.mkdir(d,{recursive:!0});const v=`${this._namePool++}-${_.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=p.URI.file((0,L.join)(d,`${v}.log`)),s=await u.create(v,t.fsPath);return new a(_,s,b.identifier.value,this._proxy)}catch(d){return this.logService.error(d),new T.ExtHostPushOutputChannel(_,b.identifier.value,this._proxy)}}};g=je([We(0,D.IExtHostRpcService),We(1,i.ILogService),We(2,I.IExtHostInitDataService)],g),e.ExtHostOutputService2=g}),define(he[254],fe([0,1,45,285,2,63,6,10,17]),function(X,e,p,L,C,y,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class A extends y.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(v){const t=await super._getWorkspaceStorageURI(v);if(t.scheme!==I.Schemas.file)return t;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${t.fsPath}.`),t;const s=t.fsPath;let r=0;do{let n;r===0?n=s:n=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${r}`:`${s}-${r}`,await i(n);const l=L.join(n,"vscode.lock"),f=await a(this._logService,l,!1);if(f)return this._workspaceStorageLock=f,process.on("exit",()=>{f.dispose()}),C.URI.file(n);r++}while(r<10);return t}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=A;async function i(h){try{await p.promises.stat(h);return}catch{}try{await p.promises.mkdir(h,{recursive:!0})}catch{}}const P=1e3,c=10*60*1e3;class u extends T.Disposable{constructor(v,t){super();this.logService=v,this.filename=t,this._timer=this._register(new D.IntervalTimer),this._timer.cancelAndSet(async()=>{const s=await g(v,t);(!s||s.pid!==process.pid)&&(v.info(`Lock '${t}': The lock was lost unexpectedly.`),this._timer.cancel());try{await p.promises.utimes(t,new Date,new Date)}catch(r){v.error(r),v.info(`Lock '${t}': Could not update mtime.`)}},P)}dispose(){super.dispose();try{p.unlinkSync(this.filename)}catch(v){}}async setWillRelease(v){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${v} ms.`);try{const t={pid:process.pid,willReleaseAt:Date.now()+v};await p.promises.writeFile(this.filename,JSON.stringify(t),{flag:"w"})}catch(t){this.logService.error(t)}}}async function a(h,v,t){try{const r={pid:process.pid,willReleaseAt:0};await p.promises.writeFile(v,JSON.stringify(r),{flag:"wx"})}catch(r){h.error(r)}const s=await g(h,v);return!s||s.pid!==process.pid?t?(h.info(`Lock '${v}': Could not acquire lock, giving up.`),null):(h.info(`Lock '${v}': Could not acquire lock, checking if the file is stale.`),b(h,v)):(h.info(`Lock '${v}': Lock acquired.`),new u(h,v))}async function g(h,v){let t;try{t=await p.promises.readFile(v)}catch(s){return h.error(s),null}try{return JSON.parse(String(t))}catch(s){return h.error(s),null}}async function w(h,v){let t;try{t=await p.promises.stat(v)}catch(s){return h.error(s),0}return t.mtime.getTime()}function _(h){try{return process.kill(h,0),!0}catch(v){return!1}}async function b(h,v){const t=await g(h,v);if(!t)return h.info(`Lock '${v}': Could not read pid of lock holder.`),d(h,v);if(t.willReleaseAt){let f=t.willReleaseAt-Date.now();if(f<5e3){for(f>0?h.info(`Lock '${v}': The lockfile is scheduled to be released in ${f} ms.`):h.info(`Lock '${v}': The lockfile is scheduled to have been released.`);f>0;){if(await(0,D.timeout)(Math.min(100,f)),await w(h,v)===0)return d(h,v);f=t.willReleaseAt-Date.now()}return d(h,v)}}if(!_(t.pid))return h.info(`Lock '${v}': The pid ${t.pid} appears to be gone.`),d(h,v);const s=await w(h,v),r=Date.now()-s;if(r<=c)return h.info(`Lock '${v}': The lock does not look stale, elapsed: ${r} ms, giving up.`),null;h.info(`Lock '${v}': The lock looks stale, waiting for 2s.`),await(0,D.timeout)(2e3);const n=await w(h,v),l=Date.now()-n;return l<=c?(h.info(`Lock '${v}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null):(h.info(`Lock '${v}': The lock looks stale even after waiting for 2s.`),d(h,v))}async function d(h,v){h.info(`Lock '${v}': Deleting a stale lock.`);try{await p.promises.unlink(v)}catch(t){}return a(h,v,!0)}}),define(he[255],fe([0,1,32,13,33]),function(X,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let y=class extends C.BaseExtHostTerminalService{constructor(I){super(!0,I)}createTerminal(I,D,A){return this.createTerminalFromOptions({name:I,shellPath:D,shellArgs:A})}createTerminalFromOptions(I,D){const A=new C.ExtHostTerminal(this._proxy,(0,p.generateUuid)(),I,I.name);return this._terminals.push(A),A.create(I,D),A.value}};y=je([We(0,L.IExtHostRpcService)],y),e.ExtHostTerminalService=y}),define(he[256],fe([0,1,5,13,6,27,2,38,24,28,7,11,49,3,189,73,12]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class _{constructor(m,E,S){this.remoteAddress=m,this.localAddress=E,this._dispose=S,this._onDispose=new u.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function b(f){const m=f.trim().split(`
`),E=[];return m.forEach(o=>{const k=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(o);k&&k.length>=3&&E.push({pid:parseInt(k[1],10),socket:parseInt(k[2],10)})}),E.reduce((o,k)=>(o[k.socket]=k,o),{})}e.getSockets=b;function d(...f){const m=[].concat(...f.map(v));return[...new Map(m.filter(E=>E.st==="0A").map(E=>{const S=E.local_address.split(":");return{socket:parseInt(E.inode,10),ip:h(S[0]),port:parseInt(S[1],16)}}).map(E=>[E.ip+":"+E.port,E])).values()]}e.loadListeningPorts=d;function h(f){let m="";if(f.length===8)for(let E=f.length-2;E>=0;E-=2)m+=parseInt(f.substr(E,2),16),E!==0&&(m+=".");else for(let E=f.length-4;E>=0;E-=4)m+=parseInt(f.substr(E,4),16).toString(16),E!==0&&(m+=":");return m}e.parseIpAddress=h;function v(f){const m=f.trim().split(`
`),E=m.shift().trim().split(/\s+/).filter(o=>o!=="rx_queue"&&o!=="tm->when");return m.map(o=>o.trim().split(/\s+/).reduce((k,O,$)=>(k[E[$]||$]=O,k),{}))}e.loadConnectionTable=v;function t(f){return!!f.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||f.indexOf("out/vs/server/main.js")!==-1||f.indexOf("_productName=VSCode")!==-1}function s(f){const m=f.trim().split(`
`),E=[];return m.forEach(S=>{const o=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(S);o&&o.length>=4&&E.push({pid:parseInt(o[1],10),ppid:parseInt(o[2]),cmd:o[3]})}),E}e.getRootProcesses=s;async function r(f,m,E){const S=E.reduce((k,O)=>(k[O.pid]=O,k),{}),o=[];return f.forEach(({socket:k,ip:O,port:$})=>{const G=m[k]?m[k].pid:void 0,re=G?S[G]?.cmd:void 0;G&&re&&!t(re)&&o.push({host:O,port:$,detail:re,pid:G})}),o}e.findPorts=r;function n(f,m,E){const S=new Map,o=s(m);for(const k of f){const O=E.get(k.port);if(O){S.set(k.port,O);continue}const $=o.find(G=>G.cmd.includes(`${k.port}`));if($){let G=$,re;do re=o.find(j=>j.ppid===G.pid),re&&(G=re);while(re);S.set(k.port,{host:k.ip,port:k.port,pid:G.pid,detail:G.cmd,ppid:G.ppid})}else S.set(k.port,{host:k.ip,port:k.port,ppid:Number.MAX_VALUE})}return S}e.tryFindRootPorts=n;let l=class extends C.Disposable{constructor(m,E,S){super();this.logService=S,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new u.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=m.getProxy(p.MainContext.MainThreadTunnelService),P.isLinux&&E.remote.isRemote&&E.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(m,E){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${m.identifier.value} called openTunnel API for ${E.remoteAddress.host}:${E.remoteAddress.port}.`);const S=await this._proxy.$openTunnel(E,m.displayName);if(S){const o=new _(S.remoteAddress,S.localAddress,()=>this._proxy.$closeTunnel(S.remoteAddress));return this._register(o),o}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(m){return Math.max(m*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(m,E){const S=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(S,{selector:m,provider:E}),this._proxy.$registerPortsAttributesProvider(m,S),new i.Disposable(()=>{this._portAttributesProviders.delete(S),this._proxy.$unregisterPortsAttributesProvider(S)})}async $providePortAttributes(m,E,S,o,k){const O=[];for(const G of m){const re=this._portAttributesProviders.get(G);if(!re)return[];O.push(...await Promise.all(E.map(async j=>re.provider.providePortAttributes(j,S,o,k))))}const $=O.filter(G=>!!G);return $.length>0?$.map(G=>({autoForwardAction:G.autoForwardAction,port:G.port})):[]}async $registerCandidateFinder(m){if(m&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=m;let E=new g.MovingAverage,S;for(;this._candidateFindingEnabled;){const o=new Date().getTime(),k=(await this.findCandidatePorts()).filter($=>(0,a.isLocalhost)($.host)||(0,a.isAllInterfaces)($.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${k.map($=>$.port).join(", ")}`);const O=new Date().getTime()-o;E.update(O),(!S||JSON.stringify(S)!==JSON.stringify(k))&&(S=k,await this._proxy.$onFoundNewCandidates(S)),await new Promise($=>setTimeout(()=>$(),this.calculateDelay(E.value)))}}async setTunnelExtensionFunctions(m){return m?(m.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(m.candidatePortSource),m.showCandidatePort&&(this._showCandidatePort=m.showCandidatePort,this._proxy.$setCandidateFilter()),m.tunnelFactory&&(this._forwardPortProvider=m.tunnelFactory,this._proxy.$setTunnelProvider(m.tunnelFeatures??{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,C.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(m,E){if(this._extensionTunnels.has(m.host)){const S=this._extensionTunnels.get(m.host);S.has(m.port)&&(E&&S.get(m.port).disposeListener.dispose(),await S.get(m.port).tunnel.dispose(),S.delete(m.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(m,E){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const S=this._forwardPortProvider(m,E);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),S!==void 0){const o=await S;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(m.remoteAddress.host)||this._extensionTunnels.set(m.remoteAddress.host,new Map);const k=this._register(o.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(o.remoteAddress))));return this._extensionTunnels.get(m.remoteAddress.host).set(m.remoteAddress.port,{tunnel:o,disposeListener:k}),c.TunnelDto.fromApiTunnel(o)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(S){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(m){const E=await Promise.all(m.map(o=>this._showCandidatePort(o.host,o.port,o.detail??""))),S=m.filter((o,k)=>E[k]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${m.map(o=>o.port).join(", ")} to ${S.map(o=>o.port).join(", ")}`),S}async findCandidatePorts(){let m="",E="";try{m=await A.Promises.readFile("/proc/net/tcp","utf8"),E=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch(x){}const S=d(m,E),o=await new Promise(x=>{(0,I.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(R,V,F)=>{x(V)})}),k=b(o),O=await A.Promises.readdir("/proc"),$=[];for(let x of O)try{const R=Number(x),V=D.joinPath(T.URI.file("/proc"),x);if((await A.Promises.stat(V.fsPath)).isDirectory()&&!isNaN(R)){const M=await A.Promises.readlink(D.joinPath(V,"cwd").fsPath),B=await A.Promises.readFile(D.joinPath(V,"cmdline").fsPath,"utf8");$.push({pid:R,cwd:M,cmd:B})}}catch(R){}const G=[],re=S.filter(x=>{const R=k[x.socket];return R||G.push(x),R}),j=r(re,k,$);let N;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${G.length}`),G.length>0){const x=await new Promise(R=>{(0,I.exec)("ps -F -A -l | grep root",(V,F,M)=>{R(F)})});this._foundRootPorts=n(G,x,this._foundRootPorts),N=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${N.join(", ")}`)}return j.then(x=>N?x.concat(N):x)}};l=je([We(0,L.IExtHostRpcService),We(1,y.IExtHostInitDataService),We(2,w.ILogService)],l),e.ExtHostTunnelService=l}),define(he[257],fe([0,1,17,21,15,3,6,100,222,127,22]),function(X,e,p,L,C,y,T,I,D,A,i){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function c(n,l){try{return JSON.stringify(n,l)}catch(f){return"null"}}function u(n,l){return JSON.stringify(n,l)}function a(n){return n?(l,f)=>f&&f.$mid===1?n.transformOutgoing(f):f:null}var g;(function(n){n[n.LocalSide=0]="LocalSide",n[n.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));var w;(function(n){n[n.Responsive=0]="Responsive",n[n.Unresponsive=1]="Unresponsive"})(w=e.ResponsiveState||(e.ResponsiveState={}));const _=()=>{},b=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class h extends T.Disposable{constructor(l,f=null,m=null){super();this[P]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=l,this._logger=f,this._uriTransformer=m,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let E=0,S=A.ProxyIdentifier.count;E<S;E++)this._locals[E]=null,this._proxies[E]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new p.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(E=>this._receiveOneMessage(E))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(l=>{this._pendingRPCReplies[l].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(l){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(l){this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(l){this._responsiveState!==l&&(this._responsiveState=l,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(l){return this._uriTransformer?(0,I.transformIncomingURIs)(l,this._uriTransformer):l}getProxy(l){const{nid:f,sid:m}=l;return this._proxies[f]||(this._proxies[f]=this._createProxy(f,m)),this._proxies[f]}_createProxy(l,f){let m={get:(E,S)=>(typeof S=="string"&&!E[S]&&S.charCodeAt(0)===36&&(E[S]=(...o)=>this._remoteCall(l,S,o)),S===d?f:E[S])};return new Proxy(Object.create(null),m)}set(l,f){return this._locals[l.nid]=f,f}assertRegistered(l){for(let f=0,m=l.length;f<m;f++){const E=l[f];if(!this._locals[E.nid])throw new Error(`Missing actor ${E.sid} (isMain: ${E.isMain})`)}}_receiveOneMessage(l){if(this._isDisposed)return;const f=l.byteLength,m=v.read(l,0),E=m.readUInt8(),S=m.readUInt32();switch(E){case 1:case 2:{let{rpcId:o,method:k,args:O}=t.deserializeRequestJSONArgs(m);this._uriTransformer&&(O=(0,I.transformIncomingURIs)(O,this._uriTransformer)),this._receiveRequest(f,S,o,k,O,E===2);break}case 3:case 4:{let{rpcId:o,method:k,args:O}=t.deserializeRequestMixedArgs(m);this._uriTransformer&&(O=(0,I.transformIncomingURIs)(O,this._uriTransformer)),this._receiveRequest(f,S,o,k,O,E===4);break}case 5:{this._logger&&this._logger.logIncoming(f,S,0,"ack"),this._onDidReceiveAcknowledge(S);break}case 6:{this._receiveCancel(f,S);break}case 7:{this._receiveReply(f,S,void 0);break}case 9:{let o=t.deserializeReplyOKJSON(m);this._uriTransformer&&(o=(0,I.transformIncomingURIs)(o,this._uriTransformer)),this._receiveReply(f,S,o);break}case 8:{let o=t.deserializeReplyOKVSBuffer(m);this._receiveReply(f,S,o);break}case 10:{let o=t.deserializeReplyErrError(m);this._uriTransformer&&(o=(0,I.transformIncomingURIs)(o,this._uriTransformer)),this._receiveReplyErr(f,S,o);break}case 11:{this._receiveReplyErr(f,S,void 0);break}default:console.error("received unexpected message"),console.error(l)}}_receiveRequest(l,f,m,E,S,o){this._logger&&this._logger.logIncoming(l,f,1,`receiveRequest ${(0,A.getStringIdentifierForProxy)(m)}.${E}(`,S);const k=String(f);let O,$;if(o){const re=new L.CancellationTokenSource;S.push(re.token),O=this._invokeHandler(m,E,S),$=()=>re.cancel()}else O=this._invokeHandler(m,E,S),$=_;this._cancelInvokedHandlers[k]=$;const G=t.serializeAcknowledged(f);this._logger&&this._logger.logOutgoing(G.byteLength,f,1,"ack"),this._protocol.send(G),O.then(re=>{delete this._cancelInvokedHandlers[k];const j=t.serializeReplyOK(f,re,this._uriReplacer);this._logger&&this._logger.logOutgoing(j.byteLength,f,1,"reply:",re),this._protocol.send(j)},re=>{delete this._cancelInvokedHandlers[k];const j=t.serializeReplyErr(f,re);this._logger&&this._logger.logOutgoing(j.byteLength,f,1,"replyErr:",re),this._protocol.send(j)})}_receiveCancel(l,f){this._logger&&this._logger.logIncoming(l,f,1,"receiveCancel");const m=String(f);this._cancelInvokedHandlers[m]&&this._cancelInvokedHandlers[m]()}_receiveReply(l,f,m){this._logger&&this._logger.logIncoming(l,f,0,"receiveReply:",m);const E=String(f);if(!this._pendingRPCReplies.hasOwnProperty(E))return;const S=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E],S.resolveOk(m)}_receiveReplyErr(l,f,m){this._logger&&this._logger.logIncoming(l,f,0,"receiveReplyErr:",m);const E=String(f);if(!this._pendingRPCReplies.hasOwnProperty(E))return;const S=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E];let o;m&&(m.$isError?(o=new Error,o.name=m.name,o.message=m.message,o.stack=m.stack):o=m),S.resolveErr(o)}_invokeHandler(l,f,m){try{return Promise.resolve(this._doInvokeHandler(l,f,m))}catch(E){return Promise.reject(E)}}_doInvokeHandler(l,f,m){const E=this._locals[l];if(!E)throw new Error("Unknown actor "+(0,A.getStringIdentifierForProxy)(l));let S=E[f];if(typeof S!="function")throw new Error("Unknown method "+f+" on actor "+(0,A.getStringIdentifierForProxy)(l));return S.apply(E,m)}_remoteCall(l,f,m){if(this._isDisposed)return Promise.reject(C.canceled());let E=null;if(m.length>0&&L.CancellationToken.isCancellationToken(m[m.length-1])&&(E=m.pop()),E&&E.isCancellationRequested)return Promise.reject(C.canceled());const S=t.serializeRequestArguments(m,this._uriReplacer),o=++this._lastMessageId,k=String(o),O=new D.LazyPromise;E&&E.onCancellationRequested(()=>{const G=t.serializeCancel(o);this._logger&&this._logger.logOutgoing(G.byteLength,o,0,"cancel"),this._protocol.send(t.serializeCancel(o))}),this._pendingRPCReplies[k]=O,this._onWillSendRequest(o);const $=t.serializeRequest(o,l,f,S,!!E);return this._logger&&this._logger.logOutgoing($.byteLength,o,0,`request: ${(0,A.getStringIdentifierForProxy)(l)}.${f}(`,m),this._protocol.send($),O}}e.RPCProtocol=h,P=b,h.UNRESPONSIVE_TIME=3*1e3;class v{constructor(l,f){this._buff=l,this._offset=f}static alloc(l,f,m){let E=new v(i.VSBuffer.alloc(m+1+4),0);return E.writeUInt8(l),E.writeUInt32(f),E}static read(l,f){return new v(l,f)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(l){this._buff.writeUInt8(l,this._offset),this._offset+=1}readUInt8(){const l=this._buff.readUInt8(this._offset);return this._offset+=1,l}writeUInt32(l){this._buff.writeUInt32BE(l,this._offset),this._offset+=4}readUInt32(){const l=this._buff.readUInt32BE(this._offset);return this._offset+=4,l}static sizeShortString(l){return 1+l.byteLength}writeShortString(l){this._buff.writeUInt8(l.byteLength,this._offset),this._offset+=1,this._buff.set(l,this._offset),this._offset+=l.byteLength}readShortString(){const l=this._buff.readUInt8(this._offset);this._offset+=1;const m=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,m}static sizeLongString(l){return 4+l.byteLength}writeLongString(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readLongString(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const m=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,m}writeBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}static sizeVSBuffer(l){return 4+l.byteLength}writeVSBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readVSBuffer(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const f=this._buff.slice(this._offset,this._offset+l);return this._offset+=l,f}static sizeMixedArray(l,f){let m=0;m+=1;for(let E=0,S=l.length;E<S;E++){const o=l[E],k=f[E];switch(m+=1,k){case 1:m+=this.sizeLongString(o);break;case 2:m+=this.sizeVSBuffer(o);break;case 3:break}}return m}writeMixedArray(l,f){this._buff.writeUInt8(l.length,this._offset),this._offset+=1;for(let m=0,E=l.length;m<E;m++){const S=l[m];switch(f[m]){case 1:this.writeUInt8(1),this.writeLongString(S);break;case 2:this.writeUInt8(2),this.writeVSBuffer(S);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const l=this._buff.readUInt8(this._offset);this._offset+=1;let f=new Array(l);for(let m=0;m<l;m++)switch(this.readUInt8()){case 1:f[m]=this.readLongString();break;case 2:f[m]=this.readVSBuffer();break;case 3:f[m]=void 0;break}return f}}class t{static _arrayContainsBufferOrUndefined(l){for(let f=0,m=l.length;f<m;f++)if(l[f]instanceof i.VSBuffer||typeof l[f]=="undefined")return!0;return!1}static serializeRequestArguments(l,f){if(this._arrayContainsBufferOrUndefined(l)){let m=[],E=[];for(let S=0,o=l.length;S<o;S++){const k=l[S];k instanceof i.VSBuffer?(m[S]=k,E[S]=2):typeof k=="undefined"?(m[S]=i.VSBuffer.alloc(0),E[S]=3):(m[S]=i.VSBuffer.fromString(u(k,f)),E[S]=1)}return{type:"mixed",args:m,argsType:E}}return{type:"simple",args:u(l,f)}}static serializeRequest(l,f,m,E,S){return E.type==="mixed"?this._requestMixedArgs(l,f,m,E.args,E.argsType,S):this._requestJSONArgs(l,f,m,E.args,S)}static _requestJSONArgs(l,f,m,E,S){const o=i.VSBuffer.fromString(m),k=i.VSBuffer.fromString(E);let O=0;O+=v.sizeUInt8(),O+=v.sizeShortString(o),O+=v.sizeLongString(k);let $=v.alloc(S?2:1,l,O);return $.writeUInt8(f),$.writeShortString(o),$.writeLongString(k),$.buffer}static deserializeRequestJSONArgs(l){const f=l.readUInt8(),m=l.readShortString(),E=l.readLongString();return{rpcId:f,method:m,args:JSON.parse(E)}}static _requestMixedArgs(l,f,m,E,S,o){const k=i.VSBuffer.fromString(m);let O=0;O+=v.sizeUInt8(),O+=v.sizeShortString(k),O+=v.sizeMixedArray(E,S);let $=v.alloc(o?4:3,l,O);return $.writeUInt8(f),$.writeShortString(k),$.writeMixedArray(E,S),$.buffer}static deserializeRequestMixedArgs(l){const f=l.readUInt8(),m=l.readShortString(),E=l.readMixedArray(),S=new Array(E.length);for(let o=0,k=E.length;o<k;o++){const O=E[o];typeof O=="string"?S[o]=JSON.parse(O):S[o]=O}return{rpcId:f,method:m,args:S}}static serializeAcknowledged(l){return v.alloc(5,l,0).buffer}static serializeCancel(l){return v.alloc(6,l,0).buffer}static serializeReplyOK(l,f,m){return typeof f=="undefined"?this._serializeReplyOKEmpty(l):f instanceof i.VSBuffer?this._serializeReplyOKVSBuffer(l,f):this._serializeReplyOKJSON(l,c(f,m))}static _serializeReplyOKEmpty(l){return v.alloc(7,l,0).buffer}static _serializeReplyOKVSBuffer(l,f){let m=0;m+=v.sizeVSBuffer(f);let E=v.alloc(8,l,m);return E.writeVSBuffer(f),E.buffer}static deserializeReplyOKVSBuffer(l){return l.readVSBuffer()}static _serializeReplyOKJSON(l,f){const m=i.VSBuffer.fromString(f);let E=0;E+=v.sizeLongString(m);let S=v.alloc(9,l,E);return S.writeLongString(m),S.buffer}static deserializeReplyOKJSON(l){const f=l.readLongString();return JSON.parse(f)}static serializeReplyErr(l,f){return f?this._serializeReplyErrEror(l,f):this._serializeReplyErrEmpty(l)}static _serializeReplyErrEror(l,f){const m=i.VSBuffer.fromString(c(C.transformErrorForSerialization(f),null));let E=0;E+=v.sizeLongString(m);let S=v.alloc(10,l,E);return S.writeLongString(m),S.buffer}static deserializeReplyErrError(l){const f=l.readLongString();return JSON.parse(f)}static _serializeReplyErrEmpty(l){return v.alloc(11,l,0).buffer}}var s;(function(n){n[n.RequestJSONArgs=1]="RequestJSONArgs",n[n.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",n[n.RequestMixedArgs=3]="RequestMixedArgs",n[n.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",n[n.Acknowledged=5]="Acknowledged",n[n.Cancel=6]="Cancel",n[n.ReplyOKEmpty=7]="ReplyOKEmpty",n[n.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",n[n.ReplyOKJSON=9]="ReplyOKJSON",n[n.ReplyErrError=10]="ReplyErrError",n[n.ReplyErrEmpty=11]="ReplyErrEmpty"})(s||(s={}));var r;(function(n){n[n.String=1]="String",n[n.VSBuffer=2]="VSBuffer",n[n.Undefined=3]="Undefined"})(r||(r={}))}),define(he[258],fe([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,p.createDecorator)("remoteAgentService")}),define(he[259],fe([0,1,10,9,11,2,4,83,47,217,258]),function(X,e,p,L,C,y,T,I,D,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,T.createDecorator)("pathService");let P=class Bn{constructor(u,a,g,w){this.localUserHome=u,this.remoteAgentService=a,this.environmentService=g,this.contextService=w,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||C.OS)(),this.resolveUserHome=(async()=>{const _=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=_?.userHome||u})()}get defaultUriScheme(){return Bn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(u,a){if(u.remoteAuthority)return p.Schemas.vscodeRemote;const g=(0,I.getVirtualWorkspaceScheme)(a.getWorkspace());if(g)return g;const w=a.getWorkspace().folders[0];if(w)return w.uri.scheme;const _=a.getWorkspace().configuration;return _?_.scheme:p.Schemas.file}async userHome(u){return u?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(u=>u===1?L.win32:L.posix)}async fileURI(u){let a="";if(await this.resolveOS===1&&(u=u.replace(/\\/g,"/")),u[0]==="/"&&u[1]==="/"){const w=u.indexOf("/",2);w===-1?(a=u.substring(2),u="/"):(a=u.substring(2,w),u=u.substring(w)||"/")}return y.URI.from({scheme:p.Schemas.file,authority:a,path:u,query:"",fragment:""})}};P=je([We(1,i.IRemoteAgentService),We(2,A.IWorkbenchEnvironmentService),We(3,D.IWorkspaceContextService)],P),e.AbstractPathService=P}),define(he[65],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class p{constructor(T,I){this.line=T,this.character=I}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,I){return new p(0,0)}with(T){return new p(0,0)}}e.Position=p;class L{constructor(T,I,D,A){this.isEmpty=!1,this.isSingleLine=!1,this.start=new p(T,I),this.end=new p(D,A)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new L(0,0,0,0)}with(T){return new L(0,0,0,0)}}e.Range=L;var C;(function(y){y[y.Information=1]="Information",y[y.Warning=2]="Warning"})(C=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(he[31],fe([0,1,18,30,25,29,8,4,9,15,65]),function(X,e,p,L,C,y,T,I,D,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const P="\u27EA ",c=" characters skipped \u27EB",u=(P.length+c.length+5)*2;e.ISearchService=(0,I.createDecorator)("searchService");var a;(function(R){R[R.file=0]="file",R[R.text=1]="text"})(a=e.SearchProviderType||(e.SearchProviderType={}));var g;(function(R){R[R.File=1]="File",R[R.Text=2]="Text"})(g=e.QueryType||(e.QueryType={}));function w(R){return!!R.preview}e.resultIsMatch=w;function _(R){return!!R.resource}e.isFileMatch=_;function b(R){return!!R.message}e.isProgressMessage=b;var d;(function(R){R[R.Normal=0]="Normal",R[R.NewSearchStarted=1]="NewSearchStarted"})(d=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class h{constructor(V){this.resource=V,this.results=[]}}e.FileMatch=h;class v{constructor(V,F,M){this.ranges=F;const B=Array.isArray(F)?F:[F];if(M&&M.matchLines===1&&t(B)){V=(0,T.getNLines)(V,M.matchLines);let W="",Q=0,ae=0;const _e=Math.floor(M.charsPerLine/5),Fe=[];for(const Ae of B){const Me=Math.max(Ae.startColumn-_e,0),Ve=Ae.startColumn+M.charsPerLine;if(Me>ae+_e+u){const He=P+(Me-ae)+c;W+=He+V.slice(Me,Ve),Q+=Me-(ae+He.length)}else W+=V.slice(ae,Ve);Fe.push(new r(0,Ae.startColumn-Q,Ae.endColumn-Q)),ae=Ve}this.preview={text:W,matches:Array.isArray(this.ranges)?Fe:Fe[0]}}else{const W=Array.isArray(F)?F[0].startLineNumber:F.startLineNumber;this.preview={text:V,matches:(0,p.mapArrayOrNot)(F,Q=>new s(Q.startLineNumber-W,Q.startColumn,Q.endLineNumber-W,Q.endColumn))}}}}e.TextSearchMatch=v;function t(R){const V=R[0].startLineNumber;for(const F of R)if(F.startLineNumber!==V||F.endLineNumber!==V)return!1;return!0}class s{constructor(V,F,M,B){this.startLineNumber=V,this.startColumn=F,this.endLineNumber=M,this.endColumn=B}}e.SearchRange=s;class r extends s{constructor(V,F,M){super(V,F,V,M)}}e.OneLineRange=r;var n;(function(R){R.Default="default",R.FileNames="fileNames",R.Type="type",R.Modified="modified",R.CountDescending="countDescending",R.CountAscending="countAscending"})(n=e.SearchSortOrder||(e.SearchSortOrder={}));function l(R,V=!0){const F=R&&R.files&&R.files.exclude,M=V&&R&&R.search&&R.search.exclude;if(!F&&!M)return;if(!F||!M)return F||M;let B=Object.create(null);return B=C.mixin(B,C.deepClone(F)),B=C.mixin(B,C.deepClone(M),!0),B}e.getExcludes=l;function f(R,V){return R.excludePattern&&L.match(R.excludePattern,V)?!1:R.includePattern||R.usingSearchPaths?R.includePattern&&L.match(R.includePattern,V)?!0:R.usingSearchPaths?!!R.folderQueries&&R.folderQueries.some(F=>{const M=F.folder.fsPath;if(y.isEqualOrParent(V,M)){const B=D.relative(M,V);return!F.includePattern||!!L.match(F.includePattern,B)}else return!1}):!1:!0}e.pathIncludedInQuery=f;var m;(function(R){R[R.unknownEncoding=1]="unknownEncoding",R[R.regexParseError=2]="regexParseError",R[R.globParseError=3]="globParseError",R[R.invalidLiteral=4]="invalidLiteral",R[R.rgProcessError=5]="rgProcessError",R[R.other=6]="other",R[R.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class E extends Error{constructor(V,F){super(V);this.code=F}}e.SearchError=E;function S(R){const V=R.message;if((0,A.isPromiseCanceledError)(R))return new E(V,m.canceled);try{const F=JSON.parse(V);return new E(F.message,F.code)}catch(F){return new E(V,m.other)}}e.deserializeSearchError=S;function o(R){const V={message:R.message,code:R.code};return new Error(JSON.stringify(V))}e.serializeSearchError=o;function k(R){return R.type==="error"?!0:R.type==="success"}e.isSerializedSearchComplete=k;function O(R){return R.type==="success"}e.isSerializedSearchSuccess=O;function $(R){return!!R.path}e.isSerializedFileMatch=$;function G(R,V){const F=R.searchPath?R.searchPath:R.relativePath;return(0,T.fuzzyContains)(F,V)}e.isFilePatternMatch=G;class re{constructor(V){this.path=V,this.results=[]}addMatch(V){this.results.push(V)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=re;function j(R,V){const F={...R||{},...V||{}};return Object.keys(F).filter(M=>{const B=F[M];return typeof B=="boolean"&&B})}e.resolvePatternsForProvider=j;class N{constructor(V,F){this._parsedIncludeExpression=null,this._excludeExpression={...V.excludePattern||{},...F.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let M=V.includePattern;F.includePattern&&(M?M={...M,...F.includePattern}:M=F.includePattern),M&&(this._parsedIncludeExpression=L.parse(M))}includedInQuerySync(V,F,M){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(V,F,M)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(V,F,M))}includedInQuery(V,F,M){return Promise.resolve(this._parsedExcludeExpression(V,F,M)).then(W=>!!W).then(W=>W?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(V,F,M)).then(Q=>!!Q):Promise.resolve(!0)).then(W=>W)}hasSiblingExcludeClauses(){return x(this._excludeExpression)}}e.QueryGlobTester=N;function x(R){for(const V in R)if(typeof R[V]!="boolean")return!0;return!1}}),define(he[35],fe([0,1,18,17,21,3,23,10,73,24,8,14,2,165,4,12,184,47,59,27,13,7,31,5]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u,a,g,w,_,b,d,h,v,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(k,O,$){return new A.ExtUri(G=>m(G,$)).isEqual(k,O)}function n(k,O,$){return r(k.uri,O.uri,$)?0:(0,i.compare)(k.uri.toString(),O.uri.toString())}function l(k,O,$){return k.index!==O.index?k.index<O.index?-1:1:r(k.uri,O.uri,$)?(0,i.compare)(k.name,O.name):(0,i.compare)(k.uri.toString(),O.uri.toString())}function f(k,O,$,G){const re=k.slice(0).sort((N,x)=>$(N,x,G)),j=O.slice(0).sort((N,x)=>$(N,x,G));return(0,p.delta)(re,j,(N,x)=>$(N,x,G))}function m(k,O){const $=O.getCapabilities(k.scheme);return!($&&$&1024)}class E extends _.Workspace{constructor(O,$,G,re,j,N){super(O,G.map(x=>new _.WorkspaceFolder(x)),re,N);this._name=$,this._isUntitled=j,this._workspaceFolders=[],this._structure=T.TernarySearchTree.forUris(N),G.forEach(x=>{this._workspaceFolders.push(x),this._structure.set(x.uri,x)})}static toExtHostWorkspace(O,$,G,re){if(!O)return{workspace:null,added:[],removed:[]};const{id:j,name:N,folders:x,configuration:R,isUntitled:V}=O,F=[],M=$;$?x.forEach((ae,_e)=>{const Fe=c.URI.revive(ae.uri),Ae=E._findFolder(G||$,Fe,re);Ae?(Ae.name=ae.name,Ae.index=ae.index,F.push(Ae)):F.push({uri:Fe,name:ae.name,index:_e})}):F.push(...x.map(({uri:ae,name:_e,index:Fe})=>({uri:c.URI.revive(ae),name:_e,index:Fe}))),F.sort((ae,_e)=>ae.index<_e.index?-1:1);const B=new E(j,N,F,R?c.URI.revive(R):null,!!V,ae=>m(ae,re)),{added:W,removed:Q}=f(M?M.workspaceFolders:[],B.workspaceFolders,n,re);return{workspace:B,added:W,removed:Q}}static _findFolder(O,$,G){for(let re=0;re<O.folders.length;re++){const j=O.workspaceFolders[re];if(r(j.uri,$,G))return j}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(O,$){return $&&this._structure.get(O)&&(O=(0,A.dirname)(O)),this._structure.findSubstr(O)}resolveWorkspaceFolder(O){return this._structure.get(O)}}let S=class{constructor(O,$,G,re){this._onDidChangeWorkspace=new y.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new y.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=re,this._extHostFileSystemInfo=G,this._requestIdProvider=new D.Counter,this._barrier=new L.Barrier,this._proxy=O.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=O.getProxy(s.MainContext.MainThreadMessageService);const j=$.workspace;this._confirmedWorkspace=j?new E(j.id,j.name,[],j.configuration?c.URI.revive(j.configuration):null,!!j.isUntitled,N=>m(N,G)):void 0}$initializeWorkspace(O,$){this._trusted=$,this.$acceptWorkspaceData(O),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?c.URI.from({scheme:I.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(O,$,G,...re){const j=[];if(Array.isArray(re)&&re.forEach(F=>{c.URI.isUri(F.uri)&&!j.some(M=>r(M.uri,F.uri,this._extHostFileSystemInfo))&&j.push({uri:F.uri,name:F.name||(0,A.basenameOrAuthority)(F.uri)})}),this._unconfirmedWorkspace||[$,G].some(F=>typeof F!="number"||F<0)||G===0&&j.length===0)return!1;const N=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if($+G>N.length)return!1;const x=N.slice(0);x.splice($,G,...j.map(F=>({uri:F.uri,name:F.name||(0,A.basenameOrAuthority)(F.uri),index:void 0})));for(let F=0;F<x.length;F++){const M=x[F];if(x.some((B,W)=>W!==F&&r(M.uri,B.uri,this._extHostFileSystemInfo)))return!1}x.forEach((F,M)=>F.index=M);const{added:R,removed:V}=f(N,x,l,this._extHostFileSystemInfo);if(R.length===0&&V.length===0)return!1;if(this._proxy){const F=O.displayName||O.name;this._proxy.$updateWorkspaceFolders(F,$,G,j).then(void 0,M=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(w.Severity.Error,(0,u.localize)(0,null,F,M.toString()),{extension:O},[])})}return this.trySetWorkspaceFolders(x),!0}getWorkspaceFolder(O,$){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,$)}async getWorkspaceFolder2(O,$){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,$)}async resolveWorkspaceFolder(O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(O)}getPath(){if(!this._actualWorkspace)return;const{folders:O}=this._actualWorkspace;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,$){let G,re="";if(typeof O=="string"?(G=c.URI.file(O),re=O):typeof O!="undefined"&&(G=O,re=O.fsPath),!G)return re;const j=this.getWorkspaceFolder(G,!0);if(!j)return re;typeof $=="undefined"&&this._actualWorkspace&&($=this._actualWorkspace.folders.length>1);let N=(0,A.relativePath)(j.uri,G);return $&&j.name&&(N=`${j.name}/${N}`),N}trySetWorkspaceFolders(O){this._actualWorkspace&&(this._unconfirmedWorkspace=E.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:O,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:$,added:G,removed:re}=E.toExtHostWorkspace(O,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=$||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:G,removed:re}))}findFiles(O,$,G,re,j=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${re.value}, entryPoint: findFiles`);let N;if($===null?N=!1:$&&(typeof $=="string"?N=$:N=$.pattern),j&&j.isCancellationRequested)return Promise.resolve([]);const{includePattern:x,folder:R}=o(O);return this._proxy.$startFileSearch((0,P.withUndefinedAsNull)(x),(0,P.withUndefinedAsNull)(R),(0,P.withUndefinedAsNull)(N),(0,P.withUndefinedAsNull)(G),j).then(V=>Array.isArray(V)?V.map(F=>c.URI.revive(F)):[])}async findTextInFiles(O,$,G,re,j=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${re.value}, entryPoint: findTextInFiles`);const N=this._requestIdProvider.getNext(),x=typeof $.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:R,folder:V}=o($.include),F=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,M={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:x,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:R,excludePattern:F},B=!1;if(this._activeSearchCallbacks[N]=W=>{if(B)return;const Q=c.URI.revive(W.resource);W.results.forEach(ae=>{(0,t.resultIsMatch)(ae)?G({uri:Q,preview:{text:ae.preview.text,matches:(0,p.mapArrayOrNot)(ae.preview.matches,_e=>new v.Range(_e.startLineNumber,_e.startColumn,_e.endLineNumber,_e.endColumn))},ranges:(0,p.mapArrayOrNot)(ae.ranges,_e=>new v.Range(_e.startLineNumber,_e.startColumn,_e.endLineNumber,_e.endColumn))}):G({uri:Q,text:ae.text,lineNumber:ae.lineNumber})})},j.isCancellationRequested)return{};try{const W=await this._proxy.$startTextSearch(O,(0,P.withUndefinedAsNull)(V),M,N,j);return delete this._activeSearchCallbacks[N],W||{}}catch(W){throw delete this._activeSearchCallbacks[N],W}}$handleTextSearchResult(O,$){this._activeSearchCallbacks[$]&&this._activeSearchCallbacks[$](O)}saveAll(O){return this._proxy.$saveAll(O)}resolveProxy(O){return this._proxy.$resolveProxy(O)}get trusted(){return this._trusted}requestWorkspaceTrust(O){return this._proxy.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};S=je([We(0,h.IExtHostRpcService),We(1,d.IExtHostInitDataService),We(2,b.IExtHostFileSystemInfo),We(3,g.ILogService)],S),e.ExtHostWorkspace=S,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function o(k){let O,$;return k&&(typeof k=="string"?O=k:(O=k.pattern,$=k.baseFolder||c.URI.file(k.base))),{includePattern:O,folder:$}}}),define(he[36],fe([0,1,25,3,35,5,7,188,82,14,17,4,13,12,2]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function g(s,r){if(r){const n=r.split(".");let l=s;for(let f=0;l&&f<n.length;f++)l=l[n[f]];return l}}function w(s){return s instanceof a.URI}function _(s){return s&&s.uri instanceof a.URI&&s.languageId&&typeof s.languageId=="string"}function b(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function d(s){return s&&s.uri instanceof a.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function h(s){if(w(s))return{resource:s};if(_(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(b(s))return{overrideIdentifier:s.languageId};if(d(s))return{resource:s.uri};if(s===null)return{resource:null}}let v=class{constructor(r,n,l){this._proxy=r.getProxy(y.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=l,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new t(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,n){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(r,n))}};v=je([We(0,c.IExtHostRpcService),We(1,C.IExtHostWorkspace),We(2,u.ILogService)],v),e.ExtHostConfiguration=v;class t{constructor(r,n,l,f){this._onDidChangeConfiguration=new L.Emitter,this._proxy=r,this._logService=f,this._extHostWorkspace=n,this._configuration=I.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,n){const l={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=I.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,l))}getConfiguration(r,n,l){const f=h(n)||{},m=this._toReadonlyValue(r?g(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,f,l?.identifier);function E(o){if(o==null)return null;if(typeof o=="boolean")return o?1:4;switch(o){case T.ConfigurationTarget.Global:return 1;case T.ConfigurationTarget.Workspace:return 4;case T.ConfigurationTarget.WorkspaceFolder:return 5}}const S={has(o){return typeof g(m,o)!="undefined"},get:(o,k)=>{this._validateConfigurationAccess(r?`${r}.${o}`:o,f,l?.identifier);let O=g(m,o);if(typeof O=="undefined")O=k;else{let $;const G=(re,j)=>{let N;const x=()=>{$=$||(0,p.deepClone)(m),N=N||g($,j)};return(0,A.isObject)(re)?new Proxy(re,{get:(R,V)=>{if(typeof V=="string"&&V.toLowerCase()==="tojson")return x(),()=>N;if($)return N=N||g($,j),N[V];const F=R[V];return typeof V=="string"?G(F,`${j}.${V}`):F},set:(R,V,F)=>(x(),N&&(N[V]=F),!0),deleteProperty:(R,V)=>(x(),N&&delete N[V],!0),defineProperty:(R,V,F)=>(x(),N&&Object.defineProperty(N,V,F),!0)}):re};O=G(O,o)}return O},update:(o,k,O,$)=>{o=r?`${r}.${o}`:o;const G=E(O);return k!==void 0?this._proxy.$updateConfigurationOption(G,o,k,f,$):this._proxy.$removeConfigurationOption(G,o,f,$)},inspect:o=>{o=r?`${r}.${o}`:o;const k=(0,p.deepClone)(this._configuration.inspect(o,f,this._extHostWorkspace.workspace));if(k)return{key:o,defaultValue:k.default?.value,globalValue:k.user?.value,workspaceValue:k.workspace?.value,workspaceFolderValue:k.workspaceFolder?.value,defaultLanguageValue:k.default?.override,globalLanguageValue:k.user?.override,workspaceLanguageValue:k.workspace?.override,workspaceFolderLanguageValue:k.workspaceFolder?.override,languageIds:k.overrideIdentifiers}}};return typeof m=="object"&&(0,p.mixin)(S,m,!1),Object.freeze(S)}_toReadonlyValue(r){const n=l=>(0,A.isObject)(l)?new Proxy(l,{get:(f,m)=>n(f[m]),set:(f,m,E)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(m)}' of object`)},deleteProperty:(f,m)=>{throw new Error(`TypeError: Cannot delete read only property '${String(m)}' of object`)},defineProperty:(f,m)=>{throw new Error(`TypeError: Cannot define property '${String(m)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return n(r)}_validateConfigurationAccess(r,n,l){const f=D.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),m=l?`[${l.value}] `:"";if(f===4){typeof n?.resource=="undefined"&&this._logService.warn(`${m}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){n?.resource&&this._logService.warn(`${m}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,n){const l=new I.ConfigurationChangeEvent(r,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,m)=>l.affectsConfiguration(f,h(m))})}_toMap(r){return r.reduce((n,l)=>(n.set(l[0],l[1]),n),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(X,e,p,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!L:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(X):L?L.value:e.get(X)};define(he[66],fe([0,1,2,17,3,5,7,35,43,36,21,33,13,27,4,10,11,12,61,207,15]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u,a,g,w,_,b,d,h){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(re){function j(x){if(x!=null)return x}re.from=j;function N(x){if(x!=null)return x}re.to=N})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var s;(function(re){function j(x){if(x!=null)return x}re.from=j;function N(x){if(x!=null)return x}re.to=N})(s=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(re){function j(x){if(x!=null)return x}re.from=j;function N(x){if(x!=null)return x}re.to=N})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function(re){function j(R){if(R){const V=R;return V&&!!V.process}else return!1}re.is=j;function N(R){if(R==null)return;const V={process:R.process,args:R.args};return R.options&&(V.options=r.from(R.options)),V}re.from=N;function x(R){if(R!=null)return new T.ProcessExecution(R.process,R.args,R.options)}re.to=x})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var l;(function(re){function j(x){if(x!=null)return x}re.from=j;function N(x){if(x!=null)return x}re.to=N})(l=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var f;(function(re){function j(R){if(R){const V=R;return V&&(!!V.commandLine||!!V.command)}else return!1}re.is=j;function N(R){if(R==null)return;const V={};return R.commandLine!==void 0?V.commandLine=R.commandLine:(V.command=R.command,V.args=R.args),R.options&&(V.options=l.from(R.options)),V}re.from=N;function x(R){if(!(R==null||R.command===void 0&&R.commandLine===void 0))return R.commandLine?new T.ShellExecution(R.commandLine,R.options):new T.ShellExecution(R.command,R.args?R.args:[],R.options)}re.to=x})(f=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var m;(function(re){function j(R){if(R){let V=R;return V&&V.customExecution==="customExecution"}else return!1}re.is=j;function N(R){return{customExecution:"customExecution"}}re.from=N;function x(R,V){return V.get(R)}re.to=x})(m=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var E;(function(re){function j(N,x){let R;return N.scope!==void 0&&typeof N.scope!="number"?R=N.scope.uri:N.scope!==void 0&&typeof N.scope=="number"&&(N.scope===T.TaskScope.Workspace&&x&&x.workspaceFile?R=x.workspaceFile:R=d.USER_TASKS_GROUP_KEY),{id:N._id,workspaceFolder:R}}re.from=j})(E=e.TaskHandleDTO||(e.TaskHandleDTO={}));var S;(function(re){function j(R,V){if(R==null)return[];const F=[];for(let M of R){const B=N(M,V);B&&F.push(B)}return F}re.fromMany=j;function N(R,V){if(R==null)return;let F;R.execution instanceof T.ProcessExecution?F=n.from(R.execution):R.execution instanceof T.ShellExecution?F=f.from(R.execution):R.execution&&R.execution instanceof T.CustomExecution&&(F=m.from(R.execution));const M=t.from(R.definition);let B;if(R.scope?typeof R.scope=="number"?B=R.scope:B=R.scope.uri:B=T.TaskScope.Workspace,!M||!B)return;const W=R.group?R.group.id:void 0;return{_id:R._id,definition:M,name:R.name,source:{extensionId:V.identifier.value,label:R.source,scope:B},execution:F,isBackground:R.isBackground,group:W,presentationOptions:s.from(R.presentationOptions),problemMatchers:R.problemMatchers,hasDefinedMatchers:R.hasDefinedMatchers,runOptions:R.runOptions?R.runOptions:{reevaluateOnRerun:!0},detail:R.detail}}re.from=N;async function x(R,V,F){if(R==null)return;let M;n.is(R.execution)?M=n.to(R.execution):f.is(R.execution)?M=f.to(R.execution):m.is(R.execution)&&(M=m.to(R._id,F));const B=t.to(R.definition);let W;if(R.source&&(R.source.scope!==void 0?typeof R.source.scope=="number"?W=R.source.scope:W=await V.resolveWorkspaceFolder(p.URI.revive(R.source.scope)):W=T.TaskScope.Workspace),!B||!W)return;const Q=new T.Task(B,W,R.name,R.source.label,M,R.problemMatchers);return R.isBackground!==void 0&&(Q.isBackground=R.isBackground),R.group!==void 0&&(Q.group=T.TaskGroup.from(R.group)),R.presentationOptions&&(Q.presentationOptions=s.to(R.presentationOptions)),R._id&&(Q._id=R._id),R.detail&&(Q.detail=R.detail),Q}re.to=x})(S=e.TaskDTO||(e.TaskDTO={}));var o;(function(re){function j(x){return x}re.from=j;function N(x){if(!!x)return Object.assign(Object.create(null),x)}re.to=N})(o=e.TaskFilterDTO||(e.TaskFilterDTO={}));class k{constructor(j,N,x){this._id=N,this._task=x,v.set(this,void 0),nt(this,v,j,"f")}get task(){return this._task}terminate(){Ue(this,v,"f").terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}v=new WeakMap;var O;(function(re){function j(N){return{id:N._id,task:void 0}}re.from=j})(O=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let $=class{constructor(j,N,x,R,V,F,M,B){this._onDidExecuteTask=new C.Emitter,this._onDidTerminateTask=new C.Emitter,this._onDidTaskProcessStarted=new C.Emitter,this._onDidTaskProcessEnded=new C.Emitter,this._proxy=j.getProxy(y.MainContext.MainThreadTask),this._workspaceProvider=x,this._editorService=R,this._configurationService=V,this._terminalService=F,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=M,this._deprecationService=B,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(j,N,x){if(!x)return new T.Disposable(()=>{});const R=this.nextHandle();return this._handlers.set(R,{type:N,provider:x,extension:j}),this._proxy.$registerTaskProvider(R,N),new T.Disposable(()=>{this._handlers.delete(R),this._proxy.$unregisterTaskProvider(R)})}registerTaskSystem(j,N){this._proxy.$registerTaskSystem(j,N)}fetchTasks(j){return this._proxy.$fetchTasks(o.from(j)).then(async N=>{const x=[];for(let R of N){const V=await S.to(R,this._workspaceProvider,this._providedCustomExecutions2);V&&x.push(V)}return x})}get taskExecutions(){const j=[];return this._taskExecutions.forEach(N=>j.push(N)),j}terminateTask(j){if(!(j instanceof k))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(j._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(j,N,x){const R=this._providedCustomExecutions2.get(j.id);if(R){if(this._activeCustomExecutions2.get(j.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(j.id,R),this._terminalService.attachPtyToTerminal(N,await R.callback(x))}this._lastStartedTask=j.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(j)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(j){const N=await this.getTaskExecution(j);this._taskExecutionPromises.delete(j.id),this._taskExecutions.delete(j.id),this.customExecutionComplete(j),this._onDidTerminateTask.fire({execution:N})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(j){const N=await this.getTaskExecution(j.id);this._onDidTaskProcessStarted.fire({execution:N,processId:j.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(j){const N=await this.getTaskExecution(j.id);this._onDidTaskProcessEnded.fire({execution:N,exitCode:j.exitCode})}$provideTasks(j,N){const x=this._handlers.get(j);if(!x)return Promise.reject(new Error("no handler found"));const R=[],V=(0,L.asPromise)(()=>x.provider.provideTasks(i.CancellationToken.None)).then(F=>this.provideTasksInternal(N,R,x,F));return new Promise(F=>{V.then(M=>{Promise.all(R).then(()=>{F(M)})})})}async $resolveTask(j,N){const x=this._handlers.get(j);if(!x)return Promise.reject(new Error("no handler found"));if(N.definition.type!==x.type)throw new Error(`Unexpected: Task of type [${N.definition.type}] cannot be resolved by provider of type [${x.type}].`);const R=await S.to(N,this._workspaceProvider,this._providedCustomExecutions2);if(!R)throw new Error("Unexpected: Task cannot be resolved.");const V=await x.provider.resolveTask(R,i.CancellationToken.None);if(!V)return;this.checkDeprecation(V,x);const F=S.from(V,x.extension);if(!F)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==R.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is(F.execution)&&await this.addCustomExecution(F,V,!0),await this.resolveTaskInternal(F)}nextHandle(){return this._handleCounter++}async addCustomExecution(j,N,x){const R=await this._proxy.$createTaskId(j);!x&&!this._providedCustomExecutions2.has(R)&&this._notProvidedCustomExecutions.add(R),this._providedCustomExecutions2.set(R,N.execution)}async getTaskExecution(j,N){if(typeof j=="string"){const V=this._taskExecutionPromises.get(j);if(!V)throw new Error("Unexpected: The specified task is missing an execution");return V}let x=this._taskExecutionPromises.get(j.id);if(x)return x;const R=new Promise(async(V,F)=>{const M=N||await S.to(j.task,this._workspaceProvider,this._providedCustomExecutions2);M?V(new k(this,j.id,M)):F("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(j.id,R),R.then(V=>(this._taskExecutions.set(j.id,V),V),V=>Promise.reject(V))}checkDeprecation(j,N){j._deprecated&&this._deprecationService.report("Task.constructor",N.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(j){this._activeCustomExecutions2.get(j.id)&&this._activeCustomExecutions2.delete(j.id),this._notProvidedCustomExecutions.has(j.id)&&this._lastStartedTask!==j.id&&(this._providedCustomExecutions2.delete(j.id),this._notProvidedCustomExecutions.delete(j.id));let x=this._notProvidedCustomExecutions.values(),R=x.next();for(;!R.done;)!this._activeCustomExecutions2.has(R.value)&&this._lastStartedTask!==R.value&&(this._providedCustomExecutions2.delete(R.value),this._notProvidedCustomExecutions.delete(R.value)),R=x.next()}};$=je([We(0,c.IExtHostRpcService),We(1,u.IExtHostInitDataService),We(2,I.IExtHostWorkspace),We(3,D.IExtHostDocumentsAndEditors),We(4,A.IExtHostConfiguration),We(5,P.IExtHostTerminalService),We(6,_.ILogService),We(7,b.IExtHostApiDeprecationService)],$),e.ExtHostTaskBase=$;let G=class extends ${constructor(j,N,x,R,V,F,M,B){super(j,N,x,R,V,F,M,B);this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:"",platform:w.PlatformToString(0)})}async executeTask(j,N){if(!N.execution)throw new Error("Tasks to execute must include an execution");const x=S.from(N,j);if(x===void 0)throw new Error("Task is not valid");if(m.is(x.execution))await this.addCustomExecution(x,N,!1);else throw new h.NotSupportedError;const R=await this.getTaskExecution(await this._proxy.$getTaskExecution(x),N);return this._proxy.$executeTask(x).catch(V=>{throw new Error(V)}),R}provideTasksInternal(j,N,x,R){const V=[];if(R)for(let F of R){this.checkDeprecation(F,x),(!F.definition||!j[F.definition.type])&&this._logService.warn(`The task [${F.source}, ${F.name}] uses an undefined task type. The task will be ignored in the future.`);const M=S.from(F,x.extension);M&&m.is(M.execution)?(V.push(M),N.push(this.addCustomExecution(M,F,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:V,extension:x.extension}}async resolveTaskInternal(j){if(m.is(j.execution))return j;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(j,N){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,N,x){}};G=je([We(0,c.IExtHostRpcService),We(1,u.IExtHostInitDataService),We(2,I.IExtHostWorkspace),We(3,D.IExtHostDocumentsAndEditors),We(4,A.IExtHostConfiguration),We(5,P.IExtHostTerminalService),We(6,_.ILogService),We(7,b.IExtHostApiDeprecationService)],G),e.WorkerExtHostTask=G,e.IExtHostTask=(0,a.createDecorator)("IExtHostTask")}),define(he[260],fe([0,1,18,69,30,76,23,10,9,24,8,14,2,142,170,117,47,124,259,31]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u,a,g,w,_,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let h=class{constructor(E,S,o,k){this.configurationService=E,this.workspaceContextService=S,this.editorGroupsService=o,this.pathService=k}text(E,S,o={}){E=this.getContentPattern(E,o);const k=this.configurationService.getValue(),O=S&&S.some(G=>!this.configurationService.getValue({resource:G}).search.useRipgrep);return{...this.commonQuery(S?.map(w.toWorkspaceFolder),o),type:2,contentPattern:E,previewOptions:o.previewOptions,maxFileSize:o.maxFileSize,usePCRE2:k.search.usePCRE2||O||!1,beforeContext:o.beforeContext,afterContext:o.afterContext,userDisabledExcludesAndIgnoreFiles:o.disregardExcludeSettings&&o.disregardIgnoreFiles}}getContentPattern(E,S){const o=this.configurationService.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const k={...E,wordSeparators:o.editor.wordSeparators};return this.isCaseSensitive(E,S)&&(k.isCaseSensitive=!0),this.isMultiline(E)&&(k.isMultiline=!0),k}file(E,S={}){return{...this.commonQuery(E,S),type:1,filePattern:S.filePattern?S.filePattern.trim():S.filePattern,exists:S.exists,sortByScore:S.sortByScore,cacheKey:S.cacheKey}}handleIncludeExclude(E,S){return E?(E=Array.isArray(E)?E.map(n):n(E),S?this.parseSearchPaths(E):{pattern:t(...Array.isArray(E)?E:[E])}):{}}commonQuery(E=[],S={}){const o=this.handleIncludeExclude(S.includePattern,S.expandPatterns),k=this.handleIncludeExclude(S.excludePattern,S.expandPatterns),O=E.length>1,$=(o.searchPaths&&o.searchPaths.length?o.searchPaths.map(j=>this.getFolderQueryForSearchPath(j,S,k)):E.map(j=>this.getFolderQueryForRoot(j,S,k,O))).filter(j=>!!j),G={_reason:S._reason,folderQueries:$,usingSearchPaths:!!(o.searchPaths&&o.searchPaths.length),extraFileResources:S.extraFileResources,excludePattern:k.pattern,includePattern:o.pattern,onlyOpenEditors:S.onlyOpenEditors,maxResults:S.maxResults};if(S.onlyOpenEditors){const N=p.coalesce(p.flatten(this.editorGroupsService.groups.map(R=>R.editors.map(V=>V.resource)))).filter(R=>(0,d.pathIncludedInQuery)(G,R.fsPath)),x=this.commonQueryFromFileList(N);return{...G,...x}}const re=S.extraFileResources&&S.extraFileResources.filter(j=>(0,d.pathIncludedInQuery)(G,j.fsPath));return G.extraFileResources=re&&re.length?re:void 0,G}commonQueryFromFileList(E){const S=[],o=new T.ResourceMap,k={};let O=!1;return E.forEach($=>{if($.scheme===I.Schemas.walkThrough)return;if((0,A.isAbsolutePath)($)){const re=this.workspaceContextService.getWorkspaceFolder($)?.uri??$.with({path:D.dirname($.fsPath)});let j=o.get(re);j||(O=!0,j={folder:re,includePattern:{}},S.push(j),o.set(re,j));const N=D.relative(re.fsPath,$.fsPath);(0,P.assertIsDefined)(j.includePattern)[N.replace(/\\/g,"/")]=!0}else $.fsPath&&(O=!0,k[$.fsPath]=!0)}),{folderQueries:S,includePattern:k,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}isCaseSensitive(E,S){if(S.isSmartCase){if(E.isRegExp){if(i.containsUppercaseCharacter(E.pattern,!0))return!0}else if(i.containsUppercaseCharacter(E.pattern))return!0}return!!E.isCaseSensitive}isMultiline(E){return E.isMultiline||E.isRegExp&&(0,u.isMultilineRegexSource)(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const S=x=>D.isAbsolute(x)||/^\.\.?([\/\\]|$)/.test(x),k=(Array.isArray(E)?E:s(E)).map(x=>{const R=this.pathService.resolvedUserHome;return R?(0,y.untildify)(x,R.scheme===I.Schemas.file?R.fsPath:R.path):x}),O=L.groupBy(k,x=>S(x)?"searchPaths":"exprSegments"),$=(O.exprSegments||[]).map(x=>i.rtrim(x,"/")).map(x=>i.rtrim(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),r(x))),G={},re=this.expandSearchPathPatterns(O.searchPaths||[]);re&&re.length&&(G.searchPaths=re);const j=p.flatten($),N=t(...j);return N&&(G.pattern=N),G}getExcludesForFolder(E,S){return S.disregardExcludeSettings?void 0:(0,d.getExcludes)(E,!S.disregardSearchExcludeSettings)}expandSearchPathPatterns(E){if(!E||!E.length)return[];const S=p.flatten(E.map(k=>{let{pathPortion:O,globPortion:$}=v(k);$&&($=l($));const G=this.expandOneSearchPath(O);return p.flatten(G.map(re=>this.resolveOneSearchPathPattern(re,$)))})),o=new Map;return S.forEach(k=>{const O=k.searchPath.toString(),$=o.get(O);$?k.pattern&&($.pattern=$.pattern||{},$.pattern[k.pattern]=!0):o.set(O,{searchPath:k.searchPath,pattern:k.pattern?t(k.pattern):void 0})}),Array.from(o.values())}expandOneSearchPath(E){if(D.isAbsolute(E)){const S=this.workspaceContextService.getWorkspace().folders;return S[0]&&S[0].uri.scheme!==I.Schemas.file?[{searchPath:S[0].uri.with({path:E})}]:[{searchPath:c.URI.file(D.normalize(E))}]}if(this.workspaceContextService.getWorkbenchState()===2){const S=this.workspaceContextService.getWorkspace().folders[0].uri;if(E=n(E),E.startsWith("../")||E===".."){const k=D.posix.resolve(S.path,E);return[{searchPath:S.with({path:k})}]}const o=l(E);return[{searchPath:S,pattern:o}]}else{if(E==="./"||E===".\\")return[];{const S=E.replace(/^\.[\/\\]/,""),k=this.workspaceContextService.getWorkspace().folders.map(O=>{const $=S.match(new RegExp(`^${i.escapeRegExpCharacters(O.name)}(?:/(.*)|$)`));return $?{match:$,folder:O}:null}).filter(P.isDefined);if(k.length)return k.map(O=>{const $=O.match[1];return{searchPath:O.folder.uri,pattern:$&&l($)}});{const O=E.match(/\.[\/\\](.+)[\/\\]?/),$=O?O[1]:E,G=a.localize(0,null,$);throw new Error(G)}}}}resolveOneSearchPathPattern(E,S){const o=E.pattern&&S?`${E.pattern}/${S}`:E.pattern||S,k=[{searchPath:E.searchPath,pattern:o}];return o&&!o.endsWith("**")&&k.push({searchPath:E.searchPath,pattern:o+"/**"}),k}getFolderQueryForSearchPath(E,S,o){const k=this.getFolderQueryForRoot((0,w.toWorkspaceFolder)(E.searchPath),S,o,!1);return k?{...k,includePattern:E.pattern}:null}getFolderQueryForRoot(E,S,o,k){let O;const $=c.URI.isUri(E)?E:E.uri;if(o.searchPaths){const x=o.searchPaths.filter(R=>(0,A.isEqual)(R.searchPath,$))[0];if(x&&!x.pattern)return null;x&&(O=x.pattern)}const G=this.configurationService.getValue({resource:$}),j={...this.getExcludesForFolder(G,S)||{},...O||{}},N=c.URI.isUri(E)?(0,A.basename)(E):E.name;return{folder:$,folderName:k?N:void 0,excludePattern:Object.keys(j).length>0?j:void 0,fileEncoding:G.files&&G.files.encoding,disregardIgnoreFiles:typeof S.disregardIgnoreFiles=="boolean"?S.disregardIgnoreFiles:!G.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof S.disregardGlobalIgnoreFiles=="boolean"?S.disregardGlobalIgnoreFiles:!G.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof S.ignoreSymlinks=="boolean"?S.ignoreSymlinks:!G.search.followSymlinks}}};h=je([We(0,g.IConfigurationService),We(1,w.IWorkspaceContextService),We(2,_.IEditorGroupsService),We(3,b.IPathService)],h),e.QueryBuilder=h;function v(m){const E=m.match(/[\*\{\}\(\)\[\]\?]/);if(E){const S=E.index,o=m.substr(0,S).match(/[/|\\][^/\\]*$/);if(o){let k=m.substr(0,o.index);return k.match(/[/\\]/)||(k+="/"),{pathPortion:k,globPortion:m.substr((o.index||0)+1)}}}return{pathPortion:m}}function t(...m){return m.length?m.reduce((E,S)=>(E[S]=!0,E),Object.create(null)):void 0}function s(m){return C.splitGlobAware(m,",").map(E=>E.trim()).filter(E=>!!E.length)}function r(m){return[`**/${m}/**`,`**/${m}`].map(S=>S.replace(/\*\*\/\*\*/g,"**"))}function n(m){return m.replace(/\\/g,"/")}function l(m){return n(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(m,E){m=p.distinct(m,k=>k.toString());const S=[],o=E.getWorkspace();return m&&m.forEach(k=>{let O;if(E.getWorkbenchState()===2)O=(0,A.relativePath)(o.folders[0].uri,k),O&&O!=="."&&(O="./"+O);else{const $=E.getWorkspaceFolder(k);if($){const G=$.name;if(o.folders.filter(j=>j.name===G).length===1){const j=(0,A.relativePath)($.uri,k);j===""?O=`./${$.name}`:O=`./${$.name}/${j}`}else O=k.fsPath}}O&&S.push(O)}),S}e.resolveResourcesForSearchIncludes=f}),define(he[261],fe([0,1,24,2,21,15,4,260,31,47]),function(X,e,p,L,C,y,T,I,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function P(g,w){const _=w.activationEvents;if(!_)return Promise.resolve(void 0);const b=[],d=[];for(const n of _)if(/^workspaceContains:/.test(n)){const l=n.substr("workspaceContains:".length);l.indexOf("*")>=0||l.indexOf("?")>=0||g.forceUsingSearch?d.push(l):b.push(l)}if(b.length===0&&d.length===0)return Promise.resolve(void 0);let h;const v=new Promise((n,l)=>{h=n}),t=n=>h({activationEvent:n}),s=Promise.all(b.map(n=>c(g,n,t))).then(()=>{}),r=u(g,w.identifier,d,t);return Promise.all([s,r]).then(()=>{h(void 0)}),v}e.checkActivateWorkspaceContainsExtension=P;async function c(g,w,_){for(const b of g.folders)if(await g.exists(p.joinPath(L.URI.revive(b),w))){_(`workspaceContains:${w}`);return}}async function u(g,w,_,b){if(_.length===0)return Promise.resolve(void 0);const d=new C.CancellationTokenSource,h=g.checkExists(g.folders,_,d.token),v=setTimeout(async()=>{d.cancel(),b(`workspaceContainsTimeout:${_.join(",")}`)},i);let t=!1;try{t=await h}catch(s){y.isPromiseCanceledError(s)||y.onUnexpectedError(s)}d.dispose(),clearTimeout(v),t&&b(`workspaceContains:${_.join(",")}`)}function a(g,w,_,b){const d=g.get(T.IInstantiationService),h=g.get(D.ISearchService),t=d.createInstance(I.QueryBuilder).file(w.map(s=>(0,A.toWorkspaceFolder)(L.URI.revive(s))),{_reason:"checkExists",includePattern:_,exists:!0});return h.fileSearch(t,b).then(s=>!!s.limitHit,s=>y.isPromiseCanceledError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=a});var nt=this&&this.__classPrivateFieldSet||function(X,e,p,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!L:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(X):L?L.value:e.get(X)};define(he[39],fe([0,1,160,9,67,24,17,6,23,2,12,5,36,220,90,35,34,218,15,26,22,196,7,118,4,27,63,13,81,49,33,3,261,88,198]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u,a,g,w,_,b,d,h,v,t,s,r,n,l,f,m,E,S,o,k,O,$){"use strict";var G,re,j;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let N=class $n extends I.Disposable{constructor(F,M,B,W,Q,ae,_e,Fe,Ae,Me){super();this._onDidChangeRemoteConnectionData=this._register(new o.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=M,this._extHostContext=B,this._initData=_e,this._extHostWorkspace=W,this._extHostConfiguration=Q,this._logService=ae,this._extHostTunnelService=Ae,this._extHostTerminalService=Me,this._disposables=new I.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(P.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(P.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(P.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._registry=new _.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new a.ExtHostStorage(this._extHostContext),this._secretState=new O.ExtHostSecretState(this._extHostContext),this._storagePath=Fe,this._instaService=F.createChild(new m.ServiceCollection([a.IExtHostStorage,this._storage],[O.IExtHostSecretState,this._secretState]));const Ve=new Set;this._initData.hostExtensions.forEach(He=>Ve.add(d.ExtensionIdentifier.toKey(He))),this._activator=new u.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(He,z,J)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(He,b.transformErrorForSerialization(z),J)},actualActivateExtension:async(He,z)=>{if(Ve.has(d.ExtensionIdentifier.toKey(He)))return await this._mainThreadExtensionsProxy.$activateExtension(He,z),new u.HostExtension;const J=this._registry.getExtensionDescription(He);return this._activateExtension(J,z)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),C.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(F){b.onUnexpectedError(F)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let F=[];try{F=this._registry.getAllExtensionDescriptions().map(Q=>Q.identifier).filter(Q=>this.isActivated(Q)).map(Q=>this._deactivate(Q))}catch(M){}await Promise.all(F)}isActivated(F){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(F):!1}_activateByEvent(F,M){return this._activator.activateByEvent(F,M)}_activateById(F,M){return this._activator.activateById(F,M)}activateByIdWithErrors(F,M){return this._activateById(F,M).then(()=>{const B=this._activator.getActivatedExtension(F);if(B.activationFailed)return Promise.reject(B.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(F=>this._registry)}getExtensionExports(F){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(F).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const F=D.TernarySearchTree.forPaths(),M=this._registry.getAllExtensionDescriptions().map(B=>{if(!!this._getEntryPoint(B))return this._hostUtils.realpath(B.extensionLocation.fsPath).then(W=>F.set(A.URI.file(W).fsPath,B))});this._extensionPathIndex=Promise.all(M).then(()=>F)}return this._extensionPathIndex}_deactivate(F){let M=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(F))return M;const B=this._activator.getActivatedExtension(F);if(!B)return M;try{typeof B.module.deactivate=="function"&&(M=Promise.resolve(B.module.deactivate()).then(void 0,W=>(this._logService.error(W),Promise.resolve(void 0))))}catch(W){this._logService.error(W)}try{(0,I.dispose)(B.subscriptions)}catch(W){this._logService.error(W)}return M}async _activateExtension(F,M){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier),this._doActivateExtension(F,M).then(B=>{const W=B.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(F.identifier,W.codeLoadingTime,W.activateCallTime,W.activateResolvedTime,M),this._logExtensionActivationTimes(F,M,"success",W),B},B=>{throw this._logExtensionActivationTimes(F,M,"failure"),B})}_logExtensionActivationTimes(F,M,B,W){const Q=x(F,M);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Q,...W||{},outcome:B})}_doActivateExtension(F,M){const B=x(F,M);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",B);const W=this._getEntryPoint(F);if(!W)return Promise.resolve(new u.EmptyExtension(u.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${F.identifier.value} ${JSON.stringify(M)}`),this._logService.flush();const Q=new u.ExtensionActivationTimesBuilder(M.startup);return Promise.all([this._loadCommonJSModule(F.identifier,(0,y.joinPath)(F.extensionLocation,W),Q),this._loadExtensionContext(F)]).then(ae=>(C.mark(`code/extHost/willActivateExtension/${F.identifier.value}`),$n._callActivate(this._logService,F.identifier,ae[0],ae[1],Q))).then(ae=>(C.mark(`code/extHost/didActivateExtension/${F.identifier.value}`),ae))}_loadExtensionContext(F){const M=new v.ExtensionGlobalMemento(F,this._storage),B=new v.ExtensionMemento(F.identifier.value,!1,this._storage),W=new $.ExtensionSecrets(F,this._secretState),Q=F.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ae=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${F.identifier.value}`),Promise.all([M.whenReady,B.whenReady,this._storagePath.whenReady]).then(()=>{const _e=this;let Fe;return Object.freeze({globalState:M,workspaceState:B,secrets:W,subscriptions:[],get extensionUri(){return F.extensionLocation},get extensionPath(){return F.extensionLocation.fsPath},asAbsolutePath(Ae){return L.join(F.extensionLocation.fsPath,Ae)},get storagePath(){return _e._storagePath.workspaceValue(F)?.fsPath},get globalStoragePath(){return _e._storagePath.globalValue(F).fsPath},get logPath(){return L.join(_e._initData.logsLocation.fsPath,F.identifier.value)},get logUri(){return A.URI.joinPath(_e._initData.logsLocation,F.identifier.value)},get storageUri(){return _e._storagePath.workspaceValue(F)},get globalStorageUri(){return _e._storagePath.globalValue(F)},get extensionMode(){return Q},get extension(){return Fe===void 0&&(Fe=new R(_e,F.identifier,F,ae)),Fe},get extensionRuntime(){return(0,w.checkProposedApiEnabled)(F),_e.extensionRuntime},get environmentVariableCollection(){return _e._extHostTerminalService.getEnvironmentVariableCollection(F)}})})}static _callActivate(F,M,B,W,Q){return B=B||{activate:void 0,deactivate:void 0},this._callActivateOptional(F,M,B,W,Q).then(ae=>new u.ActivatedExtension(!1,null,Q.build(),B,ae,W.subscriptions))}static _callActivateOptional(F,M,B,W,Q){if(typeof B.activate=="function")try{Q.activateCallStart(),F.trace(`ExtensionService#_callActivateOptional ${M.value}`);const ae=typeof global=="object"?global:self,_e=B.activate.apply(ae,[W]);return Q.activateCallStop(),Q.activateResolveStart(),Promise.resolve(_e).then(Fe=>(Q.activateResolveStop(),Fe))}catch(ae){return Promise.reject(ae)}else return Promise.resolve(B)}_activateOneStartupFinished(F,M){this._activateById(F.identifier,{startup:!1,extensionId:F.identifier,activationEvent:M}).then(void 0,B=>{this._logService.error(B)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(C.getMarks());for(const F of this._registry.getAllExtensionDescriptions())if(F.activationEvents)for(const M of F.activationEvents)M==="onStartupFinished"&&this._activateOneStartupFinished(F,M)}_handleEagerExtensions(){const F=this._activateByEvent("*",!0).then(void 0,Q=>{this._logService.error(Q)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Q=>this._handleWorkspaceContainsEagerExtensions(Q.added)));const M=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],B=this._handleWorkspaceContainsEagerExtensions(M),W=Promise.all([F,B]).then(()=>{});return Promise.race([W,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),W}_handleWorkspaceContainsEagerExtensions(F){return F.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(M=>this._handleWorkspaceContainsEagerExtension(F,M))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(F,M){if(this.isActivated(M.identifier))return;const B=!this._initData.remote.isRemote&&!!this._initData.remote.authority,W={folders:F.map(ae=>ae.uri),forceUsingSearch:B,exists:ae=>this._hostUtils.exists(ae.fsPath),checkExists:(ae,_e,Fe)=>this._mainThreadWorkspaceProxy.$checkExists(ae,_e,Fe)},Q=await(0,k.checkActivateWorkspaceContainsExtension)(W,M);if(!!Q)return this._activateById(M.identifier,{startup:!0,extensionId:M.identifier,activationEvent:Q.activationEvent}).then(void 0,ae=>this._logService.error(ae))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(F){throw console.error(F),F}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:F,extensionTestsLocationURI:M}=this._initData.environment;if(!F||!M)throw new Error(p.localize(0,null));const B=await this._loadCommonJSModule(null,M,new u.ExtensionActivationTimesBuilder(!1));if(!B||typeof B.run!="function")throw new Error(p.localize(1,null,M.toString()));return new Promise((W,Q)=>{const ae=(Ae,Me)=>{Ae?Q(Ae):W(typeof Me=="number"&&Me>0?1:0)},_e=(0,y.originalFSPath)(M),Fe=B.run(_e,ae);Fe&&Fe.then&&Fe.then(()=>{W(0)}).catch(Ae=>{Q(Ae.toString())})})}async $extensionTestsExit(F){this._logService.info(`extension host terminating: test runner requested exit with code ${F}`),this._logService.info(`exiting with code ${F}`),this._logService.flush(),this._hostUtils.exit(F)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(F,M){return this._resolvers[F]=M,(0,I.toDisposable)(()=>{delete this._resolvers[F]})}async _activateAndGetResolver(F){const M=F.indexOf("+");if(M===-1)throw new Error("Not an authority that can be resolved!");const B=F.substr(0,M);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${B}`,!1),{authorityPrefix:B,resolver:this._resolvers[B]}}async $resolveAuthority(F,M){const{authorityPrefix:B,resolver:W}=await this._activateAndGetResolver(F);if(!W)return{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${B}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(W)),C.mark(`code/extHost/willResolveAuthority/${B}`);const Q=await W.resolve(F,{resolveAttempt:M});C.mark(`code/extHost/didResolveAuthorityOK/${B}`);const ae={authority:F,host:Q.host,port:Q.port,connectionToken:Q.connectionToken},_e={extensionHostEnv:Q.extensionHostEnv,isTrusted:Q.isTrusted};return{type:"ok",value:{authority:ae,options:_e,tunnelInformation:{environmentTunnels:Q.environmentTunnels}}}}catch(Q){if(C.mark(`code/extHost/didResolveAuthorityError/${B}`),Q instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q}}async $getCanonicalURI(F,M){const{authorityPrefix:B,resolver:W}=await this._activateAndGetResolver(F);if(!W)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${B}`);const Q=A.URI.revive(M);if(typeof W.getCanonicalURI=="undefined")return Q;const ae=await(0,T.asPromise)(()=>W.getCanonicalURI(Q));return ae||Q}$startExtensionHost(F){return this._registry.keepOnly(F),this._startExtensionHost()}$activateByEvent(F,M){return M===1?this._activateByEvent(F,!1):this._readyToRunExtensions.wait().then(B=>this._activateByEvent(F,!1))}async $activate(F,M){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(F)?(await this._activateById(F,M),!0):!1}async $deltaExtensions(F,M){F.forEach(W=>W.extensionLocation=A.URI.revive(W.extensionLocation));const B=await this.getExtensionPathIndex();return await Promise.all(M.map(async W=>{const Q=this._registry.getExtensionDescription(W);if(!Q)return;const ae=await this._hostUtils.realpath(Q.extensionLocation.fsPath);B.delete(A.URI.file(ae).fsPath)})),await Promise.all(F.map(async W=>{const Q=await this._hostUtils.realpath(W.extensionLocation.fsPath);B.set(A.URI.file(Q).fsPath,W)})),this._registry.deltaExtensions(F,M),Promise.resolve(void 0)}async $test_latency(F){return F}async $test_up(F){return F.byteLength}async $test_down(F){let M=h.VSBuffer.alloc(F),B=Math.random()%256;for(let W=0;W<F;W++)M.writeUInt8(B,W);return M}async $updateRemoteConnectionData(F){this._remoteConnectionData=F,this._onDidChangeRemoteConnectionData.fire()}};N=je([We(0,r.IInstantiationService),We(1,e.IHostUtils),We(2,f.IExtHostRpcService),We(3,g.IExtHostWorkspace),We(4,c.IExtHostConfiguration),We(5,i.ILogService),We(6,n.IExtHostInitDataService),We(7,l.IExtensionStoragePaths),We(8,E.IExtHostTunnelService),We(9,S.IExtHostTerminalService)],N),e.AbstractExtHostExtensionService=N;function x(V,F){return{id:V.identifier.value,name:V.name,extensionVersion:V.version,publisherDisplayName:V.publisher,activationEvents:V.activationEvents?V.activationEvents.join(","):null,isBuiltin:V.isBuiltin,reason:F.activationEvent,reasonId:F.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class R{constructor(F,M,B,W){G.set(this,void 0),re.set(this,void 0),j.set(this,void 0),nt(this,G,F,"f"),nt(this,re,M,"f"),nt(this,j,B.identifier,"f"),this.id=B.identifier.value,this.extensionUri=B.extensionLocation,this.extensionPath=L.normalize((0,y.originalFSPath)(B.extensionLocation)),this.packageJSON=B,this.extensionKind=W}get isActive(){return Ue(this,G,"f").isActivated(Ue(this,j,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ue(this,G,"f").getExtensionExports(Ue(this,j,"f"))}activate(){return Ue(this,G,"f").activateByIdWithErrors(Ue(this,j,"f"),{startup:!1,extensionId:Ue(this,re,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=R,G=new WeakMap,re=new WeakMap,j=new WeakMap}),define(he[51],fe([0,1,9,2,3,17,5,7,121,35,39,43,209,36,204,13,4,14,37,48]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u,a,g,w,_,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,w.createDecorator)("IExtHostDebugService");let h=class{constructor(m,E,S,o,k,O){this._workspaceService=E,this._extensionService=S,this._editorsService=o,this._configurationService=k,this._editorTabs=O,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new C.Emitter,this._onDidTerminateDebugSession=new C.Emitter,this._onDidChangeActiveDebugSession=new C.Emitter,this._onDidReceiveDebugSessionCustomEvent=new C.Emitter,this._debugServiceProxy=m.getProxy(T.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new C.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then($=>{$.onDidChange(G=>{this.registerAllDebugTypes($)}),this.registerAllDebugTypes($)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(m,E){const S=m;if(typeof S.sourceReference=="number"&&S.sourceReference>0){let o=`debug:${encodeURIComponent(S.path||"")}`,k="?";return E&&(o+=`${k}session=${encodeURIComponent(E.id)}`,k="&"),o+=`${k}ref=${S.sourceReference}`,L.URI.parse(o)}else{if(S.path)return L.URI.file(S.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(m){const E=[];for(const S of m.getAllExtensionDescriptions())if(S.contributes){const o=S.contributes.debuggers;if(o&&o.length>0)for(const k of o)(0,a.isDebuggerMainContribution)(k)&&E.push(k.type)}this._debugServiceProxy.$registerDebugTypes(E)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const m=[];return this._breakpoints.forEach(E=>m.push(E)),m}addBreakpoints(m){this.startBreakpoints();const E=m.filter(k=>{const O=k.id;return this._breakpoints.has(O)?!1:(this._breakpoints.set(O,k),!0)});this.fireBreakpointChanges(E,[],[]);const S=[],o=new Map;for(const k of E)if(k instanceof I.SourceBreakpoint){let O=o.get(k.location.uri.toString());O||(O={type:"sourceMulti",uri:k.location.uri,lines:[]},o.set(k.location.uri.toString(),O),S.push(O)),O.lines.push({id:k.id,enabled:k.enabled,condition:k.condition,hitCondition:k.hitCondition,logMessage:k.logMessage,line:k.location.range.start.line,character:k.location.range.start.character})}else k instanceof I.FunctionBreakpoint&&S.push({type:"function",id:k.id,enabled:k.enabled,hitCondition:k.hitCondition,logMessage:k.logMessage,condition:k.condition,functionName:k.functionName});return this._debugServiceProxy.$registerBreakpoints(S)}removeBreakpoints(m){this.startBreakpoints();const E=m.filter(O=>this._breakpoints.delete(O.id));this.fireBreakpointChanges([],E,[]);const S=E.filter(O=>O instanceof I.SourceBreakpoint).map(O=>O.id),o=E.filter(O=>O instanceof I.FunctionBreakpoint).map(O=>O.id),k=E.filter(O=>O instanceof I.DataBreakpoint).map(O=>O.id);return this._debugServiceProxy.$unregisterBreakpoints(S,o,k)}startDebugging(m,E,S){return this._debugServiceProxy.$startDebugging(m?m.uri:void 0,E,{parentSessionID:S.parentSession?S.parentSession.id:void 0,repl:S.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:S.noDebug,compact:S.compact})}stopDebugging(m){return this._debugServiceProxy.$stopDebugging(m?m.id:void 0)}registerDebugConfigurationProvider(m,E,S){if(!E)return new I.Disposable(()=>{});const o=this._configProviderHandleCounter++;return this._configProviders.push({type:m,handle:o,provider:E}),this._debugServiceProxy.$registerDebugConfigurationProvider(m,S,!!E.provideDebugConfigurations,!!E.resolveDebugConfiguration,!!E.resolveDebugConfigurationWithSubstitutedVariables,o),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(k=>k.provider!==E),this._debugServiceProxy.$unregisterDebugConfigurationProvider(o)})}registerDebugAdapterDescriptorFactory(m,E,S){if(!S)return new I.Disposable(()=>{});if(!this.definesDebugType(m,E))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${E}' debugger.`);if(this.getAdapterDescriptorFactoryByType(E))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const o=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:E,handle:o,factory:S}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(E,o),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(k=>k.factory!==S),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(o)})}registerDebugAdapterTrackerFactory(m,E){if(!E)return new I.Disposable(()=>{});const S=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:m,handle:S,factory:E}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(o=>o.factory!==E)})}async $runInTerminal(m,E){return Promise.resolve(void 0)}async $substituteVariables(m,E){if(!this._variableResolver){const[k,O]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(k||[],this._editorsService,O)}let S;const o=await this.getFolder(m);return o&&(S={uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(S,E)}createDebugAdapter(m,E){if(m.type==="implementation")return new n(m.implementation)}createSignService(){}async $startDASession(m,E){const S=this,o=await this.getSession(E);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(o.type),o).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}' (extension might have failed to activate)`);const O=this.convertToDto(k),$=this.createDebugAdapter(O,o);if(!$)throw new Error(`Couldn't create a debug adapter for type '${o.type}'.`);const G=$;return this._debugAdapters.set(m,G),this.getDebugAdapterTrackers(o).then(re=>(re&&this._debugAdaptersTrackers.set(m,re),G.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const N=j,x={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const R=await this._signService.sign(N.arguments.value);x.body={signature:R},G.sendResponse(x)}else throw new Error("no signer")}catch(R){x.success=!1,x.message=R.message,G.sendResponse(x)}}else re&&re.onDidSendMessage&&re.onDidSendMessage(j),j=(0,a.convertToVSCPaths)(j,!0),S._debugServiceProxy.$acceptDAMessage(m,j)}),G.onError(j=>{re&&re.onError&&re.onError(j),this._debugServiceProxy.$acceptDAError(m,j.name,j.message,j.stack)}),G.onExit(j=>{re&&re.onExit&&re.onExit((0,_.withNullAsUndefined)(j),void 0),this._debugServiceProxy.$acceptDAExit(m,(0,_.withNullAsUndefined)(j),void 0)}),re&&re.onWillStartSession&&re.onWillStartSession(),G.startSession()))})}$sendDAMessage(m,E){E=(0,a.convertToDAPaths)(E,!1);const S=this._debugAdaptersTrackers.get(m);S&&S.onWillReceiveMessage&&S.onWillReceiveMessage(E);const o=this._debugAdapters.get(m);o&&o.sendMessage(E)}$stopDASession(m){const E=this._debugAdaptersTrackers.get(m);this._debugAdaptersTrackers.delete(m),E&&E.onWillStopSession&&E.onWillStopSession();const S=this._debugAdapters.get(m);return this._debugAdapters.delete(m),S?S.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(m){const E=[],S=[],o=[];if(m.added)for(const k of m.added){const O=k.id;if(O&&!this._breakpoints.has(O)){let $;if(k.type==="function")$=new I.FunctionBreakpoint(k.functionName,k.enabled,k.condition,k.hitCondition,k.logMessage);else if(k.type==="data")$=new I.DataBreakpoint(k.label,k.dataId,k.canPersist,k.enabled,k.hitCondition,k.condition,k.logMessage);else{const G=L.URI.revive(k.uri);$=new I.SourceBreakpoint(new I.Location(G,new I.Position(k.line,k.character)),k.enabled,k.condition,k.hitCondition,k.logMessage)}$._id=O,this._breakpoints.set(O,$),E.push($)}}if(m.removed)for(const k of m.removed){const O=this._breakpoints.get(k);O&&(this._breakpoints.delete(k),S.push(O))}if(m.changed){for(const k of m.changed)if(k.id){const O=this._breakpoints.get(k.id);if(O){if(O instanceof I.FunctionBreakpoint&&k.type==="function"){const $=O;$.enabled=k.enabled,$.condition=k.condition,$.hitCondition=k.hitCondition,$.logMessage=k.logMessage,$.functionName=k.functionName}else if(O instanceof I.SourceBreakpoint&&k.type==="source"){const $=O;$.enabled=k.enabled,$.condition=k.condition,$.hitCondition=k.hitCondition,$.logMessage=k.logMessage,$.location=new I.Location(L.URI.revive(k.uri),new I.Position(k.line,k.character))}o.push(O)}}}this.fireBreakpointChanges(E,S,o)}$provideDebugConfigurations(m,E,S){return(0,y.asPromise)(async()=>{const o=this.getConfigProviderByHandle(m);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const k=await this.getFolder(E);return o.provideDebugConfigurations(k,S)}).then(o=>{if(!o)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return o})}$resolveDebugConfiguration(m,E,S,o){return(0,y.asPromise)(async()=>{const k=this.getConfigProviderByHandle(m);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const O=await this.getFolder(E);return k.resolveDebugConfiguration(O,S,o)})}$resolveDebugConfigurationWithSubstitutedVariables(m,E,S,o){return(0,y.asPromise)(async()=>{const k=this.getConfigProviderByHandle(m);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const O=await this.getFolder(E);return k.resolveDebugConfigurationWithSubstitutedVariables(O,S,o)})}async $provideDebugAdapter(m,E){const S=this.getAdapterDescriptorFactoryByHandle(m);if(!S)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const o=await this.getSession(E);return this.getAdapterDescriptor(S,o).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}'`);return this.convertToDto(k)})}async $acceptDebugSessionStarted(m){const E=await this.getSession(m);this._onDidStartDebugSession.fire(E)}async $acceptDebugSessionTerminated(m){const E=await this.getSession(m);E&&(this._onDidTerminateDebugSession.fire(E),this._debugSessions.delete(E.id))}async $acceptDebugSessionActiveChanged(m){this._activeDebugSession=m?await this.getSession(m):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(m,E){const S=await this.getSession(m);S&&S._acceptNameChanged(E)}async $acceptDebugSessionCustomEvent(m,E){const o={session:await this.getSession(m),event:E.event,body:E.body};this._onDidReceiveDebugSessionCustomEvent.fire(o)}convertToDto(m){if(m instanceof I.DebugAdapterExecutable)return{type:"executable",command:m.command,args:m.args,options:m.options};if(m instanceof I.DebugAdapterServer)return{type:"server",port:m.port,host:m.host};if(m instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:m.path};if(m instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:m.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(m){const E=this._adapterFactories.filter(S=>S.type===m);if(E.length>0)return E[0].factory}getAdapterDescriptorFactoryByHandle(m){const E=this._adapterFactories.filter(S=>S.handle===m);if(E.length>0)return E[0].factory}getConfigProviderByHandle(m){const E=this._configProviders.filter(S=>S.handle===m);if(E.length>0)return E[0].provider}definesDebugType(m,E){if(m.contributes){const S=m.contributes.debuggers;if(S&&S.length>0){for(const o of S)if(o.label&&o.type&&o.type===E)return!0}}return!1}getDebugAdapterTrackers(m){const S=m.configuration.type,o=this._trackerFactories.filter(k=>k.type===S||k.type==="*").map(k=>(0,y.asPromise)(()=>k.factory.createDebugAdapterTracker(m)).then(O=>O,O=>null));return Promise.race([Promise.all(o).then(k=>{const O=k.filter($=>!!$);if(O.length>0)return new r(O)}),new Promise((k,O)=>{const $=setTimeout(()=>{clearTimeout($),O(new Error("timeout"))},1e3)})]).catch(k=>{})}async getAdapterDescriptor(m,E){const S=E.configuration.debugServer;if(typeof S=="number")return Promise.resolve(new I.DebugAdapterServer(S));if(m){const k=await this._extensionService.getExtensionRegistry();return(0,y.asPromise)(()=>m.createDebugAdapterDescriptor(E,this.daExecutableFromPackage(E,k))).then(O=>{if(O)return O})}const o=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(E,o))}daExecutableFromPackage(m,E){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(m,E,S){(m.length>0||E.length>0||S.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:m,removed:E,changed:S}))}async getSession(m){if(m)if(typeof m=="string"){const E=this._debugSessions.get(m);if(E)return E}else{let E=this._debugSessions.get(m.id);if(!E){const S=await this.getFolder(m.folderUri),o=m.parent?this._debugSessions.get(m.parent):void 0;E=new v(this._debugServiceProxy,m.id,m.type,m.name,S,m.configuration,o),this._debugSessions.set(E.id,E),this._debugServiceProxy.$sessionCached(E.id)}return E}throw new Error("cannot find session")}getFolder(m){if(m){const E=L.URI.revive(m);return this._workspaceService.resolveWorkspaceFolder(E)}return Promise.resolve(void 0)}};h=je([We(0,g.IExtHostRpcService),We(1,A.IExtHostWorkspace),We(2,i.IExtHostExtensionService),We(3,P.IExtHostDocumentsAndEditors),We(4,u.IExtHostConfiguration),We(5,d.IExtHostEditorTabs)],h),e.ExtHostDebugServiceBase=h;class v{constructor(m,E,S,o,k,O,$){this._debugServiceProxy=m,this._id=E,this._type=S,this._name=o,this._workspaceFolder=k,this._configuration=O,this._parentSession=$}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(m){this._name=m,this._debugServiceProxy.$setDebugSessionName(this._id,m)}get parentSession(){return this._parentSession}_acceptNameChanged(m){this._name=m}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(m,E){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,m,E)}getDebugProtocolBreakpoint(m){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,m.id)}}e.ExtHostDebugSession=v;class t{constructor(m){this.value=Object.freeze({append(E){m.$appendDebugConsole(E)},appendLine(E){this.append(E+`
`)}})}}e.ExtHostDebugConsole=t;class s extends c.AbstractVariableResolverService{constructor(m,E,S,o,k){function O(){if(E){const $=E.activeEditor();if($)return $.document.uri;const G=o.tabs.filter(re=>re.isActive);if(G.length>0)return G[0].resource}}super({getFolderUri:$=>{const G=m.filter(re=>re.name===$);if(G&&G.length>0)return G[0].uri},getWorkspaceFolderCount:()=>m.length,getConfigurationValue:($,G)=>S.getConfiguration(void 0,$).get(G),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{const $=O();if($)return p.normalize($.fsPath)},getWorkspaceFolderPathForFile:()=>{if(k){const $=O();if($){const G=k.getWorkspaceFolder($);if(G)return p.normalize(G.uri.fsPath)}}},getSelectedText:()=>{if(E){const $=E.activeEditor();if($&&!$.selection.isEmpty)return $.document.getText($.selection)}},getLineNumber:()=>{if(E){const $=E.activeEditor();if($)return String($.selection.end.line+1)}}},void 0,Promise.resolve(b.env))}}e.ExtHostVariableResolverService=s;class r{constructor(m){this.trackers=m}onWillStartSession(){this.trackers.forEach(m=>m.onWillStartSession?m.onWillStartSession():void 0)}onWillReceiveMessage(m){this.trackers.forEach(E=>E.onWillReceiveMessage?E.onWillReceiveMessage(m):void 0)}onDidSendMessage(m){this.trackers.forEach(E=>E.onDidSendMessage?E.onDidSendMessage(m):void 0)}onWillStopSession(){this.trackers.forEach(m=>m.onWillStopSession?m.onWillStopSession():void 0)}onError(m){this.trackers.forEach(E=>E.onError?E.onError(m):void 0)}onExit(m,E){this.trackers.forEach(S=>S.onExit?S.onExit(m,E):void 0)}}class n extends D.AbstractDebugAdapter{constructor(m){super();this.implementation=m,m.onDidSendMessage(E=>{this.acceptMessage(E)})}startSession(){return Promise.resolve(void 0)}sendMessage(m){this.implementation.handleMessage(m)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let l=class extends h{constructor(m,E,S,o,k,O){super(m,E,S,o,k,O)}createVariableResolver(m,E,S){return new s(m,E,S,this._editorTabs)}};l=je([We(0,g.IExtHostRpcService),We(1,A.IExtHostWorkspace),We(2,i.IExtHostExtensionService),We(3,P.IExtHostDocumentsAndEditors),We(4,u.IExtHostConfiguration),We(5,d.IExtHostEditorTabs)],l),e.WorkerExtHostDebugService=l}),define(he[262],fe([0,1,67,2,5,36,34,26,13,27,4,39,37,12]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(d,h,v,t,s,r,n){this._apiFactory=d,this._extensionRegistry=h,this._instaService=v,this._extHostConfiguration=t,this._extHostExtensionService=s,this._initData=r,this._logService=n,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),p.mark("code/extHost/willWaitForConfig");const d=await this._extHostConfiguration.getConfigProvider();p.mark("code/extHost/didWaitForConfig");const h=await this._extHostExtensionService.getExtensionPathIndex();this.register(new g(this._apiFactory,h,this._extensionRegistry,d,this._logService)),this.register(this._instaService.createInstance(w)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(_,h,this._initData.environment.appUriScheme))}register(d){if(Array.isArray(d.nodeModuleName))for(let h of d.nodeModuleName)this._factories.set(h,d);else this._factories.set(d.nodeModuleName,d);typeof d.alternativeModuleName=="function"&&this._alternatives.push(h=>d.alternativeModuleName(h))}};a=je([We(2,i.IInstantiationService),We(3,y.IExtHostConfiguration),We(4,P.IExtHostExtensionService),We(5,A.IExtHostInitDataService),We(6,u.ILogService)],a),e.RequireInterceptor=a;class g{constructor(d,h,v,t,s){this._apiFactory=d,this._extensionPaths=h,this._extensionRegistry=v,this._configProvider=t,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(d,h){const v=this._extensionPaths.findSubstr(h.fsPath);if(v){let t=this._extApiImpl.get(I.ExtensionIdentifier.toKey(v.identifier));return t||(t=this._apiFactory(v,this._extensionRegistry,this._configProvider),this._extApiImpl.set(I.ExtensionIdentifier.toKey(v.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((s,r)=>t+=`	${r} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${h.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let w=class{constructor(d,h){this.nodeModuleName="keytar";const{environment:v}=h,t=d.getProxy(C.MainContext.MainThreadKeytar);if(v.appRoot){let s=v.appRoot.fsPath;c.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${s}/node_modules.asar/keytar`),this.alternativeNames.add(`${s}/node_modules/keytar`)}this._impl={getPassword:(s,r)=>t.$getPassword(s,r),setPassword:(s,r,n)=>t.$setPassword(s,r,n),deletePassword:(s,r)=>t.$deletePassword(s,r),findPassword:s=>t.$findPassword(s),findCredentials(s){return t.$findCredentials(s)}}}load(d,h){return this._impl}alternativeModuleName(d){const h=d.length;if(h<=7||!this.alternativeNames)return;const v=h-7;if((d.charAt(v)==="/"||d.charAt(v)==="\\")&&d.endsWith("keytar")&&(d=d.replace(/\\/g,"/"),this.alternativeNames.has(d)))return"keytar"}};w=je([We(0,D.IExtHostRpcService),We(1,A.IExtHostInitDataService)],w);let _=class{constructor(d,h,v){this._extensionPaths=d,this._appUriScheme=h,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=v.getProxy(C.MainContext.MainThreadTelemetry);const t=v.getProxy(C.MainContext.MainThreadWindow);this._impl=(s,r)=>{const n=L.URI.parse(s);return r?this.callOriginal(s,r):n.scheme==="http"||n.scheme==="https"?t.$openUri(n,s,{allowTunneling:!0}):n.scheme==="mailto"||n.scheme===this._appUriScheme?t.$openUri(n,s,{}):this.callOriginal(s,r)}}load(d,h,v){const t=this._extensionPaths.findSubstr(h.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=v(d),this._impl}callOriginal(d,h){return this.sendNoForwardTelemetry(),this._original(d,h)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};_=je([We(2,D.IExtHostRpcService)],_)}),define(he[263],fe([0,1,166,11,7,205,35,39,43,36,33,13,51,190,17,206,48]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let _=class extends c.ExtHostDebugServiceBase{constructor(h,v,t,s,r,n,l){super(h,v,t,s,r,l);this._terminalService=n,this._integratedTerminalInstances=new b}createDebugAdapter(h,v){switch(h.type){case"server":return new y.SocketDebugAdapter(h);case"pipeServer":return new y.NamedPipeDebugAdapter(h);case"executable":return new y.ExecutableDebugAdapter(h,v.type)}return super.createDebugAdapter(h,v)}daExecutableFromPackage(h,v){const t=y.ExecutableDebugAdapter.platformAdapterExecutable(v.getAllExtensionDescriptions(),h.type);if(t)return new C.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new u.SignService}async $runInTerminal(h,v){if(h.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(O=>{this._integratedTerminalInstances.onTerminalClosed(O)}));const t=await this._configurationService.getConfigProvider(),s=this._terminalService.getDefaultShell(!0),r=this._terminalService.getDefaultShellArgs(!0),n=h.title||p.localize(0,null),l=JSON.stringify({shell:s,shellArgs:r});let f=await this._integratedTerminalInstances.checkout(l,n),m,E=!1;if(f)m=h.cwd;else{const O={shellPath:s,shellArgs:r,cwd:h.cwd,name:n,iconPath:new C.ThemeIcon("debug")};E=!0,f=this._terminalService.createTerminalFromOptions(O,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(f,l)}f.show(!0);const S=await f.processId;E?await new Promise(O=>setTimeout(O,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(s.indexOf("powershell")>=0||s.indexOf("pwsh")>=0||s.indexOf("cmd.exe")>=0?f.sendText("cls"):s.indexOf("bash")>=0?f.sendText("clear"):L.isWindows?f.sendText("cls"):f.sendText("clear"));const o=(0,g.prepareCommand)(s,h.args,m,h.env);f.sendText(o);const k=this.onDidTerminateDebugSession(O=>{O.id===v&&(this._integratedTerminalInstances.free(f),k.dispose())});return S}else if(h.kind==="external")return(0,g.runInExternalTerminal)(h,await this._configurationService.getConfigProvider());return super.$runInTerminal(h,v)}createVariableResolver(h,v,t){return new c.ExtHostVariableResolverService(h,v,t,this._editorTabs,this._workspaceService)}};_=je([We(0,P.IExtHostRpcService),We(1,T.IExtHostWorkspace),We(2,I.IExtHostExtensionService),We(3,D.IExtHostDocumentsAndEditors),We(4,A.IExtHostConfiguration),We(5,i.IExtHostTerminalService),We(6,w.IExtHostEditorTabs)],_),e.ExtHostDebugService=_;class b{constructor(){this._terminalInstances=new Map}async checkout(h,v){const s=[...this._terminalInstances.entries()].map(([r,n])=>(0,a.createCancelablePromise)(async l=>{if(r.name!==v||n.lastUsedAt!==-1&&await(0,g.hasChildProcesses)(await r.processId))return null;const f=Date.now();return n.lastUsedAt+b.minUseDelay>f||l.isCancellationRequested||n.config!==h?null:(n.lastUsedAt=f,r)}));return await(0,a.firstParallel)(s,r=>!!r)}insert(h,v){this._terminalInstances.set(h,{lastUsedAt:Date.now(),config:v})}free(h){const v=this._terminalInstances.get(h);v&&(v.lastUsedAt=-1)}onTerminalClosed(h){this._terminalInstances.delete(h)}}b.minUseDelay=1e3}),define(he[264],fe([0,1,9,2,111,35,51,43,36,33,13,27,66,10,12,61,48]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let _=class extends c.ExtHostTaskBase{constructor(d,h,v,t,s,r,n,l,f){super(d,h,v,t,s,r,n,l);this.workspaceService=v,this.editorTabs=f,h.remote.isRemote&&h.remote.authority?this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:h.remote.authority,platform:process.platform}):this.registerTaskSystem(u.Schemas.file,{scheme:u.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(d,h){const v=h;if(!h.execution&&v._id===void 0)throw new Error("Tasks to execute must include an execution");if(v._id!==void 0){const t=c.TaskHandleDTO.from(v,this.workspaceService),s=await this._proxy.$getTaskExecution(t);if(s.task===void 0)throw new Error("Task from execution DTO is undefined");const r=await this.getTaskExecution(s,h);return this._proxy.$executeTask(t).catch(()=>{}),r}else{const t=c.TaskDTO.from(h,d);if(t===void 0)return Promise.reject(new Error("Task is not valid"));c.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,h,!1);const s=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),h);return this._proxy.$executeTask(t).catch(()=>{}),s}}provideTasksInternal(d,h,v,t){const s=[];if(t)for(let r of t){this.checkDeprecation(r,v),(!r.definition||!d[r.definition.type])&&this._logService.warn(`The task [${r.source}, ${r.name}] uses an undefined task type. The task will be ignored in the future.`);const n=c.TaskDTO.from(r,v.extension);n&&(s.push(n),c.CustomExecutionDTO.is(n.execution)&&h.push(this.addCustomExecution(n,r,!0)))}return{tasks:s,extension:v.extension}}async resolveTaskInternal(d){return d}async getVariableResolver(d){if(this._variableResolver===void 0){const h=await this._configurationService.getConfigProvider();this._variableResolver=new T.ExtHostVariableResolverService(d,this._editorService,h,this.editorTabs,this.workspaceService)}return this._variableResolver}async $resolveVariables(d,h){const v=L.URI.revive(d),t={process:void 0,variables:Object.create(null)},s=await this._workspaceProvider.resolveWorkspaceFolder(v),r=await this._workspaceProvider.getWorkspaceFolders2();if(!r||!s)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const n=await this.getVariableResolver(r),l={uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}};for(let f of h.variables)t.variables[f]=await n.resolveAsync(l,f);if(h.process!==void 0){let f;if(h.process.path!==void 0){f=h.process.path.split(p.delimiter);for(let m=0;m<f.length;m++)f[m]=await n.resolveAsync(l,f[m])}t.process=await C.win32.findExecutable(await n.resolveAsync(l,h.process.name),h.process.cwd!==void 0?await n.resolveAsync(l,h.process.cwd):void 0,f)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(d,h,v){return C.win32.findExecutable(d,h,v)}};_=je([We(0,i.IExtHostRpcService),We(1,P.IExtHostInitDataService),We(2,y.IExtHostWorkspace),We(3,I.IExtHostDocumentsAndEditors),We(4,D.IExtHostConfiguration),We(5,A.IExtHostTerminalService),We(6,a.ILogService),We(7,g.IExtHostApiDeprecationService),We(8,w.IExtHostEditorTabs)],_),e.ExtHostTask=_}),define(he[265],fe([0,1,17,15,67,6,2,5,257,12,78,81,27,183,13,60,39,33]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u,a,g,w,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(h,v,t,s){this._disposables=new y.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new D.RPCProtocol(h,null,s),v=b._transform(v,this._rpcProtocol);const r=new P.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());r.set(c.IExtHostInitDataService,{_serviceBrand:void 0,...v}),r.set(a.IExtHostRpcService,new a.ExtHostRpcService(this._rpcProtocol)),r.set(g.IURITransformerService,new g.URITransformerService(s)),r.set(w.IHostUtils,t);const n=new u.InstantiationService(r,!0),l=n.invokeFunction(S=>S.get(_.IExtHostTerminalService));this._disposables.add(l),this._logService=n.invokeFunction(S=>S.get(A.ILogService)),C.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",v),this._extensionService=n.invokeFunction(S=>S.get(w.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const f=new WeakMap;this._extensionService.getExtensionPathIndex().then(S=>{Error.prepareStackTrace=(o,k)=>{let O="",$,G;for(const re of k)O+=`
	at ${re.toString()}`,G=re.getFileName(),!$&&G&&($=S.findSubstr(G));return f.set(o,$),`${o.name||"Error"}: ${o.message||""}${O}`}});const m=this._rpcProtocol.getProxy(I.MainContext.MainThreadExtensionService),E=this._rpcProtocol.getProxy(I.MainContext.MainThreadErrors);L.setUnexpectedErrorHandler(S=>{const o=L.transformErrorForSerialization(S),k=f.get(S);k?m.$onExtensionRuntimeError(k.identifier,o):E.$onUnexpectedError(o)})}terminate(h){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${h}`),this._logService.flush(),this._disposables.dispose(),L.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const v=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,p.timeout)(4e3),v]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(h,v){h.extensions.forEach(s=>s.extensionLocation=T.URI.revive(v.transformIncomingURIs(s.extensionLocation))),h.environment.appRoot=T.URI.revive(v.transformIncomingURIs(h.environment.appRoot));const t=h.environment.extensionDevelopmentLocationURI;return t&&(h.environment.extensionDevelopmentLocationURI=t.map(s=>T.URI.revive(v.transformIncomingURIs(s)))),h.environment.extensionTestsLocationURI=T.URI.revive(v.transformIncomingURIs(h.environment.extensionTestsLocationURI)),h.environment.globalStorageHome=T.URI.revive(v.transformIncomingURIs(h.environment.globalStorageHome)),h.environment.workspaceStorageHome=T.URI.revive(v.transformIncomingURIs(h.environment.workspaceStorageHome)),h.logsLocation=T.URI.revive(v.transformIncomingURIs(h.logsLocation)),h.logFile=T.URI.revive(v.transformIncomingURIs(h.logFile)),h.workspace=v.transformIncomingURIs(h.workspace),h}}e.ExtensionHostMain=b}),define(he[266],fe([0,1,9,21,58,30,24,44,31]),function(X,e,p,L,C,y,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class A{constructor(c,u,a){this.config=c,this.provider=u,this.sessionToken=a,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=c.filePattern,this.includePattern=c.includePattern&&y.parse(c.includePattern),this.maxResults=c.maxResults||void 0,this.exists=c.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=c.excludePattern&&y.parse(c.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(c=>c.cancel()),this.activeCancellationTokens=new Set}search(c){const u=this.config.folderQueries||[];return new Promise((a,g)=>{const w=_=>{this.resultCount++,c(_)};if(this.isCanceled)return a({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(_=>{const b=_.toString(),d=p.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,d)||this.matchFile(w,{base:_,basename:d})}),Promise.all(u.map(_=>this.searchInFolder(_,w))).then(_=>{a({limitHit:this.isLimitHit,stats:_[0]||void 0})},_=>{g(new Error((0,C.toErrorMessage)(_)))})})}async searchInFolder(c,u){const a=new L.CancellationTokenSource,g=this.getSearchOptionsForFolder(c),w=this.initDirectoryTree(),_=new D.QueryGlobTester(this.config,c),b=!_.hasSiblingExcludeClauses();let d;try{this.activeCancellationTokens.add(a),d=I.StopWatch.create();const h=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},g,a.token),v=d.elapsed(),t=I.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(h&&h.forEach(s=>{const r=p.posix.relative(c.folder.path,s.path);if(b){const n=p.basename(s.path);this.matchFile(u,{base:c.folder,relativePath:r,basename:n});return}this.addDirectoryEntries(w,c.folder,r,u)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(w,_,u),{providerTime:v,postProcessTime:t.elapsed()})}finally{a.dispose(),this.activeCancellationTokens.delete(a)}}getSearchOptionsForFolder(c){const u=(0,D.resolvePatternsForProvider)(this.config.includePattern,c.includePattern),a=(0,D.resolvePatternsForProvider)(this.config.excludePattern,c.excludePattern);return{folder:c.folder,excludes:a,includes:u,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries({pathToEntries:c},u,a,g){if(a===this.filePattern){const _=p.basename(this.filePattern);this.matchFile(g,{base:u,relativePath:this.filePattern,basename:_})}function w(_){const b=p.basename(_),d=p.dirname(_);let h=c[d];h||(h=c[d]=[],w(d)),h.push({base:u,relativePath:_,basename:b})}w(a)}matchDirectoryTree({rootEntries:c,pathToEntries:u},a,g){const w=this,_=this.filePattern;function b(d){const h=y.hasSiblingFn(()=>d.map(v=>v.basename));for(let v=0,t=d.length;v<t;v++){const s=d[v],{relativePath:r,basename:n}=s;if(!a.includedInQuerySync(r,n,_!==n?h:void 0))continue;const l=u[r];if(l)b(l);else{if(r===_)continue;w.matchFile(g,s)}if(w.isLimitHit)break}}b(c)}matchFile(c,u){(!this.includePattern||u.relativePath&&this.includePattern(u.relativePath,u.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||c(u))}}class i{constructor(){this.sessions=new Map}fileSearch(c,u,a,g){const w=this.getSessionTokenSource(c.cacheKey),_=new A(c,u,w&&w.token);let b=0;const d=h=>{b+=h.length,a(h.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(_,i.BATCH_SIZE,d,g).then(h=>({limitHit:h.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:h.stats}}))}clearCache(c){const u=this.getSessionTokenSource(c);u&&u.cancel()}getSessionTokenSource(c){if(!!c)return this.sessions.has(c)||this.sessions.set(c,new L.CancellationTokenSource),this.sessions.get(c)}rawMatchToSearchItem(c){return c.relativePath?{resource:T.joinPath(c.base,c.relativePath)}:{resource:c.base}}doSearch(c,u,a,g){g.onCancellationRequested(()=>{c.cancel()});const w=b=>{b&&(_.push(b),u>0&&_.length>=u&&(a(_),_=[]))};let _=[];return c.search(w).then(b=>(_.length&&a(_),b),b=>(_.length&&a(_),Promise.reject(b)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(he[130],fe([0,1,9,18,21,58,24,30,2,31,10,14]),function(X,e,p,L,C,y,T,I,D,A,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class c{constructor(d,h,v){this.query=d,this.provider=h,this.fileUtils=v,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(d,h){const v=this.query.folderQueries||[],t=new C.CancellationTokenSource;return h.onCancellationRequested(()=>t.cancel()),new Promise((s,r)=>{this.collector=new a(d);let n=!1;const l=(f,m)=>{if(!n&&!this.isLimitHit){const E=this.resultSize(f);w(f)&&typeof this.query.maxResults=="number"&&this.resultCount+E>this.query.maxResults&&(this.isLimitHit=!0,n=!0,t.cancel(),f=this.trimResultToSize(f,this.query.maxResults-this.resultCount));const S=this.resultSize(f);this.resultCount+=S,(S>0||!w(f))&&this.collector.add(f,m)}};Promise.all(v.map((f,m)=>this.searchInFolder(f,E=>l(E,m),t.token))).then(f=>{t.dispose(),this.collector.flush();const m=f.some(E=>!!E&&!!E.limitHit);s({limitHit:this.isLimitHit||m,messages:(0,L.flatten)(f.map(E=>E?.message?(0,P.isArray)(E.message)?E.message:[E.message]:[])),stats:{type:"textSearchProvider"}})},f=>{t.dispose();const m=(0,y.toErrorMessage)(f);r(new Error(m))})})}resultSize(d){return w(d)?Array.isArray(d.ranges)?d.ranges.length:1:0}trimResultToSize(d,h){const v=Array.isArray(d.ranges)?d.ranges:[d.ranges],t=Array.isArray(d.preview.matches)?d.preview.matches:[d.preview.matches];return{ranges:v.slice(0,h),preview:{matches:t.slice(0,h),text:d.preview.text},uri:d.uri}}async searchInFolder(d,h,v){const t=new A.QueryGlobTester(this.query,d),s=[],r={report:f=>{if(!this.validateProviderResult(f))return;const m=d.folder.scheme===i.Schemas.file?I.hasSiblingPromiseFn(()=>this.fileUtils.readdir(T.dirname(f.uri))):void 0,E=T.relativePath(d.folder,f.uri);E&&s.push(t.includedInQuery(E,p.basename(E),m).then(S=>{S&&h(f)}))}},n=this.getSearchOptionsForFolder(d),l=await this.provider.provideTextSearchResults(u(this.query.contentPattern),n,r,v);return await Promise.all(s),l}validateProviderResult(d){if(w(d)){if(Array.isArray(d.ranges)){if(!Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(d.preview.matches.length!==d.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(d){const h=(0,A.resolvePatternsForProvider)(this.query.includePattern,d.includePattern),v=(0,A.resolvePatternsForProvider)(this.query.excludePattern,d.excludePattern),t={folder:D.URI.from(d.folder),excludes:v,includes:h,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,encoding:d.fileEncoding&&this.fileUtils.toCanonicalName(d.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=c;function u(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class a{constructor(d){this._onResult=d,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new _(512,h=>this.sendItems(h))}add(d,h){this._currentFileMatch&&(this._currentFolderIdx!==h||!T.isEqual(this._currentUri,d.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=h,this._currentFileMatch={resource:d.uri,results:[]}),this._currentFileMatch.results.push(g(d))}pushToCollector(){const d=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,d)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(d){this._onResult(d)}}e.TextSearchResultsCollector=a;function g(b){return w(b)?{preview:{matches:(0,L.mapArrayOrNot)(b.preview.matches,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character})),text:b.preview.text},ranges:(0,L.mapArrayOrNot)(b.ranges,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function w(b){return!!b.preview}e.extensionResultIsMatch=w;class _{constructor(d,h){this.maxBatchSize=d,this.cb=h,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(d,h){!d||this.addItemToBatch(d,h)}addItems(d,h){!d||this.addItemsToBatch(d,h)}addItemToBatch(d,h){this.batch.push(d),this.batchSize+=h,this.onUpdate()}addItemsToBatch(d,h){this.batch=this.batch.concat(d),this.batchSize+=h,this.onUpdate()}onUpdate(){this.totalNumberCompleted<_.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},_.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=_,_.TIMEOUT=4e3,_.START_BATCH_AFTER_COUNT=50}),define(he[68],fe([0,1,6,5,4,266,13,60,12,2,130]),function(X,e,p,L,C,y,T,I,D,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,C.createDecorator)("IExtHostSearch");let P=class{constructor(g,w,_){this.extHostRpc=g,this._uriTransformer=w,this._logService=_,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new y.FileSearchManager}_transformScheme(g){return this._uriTransformer.transformOutgoingScheme(g)}registerTextSearchProvider(g,w){if(this._textSearchUsedSchemes.has(g))throw new Error(`a text search provider for the scheme '${g}' is already registered`);this._textSearchUsedSchemes.add(g);const _=this._handlePool++;return this._textSearchProvider.set(_,w),this._proxy.$registerTextSearchProvider(_,this._transformScheme(g)),(0,p.toDisposable)(()=>{this._textSearchUsedSchemes.delete(g),this._textSearchProvider.delete(_),this._proxy.$unregisterProvider(_)})}registerFileSearchProvider(g,w){if(this._fileSearchUsedSchemes.has(g))throw new Error(`a file search provider for the scheme '${g}' is already registered`);this._fileSearchUsedSchemes.add(g);const _=this._handlePool++;return this._fileSearchProvider.set(_,w),this._proxy.$registerFileSearchProvider(_,this._transformScheme(g)),(0,p.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(g),this._fileSearchProvider.delete(_),this._proxy.$unregisterProvider(_)})}$provideFileSearchResults(g,w,_,b){const d=c(_),h=this._fileSearchProvider.get(g);if(h)return this._fileSearchManager.fileSearch(d,h,v=>{this._proxy.$handleFileMatch(g,w,v.map(t=>t.resource))},b);throw new Error("unknown provider: "+g)}$clearCache(g){return this._fileSearchManager.clearCache(g),Promise.resolve(void 0)}$provideTextSearchResults(g,w,_,b){const d=this._textSearchProvider.get(g);if(!d||!d.provideTextSearchResults)throw new Error(`Unknown provider ${g}`);const h=c(_);return this.createTextSearchManager(h,d).search(t=>this._proxy.$handleTextMatch(g,w,t),b)}createTextSearchManager(g,w){return new i.TextSearchManager(g,w,{readdir:_=>Promise.resolve([]),toCanonicalName:_=>_})}};P=je([We(0,T.IExtHostRpcService),We(1,I.IURITransformerService),We(2,D.ILogService)],P),e.ExtHostSearch=P;function c(a){return{...a,folderQueries:a.folderQueries&&a.folderQueries.map(u),extraFileResources:a.extraFileResources&&a.extraFileResources.map(g=>A.URI.revive(g))}}e.reviveQuery=c;function u(a){return{...a,folder:A.URI.revive(a.folder)}}}),define(he[267],fe([0,1,21,15,3,56,2,112,107,143,77,41,5,226,225,50,227,36,228,229,230,211,231,43,39,232,212,234,235,236,62,214,241,242,243,90,33,245,215,16,7,248,64,129,35,34,69,202,233,83,128,66,51,68,12,60,13,27,237,200,49,61,223,246,199,63,89,251,249,250,224,59,244,247,88,48,119,239,65,240,10,185,238,197,195]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u,a,g,w,_,b,d,h,v,t,s,r,n,l,f,m,E,S,o,k,O,$,G,re,j,N,x,R,V,F,M,B,W,Q,ae,_e,Fe,Ae,Me,Ve,He,z,J,ne,oe,we,Z,de,Ie,Be,qe,Ee,tt,K,ee,pe,xe,$e,et,ke,Ce,Re,se,le,me,be,q,ge,ye,Te,Oe,Ge){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ze(Qe){const Xe=Qe.get(oe.IExtHostInitDataService),at=Qe.get(et.IExtHostFileSystemInfo),ut=Qe.get(K.IExtHostConsumerFileSystem),bt=Qe.get(r.IExtHostExtensionService),ve=Qe.get(B.IExtHostWorkspace),De=Qe.get(le.IExtHostTelemetry),ce=Qe.get(_.IExtHostConfiguration),Y=Qe.get(J.IURITransformerService),Se=Qe.get(ne.IExtHostRpcService),ze=Qe.get(G.IExtHostStorage),Je=Qe.get(tt.IExtensionStoragePaths),Ke=Qe.get(z.ILogService),lt=Qe.get(de.IExtHostTunnelService),ht=Qe.get(Ie.IExtHostApiDeprecationService),yt=Qe.get(M.IExtHostWindow),Ct=Qe.get(Re.IExtHostSecretState),Et=Qe.get(se.IExtHostEditorTabs);Se.set(c.ExtHostContext.ExtHostFileSystemInfo,at),Se.set(c.ExtHostContext.ExtHostLogService,Ke),Se.set(c.ExtHostContext.ExtHostWorkspace,ve),Se.set(c.ExtHostContext.ExtHostConfiguration,ce),Se.set(c.ExtHostContext.ExtHostExtensionService,bt),Se.set(c.ExtHostContext.ExtHostStorage,ze),Se.set(c.ExtHostContext.ExtHostTunnelService,lt),Se.set(c.ExtHostContext.ExtHostWindow,yt),Se.set(c.ExtHostContext.ExtHostSecretState,Ct),Se.set(c.ExtHostContext.ExtHostTelemetry,De),Se.set(c.ExtHostContext.ExtHostEditorTabs,Et);const vt=Se.set(c.ExtHostContext.ExtHostDecorations,Qe.get(Ae.IExtHostDecorations)),_t=Se.set(c.ExtHostContext.ExtHostDocumentsAndEditors,Qe.get(s.IExtHostDocumentsAndEditors)),dt=Se.set(c.ExtHostContext.ExtHostCommands,Qe.get(g.IExtHostCommands)),wt=Se.set(c.ExtHostContext.ExtHostTerminalService,Qe.get(re.IExtHostTerminalService)),ft=Se.set(c.ExtHostContext.ExtHostDebugService,Qe.get(Ve.IExtHostDebugService)),Nt=Se.set(c.ExtHostContext.ExtHostSearch,Qe.get(He.IExtHostSearch)),Pt=Se.set(c.ExtHostContext.ExtHostTask,Qe.get(Me.IExtHostTask)),Kt=Se.set(c.ExtHostContext.ExtHostOutputService,Qe.get(S.IExtHostOutputService)),Ut=Se.set(c.ExtHostContext.ExtHostUrls,new V.ExtHostUrls(Se)),kt=Se.set(c.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(Se,_t)),Qt=Se.set(c.ExtHostContext.ExtHostDocumentContentProviders,new h.ExtHostDocumentContentProvider(Se,_t,Ke)),Xt=Se.set(c.ExtHostContext.ExtHostDocumentSaveParticipant,new v.ExtHostDocumentSaveParticipant(Ke,kt,Se.getProxy(c.MainContext.MainThreadBulkEdits))),mt=Se.set(c.ExtHostContext.ExtHostNotebook,new we.ExtHostNotebookController(Se,dt,_t,kt,Je)),jt=Se.set(c.ExtHostContext.ExtHostNotebookDocuments,new Oe.ExtHostNotebookDocuments(Ke,mt)),zt=Se.set(c.ExtHostContext.ExtHostNotebookEditors,new Te.ExtHostNotebookEditors(Ke,Se,mt)),Yt=Se.set(c.ExtHostContext.ExtHostNotebookKernels,new me.ExtHostNotebookKernels(Se,Xe,mt,Ke)),Jt=Se.set(c.ExtHostContext.ExtHostNotebookRenderers,new q.ExtHostNotebookRenderers(Se,mt)),At=Se.set(c.ExtHostContext.ExtHostEditors,new j.ExtHostEditors(Se,_t)),qt=Se.set(c.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(Se.getProxy(c.MainContext.MainThreadTreeViews),dt,Ke)),Zt=Se.set(c.ExtHostContext.ExtHostEditorInsets,new ae.ExtHostEditorInsets(Se.getProxy(c.MainContext.MainThreadEditorInsets),At,Xe)),Ht=Se.set(c.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(Se,Ke)),ct=Se.set(c.ExtHostContext.ExtHostLanguageFeatures,new f.ExtHostLanguageFeatures(Se,Y,kt,dt,Ht,Ke,ht)),En=Se.set(c.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(Se,ct)),Rt=Se.set(c.ExtHostContext.ExtHostFileSystemEventService,new l.ExtHostFileSystemEventService(Se,Ke,_t)),xt=Se.set(c.ExtHostContext.ExtHostQuickOpen,(0,k.createExtHostQuickOpen)(Se,ve,dt)),un=Se.set(c.ExtHostContext.ExtHostSCM,new O.ExtHostSCM(Se,dt,Ke)),_n=Se.set(c.ExtHostContext.ExtHostComments,(0,w.createExtHostComments)(Se,dt,kt)),dn=Se.set(c.ExtHostContext.ExtHostProgress,new o.ExtHostProgress(Se.getProxy(c.MainContext.MainThreadProgress))),Sn=Se.set(c.ExtHostContext.ExtHosLabelService,new _e.ExtHostLabelService(Se)),hn=Se.set(c.ExtHostContext.ExtHostTheming,new Z.ExtHostTheming(Se)),Vt=Se.set(c.ExtHostContext.ExtHostAuthentication,new Be.ExtHostAuthentication(Se)),en=Se.set(c.ExtHostContext.ExtHostTimeline,new qe.ExtHostTimeline(Se,dt)),tn=Se.set(c.ExtHostContext.ExtHostWebviews,new F.ExtHostWebviews(Se,{remote:Xe.remote},ve,Ke,ht)),nn=Se.set(c.ExtHostContext.ExtHostWebviewPanels,new xe.ExtHostWebviewPanels(Se,tn,ve)),yn=Se.set(c.ExtHostContext.ExtHostCustomEditors,new pe.ExtHostCustomEditors(Se,kt,Je,tn,nn)),Dn=Se.set(c.ExtHostContext.ExtHostWebviewViews,new ee.ExtHostWebviewViews(Se,tn)),Lt=Se.set(c.ExtHostContext.ExtHostTesting,new ke.ExtHostTesting(Se,dt)),Cn=Se.set(c.ExtHostContext.ExtHostUriOpeners,new Ce.ExtHostUriOpeners(Se));Se.set(c.ExtHostContext.ExtHostInteractive,new Ge.ExtHostInteractive(Se,mt,_t));const kn=(0,Q.values)(c.ExtHostContext);Se.assertRegistered(kn);const rn=new $e.ExtHostBulkEdits(Se,_t),In=new a.ExtHostClipboard(Se),Bt=new E.ExtHostMessageService(Se,Ke),Mt=new d.ExtHostDialogs(Se),fn=new $.ExtHostStatusBar(Se,dt.converter),Tt=new m.ExtHostLanguages(Se,kt);return u.ExtHostApiCommands.register(dt),function(Ne,sn,mn){const gt=function(){let te=!Ne.isUnderDevelopment;function ue(Le){te||(Ke.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Le(rt){if(Array.isArray(rt))rt.forEach(Le);else if(typeof rt=="string")ue(rt);else{const pt=rt;typeof pt.scheme=="undefined"&&ue(rt),!Ne.enableProposedApi&&typeof pt.exclusive=="boolean"&&(0,W.throwProposedApiError)(Ne)}return rt}}(),Pn={getSession(te,ue,Le){return Vt.getSession(Ne,te,ue,Le)},get onDidChangeSessions(){return Vt.onDidChangeSessions},registerAuthenticationProvider(te,ue,Le,rt){return Vt.registerAuthenticationProvider(te,ue,Le,rt)}},An={registerCommand(te,ue,Le){return dt.registerCommand(!0,te,ue,Le)},registerTextEditorCommand(te,ue,Le){return dt.registerCommand(!0,te,(...rt)=>{const pt=At.getActiveTextEditor();if(!pt){Ke.warn("Cannot execute "+te+" because there is no active text editor.");return}return pt.edit(Dt=>{ue.apply(Le,[pt,Dt,...rt])}).then(Dt=>{Dt||Ke.warn("Edits from command "+te+" were not applied.")},Dt=>{Ke.warn("An error occurred while running command "+te,Dt)})})},registerDiffInformationCommand:(te,ue,Le)=>((0,W.checkProposedApiEnabled)(Ne),dt.registerCommand(!0,te,async(...rt)=>{const pt=_t.activeEditor(!0);if(!pt){Ke.warn("Cannot execute "+te+" because there is no active text editor.");return}const Dt=await At.getDiffInformation(pt.id);ue.apply(Le,[Dt,...rt])})),executeCommand(te,...ue){return dt.executeCommand(te,...ue)},getCommands(te=!1){return dt.getCommands(te)}},gn={get machineId(){return Xe.telemetryInfo.machineId},get sessionId(){return Xe.telemetryInfo.sessionId},get language(){return Xe.environment.appLanguage},get appName(){return Xe.environment.appName},get appRoot(){return Xe.environment.appRoot?.fsPath??""},get uriScheme(){return Xe.environment.appUriScheme},get clipboard(){return In.value},get shell(){return wt.getDefaultShell(!1)},get isTelemetryEnabled(){return De.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return De.onDidChangeTelemetryEnabled},get isNewAppInstall(){const te=Date.now()-new Date(Xe.telemetryInfo.firstSessionDate).getTime();return isNaN(te)?!1:te<1e3*60*60*24},openExternal(te,ue){return yt.openUri(te,{allowTunneling:!!Xe.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===Xe.environment.appUriScheme)return Ut.createAppUri(te);try{return await yt.asExternalUri(te,{allowTunneling:!!Xe.remote.authority})}catch(ue){if((0,ye.matchesScheme)(te,ge.Schemas.http)||(0,ye.matchesScheme)(te,ge.Schemas.https))return te;throw ue}},get remoteName(){return(0,Fe.getRemoteName)(Xe.remote.authority)},get uiKind(){return Xe.uiKind}};Xe.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=Xe.remote.isRemote?R.ExtensionKind.Workspace:R.ExtensionKind.UI,on={createTestController(te,ue){return(0,W.checkProposedApiEnabled)(Ne),Lt.createTestController(te,ue)},createTestItem(te,ue,Le){return(0,W.checkProposedApiEnabled)(Ne),Lt.createTestItem(te,ue,Le)},createTestObserver(){return(0,W.checkProposedApiEnabled)(Ne),Lt.createTestObserver()},runTests(te){return(0,W.checkProposedApiEnabled)(Ne),Lt.runTests(te)},get onDidChangeTestResults(){return(0,W.checkProposedApiEnabled)(Ne),Lt.onResultsChanged},get testResults(){return(0,W.checkProposedApiEnabled)(Ne),Lt.results}},Tn={getExtension(te){const ue=sn.getExtensionDescription(te);if(ue)return new r.Extension(bt,Ne.identifier,ue,pn)},get all(){return sn.getAllExtensionDescriptions().map(te=>new r.Extension(bt,Ne.identifier,te,pn))},get onDidChange(){return sn.onDidChange}},Rn={createDiagnosticCollection(te){return Ht.createDiagnosticCollection(Ne.identifier,te)},get onDidChangeDiagnostics(){return Ht.onDidChangeDiagnostics},getDiagnostics:te=>Ht.getDiagnostics(te),getLanguages(){return Tt.getLanguages()},setTextDocumentLanguage(te,ue){return Tt.changeLanguage(te.uri,ue)},match(te,ue){return(0,i.score)(x.LanguageSelector.from(te),ue.uri,ue.languageId,!0)},registerCodeActionsProvider(te,ue,Le){return ct.registerCodeActionProvider(Ne,gt(te),ue,Le)},registerCodeLensProvider(te,ue){return ct.registerCodeLensProvider(Ne,gt(te),ue)},registerDefinitionProvider(te,ue){return ct.registerDefinitionProvider(Ne,gt(te),ue)},registerDeclarationProvider(te,ue){return ct.registerDeclarationProvider(Ne,gt(te),ue)},registerImplementationProvider(te,ue){return ct.registerImplementationProvider(Ne,gt(te),ue)},registerTypeDefinitionProvider(te,ue){return ct.registerTypeDefinitionProvider(Ne,gt(te),ue)},registerHoverProvider(te,ue){return ct.registerHoverProvider(Ne,gt(te),ue,Ne.identifier)},registerEvaluatableExpressionProvider(te,ue){return ct.registerEvaluatableExpressionProvider(Ne,gt(te),ue,Ne.identifier)},registerInlineValuesProvider(te,ue){return ct.registerInlineValuesProvider(Ne,gt(te),ue,Ne.identifier)},registerDocumentHighlightProvider(te,ue){return ct.registerDocumentHighlightProvider(Ne,gt(te),ue)},registerLinkedEditingRangeProvider(te,ue){return ct.registerLinkedEditingRangeProvider(Ne,gt(te),ue)},registerReferenceProvider(te,ue){return ct.registerReferenceProvider(Ne,gt(te),ue)},registerRenameProvider(te,ue){return ct.registerRenameProvider(Ne,gt(te),ue)},registerDocumentSymbolProvider(te,ue,Le){return ct.registerDocumentSymbolProvider(Ne,gt(te),ue,Le)},registerWorkspaceSymbolProvider(te){return ct.registerWorkspaceSymbolProvider(Ne,te)},registerDocumentFormattingEditProvider(te,ue){return ct.registerDocumentFormattingEditProvider(Ne,gt(te),ue)},registerDocumentRangeFormattingEditProvider(te,ue){return ct.registerDocumentRangeFormattingEditProvider(Ne,gt(te),ue)},registerOnTypeFormattingEditProvider(te,ue,Le,...rt){return ct.registerOnTypeFormattingEditProvider(Ne,gt(te),ue,[Le].concat(rt))},registerDocumentSemanticTokensProvider(te,ue,Le){return ct.registerDocumentSemanticTokensProvider(Ne,gt(te),ue,Le)},registerDocumentRangeSemanticTokensProvider(te,ue,Le){return ct.registerDocumentRangeSemanticTokensProvider(Ne,gt(te),ue,Le)},registerSignatureHelpProvider(te,ue,Le,...rt){return typeof Le=="object"?ct.registerSignatureHelpProvider(Ne,gt(te),ue,Le):ct.registerSignatureHelpProvider(Ne,gt(te),ue,typeof Le=="undefined"?[]:[Le,...rt])},registerCompletionItemProvider(te,ue,...Le){return ct.registerCompletionItemProvider(Ne,gt(te),ue,Le)},registerInlineCompletionItemProvider(te,ue){return(0,W.checkProposedApiEnabled)(Ne),ct.registerInlineCompletionsProvider(Ne,gt(te),ue)},registerDocumentLinkProvider(te,ue){return ct.registerDocumentLinkProvider(Ne,gt(te),ue)},registerColorProvider(te,ue){return ct.registerColorProvider(Ne,gt(te),ue)},registerFoldingRangeProvider(te,ue){return ct.registerFoldingRangeProvider(Ne,gt(te),ue)},registerSelectionRangeProvider(te,ue){return ct.registerSelectionRangeProvider(Ne,te,ue)},registerCallHierarchyProvider(te,ue){return ct.registerCallHierarchyProvider(Ne,te,ue)},setLanguageConfiguration:(te,ue)=>ct.setLanguageConfiguration(Ne,te,ue),getTokenInformationAtPosition(te,ue){return(0,W.checkProposedApiEnabled)(Ne),Tt.tokenAtPosition(te,ue)},registerInlayHintsProvider(te,ue){return(0,W.checkProposedApiEnabled)(Ne),ct.registerInlayHintsProvider(Ne,te,ue)}},Ln={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return wt.activeTerminal},get terminals(){return wt.terminals},async showTextDocument(te,ue,Le){const rt=await(T.URI.isUri(te)?Promise.resolve(vn.openTextDocument(te)):Promise.resolve(te));return At.showTextDocument(rt,ue,Le)},createTextEditorDecorationType(te){return At.createTextEditorDecorationType(Ne,te)},onDidChangeActiveTextEditor(te,ue,Le){return At.onDidChangeActiveTextEditor(te,ue,Le)},onDidChangeVisibleTextEditors(te,ue,Le){return At.onDidChangeVisibleTextEditors(te,ue,Le)},onDidChangeTextEditorSelection(te,ue,Le){return At.onDidChangeTextEditorSelection(te,ue,Le)},onDidChangeTextEditorOptions(te,ue,Le){return At.onDidChangeTextEditorOptions(te,ue,Le)},onDidChangeTextEditorVisibleRanges(te,ue,Le){return At.onDidChangeTextEditorVisibleRanges(te,ue,Le)},onDidChangeTextEditorViewColumn(te,ue,Le){return At.onDidChangeTextEditorViewColumn(te,ue,Le)},onDidCloseTerminal(te,ue,Le){return wt.onDidCloseTerminal(te,ue,Le)},onDidOpenTerminal(te,ue,Le){return wt.onDidOpenTerminal(te,ue,Le)},onDidChangeActiveTerminal(te,ue,Le){return wt.onDidChangeActiveTerminal(te,ue,Le)},onDidChangeTerminalDimensions(te,ue,Le){return(0,W.checkProposedApiEnabled)(Ne),wt.onDidChangeTerminalDimensions(te,ue,Le)},onDidWriteTerminalData(te,ue,Le){return(0,W.checkProposedApiEnabled)(Ne),wt.onDidWriteTerminalData(te,ue,Le)},get state(){return yt.state},onDidChangeWindowState(te,ue,Le){return yt.onDidChangeWindowState(te,ue,Le)},showInformationMessage(te,...ue){return Bt.showMessage(Ne,y.default.Info,te,ue[0],ue.slice(1))},showWarningMessage(te,...ue){return Bt.showMessage(Ne,y.default.Warning,te,ue[0],ue.slice(1))},showErrorMessage(te,...ue){return Bt.showMessage(Ne,y.default.Error,te,ue[0],ue.slice(1))},showQuickPick(te,ue,Le){return xt.showQuickPick(te,!!Ne.enableProposedApi,ue,Le)},showWorkspaceFolderPick(te){return xt.showWorkspaceFolderPick(te)},showInputBox(te,ue){return xt.showInput(te,ue)},showOpenDialog(te){return Mt.showOpenDialog(te)},showSaveDialog(te){return Mt.showSaveDialog(te)},createStatusBarItem(te,ue,Le){let rt,pt,Dt;return typeof te=="string"?(rt=te,pt=ue,Dt=Le):(pt=te,Dt=ue),fn.createStatusBarEntry(Ne,rt,pt,Dt)},setStatusBarMessage(te,ue){return fn.setStatusBarMessage(te,ue)},withScmProgress(te){return ht.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),dn.withProgress(Ne,{location:R.ProgressLocation.SourceControl},(ue,Le)=>te({report(rt){}}))},withProgress(te,ue){return dn.withProgress(Ne,te,ue)},createOutputChannel(te){return Kt.createOutputChannel(te,Ne)},createWebviewPanel(te,ue,Le,rt){return nn.createWebviewPanel(Ne,te,ue,Le,rt)},createWebviewTextEditorInset(te,ue,Le,rt){return(0,W.checkProposedApiEnabled)(Ne),Zt.createWebviewEditorInset(te,ue,Le,rt,Ne)},createTerminal(te,ue,Le){return typeof te=="object"?"pty"in te?wt.createExtensionTerminal(te):wt.createTerminalFromOptions(te):wt.createTerminal(te,ue,Le)},registerTerminalLinkProvider(te){return wt.registerLinkProvider(te)},registerTerminalProfileProvider(te,ue){return wt.registerProfileProvider(Ne,te,ue)},registerTreeDataProvider(te,ue){return qt.registerTreeDataProvider(te,ue,Ne)},createTreeView(te,ue){return qt.createTreeView(te,ue,Ne)},registerWebviewPanelSerializer:(te,ue)=>nn.registerWebviewPanelSerializer(Ne,te,ue),registerCustomEditorProvider:(te,ue,Le={})=>yn.registerCustomEditorProvider(Ne,te,ue,Le),registerFileDecorationProvider(te){return vt.registerFileDecorationProvider(te,Ne.identifier)},registerUriHandler(te){return Ut.registerUriHandler(Ne.identifier,te)},createQuickPick(){return xt.createQuickPick(Ne.identifier,!!Ne.enableProposedApi)},createInputBox(){return xt.createInputBox(Ne.identifier)},get activeColorTheme(){return hn.activeColorTheme},onDidChangeActiveColorTheme(te,ue,Le){return hn.onDidChangeActiveColorTheme(te,ue,Le)},registerWebviewViewProvider(te,ue,Le){return Dn.registerWebviewViewProvider(Ne,te,ue,Le?.webviewOptions)},get activeNotebookEditor(){return(0,W.checkProposedApiEnabled)(Ne),mt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,ue,Le){return(0,W.checkProposedApiEnabled)(Ne),mt.onDidChangeActiveNotebookEditor(te,ue,Le)},get visibleNotebookEditors(){return(0,W.checkProposedApiEnabled)(Ne),mt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,W.checkProposedApiEnabled)(Ne),mt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,ue,Le){return(0,W.checkProposedApiEnabled)(Ne),zt.onDidChangeNotebookEditorSelection(te,ue,Le)},onDidChangeNotebookEditorVisibleRanges(te,ue,Le){return(0,W.checkProposedApiEnabled)(Ne),zt.onDidChangeNotebookEditorVisibleRanges(te,ue,Le)},showNotebookDocument(te,ue){return(0,W.checkProposedApiEnabled)(Ne),mt.showNotebookDocument(te,ue)},registerExternalUriOpener(te,ue,Le){return(0,W.checkProposedApiEnabled)(Ne),Cn.registerExternalUriOpener(Ne.identifier,te,ue,Le)},get openEditors(){return(0,W.checkProposedApiEnabled)(Ne),Et.tabs},get onDidChangeOpenEditors(){return(0,W.checkProposedApiEnabled)(Ne),Et.onDidChangeTabs},getInlineCompletionItemController(te){return(0,W.checkProposedApiEnabled)(Ne),f.InlineCompletionController.get(te)}},vn={get rootPath(){return ht.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ve.getPath()},set rootPath(te){throw L.readonly()},getWorkspaceFolder(te){return ve.getWorkspaceFolder(te)},get workspaceFolders(){return ve.getWorkspaceFolders()},get name(){return ve.name},set name(te){throw L.readonly()},get workspaceFile(){return ve.workspaceFile},set workspaceFile(te){throw L.readonly()},updateWorkspaceFolders:(te,ue,...Le)=>ve.updateWorkspaceFolders(Ne,te,ue||0,...Le),onDidChangeWorkspaceFolders:function(te,ue,Le){return ve.onDidChangeWorkspace(te,ue,Le)},asRelativePath:(te,ue)=>ve.getRelativePath(te,ue),findFiles:(te,ue,Le,rt)=>ve.findFiles(x.GlobPattern.from(te),x.GlobPattern.from(ue),Le,Ne.identifier,rt),findTextInFiles:(te,ue,Le,rt)=>{let pt,Dt;return typeof ue=="object"?(pt=ue,Dt=Le):(pt={},Dt=ue,rt=Le),ve.findTextInFiles(te,pt||{},Dt,Ne.identifier,rt)},saveAll:te=>ve.saveAll(te),applyEdit(te){return rn.applyWorkspaceEdit(te)},createFileSystemWatcher:(te,ue,Le,rt)=>Rt.createFileSystemWatcher(x.GlobPattern.from(te),ue,Le,rt),get textDocuments(){return kt.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw L.readonly()},openTextDocument(te){let ue;const Le=te;if(typeof te=="string")ue=Promise.resolve(T.URI.file(te));else if(T.URI.isUri(te))ue=Promise.resolve(te);else if(!Le||typeof Le=="object")ue=kt.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(rt=>kt.ensureDocumentData(rt).then(pt=>pt.document))},onDidOpenTextDocument:(te,ue,Le)=>kt.onDidAddDocument(te,ue,Le),onDidCloseTextDocument:(te,ue,Le)=>kt.onDidRemoveDocument(te,ue,Le),onDidChangeTextDocument:(te,ue,Le)=>kt.onDidChangeDocument(te,ue,Le),onDidSaveTextDocument:(te,ue,Le)=>kt.onDidSaveDocument(te,ue,Le),onWillSaveTextDocument:(te,ue,Le)=>Xt.getOnWillSaveTextDocumentEvent(Ne)(te,ue,Le),get notebookDocuments(){return mt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,ue){let Le;if(T.URI.isUri(te))Le=te,await mt.openNotebookDocument(te);else if(typeof te=="string")Le=T.URI.revive(await mt.createNotebookDocument({viewType:te,content:ue}));else throw new Error("Invalid arguments");return mt.getNotebookDocument(Le).apiNotebook},get onDidOpenNotebookDocument(){return mt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return mt.onDidCloseNotebookDocument},registerNotebookSerializer(te,ue,Le,rt){return mt.registerNotebookSerializer(Ne,te,ue,Le,Ne.enableProposedApi?rt:void 0)},registerNotebookContentProvider:(te,ue,Le,rt)=>((0,W.checkProposedApiEnabled)(Ne),mt.registerNotebookContentProvider(Ne,te,ue,Le,Ne.enableProposedApi?rt:void 0)),onDidChangeConfiguration:(te,ue,Le)=>mn.onDidChangeConfiguration(te,ue,Le),getConfiguration(te,ue){return ue=arguments.length===1?void 0:ue,mn.getConfiguration(te,ue,Ne)},registerTextDocumentContentProvider(te,ue){return Qt.registerTextDocumentContentProvider(te,ue)},registerTaskProvider:(te,ue)=>(ht.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),Pt.registerTaskProvider(Ne,te,ue)),registerFileSystemProvider(te,ue,Le){return En.registerFileSystemProvider(Ne.identifier,te,ue,Le,Ne.enableProposedApi)},get fs(){return ut.value},registerFileSearchProvider:(te,ue)=>((0,W.checkProposedApiEnabled)(Ne),Nt.registerFileSearchProvider(te,ue)),registerTextSearchProvider:(te,ue)=>((0,W.checkProposedApiEnabled)(Ne),Nt.registerTextSearchProvider(te,ue)),registerRemoteAuthorityResolver:(te,ue)=>((0,W.checkProposedApiEnabled)(Ne),bt.registerRemoteAuthorityResolver(te,ue)),registerResourceLabelFormatter:te=>((0,W.checkProposedApiEnabled)(Ne),Sn.$registerResourceLabelFormatter(te)),onDidCreateFiles:(te,ue,Le)=>Rt.onDidCreateFile(te,ue,Le),onDidDeleteFiles:(te,ue,Le)=>Rt.onDidDeleteFile(te,ue,Le),onDidRenameFiles:(te,ue,Le)=>Rt.onDidRenameFile(te,ue,Le),onWillCreateFiles:(te,ue,Le)=>Rt.getOnWillCreateFileEvent(Ne)(te,ue,Le),onWillDeleteFiles:(te,ue,Le)=>Rt.getOnWillDeleteFileEvent(Ne)(te,ue,Le),onWillRenameFiles:(te,ue,Le)=>Rt.getOnWillRenameFileEvent(Ne)(te,ue,Le),openTunnel:te=>((0,W.checkProposedApiEnabled)(Ne),lt.openTunnel(Ne,te).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,W.checkProposedApiEnabled)(Ne),lt.getTunnels()},onDidChangeTunnels:(te,ue,Le)=>((0,W.checkProposedApiEnabled)(Ne),lt.onDidChangeTunnels(te,ue,Le)),registerPortAttributesProvider:(te,ue)=>((0,W.checkProposedApiEnabled)(Ne),lt.registerPortsAttributesProvider(te,ue)),registerTimelineProvider:(te,ue)=>((0,W.checkProposedApiEnabled)(Ne),en.registerTimelineProvider(te,ue,Ne.identifier,dt.converter)),get isTrusted(){return ve.trusted},requestWorkspaceTrust:te=>((0,W.checkProposedApiEnabled)(Ne),ve.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,ue,Le)=>ve.onDidGrantWorkspaceTrust(te,ue,Le)},Fn={get inputBox(){return ht.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),un.getLastInputBox(Ne)},createSourceControl(te,ue,Le){return un.createSourceControl(Ne,te,ue,Le)}},Mn={createCommentController(te,ue){return _n.createCommentController(Ne,te,ue)}},wn={get activeDebugSession(){return ft.activeDebugSession},get activeDebugConsole(){return ft.activeDebugConsole},get breakpoints(){return ft.breakpoints},onDidStartDebugSession(te,ue,Le){return ft.onDidStartDebugSession(te,ue,Le)},onDidTerminateDebugSession(te,ue,Le){return ft.onDidTerminateDebugSession(te,ue,Le)},onDidChangeActiveDebugSession(te,ue,Le){return ft.onDidChangeActiveDebugSession(te,ue,Le)},onDidReceiveDebugSessionCustomEvent(te,ue,Le){return ft.onDidReceiveDebugSessionCustomEvent(te,ue,Le)},onDidChangeBreakpoints(te,ue,Le){return ft.onDidChangeBreakpoints(te,ue,Le)},registerDebugConfigurationProvider(te,ue,Le){return ft.registerDebugConfigurationProvider(te,ue,Le||R.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,ue){return ft.registerDebugAdapterDescriptorFactory(Ne,te,ue)},registerDebugAdapterTrackerFactory(te,ue){return ft.registerDebugAdapterTrackerFactory(te,ue)},startDebugging(te,ue,Le){return!Le||typeof Le=="object"&&"configuration"in Le?ft.startDebugging(te,ue,{parentSession:Le}):ft.startDebugging(te,ue,Le||{})},stopDebugging(te){return ft.stopDebugging(te)},addBreakpoints(te){return ft.addBreakpoints(te)},removeBreakpoints(te){return ft.removeBreakpoints(te)},asDebugSourceUri(te,ue){return ft.asDebugSourceUri(te,ue)}},On={registerTaskProvider:(te,ue)=>Pt.registerTaskProvider(Ne,te,ue),fetchTasks:te=>Pt.fetchTasks(te),executeTask:te=>Pt.executeTask(Ne,te),get taskExecutions(){return Pt.taskExecutions},onDidStartTask:(te,ue,Le)=>Pt.onDidStartTask(te,ue,Le),onDidEndTask:(te,ue,Le)=>Pt.onDidEndTask(te,ue,Le),onDidStartTaskProcess:(te,ue,Le)=>Pt.onDidStartTaskProcess(te,ue,Le),onDidEndTaskProcess:(te,ue,Le)=>Pt.onDidEndTaskProcess(te,ue,Le)},an={createNotebookController(te,ue,Le,rt,pt){return Yt.createNotebookController(Ne,te,ue,Le,rt,Ne.enableProposedApi?pt:void 0)},registerNotebookCellStatusBarItemProvider:(te,ue)=>mt.registerNotebookCellStatusBarItemProvider(Ne,te,ue),get onDidSaveNotebookDocument(){return(0,W.checkProposedApiEnabled)(Ne),jt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(te){return(0,W.checkProposedApiEnabled)(Ne),zt.createNotebookEditorDecorationType(te)},createRendererMessaging(te){return(0,W.checkProposedApiEnabled)(Ne),Jt.createRendererMessaging(te)},onDidChangeNotebookDocumentMetadata(te,ue,Le){return(0,W.checkProposedApiEnabled)(Ne),jt.onDidChangeNotebookDocumentMetadata(te,ue,Le)},onDidChangeNotebookCells(te,ue,Le){return(0,W.checkProposedApiEnabled)(Ne),mt.onDidChangeNotebookCells(te,ue,Le)},onDidChangeNotebookCellExecutionState(te,ue,Le){return(0,W.checkProposedApiEnabled)(Ne),mt.onDidChangeNotebookCellExecutionState(te,ue,Le)},onDidChangeCellOutputs(te,ue,Le){return(0,W.checkProposedApiEnabled)(Ne),mt.onDidChangeCellOutputs(te,ue,Le)},onDidChangeCellMetadata(te,ue,Le){return(0,W.checkProposedApiEnabled)(Ne),mt.onDidChangeCellMetadata(te,ue,Le)},createConcatTextDocument(te,ue){return(0,W.checkProposedApiEnabled)(Ne),new Ee.ExtHostNotebookConcatDocument(mt,kt,te,ue)}};return{version:Xe.version,authentication:Pn,commands:An,comments:Mn,debug:wn,env:gn,extensions:Tn,languages:Rn,notebooks:an,scm:Fn,tasks:On,test:on,window:Ln,workspace:vn,Breakpoint:R.Breakpoint,CallHierarchyIncomingCall:R.CallHierarchyIncomingCall,CallHierarchyItem:R.CallHierarchyItem,CallHierarchyOutgoingCall:R.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:p.CancellationTokenSource,CandidatePortSource:c.CandidatePortSource,CodeAction:R.CodeAction,CodeActionKind:R.CodeActionKind,CodeActionTriggerKind:R.CodeActionTriggerKind,CodeLens:R.CodeLens,Color:R.Color,ColorInformation:R.ColorInformation,ColorPresentation:R.ColorPresentation,ColorThemeKind:R.ColorThemeKind,CommentMode:R.CommentMode,CommentThreadCollapsibleState:R.CommentThreadCollapsibleState,CompletionItem:R.CompletionItem,CompletionItemKind:R.CompletionItemKind,CompletionItemTag:R.CompletionItemTag,CompletionList:R.CompletionList,CompletionTriggerKind:R.CompletionTriggerKind,ConfigurationTarget:R.ConfigurationTarget,CustomExecution:R.CustomExecution,DebugAdapterExecutable:R.DebugAdapterExecutable,DebugAdapterInlineImplementation:R.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:R.DebugAdapterNamedPipeServer,DebugAdapterServer:R.DebugAdapterServer,DebugConfigurationProviderTriggerKind:R.DebugConfigurationProviderTriggerKind,DebugConsoleMode:R.DebugConsoleMode,DecorationRangeBehavior:R.DecorationRangeBehavior,Diagnostic:R.Diagnostic,DiagnosticRelatedInformation:R.DiagnosticRelatedInformation,DiagnosticSeverity:R.DiagnosticSeverity,DiagnosticTag:R.DiagnosticTag,Disposable:R.Disposable,DocumentHighlight:R.DocumentHighlight,DocumentHighlightKind:R.DocumentHighlightKind,DocumentLink:R.DocumentLink,DocumentSymbol:R.DocumentSymbol,EndOfLine:R.EndOfLine,EnvironmentVariableMutatorType:R.EnvironmentVariableMutatorType,EvaluatableExpression:R.EvaluatableExpression,InlineValueText:R.InlineValueText,InlineValueVariableLookup:R.InlineValueVariableLookup,InlineValueEvaluatableExpression:R.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:R.InlineCompletionTriggerKind,EventEmitter:C.Emitter,ExtensionKind:R.ExtensionKind,ExtensionMode:R.ExtensionMode,ExternalUriOpenerPriority:R.ExternalUriOpenerPriority,FileChangeType:R.FileChangeType,FileDecoration:R.FileDecoration,FileSystemError:R.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:R.FoldingRange,FoldingRangeKind:R.FoldingRangeKind,FunctionBreakpoint:R.FunctionBreakpoint,InlineCompletionItem:R.InlineSuggestion,InlineCompletionList:R.InlineSuggestions,Hover:R.Hover,IndentAction:A.IndentAction,Location:R.Location,MarkdownString:R.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:R.ParameterInformation,PortAutoForwardAction:R.PortAutoForwardAction,Position:R.Position,ProcessExecution:R.ProcessExecution,ProgressLocation:R.ProgressLocation,QuickInputButtons:R.QuickInputButtons,Range:R.Range,RelativePattern:R.RelativePattern,Selection:R.Selection,SelectionRange:R.SelectionRange,SemanticTokens:R.SemanticTokens,SemanticTokensBuilder:R.SemanticTokensBuilder,SemanticTokensEdit:R.SemanticTokensEdit,SemanticTokensEdits:R.SemanticTokensEdits,SemanticTokensLegend:R.SemanticTokensLegend,ShellExecution:R.ShellExecution,ShellQuoting:R.ShellQuoting,SignatureHelp:R.SignatureHelp,SignatureHelpTriggerKind:R.SignatureHelpTriggerKind,SignatureInformation:R.SignatureInformation,SnippetString:R.SnippetString,SourceBreakpoint:R.SourceBreakpoint,StandardTokenType:R.StandardTokenType,StatusBarAlignment:R.StatusBarAlignment,SymbolInformation:R.SymbolInformation,SymbolKind:R.SymbolKind,SymbolTag:R.SymbolTag,Task:R.Task,TaskGroup:R.TaskGroup,TaskPanelKind:R.TaskPanelKind,TaskRevealKind:R.TaskRevealKind,TaskScope:R.TaskScope,TerminalLink:R.TerminalLink,TerminalProfile:R.TerminalProfile,TextDocumentSaveReason:R.TextDocumentSaveReason,TextEdit:R.TextEdit,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:R.TextEditorLineNumbersStyle,TextEditorRevealType:R.TextEditorRevealType,TextEditorSelectionChangeKind:R.TextEditorSelectionChangeKind,TextDocumentChangeReason:R.TextDocumentChangeReason,ThemeColor:R.ThemeColor,ThemeIcon:R.ThemeIcon,TreeItem:R.TreeItem,TreeItemCollapsibleState:R.TreeItemCollapsibleState,UIKind:c.UIKind,Uri:T.URI,ViewColumn:R.ViewColumn,WorkspaceEdit:R.WorkspaceEdit,InlayHint:R.InlayHint,InlayHintKind:R.InlayHintKind,RemoteAuthorityResolverError:R.RemoteAuthorityResolverError,ResolvedAuthority:R.ResolvedAuthority,SourceControlInputBoxValidationType:R.SourceControlInputBoxValidationType,ExtensionRuntime:R.ExtensionRuntime,TimelineItem:R.TimelineItem,NotebookRange:R.NotebookRange,NotebookCellKind:R.NotebookCellKind,NotebookCellExecutionState:R.NotebookCellExecutionState,NotebookCellData:R.NotebookCellData,NotebookData:R.NotebookData,NotebookRendererScript:R.NotebookRendererScript,NotebookCellStatusBarAlignment:R.NotebookCellStatusBarAlignment,NotebookEditorRevealType:R.NotebookEditorRevealType,NotebookCellOutput:R.NotebookCellOutput,NotebookCellOutputItem:R.NotebookCellOutputItem,NotebookCellStatusBarItem:R.NotebookCellStatusBarItem,NotebookControllerAffinity:R.NotebookControllerAffinity,PortAttributes:R.PortAttributes,LinkedEditingRanges:R.LinkedEditingRanges,TestResultState:R.TestResultState,TestRunRequest:R.TestRunRequest,TestMessage:R.TestMessage,TestRunConfigurationGroup:R.TestRunConfigurationGroup,TextSearchCompleteMessageType:be.TextSearchCompleteMessageType,TestMessageSeverity:R.TestMessageSeverity,CoveredCount:R.CoveredCount,FileCoverage:R.FileCoverage,StatementCoverage:R.StatementCoverage,BranchCoverage:R.BranchCoverage,FunctionCoverage:R.FunctionCoverage,WorkspaceTrustState:R.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Ze}),define(he[268],fe([0,1,78,62,35,128,36,50,43,33,66,51,68,90,49,61,129,89,59,88,119,48]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u,a,g,w,_,b,d,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,p.registerSingleton)(g.IExtHostApiDeprecationService,g.ExtHostApiDeprecationService),(0,p.registerSingleton)(I.IExtHostCommands,I.ExtHostCommands),(0,p.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration),(0,p.registerSingleton)(_.IExtHostConsumerFileSystem,_.ExtHostConsumerFileSystem),(0,p.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService),(0,p.registerSingleton)(y.IExtHostDecorations,y.ExtHostDecorations),(0,p.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,p.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo),(0,p.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService),(0,p.registerSingleton)(c.IExtHostSearch,c.ExtHostSearch),(0,p.registerSingleton)(u.IExtHostStorage,u.ExtHostStorage),(0,p.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,p.registerSingleton)(A.IExtHostTerminalService,A.WorkerExtHostTerminalService),(0,p.registerSingleton)(a.IExtHostTunnelService,a.ExtHostTunnelService),(0,p.registerSingleton)(w.IExtHostWindow,w.ExtHostWindow),(0,p.registerSingleton)(C.IExtHostWorkspace,C.ExtHostWorkspace),(0,p.registerSingleton)(d.IExtHostSecretState,d.ExtHostSecretState),(0,p.registerSingleton)(h.IExtHostTelemetry,h.ExtHostTelemetry),(0,p.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs)}),define(he[91],fe([0,1,18,12,31,65]),function(X,e,p,L,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function T(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.anchorGlob=T;function I(P,c,u,a){const g=(0,p.mapArrayOrNot)(u,D),w=new C.TextSearchMatch(c,g,a),_=w.preview.matches;return{ranges:(0,p.mapArrayOrNot)(g,A),uri:P,preview:{text:w.preview.text,matches:(0,p.mapArrayOrNot)(_,A)}}}e.createTextSearchResult=I;function D(P){return new C.SearchRange(P.start.line,P.start.character,P.end.line,P.end.character)}function A(P){return new y.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let i=class{constructor(c,u){this.prefix=c,this.logService=u}appendLine(c){this.logService.debug(`${this.prefix}#search`,c)}};i=je([We(1,L.ILogService)],i),e.OutputChannel=i}),define(he[269],fe([0,1,93,22]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function C(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(s=>s===t)}e.isUTFEncoding=C,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const y=512,T=512,I=512*8,D=512*128;class A{constructor(s){this.iconvLiteDecoder=s}static async create(s){let r;if(s!==e.UTF8)r=(await new Promise((l,f)=>{X(["iconv-lite-umd"],l,f)})).getDecoder(u(s));else{const n=new TextDecoder;r={write(l){return n.decode(l,{stream:!0})},end(){return n.decode()}}}return new A(r)}write(s){return this.iconvLiteDecoder.write(s)}end(){return this.iconvLiteDecoder.end()}}function i(t,s){const r=s.minBytesRequiredForDetection??s.guessEncoding?I:T;return new Promise((n,l)=>{const f=(0,p.newWriteableStream)(k=>k.join("")),m=[];let E=0,S;const o=async()=>{try{const k=await v({buffer:L.VSBuffer.concat(m),bytesRead:E},s.guessEncoding);k.encoding=await s.overwriteEncoding(k.encoding),S=await A.create(k.encoding);const O=S.write(L.VSBuffer.concat(m).buffer);f.write(O),m.length=0,E=0,n({stream:f,detected:k})}catch(k){l(k)}};(0,p.listenStream)(t,{onData:async k=>{S?f.write(S.write(k.buffer)):(m.push(k),E+=k.byteLength,E>=r&&(t.pause(),await o(),setTimeout(()=>t.resume())))},onError:k=>f.error(k),onEnd:async()=>{S||await o(),f.end(S?.end())}})})}e.toDecodeStream=i;async function P(t,s,r){const l=(await new Promise((E,S)=>{X(["iconv-lite-umd"],E,S)})).getEncoder(u(s),r);let f=!1,m=!1;return{read(){if(m)return null;const E=t.read();if(typeof E!="string"){if(m=!0,!f&&r?.addBOM)switch(s){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const S=l.end();return S&&S.length>0?(f=!0,L.VSBuffer.wrap(S)):null}return f=!0,L.VSBuffer.wrap(l.write(E))}}}e.toEncodeReadable=P;async function c(t){return(await new Promise((r,n)=>{X(["iconv-lite-umd"],r,n)})).encodingExists(u(t))}e.encodingExists=c;function u(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=u;function a(t,s){if(!t||s<e.UTF16be_BOM.length)return null;const r=t.readUInt8(0),n=t.readUInt8(1);if(r===e.UTF16be_BOM[0]&&n===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&n===e.UTF16le_BOM[1])return e.UTF16le;if(s<e.UTF8_BOM.length)return null;const l=t.readUInt8(2);return r===e.UTF8_BOM[0]&&n===e.UTF8_BOM[1]&&l===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=a;const g=["ascii","utf-16","utf-32"];async function w(t){const s=await new Promise((m,E)=>{X(["jschardet"],m,E)}),r=t.slice(0,D),n=d(r.buffer),l=s.detect(n);if(!l||!l.encoding)return null;const f=l.encoding.toLowerCase();return 0<=g.indexOf(f)?null:b(l.encoding)}const _={ibm866:"cp866",big5:"cp950"};function b(t){const s=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return _[s]||s}function d(t){let s="";for(let r=0;r<t.length;r++)s+=String.fromCharCode(t[r]);return s}function h(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const s=t.match(/windows(\d+)/);return s?"windows-"+s[1]:t}}e.toCanonicalName=h;function v({buffer:t,bytesRead:s},r){let n=a(t,s),l=!1;if(n!==e.UTF16be&&n!==e.UTF16le&&t){let f=!0,m=!0,E=!1;for(let S=0;S<s&&S<y;S++){const o=S%2==1,k=t.readUInt8(S)===0;if(k&&(E=!0),f&&(o&&!k||!o&&k)&&(f=!1),m&&(o&&k||!o&&!k)&&(m=!1),k&&!f&&!m)break}E&&(f?n=e.UTF16le:m?n=e.UTF16be:l=!0)}return r&&!l&&!n&&t?w(t.slice(0,s)).then(f=>({seemsBinary:!1,encoding:f})):{seemsBinary:l,encoding:n}}e.detectEncodingFromBuffer=v,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(he[131],fe([0,1,269,28,130]),function(X,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class y extends C.TextSearchManager{constructor(I,D,A=L){super(I,D,{readdir:i=>A.Promises.readdir(i.fsPath),toCanonicalName:i=>(0,p.toCanonicalName)(i)})}}e.NativeTextSearchManager=y}),define(he[270],fe([0,1,271,286,287,2,288]),function(X,e,p,L,C,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function I(P,c,u,a,g,w){const _=w.environment.useHostProxy,b=typeof _=="boolean"?_:!w.remote.isRemote,d=(0,T.createProxyResolver)({resolveProxy:v=>P.resolveProxy(v),getHttpProxySetting:()=>c.getConfiguration("http").get("proxy"),log:(v,t,...s)=>{switch(v){case T.LogLevel.Trace:a.trace(t,...s);break;case T.LogLevel.Debug:a.debug(t,...s);break;case T.LogLevel.Info:a.info(t,...s);break;case T.LogLevel.Warning:a.warn(t,...s);break;case T.LogLevel.Error:a.error(t,...s);break;case T.LogLevel.Critical:a.critical(t,...s);break;case T.LogLevel.Off:break;default:r(v,t,s);break}function r(n,l,...f){a.error("Unknown log level",n),a.error(l,...f)}},getLogLevel:()=>a.getLevel(),proxyResolveTelemetry:v=>{g.$publicLog2("resolveProxy",v)},useHostProxy:b,env:process.env}),h=D(c,d);return i(u,h)}e.connectProxyResolver=I;function D(P,c){const u={config:P.getConfiguration("http").get("proxySupport")||"off"};P.onDidChangeConfiguration(g=>{u.config=P.getConfiguration("http").get("proxySupport")||"off"});const a={config:!!P.getConfiguration("http").get("systemCertificates")};return P.onDidChangeConfiguration(g=>{a.config=!!P.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},p,(0,T.createHttpPatch)(p,c,{config:"off"},a,!0)),on:Object.assign({},p,(0,T.createHttpPatch)(p,c,{config:"on"},a,!0)),override:Object.assign({},p,(0,T.createHttpPatch)(p,c,{config:"override"},a,!0)),onRequest:Object.assign({},p,(0,T.createHttpPatch)(p,c,u,a,!0)),default:Object.assign(p,(0,T.createHttpPatch)(p,c,u,a,!1))},https:{off:Object.assign({},L,(0,T.createHttpPatch)(L,c,{config:"off"},a,!0)),on:Object.assign({},L,(0,T.createHttpPatch)(L,c,{config:"on"},a,!0)),override:Object.assign({},L,(0,T.createHttpPatch)(L,c,{config:"override"},a,!0)),onRequest:Object.assign({},L,(0,T.createHttpPatch)(L,c,u,a,!0)),default:Object.assign(L,(0,T.createHttpPatch)(L,c,u,a,!1))},tls:Object.assign(C,(0,T.createTlsPatch)(C))}}const A=new Map;function i(P,c){return P.getExtensionPathIndex().then(u=>{const a=X.__$__nodeRequire("module"),g=a._load;a._load=function(_,b,d){if(_==="tls")return c.tls;if(_!=="http"&&_!=="https")return g.apply(this,arguments);const h=c[_],v=u.findSubstr(y.URI.file(b.filename).fsPath);let t=A.get(v);if(t||A.set(v,t={}),!t[_]){let s=h.default;v&&v.enableProposedApi&&(s=h[v.proxySupport]||h.onRequest),t[_]={...s}}return t[_]}})}}),define(he[272],fe([0,1,38,9,75,29,11,8,91,273]),function(X,e,p,L,C,y,T,I,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const i=A.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(d,h,v,t){const s=c(d,h,v,t),r=h.folder.fsPath;return{cmd:p.spawn(i,s.args,{cwd:r}),rgDiskPath:i,siblingClauses:s.siblingClauses,rgArgs:s,cwd:r}}e.spawnRipgrepCmd=P;function c(d,h,v,t){const s=["--files","--hidden","--case-sensitive"];a([h],v,!1).forEach(n=>{const l=(0,D.anchorGlob)(n);if(s.push("-g",l),T.isMacintosh){const f=(0,C.normalizeNFD)(l);f!==l&&s.push("-g",f)}});const r=u([h],t,void 0,!1);return r.globArgs.forEach(n=>{const l=`!${(0,D.anchorGlob)(n)}`;if(s.push("-g",l),T.isMacintosh){const f=(0,C.normalizeNFD)(l);f!==l&&s.push("-g",f)}}),h.disregardIgnoreFiles!==!1?s.push("--no-ignore"):s.push("--no-ignore-parent"),h.ignoreSymlinks||s.push("--follow"),d.exists&&s.push("--quiet"),s.push("--no-config"),h.disregardGlobalIgnoreFiles&&s.push("--no-ignore-global"),{args:s,siblingClauses:r.siblingClauses}}function u(d,h,v,t=!0){const s=[];let r={};return d.forEach(n=>{const l=Object.assign({},n.excludePattern||{},h||{}),f=g(l,t?n.folder.fsPath:void 0,v);s.push(...f.globArgs),f.siblingClauses&&(r=Object.assign(r,f.siblingClauses))}),{globArgs:s,siblingClauses:r}}e.foldersToRgExcludeGlobs=u;function a(d,h,v=!0){const t=[];return d.forEach(s=>{const r=Object.assign({},h||{},s.includePattern||{}),n=g(r,v?s.folder.fsPath:void 0);t.push(...n.globArgs)}),t}e.foldersToIncludeGlobs=a;function g(d,h,v){const t=[],s={};return Object.keys(d).forEach(r=>{if(v&&v.has(r)||!r)return;const n=d[r];r=_(h?w(h,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof n=="boolean"&&n?(r.startsWith("\\\\")&&(r+="**"),t.push(b(r))):n&&n.when&&(s[r]=n)}),{globArgs:t,siblingClauses:s}}function w(d,h){return L.isAbsolute(h)?h:L.join(d,h)}e.getAbsoluteGlob=w;function _(d){return d=I.rtrim(d,"\\"),I.rtrim(d,"/")}function b(d){return y.getRoot(d).toLowerCase()==="c:/"?d.replace(/^c:[/\\]/i,"/"):d}e.fixDriveC=b}),define(he[274],fe([0,1,38,45,9,101,18,58,30,75,29,11,44,8,14,28,31,272,98]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u,a,g,w,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const d=new Set;process.on("exit",()=>{d.forEach(r=>r())});class h{constructor(n){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=n,this.filePattern=n.filePattern||"",this.includePattern=n.includePattern&&D.parse(n.includePattern),this.maxResults=n.maxResults||null,this.exists=!!n.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,b.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=n.excludePattern&&D.parse(n.excludePattern),this.folderExcludePatterns=new Map,n.folderQueries.forEach(l=>{const f=Object.assign({},l.excludePattern||{},this.config.excludePattern||{}),m=l.folder.fsPath;n.folderQueries.map(E=>E.folder.fsPath).filter(E=>E!==m).forEach(E=>{(0,i.isEqualOrParent)(E,m)&&(f[C.relative(m,E)]=!0)}),this.folderExcludePatterns.set(m,new t(f,m))})}cancel(){this.isCanceled=!0}walk(n,l,f,m,E){if(this.fileWalkSW=c.StopWatch.create(!1),this.isCanceled)return E(null,this.isLimitHit);l.forEach(S=>{const o=C.basename(S.fsPath);this.globalExcludePattern&&this.globalExcludePattern(S.fsPath,o)||this.matchFile(f,{relativePath:S.fsPath,searchPath:void 0})}),this.cmdSW=c.StopWatch.create(!1),this.parallel(n,(S,o)=>{this.call(this.cmdTraversal,this,S,f,m,k=>{if(k){const O=(0,I.toErrorMessage)(k);console.error(O),this.errors.push(O),o(k,void 0)}else o(null,void 0)})},(S,o)=>{this.fileWalkSW.stop();const k=S?T.coalesce(S)[0]:null;E(k,this.isLimitHit)})}parallel(n,l,f){const m=new Array(n.length),E=new Array(n.length);let S=!1,o=0;if(n.length===0)return f(null,[]);n.forEach((k,O)=>{l(k,($,G)=>{if($?(S=!0,m[O]=null,E[O]=$):(m[O]=G,E[O]=null),++o===n.length)return f(S?E:null,m)})})}call(n,l,...f){try{n.apply(l,f)}catch(m){f[f.length-1](m)}}cmdTraversal(n,l,f,m){const E=n.folder.fsPath,S=P.isMacintosh;let o;const k=()=>o&&o.kill();d.add(k);let O=R=>{d.delete(k),O=()=>{},m(R)},$="";const G=this.initDirectoryTree();let re;const j=(0,_.spawnRipgrepCmd)(this.config,n,this.config.includePattern,this.folderExcludePatterns.get(n.folder.fsPath).expression);o=j.cmd,re=!Object.keys(j.siblingClauses).length;const N=j.rgArgs.args.map(R=>R.match(/^-/)?R:`'${R}'`).join(" ");let x=`${j.rgDiskPath} ${N}
 - cwd: ${j.cwd}`;j.rgArgs.siblingClauses&&(x+=`
 - Sibling clauses: ${JSON.stringify(j.rgArgs.siblingClauses)}`),f({message:x}),this.cmdResultCount=0,this.collectStdout(o,"utf8",f,(R,V,F)=>{if(R){O(R);return}if(this.isLimitHit){O();return}const B=($+(S?A.normalizeNFC(V||""):V)).split(`
`);if(F){const W=B.length;B[W-1]=B[W-1].trim(),B[W-1]||B.pop()}else $=B.pop()||"";if(B.length&&B[0].indexOf(`
`)!==-1){O(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=B.length,re){for(const W of B)if(this.matchFile(l,{base:E,relativePath:W,searchPath:this.getSearchPath(n,W)}),this.isLimitHit){k();break}(F||this.isLimitHit)&&O();return}this.addDirectoryEntries(n,G,E,B,l),F&&(this.matchDirectoryTree(G,E,l),O())})}spawnFindCmd(n){const l=this.folderExcludePatterns.get(n.folder.fsPath),f=l.getBasenameTerms(),m=l.getPathTerms(),E=["-L","."];if(f.length||m.length){E.push("-not","(","(");for(const S of f)E.push("-name",S),E.push("-o");for(const S of m)E.push("-path",S),E.push("-o");E.pop(),E.push(")","-prune",")")}return E.push("-type","f"),p.spawn("find",E,{cwd:n.folder.fsPath})}readStdout(n,l,f){let m="";this.collectStdout(n,l,()=>{},(E,S,o)=>{if(E){f(E);return}m+=S,o&&f(null,m)})}collectStdout(n,l,f,m){let E=(k,O,$)=>{(k||$)&&(E=()=>{},this.cmdSW&&this.cmdSW.stop()),m(k,O,$)},S=!1;n.stdout?(this.forwardData(n.stdout,l,E),n.stdout.once("data",()=>S=!0)):f({message:"stdout is null"});let o;n.stderr?o=this.collectData(n.stderr):f({message:"stderr is null"}),n.on("error",k=>{E(k)}),n.on("close",k=>{let O;!S&&(O=this.decodeData(o,l))&&s(O)?E(new Error(`command failed with error code ${k}: ${this.decodeData(o,l)}`)):(this.exists&&k===0&&(this.isLimitHit=!0),E(null,"",!0))})}forwardData(n,l,f){const m=new y.StringDecoder(l);return n.on("data",E=>{f(null,m.write(E))}),m}collectData(n){const l=[];return n.on("data",f=>{l.push(f)}),l}decodeData(n,l){const f=new y.StringDecoder(l);return n.map(m=>f.write(m)).join("")}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries(n,{pathToEntries:l},f,m,E){m.indexOf(this.filePattern)!==-1&&this.matchFile(E,{base:f,relativePath:this.filePattern,searchPath:this.getSearchPath(n,this.filePattern)});const S=o=>{const k=C.basename(o),O=C.dirname(o);let $=l[O];$||($=l[O]=[],S(O)),$.push({base:f,relativePath:o,basename:k,searchPath:this.getSearchPath(n,o)})};m.forEach(S)}matchDirectoryTree({rootEntries:n,pathToEntries:l},f,m){const E=this,S=this.folderExcludePatterns.get(f),o=this.filePattern;function k(O){E.directoriesWalked++;const $=D.hasSiblingFn(()=>O.map(G=>G.basename));for(let G=0,re=O.length;G<re;G++){const j=O[G],{relativePath:N,basename:x}=j;if(S.test(N,x,o!==x?$:void 0))continue;const R=l[N];if(R)k(R);else{if(E.filesWalked++,N===o)continue;E.matchFile(m,j)}if(E.isLimitHit)break}}k(n)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(n,l,f,m,E){const S=n.folder,o=D.hasSiblingFn(()=>f);this.parallel(f,(k,O)=>{if(this.isCanceled||this.isLimitHit)return O(null);const $=l?[l,k].join(C.sep):k;if(this.folderExcludePatterns.get(n.folder.fsPath).test($,k,this.config.filePattern!==k?o:void 0))return O(null);const G=[S.fsPath,$].join(C.sep);L.lstat(G,(re,j)=>{if(re||this.isCanceled||this.isLimitHit)return O(null);this.statLinkIfNeeded(G,j,(N,x)=>N||this.isCanceled||this.isLimitHit?O(null):x.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(G,j,(R,V)=>R||this.isCanceled||this.isLimitHit||(V=V||"",this.walkedPaths[V])?O(null):(this.walkedPaths[V]=!0,g.Promises.readdir(G).then(F=>{if(this.isCanceled||this.isLimitHit)return O(null);this.doWalk(n,$,F,m,M=>O(M||null))},F=>{O(null)})))):(this.filesWalked++,$===this.filePattern||this.maxFilesize&&a.isNumber(x.size)&&x.size>this.maxFilesize||this.matchFile(m,{base:S.fsPath,relativePath:$,searchPath:this.getSearchPath(n,$)}),O(null,void 0)))})},k=>{const O=k&&T.coalesce(k);return E(O&&O.length>0?O[0]:void 0)})}matchFile(n,l){this.isFileMatch(l)&&(!this.includePattern||this.includePattern(l.relativePath,C.basename(l.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||n(l))}isFileMatch(n){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,w.isFilePatternMatch)(n,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(n,l,f){return l.isSymbolicLink()?L.stat(n,f):f(null,l)}realPathIfNeeded(n,l,f){return l.isSymbolicLink()?L.realpath(n,(m,E)=>m?f(m):f(null,E)):f(null,n)}getSearchPath(n,l){return n.folderName?C.join(n.folderName,l):l}}e.FileWalker=h;class v{constructor(n){this.folderQueries=n.folderQueries,this.extraFiles=n.extraFileResources||[],this.walker=new h(n)}search(n,l,f){this.walker.walk(this.folderQueries,this.extraFiles,n,l,(m,E)=>{f(m,{limitHit:E,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=v;class t{constructor(n,l){this.expression=n,this.root=l,this.init(n)}init(n){let l,f;Object.keys(n).filter(m=>n[m]).forEach(m=>{C.isAbsolute(m)?(l=l||D.getEmptyExpression(),l[m]=n[m]):(f=f||D.getEmptyExpression(),f[m]=n[m])}),this.absoluteParsedExpr=l&&D.parse(l,{trimForExclusions:!0}),this.relativeParsedExpr=f&&D.parse(f,{trimForExclusions:!0})}test(n,l,f){return this.relativeParsedExpr&&this.relativeParsedExpr(n,l,f)||this.absoluteParsedExpr&&this.absoluteParsedExpr(C.join(this.root,n),l,f)}getBasenameTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...D.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...D.getBasenameTerms(this.relativeParsedExpr)),n}getPathTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...D.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...D.getPathTerms(this.relativeParsedExpr)),n}}function s(r){const n=r.trim().split(`
`),l=n[0].trim();if(l.startsWith("Error parsing regex"))return l;if(l.startsWith("regex parse error"))return u.uppercaseFirstLetter(n[n.length-1].trim());if(l.startsWith("error parsing glob")||l.startsWith("unsupported encoding"))return l.charAt(0).toUpperCase()+l.substr(1);if(l==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(l.startsWith("Literal "))return l}e.rgErrorMsgForDisplay=s}),define(he[132],fe([0,1,38,289,101,18,69,30,9,8,2,31,65,290,273,91]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const w=a.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class _{constructor(S){this.outputChannel=S}provideTextSearchResults(S,o,k,O){return this.outputChannel.appendLine(`provideTextSearchResults ${S.pattern}, ${JSON.stringify({...o,folder:o.folder.toString()})}`),new Promise(($,G)=>{O.onCancellationRequested(()=>M());const re=s(S,o),j=o.folder.fsPath,N=re.map(_e=>_e.match(/^-/)?_e:`'${_e}'`).join(" ");this.outputChannel.appendLine(`${w} ${N}
 - cwd: ${j}`);let x=p.spawn(w,re,{cwd:j});x.on("error",_e=>{console.error(_e),this.outputChannel.appendLine("Error: "+(_e&&_e.message)),G((0,P.serializeSearchError)(new P.SearchError(_e&&_e.message,P.SearchErrorCode.rgProcessError)))});let R=!1;const V=new h(o.maxResults,j,o.previewOptions);V.on("result",_e=>{R=!0,W="",k.report(_e)});let F=!1;const M=()=>{F=!0,x&&x.kill(),V&&V.cancel()};let B=!1;V.on("hitLimit",()=>{B=!0,M()});let W="";x.stdout.on("data",_e=>{V.handleData(_e),R||(W+=_e)});let Q=!1;x.stdout.once("data",()=>Q=!0);let ae="";x.stderr.on("data",_e=>{const Fe=_e.toString();this.outputChannel.appendLine(Fe),ae+=Fe}),x.on("close",()=>{if(this.outputChannel.appendLine(Q?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(R?"Got result from parser":"No result from parser"),W&&this.outputChannel.appendLine(`Got data without result: ${W}`),this.outputChannel.appendLine(""),F)$({limitHit:B});else{V.flush(),x=null;let _e;ae&&!Q&&(_e=b(ae))?G((0,P.serializeSearchError)(new P.SearchError(_e.message,_e.code))):$({limitHit:B})}})})}}e.RipgrepTextSearchEngine=_;function b(E){const S=E.split(`
`),o=S[0].trim();if(S.some(O=>O.startsWith("regex parse error")))return new P.SearchError(d(S),P.SearchErrorCode.regexParseError);const k=o.match(/grep config error: unknown encoding: (.*)/);if(k)return new P.SearchError(`Unknown encoding: ${k[1]}`,P.SearchErrorCode.unknownEncoding);if(o.startsWith("error parsing glob"))return new P.SearchError(o.charAt(0).toUpperCase()+o.substr(1),P.SearchErrorCode.globParseError);if(o.startsWith("the literal"))return new P.SearchError(o.charAt(0).toUpperCase()+o.substr(1),P.SearchErrorCode.invalidLiteral);if(o.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(o,P.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=b;function d(E){const S=["Regex parse error"],o=E.filter(k=>k.startsWith("PCRE2:"));if(o.length>=1){const k=o[0].replace("PCRE2:","");if(k.indexOf(":")!==-1&&k.split(":").length>=2){const O=k.split(":")[1];S.push(":"+O)}}return S.join("")}e.buildRegexParseError=d;class h extends L.EventEmitter{constructor(S,o,k){super();this.maxResults=S,this.rootFolder=o,this.previewOptions=k,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new C.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(S,o){return super.on(S,o),this}handleData(S){if(this.isDone)return;const o=typeof S=="string"?S:this.stringDecoder.write(S);this.handleDecodedData(o)}handleDecodedData(S){let o=S.indexOf(`
`);const k=this.remainder+S;if(o>=0)o+=this.remainder.length;else{this.remainder=k;return}let O=0;for(;o>=0;)this.handleLine(k.substring(O,o).trim()),O=o+1,o=k.indexOf(`
`,O);this.remainder=k.substring(O)}handleLine(S){if(this.isDone||!S)return;let o;try{o=JSON.parse(S)}catch(k){throw new Error(`malformed line from rg: ${S}`)}if(o.type==="match"){const k=v(o.data.path),O=i.URI.file(D.join(this.rootFolder,k)),$=this.createTextSearchMatch(o.data,O);this.onResult($),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(o.type==="context"){const k=v(o.data.path),O=i.URI.file(D.join(this.rootFolder,k));this.createTextSearchContext(o.data,O).forEach(G=>this.onResult(G))}}createTextSearchMatch(S,o){const k=S.line_number-1,O=v(S.lines),$=Buffer.from(O);let G=0,re=0,j=k;S.submatches.length===0&&S.submatches.push(O.length?{start:0,end:1,match:{text:O[0]}}:{start:0,end:0,match:{text:""}});const N=(0,y.coalesce)(S.submatches.map((x,R)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const V=v(x.match),F=$.slice(G,x.start).toString().length,M=re+F,B=t(V),W=j,Q=B.numLines+W,ae=B.numLines>0?B.lastLineLength:B.lastLineLength+M;return G=x.end,re=ae,j=Q,new c.Range(W,M,Q,ae)}));return(0,g.createTextSearchResult)(o,O,N,this.previewOptions)}createTextSearchContext(S,o){const k=v(S.lines),O=S.line_number;return k.replace(/\r?\n$/,"").split(`
`).map(($,G)=>({text:$,uri:o,lineNumber:O+G}))}onResult(S){this.emit("result",S)}}e.RipgrepParser=h;function v(E){return E.bytes?Buffer.from(E.bytes,"base64").toString():E.text}function t(E){const S=/\n/g;let o=0,k=-1,O;for(;O=S.exec(E);)o++,k=O.index;const $=k>=0?E.length-k-1:E.length;return{numLines:o,lastLineLength:$}}function s(E,S){const o=["--hidden"];o.push(E.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:k,otherIncludes:O}=(0,T.groupBy)(S.includes,G=>G.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const G=new Set;O.forEach(re=>{G.add(re)}),o.push("-g","!*"),G.forEach(re=>{r(re).map(g.anchorGlob).forEach(j=>{o.push("-g",j)})})}k&&k.length&&k.forEach(G=>{o.push("-g",G)}),S.excludes.map(g.anchorGlob).forEach(G=>o.push("-g",`!${G}`)),S.maxFileSize&&o.push("--max-filesize",S.maxFileSize+""),S.useIgnoreFiles?o.push("--no-ignore-parent"):o.push("--no-ignore"),S.followSymlinks&&o.push("--follow"),S.encoding&&S.encoding!=="utf8"&&o.push("--encoding",S.encoding),E.pattern==="--"&&(E.isRegExp=!0,E.pattern="\\-\\-"),E.isMultiline&&!E.isRegExp&&(E.pattern=(0,A.escapeRegExpCharacters)(E.pattern),E.isRegExp=!0),S.usePCRE2&&o.push("--pcre2"),o.push("--crlf"),E.isRegExp&&(E.pattern=n(E.pattern),o.push("--auto-hybrid-regex"));let $;if(E.isWordMatch){const re=(0,A.createRegExp)(E.pattern,!!E.isRegExp,{wholeWord:E.isWordMatch}).source.replace(/\\\//g,"/");o.push("--regexp",re)}else if(E.isRegExp){let G=f(E.pattern);G=m(G),o.push("--regexp",G)}else $=E.pattern,o.push("--fixed-strings");return o.push("--no-config"),S.useGlobalIgnoreFiles||o.push("--no-ignore-global"),o.push("--json"),E.isMultiline&&o.push("--multiline"),S.beforeContext&&o.push("--before-context",S.beforeContext+""),S.afterContext&&o.push("--after-context",S.afterContext+""),o.push("--"),$&&o.push($),o.push("."),o}function r(E){const S=(0,I.splitGlobAware)(E,"/");return S.map((o,k)=>S.slice(0,k+1).join("/"))}e.spreadGlobComponents=r;function n(E){const S=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;E.match(S);)E=E.replace(S,"$1\\x{$2}");const o=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;E.match(o);)E=E.replace(o,"$1\\x{$2}");return E}e.unicodeEscapesToPCRE2=n;const l=E=>E.type==="Assertion"&&E.kind==="lookbehind";function f(E){let S;try{S=new u.RegExpParser().parsePattern(E)}catch{return E}let o="",k=0;const O=(re,j,N)=>{o+=E.slice(k,re)+N,k=j},$=[];return new u.RegExpVisitor({onCharacterEnter(re){if(re.raw!=="\\n")return;const j=$[0];if(!j)O(re.start,re.end,"\\r?\\n");else if(!$.some(l))if(j.type==="CharacterClass")if(j.negate){const N=E.slice(j.start+2,re.start)+E.slice(re.end,j.end-1);O(j.start,j.end,"(?!\\r?\\n"+(N?`|[${N}]`:"")+")")}else{const N=E.slice(j.start+1,re.start)+E.slice(re.end,j.end-1);O(j.start,j.end,N===""?"\\r?\\n":`(?:[${N}]|\\r?\\n)`)}else j.type==="Quantifier"&&O(re.start,re.end,"(?:\\r?\\n)")},onQuantifierEnter(re){$.unshift(re)},onQuantifierLeave(){$.shift()},onCharacterClassRangeEnter(re){$.unshift(re)},onCharacterClassRangeLeave(){$.shift()},onCharacterClassEnter(re){$.unshift(re)},onCharacterClassLeave(){$.shift()},onAssertionEnter(re){l(re)&&$.push(re)},onAssertionLeave(re){$[0]===re&&$.shift()}}).visit(S),o+=E.slice(k),o}e.fixRegexNewline=f;function m(E){return E.replace(/\n/g,"\\r?\\n")}e.fixNewline=m}),define(he[275],fe([0,1,21,132,116,10]),function(X,e,p,L,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class T{constructor(A){this.outputChannel=A,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(A,i,P,c){const u=new L.RipgrepTextSearchEngine(this.outputChannel);if(i.folder.scheme===y.Schemas.userData){const a={...i,folder:i.folder.with({scheme:y.Schemas.file})},g=new C.Progress(w=>P.report({...w,uri:w.uri.with({scheme:i.folder.scheme})}));return this.withToken(c,w=>u.provideTextSearchResults(A,a,g,w))}else return this.withToken(c,a=>u.provideTextSearchResults(A,i,P,a))}async withToken(A,i){const P=I(A);this.inProgress.add(P);const c=await i(P.token);return this.inProgress.delete(P),c}dispose(){this.inProgress.forEach(A=>A.cancel())}}e.RipgrepSearchProvider=T;function I(D){const A=new p.CancellationTokenSource;return D.onCancellationRequested(()=>A.cancel()),A}}),define(he[276],fe([0,1,28,132,131]),function(X,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class y{constructor(D){this.query=D}search(D,A,i){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(u){i({message:u})}},c=new C.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(P),p);return new Promise((u,a)=>c.search(g=>{A(g.map(T))},D).then(g=>u({limitHit:g.limitHit,type:"success"}),a))}}e.TextSearchEngineAdapter=y;function T(I){return{path:I.resource&&I.resource.fsPath,results:I.results,numMatches:(I.results||[]).reduce((D,A)=>{if(A.ranges){const i=A;return D+(Array.isArray(i.ranges)?i.ranges.length:1)}else return D+1},0)}}}),define(he[277],fe([0,1,45,291,18,17,15,3,98,9,44,2,41,31,274,276]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,L.gracefulify(p);class w{constructor(){this.caches=Object.create(null)}fileSearch(t){let s;const r=d(t),n=new I.Emitter({onFirstListenerDidAdd:()=>{s=(0,y.createCancelablePromise)(l=>this.doFileSearchWithEngine(a.Engine,r,f=>n.fire(f),l)),s.then(l=>n.fire(l),l=>n.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onLastListenerRemove:()=>{s.cancel()}});return n.event}textSearch(t){let s;const r=d(t),n=new I.Emitter({onFirstListenerDidAdd:()=>{s=(0,y.createCancelablePromise)(l=>this.ripgrepTextSearch(r,f=>n.fire(f),l)),s.then(l=>n.fire(l),l=>n.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onLastListenerRemove:()=>{s.cancel()}});return n.event}ripgrepTextSearch(t,s,r){return t.maxFileSize=(0,c.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new g.TextSearchEngineAdapter(t).search(r,s,s)}doFileSearch(t,s,r){return this.doFileSearchWithEngine(a.Engine,t,s,r)}doFileSearchWithEngine(t,s,r,n,l=w.BATCH_SIZE){let f=0;const m=S=>{Array.isArray(S)?(f+=S.length,r(S.map(o=>this.rawMatchToSearchItem(o)))):S.relativePath?(f++,r(this.rawMatchToSearchItem(S))):r(S)};if(s.sortByScore){let S=this.trySortedSearchFromCache(s,m,n);if(!S){const o=s.maxResults?Object.assign({},s,{maxResults:null}):s,k=new t(o);S=this.doSortedSearch(k,s,r,m,n)}return new Promise((o,k)=>{S.then(([O,$])=>{const G=$.map(re=>this.rawMatchToSearchItem(re));this.sendProgress(G,r,l),o(O)},k)})}const E=new t(s);return this.doSearch(E,m,l,n).then(S=>({limitHit:S.limitHit,type:"success",stats:{detailStats:S.stats,type:"searchProcess",fromCache:!1,resultCount:f,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,A.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,s,r,n,l){const f=new I.Emitter;let m=(0,y.createCancelablePromise)(S=>{let o=[];const k=O=>{Array.isArray(O)?o=O:(n(O),f.fire(O))};return this.doSearch(t,k,-1,S).then(O=>[O,o])}),E;if(s.cacheKey){E=this.getOrCreateCache(s.cacheKey);const S={promise:m,event:f.event,resolved:!1};E.resultsToSearchCache[s.filePattern||""]=S,m.then(()=>{S.resolved=!0},o=>{delete E.resultsToSearchCache[s.filePattern||""]}),m=this.preventCancellation(m)}return m.then(([S,o])=>{const k=E?E.scorerCache:Object.create(null),O=(typeof s.maxResults!="number"||s.maxResults>0)&&i.StopWatch.create(!1);return this.sortResults(s,o,k,l).then($=>{const G=O?O.elapsed():-1;return[{type:"success",stats:{detailStats:S.stats,sortingTime:G,fromCache:!1,type:"searchProcess",workspaceFolderCount:s.folderQueries.length,resultCount:$.length},messages:S.messages,limitHit:S.limitHit||typeof s.maxResults=="number"&&o.length>s.maxResults},$]})})}getOrCreateCache(t){const s=this.caches[t];return s||(this.caches[t]=new _)}trySortedSearchFromCache(t,s,r){const n=t.cacheKey&&this.caches[t.cacheKey];if(!n)return;const l=this.getResultsFromCache(n,t.filePattern||"",s,r);if(l)return l.then(([f,m,E])=>{const S=i.StopWatch.create(!1);return this.sortResults(t,m,n.scorerCache,r).then(o=>{const k=S.elapsed(),O={fromCache:!0,detailStats:E,type:"searchProcess",resultCount:m.length,sortingTime:k};return[{type:"success",limitHit:f.limitHit||typeof t.maxResults=="number"&&m.length>t.maxResults,stats:O},o]})})}sortResults(t,s,r,n){const l=(0,D.prepareQuery)(t.filePattern||""),f=(E,S)=>(0,D.compareItemsByFuzzyScore)(E,S,l,!0,b,r),m=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return C.topAsync(s,f,m,1e4,n)}sendProgress(t,s,r){if(r&&r>0)for(let n=0;n<t.length;n+=r)s(t.slice(n,n+r));else s(t)}getResultsFromCache(t,s,r,n){const l=i.StopWatch.create(!1),f=s.indexOf(A.sep)>=0;let m;for(const k in t.resultsToSearchCache)if(s.startsWith(k)){if(f&&k.indexOf(A.sep)<0&&k!=="")continue;const O=t.resultsToSearchCache[k];m={promise:this.preventCancellation(O.promise),event:O.event,resolved:O.resolved};break}if(!m)return null;const E=l.elapsed(),S=i.StopWatch.create(!1),o=m.event(r);return n&&n.onCancellationRequested(()=>{o.dispose()}),m.promise.then(([k,O])=>{if(n&&n.isCancellationRequested)throw(0,T.canceled)();const $=[],G=(0,D.prepareQuery)(s).normalizedLowercase;for(const re of O)!(0,u.isFilePatternMatch)(re,G)||$.push(re);return[k,$,{cacheWasResolved:m.resolved,cacheLookupTime:E,cacheFilterTime:S.elapsed(),cacheEntryCount:O.length}]})}doSearch(t,s,r,n){return new Promise((l,f)=>{let m=[];n&&n.onCancellationRequested(()=>t.cancel()),t.search(E=>{E&&(r?(m.push(E),r>0&&m.length>=r&&(s(m),m=[])):s(E))},E=>{s(E)},(E,S)=>{m.length&&s(m),E?f(E):l(S)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(s,r){return t.then(s,r)}catch(s){return this.then(void 0,s)}finally(s){return t.finally(s)}}}}e.SearchService=w,w.BATCH_SIZE=512;class _{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const b=new class{getItemLabel(v){return(0,A.basename)(v.relativePath)}getItemDescription(v){return(0,A.dirname)(v.relativePath)}getItemPath(v){return v.relativePath}};function d(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(h),extraFileResources:v.extraFileResources&&v.extraFileResources.map(t=>P.URI.revive(t))}}function h(v){return{...v,folder:P.URI.revive(v.folder)}}}),define(he[278],fe([0,1,6,2,28,12,31,277,275,91,13,60,27,68,10,131]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let w=class extends u.ExtHostSearch{constructor(b,d,h,v){super(b,h,v);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new A.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(a.Schemas.userData,new D.RipgrepSearchProvider(t)),d.remote.isRemote&&d.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const b=new A.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(a.Schemas.file,new D.RipgrepSearchProvider(b)),this.registerInternalFileSearchProvider(a.Schemas.file,new I.SearchService)}registerInternalFileSearchProvider(b,d){const h=this._handlePool++;return this._internalFileSearchProvider=d,this._internalFileSearchHandle=h,this._proxy.$registerFileSearchProvider(h,this._transformScheme(b)),(0,p.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(h)})}$provideFileSearchResults(b,d,h,v){const t=(0,u.reviveQuery)(h);return b===this._internalFileSearchHandle?this.doInternalFileSearch(b,d,t,v):super.$provideFileSearchResults(b,d,h,v)}doInternalFileSearch(b,d,h,v){const t=s=>{if((0,T.isSerializedFileMatch)(s)&&(s=[s]),Array.isArray(s)){this._proxy.$handleFileMatch(b,d,s.map(r=>L.URI.file(r.path)));return}s.message&&this._logService.debug("ExtHostSearch",s.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(h,t,v)}$clearCache(b){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(b),super.$clearCache(b)}createTextSearchManager(b,d){return new g.NativeTextSearchManager(b,d)}};w=je([We(0,i.IExtHostRpcService),We(1,c.IExtHostInitDataService),We(2,P.IURITransformerService),We(3,y.ILogService)],w),e.NativeExtHostSearch=w}),define(he[133],fe([0,1,292,122,293,3,104,9,102,32,6,22,105,15,11]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(m){this.socket=m,this._errorListener=E=>{if(E){if(E.code==="EPIPE")return;(0,u.onUnexpectedError)(E)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(m){const E=S=>m(P.VSBuffer.wrap(S));return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(m){const E=S=>{m({type:0,hadError:S,error:void 0})};return this.socket.on("close",E),{dispose:()=>this.socket.off("close",E)}}onEnd(m){return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(m){if(!this.socket.destroyed)try{this.socket.write(m.buffer,E=>{if(E){if(E.code==="EPIPE")return;(0,u.onUnexpectedError)(E)}})}catch(E){if(E.code==="EPIPE")return;(0,u.onUnexpectedError)(E)}}end(){this.socket.end()}drain(){return new Promise((m,E)=>{if(this.socket.bufferSize===0){m();return}const S=()=>{this.socket.off("close",S),this.socket.off("end",S),this.socket.off("error",S),this.socket.off("timeout",S),this.socket.off("drain",S),m()};this.socket.on("close",S),this.socket.on("end",S),this.socket.on("error",S),this.socket.on("timeout",S),this.socket.on("drain",S)})}}e.NodeSocket=g;var w;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(w||(w={}));var _;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(_||(_={}));class b extends i.Disposable{constructor(m,E,S,o){super();this._onDidZlibFlush=this._register(new y.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new y.Emitter),this._onClose=this._register(new y.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=m,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=E,this._recordInflateBytes=o,E?(this._zlibInflate=C.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",k=>{console.error(k),(0,u.onUnexpectedError)(k),this._onClose.fire({type:0,hadError:!0,error:k})}),this._zlibInflate.on("data",k=>{this._pendingInflateData.push(k)}),S&&(this._zlibInflate.write(S.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=C.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",k=>{console.error(k),(0,u.onUnexpectedError)(k),this._onClose.fire({type:0,hadError:!0,error:k})}),this._zlibDeflate.on("data",k=>{this._pendingDeflateData.push(k)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new c.ChunkStream,this._register(this.socket.onData(k=>this._acceptChunk(k))),this._register(this.socket.onClose(k=>this._onClose.fire(k)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?P.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):P.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(m){return this._onData.event(m)}onClose(m){return this._onClose.event(m)}onEnd(m){return this.socket.onEnd(m)}write(m){this._totalOutgoingDataBytes+=m.byteLength,this._zlibDeflate?(this._zlibDeflate.write(m.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let E=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,E=E.slice(0,E.length-4),this._isEnded||this._write(P.VSBuffer.wrap(E),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(m,!1)}_write(m,E){let S=2;m.byteLength<126?S+=0:m.byteLength<2**16?S+=2:S+=8;const o=P.VSBuffer.alloc(S);if(E?o.writeUInt8(194,0):o.writeUInt8(130,0),m.byteLength<126)o.writeUInt8(m.byteLength,1);else if(m.byteLength<2**16){o.writeUInt8(126,1);let k=1;o.writeUInt8(m.byteLength>>>8&255,++k),o.writeUInt8(m.byteLength>>>0&255,++k)}else{o.writeUInt8(127,1);let k=1;o.writeUInt8(0,++k),o.writeUInt8(0,++k),o.writeUInt8(0,++k),o.writeUInt8(0,++k),o.writeUInt8(m.byteLength>>>24&255,++k),o.writeUInt8(m.byteLength>>>16&255,++k),o.writeUInt8(m.byteLength>>>8&255,++k),o.writeUInt8(m.byteLength>>>0&255,++k)}this._totalOutgoingWireBytes+=o.byteLength+m.byteLength,this.socket.write(P.VSBuffer.concat([o,m]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(m){if(m.byteLength!==0){for(this._totalIncomingWireBytes+=m.byteLength,this._incomingData.acceptChunk(m);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const E=this._incomingData.peek(this._state.readLen),o=(E.readUInt8(0)&128)>>>7,k=E.readUInt8(1),O=(k&128)>>>7,$=k&127;this._state.state=2,this._state.readLen=2+(O?4:0)+($===126?2:0)+($===127?8:0),this._state.fin=o,this._state.mask=0}else if(this._state.state===2){const E=this._incomingData.read(this._state.readLen),S=E.readUInt8(1),o=(S&128)>>>7;let k=S&127,O=1;k===126?k=E.readUInt8(++O)*2**8+E.readUInt8(++O):k===127&&(k=E.readUInt8(++O)*0+E.readUInt8(++O)*0+E.readUInt8(++O)*0+E.readUInt8(++O)*0+E.readUInt8(++O)*2**24+E.readUInt8(++O)*2**16+E.readUInt8(++O)*2**8+E.readUInt8(++O));let $=0;o&&($=E.readUInt8(++O)*2**24+E.readUInt8(++O)*2**16+E.readUInt8(++O)*2**8+E.readUInt8(++O)),this._state.state=3,this._state.readLen=k,this._state.mask=$}else if(this._state.state===3){const E=this._incomingData.read(this._state.readLen);d(E,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(E.buffer)),this._zlibInflate.write(E.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const S=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=S.length,this._onData.fire(P.VSBuffer.wrap(S))})):(this._totalIncomingDataBytes+=E.byteLength,this._onData.fire(E))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await y.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=b;function d(f,m){if(m===0)return;let E=f.byteLength>>>2;for(let G=0;G<E;G++){const re=f.readUInt32BE(G*4);f.writeUInt32BE(re^m,G*4)}let S=E*4,o=f.byteLength-S;const k=m>>>24&255,O=m>>>16&255,$=m>>>8&255;o>=1&&f.writeUInt8(f.readUInt8(S)^k,S),o>=2&&f.writeUInt8(f.readUInt8(S+1)^O,S+1),o>=3&&f.writeUInt8(f.readUInt8(S+2)^$,S+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const h={[2]:107,[1]:103};function v(){const f=(0,A.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let m;return e.XDG_RUNTIME_DIR?m=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):m=(0,I.join)((0,D.tmpdir)(),`vscode-ipc-${f}.sock`),s(m),m}e.createRandomIPCHandle=v;function t(f,m,E){const S=(0,p.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${S}-${E}-${m}-sock`;let o;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?o=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-${S.substr(0,8)}-${E}-${m}.sock`):o=(0,I.join)(f,`${E}-${m}.sock`),s(o),o}e.createStaticIPCHandle=t;function s(f){const m=h[a.platform];typeof m=="number"&&f.length>=m&&console.warn(`WARNING: IPC handle "${f}" is longer than ${m} chars, try a shorter --user-data-dir`)}class r extends T.IPCServer{constructor(m){super(r.toClientConnectionEvent(m));this.server=m}static toClientConnectionEvent(m){const E=y.Event.fromNodeEventEmitter(m,"connection");return y.Event.map(E,S=>({protocol:new c.Protocol(new g(S)),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(S,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function n(f){return new Promise((m,E)=>{const S=(0,L.createServer)();S.on("error",E),S.listen(f,()=>{S.removeListener("error",E),m(new r(S))})})}e.serve=n;function l(f,m){return new Promise((E,S)=>{const o=(0,L.createConnection)(f,()=>{o.removeListener("error",S),E(c.Client.fromSocket(new g(o),m))});o.once("error",S)})}e.connect=l}),define(he[279],fe([0,1,133,271,45,50,2,194,12]),function(X,e,p,L,C,y,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class A{constructor(c,u,a){this._commands=c,this.logService=u,this._ipcHandlePath=a,this._server=L.createServer((g,w)=>this.onRequest(g,w)),this.setup().catch(g=>(u.error(g),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",c=>this.logService.error(c))}catch(c){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(c,u){const a=[];c.setEncoding("utf8"),c.on("data",g=>a.push(g)),c.on("end",()=>{const g=JSON.parse(a.join(""));switch(g.type){case"open":this.open(g,u);break;case"openExternal":this.openExternal(g,u);break;case"status":this.getStatus(g,u);break;case"extensionManagement":this.manageExtensions(g,u).catch(this.logService.error);break;default:u.writeHead(404),u.write(`Unknown message type: ${g.type}`,w=>{w&&this.logService.error(w)}),u.end();break}})}open(c,u){let{fileURIs:a,folderURIs:g,forceNewWindow:w,diffMode:_,addMode:b,forceReuseWindow:d,gotoLineMode:h,waitMarkerFilePath:v}=c;const t=[];if(Array.isArray(g))for(const s of g)try{t.push({folderUri:T.URI.parse(s)})}catch(r){}if(Array.isArray(a))for(const s of a)try{(0,I.hasWorkspaceFileExtension)(s)?t.push({workspaceUri:T.URI.parse(s)}):t.push({fileUri:T.URI.parse(s)})}catch(r){}if(t.length){const s=v?T.URI.file(v):void 0,n={forceNewWindow:w,diffMode:_,addMode:b,gotoLineMode:h,forceReuseWindow:d,preferNewWindow:!d&&!s&&!b,waitMarkerFileURI:s};this._commands.executeCommand("_remoteCLI.windowOpen",t,n)}u.writeHead(200),u.end()}async openExternal(c,u){for(const a of c.uris){const g=T.URI.parse(a),w=g.scheme==="file"?g:a;await this._commands.executeCommand("_remoteCLI.openExternal",w)}u.writeHead(200),u.end()}async manageExtensions(c,u){try{const a=_=>_?.map(b=>/\.vsix$/i.test(b)?T.URI.parse(b):b),g={list:c.list,install:a(c.install),uninstall:a(c.uninstall),force:c.force},w=await this._commands.executeCommand("_remoteCLI.manageExtensions",g);u.writeHead(200),u.write(w)}catch(a){u.writeHead(500),u.write(String(a),g=>{g&&this.logService.error(g)})}u.end()}async getStatus(c,u){try{const a=await this._commands.executeCommand("_remoteCLI.getSystemStatus");u.writeHead(200),u.write(a),u.end()}catch(a){u.writeHead(500),u.write(String(a),g=>{g&&this.logService.error(g)}),u.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&C.existsSync(this._ipcHandlePath)&&C.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=A;let i=class extends A{constructor(c,u){super(c,u,(0,p.createRandomIPCHandle)())}};i=je([We(0,y.IExtHostCommands),We(1,D.ILogService)],i),e.CLIServer=i}),define(he[280],fe([0,1,67,267,262,5,270,39,252,2,10,7,279,103]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class a extends C.RequireInterceptor{_installInterceptor(){const _=this,b=X.__$__nodeRequire("module"),d=b._load;b._load=function(v,t,s){for(let r of _._alternatives){let n=r(v);if(n){v=n;break}}return _._factories.has(v)?_._factories.get(v).load(v,A.URI.file((0,u.realpathSync)(t.filename)),r=>d.apply(this,[r,t,s])):d.apply(this,arguments)}}}class g extends I.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=P.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const _=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(c.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(a,_,this._registry).install(),p.mark("code/extHost/didInitAPI");const d=await this._extHostConfiguration.getConfigProvider();await(0,T.connectProxyResolver)(this._extHostWorkspace,d,this,this._logService,this._mainThreadTelemetryProxy,this._initData),p.mark("code/extHost/didInitProxyResolver");const h=process.send,v=this._extHostContext.getProxy(y.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?h.apply(process,t):(v.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(_){return _.main}_loadCommonJSModule(_,b,d){if(b.scheme!==i.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let h=null;d.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this._logService.flush();try{_&&p.mark(`code/extHost/willLoadExtensionCode/${_.value}`),h=X.__$__nodeRequire(b.fsPath)}catch(v){return Promise.reject(v)}finally{_&&p.mark(`code/extHost/didLoadExtensionCode/${_.value}`),d.codeLoadingStop()}return Promise.resolve(h)}async $setRemoteEnvironment(_){if(!!this._initData.remote.isRemote)for(const b in _){const d=_[b];d===null?delete process.env[b]:process.env[b]=d}}}e.ExtHostExtensionService=g}),define(he[281],fe([0,1,78,253,255,264,263,278,280,221,256,51,39,62,68,66,33,49,12,63,254]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u,a,g,w,_,b,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,p.registerSingleton)(c.IExtHostExtensionService,D.ExtHostExtensionService),(0,p.registerSingleton)(b.ILogService,A.ExtHostLogService),(0,p.registerSingleton)(d.IExtensionStoragePaths,h.ExtensionStoragePaths),(0,p.registerSingleton)(P.IExtHostDebugService,T.ExtHostDebugService),(0,p.registerSingleton)(u.IExtHostOutputService,L.ExtHostOutputService2),(0,p.registerSingleton)(a.IExtHostSearch,I.NativeExtHostSearch),(0,p.registerSingleton)(g.IExtHostTask,y.ExtHostTask),(0,p.registerSingleton)(w.IExtHostTerminalService,C.ExtHostTerminalService),(0,p.registerSingleton)(_.IExtHostTunnelService,i.ExtHostTunnelService)}),define(he[282],fe([0,1,122,294,67,15,105,133,186,219,265,22,100,28,103,17,112,268,281]),function(X,e,p,L,C,y,T,I,D,A,i,P,c,u,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let l=0;l<process.execArgv.length;l++)process.execArgv[l]==="--inspect-port=0"&&(process.execArgv.splice(l,1),l--)}();const _=L(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const n=X.__$__nodeRequire("module"),l=n._load;n._load=function(f){if(f==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return l.apply(this,arguments)}})();const b=process.exit.bind(process);function d(n){process.exit=function(l){if(n)b(l);else{const f=new Error("An extension called process.exit() and this was prevented.");console.warn(f.stack)}},process.crash=function(){const l=new Error("An extension called process.crash() and this was prevented.");console.warn(l.stack)}}let h=function(n){b()};function v(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((n,l)=>{let f=null,m=setTimeout(()=>{h("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const E=108e5,S=3e5,o=new g.RunOnceScheduler(()=>h("renderer disconnected for too long (1)"),E),k=new g.RunOnceScheduler(()=>h("renderer disconnected for too long (2)"),S);process.on("message",($,G)=>{if($&&$.type==="VSCODE_EXTHOST_IPC_SOCKET"){const re=P.VSBuffer.wrap(Buffer.from($.initialDataChunk,"base64"));let j;if($.skipWebSocketFrames)j=new I.NodeSocket(G);else{const N=P.VSBuffer.wrap(Buffer.from($.inflateBytes,"base64"));j=new I.WebSocketNodeSocket(new I.NodeSocket(G),$.permessageDeflate,N,!1)}f?(o.cancel(),k.cancel(),f.beginAcceptReconnection(j,re),f.endAcceptReconnection()):(clearTimeout(m),f=new T.PersistentProtocol(j,re),f.onDidDispose(()=>h("renderer disconnected")),n(f),f.onSocketClose(()=>{o.schedule()}))}if($&&$.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(k.isScheduled())return;o.isScheduled()&&k.schedule()}});const O={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(O)});{const n=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((l,f)=>{const m=p.createConnection(n,()=>{m.removeListener("error",f),l(new T.PersistentProtocol(new I.NodeSocket(m)))});m.once("error",f),m.on("close",()=>{h("renderer closed the socket")})})}}async function t(){const n=await v();return new class{constructor(){this._onMessage=new T.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,n.onMessage(l=>{(0,A.isMessageOfType)(l,2)?(this._terminating=!0,h("received terminate message from renderer")):this._onMessage.fire(l)})}send(l){this._terminating||n.send(l)}drain(){return n.drain()}}}function s(n){return new Promise(l=>{const f=n.onMessage(m=>{f.dispose();const E=JSON.parse(m.toString()),S=E.commit,o=D.default.commit;S&&o&&S!==o&&b(55);const k=[];process.on("unhandledRejection",(G,re)=>{k.push(re),setTimeout(()=>{const j=k.indexOf(re);j>=0&&re.catch(N=>{k.splice(j,1),(0,y.isPromiseCanceledError)(N)||(console.warn(`rejected promise not handled within 1 second: ${N}`),N&&N.stack&&console.warn(`stack trace: ${N.stack}`),(0,y.onUnexpectedError)(G))})},1e3)}),process.on("rejectionHandled",G=>{const re=k.indexOf(G);re>=0&&k.splice(re,1)}),process.on("uncaughtException",function(G){(0,y.onUnexpectedError)(G)});let O=0;setInterval(function(){try{process.kill(E.parentPid,0),O=0}catch(G){G&&G.code==="EPERM"?(O++,O>=3&&h(`parent process ${E.parentPid} does not exist anymore (3 x EPERM): ${G.message} (code: ${G.code}) (errno: ${G.errno})`)):h(`parent process ${E.parentPid} does not exist anymore: ${G.message} (code: ${G.code}) (errno: ${G.errno})`)}},1e3);let $;try{$=X.__$__nodeRequire("native-watchdog"),$.start(E.parentPid)}catch(G){(0,y.onUnexpectedError)(G)}n.send((0,A.createMessageOfType)(0)),l({protocol:n,initData:E})});n.send((0,A.createMessageOfType)(1))})}async function r(){C.mark("code/extHost/willConnectToRenderer");const n=await t();C.mark("code/extHost/didConnectToRenderer");const l=await s(n);C.mark("code/extHost/didWaitForInitData");const{initData:f}=l;d(!!f.environment.extensionTestsLocationURI),f.environment.useHostProxy=_.useHostProxy!==void 0?_.useHostProxy!=="false":void 0,f.environment.skipWorkspaceStorageLock=(0,w.boolean)(_.skipWorkspaceStorageLock,!1);const m=new class{exit(k){b(k)}exists(k){return u.Promises.exists(k)}realpath(k){return(0,a.realpath)(k)}};let E=null;if(f.remote.authority&&_.uriTransformerPath)try{const k=X.__$__nodeRequire(_.uriTransformerPath)(f.remote.authority);E=new c.URITransformer(k)}catch(o){console.error(o)}const S=new i.ExtensionHostMain(l.protocol,f,m,E);h=o=>S.terminate(o)}e.startExtensionHostProcess=r}),define(he[295],fe([0,1,282]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,p.startExtensionHostProcess)().catch(L=>console.log(L))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/50b3811fdc5b5c80ca516a2edfffedcbd464b033/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
