/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var _e=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/network","vs/base/common/errors","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/platform/log/common/log","vs/base/common/async","vs/base/common/arrays","vs/base/common/cancellation","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/platform","vs/base/common/map","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/glob","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/editor/common/core/position","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/process","vs/base/common/hash","vs/base/common/severity","vs/base/common/extpath","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],ye=function(ee){for(var e=[],m=0,F=ee.length;m<F;m++)e[m]=_e[ee[m]];return e};define(_e[39],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(F,D){if(!F)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=m}),define(_e[77],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const m=Object.prototype.hasOwnProperty;function F(n){const k=[];for(let l in n)m.call(n,l)&&k.push(n[l]);return k}e.values=F;function D(n,k){for(let l in n)if(m.call(n,l)&&k({key:l,value:n[l]},function(){delete n[l]})===!1)return}e.forEach=D;function y(n,k){const l=Object.create(null);for(const h of n){const a=k(h);let d=l[a];d||(d=l[a]=[]),d.push(h)}return l}e.groupBy=y;function I(n){const k=Object.create(null);return n&&n.forEach((l,h)=>{k[h]=l}),k}e.fromMap=I;function S(n,k){const l=[],h=[];for(let a of n)k.has(a)||l.push(a);for(let a of k)n.has(a)||h.push(a);return{removed:l,added:h}}e.diffSets=S;function _(n,k){const l=[],h=[];for(let[a,d]of n)k.has(a)||l.push(d);for(let[a,d]of k)n.has(a)||h.push(d);return{removed:l,added:h}}e.diffMaps=_;class C{constructor(){this.map=new Map}add(k,l){let h=this.map.get(k);h||(h=new Set,this.map.set(k,h)),h.add(l)}delete(k,l){const h=this.map.get(k);!h||(h.delete(l),h.size===0&&this.map.delete(k))}forEach(k,l){const h=this.map.get(k);!h||h.forEach(l)}}e.SetMap=C}),define(_e[48],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(I){return(S,_,C)=>{let n=null,k=null;if(typeof C.value=="function"?(n="value",k=C.value):typeof C.get=="function"&&(n="get",k=C.get),!k)throw new Error("not supported");C[n]=I(k,_)}}e.createDecorator=m;function F(I,S,_){let C=null,n=null;if(typeof _.value=="function"?(C="value",n=_.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(C="get",n=_.get),!n)throw new Error("not supported");const k=`$memoize$${S}`;_[C]=function(...l){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,l)}),this[k]}}e.memoize=F;function D(I,S,_){return m((C,n)=>{const k=`$debounce$${n}`,l=`$debounce$result$${n}`;return function(...h){this[l]||(this[l]=_?_():void 0),clearTimeout(this[k]),S&&(this[l]=S(this[l],...h),h=[this[l]]),this[k]=setTimeout(()=>{C.apply(this,h),this[l]=_?_():void 0},I)}})}e.debounce=D;function y(I,S,_){return m((C,n)=>{const k=`$throttle$timer$${n}`,l=`$throttle$result$${n}`,h=`$throttle$lastRun$${n}`,a=`$throttle$pending$${n}`;return function(...d){if(this[l]||(this[l]=_?_():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),S&&(this[l]=S(this[l],...d)),this[a])return;const f=this[h]+I;f<=Date.now()?(this[h]=Date.now(),C.apply(this,[this[l]]),this[l]=_?_():void 0):(this[a]=!0,this[k]=setTimeout(()=>{this[a]=!1,this[h]=Date.now(),C.apply(this,[this[l]]),this[l]=_?_():void 0},f-Date.now()))}})}e.throttle=y}),define(_e[12],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(s=>{s(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=m,e.errorHandler=new m;function F(b){e.errorHandler.setUnexpectedErrorHandler(b)}e.setUnexpectedErrorHandler=F;function D(b){_(b)||e.errorHandler.onUnexpectedError(b)}e.onUnexpectedError=D;function y(b){_(b)||e.errorHandler.onUnexpectedExternalError(b)}e.onUnexpectedExternalError=y;function I(b){if(b instanceof Error){let{name:t,message:s}=b;const i=b.stacktrace||b.stack;return{$isError:!0,name:t,message:s,stack:i}}return b}e.transformErrorForSerialization=I;const S="Canceled";function _(b){return b instanceof Error&&b.name===S&&b.message===S}e.isPromiseCanceledError=_;class C extends Error{constructor(){super(S);this.name=this.message}}e.CancellationError=C;function n(){const b=new Error(S);return b.name=b.message,b}e.canceled=n;function k(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}e.illegalArgument=k;function l(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}e.illegalState=l;function h(b){return b?new Error(`readonly property '${b} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function a(b){const t=new Error(`${b} has been disposed`);return t.name="DISPOSED",t}e.disposed=a;function d(b){return b?b.message?b.message:b.stack?b.stack.split(`
`)[0]:String(b):"Error"}e.getErrorMessage=d;class f extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=f;class E extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=E;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function u(b){const t=b;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=u;function g(b,t=Object.create(null)){const s=new Error(b);return t.actions&&(s.actions=t.actions),s}e.createErrorWithActions=g}),define(_e[17],ye([0,1,12]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function F(L,B=0){return L[L.length-(1+B)]}e.tail=F;function D(L){if(L.length===0)throw new Error("Invalid tail call");return[L.slice(0,L.length-1),L[L.length-1]]}e.tail2=D;function y(L,B,Y=(j,se)=>j===se){if(L===B)return!0;if(!L||!B||L.length!==B.length)return!1;for(let j=0,se=L.length;j<se;j++)if(!Y(L[j],B[j]))return!1;return!0}e.equals=y;function I(L,B,Y){let j=0,se=L.length-1;for(;j<=se;){const Se=(j+se)/2|0,Re=Y(L[Se],B);if(Re<0)j=Se+1;else if(Re>0)se=Se-1;else return Se}return-(j+1)}e.binarySearch=I;function S(L,B){let Y=0,j=L.length;if(j===0)return 0;for(;Y<j;){const se=Math.floor((Y+j)/2);B(L[se])?j=se:Y=se+1}return Y}e.findFirstInSorted=S;function _(L,B,Y){if(L=L|0,L>=B.length)throw new TypeError("invalid index");let j=B[Math.floor(B.length*Math.random())],se=[],Se=[],Re=[];for(let $e of B){const Ne=Y($e,j);Ne<0?se.push($e):Ne>0?Se.push($e):Re.push($e)}return L<se.length?_(L,se,Y):L<se.length+Re.length?Re[0]:_(L-(se.length+Re.length),Se,Y)}e.quickSelect=_;function C(L,B){const Y=[];let j;for(const se of L.slice(0).sort(B))!j||B(j[0],se)!==0?(j=[se],Y.push(j)):j.push(se);return Y}e.groupBy=C;function n(L,B,Y){const j=[];function se($e,Ne,Ge){if(Ne===0&&Ge.length===0)return;const Ke=j[j.length-1];Ke&&Ke.start+Ke.deleteCount===$e?(Ke.deleteCount+=Ne,Ke.toInsert.push(...Ge)):j.push({start:$e,deleteCount:Ne,toInsert:Ge})}let Se=0,Re=0;for(;;){if(Se===L.length){se(Se,0,B.slice(Re));break}if(Re===B.length){se(Se,L.length-Se,[]);break}const $e=L[Se],Ne=B[Re],Ge=Y($e,Ne);Ge===0?(Se+=1,Re+=1):Ge<0?(se(Se,1,[]),Se+=1):Ge>0&&(se(Se,0,[Ne]),Re+=1)}return j}e.sortedDiff=n;function k(L,B,Y){const j=n(L,B,Y),se=[],Se=[];for(const Re of j)se.push(...L.slice(Re.start,Re.start+Re.deleteCount)),Se.push(...Re.toInsert);return{removed:se,added:Se}}e.delta=k;function l(L,B,Y){if(Y===0)return[];const j=L.slice(0,Y).sort(B);return a(L,B,j,Y,L.length),j}e.top=l;function h(L,B,Y,j,se){return Y===0?Promise.resolve([]):new Promise((Se,Re)=>{(async()=>{const $e=L.length,Ne=L.slice(0,Y).sort(B);for(let Ge=Y,Ke=Math.min(Y+j,$e);Ge<$e;Ge=Ke,Ke=Math.min(Ke+j,$e)){if(Ge>Y&&await new Promise(qe=>setTimeout(qe)),se&&se.isCancellationRequested)throw(0,m.canceled)();a(L,B,Ne,Ge,Ke)}return Ne})().then(Se,Re)})}e.topAsync=h;function a(L,B,Y,j,se){for(const Se=Y.length;j<se;j++){const Re=L[j];if(B(Re,Y[Se-1])<0){Y.pop();const $e=S(Y,Ne=>B(Re,Ne)<0);Y.splice($e,0,Re)}}}function d(L){return L.filter(B=>!!B)}e.coalesce=d;function f(L){let B=0;for(let Y=0;Y<L.length;Y++)L[Y]&&(L[B]=L[Y],B+=1);L.length=B}e.coalesceInPlace=f;function E(L,B,Y){L.splice(Y,0,L.splice(B,1)[0])}e.move=E;function w(L){return!Array.isArray(L)||L.length===0}e.isFalsyOrEmpty=w;function u(L){return Array.isArray(L)&&L.length>0}e.isNonEmptyArray=u;function g(L,B){if(!B)return L.filter((j,se)=>L.indexOf(j)===se);const Y=Object.create(null);return L.filter(j=>{const se=B(j);return Y[se]?!1:(Y[se]=!0,!0)})}e.distinct=g;function b(L){const B=new Set;return L.filter(Y=>B.has(Y)?!1:(B.add(Y),!0))}e.distinctES6=b;function t(L){const B=Object.create(null);return Y=>{const j=L(Y);return B[j]?!1:(B[j]=!0,!0)}}e.uniqueFilter=t;function s(L,B){for(let Y=L.length-1;Y>=0;Y--){const j=L[Y];if(B(j))return Y}return-1}e.lastIndex=s;function i(L,B){return L.length>0?L[0]:B}e.firstOrDefault=i;function r(L,B,Y=(j,se)=>j===se){let j=0;for(let se=0,Se=Math.min(L.length,B.length);se<Se&&Y(L[se],B[se]);se++)j++;return j}e.commonPrefixLength=r;function c(L){return[].concat(...L)}e.flatten=c;function p(L,B){let Y=typeof B=="number"?L:0;typeof B=="number"?Y=L:(Y=0,B=L);const j=[];if(Y<=B)for(let se=Y;se<B;se++)j.push(se);else for(let se=Y;se>B;se--)j.push(se);return j}e.range=p;function v(L,B,Y){return L.reduce((j,se)=>(j[B(se)]=Y?Y(se):se,j),Object.create(null))}e.index=v;function A(L,B){return L.push(B),()=>R(L,B)}e.insert=A;function R(L,B){const Y=L.indexOf(B);if(Y>-1)return L.splice(Y,1),B}e.remove=R;function o(L,B,Y){const j=L.slice(0,B),se=L.slice(B);return j.concat(Y,se)}e.arrayInsert=o;function P(L,B){let Y;if(typeof B=="number"){let j=B;Y=()=>{const se=Math.sin(j++)*179426549;return se-Math.floor(se)}}else Y=Math.random;for(let j=L.length-1;j>0;j-=1){const se=Math.floor(Y()*(j+1)),Se=L[j];L[j]=L[se],L[se]=Se}}e.shuffle=P;function N(L,B){const Y=L.indexOf(B);Y>-1&&(L.splice(Y,1),L.unshift(B))}e.pushToStart=N;function $(L,B){const Y=L.indexOf(B);Y>-1&&(L.splice(Y,1),L.push(B))}e.pushToEnd=$;function ie(L,B){return Array.isArray(L)?L.map(B):B(L)}e.mapArrayOrNot=ie;function ce(L){return Array.isArray(L)?L:[L]}e.asArray=ce;function K(L){return L[Math.floor(Math.random()*L.length)]}e.getRandomElement=K;function H(L,B){for(const Y of L){const j=B(Y);if(j!==void 0)return j}}e.mapFind=H;function z(L,B){let Y=Number.MAX_SAFE_INTEGER,j=0;return L.forEach((se,Se)=>{const Re=B(se);Re<Y&&(Y=Re,j=Se)}),j}e.minIndex=z;function T(L,B){let Y=Number.MIN_SAFE_INTEGER,j=0;return L.forEach((se,Se)=>{const Re=B(se);Re>Y&&(Y=Re,j=Se)}),j}e.maxIndex=T;class q{constructor(B){this.items=B,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(B){let Y=this.firstIdx;for(;Y<this.items.length&&B(this.items[Y]);)Y++;const j=Y===this.firstIdx?null:this.items.slice(this.firstIdx,Y);return this.firstIdx=Y,j}takeFromEndWhile(B){let Y=this.lastIdx;for(;Y>=0&&B(this.items[Y]);)Y--;const j=Y===this.lastIdx?null:this.items.slice(Y+1,this.lastIdx+1);return this.lastIdx=Y,j}}e.ArrayQueue=q}),define(_e[49],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(F){const D=this;let y=!1,I;return function(){return y||(y=!0,I=F.apply(D,arguments)),I}}e.once=m}),define(_e[50],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class m{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=m,e.defaultGenerator=new m("id#")}),define(_e[51],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(F){function D(b){return b&&typeof b=="object"&&typeof b[Symbol.iterator]=="function"}F.is=D;const y=Object.freeze([]);function I(){return y}F.empty=I;function*S(b){yield b}F.single=S;function _(b){return b||y}F.from=_;function C(b){return!b||b[Symbol.iterator]().next().done===!0}F.isEmpty=C;function n(b){return b[Symbol.iterator]().next().value}F.first=n;function k(b,t){for(const s of b)if(t(s))return!0;return!1}F.some=k;function l(b,t){for(const s of b)if(t(s))return s}F.find=l;function*h(b,t){for(const s of b)t(s)&&(yield s)}F.filter=h;function*a(b,t){let s=0;for(const i of b)yield t(i,s++)}F.map=a;function*d(...b){for(const t of b)for(const s of t)yield s}F.concat=d;function*f(b){for(const t of b)for(const s of t)yield s}F.concatNested=f;function E(b,t,s){let i=s;for(const r of b)i=t(i,r);return i}F.reduce=E;function*w(b,t,s=b.length){for(t<0&&(t+=b.length),s<0?s+=b.length:s>b.length&&(s=b.length);t<s;t++)yield b[t]}F.slice=w;function u(b,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,b];const i=b[Symbol.iterator]();for(let r=0;r<t;r++){const c=i.next();if(c.done)return[s,F.empty()];s.push(c.value)}return[s,{[Symbol.iterator](){return i}}]}F.consume=u;function g(b,t,s=(i,r)=>i===r){const i=b[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const c=i.next(),p=r.next();if(c.done!==p.done)return!1;if(c.done)return!0;if(!s(c.value,p.value))return!1}}F.equals=g})(m=e.Iterable||(e.Iterable={}))}),define(_e[108],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var F;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(F=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var y;(function(t){t.DEFAULT={allowTrailingComma:!0}})(y=e.ParseOptions||(e.ParseOptions={}));function I(t,s=!1){let i=0,r=t.length,c="",p=0,v=16,A=0;function R(K){let H=0,z=0;for(;H<K;){const T=t.charCodeAt(i);if(T>=48&&T<=57)z=z*16+T-48;else if(T>=65&&T<=70)z=z*16+T-65+10;else if(T>=97&&T<=102)z=z*16+T-97+10;else break;i++,H++}return H<K&&(z=-1),z}function o(K){i=K,c="",p=0,v=16,A=0}function P(){const K=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&C(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&C(t.charCodeAt(i)))for(i++;i<t.length&&C(t.charCodeAt(i));)i++;else return A=3,t.substring(K,i);let H=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&C(t.charCodeAt(i))){for(i++;i<t.length&&C(t.charCodeAt(i));)i++;H=i}else A=3;return t.substring(K,H)}function N(){let K="",H=i;for(;;){if(i>=r){K+=t.substring(H,i),A=2;break}const z=t.charCodeAt(i);if(z===34){K+=t.substring(H,i),i++;break}if(z===92){if(K+=t.substring(H,i),i++,i>=r){A=2;break}switch(t.charCodeAt(i++)){case 34:K+='"';break;case 92:K+="\\";break;case 47:K+="/";break;case 98:K+="\b";break;case 102:K+="\f";break;case 110:K+=`
`;break;case 114:K+="\r";break;case 116:K+="	";break;case 117:const q=R(4);q>=0?K+=String.fromCharCode(q):A=4;break;default:A=5}H=i;continue}if(z>=0&&z<=31)if(_(z)){K+=t.substring(H,i),A=2;break}else A=6;i++}return K}function $(){if(c="",A=0,p=i,i>=r)return p=r,v=17;let K=t.charCodeAt(i);if(S(K)){do i++,c+=String.fromCharCode(K),K=t.charCodeAt(i);while(S(K));return v=15}if(_(K))return i++,c+=String.fromCharCode(K),K===13&&t.charCodeAt(i)===10&&(i++,c+=`
`),v=14;switch(K){case 123:return i++,v=1;case 125:return i++,v=2;case 91:return i++,v=3;case 93:return i++,v=4;case 58:return i++,v=6;case 44:return i++,v=5;case 34:return i++,c=N(),v=10;case 47:const H=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<r&&!_(t.charCodeAt(i));)i++;return c=t.substring(H,i),v=12}if(t.charCodeAt(i+1)===42){i+=2;const z=r-1;let T=!1;for(;i<z;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,T=!0;break}i++}return T||(i++,A=1),c=t.substring(H,i),v=13}return c+=String.fromCharCode(K),i++,v=16;case 45:if(c+=String.fromCharCode(K),i++,i===r||!C(t.charCodeAt(i)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=P(),v=11;default:for(;i<r&&ie(K);)i++,K=t.charCodeAt(i);if(p!==i){switch(c=t.substring(p,i),c){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return c+=String.fromCharCode(K),i++,v=16}}function ie(K){if(S(K)||_(K))return!1;switch(K){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ce(){let K;do K=$();while(K>=12&&K<=15);return K}return{setPosition:o,getPosition:()=>i,scan:s?ce:$,getToken:()=>v,getTokenValue:()=>c,getTokenOffset:()=>p,getTokenLength:()=>i-p,getTokenError:()=>A}}e.createScanner=I;function S(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function _(t){return t===10||t===13||t===8232||t===8233}function C(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function k(t,s){const i=[],r=new Object;let c;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function A(R,o,P,N){p.value=R,p.offset=o,p.length=P,p.type=N,p.colonOffset=void 0,c=p}try{u(t,{onObjectBegin:(R,o)=>{if(s<=R)throw r;c=void 0,v=s>R,i.push("")},onObjectProperty:(R,o,P)=>{if(s<o||(A(R,o,P,"property"),i[i.length-1]=R,s<=o+P))throw r},onObjectEnd:(R,o)=>{if(s<=R)throw r;c=void 0,i.pop()},onArrayBegin:(R,o)=>{if(s<=R)throw r;c=void 0,i.push(0)},onArrayEnd:(R,o)=>{if(s<=R)throw r;c=void 0,i.pop()},onLiteralValue:(R,o,P)=>{if(s<o||(A(R,o,P,b(R)),s<=o+P))throw r},onSeparator:(R,o,P)=>{if(s<=o)throw r;if(R===":"&&c&&c.type==="property")c.colonOffset=o,v=!1,c=void 0;else if(R===","){const N=i[i.length-1];typeof N=="number"?i[i.length-1]=N+1:(v=!0,i[i.length-1]=""),c=void 0}}})}catch(R){if(R!==r)throw R}return{path:i,previousNode:c,isAtPropertyKey:v,matches:R=>{let o=0;for(let P=0;o<R.length&&P<i.length;P++)if(R[o]===i[P]||R[o]==="*")o++;else if(R[o]!=="**")return!1;return o===R.length}}}e.getLocation=k;function l(t,s=[],i=y.DEFAULT){let r=null,c=[];const p=[];function v(R){Array.isArray(c)?c.push(R):r!==null&&(c[r]=R)}return u(t,{onObjectBegin:()=>{const R={};v(R),p.push(c),c=R,r=null},onObjectProperty:R=>{r=R},onObjectEnd:()=>{c=p.pop()},onArrayBegin:()=>{const R=[];v(R),p.push(c),c=R,r=null},onArrayEnd:()=>{c=p.pop()},onLiteralValue:v,onError:(R,o,P)=>{s.push({error:R,offset:o,length:P})}},i),c[0]}e.parse=l;function h(t,s=[],i=y.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(R){r.type==="property"&&(r.length=R-r.offset,r=r.parent)}function p(R){return r.children.push(R),R}u(t,{onObjectBegin:R=>{r=p({type:"object",offset:R,length:-1,parent:r,children:[]})},onObjectProperty:(R,o,P)=>{r=p({type:"property",offset:o,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:R,offset:o,length:P,parent:r})},onObjectEnd:(R,o)=>{r.length=R+o-r.offset,r=r.parent,c(R+o)},onArrayBegin:(R,o)=>{r=p({type:"array",offset:R,length:-1,parent:r,children:[]})},onArrayEnd:(R,o)=>{r.length=R+o-r.offset,r=r.parent,c(R+o)},onLiteralValue:(R,o,P)=>{p({type:b(R),offset:o,length:P,parent:r,value:R}),c(o+P)},onSeparator:(R,o,P)=>{r.type==="property"&&(R===":"?r.colonOffset=o:R===","&&c(o))},onError:(R,o,P)=>{s.push({error:R,offset:o,length:P})}},i);const A=r.children[0];return A&&delete A.parent,A}e.parseTree=h;function a(t,s){if(!t)return;let i=t;for(let r of s)if(typeof r=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let c=!1;for(const p of i.children)if(Array.isArray(p.children)&&p.children[0].value===r){i=p.children[1],c=!0;break}if(!c)return}else{const c=r;if(i.type!=="array"||c<0||!Array.isArray(i.children)||c>=i.children.length)return;i=i.children[c]}return i}e.findNodeAtLocation=a;function d(t){if(!t.parent||!t.parent.children)return[];const s=d(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;s.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&s.push(i)}return s}e.getNodePath=d;function f(t){switch(t.type){case"array":return t.children.map(f);case"object":const s=Object.create(null);for(let i of t.children){const r=i.children[1];r&&(s[i.children[0].value]=f(r))}return s;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=f;function E(t,s,i=!1){return s>=t.offset&&s<t.offset+t.length||i&&s===t.offset+t.length}e.contains=E;function w(t,s,i=!1){if(E(t,s,i)){const r=t.children;if(Array.isArray(r))for(let c=0;c<r.length&&r[c].offset<=s;c++){const p=w(r[c],s,i);if(p)return p}return t}}e.findNodeAtOffset=w;function u(t,s,i=y.DEFAULT){const r=I(t,!1);function c(Se){return Se?()=>Se(r.getTokenOffset(),r.getTokenLength()):()=>!0}function p(Se){return Se?Re=>Se(Re,r.getTokenOffset(),r.getTokenLength()):()=>!0}const v=c(s.onObjectBegin),A=p(s.onObjectProperty),R=c(s.onObjectEnd),o=c(s.onArrayBegin),P=c(s.onArrayEnd),N=p(s.onLiteralValue),$=p(s.onSeparator),ie=c(s.onComment),ce=p(s.onError),K=i&&i.disallowComments,H=i&&i.allowTrailingComma;function z(){for(;;){const Se=r.scan();switch(r.getTokenError()){case 4:T(14);break;case 5:T(15);break;case 3:T(13);break;case 1:K||T(11);break;case 2:T(12);break;case 6:T(16);break}switch(Se){case 12:case 13:K?T(10):ie();break;case 16:T(1);break;case 15:case 14:break;default:return Se}}}function T(Se,Re=[],$e=[]){if(ce(Se),Re.length+$e.length>0){let Ne=r.getToken();for(;Ne!==17;){if(Re.indexOf(Ne)!==-1){z();break}else if($e.indexOf(Ne)!==-1)break;Ne=z()}}}function q(Se){const Re=r.getTokenValue();return Se?N(Re):A(Re),z(),!0}function L(){switch(r.getToken()){case 11:let Se=0;try{Se=JSON.parse(r.getTokenValue()),typeof Se!="number"&&(T(2),Se=0)}catch(Re){T(2)}N(Se);break;case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return z(),!0}function B(){return r.getToken()!==10?(T(3,[],[2,5]),!1):(q(!1),r.getToken()===6?($(":"),z(),se()||T(4,[],[2,5])):T(5,[],[2,5]),!0)}function Y(){v(),z();let Se=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(Se||T(4,[],[]),$(","),z(),r.getToken()===2&&H)break}else Se&&T(6,[],[]);B()||T(4,[],[2,5]),Se=!0}return R(),r.getToken()!==2?T(7,[2],[]):z(),!0}function j(){o(),z();let Se=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(Se||T(4,[],[]),$(","),z(),r.getToken()===4&&H)break}else Se&&T(6,[],[]);se()||T(4,[],[4,5]),Se=!0}return P(),r.getToken()!==4?T(8,[4],[]):z(),!0}function se(){switch(r.getToken()){case 3:return j();case 1:return Y();case 10:return q(!0);default:return L()}}return z(),r.getToken()===17?i.allowEmptyContent?!0:(T(4,[],[]),!1):se()?(r.getToken()!==17&&T(9,[],[]),!0):(T(4,[],[]),!1)}e.visit=u;function g(t,s){let i=I(t),r=[],c,p=0,v;do switch(v=i.getPosition(),c=i.scan(),c){case 12:case 13:case 17:p!==v&&r.push(t.substring(p,v)),s!==void 0&&r.push(i.getTokenValue().replace(/[^\r\n]/g,s)),p=i.getPosition();break}while(c!==17);return r.join("")}e.stripComments=g;function b(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=b}),define(_e[109],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class m{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new m(()=>D(this.getValue()))}}e.Lazy=m}),define(_e[7],ye([0,1,49,51]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let y=null;function I(s){y=s}if(e.setDisposableTracker=I,D){const s="__is_disposable_tracked__";I(new class{trackDisposable(i){const r=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[s]||console.log(r)},3e3)}setParent(i,r){if(i&&i!==w.None)try{i[s]=!0}catch{}}markAsDisposed(i){if(i&&i!==w.None)try{i[s]=!0}catch{}}markAsSingleton(i){}})}function S(s){return y?.trackDisposable(s),s}function _(s){y?.markAsDisposed(s)}function C(s,i){y?.setParent(s,i)}function n(s,i){if(!!y)for(const r of s)y.setParent(r,i)}function k(s){return y?.markAsSingleton(s),s}e.markAsSingleton=k;class l extends Error{constructor(i){super(`Encountered errors while disposing of store. Errors: [${i.join(", ")}]`);this.errors=i}}e.MultiDisposeError=l;function h(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=h;function a(s){if(F.Iterable.is(s)){let i=[];for(const r of s)if(r)try{r.dispose()}catch(c){i.push(c)}if(i.length===1)throw i[0];if(i.length>1)throw new l(i);return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=a;function d(...s){const i=f(()=>a(s));return n(s,i),i}e.combinedDisposable=d;function f(s){const i=S({dispose:(0,m.once)(()=>{_(i),s()})});return i}e.toDisposable=f;class E{constructor(){this._toDispose=new Set,this._isDisposed=!1,S(this)}dispose(){this._isDisposed||(_(this),this._isDisposed=!0,this.clear())}clear(){try{a(this._toDispose.values())}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return C(i,this),this._isDisposed?E.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}e.DisposableStore=E,E.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new E,S(this),C(this._store,this)}dispose(){_(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class u{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&C(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,_(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&C(i,null),i}}e.MutableDisposable=u;class g{constructor(){this.references=new Map}acquire(i,...r){let c=this.references.get(i);c||(c={counter:0,object:this.createReferencedObject(i,...r)},this.references.set(i,c));const{object:p}=c,v=(0,m.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(i,c.object),this.references.delete(i))});return c.counter++,{object:p,dispose:v}}}e.ReferenceCollection=g;class b{constructor(i){this.referenceCollection=i}async acquire(i,...r){const c=this.referenceCollection.acquire(i,...r);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(p){throw c.dispose(),p}}}e.AsyncReferenceCollection=b;class t{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=t}),define(_e[78],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(y){this.element=y,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class F{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let y=this._first;for(;y!==m.Undefined;){const I=y.next;y.prev=m.Undefined,y.next=m.Undefined,y=I}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(y){return this._insert(y,!1)}push(y){return this._insert(y,!0)}_insert(y,I){const S=new m(y);if(this._first===m.Undefined)this._first=S,this._last=S;else if(I){const C=this._last;this._last=S,S.prev=C,C.next=S}else{const C=this._first;this._first=S,S.next=C,C.prev=S}this._size+=1;let _=!1;return()=>{_||(_=!0,this._remove(S))}}shift(){if(this._first!==m.Undefined){const y=this._first.element;return this._remove(this._first),y}}pop(){if(this._last!==m.Undefined){const y=this._last.element;return this._remove(this._last),y}}_remove(y){if(y.prev!==m.Undefined&&y.next!==m.Undefined){const I=y.prev;I.next=y.next,y.next.prev=I}else y.prev===m.Undefined&&y.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):y.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):y.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let y=this._first;for(;y!==m.Undefined;)yield y.element,y=y.next}}e.LinkedList=F}),function(ee,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ee=typeof globalThis!="undefined"?globalThis:ee||self,ee.marked=e())}(this,function(){"use strict";function ee(Ce,De){for(var Ae=0;Ae<De.length;Ae++){var ne=De[Ae];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(Ce,ne.key,ne)}}function e(Ce,De,Ae){return De&&ee(Ce.prototype,De),Ae&&ee(Ce,Ae),Ce}function m(Ce,De){if(!!Ce){if(typeof Ce=="string")return F(Ce,De);var Ae=Object.prototype.toString.call(Ce).slice(8,-1);if(Ae==="Object"&&Ce.constructor&&(Ae=Ce.constructor.name),Ae==="Map"||Ae==="Set")return Array.from(Ce);if(Ae==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ae))return F(Ce,De)}}function F(Ce,De){(De==null||De>Ce.length)&&(De=Ce.length);for(var Ae=0,ne=new Array(De);Ae<De;Ae++)ne[Ae]=Ce[Ae];return ne}function D(Ce,De){var Ae;if(typeof Symbol=="undefined"||Ce[Symbol.iterator]==null){if(Array.isArray(Ce)||(Ae=m(Ce))||De&&Ce&&typeof Ce.length=="number"){Ae&&(Ce=Ae);var ne=0;return function(){return ne>=Ce.length?{done:!0}:{done:!1,value:Ce[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Ae=Ce[Symbol.iterator](),Ae.next.bind(Ae)}function y(Ce){var De={exports:{}};return Ce(De,De.exports),De.exports}var I=y(function(Ce){function De(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Ae(ne){Ce.exports.defaults=ne}Ce.exports={defaults:De(),getDefaults:De,changeDefaults:Ae}}),S=/[&<>"']/,_=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,n=/[<>"']|&(?!#?\w+;)/g,k={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},l=function(De){return k[De]};function h(Ce,De){if(De){if(S.test(Ce))return Ce.replace(_,l)}else if(C.test(Ce))return Ce.replace(n,l);return Ce}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(Ce){return Ce.replace(a,function(De,Ae){return Ae=Ae.toLowerCase(),Ae==="colon"?":":Ae.charAt(0)==="#"?Ae.charAt(1)==="x"?String.fromCharCode(parseInt(Ae.substring(2),16)):String.fromCharCode(+Ae.substring(1)):""})}var f=/(^|[^\[])\^/g;function E(Ce,De){Ce=Ce.source||Ce,De=De||"";var Ae={replace:function(oe,de){return de=de.source||de,de=de.replace(f,"$1"),Ce=Ce.replace(oe,de),Ae},getRegex:function(){return new RegExp(Ce,De)}};return Ae}var w=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(Ce,De,Ae){if(Ce){var ne;try{ne=decodeURIComponent(d(Ae)).replace(w,"").toLowerCase()}catch(oe){return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}De&&!u.test(Ae)&&(Ae=r(De,Ae));try{Ae=encodeURI(Ae).replace(/%25/g,"%")}catch(oe){return null}return Ae}var b={},t=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(Ce,De){b[" "+Ce]||(t.test(Ce)?b[" "+Ce]=Ce+"/":b[" "+Ce]=A(Ce,"/",!0)),Ce=b[" "+Ce];var Ae=Ce.indexOf(":")===-1;return De.substring(0,2)==="//"?Ae?De:Ce.replace(s,"$1")+De:De.charAt(0)==="/"?Ae?De:Ce.replace(i,"$1")+De:Ce+De}var c={exec:function(){}};function p(Ce){for(var De=1,Ae,ne;De<arguments.length;De++){Ae=arguments[De];for(ne in Ae)Object.prototype.hasOwnProperty.call(Ae,ne)&&(Ce[ne]=Ae[ne])}return Ce}function v(Ce,De){var Ae=Ce.replace(/\|/g,function(de,ge,x){for(var he=!1,we=ge;--we>=0&&x[we]==="\\";)he=!he;return he?"|":" |"}),ne=Ae.split(/ \|/),oe=0;if(ne.length>De)ne.splice(De);else for(;ne.length<De;)ne.push("");for(;oe<ne.length;oe++)ne[oe]=ne[oe].trim().replace(/\\\|/g,"|");return ne}function A(Ce,De,Ae){var ne=Ce.length;if(ne===0)return"";for(var oe=0;oe<ne;){var de=Ce.charAt(ne-oe-1);if(de===De&&!Ae)oe++;else if(de!==De&&Ae)oe++;else break}return Ce.substr(0,ne-oe)}function R(Ce,De){if(Ce.indexOf(De[1])===-1)return-1;for(var Ae=Ce.length,ne=0,oe=0;oe<Ae;oe++)if(Ce[oe]==="\\")oe++;else if(Ce[oe]===De[0])ne++;else if(Ce[oe]===De[1]&&(ne--,ne<0))return oe;return-1}function o(Ce){Ce&&Ce.sanitize&&!Ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(Ce,De){if(De<1)return"";for(var Ae="";De>1;)De&1&&(Ae+=Ce),De>>=1,Ce+=Ce;return Ae+Ce}var N={escape:h,unescape:d,edit:E,cleanUrl:g,resolveUrl:r,noopTest:c,merge:p,splitCells:v,rtrim:A,findClosingBracket:R,checkSanitizeDeprecation:o,repeatString:P},$=I.defaults,ie=N.rtrim,ce=N.splitCells,K=N.escape,H=N.findClosingBracket;function z(Ce,De,Ae){var ne=De.href,oe=De.title?K(De.title):null,de=Ce[1].replace(/\\([\[\]])/g,"$1");return Ce[0].charAt(0)!=="!"?{type:"link",raw:Ae,href:ne,title:oe,text:de}:{type:"image",raw:Ae,href:ne,title:oe,text:K(de)}}function T(Ce,De){var Ae=Ce.match(/^(\s+)(?:```)/);if(Ae===null)return De;var ne=Ae[1];return De.split(`
`).map(function(oe){var de=oe.match(/^\s+/);if(de===null)return oe;var ge=de[0];return ge.length>=ne.length?oe.slice(ne.length):oe}).join(`
`)}var q=function(){function Ce(Ae){this.options=Ae||$}var De=Ce.prototype;return De.space=function(ne){var oe=this.rules.block.newline.exec(ne);if(oe)return oe[0].length>1?{type:"space",raw:oe[0]}:{raw:`
`}},De.code=function(ne){var oe=this.rules.block.code.exec(ne);if(oe){var de=oe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:oe[0],codeBlockStyle:"indented",text:this.options.pedantic?de:ie(de,`
`)}}},De.fences=function(ne){var oe=this.rules.block.fences.exec(ne);if(oe){var de=oe[0],ge=T(de,oe[3]||"");return{type:"code",raw:de,lang:oe[2]?oe[2].trim():oe[2],text:ge}}},De.heading=function(ne){var oe=this.rules.block.heading.exec(ne);if(oe){var de=oe[2].trim();if(/#$/.test(de)){var ge=ie(de,"#");(this.options.pedantic||!ge||/ $/.test(ge))&&(de=ge.trim())}return{type:"heading",raw:oe[0],depth:oe[1].length,text:de}}},De.nptable=function(ne){var oe=this.rules.block.nptable.exec(ne);if(oe){var de={type:"table",header:ce(oe[1].replace(/^ *| *\| *$/g,"")),align:oe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:oe[3]?oe[3].replace(/\n$/,"").split(`
`):[],raw:oe[0]};if(de.header.length===de.align.length){var ge=de.align.length,x;for(x=0;x<ge;x++)/^ *-+: *$/.test(de.align[x])?de.align[x]="right":/^ *:-+: *$/.test(de.align[x])?de.align[x]="center":/^ *:-+ *$/.test(de.align[x])?de.align[x]="left":de.align[x]=null;for(ge=de.cells.length,x=0;x<ge;x++)de.cells[x]=ce(de.cells[x],de.header.length);return de}}},De.hr=function(ne){var oe=this.rules.block.hr.exec(ne);if(oe)return{type:"hr",raw:oe[0]}},De.blockquote=function(ne){var oe=this.rules.block.blockquote.exec(ne);if(oe){var de=oe[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:oe[0],text:de}}},De.list=function(ne){var oe=this.rules.block.list.exec(ne);if(oe){var de=oe[0],ge=oe[2],x=ge.length>1,he={type:"list",raw:de,ordered:x,start:x?+ge.slice(0,-1):"",loose:!1,items:[]},we=oe[0].match(this.rules.block.item),Pe=!1,Fe,He,Ze,Qe,Ye,at,ct,wt,me=we.length;Ze=this.rules.block.listItemStart.exec(we[0]);for(var Ee=0;Ee<me;Ee++){if(Fe=we[Ee],de=Fe,Ee!==me-1){if(Qe=this.rules.block.listItemStart.exec(we[Ee+1]),this.options.pedantic?Qe[1].length>Ze[1].length:Qe[1].length>Ze[0].length||Qe[1].length>3){we.splice(Ee,2,we[Ee]+`
`+we[Ee+1]),Ee--,me--;continue}else(!this.options.pedantic||this.options.smartLists?Qe[2][Qe[2].length-1]!==ge[ge.length-1]:x===(Qe[2].length===1))&&(Ye=we.slice(Ee+1).join(`
`),he.raw=he.raw.substring(0,he.raw.length-Ye.length),Ee=me-1);Ze=Qe}He=Fe.length,Fe=Fe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Fe.indexOf(`
 `)&&(He-=Fe.length,Fe=this.options.pedantic?Fe.replace(/^ {1,4}/gm,""):Fe.replace(new RegExp("^ {1,"+He+"}","gm"),"")),at=Pe||/\n\n(?!\s*$)/.test(Fe),Ee!==me-1&&(Pe=Fe.charAt(Fe.length-1)===`
`,at||(at=Pe)),at&&(he.loose=!0),this.options.gfm&&(ct=/^\[[ xX]\] /.test(Fe),wt=void 0,ct&&(wt=Fe[1]!==" ",Fe=Fe.replace(/^\[[ xX]\] +/,""))),he.items.push({type:"list_item",raw:de,task:ct,checked:wt,loose:at,text:Fe})}return he}},De.html=function(ne){var oe=this.rules.block.html.exec(ne);if(oe)return{type:this.options.sanitize?"paragraph":"html",raw:oe[0],pre:!this.options.sanitizer&&(oe[1]==="pre"||oe[1]==="script"||oe[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):K(oe[0]):oe[0]}},De.def=function(ne){var oe=this.rules.block.def.exec(ne);if(oe){oe[3]&&(oe[3]=oe[3].substring(1,oe[3].length-1));var de=oe[1].toLowerCase().replace(/\s+/g," ");return{tag:de,raw:oe[0],href:oe[2],title:oe[3]}}},De.table=function(ne){var oe=this.rules.block.table.exec(ne);if(oe){var de={type:"table",header:ce(oe[1].replace(/^ *| *\| *$/g,"")),align:oe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:oe[3]?oe[3].replace(/\n$/,"").split(`
`):[]};if(de.header.length===de.align.length){de.raw=oe[0];var ge=de.align.length,x;for(x=0;x<ge;x++)/^ *-+: *$/.test(de.align[x])?de.align[x]="right":/^ *:-+: *$/.test(de.align[x])?de.align[x]="center":/^ *:-+ *$/.test(de.align[x])?de.align[x]="left":de.align[x]=null;for(ge=de.cells.length,x=0;x<ge;x++)de.cells[x]=ce(de.cells[x].replace(/^ *\| *| *\| *$/g,""),de.header.length);return de}}},De.lheading=function(ne){var oe=this.rules.block.lheading.exec(ne);if(oe)return{type:"heading",raw:oe[0],depth:oe[2].charAt(0)==="="?1:2,text:oe[1]}},De.paragraph=function(ne){var oe=this.rules.block.paragraph.exec(ne);if(oe)return{type:"paragraph",raw:oe[0],text:oe[1].charAt(oe[1].length-1)===`
`?oe[1].slice(0,-1):oe[1]}},De.text=function(ne){var oe=this.rules.block.text.exec(ne);if(oe)return{type:"text",raw:oe[0],text:oe[0]}},De.escape=function(ne){var oe=this.rules.inline.escape.exec(ne);if(oe)return{type:"escape",raw:oe[0],text:K(oe[1])}},De.tag=function(ne,oe,de){var ge=this.rules.inline.tag.exec(ne);if(ge)return!oe&&/^<a /i.test(ge[0])?oe=!0:oe&&/^<\/a>/i.test(ge[0])&&(oe=!1),!de&&/^<(pre|code|kbd|script)(\s|>)/i.test(ge[0])?de=!0:de&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ge[0])&&(de=!1),{type:this.options.sanitize?"text":"html",raw:ge[0],inLink:oe,inRawBlock:de,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):K(ge[0]):ge[0]}},De.link=function(ne){var oe=this.rules.inline.link.exec(ne);if(oe){var de=oe[2].trim();if(!this.options.pedantic&&/^</.test(de)){if(!/>$/.test(de))return;var ge=ie(de.slice(0,-1),"\\");if((de.length-ge.length)%2==0)return}else{var x=H(oe[2],"()");if(x>-1){var he=oe[0].indexOf("!")===0?5:4,we=he+oe[1].length+x;oe[2]=oe[2].substring(0,x),oe[0]=oe[0].substring(0,we).trim(),oe[3]=""}}var Pe=oe[2],Fe="";if(this.options.pedantic){var He=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Pe);He&&(Pe=He[1],Fe=He[3])}else Fe=oe[3]?oe[3].slice(1,-1):"";return Pe=Pe.trim(),/^</.test(Pe)&&(this.options.pedantic&&!/>$/.test(de)?Pe=Pe.slice(1):Pe=Pe.slice(1,-1)),z(oe,{href:Pe&&Pe.replace(this.rules.inline._escapes,"$1"),title:Fe&&Fe.replace(this.rules.inline._escapes,"$1")},oe[0])}},De.reflink=function(ne,oe){var de;if((de=this.rules.inline.reflink.exec(ne))||(de=this.rules.inline.nolink.exec(ne))){var ge=(de[2]||de[1]).replace(/\s+/g," ");if(ge=oe[ge.toLowerCase()],!ge||!ge.href){var x=de[0].charAt(0);return{type:"text",raw:x,text:x}}return z(de,ge,de[0])}},De.emStrong=function(ne,oe,de){de===void 0&&(de="");var ge=this.rules.inline.emStrong.lDelim.exec(ne);if(!!ge&&!(ge[3]&&de.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var x=ge[1]||ge[2]||"";if(!x||x&&(de===""||this.rules.inline.punctuation.exec(de))){var he=ge[0].length-1,we,Pe,Fe=he,He=0,Ze=ge[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ze.lastIndex=0,oe=oe.slice(-1*ne.length+he);(ge=Ze.exec(oe))!=null;)if(we=ge[1]||ge[2]||ge[3]||ge[4]||ge[5]||ge[6],!!we){if(Pe=we.length,ge[3]||ge[4]){Fe+=Pe;continue}else if((ge[5]||ge[6])&&he%3&&!((he+Pe)%3)){He+=Pe;continue}if(Fe-=Pe,!(Fe>0)){if(Fe+He-Pe<=0&&!oe.slice(Ze.lastIndex).match(Ze)&&(Pe=Math.min(Pe,Pe+Fe+He)),Math.min(he,Pe)%2)return{type:"em",raw:ne.slice(0,he+ge.index+Pe+1),text:ne.slice(1,he+ge.index+Pe)};if(Math.min(he,Pe)%2==0)return{type:"strong",raw:ne.slice(0,he+ge.index+Pe+1),text:ne.slice(2,he+ge.index+Pe-1)}}}}}},De.codespan=function(ne){var oe=this.rules.inline.code.exec(ne);if(oe){var de=oe[2].replace(/\n/g," "),ge=/[^ ]/.test(de),x=/^ /.test(de)&&/ $/.test(de);return ge&&x&&(de=de.substring(1,de.length-1)),de=K(de,!0),{type:"codespan",raw:oe[0],text:de}}},De.br=function(ne){var oe=this.rules.inline.br.exec(ne);if(oe)return{type:"br",raw:oe[0]}},De.del=function(ne){var oe=this.rules.inline.del.exec(ne);if(oe)return{type:"del",raw:oe[0],text:oe[2]}},De.autolink=function(ne,oe){var de=this.rules.inline.autolink.exec(ne);if(de){var ge,x;return de[2]==="@"?(ge=K(this.options.mangle?oe(de[1]):de[1]),x="mailto:"+ge):(ge=K(de[1]),x=ge),{type:"link",raw:de[0],text:ge,href:x,tokens:[{type:"text",raw:ge,text:ge}]}}},De.url=function(ne,oe){var de;if(de=this.rules.inline.url.exec(ne)){var ge,x;if(de[2]==="@")ge=K(this.options.mangle?oe(de[0]):de[0]),x="mailto:"+ge;else{var he;do he=de[0],de[0]=this.rules.inline._backpedal.exec(de[0])[0];while(he!==de[0]);ge=K(de[0]),de[1]==="www."?x="http://"+ge:x=ge}return{type:"link",raw:de[0],text:ge,href:x,tokens:[{type:"text",raw:ge,text:ge}]}}},De.inlineText=function(ne,oe,de){var ge=this.rules.inline.text.exec(ne);if(ge){var x;return oe?x=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):K(ge[0]):ge[0]:x=K(this.options.smartypants?de(ge[0]):ge[0]),{type:"text",raw:ge[0],text:x}}},Ce}(),L=N.noopTest,B=N.edit,Y=N.merge,j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:L,table:L,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=B(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,j.item=B(j.item,"gm").replace(/bull/g,j.bullet).getRegex(),j.listItemStart=B(/^( *)(bull)/).replace("bull",j.bullet).getRegex(),j.list=B(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=B(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=B(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",j._tag).getRegex(),j.blockquote=B(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=Y({},j),j.gfm=Y({},j.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.nptable=B(j.gfm.nptable).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",j._tag).getRegex(),j.gfm.table=B(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",j._tag).getRegex(),j.pedantic=Y({},j.normal,{html:B(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:L,paragraph:B(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var se={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:L,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:L,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};se._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",se.punctuation=B(se.punctuation).replace(/punctuation/g,se._punctuation).getRegex(),se.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,se.escapedEmSt=/\\\*|\\_/g,se._comment=B(j._comment).replace("(?:-->|$)","-->").getRegex(),se.emStrong.lDelim=B(se.emStrong.lDelim).replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimAst=B(se.emStrong.rDelimAst,"g").replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimUnd=B(se.emStrong.rDelimUnd,"g").replace(/punct/g,se._punctuation).getRegex(),se._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,se._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,se._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,se.autolink=B(se.autolink).replace("scheme",se._scheme).replace("email",se._email).getRegex(),se._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,se.tag=B(se.tag).replace("comment",se._comment).replace("attribute",se._attribute).getRegex(),se._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,se._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,se._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,se.link=B(se.link).replace("label",se._label).replace("href",se._href).replace("title",se._title).getRegex(),se.reflink=B(se.reflink).replace("label",se._label).getRegex(),se.reflinkSearch=B(se.reflinkSearch,"g").replace("reflink",se.reflink).replace("nolink",se.nolink).getRegex(),se.normal=Y({},se),se.pedantic=Y({},se.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:B(/^!?\[(label)\]\((.*?)\)/).replace("label",se._label).getRegex(),reflink:B(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",se._label).getRegex()}),se.gfm=Y({},se.normal,{escape:B(se.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),se.gfm.url=B(se.gfm.url,"i").replace("email",se.gfm._extended_email).getRegex(),se.breaks=Y({},se.gfm,{br:B(se.br).replace("{2,}","*").getRegex(),text:B(se.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var Se={block:j,inline:se},Re=I.defaults,$e=Se.block,Ne=Se.inline,Ge=N.repeatString;function Ke(Ce){return Ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function qe(Ce){var De="",Ae,ne,oe=Ce.length;for(Ae=0;Ae<oe;Ae++)ne=Ce.charCodeAt(Ae),Math.random()>.5&&(ne="x"+ne.toString(16)),De+="&#"+ne+";";return De}var U=function(){function Ce(Ae){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ae||Re,this.options.tokenizer=this.options.tokenizer||new q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var ne={block:$e.normal,inline:Ne.normal};this.options.pedantic?(ne.block=$e.pedantic,ne.inline=Ne.pedantic):this.options.gfm&&(ne.block=$e.gfm,this.options.breaks?ne.inline=Ne.breaks:ne.inline=Ne.gfm),this.tokenizer.rules=ne}Ce.lex=function(ne,oe){var de=new Ce(oe);return de.lex(ne)},Ce.lexInline=function(ne,oe){var de=new Ce(oe);return de.inlineTokens(ne)};var De=Ce.prototype;return De.lex=function(ne){return ne=ne.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ne,this.tokens,!0),this.inline(this.tokens),this.tokens},De.blockTokens=function(ne,oe,de){oe===void 0&&(oe=[]),de===void 0&&(de=!0),this.options.pedantic&&(ne=ne.replace(/^ +$/gm,""));for(var ge,x,he,we;ne;){if(ge=this.tokenizer.space(ne)){ne=ne.substring(ge.raw.length),ge.type&&oe.push(ge);continue}if(ge=this.tokenizer.code(ne)){ne=ne.substring(ge.raw.length),we=oe[oe.length-1],we&&we.type==="paragraph"?(we.raw+=`
`+ge.raw,we.text+=`
`+ge.text):oe.push(ge);continue}if(ge=this.tokenizer.fences(ne)){ne=ne.substring(ge.raw.length),oe.push(ge);continue}if(ge=this.tokenizer.heading(ne)){ne=ne.substring(ge.raw.length),oe.push(ge);continue}if(ge=this.tokenizer.nptable(ne)){ne=ne.substring(ge.raw.length),oe.push(ge);continue}if(ge=this.tokenizer.hr(ne)){ne=ne.substring(ge.raw.length),oe.push(ge);continue}if(ge=this.tokenizer.blockquote(ne)){ne=ne.substring(ge.raw.length),ge.tokens=this.blockTokens(ge.text,[],de),oe.push(ge);continue}if(ge=this.tokenizer.list(ne)){for(ne=ne.substring(ge.raw.length),he=ge.items.length,x=0;x<he;x++)ge.items[x].tokens=this.blockTokens(ge.items[x].text,[],!1);oe.push(ge);continue}if(ge=this.tokenizer.html(ne)){ne=ne.substring(ge.raw.length),oe.push(ge);continue}if(de&&(ge=this.tokenizer.def(ne))){ne=ne.substring(ge.raw.length),this.tokens.links[ge.tag]||(this.tokens.links[ge.tag]={href:ge.href,title:ge.title});continue}if(ge=this.tokenizer.table(ne)){ne=ne.substring(ge.raw.length),oe.push(ge);continue}if(ge=this.tokenizer.lheading(ne)){ne=ne.substring(ge.raw.length),oe.push(ge);continue}if(de&&(ge=this.tokenizer.paragraph(ne))){ne=ne.substring(ge.raw.length),oe.push(ge);continue}if(ge=this.tokenizer.text(ne)){ne=ne.substring(ge.raw.length),we=oe[oe.length-1],we&&we.type==="text"?(we.raw+=`
`+ge.raw,we.text+=`
`+ge.text):oe.push(ge);continue}if(ne){var Pe="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(Pe);break}else throw new Error(Pe)}}return oe},De.inline=function(ne){var oe,de,ge,x,he,we,Pe=ne.length;for(oe=0;oe<Pe;oe++)switch(we=ne[oe],we.type){case"paragraph":case"text":case"heading":{we.tokens=[],this.inlineTokens(we.text,we.tokens);break}case"table":{for(we.tokens={header:[],cells:[]},x=we.header.length,de=0;de<x;de++)we.tokens.header[de]=[],this.inlineTokens(we.header[de],we.tokens.header[de]);for(x=we.cells.length,de=0;de<x;de++)for(he=we.cells[de],we.tokens.cells[de]=[],ge=0;ge<he.length;ge++)we.tokens.cells[de][ge]=[],this.inlineTokens(he[ge],we.tokens.cells[de][ge]);break}case"blockquote":{this.inline(we.tokens);break}case"list":{for(x=we.items.length,de=0;de<x;de++)this.inline(we.items[de].tokens);break}}return ne},De.inlineTokens=function(ne,oe,de,ge){oe===void 0&&(oe=[]),de===void 0&&(de=!1),ge===void 0&&(ge=!1);var x,he,we=ne,Pe,Fe,He;if(this.tokens.links){var Ze=Object.keys(this.tokens.links);if(Ze.length>0)for(;(Pe=this.tokenizer.rules.inline.reflinkSearch.exec(we))!=null;)Ze.includes(Pe[0].slice(Pe[0].lastIndexOf("[")+1,-1))&&(we=we.slice(0,Pe.index)+"["+Ge("a",Pe[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Pe=this.tokenizer.rules.inline.blockSkip.exec(we))!=null;)we=we.slice(0,Pe.index)+"["+Ge("a",Pe[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Pe=this.tokenizer.rules.inline.escapedEmSt.exec(we))!=null;)we=we.slice(0,Pe.index)+"++"+we.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;){if(Fe||(He=""),Fe=!1,x=this.tokenizer.escape(ne)){ne=ne.substring(x.raw.length),oe.push(x);continue}if(x=this.tokenizer.tag(ne,de,ge)){ne=ne.substring(x.raw.length),de=x.inLink,ge=x.inRawBlock;var Qe=oe[oe.length-1];Qe&&x.type==="text"&&Qe.type==="text"?(Qe.raw+=x.raw,Qe.text+=x.text):oe.push(x);continue}if(x=this.tokenizer.link(ne)){ne=ne.substring(x.raw.length),x.type==="link"&&(x.tokens=this.inlineTokens(x.text,[],!0,ge)),oe.push(x);continue}if(x=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(x.raw.length);var Ye=oe[oe.length-1];x.type==="link"?(x.tokens=this.inlineTokens(x.text,[],!0,ge),oe.push(x)):Ye&&x.type==="text"&&Ye.type==="text"?(Ye.raw+=x.raw,Ye.text+=x.text):oe.push(x);continue}if(x=this.tokenizer.emStrong(ne,we,He)){ne=ne.substring(x.raw.length),x.tokens=this.inlineTokens(x.text,[],de,ge),oe.push(x);continue}if(x=this.tokenizer.codespan(ne)){ne=ne.substring(x.raw.length),oe.push(x);continue}if(x=this.tokenizer.br(ne)){ne=ne.substring(x.raw.length),oe.push(x);continue}if(x=this.tokenizer.del(ne)){ne=ne.substring(x.raw.length),x.tokens=this.inlineTokens(x.text,[],de,ge),oe.push(x);continue}if(x=this.tokenizer.autolink(ne,qe)){ne=ne.substring(x.raw.length),oe.push(x);continue}if(!de&&(x=this.tokenizer.url(ne,qe))){ne=ne.substring(x.raw.length),oe.push(x);continue}if(x=this.tokenizer.inlineText(ne,ge,Ke)){ne=ne.substring(x.raw.length),x.raw.slice(-1)!=="_"&&(He=x.raw.slice(-1)),Fe=!0,he=oe[oe.length-1],he&&he.type==="text"?(he.raw+=x.raw,he.text+=x.text):oe.push(x);continue}if(ne){var at="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(at);break}else throw new Error(at)}}return oe},e(Ce,null,[{key:"rules",get:function(){return{block:$e,inline:Ne}}}]),Ce}(),G=I.defaults,te=N.cleanUrl,re=N.escape,pe=function(){function Ce(Ae){this.options=Ae||G}var De=Ce.prototype;return De.code=function(ne,oe,de){var ge=(oe||"").match(/\S*/)[0];if(this.options.highlight){var x=this.options.highlight(ne,ge);x!=null&&x!==ne&&(de=!0,ne=x)}return ne=ne.replace(/\n$/,"")+`
`,ge?'<pre><code class="'+this.options.langPrefix+re(ge,!0)+'">'+(de?ne:re(ne,!0))+`</code></pre>
`:"<pre><code>"+(de?ne:re(ne,!0))+`</code></pre>
`},De.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},De.html=function(ne){return ne},De.heading=function(ne,oe,de,ge){return this.options.headerIds?"<h"+oe+' id="'+this.options.headerPrefix+ge.slug(de)+'">'+ne+"</h"+oe+`>
`:"<h"+oe+">"+ne+"</h"+oe+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(ne,oe,de){var ge=oe?"ol":"ul",x=oe&&de!==1?' start="'+de+'"':"";return"<"+ge+x+`>
`+ne+"</"+ge+`>
`},De.listitem=function(ne){return"<li>"+ne+`</li>
`},De.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(ne){return"<p>"+ne+`</p>
`},De.table=function(ne,oe){return oe&&(oe="<tbody>"+oe+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+oe+`</table>
`},De.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},De.tablecell=function(ne,oe){var de=oe.header?"th":"td",ge=oe.align?"<"+de+' align="'+oe.align+'">':"<"+de+">";return ge+ne+"</"+de+`>
`},De.strong=function(ne){return"<strong>"+ne+"</strong>"},De.em=function(ne){return"<em>"+ne+"</em>"},De.codespan=function(ne){return"<code>"+ne+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(ne){return"<del>"+ne+"</del>"},De.link=function(ne,oe,de){if(ne=te(this.options.sanitize,this.options.baseUrl,ne),ne===null)return de;var ge='<a href="'+re(ne)+'"';return oe&&(ge+=' title="'+oe+'"'),ge+=">"+de+"</a>",ge},De.image=function(ne,oe,de){if(ne=te(this.options.sanitize,this.options.baseUrl,ne),ne===null)return de;var ge='<img src="'+ne+'" alt="'+de+'"';return oe&&(ge+=' title="'+oe+'"'),ge+=this.options.xhtml?"/>":">",ge},De.text=function(ne){return ne},Ce}(),Q=function(){function Ce(){}var De=Ce.prototype;return De.strong=function(ne){return ne},De.em=function(ne){return ne},De.codespan=function(ne){return ne},De.del=function(ne){return ne},De.html=function(ne){return ne},De.text=function(ne){return ne},De.link=function(ne,oe,de){return""+de},De.image=function(ne,oe,de){return""+de},De.br=function(){return""},Ce}(),ue=function(){function Ce(){this.seen={}}var De=Ce.prototype;return De.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(ne,oe){var de=ne,ge=0;if(this.seen.hasOwnProperty(de)){ge=this.seen[ne];do ge++,de=ne+"-"+ge;while(this.seen.hasOwnProperty(de))}return oe||(this.seen[ne]=ge,this.seen[de]=0),de},De.slug=function(ne,oe){oe===void 0&&(oe={});var de=this.serialize(ne);return this.getNextSafeSlug(de,oe.dryrun)},Ce}(),Ie=I.defaults,xe=N.unescape,We=function(){function Ce(Ae){this.options=Ae||Ie,this.options.renderer=this.options.renderer||new pe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Q,this.slugger=new ue}Ce.parse=function(ne,oe){var de=new Ce(oe);return de.parse(ne)},Ce.parseInline=function(ne,oe){var de=new Ce(oe);return de.parseInline(ne)};var De=Ce.prototype;return De.parse=function(ne,oe){oe===void 0&&(oe=!0);var de="",ge,x,he,we,Pe,Fe,He,Ze,Qe,Ye,at,ct,wt,me,Ee,ae,V,be,Be=ne.length;for(ge=0;ge<Be;ge++)switch(Ye=ne[ge],Ye.type){case"space":continue;case"hr":{de+=this.renderer.hr();continue}case"heading":{de+=this.renderer.heading(this.parseInline(Ye.tokens),Ye.depth,xe(this.parseInline(Ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{de+=this.renderer.code(Ye.text,Ye.lang,Ye.escaped);continue}case"table":{for(Ze="",He="",we=Ye.header.length,x=0;x<we;x++)He+=this.renderer.tablecell(this.parseInline(Ye.tokens.header[x]),{header:!0,align:Ye.align[x]});for(Ze+=this.renderer.tablerow(He),Qe="",we=Ye.cells.length,x=0;x<we;x++){for(Fe=Ye.tokens.cells[x],He="",Pe=Fe.length,he=0;he<Pe;he++)He+=this.renderer.tablecell(this.parseInline(Fe[he]),{header:!1,align:Ye.align[he]});Qe+=this.renderer.tablerow(He)}de+=this.renderer.table(Ze,Qe);continue}case"blockquote":{Qe=this.parse(Ye.tokens),de+=this.renderer.blockquote(Qe);continue}case"list":{for(at=Ye.ordered,ct=Ye.start,wt=Ye.loose,we=Ye.items.length,Qe="",x=0;x<we;x++)Ee=Ye.items[x],ae=Ee.checked,V=Ee.task,me="",Ee.task&&(be=this.renderer.checkbox(ae),wt?Ee.tokens.length>0&&Ee.tokens[0].type==="text"?(Ee.tokens[0].text=be+" "+Ee.tokens[0].text,Ee.tokens[0].tokens&&Ee.tokens[0].tokens.length>0&&Ee.tokens[0].tokens[0].type==="text"&&(Ee.tokens[0].tokens[0].text=be+" "+Ee.tokens[0].tokens[0].text)):Ee.tokens.unshift({type:"text",text:be}):me+=be),me+=this.parse(Ee.tokens,wt),Qe+=this.renderer.listitem(me,V,ae);de+=this.renderer.list(Qe,at,ct);continue}case"html":{de+=this.renderer.html(Ye.text);continue}case"paragraph":{de+=this.renderer.paragraph(this.parseInline(Ye.tokens));continue}case"text":{for(Qe=Ye.tokens?this.parseInline(Ye.tokens):Ye.text;ge+1<Be&&ne[ge+1].type==="text";)Ye=ne[++ge],Qe+=`
`+(Ye.tokens?this.parseInline(Ye.tokens):Ye.text);de+=oe?this.renderer.paragraph(Qe):Qe;continue}default:{var Xe='Token with "'+Ye.type+'" type was not found.';if(this.options.silent){console.error(Xe);return}else throw new Error(Xe)}}return de},De.parseInline=function(ne,oe){oe=oe||this.renderer;var de="",ge,x,he=ne.length;for(ge=0;ge<he;ge++)switch(x=ne[ge],x.type){case"escape":{de+=oe.text(x.text);break}case"html":{de+=oe.html(x.text);break}case"link":{de+=oe.link(x.href,x.title,this.parseInline(x.tokens,oe));break}case"image":{de+=oe.image(x.href,x.title,x.text);break}case"strong":{de+=oe.strong(this.parseInline(x.tokens,oe));break}case"em":{de+=oe.em(this.parseInline(x.tokens,oe));break}case"codespan":{de+=oe.codespan(x.text);break}case"br":{de+=oe.br();break}case"del":{de+=oe.del(this.parseInline(x.tokens,oe));break}case"text":{de+=oe.text(x.text);break}default:{var we='Token with "'+x.type+'" type was not found.';if(this.options.silent){console.error(we);return}else throw new Error(we)}}return de},Ce}(),ve=N.merge,tt=N.checkSanitizeDeprecation,W=N.escape,J=I.getDefaults,fe=I.changeDefaults,Oe=I.defaults;function Ue(Ce,De,Ae){if(typeof Ce=="undefined"||Ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");if(typeof De=="function"&&(Ae=De,De=null),De=ve({},Ue.defaults,De||{}),tt(De),Ae){var ne=De.highlight,oe;try{oe=U.lex(Ce,De)}catch(he){return Ae(he)}var de=function(we){var Pe;if(!we)try{Pe=We.parse(oe,De)}catch(Fe){we=Fe}return De.highlight=ne,we?Ae(we):Ae(null,Pe)};if(!ne||ne.length<3||(delete De.highlight,!oe.length))return de();var ge=0;Ue.walkTokens(oe,function(he){he.type==="code"&&(ge++,setTimeout(function(){ne(he.text,he.lang,function(we,Pe){if(we)return de(we);Pe!=null&&Pe!==he.text&&(he.text=Pe,he.escaped=!0),ge--,ge===0&&de()})},0))}),ge===0&&de();return}try{var x=U.lex(Ce,De);return De.walkTokens&&Ue.walkTokens(x,De.walkTokens),We.parse(x,De)}catch(he){if(he.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+W(he.message+"",!0)+"</pre>";throw he}}Ue.options=Ue.setOptions=function(Ce){return ve(Ue.defaults,Ce),fe(Ue.defaults),Ue},Ue.getDefaults=J,Ue.defaults=Oe,Ue.use=function(Ce){var De=ve({},Ce);if(Ce.renderer&&function(){var ne=Ue.defaults.renderer||new pe,oe=function(x){var he=ne[x];ne[x]=function(){for(var we=arguments.length,Pe=new Array(we),Fe=0;Fe<we;Fe++)Pe[Fe]=arguments[Fe];var He=Ce.renderer[x].apply(ne,Pe);return He===!1&&(He=he.apply(ne,Pe)),He}};for(var de in Ce.renderer)oe(de);De.renderer=ne}(),Ce.tokenizer&&function(){var ne=Ue.defaults.tokenizer||new q,oe=function(x){var he=ne[x];ne[x]=function(){for(var we=arguments.length,Pe=new Array(we),Fe=0;Fe<we;Fe++)Pe[Fe]=arguments[Fe];var He=Ce.tokenizer[x].apply(ne,Pe);return He===!1&&(He=he.apply(ne,Pe)),He}};for(var de in Ce.tokenizer)oe(de);De.tokenizer=ne}(),Ce.walkTokens){var Ae=Ue.defaults.walkTokens;De.walkTokens=function(ne){Ce.walkTokens(ne),Ae&&Ae(ne)}}Ue.setOptions(De)},Ue.walkTokens=function(Ce,De){for(var Ae=D(Ce),ne;!(ne=Ae()).done;){var oe=ne.value;switch(De(oe),oe.type){case"table":{for(var de=D(oe.tokens.header),ge;!(ge=de()).done;){var x=ge.value;Ue.walkTokens(x,De)}for(var he=D(oe.tokens.cells),we;!(we=he()).done;)for(var Pe=we.value,Fe=D(Pe),He;!(He=Fe()).done;){var Ze=He.value;Ue.walkTokens(Ze,De)}break}case"list":{Ue.walkTokens(oe.items,De);break}default:oe.tokens&&Ue.walkTokens(oe.tokens,De)}}},Ue.parseInline=function(Ce,De){if(typeof Ce=="undefined"||Ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");De=ve({},Ue.defaults,De||{}),tt(De);try{var Ae=U.lexInline(Ce,De);return De.walkTokens&&Ue.walkTokens(Ae,De.walkTokens),We.parseInline(Ae,De)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+W(ne.message+"",!0)+"</pre>";throw ne}},Ue.Parser=We,Ue.parser=We.parse,Ue.Renderer=pe,Ue.TextRenderer=Q,Ue.Lexer=U,Ue.lexer=U.lex,Ue.Tokenizer=q,Ue.Slugger=ue,Ue.parse=Ue;var et=Ue;return et}),define(_e[79],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function m(I,S,_){return Math.min(Math.max(I,S),_)}e.clamp=m;function F(I,S){return(S+I%S)%S}e.rot=F;class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class y{constructor(){this._n=1,this._val=0}update(S){return this._val=this._val+(S-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=y}),function(){function ee(D){const y=[];typeof D=="number"&&y.push("code/timeOrigin",D);function I(_){y.push(_,Date.now())}function S(){const _=[];for(let C=0;C<y.length;C+=2)_.push({name:y[C],startTime:y[C+1]});return _}return{mark:I,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const y=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const I of performance.getEntriesByType("mark"))y.push({name:I.name,startTime:Math.round(D+I.startTime)});return y}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function m(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=m(F))}(),define(_e[21],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const m="en";let F=!1,D=!1,y=!1,I=!1,S=!1,_=!1,C=!1,n,k=m,l,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?a=e.globals.vscode.process:typeof process!="undefined"&&(a=process);const d=typeof a?.versions?.electron=="string"&&a.type==="renderer";if(e.isElectronSandboxed=d&&a?.sandboxed,e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const i=a?.env.VSCODE_BROWSER_CODE_LOADING;if(typeof i=="string")return i==="none"||i==="code"||i==="bypassHeatCheck"||i==="bypassHeatCheckAndEagerCompile"?i:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!d)h=navigator.userAgent,F=h.indexOf("Windows")>=0,D=h.indexOf("Macintosh")>=0,C=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=h.indexOf("Linux")>=0,_=!0,n=navigator.language,k=n;else if(typeof a=="object"){F=a.platform==="win32",D=a.platform==="darwin",y=a.platform==="linux",I=y&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,n=m,k=m;const i=a.env.VSCODE_NLS_CONFIG;if(i)try{const r=JSON.parse(i),c=r.availableLanguages["*"];n=r.locale,k=c||m,l=r._translationsConfigFile}catch(r){}S=!0}else console.error("Unable to resolve platform.");var f;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function E(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=E;let w=0;D?w=1:F?w=3:y&&(w=2),e.isWindows=F,e.isMacintosh=D,e.isLinux=y,e.isLinuxSnap=I,e.isNative=S,e.isWeb=_,e.isIOS=C,e.platform=w,e.userAgent=h,e.language=k;var u;(function(i){function r(){return e.language}i.value=r;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=c;function p(){return e.language==="en"}i.isDefault=p})(u=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=l,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",v=>{if(v.data&&v.data.vscodeSetImmediateId)for(let A=0,R=c.length;A<R;A++){const o=c[A];if(o.id===v.data.vscodeSetImmediateId){c.splice(A,1),o.callback();return}}});let p=0;return v=>{const A=++p;c.push({id:A,callback:v}),e.globals.postMessage({vscodeSetImmediateId:A},"*")}}if(typeof a?.nextTick=="function")return a.nextTick.bind(a);const r=Promise.resolve();return c=>r.then(c)}();var g;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(g=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||C?2:F?1:3;let b=!0,t=!1;function s(){if(!t){t=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,b=new Uint16Array(i.buffer)[0]===(2<<8)+1}return b}e.isLittleEndian=s}),define(_e[40],ye([0,1,21]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let F;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const D=m.globals.vscode.process;F={get platform(){return D.platform},get env(){return D.env},cwd(){return D.cwd()},nextTick(y){return(0,m.setImmediate)(y)}}}else typeof process!="undefined"?F={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:F={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},nextTick(D){return(0,m.setImmediate)(D)},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.platform=F.platform,e.nextTick=F.nextTick}),define(_e[14],ye([0,1,40]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const F=65,D=97,y=90,I=122,S=46,_=47,C=92,n=58,k=63;class l extends Error{constructor(g,b,t){let s;typeof b=="string"&&b.indexOf("not ")===0?(s="must not be",b=b.replace(/^not /,"")):s="must be";const i=g.indexOf(".")!==-1?"property":"argument";let r=`The "${g}" ${i} ${s} of type ${b}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function h(u,g){if(typeof u!="string")throw new l(g,"string",u)}function a(u){return u===_||u===C}function d(u){return u===_}function f(u){return u>=F&&u<=y||u>=D&&u<=I}function E(u,g,b,t){let s="",i=0,r=-1,c=0,p=0;for(let v=0;v<=u.length;++v){if(v<u.length)p=u.charCodeAt(v);else{if(t(p))break;p=_}if(t(p)){if(!(r===v-1||c===1))if(c===2){if(s.length<2||i!==2||s.charCodeAt(s.length-1)!==S||s.charCodeAt(s.length-2)!==S){if(s.length>2){const A=s.lastIndexOf(b);A===-1?(s="",i=0):(s=s.slice(0,A),i=s.length-1-s.lastIndexOf(b)),r=v,c=0;continue}else if(s.length!==0){s="",i=0,r=v,c=0;continue}}g&&(s+=s.length>0?`${b}..`:"..",i=2)}else s.length>0?s+=`${b}${u.slice(r+1,v)}`:s=u.slice(r+1,v),i=v-r-1;r=v,c=0}else p===S&&c!==-1?++c:c=-1}return s}function w(u,g){if(g===null||typeof g!="object")throw new l("pathObject","Object",g);const b=g.dir||g.root,t=g.base||`${g.name||""}${g.ext||""}`;return b?b===g.root?`${b}${t}`:`${b}${u}${t}`:t}e.win32={resolve(...u){let g="",b="",t=!1;for(let s=u.length-1;s>=-1;s--){let i;if(s>=0){if(i=u[s],h(i,"path"),i.length===0)continue}else g.length===0?i=m.cwd():(i=m.env[`=${g}`]||m.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==g.toLowerCase()&&i.charCodeAt(2)===C)&&(i=`${g}\\`));const r=i.length;let c=0,p="",v=!1;const A=i.charCodeAt(0);if(r===1)a(A)&&(c=1,v=!0);else if(a(A))if(v=!0,a(i.charCodeAt(1))){let R=2,o=R;for(;R<r&&!a(i.charCodeAt(R));)R++;if(R<r&&R!==o){const P=i.slice(o,R);for(o=R;R<r&&a(i.charCodeAt(R));)R++;if(R<r&&R!==o){for(o=R;R<r&&!a(i.charCodeAt(R));)R++;(R===r||R!==o)&&(p=`\\\\${P}\\${i.slice(o,R)}`,c=R)}}}else c=1;else f(A)&&i.charCodeAt(1)===n&&(p=i.slice(0,2),c=2,r>2&&a(i.charCodeAt(2))&&(v=!0,c=3));if(p.length>0)if(g.length>0){if(p.toLowerCase()!==g.toLowerCase())continue}else g=p;if(t){if(g.length>0)break}else if(b=`${i.slice(c)}\\${b}`,t=v,v&&g.length>0)break}return b=E(b,!t,"\\",a),t?`${g}\\${b}`:`${g}${b}`||"."},normalize(u){h(u,"path");const g=u.length;if(g===0)return".";let b=0,t,s=!1;const i=u.charCodeAt(0);if(g===1)return d(i)?"\\":u;if(a(i))if(s=!0,a(u.charCodeAt(1))){let c=2,p=c;for(;c<g&&!a(u.charCodeAt(c));)c++;if(c<g&&c!==p){const v=u.slice(p,c);for(p=c;c<g&&a(u.charCodeAt(c));)c++;if(c<g&&c!==p){for(p=c;c<g&&!a(u.charCodeAt(c));)c++;if(c===g)return`\\\\${v}\\${u.slice(p)}\\`;c!==p&&(t=`\\\\${v}\\${u.slice(p,c)}`,b=c)}}}else b=1;else f(i)&&u.charCodeAt(1)===n&&(t=u.slice(0,2),b=2,g>2&&a(u.charCodeAt(2))&&(s=!0,b=3));let r=b<g?E(u.slice(b),!s,"\\",a):"";return r.length===0&&!s&&(r="."),r.length>0&&a(u.charCodeAt(g-1))&&(r+="\\"),t===void 0?s?`\\${r}`:r:s?`${t}\\${r}`:`${t}${r}`},isAbsolute(u){h(u,"path");const g=u.length;if(g===0)return!1;const b=u.charCodeAt(0);return a(b)||g>2&&f(b)&&u.charCodeAt(1)===n&&a(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let g,b;for(let i=0;i<u.length;++i){const r=u[i];h(r,"path"),r.length>0&&(g===void 0?g=b=r:g+=`\\${r}`)}if(g===void 0)return".";let t=!0,s=0;if(typeof b=="string"&&a(b.charCodeAt(0))){++s;const i=b.length;i>1&&a(b.charCodeAt(1))&&(++s,i>2&&(a(b.charCodeAt(2))?++s:t=!1))}if(t){for(;s<g.length&&a(g.charCodeAt(s));)s++;s>=2&&(g=`\\${g.slice(s)}`)}return e.win32.normalize(g)},relative(u,g){if(h(u,"from"),h(g,"to"),u===g)return"";const b=e.win32.resolve(u),t=e.win32.resolve(g);if(b===t||(u=b.toLowerCase(),g=t.toLowerCase(),u===g))return"";let s=0;for(;s<u.length&&u.charCodeAt(s)===C;)s++;let i=u.length;for(;i-1>s&&u.charCodeAt(i-1)===C;)i--;const r=i-s;let c=0;for(;c<g.length&&g.charCodeAt(c)===C;)c++;let p=g.length;for(;p-1>c&&g.charCodeAt(p-1)===C;)p--;const v=p-c,A=r<v?r:v;let R=-1,o=0;for(;o<A;o++){const N=u.charCodeAt(s+o);if(N!==g.charCodeAt(c+o))break;N===C&&(R=o)}if(o!==A){if(R===-1)return t}else{if(v>A){if(g.charCodeAt(c+o)===C)return t.slice(c+o+1);if(o===2)return t.slice(c+o)}r>A&&(u.charCodeAt(s+o)===C?R=o:o===2&&(R=3)),R===-1&&(R=0)}let P="";for(o=s+R+1;o<=i;++o)(o===i||u.charCodeAt(o)===C)&&(P+=P.length===0?"..":"\\..");return c+=R,P.length>0?`${P}${t.slice(c,p)}`:(t.charCodeAt(c)===C&&++c,t.slice(c,p))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const g=e.win32.resolve(u);if(g.length<=2)return u;if(g.charCodeAt(0)===C){if(g.charCodeAt(1)===C){const b=g.charCodeAt(2);if(b!==k&&b!==S)return`\\\\?\\UNC\\${g.slice(2)}`}}else if(f(g.charCodeAt(0))&&g.charCodeAt(1)===n&&g.charCodeAt(2)===C)return`\\\\?\\${g}`;return u},dirname(u){h(u,"path");const g=u.length;if(g===0)return".";let b=-1,t=0;const s=u.charCodeAt(0);if(g===1)return a(s)?u:".";if(a(s)){if(b=t=1,a(u.charCodeAt(1))){let c=2,p=c;for(;c<g&&!a(u.charCodeAt(c));)c++;if(c<g&&c!==p){for(p=c;c<g&&a(u.charCodeAt(c));)c++;if(c<g&&c!==p){for(p=c;c<g&&!a(u.charCodeAt(c));)c++;if(c===g)return u;c!==p&&(b=t=c+1)}}}}else f(s)&&u.charCodeAt(1)===n&&(b=g>2&&a(u.charCodeAt(2))?3:2,t=b);let i=-1,r=!0;for(let c=g-1;c>=t;--c)if(a(u.charCodeAt(c))){if(!r){i=c;break}}else r=!1;if(i===-1){if(b===-1)return".";i=b}return u.slice(0,i)},basename(u,g){g!==void 0&&h(g,"ext"),h(u,"path");let b=0,t=-1,s=!0,i;if(u.length>=2&&f(u.charCodeAt(0))&&u.charCodeAt(1)===n&&(b=2),g!==void 0&&g.length>0&&g.length<=u.length){if(g===u)return"";let r=g.length-1,c=-1;for(i=u.length-1;i>=b;--i){const p=u.charCodeAt(i);if(a(p)){if(!s){b=i+1;break}}else c===-1&&(s=!1,c=i+1),r>=0&&(p===g.charCodeAt(r)?--r==-1&&(t=i):(r=-1,t=c))}return b===t?t=c:t===-1&&(t=u.length),u.slice(b,t)}for(i=u.length-1;i>=b;--i)if(a(u.charCodeAt(i))){if(!s){b=i+1;break}}else t===-1&&(s=!1,t=i+1);return t===-1?"":u.slice(b,t)},extname(u){h(u,"path");let g=0,b=-1,t=0,s=-1,i=!0,r=0;u.length>=2&&u.charCodeAt(1)===n&&f(u.charCodeAt(0))&&(g=t=2);for(let c=u.length-1;c>=g;--c){const p=u.charCodeAt(c);if(a(p)){if(!i){t=c+1;break}continue}s===-1&&(i=!1,s=c+1),p===S?b===-1?b=c:r!==1&&(r=1):b!==-1&&(r=-1)}return b===-1||s===-1||r===0||r===1&&b===s-1&&b===t+1?"":u.slice(b,s)},format:w.bind(null,"\\"),parse(u){h(u,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return g;const b=u.length;let t=0,s=u.charCodeAt(0);if(b===1)return a(s)?(g.root=g.dir=u,g):(g.base=g.name=u,g);if(a(s)){if(t=1,a(u.charCodeAt(1))){let R=2,o=R;for(;R<b&&!a(u.charCodeAt(R));)R++;if(R<b&&R!==o){for(o=R;R<b&&a(u.charCodeAt(R));)R++;if(R<b&&R!==o){for(o=R;R<b&&!a(u.charCodeAt(R));)R++;R===b?t=R:R!==o&&(t=R+1)}}}}else if(f(s)&&u.charCodeAt(1)===n){if(b<=2)return g.root=g.dir=u,g;if(t=2,a(u.charCodeAt(2))){if(b===3)return g.root=g.dir=u,g;t=3}}t>0&&(g.root=u.slice(0,t));let i=-1,r=t,c=-1,p=!0,v=u.length-1,A=0;for(;v>=t;--v){if(s=u.charCodeAt(v),a(s)){if(!p){r=v+1;break}continue}c===-1&&(p=!1,c=v+1),s===S?i===-1?i=v:A!==1&&(A=1):i!==-1&&(A=-1)}return c!==-1&&(i===-1||A===0||A===1&&i===c-1&&i===r+1?g.base=g.name=u.slice(r,c):(g.name=u.slice(r,i),g.base=u.slice(r,c),g.ext=u.slice(i,c))),r>0&&r!==t?g.dir=u.slice(0,r-1):g.dir=g.root,g},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let g="",b=!1;for(let t=u.length-1;t>=-1&&!b;t--){const s=t>=0?u[t]:m.cwd();h(s,"path"),s.length!==0&&(g=`${s}/${g}`,b=s.charCodeAt(0)===_)}return g=E(g,!b,"/",d),b?`/${g}`:g.length>0?g:"."},normalize(u){if(h(u,"path"),u.length===0)return".";const g=u.charCodeAt(0)===_,b=u.charCodeAt(u.length-1)===_;return u=E(u,!g,"/",d),u.length===0?g?"/":b?"./":".":(b&&(u+="/"),g?`/${u}`:u)},isAbsolute(u){return h(u,"path"),u.length>0&&u.charCodeAt(0)===_},join(...u){if(u.length===0)return".";let g;for(let b=0;b<u.length;++b){const t=u[b];h(t,"path"),t.length>0&&(g===void 0?g=t:g+=`/${t}`)}return g===void 0?".":e.posix.normalize(g)},relative(u,g){if(h(u,"from"),h(g,"to"),u===g||(u=e.posix.resolve(u),g=e.posix.resolve(g),u===g))return"";const b=1,t=u.length,s=t-b,i=1,r=g.length-i,c=s<r?s:r;let p=-1,v=0;for(;v<c;v++){const R=u.charCodeAt(b+v);if(R!==g.charCodeAt(i+v))break;R===_&&(p=v)}if(v===c)if(r>c){if(g.charCodeAt(i+v)===_)return g.slice(i+v+1);if(v===0)return g.slice(i+v)}else s>c&&(u.charCodeAt(b+v)===_?p=v:v===0&&(p=0));let A="";for(v=b+p+1;v<=t;++v)(v===t||u.charCodeAt(v)===_)&&(A+=A.length===0?"..":"/..");return`${A}${g.slice(i+p)}`},toNamespacedPath(u){return u},dirname(u){if(h(u,"path"),u.length===0)return".";const g=u.charCodeAt(0)===_;let b=-1,t=!0;for(let s=u.length-1;s>=1;--s)if(u.charCodeAt(s)===_){if(!t){b=s;break}}else t=!1;return b===-1?g?"/":".":g&&b===1?"//":u.slice(0,b)},basename(u,g){g!==void 0&&h(g,"ext"),h(u,"path");let b=0,t=-1,s=!0,i;if(g!==void 0&&g.length>0&&g.length<=u.length){if(g===u)return"";let r=g.length-1,c=-1;for(i=u.length-1;i>=0;--i){const p=u.charCodeAt(i);if(p===_){if(!s){b=i+1;break}}else c===-1&&(s=!1,c=i+1),r>=0&&(p===g.charCodeAt(r)?--r==-1&&(t=i):(r=-1,t=c))}return b===t?t=c:t===-1&&(t=u.length),u.slice(b,t)}for(i=u.length-1;i>=0;--i)if(u.charCodeAt(i)===_){if(!s){b=i+1;break}}else t===-1&&(s=!1,t=i+1);return t===-1?"":u.slice(b,t)},extname(u){h(u,"path");let g=-1,b=0,t=-1,s=!0,i=0;for(let r=u.length-1;r>=0;--r){const c=u.charCodeAt(r);if(c===_){if(!s){b=r+1;break}continue}t===-1&&(s=!1,t=r+1),c===S?g===-1?g=r:i!==1&&(i=1):g!==-1&&(i=-1)}return g===-1||t===-1||i===0||i===1&&g===t-1&&g===b+1?"":u.slice(g,t)},format:w.bind(null,"/"),parse(u){h(u,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return g;const b=u.charCodeAt(0)===_;let t;b?(g.root="/",t=1):t=0;let s=-1,i=0,r=-1,c=!0,p=u.length-1,v=0;for(;p>=t;--p){const A=u.charCodeAt(p);if(A===_){if(!c){i=p+1;break}continue}r===-1&&(c=!1,r=p+1),A===S?s===-1?s=p:v!==1&&(v=1):s!==-1&&(v=-1)}if(r!==-1){const A=i===0&&b?1:i;s===-1||v===0||v===1&&s===r-1&&s===i+1?g.base=g.name=u.slice(A,r):(g.name=u.slice(A,s),g.base=u.slice(A,r),g.ext=u.slice(s,r))}return i>0?g.dir=u.slice(0,i-1):b&&(g.dir="/"),g},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(_e[52],ye([0,1,21]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const F=m.globals.performance&&typeof m.globals.performance.now=="function";class D{constructor(I){this._highResolution=F&&I,this._startTime=this._now(),this._stopTime=-1}static create(I=!0){return new D(I)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=D}),define(_e[3],ye([0,1,12,49,7,78,52]),function(ee,e,m,F,D,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var S;(function(u){u.None=()=>D.Disposable.None;function g(K){return(H,z=null,T)=>{let q=!1,L;return L=K(B=>{if(!q)return L?L.dispose():q=!0,H.call(z,B)},null,T),q&&L.dispose(),L}}u.once=g;function b(K,H){return p((z,T=null,q)=>K(L=>z.call(T,H(L)),null,q))}u.map=b;function t(K,H){return p((z,T=null,q)=>K(L=>{H(L),z.call(T,L)},null,q))}u.forEach=t;function s(K,H){return p((z,T=null,q)=>K(L=>H(L)&&z.call(T,L),null,q))}u.filter=s;function i(K){return K}u.signal=i;function r(...K){return(H,z=null,T)=>(0,D.combinedDisposable)(...K.map(q=>q(L=>H.call(z,L),null,T)))}u.any=r;function c(K,H,z){let T=z;return b(K,q=>(T=H(T,q),T))}u.reduce=c;function p(K){let H;const z=new l({onFirstListenerAdd(){H=K(z.fire,z)},onLastListenerRemove(){H.dispose()}});return z.event}function v(K,H,z=100,T=!1,q){let L,B,Y,j=0;const se=new l({leakWarningThreshold:q,onFirstListenerAdd(){L=K(Se=>{j++,B=H(B,Se),T&&!Y&&(se.fire(B),B=void 0),clearTimeout(Y),Y=setTimeout(()=>{const Re=B;B=void 0,Y=void 0,(!T||j>1)&&se.fire(Re),j=0},z)})},onLastListenerRemove(){L.dispose()}});return se.event}u.debounce=v;function A(K,H=(z,T)=>z===T){let z=!0,T;return s(K,q=>{const L=z||!H(q,T);return z=!1,T=q,L})}u.latch=A;function R(K,H){return[u.filter(K,H),u.filter(K,z=>!H(z))]}u.split=R;function o(K,H=!1,z=[]){let T=z.slice(),q=K(Y=>{T?T.push(Y):B.fire(Y)});const L=()=>{T&&T.forEach(Y=>B.fire(Y)),T=null},B=new l({onFirstListenerAdd(){q||(q=K(Y=>B.fire(Y)))},onFirstListenerDidAdd(){T&&(H?setTimeout(L):L())},onLastListenerRemove(){q&&q.dispose(),q=null}});return B.event}u.buffer=o;class P{constructor(H){this.event=H}map(H){return new P(b(this.event,H))}forEach(H){return new P(t(this.event,H))}filter(H){return new P(s(this.event,H))}reduce(H,z){return new P(c(this.event,H,z))}latch(){return new P(A(this.event))}debounce(H,z=100,T=!1,q){return new P(v(this.event,H,z,T,q))}on(H,z,T){return this.event(H,z,T)}once(H,z,T){return g(this.event)(H,z,T)}}function N(K){return new P(K)}u.chain=N;function $(K,H,z=T=>T){const T=(...Y)=>B.fire(z(...Y)),q=()=>K.on(H,T),L=()=>K.removeListener(H,T),B=new l({onFirstListenerAdd:q,onLastListenerRemove:L});return B.event}u.fromNodeEventEmitter=$;function ie(K,H,z=T=>T){const T=(...Y)=>B.fire(z(...Y)),q=()=>K.addEventListener(H,T),L=()=>K.removeEventListener(H,T),B=new l({onFirstListenerAdd:q,onLastListenerRemove:L});return B.event}u.fromDOMEventEmitter=ie;function ce(K){return new Promise(H=>g(K)(H))}u.toPromise=ce})(S=e.Event||(e.Event={}));class _{constructor(g){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${g}_${_._idPool++}`}start(g){this._stopWatch=new I.StopWatch(!0),this._listenerCount=g}stop(){if(this._stopWatch){const g=this._stopWatch.elapsed();this._elapsedOverall+=g,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${g.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}_._idPool=0;let C=-1;function n(u){const g=C;return C=u,{dispose(){C=g}}}e.setGlobalLeakWarningThreshold=n;class k{constructor(g,b=Math.random().toString(18).slice(2,5)){this.customThreshold=g,this.name=b,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(g){let b=C;if(typeof this.customThreshold=="number"&&(b=this.customThreshold),b<=0||g<b)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(t)||0;if(this._stacks.set(t,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=b*.5;let i,r=0;for(const[c,p]of this._stacks)(!i||r<p)&&(i=c,r=p);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${r}):`),console.warn(i)}return()=>{const i=this._stacks.get(t)||0;this._stacks.set(t,i-1)}}}class l{constructor(g){this._disposed=!1,this._options=g,this._leakageMon=C>0?new k(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new _(this._options._profName):void 0}get event(){return this._event||(this._event=(g,b,t)=>{this._listeners||(this._listeners=new y.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(b?[g,b]:g);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,g,b);const r=this._leakageMon?.check(this._listeners.size),c=(0,D.toDisposable)(()=>{r&&r(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof D.DisposableStore?t.add(c):Array.isArray(t)&&t.push(c),c}),this._event}fire(g){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new y.LinkedList);for(let b of this._listeners)this._deliveryQueue.push([b,g]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[b,t]=this._deliveryQueue.shift();try{typeof b=="function"?b.call(void 0,t):b[0].call(b[1],t)}catch(s){(0,m.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=l;class h extends l{async fireAsync(g,b,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,g]);for(;this._asyncDeliveryQueue.size>0&&!b.isCancellationRequested;){const[s,i]=this._asyncDeliveryQueue.shift(),r=[],c={...i,waitUntil:p=>{if(Object.isFrozen(r))throw new Error("waitUntil can NOT be called asynchronous");t&&(p=t(p,typeof s=="function"?s:s[0])),r.push(p)}};try{typeof s=="function"?s.call(void 0,c):s[0].call(s[1],c)}catch(p){(0,m.onUnexpectedError)(p);continue}Object.freeze(r),await Promise.allSettled(r).then(p=>{for(const v of p)v.status==="rejected"&&(0,m.onUnexpectedError)(v.reason)})}}}}e.AsyncEmitter=h;class a extends l{constructor(g){super(g);this._isPaused=0,this._eventQueue=new y.LinkedList,this._mergeFn=g?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const g=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(g))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(g){this._listeners&&(this._isPaused!==0?this._eventQueue.push(g):super.fire(g))}}e.PauseableEmitter=a;class d extends a{constructor(g){super(g);this._delay=g.delay??100}fire(g){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(g)}}e.DebounceEmitter=d;class f{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(g){const b={event:g,listener:null};this.events.push(b),this.hasListeners&&this.hook(b);const t=()=>{this.hasListeners&&this.unhook(b);const s=this.events.indexOf(b);this.events.splice(s,1)};return(0,D.toDisposable)((0,F.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(g=>this.hook(g))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(g=>this.unhook(g))}hook(g){g.listener=g.event(b=>this.emitter.fire(b))}unhook(g){g.listener&&g.listener.dispose(),g.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=f;class E{constructor(){this.buffers=[]}wrapEvent(g){return(b,t,s)=>g(i=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>b.call(t,i)):b.call(t,i)},void 0,s)}bufferEvents(g){const b=[];this.buffers.push(b);const t=g();return this.buffers.pop(),b.forEach(s=>s()),t}}e.EventBufferer=E;class w{constructor(){this.listening=!1,this.inputEvent=S.None,this.inputEventListener=D.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(g){this.inputEvent=g,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=g(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=w}),define(_e[18],ye([0,1,3]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const F=Object.freeze(function(S,_){const C=setTimeout(S.bind(_),0);return{dispose(){clearTimeout(C)}}});var D;(function(S){function _(C){return C===S.None||C===S.Cancelled||C instanceof y?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}S.isCancellationToken=_,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(D=e.CancellationToken||(e.CancellationToken={}));class y{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?F:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class I{constructor(_){this._token=void 0,this._parentListener=void 0,this._parentListener=_&&_.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new y),this._token}cancel(){this._token?this._token instanceof y&&this._token.cancel():this._token=D.Cancelled}dispose(_=!1){_&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof y&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=I}),define(_e[53],ye([0,1,3]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class F{constructor(){this._icons=new Map,this._onDidRegister=new m.Emitter}add(k){const l=this._icons.get(k.id);l?k.description?l.description=k.description:console.error(`Duplicate registration of codicon ${k.id}`):(this._icons.set(k.id,k),this._onDidRegister.fire(k))}get(k){return this._icons.get(k)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new F;e.iconRegistry=D;function y(n,k){return new S(n,k)}e.registerCodicon=y;function I(n){return n?n.replace(/\$\((.*?)\)/g,(k,l)=>` ${l} `).trim():""}e.getCodiconAriaLabel=I;class S{constructor(k,l,h){this.id=k,this.definition=l,this.description=h,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=S;function _(n,k){const l=["codicon","codicon-"+n];return k&&l.push("codicon-modifier-"+k),l}e.getClassNamesArray=_;var C;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const k=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function l(d){if(d instanceof S)return["codicon","codicon-"+d.id];const f=k.exec(d.id);if(!f)return l(S.error);let[,E,w]=f;const u=["codicon","codicon-"+E];return w&&u.push("codicon-modifier-"+w.substr(1)),u}n.asClassNameArray=l;function h(d){return l(d).join(" ")}n.asClassName=h;function a(d){return"."+l(d).join(".")}n.asCSSSelector=a})(C=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(S=e.Codicon||(e.Codicon={}))}),define(_e[110],ye([0,1,12,7]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(u){const g=u;return g?[g.on,g.pause,g.resume,g.destroy].every(b=>typeof b=="function"):!1}e.isReadableStream=D;function y(u){const g=u;return g?D(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.isReadableBufferedStream=y;function I(u,g){return new S(u,g)}e.newWriteableStream=I;class S{constructor(g,b){this.reducer=g,this.options=b,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(g){if(!this.state.destroyed){if(this.state.flowing)this.emitData(g);else if(this.buffer.data.push(g),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(b=>this.pendingWritePromises.push(b))}}error(g){this.state.destroyed||(this.state.flowing?this.emitError(g):this.buffer.error.push(g))}end(g){this.state.destroyed||(typeof g!="undefined"&&this.write(g),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(g){this.listeners.data.slice(0).forEach(b=>b(g))}emitError(g){this.listeners.error.length===0?(0,m.onUnexpectedError)(g):this.listeners.error.slice(0).forEach(b=>b(g))}emitEnd(){this.listeners.end.slice(0).forEach(g=>g())}on(g,b){if(!this.state.destroyed)switch(g){case"data":this.listeners.data.push(b),this.resume();break;case"end":this.listeners.end.push(b),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(b),this.state.flowing&&this.flowErrors();break}}removeListener(g,b){if(this.state.destroyed)return;let t;switch(g){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const s=t.indexOf(b);s>=0&&t.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const g=this.reducer(this.buffer.data);this.emitData(g),this.buffer.data.length=0;const b=[...this.pendingWritePromises];this.pendingWritePromises.length=0,b.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const g of this.buffer.error)this.emitError(g);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(u,g){const b=[];let t;for(;(t=u.read())!==null;)b.push(t);return g(b)}e.consumeReadable=_;function C(u,g,b){const t=[];let s;for(;(s=u.read())!==null&&t.length<b;)t.push(s);return s===null&&t.length>0?g(t):{read:()=>{if(t.length>0)return t.shift();if(typeof s!="undefined"){const i=s;return s=void 0,i}return u.read()}}}e.peekReadable=C;function n(u,g){return new Promise((b,t)=>{const s=[];k(u,{onData:i=>{g&&s.push(i)},onError:i=>{g?t(i):b(void 0)},onEnd:()=>{b(g?g(s):void 0)}})})}e.consumeStream=n;function k(u,g){u.on("error",b=>g.onError(b)),u.on("end",()=>g.onEnd()),u.on("data",b=>g.onData(b))}e.listenStream=k;function l(u,g){return new Promise((b,t)=>{const s=new F.DisposableStore,i=[],r=v=>{if(i.push(v),i.length>g)return s.dispose(),u.pause(),b({stream:u,buffer:i,ended:!1})},c=v=>t(v),p=()=>b({stream:u,buffer:i,ended:!0});s.add((0,F.toDisposable)(()=>u.removeListener("error",c))),u.on("error",c),s.add((0,F.toDisposable)(()=>u.removeListener("end",p))),u.on("end",p),s.add((0,F.toDisposable)(()=>u.removeListener("data",r))),u.on("data",r)})}e.peekStream=l;function h(u,g){const b=I(g);return b.end(u),b}e.toStream=h;function a(){const u=I(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=a;function d(u){let g=!1;return{read:()=>g?null:(g=!0,u)}}e.toReadable=d;function f(u,g,b){const t=I(b);return k(u,{onData:s=>t.write(g.data(s)),onError:s=>t.error(g.error?g.error(s):s),onEnd:()=>t.end()}),t}e.transform=f;function E(u,g,b){let t=!1;return{read:()=>{const s=g.read();return t?s:(t=!0,s!==null?b([u,s]):u)}}}e.prefixedReadable=E;function w(u,g,b){let t=!1;const s=I(b);return k(g,{onData:i=>t?s.write(i):(t=!0,s.write(b([u,i]))),onError:i=>s.error(i),onEnd:()=>{t||(t=!0,s.write(u)),s.end()}}),s}e.prefixedStream=w}),define(_e[8],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function m(x){return!x||typeof x!="string"?!0:x.trim().length===0}e.isFalsyOrWhitespace=m;const F=/{(\d+)}/g;function D(x,...he){return he.length===0?x:x.replace(F,function(we,Pe){const Fe=parseInt(Pe,10);return isNaN(Fe)||Fe<0||Fe>=he.length?we:he[Fe]})}e.format=D;const y=/{([^}]+)}/g;function I(x,he){return x.replace(y,(we,Pe)=>he[Pe]??we)}e.format2=I;function S(x){return x.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.escape=S;function _(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=_;function C(x,he){let we=0;const Pe=he.charCodeAt(0);for(let Fe=x.length-1;Fe>=0;Fe--)x.charCodeAt(Fe)===Pe&&we++;return we}e.count=C;function n(x,he,we="\u2026"){return x.length<=he?x:`${x.substr(0,he)}${we}`}e.truncate=n;function k(x,he=" "){const we=l(x,he);return h(we,he)}e.trim=k;function l(x,he){if(!x||!he)return x;const we=he.length;if(we===0||x.length===0)return x;let Pe=0;for(;x.indexOf(he,Pe)===Pe;)Pe=Pe+we;return x.substring(Pe)}e.ltrim=l;function h(x,he){if(!x||!he)return x;const we=he.length,Pe=x.length;if(we===0||Pe===0)return x;let Fe=Pe,He=-1;for(;He=x.lastIndexOf(he,Fe-1),!(He===-1||He+we!==Fe);){if(He===0)return"";Fe=He}return x.substring(0,Fe)}e.rtrim=h;function a(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=a;function d(x){return x.replace(/\*/g,"")}e.stripWildcards=d;function f(x,he,we={}){if(!x)throw new Error("Cannot create regex from empty string");he||(x=_(x)),we.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let Pe="";return we.global&&(Pe+="g"),we.matchCase||(Pe+="i"),we.multiline&&(Pe+="m"),we.unicode&&(Pe+="u"),new RegExp(x,Pe)}e.createRegExp=f;function E(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}e.regExpLeadsToEndlessLoop=E;function w(x){return!!x.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=w;function u(x){return(x.global?"g":"")+(x.ignoreCase?"i":"")+(x.multiline?"m":"")+(x.unicode?"u":"")}e.regExpFlags=u;function g(x){return x.split(/\r\n|\r|\n/)}e.splitLines=g;function b(x){for(let he=0,we=x.length;he<we;he++){const Pe=x.charCodeAt(he);if(Pe!==32&&Pe!==9)return he}return-1}e.firstNonWhitespaceIndex=b;function t(x,he=0,we=x.length){for(let Pe=he;Pe<we;Pe++){const Fe=x.charCodeAt(Pe);if(Fe!==32&&Fe!==9)return x.substring(he,Pe)}return x.substring(he,we)}e.getLeadingWhitespace=t;function s(x,he=x.length-1){for(let we=he;we>=0;we--){const Pe=x.charCodeAt(we);if(Pe!==32&&Pe!==9)return we}return-1}e.lastNonWhitespaceIndex=s;function i(x,he){return x<he?-1:x>he?1:0}e.compare=i;function r(x,he,we=0,Pe=x.length,Fe=0,He=he.length){for(;we<Pe&&Fe<He;we++,Fe++){let Ye=x.charCodeAt(we),at=he.charCodeAt(Fe);if(Ye<at)return-1;if(Ye>at)return 1}const Ze=Pe-we,Qe=He-Fe;return Ze<Qe?-1:Ze>Qe?1:0}e.compareSubstring=r;function c(x,he){return p(x,he,0,x.length,0,he.length)}e.compareIgnoreCase=c;function p(x,he,we=0,Pe=x.length,Fe=0,He=he.length){for(;we<Pe&&Fe<He;we++,Fe++){let Ye=x.charCodeAt(we),at=he.charCodeAt(Fe);if(Ye===at)continue;const ct=Ye-at;if(!(ct===32&&A(at))&&!(ct===-32&&A(Ye)))return v(Ye)&&v(at)?ct:r(x.toLowerCase(),he.toLowerCase(),we,Pe,Fe,He)}const Ze=Pe-we,Qe=He-Fe;return Ze<Qe?-1:Ze>Qe?1:0}e.compareSubstringIgnoreCase=p;function v(x){return x>=97&&x<=122}e.isLowerAsciiLetter=v;function A(x){return x>=65&&x<=90}e.isUpperAsciiLetter=A;function R(x){return v(x)||A(x)}function o(x,he){return x.length===he.length&&P(x,he)}e.equalsIgnoreCase=o;function P(x,he,we=x.length){for(let Pe=0;Pe<we;Pe++){const Fe=x.charCodeAt(Pe),He=he.charCodeAt(Pe);if(Fe!==He){if(R(Fe)&&R(He)){const Ze=Math.abs(Fe-He);if(Ze!==0&&Ze!==32)return!1}else if(String.fromCharCode(Fe).toLowerCase()!==String.fromCharCode(He).toLowerCase())return!1}}return!0}function N(x,he){const we=he.length;return he.length>x.length?!1:P(x,he,we)}e.startsWithIgnoreCase=N;function $(x,he){let we,Pe=Math.min(x.length,he.length);for(we=0;we<Pe;we++)if(x.charCodeAt(we)!==he.charCodeAt(we))return we;return Pe}e.commonPrefixLength=$;function ie(x,he){let we,Pe=Math.min(x.length,he.length);const Fe=x.length-1,He=he.length-1;for(we=0;we<Pe;we++)if(x.charCodeAt(Fe-we)!==he.charCodeAt(He-we))return we;return Pe}e.commonSuffixLength=ie;function ce(x){return 55296<=x&&x<=56319}e.isHighSurrogate=ce;function K(x){return 56320<=x&&x<=57343}e.isLowSurrogate=K;function H(x,he){return(x-55296<<10)+(he-56320)+65536}e.computeCodePoint=H;function z(x,he,we){const Pe=x.charCodeAt(we);if(ce(Pe)&&we+1<he){const Fe=x.charCodeAt(we+1);if(K(Fe))return H(Pe,Fe)}return Pe}e.getNextCodePoint=z;function T(x,he){const we=x.charCodeAt(he-1);if(K(we)&&he>1){const Pe=x.charCodeAt(he-2);if(ce(Pe))return H(Pe,we)}return we}function q(x,he){const we=Ce.getInstance(),Pe=he,Fe=x.length,He=z(x,Fe,he);he+=He>=65536?2:1;let Ze=we.getGraphemeBreakType(He);for(;he<Fe;){const Qe=z(x,Fe,he),Ye=we.getGraphemeBreakType(Qe);if(Ue(Ze,Ye))break;he+=Qe>=65536?2:1,Ze=Ye}return he-Pe}e.nextCharLength=q;function L(x,he){const we=Ce.getInstance(),Pe=he,Fe=T(x,he);he-=Fe>=65536?2:1;let He=we.getGraphemeBreakType(Fe);for(;he>0;){const Ze=T(x,he),Qe=we.getGraphemeBreakType(Ze);if(Ue(Qe,He))break;he-=Ze>=65536?2:1,He=Qe}return Pe-he}e.prevCharLength=L;function B(x,he){const we=Ce.getInstance(),Pe=x.length,Fe=he,He=z(x,Pe,he),Ze=we.getGraphemeBreakType(He);he+=He>=65536?2:1;let Qe=Ze;for(;he<Pe;){const at=z(x,Pe,he),ct=we.getGraphemeBreakType(at);if(Ue(Qe,ct))break;he+=at>=65536?2:1,Qe=ct}const Ye=he;for(he=Fe,Qe=Ze;he>0;){const at=T(x,he),ct=we.getGraphemeBreakType(at);if(Ue(ct,Qe))break;he-=at>=65536?2:1,Qe=ct}return[he,Ye]}function Y(x,he){return he>0&&K(x.charCodeAt(he))?B(x,he-1):B(x,he)}e.getCharContainingOffset=Y;function j(x){const he=x.length;let we=0,Pe=0;for(;Pe<he;){const Ze=z(x,he,Pe);Pe+=Ze>=65536?2:1,Ze<128?we+=1:Ze<2048?we+=2:Ze<65536?we+=3:we+=4}const Fe=new Uint8Array(we);Pe=0;let He=0;for(;Pe<he;){const Ze=z(x,he,Pe);Pe+=Ze>=65536?2:1,Ze<128?Fe[He++]=Ze:Ze<2048?(Fe[He++]=192|(Ze&1984)>>>6,Fe[He++]=128|(Ze&63)>>>0):Ze<65536?(Fe[He++]=224|(Ze&61440)>>>12,Fe[He++]=128|(Ze&4032)>>>6,Fe[He++]=128|(Ze&63)>>>0):(Fe[He++]=240|(Ze&1835008)>>>18,Fe[He++]=128|(Ze&258048)>>>12,Fe[He++]=128|(Ze&4032)>>>6,Fe[He++]=128|(Ze&63)>>>0)}return Fe}e.encodeUTF8=j;function se(x){const he=x.byteLength,we=[];let Pe=0;for(;Pe<he;){const Fe=x[Pe];let He;if(Fe>=240&&Pe+3<he?He=(x[Pe++]&7)<<18>>>0|(x[Pe++]&63)<<12>>>0|(x[Pe++]&63)<<6>>>0|(x[Pe++]&63)<<0>>>0:Fe>=224&&Pe+2<he?He=(x[Pe++]&15)<<12>>>0|(x[Pe++]&63)<<6>>>0|(x[Pe++]&63)<<0>>>0:Fe>=192&&Pe+1<he?He=(x[Pe++]&31)<<6>>>0|(x[Pe++]&63)<<0>>>0:He=x[Pe++],He>=0&&He<=55295||He>=57344&&He<=65535)we.push(String.fromCharCode(He));else if(He>=65536&&He<=1114111){const Ze=He-65536,Qe=55296+((Ze&1047552)>>>10),Ye=56320+((Ze&1023)>>>0);we.push(String.fromCharCode(Qe)),we.push(String.fromCharCode(Ye))}else we.push(String.fromCharCode(65533))}return we.join("")}e.decodeUTF8=se;const Se=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Re(x){return Se.test(x)}e.containsRTL=Re;const $e=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Ne(x){return $e.test(x)}e.containsEmoji=Ne;const Ge=/^[\t\n\r\x20-\x7E]*$/;function Ke(x){return Ge.test(x)}e.isBasicASCII=Ke,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function qe(x){return e.UNUSUAL_LINE_TERMINATORS.test(x)}e.containsUnusualLineTerminators=qe;function U(x){for(let he=0,we=x.length;he<we;he++)if(G(x.charCodeAt(he)))return!0;return!1}e.containsFullWidthCharacter=U;function G(x){return x=+x,x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}e.isFullWidthCharacter=G;function te(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129003||x>=129280&&x<=129535||x>=129648&&x<=129750}e.isEmojiImprecise=te;function re(x,he){if(x.length<he)return x;const we=/\b/g;let Pe=0;for(;we.test(x)&&!(x.length-we.lastIndex<he);)Pe=we.lastIndex,we.lastIndex+=1;return x.substring(Pe).replace(/^\s/,"")}e.lcut=re;const pe=/\x1B\x5B[12]?K/g,Q=/\x1b\[\d+m/g,ue=/\x1b\[0?m/g;function Ie(x){return x&&(x=x.replace(pe,""),x=x.replace(Q,""),x=x.replace(ue,"")),x}e.removeAnsiEscapeCodes=Ie,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function xe(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}e.startsWithUTF8BOM=xe;function We(x){return xe(x)?x.substr(1):x}e.stripUTF8BOM=We;function ve(x,he){if(!x||!he||x.length<he.length)return!1;const we=he.length,Pe=x.toLowerCase();let Fe=0,He=-1;for(;Fe<we;){const Ze=Pe.indexOf(he[Fe],He+1);if(Ze<0)return!1;He=Ze,Fe++}return!0}e.fuzzyContains=ve;function tt(x,he=!1){return x?(he&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}e.containsUppercaseCharacter=tt;function W(x){return x.charAt(0).toUpperCase()+x.slice(1)}e.uppercaseFirstLetter=W;function J(x,he=1){if(he===0)return"";let we=-1;do we=x.indexOf(`
`,we+1),he--;while(he>0&&we>=0);return we===-1?x:(x[we-1]==="\r"&&we--,x.substr(0,we))}e.getNLines=J;function fe(x){const he=90-65+1;return x=x%(2*he),x<he?String.fromCharCode(97+x):String.fromCharCode(65+x-he)}e.singleLetterHash=fe;function Oe(x){return Ce.getInstance().getGraphemeBreakType(x)}e.getGraphemeBreakType=Oe;function Ue(x,he){return x===0?he!==5&&he!==7:x===2&&he===3?!1:x===4||x===2||x===3||he===4||he===2||he===3?!0:!(x===8&&(he===8||he===9||he===11||he===12)||(x===11||x===9)&&(he===9||he===10)||(x===12||x===10)&&he===10||he===5||he===13||he===7||x===1||x===13&&he===14||x===6&&he===6)}e.breakBetweenGraphemeBreakType=Ue;var et;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})(et=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ce{constructor(){this._data=De()}static getInstance(){return Ce._INSTANCE||(Ce._INSTANCE=new Ce),Ce._INSTANCE}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const we=this._data,Pe=we.length/3;let Fe=1;for(;Fe<=Pe;)if(he<we[3*Fe])Fe=2*Fe;else if(he>we[3*Fe+1])Fe=2*Fe+1;else return we[3*Fe+2];return 0}}Ce._INSTANCE=null;function De(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Ae(x,he){if(x===0)return 0;const we=ne(x,he);if(we!==void 0)return we;const Pe=T(he,x);return x-=oe(Pe),x}e.getLeftDeleteOffset=Ae;function ne(x,he){let we=T(he,x);for(x-=oe(we);de(we)||we===65039||we===8419;){if(x===0)return;we=T(he,x),x-=oe(we)}if(!!te(we)){if(x>=0){const Pe=T(he,x);Pe===8205&&(x-=oe(Pe))}return x}}function oe(x){return x>=65536?2:1}function de(x){return 127995<=x&&x<=127999}var ge;(function(x){x[x.zwj=8205]="zwj",x[x.emojiVariantSelector=65039]="emojiVariantSelector",x[x.enclosingKeyCap=8419]="enclosingKeyCap"})(ge||(ge={}))}),define(_e[23],ye([0,1,8,110]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer!="undefined",y=typeof TextEncoder!="undefined",I=typeof TextDecoder!="undefined";let S,_;class C{constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}static alloc(v){return D?new C(Buffer.allocUnsafe(v)):new C(new Uint8Array(v))}static wrap(v){return D&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new C(v)}static fromString(v,A){return!(A?.dontUseNodeBuffer||!1)&&D?new C(Buffer.from(v)):y?(S||(S=new TextEncoder),new C(S.encode(v))):new C(m.encodeUTF8(v))}static concat(v,A){if(typeof A=="undefined"){A=0;for(let P=0,N=v.length;P<N;P++)A+=v[P].byteLength}const R=C.alloc(A);let o=0;for(let P=0,N=v.length;P<N;P++){const $=v[P];R.set($,o),o+=$.byteLength}return R}toString(){return D?this.buffer.toString():I?(_||(_=new TextDecoder),_.decode(this.buffer)):m.decodeUTF8(this.buffer)}slice(v,A){return new C(this.buffer.subarray(v,A))}set(v,A){v instanceof C?this.buffer.set(v.buffer,A):this.buffer.set(v,A)}readUInt32BE(v){return l(this.buffer,v)}writeUInt32BE(v,A){h(this.buffer,v,A)}readUInt32LE(v){return a(this.buffer,v)}writeUInt32LE(v,A){d(this.buffer,v,A)}readUInt8(v){return f(this.buffer,v)}writeUInt8(v,A){E(this.buffer,v,A)}}e.VSBuffer=C;function n(p,v){return p[v+0]<<0>>>0|p[v+1]<<8>>>0}e.readUInt16LE=n;function k(p,v,A){p[A+0]=v&255,v=v>>>8,p[A+1]=v&255}e.writeUInt16LE=k;function l(p,v){return p[v]*2**24+p[v+1]*2**16+p[v+2]*2**8+p[v+3]}e.readUInt32BE=l;function h(p,v,A){p[A+3]=v,v=v>>>8,p[A+2]=v,v=v>>>8,p[A+1]=v,v=v>>>8,p[A]=v}e.writeUInt32BE=h;function a(p,v){return p[v+0]<<0>>>0|p[v+1]<<8>>>0|p[v+2]<<16>>>0|p[v+3]<<24>>>0}e.readUInt32LE=a;function d(p,v,A){p[A+0]=v&255,v=v>>>8,p[A+1]=v&255,v=v>>>8,p[A+2]=v&255,v=v>>>8,p[A+3]=v&255}e.writeUInt32LE=d;function f(p,v){return p[v]}e.readUInt8=f;function E(p,v,A){p[A]=v}e.writeUInt8=E;function w(p){return F.consumeReadable(p,v=>C.concat(v))}e.readableToBuffer=w;function u(p){return F.toReadable(p)}e.bufferToReadable=u;function g(p){return F.consumeStream(p,v=>C.concat(v))}e.streamToBuffer=g;async function b(p){return p.ended?C.concat(p.buffer):C.concat([...p.buffer,await g(p.stream)])}e.bufferedStreamToBuffer=b;function t(p){return F.toStream(p,v=>C.concat(v))}e.bufferToStream=t;function s(p){return F.transform(p,{data:v=>typeof v=="string"?C.fromString(v):C.wrap(v)},v=>C.concat(v))}e.streamToBufferReadableStream=s;function i(p){return F.newWriteableStream(v=>C.concat(v),p)}e.newWriteableBufferStream=i;function r(p,v){return F.prefixedReadable(p,v,A=>C.concat(A))}e.prefixedBufferReadable=r;function c(p,v){return F.prefixedStream(p,v,A=>C.concat(A))}e.prefixedBufferStream=c}),define(_e[41],ye([0,1,8]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function F(E){return D(E,0)}e.hash=F;function D(E,w){switch(typeof E){case"object":return E===null?y(349,w):Array.isArray(E)?_(E,w):C(E,w);case"string":return S(E,w);case"boolean":return I(E,w);case"number":return y(E,w);case"undefined":return y(937,w);default:return y(617,w)}}e.doHash=D;function y(E,w){return(w<<5)-w+E|0}function I(E,w){return y(E?433:863,w)}function S(E,w){w=y(149417,w);for(let u=0,g=E.length;u<g;u++)w=y(E.charCodeAt(u),w);return w}e.stringHash=S;function _(E,w){return w=y(104579,w),E.reduce((u,g)=>D(g,u),w)}function C(E,w){return w=y(181387,w),Object.keys(E).sort().reduce((u,g)=>(u=S(g,u),D(E[g],u)),w)}class n{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=D(w,this._value),this._value}}e.Hasher=n;var k;(function(E){E[E.BLOCK_SIZE=64]="BLOCK_SIZE",E[E.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function l(E,w,u=32){const g=u-w,b=~((1<<g)-1);return(E<<w|(b&E)>>>g)>>>0}function h(E,w=0,u=E.byteLength,g=0){for(let b=0;b<u;b++)E[w+b]=g}function a(E,w,u="0"){for(;E.length<w;)E=u+E;return E}function d(E,w=32){return E instanceof ArrayBuffer?Array.from(new Uint8Array(E)).map(u=>u.toString(16).padStart(2,"0")).join(""):a((E>>>0).toString(16),w/4)}e.toHexString=d;class f{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const u=w.length;if(u===0)return;const g=this._buff;let b=this._buffLen,t=this._leftoverHighSurrogate,s,i;for(t!==0?(s=t,i=-1,t=0):(s=w.charCodeAt(0),i=0);;){let r=s;if(m.isHighSurrogate(s))if(i+1<u){const c=w.charCodeAt(i+1);m.isLowSurrogate(c)?(i++,r=m.computeCodePoint(s,c)):r=65533}else{t=s;break}else m.isLowSurrogate(s)&&(r=65533);if(b=this._push(g,b,r),i++,i<u)s=w.charCodeAt(i);else break}this._buffLen=b,this._leftoverHighSurrogate=t}_push(w,u,g){return g<128?w[u++]=g:g<2048?(w[u++]=192|(g&1984)>>>6,w[u++]=128|(g&63)>>>0):g<65536?(w[u++]=224|(g&61440)>>>12,w[u++]=128|(g&4032)>>>6,w[u++]=128|(g&63)>>>0):(w[u++]=240|(g&1835008)>>>18,w[u++]=128|(g&258048)>>>12,w[u++]=128|(g&4032)>>>6,w[u++]=128|(g&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=f._bigBlock32,u=this._buffDV;for(let v=0;v<64;v+=4)w.setUint32(v,u.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)w.setUint32(v,l(w.getUint32(v-12,!1)^w.getUint32(v-32,!1)^w.getUint32(v-56,!1)^w.getUint32(v-64,!1),1),!1);let g=this._h0,b=this._h1,t=this._h2,s=this._h3,i=this._h4,r,c,p;for(let v=0;v<80;v++)v<20?(r=b&t|~b&s,c=1518500249):v<40?(r=b^t^s,c=1859775393):v<60?(r=b&t|b&s|t&s,c=2400959708):(r=b^t^s,c=3395469782),p=l(g,5)+r+i+c+w.getUint32(v*4,!1)&4294967295,i=s,s=t,t=l(b,30),b=g,g=p;this._h0=this._h0+g&4294967295,this._h1=this._h1+b&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=f,f._bigBlock32=new DataView(new ArrayBuffer(320))}),define(_e[42],ye([0,1,8]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(F||(F={})),function(D){const y="error",I="warning",S="warn",_="info",C="ignore";function n(l){return l?m.equalsIgnoreCase(y,l)?D.Error:m.equalsIgnoreCase(I,l)||m.equalsIgnoreCase(S,l)?D.Warning:m.equalsIgnoreCase(_,l)?D.Info:D.Ignore:D.Ignore}D.fromValue=n;function k(l){switch(l){case D.Error:return y;case D.Warning:return I;case D.Info:return _;default:return C}}D.toString=k}(F||(F={})),e.default=F}),define(_e[10],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(v){return Array.isArray(v)}e.isArray=m;function F(v){return typeof v=="string"}e.isString=F;function D(v){return Array.isArray(v)&&v.every(A=>F(A))}e.isStringArray=D;function y(v){return typeof v=="object"&&v!==null&&!Array.isArray(v)&&!(v instanceof RegExp)&&!(v instanceof Date)}e.isObject=y;function I(v){return typeof v=="number"&&!isNaN(v)}e.isNumber=I;function S(v){return!!v&&typeof v[Symbol.iterator]=="function"}e.isIterable=S;function _(v){return v===!0||v===!1}e.isBoolean=_;function C(v){return typeof v=="undefined"}e.isUndefined=C;function n(v){return!k(v)}e.isDefined=n;function k(v){return C(v)||v===null}e.isUndefinedOrNull=k;function l(v,A){if(!v)throw new Error(A?`Unexpected type, expected '${A}'`:"Unexpected type")}e.assertType=l;function h(v){if(k(v))throw new Error("Assertion Failed: argument is undefined or null");return v}e.assertIsDefined=h;function a(...v){const A=[];for(let R=0;R<v.length;R++){const o=v[R];if(k(o))throw new Error(`Assertion Failed: argument at index ${R} is undefined or null`);A.push(o)}return A}e.assertAllDefined=a;const d=Object.prototype.hasOwnProperty;function f(v){if(!y(v))return!1;for(let A in v)if(d.call(v,A))return!1;return!0}e.isEmptyObject=f;function E(v){return typeof v=="function"}e.isFunction=E;function w(...v){return v.length>0&&v.every(E)}e.areFunctions=w;function u(v,A){const R=Math.min(v.length,A.length);for(let o=0;o<R;o++)g(v[o],A[o])}e.validateConstraints=u;function g(v,A){if(F(A)){if(typeof v!==A)throw new Error(`argument does not match constraint: typeof ${A}`)}else if(E(A)){try{if(v instanceof A)return}catch{}if(!k(v)&&v.constructor===A||A.length===1&&A.call(void 0,v)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=g;function b(v){let A=[],R=Object.getPrototypeOf(v);for(;Object.prototype!==R;)A=A.concat(Object.getOwnPropertyNames(R)),R=Object.getPrototypeOf(R);return A}e.getAllPropertyNames=b;function t(v){const A=[];for(const R of b(v))typeof v[R]=="function"&&A.push(R);return A}e.getAllMethodNames=t;function s(v,A){const R=P=>function(){const N=Array.prototype.slice.call(arguments,0);return A(P,N)};let o={};for(const P of v)o[P]=R(P);return o}e.createProxyObject=s;function i(v){return v===null?void 0:v}e.withNullAsUndefined=i;function r(v){return typeof v=="undefined"?null:v}e.withUndefinedAsNull=r;function c(v){return class{constructor(){return new Proxy({},{get(A,R){if(A[R])return A[R];throw new Error(`Not Implemented: ${v}->${String(R)}`)}})}}}e.NotImplementedProxy=c;function p(v,A="Unreachable"){throw new Error(A)}e.assertNever=p}),define(_e[43],ye([0,1,21,8,14,10]),function(ee,e,m,F,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function I(i){return i===47||i===92}e.isPathSeparator=I;function S(i){return i.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=S;function _(i){return i.indexOf("/")===-1&&(i=S(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=_;function C(i,r=D.posix.sep){if(!i)return"";const c=i.length,p=i.charCodeAt(0);if(I(p)){if(I(i.charCodeAt(1))&&!I(i.charCodeAt(2))){let A=3;const R=A;for(;A<c&&!I(i.charCodeAt(A));A++);if(R!==A&&!I(i.charCodeAt(A+1))){for(A+=1;A<c;A++)if(I(i.charCodeAt(A)))return i.slice(0,A+1).replace(/[\\/]/g,r)}}return r}else if(E(p)&&i.charCodeAt(1)===58)return I(i.charCodeAt(2))?i.slice(0,2)+r:i.slice(0,2);let v=i.indexOf("://");if(v!==-1){for(v+=3;v<c;v++)if(I(i.charCodeAt(v)))return i.slice(0,v+1)}return""}e.getRoot=C;function n(i){if(!m.isWindows||!i||i.length<5)return!1;let r=i.charCodeAt(0);if(r!==92||(r=i.charCodeAt(1),r!==92))return!1;let c=2;const p=c;for(;c<i.length&&(r=i.charCodeAt(c),r!==92);c++);return!(p===c||(r=i.charCodeAt(c+1),isNaN(r)||r===92))}e.isUNC=n;const k=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(i,r=m.isWindows){const c=r?k:l;return!(!i||i.length===0||/^\s+$/.test(i)||(c.lastIndex=0,c.test(i))||r&&h.test(i)||i==="."||i===".."||r&&i[i.length-1]==="."||r&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=a;function d(i,r,c){const p=i===r;return!c||p?p:!i||!r?!1:(0,F.equalsIgnoreCase)(i,r)}e.isEqual=d;function f(i,r,c,p=D.sep){if(i===r)return!0;if(!i||!r||r.length>i.length)return!1;if(c){if(!(0,F.startsWithIgnoreCase)(i,r))return!1;if(r.length===i.length)return!0;let A=r.length;return r.charAt(r.length-1)===p&&A--,i.charAt(A)===p}return r.charAt(r.length-1)!==p&&(r+=p),i.indexOf(r)===0}e.isEqualOrParent=f;function E(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=E;function w(i,r){return m.isWindows&&i.endsWith(":")&&(i+=D.sep),(0,D.isAbsolute)(i)||(i=(0,D.join)(r,i)),i=(0,D.normalize)(i),m.isWindows?(i=(0,F.rtrim)(i,D.sep),i.endsWith(":")&&(i+=D.sep)):(i=(0,F.rtrim)(i,D.sep),i||(i=D.sep)),i}e.sanitizeFilePath=w;function u(i){const r=(0,D.normalize)(i);return m.isWindows?i.length>3?!1:g(r)&&(i.length===2||r.charCodeAt(2)===92):r===D.posix.sep}e.isRootOrDriveLetter=u;function g(i){return m.isWindows?E(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=g;function b(i){return g(i)?i[0]:void 0}e.getDriveLetter=b;function t(i,r,c){return r.length>i.length?-1:i===r?0:(c&&(i=i.toLowerCase(),r=r.toLowerCase()),i.indexOf(r))}e.indexOfPath=t;function s(i){const r=i.split(":");let c,p,v;if(r.forEach(A=>{const R=Number(A);(0,y.isNumber)(R)?p===void 0?p=R:v===void 0&&(v=R):c=c?[c,A].join(":"):A}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:p!==void 0?p:void 0,column:v!==void 0?v:p!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(_e[24],ye([0,1,10]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function F(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const f=Array.isArray(d)?[]:{};return Object.keys(d).forEach(E=>{d[E]&&typeof d[E]=="object"?f[E]=F(d[E]):f[E]=d[E]}),f}e.deepClone=F;function D(d){if(!d||typeof d!="object")return d;const f=[d];for(;f.length>0;){const E=f.shift();Object.freeze(E);for(const w in E)if(y.call(E,w)){const u=E[w];typeof u=="object"&&!Object.isFrozen(u)&&f.push(u)}}return d}e.deepFreeze=D;const y=Object.prototype.hasOwnProperty;function I(d,f){return S(d,f,new Set)}e.cloneAndChange=I;function S(d,f,E){if((0,m.isUndefinedOrNull)(d))return d;const w=f(d);if(typeof w!="undefined")return w;if((0,m.isArray)(d)){const u=[];for(const g of d)u.push(S(g,f,E));return u}if((0,m.isObject)(d)){if(E.has(d))throw new Error("Cannot clone recursive data-structure");E.add(d);const u={};for(let g in d)y.call(d,g)&&(u[g]=S(d[g],f,E));return E.delete(d),u}return d}function _(d,f,E=!0){return(0,m.isObject)(d)?((0,m.isObject)(f)&&Object.keys(f).forEach(w=>{w in d?E&&((0,m.isObject)(d[w])&&(0,m.isObject)(f[w])?_(d[w],f[w],E):d[w]=f[w]):d[w]=f[w]}),d):f}e.mixin=_;function C(d,f){if(d===f)return!0;if(d==null||f===null||f===void 0||typeof d!=typeof f||typeof d!="object"||Array.isArray(d)!==Array.isArray(f))return!1;let E,w;if(Array.isArray(d)){if(d.length!==f.length)return!1;for(E=0;E<d.length;E++)if(!C(d[E],f[E]))return!1}else{const u=[];for(w in d)u.push(w);u.sort();const g=[];for(w in f)g.push(w);if(g.sort(),!C(u,g))return!1;for(E=0;E<u.length;E++)if(!C(d[u[E]],f[u[E]]))return!1}return!0}e.equals=C;function n(d){const f=new Set;return JSON.stringify(d,(E,w)=>{if((0,m.isObject)(w)||Array.isArray(w)){if(f.has(w))return"[Circular]";f.add(w)}return w})}e.safeStringify=n;function k(d,f,E){const w=f(d);return typeof w=="undefined"?E:w}e.getOrDefault=k;function l(d,f){const E=Object.create(null);return!d||!f||Object.keys(f).forEach(u=>{const g=d[u],b=f[u];C(g,b)||(E[u]=b)}),E}e.distinct=l;function h(d,f){const E=f.toLowerCase(),w=Object.keys(d).find(u=>u.toLowerCase()===E);return w?d[w]:d[f]}e.getCaseInsensitive=h;function a(d,f){const E=Object.create(null);for(const w of Object.keys(d))f(w,d[w])&&(E[w]=d[w]);return E}e.filter=a}),define(_e[80],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var m;(function(y){y[y.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",y[y.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",y[y.MAX_UINT_8=255]="MAX_UINT_8",y[y.MAX_UINT_16=65535]="MAX_UINT_16",y[y.MAX_UINT_32=4294967295]="MAX_UINT_32",y[y.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(m=e.Constants||(e.Constants={}));function F(y){return y<0?0:y>255?255:y|0}e.toUint8=F;function D(y){return y<0?0:y>4294967295?4294967295:y|0}e.toUint32=D}),define(_e[2],ye([0,1,21,14]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,y=/^\//,I=/^\/\//;function S(i,r){if(!i.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!D.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!y.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function _(i,r){return!i&&!r?"file":i}function C(i,r){switch(i){case"https":case"http":case"file":r?r[0]!==k&&(r=k+r):r=k;break}return r}const n="",k="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{constructor(r,c,p,v,A,R=!1){typeof r=="object"?(this.scheme=r.scheme||n,this.authority=r.authority||n,this.path=r.path||n,this.query=r.query||n,this.fragment=r.fragment||n):(this.scheme=_(r,R),this.authority=c||n,this.path=C(this.scheme,p||n),this.query=v||n,this.fragment=A||n,S(this,R))}static isUri(r){return r instanceof h?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return u(this,!1)}with(r){if(!r)return this;let{scheme:c,authority:p,path:v,query:A,fragment:R}=r;return c===void 0?c=this.scheme:c===null&&(c=n),p===void 0?p=this.authority:p===null&&(p=n),v===void 0?v=this.path:v===null&&(v=n),A===void 0?A=this.query:A===null&&(A=n),R===void 0?R=this.fragment:R===null&&(R=n),c===this.scheme&&p===this.authority&&v===this.path&&A===this.query&&R===this.fragment?this:new d(c,p,v,A,R)}static parse(r,c=!1){const p=l.exec(r);return p?new d(p[2]||n,s(p[4]||n),s(p[5]||n),s(p[7]||n),s(p[9]||n),c):new d(n,n,n,n,n)}static file(r){let c=n;if(m.isWindows&&(r=r.replace(/\\/g,k)),r[0]===k&&r[1]===k){const p=r.indexOf(k,2);p===-1?(c=r.substring(2),r=k):(c=r.substring(2,p),r=r.substring(p)||k)}return new d("file",c,r,n,n)}static from(r){const c=new d(r.scheme,r.authority,r.path,r.query,r.fragment);return S(c,!0),c}static joinPath(r,...c){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return m.isWindows&&r.scheme==="file"?p=h.file(F.win32.join(u(r,!0),...c)).path:p=F.posix.join(r.path,...c),r.with({path:p})}toString(r=!1){return g(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof h)return r;{const c=new d(r);return c._formatted=r.external,c._fsPath=r._sep===a?r.fsPath:null,c}}else return r}}e.URI=h;const a=m.isWindows?1:void 0;class d extends h{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(r=!1){return r?g(this,!0):(this._formatted||(this._formatted=g(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=a),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function E(i,r){let c,p=-1;for(let v=0;v<i.length;v++){const A=i.charCodeAt(v);if(A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57||A===45||A===46||A===95||A===126||r&&A===47)p!==-1&&(c+=encodeURIComponent(i.substring(p,v)),p=-1),c!==void 0&&(c+=i.charAt(v));else{c===void 0&&(c=i.substr(0,v));const R=f[A];R!==void 0?(p!==-1&&(c+=encodeURIComponent(i.substring(p,v)),p=-1),c+=R):p===-1&&(p=v)}}return p!==-1&&(c+=encodeURIComponent(i.substring(p))),c!==void 0?c:i}function w(i){let r;for(let c=0;c<i.length;c++){const p=i.charCodeAt(c);p===35||p===63?(r===void 0&&(r=i.substr(0,c)),r+=f[p]):r!==void 0&&(r+=i[c])}return r!==void 0?r:i}function u(i,r){let c;return i.authority&&i.path.length>1&&i.scheme==="file"?c=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?r?c=i.path.substr(1):c=i.path[1].toLowerCase()+i.path.substr(2):c=i.path,m.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=u;function g(i,r){const c=r?w:E;let p="",{scheme:v,authority:A,path:R,query:o,fragment:P}=i;if(v&&(p+=v,p+=":"),(A||v==="file")&&(p+=k,p+=k),A){let N=A.indexOf("@");if(N!==-1){const $=A.substr(0,N);A=A.substr(N+1),N=$.indexOf(":"),N===-1?p+=c($,!1):(p+=c($.substr(0,N),!1),p+=":",p+=c($.substr(N+1),!1)),p+="@"}A=A.toLowerCase(),N=A.indexOf(":"),N===-1?p+=c(A,!1):(p+=c(A.substr(0,N),!1),p+=A.substr(N))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const N=R.charCodeAt(1);N>=65&&N<=90&&(R=`/${String.fromCharCode(N+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const N=R.charCodeAt(0);N>=65&&N<=90&&(R=`${String.fromCharCode(N+32)}:${R.substr(2)}`)}p+=c(R,!0)}return o&&(p+="?",p+=c(o,!1)),P&&(p+="#",p+=r?P:E(P,!1)),p}function b(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+b(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(i){return i.match(t)?i.replace(t,r=>b(r)):i}});var nt=this&&this.__classPrivateFieldSet||function(ee,e,m,F,D){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?D.call(ee,m):D?D.value=m:e.set(ee,m),m},Le=this&&this.__classPrivateFieldGet||function(ee,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(ee):F?F.value:e.get(ee)};define(_e[22],ye([0,1,2,8]),function(ee,e,m,F){"use strict";var D,y,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(t,s,i){let r=t.get(s);return r===void 0&&(r=i,t.set(s,r)),r}e.getOrSet=S;function _(t){const s=[];return t.forEach((i,r)=>{s.push(`${r} => ${i}`)}),`Map(${t.size}) {${s.join(", ")}}`}e.mapToString=_;function C(t){const s=[];return t.forEach(i=>{s.push(i)}),`Set(${t.size}) {${s.join(", ")}}`}e.setToString=C;class n{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const i=s.charCodeAt(0),r=this._value.charCodeAt(this._pos);return i-r}value(){return this._value[this._pos]}}e.StringIterator=n;class k{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,F.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=k;class l{constructor(s=!0,i=!0){this._splitOnBackslash=s,this._caseSensitive=i}reset(s){return this._value=s.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,F.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=l;var h;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(h||(h={}));class a{constructor(s){this._ignorePathCasing=s,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,F.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,F.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,F.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,F.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=a;class d{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class f{constructor(s){this._iter=s}static forUris(s=()=>!1){return new f(new a(s))}static forPaths(){return new f(new l)}static forStrings(){return new f(new n)}static forConfigKeys(){return new f(new k)}clear(){this._root=void 0}set(s,i){const r=this._iter.reset(s);let c;for(this._root||(this._root=new d,this._root.segment=r.value()),c=this._root;;){const v=r.cmp(c.segment);if(v>0)c.left||(c.left=new d,c.left.segment=r.value()),c=c.left;else if(v<0)c.right||(c.right=new d,c.right.segment=r.value()),c=c.right;else if(r.hasNext())r.next(),c.mid||(c.mid=new d,c.mid.segment=r.value()),c=c.mid;else break}const p=c.value;return c.value=i,c.key=s,p}get(s){return this._getNode(s)?.value}_getNode(s){const i=this._iter.reset(s);let r=this._root;for(;r;){const c=i.cmp(r.segment);if(c>0)r=r.left;else if(c<0)r=r.right;else if(i.hasNext())i.next(),r=r.mid;else break}return r}has(s){const i=this._getNode(s);return!(i?.value===void 0&&i?.mid===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,i){const r=this._iter.reset(s),c=[];let p=this._root;for(;p;){const v=r.cmp(p.segment);if(v>0)c.push([1,p]),p=p.left;else if(v<0)c.push([-1,p]),p=p.right;else if(r.hasNext())r.next(),c.push([0,p]),p=p.mid;else{for(i?(p.left=void 0,p.mid=void 0,p.right=void 0):p.value=void 0;c.length>0&&p.isEmpty();){let[A,R]=c.pop();switch(A){case 1:R.left=void 0;break;case 0:R.mid=void 0;break;case-1:R.right=void 0;break}p=R}break}}}findSubstr(s){const i=this._iter.reset(s);let r=this._root,c;for(;r;){const p=i.cmp(r.segment);if(p>0)r=r.left;else if(p<0)r=r.right;else if(i.hasNext())i.next(),c=r.value||c,r=r.mid;else break}return r&&r.value||c}findSuperstr(s){const i=this._iter.reset(s);let r=this._root;for(;r;){const c=i.cmp(r.segment);if(c>0)r=r.left;else if(c<0)r=r.right;else if(i.hasNext())i.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(s){for(const[i,r]of this)s(r,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){if(!s)return;const i=[s];for(;i.length>0;){const r=i.pop();r&&(r.value&&(yield[r.key,r.value]),r.left&&i.push(r.left),r.mid&&i.push(r.mid),r.right&&i.push(r.right))}}}e.TernarySearchTree=f;class E{constructor(s,i){this[D]="ResourceMap",s instanceof E?(this.map=new Map(s.map),this.toKey=i??E.defaultToKey):(this.map=new Map,this.toKey=s??E.defaultToKey)}set(s,i){return this.map.set(this.toKey(s),i),this}get(s){return this.map.get(this.toKey(s))}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,i){typeof i!="undefined"&&(s=s.bind(i));for(let[r,c]of this.map)s(c,m.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let s of this.map.keys())yield m.URI.parse(s)}*entries(){for(let s of this.map.entries())yield[m.URI.parse(s[0]),s[1]]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let s of this.map)yield[m.URI.parse(s[0]),s[1]]}}e.ResourceMap=E,E.defaultToKey=t=>t.toString();var w;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class u{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,i=0){const r=this._map.get(s);if(!!r)return i!==0&&this.touch(r,i),r.value}set(s,i,r=0){let c=this._map.get(s);if(c)c.value=i,r!==0&&this.touch(c,r);else{switch(c={key:s,value:i,next:void 0,previous:void 0},r){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(s,c),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const i=this._map.get(s);if(!!i)return this._map.delete(s),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,i){const r=this._state;let c=this._head;for(;c;){if(i?s.bind(i)(c.value,c.key,this):s(c.value,c.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const s=this,i=this._state;let r=this._head;const c={[Symbol.iterator](){return c},next(){if(s._state!==i)throw new Error("LinkedMap got modified during iteration.");if(r){const p={value:r.key,done:!1};return r=r.next,p}else return{value:void 0,done:!0}}};return c}values(){const s=this,i=this._state;let r=this._head;const c={[Symbol.iterator](){return c},next(){if(s._state!==i)throw new Error("LinkedMap got modified during iteration.");if(r){const p={value:r.value,done:!1};return r=r.next,p}else return{value:void 0,done:!0}}};return c}entries(){const s=this,i=this._state;let r=this._head;const c={[Symbol.iterator](){return c},next(){if(s._state!==i)throw new Error("LinkedMap got modified during iteration.");if(r){const p={value:[r.key,r.value],done:!1};return r=r.next,p}else return{value:void 0,done:!0}}};return c}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let i=this._head,r=this.size;for(;i&&r>s;)this._map.delete(i.key),i=i.next,r--;this._head=i,this._size=r,i&&(i.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const i=s.next,r=s.previous;if(!i||!r)throw new Error("Invalid list");i.previous=r,r.next=i}s.next=void 0,s.previous=void 0,this._state++}touch(s,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(s===this._head)return;const r=s.next,c=s.previous;s===this._tail?(c.next=void 0,this._tail=c):(r.previous=c,c.next=r),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(i===2){if(s===this._tail)return;const r=s.next,c=s.previous;s===this._head?(r.previous=void 0,this._head=r):(r.previous=c,c.next=r),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((i,r)=>{s.push([r,i])}),s}fromJSON(s){this.clear();for(const[i,r]of s)this.set(i,r)}}e.LinkedMap=u;class g extends u{constructor(s,i=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,i=2){return super.get(s,i)}peek(s){return super.get(s,0)}set(s,i){return super.set(s,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=g;class b{constructor(s){I.set(this,void 0),nt(this,I,s,"f")}get size(){return Le(this,I,"f").size}forEach(s,i){Le(this,I,"f").forEach(s,i)}get(s){return Le(this,I,"f").get(s)}has(s){return Le(this,I,"f").has(s)}entries(){return Le(this,I,"f").entries()}keys(){return Le(this,I,"f").keys()}values(){return Le(this,I,"f").values()}[(I=new WeakMap,Symbol.iterator)](){return Le(this,I,"f").entries()}}e.ReadonlyMapView=b}),define(_e[111],ye([0,1,22,8]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...Q){return function(ue,Ie){for(let xe=0,We=Q.length;xe<We;xe++){const ve=Q[xe](ue,Ie);if(ve)return ve}return null}}e.or=D,e.matchesStrictPrefix=y.bind(void 0,!1),e.matchesPrefix=y.bind(void 0,!0);function y(Q,ue,Ie){if(!Ie||Ie.length<ue.length)return null;let xe;return Q?xe=F.startsWithIgnoreCase(Ie,ue):xe=Ie.indexOf(ue)===0,xe?ue.length>0?[{start:0,end:ue.length}]:[]:null}function I(Q,ue){const Ie=ue.toLowerCase().indexOf(Q.toLowerCase());return Ie===-1?null:[{start:Ie,end:Ie+Q.length}]}e.matchesContiguousSubString=I;function S(Q,ue){return _(Q.toLowerCase(),ue.toLowerCase(),0,0)}e.matchesSubString=S;function _(Q,ue,Ie,xe){if(Ie===Q.length)return[];if(xe===ue.length)return null;if(Q[Ie]===ue[xe]){let We=null;return(We=_(Q,ue,Ie+1,xe+1))?E({start:xe,end:xe+1},We):null}return _(Q,ue,Ie,xe+1)}function C(Q){return 97<=Q&&Q<=122}function n(Q){return 65<=Q&&Q<=90}e.isUpper=n;function k(Q){return 48<=Q&&Q<=57}function l(Q){return Q===32||Q===9||Q===10||Q===13}const h=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(Q=>h.add(Q.charCodeAt(0)));function a(Q){return l(Q)||h.has(Q)}function d(Q,ue){return Q===ue||a(Q)&&a(ue)}function f(Q){return C(Q)||n(Q)||k(Q)}function E(Q,ue){return ue.length===0?ue=[Q]:Q.end===ue[0].start?ue[0].start=Q.start:ue.unshift(Q),ue}function w(Q,ue){for(let Ie=ue;Ie<Q.length;Ie++){const xe=Q.charCodeAt(Ie);if(n(xe)||k(xe)||Ie>0&&!f(Q.charCodeAt(Ie-1)))return Ie}return Q.length}function u(Q,ue,Ie,xe){if(Ie===Q.length)return[];if(xe===ue.length)return null;if(Q[Ie]!==ue[xe].toLowerCase())return null;{let We=null,ve=xe+1;for(We=u(Q,ue,Ie+1,xe+1);!We&&(ve=w(ue,ve))<ue.length;)We=u(Q,ue,Ie+1,ve),ve++;return We===null?null:E({start:xe,end:xe+1},We)}}function g(Q){let ue=0,Ie=0,xe=0,We=0,ve=0;for(let Oe=0;Oe<Q.length;Oe++)ve=Q.charCodeAt(Oe),n(ve)&&ue++,C(ve)&&Ie++,f(ve)&&xe++,k(ve)&&We++;const tt=ue/Q.length,W=Ie/Q.length,J=xe/Q.length,fe=We/Q.length;return{upperPercent:tt,lowerPercent:W,alphaPercent:J,numericPercent:fe}}function b(Q){const{upperPercent:ue,lowerPercent:Ie}=Q;return Ie===0&&ue>.6}function t(Q){const{upperPercent:ue,lowerPercent:Ie,alphaPercent:xe,numericPercent:We}=Q;return Ie>.2&&ue<.8&&xe>.6&&We<.2}function s(Q){let ue=0,Ie=0,xe=0,We=0;for(let ve=0;ve<Q.length;ve++)xe=Q.charCodeAt(ve),n(xe)&&ue++,C(xe)&&Ie++,l(xe)&&We++;return(ue===0||Ie===0)&&We===0?Q.length<=30:ue<=5}function i(Q,ue){if(!ue||(ue=ue.trim(),ue.length===0)||!s(Q)||ue.length>60)return null;const Ie=g(ue);if(!t(Ie)){if(!b(Ie))return null;ue=ue.toLowerCase()}let xe=null,We=0;for(Q=Q.toLowerCase();We<ue.length&&(xe=u(Q,ue,0,We))===null;)We=w(ue,We+1);return xe}e.matchesCamelCase=i;function r(Q,ue,Ie=!1){if(!ue||ue.length===0)return null;let xe=null,We=0;for(Q=Q.toLowerCase(),ue=ue.toLowerCase();We<ue.length&&(xe=c(Q,ue,0,We,Ie))===null;)We=p(ue,We+1);return xe}e.matchesWords=r;function c(Q,ue,Ie,xe,We){if(Ie===Q.length)return[];if(xe===ue.length)return null;if(d(Q.charCodeAt(Ie),ue.charCodeAt(xe))){let ve=null,tt=xe+1;if(ve=c(Q,ue,Ie+1,xe+1,We),!We)for(;!ve&&(tt=p(ue,tt))<ue.length;)ve=c(Q,ue,Ie+1,tt,We),tt++;return ve===null?null:E({start:xe,end:xe+1},ve)}else return null}function p(Q,ue){for(let Ie=ue;Ie<Q.length;Ie++)if(a(Q.charCodeAt(Ie))||Ie>0&&a(Q.charCodeAt(Ie-1)))return Ie;return Q.length}const v=D(e.matchesPrefix,i,I),A=D(e.matchesPrefix,i,S),R=new m.LRUCache(1e4);function o(Q,ue,Ie=!1){if(typeof Q!="string"||typeof ue!="string")return null;let xe=R.get(Q);xe||(xe=new RegExp(F.convertSimple2RegExpPattern(Q),"i"),R.set(Q,xe));const We=xe.exec(ue);return We?[{start:We.index,end:We.index+We[0].length}]:Ie?A(Q,ue):v(Q,ue)}e.matchesFuzzy=o;function P(Q,ue){const Ie=Ke(Q,Q.toLowerCase(),0,ue,ue.toLowerCase(),0,!0);return Ie?$(Ie):null}e.matchesFuzzy2=P;function N(Q,ue,Ie,xe,We,ve){const tt=Math.min(13,Q.length);for(;Ie<tt;Ie++){const W=Ke(Q,ue,Ie,xe,We,ve,!1);if(W)return W}return[0,ve]}e.anyScore=N;function $(Q){if(typeof Q=="undefined")return[];const ue=[],Ie=Q[1];for(let xe=Q.length-1;xe>1;xe--){const We=Q[xe]+Ie,ve=ue[ue.length-1];ve&&ve.end===We?ve.end=We+1:ue.push({start:We,end:We+1})}return ue}e.createMatches=$;const ie=128;function ce(){const Q=[],ue=[];for(let Ie=0;Ie<=ie;Ie++)ue[Ie]=0;for(let Ie=0;Ie<=ie;Ie++)Q.push(ue.slice(0));return Q}function K(Q){const ue=[];for(let Ie=0;Ie<=Q;Ie++)ue[Ie]=0;return ue}const H=K(2*ie),z=K(2*ie),T=ce(),q=ce(),L=ce(),B=!1;function Y(Q,ue,Ie,xe,We){function ve(W,J,fe=" "){for(;W.length<J;)W=fe+W;return W}let tt=` |   |${xe.split("").map(W=>ve(W,3)).join("|")}
`;for(let W=0;W<=Ie;W++)W===0?tt+=" |":tt+=`${ue[W-1]}|`,tt+=Q[W].slice(0,We+1).map(J=>ve(J.toString(),3)).join("|")+`
`;return tt}function j(Q,ue,Ie,xe){Q=Q.substr(ue),Ie=Ie.substr(xe),console.log(Y(q,Q,Q.length,Ie,Ie.length)),console.log(Y(L,Q,Q.length,Ie,Ie.length)),console.log(Y(T,Q,Q.length,Ie,Ie.length))}function se(Q,ue){if(ue<0||ue>=Q.length)return!1;const Ie=Q.codePointAt(ue);switch(Ie){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!F.isEmojiImprecise(Ie)}}function Se(Q,ue){if(ue<0||ue>=Q.length)return!1;switch(Q.charCodeAt(ue)){case 32:case 9:return!0;default:return!1}}function Re(Q,ue,Ie){return ue[Q]!==Ie[Q]}function $e(Q,ue,Ie,xe,We,ve,tt=!1){for(;ue<Ie&&We<ve;)Q[ue]===xe[We]&&(tt&&(H[ue]=We),ue+=1),We+=1;return ue===Ie}e.isPatternInWord=$e;var Ne;(function(Q){Q[Q.Diag=1]="Diag",Q[Q.Left=2]="Left",Q[Q.LeftLeft=3]="LeftLeft"})(Ne||(Ne={}));var Ge;(function(Q){Q.Default=[-100,0];function ue(Ie){return!Ie||Ie.length===2&&Ie[0]===-100&&Ie[1]===0}Q.isDefault=ue})(Ge=e.FuzzyScore||(e.FuzzyScore={}));function Ke(Q,ue,Ie,xe,We,ve,tt){const W=Q.length>ie?ie:Q.length,J=xe.length>ie?ie:xe.length;if(Ie>=W||ve>=J||W-Ie>J-ve||!$e(ue,Ie,W,We,ve,J,!0))return;qe(W,J,Ie,ve,ue,We);let fe=1,Oe=1,Ue=Ie,et=ve;const Ce=[!1];for(fe=1,Ue=Ie;Ue<W;fe++,Ue++){const de=H[Ue],ge=z[Ue],x=Ue+1<W?z[Ue+1]:J;for(Oe=de-ve+1,et=de;et<x;Oe++,et++){let he=Number.MIN_SAFE_INTEGER,we=!1;et<=ge&&(he=U(Q,ue,Ue,Ie,xe,We,et,J,ve,T[fe-1][Oe-1]===0,Ce));let Pe=0;he!==Number.MAX_SAFE_INTEGER&&(we=!0,Pe=he+q[fe-1][Oe-1]);const Fe=et>de,He=Fe?q[fe][Oe-1]+(T[fe][Oe-1]>0?-5:0):0,Ze=et>de+1&&T[fe][Oe-1]>0,Qe=Ze?q[fe][Oe-2]+(T[fe][Oe-2]>0?-5:0):0;if(Ze&&(!Fe||Qe>=He)&&(!we||Qe>=Pe))q[fe][Oe]=Qe,L[fe][Oe]=3,T[fe][Oe]=0;else if(Fe&&(!we||He>=Pe))q[fe][Oe]=He,L[fe][Oe]=2,T[fe][Oe]=0;else if(we)q[fe][Oe]=Pe,L[fe][Oe]=1,T[fe][Oe]=T[fe-1][Oe-1]+1;else throw new Error("not possible")}}if(B&&j(Q,Ie,xe,ve),!Ce[0]&&!tt)return;fe--,Oe--;const De=[q[fe][Oe],ve];let Ae=0,ne=0;for(;fe>=1;){let de=Oe;do{const ge=L[fe][de];if(ge===3)de=de-2;else if(ge===2)de=de-1;else break}while(de>=1);Ae>1&&ue[Ie+fe-1]===We[ve+Oe-1]&&!Re(de+ve-1,xe,We)&&Ae+1>T[fe][de]&&(de=Oe),de===Oe?Ae++:Ae=1,ne||(ne=de),fe--,Oe=de-1,De.push(Oe)}J===W&&(De[0]+=2);const oe=ne-W;return De[0]-=oe,De}e.fuzzyScore=Ke;function qe(Q,ue,Ie,xe,We,ve){let tt=Q-1,W=ue-1;for(;tt>=Ie&&W>=xe;)We[tt]===ve[W]&&(z[tt]=W,tt--),W--}function U(Q,ue,Ie,xe,We,ve,tt,W,J,fe,Oe){if(ue[Ie]!==ve[tt])return Number.MIN_SAFE_INTEGER;let Ue=1,et=!1;return tt===Ie-xe?Ue=Q[Ie]===We[tt]?7:5:Re(tt,We,ve)&&(tt===0||!Re(tt-1,We,ve))?(Ue=Q[Ie]===We[tt]?7:5,et=!0):se(ve,tt)&&(tt===0||!se(ve,tt-1))?Ue=5:(se(ve,tt-1)||Se(ve,tt-1))&&(Ue=5,et=!0),Ue>1&&Ie===xe&&(Oe[0]=!0),et||(et=Re(tt,We,ve)||se(ve,tt-1)||Se(ve,tt-1)),Ie===xe?tt>J&&(Ue-=et?3:5):fe?Ue+=et?2:0:Ue+=et?0:1,tt+1===W&&(Ue-=et?3:5),Ue}function G(Q,ue,Ie,xe,We,ve,tt){return re(Q,ue,Ie,xe,We,ve,!0,tt)}e.fuzzyScoreGracefulAggressive=G;function te(Q,ue,Ie,xe,We,ve,tt){return re(Q,ue,Ie,xe,We,ve,!1,tt)}e.fuzzyScoreGraceful=te;function re(Q,ue,Ie,xe,We,ve,tt,W){let J=Ke(Q,ue,Ie,xe,We,ve,W);if(J&&!tt)return J;if(Q.length>=3){const fe=Math.min(7,Q.length-1);for(let Oe=Ie+1;Oe<fe;Oe++){const Ue=pe(Q,Oe);if(Ue){const et=Ke(Ue,Ue.toLowerCase(),Ie,xe,We,ve,W);et&&(et[0]-=3,(!J||et[0]>J[0])&&(J=et))}}}return J}function pe(Q,ue){if(ue+1>=Q.length)return;const Ie=Q[ue],xe=Q[ue+1];if(Ie!==xe)return Q.slice(0,ue)+xe+Ie+Q.slice(ue+2)}}),define(_e[112],ye([0,1,53,111,8]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const y=new RegExp(`\\$\\(${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?\\)`,"g"),I=new RegExp(`(\\\\)?${y.source}`,"g");function S(d){return d.replace(I,(f,E)=>E?f:`\\${f}`)}e.escapeIcons=S;const _=new RegExp(`\\\\${y.source}`,"g");function C(d){return d.replace(_,f=>`\\${f}`)}e.markdownEscapeEscapedIcons=C;const n=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function k(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(n,(f,E,w,u)=>w?f:E||u||"")}e.stripIcons=k;function l(d){const f=d.indexOf(e.iconStartMarker);return f===-1?{text:d}:h(d,f)}e.parseLabelWithIcons=l;function h(d,f){const E=[];let w="";function u(p){if(p){w+=p;for(const v of p)E.push(t)}}let g=-1,b="",t=0,s,i,r=f;const c=d.length;for(u(d.substr(0,f));r<c;)s=d[r],i=d[r+1],s===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(g=r,u(b),b=e.iconStartMarker,r++):s===")"&&g!==-1?(t+=r-g+1,g=-1,b=""):g!==-1?/^[a-z0-9\-]$/i.test(s)?b+=s:(u(b),g=-1,b=""):u(s),r++;return u(b),{text:w,iconOffsets:E}}function a(d,f,E=!1){const{text:w,iconOffsets:u}=f;if(!u||u.length===0)return(0,F.matchesFuzzy)(d,w,E);const g=(0,D.ltrim)(w," "),b=w.length-g.length,t=(0,F.matchesFuzzy)(d,g,E);if(t)for(const s of t){const i=u[s.start+b]+b;s.start+=i,s.end+=i}return t}e.matchesFuzzyIconAware=a}),define(_e[81],ye([0,1,112,12]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var D;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(D=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(h="",a=!1){if(this.value=h,typeof this.value!="string")throw(0,F.illegalArgument)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1)}appendText(h,a=0){return this.value+=C(this.supportThemeIcons?(0,m.escapeIcons)(h):h).replace(/([ \t]+)/g,(d,f)=>"&nbsp;".repeat(f.length)).replace(/^>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,a){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=a,this.value+="\n```\n",this}}e.MarkdownString=y;function I(l){return S(l)?!l.value:Array.isArray(l)?l.every(I):!0}e.isEmptyMarkdownString=I;function S(l){return l instanceof y?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=S;function _(l,h){return l===h?!0:!l||!h?!1:l.value===h.value&&l.isTrusted===h.isTrusted&&l.supportThemeIcons===h.supportThemeIcons}e.markdownStringEqual=_;function C(l){return l.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function n(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function k(l){const h=[],a=l.split("|").map(f=>f.trim());l=a[0];const d=a[1];if(d){const f=/height=(\d+)/.exec(d),E=/width=(\d+)/.exec(d),w=f?f[1]:"",u=E?E[1]:"",g=isFinite(parseInt(u)),b=isFinite(parseInt(w));g&&h.push(`width="${u}"`),b&&h.push(`height="${w}"`)}return{href:l,dimensions:h}}e.parseHrefAndDimensions=k}),define(_e[54],ye([0,1,23,8,2]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function y(n){return JSON.stringify(n,_)}e.stringify=y;function I(n){let k=JSON.parse(n);return k=C(k),k}e.parse=I;var S;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(S=e.MarshalledId||(e.MarshalledId={}));function _(n,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:(0,F.regExpFlags)(k)}:k}function C(n,k=0){if(!n||k>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return D.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof m.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let l=0;l<n.length;++l)n[l]=C(n[l],k+1);else for(const l in n)Object.hasOwnProperty.call(n,l)&&(n[l]=C(n[l],k+1))}return n}e.revive=C}),define(_e[11],ye([0,1,2,21]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.userData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp"})(D=e.Schemas||(e.Schemas={}));class y{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(_){this._preferredWebSchema=_}setDelegate(_){this._delegate=_}set(_,C,n){this._hosts[_]=C,this._ports[_]=n}setConnectionToken(_,C){this._connectionTokens[_]=C}rewrite(_){if(this._delegate)return this._delegate(_);const C=_.authority;let n=this._hosts[C];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const k=this._ports[C],l=this._connectionTokens[C];let h=`path=${encodeURIComponent(_.path)}`;return typeof l=="string"&&(h+=`&tkn=${encodeURIComponent(l)}`),m.URI.from({scheme:F.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${n}:${k}`,path:"/vscode-remote-resource",query:h})}}e.RemoteAuthorities=new y;class I{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(_,C,n){const k=this.toUri(_,C);if(k.scheme===D.vscodeRemote)return e.RemoteAuthorities.rewrite(k);let l=!1;return F.isNative&&(n||F.isPreferringBrowserCodeLoad)&&k.scheme===D.file&&(l=!0),k.scheme===D.file&&typeof F.globals.importScripts=="function"&&F.globals.origin==="vscode-file://vscode-app"&&(l=!0),l?k.with({scheme:D.vscodeFileResource,authority:k.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):k}asFileUri(_,C){const n=this.toUri(_,C);return n.scheme===D.vscodeFileResource?n.with({scheme:D.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(_,C){return m.URI.isUri(_)?_:m.URI.parse(C.toUrl(_))}}e.FileAccess=new I}),define(_e[25],ye([0,1,43,14,2,8,11,21]),function(ee,e,m,F,D,y,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(h){return(0,D.uriToFsPath)(h,!0)}e.originalFSPath=_;class C{constructor(a){this._ignorePathCasing=a}compare(a,d,f=!1){return a===d?0:(0,y.compare)(this.getComparisonKey(a,f),this.getComparisonKey(d,f))}isEqual(a,d,f=!1){return a===d?!0:!a||!d?!1:this.getComparisonKey(a,f)===this.getComparisonKey(d,f)}getComparisonKey(a,d=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,d,f=!1){if(a.scheme===d.scheme){if(a.scheme===I.Schemas.file)return m.isEqualOrParent(_(a),_(d),this._ignorePathCasing(a))&&a.query===d.query&&(f||a.fragment===d.fragment);if((0,e.isEqualAuthority)(a.authority,d.authority))return m.isEqualOrParent(a.path,d.path,this._ignorePathCasing(a),"/")&&a.query===d.query&&(f||a.fragment===d.fragment)}return!1}joinPath(a,...d){return D.URI.joinPath(a,...d)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return F.posix.basename(a.path)}extname(a){return F.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let d;return a.scheme===I.Schemas.file?d=D.URI.file(F.dirname(_(a))).path:(d=F.posix.dirname(a.path),a.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),d="/")),a.with({path:d})}normalizePath(a){if(!a.path.length)return a;let d;return a.scheme===I.Schemas.file?d=D.URI.file(F.normalize(_(a))).path:d=F.posix.normalize(a.path),a.with({path:d})}relativePath(a,d){if(a.scheme!==d.scheme||!(0,e.isEqualAuthority)(a.authority,d.authority))return;if(a.scheme===I.Schemas.file){const w=F.relative(_(a),_(d));return S.isWindows?m.toSlashes(w):w}let f=a.path||"/",E=d.path||"/";if(this._ignorePathCasing(a)){let w=0;for(const u=Math.min(f.length,E.length);w<u&&!(f.charCodeAt(w)!==E.charCodeAt(w)&&f.charAt(w).toLowerCase()!==E.charAt(w).toLowerCase());w++);f=E.substr(0,w)+f.substr(w)}return F.posix.relative(f,E)}resolvePath(a,d){if(a.scheme===I.Schemas.file){const f=D.URI.file(F.resolve(_(a),d));return a.with({authority:f.authority,path:f.path})}return d=m.toPosixPath(d),a.with({path:F.posix.resolve(a.path,d)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,d){return a===d||(0,y.equalsIgnoreCase)(a,d)}hasTrailingPathSeparator(a,d=F.sep){if(a.scheme===I.Schemas.file){const f=_(a);return f.length>m.getRoot(f).length&&f[f.length-1]===d}else{const f=a.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,d=F.sep){return(0,e.hasTrailingPathSeparator)(a,d)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,d=F.sep){let f=!1;if(a.scheme===I.Schemas.file){const E=_(a);f=E!==void 0&&E.length===m.getRoot(E).length&&E[E.length-1]===d}else{d="/";const E=a.path;f=E.length===1&&E.charCodeAt(E.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(a,d)?a.with({path:a.path+"/"}):a}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(h=>h.scheme===I.Schemas.file?!S.isLinux:!0),e.extUriIgnorePathCase=new C(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(h,a){const d=[];for(let f=0;f<h.length;f++){const E=a(h[f]);h.some((w,u)=>u===f?!1:(0,e.isEqualOrParent)(E,a(w)))||d.push(h[f])}return d}e.distinctParents=n;var k;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function a(d){const f=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(u=>{const[g,b]=u.split(":");g&&b&&f.set(g,b)});const w=d.path.substring(0,d.path.indexOf(";"));return w&&f.set(h.META_DATA_MIME,w),f}h.parseMetaData=a})(k=e.DataUri||(e.DataUri={}));function l(h,a,d){if(a){let f=h.path;return f&&f[0]!==F.posix.sep&&(f=F.posix.sep+f),h.with({scheme:d,authority:a,path:f})}return h.with({scheme:d})}e.toLocalResource=l}),define(_e[16],ye([0,1,18,12,3,7,25]),function(ee,e,m,F,D,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(z){return!!z&&typeof z.then=="function"}e.isThenable=S;function _(z){const T=new m.CancellationTokenSource,q=z(T.token),L=new Promise((B,Y)=>{const j=T.token.onCancellationRequested(()=>{j.dispose(),T.dispose(),Y((0,F.canceled)())});Promise.resolve(q).then(se=>{j.dispose(),T.dispose(),B(se)},se=>{j.dispose(),T.dispose(),Y(se)})});return new class{cancel(){T.cancel()}then(B,Y){return L.then(B,Y)}catch(B){return this.then(void 0,B)}finally(B){return L.finally(B)}}}e.createCancelablePromise=_;function C(z,T,q){return Promise.race([z,new Promise(L=>T.onCancellationRequested(()=>L(q)))])}e.raceCancellation=C;async function n(z){let T=-1;const q=z.map((B,Y)=>B.then(j=>(T=Y,j))),L=await Promise.race(q);return z.forEach((B,Y)=>{Y!==T&&B.cancel()}),L}e.raceCancellablePromises=n;function k(z,T,q){let L;const B=setTimeout(()=>{L?.(void 0),q?.()},T);return Promise.race([z.finally(()=>clearTimeout(B)),new Promise(Y=>L=Y)])}e.raceTimeout=k;function l(z){return new Promise((T,q)=>{const L=z();S(L)?L.then(T,q):T(L)})}e.asPromise=l;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(T){if(this.activePromise){if(this.queuedPromiseFactory=T,!this.queuedPromise){const q=()=>{this.queuedPromise=null;const L=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,L};this.queuedPromise=new Promise(L=>{this.activePromise.then(q,q).then(L)})}return new Promise((q,L)=>{this.queuedPromise.then(q,L)})}return this.activePromise=T(),new Promise((q,L)=>{this.activePromise.then(B=>{this.activePromise=null,q(B)},B=>{this.activePromise=null,L(B)})})}}e.Throttler=h;class a{constructor(){this.current=Promise.resolve(null)}queue(T){return this.current=this.current.then(()=>T(),()=>T())}}e.Sequencer=a;class d{constructor(){this.promiseMap=new Map}queue(T,q){const B=(this.promiseMap.get(T)??Promise.resolve()).catch(()=>{}).then(q).finally(()=>{this.promiseMap.get(T)===B&&this.promiseMap.delete(T)});return this.promiseMap.set(T,B),B}}e.SequencerByKey=d;class f{constructor(T){this.defaultDelay=T,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(T,q=this.defaultDelay){return this.task=T,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((L,B)=>{this.doResolve=L,this.doReject=B}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const L=this.task;return this.task=null,L()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},q),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,F.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=f;class E{constructor(T){this.delayer=new f(T),this.throttler=new h}trigger(T,q){return this.delayer.trigger(()=>this.throttler.queue(T),q)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=E;class w{constructor(){this._isOpen=!1,this._promise=new Promise((T,q)=>{this._completePromise=T})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=w;class u extends w{constructor(T){super();this._timeout=setTimeout(()=>this.open(),T)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function g(z,T){return T?new Promise((q,L)=>{const B=setTimeout(()=>{Y.dispose(),q()},z),Y=T.onCancellationRequested(()=>{clearTimeout(B),Y.dispose(),L((0,F.canceled)())})}):_(q=>g(z,q))}e.timeout=g;function b(z,T=0){const q=setTimeout(z,T);return(0,y.toDisposable)(()=>clearTimeout(q))}e.disposableTimeout=b;function t(z){const T=[];let q=0;const L=z.length;function B(){return q<L?z[q++]():null}function Y(j){j!=null&&T.push(j);const se=B();return se?se.then(Y):Promise.resolve(T)}return Promise.resolve(null).then(Y)}e.sequence=t;function s(z,T=L=>!!L,q=null){let L=0;const B=z.length,Y=()=>{if(L>=B)return Promise.resolve(q);const j=z[L++];return Promise.resolve(j()).then(Se=>T(Se)?Promise.resolve(Se):Y())};return Y()}e.first=s;function i(z,T=L=>!!L,q=null){if(z.length===0)return Promise.resolve(q);let L=z.length;const B=()=>{L=-1;for(const Y of z)Y.cancel?.()};return new Promise((Y,j)=>{for(const se of z)se.then(Se=>{--L>=0&&T(Se)?(B(),Y(Se)):L===0&&Y(q)}).catch(Se=>{--L>=0&&(B(),j(Se))})})}e.firstParallel=i;class r{constructor(T){this._size=0,this.maxDegreeOfParalellism=T,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(T){return this._size++,new Promise((q,L)=>{this.outstandingPromises.push({factory:T,c:q,e:L}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const T=this.outstandingPromises.shift();this.runningPromises++;const q=T.factory();q.then(T.c,T.e),q.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=r;class c extends r{constructor(){super(1)}}e.Queue=c;class p{constructor(){this.queues=new Map}queueFor(T,q=I.extUri){const L=q.getComparisonKey(T);let B=this.queues.get(L);return B||(B=new c,D.Event.once(B.onFinished)(()=>{B?.dispose(),this.queues.delete(L)}),this.queues.set(L,B)),B}dispose(){this.queues.forEach(T=>T.dispose()),this.queues.clear()}}e.ResourceQueue=p;class v{constructor(T,q){this._token=-1,typeof T=="function"&&typeof q=="number"&&this.setIfNotSet(T,q)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(T,q){this.cancel(),this._token=setTimeout(()=>{this._token=-1,T()},q)}setIfNotSet(T,q){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,T()},q))}}e.TimeoutTimer=v;class A{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(T,q){this.cancel(),this._token=setInterval(()=>{T()},q)}}e.IntervalTimer=A;class R{constructor(T,q){this.timeoutToken=-1,this.runner=T,this.timeout=q,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(T=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,T)}get delay(){return this.timeout}set delay(T){this.timeout=T}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class o extends R{constructor(T,q){super(T,q);this.units=[]}work(T){this.units.push(T),this.isScheduled()||this.schedule()}doRun(){const T=this.units;this.units=[],this.runner&&this.runner(T)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=o;class P extends y.Disposable{constructor(T,q,L,B){super();this.maxWorkChunkSize=T,this.maxPendingWork=q,this.throttleDelay=L,this.handler=B,this.pendingWork=[],this.throttler=this._register(new y.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(T){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+T.length>this.maxPendingWork)return!1}else if(this.pending+T.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...T),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=P,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const z=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=T=>{const q=setTimeout(()=>T(z));let L=!1;return{dispose(){L||(L=!0,clearTimeout(q))}}}}else e.runWhenIdle=(z,T)=>{const q=requestIdleCallback(z,typeof T=="number"?{timeout:T}:void 0);let L=!1;return{dispose(){L||(L=!0,cancelIdleCallback(q))}}}}();class N{constructor(T){this._didRun=!1,this._executor=()=>{try{this._value=T()}catch(q){this._error=q}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=N;async function $(z,T,q){let L;for(let B=0;B<q;B++)try{return await z()}catch(Y){L=Y,await g(T)}throw L}e.retry=$;class ie{hasPending(T){return this._pending?typeof T=="number"?this._pending.taskId===T:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(T,q,L){return this._pending={taskId:T,cancel:()=>L?.(),promise:q},q.then(()=>this.donePending(T),()=>this.donePending(T)),q}donePending(T){this._pending&&T===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const T=this._next;this._next=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}setNext(T){if(this._next)this._next.run=T;else{let q,L;const B=new Promise((Y,j)=>{q=Y,L=j});this._next={run:T,promise:B,promiseResolve:q,promiseReject:L}}return this._next.promise}}e.TaskSequentializer=ie;class ce{constructor(T){this.interval=T,this.lastIncrementTime=0,this.value=0}increment(){const T=Date.now();return T-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=T,this.value=0),this.value++,this.value}}e.IntervalCounter=ce;class K{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((T,q)=>{this.completeCallback=T,this.errorCallback=q})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(T){return new Promise(q=>{this.completeCallback(T),this.resolved=!0,q()})}error(T){return new Promise(q=>{this.errorCallback(T),this.rejected=!0,q()})}cancel(){new Promise(T=>{this.errorCallback((0,F.canceled)()),this.rejected=!0,T()})}}e.DeferredPromise=K;var H;(function(z){async function T(q){let L;const B=await Promise.all(q.map(Y=>Y.then(j=>j,j=>{L||(L=j)})));if(typeof L!="undefined")throw L;return B}z.settled=T})(H=e.Promises||(e.Promises={}))}),define(_e[113],ye([0,1,14,16]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new F.IdleValue(()=>{const R=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:R,collatorIsNumeric:R.resolvedOptions().numeric}}),y=new F.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),I=new F.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function S(R,o,P=!1){const N=R||"",$=o||"",ie=D.value.collator.compare(N,$);return D.value.collatorIsNumeric&&ie===0&&N!==$?N<$?-1:1:ie}e.compareFileNames=S;function _(R,o){const P=y.value.collator;return R=R||"",o=o||"",b(P,R,o)}e.compareFileNamesDefault=_;function C(R,o){const P=y.value.collator;return R=R||"",o=o||"",r(R,o)||b(P,R,o)}e.compareFileNamesUpper=C;function n(R,o){const P=y.value.collator;return R=R||"",o=o||"",i(R,o)||b(P,R,o)}e.compareFileNamesLower=n;function k(R,o){return R=R||"",o=o||"",R===o?0:R<o?-1:1}e.compareFileNamesUnicode=k;function l(R,o,P=!1){P||(R=R&&R.toLowerCase(),o=o&&o.toLowerCase());const[N,$]=u(R),[ie,ce]=u(o);return N!==ie?N<ie?-1:1:$===ce?0:$<ce?-1:1}e.noIntlCompareFileNames=l;function h(R,o){const[P,N]=u(R),[$,ie]=u(o);let ce=D.value.collator.compare(N,ie);if(ce===0){if(D.value.collatorIsNumeric&&N!==ie)return N<ie?-1:1;if(ce=D.value.collator.compare(P,$),D.value.collatorIsNumeric&&ce===0&&P!==$)return P<$?-1:1}return ce}e.compareFileExtensions=h;function a(R,o){R=R||"",o=o||"";const P=g(R),N=g(o),$=y.value.collator,ie=I.value.collator;return b(ie,P,N)||b($,R,o)}e.compareFileExtensionsDefault=a;function d(R,o){R=R||"",o=o||"";const P=g(R),N=g(o),$=y.value.collator,ie=I.value.collator;return b(ie,P,N)||r(R,o)||b($,R,o)}e.compareFileExtensionsUpper=d;function f(R,o){R=R||"",o=o||"";const P=g(R),N=g(o),$=y.value.collator,ie=I.value.collator;return b(ie,P,N)||i(R,o)||b($,R,o)}e.compareFileExtensionsLower=f;function E(R,o){R=R||"",o=o||"";const P=g(R).toLowerCase(),N=g(o).toLowerCase();return P!==N?P<N?-1:1:R!==o?R<o?-1:1:0}e.compareFileExtensionsUnicode=E;const w=/^(.*?)(\.([^.]*))?$/;function u(R,o=!1){const P=R?w.exec(R):[];let N=[P&&P[1]||"",P&&P[3]||""];return o&&(!N[0]&&N[1]||N[0]&&N[0].charAt(0)===".")&&(N=[N[0]+"."+N[1],""]),N}function g(R){const o=R?w.exec(R):[];return o&&o[1]&&o[1].charAt(0)!=="."&&o[3]||""}function b(R,o,P){let N=R.compare(o,P);return N!==0?N:o.length!==P.length?o.length<P.length?-1:1:0}function t(R){const o=R.charAt(0);return o.toLocaleUpperCase()!==o}function s(R){const o=R.charAt(0);return o.toLocaleLowerCase()!==o}function i(R,o){return t(R)&&s(o)?-1:s(R)&&t(o)?1:0}function r(R,o){return s(R)&&t(o)?-1:t(R)&&s(o)?1:0}function c(R,o,P=!1){return P||(R=R&&R.toLowerCase(),o=o&&o.toLowerCase()),R===o?0:R<o?-1:1}function p(R,o,P=!1){const N=R.split(m.sep),$=o.split(m.sep),ie=N.length-1,ce=$.length-1;let K,H;for(let z=0;;z++){if(K=ie===z,H=ce===z,K&&H)return S(N[z],$[z],P);if(K)return-1;if(H)return 1;const T=c(N[z],$[z],P);if(T!==0)return T}}e.comparePaths=p;function v(R,o,P){const N=R.toLowerCase(),$=o.toLowerCase(),ie=A(R,o,P);if(ie)return ie;const ce=N.endsWith(P),K=$.endsWith(P);if(ce!==K)return ce?-1:1;const H=S(N,$);return H!==0?H:N.localeCompare($)}e.compareAnything=v;function A(R,o,P){const N=R.toLowerCase(),$=o.toLowerCase(),ie=N.startsWith(P),ce=$.startsWith(P);if(ie!==ce)return ie?-1:1;if(ie&&ce){if(N.length<$.length)return-1;if(N.length>$.length)return 1}return 0}e.compareByPrefix=A}),define(_e[27],ye([0,1,8,43,14,22,16]),function(ee,e,m,F,D,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S;const _="**",C="/",n="[/\\\\]",k="[^/\\\\]",l=/\//g;function h(B){switch(B){case 0:return"";case 1:return`${k}*?`;default:return`(?:${n}|${k}+${n}|${n}${k}+)*?`}}function a(B,Y){if(!B)return[];const j=[];let se=!1,Se=!1,Re="";for(const $e of B){switch($e){case Y:if(!se&&!Se){j.push(Re),Re="";continue}break;case"{":se=!0;break;case"}":se=!1;break;case"[":Se=!0;break;case"]":Se=!1;break}Re+=$e}return Re&&j.push(Re),j}e.splitGlobAware=a;function d(B){if(!B)return"";let Y="";const j=a(B,C);if(j.every(se=>se===_))Y=".*";else{let se=!1;j.forEach((Se,Re)=>{if(Se===_){se||(Y+=h(2),se=!0);return}let $e=!1,Ne="",Ge=!1,Ke="";for(const qe of Se){if(qe!=="}"&&$e){Ne+=qe;continue}if(Ge&&(qe!=="]"||!Ke)){let U;qe==="-"?U=qe:(qe==="^"||qe==="!")&&!Ke?U="^":qe===C?U="":U=m.escapeRegExpCharacters(qe),Ke+=U;continue}switch(qe){case"{":$e=!0;continue;case"[":Ge=!0;continue;case"}":Y+=`(?:${a(Ne,",").map(te=>d(te)).join("|")})`,$e=!1,Ne="";break;case"]":Y+="["+Ke+"]",Ge=!1,Ke="";break;case"?":Y+=k;continue;case"*":Y+=h(1);continue;default:Y+=m.escapeRegExpCharacters(qe)}}Re<j.length-1&&(j[Re+1]!==_||Re+2<j.length)&&(Y+=n),se=!1})}return Y}const f=/^\*\*\/\*\.[\w\.-]+$/,E=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,u=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,g=/^\*\*((\/[\w\.-]+)+)\/?$/,b=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new y.LRUCache(1e4),s=function(){return!1},i=function(){return null};function r(B,Y){if(!B)return i;let j;typeof B!="string"?j=B.pattern:j=B,j=j.trim();const se=`${j}_${!!Y.trimForExclusions}`;let Se=t.get(se);if(Se)return c(Se,B);let Re;if(f.test(j)){const $e=j.substr(4);Se=function(Ne,Ge){return typeof Ne=="string"&&Ne.endsWith($e)?j:null}}else(Re=E.exec(p(j,Y)))?Se=v(Re[1],j):(Y.trimForExclusions?u:w).test(j)?Se=A(j,Y):(Re=g.exec(p(j,Y)))?Se=R(Re[1].substr(1),j,!0):(Re=b.exec(p(j,Y)))?Se=R(Re[1],j,!1):Se=o(j);return t.set(se,Se),c(Se,B)}function c(B,Y){return typeof Y=="string"?B:function(j,se){return F.isEqualOrParent(j,Y.base)?B(D.relative(Y.base,j),se):null}}function p(B,Y){return Y.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function v(B,Y){const j=`/${B}`,se=`\\${B}`,Se=function($e,Ne){return typeof $e!="string"?null:Ne?Ne===B?Y:null:$e===B||$e.endsWith(j)||$e.endsWith(se)?Y:null},Re=[B];return Se.basenames=Re,Se.patterns=[Y],Se.allBasenames=Re,Se}function A(B,Y){const j=L(B.slice(1,-1).split(",").map(Ne=>r(Ne,Y)).filter(Ne=>Ne!==i),B),se=j.length;if(!se)return i;if(se===1)return j[0];const Se=function(Ne,Ge){for(let Ke=0,qe=j.length;Ke<qe;Ke++)if(j[Ke](Ne,Ge))return B;return null},Re=j.find(Ne=>!!Ne.allBasenames);Re&&(Se.allBasenames=Re.allBasenames);const $e=j.reduce((Ne,Ge)=>Ge.allPaths?Ne.concat(Ge.allPaths):Ne,[]);return $e.length&&(Se.allPaths=$e),Se}function R(B,Y,j){const se=D.sep===D.posix.sep,Se=se?B:B.replace(l,D.sep),Re=D.sep+Se,$e=D.posix.sep+B,Ne=j?function(Ge,Ke){return typeof Ge=="string"&&(Ge===Se||Ge.endsWith(Re)||!se&&(Ge===B||Ge.endsWith($e)))?Y:null}:function(Ge,Ke){return typeof Ge=="string"&&(Ge===Se||!se&&Ge===B)?Y:null};return Ne.allPaths=[(j?"*/":"./")+B],Ne}function o(B){try{const Y=new RegExp(`^${d(B)}$`);return function(j){return Y.lastIndex=0,typeof j=="string"&&Y.test(j)?B:null}}catch(Y){return i}}function P(B,Y,j){return!B||typeof Y!="string"?!1:N(B)(Y,void 0,j)}e.match=P;function N(B,Y={}){if(!B)return s;if(typeof B=="string"||K(B)){const j=r(B,Y);if(j===i)return s;const se=function(Se,Re){return!!j(Se,Re)};return j.allBasenames&&(se.allBasenames=j.allBasenames),j.allPaths&&(se.allPaths=j.allPaths),se}return T(B,Y)}e.parse=N;function $(B){if(!B)return;let Y;return j=>(Y||(Y=(B()||Promise.resolve([])).then(se=>se?ce(se):{})),Y.then(se=>!!se[j]))}e.hasSiblingPromiseFn=$;function ie(B){if(!B)return;let Y;return j=>{if(!Y){const se=B();Y=se?ce(se):{}}return!!Y[j]}}e.hasSiblingFn=ie;function ce(B){const Y={};for(const j of B)Y[j]=!0;return Y}function K(B){const Y=B;return Y&&typeof Y.base=="string"&&typeof Y.pattern=="string"}e.isRelativePattern=K;function H(B){return B.allBasenames||[]}e.getBasenameTerms=H;function z(B){return B.allPaths||[]}e.getPathTerms=z;function T(B,Y){const j=L(Object.getOwnPropertyNames(B).map(Ne=>q(Ne,B[Ne],Y)).filter(Ne=>Ne!==i)),se=j.length;if(!se)return i;if(!j.some(Ne=>!!Ne.requiresSiblings)){if(se===1)return j[0];const Ne=function(qe,U){for(let G=0,te=j.length;G<te;G++){const re=j[G](qe,U);if(re)return re}return null},Ge=j.find(qe=>!!qe.allBasenames);Ge&&(Ne.allBasenames=Ge.allBasenames);const Ke=j.reduce((qe,U)=>U.allPaths?qe.concat(U.allPaths):qe,[]);return Ke.length&&(Ne.allPaths=Ke),Ne}const Se=function(Ne,Ge,Ke){let qe;for(let U=0,G=j.length;U<G;U++){const te=j[U];te.requiresSiblings&&Ke&&(Ge||(Ge=D.basename(Ne)),qe||(qe=Ge.substr(0,Ge.length-D.extname(Ne).length)));const re=te(Ne,Ge,qe,Ke);if(re)return re}return null},Re=j.find(Ne=>!!Ne.allBasenames);Re&&(Se.allBasenames=Re.allBasenames);const $e=j.reduce((Ne,Ge)=>Ge.allPaths?Ne.concat(Ge.allPaths):Ne,[]);return $e.length&&(Se.allPaths=$e),Se}function q(B,Y,j){if(Y===!1)return i;const se=r(B,j);if(se===i)return i;if(typeof Y=="boolean")return se;if(Y){const Se=Y.when;if(typeof Se=="string"){const Re=($e,Ne,Ge,Ke)=>{if(!Ke||!se($e,Ne))return null;const qe=Se.replace("$(basename)",Ge),U=Ke(qe);return(0,I.isThenable)(U)?U.then(G=>G?B:null):U?B:null};return Re.requiresSiblings=!0,Re}}return se}function L(B,Y){const j=B.filter(Ne=>!!Ne.basenames);if(j.length<2)return B;const se=j.reduce((Ne,Ge)=>{const Ke=Ge.basenames;return Ke?Ne.concat(Ke):Ne},[]);let Se;if(Y){Se=[];for(let Ne=0,Ge=se.length;Ne<Ge;Ne++)Se.push(Y)}else Se=j.reduce((Ne,Ge)=>{const Ke=Ge.patterns;return Ke?Ne.concat(Ke):Ne},[]);const Re=function(Ne,Ge){if(typeof Ne!="string")return null;if(!Ge){let qe;for(qe=Ne.length;qe>0;qe--){const U=Ne.charCodeAt(qe-1);if(U===47||U===92)break}Ge=Ne.substr(qe)}const Ke=se.indexOf(Ge);return Ke!==-1?Se[Ke]:null};Re.basenames=se,Re.patterns=Se,Re.allBasenames=se;const $e=B.filter(Ne=>!Ne.basenames);return $e.push(Re),$e}}),define(_e[82],ye([0,1,2,14,8,11,21,25,43]),function(ee,e,m,F,D,y,I,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function C(r,c,p){if(typeof r=="string"&&(r=m.URI.file(r)),p){const A=p.getWorkspaceFolder(r);if(A){const R=p.getWorkspace().folders.length>1;let o;if((0,S.isEqual)(A.uri,r)?o="":o=(0,S.relativePath)(A.uri,r),R){const P=A.name?A.name:(0,S.basename)(A.uri);o=o?P+" \u2022 "+o:P}return o}}if(r.scheme!==y.Schemas.file&&r.scheme!==y.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,_.hasDriveLetter)(r.fsPath))return(0,F.normalize)(k(r.fsPath));let v=(0,F.normalize)(r.fsPath);return!I.isWindows&&c?.userHome&&(v=h(v,c.userHome.fsPath)),v}e.getPathLabel=C;function n(r){if(!r)return;typeof r=="string"&&(r=m.URI.file(r));const c=(0,S.basename)(r)||(r.scheme===y.Schemas.file?r.fsPath:r.path);return I.isWindows&&(0,_.isRootOrDriveLetter)(c)?k(c):c}e.getBaseLabel=n;function k(r){return(0,_.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=k;let l=Object.create(null);function h(r,c){if(I.isWindows||!r||!c)return r;let p=l.original===c?l.normalized:void 0;return p||(p=`${(0,D.rtrim)(c,F.posix.sep)}${F.posix.sep}`,l={original:c,normalized:p}),(I.isLinux?r.startsWith(p):(0,D.startsWithIgnoreCase)(r,p))&&(r=`~/${r.substr(p.length)}`),r}e.tildify=h;function a(r,c){return r.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=a;const d="\u2026",f="\\\\",E="~";function w(r,c=F.sep){const p=new Array(r.length);let v=!1;for(let A=0;A<r.length;A++){let R=r[A];if(R===""){p[A]=`.${c}`;continue}if(!R){p[A]=R;continue}v=!0;let o="";R.indexOf(f)===0?(o=R.substr(0,R.indexOf(f)+f.length),R=R.substr(R.indexOf(f)+f.length)):R.indexOf(c)===0?(o=R.substr(0,R.indexOf(c)+c.length),R=R.substr(R.indexOf(c)+c.length)):R.indexOf(E)===0&&(o=R.substr(0,R.indexOf(E)+E.length),R=R.substr(R.indexOf(E)+E.length));const P=R.split(c);for(let N=1;v&&N<=P.length;N++)for(let $=P.length-N;v&&$>=0;$--){v=!1;let ie=P.slice($,$+N).join(c);for(let ce=0;!v&&ce<r.length;ce++)if(ce!==A&&r[ce]&&r[ce].indexOf(ie)>-1){const K=$+N===P.length,H=$>0&&r[ce].indexOf(c)>-1?c+ie:ie,z=r[ce].endsWith(H);v=!K||z}if(!v){let ce="";(P[0].endsWith(":")||o!=="")&&($===1&&($=0,N++,ie=P[0]+c+ie),$>0&&(ce=P[0]+c),ce=o+ce),$>0&&(ce=ce+d+c),ce=ce+ie,$+N<P.length&&(ce=ce+c+d),p[A]=ce}}v&&(p[A]=R)}return p}e.shorten=w;var u;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function g(r,c=Object.create(null)){const p=[];let v=!1,A="";for(const R of r)if(R==="$"||v&&R==="{")A&&p.push({value:A,type:u.TEXT}),A="",v=!0;else if(R==="}"&&v){const o=c[A];if(typeof o=="string")o.length&&p.push({value:o,type:u.VARIABLE});else if(o){const P=p[p.length-1];(!P||P.type!==u.SEPARATOR)&&p.push({value:o.label,type:u.SEPARATOR})}A="",v=!1}else A+=R;return A&&!v&&p.push({value:A,type:u.TEXT}),p.filter((R,o)=>{if(R.type===u.SEPARATOR){const P=p[o-1],N=p[o+1];return[P,N].every($=>$&&($.type===u.VARIABLE||$.type===u.TEXT)&&$.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=g;function b(r,c){return I.isMacintosh||c?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.isMacintosh?"&":"&&"):r.replace(/&&|&/g,p=>p==="&"?"&&":"&")}e.mnemonicMenuLabel=b;function t(r,c){return I.isMacintosh||c?r.replace(/\(&&\w\)|&&/g,""):I.isWindows?r.replace(/&&|&/g,p=>p==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function s(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=s;function i(r){const c=r.indexOf("/")!==-1?F.posix:F.win32,p=c.basename(r),v=c.dirname(r);return p.length?{name:p,parentPath:v}:{name:v,parentPath:""}}e.splitName=i}),define(_e[83],ye([0,1,14,8,27,11,25]),function(ee,e,m,F,D,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var S;(function(s){s.text="text/plain",s.binary="application/octet-stream",s.unknown="application/unknown",s.markdown="text/markdown"})(S=e.Mimes||(e.Mimes={}));let _=[],C=[],n=[];function k(s,i=!1){const r=l(s);_.push(r),r.userConfigured?n.push(r):C.push(r),i&&!r.userConfigured&&_.forEach(c=>{c.mime===r.mime||c.userConfigured||(r.extension&&c.extension===r.extension&&console.warn(`Overwriting extension <<${r.extension}>> to now point to mime <<${r.mime}>>`),r.filename&&c.filename===r.filename&&console.warn(`Overwriting filename <<${r.filename}>> to now point to mime <<${r.mime}>>`),r.filepattern&&c.filepattern===r.filepattern&&console.warn(`Overwriting filepattern <<${r.filepattern}>> to now point to mime <<${r.mime}>>`),r.firstline&&c.firstline===r.firstline&&console.warn(`Overwriting firstline <<${r.firstline}>> to now point to mime <<${r.mime}>>`))})}e.registerTextMime=k;function l(s){return{id:s.id,mime:s.mime,filename:s.filename,extension:s.extension,filepattern:s.filepattern,firstline:s.firstline,userConfigured:s.userConfigured,filenameLowercase:s.filename?s.filename.toLowerCase():void 0,extensionLowercase:s.extension?s.extension.toLowerCase():void 0,filepatternLowercase:s.filepattern?s.filepattern.toLowerCase():void 0,filepatternOnPath:s.filepattern?s.filepattern.indexOf(m.posix.sep)>=0:!1}}function h(s){s?(_=_.filter(i=>!i.userConfigured),n=[]):(_=[],C=[],n=[])}e.clearTextMimes=h;function a(s,i){let r;if(s)switch(s.scheme){case y.Schemas.file:r=s.fsPath;break;case y.Schemas.data:r=I.DataUri.parseMetaData(s).get(I.DataUri.META_DATA_LABEL);break;default:r=s.path}if(!r)return[S.unknown];r=r.toLowerCase();const c=(0,m.basename)(r),p=d(r,c,n);if(p)return[p,S.text];const v=d(r,c,C);if(v)return[v,S.text];if(i){const A=f(i);if(A)return[A,S.text]}return[S.unknown]}e.guessMimeTypes=a;function d(s,i,r){let c=null,p=null,v=null;for(let A=r.length-1;A>=0;A--){const R=r[A];if(i===R.filenameLowercase){c=R;break}if(R.filepattern&&(!p||R.filepattern.length>p.filepattern.length)){const o=R.filepatternOnPath?s:i;(0,D.match)(R.filepatternLowercase,o)&&(p=R)}R.extension&&(!v||R.extension.length>v.extension.length)&&i.endsWith(R.extensionLowercase)&&(v=R)}return c?c.mime:p?p.mime:v?v.mime:null}function f(s){if((0,F.startsWithUTF8BOM)(s)&&(s=s.substr(1)),s.length>0)for(let i=_.length-1;i>=0;i--){const r=_[i];if(!r.firstline)continue;const c=s.match(r.firstline);if(c&&c.length>0)return r.mime}return null}function E(s){return s?typeof s=="string"?s===S.binary||s===S.text||s===S.unknown:s.length===1&&E(s[0]):!0}e.isUnspecific=E;const w={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function u(s){const i=(0,m.extname)(s);return w[i.toLowerCase()]}e.getMediaMime=u;function g(s){for(const i in w)if(w[i]===s)return i}e.getExtensionForMimeType=g;const b=/^(.+)\/(.+?)(;.+)?$/;function t(s,i){const r=b.exec(s);return r?`${r[1].toLowerCase()}/${r[2].toLowerCase()}${r[3]??""}`:i?void 0:s}e.normalizeMimeType=t}),define(_e[114],ye([0,1,2]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function F(n){return n.toJSON()}class D{constructor(k){this._uriTransformer=k}transformIncoming(k){const l=this._uriTransformer.transformIncoming(k);return l===k?k:F(m.URI.from(l))}transformOutgoing(k){const l=this._uriTransformer.transformOutgoing(k);return l===k?k:F(m.URI.from(l))}transformOutgoingURI(k){const l=this._uriTransformer.transformOutgoing(k);return l===k?k:m.URI.from(l)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function y(n,k,l){if(!n||l>200)return null;if(typeof n=="object"){if(n instanceof m.URI)return k.transformOutgoing(n);for(let h in n)if(Object.hasOwnProperty.call(n,h)){const a=y(n[h],k,l+1);a!==null&&(n[h]=a)}}return null}function I(n,k){const l=y(n,k,0);return l===null?n:l}e.transformOutgoingURIs=I;function S(n,k,l,h){if(!n||h>200)return null;if(typeof n=="object"){if(n.$mid===1)return l?m.URI.revive(k.transformIncoming(n)):k.transformIncoming(n);for(let a in n)if(Object.hasOwnProperty.call(n,a)){const d=S(n[a],k,l,h+1);d!==null&&(n[a]=d)}}return null}function _(n,k){const l=S(n,k,!1,0);return l===null?n:l}e.transformIncomingURIs=_;function C(n,k){const l=S(n,k,!0,0);return l===null?n:l}e.transformAndReviveIncomingURIs=C}),define(_e[35],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(_){return m.test(_)}e.isUUID=F;const D=new Uint8Array(16),y=[];for(let _=0;_<256;_++)y.push(_.toString(16).padStart(2,"0"));let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(_){for(let C=0;C<_.length;C++)_[C]=Math.floor(Math.random()*256);return _};function S(){I(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let _=0,C="";return C+=y[D[_++]],C+=y[D[_++]],C+=y[D[_++]],C+=y[D[_++]],C+="-",C+=y[D[_++]],C+=y[D[_++]],C+="-",C+=y[D[_++]],C+=y[D[_++]],C+="-",C+=y[D[_++]],C+=y[D[_++]],C+="-",C+=y[D[_++]],C+=y[D[_++]],C+=y[D[_++]],C+=y[D[_++]],C+=y[D[_++]],C+=y[D[_++]],C}e.generateUuid=S}),define(_e[84],ye([0,1,80]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class F{constructor(S){let _=(0,m.toUint8)(S);this._defaultValue=_,this._asciiMap=F._createAsciiMap(_),this._map=new Map}static _createAsciiMap(S){let _=new Uint8Array(256);for(let C=0;C<256;C++)_[C]=S;return _}set(S,_){let C=(0,m.toUint8)(_);S>=0&&S<256?this._asciiMap[S]=C:this._map.set(S,C)}get(S){return S>=0&&S<256?this._asciiMap[S]:this._map.get(S)||this._defaultValue}}e.CharacterClassifier=F;var D;(function(I){I[I.False=0]="False",I[I.True=1]="True"})(D||(D={}));class y{constructor(){this._actual=new F(0)}add(S){this._actual.set(S,1)}has(S){return this._actual.get(S)===1}}e.CharacterSet=y}),define(_e[115],ye([0,1,84]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var F;(function(I){I[I.Regular=0]="Regular",I[I.Whitespace=1]="Whitespace",I[I.WordSeparator=2]="WordSeparator"})(F=e.WordCharacterClass||(e.WordCharacterClass={}));class D extends m.CharacterClassifier{constructor(S){super(0);for(let _=0,C=S.length;_<C;_++)this.set(S.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=D;function y(I){let S={};return _=>(S.hasOwnProperty(_)||(S[_]=I(_)),S[_])}e.getMapForWordSeparators=y(I=>new D(I))}),define(_e[36],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class m{constructor(D,y){this.lineNumber=D,this.column=y}with(D=this.lineNumber,y=this.column){return D===this.lineNumber&&y===this.column?this:new m(D,y)}delta(D=0,y=0){return this.with(this.lineNumber+D,this.column+y)}equals(D){return m.equals(this,D)}static equals(D,y){return!D&&!y?!0:!!D&&!!y&&D.lineNumber===y.lineNumber&&D.column===y.column}isBefore(D){return m.isBefore(this,D)}static isBefore(D,y){return D.lineNumber<y.lineNumber?!0:y.lineNumber<D.lineNumber?!1:D.column<y.column}isBeforeOrEqual(D){return m.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,y){return D.lineNumber<y.lineNumber?!0:y.lineNumber<D.lineNumber?!1:D.column<=y.column}static compare(D,y){let I=D.lineNumber|0,S=y.lineNumber|0;if(I===S){let _=D.column|0,C=y.column|0;return _-C}return I-S}clone(){return new m(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new m(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=m}),define(_e[30],ye([0,1,36]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class F{constructor(y,I,S,_){y>S||y===S&&I>_?(this.startLineNumber=S,this.startColumn=_,this.endLineNumber=y,this.endColumn=I):(this.startLineNumber=y,this.startColumn=I,this.endLineNumber=S,this.endColumn=_)}isEmpty(){return F.isEmpty(this)}static isEmpty(y){return y.startLineNumber===y.endLineNumber&&y.startColumn===y.endColumn}containsPosition(y){return F.containsPosition(this,y)}static containsPosition(y,I){return!(I.lineNumber<y.startLineNumber||I.lineNumber>y.endLineNumber||I.lineNumber===y.startLineNumber&&I.column<y.startColumn||I.lineNumber===y.endLineNumber&&I.column>y.endColumn)}containsRange(y){return F.containsRange(this,y)}static containsRange(y,I){return!(I.startLineNumber<y.startLineNumber||I.endLineNumber<y.startLineNumber||I.startLineNumber>y.endLineNumber||I.endLineNumber>y.endLineNumber||I.startLineNumber===y.startLineNumber&&I.startColumn<y.startColumn||I.endLineNumber===y.endLineNumber&&I.endColumn>y.endColumn)}strictContainsRange(y){return F.strictContainsRange(this,y)}static strictContainsRange(y,I){return!(I.startLineNumber<y.startLineNumber||I.endLineNumber<y.startLineNumber||I.startLineNumber>y.endLineNumber||I.endLineNumber>y.endLineNumber||I.startLineNumber===y.startLineNumber&&I.startColumn<=y.startColumn||I.endLineNumber===y.endLineNumber&&I.endColumn>=y.endColumn)}plusRange(y){return F.plusRange(this,y)}static plusRange(y,I){let S,_,C,n;return I.startLineNumber<y.startLineNumber?(S=I.startLineNumber,_=I.startColumn):I.startLineNumber===y.startLineNumber?(S=I.startLineNumber,_=Math.min(I.startColumn,y.startColumn)):(S=y.startLineNumber,_=y.startColumn),I.endLineNumber>y.endLineNumber?(C=I.endLineNumber,n=I.endColumn):I.endLineNumber===y.endLineNumber?(C=I.endLineNumber,n=Math.max(I.endColumn,y.endColumn)):(C=y.endLineNumber,n=y.endColumn),new F(S,_,C,n)}intersectRanges(y){return F.intersectRanges(this,y)}static intersectRanges(y,I){let S=y.startLineNumber,_=y.startColumn,C=y.endLineNumber,n=y.endColumn,k=I.startLineNumber,l=I.startColumn,h=I.endLineNumber,a=I.endColumn;return S<k?(S=k,_=l):S===k&&(_=Math.max(_,l)),C>h?(C=h,n=a):C===h&&(n=Math.min(n,a)),S>C||S===C&&_>n?null:new F(S,_,C,n)}equalsRange(y){return F.equalsRange(this,y)}static equalsRange(y,I){return!!y&&!!I&&y.startLineNumber===I.startLineNumber&&y.startColumn===I.startColumn&&y.endLineNumber===I.endLineNumber&&y.endColumn===I.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(y){return new m.Position(y.endLineNumber,y.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(y){return new m.Position(y.startLineNumber,y.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(y,I){return new F(this.startLineNumber,this.startColumn,y,I)}setStartPosition(y,I){return new F(y,I,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(y){return new F(y.startLineNumber,y.startColumn,y.startLineNumber,y.startColumn)}static fromPositions(y,I=y){return new F(y.lineNumber,y.column,I.lineNumber,I.column)}static lift(y){return y?new F(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn):null}static isIRange(y){return y&&typeof y.startLineNumber=="number"&&typeof y.startColumn=="number"&&typeof y.endLineNumber=="number"&&typeof y.endColumn=="number"}static areIntersectingOrTouching(y,I){return!(y.endLineNumber<I.startLineNumber||y.endLineNumber===I.startLineNumber&&y.endColumn<I.startColumn||I.endLineNumber<y.startLineNumber||I.endLineNumber===y.startLineNumber&&I.endColumn<y.startColumn)}static areIntersecting(y,I){return!(y.endLineNumber<I.startLineNumber||y.endLineNumber===I.startLineNumber&&y.endColumn<=I.startColumn||I.endLineNumber<y.startLineNumber||I.endLineNumber===y.startLineNumber&&I.endColumn<=y.startColumn)}static compareRangesUsingStarts(y,I){if(y&&I){const C=y.startLineNumber|0,n=I.startLineNumber|0;if(C===n){const k=y.startColumn|0,l=I.startColumn|0;if(k===l){const h=y.endLineNumber|0,a=I.endLineNumber|0;if(h===a){const d=y.endColumn|0,f=I.endColumn|0;return d-f}return h-a}return k-l}return C-n}return(y?1:0)-(I?1:0)}static compareRangesUsingEnds(y,I){return y.endLineNumber===I.endLineNumber?y.endColumn===I.endColumn?y.startLineNumber===I.startLineNumber?y.startColumn-I.startColumn:y.startLineNumber-I.startLineNumber:y.endColumn-I.endColumn:y.endLineNumber-I.endLineNumber}static spansMultipleLines(y){return y.endLineNumber>y.startLineNumber}}e.Range=F}),define(_e[116],ye([0,1,36,30]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var D;(function(I){I[I.LTR=0]="LTR",I[I.RTL=1]="RTL"})(D=e.SelectionDirection||(e.SelectionDirection={}));class y extends F.Range{constructor(S,_,C,n){super(S,_,C,n);this.selectionStartLineNumber=S,this.selectionStartColumn=_,this.positionLineNumber=C,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(S){return y.selectionsEqual(this,S)}static selectionsEqual(S,_){return S.selectionStartLineNumber===_.selectionStartLineNumber&&S.selectionStartColumn===_.selectionStartColumn&&S.positionLineNumber===_.positionLineNumber&&S.positionColumn===_.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(S,_){return this.getDirection()===0?new y(this.startLineNumber,this.startColumn,S,_):new y(S,_,this.startLineNumber,this.startColumn)}getPosition(){return new m.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(S,_){return this.getDirection()===0?new y(S,_,this.endLineNumber,this.endColumn):new y(this.endLineNumber,this.endColumn,S,_)}static fromPositions(S,_=S){return new y(S.lineNumber,S.column,_.lineNumber,_.column)}static liftSelection(S){return new y(S.selectionStartLineNumber,S.selectionStartColumn,S.positionLineNumber,S.positionColumn)}static selectionsArrEqual(S,_){if(S&&!_||!S&&_)return!1;if(!S&&!_)return!0;if(S.length!==_.length)return!1;for(let C=0,n=S.length;C<n;C++)if(!this.selectionsEqual(S[C],_[C]))return!1;return!0}static isISelection(S){return S&&typeof S.selectionStartLineNumber=="number"&&typeof S.selectionStartColumn=="number"&&typeof S.positionLineNumber=="number"&&typeof S.positionColumn=="number"}static createWithDirection(S,_,C,n,k){return k===0?new y(S,_,C,n):new y(C,n,S,_)}}e.Selection=y}),define(_e[85],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var m;(function(a){a[a.Left=1]="Left",a[a.Center=2]="Center",a[a.Right=4]="Right",a[a.Full=7]="Full"})(m=e.OverviewRulerLane||(e.OverviewRulerLane={}));var F;(function(a){a[a.Inline=1]="Inline",a[a.Gutter=2]="Gutter"})(F=e.MinimapPosition||(e.MinimapPosition={}));var D;(function(a){a[a.TextDefined=0]="TextDefined",a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(D=e.EndOfLinePreference||(e.EndOfLinePreference={}));var y;(function(a){a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(y=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var I;(function(a){a[a.LF=0]="LF",a[a.CRLF=1]="CRLF"})(I=e.EndOfLineSequence||(e.EndOfLineSequence={}));class S{constructor(d){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,d.tabSize|0),this.indentSize=d.tabSize|0,this.insertSpaces=Boolean(d.insertSpaces),this.defaultEOL=d.defaultEOL|0,this.trimAutoWhitespace=Boolean(d.trimAutoWhitespace)}equals(d){return this.tabSize===d.tabSize&&this.indentSize===d.indentSize&&this.insertSpaces===d.insertSpaces&&this.defaultEOL===d.defaultEOL&&this.trimAutoWhitespace===d.trimAutoWhitespace}createChangeEvent(d){return{tabSize:this.tabSize!==d.tabSize,indentSize:this.indentSize!==d.indentSize,insertSpaces:this.insertSpaces!==d.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==d.trimAutoWhitespace}}}e.TextModelResolvedOptions=S;class _{constructor(d,f){this._findMatchBrand=void 0,this.range=d,this.matches=f}}e.FindMatch=_;var C;(function(a){a[a.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",a[a.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",a[a.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",a[a.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var n;(function(a){a[a.Left=0]="Left",a[a.Right=1]="Right",a[a.None=2]="None"})(n=e.PositionAffinity||(e.PositionAffinity={}));var k;(function(a){a[a.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(k=e.ModelConstants||(e.ModelConstants={}));class l{constructor(d,f,E,w,u,g){this.identifier=d,this.range=f,this.text=E,this.forceMoveMarkers=w,this.isAutoWhitespaceEdit=u,this._isTracked=g}}e.ValidAnnotatedEditOperation=l;class h{constructor(d,f,E){this.reverseEdits=d,this.changes=f,this.trimAutoWhitespaceLineNumbers=E}}e.ApplyEditsResult=h}),define(_e[117],ye([0,1,8,115,36,30,85]),function(ee,e,m,F,D,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const S=999;class _{constructor(u,g,b,t){this.searchString=u,this.isRegex=g,this.matchCase=b,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let u;this.isRegex?u=C(this.searchString):u=this.searchString.indexOf(`
`)>=0;let g=null;try{g=m.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:u,global:!0,unicode:!0})}catch(t){return null}if(!g)return null;let b=!this.isRegex&&!u;return b&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(b=this.matchCase),new n(g,this.wordSeparators?(0,F.getMapForWordSeparators)(this.wordSeparators):null,b?this.searchString:null)}}e.SearchParams=_;function C(w){if(!w||w.length===0)return!1;for(let u=0,g=w.length;u<g;u++)if(w.charCodeAt(u)===92){if(u++,u>=g)break;const t=w.charCodeAt(u);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=C;class n{constructor(u,g,b){this.regex=u,this.wordSeparators=g,this.simpleSearch=b}}e.SearchData=n;function k(w,u,g){if(!g)return new I.FindMatch(w,null);let b=[];for(let t=0,s=u.length;t<s;t++)b[t]=u[t];return new I.FindMatch(w,b)}e.createFindMatch=k;class l{constructor(u){let g=[],b=0;for(let t=0,s=u.length;t<s;t++)u.charCodeAt(t)===10&&(g[b++]=t);this._lineFeedsOffsets=g}findLineFeedCountBeforeOffset(u){const g=this._lineFeedsOffsets;let b=0,t=g.length-1;if(t===-1||u<=g[0])return 0;for(;b<t;){const s=b+((t-b)/2>>0);g[s]>=u?t=s-1:g[s+1]>=u?(b=s,t=s):b=s+1}return b+1}}class h{static findMatches(u,g,b,t,s){const i=g.parseSearchRequest();return i?i.regex.multiline?this._doFindMatchesMultiline(u,b,new E(i.wordSeparators,i.regex),t,s):this._doFindMatchesLineByLine(u,b,i,t,s):[]}static _getMultilineMatchRange(u,g,b,t,s,i){let r,c=0;t?(c=t.findLineFeedCountBeforeOffset(s),r=g+s+c):r=g+s;let p;if(t){let o=t.findLineFeedCountBeforeOffset(s+i.length)-c;p=r+i.length+o}else p=r+i.length;const v=u.getPositionAt(r),A=u.getPositionAt(p);return new y.Range(v.lineNumber,v.column,A.lineNumber,A.column)}static _doFindMatchesMultiline(u,g,b,t,s){const i=u.getOffsetAt(g.getStartPosition()),r=u.getValueInRange(g,1),c=u.getEOL()===`\r
`?new l(r):null,p=[];let v=0,A;for(b.reset(0);A=b.next(r);)if(p[v++]=k(this._getMultilineMatchRange(u,i,r,c,A.index,A[0]),A,t),v>=s)return p;return p}static _doFindMatchesLineByLine(u,g,b,t,s){const i=[];let r=0;if(g.startLineNumber===g.endLineNumber){const p=u.getLineContent(g.startLineNumber).substring(g.startColumn-1,g.endColumn-1);return r=this._findMatchesInLine(b,p,g.startLineNumber,g.startColumn-1,r,i,t,s),i}const c=u.getLineContent(g.startLineNumber).substring(g.startColumn-1);r=this._findMatchesInLine(b,c,g.startLineNumber,g.startColumn-1,r,i,t,s);for(let p=g.startLineNumber+1;p<g.endLineNumber&&r<s;p++)r=this._findMatchesInLine(b,u.getLineContent(p),p,0,r,i,t,s);if(r<s){const p=u.getLineContent(g.endLineNumber).substring(0,g.endColumn-1);r=this._findMatchesInLine(b,p,g.endLineNumber,0,r,i,t,s)}return i}static _findMatchesInLine(u,g,b,t,s,i,r,c){const p=u.wordSeparators;if(!r&&u.simpleSearch){const R=u.simpleSearch,o=R.length,P=g.length;let N=-o;for(;(N=g.indexOf(R,N+o))!==-1;)if((!p||f(p,g,P,N,o))&&(i[s++]=new I.FindMatch(new y.Range(b,N+1+t,b,N+1+o+t),null),s>=c))return s;return s}const v=new E(u.wordSeparators,u.regex);let A;v.reset(0);do if(A=v.next(g),A&&(i[s++]=k(new y.Range(b,A.index+1+t,b,A.index+1+A[0].length+t),A,r),s>=c))return s;while(A);return s}static findNextMatch(u,g,b,t){const s=g.parseSearchRequest();if(!s)return null;const i=new E(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindNextMatchMultiline(u,b,i,t):this._doFindNextMatchLineByLine(u,b,i,t)}static _doFindNextMatchMultiline(u,g,b,t){const s=new D.Position(g.lineNumber,1),i=u.getOffsetAt(s),r=u.getLineCount(),c=u.getValueInRange(new y.Range(s.lineNumber,s.column,r,u.getLineMaxColumn(r)),1),p=u.getEOL()===`\r
`?new l(c):null;b.reset(g.column-1);let v=b.next(c);return v?k(this._getMultilineMatchRange(u,i,c,p,v.index,v[0]),v,t):g.lineNumber!==1||g.column!==1?this._doFindNextMatchMultiline(u,new D.Position(1,1),b,t):null}static _doFindNextMatchLineByLine(u,g,b,t){const s=u.getLineCount(),i=g.lineNumber,r=u.getLineContent(i),c=this._findFirstMatchInLine(b,r,i,g.column,t);if(c)return c;for(let p=1;p<=s;p++){const v=(i+p-1)%s,A=u.getLineContent(v+1),R=this._findFirstMatchInLine(b,A,v+1,1,t);if(R)return R}return null}static _findFirstMatchInLine(u,g,b,t,s){u.reset(t-1);const i=u.next(g);return i?k(new y.Range(b,i.index+1,b,i.index+1+i[0].length),i,s):null}static findPreviousMatch(u,g,b,t){const s=g.parseSearchRequest();if(!s)return null;const i=new E(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindPreviousMatchMultiline(u,b,i,t):this._doFindPreviousMatchLineByLine(u,b,i,t)}static _doFindPreviousMatchMultiline(u,g,b,t){const s=this._doFindMatchesMultiline(u,new y.Range(1,1,g.lineNumber,g.column),b,t,10*S);if(s.length>0)return s[s.length-1];const i=u.getLineCount();return g.lineNumber!==i||g.column!==u.getLineMaxColumn(i)?this._doFindPreviousMatchMultiline(u,new D.Position(i,u.getLineMaxColumn(i)),b,t):null}static _doFindPreviousMatchLineByLine(u,g,b,t){const s=u.getLineCount(),i=g.lineNumber,r=u.getLineContent(i).substring(0,g.column-1),c=this._findLastMatchInLine(b,r,i,t);if(c)return c;for(let p=1;p<=s;p++){const v=(s+i-p-1)%s,A=u.getLineContent(v+1),R=this._findLastMatchInLine(b,A,v+1,t);if(R)return R}return null}static _findLastMatchInLine(u,g,b,t){let s=null,i;for(u.reset(0);i=u.next(g);)s=k(new y.Range(b,i.index+1,b,i.index+1+i[0].length),i,t);return s}}e.TextModelSearch=h;function a(w,u,g,b,t){if(b===0)return!0;const s=u.charCodeAt(b-1);if(w.get(s)!==0||s===13||s===10)return!0;if(t>0){const i=u.charCodeAt(b);if(w.get(i)!==0)return!0}return!1}function d(w,u,g,b,t){if(b+t===g)return!0;const s=u.charCodeAt(b+t);if(w.get(s)!==0||s===13||s===10)return!0;if(t>0){const i=u.charCodeAt(b+t-1);if(w.get(i)!==0)return!0}return!1}function f(w,u,g,b,t){return a(w,u,g,b,t)&&d(w,u,g,b,t)}e.isValidMatch=f;class E{constructor(u,g){this._wordSeparators=u,this._searchRegex=g,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(u){this._searchRegex.lastIndex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(u){const g=u.length;let b;do{if(this._prevMatchStartIndex+this._prevMatchLength===g||(b=this._searchRegex.exec(u),!b))return null;const t=b.index,s=b[0].length;if(t===this._prevMatchStartIndex&&s===this._prevMatchLength){if(s===0){m.getNextCodePoint(u,g,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=s,!this._wordSeparators||f(this._wordSeparators,u,g,t,s))return b}while(b);return null}}e.Searcher=E}),define(_e[86],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function m(S=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)S.indexOf(C)>=0||(_+="\\"+C);return _+="\\s]+)",new RegExp(_,"g")}e.DEFAULT_WORD_REGEXP=m();function F(S){let _=e.DEFAULT_WORD_REGEXP;if(S&&S instanceof RegExp)if(S.global)_=S;else{let C="g";S.ignoreCase&&(C+="i"),S.multiline&&(C+="m"),S.unicode&&(C+="u"),_=new RegExp(S.source,C)}return _.lastIndex=0,_}e.ensureValidWordDefinition=F;const D={maxLen:1e3,windowSize:15,timeBudget:150};function y(S,_,C,n,k=D){if(C.length>k.maxLen){let f=S-k.maxLen/2;return f<0?f=0:n+=f,C=C.substring(f,S+k.maxLen/2),y(S,_,C,n,k)}const l=Date.now(),h=S-1-n;let a=-1,d=null;for(let f=1;!(Date.now()-l>=k.timeBudget);f++){const E=h-k.windowSize*f;_.lastIndex=Math.max(0,E);const w=I(_,C,h,a);if(!w&&d||(d=w,E<=0))break;a=E}if(d){let f={word:d[0],startColumn:n+1+d.index,endColumn:n+1+d.index+d[0].length};return _.lastIndex=0,f}return null}e.getWordAtText=y;function I(S,_,C,n){let k;for(;k=S.exec(_);){const l=k.index||0;if(l<=C&&S.lastIndex>=C)return k;if(n>0&&l>n)return null}return null}}),define(_e[118],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var m;(function(I){I[I.None=0]="None",I[I.Indent=1]="Indent",I[I.IndentOutdent=2]="IndentOutdent",I[I.Outdent=3]="Outdent"})(m=e.IndentAction||(e.IndentAction={}));class F{constructor(S){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=S.open,this.close=S.close,this._standardTokenMask=0,Array.isArray(S.notIn))for(let _=0,C=S.notIn.length;_<C;_++)switch(S.notIn[_]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(S){return(this._standardTokenMask&S)==0}}e.StandardAutoClosingPairConditional=F;class D{constructor(S){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of S)y(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),y(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),y(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),y(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&y(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=D;function y(I,S,_){I.has(S)?I.get(S).push(_):I.set(S,[_])}}),define(_e[55],ye([0,1,27,14]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(y,I,S,_){if(Array.isArray(y)){let C=0;for(const n of y){const k=D(n,I,S,_);if(k===10)return k;k>C&&(C=k)}return C}else{if(typeof y=="string")return _?y==="*"?5:y===S?10:0:0;if(y){const{language:C,pattern:n,scheme:k,hasAccessToAllModels:l}=y;if(!_&&!l)return 0;let h=0;if(k)if(k===I.scheme)h=10;else if(k==="*")h=5;else return 0;if(C)if(C===S)h=10;else if(C==="*")h=Math.max(h,5);else return 0;if(n){let a;if(typeof n=="string"?a=n:a={...n,base:(0,F.normalize)(n.base)},a===I.fsPath||(0,m.match)(a,I.fsPath))h=10;else return 0}return h}else return 0}}e.score=D}),define(_e[119],ye([0,1,84]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var F;(function(h){h[h.Invalid=0]="Invalid",h[h.Start=1]="Start",h[h.H=2]="H",h[h.HT=3]="HT",h[h.HTT=4]="HTT",h[h.HTTP=5]="HTTP",h[h.F=6]="F",h[h.FI=7]="FI",h[h.FIL=8]="FIL",h[h.BeforeColon=9]="BeforeColon",h[h.AfterColon=10]="AfterColon",h[h.AlmostThere=11]="AlmostThere",h[h.End=12]="End",h[h.Accept=13]="Accept",h[h.LastKnownState=14]="LastKnownState"})(F=e.State||(e.State={}));class D{constructor(a,d,f){const E=new Uint8Array(a*d);for(let w=0,u=a*d;w<u;w++)E[w]=f;this._data=E,this.rows=a,this.cols=d}get(a,d){return this._data[a*this.cols+d]}set(a,d,f){this._data[a*this.cols+d]=f}}e.Uint8Matrix=D;class y{constructor(a){let d=0,f=0;for(let w=0,u=a.length;w<u;w++){let[g,b,t]=a[w];b>d&&(d=b),g>f&&(f=g),t>f&&(f=t)}d++,f++;let E=new D(f,d,0);for(let w=0,u=a.length;w<u;w++){let[g,b,t]=a[w];E.set(g,b,t)}this._states=E,this._maxCharCode=d}nextState(a,d){return d<0||d>=this._maxCharCode?0:this._states.get(a,d)}}e.StateMachine=y;let I=null;function S(){return I===null&&(I=new y([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),I}var _;(function(h){h[h.None=0]="None",h[h.ForceTermination=1]="ForceTermination",h[h.CannotEndIn=2]="CannotEndIn"})(_||(_={}));let C=null;function n(){if(C===null){C=new m.CharacterClassifier(0);const h=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<h.length;d++)C.set(h.charCodeAt(d),1);const a=".,;";for(let d=0;d<a.length;d++)C.set(a.charCodeAt(d),2)}return C}class k{static _createLink(a,d,f,E,w){let u=w-1;do{const g=d.charCodeAt(u);if(a.get(g)!==2)break;u--}while(u>E);if(E>0){const g=d.charCodeAt(E-1),b=d.charCodeAt(u);(g===40&&b===41||g===91&&b===93||g===123&&b===125)&&u--}return{range:{startLineNumber:f,startColumn:E+1,endLineNumber:f,endColumn:u+2},url:d.substring(E,u+1)}}static computeLinks(a,d=S()){const f=n();let E=[];for(let w=1,u=a.getLineCount();w<=u;w++){const g=a.getLineContent(w),b=g.length;let t=0,s=0,i=0,r=1,c=!1,p=!1,v=!1,A=!1;for(;t<b;){let R=!1;const o=g.charCodeAt(t);if(r===13){let P;switch(o){case 40:c=!0,P=0;break;case 41:P=c?0:1;break;case 91:v=!0,p=!0,P=0;break;case 93:v=!1,P=p?0:1;break;case 123:A=!0,P=0;break;case 125:P=A?0:1;break;case 39:P=i===34||i===96?0:1;break;case 34:P=i===39||i===96?0:1;break;case 96:P=i===39||i===34?0:1;break;case 42:P=i===42?1:0;break;case 124:P=i===124?1:0;break;case 32:P=v?0:1;break;default:P=f.get(o)}P===1&&(E.push(k._createLink(f,g,w,s,t)),R=!0)}else if(r===12){let P;o===91?(p=!0,P=0):P=f.get(o),P===1?R=!0:r=13}else r=d.nextState(r,o),r===0&&(R=!0);R&&(r=1,c=!1,p=!1,A=!1,s=t+1,i=o),t++}r===13&&E.push(k._createLink(f,g,w,s,b))}return E}}e.LinkComputer=k;function l(h){return!h||typeof h.getLineCount!="function"||typeof h.getLineContent!="function"?[]:k.computeLinks(h)}e.computeLinks=l}),define(_e[120],ye([0,1,3,7]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class D{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new m.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(I){this._onDidChange.fire({changedLanguages:I,changedColorMap:!1})}register(I,S){return this._map.set(I,S),this.fire([I]),(0,F.toDisposable)(()=>{this._map.get(I)===S&&(this._map.delete(I),this.fire([I]))})}registerPromise(I,S){let _=null,C=!1;return this._promises.set(I,S.then(n=>{this._promises.delete(I),!(C||!n)&&(_=this.register(I,n))})),(0,F.toDisposable)(()=>{C=!0,_&&_.dispose()})}getPromise(I){const S=this.get(I);if(S)return Promise.resolve(S);const _=this._promises.get(I);return _?_.then(C=>this.get(I)):null}get(I){return this._map.get(I)||null}setColorMap(I){this._colorMap=I,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=D}),define(_e[87],ye([0,1,23,21]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(D||(D={}));function y(k){for(let l=0,h=k.length;l<h;l+=4){const a=k[l+0],d=k[l+1],f=k[l+2],E=k[l+3];k[l+0]=E,k[l+1]=f,k[l+2]=d,k[l+3]=a}}function I(k){const l=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return F.isLittleEndian()||y(l),m.VSBuffer.wrap(l)}function S(k){const l=k.buffer;if(F.isLittleEndian()||y(l),l.byteOffset%4==0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const h=new Uint8Array(l.byteLength);return h.set(l),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function _(k){const l=new Uint32Array(C(k));let h=0;if(l[h++]=k.id,k.type==="full")l[h++]=1,l[h++]=k.data.length,l.set(k.data,h),h+=k.data.length;else{l[h++]=2,l[h++]=k.deltas.length;for(const a of k.deltas)l[h++]=a.start,l[h++]=a.deleteCount,a.data?(l[h++]=a.data.length,l.set(a.data,h),h+=a.data.length):l[h++]=0}return I(l)}e.encodeSemanticTokensDto=_;function C(k){let l=0;if(l+=1+1,k.type==="full")l+=1+k.data.length;else{l+=1,l+=(1+1+1)*k.deltas.length;for(const h of k.deltas)h.data&&(l+=h.data.length)}return l}function n(k){const l=S(k);let h=0;const a=l[h++];if(l[h++]===1){const w=l[h++],u=l.subarray(h,h+w);return h+=w,{id:a,type:"full",data:u}}const f=l[h++];let E=[];for(let w=0;w<f;w++){const u=l[h++],g=l[h++],b=l[h++];let t;b>0&&(t=l.subarray(h,h+b),h+=b),E[w]={start:u,deleteCount:g,data:t}}return{id:a,type:"delta",deltas:E}}e.decodeSemanticTokensDto=n}),define(_e[88],ye([0,1,80]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class F{constructor(I,S){this._prefixSumIndexOfResultBrand=void 0,this.index=I,this.remainder=S}}e.PrefixSumIndexOfResult=F;class D{constructor(I){this.values=I,this.prefixSum=new Uint32Array(I.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(I,S){I=(0,m.toUint32)(I);const _=this.values,C=this.prefixSum,n=S.length;return n===0?!1:(this.values=new Uint32Array(_.length+n),this.values.set(_.subarray(0,I),0),this.values.set(_.subarray(I),I+n),this.values.set(S,I),I-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=I-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(I,S){return I=(0,m.toUint32)(I),S=(0,m.toUint32)(S),this.values[I]===S?!1:(this.values[I]=S,I-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=I-1),!0)}removeValues(I,S){I=(0,m.toUint32)(I),S=(0,m.toUint32)(S);const _=this.values,C=this.prefixSum;if(I>=_.length)return!1;let n=_.length-I;return S>=n&&(S=n),S===0?!1:(this.values=new Uint32Array(_.length-S),this.values.set(_.subarray(0,I),0),this.values.set(_.subarray(I+S),I),this.prefixSum=new Uint32Array(this.values.length),I-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=I-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(I){return I<0?0:(I=(0,m.toUint32)(I),this._getPrefixSum(I))}_getPrefixSum(I){if(I<=this.prefixSumValidIndex[0])return this.prefixSum[I];let S=this.prefixSumValidIndex[0]+1;S===0&&(this.prefixSum[0]=this.values[0],S++),I>=this.values.length&&(I=this.values.length-1);for(let _=S;_<=I;_++)this.prefixSum[_]=this.prefixSum[_-1]+this.values[_];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],I),this.prefixSum[I]}getIndexOf(I){I=Math.floor(I),this.getTotalSum();let S=0,_=this.values.length-1,C=0,n=0,k=0;for(;S<=_;)if(C=S+(_-S)/2|0,n=this.prefixSum[C],k=n-this.values[C],I<k)_=C-1;else if(I>=n)S=C+1;else break;return new F(C,I-k)}}e.PrefixSumComputer=D}),define(_e[121],ye([0,1,8,36,88]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class y{constructor(S,_,C,n){this._uri=S,this._lines=_,this._eol=C,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(S){S.eol&&S.eol!==this._eol&&(this._eol=S.eol,this._lineStarts=null);const _=S.changes;for(const C of _)this._acceptDeleteRange(C.range),this._acceptInsertText(new F.Position(C.range.startLineNumber,C.range.startColumn),C.text);this._versionId=S.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const S=this._eol.length,_=this._lines.length,C=new Uint32Array(_);for(let n=0;n<_;n++)C[n]=this._lines[n].length+S;this._lineStarts=new D.PrefixSumComputer(C)}}_setLineText(S,_){this._lines[S]=_,this._lineStarts&&this._lineStarts.changeValue(S,this._lines[S].length+this._eol.length)}_acceptDeleteRange(S){if(S.startLineNumber===S.endLineNumber){if(S.startColumn===S.endColumn)return;this._setLineText(S.startLineNumber-1,this._lines[S.startLineNumber-1].substring(0,S.startColumn-1)+this._lines[S.startLineNumber-1].substring(S.endColumn-1));return}this._setLineText(S.startLineNumber-1,this._lines[S.startLineNumber-1].substring(0,S.startColumn-1)+this._lines[S.endLineNumber-1].substring(S.endColumn-1)),this._lines.splice(S.startLineNumber,S.endLineNumber-S.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(S.startLineNumber,S.endLineNumber-S.startLineNumber)}_acceptInsertText(S,_){if(_.length===0)return;let C=(0,m.splitLines)(_);if(C.length===1){this._setLineText(S.lineNumber-1,this._lines[S.lineNumber-1].substring(0,S.column-1)+C[0]+this._lines[S.lineNumber-1].substring(S.column-1));return}C[C.length-1]+=this._lines[S.lineNumber-1].substring(S.column-1),this._setLineText(S.lineNumber-1,this._lines[S.lineNumber-1].substring(0,S.column-1)+C[0]);let n=new Uint32Array(C.length-1);for(let k=1;k<C.length;k++)this._lines.splice(S.lineNumber+k-1,0,C[k]),n[k-1]=C[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(S.lineNumber,n)}}e.MirrorTextModel=y}),define(_e[122],ye([19,20]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(_e[56],ye([0,1,122,10,17]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function y(C,n){return n&&(C.stack||C.stacktrace)?m.localize(0,null,S(C),I(C.stack)||I(C.stacktrace)):S(C)}function I(C){return Array.isArray(C)?C.join(`
`):C}function S(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?m.localize(1,null,C.message):C.message||m.localize(2,null)}function _(C=null,n=!1){if(!C)return m.localize(3,null);if(Array.isArray(C)){const k=D.coalesce(C),l=_(k[0],n);return k.length>1?m.localize(4,null,l,k.length):l}if(F.isString(C))return C;if(C.detail){const k=C.detail;if(k.error)return y(k.error,n);if(k.exception)return y(k.exception,n)}return C.stack?y(C,n):C.message?C.message:m.localize(5,null)}e.toErrorMessage=_}),define(_e[123],ye([19,20]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(_e[124],ye([0,1,123,21,86]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(W){W[W.None=0]="None",W[W.Keep=1]="Keep",W[W.Brackets=2]="Brackets",W[W.Advanced=3]="Advanced",W[W.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class I{constructor(J){this._values=J}hasChanged(J){return this._values[J]}}e.ConfigurationChangedEvent=I;class S{constructor(){this._values=[]}_read(J){return this._values[J]}get(J){return this._values[J]}_write(J,fe){this._values[J]=fe}}e.ValidatedEditorOptions=S;class _{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=_;class C{constructor(J,fe,Oe,Ue){this.id=J,this.name=fe,this.defaultValue=Oe,this.schema=Ue}compute(J,fe,Oe){return Oe}}class n{constructor(J,fe=null){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0,this.deps=fe}validate(J){return this.defaultValue}}class k{constructor(J,fe,Oe,Ue){this.id=J,this.name=fe,this.defaultValue=Oe,this.schema=Ue}validate(J){return typeof J=="undefined"?this.defaultValue:J}compute(J,fe,Oe){return Oe}}function l(W,J){return typeof W=="undefined"?J:W==="false"?!1:Boolean(W)}e.boolean=l;class h extends k{constructor(J,fe,Oe,Ue=void 0){typeof Ue!="undefined"&&(Ue.type="boolean",Ue.default=Oe),super(J,fe,Oe,Ue)}validate(J){return l(J,this.defaultValue)}}class a extends k{constructor(J,fe,Oe,Ue,et,Ce=void 0){typeof Ce!="undefined"&&(Ce.type="integer",Ce.default=Oe,Ce.minimum=Ue,Ce.maximum=et),super(J,fe,Oe,Ce),this.minimum=Ue,this.maximum=et}static clampedInt(J,fe,Oe,Ue){if(typeof J=="undefined")return fe;let et=parseInt(J,10);return isNaN(et)?fe:(et=Math.max(Oe,et),et=Math.min(Ue,et),et|0)}validate(J){return a.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}class d extends k{constructor(J,fe,Oe,Ue,et){typeof et!="undefined"&&(et.type="number",et.default=Oe),super(J,fe,Oe,et),this.validationFn=Ue}static clamp(J,fe,Oe){return J<fe?fe:J>Oe?Oe:J}static float(J,fe){if(typeof J=="number")return J;if(typeof J=="undefined")return fe;const Oe=parseFloat(J);return isNaN(Oe)?fe:Oe}validate(J){return this.validationFn(d.float(J,this.defaultValue))}}class f extends k{static string(J,fe){return typeof J!="string"?fe:J}constructor(J,fe,Oe,Ue=void 0){typeof Ue!="undefined"&&(Ue.type="string",Ue.default=Oe),super(J,fe,Oe,Ue)}validate(J){return f.string(J,this.defaultValue)}}function E(W,J,fe){return typeof W!="string"||fe.indexOf(W)===-1?J:W}e.stringSet=E;class w extends k{constructor(J,fe,Oe,Ue,et=void 0){typeof et!="undefined"&&(et.type="string",et.enum=Ue,et.default=Oe),super(J,fe,Oe,et),this._allowedValues=Ue}validate(J){return E(J,this.defaultValue,this._allowedValues)}}class u extends C{constructor(J,fe,Oe,Ue,et,Ce,De=void 0){typeof De!="undefined"&&(De.type="string",De.enum=et,De.default=Ue),super(J,fe,Oe,De),this._allowedValues=et,this._convert=Ce}validate(J){return typeof J!="string"?this.defaultValue:this._allowedValues.indexOf(J)===-1?this.defaultValue:this._convert(J)}}function g(W){switch(W){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class b extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",description:m.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,fe,Oe){return Oe===0?J.accessibilitySupport:Oe}}class t extends C{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:m.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{insertSpace:l(fe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:l(fe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(W){W[W.Hidden=0]="Hidden",W[W.Blink=1]="Blink",W[W.Smooth=2]="Smooth",W[W.Phase=3]="Phase",W[W.Expand=4]="Expand",W[W.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function i(W){switch(W){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var r;(function(W){W[W.Line=1]="Line",W[W.Block=2]="Block",W[W.Underline=3]="Underline",W[W.LineThin=4]="LineThin",W[W.BlockOutline=5]="BlockOutline",W[W.UnderlineThin=6]="UnderlineThin"})(r=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function c(W){switch(W){case r.Line:return"line";case r.Block:return"block";case r.Underline:return"underline";case r.LineThin:return"line-thin";case r.BlockOutline:return"block-outline";case r.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=c;function p(W){switch(W){case"line":return r.Line;case"block":return r.Block;case"underline":return r.Underline;case"line-thin":return r.LineThin;case"block-outline":return r.BlockOutline;case"underline-thin":return r.UnderlineThin}}class v extends n{constructor(){super(125,[63,31])}compute(J,fe,Oe){const Ue=["monaco-editor"];return fe.get(31)&&Ue.push(fe.get(31)),J.extraEditorClassName&&Ue.push(J.extraEditorClassName),fe.get(63)==="default"?Ue.push("mouse-default"):fe.get(63)==="copy"&&Ue.push("mouse-copy"),fe.get(98)&&Ue.push("showUnused"),fe.get(123)&&Ue.push("showDeprecated"),Ue.join(" ")}}class A extends h{constructor(){super(30,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(J,fe,Oe){return Oe&&J.emptySelectionClipboard}}class R extends C{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:J.seedSearchStringFromSelection,description:m.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[m.localize(9,null),m.localize(10,null),m.localize(11,null)],description:m.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:m.localize(13,null),included:F.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:m.localize(14,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:m.localize(15,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{cursorMoveOnType:l(fe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:l(fe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":E(fe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:l(fe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:l(fe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:l(fe.loop,this.defaultValue.loop)}}}class o extends C{constructor(){super(41,"fontLigatures",o.OFF,{anyOf:[{type:"boolean",description:m.localize(16,null)},{type:"string",description:m.localize(17,null)}],description:m.localize(18,null),default:!1})}validate(J){return typeof J=="undefined"?this.defaultValue:typeof J=="string"?J==="false"?o.OFF:J==="true"?o.ON:J:Boolean(J)?o.ON:o.OFF}}e.EditorFontLigatures=o,o.OFF='"liga" off, "calt" off',o.ON='"liga" on, "calt" on';class P extends n{constructor(){super(40)}compute(J,fe,Oe){return J.fontInfo}}class N extends k{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(19,null)})}validate(J){let fe=d.float(J,this.defaultValue);return fe===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(fe,6,100)}compute(J,fe,Oe){return J.fontInfo.fontSize}}class $ extends C{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:$.MINIMUM_VALUE,maximum:$.MAXIMUM_VALUE,errorMessage:m.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:$.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(21,null)})}validate(J){return J==="normal"||J==="bold"?J:String(a.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,$.MINIMUM_VALUE,$.MAXIMUM_VALUE))}}$.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],$.MINIMUM_VALUE=1,$.MAXIMUM_VALUE=1e3;class ie extends C{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},fe={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[m.localize(22,null),m.localize(23,null),m.localize(24,null)]},Oe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(25,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(26,null),...fe},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(27,null),...fe},"editor.gotoLocation.multipleDeclarations":{description:m.localize(28,null),...fe},"editor.gotoLocation.multipleImplementations":{description:m.localize(29,null),...fe},"editor.gotoLocation.multipleReferences":{description:m.localize(30,null),...fe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:Oe,description:m.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:Oe,description:m.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:Oe,description:m.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:Oe,description:m.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:Oe,description:m.localize(35,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{multiple:E(fe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:fe.multipleDefinitions??E(fe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:fe.multipleTypeDefinitions??E(fe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:fe.multipleDeclarations??E(fe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:fe.multipleImplementations??E(fe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:fe.multipleReferences??E(fe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:f.string(fe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:f.string(fe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:f.string(fe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:f.string(fe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:f.string(fe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ce extends C{constructor(){const J={enabled:!0,delay:300,sticky:!0};super(50,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:m.localize(36,null)},"editor.hover.delay":{type:"number",default:J.delay,description:m.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:m.localize(38,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{enabled:l(fe.enabled,this.defaultValue.enabled),delay:a.clampedInt(fe.delay,this.defaultValue.delay,0,1e4),sticky:l(fe.sticky,this.defaultValue.sticky)}}}var K;(function(W){W[W.None=0]="None",W[W.Text=1]="Text",W[W.Blocks=2]="Blocks"})(K=e.RenderMinimap||(e.RenderMinimap={}));class H extends n{constructor(){super(128,[46,55,35,62,90,57,58,92,115,118,119,120,2])}compute(J,fe,Oe){return H.computeLayout(fe,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio})}static computeContainedMinimapLineCount(J){const fe=J.height/J.lineHeight,Oe=J.scrollBeyondLastLine?fe-1:0,Ue=(J.viewLineCount+Oe)/(J.pixelRatio*J.height),et=Math.floor(J.viewLineCount/Ue);return{typicalViewportLineCount:fe,extraLinesBeyondLastLine:Oe,desiredRatio:Ue,minimapLineCount:et}}static _computeMinimapLayout(J,fe){const Oe=J.outerWidth,Ue=J.outerHeight,et=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(et*Ue),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ue};const Ce=fe.stableMinimapLayoutInput,De=Ce&&J.outerHeight===Ce.outerHeight&&J.lineHeight===Ce.lineHeight&&J.typicalHalfwidthCharacterWidth===Ce.typicalHalfwidthCharacterWidth&&J.pixelRatio===Ce.pixelRatio&&J.scrollBeyondLastLine===Ce.scrollBeyondLastLine&&J.minimap.enabled===Ce.minimap.enabled&&J.minimap.side===Ce.minimap.side&&J.minimap.size===Ce.minimap.size&&J.minimap.showSlider===Ce.minimap.showSlider&&J.minimap.renderCharacters===Ce.minimap.renderCharacters&&J.minimap.maxColumn===Ce.minimap.maxColumn&&J.minimap.scale===Ce.minimap.scale&&J.verticalScrollbarWidth===Ce.verticalScrollbarWidth&&J.isViewportWrapping===Ce.isViewportWrapping,Ae=J.lineHeight,ne=J.typicalHalfwidthCharacterWidth,oe=J.scrollBeyondLastLine,de=J.minimap.renderCharacters;let ge=et>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const x=J.minimap.maxColumn,he=J.minimap.size,we=J.minimap.side,Pe=J.verticalScrollbarWidth,Fe=J.viewLineCount,He=J.remainingWidth,Ze=J.isViewportWrapping,Qe=de?2:3;let Ye=Math.floor(et*Ue);const at=Ye/et;let ct=!1,wt=!1,me=Qe*ge,Ee=ge/et,ae=1;if(he==="fill"||he==="fit"){const{typicalViewportLineCount:ht,extraLinesBeyondLastLine:St,desiredRatio:Ct,minimapLineCount:Et}=H.computeContainedMinimapLineCount({viewLineCount:Fe,scrollBeyondLastLine:oe,height:Ue,lineHeight:Ae,pixelRatio:et});if(Fe/Et>1)ct=!0,wt=!0,ge=1,me=1,Ee=ge/et;else{let _t=!1,dt=ge+1;if(he==="fit"){const bt=Math.ceil((Fe+St)*me);Ze&&De&&He<=fe.stableFitRemainingWidth?(_t=!0,dt=fe.stableFitMaxMinimapScale):_t=bt>Ye}if(he==="fill"||_t){ct=!0;const bt=ge;me=Math.min(Ae*et,Math.max(1,Math.floor(1/Ct))),Ze&&De&&He<=fe.stableFitRemainingWidth&&(dt=fe.stableFitMaxMinimapScale),ge=Math.min(dt,Math.max(1,Math.floor(me/Qe))),ge>bt&&(ae=Math.min(2,ge/bt)),Ee=ge/et/ae,Ye=Math.ceil(Math.max(ht,Fe+St)*me),Ze?(fe.stableMinimapLayoutInput=J,fe.stableFitRemainingWidth=He,fe.stableFitMaxMinimapScale=ge):(fe.stableMinimapLayoutInput=null,fe.stableFitRemainingWidth=0)}}}const V=Math.floor(x*Ee),be=Math.min(V,Math.max(0,Math.floor((He-Pe-2)*Ee/(ne+Ee)))+e.MINIMAP_GUTTER_WIDTH);let Be=Math.floor(et*be);const Xe=Be/et;Be=Math.floor(Be*ae);const Ve=de?1:2,lt=we==="left"?0:Oe-be-Pe;return{renderMinimap:Ve,minimapLeft:lt,minimapWidth:be,minimapHeightIsEditorHeight:ct,minimapIsSampling:wt,minimapScale:ge,minimapLineHeight:me,minimapCanvasInnerWidth:Be,minimapCanvasInnerHeight:Ye,minimapCanvasOuterWidth:Xe,minimapCanvasOuterHeight:at}}static computeLayout(J,fe){const Oe=fe.outerWidth|0,Ue=fe.outerHeight|0,et=fe.lineHeight|0,Ce=fe.lineNumbersDigitCount|0,De=fe.typicalHalfwidthCharacterWidth,Ae=fe.maxDigitWidth,ne=fe.pixelRatio,oe=fe.viewLineCount,de=J.get(120),ge=de==="inherit"?J.get(119):de,x=ge==="inherit"?J.get(115):ge,he=J.get(118),we=J.get(2),Pe=fe.isDominatedByLongLines,Fe=J.get(46),He=J.get(57).renderType!==0,Ze=J.get(58),Qe=J.get(92),Ye=J.get(62),at=J.get(90),ct=at.verticalScrollbarSize,wt=at.verticalHasArrows,me=at.arrowSize,Ee=at.horizontalScrollbarSize,ae=J.get(55),V=J.get(35);let be;if(typeof ae=="string"&&/^\d+(\.\d+)?ch$/.test(ae)){const Pt=parseFloat(ae.substr(0,ae.length-2));be=a.clampedInt(Pt*De,0,0,1e3)}else be=a.clampedInt(ae,0,0,1e3);V&&(be+=16);let Be=0;if(He){const Pt=Math.max(Ce,Ze);Be=Math.round(Pt*Ae)}let Xe=0;Fe&&(Xe=et);let Ve=0,lt=Ve+Xe,ht=lt+Be,St=ht+be;const Ct=Oe-Xe-Be-be;let Et=!1,vt=!1,_t=-1;we!==2&&(ge==="inherit"&&Pe?(Et=!0,vt=!0):x==="on"||x==="bounded"?vt=!0:x==="wordWrapColumn"&&(_t=he));const dt=H._computeMinimapLayout({outerWidth:Oe,outerHeight:Ue,lineHeight:et,typicalHalfwidthCharacterWidth:De,pixelRatio:ne,scrollBeyondLastLine:Qe,minimap:Ye,verticalScrollbarWidth:ct,viewLineCount:oe,remainingWidth:Ct,isViewportWrapping:vt},fe.memory||new _);dt.renderMinimap!==0&&dt.minimapLeft===0&&(Ve+=dt.minimapWidth,lt+=dt.minimapWidth,ht+=dt.minimapWidth,St+=dt.minimapWidth);const bt=Ct-dt.minimapWidth,ft=Math.max(1,Math.floor((bt-ct-2)/De)),Ot=wt?me:0;return vt&&(_t=Math.max(1,ft),x==="bounded"&&(_t=Math.min(_t,he))),{width:Oe,height:Ue,glyphMarginLeft:Ve,glyphMarginWidth:Xe,lineNumbersLeft:lt,lineNumbersWidth:Be,decorationsLeft:ht,decorationsWidth:be,contentLeft:St,contentWidth:bt,minimap:dt,viewportColumn:ft,isWordWrapMinified:Et,isViewportWrapping:vt,wrappingColumn:_t,verticalScrollbarWidth:ct,horizontalScrollbarHeight:Ee,overviewRuler:{top:Ot,width:ct,height:Ue-2*Ot,right:0}}}}e.EditorLayoutInfoComputer=H;class z extends C{constructor(){const J={enabled:!0};super(54,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:m.localize(39,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:l(J.enabled,this.defaultValue.enabled)}}}class T extends C{constructor(){const J={enabled:!0,fontSize:0,fontFamily:""};super(124,"inlayHints",J,{"editor.inlayHints.enabled":{type:"boolean",default:J.enabled,description:m.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:m.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,description:m.localize(42,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{enabled:l(fe.enabled,this.defaultValue.enabled),fontSize:a.clampedInt(fe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:f.string(fe.fontFamily,this.defaultValue.fontFamily)}}}class q extends d{constructor(){super(56,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>d.clamp(J,0,150),{markdownDescription:m.localize(43,null)})}compute(J,fe,Oe){return J.fontInfo.lineHeight}}class L extends C{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(62,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:m.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(45,null),m.localize(46,null),m.localize(47,null)],default:J.size,description:m.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:m.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:m.localize(50,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:m.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:m.localize(53,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{enabled:l(fe.enabled,this.defaultValue.enabled),size:E(fe.size,this.defaultValue.size,["proportional","fill","fit"]),side:E(fe.side,this.defaultValue.side,["right","left"]),showSlider:E(fe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:l(fe.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(fe.scale,1,1,3),maxColumn:a.clampedInt(fe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function B(W){return W==="ctrlCmd"?F.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Y extends C{constructor(){super(72,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(55,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{top:a.clampedInt(fe.top,0,0,1e3),bottom:a.clampedInt(fe.bottom,0,0,1e3)}}}class j extends C{constructor(){const J={enabled:!0,cycle:!1};super(73,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:m.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:m.localize(57,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{enabled:l(fe.enabled,this.defaultValue.enabled),cycle:l(fe.cycle,this.defaultValue.cycle)}}}class se extends n{constructor(){super(126)}compute(J,fe,Oe){return J.pixelRatio}}class Se extends C{constructor(){const J={other:!0,comments:!1,strings:!1};super(76,"quickSuggestions",J,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:J.strings,description:m.localize(58,null)},comments:{type:"boolean",default:J.comments,description:m.localize(59,null)},other:{type:"boolean",default:J.other,description:m.localize(60,null)}}}],default:J,description:m.localize(61,null)});this.defaultValue=J}validate(J){if(typeof J=="boolean")return J;if(J&&typeof J=="object"){const fe=J,Oe={other:l(fe.other,this.defaultValue.other),comments:l(fe.comments,this.defaultValue.comments),strings:l(fe.strings,this.defaultValue.strings)};return Oe.other&&Oe.comments&&Oe.strings?!0:!Oe.other&&!Oe.comments&&!Oe.strings?!1:Oe}return this.defaultValue}}var Re;(function(W){W[W.Off=0]="Off",W[W.On=1]="On",W[W.Relative=2]="Relative",W[W.Interval=3]="Interval",W[W.Custom=4]="Custom"})(Re=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class $e extends C{constructor(){super(57,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(62,null),m.localize(63,null),m.localize(64,null),m.localize(65,null)],default:"on",description:m.localize(66,null)})}validate(J){let fe=this.defaultValue.renderType,Oe=this.defaultValue.renderFn;return typeof J!="undefined"&&(typeof J=="function"?(fe=4,Oe=J):J==="interval"?fe=3:J==="relative"?fe=2:J==="on"?fe=1:fe=0),{renderType:fe,renderFn:Oe}}}function Ne(W){const J=W.get(85);return J==="editable"?W.get(78):J!=="on"}e.filterValidationDecorations=Ne;class Ge extends C{constructor(){const J=[],fe={type:"number",description:m.localize(67,null)};super(89,"rulers",J,{type:"array",items:{anyOf:[fe,{type:["object"],properties:{column:fe,color:{type:"string",description:m.localize(68,null),format:"color-hex"}}}]},default:J,description:m.localize(69,null)})}validate(J){if(Array.isArray(J)){let fe=[];for(let Oe of J)if(typeof Oe=="number")fe.push({column:a.clampedInt(Oe,0,0,1e4),color:null});else if(Oe&&typeof Oe=="object"){const Ue=Oe;fe.push({column:a.clampedInt(Ue.column,0,0,1e4),color:Ue.color})}return fe.sort((Oe,Ue)=>Oe.column-Ue.column),fe}return this.defaultValue}}function Ke(W,J){if(typeof W!="string")return J;switch(W){case"hidden":return 2;case"visible":return 3;default:return 1}}class qe extends C{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(90,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(70,null),m.localize(71,null),m.localize(72,null)],default:"auto",description:m.localize(73,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(74,null),m.localize(75,null),m.localize(76,null)],default:"auto",description:m.localize(77,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:m.localize(78,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:m.localize(79,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:m.localize(80,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J,Oe=a.clampedInt(fe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ue=a.clampedInt(fe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(fe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ke(fe.vertical,this.defaultValue.vertical),horizontal:Ke(fe.horizontal,this.defaultValue.horizontal),useShadows:l(fe.useShadows,this.defaultValue.useShadows),verticalHasArrows:l(fe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:l(fe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:l(fe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:l(fe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Oe,horizontalSliderSize:a.clampedInt(fe.horizontalSliderSize,Oe,0,1e3),verticalScrollbarSize:Ue,verticalSliderSize:a.clampedInt(fe.verticalSliderSize,Ue,0,1e3),scrollByPage:l(fe.scrollByPage,this.defaultValue.scrollByPage)}}}class U extends C{constructor(){const J={enabled:!1,mode:"subwordSmart"};super(52,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:m.localize(81,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[m.localize(82,null),m.localize(83,null),m.localize(84,null)],default:J.mode,description:m.localize(85,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{enabled:l(fe.enabled,this.defaultValue.enabled),mode:E(fe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class G extends C{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(104,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(86,null),m.localize(87,null)],default:J.insertMode,description:m.localize(88,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:m.localize(89,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:m.localize(90,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:m.localize(91,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:m.localize(92,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:m.localize(93,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:m.localize(94,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:m.localize(95,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[m.localize(96,null),m.localize(97,null),m.localize(98,null)],default:J.previewMode,description:m.localize(99,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:m.localize(100,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(101,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(102,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(103,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(104,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(105,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(106,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(107,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(108,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(109,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(110,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(111,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(112,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(113,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(114,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(115,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(116,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(117,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(118,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(119,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(120,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(121,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(122,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(123,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(124,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(125,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(126,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(127,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(128,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(129,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(130,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(131,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const fe=J;return{insertMode:E(fe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:l(fe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:l(fe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:l(fe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:l(fe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:l(fe.showIcons,this.defaultValue.showIcons),showStatusBar:l(fe.showStatusBar,this.defaultValue.showStatusBar),preview:l(fe.preview,this.defaultValue.preview),previewMode:E(fe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:l(fe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:l(fe.showMethods,this.defaultValue.showMethods),showFunctions:l(fe.showFunctions,this.defaultValue.showFunctions),showConstructors:l(fe.showConstructors,this.defaultValue.showConstructors),showDeprecated:l(fe.showDeprecated,this.defaultValue.showDeprecated),showFields:l(fe.showFields,this.defaultValue.showFields),showVariables:l(fe.showVariables,this.defaultValue.showVariables),showClasses:l(fe.showClasses,this.defaultValue.showClasses),showStructs:l(fe.showStructs,this.defaultValue.showStructs),showInterfaces:l(fe.showInterfaces,this.defaultValue.showInterfaces),showModules:l(fe.showModules,this.defaultValue.showModules),showProperties:l(fe.showProperties,this.defaultValue.showProperties),showEvents:l(fe.showEvents,this.defaultValue.showEvents),showOperators:l(fe.showOperators,this.defaultValue.showOperators),showUnits:l(fe.showUnits,this.defaultValue.showUnits),showValues:l(fe.showValues,this.defaultValue.showValues),showConstants:l(fe.showConstants,this.defaultValue.showConstants),showEnums:l(fe.showEnums,this.defaultValue.showEnums),showEnumMembers:l(fe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:l(fe.showKeywords,this.defaultValue.showKeywords),showWords:l(fe.showWords,this.defaultValue.showWords),showColors:l(fe.showColors,this.defaultValue.showColors),showFiles:l(fe.showFiles,this.defaultValue.showFiles),showReferences:l(fe.showReferences,this.defaultValue.showReferences),showFolders:l(fe.showFolders,this.defaultValue.showFolders),showTypeParameters:l(fe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:l(fe.showSnippets,this.defaultValue.showSnippets),showUsers:l(fe.showUsers,this.defaultValue.showUsers),showIssues:l(fe.showIssues,this.defaultValue.showIssues)}}}class te extends C{constructor(){super(100,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(132,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:l(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class re extends n{constructor(){super(127,[78])}compute(J,fe,Oe){return fe.get(78)?!0:J.tabFocusMode}}var pe;(function(W){W[W.None=0]="None",W[W.Same=1]="Same",W[W.Indent=2]="Indent",W[W.DeepIndent=3]="DeepIndent"})(pe=e.WrappingIndent||(e.WrappingIndent={}));function Q(W){switch(W){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ue extends n{constructor(){super(129,[128])}compute(J,fe,Oe){const Ue=fe.get(128);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:Ue.isWordWrapMinified,isViewportWrapping:Ue.isViewportWrapping,wrappingColumn:Ue.wrappingColumn}}}const Ie="Consolas, 'Courier New', monospace",xe="Menlo, Monaco, 'Courier New', monospace",We="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:F.isMacintosh?xe:F.isLinux?We:Ie,fontWeight:"normal",fontSize:F.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function ve(W){return e.editorOptionsRegistry[W.id]=W,W}var tt;(function(W){W[W.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",W[W.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",W[W.accessibilitySupport=2]="accessibilitySupport",W[W.accessibilityPageSize=3]="accessibilityPageSize",W[W.ariaLabel=4]="ariaLabel",W[W.autoClosingBrackets=5]="autoClosingBrackets",W[W.autoClosingDelete=6]="autoClosingDelete",W[W.autoClosingOvertype=7]="autoClosingOvertype",W[W.autoClosingQuotes=8]="autoClosingQuotes",W[W.autoIndent=9]="autoIndent",W[W.automaticLayout=10]="automaticLayout",W[W.autoSurround=11]="autoSurround",W[W.codeLens=12]="codeLens",W[W.codeLensFontFamily=13]="codeLensFontFamily",W[W.codeLensFontSize=14]="codeLensFontSize",W[W.colorDecorators=15]="colorDecorators",W[W.columnSelection=16]="columnSelection",W[W.comments=17]="comments",W[W.contextmenu=18]="contextmenu",W[W.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",W[W.cursorBlinking=20]="cursorBlinking",W[W.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",W[W.cursorStyle=22]="cursorStyle",W[W.cursorSurroundingLines=23]="cursorSurroundingLines",W[W.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",W[W.cursorWidth=25]="cursorWidth",W[W.disableLayerHinting=26]="disableLayerHinting",W[W.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",W[W.domReadOnly=28]="domReadOnly",W[W.dragAndDrop=29]="dragAndDrop",W[W.emptySelectionClipboard=30]="emptySelectionClipboard",W[W.extraEditorClassName=31]="extraEditorClassName",W[W.fastScrollSensitivity=32]="fastScrollSensitivity",W[W.find=33]="find",W[W.fixedOverflowWidgets=34]="fixedOverflowWidgets",W[W.folding=35]="folding",W[W.foldingStrategy=36]="foldingStrategy",W[W.foldingHighlight=37]="foldingHighlight",W[W.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",W[W.fontFamily=39]="fontFamily",W[W.fontInfo=40]="fontInfo",W[W.fontLigatures=41]="fontLigatures",W[W.fontSize=42]="fontSize",W[W.fontWeight=43]="fontWeight",W[W.formatOnPaste=44]="formatOnPaste",W[W.formatOnType=45]="formatOnType",W[W.glyphMargin=46]="glyphMargin",W[W.gotoLocation=47]="gotoLocation",W[W.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",W[W.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",W[W.hover=50]="hover",W[W.inDiffEditor=51]="inDiffEditor",W[W.inlineSuggest=52]="inlineSuggest",W[W.letterSpacing=53]="letterSpacing",W[W.lightbulb=54]="lightbulb",W[W.lineDecorationsWidth=55]="lineDecorationsWidth",W[W.lineHeight=56]="lineHeight",W[W.lineNumbers=57]="lineNumbers",W[W.lineNumbersMinChars=58]="lineNumbersMinChars",W[W.linkedEditing=59]="linkedEditing",W[W.links=60]="links",W[W.matchBrackets=61]="matchBrackets",W[W.minimap=62]="minimap",W[W.mouseStyle=63]="mouseStyle",W[W.mouseWheelScrollSensitivity=64]="mouseWheelScrollSensitivity",W[W.mouseWheelZoom=65]="mouseWheelZoom",W[W.multiCursorMergeOverlapping=66]="multiCursorMergeOverlapping",W[W.multiCursorModifier=67]="multiCursorModifier",W[W.multiCursorPaste=68]="multiCursorPaste",W[W.occurrencesHighlight=69]="occurrencesHighlight",W[W.overviewRulerBorder=70]="overviewRulerBorder",W[W.overviewRulerLanes=71]="overviewRulerLanes",W[W.padding=72]="padding",W[W.parameterHints=73]="parameterHints",W[W.peekWidgetDefaultFocus=74]="peekWidgetDefaultFocus",W[W.definitionLinkOpensInPeek=75]="definitionLinkOpensInPeek",W[W.quickSuggestions=76]="quickSuggestions",W[W.quickSuggestionsDelay=77]="quickSuggestionsDelay",W[W.readOnly=78]="readOnly",W[W.renameOnType=79]="renameOnType",W[W.renderControlCharacters=80]="renderControlCharacters",W[W.renderIndentGuides=81]="renderIndentGuides",W[W.renderFinalNewline=82]="renderFinalNewline",W[W.renderLineHighlight=83]="renderLineHighlight",W[W.renderLineHighlightOnlyWhenFocus=84]="renderLineHighlightOnlyWhenFocus",W[W.renderValidationDecorations=85]="renderValidationDecorations",W[W.renderWhitespace=86]="renderWhitespace",W[W.revealHorizontalRightPadding=87]="revealHorizontalRightPadding",W[W.roundedSelection=88]="roundedSelection",W[W.rulers=89]="rulers",W[W.scrollbar=90]="scrollbar",W[W.scrollBeyondLastColumn=91]="scrollBeyondLastColumn",W[W.scrollBeyondLastLine=92]="scrollBeyondLastLine",W[W.scrollPredominantAxis=93]="scrollPredominantAxis",W[W.selectionClipboard=94]="selectionClipboard",W[W.selectionHighlight=95]="selectionHighlight",W[W.selectOnLineNumbers=96]="selectOnLineNumbers",W[W.showFoldingControls=97]="showFoldingControls",W[W.showUnused=98]="showUnused",W[W.snippetSuggestions=99]="snippetSuggestions",W[W.smartSelect=100]="smartSelect",W[W.smoothScrolling=101]="smoothScrolling",W[W.stickyTabStops=102]="stickyTabStops",W[W.stopRenderingLineAfter=103]="stopRenderingLineAfter",W[W.suggest=104]="suggest",W[W.suggestFontSize=105]="suggestFontSize",W[W.suggestLineHeight=106]="suggestLineHeight",W[W.suggestOnTriggerCharacters=107]="suggestOnTriggerCharacters",W[W.suggestSelection=108]="suggestSelection",W[W.tabCompletion=109]="tabCompletion",W[W.tabIndex=110]="tabIndex",W[W.unusualLineTerminators=111]="unusualLineTerminators",W[W.useShadowDOM=112]="useShadowDOM",W[W.useTabStops=113]="useTabStops",W[W.wordSeparators=114]="wordSeparators",W[W.wordWrap=115]="wordWrap",W[W.wordWrapBreakAfterCharacters=116]="wordWrapBreakAfterCharacters",W[W.wordWrapBreakBeforeCharacters=117]="wordWrapBreakBeforeCharacters",W[W.wordWrapColumn=118]="wordWrapColumn",W[W.wordWrapOverride1=119]="wordWrapOverride1",W[W.wordWrapOverride2=120]="wordWrapOverride2",W[W.wrappingIndent=121]="wrappingIndent",W[W.wrappingStrategy=122]="wrappingStrategy",W[W.showDeprecated=123]="showDeprecated",W[W.inlayHints=124]="inlayHints",W[W.editorClassName=125]="editorClassName",W[W.pixelRatio=126]="pixelRatio",W[W.tabFocusMode=127]="tabFocusMode",W[W.layoutInfo=128]="layoutInfo",W[W.wrappingInfo=129]="wrappingInfo"})(tt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ve(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(133,null)})),acceptSuggestionOnEnter:ve(new w(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(134,null),""],markdownDescription:m.localize(135,null)})),accessibilitySupport:ve(new b),accessibilityPageSize:ve(new a(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(136,null)})),ariaLabel:ve(new f(4,"ariaLabel",m.localize(137,null))),autoClosingBrackets:ve(new w(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(138,null),m.localize(139,null),""],description:m.localize(140,null)})),autoClosingDelete:ve(new w(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(141,null),""],description:m.localize(142,null)})),autoClosingOvertype:ve(new w(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(143,null),""],description:m.localize(144,null)})),autoClosingQuotes:ve(new w(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(145,null),m.localize(146,null),""],description:m.localize(147,null)})),autoIndent:ve(new u(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],g,{enumDescriptions:[m.localize(148,null),m.localize(149,null),m.localize(150,null),m.localize(151,null),m.localize(152,null)],description:m.localize(153,null)})),automaticLayout:ve(new h(10,"automaticLayout",!1)),autoSurround:ve(new w(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(154,null),m.localize(155,null),m.localize(156,null),""],description:m.localize(157,null)})),stickyTabStops:ve(new h(102,"stickyTabStops",!1,{description:m.localize(158,null)})),codeLens:ve(new h(12,"codeLens",!0,{description:m.localize(159,null)})),codeLensFontFamily:ve(new f(13,"codeLensFontFamily","",{description:m.localize(160,null)})),codeLensFontSize:ve(new a(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(161,null)})),colorDecorators:ve(new h(15,"colorDecorators",!0,{description:m.localize(162,null)})),columnSelection:ve(new h(16,"columnSelection",!1,{description:m.localize(163,null)})),comments:ve(new t),contextmenu:ve(new h(18,"contextmenu",!0)),copyWithSyntaxHighlighting:ve(new h(19,"copyWithSyntaxHighlighting",!0,{description:m.localize(164,null)})),cursorBlinking:ve(new u(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],i,{description:m.localize(165,null)})),cursorSmoothCaretAnimation:ve(new h(21,"cursorSmoothCaretAnimation",!1,{description:m.localize(166,null)})),cursorStyle:ve(new u(22,"cursorStyle",r.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],p,{description:m.localize(167,null)})),cursorSurroundingLines:ve(new a(23,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(168,null)})),cursorSurroundingLinesStyle:ve(new w(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(169,null),m.localize(170,null)],description:m.localize(171,null)})),cursorWidth:ve(new a(25,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(172,null)})),disableLayerHinting:ve(new h(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:ve(new h(27,"disableMonospaceOptimizations",!1)),domReadOnly:ve(new h(28,"domReadOnly",!1)),dragAndDrop:ve(new h(29,"dragAndDrop",!0,{description:m.localize(173,null)})),emptySelectionClipboard:ve(new A),extraEditorClassName:ve(new f(31,"extraEditorClassName","")),fastScrollSensitivity:ve(new d(32,"fastScrollSensitivity",5,W=>W<=0?5:W,{markdownDescription:m.localize(174,null)})),find:ve(new R),fixedOverflowWidgets:ve(new h(34,"fixedOverflowWidgets",!1)),folding:ve(new h(35,"folding",!0,{description:m.localize(175,null)})),foldingStrategy:ve(new w(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(176,null),m.localize(177,null)],description:m.localize(178,null)})),foldingHighlight:ve(new h(37,"foldingHighlight",!0,{description:m.localize(179,null)})),unfoldOnClickAfterEndOfLine:ve(new h(38,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(180,null)})),fontFamily:ve(new f(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(181,null)})),fontInfo:ve(new P),fontLigatures2:ve(new o),fontSize:ve(new N),fontWeight:ve(new $),formatOnPaste:ve(new h(44,"formatOnPaste",!1,{description:m.localize(182,null)})),formatOnType:ve(new h(45,"formatOnType",!1,{description:m.localize(183,null)})),glyphMargin:ve(new h(46,"glyphMargin",!0,{description:m.localize(184,null)})),gotoLocation:ve(new ie),hideCursorInOverviewRuler:ve(new h(48,"hideCursorInOverviewRuler",!1,{description:m.localize(185,null)})),highlightActiveIndentGuide:ve(new h(49,"highlightActiveIndentGuide",!0,{description:m.localize(186,null)})),hover:ve(new ce),inDiffEditor:ve(new h(51,"inDiffEditor",!1)),letterSpacing:ve(new d(53,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,W=>d.clamp(W,-5,20),{description:m.localize(187,null)})),lightbulb:ve(new z),lineDecorationsWidth:ve(new k(55,"lineDecorationsWidth",10)),lineHeight:ve(new q),lineNumbers:ve(new $e),lineNumbersMinChars:ve(new a(58,"lineNumbersMinChars",5,1,300)),linkedEditing:ve(new h(59,"linkedEditing",!1,{description:m.localize(188,null)})),links:ve(new h(60,"links",!0,{description:m.localize(189,null)})),matchBrackets:ve(new w(61,"matchBrackets","always",["always","near","never"],{description:m.localize(190,null)})),minimap:ve(new L),mouseStyle:ve(new w(63,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ve(new d(64,"mouseWheelScrollSensitivity",1,W=>W===0?1:W,{markdownDescription:m.localize(191,null)})),mouseWheelZoom:ve(new h(65,"mouseWheelZoom",!1,{markdownDescription:m.localize(192,null)})),multiCursorMergeOverlapping:ve(new h(66,"multiCursorMergeOverlapping",!0,{description:m.localize(193,null)})),multiCursorModifier:ve(new u(67,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],B,{markdownEnumDescriptions:[m.localize(194,null),m.localize(195,null)],markdownDescription:m.localize(196,null)})),multiCursorPaste:ve(new w(68,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(197,null),m.localize(198,null)],markdownDescription:m.localize(199,null)})),occurrencesHighlight:ve(new h(69,"occurrencesHighlight",!0,{description:m.localize(200,null)})),overviewRulerBorder:ve(new h(70,"overviewRulerBorder",!0,{description:m.localize(201,null)})),overviewRulerLanes:ve(new a(71,"overviewRulerLanes",3,0,3)),padding:ve(new Y),parameterHints:ve(new j),peekWidgetDefaultFocus:ve(new w(74,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(202,null),m.localize(203,null)],description:m.localize(204,null)})),definitionLinkOpensInPeek:ve(new h(75,"definitionLinkOpensInPeek",!1,{description:m.localize(205,null)})),quickSuggestions:ve(new Se),quickSuggestionsDelay:ve(new a(77,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(206,null)})),readOnly:ve(new h(78,"readOnly",!1)),renameOnType:ve(new h(79,"renameOnType",!1,{description:m.localize(207,null),markdownDeprecationMessage:m.localize(208,null)})),renderControlCharacters:ve(new h(80,"renderControlCharacters",!1,{description:m.localize(209,null)})),renderIndentGuides:ve(new h(81,"renderIndentGuides",!0,{description:m.localize(210,null)})),renderFinalNewline:ve(new h(82,"renderFinalNewline",!0,{description:m.localize(211,null)})),renderLineHighlight:ve(new w(83,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(212,null)],description:m.localize(213,null)})),renderLineHighlightOnlyWhenFocus:ve(new h(84,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(214,null)})),renderValidationDecorations:ve(new w(85,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ve(new w(86,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(215,null),m.localize(216,null),m.localize(217,null),""],description:m.localize(218,null)})),revealHorizontalRightPadding:ve(new a(87,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ve(new h(88,"roundedSelection",!0,{description:m.localize(219,null)})),rulers:ve(new Ge),scrollbar:ve(new qe),scrollBeyondLastColumn:ve(new a(91,"scrollBeyondLastColumn",5,0,1073741824,{description:m.localize(220,null)})),scrollBeyondLastLine:ve(new h(92,"scrollBeyondLastLine",!0,{description:m.localize(221,null)})),scrollPredominantAxis:ve(new h(93,"scrollPredominantAxis",!0,{description:m.localize(222,null)})),selectionClipboard:ve(new h(94,"selectionClipboard",!0,{description:m.localize(223,null),included:F.isLinux})),selectionHighlight:ve(new h(95,"selectionHighlight",!0,{description:m.localize(224,null)})),selectOnLineNumbers:ve(new h(96,"selectOnLineNumbers",!0)),showFoldingControls:ve(new w(97,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[m.localize(225,null),m.localize(226,null)],description:m.localize(227,null)})),showUnused:ve(new h(98,"showUnused",!0,{description:m.localize(228,null)})),showDeprecated:ve(new h(123,"showDeprecated",!0,{description:m.localize(229,null)})),inlayHints:ve(new T),snippetSuggestions:ve(new w(99,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(230,null),m.localize(231,null),m.localize(232,null),m.localize(233,null)],description:m.localize(234,null)})),smartSelect:ve(new te),smoothScrolling:ve(new h(101,"smoothScrolling",!1,{description:m.localize(235,null)})),stopRenderingLineAfter:ve(new a(103,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ve(new G),inlineSuggest:ve(new U),suggestFontSize:ve(new a(105,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(236,null)})),suggestLineHeight:ve(new a(106,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(237,null)})),suggestOnTriggerCharacters:ve(new h(107,"suggestOnTriggerCharacters",!0,{description:m.localize(238,null)})),suggestSelection:ve(new w(108,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(239,null),m.localize(240,null),m.localize(241,null)],description:m.localize(242,null)})),tabCompletion:ve(new w(109,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(243,null),m.localize(244,null),m.localize(245,null)],description:m.localize(246,null)})),tabIndex:ve(new a(110,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ve(new w(111,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(247,null),m.localize(248,null),m.localize(249,null)],description:m.localize(250,null)})),useShadowDOM:ve(new h(112,"useShadowDOM",!0)),useTabStops:ve(new h(113,"useTabStops",!0,{description:m.localize(251,null)})),wordSeparators:ve(new f(114,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:m.localize(252,null)})),wordWrap:ve(new w(115,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(253,null),m.localize(254,null),m.localize(255,null),m.localize(256,null)],description:m.localize(257,null)})),wordWrapBreakAfterCharacters:ve(new f(116,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ve(new f(117,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ve(new a(118,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(258,null)})),wordWrapOverride1:ve(new w(119,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ve(new w(120,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ve(new u(121,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Q,{enumDescriptions:[m.localize(259,null),m.localize(260,null),m.localize(261,null),m.localize(262,null)],description:m.localize(263,null)})),wrappingStrategy:ve(new w(122,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[m.localize(264,null),m.localize(265,null)],description:m.localize(266,null)})),editorClassName:ve(new v),pixelRatio:ve(new se),tabFocusMode:ve(new re),layoutInfo:ve(new H),wrappingInfo:ve(new ue)}}),define(_e[125],ye([19,20]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(_e[126],ye([19,20]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(_e[127],ye([19,20]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(_e[128],ye([19,20]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(_e[129],ye([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(_e[130],ye([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(_e[131],ye([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(_e[132],ye([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(_e[133],ye([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(_e[134],ye([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(_e[135],ye([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(_e[136],ye([19,20]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(_e[137],ye([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(_e[138],ye([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(_e[139],ye([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(_e[140],ye([19,20]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(_e[141],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var m;(function(I){I[I.ACTIVATE=1]="ACTIVATE",I[I.RESTORE=2]="RESTORE",I[I.PRESERVE=3]="PRESERVE"})(m=e.EditorActivation||(e.EditorActivation={}));var F;(function(I){I[I.PICK=0]="PICK",I[I.DISABLED=1]="DISABLED",I[I.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(F=e.EditorResolution||(e.EditorResolution={}));var D;(function(I){I[I.API=0]="API",I[I.USER=1]="USER"})(D=e.EditorOpenContext||(e.EditorOpenContext={}));var y;(function(I){I[I.Center=0]="Center",I[I.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",I[I.NearTop=2]="NearTop",I[I.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(y=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(_e[142],ye([0,1,126]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const F=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function y(l){return l=l.trim(),l==="*"||F.test(l)}e.isValidVersionStr=y;function I(l){if(!y(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let h=l.match(F);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=I;function S(l){if(!l)return null;let h=l.majorBase,a=l.majorMustEqual,d=l.minorBase,f=l.minorMustEqual,E=l.patchBase,w=l.patchMustEqual;l.hasCaret&&(h===0||(f=!1),w=!1);let u=0;if(l.preRelease){const g=D.exec(l.preRelease);if(g){const[,b,t,s]=g;u=Date.UTC(Number(b),Number(t)-1,Number(s))}}return{majorBase:h,majorMustEqual:a,minorBase:d,minorMustEqual:f,patchBase:E,patchMustEqual:w,isMinimum:l.hasGreaterEquals,notBefore:u}}e.normalizeVersion=S;function _(l,h,a){let d;typeof l=="string"?d=S(I(l)):d=l;let f;h instanceof Date?f=h.getTime():typeof h=="string"&&(f=new Date(h).getTime());let E;if(typeof a=="string"?E=S(I(a)):E=a,!d||!E)return!1;let w=d.majorBase,u=d.minorBase,g=d.patchBase,b=E.majorBase,t=E.minorBase,s=E.patchBase,i=E.notBefore,r=E.majorMustEqual,c=E.minorMustEqual,p=E.patchMustEqual;return E.isMinimum?w>b?!0:w<b?!1:u>t?!0:u<t||f&&f<i?!1:g>=s:(w===1&&b===0&&(!r||!c||!p)&&(b=1,t=0,s=0,r=!0,c=!1,p=!1),w<b?!1:w>b?!r:u<t?!1:u>t?!c:g<s?!1:g>s?!p:!(f&&f<i))}e.isValidVersion=_;function C(l,h,a,d){return a.isBuiltin||typeof a.main=="undefined"?!0:k(l,h,a.engines.vscode,d)}e.isValidExtensionVersion=C;function n(l,h,a){return l==="*"||k(h,a,l)}e.isEngineValid=n;function k(l,h,a,d=[]){let f=S(I(a));if(!f)return d.push(m.localize(0,null,a)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return d.push(m.localize(1,null,a)),!1}else if(!f.majorMustEqual)return d.push(m.localize(2,null,a)),!1;return _(l,h,f)?!0:(d.push(m.localize(3,null,l,a)),!1)}}),define(_e[89],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class m{constructor(D,y=[],I=!1){this.ctor=D,this.staticArguments=y,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=m}),define(_e[57],ye([0,1,89]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const F=[];function D(I,S,_){S instanceof m.SyncDescriptor||(S=new m.SyncDescriptor(S,[],_)),F.push([I,S])}e.registerSingleton=D;function y(){return F}e.getSingletonServiceDescriptors=y}),define(_e[143],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(y){this.incoming=new Map,this.outgoing=new Map,this.data=y}}e.Node=m;class F{constructor(y){this._hashFn=y,this._nodes=new Map}roots(){const y=[];for(let I of this._nodes.values())I.outgoing.size===0&&y.push(I);return y}insertEdge(y,I){const S=this.lookupOrInsertNode(y),_=this.lookupOrInsertNode(I);S.outgoing.set(this._hashFn(I),_),_.incoming.set(this._hashFn(y),S)}removeNode(y){const I=this._hashFn(y);this._nodes.delete(I);for(let S of this._nodes.values())S.outgoing.delete(I),S.incoming.delete(I)}lookupOrInsertNode(y){const I=this._hashFn(y);let S=this._nodes.get(I);return S||(S=new m(y),this._nodes.set(I,S)),S}lookup(y){return this._nodes.get(this._hashFn(y))}isEmpty(){return this._nodes.size===0}toString(){let y=[];for(let[I,S]of this._nodes)y.push(`${I}, (incoming)[${[...S.incoming.keys()].join(", ")}], (outgoing)[${[...S.outgoing.keys()].join(",")}]`);return y.join(`
`)}findCycleSlow(){for(let[y,I]of this._nodes){const S=new Set([y]),_=this._findCycle(I,S);if(_)return _}}_findCycle(y,I){for(let[S,_]of y.outgoing){if(I.has(S))return[...I,S].join(" -> ");I.add(S);const C=this._findCycle(_,I);if(C)return C;I.delete(S)}}}e.Graph=F}),define(_e[4],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(S){S.serviceIds=new Map,S.DI_TARGET="$di$target",S.DI_DEPENDENCIES="$di$dependencies";function _(C){return C[S.DI_DEPENDENCIES]||[]}S.getServiceDependencies=_})(m=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function F(S,_,C,n){_[m.DI_TARGET]===_?_[m.DI_DEPENDENCIES].push({id:S,index:C,optional:n}):(_[m.DI_DEPENDENCIES]=[{id:S,index:C,optional:n}],_[m.DI_TARGET]=_)}function D(S){if(m.serviceIds.has(S))return m.serviceIds.get(S);const _=function(C,n,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(_,C,k,!1)};return _.toString=()=>S,m.serviceIds.set(S,_),_}e.createDecorator=D;function y(S){return S}e.refineServiceDecorator=y;function I(S){return function(_,C,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");F(S,_,n,!0)}}e.optional=I}),define(_e[144],ye([0,1,4]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,m.createDecorator)("modelService");function F(D){return!D.isTooLargeForSyncing()&&!D.isForSimpleWidget}e.shouldSynchronizeModel=F}),define(_e[145],ye([0,1,3,41,7,22,79,55,144]),function(ee,e,m,F,D,y,I,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function C(l){return typeof l=="string"?!1:Array.isArray(l)?l.every(C):!!l.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new m.Emitter}get onDidChange(){return this._onDidChange.event}register(h,a){let d={selector:h,provider:a,_score:-1,_time:this._clock++};return this._entries.push(d),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,D.toDisposable)(()=>{if(d){let f=this._entries.indexOf(d);f>=0&&(this._entries.splice(f,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),d=void 0)}})}has(h){return this.all(h).length>0}all(h){if(!h)return[];this._updateScores(h);const a=[];for(let d of this._entries)d._score>0&&a.push(d.provider);return a}ordered(h){const a=[];return this._orderedForEach(h,d=>a.push(d.provider)),a}orderedGroups(h){const a=[];let d,f;return this._orderedForEach(h,E=>{d&&f===E._score?d.push(E.provider):(f=E._score,d=[E.provider],a.push(d))}),a}_orderedForEach(h,a){if(!!h){this._updateScores(h);for(const d of this._entries)d._score>0&&a(d)}}_updateScores(h){let a={uri:h.uri.toString(),language:h.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===a.language&&this._lastCandidate.uri===a.uri)){this._lastCandidate=a;for(let d of this._entries)if(d._score=(0,S.score)(d.selector,h.uri,h.getLanguageIdentifier().language,(0,_.shouldSynchronizeModel)(h)),C(d.selector)&&d._score>0){for(let f of this._entries)f._score=0;d._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(h,a){return h._score<a._score?1:h._score>a._score?-1:h._time<a._time?1:h._time>a._time?-1:0}}e.LanguageFeatureRegistry=n;class k{constructor(h,a,d=Number.MAX_SAFE_INTEGER){this._registry=h,this.min=a,this.max=d,this._cache=new y.LRUCache(50,.7)}_key(h){return h.id+(0,F.hash)(this._registry.all(h))}_clamp(h){return h===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(h*1.3)))}get(h){const a=this._key(h),d=this._cache.get(a);return this._clamp(d?.value)}update(h,a){const d=this._key(h);let f=this._cache.get(d);return f||(f=new I.MovingAverage,this._cache.set(d,f)),f.update(a),this.get(h)}}e.LanguageFeatureRequestDelays=k}),define(_e[58],ye([0,1,2,30,145,120,53]),function(ee,e,m,F,D,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var S;(function(o){o[o.Null=0]="Null",o[o.PlainText=1]="PlainText"})(S=e.LanguageId||(e.LanguageId={}));class _{constructor(P,N){this.language=P,this.id=N}}e.LanguageIdentifier=_;var C;(function(o){o[o.NotSet=-1]="NotSet",o[o.None=0]="None",o[o.Italic=1]="Italic",o[o.Bold=2]="Bold",o[o.Underline=4]="Underline"})(C=e.FontStyle||(e.FontStyle={}));var n;(function(o){o[o.None=0]="None",o[o.DefaultForeground=1]="DefaultForeground",o[o.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var k;(function(o){o[o.Other=0]="Other",o[o.Comment=1]="Comment",o[o.String=2]="String",o[o.RegEx=4]="RegEx"})(k=e.StandardTokenType||(e.StandardTokenType={}));var l;(function(o){o[o.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",o[o.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",o[o.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",o[o.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",o[o.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",o[o.ITALIC_MASK=2048]="ITALIC_MASK",o[o.BOLD_MASK=4096]="BOLD_MASK",o[o.UNDERLINE_MASK=8192]="UNDERLINE_MASK",o[o.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",o[o.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",o[o.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",o[o.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",o[o.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",o[o.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",o[o.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",o[o.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",o[o.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",o[o.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(l=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(P){return(P&255)>>>0}static getTokenType(P){return(P&1792)>>>8}static getFontStyle(P){return(P&14336)>>>11}static getForeground(P){return(P&8372224)>>>14}static getBackground(P){return(P&4286578688)>>>23}static getClassNameFromMetadata(P){let N=this.getForeground(P),$="mtk"+N,ie=this.getFontStyle(P);return ie&1&&($+=" mtki"),ie&2&&($+=" mtkb"),ie&4&&($+=" mtku"),$}static getInlineStyleFromMetadata(P,N){const $=this.getForeground(P),ie=this.getFontStyle(P);let ce=`color: ${N[$]};`;return ie&1&&(ce+="font-style: italic;"),ie&2&&(ce+="font-weight: bold;"),ie&4&&(ce+="text-decoration: underline;"),ce}}e.TokenMetadata=h;var a;(function(o){o[o.Method=0]="Method",o[o.Function=1]="Function",o[o.Constructor=2]="Constructor",o[o.Field=3]="Field",o[o.Variable=4]="Variable",o[o.Class=5]="Class",o[o.Struct=6]="Struct",o[o.Interface=7]="Interface",o[o.Module=8]="Module",o[o.Property=9]="Property",o[o.Event=10]="Event",o[o.Operator=11]="Operator",o[o.Unit=12]="Unit",o[o.Value=13]="Value",o[o.Constant=14]="Constant",o[o.Enum=15]="Enum",o[o.EnumMember=16]="EnumMember",o[o.Keyword=17]="Keyword",o[o.Text=18]="Text",o[o.Color=19]="Color",o[o.File=20]="File",o[o.Reference=21]="Reference",o[o.Customcolor=22]="Customcolor",o[o.Folder=23]="Folder",o[o.TypeParameter=24]="TypeParameter",o[o.User=25]="User",o[o.Issue=26]="Issue",o[o.Snippet=27]="Snippet"})(a=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let o=Object.create(null);return o[0]="symbol-method",o[1]="symbol-function",o[2]="symbol-constructor",o[3]="symbol-field",o[4]="symbol-variable",o[5]="symbol-class",o[6]="symbol-struct",o[7]="symbol-interface",o[8]="symbol-module",o[9]="symbol-property",o[10]="symbol-event",o[11]="symbol-operator",o[12]="symbol-unit",o[13]="symbol-value",o[14]="symbol-constant",o[15]="symbol-enum",o[16]="symbol-enum-member",o[17]="symbol-keyword",o[27]="symbol-snippet",o[18]="symbol-text",o[19]="symbol-color",o[20]="symbol-file",o[21]="symbol-reference",o[22]="symbol-customcolor",o[23]="symbol-folder",o[24]="symbol-type-parameter",o[25]="account",o[26]="issues",function(P){const N=o[P];let $=N&&I.iconRegistry.get(N);return $||(console.info("No codicon found for CompletionItemKind "+P),$=I.Codicon.symbolProperty),$.classNames}}(),e.completionKindFromString=function(){let o=Object.create(null);return o.method=0,o.function=1,o.constructor=2,o.field=3,o.variable=4,o.class=5,o.struct=6,o.interface=7,o.module=8,o.property=9,o.event=10,o.operator=11,o.unit=12,o.value=13,o.constant=14,o.enum=15,o["enum-member"]=16,o.enumMember=16,o.keyword=17,o.snippet=27,o.text=18,o.color=19,o.file=20,o.reference=21,o.customcolor=22,o.folder=23,o["type-parameter"]=24,o.typeParameter=24,o.account=25,o.issue=26,function(P,N){let $=o[P];return typeof $=="undefined"&&!N&&($=9),$}}();var d;(function(o){o[o.Deprecated=1]="Deprecated"})(d=e.CompletionItemTag||(e.CompletionItemTag={}));var f;(function(o){o[o.KeepWhitespace=1]="KeepWhitespace",o[o.InsertAsSnippet=4]="InsertAsSnippet"})(f=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var E;(function(o){o[o.Invoke=0]="Invoke",o[o.TriggerCharacter=1]="TriggerCharacter",o[o.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(E=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var w;(function(o){o[o.Automatic=0]="Automatic",o[o.Explicit=1]="Explicit"})(w=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var u;(function(o){o[o.Invoke=1]="Invoke",o[o.Auto=2]="Auto"})(u=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var g;(function(o){o[o.Invoke=1]="Invoke",o[o.TriggerCharacter=2]="TriggerCharacter",o[o.ContentChange=3]="ContentChange"})(g=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var b;(function(o){o[o.Text=0]="Text",o[o.Read=1]="Read",o[o.Write=2]="Write"})(b=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(o){return o&&m.URI.isUri(o.uri)&&F.Range.isIRange(o.range)&&(F.Range.isIRange(o.originSelectionRange)||F.Range.isIRange(o.targetSelectionRange))}e.isLocationLink=t;var s;(function(o){o[o.File=0]="File",o[o.Module=1]="Module",o[o.Namespace=2]="Namespace",o[o.Package=3]="Package",o[o.Class=4]="Class",o[o.Method=5]="Method",o[o.Property=6]="Property",o[o.Field=7]="Field",o[o.Constructor=8]="Constructor",o[o.Enum=9]="Enum",o[o.Interface=10]="Interface",o[o.Function=11]="Function",o[o.Variable=12]="Variable",o[o.Constant=13]="Constant",o[o.String=14]="String",o[o.Number=15]="Number",o[o.Boolean=16]="Boolean",o[o.Array=17]="Array",o[o.Object=18]="Object",o[o.Key=19]="Key",o[o.Null=20]="Null",o[o.EnumMember=21]="EnumMember",o[o.Struct=22]="Struct",o[o.Event=23]="Event",o[o.Operator=24]="Operator",o[o.TypeParameter=25]="TypeParameter"})(s=e.SymbolKind||(e.SymbolKind={}));var i;(function(o){o[o.Deprecated=1]="Deprecated"})(i=e.SymbolTag||(e.SymbolTag={}));var r;(function(o){const P=new Map;P.set("file",0),P.set("module",1),P.set("namespace",2),P.set("package",3),P.set("class",4),P.set("method",5),P.set("property",6),P.set("field",7),P.set("constructor",8),P.set("enum",9),P.set("interface",10),P.set("function",11),P.set("variable",12),P.set("constant",13),P.set("string",14),P.set("number",15),P.set("boolean",16),P.set("array",17),P.set("object",18),P.set("key",19),P.set("null",20),P.set("enum-member",21),P.set("struct",22),P.set("event",23),P.set("operator",24),P.set("type-parameter",25);const N=new Map;N.set(0,"file"),N.set(1,"module"),N.set(2,"namespace"),N.set(3,"package"),N.set(4,"class"),N.set(5,"method"),N.set(6,"property"),N.set(7,"field"),N.set(8,"constructor"),N.set(9,"enum"),N.set(10,"interface"),N.set(11,"function"),N.set(12,"variable"),N.set(13,"constant"),N.set(14,"string"),N.set(15,"number"),N.set(16,"boolean"),N.set(17,"array"),N.set(18,"object"),N.set(19,"key"),N.set(20,"null"),N.set(21,"enum-member"),N.set(22,"struct"),N.set(23,"event"),N.set(24,"operator"),N.set(25,"type-parameter");function $(K){return P.get(K)}o.fromString=$;function ie(K){return N.get(K)}o.toString=ie;function ce(K,H){const z=N.get(K);let T=z&&I.iconRegistry.get("symbol-"+z);return T||(console.info("No codicon found for SymbolKind "+K),T=I.Codicon.symbolProperty),`${H?"inline":"block"} ${T.classNames}`}o.toCssClassName=ce})(r=e.SymbolKinds||(e.SymbolKinds={}));class c{constructor(P){this.value=P}}e.FoldingRangeKind=c,c.Comment=new c("comment"),c.Imports=new c("imports"),c.Region=new c("region");var p;(function(o){o[o.Collapsed=0]="Collapsed",o[o.Expanded=1]="Expanded"})(p=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var v;(function(o){o[o.Editing=0]="Editing",o[o.Preview=1]="Preview"})(v=e.CommentMode||(e.CommentMode={}));var A;(function(o){o[o.Other=0]="Other",o[o.Type=1]="Type",o[o.Parameter=2]="Parameter"})(A=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new D.LanguageFeatureRegistry,e.RenameProviderRegistry=new D.LanguageFeatureRegistry,e.CompletionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new D.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new D.LanguageFeatureRegistry,e.HoverProviderRegistry=new D.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new D.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new D.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new D.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new D.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new D.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.LinkProviderRegistry=new D.LanguageFeatureRegistry,e.ColorProviderRegistry=new D.LanguageFeatureRegistry,e.SelectionRangeRegistry=new D.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.TokenizationRegistry=new y.TokenizationRegistryImpl;var R;(function(o){o[o.None=0]="None",o[o.Option=1]="Option",o[o.Default=2]="Default",o[o.Preferred=3]="Preferred"})(R=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(_e[59],ye([0,1,8,4,21]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let y=D.userAgent||"";const I=new Map;I.set("false",!1),I.set("true",!0),I.set("isMac",D.isMacintosh),I.set("isLinux",D.isLinux),I.set("isWindows",D.isWindows),I.set("isWeb",D.isWeb),I.set("isMacNative",D.isMacintosh&&!D.isWeb),I.set("isEdge",y.indexOf("Edg/")>=0),I.set("isFirefox",y.indexOf("Firefox")>=0),I.set("isChrome",y.indexOf("Chrome")>=0),I.set("isSafari",y.indexOf("Safari")>=0);const S=Object.prototype.hasOwnProperty;var _;(function(R){R[R.False=0]="False",R[R.True=1]="True",R[R.Defined=2]="Defined",R[R.Not=3]="Not",R[R.Equals=4]="Equals",R[R.NotEquals=5]="NotEquals",R[R.And=6]="And",R[R.Regex=7]="Regex",R[R.NotRegex=8]="NotRegex",R[R.Or=9]="Or",R[R.In=10]="In",R[R.NotIn=11]="NotIn",R[R.Greater=12]="Greater",R[R.GreaterEquals=13]="GreaterEquals",R[R.Smaller=14]="Smaller",R[R.SmallerEquals=15]="SmallerEquals"})(_=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return k.INSTANCE}static true(){return l.INSTANCE}static has(o){return h.create(o)}static equals(o,P){return a.create(o,P)}static notEquals(o,P){return E.create(o,P)}static regex(o,P){return s.create(o,P)}static in(o,P){return d.create(o,P)}static not(o){return w.create(o)}static and(...o){return r.create(o)}static or(...o){return c.create(o)}static greater(o,P){return u.create(o,P)}static less(o,P){return b.create(o,P)}static deserialize(o,P=!1){if(!!o)return this._deserializeOrExpression(o,P)}static _deserializeOrExpression(o,P){let N=o.split("||");return c.create(N.map($=>this._deserializeAndExpression($,P)))}static _deserializeAndExpression(o,P){let N=o.split("&&");return r.create(N.map($=>this._deserializeOne($,P)))}static _deserializeOne(o,P){if(o=o.trim(),o.indexOf("!=")>=0){let N=o.split("!=");return E.create(N[0].trim(),this._deserializeValue(N[1],P))}if(o.indexOf("==")>=0){let N=o.split("==");return a.create(N[0].trim(),this._deserializeValue(N[1],P))}if(o.indexOf("=~")>=0){let N=o.split("=~");return s.create(N[0].trim(),this._deserializeRegexValue(N[1],P))}if(o.indexOf(" in ")>=0){let N=o.split(" in ");return d.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(o)){const N=o.split(">=");return g.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(o)){const N=o.split(">");return u.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(o)){const N=o.split("<=");return t.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(o)){const N=o.split("<");return b.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(o)?w.create(o.substr(1).trim()):h.create(o)}static _deserializeValue(o,P){if(o=o.trim(),o==="true")return!0;if(o==="false")return!1;let N=/^'([^']*)'$/.exec(o);return N?N[1].trim():o}static _deserializeRegexValue(o,P){if((0,m.isFalsyOrWhitespace)(o)){if(P)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=o.indexOf("/"),$=o.lastIndexOf("/");if(N===$||N<0){if(P)throw new Error(`bad regexp-value '${o}', missing /-enclosure`);return console.warn(`bad regexp-value '${o}', missing /-enclosure`),null}let ie=o.slice(N+1,$),ce=o[$+1]==="i"?"i":"";try{return new RegExp(ie,ce)}catch(K){if(P)throw new Error(`bad regexp-value '${o}', parse error: ${K}`);return console.warn(`bad regexp-value '${o}', parse error: ${K}`),null}}}e.ContextKeyExpr=C;function n(R,o){return R.cmp(o)}class k{constructor(){this.type=0}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!1}serialize(){return"false"}keys(){return[]}map(o){return this}negate(){return l.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class l{constructor(){this.type=1}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!0}serialize(){return"true"}keys(){return[]}map(o){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=l,l.INSTANCE=new l;class h{constructor(o){this.key=o,this.type=2}static create(o){const P=I.get(o);return typeof P=="boolean"?P?l.INSTANCE:k.INSTANCE:new h(o)}cmp(o){return o.type!==this.type?this.type-o.type:v(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!!o.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(o){return o.mapDefined(this.key)}negate(){return w.create(this.key)}}e.ContextKeyDefinedExpr=h;class a{constructor(o,P){this.key=o,this.value=P,this.type=4}static create(o,P){if(typeof P=="boolean")return P?h.create(o):w.create(o);const N=I.get(o);return typeof N=="boolean"?P===(N?"true":"false")?l.INSTANCE:k.INSTANCE:new a(o,P)}cmp(o){return o.type!==this.type?this.type-o.type:A(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(o){return o.mapEquals(this.key,this.value)}negate(){return E.create(this.key,this.value)}}e.ContextKeyEqualsExpr=a;class d{constructor(o,P){this.key=o,this.valueKey=P,this.type=10}static create(o,P){return new d(o,P)}cmp(o){return o.type!==this.type?this.type-o.type:A(this.key,this.valueKey,o.key,o.valueKey)}equals(o){return o.type===this.type?this.key===o.key&&this.valueKey===o.valueKey:!1}evaluate(o){const P=o.getValue(this.valueKey),N=o.getValue(this.key);return Array.isArray(P)?P.indexOf(N)>=0:typeof N=="string"&&typeof P=="object"&&P!==null?S.call(P,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(o){return o.mapIn(this.key,this.valueKey)}negate(){return f.create(this)}}e.ContextKeyInExpr=d;class f{constructor(o){this._actual=o,this.type=11}static create(o){return new f(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new f(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotInExpr=f;class E{constructor(o,P){this.key=o,this.value=P,this.type=5}static create(o,P){if(typeof P=="boolean")return P?w.create(o):h.create(o);const N=I.get(o);return typeof N=="boolean"?P===(N?"true":"false")?k.INSTANCE:l.INSTANCE:new E(o,P)}cmp(o){return o.type!==this.type?this.type-o.type:A(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(o){return o.mapNotEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=E;class w{constructor(o){this.key=o,this.type=3}static create(o){const P=I.get(o);return typeof P=="boolean"?P?k.INSTANCE:l.INSTANCE:new w(o)}cmp(o){return o.type!==this.type?this.type-o.type:v(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!o.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(o){return o.mapNot(this.key)}negate(){return h.create(this.key)}}e.ContextKeyNotExpr=w;class u{constructor(o,P){this.key=o,this.value=P,this.type=12}static create(o,P){return new u(o,P)}cmp(o){return o.type!==this.type?this.type-o.type:A(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=u;class g{constructor(o,P){this.key=o,this.value=P,this.type=13}static create(o,P){return new g(o,P)}cmp(o){return o.type!==this.type?this.type-o.type:A(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreaterEquals(this.key,this.value)}negate(){return b.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=g;class b{constructor(o,P){this.key=o,this.value=P,this.type=14}static create(o,P){return new b(o,P)}cmp(o){return o.type!==this.type?this.type-o.type:A(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmaller(this.key,this.value)}negate(){return g.create(this.key,this.value)}}e.ContextKeySmallerExpr=b;class t{constructor(o,P){this.key=o,this.value=P,this.type=15}static create(o,P){return new t(o,P)}cmp(o){return o.type!==this.type?this.type-o.type:A(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmallerEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class s{constructor(o,P){this.key=o,this.regexp=P,this.type=7}static create(o,P){return new s(o,P)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.key<o.key)return-1;if(this.key>o.key)return 1;const P=this.regexp?this.regexp.source:"",N=o.regexp?o.regexp.source:"";return P<N?-1:P>N?1:0}equals(o){if(o.type===this.type){const P=this.regexp?this.regexp.source:"",N=o.regexp?o.regexp.source:"";return this.key===o.key&&P===N}return!1}evaluate(o){let P=o.getValue(this.key);return this.regexp?this.regexp.test(P):!1}serialize(){const o=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${o}`}keys(){return[this.key]}map(o){return o.mapRegex(this.key,this.regexp)}negate(){return i.create(this)}}e.ContextKeyRegexExpr=s;class i{constructor(o){this._actual=o,this.type=8}static create(o){return new i(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new i(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;class r{constructor(o){this.expr=o,this.type=6}static create(o){return r._normalizeArr(o)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let P=0,N=this.expr.length;P<N;P++){const $=n(this.expr[P],o.expr[P]);if($!==0)return $}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let P=0,N=this.expr.length;P<N;P++)if(!this.expr[P].equals(o.expr[P]))return!1;return!0}return!1}evaluate(o){for(let P=0,N=this.expr.length;P<N;P++)if(!this.expr[P].evaluate(o))return!1;return!0}static _normalizeArr(o){const P=[];let N=!1;for(const $ of o)if(!!$){if($.type===1){N=!0;continue}if($.type===0)return k.INSTANCE;if($.type===6){P.push(...$.expr);continue}P.push($)}if(P.length===0&&N)return l.INSTANCE;if(P.length!==0){if(P.length===1)return P[0];for(P.sort(n);P.length>1;){const $=P[P.length-1];if($.type!==9)break;P.pop();const ie=P.pop(),ce=c.create($.expr.map(K=>r.create([K,ie])));ce&&(P.push(ce),P.sort(n))}return P.length===1?P[0]:new r(P)}}serialize(){return this.expr.map(o=>o.serialize()).join(" && ")}keys(){const o=[];for(let P of this.expr)o.push(...P.keys());return o}map(o){return new r(this.expr.map(P=>P.map(o)))}negate(){let o=[];for(let P of this.expr)o.push(P.negate());return c.create(o)}}e.ContextKeyAndExpr=r;class c{constructor(o){this.expr=o,this.type=9}static create(o){const P=c._normalizeArr(o);if(P.length!==0)return P.length===1?P[0]:new c(P)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let P=0,N=this.expr.length;P<N;P++){const $=n(this.expr[P],o.expr[P]);if($!==0)return $}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let P=0,N=this.expr.length;P<N;P++)if(!this.expr[P].equals(o.expr[P]))return!1;return!0}return!1}evaluate(o){for(let P=0,N=this.expr.length;P<N;P++)if(this.expr[P].evaluate(o))return!0;return!1}static _normalizeArr(o){let P=[],N=!1;if(o){for(let $=0,ie=o.length;$<ie;$++){const ce=o[$];if(!!ce){if(ce.type===0){N=!0;continue}if(ce.type===1)return[l.INSTANCE];if(ce.type===9){P=P.concat(ce.expr);continue}P.push(ce)}}if(P.length===0&&N)return[k.INSTANCE];P.sort(n)}return P}serialize(){return this.expr.map(o=>o.serialize()).join(" || ")}keys(){const o=[];for(let P of this.expr)o.push(...P.keys());return o}map(o){return new c(this.expr.map(P=>P.map(o)))}negate(){let o=[];for(let N of this.expr)o.push(N.negate());const P=N=>N.type===9?N.expr:[N];for(;o.length>1;){const N=o.shift(),$=o.shift(),ie=[];for(const ce of P(N))for(const K of P($))ie.push(C.and(ce,K));o.unshift(C.or(...ie))}return o[0]}}e.ContextKeyOrExpr=c;class p extends h{constructor(o,P,N){super(o);this._defaultValue=P,typeof N=="object"?p._info.push({...N,key:o}):N!==!0&&p._info.push({key:o,description:N,type:P!=null?typeof P:void 0})}static all(){return p._info.values()}bindTo(o){return o.createKey(this.key,this._defaultValue)}getValue(o){return o.getContextKeyValue(this.key)}toNegated(){return C.not(this.key)}isEqualTo(o){return C.equals(this.key,o)}notEqualsTo(o){return C.notEquals(this.key,o)}}e.RawContextKey=p,p._info=[],e.IContextKeyService=(0,F.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(R,o){return R<o?-1:R>o?1:0}function A(R,o,P,N){return R<P?-1:R>P?1:o<N?-1:o>N?1:0}}),define(_e[146],ye([0,1,4]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(_e[26],ye([0,1,8,4]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function D(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=D;function y(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class S{constructor(k){this.value=k,this._lower=k.toLowerCase()}static equals(k,l){if(typeof k=="undefined"||k===null)return typeof l=="undefined"||l===null;if(typeof l=="undefined"||l===null)return!1;if(typeof k=="string"||typeof l=="string"){let h=typeof k=="string"?k:k.value,a=typeof l=="string"?l:l.value;return m.equalsIgnoreCase(h,a)}return k._lower===l._lower}static toKey(k){return typeof k=="string"?k.toLowerCase():k._lower}}e.ExtensionIdentifier=S;function _(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=_;function C(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=C,e.IBuiltinExtensionsScannerService=(0,F.createDecorator)("IBuiltinExtensionsScannerService")}),define(_e[147],ye([0,1,8,26]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(a,d){return a.uuid&&d.uuid?a.uuid===d.uuid:a.id===d.id?!0:(0,m.compareIgnoreCase)(a.id,d.id)===0}e.areSameExtensions=D;class y{constructor(d,f){this.version=f,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof y?D(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=y;function I(a,d){return`${a}.${d}`}e.getExtensionId=I;function S(a){return a.toLocaleLowerCase()}e.adoptToGalleryExtensionId=S;function _(a,d){return S(I(a,d))}e.getGalleryExtensionId=_;function C(a,d){const f=[],E=w=>{for(const u of f)if(u.some(g=>D(d(g),d(w))))return u;return null};for(const w of a){const u=E(w);u?u.push(w):f.push([w])}return f}e.groupByExtension=C;function n(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function k(a){return{id:a.identifier.id,name:a.name,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),...a.telemetryData}}e.getGalleryExtensionTelemetryData=k,e.BetterMergeId=new F.ExtensionIdentifier("pprice.better-merge");function l(a){const d=new Set;for(const f of a)f.malicious&&d.add(f.id.id);return d}e.getMaliciousExtensionsSet=l;function h(a,d){const f=[],E=d.manifest.extensionDependencies?.slice(0)??[];for(;E.length;){const w=E.shift();if(w&&f.every(u=>!D(u.identifier,{id:w}))){const u=a.filter(g=>D(g.identifier,{id:w}));u.length===1&&(f.push(u[0]),E.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return f}e.getExtensionDependencies=h}),define(_e[60],ye([0,1,127,14,2,4,8,10,22]),function(ee,e,m,F,D,y,I,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function C(H){return H.create===!0}e.isFileOpenForWriteOptions=C;var n;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var k;(function(H){H[H.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var l;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock"})(l=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=h;function a(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=a;function d(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function f(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=f;var E;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(z,T){super(z);this.code=T}}e.FileSystemProviderError=w;function u(H,z){const T=new w(H.toString(),z);return b(T,z),T}e.createFileSystemProviderError=u;function g(H){return H||u((0,m.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=g;function b(H,z){return H.name=z?`${z} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=b;function t(H){if(!H)return E.Unknown;if(H instanceof w)return H.code;const z=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!z)return E.Unknown;switch(z[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=t;function s(H){if(H instanceof A)return H.fileOperationResult;switch(t(H)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var i;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class r{constructor(z,T,q){this.resource=z,this.operation=T,this.target=q}isOperation(z){return this.operation===z}}e.FileOperationEvent=r;var c;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class p{constructor(z,T){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const q of z)switch(q.type){case 1:this.added||(this.added=_.TernarySearchTree.forUris(()=>T)),this.added.set(q.resource,q);break;case 0:this.updated||(this.updated=_.TernarySearchTree.forUris(()=>T)),this.updated.set(q.resource,q);break;case 2:this.deleted||(this.deleted=_.TernarySearchTree.forUris(()=>T)),this.deleted.set(q.resource,q);break}}contains(z,...T){return this.doContains(z,{includeChildren:!1},...T)}affects(z,...T){return this.doContains(z,{includeChildren:!0},...T)}doContains(z,T,...q){if(!z)return!1;const L=q.length>0;return!!((!L||q.includes(1))&&(this.added?.get(z)||T.includeChildren&&this.added?.findSuperstr(z))||(!L||q.includes(0))&&(this.updated?.get(z)||T.includeChildren&&this.updated?.findSuperstr(z))||(!L||q.includes(2))&&(this.deleted?.findSubstr(z)||T.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=p;function v(H,z,T){return!H||!z||H===z||z.length>H.length?!1:(z.charAt(z.length-1)!==F.sep&&(z+=F.sep),T?(0,I.startsWithIgnoreCase)(H,z):H.indexOf(z)===0)}e.isParent=v;class A extends Error{constructor(z,T,q){super(z);this.fileOperationResult=T,this.options=q}}e.FileOperationError=A;class R extends A{constructor(z,T,q){super(z,2,q);this.stat=T}}e.NotModifiedSinceFileOperationError=R;var o;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(o=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var P;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(P=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=N;async function $(H,z){if(!z.canHandleResource(D.URI.from({scheme:H.scheme})))return new Promise(T=>{const q=z.onDidChangeFileSystemProviderRegistrations(L=>{L.scheme===H.scheme&&L.added&&(q.dispose(),T())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ie{static formatSize(z){return(0,S.isNumber)(z)||(z=0),z<ie.KB?(0,m.localize)(1,null,z.toFixed(0)):z<ie.MB?(0,m.localize)(2,null,(z/ie.KB).toFixed(2)):z<ie.GB?(0,m.localize)(3,null,(z/ie.MB).toFixed(2)):z<ie.TB?(0,m.localize)(4,null,(z/ie.GB).toFixed(2)):(0,m.localize)(5,null,(z/ie.TB).toFixed(2))}}e.ByteSize=ie,ie.KB=1024,ie.MB=ie.KB*ie.KB,ie.GB=ie.MB*ie.KB,ie.TB=ie.GB*ie.KB;var ce;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(ce=e.Arch||(e.Arch={}));function K(H){return{maxFileSize:H===0?300*ie.MB:16*ie.GB,maxHeapSize:H===0?700*ie.MB:2*700*ie.MB}}e.getPlatformLimits=K}),define(_e[61],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...D){this._entries=new Map;for(let[y,I]of D)this.set(y,I)}set(D,y){const I=this._entries.get(D);return this._entries.set(D,y),I}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=m}),define(_e[148],ye([0,1,12,143,89,4,61,16]),function(ee,e,m,F,D,y,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const _=!1;class C extends Error{constructor(a){super("cyclic dependency between services");this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class n{constructor(a=new I.ServiceCollection,d=!1,f){this._activeInstantiations=new Set,this._services=a,this._strict=d,this._parent=f,this._services.set(y.IInstantiationService,this)}createChild(a){return new n(a,this._strict,this)}invokeFunction(a,...d){let f=l.traceInvocation(a),E=!1;try{return a({get:(u,g)=>{if(E)throw(0,m.illegalState)("service accessor is only valid during the invocation of its target method");const b=this._getOrCreateServiceInstance(u,f);if(!b&&g!==y.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return b}},...d)}finally{E=!0,f.stop()}}createInstance(a,...d){let f,E;return a instanceof D.SyncDescriptor?(f=l.traceCreation(a.ctor),E=this._createInstance(a.ctor,a.staticArguments.concat(d),f)):(f=l.traceCreation(a),E=this._createInstance(a,d,f)),f.stop(),E}_createInstance(a,d=[],f){let E=y._util.getServiceDependencies(a).sort((g,b)=>g.index-b.index),w=[];for(const g of E){let b=this._getOrCreateServiceInstance(g.id,f);if(!b&&this._strict&&!g.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${g.id}.`);w.push(b)}let u=E.length>0?E[0].index:d.length;if(d.length!==u){console.warn(`[createInstance] First service dependency of ${a.name} at position ${u+1} conflicts with ${d.length} static arguments`);let g=u-d.length;g>0?d=d.concat(new Array(g)):d=d.slice(0,u)}return new a(...[...d,...w])}_setServiceInstance(a,d){if(this._services.get(a)instanceof D.SyncDescriptor)this._services.set(a,d);else if(this._parent)this._parent._setServiceInstance(a,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let d=this._services.get(a);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):d}_getOrCreateServiceInstance(a,d){let f=this._getServiceInstanceOrDescriptor(a);return f instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,f,d.branch(a,!0)):(d.branch(a,!1),f)}_safeCreateAndCacheServiceInstance(a,d,f){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,d,f)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,d,f){const E=new F.Graph(g=>g.id.toString());let w=0;const u=[{id:a,desc:d,_trace:f}];for(;u.length;){const g=u.pop();if(E.lookupOrInsertNode(g),w++>1e3)throw new C(E);for(let b of y._util.getServiceDependencies(g.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(b.id);if(!t&&!b.optional&&console.warn(`[createInstance] ${a} depends on ${b.id} which is NOT registered.`),t instanceof D.SyncDescriptor){const s={id:b.id,desc:t,_trace:g._trace.branch(b.id,!0)};E.insertEdge(g,s),u.push(s)}}}for(;;){const g=E.roots();if(g.length===0){if(!E.isEmpty())throw new C(E);break}for(const{data:b}of g){if(this._getServiceInstanceOrDescriptor(b.id)instanceof D.SyncDescriptor){const s=this._createServiceInstanceWithOwner(b.id,b.desc.ctor,b.desc.staticArguments,b.desc.supportsDelayedInstantiation,b._trace);this._setServiceInstance(b.id,s)}E.removeNode(b)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,d,f=[],E,w){if(this._services.get(a)instanceof D.SyncDescriptor)return this._createServiceInstance(d,f,E,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,d,f,E,w);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(a,d=[],f,E){if(f){const w=new S.IdleValue(()=>this._createInstance(a,d,E));return new Proxy(Object.create(null),{get(u,g){if(g in u)return u[g];let b=w.value,t=b[g];return typeof t!="function"||(t=t.bind(b),u[g]=t),t},set(u,g,b){return w.value[g]=b,!0}})}else return this._createInstance(a,d,E)}}e.InstantiationService=n;var k;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(k||(k={}));class l{constructor(a,d){this.type=a,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return _?new l(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):l._None}static traceCreation(a){return _?new l(0,a.name):l._None}branch(a,d){let f=new l(2,a.toString());return this._dep.push([a,d,f]),f}stop(){let a=Date.now()-this._start;l._totals+=a;let d=!1;function f(w,u){let g=[],b=new Array(w+1).join("	");for(const[t,s,i]of u._dep)if(s&&i){d=!0,g.push(`${b}CREATES -> ${t}`);let r=f(w+1,i);r&&g.push(r)}else g.push(`${b}uses -> ${t}`);return g.join(`
`)}let E=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(a>2||d)&&console.log(E.join(`
`))}}l._None=new class extends l{constructor(){super(-1,null)}stop(){}branch(){return this}},l._totals=0}),define(_e[15],ye([0,1,4,7,21,3,56]),function(ee,e,m,F,D,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,m.createDecorator)("logService"),e.ILoggerService=(0,m.createDecorator)("loggerService");function S(){return new Date().toISOString()}var _;(function(b){b[b.Trace=0]="Trace",b[b.Debug=1]="Debug",b[b.Info=2]="Info",b[b.Warning=3]="Warning",b[b.Error=4]="Error",b[b.Critical=5]="Critical",b[b.Off=6]="Off"})(_=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=_.Info;class C extends F.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new y.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class n extends C{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...s){this.checkLogLevel(_.Trace)&&this.log(_.Trace,this.format([t,...s]))}debug(t,...s){this.checkLogLevel(_.Debug)&&this.log(_.Debug,this.format([t,...s]))}info(t,...s){this.checkLogLevel(_.Info)&&this.log(_.Info,this.format([t,...s]))}warn(t,...s){this.checkLogLevel(_.Warning)&&this.log(_.Warning,this.format([t,...s]))}error(t,...s){if(this.checkLogLevel(_.Error))if(t instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=t.stack,this.log(_.Error,this.format(i))}else this.log(_.Error,this.format([t,...s]))}critical(t,...s){this.checkLogLevel(_.Critical)&&this.log(_.Critical,this.format([t,...s]))}flush(){}format(t){let s="";for(let i=0;i<t.length;i++){let r=t[i];if(typeof r=="object")try{r=JSON.stringify(r)}catch(c){}s+=(i>0?" ":"")+r}return s}}e.AbstractMessageLogger=n;class k extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!D.isWindows}trace(t,...s){this.getLevel()<=_.Trace&&(this.useColors?console.log(`[90m[main ${S()}][0m`,t,...s):console.log(`[main ${S()}]`,t,...s))}debug(t,...s){this.getLevel()<=_.Debug&&(this.useColors?console.log(`[90m[main ${S()}][0m`,t,...s):console.log(`[main ${S()}]`,t,...s))}info(t,...s){this.getLevel()<=_.Info&&(this.useColors?console.log(`[90m[main ${S()}][0m`,t,...s):console.log(`[main ${S()}]`,t,...s))}warn(t,...s){this.getLevel()<=_.Warning&&(this.useColors?console.warn(`[93m[main ${S()}][0m`,t,...s):console.warn(`[main ${S()}]`,t,...s))}error(t,...s){this.getLevel()<=_.Error&&(this.useColors?console.error(`[91m[main ${S()}][0m`,t,...s):console.error(`[main ${S()}]`,t,...s))}critical(t,...s){this.getLevel()<=_.Critical&&(this.useColors?console.error(`[90m[main ${S()}][0m`,t,...s):console.error(`[main ${S()}]`,t,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=k;class l extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...s){this.getLevel()<=_.Trace&&console.log("%cTRACE","color: #888",t,...s)}debug(t,...s){this.getLevel()<=_.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...s)}info(t,...s){this.getLevel()<=_.Info&&console.log("%c INFO","color: #33f",t,...s)}warn(t,...s){this.getLevel()<=_.Warning&&console.log("%c WARN","color: #993",t,...s)}error(t,...s){this.getLevel()<=_.Error&&console.log("%c  ERR","color: #f33",t,...s)}critical(t,...s){this.getLevel()<=_.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...s)}dispose(){}flush(){}}e.ConsoleLogger=l;class h extends C{constructor(t,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(s)}trace(t,...s){this.getLevel()<=_.Trace&&this.adapter.log(_.Trace,[this.extractMessage(t),...s])}debug(t,...s){this.getLevel()<=_.Debug&&this.adapter.log(_.Debug,[this.extractMessage(t),...s])}info(t,...s){this.getLevel()<=_.Info&&this.adapter.log(_.Info,[this.extractMessage(t),...s])}warn(t,...s){this.getLevel()<=_.Warning&&this.adapter.log(_.Warning,[this.extractMessage(t),...s])}error(t,...s){this.getLevel()<=_.Error&&this.adapter.log(_.Error,[this.extractMessage(t),...s])}critical(t,...s){this.getLevel()<=_.Critical&&this.adapter.log(_.Critical,[this.extractMessage(t),...s])}extractMessage(t){return typeof t=="string"?t:(0,I.toErrorMessage)(t,this.getLevel()<=_.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class a extends C{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const s of this.logServices)s.setLevel(t);super.setLevel(t)}trace(t,...s){for(const i of this.logServices)i.trace(t,...s)}debug(t,...s){for(const i of this.logServices)i.debug(t,...s)}info(t,...s){for(const i of this.logServices)i.info(t,...s)}warn(t,...s){for(const i of this.logServices)i.warn(t,...s)}error(t,...s){for(const i of this.logServices)i.error(t,...s)}critical(t,...s){for(const i of this.logServices)i.critical(t,...s)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=a;class d extends F.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...s){this.logger.trace(t,...s)}debug(t,...s){this.logger.debug(t,...s)}info(t,...s){this.logger.info(t,...s)}warn(t,...s){this.logger.warn(t,...s)}error(t,...s){this.logger.error(t,...s)}critical(t,...s){this.logger.critical(t,...s)}flush(){this.logger.flush()}}e.LogService=d;class f extends F.Disposable{constructor(t,s){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(i))}))}createLogger(t,s){let i=this.loggers.get(t.toString());return i||(i=this.doCreateLogger(t,s?.always?_.Trace:this.logLevel,s),this.loggers.set(t.toString(),i),s?.always||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=f;class E{constructor(){this.onDidChangeLogLevel=new y.Emitter().event}setLevel(t){}getLevel(){return _.Info}trace(t,...s){}debug(t,...s){}info(t,...s){}warn(t,...s){}error(t,...s){}critical(t,...s){}dispose(){}flush(){}}e.NullLogService=E;function w(b){if(b.verbose)return _.Trace;if(typeof b.logLevel=="string"){const t=u(b.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=w;function u(b){switch(b){case"trace":return _.Trace;case"debug":return _.Debug;case"info":return _.Info;case"warn":return _.Warning;case"error":return _.Error;case"critical":return _.Critical;case"off":return _.Off}}e.parseLogLevel=u;function g(b){switch(b){case _.Trace:return"trace";case _.Debug:return"debug";case _.Info:return"info";case _.Warning:return"warn";case _.Error:return"error";case _.Critical:return"critical";case _.Off:return"off"}}e.LogLevelToString=g}),define(_e[90],ye([0,1,4,128,42]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var y;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(y=e.MarkerTag||(e.MarkerTag={}));var I;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(I=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function C(a,d){return d-a}_.compare=C;const n=Object.create(null);n[_.Error]=(0,F.localize)(0,null),n[_.Warning]=(0,F.localize)(1,null),n[_.Info]=(0,F.localize)(2,null);function k(a){return n[a]||""}_.toString=k;function l(a){switch(a){case D.default.Error:return _.Error;case D.default.Warning:return _.Warning;case D.default.Info:return _.Info;case D.default.Ignore:return _.Hint}}_.fromSeverity=l;function h(a){switch(a){case _.Error:return D.default.Error;case _.Warning:return D.default.Warning;case _.Info:return D.default.Info;case _.Hint:return D.default.Ignore}}_.toSeverity=h}(I=e.MarkerSeverity||(e.MarkerSeverity={}));var S;(function(_){const C="";function n(l){return k(l,!0)}_.makeKey=n;function k(l,h){let a=[C];return l.source?a.push(l.source.replace("\xA6","\\\xA6")):a.push(C),l.code?typeof l.code=="string"?a.push(l.code.replace("\xA6","\\\xA6")):a.push(l.code.value.replace("\xA6","\\\xA6")):a.push(C),l.severity!==void 0&&l.severity!==null?a.push(I.toString(l.severity)):a.push(C),l.message&&h?a.push(l.message.replace("\xA6","\\\xA6")):a.push(C),l.startLineNumber!==void 0&&l.startLineNumber!==null?a.push(l.startLineNumber.toString()):a.push(C),l.startColumn!==void 0&&l.startColumn!==null?a.push(l.startColumn.toString()):a.push(C),l.endLineNumber!==void 0&&l.endLineNumber!==null?a.push(l.endLineNumber.toString()):a.push(C),l.endColumn!==void 0&&l.endColumn!==null?a.push(l.endColumn.toString()):a.push(C),a.push(C),a.join("\xA6")}_.makeKeyOptionalMessage=k})(S=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,m.createDecorator)("markerService")}),define(_e[149],ye([0,1,42,4,3]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=m.default,e.INotificationService=(0,F.createDecorator)("notificationService");var y;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.GLOBAL=1]="GLOBAL"})(y=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var I;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(I=e.NotificationsFilter||(e.NotificationsFilter={}));class S{constructor(){this.progress=new _,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=S;class _{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=_}),define(_e[150],ye([0,1,7,8,2,4]),function(ee,e,m,F,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,y.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return m.Disposable.None},registerValidator(){return m.Disposable.None},registerExternalUriResolver(){return m.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return m.Disposable.None},async open(){return!1},async resolveExternalUri(S){return{resolved:S,dispose(){}}}});function I(S,_){return D.URI.isUri(S)?(0,F.equalsIgnoreCase)(S.scheme,_):(0,F.startsWithIgnoreCase)(S,_+":")}e.matchesScheme=I});var ze=this&&this.__decorate||function(ee,e,m,F){var D=arguments.length,y=D<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,m):F,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")y=Reflect.decorate(ee,e,m,F);else for(var S=ee.length-1;S>=0;S--)(I=ee[S])&&(y=(D<3?I(y):D>3?I(e,m,y):I(e,m))||y);return D>3&&y&&Object.defineProperty(e,m,y),y},je=this&&this.__param||function(ee,e){return function(m,F){e(m,F,ee)}};define(_e[151],ye([0,1,4,18,7,16]),function(ee,e,m,F,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,m.createDecorator)("progressService");var I;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(I=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class S{constructor(k){this.callback=k}get value(){return this._value}report(k){this._value=k,this.callback(this._value)}}e.Progress=S,S.None=Object.freeze({report(){}});let _=class extends D.Disposable{constructor(k,l){super();this.deferred=new y.DeferredPromise,l.withProgress(k,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register((0,D.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};_=ze([je(1,e.IProgressService)],_),e.UnmanagedProgress=_;class C extends D.Disposable{constructor(k){super();this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(k){this.stop();const l=++this.currentOperationId,h=new F.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{l===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,D.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,D.toDisposable)(()=>h.cancel())),this.currentOperationDisposables.add((0,D.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:l,token:h.token,stop:()=>this.doStop(l),isCurrent:()=>this.currentOperationId===l}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=(0,m.createDecorator)("editorProgressService")}),define(_e[31],ye([0,1,10,39]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(I,S){F.ok(m.isString(I)),F.ok(m.isObject(S)),F.ok(!this.data.has(I),"There is already an extension with this id"),this.data.set(I,S)}knows(I){return this.data.has(I)}as(I){return this.data.get(I)||null}}e.Registry=new D}),define(_e[152],ye([0,1,31,3]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class y{constructor(){this._onDidChangeSchema=new F.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,C){this.schemasById[D(_)]=C,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const I=new y;m.Registry.add(e.Extensions.JSONContribution,I)}),define(_e[62],ye([0,1,125,3,31,10,152]),function(ee,e,m,F,D,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(E){E.Multiline="multilineText",E.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var _;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(_=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const C=D.Registry.as(I.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new F.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new F.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:m.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,u=!0){this.registerConfigurations([w],u)}registerConfigurations(w,u=!0){const g=[];w.forEach(b=>{g.push(...this.validateAndRegisterProperties(b,u,b.extensionInfo)),this.configurationContributors.push(b),this.registerJSONConfiguration(b)}),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(g)}deregisterConfigurations(w){const u=[],g=b=>{if(b.properties)for(const t in b.properties)u.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,b.properties[t]);b.allOf&&b.allOf.forEach(t=>g(t))};for(const b of w){g(b);const t=this.configurationContributors.indexOf(b);t!==-1&&this.configurationContributors.splice(t,1)}C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}registerDefaultConfigurations(w){const u=[],g=[];for(const b of w)for(const t in b)if(u.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...b[t]};const s={type:"object",default:this.defaultValues[t],description:m.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};g.push(l(t)),this.configurationProperties[t]=s,this.defaultLanguageConfigurationOverridesNode.properties[t]=s}else{this.defaultValues[t]=b[t];const s=this.configurationProperties[t];s&&(this.updatePropertyDefaultValue(t,s),this.updateSchema(t,s))}this.registerOverrideIdentifiers(g),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterDefaultConfigurations(w){const u=[];for(const g of w)for(const b in g)if(u.push(b),delete this.defaultValues[b],e.OVERRIDE_PROPERTY_PATTERN.test(b))delete this.configurationProperties[b],delete this.defaultLanguageConfigurationOverridesNode.properties[b];else{const t=this.configurationProperties[b];t&&(this.updatePropertyDefaultValue(b,t),this.updateSchema(b,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const u of w)this.overrideIdentifiers.add(u);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,u=!0,g,b=3){b=y.isUndefinedOrNull(w.scope)?b:w.scope;let t=[],s=w.properties;if(s)for(let r in s){if(u&&d(r)){delete s[r];continue}const c=s[r];if(this.updatePropertyDefaultValue(r,c),e.OVERRIDE_PROPERTY_PATTERN.test(r)?c.scope=void 0:(c.scope=y.isUndefinedOrNull(c.scope)?b:c.scope,c.restricted=y.isUndefinedOrNull(c.restricted)?!!g?.restrictedConfigurations?.includes(r):c.restricted),s[r].hasOwnProperty("included")&&!s[r].included){this.excludedConfigurationProperties[r]=s[r],delete s[r];continue}else this.configurationProperties[r]=s[r];!s[r].deprecationMessage&&s[r].markdownDeprecationMessage&&(s[r].deprecationMessage=s[r].markdownDeprecationMessage),t.push(r)}let i=w.allOf;if(i)for(let r of i)t.push(...this.validateAndRegisterProperties(r,u,g,b));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const u=g=>{let b=g.properties;if(b)for(const s in b)this.updateSchema(s,b[s]);let t=g.allOf;t&&t.forEach(u)};u(w)}updateSchema(w,u){switch(e.allSettings.properties[w]=u,u.scope){case 1:e.applicationSettings.properties[w]=u;break;case 2:e.machineSettings.properties[w]=u;break;case 6:e.machineOverridableSettings.properties[w]=u;break;case 3:e.windowSettings.properties[w]=u;break;case 4:e.resourceSettings.properties[w]=u;break;case 5:e.resourceSettings.properties[w]=u,this.resourceLanguageSettingsSchema.properties[w]=u;break}}removeFromSchema(w,u){switch(delete e.allSettings.properties[w],u.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const u=`[${w}]`,g={type:"object",description:m.localize(2,null),errorMessage:m.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(u,g),e.allSettings.properties[u]=g,e.applicationSettings.properties[u]=g,e.machineSettings.properties[u]=g,e.machineOverridableSettings.properties[u]=g,e.windowSettings.properties[u]=g,e.resourceSettings.properties[u]=g}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,u){let g=this.defaultValues[w];y.isUndefined(g)&&(g=u.default),y.isUndefined(g)&&(g=h(u.type)),u.default=g}}const k="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(k);function l(E){return E.substring(1,E.length-1)}e.overrideIdentifierFromKey=l;function h(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const a=new n;D.Registry.add(e.Extensions.Configuration,a);function d(E){return E.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(E)?m.localize(5,null,E):a.getConfigurationProperties()[E]!==void 0?m.localize(6,null,E):null:m.localize(4,null)}e.validateProperty=d;function f(){const E=[],w=a.getConfigurationProperties();for(const u of Object.keys(w))E.push([u,w[u].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=f}),define(_e[91],ye([0,1,24,10,2,31,4,62]),function(ee,e,m,F,D,y,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function _(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof D.URI)}e.isConfigurationOverrides=_;var C;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function k(s,i){const r=i?s?i.keys.filter(P=>s.keys.indexOf(P)===-1):[...i.keys]:[],c=s?i?s.keys.filter(P=>i.keys.indexOf(P)===-1):[...s.keys]:[],p=[];if(i&&s){for(const P of s.keys)if(i.keys.indexOf(P)!==-1){const N=E(s.contents,P),$=E(i.contents,P);m.equals(N,$)||p.push(P)}}const v=[],A=P=>{const N={};for(const $ of P)for(const ie of $.identifiers)N[b(ie)]=$;return N},R=i?A(i.overrides):{},o=s?A(s.overrides):{};if(Object.keys(R).length)for(const P of r){const N=R[P];N&&v.push([(0,S.overrideIdentifierFromKey)(P),N.keys])}if(Object.keys(o).length)for(const P of c){const N=o[P];N&&v.push([(0,S.overrideIdentifierFromKey)(P),N.keys])}if(Object.keys(R).length&&Object.keys(o).length)for(const P of p){const N=o[P],$=R[P];if(N&&$){const ie=k({contents:N.contents,keys:N.keys,overrides:[]},{contents:$.contents,keys:$.keys,overrides:[]});v.push([(0,S.overrideIdentifierFromKey)(P),[...ie.added,...ie.removed,...ie.updated]])}}return{added:r,removed:c,updated:p,overrides:v}}e.compare=k;function l(s,i){const r=[];for(const c of Object.keys(s))if(S.OVERRIDE_PROPERTY_PATTERN.test(c)){const p={};for(const v in s[c])p[v]=s[c][v];r.push({identifiers:[(0,S.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(p),contents:h(p,i)})}return r}e.toOverrides=l;function h(s,i){const r=Object.create(null);for(let c in s)a(r,c,s[c],i);return r}e.toValuesTree=h;function a(s,i,r,c){const p=i.split("."),v=p.pop();let A=s;for(let R=0;R<p.length;R++){let o=p[R],P=A[o];switch(typeof P){case"undefined":P=A[o]=Object.create(null);break;case"object":break;default:c(`Ignoring ${i} as ${p.slice(0,R+1).join(".")} is ${JSON.stringify(P)}`);return}A=P}if(typeof A=="object"&&A!==null)try{A[v]=r}catch(R){c(`Ignoring ${i} as ${p.join(".")} is ${JSON.stringify(A)}`)}else c(`Ignoring ${i} as ${p.join(".")} is ${JSON.stringify(A)}`)}e.addToValueTree=a;function d(s,i){const r=i.split(".");f(s,r)}e.removeFromValueTree=d;function f(s,i){const r=i.shift();if(i.length===0){delete s[r];return}if(Object.keys(s).indexOf(r)!==-1){const c=s[r];typeof c=="object"&&!Array.isArray(c)&&(f(c,i),Object.keys(c).length===0&&delete s[r])}}function E(s,i,r){function c(A,R){let o=A;for(const P of R){if(typeof o!="object"||o===null)return;o=o[P]}return o}const p=i.split("."),v=c(s,p);return typeof v=="undefined"?r:v}e.getConfigurationValue=E;function w(s,i,r){Object.keys(i).forEach(c=>{c!=="__proto__"&&(c in s?F.isObject(s[c])&&F.isObject(i[c])?w(s[c],i[c],r):r&&(s[c]=i[c]):s[c]=i[c])})}e.merge=w;function u(){const s=y.Registry.as(S.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=u;function g(){const s=Object.create(null),i=y.Registry.as(S.Extensions.Configuration).getConfigurationProperties();for(let r in i){let c=i[r].default;a(s,r,c,p=>console.error(`Conflict in default settings: ${p}`))}return s}e.getDefaultValues=g;function b(s){return`[${s}]`}e.keyFromOverrideIdentifier=b;function t(s,i,r){const c=s.inspect(i),p=s.inspect(r);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:c.defaultValue}e.getMigratedSettingValue=t}),define(_e[153],ye([0,1,108,22,17,10,24,2,62,91,31,7,3]),function(ee,e,m,F,D,y,I,S,_,C,n,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(t={},s=[],i=[]){this._contents=t,this._keys=s,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,C.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,s){const i=this.getContentsForOverrideIdentifer(s);return i?t?(0,C.getConfigurationValue)(i,t):i:void 0}getKeysForOverrideIdentifier(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.keys;return[]}override(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let i={};for(const r of D.distinct([...Object.keys(this.contents),...Object.keys(s)])){let c=this.contents[r],p=s[r];p&&(typeof c=="object"&&typeof p=="object"?(c=I.deepClone(c),this.mergeContents(c,p)):c=p),i[r]=c}return new h(i,this.keys,this.overrides)}merge(...t){const s=I.deepClone(this.contents),i=I.deepClone(this.overrides),r=[...this.keys];for(const c of t){this.mergeContents(s,c.contents);for(const p of c.overrides){const[v]=i.filter(A=>D.equals(A.identifiers,p.identifiers));v?this.mergeContents(v.contents,p.contents):i.push(I.deepClone(p))}for(const p of c.keys)r.indexOf(p)===-1&&r.push(p)}return new h(s,r,i)}freeze(){return this.isFrozen=!0,this}mergeContents(t,s){for(const i of Object.keys(s)){if(i in t&&y.isObject(t[i])&&y.isObject(s[i])){this.mergeContents(t[i],s[i]);continue}t[i]=I.deepClone(s[i])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?I.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,s){this.addKey(t),(0,C.addToValueTree)(this.contents,t,s,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&(0,C.removeFromValueTree)(this.contents,t)}addKey(t){let s=this.keys.length;for(let i=0;i<s;i++)t.indexOf(this.keys[i])===0&&(s=i);this.keys.splice(s,1,t)}removeKey(t){let s=this.keys.indexOf(t);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=h;class a extends h{constructor(){const t=(0,C.getDefaultValues)(),s=(0,C.getConfigurationKeys)(),i=[];for(const r of Object.keys(t))_.OVERRIDE_PROPERTY_PATTERN.test(r)&&i.push({identifiers:[(0,_.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(t[r]),contents:(0,C.toValuesTree)(t[r],c=>console.error(`Conflict in default settings file: ${c}`))});super(t,s,i)}}e.DefaultConfigurationModel=a;class d{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!y.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:i,keys:r,overrides:c,restricted:p}=this.doParseRaw(t,s);this._configurationModel=new h(i,r,c),this._restrictedConfigurations=p||[]}doParseContent(t){let s={},i=null,r=[],c=[],p=[];function v(R){Array.isArray(r)?r.push(R):i&&(r[i]=R)}let A={onObjectBegin:()=>{let R={};v(R),c.push(r),r=R,i=null},onObjectProperty:R=>{i=R},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{let R=[];v(R),c.push(r),r=R,i=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:v,onError:(R,o,P)=>{p.push({error:R,offset:o,length:P})}};if(t)try{m.visit(t,A),s=r[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return s}doParseRaw(t,s){const i=n.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,i,!0,s);t=r.raw;const c=(0,C.toValuesTree)(t,A=>console.error(`Conflict in settings file ${this._name}: ${A}`)),p=Object.keys(t),v=(0,C.toOverrides)(t,A=>console.error(`Conflict in settings file ${this._name}: ${A}`));return{contents:c,keys:p,overrides:v,restricted:r.restricted}}filter(t,s,i,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:t,restricted:[]};const c={},p=[];for(let v in t)if(_.OVERRIDE_PROPERTY_PATTERN.test(v)&&i){const A=this.filter(t[v],s,!1,r);c[v]=A.raw,p.push(...A.restricted)}else{const A=s[v],R=A?typeof A.scope!="undefined"?A.scope:3:void 0;A?.restricted&&p.push(v),(R===void 0||r.scopes===void 0||r.scopes.includes(R))&&(r.skipRestricted&&A?.restricted||(c[v]=t[v]))}return{raw:c,restricted:p}}}e.ConfigurationModelParser=d;class f extends k.Disposable{constructor(t,s,i,r){super();this.userSettingsResource=t,this.scopes=s,this.fileService=r,this._onDidChange=this._register(new l.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(l.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=f;class E{constructor(t,s,i=new h,r=new h,c=new F.ResourceMap,p=new h,v=new F.ResourceMap,A=!0){this._defaultConfiguration=t,this._localUserConfiguration=s,this._remoteUserConfiguration=i,this._workspaceConfiguration=r,this._folderConfigurations=c,this._memoryConfiguration=p,this._memoryConfigurationByResource=v,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new F.ResourceMap,this._userConfiguration=null}getValue(t,s,i){return this.getConsolidateConfigurationModel(s,i).getValue(t)}updateValue(t,s,i={}){let r;i.resource?(r=this._memoryConfigurationByResource.get(i.resource),r||(r=new h,this._memoryConfigurationByResource.set(i.resource,r))):r=this._memoryConfiguration,s===void 0?r.removeValue(t):r.setValue(t,s),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,i){const r=this.getConsolidateConfigurationModel(s,i),c=this.getFolderConfigurationModelForResource(s.resource,i),p=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,v=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),A=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),R=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),o=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),P=i?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,N=c?s.overrideIdentifier?c.freeze().override(s.overrideIdentifier).getValue(t):c.freeze().getValue(t):void 0,$=s.overrideIdentifier?p.override(s.overrideIdentifier).getValue(t):p.getValue(t),ie=r.getValue(t),ce=D.distinct(D.flatten(r.overrides.map(K=>K.identifiers))).filter(K=>r.getOverrideValue(t,K)!==void 0);return{defaultValue:v,userValue:A,userLocalValue:R,userRemoteValue:o,workspaceValue:P,workspaceFolderValue:N,memoryValue:$,value:ie,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userRemote:o!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspace:P!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspaceFolder:N!==void 0?{value:c?.freeze().getValue(t),override:s.overrideIdentifier?c?.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,memory:$!==void 0?{value:p.getValue(t),override:s.overrideIdentifier?p.getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ce.length?ce:void 0}}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const i=s.filter(r=>_.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const c=(0,_.overrideIdentifierFromKey)(r),p=this._defaultConfiguration.getKeysForOverrideIdentifier(c),v=t.getKeysForOverrideIdentifier(c),A=[...v.filter(R=>p.indexOf(R)===-1),...p.filter(R=>v.indexOf(R)===-1),...p.filter(R=>!I.equals(this._defaultConfiguration.override(c).getValue(R),t.override(c).getValue(R)))];return[c,A]});return this.updateDefaultConfiguration(t),{keys:s,overrides:i}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:i,removed:r,overrides:c}=(0,C.compare)(this.localUserConfiguration,t),p=[...s,...i,...r];return p.length&&this.updateLocalUserConfiguration(t),{keys:p,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:i,removed:r,overrides:c}=(0,C.compare)(this.remoteUserConfiguration,t);let p=[...s,...i,...r];return p.length&&this.updateRemoteUserConfiguration(t),{keys:p,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:i,removed:r,overrides:c}=(0,C.compare)(this.workspaceConfiguration,t);let p=[...s,...i,...r];return p.length&&this.updateWorkspaceConfiguration(t),{keys:p,overrides:c}}compareAndUpdateFolderConfiguration(t,s){const i=this.folderConfigurations.get(t),{added:r,updated:c,removed:p,overrides:v}=(0,C.compare)(i,s);let A=[...r,...c,...p];return(A.length||!i)&&this.updateFolderConfiguration(t,s),{keys:A,overrides:v}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:r,removed:c,overrides:p}=(0,C.compare)(s,void 0);return{keys:[...i,...r,...c],overrides:p}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,s){let i=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier?i.override(t.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:t},s){let i=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const r=s.getFolder(t);r&&(i=this.getFolderConsolidatedConfiguration(r.uri)||i);const c=this._memoryConfigurationByResource.get(t);c&&(i=i.merge(c))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const i=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(s=i.merge(r),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(t,s)):s=i}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const i=s.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:i,overrides:r,keys:c}=this._folderConfigurations.get(s);return t.push([s,{contents:i,overrides:r,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>t.add(s)),this.userConfiguration.freeze().keys.forEach(s=>t.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>s.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>s.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r))),[...s.values()]}static parse(t){const s=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),c=t.folders.reduce((p,v)=>(p.set(S.URI.revive(v[0]),this.parseConfigurationModel(v[1])),p),new F.ResourceMap);return new E(s,i,new h,r,c,new h,new F.ResourceMap,!1)}static parseConfigurationModel(t){return new h(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=E;function w(...b){if(b.length===0)return{keys:[],overrides:[]};if(b.length===1)return b[0];const t=new Set,s=new Map;for(const r of b)r.keys.forEach(c=>t.add(c)),r.overrides.forEach(([c,p])=>{const v=(0,F.getOrSet)(s,c,new Set);p.forEach(A=>v.add(A))});const i=[];return s.forEach((r,c)=>i.push([c,[...r.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=w;class u{constructor(t,s,i,r){this.change=t,this.previous=s,this.currentConfiguraiton=i,this.currentWorkspace=r,this._previousConfiguration=void 0;const c=new Set;t.keys.forEach(v=>c.add(v)),t.overrides.forEach(([,v])=>v.forEach(A=>c.add(A))),this.affectedKeys=[...c.values()];const p=new h;this.affectedKeys.forEach(v=>p.setValue(v,{})),this.affectedKeysTree=p.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=E.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(s){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!I.equals(i,r)}return!0}return!1}doesAffectedKeysTreeContains(t,s){let i=(0,C.toValuesTree)({[s]:!0},()=>{}),r;for(;typeof i=="object"&&(r=Object.keys(i)[0]);){if(t=t[r],!t)return!1;i=i[r]}return!0}}e.ConfigurationChangeEvent=u;class g extends u{constructor(t,s,i,r){super({keys:t.allKeys(),overrides:[]},void 0,t,s);this.source=i,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=g}),define(_e[92],ye([0,1,4]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,m.createDecorator)("remoteAuthorityResolverService");var F;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(F=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(I,S=F.Unknown,_){super(I);this._message=I,this._code=S,this._detail=_,this.isHandled=S===F.NotAvailable&&_===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(I){return I instanceof D&&I._code===F.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof D&&I._code===F.NoResolverFound}static isHandled(I){return I instanceof D&&I.isHandled}}e.RemoteAuthorityResolverError=D}),define(_e[93],ye([0,1,11]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function F(C){return C.scheme===m.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=F;function D(C){if(!C)return;const n=C.indexOf("+");return n<0?C:C.substr(0,n)}e.getRemoteName=D;function y(C){return C.scheme!==m.Schemas.file&&C.scheme!==m.Schemas.vscodeRemote}e.isVirtualResource=y;function I(C){if(C.folders.length)return C.folders.every(n=>y(n.uri))?C.folders[0].uri:void 0;if(C.configuration&&y(C.configuration))return C.configuration}e.getVirtualWorkspaceLocation=I;function S(C){return I(C)?.scheme}e.getVirtualWorkspaceScheme=S;function _(C){return I(C)!==void 0}e.isVirtualWorkspace=_}),define(_e[154],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class m{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,y,I=5){let S;return S=y(_=>{const C=typeof _=="string"?_:_.data;let n=this._terminalBufferMap.get(D);if(n){n.data.push(C);return}const k=setTimeout(()=>this.flushBuffer(D),I);n={data:[C],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(D),S.dispose()}},this._terminalBufferMap.set(D,n)}),S}stopBuffering(D){const y=this._terminalBufferMap.get(D);y&&y.dispose()}flushBuffer(D){const y=this._terminalBufferMap.get(D);y&&(this._terminalBufferMap.delete(D),this._callback(D,y.data.join("")))}}e.TerminalDataBufferer=m}),define(_e[155],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(F){F.DARK="dark",F.LIGHT="light",F.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(_e[156],ye([0,1,4,7,31,3,155,53]),function(ee,e,m,F,D,y,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,m.createDecorator)("themeService");var _;(function(f){function E(w){return w&&typeof w=="object"&&typeof w.id=="string"}f.isThemeColor=E})(_=e.ThemeColor||(e.ThemeColor={}));function C(f){return{id:f}}e.themeColorFromId=C;var n;(function(f){function E(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||_.isThemeColor(s.color))}f.isThemeIcon=E;const w=new RegExp(`^\\$\\((${S.CSSIcon.iconNameExpression}(?:${S.CSSIcon.iconModifierExpression})?)\\)$`);function u(s){const i=w.exec(s);if(!i)return;let[,r]=i;return{id:r}}f.fromString=u;function g(s,i){let r=s.id;const c=r.lastIndexOf("~");return c!==-1&&(r=r.substring(0,c)),i&&(r=`${r}~${i}`),{id:r}}f.modify=g;function b(s,i){return s.id===i.id&&s.color?.id===i.color?.id}f.isEqual=b;function t(s,i){return{id:s.id,color:i?C(i):void 0}}f.asThemeIcon=t,f.asClassNameArray=S.CSSIcon.asClassNameArray,f.asClassName=S.CSSIcon.asClassName,f.asCSSSelector=S.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=S.Codicon.file,e.FolderThemeIcon=S.Codicon.folder;function k(f){switch(f){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class l{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new y.Emitter}onColorThemeChange(E){return this.themingParticipants.push(E),this.onThemingParticipantAddedEmitter.fire(E),(0,F.toDisposable)(()=>{const w=this.themingParticipants.indexOf(E);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let h=new l;D.Registry.add(e.Extensions.ThemingContribution,h);function a(f){return h.onColorThemeChange(f)}e.registerThemingParticipant=a;class d extends F.Disposable{constructor(E){super();this.themeService=E,this.theme=E.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(E){this.theme=E,this.updateStyles()}updateStyles(){}getColor(E,w){let u=this.theme.getColor(E);return u&&w&&(u=w(u,this.theme)),u?u.toString():null}}e.Themable=d}),define(_e[44],ye([0,1,2,25,4,22]),function(ee,e,m,F,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");var I;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(I=e.WorkbenchState||(e.WorkbenchState={}));function S(l){const h=l;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=S;function _(l){const h=l;return!!(h&&typeof h=="object"&&m.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=_;class C{constructor(h,a,d,f){this._id=h,this._configuration=d,this._ignorePathCasing=f,this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=a}update(h){this._id=h.id,this._configuration=h.configuration,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=C;class n{constructor(h,a){this.raw=a,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,F.joinPath)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function k(l){return new n({uri:l,index:0,name:(0,F.basenameOrAuthority)(l)},{uri:l.toString()})}e.toWorkspaceFolder=k}),define(_e[63],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class m{constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const y=this._idPool++;return this._data.set(y,D),this.logDebugInfo(),y}get(D,y){return this._data.has(D)?this._data.get(D)[y]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){!m.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=m,m.enableDebugLogging=!1}),define(_e[64],ye([0,1,2,3,4]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,D.createDecorator)("IExtHostEditorTabs");class y{constructor(){this._onDidChangeTabs=new F.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(S){this._tabs=S.map(_=>({name:_.name,group:_.group,resource:m.URI.revive(_.resource),isActive:_.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=y}),define(_e[45],ye([0,1,11,4]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class D{constructor(){this._systemSchemes=new Set(Object.keys(m.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(I,S){S===null?this._providerInfo.delete(I):this._providerInfo.set(I,S)}isFreeScheme(I){return!this._providerInfo.has(I)&&!this._systemSchemes.has(I)}getCapabilities(I){return this._providerInfo.get(I)}}e.ExtHostFileSystemInfo=D,e.IExtHostFileSystemInfo=(0,F.createDecorator)("IExtHostFileSystemInfo")}),define(_e[28],ye([0,1,4]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,m.createDecorator)("IExtHostInitDataService")}),define(_e[157],ye([0,1,2]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class F{constructor(y,I,S){this._extHostNotebooks=I,this._textDocumentsAndEditors=S}$willAddInteractiveDocument(y,I,S,_){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:I,lines:[""],modeId:S,uri:y,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(m.URI.revive(_))?.apiNotebook}]})}$willRemoveInteractiveDocument(y,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[y]})}}e.ExtHostInteractive=F}),define(_e[158],ye([0,1,16]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class F{constructor(I,S,_){this._deferredPromises=new Map,this._id=I,this._shared=S,this._storage=_,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(C=>(this._value=C,this)),this._storageListener=this._storage.onDidChangeStorage(C=>{C.shared===this._shared&&C.key===this._id&&(this._value=C.value)}),this._scheduler=new m.RunOnceScheduler(()=>{const C=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of C.values())n.complete()}catch(n){for(const k of C.values())k.error(n)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,I])=>I!==void 0).map(([I])=>I)}get whenReady(){return this._init}get(I,S){let _=this._value[I];return typeof _=="undefined"&&(_=S),_}update(I,S){this._value[I]=S;let _=this._deferredPromises.get(I);if(_!==void 0)return _.p;const C=new m.DeferredPromise;return this._deferredPromises.set(I,C),this._scheduler.isScheduled()||this._scheduler.schedule(),C.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=F;class D extends F{constructor(I,S){super(I.identifier.value,!0,S);this._extension=I}setKeysForSync(I){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},I)}}e.ExtensionGlobalMemento=D}),define(_e[159],ye([0,1,3,2,15]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let y=class{constructor(S,_){this._logService=S,this._notebooksAndEditors=_,this._onDidChangeNotebookDocumentMetadata=new m.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new m.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(S,_,C){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(S)).acceptModelChanged(_,C)}$acceptDirtyStateChanged(S,_){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(S)).acceptDirty(_)}$acceptModelSaved(S){const _=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(S));this._onDidSaveNotebookDocument.fire(_.apiNotebook)}$acceptDocumentPropertiesChanged(S,_){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",S.path,_);const C=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(S));C.acceptDocumentPropertiesChanged(_),_.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:C.apiNotebook})}};y=ze([je(0,D.ILogService)],y),e.ExtHostNotebookDocuments=y}),define(_e[13],ye([0,1,4]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,m.createDecorator)("IExtHostRpcService");class F{constructor(y){this.getProxy=y.getProxy.bind(y),this.set=y.set.bind(y),this.assertRegistered=y.assertRegistered.bind(y),this.drain=y.drain.bind(y)}}e.ExtHostRpcService=F});var nt=this&&this.__classPrivateFieldSet||function(ee,e,m,F,D){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?D.call(ee,m):D?D.value=m:e.set(ee,m),m},Le=this&&this.__classPrivateFieldGet||function(ee,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(ee):F?F.value:e.get(ee)};define(_e[160],ye([0,1,26,3]),function(ee,e,m,F){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class y{constructor(S,_){D.set(this,void 0),this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._id=m.ExtensionIdentifier.toKey(S.identifier),nt(this,D,_,"f"),Le(this,D,"f").onDidChangePassword(C=>{C.extensionId===this._id&&this._onDidChange.fire({key:C.key})})}get(S){return Le(this,D,"f").get(this._id,S)}store(S,_){return Le(this,D,"f").store(this._id,S,_)}delete(S){return Le(this,D,"f").delete(this._id,S)}}e.ExtensionSecrets=y,D=new WeakMap}),define(_e[94],ye([0,1,4,3]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class D{constructor(){this._onDidChangeTelemetryEnabled=new F.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(I){this._enabled=I}$onDidChangeTelemetryEnabled(I){this._enabled=I,this._onDidChangeTelemetryEnabled.fire(I)}}e.ExtHostTelemetry=D,e.IExtHostTelemetry=(0,m.createDecorator)("IExtHostTelemetry")}),define(_e[65],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemImpl=e.createTestItemCollection=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var m;(function(d){d[d.Upsert=0]="Upsert",d[d.RemoveChild=1]="RemoveChild",d[d.Invalidated=2]="Invalidated",d[d.SetProp=3]="SetProp",d[d.Bulk=4]="Bulk"})(m=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const F=new WeakMap,D=d=>{let f=F.get(d);return f||(f={},F.set(d,f)),f};e.getPrivateApiFor=D;const y=(d,f,E,w)=>{let u=E;return{enumerable:!0,configurable:!1,get(){return u},set(g){w(u,g)||(u=g,d.listener?.({op:3,key:f,value:g}))}}},I=(d,f)=>d===f,S={range:(d,f)=>d===f?!0:!d||!f?!1:d.isEqual(f),label:I,description:I,busy:I,error:I,canResolveChildren:I},_=Object.keys(S),C=(d,f)=>({range:y(d,"range",void 0,S.range),label:y(d,"label",f,S.label),description:y(d,"description",void 0,S.description),canResolveChildren:y(d,"canResolveChildren",!1,S.canResolveChildren),busy:y(d,"busy",!1,S.busy),error:y(d,"error",void 0,S.error)}),n=(d,f)=>{const E=new Map;for(const w of _)S[w](d[w],f[w])||E.set(w,f[w]);return E};e.diffTestItems=n;class k extends Error{constructor(f){super(`Attempted to insert a duplicate test item ID ${f}`)}}e.DuplicateTestItemError=k;class l extends Error{constructor(f){super(`TestItem with ID "${f}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=l;const h=d=>{const f=(0,e.getPrivateApiFor)(d);let E,w=new Map;return{get all(){return E||(E=Object.freeze([...w.values()])),E},set all(u){const g=new Map,b=new Set(w.keys()),t={op:4,ops:[]};for(const s of u){if(!(s instanceof a))throw new l(s.id);if(g.has(s.id))throw new k(s.id);g.set(s.id,s),b.delete(s.id),t.ops.push({op:0,item:s})}for(const s of b.keys())t.ops.push({op:1,id:s});f.listener?.(t),w=g,E=void 0},add(u){if(!(u instanceof a))throw new l(u.id);w.set(u.id,u),E=void 0,f.listener?.({op:0,item:u})},remove(u){w.delete(u)&&(E=void 0,f.listener?.({op:1,id:u}))},get(u){return w.get(u)},toJSON(){return this.all}}};e.createTestItemCollection=h;class a{constructor(f,E,w){const u=(0,e.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:f,enumerable:!0,writable:!1},uri:{value:w,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return u.parent}},children:{value:(0,e.createTestItemCollection)(this),enumerable:!0,writable:!1},...C(u,E)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=a}),define(_e[66],ye([0,1,4,3,13]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var y;(function(S){function _(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,protocol:n.protocol}}S.fromApiTunnel=_;function C(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public,protocol:n.protocol}}S.fromServiceTunnel=C})(y=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,m.createDecorator)("IExtHostTunnelService");let I=class{constructor(_){this.onDidChangeTunnels=new F.Emitter().event}async $applyCandidateFilter(_){return _}async openTunnel(_,C){}async getTunnels(){return[]}async setTunnelExtensionFunctions(_){return{dispose:()=>{}}}registerPortsAttributesProvider(_,C){return{dispose:()=>{}}}async $providePortAttributes(_,C,n,k,l){return[]}async $forwardPort(_,C){}async $closeTunnel(_){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};I=ze([je(0,D.IExtHostRpcService)],I),e.ExtHostTunnelService=I});var nt=this&&this.__classPrivateFieldSet||function(ee,e,m,F,D){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?D.call(ee,m):D?D.value=m:e.set(ee,m),m},Le=this&&this.__classPrivateFieldGet||function(ee,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(ee):F?F.value:e.get(ee)};define(_e[6],ye([0,1,17,12,81,22,83,10,2,35,60,92]),function(ee,e,m,F,D,y,I,S,_,C,n,k){"use strict";var l,h,a,d,f,E,w,u,g,b,t,s,i,r,c,p,v,A,R,o;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestMessage=e.TestRunRequest=e.TestRunConfigurationGroup=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function P(O){function M(){return Reflect.construct(O,arguments,this.constructor)}return Object.defineProperty(M,"name",Object.getOwnPropertyDescriptor(O,"name")),Object.setPrototypeOf(M,O),Object.setPrototypeOf(M.prototype,O.prototype),M}let N=f=class{constructor(M){l.set(this,void 0),nt(this,l,M,"f")}static from(...M){let Z=M;return new f(function(){if(Z){for(const ke of Z)ke&&typeof ke.dispose=="function"&&ke.dispose();Z=void 0}})}dispose(){typeof Le(this,l,"f")=="function"&&(Le(this,l,"f").call(this),nt(this,l,void 0,"f"))}};l=new WeakMap,N=f=ze([P],N),e.Disposable=N;let $=E=class{constructor(M,Z){if(M<0)throw(0,F.illegalArgument)("line must be non-negative");if(Z<0)throw(0,F.illegalArgument)("character must be non-negative");this._line=M,this._character=Z}static Min(...M){if(M.length===0)throw new TypeError;let Z=M[0];for(let ke=1;ke<M.length;ke++){const Je=M[ke];Je.isBefore(Z)&&(Z=Je)}return Z}static Max(...M){if(M.length===0)throw new TypeError;let Z=M[0];for(let ke=1;ke<M.length;ke++){const Je=M[ke];Je.isAfter(Z)&&(Z=Je)}return Z}static isPosition(M){if(!M)return!1;if(M instanceof E)return!0;let{line:Z,character:ke}=M;return typeof Z=="number"&&typeof ke=="number"}get line(){return this._line}get character(){return this._character}isBefore(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<M._character}isBeforeOrEqual(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<=M._character}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this._line===M._line&&this._character===M._character}compareTo(M){return this._line<M._line?-1:this._line>M.line?1:this._character<M._character?-1:this._character>M._character?1:0}translate(M,Z=0){if(M===null||Z===null)throw(0,F.illegalArgument)();let ke;return typeof M=="undefined"?ke=0:typeof M=="number"?ke=M:(ke=typeof M.lineDelta=="number"?M.lineDelta:0,Z=typeof M.characterDelta=="number"?M.characterDelta:0),ke===0&&Z===0?this:new E(this.line+ke,this.character+Z)}with(M,Z=this.character){if(M===null||Z===null)throw(0,F.illegalArgument)();let ke;return typeof M=="undefined"?ke=this.line:typeof M=="number"?ke=M:(ke=typeof M.line=="number"?M.line:this.line,Z=typeof M.character=="number"?M.character:this.character),ke===this.line&&Z===this.character?this:new E(ke,Z)}toJSON(){return{line:this.line,character:this.character}}};$=E=ze([P],$),e.Position=$;let ie=w=class{constructor(M,Z,ke,Je){let it,st;if(typeof M=="number"&&typeof Z=="number"&&typeof ke=="number"&&typeof Je=="number"?(it=new $(M,Z),st=new $(ke,Je)):M instanceof $&&Z instanceof $&&(it=M,st=Z),!it||!st)throw new Error("Invalid arguments");it.isBefore(st)?(this._start=it,this._end=st):(this._start=st,this._end=it)}static isRange(M){return M instanceof w?!0:M?$.isPosition(M.start)&&$.isPosition(M.end):!1}get start(){return this._start}get end(){return this._end}contains(M){return M instanceof w?this.contains(M._start)&&this.contains(M._end):M instanceof $?!(M.isBefore(this._start)||this._end.isBefore(M)):!1}isEqual(M){return this._start.isEqual(M._start)&&this._end.isEqual(M._end)}intersection(M){const Z=$.Max(M.start,this._start),ke=$.Min(M.end,this._end);if(!Z.isAfter(ke))return new w(Z,ke)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const Z=$.Min(M.start,this._start),ke=$.Max(M.end,this.end);return new w(Z,ke)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(M,Z=this.end){if(M===null||Z===null)throw(0,F.illegalArgument)();let ke;return M?$.isPosition(M)?ke=M:(ke=M.start||this.start,Z=M.end||this.end):ke=this.start,ke.isEqual(this._start)&&Z.isEqual(this.end)?this:new w(ke,Z)}toJSON(){return[this.start,this.end]}};ie=w=ze([P],ie),e.Range=ie;let ce=u=class extends ie{constructor(M,Z,ke,Je){let it,st;if(typeof M=="number"&&typeof Z=="number"&&typeof ke=="number"&&typeof Je=="number"?(it=new $(M,Z),st=new $(ke,Je)):M instanceof $&&Z instanceof $&&(it=M,st=Z),!it||!st)throw new Error("Invalid arguments");super(it,st);this._anchor=it,this._active=st}static isSelection(M){return M instanceof u?!0:M?ie.isRange(M)&&$.isPosition(M.anchor)&&$.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};ce=u=ze([P],ce),e.Selection=ce;class K{constructor(M,Z,ke){if(typeof M!="string"||M.length===0)throw(0,F.illegalArgument)("host");if(typeof Z!="number"||Z===0||Math.round(Z)!==Z)throw(0,F.illegalArgument)("port");if(typeof ke!="undefined"&&(typeof ke!="string"||ke.length===0||!/^[0-9A-Za-z\-]+$/.test(ke)))throw(0,F.illegalArgument)("connectionToken");this.host=M,this.port=Math.round(Z),this.connectionToken=ke}}e.ResolvedAuthority=K;class H extends Error{constructor(M,Z=k.RemoteAuthorityResolverErrorCode.Unknown,ke){super(M);this._message=M,this._code=Z,this._detail=ke,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,H.prototype)}static NotAvailable(M,Z){return new H(M,k.RemoteAuthorityResolverErrorCode.NotAvailable,Z)}static TemporarilyNotAvailable(M){return new H(M,k.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=H;var z;(function(O){O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(z=e.EndOfLine||(e.EndOfLine={}));var T;(function(O){O[O.Replace=1]="Replace",O[O.Append=2]="Append",O[O.Prepend=3]="Prepend"})(T=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let q=g=class{constructor(M,Z){this._range=M,this._newText=Z}static isTextEdit(M){return M instanceof g?!0:M?ie.isRange(M)&&typeof M.newText=="string":!1}static replace(M,Z){return new g(M,Z)}static insert(M,Z){return g.replace(new ie(M,M),Z)}static delete(M){return g.replace(M,"")}static setEndOfLine(M){const Z=new g(new ie(new $(0,0),new $(0,0)),"");return Z.newEol=M,Z}get range(){return this._range}set range(M){if(M&&!ie.isRange(M))throw(0,F.illegalArgument)("range");this._range=M}get newText(){return this._newText||""}set newText(M){if(M&&typeof M!="string")throw(0,F.illegalArgument)("newText");this._newText=M}get newEol(){return this._newEol}set newEol(M){if(M&&typeof M!="number")throw(0,F.illegalArgument)("newEol");this._newEol=M}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};q=g=ze([P],q),e.TextEdit=q;var L;(function(O){O[O.File=1]="File",O[O.Text=2]="Text",O[O.Cell=3]="Cell",O[O.CellReplace=5]="CellReplace"})(L=e.FileEditType||(e.FileEditType={}));let B=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(M,Z,ke,Je){this._edits.push({_type:1,from:M,to:Z,options:ke,metadata:Je})}createFile(M,Z,ke){this._edits.push({_type:1,from:void 0,to:M,options:Z,metadata:ke})}deleteFile(M,Z,ke){this._edits.push({_type:1,from:M,to:void 0,options:Z,metadata:ke})}replaceNotebookMetadata(M,Z,ke){this._edits.push({_type:3,metadata:ke,uri:M,edit:{editType:5,metadata:Z},notebookMetadata:Z})}replaceNotebookCells(M,Z,ke,Je,it){let st,ot,yt=[],It;if(Bt.isNotebookRange(Z)&&Lt.isNotebookCellDataArray(ke)&&!Lt.isNotebookCellDataArray(Je)?(st=Z.start,ot=Z.end,yt=ke,It=Je):typeof Z=="number"&&typeof ke=="number"&&Lt.isNotebookCellDataArray(Je)&&(st=Z,ot=ke,yt=Je,It=it),st===void 0||ot===void 0)throw new Error("Invalid arguments");(st!==ot||yt.length>0)&&this._edits.push({_type:5,uri:M,index:st,count:ot-st,cells:yt,metadata:It})}replaceNotebookCellMetadata(M,Z,ke,Je){this._edits.push({_type:3,metadata:Je,uri:M,edit:{editType:8,index:Z,metadata:ke}})}replace(M,Z,ke,Je){this._edits.push({_type:2,uri:M,edit:new q(Z,ke),metadata:Je})}insert(M,Z,ke,Je){this.replace(M,new ie(Z,Z),ke,Je)}delete(M,Z,ke){this.replace(M,Z,"",ke)}has(M){return this._edits.some(Z=>Z._type===2&&Z.uri.toString()===M.toString())}set(M,Z){if(Z)for(const ke of Z)ke&&this._edits.push({_type:2,uri:M,edit:ke});else{for(let ke=0;ke<this._edits.length;ke++){const Je=this._edits[ke];Je._type===2&&Je.uri.toString()===M.toString()&&(this._edits[ke]=void 0)}(0,m.coalesceInPlace)(this._edits)}}get(M){const Z=[];for(let ke of this._edits)ke._type===2&&ke.uri.toString()===M.toString()&&Z.push(ke.edit);return Z}entries(){const M=new y.ResourceMap;for(let Z of this._edits)if(Z._type===2){let ke=M.get(Z.uri);ke||(ke=[Z.uri,[]],M.set(Z.uri,ke)),ke[1].push(Z.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};B=ze([P],B),e.WorkspaceEdit=B;let Y=b=class{constructor(M){this._tabstop=1,this.value=M||""}static isSnippetString(M){return M instanceof b?!0:M?typeof M.value=="string":!1}static _escape(M){return M.replace(/\$|}|\\/g,"\\$&")}appendText(M){return this.value+=b._escape(M),this}appendTabstop(M=this._tabstop++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,Z=this._tabstop++){if(typeof M=="function"){const ke=new b;ke._tabstop=this._tabstop,M(ke),this._tabstop=ke._tabstop,M=ke.value}else M=b._escape(M);return this.value+="${",this.value+=Z,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,Z=this._tabstop++){const ke=M.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=Z,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(M,Z){if(typeof Z=="function"){const ke=new b;ke._tabstop=this._tabstop,Z(ke),this._tabstop=ke._tabstop,Z=ke.value}else typeof Z=="string"&&(Z=Z.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,Z&&(this.value+=":",this.value+=Z),this.value+="}",this}};Y=b=ze([P],Y),e.SnippetString=Y;var j;(function(O){O[O.Unnecessary=1]="Unnecessary",O[O.Deprecated=2]="Deprecated"})(j=e.DiagnosticTag||(e.DiagnosticTag={}));var se;(function(O){O[O.Hint=3]="Hint",O[O.Information=2]="Information",O[O.Warning=1]="Warning",O[O.Error=0]="Error"})(se=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Se=t=class{constructor(M,Z){if(this.uri=M,Z)if(Z instanceof ie)this.range=Z;else if(Z instanceof $)this.range=new ie(Z,Z);else throw new Error("Illegal argument")}static isLocation(M){return M instanceof t?!0:M?ie.isRange(M.range)&&_.URI.isUri(M.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Se=t=ze([P],Se),e.Location=Se;let Re=class{constructor(M,Z){this.location=M,this.message=Z}static is(M){return M?typeof M.message=="string"&&M.location&&ie.isRange(M.location.range)&&_.URI.isUri(M.location.uri):!1}static isEqual(M,Z){return M===Z?!0:!M||!Z?!1:M.message===Z.message&&M.location.range.isEqual(Z.location.range)&&M.location.uri.toString()===Z.location.uri.toString()}};Re=ze([P],Re),e.DiagnosticRelatedInformation=Re;let $e=class{constructor(M,Z,ke=se.Error){if(!ie.isRange(M))throw new TypeError("range must be set");if(!Z)throw new TypeError("message must be set");this.range=M,this.message=Z,this.severity=ke}toJSON(){return{severity:se[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,Z){return M===Z?!0:!M||!Z?!1:M.message===Z.message&&M.severity===Z.severity&&M.code===Z.code&&M.severity===Z.severity&&M.source===Z.source&&M.range.isEqual(Z.range)&&(0,m.equals)(M.tags,Z.tags)&&(0,m.equals)(M.relatedInformation,Z.relatedInformation,Re.isEqual)}};$e=ze([P],$e),e.Diagnostic=$e;let Ne=class{constructor(M,Z){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=Z}};Ne=ze([P],Ne),e.Hover=Ne;var Ge;(function(O){O[O.Text=0]="Text",O[O.Read=1]="Read",O[O.Write=2]="Write"})(Ge=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ke=class{constructor(M,Z=Ge.Text){this.range=M,this.kind=Z}toJSON(){return{range:this.range,kind:Ge[this.kind]}}};Ke=ze([P],Ke),e.DocumentHighlight=Ke;var qe;(function(O){O[O.File=0]="File",O[O.Module=1]="Module",O[O.Namespace=2]="Namespace",O[O.Package=3]="Package",O[O.Class=4]="Class",O[O.Method=5]="Method",O[O.Property=6]="Property",O[O.Field=7]="Field",O[O.Constructor=8]="Constructor",O[O.Enum=9]="Enum",O[O.Interface=10]="Interface",O[O.Function=11]="Function",O[O.Variable=12]="Variable",O[O.Constant=13]="Constant",O[O.String=14]="String",O[O.Number=15]="Number",O[O.Boolean=16]="Boolean",O[O.Array=17]="Array",O[O.Object=18]="Object",O[O.Key=19]="Key",O[O.Null=20]="Null",O[O.EnumMember=21]="EnumMember",O[O.Struct=22]="Struct",O[O.Event=23]="Event",O[O.Operator=24]="Operator",O[O.TypeParameter=25]="TypeParameter"})(qe=e.SymbolKind||(e.SymbolKind={}));var U;(function(O){O[O.Deprecated=1]="Deprecated"})(U=e.SymbolTag||(e.SymbolTag={}));let G=s=class{constructor(M,Z,ke,Je,it){this.name=M,this.kind=Z,this.containerName=it,typeof ke=="string"&&(this.containerName=ke),Je instanceof Se?this.location=Je:ke instanceof ie&&(this.location=new Se(Je,ke)),s.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:qe[this.kind],location:this.location,containerName:this.containerName}}};G=s=ze([P],G),e.SymbolInformation=G;let te=i=class{constructor(M,Z,ke,Je,it){this.name=M,this.detail=Z,this.kind=ke,this.range=Je,this.selectionRange=it,this.children=[],i.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children&&M.children.forEach(i.validate)}};te=i=ze([P],te),e.DocumentSymbol=te;var re;(function(O){O[O.Invoke=1]="Invoke",O[O.Automatic=2]="Automatic"})(re=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let pe=class{constructor(M,Z){this.title=M,this.kind=Z}};pe=ze([P],pe),e.CodeAction=pe;let Q=r=class{constructor(M){this.value=M}append(M){return new r(this.value?this.value+r.sep+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+r.sep)}};Q.sep=".",Q=r=ze([P],Q),e.CodeActionKind=Q,Q.Empty=new Q(""),Q.QuickFix=Q.Empty.append("quickfix"),Q.Refactor=Q.Empty.append("refactor"),Q.RefactorExtract=Q.Refactor.append("extract"),Q.RefactorInline=Q.Refactor.append("inline"),Q.RefactorRewrite=Q.Refactor.append("rewrite"),Q.Source=Q.Empty.append("source"),Q.SourceOrganizeImports=Q.Source.append("organizeImports"),Q.SourceFixAll=Q.Source.append("fixAll");let ue=class{constructor(M,Z){if(this.range=M,this.parent=Z,Z&&!Z.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ue=ze([P],ue),e.SelectionRange=ue;class Ie{constructor(M,Z,ke,Je,it,st){this.kind=M,this.name=Z,this.detail=ke,this.uri=Je,this.range=it,this.selectionRange=st}}e.CallHierarchyItem=Ie;class xe{constructor(M,Z){this.fromRanges=Z,this.from=M}}e.CallHierarchyIncomingCall=xe;class We{constructor(M,Z){this.fromRanges=Z,this.to=M}}e.CallHierarchyOutgoingCall=We;let ve=class{constructor(M,Z){this.range=M,this.command=Z}get isResolved(){return!!this.command}};ve=ze([P],ve),e.CodeLens=ve;let tt=c=class{constructor(M,Z=!1){h.set(this,void 0),nt(this,h,new D.MarkdownString(M,{supportThemeIcons:Z}),"f")}static isMarkdownString(M){return M instanceof c?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}get value(){return Le(this,h,"f").value}set value(M){Le(this,h,"f").value=M}get isTrusted(){return Le(this,h,"f").isTrusted}set isTrusted(M){Le(this,h,"f").isTrusted=M}get supportThemeIcons(){return Le(this,h,"f").supportThemeIcons}set supportThemeIcons(M){Le(this,h,"f").supportThemeIcons=M}appendText(M){return Le(this,h,"f").appendText(M),this}appendMarkdown(M){return Le(this,h,"f").appendMarkdown(M),this}appendCodeblock(M,Z){return Le(this,h,"f").appendCodeblock(Z??"",M),this}};h=new WeakMap,tt=c=ze([P],tt),e.MarkdownString=tt;let W=class{constructor(M,Z){this.label=M,this.documentation=Z}};W=ze([P],W),e.ParameterInformation=W;let J=class{constructor(M,Z){this.label=M,this.documentation=Z,this.parameters=[]}};J=ze([P],J),e.SignatureInformation=J;let fe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};fe=ze([P],fe),e.SignatureHelp=fe;var Oe;(function(O){O[O.Invoke=1]="Invoke",O[O.TriggerCharacter=2]="TriggerCharacter",O[O.ContentChange=3]="ContentChange"})(Oe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ue;(function(O){O[O.Other=0]="Other",O[O.Type=1]="Type",O[O.Parameter=2]="Parameter"})(Ue=e.InlayHintKind||(e.InlayHintKind={}));let et=class{constructor(M,Z,ke){this.text=M,this.position=Z,this.kind=ke}};et=ze([P],et),e.InlayHint=et;var Ce;(function(O){O[O.Invoke=0]="Invoke",O[O.TriggerCharacter=1]="TriggerCharacter",O[O.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var De;(function(O){O[O.Text=0]="Text",O[O.Method=1]="Method",O[O.Function=2]="Function",O[O.Constructor=3]="Constructor",O[O.Field=4]="Field",O[O.Variable=5]="Variable",O[O.Class=6]="Class",O[O.Interface=7]="Interface",O[O.Module=8]="Module",O[O.Property=9]="Property",O[O.Unit=10]="Unit",O[O.Value=11]="Value",O[O.Enum=12]="Enum",O[O.Keyword=13]="Keyword",O[O.Snippet=14]="Snippet",O[O.Color=15]="Color",O[O.File=16]="File",O[O.Reference=17]="Reference",O[O.Folder=18]="Folder",O[O.EnumMember=19]="EnumMember",O[O.Constant=20]="Constant",O[O.Struct=21]="Struct",O[O.Event=22]="Event",O[O.Operator=23]="Operator",O[O.TypeParameter=24]="TypeParameter",O[O.User=25]="User",O[O.Issue=26]="Issue"})(De=e.CompletionItemKind||(e.CompletionItemKind={}));var Ae;(function(O){O[O.Deprecated=1]="Deprecated"})(Ae=e.CompletionItemTag||(e.CompletionItemTag={}));let ne=class{constructor(M,Z){this.label=M,this.kind=Z}toJSON(){return{label:this.label,kind:this.kind&&De[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ne=ze([P],ne),e.CompletionItem=ne;let oe=class{constructor(M=[],Z=!1){this.items=M,this.isIncomplete=Z}};oe=ze([P],oe),e.CompletionList=oe;let de=class{constructor(M,Z,ke){this.text=M,this.range=Z,this.command=ke}};de=ze([P],de),e.InlineSuggestion=de;let ge=class{constructor(M){this.items=M}};ge=ze([P],ge),e.InlineSuggestions=ge;var x;(function(O){O[O.Active=-1]="Active",O[O.Beside=-2]="Beside",O[O.One=1]="One",O[O.Two=2]="Two",O[O.Three=3]="Three",O[O.Four=4]="Four",O[O.Five=5]="Five",O[O.Six=6]="Six",O[O.Seven=7]="Seven",O[O.Eight=8]="Eight",O[O.Nine=9]="Nine"})(x=e.ViewColumn||(e.ViewColumn={}));var he;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(he=e.StatusBarAlignment||(e.StatusBarAlignment={}));var we;(function(O){O[O.Off=0]="Off",O[O.On=1]="On",O[O.Relative=2]="Relative"})(we=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Pe;(function(O){O[O.Manual=1]="Manual",O[O.AfterDelay=2]="AfterDelay",O[O.FocusOut=3]="FocusOut"})(Pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Fe;(function(O){O[O.Default=0]="Default",O[O.InCenter=1]="InCenter",O[O.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",O[O.AtTop=3]="AtTop"})(Fe=e.TextEditorRevealType||(e.TextEditorRevealType={}));var He;(function(O){O[O.Keyboard=1]="Keyboard",O[O.Mouse=2]="Mouse",O[O.Command=3]="Command"})(He=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ze;(function(O){O[O.Undo=1]="Undo",O[O.Redo=2]="Redo"})(Ze=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Qe;(function(O){O[O.OpenOpen=0]="OpenOpen",O[O.ClosedClosed=1]="ClosedClosed",O[O.OpenClosed=2]="OpenClosed",O[O.ClosedOpen=3]="ClosedOpen"})(Qe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(O){function M(Z){switch(Z){case"keyboard":return O.Keyboard;case"mouse":return O.Mouse;case"api":return O.Command}}O.fromValue=M}(He=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ye=class{constructor(M,Z){if(Z&&!_.URI.isUri(Z))throw(0,F.illegalArgument)("target");if(!ie.isRange(M)||M.isEmpty)throw(0,F.illegalArgument)("range");this.range=M,this.target=Z}};Ye=ze([P],Ye),e.DocumentLink=Ye;let at=class{constructor(M,Z,ke,Je){this.red=M,this.green=Z,this.blue=ke,this.alpha=Je}};at=ze([P],at),e.Color=at;let ct=class{constructor(M,Z){if(Z&&!(Z instanceof at))throw(0,F.illegalArgument)("color");if(!ie.isRange(M)||M.isEmpty)throw(0,F.illegalArgument)("range");this.range=M,this.color=Z}};ct=ze([P],ct),e.ColorInformation=ct;let wt=class{constructor(M){if(!M||typeof M!="string")throw(0,F.illegalArgument)("label");this.label=M}};wt=ze([P],wt),e.ColorPresentation=wt;var me;(function(O){O[O.RGB=0]="RGB",O[O.HEX=1]="HEX",O[O.HSL=2]="HSL"})(me=e.ColorFormat||(e.ColorFormat={}));var Ee;(function(O){O[O.Error=0]="Error",O[O.Warning=1]="Warning",O[O.Information=2]="Information"})(Ee=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class ae{constructor(M,Z,ke){if(this.startIndex=M,this.length=Z,this.tooltip=ke,typeof M!="number"||M<0)throw(0,F.illegalArgument)("startIndex");if(typeof Z!="number"||Z<1)throw(0,F.illegalArgument)("length");if(ke!==void 0&&typeof ke!="string")throw(0,F.illegalArgument)("tooltip")}}e.TerminalLink=ae;class V{constructor(M){this.options=M,typeof M!="object"&&(0,F.illegalArgument)("options")}}e.TerminalProfile=V;var be;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(be=e.TaskRevealKind||(e.TaskRevealKind={}));var Be;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(Be=e.TaskPanelKind||(e.TaskPanelKind={}));let Xe=p=class{constructor(M,Z){if(typeof M!="string"||typeof Z!="string")throw(0,F.illegalArgument)("name");this._id=M}static from(M){switch(M){case"clean":return p.Clean;case"build":return p.Build;case"rebuild":return p.Rebuild;case"test":return p.Test;default:return}}get id(){return this._id}};Xe.Clean=new p("clean","Clean"),Xe.Build=new p("build","Build"),Xe.Rebuild=new p("rebuild","Rebuild"),Xe.Test=new p("test","Test"),Xe=p=ze([P],Xe),e.TaskGroup=Xe;function Ve(O){let M="";for(let Z=0;Z<O.length;Z++)M+=O[Z].replace(/,/g,",,")+",";return M}let lt=class{constructor(M,Z,ke){if(typeof M!="string")throw(0,F.illegalArgument)("process");this._args=[],this._process=M,Z!==void 0&&(Array.isArray(Z)?(this._args=Z,this._options=ke):this._options=Z)}get process(){return this._process}set process(M){if(typeof M!="string")throw(0,F.illegalArgument)("process");this._process=M}get args(){return this._args}set args(M){Array.isArray(M)||(M=[]),this._args=M}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("process"),this._process!==void 0&&M.push(this._process),this._args&&this._args.length>0)for(let Z of this._args)M.push(Z);return Ve(M)}};lt=ze([P],lt),e.ProcessExecution=lt;let ht=class{constructor(M,Z,ke){if(this._args=[],Array.isArray(Z)){if(!M)throw(0,F.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,F.illegalArgument)("command");this._command=M,this._args=Z,this._options=ke}else{if(typeof M!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=M,this._options=Z}}get commandLine(){return this._commandLine}set commandLine(M){if(typeof M!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=M}get command(){return this._command?this._command:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,F.illegalArgument)("command");this._command=M}get args(){return this._args}set args(M){this._args=M||[]}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("shell"),this._commandLine!==void 0&&M.push(this._commandLine),this._command!==void 0&&M.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let Z of this._args)M.push(typeof Z=="string"?Z:Z.value);return Ve(M)}};ht=ze([P],ht),e.ShellExecution=ht;var St;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(St=e.ShellQuoting||(e.ShellQuoting={}));var Ct;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace"})(Ct=e.TaskScope||(e.TaskScope={}));class Et{constructor(M){this._callback=M}computeId(){return"customExecution"+(0,C.generateUuid)()}set callback(M){this._callback=M}get callback(){return this._callback}}e.CustomExecution=Et;let vt=v=class{constructor(M,Z,ke,Je,it,st){this.__deprecated=!1,this._definition=this.definition=M;let ot;typeof Z=="string"?(this._name=this.name=Z,this._source=this.source=ke,this.execution=Je,ot=it,this.__deprecated=!0):Z===Ct.Global||Z===Ct.Workspace?(this.target=Z,this._name=this.name=ke,this._source=this.source=Je,this.execution=it,ot=st):(this.target=Z,this._name=this.name=ke,this._source=this.source=Je,this.execution=it,ot=st),typeof ot=="string"?(this._problemMatchers=[ot],this._hasDefinedMatchers=!0):Array.isArray(ot)?(this._problemMatchers=ot,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(M){this.__id=M}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof lt?this._definition={type:v.ProcessType,id:this._execution.computeId()}:this._execution instanceof ht?this._definition={type:v.ShellType,id:this._execution.computeId()}:this._execution instanceof Et?this._definition={type:v.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:v.EmptyType,id:(0,C.generateUuid)()}}get definition(){return this._definition}set definition(M){if(M==null)throw(0,F.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=M}get scope(){return this._scope}set target(M){this.clear(),this._scope=M}get name(){return this._name}set name(M){if(typeof M!="string")throw(0,F.illegalArgument)("name");this.clear(),this._name=M}get execution(){return this._execution}set execution(M){M===null&&(M=void 0),this.clear(),this._execution=M;const Z=this._definition.type;(v.EmptyType===Z||v.ProcessType===Z||v.ShellType===Z||v.ExtensionCallbackType===Z)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(M){if(Array.isArray(M))this.clear(),this._problemMatchers=M,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.clear(),this._isBackground=M}get source(){return this._source}set source(M){if(typeof M!="string"||M.length===0)throw(0,F.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=M}get group(){return this._group}set group(M){M===null&&(M=void 0),this.clear(),this._group=M}get detail(){return this._detail}set detail(M){M===null&&(M=void 0),this._detail=M}get presentationOptions(){return this._presentationOptions}set presentationOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._presentationOptions=M}get runOptions(){return this._runOptions}set runOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._runOptions=M}};vt.ExtensionCallbackType="customExecution",vt.ProcessType="process",vt.ShellType="shell",vt.EmptyType="$empty",vt=v=ze([P],vt),e.Task=vt;var _t;(function(O){O[O.SourceControl=1]="SourceControl",O[O.Window=10]="Window",O[O.Notification=15]="Notification"})(_t=e.ProgressLocation||(e.ProgressLocation={}));let dt=class{constructor(M,Z=bt.None){this.collapsibleState=Z,_.URI.isUri(M)?this.resourceUri=M:this.label=M}};dt=ze([P],dt),e.TreeItem=dt;var bt;(function(O){O[O.None=0]="None",O[O.Collapsed=1]="Collapsed",O[O.Expanded=2]="Expanded"})(bt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let ft=class{constructor(M,Z){this.id=M,this.color=Z}};ft=ze([P],ft),e.ThemeIcon=ft,ft.File=new ft("file"),ft.Folder=new ft("folder");let Ot=class{constructor(M){this.id=M}};Ot=ze([P],Ot),e.ThemeColor=Ot;var Pt;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.WorkspaceFolder=3]="WorkspaceFolder"})(Pt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Kt=class{constructor(M,Z){if(typeof M!="string"&&(!M||!_.URI.isUri(M)&&!_.URI.isUri(M.uri)))throw(0,F.illegalArgument)("base");if(typeof Z!="string")throw(0,F.illegalArgument)("pattern");typeof M=="string"?(this.baseFolder=_.URI.file(M),this.base=M):_.URI.isUri(M)?(this.baseFolder=M,this.base=M.fsPath):(this.baseFolder=M.uri,this.base=M.uri.fsPath),this.pattern=Z}};Kt=ze([P],Kt),e.RelativePattern=Kt;let Ut=class{constructor(M,Z,ke,Je){this.enabled=typeof M=="boolean"?M:!0,typeof Z=="string"&&(this.condition=Z),typeof ke=="string"&&(this.hitCondition=ke),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this._id||(this._id=(0,C.generateUuid)()),this._id}};Ut=ze([P],Ut),e.Breakpoint=Ut;let kt=class extends Ut{constructor(M,Z,ke,Je,it){super(Z,ke,Je,it);if(M===null)throw(0,F.illegalArgument)("location");this.location=M}};kt=ze([P],kt),e.SourceBreakpoint=kt;let Qt=class extends Ut{constructor(M,Z,ke,Je,it){super(Z,ke,Je,it);this.functionName=M}};Qt=ze([P],Qt),e.FunctionBreakpoint=Qt;let Yt=class extends Ut{constructor(M,Z,ke,Je,it,st,ot){super(Je,it,st,ot);if(!Z)throw(0,F.illegalArgument)("dataId");this.label=M,this.dataId=Z,this.canPersist=ke}};Yt=ze([P],Yt),e.DataBreakpoint=Yt;let mt=class{constructor(M,Z,ke){this.command=M,this.args=Z||[],this.options=ke}};mt=ze([P],mt),e.DebugAdapterExecutable=mt;let qt=class{constructor(M,Z){this.port=M,this.host=Z}};qt=ze([P],qt),e.DebugAdapterServer=qt;let zt=class{constructor(M){this.path=M}};zt=ze([P],zt),e.DebugAdapterNamedPipeServer=zt;let Jt=class{constructor(M){this.implementation=M}};Jt=ze([P],Jt),e.DebugAdapterInlineImplementation=Jt;let Xt=class{constructor(M,Z){this.range=M,this.expression=Z}};Xt=ze([P],Xt),e.EvaluatableExpression=Xt;var At;(function(O){O[O.Automatic=0]="Automatic",O[O.Explicit=1]="Explicit"})(At=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let jt=class{constructor(M,Z){this.range=M,this.text=Z}};jt=ze([P],jt),e.InlineValueText=jt;let Zt=class{constructor(M,Z,ke=!0){this.range=M,this.variableName=Z,this.caseSensitiveLookup=ke}};Zt=ze([P],Zt),e.InlineValueVariableLookup=Zt;let Ht=class{constructor(M,Z){this.range=M,this.expression=Z}};Ht=ze([P],Ht),e.InlineValueEvaluatableExpression=Ht;let ut=class{constructor(M,Z){this.frameId=M,this.stoppedLocation=Z}};ut=ze([P],ut),e.InlineValueContext=ut;var En;(function(O){O[O.Changed=1]="Changed",O[O.Created=2]="Created",O[O.Deleted=3]="Deleted"})(En=e.FileChangeType||(e.FileChangeType={}));let Rt=A=class extends Error{constructor(M,Z=n.FileSystemProviderErrorCode.Unknown,ke){super(_.URI.isUri(M)?M.toString(!0):M);this.code=ke?.name??"Unknown",(0,n.markAsFileSystemProviderError)(this,Z),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}static FileExists(M){return new A(M,n.FileSystemProviderErrorCode.FileExists,A.FileExists)}static FileNotFound(M){return new A(M,n.FileSystemProviderErrorCode.FileNotFound,A.FileNotFound)}static FileNotADirectory(M){return new A(M,n.FileSystemProviderErrorCode.FileNotADirectory,A.FileNotADirectory)}static FileIsADirectory(M){return new A(M,n.FileSystemProviderErrorCode.FileIsADirectory,A.FileIsADirectory)}static NoPermissions(M){return new A(M,n.FileSystemProviderErrorCode.NoPermissions,A.NoPermissions)}static Unavailable(M){return new A(M,n.FileSystemProviderErrorCode.Unavailable,A.Unavailable)}};Rt=A=ze([P],Rt),e.FileSystemError=Rt;let xt=class{constructor(M,Z,ke){this.start=M,this.end=Z,this.kind=ke}};xt=ze([P],xt),e.FoldingRange=xt;var cn;(function(O){O[O.Comment=1]="Comment",O[O.Imports=2]="Imports",O[O.Region=3]="Region"})(cn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var _n;(function(O){O[O.Collapsed=0]="Collapsed",O[O.Expanded=1]="Expanded"})(_n=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var dn;(function(O){O[O.Editing=0]="Editing",O[O.Preview=1]="Preview"})(dn=e.CommentMode||(e.CommentMode={}));class yn{constructor(M,Z=[]){this.tokenTypes=M,this.tokenModifiers=Z}}e.SemanticTokensLegend=yn;function hn(O){return typeof O=="undefined"||(0,S.isStringArray)(O)}class Vt{constructor(M){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,M){this._hasLegend=!0;for(let Z=0,ke=M.tokenTypes.length;Z<ke;Z++)this._tokenTypeStrToInt.set(M.tokenTypes[Z],Z);for(let Z=0,ke=M.tokenModifiers.length;Z<ke;Z++)this._tokenModifierStrToInt.set(M.tokenModifiers[Z],Z)}}push(M,Z,ke,Je,it){if(typeof M=="number"&&typeof Z=="number"&&typeof ke=="number"&&typeof Je=="number"&&(typeof it=="number"||typeof it=="undefined"))return typeof it=="undefined"&&(it=0),this._pushEncoded(M,Z,ke,Je,it);if(ie.isRange(M)&&typeof Z=="string"&&hn(ke))return this._push(M,Z,ke);throw(0,F.illegalArgument)()}_push(M,Z,ke){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(Z))throw new Error("`tokenType` is not in the provided legend");const Je=M.start.line,it=M.start.character,st=M.end.character-M.start.character,ot=this._tokenTypeStrToInt.get(Z);let yt=0;if(ke)for(const It of ke){if(!this._tokenModifierStrToInt.has(It))throw new Error("`tokenModifier` is not in the provided legend");const Mt=this._tokenModifierStrToInt.get(It);yt|=1<<Mt>>>0}this._pushEncoded(Je,it,st,ot,yt)}_pushEncoded(M,Z,ke,Je,it){if(this._dataIsSortedAndDeltaEncoded&&(M<this._prevLine||M===this._prevLine&&Z<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let It=0,Mt=0;for(let Nt=0;Nt<yt;Nt++){let $t=this._data[5*Nt],ln=this._data[5*Nt+1];$t===0?($t=It,ln+=Mt):$t+=It,this._data[5*Nt]=$t,this._data[5*Nt+1]=ln,It=$t,Mt=ln}}let st=M,ot=Z;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(ot-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=ot,this._data[this._dataLen++]=ke,this._data[this._dataLen++]=Je,this._data[this._dataLen++]=it,this._prevLine=M,this._prevChar=Z}static _sortAndDeltaEncode(M){let Z=[];const ke=M.length/5|0;for(let ot=0;ot<ke;ot++)Z[ot]=ot;Z.sort((ot,yt)=>{const It=M[5*ot],Mt=M[5*yt];if(It===Mt){const Nt=M[5*ot+1],$t=M[5*yt+1];return Nt-$t}return It-Mt});const Je=new Uint32Array(M.length);let it=0,st=0;for(let ot=0;ot<ke;ot++){const yt=5*Z[ot],It=M[yt+0],Mt=M[yt+1],Nt=M[yt+2],$t=M[yt+3],ln=M[yt+4],On=It-it,Vn=On===0?Mt-st:Mt,un=5*ot;Je[un+0]=On,Je[un+1]=Vn,Je[un+2]=Nt,Je[un+3]=$t,Je[un+4]=ln,it=It,st=Mt}return Je}build(M){return this._dataIsSortedAndDeltaEncoded?new en(new Uint32Array(this._data),M):new en(Vt._sortAndDeltaEncode(this._data),M)}}e.SemanticTokensBuilder=Vt;class en{constructor(M,Z){this.resultId=Z,this.data=M}}e.SemanticTokens=en;class tn{constructor(M,Z,ke){this.start=M,this.deleteCount=Z,this.data=ke}}e.SemanticTokensEdit=tn;class nn{constructor(M,Z){this.resultId=Z,this.edits=M}}e.SemanticTokensEdits=nn;var Sn;(function(O){O[O.Separate=0]="Separate",O[O.MergeWithParent=1]="MergeWithParent"})(Sn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Dn;(function(O){O[O.Initial=1]="Initial",O[O.Dynamic=2]="Dynamic"})(Dn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Ft=class{constructor(){}};Ft.Back={iconPath:new ft("arrow-left")},Ft=ze([P],Ft),e.QuickInputButtons=Ft;var Cn;(function(O){O[O.UI=1]="UI",O[O.Workspace=2]="Workspace"})(Cn=e.ExtensionKind||(e.ExtensionKind={}));class kn{constructor(M,Z,ke){this.badge=M,this.tooltip=Z,this.color=ke}static validate(M){if(M.badge&&M.badge.length!==1&&M.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=kn;let rn=class{constructor(M){this.kind=M}};rn=ze([P],rn),e.ColorTheme=rn;var In;(function(O){O[O.Light=1]="Light",O[O.Dark=2]="Dark",O[O.HighContrast=3]="HighContrast"})(In=e.ColorThemeKind||(e.ColorThemeKind={}));class Bt{constructor(M,Z){if(M<0)throw(0,F.illegalArgument)("start must be positive");if(Z<0)throw(0,F.illegalArgument)("end must be positive");M<=Z?(this._start=M,this._end=Z):(this._start=Z,this._end=M)}static isNotebookRange(M){return M instanceof Bt?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(M){let Z=this._start,ke=this._end;return M.start!==void 0&&(Z=M.start),M.end!==void 0&&(ke=M.end),Z===this._start&&ke===this._end?this:new Bt(Z,ke)}}e.NotebookRange=Bt;class Lt{constructor(M,Z,ke,Je,it,st,ot){this.kind=M,this.value=Z,this.languageId=ke,this.mime=Je,this.outputs=it??[],this.metadata=st,this.executionSummary=ot,Lt.validate(this)}static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(Z=>Lt.isNotebookCellData(Z))}static isNotebookCellData(M){return!0}}e.NotebookCellData=Lt;class fn{constructor(M){this.cells=M}}e.NotebookData=fn;class Tt{constructor(M,Z){this.data=M,this.mime=Z;const ke=(0,I.normalizeMimeType)(Z,!0);if(!ke)throw new Error("INVALID mime type, must not be empty or falsy: "+Z);this.mime=ke}static isNotebookCellOutputItem(M){return M instanceof Tt?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const Z={name:M.name,message:M.message,stack:M.stack};return Tt.json(Z,"application/vnd.code.notebook.error")}static stdout(M){return Tt.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return Tt.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,Z="application/octet-stream"){return new Tt(M,Z)}static text(M,Z=I.Mimes.text){const ke=Le(Tt,a,"f",d).encode(String(M));return new Tt(ke,Z)}static json(M,Z="application/json"){const ke=JSON.stringify(M,void 0,"	");return Tt.text(ke,Z)}}e.NotebookCellOutputItem=Tt,a=Tt,d={value:new TextEncoder};class Me{constructor(M,Z,ke){this.items=Me.ensureUniqueMimeTypes(M,!0),typeof Z=="string"?(this.id=Z,this.metadata=ke):(this.id=(0,C.generateUuid)(),this.metadata=Z??ke)}static isNotebookCellOutput(M){return M instanceof Me?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&(0,S.isArray)(M.items)}static ensureUniqueMimeTypes(M,Z=!1){const ke=new Set,Je=new Set;for(let it=0;it<M.length;it++){const st=M[it],ot=(0,I.normalizeMimeType)(st.mime);if(!ke.has(ot)){ke.add(ot);continue}Je.add(it),Z&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return Je.size===0?M:M.filter((it,st)=>!Je.has(st))}}e.NotebookCellOutput=Me;var sn;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(sn=e.NotebookCellKind||(e.NotebookCellKind={}));var mn;(function(O){O[O.Idle=1]="Idle",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(mn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var gt;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(gt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pn;(function(O){O[O.Default=0]="Default",O[O.InCenter=1]="InCenter",O[O.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",O[O.AtTop=3]="AtTop"})(Pn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class An{constructor(M,Z){this.text=M,this.alignment=Z}}e.NotebookCellStatusBarItem=An;var gn;(function(O){O[O.Default=1]="Default",O[O.Preferred=2]="Preferred"})(gn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class pn{constructor(M,Z=[]){this.uri=M,this.provides=(0,m.asArray)(Z)}}e.NotebookRendererScript=pn;let on=class{constructor(M,Z){this.label=M,this.timestamp=Z}};on=ze([P],on),e.TimelineItem=on;var Tn;(function(O){O[O.Production=1]="Production",O[O.Development=2]="Development",O[O.Test=3]="Test"})(Tn=e.ExtensionMode||(e.ExtensionMode={}));var Rn;(function(O){O[O.Node=1]="Node",O[O.Webworker=2]="Webworker"})(Rn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Fn;(function(O){O[O.Other=0]="Other",O[O.Comment=1]="Comment",O[O.String=2]="String",O[O.RegEx=4]="RegEx"})(Fn=e.StandardTokenType||(e.StandardTokenType={}));class vn{constructor(M,Z){this.ranges=M,this.wordPattern=Z}}e.LinkedEditingRanges=vn;class Mn{constructor(M,Z){this._port=M,this._autoForwardAction=Z}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Mn;var Ln;(function(O){O[O.Unset=0]="Unset",O[O.Queued=1]="Queued",O[O.Running=2]="Running",O[O.Passed=3]="Passed",O[O.Failed=4]="Failed",O[O.Skipped=5]="Skipped",O[O.Errored=6]="Errored"})(Ln=e.TestResultState||(e.TestResultState={}));var bn;(function(O){O[O.Error=0]="Error",O[O.Warning=1]="Warning",O[O.Information=2]="Information",O[O.Hint=3]="Hint"})(bn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var Nn;(function(O){O[O.Run=1]="Run",O[O.Debug=2]="Debug",O[O.Coverage=3]="Coverage"})(Nn=e.TestRunConfigurationGroup||(e.TestRunConfigurationGroup={}));let an=class{constructor(M,Z,ke){this.include=M,this.exclude=Z,this.configuration=ke}};an=ze([P],an),e.TestRunRequest=an;let X=R=class{constructor(M){this.message=M,this.severity=bn.Error}static diff(M,Z,ke){const Je=new R(M);return Je.expectedOutput=Z,Je.actualOutput=ke,Je}};X=R=ze([P],X),e.TestMessage=X;let le=class{constructor(M,Z){this.covered=M,this.total=Z}};le=ze([P],le),e.CoveredCount=le;let Te=o=class{constructor(M,Z,ke,Je){this.uri=M,this.statementCoverage=Z,this.branchCoverage=ke,this.functionCoverage=Je}static fromDetails(M,Z){const ke=new le(0,0),Je=new le(0,0),it=new le(0,0);for(const ot of Z)if("branches"in ot){ke.total+=1,ke.covered+=ot.executionCount>0?1:0;for(const yt of ot.branches)Je.total+=1,Je.covered+=yt.executionCount>0?1:0}else it.total+=1,it.covered+=ot.executionCount>0?1:0;const st=new o(M,ke,Je.total>0?Je:void 0,it.total>0?it:void 0);return st.detailedCoverage=Z,st}};Te=o=ze([P],Te),e.FileCoverage=Te;let rt=class{constructor(M,Z,ke=[]){this.executionCount=M,this.location=Z,this.branches=ke}};rt=ze([P],rt),e.StatementCoverage=rt;let pt=class{constructor(M,Z){this.executionCount=M,this.location=Z}};pt=ze([P],pt),e.BranchCoverage=pt;let Dt=class{constructor(M,Z){this.executionCount=M,this.location=Z}};Dt=ze([P],Dt),e.FunctionCoverage=Dt;var Wn;(function(O){O[O.None=0]="None",O[O.Option=1]="Option",O[O.Default=2]="Default",O[O.Preferred=3]="Preferred"})(Wn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Hn;(function(O){O[O.Untrusted=0]="Untrusted",O[O.Trusted=1]="Trusted",O[O.Unspecified=2]="Unspecified"})(Hn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var zn;(function(O){O[O.Notify=1]="Notify",O[O.OpenBrowser=2]="OpenBrowser",O[O.OpenPreview=3]="OpenPreview",O[O.Silent=4]="Silent",O[O.Ignore=5]="Ignore",O[O.OpenBrowserOnce=6]="OpenBrowserOnce"})(zn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(_e[95],ye([0,1,39,11,8,121,86,6,17]),function(ee,e,m,F,D,y,I,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const C=new Map;function n(a,d){d?C.set(a,d):C.delete(a)}e.setWordDefinitionFor=n;function k(a){return C.get(a)}e.getWordDefinitionFor=k;class l extends y.MirrorTextModel{constructor(d,f,E,w,u,g,b,t){super(f,E,w,u);this._proxy=d,this._languageId=g,this._isDirty=b,this._notebook=t,this._isDisposed=!1}dispose(){(0,m.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(d){return(0,_.equals)(this._lines,d)}get document(){if(!this._document){const d=this;this._document={get uri(){return d._uri},get fileName(){return d._uri.fsPath},get isUntitled(){return d._uri.scheme===F.Schemas.untitled},get languageId(){return d._languageId},get version(){return d._versionId},get isClosed(){return d._isDisposed},get isDirty(){return d._isDirty},get notebook(){return d._notebook},save(){return d._save()},getText(f){return f?d._getTextInRange(f):d.getText()},get eol(){return d._eol===`
`?S.EndOfLine.LF:S.EndOfLine.CRLF},get lineCount(){return d._lines.length},lineAt(f){return d._lineAt(f)},offsetAt(f){return d._offsetAt(f)},positionAt(f){return d._positionAt(f)},validateRange(f){return d._validateRange(f)},validatePosition(f){return d._validatePosition(f)},getWordRangeAtPosition(f,E){return d._getWordRangeAtPosition(f,E)}}}return Object.freeze(this._document)}_acceptLanguageId(d){(0,m.ok)(!this._isDisposed),this._languageId=d}_acceptIsDirty(d){(0,m.ok)(!this._isDisposed),this._isDirty=d}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(d){const f=this._validateRange(d);if(f.isEmpty)return"";if(f.isSingleLine)return this._lines[f.start.line].substring(f.start.character,f.end.character);const E=this._eol,w=f.start.line,u=f.end.line,g=[];g.push(this._lines[w].substring(f.start.character));for(let b=w+1;b<u;b++)g.push(this._lines[b]);return g.push(this._lines[u].substring(0,f.end.character)),g.join(E)}_lineAt(d){let f;if(d instanceof S.Position?f=d.line:typeof d=="number"&&(f=d),typeof f!="number"||f<0||f>=this._lines.length||Math.floor(f)!==f)throw new Error("Illegal value for `line`");return new h(f,this._lines[f],f===this._lines.length-1)}_offsetAt(d){return d=this._validatePosition(d),this._ensureLineStarts(),this._lineStarts.getPrefixSum(d.line-1)+d.character}_positionAt(d){d=Math.floor(d),d=Math.max(0,d),this._ensureLineStarts();const f=this._lineStarts.getIndexOf(d),E=this._lines[f.index].length;return new S.Position(f.index,Math.min(f.remainder,E))}_validateRange(d){if(!(d instanceof S.Range))throw new Error("Invalid argument");const f=this._validatePosition(d.start),E=this._validatePosition(d.end);return f===d.start&&E===d.end?d:new S.Range(f.line,f.character,E.line,E.character)}_validatePosition(d){if(!(d instanceof S.Position))throw new Error("Invalid argument");if(this._lines.length===0)return d.with(0,0);let{line:f,character:E}=d,w=!1;if(f<0)f=0,E=0,w=!0;else if(f>=this._lines.length)f=this._lines.length-1,E=this._lines[f].length,w=!0;else{const u=this._lines[f].length;E<0?(E=0,w=!0):E>u&&(E=u,w=!0)}return w?new S.Position(f,E):d}_getWordRangeAtPosition(d,f){const E=this._validatePosition(d);if(!f)f=k(this._languageId);else if((0,D.regExpLeadsToEndlessLoop)(f))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${f.source}' because it matches the empty string.`);const w=(0,I.getWordAtText)(E.character+1,(0,I.ensureValidWordDefinition)(f),this._lines[E.line],0);if(w)return new S.Range(E.line,w.startColumn-1,E.line,w.endColumn-1)}}e.ExtHostDocumentData=l;class h{constructor(d,f,E){this._line=d,this._text=f,this._isLastLine=E}get lineNumber(){return this._line}get text(){return this._text}get range(){return new S.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new S.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(_e[161],ye([0,1,6,3,88,7,55,22,2,35]),function(ee,e,m,F,D,y,I,S,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(l,h,a,d){this._notebook=a,this._selector=d,this._disposables=new y.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this.uri=_.URI.from({scheme:"vscode-concat-doc",path:(0,C.generateUuid)()}),this._init(),this._disposables.add(h.onDidChangeDocument(E=>{const w=this._cellUris.get(E.document.uri);w!==void 0&&(this._cellLengths.changeValue(w,this._cells[w].document.getText().length+1),this._cellLines.changeValue(w,this._cells[w].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const f=E=>{E===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(l.onDidChangeNotebookCells(E=>f(E.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new S.ResourceMap;const l=[],h=[];for(const a of this._notebook.getCells())a.kind===m.NotebookCellKind.Code&&(!this._selector||(0,I.score)(this._selector,a.document.uri,a.document.languageId,!0))&&(this._cellUris.set(a.document.uri,this._cells.length),this._cells.push(a),l.push(a.document.getText().length+1),h.push(a.document.lineCount));this._cellLengths=new D.PrefixSumComputer(new Uint32Array(l)),this._cellLines=new D.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(l){if(!l){let w="";for(const u of this._cells)w+=u.document.getText()+`
`;return w=w.slice(0,-1),w}if(l.isEmpty)return"";const h=this.locationAt(l.start),a=this.locationAt(l.end),d=this._cellUris.get(h.uri),f=this._cellUris.get(a.uri);if(d===void 0||f===void 0)return"";if(d===f)return this._cells[d].document.getText(new m.Range(h.range.start,a.range.end));const E=[this._cells[d].document.getText(new m.Range(h.range.start,new m.Position(this._cells[d].document.lineCount,0)))];for(let w=d+1;w<f;w++)E.push(this._cells[w].document.getText());return E.push(this._cells[f].document.getText(new m.Range(new m.Position(0,0),a.range.end))),E.join(`
`)}offsetAt(l){const h=this._cellLines.getIndexOf(l.line),a=this._cellLengths.getPrefixSum(h.index-1),d=this._cells[h.index].document.offsetAt(l.with(h.remainder));return a+d}positionAt(l){if(typeof l=="number"){const a=this._cellLengths.getIndexOf(l),d=this._cellLines.getPrefixSum(a.index-1);return this._cells[a.index].document.positionAt(a.remainder).translate(d)}const h=this._cellUris.get(l.uri);if(h!==void 0){const a=this._cellLines.getPrefixSum(h-1);return new m.Position(a+l.range.start.line,l.range.start.character)}return new m.Position(0,0)}locationAt(l){m.Range.isRange(l)||(l=new m.Range(l,l));const h=this._cellLines.getIndexOf(l.start.line);let a=h;l.isEmpty||(a=this._cellLines.getIndexOf(l.end.line));const d=new m.Position(h.remainder,l.start.character),f=new m.Position(a.remainder,l.end.character),E=new m.Range(d,f),w=this._cells[h.index];return new m.Location(w.document.uri,w.document.validateRange(E))}contains(l){return this._cellUris.has(l)}validateRange(l){const h=this.validatePosition(l.start),a=this.validatePosition(l.end);return l.with(h,a)}validatePosition(l){const h=this._cellLines.getIndexOf(l.line),a=new m.Position(h.remainder,l.character),d=this._cells[h.index].document.validatePosition(a),f=this._cellLines.getPrefixSum(h.index-1);return new m.Position(f+d.line,d.character)}}e.ExtHostNotebookConcatDocument=n}),define(_e[162],ye([0,1,6,13,3]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let y=class{constructor(S){this._actual=new m.ColorTheme(m.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(S){let _=S==="light"?m.ColorThemeKind.Light:S==="dark"?m.ColorThemeKind.Dark:m.ColorThemeKind.HighContrast;this._actual=new m.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};y=ze([je(0,F.IExtHostRpcService)],y),e.ExtHostTheming=y}),define(_e[67],ye([0,1,4]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,m.createDecorator)("IURITransformerService");class F{constructor(y){y?(this.transformIncoming=y.transformIncoming.bind(y),this.transformOutgoing=y.transformOutgoing.bind(y),this.transformOutgoingURI=y.transformOutgoingURI.bind(y),this.transformOutgoingScheme=y.transformOutgoingScheme.bind(y)):(this.transformIncoming=I=>I,this.transformOutgoing=I=>I,this.transformOutgoingURI=I=>I,this.transformOutgoingScheme=I=>I)}}e.URITransformerService=F}),define(_e[163],ye([0,1,23]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class F{constructor(){this.buffers=[]}add(_){let C=this.buffers.indexOf(_);return C<0&&(C=this.buffers.length,this.buffers.push(_)),C}}function D(S,_){if(_.serializeBuffersForPostMessage){const C=new F,n=(h,a)=>{if(a instanceof ArrayBuffer){const d=C.add(a);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(a)){const d=y(a);if(d){const f=C.add(a.buffer);return{$$vscode_array_buffer_reference$$:!0,index:f,view:{type:d,byteLength:a.byteLength,byteOffset:a.byteOffset}}}}return a},k=JSON.stringify(S,n),l=C.buffers.map(h=>{const a=new Uint8Array(h);return m.VSBuffer.wrap(a)});return{message:k,buffers:l}}else return{message:JSON.stringify(S),buffers:[]}}e.serializeWebviewMessage=D;function y(S){switch(S.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function I(S,_){const C=_.map(l=>{const h=new ArrayBuffer(l.byteLength);return new Uint8Array(h).set(l.buffer),h}),n=_.length?(l,h)=>{if(typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const a=h,{index:d}=a,f=C[d];if(a.view)switch(a.view.type){case 1:return new Int8Array(f,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(f,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(f,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(f,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(f,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(f,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(f,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(f,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(f,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(f,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(f,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return f}return h}:void 0;return{message:JSON.parse(S,n),arrayBuffers:C}}e.deserializeWebviewMessage=I}),define(_e[68],ye([0,1,11,2]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function D(y,I){return y.scheme===m.Schemas.http||y.scheme===m.Schemas.https?y:(I&&I.authority&&I.isRemote&&y.scheme===m.Schemas.file&&(y=F.URI.from({scheme:m.Schemas.vscodeRemote,authority:I.authority,path:y.path})),F.URI.from({scheme:m.Schemas.https,authority:`${y.scheme}+${y.authority}.${e.webviewRootResourceAuthority}`,path:y.path,fragment:y.fragment,query:y.query}))}e.asWebviewUri=D}),define(_e[164],ye([0,1,3,7,68]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(S,_,C){this._proxy=S,this._editors=_,this._initData=C,this._handlePool=0,this._disposables=new F.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const n=_.getVisibleTextEditors();for(const k of this._insets.values())n.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this._insets.forEach(S=>S.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(S,_,C,n,k){let l;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===S){l=u;break}if(!l)throw new Error("not a visible editor");const h=this,a=this._handlePool++,d=new m.Emitter,f=new m.Emitter,E=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(u){return(0,D.asWebviewUri)(u,h._initData.remote)}get cspSource(){return D.webviewGenericCspSource}set options(u){this._options=u,h._proxy.$setOptions(a,u)}get options(){return this._options}set html(u){this._html=u,h._proxy.$setHtml(a,u)}get html(){return this._html}get onDidReceiveMessage(){return d.event}postMessage(u){return h._proxy.$postMessage(a,u)}},w=new class{constructor(){this.editor=S,this.line=_,this.height=C,this.webview=E,this.onDidDispose=f.event}dispose(){h._insets.has(a)&&(h._insets.delete(a),h._proxy.$disposeEditorInset(a),f.fire(),f.dispose(),d.dispose())}};return this._proxy.$createEditorInset(a,l.id,l.value.document.uri,_+1,C,n||{},k.identifier,k.extensionLocation),this._insets.set(a,{editor:S,inset:w,onDidReceiveMessage:d}),w}$onDidDispose(S){const _=this._insets.get(S);_&&_.inset.dispose()}$onDidReceiveMessage(S,_){const C=this._insets.get(S);C&&C.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=y}),define(_e[165],ye([0,1,136,10,2,7,4,59,31,17,11]),function(ee,e,m,F,D,y,I,S,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,m.localize)(0,null),providerDisplayName:(0,m.localize)(1,null)},e.ActiveEditorDirtyContext=new S.RawContextKey("activeEditorIsDirty",!1,(0,m.localize)(2,null)),e.ActiveEditorPinnedContext=new S.RawContextKey("activeEditorIsNotPreview",!1,(0,m.localize)(3,null)),e.ActiveEditorStickyContext=new S.RawContextKey("activeEditorIsPinned",!1,(0,m.localize)(4,null)),e.ActiveEditorReadonlyContext=new S.RawContextKey("activeEditorIsReadonly",!1,(0,m.localize)(5,null)),e.ActiveEditorCanRevertContext=new S.RawContextKey("activeEditorCanRevert",!1,(0,m.localize)(6,null)),e.ActiveEditorContext=new S.RawContextKey("activeEditor",null,{type:"string",description:(0,m.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new S.RawContextKey("activeEditorAvailableEditorIds","",(0,m.localize)(8,null)),e.TextCompareEditorVisibleContext=new S.RawContextKey("textCompareEditorVisible",!1,(0,m.localize)(9,null)),e.TextCompareEditorActiveContext=new S.RawContextKey("textCompareEditorActive",!1,(0,m.localize)(10,null)),e.EditorGroupEditorsCountContext=new S.RawContextKey("groupEditorsCount",0,(0,m.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new S.RawContextKey("activeEditorGroupEmpty",!1,(0,m.localize)(12,null)),e.ActiveEditorGroupIndexContext=new S.RawContextKey("activeEditorGroupIndex",0,(0,m.localize)(13,null)),e.ActiveEditorGroupLastContext=new S.RawContextKey("activeEditorGroupLast",!1,(0,m.localize)(14,null)),e.MultipleEditorGroupsContext=new S.RawContextKey("multipleEditorGroups",!1,(0,m.localize)(15,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new S.RawContextKey("editorIsOpen",!1,(0,m.localize)(16,null)),e.InEditorZenModeContext=new S.RawContextKey("inZenMode",!1,(0,m.localize)(17,null)),e.IsCenteredLayoutContext=new S.RawContextKey("isCenteredLayout",!1,(0,m.localize)(18,null)),e.SplitEditorsVertically=new S.RawContextKey("splitEditorsVertically",!1,(0,m.localize)(19,null)),e.EditorAreaVisibleContext=new S.RawContextKey("editorAreaVisible",!0,(0,m.localize)(20,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function k(o){return typeof o?.getViewState=="function"}e.isTextEditorPane=k;function l(o){if(u(o))return!1;const P=o;return D.URI.isUri(P?.resource)}e.isResourceEditorInput=l;function h(o){if(u(o))return!1;const P=o;return P?.original!==void 0&&P.modified!==void 0}e.isResourceDiffEditorInput=h;function a(o){if(u(o))return!1;const P=o;return P?P?.resource===void 0||P.resource.scheme===n.Schemas.untitled||P.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=a;var d;(function(o){o[o.SHORT=0]="SHORT",o[o.MEDIUM=1]="MEDIUM",o[o.LONG=2]="LONG"})(d=e.Verbosity||(e.Verbosity={}));var f;(function(o){o[o.EXPLICIT=1]="EXPLICIT",o[o.AUTO=2]="AUTO",o[o.FOCUS_CHANGE=3]="FOCUS_CHANGE",o[o.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(f=e.SaveReason||(e.SaveReason={}));var E;(function(o){o[o.None=0]="None",o[o.Readonly=2]="Readonly",o[o.Untitled=4]="Untitled",o[o.Singleton=8]="Singleton",o[o.RequiresTrust=16]="RequiresTrust"})(E=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class w extends y.Disposable{}e.AbstractEditorInput=w;function u(o){return o instanceof w}e.isEditorInput=u;function g(o){const P=o;return D.URI.isUri(P?.preferredResource)}function b(o){const P=o;return u(P?.primary)&&u(P?.secondary)}e.isSideBySideEditorInput=b;function t(o){return u(o?.editor)}e.isEditorInputWithOptions=t;function s(o){const P=o;return t(o)&&P?.group!==void 0}e.isEditorInputWithOptionsAndGroup=s;function i(o){const P=o;return typeof P?.groupId=="number"&&u(P.editor)}e.isEditorIdentifier=i;var r;(function(o){o[o.PRIMARY=1]="PRIMARY",o[o.SECONDARY=2]="SECONDARY",o[o.BOTH=3]="BOTH"})(r=e.SideBySideEditor||(e.SideBySideEditor={}));class c{getOriginalUri(P,N){if(!P)return;const $=b(P)?P.primary:h(P)?P.modified:void 0,ie=b(P)?P.secondary:h(P)?P.original:void 0;if(N?.supportSideBySide&&$&&ie){if(N?.supportSideBySide===r.BOTH)return{primary:this.getOriginalUri($,{filterByScheme:N.filterByScheme}),secondary:this.getOriginalUri(ie,{filterByScheme:N.filterByScheme})};P=N.supportSideBySide===r.PRIMARY?$:ie}if(h(P))return;const ce=g(P)?P.preferredResource:P.resource;return!ce||!N||!N.filterByScheme?ce:this.filterUri(ce,N.filterByScheme)}getCanonicalUri(P,N){if(!P)return;const $=b(P)?P.primary:h(P)?P.modified:void 0,ie=b(P)?P.secondary:h(P)?P.original:void 0;if(N?.supportSideBySide&&$&&ie){if(N?.supportSideBySide===r.BOTH)return{primary:this.getCanonicalUri($,{filterByScheme:N.filterByScheme}),secondary:this.getCanonicalUri(ie,{filterByScheme:N.filterByScheme})};P=N.supportSideBySide===r.PRIMARY?$:ie}if(h(P))return;const ce=P.resource;return!ce||!N||!N.filterByScheme?ce:this.filterUri(ce,N.filterByScheme)}filterUri(P,N){if(Array.isArray(N)){if(N.some($=>P.scheme===$))return P}else if(N===P.scheme)return P}}e.EditorResourceAccessor=new c;var p;(function(o){o[o.LEFT=0]="LEFT",o[o.RIGHT=1]="RIGHT"})(p=e.CloseDirection||(e.CloseDirection={}));class v{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(P){const N=this.instantiationService=P.get(I.IInstantiationService);for(const[$,ie]of this.editorSerializerConstructors)this.createEditorSerializer($,ie,N);this.editorSerializerConstructors.clear()}createEditorSerializer(P,N,$){const ie=$.createInstance(N);this.editorSerializerInstances.set(P,ie)}registerFileEditorFactory(P){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=P}getFileEditorFactory(){return(0,F.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(P,N){if(this.editorSerializerConstructors.has(P)||this.editorSerializerInstances.has(P))throw new Error(`A editor serializer with type ID '${P}' was already registered.`);return this.instantiationService?this.createEditorSerializer(P,N,this.instantiationService):this.editorSerializerConstructors.set(P,N),(0,y.toDisposable)(()=>{this.editorSerializerConstructors.delete(P),this.editorSerializerInstances.delete(P)})}getEditorSerializer(P){return this.editorSerializerInstances.get(typeof P=="string"?P:P.typeId)}}_.Registry.add(e.EditorExtensions.EditorFactory,new v);async function A(o,P){if(!o||!o.length)return[];const N=await Promise.all(o.map(async $=>{const ie=D.URI.revive($.fileUri);if(!ie||(await P.activateProvider(ie.scheme),!P.canHandleResource(ie)))return;const ce=typeof $.exists=="boolean"?$.exists:await P.exists(ie);if(!ce&&$.openOnlyIfExists)return;const K=ce&&typeof $.lineNumber=="number"?{selection:{startLineNumber:$.lineNumber,startColumn:$.columnNumber||1},pinned:!0,override:$.editorOverrideId}:{pinned:!0,override:$.editorOverrideId};let H;return ce?H={resource:ie,options:K,forceFile:!0}:H={resource:ie,options:K,forceUntitled:!0},H}));return(0,C.coalesce)(N)}e.pathsToEditors=A;var R;(function(o){o[o.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",o[o.SEQUENTIAL=1]="SEQUENTIAL"})(R=e.EditorsOrder||(e.EditorsOrder={}))}),define(_e[166],ye([0,1,3,16,137]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class y{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new m.Emitter,this._onExit=new m.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(S){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=S}onEvent(S){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=S}onRequest(S){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=S}sendResponse(S){S.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${S.command}`)):this.internalSend("response",S)}sendRequest(S,_,C,n){const k={command:S};if(_&&Object.keys(_).length>0&&(k.arguments=_),this.internalSend("request",k),typeof n=="number"){const l=setTimeout(()=>{clearTimeout(l);const h=this.pendingRequests.get(k.seq);if(h){this.pendingRequests.delete(k.seq);const a={type:"response",seq:0,request_seq:k.seq,success:!1,command:S,message:(0,D.localize)(0,null,n,S)};h(a)}},n)}return C&&this.pendingRequests.set(k.seq,C),k.seq}acceptMessage(S){this.messageCallback?this.messageCallback(S):(this.queue.push(S),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(S,_){return S.type!=="event"||_.type!=="event"}async processQueue(){let S;for(;this.queue.length;){if((!S||this.needsTaskBoundaryBetween(this.queue[0],S))&&await(0,F.timeout)(0),S=this.queue.shift(),!S)return;switch(S.type){case"event":this.eventCallback&&this.eventCallback(S);break;case"request":this.requestCallback&&this.requestCallback(S);break;case"response":const _=S,C=this.pendingRequests.get(_.request_seq);C&&(this.pendingRequests.delete(_.request_seq),C(_));break}}}internalSend(S,_){_.type=S,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const S=new Map;this.pendingRequests.forEach((_,C)=>S.set(C,_)),await(0,F.timeout)(500),S.forEach((_,C)=>{_({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(C)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=y}),define(_e[167],ye([0,1,8,2,14,24,11]),function(ee,e,m,F,D,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const S=/{([^}]+)}/g;function _(s,i,r){return s.replace(S,function(c,p){return i&&p.length>0&&p[0]!=="_"?c:r&&r.hasOwnProperty(p)?r[p]:c})}e.formatPII=_;function C(s){const i={};for(const r of Object.keys(s))r.startsWith("!")||(i[r]=s[r]);return i}e.filterExceptionsFromTelemetry=C;function n(s){return s.configuration.request==="attach"&&!k(s)&&(!s.parentSession||n(s.parentSession))}e.isSessionAttach=n;function k(s){let i=s.configuration.type;if(!!i)return i==="vslsShare"&&(i=s.configuration.adapterProxy.configuration.type),(0,m.equalsIgnoreCase)(i,"extensionhost")||(0,m.equalsIgnoreCase)(i,"pwa-extensionhost")?s:s.parentSession?k(s.parentSession):void 0}e.getExtensionHostDebugSession=k;function l(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=l;function h(s,i,r){let c,p=0,v=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,A=null;for(;A=v.exec(s);){let R=A.index+1,o=R+A[0].length;if(R<=i&&o>=r){c=A[0],p=R;break}}if(c){let R=/\w+/g,o=null;for(;(o=R.exec(c))&&!(o.index+1+p+o[0].length>=r););o&&(c=c.substring(0,R.lastIndex))}return c?{start:p,end:p+c.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(s){return!!(s&&s.match(a))}e.isUri=d;function f(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(d(s.path))return F.URI.parse(s.path);if((0,D.isAbsolute)(s.path))return F.URI.file(s.path)}return s.path}function E(s){if(typeof s.path=="object"){const i=F.URI.revive(s.path);if(i)return i.scheme===I.Schemas.file?i.fsPath:i.toString()}return s.path}function w(s,i){const r=i?f:E,c=(0,y.deepClone)(s);return g(c,(p,v)=>{p&&v&&(v.path=r(v))}),c}e.convertToDAPaths=w;function u(s,i){const r=i?f:E,c=(0,y.deepClone)(s);return g(c,(p,v)=>{!p&&v&&(v.path=r(v))}),c}e.convertToVSCPaths=u;function g(s,i){switch(s.type){case"event":const r=s;switch(r.event){case"output":i(!1,r.body.source);break;case"loadedSource":i(!1,r.body.source);break;case"breakpoint":i(!1,r.body.breakpoint.source);break;default:break}break;case"request":const c=s;switch(c.command){case"setBreakpoints":i(!0,c.arguments.source);break;case"breakpointLocations":i(!0,c.arguments.source);break;case"source":i(!0,c.arguments.source);break;case"gotoTargets":i(!0,c.arguments.source);break;case"launchVSCode":c.arguments.args.forEach(v=>i(!1,v));break;default:break}break;case"response":const p=s;if(p.success&&p.body)switch(p.command){case"stackTrace":p.body.stackFrames.forEach(v=>i(!1,v.source));break;case"loadedSources":p.body.sources.forEach(v=>i(!1,v));break;case"scopes":p.body.scopes.forEach(v=>i(!1,v.source));break;case"setFunctionBreakpoints":p.body.breakpoints.forEach(v=>i(!1,v.source));break;case"setBreakpoints":p.body.breakpoints.forEach(v=>i(!1,v.source));break;default:break}break}}function b(s){return s.filter(i=>!i.presentation?.hidden).sort((i,r)=>i.presentation?r.presentation?i.presentation.group?r.presentation.group?i.presentation.group!==r.presentation.group?i.presentation.group.localeCompare(r.presentation.group):t(i.presentation.order,r.presentation.order):-1:r.presentation.group?1:t(i.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=b;function t(s,i){return typeof s!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:s-i}}),define(_e[69],ye([0,1,27,83,11,14,21,59]),function(ee,e,m,F,D,y,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var _;(function(o){o[o.Markup=1]="Markup",o[o.Code=2]="Code"})(_=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",F.Mimes.markdown,"image/png","image/jpeg",F.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[F.Mimes.markdown,"application/json",F.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var C;(function(o){o[o.Running=1]="Running",o[o.Idle=2]="Idle"})(C=e.NotebookRunState||(e.NotebookRunState={}));var n;(function(o){o[o.Pending=2]="Pending",o[o.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var k;(function(o){o[o.WithHardKernelDependency=0]="WithHardKernelDependency",o[o.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",o[o.Pure=2]="Pure",o[o.Never=3]="Never"})(k=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var l;(function(o){o.Always="always",o.Never="never",o.Optional="optional"})(l=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(o){o[o.ModelChange=1]="ModelChange",o[o.Move=2]="Move",o[o.ChangeLanguage=5]="ChangeLanguage",o[o.Initialize=6]="Initialize",o[o.ChangeCellMetadata=7]="ChangeCellMetadata",o[o.Output=8]="Output",o[o.OutputItem=9]="OutputItem",o[o.ChangeCellContent=10]="ChangeCellContent",o[o.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",o[o.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",o[o.ChangeCellMime=13]="ChangeCellMime",o[o.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var a;(function(o){o[o.Handle=0]="Handle",o[o.Index=1]="Index"})(a=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(o){o[o.Replace=1]="Replace",o[o.Output=2]="Output",o[o.Metadata=3]="Metadata",o[o.CellLanguage=4]="CellLanguage",o[o.DocumentMetadata=5]="DocumentMetadata",o[o.Move=6]="Move",o[o.OutputItems=7]="OutputItems",o[o.PartialMetadata=8]="PartialMetadata",o[o.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var f;(function(o){o.scheme=D.Schemas.vscodeNotebookCell;const P=/^ch(\d{7,})/;function N(H,z){return H.with({scheme:o.scheme,fragment:`ch${z.toString().padStart(7,"0")}${H.scheme!==D.Schemas.file?H.scheme:""}`})}o.generate=N;function $(H){if(H.scheme!==o.scheme)return;const z=P.exec(H.fragment);return z?{handle:Number(z[1]),notebook:H.with({scheme:H.fragment.substr(z[0].length)||D.Schemas.file,fragment:null})}:void 0}o.parse=$;function ie(H){if(H.scheme!==D.Schemas.vscodeNotebookCellMetadata)return;const z=P.exec(H.fragment);return z?{handle:Number(z[1]),notebook:H.with({scheme:H.fragment.substr(z[0].length)||D.Schemas.file,fragment:null})}:void 0}o.parseCellMetadataUri=ie;function ce(H,z,T){return H.with({scheme:T,fragment:`ch${z.toString().padStart(7,"0")}${H.scheme!==D.Schemas.file?H.scheme:""}`})}o.generateCellUri=ce;function K(H,z){if(H.scheme!==z)return;const T=P.exec(H.fragment);return T?{handle:Number(T[1]),notebook:H.with({scheme:H.fragment.substr(T[0].length)||D.Schemas.file,fragment:null})}:void 0}o.parseCellUri=K})(f=e.CellUri||(e.CellUri={}));const E=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function w(o){return E.get(o)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=w;function u(o){return E.get(o)?.supportedByCore??!1}e.mimeTypeSupportedByCore=u;function g(o){return E.get(o)?.mergeable??!1}e.mimeTypeIsMergeable=g;function b(o,P){return I.isWindows&&(o=o.replace(/\//g,"\\"),P=P.replace(/\//g,"\\")),m.match(o,P)}function t(o,P,N){let $=0;for(let ie=0;ie<P.length;ie++){if(b(P[ie],o))return $;$++}for(let ie=0;ie<N.length;ie++){if(b(N[ie],o))return $;$++}return $}function s(o,P,N){return o.sort(($,ie)=>t($,P,N)-t(ie,P,N))}e.sortMimeTypes=s;function i(o,P,N,$=(ie,ce)=>ie===ce){const ie=[];function ce(z,T,q){if(T===0&&q.length===0)return;const L=ie[ie.length-1];L&&L.start+L.deleteCount===z?(L.deleteCount+=T,L.toInsert.push(...q)):ie.push({start:z,deleteCount:T,toInsert:q})}let K=0,H=0;for(;;){if(K===o.length){ce(K,0,P.slice(H));break}if(H===P.length){ce(K,o.length-K,[]);break}const z=o[K],T=P[H];if($(z,T)){K+=1,H+=1;continue}N(T)?(ce(K,1,[]),K+=1):(ce(K,0,[T]),H+=1)}return ie}e.diff=i,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(o){o.default="default",o.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function c(o){const P=o;return!!((typeof P.include=="string"||m.isRelativePattern(P.include))&&(typeof P.exclude=="string"||m.isRelativePattern(P.exclude)))}e.isDocumentExcludePattern=c;function p(o,P,N){if(Array.isArray(o.viewType)&&o.viewType.indexOf(P)>=0||o.viewType===P)return!0;if(o.filenamePattern){let $=c(o.filenamePattern)?o.filenamePattern.include:o.filenamePattern,ie=c(o.filenamePattern)?o.filenamePattern.exclude:void 0;if(m.match($,(0,y.basename)(N.fsPath).toLowerCase()))return!(ie&&m.match(ie,(0,y.basename)(N.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=p;class v{constructor(P){this.textModel=P}getElements(){const P=new Int32Array(this.textModel.cells.length);for(let N=0;N<this.textModel.cells.length;N++)P[N]=this.textModel.cells[N].getHashValue();return P}}e.CellSequence=v,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted";var A;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(A=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class R{static create(P){return`${R._prefix}${P}`}static parse(P){if(P.startsWith(R._prefix))return P.substr(R._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=R,R._prefix="notebook/"}),define(_e[168],ye([0,1,139,4,59]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new D.RawContextKey("customExecutionSupported",!0,m.localize(0,null)),e.ShellExecutionSupportedContext=new D.RawContextKey("shellExecutionSupported",!1,m.localize(1,null)),e.ProcessExecutionSupportedContext=new D.RawContextKey("processExecutionSupported",!1,m.localize(2,null)),e.ITaskService=(0,F.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(_e[169],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function m(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=m;function F(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=F}),define(_e[96],ye([0,1,6]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.testRunConfigurationBitsetList=e.TestRunConfigurationBitset=e.identifyTest=e.TestResultState=void 0,Object.defineProperty(e,"TestResultState",{enumerable:!0,get:function(){return m.TestResultState}});const F=k=>({testId:k.item.extId,controllerId:k.controllerId});e.identifyTest=F;var D;(function(k){k[k.Run=2]="Run",k[k.Debug=4]="Debug",k[k.Coverage=8]="Coverage",k[k.HasNonDefaultConfig=16]="HasNonDefaultConfig",k[k.HasConfigurable=32]="HasConfigurable"})(D=e.TestRunConfigurationBitset||(e.TestRunConfigurationBitset={})),e.testRunConfigurationBitsetList=[2,4,8,16];var y;(function(k){k[k.NotExpandable=0]="NotExpandable",k[k.Expandable=1]="Expandable",k[k.BusyExpanding=2]="BusyExpanding",k[k.Expanded=3]="Expanded"})(y=e.TestItemExpandState||(e.TestItemExpandState={}));const I=(k,l)=>{l.expand!==void 0&&(k.expand=l.expand),l.item!==void 0&&(k.item=k.item?Object.assign(k.item,l.item):l.item)};e.applyTestItemUpdate=I;var S;(function(k){k[k.Function=0]="Function",k[k.Statement=1]="Statement"})(S=e.DetailType||(e.DetailType={}));var _;(function(k){k[k.Add=0]="Add",k[k.Update=1]="Update",k[k.Remove=2]="Remove",k[k.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",k[k.Retire=4]="Retire"})(_=e.TestDiffOpType||(e.TestDiffOpType={}));class C{add(l){}update(l){}remove(l,h){}complete(){}}e.IncrementalChangeCollector=C;class n{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(l){const h=this.createChangeCollector();for(const a of l)switch(a[0]){case 0:{const d=a[1];if(d.parent){if(this.items.has(d.parent)){const f=this.items.get(d.parent);f.children.add(d.item.extId);const E=this.createItem(d,f);this.items.set(d.item.extId,E),h.add(E)}}else{const f=this.createItem(d);this.roots.add(f),this.items.set(d.item.extId,f),h.add(f)}d.expand===2&&this.busyControllerCount++;break}case 1:{const d=a[1],f=this.items.get(d.extId);if(!f)break;d.expand!==void 0&&(f.expand===2&&this.busyControllerCount--,d.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(f,d),h.update(f);break}case 2:{const d=this.items.get(a[1]);if(!d)break;d.parent?this.items.get(d.parent).children.delete(d.item.extId):this.roots.delete(d);const f=[[a[1]]];for(;f.length;)for(const E of f.pop()){const w=this.items.get(E);w&&(f.push(w.children),this.items.delete(E),h.remove(w,w!==d),w.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(a[1]);break;case 3:this.updatePendingRoots(a[1]);break}h.complete()}retireTest(l){}updatePendingRoots(l){this.pendingRootCount+=l}createChangeCollector(){return new C}}e.AbstractIncrementalTestCollection=n}),define(_e[170],ye([0,1,14,40,10,24,21,82,140]),function(ee,e,m,F,D,y,I,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class C{constructor(k,l,h){this._contributedVariables=new Map,this._context=k,this._labelService=l,h&&(this._envVariablesPromise=h.then(a=>this.prepareEnv(a)))}prepareEnv(k){if(I.isWindows){const l=Object.create(null);return Object.keys(k).forEach(h=>{l[h.toLowerCase()]=k[h]}),l}return k}resolveWithEnvironment(k,l,h){return this.recursiveResolve(this.prepareEnv(k),l?l.uri:void 0,h)}async resolveAsync(k,l){return this.recursiveResolve(await this._envVariablesPromise,k?k.uri:void 0,l)}async resolveAnyBase(k,l,h,a){const d=y.deepClone(l);return I.isWindows&&d.windows?Object.keys(d.windows).forEach(f=>d[f]=d.windows[f]):I.isMacintosh&&d.osx?Object.keys(d.osx).forEach(f=>d[f]=d.osx[f]):I.isLinux&&d.linux&&Object.keys(d.linux).forEach(f=>d[f]=d.linux[f]),delete d.windows,delete d.osx,delete d.linux,this.recursiveResolve(await this._envVariablesPromise,k?k.uri:void 0,d,h,a)}async resolveAnyAsync(k,l,h){return this.resolveAnyBase(k,l,h)}async resolveAnyMap(k,l,h){const a=new Map;return{newConfig:await this.resolveAnyBase(k,l,h,a),resolvedVariables:a}}resolveWithInteractionReplace(k,l,h,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,l,h,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,l){if(this._contributedVariables.has(k))throw new Error("Variable "+k+" is contributed twice.");this._contributedVariables.set(k,l)}recursiveResolve(k,l,h,a,d){if(D.isString(h))return this.resolveString(k,l,h,a,d);if(D.isArray(h))return h.map(f=>this.recursiveResolve(k,l,f,a,d));if(D.isObject(h)){let f=Object.create(null);return Object.keys(h).forEach(E=>{const w=this.resolveString(k,l,E,a,d);f[w]=this.recursiveResolve(k,l,h[E],a,d)}),f}return h}resolveString(k,l,h,a,d){return h.replace(C.VARIABLE_REGEXP,(E,w)=>{if(w.includes(C.VARIABLE_LHS))return E;let u=this.evaluateSingleVariable(k,E,w,l,a);return d&&d.set(w,u),u!==E&&D.isString(u)&&u.match(C.VARIABLE_REGEXP)&&(u=this.resolveString(k,l,u,a,d)),u})}fsPath(k){return this._labelService?this._labelService.getUriLabel(k,{noPrefix:!0}):k.fsPath}evaluateSingleVariable(k,l,h,a,d){let f;const E=h.split(":");E.length>1&&(h=E[0],f=E[1]);const w=()=>{const b=this._context.getFilePath();if(b)return b;throw new Error((0,_.localize)(0,null,l))},u=()=>{const b=w();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,_.localize)(1,null,l,m.basename(b)))},g=()=>{if(f){const b=this._context.getFolderUri(f);if(b)return b;throw new Error((0,_.localize)(2,null,l,f))}if(a)return a;throw this._context.getWorkspaceFolderCount()>1?new Error((0,_.localize)(3,null,l)):new Error((0,_.localize)(4,null,l))};switch(h){case"env":if(f){if(k){const b=k[I.isWindows?f.toLowerCase():f];if(D.isString(b))return b}return""}throw new Error((0,_.localize)(5,null,l));case"config":if(f){const b=this._context.getConfigurationValue(a,f);if(D.isUndefinedOrNull(b))throw new Error((0,_.localize)(6,null,l,f));if(D.isObject(b))throw new Error((0,_.localize)(7,null,l,f));return b}throw new Error((0,_.localize)(8,null,l));case"command":return this.resolveFromMap(l,f,d,"command");case"input":return this.resolveFromMap(l,f,d,"input");default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,S.normalizeDriveLetter)(this.fsPath(g()));case"cwd":return a||f?(0,S.normalizeDriveLetter)(this.fsPath(g())):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return m.basename(this.fsPath(g()));case"lineNumber":const b=this._context.getLineNumber();if(b)return b;throw new Error((0,_.localize)(9,null,l));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,_.localize)(10,null,l));case"file":return w();case"fileWorkspaceFolder":return u();case"relativeFile":return a||f?m.relative(this.fsPath(g()),w()):w();case"relativeFileDirname":const s=m.dirname(w());if(a||f){const p=m.relative(this.fsPath(g()),s);return p.length===0?".":p}return s;case"fileDirname":return m.dirname(w());case"fileExtname":return m.extname(w());case"fileBasename":return m.basename(w());case"fileBasenameNoExtension":const i=m.basename(w());return i.slice(0,i.length-m.extname(i).length);case"fileDirnameBasename":return m.basename(m.dirname(w()));case"execPath":const r=this._context.getExecPath();return r||l;case"execInstallFolder":const c=this._context.getAppRoot();return c||l;case"pathSeparator":return m.sep;default:try{const p=f?`${h}:${f}`:h;return this.resolveFromMap(l,p,d,void 0)}catch(p){return l}}}}resolveFromMap(k,l,h,a){if(l&&h){const d=a===void 0?h[l]:h[a+":"+l];if(typeof d=="string")return d;throw new Error((0,_.localize)(11,null,k))}return k}}e.AbstractVariableResolverService=C,C.VARIABLE_LHS="${",C.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(_e[97],ye([0,1,4,165]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,m.createDecorator)("editorGroupsService");var D;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var y;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(y=e.GroupOrientation||(e.GroupOrientation={}));var I;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(I=e.GroupLocation||(e.GroupLocation={}));var S;(function(d){d[d.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",d[d.EVEN=1]="EVEN",d[d.TOGGLE=2]="TOGGLE"})(S=e.GroupsArrangement||(e.GroupsArrangement={}));var _;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(_=e.MergeGroupMode||(e.MergeGroupMode={}));function C(d){const f=d;return(0,F.isEditorInput)(f?.editor)&&(0,F.isEditorInput)(f?.replacement)}e.isEditorReplacement=C;var n;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(n=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(d){d[d.GROUP_ACTIVE=0]="GROUP_ACTIVE",d[d.GROUP_INDEX=1]="GROUP_INDEX",d[d.EDITOR_OPEN=2]="EDITOR_OPEN",d[d.EDITOR_CLOSE=3]="EDITOR_CLOSE",d[d.EDITOR_MOVE=4]="EDITOR_MOVE",d[d.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",d[d.EDITOR_LABEL=6]="EDITOR_LABEL",d[d.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",d[d.EDITOR_PIN=8]="EDITOR_PIN",d[d.EDITOR_STICKY=9]="EDITOR_STICKY",d[d.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(k=e.GroupChangeKind||(e.GroupChangeKind={}));var l;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(l=e.OpenEditorContext||(e.OpenEditorContext={}));function h(d){const f=d;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.isEditorGroup=h;function a(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=a}),define(_e[171],ye([0,1,4,97]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,m.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(y){const I=y;return typeof y=="number"||(0,F.isEditorGroup)(I)}e.isPreferredGroup=D}),define(_e[9],ye([0,1,17,81,227,54,24,10,2,30,58,141,90,65,69,171,6]),function(ee,e,m,F,D,y,I,S,_,C,n,k,l,h,a,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var E;(function(me){function Ee(V){const{selectionStartLineNumber:be,selectionStartColumn:Be,positionLineNumber:Xe,positionColumn:Ve}=V,lt=new f.Position(be-1,Be-1),ht=new f.Position(Xe-1,Ve-1);return new f.Selection(lt,ht)}me.to=Ee;function ae(V){const{anchor:be,active:Be}=V;return{selectionStartLineNumber:be.line+1,selectionStartColumn:be.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}me.from=ae})(E=e.Selection||(e.Selection={}));var w;(function(me){function Ee(V){if(!V)return;const{start:be,end:Be}=V;return{startLineNumber:be.line+1,startColumn:be.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}me.from=Ee;function ae(V){if(!V)return;const{startLineNumber:be,startColumn:Be,endLineNumber:Xe,endColumn:Ve}=V;return new f.Range(be-1,Be-1,Xe-1,Ve-1)}me.to=ae})(w=e.Range||(e.Range={}));var u;(function(me){function Ee(ae){switch(ae){case 1:return f.StandardTokenType.Comment;case 0:return f.StandardTokenType.Other;case 4:return f.StandardTokenType.RegEx;case 2:return f.StandardTokenType.String}}me.to=Ee})(u=e.TokenType||(e.TokenType={}));var g;(function(me){function Ee(V){return new f.Position(V.lineNumber-1,V.column-1)}me.to=Ee;function ae(V){return{lineNumber:V.line+1,column:V.character+1}}me.from=ae})(g=e.Position||(e.Position={}));var b;(function(me){function Ee(V){switch(V){case f.DiagnosticTag.Unnecessary:return 1;case f.DiagnosticTag.Deprecated:return 2}}me.from=Ee;function ae(V){switch(V){case 1:return f.DiagnosticTag.Unnecessary;case 2:return f.DiagnosticTag.Deprecated;default:return}}me.to=ae})(b=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(me){function Ee(V){let be;return V.code&&((0,S.isString)(V.code)||(0,S.isNumber)(V.code)?be=String(V.code):be={value:String(V.code.value),target:V.code.target}),{...w.from(V.range),message:V.message,source:V.source,code:be,severity:i.from(V.severity),relatedInformation:V.relatedInformation&&V.relatedInformation.map(s.from),tags:Array.isArray(V.tags)?(0,m.coalesce)(V.tags.map(b.from)):void 0}}me.from=Ee;function ae(V){const be=new f.Diagnostic(w.to(V),V.message,i.to(V.severity));return be.source=V.source,be.code=(0,S.isString)(V.code)?V.code:V.code?.value,be.relatedInformation=V.relatedInformation&&V.relatedInformation.map(s.to),be.tags=V.tags&&(0,m.coalesce)(V.tags.map(b.to)),be}me.to=ae})(t=e.Diagnostic||(e.Diagnostic={}));var s;(function(me){function Ee(V){return{...w.from(V.location.range),message:V.message,resource:V.location.uri}}me.from=Ee;function ae(V){return new f.DiagnosticRelatedInformation(new f.Location(V.resource,w.to(V)),V.message)}me.to=ae})(s=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(me){function Ee(V){switch(V){case f.DiagnosticSeverity.Error:return l.MarkerSeverity.Error;case f.DiagnosticSeverity.Warning:return l.MarkerSeverity.Warning;case f.DiagnosticSeverity.Information:return l.MarkerSeverity.Info;case f.DiagnosticSeverity.Hint:return l.MarkerSeverity.Hint}return l.MarkerSeverity.Error}me.from=Ee;function ae(V){switch(V){case l.MarkerSeverity.Info:return f.DiagnosticSeverity.Information;case l.MarkerSeverity.Warning:return f.DiagnosticSeverity.Warning;case l.MarkerSeverity.Error:return f.DiagnosticSeverity.Error;case l.MarkerSeverity.Hint:return f.DiagnosticSeverity.Hint;default:return f.DiagnosticSeverity.Error}}me.to=ae})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var r;(function(me){function Ee(V){return typeof V=="number"&&V>=f.ViewColumn.One?V-1:V===f.ViewColumn.Beside?d.SIDE_GROUP:d.ACTIVE_GROUP}me.from=Ee;function ae(V){if(typeof V=="number"&&V>=0)return V+1;throw new Error("invalid 'EditorGroupColumn'")}me.to=ae})(r=e.ViewColumn||(e.ViewColumn={}));function c(me){return typeof me.range!="undefined"}function p(me){return me.length===0?!0:!!c(me[0])}e.isDecorationOptionsArr=p;var v;(function(me){function Ee(Ve){return Ve.map(me.from)}me.fromMany=Ee;function ae(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function V(Ve){let lt;if(ae(Ve)){const{language:Et,value:vt}=Ve;lt={value:"```"+Et+`
`+vt+"\n```\n"}}else f.MarkdownString.isMarkdownString(Ve)?lt={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons}:typeof Ve=="string"?lt={value:Ve}:lt={value:""};const ht=Object.create(null);lt.uris=ht;const St=Et=>{try{let vt=_.URI.parse(Et,!0);vt=vt.with({query:be(vt.query,ht)}),ht[Et]=vt}catch(vt){}return""},Ct=new D.Renderer;return Ct.link=St,Ct.image=Et=>St(F.parseHrefAndDimensions(Et).href),D(lt.value,{renderer:Ct}),lt}me.from=V;function be(Ve,lt){if(!Ve)return Ve;let ht;try{ht=(0,y.parse)(Ve)}catch(Ct){}if(!ht)return Ve;let St=!1;return ht=(0,I.cloneAndChange)(ht,Ct=>{if(_.URI.isUri(Ct)){const Et=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[Et]=Ct,St=!0,Et}else return}),St?JSON.stringify(ht):Ve}function Be(Ve){const lt=new f.MarkdownString(Ve.value,Ve.supportThemeIcons);return lt.isTrusted=Ve.isTrusted,lt}me.to=Be;function Xe(Ve){if(!!Ve)return typeof Ve=="string"?Ve:me.from(Ve)}me.fromStrict=Xe})(v=e.MarkdownString||(e.MarkdownString={}));function A(me){return p(me)?me.map(Ee=>({range:w.from(Ee.range),hoverMessage:Array.isArray(Ee.hoverMessage)?v.fromMany(Ee.hoverMessage):Ee.hoverMessage?v.from(Ee.hoverMessage):void 0,renderOptions:Ee.renderOptions})):me.map(Ee=>({range:w.from(Ee)}))}e.fromRangeOrRangeWithMessage=A;function R(me){return typeof me=="undefined"?me:typeof me=="string"?_.URI.file(me):me}e.pathOrURIToURI=R;var o;(function(me){function Ee(ae){return typeof ae=="undefined"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?R(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}me.from=Ee})(o=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var P;(function(me){function Ee(ae){return typeof ae=="undefined"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?R(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?o.from(ae.before):void 0,after:ae.after?o.from(ae.after):void 0}}me.from=Ee})(P=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var N;(function(me){function Ee(ae){if(typeof ae=="undefined")return ae;switch(ae){case f.DecorationRangeBehavior.OpenOpen:return 0;case f.DecorationRangeBehavior.ClosedClosed:return 1;case f.DecorationRangeBehavior.OpenClosed:return 2;case f.DecorationRangeBehavior.ClosedOpen:return 3}}me.from=Ee})(N=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var $;(function(me){function Ee(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?N.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?P.from(ae.light):void 0,dark:ae.dark?P.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?R(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?o.from(ae.before):void 0,after:ae.after?o.from(ae.after):void 0}}me.from=Ee})($=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var ie;(function(me){function Ee(V){return{text:V.newText,eol:V.newEol&&J.from(V.newEol),range:w.from(V.range)}}me.from=Ee;function ae(V){const be=new f.TextEdit(w.to(V.range),V.text);return be.newEol=typeof V.eol=="undefined"?void 0:J.to(V.eol),be}me.to=ae})(ie=e.TextEdit||(e.TextEdit={}));var ce;(function(me){function Ee(V,be,Be){const Xe={edits:[]};if(V instanceof f.WorkspaceEdit)for(let Ve of V._allEntries())if(Ve._type===1)Xe.edits.push({_type:1,oldUri:Ve.from,newUri:Ve.to,options:Ve.options,metadata:Ve.metadata});else if(Ve._type===2){const lt=be?.getDocument(Ve.uri);Xe.edits.push({_type:2,resource:Ve.uri,edit:ie.from(Ve.edit),modelVersionId:lt?.version,metadata:Ve.metadata})}else Ve._type===3?Xe.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,edit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Be?.getNotebookDocument(Ve.uri,!0)?.apiNotebook.version}):Ve._type===5&&Xe.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Be?.getNotebookDocument(Ve.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(ge.from)}});return Xe}me.from=Ee;function ae(V){const be=new f.WorkspaceEdit;for(const Be of V.edits)Be.edit?be.replace(_.URI.revive(Be.resource),w.to(Be.edit.range),Be.edit.text):be.renameFile(_.URI.revive(Be.oldUri),_.URI.revive(Be.newUri),Be.options);return be}me.to=ae})(ce=e.WorkspaceEdit||(e.WorkspaceEdit={}));var K;(function(me){const Ee=Object.create(null);Ee[f.SymbolKind.File]=0,Ee[f.SymbolKind.Module]=1,Ee[f.SymbolKind.Namespace]=2,Ee[f.SymbolKind.Package]=3,Ee[f.SymbolKind.Class]=4,Ee[f.SymbolKind.Method]=5,Ee[f.SymbolKind.Property]=6,Ee[f.SymbolKind.Field]=7,Ee[f.SymbolKind.Constructor]=8,Ee[f.SymbolKind.Enum]=9,Ee[f.SymbolKind.Interface]=10,Ee[f.SymbolKind.Function]=11,Ee[f.SymbolKind.Variable]=12,Ee[f.SymbolKind.Constant]=13,Ee[f.SymbolKind.String]=14,Ee[f.SymbolKind.Number]=15,Ee[f.SymbolKind.Boolean]=16,Ee[f.SymbolKind.Array]=17,Ee[f.SymbolKind.Object]=18,Ee[f.SymbolKind.Key]=19,Ee[f.SymbolKind.Null]=20,Ee[f.SymbolKind.EnumMember]=21,Ee[f.SymbolKind.Struct]=22,Ee[f.SymbolKind.Event]=23,Ee[f.SymbolKind.Operator]=24,Ee[f.SymbolKind.TypeParameter]=25;function ae(be){return typeof Ee[be]=="number"?Ee[be]:6}me.from=ae;function V(be){for(const Be in Ee)if(Ee[Be]===be)return Number(Be);return f.SymbolKind.Property}me.to=V})(K=e.SymbolKind||(e.SymbolKind={}));var H;(function(me){function Ee(V){switch(V){case f.SymbolTag.Deprecated:return 1}}me.from=Ee;function ae(V){switch(V){case 1:return f.SymbolTag.Deprecated}}me.to=ae})(H=e.SymbolTag||(e.SymbolTag={}));var z;(function(me){function Ee(V){return{name:V.name,kind:K.from(V.kind),tags:V.tags&&V.tags.map(H.from),containerName:V.containerName,location:Y.from(V.location)}}me.from=Ee;function ae(V){const be=new f.SymbolInformation(V.name,K.to(V.kind),V.containerName,Y.to(V.location));return be.tags=V.tags&&V.tags.map(H.to),be}me.to=ae})(z=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var T;(function(me){function Ee(V){const be={name:V.name||"!!MISSING: name!!",detail:V.detail,range:w.from(V.range),selectionRange:w.from(V.selectionRange),kind:K.from(V.kind),tags:V.tags?.map(H.from)??[]};return V.children&&(be.children=V.children.map(Ee)),be}me.from=Ee;function ae(V){const be=new f.DocumentSymbol(V.name,V.detail,K.to(V.kind),w.to(V.range),w.to(V.selectionRange));return(0,m.isNonEmptyArray)(V.tags)&&(be.tags=V.tags.map(H.to)),V.children&&(be.children=V.children.map(ae)),be}me.to=ae})(T=e.DocumentSymbol||(e.DocumentSymbol={}));var q;(function(me){function Ee(ae){const V=new f.CallHierarchyItem(K.to(ae.kind),ae.name,ae.detail||"",_.URI.revive(ae.uri),w.to(ae.range),w.to(ae.selectionRange));return V._sessionId=ae._sessionId,V._itemId=ae._itemId,V}me.to=Ee})(q=e.CallHierarchyItem||(e.CallHierarchyItem={}));var L;(function(me){function Ee(ae){return new f.CallHierarchyIncomingCall(q.to(ae.from),ae.fromRanges.map(V=>w.to(V)))}me.to=Ee})(L=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var B;(function(me){function Ee(ae){return new f.CallHierarchyOutgoingCall(q.to(ae.to),ae.fromRanges.map(V=>w.to(V)))}me.to=Ee})(B=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Y;(function(me){function Ee(V){return{range:V.range&&w.from(V.range),uri:V.uri}}me.from=Ee;function ae(V){return new f.Location(_.URI.revive(V.uri),w.to(V.range))}me.to=ae})(Y=e.location||(e.location={}));var j;(function(me){function Ee(V){const be=V,Be=V;return{originSelectionRange:be.originSelectionRange?w.from(be.originSelectionRange):void 0,uri:be.targetUri?be.targetUri:Be.uri,range:w.from(be.targetRange?be.targetRange:Be.range),targetSelectionRange:be.targetSelectionRange?w.from(be.targetSelectionRange):void 0}}me.from=Ee;function ae(V){return{targetUri:_.URI.revive(V.uri),targetRange:w.to(V.range),targetSelectionRange:V.targetSelectionRange?w.to(V.targetSelectionRange):void 0,originSelectionRange:V.originSelectionRange?w.to(V.originSelectionRange):void 0}}me.to=ae})(j=e.DefinitionLink||(e.DefinitionLink={}));var se;(function(me){function Ee(V){return{range:w.from(V.range),contents:v.fromMany(V.contents)}}me.from=Ee;function ae(V){return new f.Hover(V.contents.map(v.to),w.to(V.range))}me.to=ae})(se=e.Hover||(e.Hover={}));var Se;(function(me){function Ee(V){return{range:w.from(V.range),expression:V.expression}}me.from=Ee;function ae(V){return new f.EvaluatableExpression(w.to(V.range),V.expression)}me.to=ae})(Se=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Re;(function(me){function Ee(V){if(V instanceof f.InlineValueText)return{type:"text",range:w.from(V.range),text:V.text};if(V instanceof f.InlineValueVariableLookup)return{type:"variable",range:w.from(V.range),variableName:V.variableName,caseSensitiveLookup:V.caseSensitiveLookup};if(V instanceof f.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(V.range),expression:V.expression};throw new Error("Unknown 'InlineValue' type")}me.from=Ee;function ae(V){switch(V.type){case"text":return{range:w.to(V.range),text:V.text};case"variable":return{range:w.to(V.range),variableName:V.variableName,caseSensitiveLookup:V.caseSensitiveLookup};case"expression":return{range:w.to(V.range),expression:V.expression}}}me.to=ae})(Re=e.InlineValue||(e.InlineValue={}));var $e;(function(me){function Ee(V){return{frameId:V.frameId,stoppedLocation:w.from(V.stoppedLocation)}}me.from=Ee;function ae(V){return new f.InlineValueContext(V.frameId,w.to(V.stoppedLocation))}me.to=ae})($e=e.InlineValueContext||(e.InlineValueContext={}));var Ne;(function(me){function Ee(V){return{range:w.from(V.range),kind:V.kind}}me.from=Ee;function ae(V){return new f.DocumentHighlight(w.to(V.range),V.kind)}me.to=ae})(Ne=e.DocumentHighlight||(e.DocumentHighlight={}));var Ge;(function(me){function Ee(ae){switch(ae){case 1:return f.CompletionTriggerKind.TriggerCharacter;case 2:return f.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return f.CompletionTriggerKind.Invoke}}me.to=Ee})(Ge=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ke;(function(me){function Ee(ae){return{triggerKind:Ge.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}me.to=Ee})(Ke=e.CompletionContext||(e.CompletionContext={}));var qe;(function(me){function Ee(V){switch(V){case f.CompletionItemTag.Deprecated:return 1}}me.from=Ee;function ae(V){switch(V){case 1:return f.CompletionItemTag.Deprecated}}me.to=ae})(qe=e.CompletionItemTag||(e.CompletionItemTag={}));var U;(function(me){const Ee=new Map([[f.CompletionItemKind.Method,0],[f.CompletionItemKind.Function,1],[f.CompletionItemKind.Constructor,2],[f.CompletionItemKind.Field,3],[f.CompletionItemKind.Variable,4],[f.CompletionItemKind.Class,5],[f.CompletionItemKind.Interface,7],[f.CompletionItemKind.Struct,6],[f.CompletionItemKind.Module,8],[f.CompletionItemKind.Property,9],[f.CompletionItemKind.Unit,12],[f.CompletionItemKind.Value,13],[f.CompletionItemKind.Constant,14],[f.CompletionItemKind.Enum,15],[f.CompletionItemKind.EnumMember,16],[f.CompletionItemKind.Keyword,17],[f.CompletionItemKind.Snippet,27],[f.CompletionItemKind.Text,18],[f.CompletionItemKind.Color,19],[f.CompletionItemKind.File,20],[f.CompletionItemKind.Reference,21],[f.CompletionItemKind.Folder,23],[f.CompletionItemKind.Event,10],[f.CompletionItemKind.Operator,11],[f.CompletionItemKind.TypeParameter,24],[f.CompletionItemKind.Issue,26],[f.CompletionItemKind.User,25]]);function ae(Be){return Ee.get(Be)??9}me.from=ae;const V=new Map([[0,f.CompletionItemKind.Method],[1,f.CompletionItemKind.Function],[2,f.CompletionItemKind.Constructor],[3,f.CompletionItemKind.Field],[4,f.CompletionItemKind.Variable],[5,f.CompletionItemKind.Class],[7,f.CompletionItemKind.Interface],[6,f.CompletionItemKind.Struct],[8,f.CompletionItemKind.Module],[9,f.CompletionItemKind.Property],[12,f.CompletionItemKind.Unit],[13,f.CompletionItemKind.Value],[14,f.CompletionItemKind.Constant],[15,f.CompletionItemKind.Enum],[16,f.CompletionItemKind.EnumMember],[17,f.CompletionItemKind.Keyword],[27,f.CompletionItemKind.Snippet],[18,f.CompletionItemKind.Text],[19,f.CompletionItemKind.Color],[20,f.CompletionItemKind.File],[21,f.CompletionItemKind.Reference],[23,f.CompletionItemKind.Folder],[10,f.CompletionItemKind.Event],[11,f.CompletionItemKind.Operator],[24,f.CompletionItemKind.TypeParameter],[25,f.CompletionItemKind.User],[26,f.CompletionItemKind.Issue]]);function be(Be){return V.get(Be)??f.CompletionItemKind.Property}me.to=be})(U=e.CompletionItemKind||(e.CompletionItemKind={}));var G;(function(me){function Ee(ae,V){const be=new f.CompletionItem(ae.label);return be.insertText=ae.insertText,be.kind=U.to(ae.kind),be.tags=ae.tags?.map(qe.to),be.detail=ae.detail,be.documentation=F.isMarkdownString(ae.documentation)?v.to(ae.documentation):ae.documentation,be.sortText=ae.sortText,be.filterText=ae.filterText,be.preselect=ae.preselect,be.commitCharacters=ae.commitCharacters,C.Range.isIRange(ae.range)?be.range=w.to(ae.range):typeof ae.range=="object"&&(be.range={inserting:w.to(ae.range.insert),replacing:w.to(ae.range.replace)}),be.keepWhitespace=typeof ae.insertTextRules=="undefined"?!1:Boolean(ae.insertTextRules&1),typeof ae.insertTextRules!="undefined"&&ae.insertTextRules&4?be.insertText=new f.SnippetString(ae.insertText):(be.insertText=ae.insertText,be.textEdit=be.range instanceof f.Range?new f.TextEdit(be.range,be.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(be.additionalTextEdits=ae.additionalTextEdits.map(Be=>ie.to(Be))),be.command=V&&ae.command?V.fromInternal(ae.command):void 0,be}me.to=Ee})(G=e.CompletionItem||(e.CompletionItem={}));var te;(function(me){function Ee(V){return{label:V.label,documentation:V.documentation?v.fromStrict(V.documentation):void 0}}me.from=Ee;function ae(V){return{label:V.label,documentation:F.isMarkdownString(V.documentation)?v.to(V.documentation):V.documentation}}me.to=ae})(te=e.ParameterInformation||(e.ParameterInformation={}));var re;(function(me){function Ee(V){return{label:V.label,documentation:V.documentation?v.fromStrict(V.documentation):void 0,parameters:Array.isArray(V.parameters)?V.parameters.map(te.from):[],activeParameter:V.activeParameter}}me.from=Ee;function ae(V){return{label:V.label,documentation:F.isMarkdownString(V.documentation)?v.to(V.documentation):V.documentation,parameters:Array.isArray(V.parameters)?V.parameters.map(te.to):[],activeParameter:V.activeParameter}}me.to=ae})(re=e.SignatureInformation||(e.SignatureInformation={}));var pe;(function(me){function Ee(V){return{activeSignature:V.activeSignature,activeParameter:V.activeParameter,signatures:Array.isArray(V.signatures)?V.signatures.map(re.from):[]}}me.from=Ee;function ae(V){return{activeSignature:V.activeSignature,activeParameter:V.activeParameter,signatures:Array.isArray(V.signatures)?V.signatures.map(re.to):[]}}me.to=ae})(pe=e.SignatureHelp||(e.SignatureHelp={}));var Q;(function(me){function Ee(V){return{text:V.text,position:g.from(V.position),kind:ue.from(V.kind??f.InlayHintKind.Other),whitespaceBefore:V.whitespaceBefore,whitespaceAfter:V.whitespaceAfter}}me.from=Ee;function ae(V){const be=new f.InlayHint(V.text,g.to(V.position),ue.to(V.kind));return be.whitespaceAfter=V.whitespaceAfter,be.whitespaceBefore=V.whitespaceBefore,be}me.to=ae})(Q=e.InlayHint||(e.InlayHint={}));var ue;(function(me){function Ee(V){return V}me.from=Ee;function ae(V){return V}me.to=ae})(ue=e.InlayHintKind||(e.InlayHintKind={}));var Ie;(function(me){function Ee(V){return{range:w.from(V.range),url:V.target,tooltip:V.tooltip}}me.from=Ee;function ae(V){let be;if(V.url)try{be=typeof V.url=="string"?_.URI.parse(V.url,!0):_.URI.revive(V.url)}catch(Be){}return new f.DocumentLink(w.to(V.range),be)}me.to=ae})(Ie=e.DocumentLink||(e.DocumentLink={}));var xe;(function(me){function Ee(V){const be=new f.ColorPresentation(V.label);return V.textEdit&&(be.textEdit=ie.to(V.textEdit)),V.additionalTextEdits&&(be.additionalTextEdits=V.additionalTextEdits.map(Be=>ie.to(Be))),be}me.to=Ee;function ae(V){return{label:V.label,textEdit:V.textEdit?ie.from(V.textEdit):void 0,additionalTextEdits:V.additionalTextEdits?V.additionalTextEdits.map(be=>ie.from(be)):void 0}}me.from=ae})(xe=e.ColorPresentation||(e.ColorPresentation={}));var We;(function(me){function Ee(V){return new f.Color(V[0],V[1],V[2],V[3])}me.to=Ee;function ae(V){return[V.red,V.green,V.blue,V.alpha]}me.from=ae})(We=e.Color||(e.Color={}));var ve;(function(me){function Ee(V){return{range:w.from(V.range)}}me.from=Ee;function ae(V){return new f.SelectionRange(w.to(V.range))}me.to=ae})(ve=e.SelectionRange||(e.SelectionRange={}));var tt;(function(me){function Ee(ae){switch(ae){case 2:return f.TextDocumentSaveReason.AfterDelay;case 1:return f.TextDocumentSaveReason.Manual;case 3:case 4:return f.TextDocumentSaveReason.FocusOut}}me.to=Ee})(tt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var W;(function(me){function Ee(V){switch(V){case f.TextEditorLineNumbersStyle.Off:return 0;case f.TextEditorLineNumbersStyle.Relative:return 2;case f.TextEditorLineNumbersStyle.On:default:return 1}}me.from=Ee;function ae(V){switch(V){case 0:return f.TextEditorLineNumbersStyle.Off;case 2:return f.TextEditorLineNumbersStyle.Relative;case 1:default:return f.TextEditorLineNumbersStyle.On}}me.to=ae})(W=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var J;(function(me){function Ee(V){if(V===f.EndOfLine.CRLF)return 1;if(V===f.EndOfLine.LF)return 0}me.from=Ee;function ae(V){if(V===1)return f.EndOfLine.CRLF;if(V===0)return f.EndOfLine.LF}me.to=ae})(J=e.EndOfLine||(e.EndOfLine={}));var fe;(function(me){function Ee(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case f.ProgressLocation.SourceControl:return 3;case f.ProgressLocation.Window:return 10;case f.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}me.from=Ee})(fe=e.ProgressLocation||(e.ProgressLocation={}));var Oe;(function(me){function Ee(ae){const V={start:ae.start+1,end:ae.end+1};return ae.kind&&(V.kind=Ue.from(ae.kind)),V}me.from=Ee})(Oe=e.FoldingRange||(e.FoldingRange={}));var Ue;(function(me){function Ee(ae){if(ae)switch(ae){case f.FoldingRangeKind.Comment:return n.FoldingRangeKind.Comment;case f.FoldingRangeKind.Imports:return n.FoldingRangeKind.Imports;case f.FoldingRangeKind.Region:return n.FoldingRangeKind.Region}}me.from=Ee})(Ue=e.FoldingRangeKind||(e.FoldingRangeKind={}));var et;(function(me){function Ee(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?w.from(ae.selection):void 0,override:typeof ae.override=="boolean"?k.EditorResolution.DISABLED:void 0}}me.from=Ee})(et=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ce;(function(me){function Ee(V){return V instanceof f.RelativePattern||typeof V=="string"?V:ae(V)?new f.RelativePattern(V.base,V.pattern):V}me.from=Ee;function ae(V){const be=V;return be&&typeof be.base=="string"&&typeof be.pattern=="string"}})(Ce=e.GlobPattern||(e.GlobPattern={}));var De;(function(me){function Ee(ae){if(ae){if(Array.isArray(ae))return ae.map(Ee);if(typeof ae=="string")return ae;{const V=ae;return{language:V.language,scheme:V.scheme,pattern:typeof V.pattern=="undefined"?void 0:Ce.from(V.pattern),exclusive:V.exclusive}}}else return}me.from=Ee})(De=e.LanguageSelector||(e.LanguageSelector={}));var Ae;(function(me){function Ee(V){return{start:V.start,end:V.end}}me.from=Ee;function ae(V){return new f.NotebookRange(V.start,V.end)}me.to=ae})(Ae=e.NotebookRange||(e.NotebookRange={}));var ne;(function(me){function Ee(V){return{timing:typeof V.runStartTime=="number"&&typeof V.runEndTime=="number"?{startTime:V.runStartTime,endTime:V.runEndTime}:void 0,executionOrder:V.executionOrder,success:V.lastRunSuccess}}me.to=Ee;function ae(V){return{lastRunSuccess:V.success,runStartTime:V.timing?.startTime,runEndTime:V.timing?.endTime,executionOrder:V.executionOrder}}me.from=ae})(ne=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var oe;(function(me){function Ee(V){switch(V){case f.NotebookCellKind.Markup:return a.CellKind.Markup;case f.NotebookCellKind.Code:default:return a.CellKind.Code}}me.from=Ee;function ae(V){switch(V){case a.CellKind.Markup:return f.NotebookCellKind.Markup;case a.CellKind.Code:default:return f.NotebookCellKind.Code}}me.to=ae})(oe=e.NotebookCellKind||(e.NotebookCellKind={}));var de;(function(me){function Ee(V){const be={metadata:V.metadata??Object.create(null),cells:[]};for(let Be of V.cells)f.NotebookCellData.validate(Be),be.cells.push(ge.from(Be));return be}me.from=Ee;function ae(V){const be=new f.NotebookData(V.cells.map(ge.to));return(0,S.isEmptyObject)(V.metadata)||(be.metadata=V.metadata),be}me.to=ae})(de=e.NotebookData||(e.NotebookData={}));var ge;(function(me){function Ee(V){return{cellKind:oe.from(V.kind),language:V.languageId,mime:V.mime,source:V.value,metadata:V.metadata,internalMetadata:ne.from(V.executionSummary??{}),outputs:V.outputs?V.outputs.map(he.from):[]}}me.from=Ee;function ae(V){return new f.NotebookCellData(oe.to(V.cellKind),V.source,V.language,V.mime,V.outputs?V.outputs.map(he.to):void 0,V.metadata,V.internalMetadata?ne.to(V.internalMetadata):void 0)}me.to=ae})(ge=e.NotebookCellData||(e.NotebookCellData={}));var x;(function(me){function Ee(V){return{mime:V.mime,valueBytes:Array.from(V.data)}}me.from=Ee;function ae(V){return new f.NotebookCellOutputItem(new Uint8Array(V.valueBytes),V.mime)}me.to=ae})(x=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var he;(function(me){function Ee(V){return{outputId:V.id,items:V.items.map(x.from),metadata:V.metadata}}me.from=Ee;function ae(V){const be=V.items.map(x.to);return new f.NotebookCellOutput(be,V.outputId,V.metadata)}me.to=ae})(he=e.NotebookCellOutput||(e.NotebookCellOutput={}));var we;(function(me){function Ee(Be){if(Be!=null){if(Be instanceof f.RelativePattern||typeof Be=="string")return Be;if(be(Be))return new f.RelativePattern(Be.base,Be.pattern);if(V(Be))return{include:Ce.from(Be.include)||void 0,exclude:Ce.from(Be.exclude)||void 0}}}me.from=Ee;function ae(Be){return typeof Be=="string"?Be:be(Be)?{base:Be.base,pattern:Be.pattern}:{include:Be.include,exclude:Be.exclude}}me.to=ae;function V(Be){const Xe=Be,Ve=Ce.from(Xe.include);if(!(Ve&&Ve instanceof f.RelativePattern||typeof Ve=="string"))return!1;const lt=Ce.from(Xe.exclude);return!!(lt&&lt instanceof f.RelativePattern||typeof lt=="string")}function be(Be){const Xe=Be;return Xe&&typeof Xe.base=="string"&&typeof Xe.pattern=="string"}})(we=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Pe;(function(me){function Ee(ae){return{backgroundColor:ae.backgroundColor,borderColor:ae.borderColor,top:ae.top?o.from(ae.top):void 0}}me.from=Ee})(Pe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Fe;(function(me){function Ee(ae,V,be){const Be=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===f.NotebookCellStatusBarAlignment.Left?1:2,command:V.toInternal(Be,be),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}me.from=Ee})(Fe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var He;(function(me){function Ee(ae){return{transientOutputs:ae?.transientOutputs??!1,transientCellMetadata:ae?.transientCellMetadata??{},transientDocumentMetadata:ae?.transientDocumentMetadata??{}}}me.from=Ee})(He=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ze;(function(me){function Ee(V){return{uri:V.uri,provides:V.provides}}me.from=Ee;function ae(V){return new f.NotebookRendererScript(_.URI.revive(V.uri),V.provides)}me.to=ae})(Ze=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Qe;(function(me){function Ee(V){return{message:v.fromStrict(V.message)||"",severity:V.severity,expectedOutput:V.expectedOutput,actualOutput:V.actualOutput,location:V.location?Y.from(V.location):void 0}}me.from=Ee;function ae(V){const be=new f.TestMessage(typeof V.message=="string"?V.message:v.to(V.message));return be.severity=V.severity,be.actualOutput=V.actualOutput,be.expectedOutput=V.expectedOutput,be}me.to=ae})(Qe=e.TestMessage||(e.TestMessage={}));var Ye;(function(me){function Ee(Xe){return{extId:Xe.id,label:Xe.label,uri:Xe.uri,range:w.from(Xe.range)||null,description:Xe.description||null,error:Xe.error&&v.fromStrict(Xe.error)||null}}me.from=Ee;function ae(Xe){return{extId:Xe.id,label:Xe.label,uri:Xe.uri,range:w.from(Xe.range)||null,description:Xe.description||null,error:null}}me.fromResultSnapshot=ae;function V(Xe){return{id:Xe.extId,label:Xe.label,uri:_.URI.revive(Xe.uri),range:w.to(Xe.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Xe.description||void 0}}me.toPlain=V;function be(Xe){const Ve=new h.TestItemImpl(Xe.extId,Xe.label,_.URI.revive(Xe.uri));return Ve.range=w.to(Xe.range||void 0),Ve.description=Xe.description||void 0,Ve}me.to=be;function Be(Xe){let Ve;for(const lt of Xe.tests){const ht=be(lt.item);(0,h.getPrivateApiFor)(ht).parent=Ve,Ve=ht}return Ve}me.toItemFromContext=Be})(Ye=e.TestItem||(e.TestItem={}));var at;(function(me){const Ee=(V,be)=>({...Ye.toPlain(V.item),taskStates:V.tasks.map(Be=>({state:Be.state,duration:Be.duration,messages:Be.messages.map(Qe.to)})),children:V.children.map(Be=>be.get(Be)).filter(S.isDefined).map(Be=>Ee(Be,be))});function ae(V){const be=[],Be=new Map;for(const Xe of V.items)Be.set(Xe.item.extId,Xe),V.request.targets.some(Ve=>Ve.controllerId===Xe.controllerId&&Ve.testIds.includes(Xe.item.extId))&&be.push(Xe);return{completedAt:V.completedAt,results:be.map(Xe=>Ee(Xe,Be))}}me.to=ae})(at=e.TestResults||(e.TestResults={}));var ct;(function(me){function Ee(Be){return{covered:Be.covered,total:Be.covered}}function ae(Be){return"line"in Be?g.from(Be):w.from(Be)}function V(Be){return"branches"in Be?{count:Be.executionCount,location:ae(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Xe=>({count:Xe.executionCount,location:Xe.location&&ae(Xe.location)})):void 0}:{type:0,count:Be.executionCount,location:ae(Be.location)}}me.fromDetailed=V;function be(Be){return{uri:Be.uri,statement:Ee(Be.statementCoverage),branch:Be.branchCoverage&&Ee(Be.branchCoverage),function:Be.functionCoverage&&Ee(Be.functionCoverage),details:Be.detailedCoverage?.map(V)}}me.fromFile=be})(ct=e.TestCoverage||(e.TestCoverage={}));var wt;(function(me){function Ee(ae){switch(ae){case 1:return f.CodeActionTriggerKind.Invoke;case 2:return f.CodeActionTriggerKind.Automatic}}me.to=Ee})(wt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(_e[172],ye([0,1,2,12,6,9,78]),function(ee,e,m,F,D,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class S{constructor(C,n,k,l={timeout:1500,errors:3}){this._logService=C,this._documents=n,this._mainThreadBulkEdits=k,this._thresholds=l,this._callbacks=new I.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(C){return(n,k,l)=>{const a={dispose:this._callbacks.push([n,k,C])};return Array.isArray(l)&&l.push(a),a}}async $participateInSave(C,n){const k=m.URI.revive(C);let l=!1;const h=setTimeout(()=>l=!0,this._thresholds.timeout),a=[];try{for(let d of[...this._callbacks]){if(l)break;const f=this._documents.getDocument(k),E=await this._deliverEventAsyncAndBlameBadListeners(d,{document:f,reason:y.TextDocumentSaveReason.to(n)});a.push(E)}}finally{clearTimeout(h)}return a}_deliverEventAsyncAndBlameBadListeners([C,n,k],l){const h=this._badListeners.get(C);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,C,n,l).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const d=this._badListeners.get(C);this._badListeners.set(C,d?d+1:1),typeof d=="number"&&d>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(C,n,k,l){const h=[],a=Date.now(),{document:d,reason:f}=l,{version:E}=d,w=Object.freeze({document:d,reason:f,waitUntil(u){if(Object.isFrozen(h))throw(0,F.illegalState)("waitUntil can not be called async");h.push(Promise.resolve(u))}});try{n.apply(k,[w])}catch(u){return Promise.reject(u)}return Object.freeze(h),new Promise((u,g)=>{const b=setTimeout(()=>g(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(b),u(t)}).catch(t=>{clearTimeout(b),g(t)})}).then(u=>{const g={edits:[]};for(const b of u)if(Array.isArray(b)&&b.every(t=>t instanceof D.TextEdit))for(const{newText:t,newEol:s,range:i}of b)g.edits.push({_type:2,resource:d.uri,edit:{range:i&&y.Range.from(i),text:t,eol:s&&y.EndOfLine.from(s)}});if(g.edits.length!==0)return E===d.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(g):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=S}),define(_e[173],ye([0,1,3,27,2,9,6]),function(ee,e,m,F,D,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{constructor(n,k,l,h,a){this._onDidCreate=new m.Emitter,this._onDidChange=new m.Emitter,this._onDidDelete=new m.Emitter,this._config=0,l&&(this._config+=1),h&&(this._config+=2),a&&(this._config+=4);const d=(0,F.parse)(k),f=n(E=>{if(!l)for(let w of E.created){const u=D.URI.revive(w);d(u.fsPath)&&this._onDidCreate.fire(u)}if(!h)for(let w of E.changed){const u=D.URI.revive(w);d(u.fsPath)&&this._onDidChange.fire(u)}if(!a)for(let w of E.deleted){const u=D.URI.revive(w);d(u.fsPath)&&this._onDidDelete.fire(u)}});this._disposable=I.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,f)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class _{constructor(n,k,l){this._logService=k,this._extHostDocumentsAndEditors=l,this._onFileSystemEvent=new m.Emitter,this._onDidRenameFile=new m.Emitter,this._onDidCreateFile=new m.Emitter,this._onDidDeleteFile=new m.Emitter,this._onWillRenameFile=new m.AsyncEmitter,this._onWillCreateFile=new m.AsyncEmitter,this._onWillDeleteFile=new m.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(n,k,l,h){return new S(this._onFileSystemEvent.event,n,k,l,h)}$onFileEvent(n){this._onFileSystemEvent.fire(n)}$onDidRunFileOperation(n,k){switch(n){case 2:this._onDidRenameFile.fire(Object.freeze({files:k.map(l=>({oldUri:D.URI.revive(l.source),newUri:D.URI.revive(l.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:k.map(l=>D.URI.revive(l.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:k.map(l=>D.URI.revive(l.target))}));break;default:}}getOnWillRenameFileEvent(n){return this._createWillExecuteEvent(n,this._onWillRenameFile)}getOnWillCreateFileEvent(n){return this._createWillExecuteEvent(n,this._onWillCreateFile)}getOnWillDeleteFileEvent(n){return this._createWillExecuteEvent(n,this._onWillDeleteFile)}_createWillExecuteEvent(n,k){return(l,h,a)=>{const d=function(E){l.call(h,E)};return d.extension=n,k.event(d,void 0,a)}}async $onWillRunFileOperation(n,k,l,h){switch(n){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:k.map(a=>({oldUri:D.URI.revive(a.source),newUri:D.URI.revive(a.target)}))},l,h);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:k.map(a=>D.URI.revive(a.target))},l,h);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:k.map(a=>D.URI.revive(a.target))},l,h)}}async _fireWillEvent(n,k,l,h){const a=new Set,d=[];if(await n.fireAsync(k,h,async(E,w)=>{const u=Date.now(),g=await Promise.resolve(E);g instanceof I.WorkspaceEdit&&(d.push(g),a.add(w.extension.displayName??w.extension.identifier.value)),Date.now()-u>l&&this._logService.warn("SLOW file-participant",w.extension.identifier)}),h.isCancellationRequested||d.length===0)return;const f={edits:[]};for(let E of d){let{edits:w}=y.WorkspaceEdit.from(E,this._extHostDocumentsAndEditors);f.edits=f.edits.concat(w)}return{edit:f,extensionNames:Array.from(a)}}}e.ExtHostFileSystemEventService=_}),define(_e[174],ye([0,1,11,24,2,9,6,69]),function(ee,e,m,F,D,y,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class _{constructor(l,h,a,d){this.start=l,this.deletedCount=h,this.deletedItems=a,this.items=d}static asApiEvents(l){return l.map(h=>({start:h.start,deletedCount:h.deletedCount,deletedItems:h.deletedItems,items:h.items.map(a=>a.apiCell)}))}}class C{constructor(l,h,a){this.notebook=l,this._extHostDocument=h,this._cellData=a,this.handle=a.handle,this.uri=D.URI.revive(a.uri),this.cellKind=a.cellKind,this._outputs=a.outputs.map(y.NotebookCellOutput.to),this._internalMetadata=a.internalMetadata??{},this._metadata=a.metadata??{},this._previousResult=y.NotebookCellExecutionSummary.to(a.internalMetadata??{})}static asModelAddData(l,h){return{EOL:h.eol,lines:h.source,modeId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:l}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const l=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return l.notebook.getCellIndex(l)},notebook:l.notebook.apiNotebook,kind:y.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get mime(){return l._mime},set mime(a){l._mime=a},get outputs(){return l._outputs.slice(0)},get metadata(){return l._metadata},get executionSummary(){return l._previousResult}})}return this._apiCell}setOutputs(l){this._outputs=l.map(y.NotebookCellOutput.to)}setOutputItems(l,h,a){const d=a.map(y.NotebookCellOutputItem.to),f=this._outputs.find(E=>E.id===l);f&&(h||(f.items.length=0),f.items.push(...d))}setMetadata(l){this._metadata=l}setInternalMetadata(l){this._internalMetadata=l,this._previousResult=y.NotebookCellExecutionSummary.to(l)}setMime(l){}}e.ExtHostCell=C;class n{constructor(l,h,a,d,f,E){this._proxy=l,this._textDocumentsAndEditors=h,this._textDocuments=a,this._emitter=d,this.uri=f,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=E.viewType,this._metadata=E.metadata??Object.create(null),this._spliceNotebookCells([[0,0,E.cells]],!0),this._versionId=E.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const l=this;this._notebook={get uri(){return l.uri},get version(){return l._versionId},get notebookType(){return l._notebookType},get isDirty(){return l._isDirty},get isUntitled(){return l.uri.scheme===m.Schemas.untitled},get isClosed(){return l._disposed},get metadata(){return l._metadata},get cellCount(){return l._cells.length},cellAt(h){return h=l._validateIndex(h),l._cells[h].apiCell},getCells(h){return(h?l._getCells(h):l._cells).map(d=>d.apiCell)},save(){return l._save()}}}return this._notebook}updateBackup(l){this._backup?.delete(),this._backup=l}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(l){l.metadata&&(this._metadata={...this._metadata,...l.metadata})}acceptDirty(l){this._isDirty=l}acceptModelChanged(l,h){this._versionId=l.versionId,this._isDirty=h;for(const a of l.rawEvents)a.kind===S.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1):a.kind===S.NotebookCellsChangeType.Move?this._moveCell(a.index,a.newIdx):a.kind===S.NotebookCellsChangeType.Output?this._setCellOutputs(a.index,a.outputs):a.kind===S.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems):a.kind===S.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(a.index,a.language):a.kind===S.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(a.index,a.mime):a.kind===S.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(a.index,a.metadata):a.kind===S.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(a.index,a.internalMetadata)}_validateIndex(l){return l=l|0,l<0?0:l>=this._cells.length?this._cells.length-1:l}_validateRange(l){let h=l.start|0,a=l.end|0;return h<0&&(h=0),a>this._cells.length&&(a=this._cells.length),l.with({start:h,end:a})}_getCells(l){l=this._validateRange(l);const h=[];for(let a=l.start;a<l.end;a++)h.push(this._cells[a]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(l,h){if(this._disposed)return;const a=[],d=[],f=[];l.reverse().forEach(E=>{const u=E[2].map(t=>{const s=new C(this,this._textDocumentsAndEditors,t);return h||d.push(C.asModelAddData(this.apiNotebook,t)),s}),g=new _(E[0],E[1],[],u),b=this._cells.splice(E[0],E[1],...u);for(const t of b)f.push(t.uri),g.deletedItems.push(t.apiCell);a.push(g)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:f}),h||this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(a)}))}_moveCell(l,h){const a=this._cells.splice(l,1);this._cells.splice(h,0,...a);const d=[new _(l,1,a.map(f=>f.apiCell),[]),new _(h,0,[],a)];this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(d)}))}_setCellOutputs(l,h){const a=this._cells[l];a.setOutputs(h),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[a.apiCell]}))}_setCellOutputItems(l,h,a,d){const f=this._cells[l];f.setOutputItems(h,a,d),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[f.apiCell]}))}_changeCellLanguage(l,h){const a=this._cells[l];a.apiCell.document.languageId!==h&&this._textDocuments.$acceptModelModeChanged(a.uri,h)}_changeCellMime(l,h){const a=this._cells[l];a.apiCell.mime=h}_changeCellMetadata(l,h){const a=this._cells[l],d=a.apiCell.metadata;a.setMetadata(h);const f=a.apiCell.metadata;(0,F.equals)(d,f)||this._emitter.emitCellMetadataChange((0,F.deepFreeze)({document:this.apiNotebook,cell:a.apiCell}))}_changeCellInternalMetadata(l,h){const a=this._cells[l],d=a.internalMetadata;if(a.setInternalMetadata(h),d.runState!==h.runState){const f=h.runState??I.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,F.deepFreeze)({document:this.apiNotebook,cell:a.apiCell,state:f}))}}getCellFromApiCell(l){return this._cells.find(h=>h.apiCell===l)}getCellFromIndex(l){return this._cells[l]}getCell(l){return this._cells.find(h=>h.handle===l)}getCellIndex(l){return this._cells.indexOf(l)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(_e[98],ye([0,1,6,9,12]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class y{constructor(_){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=_}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(_){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:_})}replaceCellMetadata(_,C){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:_,metadata:C})}replaceCells(_,C,n){this._throwIfFinalized(),!(_===C&&n.length===0)&&this._collectedEdits.push({editType:1,index:_,count:C-_,cells:n.map(F.NotebookCellData.from)})}}class I{constructor(_,C,n,k,l,h){this.id=_,this._proxy=C,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._visibleRanges=k,this._viewColumn=h}get apiEditor(){if(!this._editor){const _=this;this._editor={get document(){return _.notebookData.apiNotebook},get selections(){return _._selections},set selections(C){if(!Array.isArray(C)||!C.every(m.NotebookRange.isNotebookRange))throw(0,D.illegalArgument)("selections");_._selections=C,_._trySetSelections(C)},get visibleRanges(){return _._visibleRanges},revealRange(C,n){_._proxy.$tryRevealRange(_.id,F.NotebookRange.from(C),n??m.NotebookEditorRevealType.Default)},get viewColumn(){return _._viewColumn},edit(C){const n=new y(this.document.version);return C(n),_._applyEdit(n.finalize())},setDecorations(C,n){return _.setDecorations(C,n)}},I.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(_){this._visible=_}_acceptVisibleRanges(_){this._visibleRanges=_}_acceptSelections(_){this._selections=_}_trySetSelections(_){this._proxy.$trySetSelections(this.id,_.map(F.NotebookRange.from))}_acceptViewColumn(_){this._viewColumn=_}_applyEdit(_){if(_.cellEdits.length===0)return Promise.resolve(!0);const C=[];let n=-1;for(let k=0;k<_.cellEdits.length;k++){if(n<0){C.push(_.cellEdits[k]),n++;continue}const h=C[n],a=_.cellEdits[k];if(h.editType===1&&a.editType===1&&h.index===a.index){h.cells.push(..._.cellEdits[k].cells),h.count+=_.cellEdits[k].count;continue}C.push(_.cellEdits[k]),n++}return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,C)}setDecorations(_,C){if(!(C.isEmpty&&!this._hasDecorationsForKey.has(_.key)))return C.isEmpty?this._hasDecorationsForKey.delete(_.key):this._hasDecorationsForKey.add(_.key),this._proxy.$trySetDecorations(this.id,F.NotebookRange.from(C),_.key)}}e.ExtHostNotebookEditor=I,I.apiEditorsToExtHost=new WeakMap}),define(_e[175],ye([0,1,9,151,131,18,48]),function(ee,e,m,F,D,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(k){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=k}withProgress(k,l,h){const a=this._handles++,{title:d,location:f,cancellable:E}=l,w={label:(0,D.localize)(0,null,k.displayName||k.name),id:k.identifier.value};return this._proxy.$startProgress(a,{location:m.ProgressLocation.from(f),title:d,source:w,cancellable:E},k),this._withProgress(a,h,!!E)}_withProgress(k,l,h){let a;h&&(a=new y.CancellationTokenSource,this._mapHandleToCancellationSource.set(k,a));const d=E=>{this._proxy.$progressEnd(E),this._mapHandleToCancellationSource.delete(E),a&&a.dispose()};let f;try{f=l(new C(this._proxy,k),h&&a?a.token:y.CancellationToken.None)}catch(E){throw d(k),E}return f.then(E=>d(k),E=>d(k)),f}$acceptProgressCanceled(k){const l=this._mapHandleToCancellationSource.get(k);l&&(l.cancel(),this._mapHandleToCancellationSource.delete(k))}}e.ExtHostProgress=S;function _(n,k){return n.message=k.message,typeof k.increment=="number"&&(typeof n.increment=="number"?n.increment+=k.increment:n.increment=k.increment),n}class C extends F.Progress{constructor(k,l){super(h=>this.throttledReport(h));this._proxy=k,this._handle=l}throttledReport(k){this._proxy.$progressReport(this._handle,k)}}ze([(0,I.throttle)(100,(n,k)=>_(n,k),()=>Object.create(null))],C.prototype,"throttledReport",null)}),define(_e[99],ye([0,1,39,12,50,9,6]),function(ee,e,m,F,D,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class S{constructor(l,h,a){const d=S._Keys.nextId();l.$registerTextEditorDecorationType(h.identifier,d,y.DecorationRenderOptions.from(a)),this.value=Object.freeze({key:d,dispose(){l.$removeTextEditorDecorationType(d)}})}}e.TextEditorDecorationType=S,S._Keys=new D.IdGenerator("TextEditorDecorationType");class _{constructor(l,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,h){this._throwIfFinalized();let a=null;if(l instanceof I.Position)a=new I.Range(l,l);else if(l instanceof I.Range)a=l;else throw new Error("Unrecognized location");this._pushEdit(a,h,!1)}insert(l,h){this._throwIfFinalized(),this._pushEdit(new I.Range(l,l),h,!0)}delete(l){this._throwIfFinalized();let h=null;if(l instanceof I.Range)h=l;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(l,h,a){const d=this._document.validateRange(l);this._collectedEdits.push({range:d,text:h,forceMoveMarkers:a})}setEndOfLine(l){if(this._throwIfFinalized(),l!==I.EndOfLine.LF&&l!==I.EndOfLine.CRLF)throw(0,F.illegalArgument)("endOfLine");this._setEndOfLine=l}}e.TextEditorEdit=_;class C{constructor(l,h,a,d){this._proxy=l,this._id=h,this._accept(a),this._logService=d;const f=this;this.value={get tabSize(){return f._tabSize},set tabSize(E){f._setTabSize(E)},get insertSpaces(){return f._insertSpaces},set insertSpaces(E){f._setInsertSpaces(E)},get cursorStyle(){return f._cursorStyle},set cursorStyle(E){f._setCursorStyle(E)},get lineNumbers(){return f._lineNumbers},set lineNumbers(E){f._setLineNumbers(E)}}}_accept(l){this._tabSize=l.tabSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=y.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const h=Math.floor(l);return h>0?h:null}if(typeof l=="string"){const h=parseInt(l,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(l){const h=this._validateTabSize(l);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:Boolean(l)}_setInsertSpaces(l){const h=this._validateInsertSpaces(l);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:y.TextEditorLineNumbersStyle.from(l)})))}assign(l){const h={};let a=!1;if(typeof l.tabSize!="undefined"){const d=this._validateTabSize(l.tabSize);d==="auto"?(a=!0,h.tabSize=d):typeof d=="number"&&this._tabSize!==d&&(this._tabSize=d,a=!0,h.tabSize=d)}if(typeof l.insertSpaces!="undefined"){const d=this._validateInsertSpaces(l.insertSpaces);d==="auto"?(a=!0,h.insertSpaces=d):this._insertSpaces!==d&&(this._insertSpaces=d,a=!0,h.insertSpaces=d)}typeof l.cursorStyle!="undefined"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,a=!0,h.cursorStyle=l.cursorStyle),typeof l.lineNumbers!="undefined"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,a=!0,h.lineNumbers=y.TextEditorLineNumbersStyle.from(l.lineNumbers)),a&&this._warnOnError(this._proxy.$trySetOptions(this._id,h))}_warnOnError(l){l.catch(h=>this._logService.warn(h))}}e.ExtHostTextEditorOptions=C;class n{constructor(l,h,a,d,f,E,w,u){this.id=l,this._proxy=h,this._logService=a,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=f,this._options=new C(this._proxy,this.id,E,a),this._visibleRanges=w,this._viewColumn=u;const g=this;this.value=Object.freeze({get document(){return d.getValue()},set document(b){throw(0,F.readonly)("document")},get selection(){return g._selections&&g._selections[0]},set selection(b){if(!(b instanceof I.Selection))throw(0,F.illegalArgument)("selection");g._selections=[b],g._trySetSelection()},get selections(){return g._selections},set selections(b){if(!Array.isArray(b)||b.some(t=>!(t instanceof I.Selection)))throw(0,F.illegalArgument)("selections");g._selections=b,g._trySetSelection()},get visibleRanges(){return g._visibleRanges},set visibleRanges(b){throw(0,F.readonly)("visibleRanges")},get options(){return g._options.value},set options(b){g._disposed||g._options.assign(b)},get viewColumn(){return g._viewColumn},set viewColumn(b){throw(0,F.readonly)("viewColumn")},edit(b,t={undoStopBefore:!0,undoStopAfter:!0}){if(g._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new _(d.getValue(),t);return b(s),g._applyEdit(s)},insertSnippet(b,t,s={undoStopBefore:!0,undoStopAfter:!0}){if(g._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!t||Array.isArray(t)&&t.length===0)i=g._selections.map(r=>y.Range.from(r));else if(t instanceof I.Position){const{lineNumber:r,column:c}=y.Position.from(t);i=[{startLineNumber:r,startColumn:c,endLineNumber:r,endColumn:c}]}else if(t instanceof I.Range)i=[y.Range.from(t)];else{i=[];for(const r of t)if(r instanceof I.Range)i.push(y.Range.from(r));else{const{lineNumber:c,column:p}=y.Position.from(r);i.push({startLineNumber:c,startColumn:p,endLineNumber:c,endColumn:p})}}return h.$tryInsertSnippet(l,b.value,i,s)},setDecorations(b,t){const s=t.length===0;s&&!g._hasDecorationsForKey.has(b.key)||(s?g._hasDecorationsForKey.delete(b.key):g._hasDecorationsForKey.add(b.key),g._runOnProxy(()=>{if(y.isDecorationOptionsArr(t))return h.$trySetDecorations(l,b.key,y.fromRangeOrRangeWithMessage(t));{const i=new Array(4*t.length);for(let r=0,c=t.length;r<c;r++){const p=t[r];i[4*r]=p.start.line+1,i[4*r+1]=p.start.character+1,i[4*r+2]=p.end.line+1,i[4*r+3]=p.end.character+1}return h.$trySetDecorationsFast(l,b.key,i)}}))},revealRange(b,t){g._runOnProxy(()=>h.$tryRevealRange(l,y.Range.from(b),t||I.TextEditorRevealType.Default))},show(b){h.$tryShowEditor(l,y.ViewColumn.from(b))},hide(){h.$tryHideEditor(l)}})}dispose(){(0,m.ok)(!this._disposed),this._disposed=!0}_acceptOptions(l){(0,m.ok)(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){(0,m.ok)(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){(0,m.ok)(!this._disposed),this._viewColumn=l}_acceptSelections(l){(0,m.ok)(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(y.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const h=l.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const a=h.edits.map(f=>f.range);a.sort((f,E)=>f.end.line===E.end.line?f.end.character===E.end.character?f.start.line===E.start.line?f.start.character-E.start.character:f.start.line-E.start.line:f.end.character-E.end.character:f.end.line-E.end.line);for(let f=0,E=a.length-1;f<E;f++){const w=a[f].end;if(a[f+1].start.isBefore(w))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=h.edits.map(f=>({range:y.Range.from(f.range),text:f.text,forceMoveMarkers:f.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,d,{setEndOfLine:typeof h.setEndOfLine=="number"?y.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=n}),define(_e[176],ye([0,1,134,25,2,3,7,16,6,10,17,9,18]),function(ee,e,m,F,D,y,I,S,_,C,n,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(f,E){if((0,C.isString)(f))return{label:f};if(f&&typeof f=="object"&&typeof f.label=="string"){let w;return Array.isArray(f.highlights)&&(w=f.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),w=w.length?w:void 0),{label:f.label,highlights:w}}}class a{constructor(E,w,u){this._proxy=E,this.commands=w,this.logService=u,this.treeViews=new Map;function g(b){return b&&b.$treeViewId&&b.$treeItemHandle}w.registerArgumentProcessor({processArgument:b=>g(b)?this.convertArgument(b):Array.isArray(b)&&b.length>0?b.map(t=>g(t)?this.convertArgument(t):t):b})}registerTreeDataProvider(E,w,u){const g=this.createTreeView(E,{treeDataProvider:w},u);return{dispose:()=>g.dispose()}}createTreeView(E,w,u){if(!w||!w.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const g=w.dragAndDropController!==void 0,b=this._proxy.$registerTreeViewDataProvider(E,{showCollapseAll:!!w.showCollapseAll,canSelectMany:!!w.canSelectMany,canDragAndDrop:g}),t=this.createExtHostTreeView(E,w,u);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(s){t.message=s},get title(){return t.title},set title(s){t.title=s},get description(){return t.description},set description(s){t.description=s},reveal:(s,i)=>t.reveal(s,i),dispose:async()=>{await b,this.treeViews.delete(E),t.dispose()}}}$getChildren(E,w){const u=this.treeViews.get(E);return u?u.getChildren(w):Promise.reject(new Error((0,m.localize)(0,null,E)))}$onDrop(E,w,u){const g=this.treeViews.get(E);return g?g.onDrop(w,u):Promise.reject(new Error((0,m.localize)(1,null,E)))}async $hasResolve(E){const w=this.treeViews.get(E);if(!w)throw new Error((0,m.localize)(2,null,E));return w.hasResolve}$resolve(E,w,u){const g=this.treeViews.get(E);if(!g)throw new Error((0,m.localize)(3,null,E));return g.resolveTreeItem(w,u)}$setExpanded(E,w,u){const g=this.treeViews.get(E);if(!g)throw new Error((0,m.localize)(4,null,E));g.setExpanded(w,u)}$setSelection(E,w){const u=this.treeViews.get(E);if(!u)throw new Error((0,m.localize)(5,null,E));u.setSelection(w)}$setVisible(E,w){const u=this.treeViews.get(E);if(!u)throw new Error((0,m.localize)(6,null,E));u.setVisible(w)}createExtHostTreeView(E,w,u){const g=new d(E,w,this._proxy,this.commands.converter,this.logService,u);return this.treeViews.set(E,g),g}convertArgument(E){const w=this.treeViews.get(E.$treeViewId);return w?w.getExtensionElement(E.$treeItemHandle):null}}e.ExtHostTreeViews=a;class d extends I.Disposable{constructor(E,w,u,g,b,t){super();if(this.viewId=E,this.proxy=u,this.commands=g,this.logService=b,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new l.CancellationTokenSource,t.contributes&&t.contributes.views)for(const r in t.contributes.views)for(const c of t.contributes.views[r])c.id===E&&(this._title=c.name);this.dataProvider=w.treeDataProvider,this.dndController=w.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(r=>this._onDidChangeData.fire({message:!1,element:r}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let s,i;this._register(y.Event.debounce(this._onDidChangeData.event,(r,c)=>(r||(r={message:!1,elements:[]}),c.element!==!1&&(s||(s=new Promise(p=>i=p),this.refreshPromise=this.refreshPromise.then(()=>s)),Array.isArray(c.element)?r.elements.push(...c.element):r.elements.push(c.element)),c.message&&(r.message=!0),r),200,!0)(({message:r,elements:c})=>{c.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const p=i;return s=null,this.refresh(c).then(()=>p())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(E=>this.getExtensionElement(E)).filter(E=>!(0,C.isUndefinedOrNull)(E))}getChildren(E){const w=E?this.getExtensionElement(E):void 0;if(E&&!w)return this.logService.error(`No tree item with id '${E}' found.`),Promise.resolve([]);const u=this.getChildrenNodes(E);return(u?Promise.resolve(u):this.fetchChildrenNodes(w)).then(g=>g.map(b=>b.item))}getExtensionElement(E){return this.elements.get(E)}reveal(E,w){w=w||{select:!0,focus:!1};const u=(0,C.isUndefinedOrNull)(w.select)?!0:w.select,g=(0,C.isUndefinedOrNull)(w.focus)?!1:w.focus,b=(0,C.isUndefinedOrNull)(w.expand)?!1:w.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):E?this.refreshPromise.then(()=>this.resolveUnknownParentChain(E)).then(t=>this.resolveTreeNode(E,t[t.length-1]).then(s=>this.proxy.$reveal(this.viewId,{item:s.item,parentChain:t.map(i=>i.item)},{select:u,focus:g,expand:b})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:u,focus:g,expand:b})}get message(){return this._message}set message(E){this._message=E,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(E){this._title=E,this.proxy.$setTitle(this.viewId,E,this._description)}get description(){return this._description}set description(E){this._description=E,this.proxy.$setTitle(this.viewId,this._title,E)}setExpanded(E,w){const u=this.getExtensionElement(E);u&&(w?this._onDidExpandElement.fire(Object.freeze({element:u})):this._onDidCollapseElement.fire(Object.freeze({element:u})))}setSelection(E){(0,n.equals)(this._selectedHandles,E)||(this._selectedHandles=E,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(E){E!==this._visible&&(this._visible=E,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(E,w){const u=E.map(b=>this.getExtensionElement(b)).filter(b=>!(0,C.isUndefinedOrNull)(b)),g=this.getExtensionElement(w);return u&&g?(0,S.asPromise)(()=>this.dndController?.onDrop(u,g)):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(E,w){if(!this.dataProvider.resolveTreeItem)return;const u=this.elements.get(E);if(u){const g=this.nodes.get(u);if(g){const b=await this.dataProvider.resolveTreeItem(g.extensionItem,u,w)??g.extensionItem;return g.item.tooltip=this.getTooltip(b.tooltip),g.item.command=this.getCommand(g.disposableStore,b.command),g.item}}}resolveUnknownParentChain(E){return this.resolveParent(E).then(w=>w?this.resolveUnknownParentChain(w).then(u=>this.resolveTreeNode(w,u[u.length-1]).then(g=>(u.push(g),u))):Promise.resolve([]))}resolveParent(E){const w=this.nodes.get(E);return w?Promise.resolve(w.parent?this.elements.get(w.parent.item.handle):void 0):(0,S.asPromise)(()=>this.dataProvider.getParent(E))}resolveTreeNode(E,w){const u=this.nodes.get(E);return u?Promise.resolve(u):(0,S.asPromise)(()=>this.dataProvider.getTreeItem(E)).then(g=>this.createHandle(E,g,w,!0)).then(g=>this.getChildren(w?w.item.handle:void 0).then(()=>{const b=this.getExtensionElement(g);if(b){const t=this.nodes.get(b);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${g}`)}))}getChildrenNodes(E){if(E){let w;if(typeof E=="string"){const u=this.getExtensionElement(E);w=u?this.nodes.get(u):void 0}else w=E;return w&&w.children||null}return this.roots}async fetchChildrenNodes(E){this.clearChildren(E);const w=new l.CancellationTokenSource(this._refreshCancellationSource.token);try{const u=E?this.nodes.get(E):void 0,g=await this.dataProvider.getChildren(E);if(w.token.isCancellationRequested)return[];const b=await Promise.all((0,n.coalesce)(g||[]).map(async t=>{const s=await this.dataProvider.getTreeItem(t);return s&&!w.token.isCancellationRequested?this.createAndRegisterTreeNode(t,s,u):null}));return w.token.isCancellationRequested?[]:(0,n.coalesce)(b)}finally{w.dispose()}}refresh(E){if(E.some(u=>!u))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new l.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const u=this.getHandlesToRefresh(E);if(u.length)return this.refreshHandles(u)}return Promise.resolve(void 0)}getHandlesToRefresh(E){const w=new Set,u=E.map(b=>this.nodes.get(b));for(const b of u)if(b&&!w.has(b.item.handle)){let t=b;for(;t&&t.parent&&u.findIndex(s=>t&&t.parent&&s&&s.item.handle===t.parent.item.handle)===-1;){const s=this.elements.get(t.parent.item.handle);t=s?this.nodes.get(s):void 0}t&&!t.parent&&w.add(b.item.handle)}const g=[];return w.forEach(b=>{const t=this.elements.get(b);if(t){const s=this.nodes.get(t);s&&(!s.parent||!w.has(s.parent.item.handle))&&g.push(b)}}),g}refreshHandles(E){const w={};return Promise.all(E.map(u=>this.refreshNode(u).then(g=>{g&&(w[u]=g.item)}))).then(()=>Object.keys(w).length?this.proxy.$refresh(this.viewId,w):void 0)}refreshNode(E){const w=this.getExtensionElement(E);if(w){const u=this.nodes.get(w);if(u)return this.clearChildren(w),(0,S.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(g=>{if(g){const b=this.createTreeNode(w,g,u.parent);return this.updateNodeCache(w,b,u,u.parent),u.dispose(),b}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(E,w,u){const g=this.createTreeNode(E,w,u);if(w.id&&this.elements.has(g.item.handle))throw new Error((0,m.localize)(7,null,w.id));return this.addNodeToCache(E,g),this.addNodeToParentCache(g,u),g}getTooltip(E){return _.MarkdownString.isMarkdownString(E)?k.MarkdownString.from(E):E}getCommand(E,w){return w?this.commands.toInternal(w,E):void 0}createTreeNode(E,w,u){const g=new I.DisposableStore,b=this.createHandle(E,w,u),t=this.getLightIconPath(w);return{item:{handle:b,parentHandle:u?u.item.handle:void 0,label:h(w.label,this.extension),description:w.description,resourceUri:w.resourceUri,tooltip:this.getTooltip(w.tooltip),command:this.getCommand(g,w.command),contextValue:w.contextValue,icon:t,iconDark:this.getDarkIconPath(w)||t,themeIcon:this.getThemeIcon(w),collapsibleState:(0,C.isUndefinedOrNull)(w.collapsibleState)?_.TreeItemCollapsibleState.None:w.collapsibleState,accessibilityInformation:w.accessibilityInformation},extensionItem:w,parent:u,children:void 0,disposableStore:g,dispose(){g.dispose()}}}getThemeIcon(E){return E.iconPath instanceof _.ThemeIcon?E.iconPath:void 0}createHandle(E,{id:w,label:u,resourceUri:g},b,t){if(w)return`${d.ID_HANDLE_PREFIX}/${w}`;const s=h(u,this.extension),i=b?b.item.handle:d.LABEL_HANDLE_PREFIX;let r=s?s.label:g?(0,F.basename)(g):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const c=this.nodes.has(E)?this.nodes.get(E).item.handle:void 0,p=this.getChildrenNodes(b)||[];let v,A=0;do{if(v=`${i}/${A}:${r}`,t||!this.elements.has(v)||c===v)break;A++}while(A<=p.length);return v}getLightIconPath(E){if(E.iconPath&&!(E.iconPath instanceof _.ThemeIcon))return typeof E.iconPath=="string"||D.URI.isUri(E.iconPath)?this.getIconPath(E.iconPath):this.getIconPath(E.iconPath.light)}getDarkIconPath(E){if(E.iconPath&&!(E.iconPath instanceof _.ThemeIcon)&&E.iconPath.dark)return this.getIconPath(E.iconPath.dark)}getIconPath(E){return D.URI.isUri(E)?E:D.URI.file(E)}addNodeToCache(E,w){this.elements.set(w.item.handle,E),this.nodes.set(E,w)}updateNodeCache(E,w,u,g){this.elements.delete(w.item.handle),this.nodes.delete(E),w.item.handle!==u.item.handle&&this.elements.delete(u.item.handle),this.addNodeToCache(E,w);const b=this.getChildrenNodes(g)||[],t=b.filter(s=>s.item.handle===u.item.handle)[0];t&&b.splice(b.indexOf(t),1,w)}addNodeToParentCache(E,w){w?(w.children||(w.children=[]),w.children.push(E)):(this.roots||(this.roots=[]),this.roots.push(E))}clearChildren(E){if(E){const w=this.nodes.get(E);if(w){if(w.children)for(const u of w.children){const g=this.elements.get(u.item.handle);g&&this.clear(g)}w.children=void 0}}else this.clearAll()}clear(E){const w=this.nodes.get(E);if(w){if(w.children)for(const u of w.children){const g=this.elements.get(u.item.handle);g&&this.clear(g)}this.nodes.delete(E),this.elements.delete(w.item.handle),w.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(E=>E.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}d.LABEL_HANDLE_PREFIX="0",d.ID_HANDLE_PREFIX="1"}),define(_e[177],ye([0,1,16,3,7,10,65,9,96]),function(ee,e,m,F,D,y,I,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=void 0;var C;(function(l){l[l.Disconnected=0]="Disconnected",l[l.IsChild=1]="IsChild",l[l.IsParent=2]="IsParent",l[l.IsSame=3]="IsSame"})(C=e.TestPosition||(e.TestPosition={}));class n{constructor(){this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(h){if(this.map.has(h.actual.id))throw new Error(`Attempted to insert a duplicate test item ID ${h.actual.id}`);this.map.set(h.actual.id,h),h.parent||this._roots.add(h)}has(h){return this.map.has(h)}delete(h){const a=this.map.get(h);return a?(this.map.delete(h),this._roots.delete(a),!0):!1}get(h){return this.map.get(h)}comparePositions(h,a){const d=typeof h=="string"?this.map.get(h):h,f=typeof a=="string"?this.map.get(a):a;if(!d||!f)return 0;if(d===f)return 3;for(let E=this.map.get(f.parent);E;E=this.map.get(E.parent))if(E===d)return 1;for(let E=this.map.get(d.parent);E;E=this.map.get(E.parent))if(E===f)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=n;class k extends D.Disposable{constructor(h){super();this.controllerId=h,this.debounceSendDiff=this._register(new m.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new F.Emitter),this.root=new I.TestItemImpl(`${this.controllerId}Root`,this.controllerId,void 0),this.tree=new n,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.upsertItem(this.root,null)}set resolveHandler(h){this._resolveHandler=h;for(const a of this.tree)this.updateExpandability(a)}collectDiff(){const h=this.diff;return this.diff=[],h}pushDiff(h){const a=this.diff[this.diff.length-1];if(a&&h[0]===1){if(a[0]===1&&a[1].extId===h[1].extId){(0,_.applyTestItemUpdate)(a[1],h[1]);return}if(a[0]===0&&a[1].item.extId===h[1].extId){(0,_.applyTestItemUpdate)(a[1],h[1]);return}}this.diff.push(h),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(h,a){const d=this.tree.get(h);if(!!d){if((d.expandLevels===void 0||a>d.expandLevels)&&(d.expandLevels=a),d.expand===1){const f=this.resolveChildren(d);return f.isOpen()?this.expandChildren(d,a-1):f.wait().then(()=>this.expandChildren(d,a-1))}else if(d.expand===3)return d.resolveBarrier?.isOpen()===!1?d.resolveBarrier.wait().then(()=>this.expandChildren(d,a-1)):this.expandChildren(d,a-1)}}dispose(){for(const h of this.tree)(0,I.getPrivateApiFor)(h.actual).listener=void 0;this.diff=[],super.dispose()}onTestItemEvent(h,a){const d=h?.actual.id;switch(a.op){case 2:this.pushDiff([4,d]);break;case 1:this.removeItem(a.id);break;case 0:this.upsertItem(a.item,h);break;case 4:for(const w of a.ops)this.onTestItemEvent(h,w);break;case 3:const{key:f,value:E}=a;switch(f){case"canResolveChildren":this.updateExpandability(h);break;case"range":this.pushDiff([1,{extId:d,item:{range:S.Range.from(E)}}]);break;case"error":this.pushDiff([1,{extId:d,item:{error:S.MarkdownString.fromStrict(E)||null}}]);break;default:this.pushDiff([1,{extId:d,item:{[f]:E??null}}]);break}break;default:(0,y.assertNever)(a)}}upsertItem(h,a){if(!(h instanceof I.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${h.id} did not`);let d=this.tree.get(h.id);if(d&&d.parent!==a?.actual.id&&((d.actual.parent??this.root).children.remove(h.id),d=void 0),!d){const u=a?a.actual.id:null,g=a?a.expandLevels:1;d={actual:h,parent:u,expandLevels:g?g-1:void 0,expand:0},this.tree.add(d),this.pushDiff([0,{parent:u,controllerId:this.controllerId,expand:d.expand,item:S.TestItem.from(h)}]),this.connectItemAndChildren(h,d,a);return}if(d.actual===h){this.connectItem(h,d,a);return}const f=d.actual.children.all,E=d.actual,w=(0,I.diffTestItems)(E,h);(0,I.getPrivateApiFor)(E).listener=void 0,d.actual=h,d.expand=0;for(const[u,g]of w)this.onTestItemEvent(d,{op:3,key:u,value:g});this.connectItemAndChildren(h,d,a);for(const u of f)!h.children.get(u.id)&&this.tree.get(u.id)?.parent===h.id&&this.removeItem(u.id)}connectItem(h,a,d){const f=(0,I.getPrivateApiFor)(h);f.parent=d&&d.actual!==this.root?d.actual:void 0,f.listener=E=>this.onTestItemEvent(a,E),this.updateExpandability(a)}connectItemAndChildren(h,a,d){this.connectItem(h,a,d);for(const f of h.children.all)this.upsertItem(f,a)}updateExpandability(h){let a;this._resolveHandler?h.resolveBarrier?a=h.resolveBarrier.isOpen()?3:2:a=h.actual.canResolveChildren?1:0:a=0,a!==h.expand&&(h.expand=a,this.pushDiff([1,{extId:h.actual.id,expand:a}]),a===1&&h.expandLevels!==void 0&&this.resolveChildren(h))}expandChildren(h,a){if(a<0)return;const d=h.actual.children.all.map(f=>this.expand(f.id,a)).filter(m.isThenable);if(d.length)return Promise.all(d).then(()=>{})}resolveChildren(h){if(h.resolveBarrier)return h.resolveBarrier;if(!this._resolveHandler){const f=new m.Barrier;return f.open(),f}h.expand=2,this.pushExpandStateUpdate(h);const a=h.resolveBarrier=new m.Barrier;let d;try{d=this._resolveHandler(h.actual)}catch(f){h.actual.error=f.stack||f.message}return(0,m.isThenable)(d)?d.catch(f=>h.actual.error=f.stack||f.message).then(()=>{a.open(),this.updateExpandability(h)}):(a.open(),this.updateExpandability(h)),h.resolveBarrier}pushExpandStateUpdate(h){this.pushDiff([1,{extId:h.actual.id,expand:h.expand}])}removeItem(h){const a=this.tree.get(h);if(!a)throw new Error("attempting to remove non-existent child");this.pushDiff([2,h]);const d=[a];for(;d.length;){const f=d.pop();if(!!f){(0,I.getPrivateApiFor)(f.actual).listener=void 0,this.tree.delete(f.actual.id);for(const E of f.actual.children.all)d.push(this.tree.get(E.id))}}}flushDiff(){const h=this.collectDiff();h.length&&this.diffOpEmitter.fire(h)}}e.SingleUseTestCollection=k}),define(_e[178],ye([0,1,4,146]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,m.refineServiceDecorator)(F.IEnvironmentService)}),define(_e[179],ye([0,1,26,3,14]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class y{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=y;class I{constructor(n){this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(m.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(m.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let k of n.activationEvents)k==="onUri"&&(k=`onUri:${m.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(k)||this._activationMap.set(k,[]),this._activationMap.get(k).push(n)}}keepOnly(n){const k=new Set;n.forEach(l=>k.add(m.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>k.has(m.ExtensionIdentifier.toKey(l.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,k){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const l=I._findLoopingExtensions(this._extensionDescriptions);if(k=k.concat(l.map(h=>h.identifier)),k.length>0){const h=new Set;k.forEach(a=>h.add(m.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>!h.has(m.ExtensionIdentifier.toKey(a.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new y(l)}static _findLoopingExtensions(n){const k=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(f){this._nodesSet.has(f)||(this._nodesSet.add(f),this._nodesArr.push(f))}addArc(f,E){this.addNode(f),this.addNode(E),this._arcs.has(f)?this._arcs.get(f).push(E):this._arcs.set(f,[E])}getArcs(f){return this._arcs.has(f)?this._arcs.get(f):[]}hasOnlyGoodArcs(f,E){const w=k.getArcs(f);for(let u=0;u<w.length;u++)if(!E.has(w[u]))return!1;return!0}getNodes(){return this._nodesArr}};let l=new Map;for(let f of n){const E=m.ExtensionIdentifier.toKey(f.identifier);if(l.set(E,f),f.extensionDependencies)for(let w of f.extensionDependencies){const u=m.ExtensionIdentifier.toKey(w);k.addArc(E,u)}}let h=new Set;k.getNodes().filter(f=>k.getArcs(f).length===0).forEach(f=>h.add(f));let a=k.getNodes().filter(f=>!h.has(f)),d;do{d=!1;for(let f=0;f<a.length;f++){const E=a[f];k.hasOnlyGoodArcs(E,h)&&(a.splice(f,1),f--,h.add(E),d=!0)}}while(d);return a.map(f=>l.get(f))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(m.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const k=this._activationMap.get(n);return k?k.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const k=this._extensionsMap.get(m.ExtensionIdentifier.toKey(n));return k||void 0}}e.ExtensionDescriptionRegistry=I;var S;(function(C){C[C.Builtin=0]="Builtin",C[C.User=1]="User",C[C.Dev=2]="Dev"})(S||(S={}));function _(C,n){const k=C.isBuiltin?0:C.isUnderDevelopment?2:1,l=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(k!==l)return k-l;const h=D.posix.basename(C.extensionLocation.path),a=D.posix.basename(n.extensionLocation.path);return h<a?-1:h>a?1:0}}),define(_e[180],ye([0,1,23]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var F;(function(S){S[S.VersionMismatch=55]="VersionMismatch",S[S.UnexpectedError=81]="UnexpectedError"})(F=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var D;(function(S){S[S.Initialized=0]="Initialized",S[S.Ready=1]="Ready",S[S.Terminate=2]="Terminate"})(D=e.MessageType||(e.MessageType={}));function y(S){const _=m.VSBuffer.alloc(1);switch(S){case 0:_.writeUInt8(1,0);break;case 1:_.writeUInt8(2,0);break;case 2:_.writeUInt8(3,0);break}return _}e.createMessageOfType=y;function I(S,_){if(S.byteLength!==1)return!1;switch(S.readUInt8(0)){case 1:return _===0;case 2:return _===1;case 3:return _===2;default:return!1}}e.isMessageOfType=I}),define(_e[29],ye([0,1,3,2,4,26,147]),function(ee,e,m,F,D,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new y.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");class S{constructor(w){this.dependency=w}}e.MissingExtensionDependency=S;var _;(function(E){E[E.LocalProcess=0]="LocalProcess",E[E.LocalWebWorker=1]="LocalWebWorker",E[E.Remote=2]="Remote"})(_=e.ExtensionHostKind||(e.ExtensionHostKind={}));class C{constructor(w,u,g,b){this.codeLoadingTime=w,this.activateCallTime=u,this.activateResolvedTime=g,this.activationReason=b}}e.ActivationTimes=C;class n{constructor(w,u){this.description=w,this.value=u}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var k;(function(E){E[E.Normal=0]="Normal",E[E.Immediate=1]="Immediate"})(k=e.ActivationKind||(e.ActivationKind={}));function l(E){E.enableProposedApi||h(E)}e.checkProposedApiEnabled=l;function h(E){throw new Error(`[${E.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${E.identifier.value}`)}e.throwProposedApiError=h;function a(E){return{type:E.isBuiltin?0:1,isBuiltin:E.isBuiltin||E.isUserBuiltin,identifier:{id:(0,I.getGalleryExtensionId)(E.publisher,E.name),uuid:E.uuid},manifest:E,location:E.extensionLocation}}e.toExtension=a;function d(E,w){return{identifier:new y.ExtensionIdentifier(E.identifier.id),isBuiltin:E.type===0,isUserBuiltin:E.type===1&&E.isBuiltin,isUnderDevelopment:!!w,extensionLocation:E.location,...E.manifest,uuid:E.identifier.uuid}}e.toExtensionDescription=d;class f{constructor(){this.onDidRegisterExtensions=m.Event.None,this.onDidChangeExtensionsStatus=m.Event.None,this.onDidChangeExtensions=m.Event.None,this.onWillActivateByEvent=m.Event.None,this.onDidChangeResponsiveChange=m.Event.None}activateByEvent(w){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(w){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(w){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(w){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(w,u){return Promise.resolve()}_onWillActivateExtension(w){}_onDidActivateExtension(w,u,g,b,t){}_onDidActivateExtensionError(w,u){}_onExtensionRuntimeError(w,u){}_onExtensionHostExit(w){}}e.NullExtensionService=f}),define(_e[181],ye([0,1,26,29,15]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const y=Promise.resolve(void 0);class I{constructor(a,d,f,E){this.startup=a,this.codeLoadingTime=d,this.activateCallTime=f,this.activateResolvedTime=E}}e.ExtensionActivationTimes=I,I.NONE=new I(!1,-1,-1,-1);class S{constructor(a){this._startup=a,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(a,d){return a===-1||d===-1?-1:d-a}build(){return new I(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class _{constructor(a,d,f,E,w,u){this.activationFailed=a,this.activationFailedError=d,this.activationTimes=f,this.module=E,this.exports=w,this.subscriptions=u}}e.ActivatedExtension=_;class C extends _{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=C;class n extends _{constructor(){super(!1,null,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class k extends _{constructor(a){super(!0,a,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=k;let l=class{constructor(a,d,f,E,w){this._logService=w,this._registry=a,this._resolvedExtensionsSet=new Set,d.forEach(u=>this._resolvedExtensionsSet.add(m.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,f.forEach(u=>this._hostExtensionsMap.set(m.ExtensionIdentifier.toKey(u),u)),this._host=E,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(a){const d=m.ExtensionIdentifier.toKey(a);return this._activatedExtensions.has(d)}getActivatedExtension(a){const d=m.ExtensionIdentifier.toKey(a),f=this._activatedExtensions.get(d);if(!f)throw new Error("Extension `"+a.value+"` is not known or not activated");return f}activateByEvent(a,d){if(this._alreadyActivatedEvents[a])return y;const f=this._registry.getExtensionDescriptionsForActivationEvent(a);return this._activateExtensions(f.map(E=>({id:E.identifier,reason:{startup:d,extensionId:E.identifier,activationEvent:a}}))).then(()=>{this._alreadyActivatedEvents[a]=!0})}activateById(a,d){const f=this._registry.getExtensionDescription(a);if(!f)throw new Error("Extension `"+a+"` is not known");return this._activateExtensions([{id:f.identifier,reason:d}])}_handleActivateRequest(a,d,f){if(this._hostExtensionsMap.has(m.ExtensionIdentifier.toKey(a.id))){d[m.ExtensionIdentifier.toKey(a.id)]=a;return}const E=this._registry.getExtensionDescription(a.id);if(!E){const g=new Error(`Cannot activate unknown extension '${a.id.value}'`);this._host.onExtensionActivationError(a.id,g,new F.MissingExtensionDependency(a.id.value)),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(a.id),new k(g));return}const w=typeof E.extensionDependencies=="undefined"?[]:E.extensionDependencies;let u=!0;for(let g=0,b=w.length;g<b;g++){const t=w[g];if(this._resolvedExtensionsSet.has(m.ExtensionIdentifier.toKey(t)))continue;const s=this._activatedExtensions.get(m.ExtensionIdentifier.toKey(t));if(s&&!s.activationFailed)continue;if(s&&s.activationFailed){const p=E.displayName||E.identifier.value,v=this._registry.getExtensionDescription(t),A=v&&v.displayName||t,R=new Error(`Cannot activate the '${p}' extension because its dependency '${A}' failed to activate`);R.detail=s.activationFailedError,this._host.onExtensionActivationError(E.identifier,R,null),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(E.identifier),new k(R));return}if(this._hostExtensionsMap.has(m.ExtensionIdentifier.toKey(t))){u=!1,d[m.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(m.ExtensionIdentifier.toKey(t)),reason:a.reason};continue}const i=this._registry.getExtensionDescription(t);if(i){u=!1,d[m.ExtensionIdentifier.toKey(t)]={id:i.identifier,reason:a.reason};continue}const r=E.displayName||E.identifier.value,c=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(E.identifier,c,new F.MissingExtensionDependency(t)),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(E.identifier),new k(c));return}u?d[m.ExtensionIdentifier.toKey(E.identifier)]=a:f.push(a)}_activateExtensions(a){if(a.length===0||(a=a.filter(w=>!this._activatedExtensions.has(m.ExtensionIdentifier.toKey(w.id))),a.length===0))return Promise.resolve(void 0);const d=Object.create(null),f=[];for(let w=0,u=a.length;w<u;w++)this._handleActivateRequest(a[w],d,f);for(let w=0,u=f.length;w<u;w++){const g=m.ExtensionIdentifier.toKey(f[w].id);d[g]&&delete d[g]}const E=Object.keys(d).map(w=>d[w]);return f.length===0?Promise.all(E.map(w=>this._activateExtension(w.id,w.reason))).then(w=>{}):this._activateExtensions(E).then(w=>this._activateExtensions(f))}_activateExtension(a,d){const f=m.ExtensionIdentifier.toKey(a);if(this._activatedExtensions.has(f))return Promise.resolve(void 0);const E=this._activatingExtensions.get(f);if(E)return E;const w=this._host.actualActivateExtension(a,d).then(void 0,u=>{const g=new Error;return u&&u.name&&(g.name=u.name),u&&u.message?g.message=`Activating extension '${a.value}' failed: ${u.message}.`:g.message=`Activating extension '${a.value}' failed: ${u}.`,u&&u.stack&&(g.stack=u.stack),this._host.onExtensionActivationError(a,g,null),this._logService.error(`Activating extension ${a.value} failed due to an error:`),this._logService.error(u),new k(u)}).then(u=>{this._activatedExtensions.set(f,u),this._activatingExtensions.delete(f)});return this._activatingExtensions.set(f,w),w}};l=ze([je(4,D.ILogService)],l),e.ExtensionsActivator=l}),define(_e[182],ye([0,1,12]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class F{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,I)=>{this._actualOk=y,this._actualErr=I,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):(0,m.onUnexpectedError)(y))}then(y,I){return this._ensureActual().then(y,I)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=F}),define(_e[100],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class m{constructor(_,C){this._proxyIdentifierBrand=void 0,this.isMain=_,this.sid=C,this.nid=++m.count}}e.ProxyIdentifier=m,m.count=0;const F=[];function D(S){const _=new m(!0,S);return F[_.nid]=_,_}e.createMainContextProxyIdentifier=D;function y(S){const _=new m(!1,S);return F[_.nid]=_,_}e.createExtHostContextProxyIdentifier=y;function I(S){return F[S].sid}e.getStringIdentifierForProxy=I}),define(_e[5],ye([0,1,54,2,100]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var y;(function(u){u[u.Desktop=1]="Desktop",u[u.Web=2]="Web"})(y=e.UIKind||(e.UIKind={}));var I;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(I=e.TextEditorRevealType||(e.TextEditorRevealType={}));var S;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(S=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var _;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(_=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var C;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(C=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var k;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(k=e.CandidatePortSource||(e.CandidatePortSource={}));var l;(function(u){u.name="$ident";function g(t,s){return Object.defineProperty(t,u.name,{value:s,enumerable:!0}),t}u.mixin=g;function b(t){return t[u.name]}u.of=b})(l=e.ObjectIdentifier||(e.ObjectIdentifier={}));class h{static mixin(g){return g._id=h._n++,g}}e.IdObject=h,h._n=0;var a;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.command="m",u.kindModifier="n"})(a=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var d;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(d=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var f;(function(u){u[u.File=1]="File",u[u.Text=2]="Text",u[u.Cell=3]="Cell"})(f=e.WorkspaceEditType||(e.WorkspaceEditType={}));function E(u){if(u&&u.edits)for(const g of u.edits)typeof g.resource=="object"?g.resource=F.URI.revive(g.resource):(g.newUri=F.URI.revive(g.newUri),g.oldUri=F.URI.revive(g.oldUri)),g.metadata&&g.metadata.iconPath&&(g.metadata=(0,m.revive)(g.metadata));return u}e.reviveWorkspaceEditDto=E;var w;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(w=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,D.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,D.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,D.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,D.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,D.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,D.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,D.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,D.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,D.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,D.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,D.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,D.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,D.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,D.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,D.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,D.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,D.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,D.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,D.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,D.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,D.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,D.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,D.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,D.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,D.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,D.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,D.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,D.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,D.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,D.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,D.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,D.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,D.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,D.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,D.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,D.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,D.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,D.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,D.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,D.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,D.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,D.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,D.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,D.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,D.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,D.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,D.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,D.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,D.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,D.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,D.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,D.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,D.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,D.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,D.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,D.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,D.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,D.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,D.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,D.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,D.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,D.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(_e[70],ye([0,1,5,3,4]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class y{constructor(S){this._onDidChangePassword=new F.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=S.getProxy(m.MainContext.MainThreadSecretState)}async $onDidChangePassword(S){this._onDidChangePassword.fire(S)}get(S,_){return this._proxy.$getPassword(S,_)}store(S,_,C){return this._proxy.$setPassword(S,_,C)}delete(S,_){return this._proxy.$deletePassword(S,_)}}e.ExtHostSecretState=y,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")}),define(_e[71],ye([0,1,4,15,5,13]),function(ee,e,m,F,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,m.createDecorator)("IExtHostApiDeprecationService");let I=class{constructor(_,C){this._extHostLogService=C,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(D.MainContext.MainThreadTelemetry)}report(_,C,n){const k=this.getUsageKey(_,C);this._reportedUsages.has(k)||(this._reportedUsages.add(k),C.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:_}))}getUsageKey(_,C){return`${_}-${C.identifier.value}`}};I=ze([je(0,y.IExtHostRpcService),je(1,F.ILogService)],I),e.ExtHostApiDeprecationService=I,e.NullApiDeprecationService=Object.freeze(new class{report(S,_,C){}})}),define(_e[183],ye([0,1,3,5,6,26]),function(ee,e,m,F,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class I{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new m.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(F.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}async getSession(_,C,n,k={}){const l=y.ExtensionIdentifier.toKey(_.identifier),h=this._inFlightRequests.get(l)||[],a=[...n].sort().join(" ");let d=h.find(f=>f.scopes===a);if(d)return d.result;{const f=this._getSession(_,l,C,n,k);d={scopes:a,result:f},h.push(d),this._inFlightRequests.set(l,h);try{await f}finally{const E=h.findIndex(w=>w.scopes===a);E>-1&&(h.splice(E),this._inFlightRequests.set(l,h))}return f}}async _getSession(_,C,n,k,l={}){await this._proxy.$ensureProvider(n);const h=_.displayName||_.name;return this._proxy.$getSession(n,k,C,h,l)}async removeSession(_,C){const n=this._authenticationProviders.get(_);return n?n.provider.removeSession(C):this._proxy.$removeSession(_,C)}registerAuthenticationProvider(_,C,n,k){if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:C,provider:n,options:k??{supportsMultipleAccounts:!1}}),this._providers.find(h=>h.id===_)||this._providers.push({id:_,label:C});const l=n.onDidChangeSessions(h=>{this._proxy.$sendDidChangeSessions(_,{added:h.added??[],changed:h.changed??[],removed:h.removed??[]})});return this._proxy.$registerAuthenticationProvider(_,C,k?.supportsMultipleAccounts??!1),new D.Disposable(()=>{l.dispose(),this._authenticationProviders.delete(_);const h=this._providers.findIndex(a=>a.id===_);h>-1&&this._providers.splice(h),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,C){const n=this._authenticationProviders.get(_);if(n)return Promise.resolve(n.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,C){const n=this._authenticationProviders.get(_);if(n)return Promise.resolve(n.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,C){const n=this._authenticationProviders.get(_);if(n)return Promise.resolve(n.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,C){return this._onDidChangeSessions.fire({provider:{id:_,label:C}}),Promise.resolve()}}e.ExtHostAuthentication=I}),define(_e[184],ye([0,1,5,13,9]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let y=class{constructor(S,_){this._extHostDocumentsAndEditors=_,this._proxy=S.getProxy(m.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(S){const _=D.WorkspaceEdit.from(S,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(_)}};y=ze([je(0,F.IExtHostRpcService)],y),e.ExtHostBulkEdits=y}),define(_e[185],ye([0,1,5]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class F{constructor(y){const I=y.getProxy(m.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return I.$readText()},writeText(S){return I.$writeText(S)}})}}e.ExtHostClipboard=F}),define(_e[72],ye([0,1,10,6,9,24,5,17,15,54,30,36,2,7,4,13]),function(ee,e,m,F,D,y,I,S,_,C,n,k,l,h,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let f=class{constructor(t,s){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(I.MainContext.MainThreadCommands),this._logService=s,this.converter=new E(this,i=>{const r=this._apiCommands.get(i);return r?.result===u.Void?r:void 0},s),this._argumentProcessors=[{processArgument(i){return(0,C.revive)(i)}},{processArgument(i){return(0,y.cloneAndChange)(i,function(r){if(n.Range.isIRange(r))return D.Range.to(r);if(k.Position.isIPosition(r))return D.Position.to(r);if(n.Range.isIRange(r.range)&&l.URI.isUri(r.uri))return D.location.to(r);if(!Array.isArray(r))return r})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const s=this.registerCommand(!1,t.id,async(...i)=>{const r=t.args.map((p,v)=>{if(!p.validate(i[v]))throw new Error(`Invalid argument '${p.name}' when running '${t.id}', received: ${i[v]}`);return p.convert(i[v])}),c=await this.executeCommand(t.internalId,...r);return t.result.convert(c,i,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new F.Disposable(()=>{s.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,s,i,r,c){if(this._logService.trace("ExtHostCommands#registerCommand",s),!s.trim().length)throw new Error("invalid id");if(this._commands.has(s))throw new Error(`command '${s}' already exists`);return this._commands.set(s,{callback:i,thisArg:r,description:c}),t&&this._proxy.$registerCommand(s),new F.Disposable(()=>{this._commands.delete(s)&&t&&this._proxy.$unregisterCommand(s)})}executeCommand(t,...s){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,s,!0)}async _doExecuteCommand(t,s,i){if(this._commands.has(t))return this._executeContributedCommand(t,s);{const r=(0,y.cloneAndChange)(s,function(c){if(c instanceof F.Position)return D.Position.from(c);if(c instanceof F.Range)return D.Range.from(c);if(c instanceof F.Location)return D.location.from(c);if(F.NotebookRange.isNotebookRange(c))return D.NotebookRange.from(c);if(!Array.isArray(c))return c});try{const c=await this._proxy.$executeCommand(t,r,i);return(0,C.revive)(c)}catch(c){if(c instanceof Error&&c.message==="$executeCommand:retry")return this._doExecuteCommand(t,s,!1);throw c}}}async _executeContributedCommand(t,s){const i=this._commands.get(t);if(!i)throw new Error("Unknown command");let{callback:r,thisArg:c,description:p}=i;if(p)for(let v=0;v<p.args.length;v++)try{(0,m.validateConstraint)(s[v],p.args[v].constraint)}catch(A){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${p.args[v].name}' - ${p.args[v].description}`)}try{return await r.apply(c,s)}catch(v){if(t===this.converter.delegatingCommandId){const A=this.converter.getActualCommand(...s);A&&(t=A.command)}throw this._logService.error(v,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...s){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(s=s.map(i=>this._argumentProcessors.reduce((r,c)=>c.processArgument(r),i)),this._executeContributedCommand(t,s)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(s=>(t&&(s=s.filter(i=>i[0]!=="_")),s))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[s,i]of this._commands){let{description:r}=i;r&&(t[s]=r)}return Promise.resolve(t)}};f=ze([je(0,d.IExtHostRpcService),je(1,_.ILogService)],f),e.ExtHostCommands=f,e.IExtHostCommands=(0,a.createDecorator)("IExtHostCommands");class E{constructor(t,s,i){this._commands=t,this._lookupApiCommand=s,this._logService=i,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,s){if(!t)return;const i={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return i;const r=this._lookupApiCommand(t.command);if(r)i.id=r.internalId,i.arguments=r.args.map((c,p)=>c.convert(t.arguments&&t.arguments[p]));else if((0,S.isNonEmptyArray)(t.arguments)){const c=++this._cachIdPool;this._cache.set(c,t),s.add((0,h.toDisposable)(()=>{this._cache.delete(c),this._logService.trace("CommandsConverter#DISPOSE",c)})),i.$ident=c,i.id=this.delegatingCommandId,i.arguments=[c],this._logService.trace("CommandsConverter#CREATE",t.command,c)}return i}fromInternal(t){const s=I.ObjectIdentifier.of(t);return typeof s=="number"?this._cache.get(s):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const s=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],s?s.command:"MISSING"),s?this._commands.executeCommand(s.command,...s.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=E;class w{constructor(t,s,i,r){this.name=t,this.description=s,this.validate=i,this.convert=r}optional(){return new w(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,s){return new w(t??this.name,s??this.description,this.validate,this.convert)}}e.ApiCommandArgument=w,w.Uri=new w("uri","Uri of a text document",b=>l.URI.isUri(b),b=>b),w.Position=new w("position","A position in a text document",b=>F.Position.isPosition(b),D.Position.from),w.Range=new w("range","A range in a text document",b=>F.Range.isRange(b),D.Range.from),w.Selection=new w("selection","A selection in a text document",b=>F.Selection.isSelection(b),D.Selection.from),w.Number=new w("number","",b=>typeof b=="number",b=>b),w.String=new w("string","",b=>typeof b=="string",b=>b),w.CallHierarchyItem=new w("item","A call hierarchy item",b=>b instanceof F.CallHierarchyItem,D.CallHierarchyItem.to);class u{constructor(t,s){this.description=t,this.convert=s}}e.ApiCommandResult=u,u.Void=new u("no result",b=>b);class g{constructor(t,s,i,r,c){this.id=t,this.internalId=s,this.description=i,this.args=r,this.result=c}}e.ApiCommand=g}),define(_e[186],ye([0,1,9,6,58,72,17,87]),function(ee,e,m,F,D,y,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",n(m.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,h)=>{if((0,I.isFalsyOrEmpty)(l))return;class a extends F.SymbolInformation{static to(f){const E=new a(f.name,m.SymbolKind.to(f.kind),f.containerName||"",new F.Location(h[0],m.Range.to(f.range)));return E.detail=f.detail,E.range=E.location.range,E.selectionRange=m.Range.to(f.selectionRange),E.children=f.children?f.children.map(a.to):[],E}}return l.map(a.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",k)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",k)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",k)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",k)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",n(m.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",n(m.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(h=>F.Position.isPosition(h)),l=>l.map(m.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(h=>{let a;for(const d of h.reverse())a=new F.SelectionRange(m.Range.to(d),a);return a}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>{const h=[];if(Array.isArray(l))for(let a of l)h.push(...a[1].map(m.WorkspaceSymbol.to));return h})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(m.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(m.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(m.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return m.WorkspaceEdit.to(l)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(m.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new F.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const h=(0,S.decodeSemanticTokensDto)(l);if(h.type==="full")return new F.SemanticTokens(h.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new F.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const h=(0,S.decodeSemanticTokensDto)(l);if(h.type==="full")return new F.SemanticTokens(h.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,h,a)=>{if(!l)return new F.CompletionList([]);const d=l.suggestions.map(f=>m.CompletionItem.to(f,a));return new F.CompletionList(d,l.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return m.SignatureHelp.to(l)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,h,a)=>n(d=>new F.CodeLens(m.Range.to(d.range),d.command&&a.fromInternal(d.command)))(l))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>F.Range.isRange(l),l=>F.Selection.isSelection(l)?m.Selection.from(l):m.Range.from(l)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,h,a)=>n(d=>{if(d._isSynthetic){if(!d.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(d.command)}else{const f=new F.CodeAction(d.title,d.kind?new F.CodeActionKind(d.kind):void 0);return d.edit&&(f.edit=m.WorkspaceEdit.to(d.edit)),d.command&&(f.command=a.fromInternal(d.command)),f.isPreferred=d.isPreferred,f}})(l))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(h=>new F.ColorInformation(m.Range.to(h.range),m.Color.to(h.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",l=>l instanceof F.Color,m.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:m.Range.from(l.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(m.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",l=>l.map(m.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",n(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(h=>m.NotebookExclusiveDocumentPattern.to(h))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(m.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[m.ViewColumn.from(l.viewColumn),m.TextEditorOpenOptions.from(l)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[m.ViewColumn.from(l.viewColumn),m.TextEditorOpenOptions.from(l)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[m.ViewColumn.from(l.viewColumn),m.TextEditorOpenOptions.from(l)]).optional()],y.ApiCommandResult.Void)];class C{static register(h){_.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=C;function n(l){return h=>{if(Array.isArray(h))return h.map(l)}}function k(l){if(!Array.isArray(l))return;const h=[];for(const a of l)D.isLocationLink(a)?h.push(m.DefinitionLink.to(a)):h.push(m.location.to(a));return h}}),define(_e[187],ye([0,1,16,48,3,7,2,58,26,9,6,5]),function(ee,e,m,F,D,y,I,S,_,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function l(h,a,d){const f=h.getProxy(k.MainContext.MainThreadComments);class E{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,a.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===6){const c=this._commentControllers.get(r.handle);return c||r}else if(r&&r.$mid===7){const c=this._commentControllers.get(r.commentControlHandle);if(!c)return r;const p=c.getCommentThread(r.commentThreadHandle);return p||r}else if(r&&r.$mid===8){const c=this._commentControllers.get(r.thread.commentControlHandle);if(!c)return r;const p=c.getCommentThread(r.thread.commentThreadHandle);return p?{thread:p,text:r.text}:r}else if(r&&r.$mid===9){const c=this._commentControllers.get(r.thread.commentControlHandle);if(!c)return r;const p=c.getCommentThread(r.thread.commentThreadHandle);if(!p)return r;let v=r.commentUniqueId,A=p.getCommentByUniqueId(v);return A||r}else if(r&&r.$mid===10){const c=this._commentControllers.get(r.thread.commentControlHandle);if(!c)return r;const p=c.getCommentThread(r.thread.commentThreadHandle);if(!p)return r;let v=r.text,A=r.commentUniqueId,R=p.getCommentByUniqueId(A);return R?(R.body=v,R):r}return r}})}createCommentController(r,c,p){const v=E.handlePool++,A=new u(r,v,c,p);this._commentControllers.set(A.handle,A);const R=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(r.identifier))||[];return R.push(A),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(r.identifier),R),A.value}$createCommentThreadTemplate(r,c,p){const v=this._commentControllers.get(r);!v||v.$createCommentThreadTemplate(c,p)}async $updateCommentThreadTemplate(r,c,p){const v=this._commentControllers.get(r);!v||v.$updateCommentThreadTemplate(c,p)}$deleteCommentThread(r,c){const p=this._commentControllers.get(r);p&&p.$deleteCommentThread(c)}$provideCommentingRanges(r,c,p){const v=this._commentControllers.get(r);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const A=d.getDocument(I.URI.revive(c));return(0,m.asPromise)(()=>v.commentingRangeProvider.provideCommentingRanges(A,p)).then(R=>R?R.map(o=>C.Range.from(o)):void 0)}$toggleReaction(r,c,p,v,A){const R=this._commentControllers.get(r);return!R||!R.reactionHandler?Promise.resolve(void 0):(0,m.asPromise)(()=>{const o=R.getCommentThread(c);if(o){const P=o.getCommentByUniqueId(v.uniqueIdInThread);if(R!==void 0&&P&&R.reactionHandler)return R.reactionHandler(P,t(A))}return Promise.resolve(void 0)})}dispose(){}}E.handlePool=0;class w{constructor(r,c,p,v,A,R,o){this._commentControllerHandle=c,this._id=p,this._uri=v,this._range=A,this._comments=R,this.handle=w._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputDisposables.value=new y.DisposableStore,this._id===void 0&&(this._id=`${r}.${this.handle}`),f.$createCommentThread(c,this.handle,this._id,this._uri,C.Range.from(this._range),o),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=R,this._localDisposables.push({dispose:()=>{f.$deleteCommentThread(c,this.handle)}});const P=this;this.value={get uri(){return P.uri},get range(){return P.range},set range(N){P.range=N},get comments(){return P.comments},set comments(N){P.comments=N},get collapsibleState(){return P.collapsibleState},set collapsibleState(N){P.collapsibleState=N},get canReply(){return P.canReply},set canReply(N){P.canReply=N},get contextValue(){return P.contextValue},set contextValue(N){P.contextValue=N},get label(){return P.label},set label(N){P.label=N},dispose:()=>{P.dispose()}}}set threadId(r){this._id=r}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(r){r.isEqual(this._range)||(this._range=r,this.modifications.range=r,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(r){this._canReply!==r&&(this._canReply=r,this.modifications.canReply=r,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(r){this._label=r,this.modifications.label=r,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(r){this._contextValue=r,this.modifications.contextValue=r,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(r){this._comments=r,this.modifications.comments=r,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(r){this._collapseState=r,this.modifications.collapsibleState=r,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new y.DisposableStore);const r=p=>Object.prototype.hasOwnProperty.call(this.modifications,p),c={};r("range")&&(c.range=C.Range.from(this._range)),r("label")&&(c.label=this.label),r("contextValue")&&(c.contextValue=this.contextValue),r("comments")&&(c.comments=this._comments.map(p=>g(this,p,this._commentsMap))),r("collapsibleState")&&(c.collapseState=s(this._collapseState)),r("canReply")&&(c.canReply=this.canReply),this.modifications={},f.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,c)}getCommentByUniqueId(r){for(let c of this._commentsMap){let p=c[0],v=c[1];if(r===v)return p}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(r=>r.dispose())}}w._handlePool=0,ze([(0,F.debounce)(100)],w.prototype,"eventuallyUpdateCommentThread",null);class u{constructor(r,c,p,v){this._extension=r,this._handle=c,this._id=p,this._label=v,this._threads=new Map,f.$registerCommentController(this.handle,p,v);const A=this;this.value=Object.freeze({id:A.id,label:A.label,get options(){return A.options},set options(R){A.options=R},get commentingRangeProvider(){return A.commentingRangeProvider},set commentingRangeProvider(R){A.commentingRangeProvider=R},get reactionHandler(){return A.reactionHandler},set reactionHandler(R){A.reactionHandler=R},createCommentThread(R,o,P){return A.createCommentThread(R,o,P).value},dispose:()=>{A.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{f.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(r){this._reactionHandler=r,f.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!r})}get options(){return this._options}set options(r){this._options=r,f.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(r,c,p,v){if(typeof r=="string"){const A=new w(this.id,this.handle,r,c,p,v,this._extension.identifier);return this._threads.set(A.handle,A),A}else{const A=new w(this.id,this.handle,void 0,r,c,p,this._extension.identifier);return this._threads.set(A.handle,A),A}}$createCommentThreadTemplate(r,c){const p=new w(this.id,this.handle,void 0,I.URI.revive(r),C.Range.to(c),[],this._extension.identifier);return p.collapsibleState=S.CommentThreadCollapsibleState.Expanded,this._threads.set(p.handle,p),p}$updateCommentThreadTemplate(r,c){let p=this._threads.get(r);p&&(p.range=C.Range.to(c))}$deleteCommentThread(r){let c=this._threads.get(r);c&&c.dispose(),this._threads.delete(r)}getCommentThread(r){return this._threads.get(r)}dispose(){this._threads.forEach(r=>{r.dispose()}),this._localDisposables.forEach(r=>r.dispose())}}function g(i,r,c){let p=c.get(r);p||(p=++i.commentHandle,c.set(r,p));const v=r.author&&r.author.iconPath?r.author.iconPath.toString():void 0;return{mode:r.mode,contextValue:r.contextValue,uniqueIdInThread:p,body:C.MarkdownString.from(r.body),userName:r.author.name,userIconPath:v,label:r.label,commentReactions:r.reactions?r.reactions.map(A=>b(A)):void 0}}function b(i){return{label:i.label,iconPath:i.iconPath?C.pathOrURIToURI(i.iconPath):void 0,count:i.count,hasReacted:i.authorHasReacted}}function t(i){return{label:i.label||"",count:i.count||0,iconPath:i.iconPath?I.URI.revive(i.iconPath):"",authorHasReacted:i.hasReacted||!1}}function s(i){if(i!==void 0)switch(i){case n.CommentThreadCollapsibleState.Expanded:return S.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return S.CommentThreadCollapsibleState.Collapsed}return S.CommentThreadCollapsibleState.Collapsed}return new E}e.createExtHostComments=l}),define(_e[101],ye([0,1,2,5,6,4,13,15,17,8,14]),function(ee,e,m,F,D,y,I,S,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let k=class wn{constructor(h,a){this._logService=a,this._provider=new Map,this._proxy=h.getProxy(F.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,a){const d=wn._handlePool++;this._provider.set(d,{provider:h,extensionId:a}),this._proxy.$registerDecorationProvider(d,a.value);const f=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(E=>{if(!E){this._proxy.$onDidChange(d,null);return}let w=(0,_.asArray)(E);if(w.length<=wn._maxEventSize){this._proxy.$onDidChange(d,w);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.value,w.length);const u=w.map(t=>({uri:t,rank:(0,C.count)(t.path,"/")})),g=(0,_.groupBy)(u,(t,s)=>t.rank-s.rank||(0,C.compare)(t.uri.path,s.uri.path));let b=[];e:for(let t of g){let s;for(let i of t){let r=(0,n.dirname)(i.uri.path);if(s!==r&&(s=r,b.push(i.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(d,b)});return new D.Disposable(()=>{f?.dispose(),this._proxy.$unregisterDecorationProvider(d),this._provider.delete(d)})}async $provideDecorations(h,a,d){if(!this._provider.has(h))return Object.create(null);const f=Object.create(null),{provider:E,extensionId:w}=this._provider.get(h);return await Promise.all(a.map(async u=>{try{const{uri:g,id:b}=u,t=await Promise.resolve(E.provideFileDecoration(m.URI.revive(g),d));if(!t)return;try{D.FileDecoration.validate(t),f[b]=[t.propagate,t.tooltip,t.badge,t.color]}catch(s){this._logService.warn(`INVALID decoration from extension '${w.value}': ${s}`)}}catch(g){this._logService.error(g)}})),f}};k._handlePool=0,k._maxEventSize=250,k=ze([je(0,I.IExtHostRpcService),je(1,S.ILogService)],k),e.ExtHostDecorations=k,e.IExtHostDecorations=(0,y.createDecorator)("IExtHostDecorations")}),define(_e[188],ye([0,1,129,90,2,5,6,9,3,15,22]),function(ee,e,m,F,D,y,I,S,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class k{constructor(a,d,f,E,w){this._name=a,this._owner=d,this._maxDiagnosticsPerFile=f,this._proxy=E,this._onDidChangeDiagnostics=w,this._isDisposed=!1,this._data=new n.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(a,d){if(!a){this.clear();return}this._checkDisposed();let f=[];if(D.URI.isUri(a)){if(!d){this.delete(a);return}this._data.set(a,d.slice()),f=[a]}else if(Array.isArray(a)){f=[];let w;a=[...a].sort(k._compareIndexedTuplesByUri);for(const u of a){const[g,b]=u;if((!w||g.toString()!==w.toString())&&(w&&this._data.get(w).length===0&&this._data.delete(w),w=g,f.push(g),this._data.set(g,[])),b){const t=this._data.get(g);t&&t.push(...b)}else{const t=this._data.get(g);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(f),!this._proxy)return;const E=[];for(let w of f){let u=[];const g=this._data.get(w);if(g)if(g.length>this._maxDiagnosticsPerFile){u=[];const b=[I.DiagnosticSeverity.Error,I.DiagnosticSeverity.Warning,I.DiagnosticSeverity.Information,I.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let s of g)if(s.severity===b[t]&&u.push(S.Diagnostic.from(s))===this._maxDiagnosticsPerFile)break e;u.push({severity:F.MarkerSeverity.Info,message:(0,m.localize)(0,null,g.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=g.map(b=>S.Diagnostic.from(b));E.push([w,u])}this._proxy.$changeMany(this._owner,E)}delete(a){this._checkDisposed(),this._onDidChangeDiagnostics.fire([a]),this._data.delete(a),this._proxy&&this._proxy.$changeMany(this._owner,[[a,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(a,d){this._checkDisposed();for(let f of this._data.keys())a.apply(d,[f,this.get(f),this])}get(a){this._checkDisposed();const d=this._data.get(a);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(a){return this._checkDisposed(),Array.isArray(this._data.get(a))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(a,d){return a[0].toString()<d[0].toString()?-1:a[0].toString()>d[0].toString()?1:0}}e.DiagnosticCollection=k;let l=class Gt{constructor(a,d){this._logService=d,this._collections=new Map,this._onDidChangeDiagnostics=new _.DebounceEmitter({merge:f=>f.flat(),delay:50}),this.onDidChangeDiagnostics=_.Event.map(this._onDidChangeDiagnostics.event,Gt._mapper),this._proxy=a.getProxy(y.MainContext.MainThreadDiagnostics)}static _mapper(a){const d=new n.ResourceMap;for(const f of a)d.set(f,f);return{uris:Object.freeze(Array.from(d.values()))}}createDiagnosticCollection(a,d){const{_collections:f,_proxy:E,_onDidChangeDiagnostics:w,_logService:u}=this,g=new class{$changeMany(s,i){E.$changeMany(s,i),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,s,i.length===0?"CLEARING":i)}$clear(s){E.$clear(s),u.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,s)}dispose(){E.dispose()}};let b;if(!d)d="_generated_diagnostic_collection_name_#"+Gt._idPool++,b=d;else if(!f.has(d))b=d;else{this._logService.warn(`DiagnosticCollection with name '${d}' does already exist.`);do b=d+Gt._idPool++;while(f.has(b))}return new class extends k{constructor(){super(d,b,Gt._maxDiagnosticsPerFile,g,w);f.set(b,this)}dispose(){super.dispose(),f.delete(b)}}}getDiagnostics(a){if(a)return this._getDiagnostics(a);{const d=new Map,f=[];for(const E of this._collections.values())E.forEach((w,u)=>{let g=d.get(w.toString());typeof g=="undefined"&&(g=f.length,d.set(w.toString(),g),f.push([w,[]])),f[g][1]=f[g][1].concat(...u)});return f}}_getDiagnostics(a){let d=[];for(let f of this._collections.values())f.has(a)&&(d=d.concat(f.get(a)));return d}$acceptMarkersChange(a){if(!this._mirrorCollection){const d="_generated_mirror",f=new k(d,d,Gt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(d,f),this._mirrorCollection=f}for(const[d,f]of a)this._mirrorCollection.set(D.URI.revive(d),f.map(S.Diagnostic.to))}};l._idPool=0,l._maxDiagnosticsPerFile=1e3,l=ze([je(1,C.ILogService)],l),e.ExtHostDiagnostics=l}),define(_e[189],ye([0,1,2,5]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(I){this._proxy=I.getProxy(F.MainContext.MainThreadDialogs)}showOpenDialog(I){return this._proxy.$showOpenDialog(I).then(S=>S?S.map(_=>m.URI.revive(_)):void 0)}showSaveDialog(I){return this._proxy.$showSaveDialog(I).then(S=>S?m.URI.revive(S):void 0)}}e.ExtHostDialogs=D}),define(_e[190],ye([0,1,12,2,6,5,11,18,8]),function(ee,e,m,F,D,y,I,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(k,l,h){this._documentsAndEditors=l,this._logService=h,this._documentContentProviders=new Map,this._proxy=k.getProxy(y.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,l){if(Object.keys(I.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const h=C._handlePool++;this._documentContentProviders.set(h,l),this._proxy.$registerTextContentProvider(h,k);let a;return typeof l.onDidChange=="function"&&(a=l.onDidChange(d=>{if(d.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(d)&&this.$provideTextDocumentContent(h,d).then(f=>{if(!f&&typeof f!="string")return;const E=this._documentsAndEditors.getDocument(d);if(!E)return;const w=(0,_.splitLines)(f);if(!E.equalLines(w))return this._proxy.$onVirtualDocumentChange(d,f)},m.onUnexpectedError)})),new D.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),a&&(a.dispose(),a=void 0)})}$provideTextDocumentContent(k,l){const h=this._documentContentProviders.get(k);return h?Promise.resolve(h.provideTextDocumentContent(F.URI.revive(l),S.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=C,C._handlePool=0}),define(_e[191],ye([0,1,3,7,2,5,95,9,10,24,6]),function(ee,e,m,F,D,y,I,S,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class k{constructor(h,a){this._onDidAddDocument=new m.Emitter,this._onDidRemoveDocument=new m.Emitter,this._onDidChangeDocument=new m.Emitter,this._onDidSaveDocument=new m.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new F.DisposableStore,this._documentLoader=new Map,this._proxy=h.getProxy(y.MainContext.MainThreadDocuments),this._documentsAndEditors=a,this._documentsAndEditors.onDidRemoveDocuments(d=>{for(const f of d)this._onDidRemoveDocument.fire(f.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(d=>{for(const f of d)this._onDidAddDocument.fire(f.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(h){if(!h)return;const a=this._documentsAndEditors.getDocument(h);if(a)return a}getDocument(h){const a=this.getDocumentData(h);if(!a?.document)throw new Error(`Unable to retrieve document from URI '${h}'`);return a.document}ensureDocumentData(h){const a=this._documentsAndEditors.getDocument(h);if(a)return Promise.resolve(a);let d=this._documentLoader.get(h.toString());return d||(d=this._proxy.$tryOpenDocument(h).then(f=>{this._documentLoader.delete(h.toString());const E=D.URI.revive(f);return(0,_.assertIsDefined)(this._documentsAndEditors.getDocument(E))},f=>(this._documentLoader.delete(h.toString()),Promise.reject(f))),this._documentLoader.set(h.toString(),d)),d}createDocumentData(h){return this._proxy.$tryCreateDocument(h).then(a=>D.URI.revive(a))}$acceptModelModeChanged(h,a){const d=D.URI.revive(h),f=this._documentsAndEditors.getDocument(d);if(!f)throw new Error("unknown document");this._onDidRemoveDocument.fire(f.document),f._acceptLanguageId(a),this._onDidAddDocument.fire(f.document)}$acceptModelSaved(h){const a=D.URI.revive(h),d=this._documentsAndEditors.getDocument(a);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(h,!1),this._onDidSaveDocument.fire(d.document)}$acceptDirtyStateChanged(h,a){const d=D.URI.revive(h),f=this._documentsAndEditors.getDocument(d);if(!f)throw new Error("unknown document");f._acceptIsDirty(a),this._onDidChangeDocument.fire({document:f.document,contentChanges:[],reason:void 0})}$acceptModelChanged(h,a,d){const f=D.URI.revive(h),E=this._documentsAndEditors.getDocument(f);if(!E)throw new Error("unknown document");E._acceptIsDirty(d),E.onEvents(a);let w;a.isUndoing?w=n.TextDocumentChangeReason.Undo:a.isRedoing&&(w=n.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,C.deepFreeze)({document:E.document,contentChanges:a.changes.map(u=>({range:S.Range.to(u.range),rangeOffset:u.rangeOffset,rangeLength:u.rangeLength,text:u.text})),reason:w}))}setWordDefinitionFor(h,a){(0,I.setWordDefinitionFor)(h,a)}}e.ExtHostDocuments=k}),define(_e[46],ye([0,1,39,3,7,2,4,5,95,13,99,9,15,22,11,51,109]),function(ee,e,m,F,D,y,I,S,_,C,n,k,l,h,a,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class E{constructor(g){this.value=g,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let w=class{constructor(g,b){this._extHostRpc=g,this._logService=b,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new F.Emitter,this._onDidRemoveDocuments=new F.Emitter,this._onDidChangeVisibleTextEditors=new F.Emitter,this._onDidChangeActiveTextEditor=new F.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(g){this.acceptDocumentsAndEditorsDelta(g)}acceptDocumentsAndEditorsDelta(g){const b=[],t=[],s=[];if(g.removedDocuments)for(const i of g.removedDocuments){const r=y.URI.revive(i),c=this._documents.get(r);c?.unref()&&(this._documents.delete(r),b.push(c.value))}if(g.addedDocuments)for(const i of g.addedDocuments){const r=y.URI.revive(i.uri);let c=this._documents.get(r);if(c&&r.scheme!==a.Schemas.vscodeNotebookCell&&r.scheme!==a.Schemas.vscodeInteractiveInput)throw new Error(`document '${r} already exists!'`);c||(c=new E(new _.ExtHostDocumentData(this._extHostRpc.getProxy(S.MainContext.MainThreadDocuments),r,i.lines,i.EOL,i.versionId,i.modeId,i.isDirty,i.notebook)),this._documents.set(r,c),t.push(c.value)),c.ref()}if(g.removedEditors)for(const i of g.removedEditors){const r=this._editors.get(i);this._editors.delete(i),r&&s.push(r)}if(g.addedEditors)for(const i of g.addedEditors){const r=y.URI.revive(i.documentUri);m.ok(this._documents.has(r),`document '${r}' does not exist`),m.ok(!this._editors.has(i.id),`editor '${i.id}' already exists!`);const c=this._documents.get(r).value,p=new n.ExtHostTextEditor(i.id,this._extHostRpc.getProxy(S.MainContext.MainThreadTextEditors),this._logService,new f.Lazy(()=>c.document),i.selections.map(k.Selection.to),i.options,i.visibleRanges.map(v=>k.Range.to(v)),typeof i.editorPosition=="number"?k.ViewColumn.to(i.editorPosition):void 0);this._editors.set(i.id,p)}g.newActiveEditor!==void 0&&(m.ok(g.newActiveEditor===null||this._editors.has(g.newActiveEditor),`active editor '${g.newActiveEditor}' does not exist`),this._activeEditorId=g.newActiveEditor),(0,D.dispose)(b),(0,D.dispose)(s),g.removedDocuments&&this._onDidRemoveDocuments.fire(b),g.addedDocuments&&this._onDidAddDocuments.fire(t),(g.removedEditors||g.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(i=>i.value)),g.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(g){return this._documents.get(g)?.value}allDocuments(){return d.Iterable.map(this._documents.values(),g=>g.value)}getEditor(g){return this._editors.get(g)}activeEditor(g){if(!this._activeEditorId)return;const b=this._editors.get(this._activeEditorId);return g?b:b?.value}allEditors(){return[...this._editors.values()]}};w=ze([je(0,C.IExtHostRpcService),je(1,l.ILogService)],w),e.ExtHostDocumentsAndEditors=w,e.IExtHostDocumentsAndEditors=(0,I.createDecorator)("IExtHostDocumentsAndEditors")}),define(_e[192],ye([0,1,2,5,7,6,9,119,8,23]),function(ee,e,m,F,D,y,I,S,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const a=this._schemes.indexOf(h);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),a=[];let d,f,E=14,w=14;for(const u of h){let g=d?(0,_.commonPrefixLength)(d,u):0;for(g===0?f=1:f=w;g<u.length;g++)g+1===u.length?(E=w,w=9):w+=1,a.push([f,u.toUpperCase().charCodeAt(g),w]),a.push([f,u.toLowerCase().charCodeAt(g),w]),f=w;d=u,w=E}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new S.StateMachine(a)}}provideDocumentLinks(h){this._initStateMachine();const a=[],d=S.LinkComputer.computeLinks({getLineContent(f){return h.lineAt(f-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const f of d){const E=I.DocumentLink.to(f);E.target&&a.push(E)}return a}}class k{constructor(h,a){this._extHostLanguageFeatures=a,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=h.getProxy(F.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,a,d,f={},E){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const w=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(w,d),this._enableProposedApi.set(w,E??!1);let u=2;f.isCaseSensitive&&(u+=1024),f.isReadonly&&(u+=2048),typeof d.copy=="function"&&(u+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&(u+=4),this._proxy.$registerFileSystemProvider(w,a,u).catch(b=>{console.error(`FAILED to register filesystem provider of ${h.value}-extension for the scheme ${a}`),console.error(b)});const g=d.onDidChangeFile(b=>{const t=[];for(const s of b){let{uri:i,type:r}=s;if(i.scheme!==a)continue;let c;switch(r){case y.FileChangeType.Changed:c=0;break;case y.FileChangeType.Created:c=1;break;case y.FileChangeType.Deleted:c=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:i,type:c})}this._proxy.$onFileSystemChange(w,t)});return(0,D.toDisposable)(()=>{g.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(w),this._enableProposedApi.delete(w),this._proxy.$unregisterProvider(w)})}static _asIStat(h,a){const{type:d,ctime:f,mtime:E,size:w,permissions:u}=h;return a?{type:d,ctime:f,mtime:E,size:w,permissions:u}:{type:d,ctime:f,mtime:E,size:w}}$stat(h,a){return Promise.resolve(this._getFsProvider(h).stat(m.URI.revive(a))).then(d=>k._asIStat(d,this._enableProposedApi.get(h)??!1))}$readdir(h,a){return Promise.resolve(this._getFsProvider(h).readDirectory(m.URI.revive(a)))}$readFile(h,a){return Promise.resolve(this._getFsProvider(h).readFile(m.URI.revive(a))).then(d=>C.VSBuffer.wrap(d))}$writeFile(h,a,d,f){return Promise.resolve(this._getFsProvider(h).writeFile(m.URI.revive(a),d.buffer,f))}$delete(h,a,d){return Promise.resolve(this._getFsProvider(h).delete(m.URI.revive(a),d))}$rename(h,a,d,f){return Promise.resolve(this._getFsProvider(h).rename(m.URI.revive(a),m.URI.revive(d),f))}$copy(h,a,d,f){const E=this._getFsProvider(h);if(!E.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(E.copy(m.URI.revive(a),m.URI.revive(d),f))}$mkdir(h,a){return Promise.resolve(this._getFsProvider(h).createDirectory(m.URI.revive(a)))}$watch(h,a,d,f){const E=this._getFsProvider(h).watch(m.URI.revive(d),f);this._watches.set(a,E)}$unwatch(h,a){const d=this._watches.get(a);d&&(d.dispose(),this._watches.delete(a))}$open(h,a,d){const f=this._getFsProvider(h);if(!f.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(f.open(m.URI.revive(a),d))}$close(h,a){const d=this._getFsProvider(h);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(a))}$read(h,a,d,f){const E=this._getFsProvider(h);if(!E.read)throw new Error('FileSystemProvider does not implement "read"');const w=C.VSBuffer.alloc(f);return Promise.resolve(E.read(a,d,w.buffer,0,f)).then(u=>w.slice(0,u))}$write(h,a,d,f){const E=this._getFsProvider(h);if(!E.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(E.write(a,d,f.buffer,0,f.byteLength))}_getFsProvider(h){const a=this._fsProvider.get(h);if(!a){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return a}}e.ExtHostFileSystem=k}),define(_e[73],ye([0,1,5,60,6,23,4,13,45]),function(ee,e,m,F,D,y,I,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let C=class Wt{constructor(k,l){const h=k.getProxy(m.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(a){return h.$stat(a).catch(Wt._handleError)},readDirectory(a){return h.$readdir(a).catch(Wt._handleError)},createDirectory(a){return h.$mkdir(a).catch(Wt._handleError)},async readFile(a){return h.$readFile(a).then(d=>d.buffer).catch(Wt._handleError)},writeFile(a,d){return h.$writeFile(a,y.VSBuffer.wrap(d)).catch(Wt._handleError)},delete(a,d){return h.$delete(a,{recursive:!1,useTrash:!1,...d}).catch(Wt._handleError)},rename(a,d,f){return h.$rename(a,d,{overwrite:!1,...f}).catch(Wt._handleError)},copy(a,d,f){return h.$copy(a,d,{overwrite:!1,...f}).catch(Wt._handleError)},isWritableFileSystem(a){const d=l.getCapabilities(a);if(typeof d=="number")return!(d&2048)}})}static _handleError(k){if(!(k instanceof Error))throw new D.FileSystemError(String(k));if(k.name==="ENOPRO")throw D.FileSystemError.Unavailable(k.message);switch(k.name){case F.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(k.message);case F.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(k.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(k.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(k.message);case F.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(k.message);case F.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(k.message);default:throw new D.FileSystemError(k.message,k.name)}}};C=ze([je(0,S.IExtHostRpcService),je(1,_.IExtHostFileSystemInfo)],C),e.ExtHostConsumerFileSystem=C,e.IExtHostConsumerFileSystem=(0,I.createDecorator)("IExtHostConsumerFileSystem")}),define(_e[193],ye([0,1,7,5]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(I){this._handlePool=0,this._proxy=I.getProxy(F.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(I){const S=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(S,I),(0,m.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(S)})}}e.ExtHostLabelService=D}),define(_e[194],ye([0,1,2,24,9,6,5,8,30,17,10,116,7,87,50,63,52,12,3]),function(ee,e,m,F,D,y,I,S,_,C,n,k,l,h,a,d,f,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class u{constructor(U,G){this._documents=U,this._provider=G}async provideDocumentSymbols(U,G){const te=this._documents.getDocument(U),re=await this._provider.provideDocumentSymbols(te,G);if(!(0,C.isFalsyOrEmpty)(re))return re[0]instanceof y.DocumentSymbol?re.map(D.DocumentSymbol.from):u._asDocumentSymbolTree(re)}static _asDocumentSymbolTree(U){U=U.slice(0).sort((re,pe)=>{let Q=re.location.range.start.compareTo(pe.location.range.start);return Q===0&&(Q=pe.location.range.end.compareTo(re.location.range.end)),Q});const G=[],te=[];for(const re of U){const pe={name:re.name||"!!MISSING: name!!",kind:D.SymbolKind.from(re.kind),tags:re.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:re.containerName,range:D.Range.from(re.location.range),selectionRange:D.Range.from(re.location.range),children:[]};for(;;){if(te.length===0){te.push(pe),G.push(pe);break}const Q=te[te.length-1];if(_.Range.containsRange(Q.range,pe.range)&&!_.Range.equalsRange(Q.range,pe.range)){Q.children&&Q.children.push(pe),te.push(pe);break}te.pop()}}return G}}class g{constructor(U,G,te){this._documents=U,this._commands=G,this._provider=te,this._cache=new d.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(U,G){const te=this._documents.getDocument(U),re=await this._provider.provideCodeLenses(te,G);if(!re||G.isCancellationRequested)return;const pe=this._cache.add(re),Q=new l.DisposableStore;this._disposables.set(pe,Q);const ue={cacheId:pe,lenses:[]};for(let Ie=0;Ie<re.length;Ie++)ue.lenses.push({cacheId:[pe,Ie],range:D.Range.from(re[Ie].range),command:this._commands.toInternal(re[Ie].command,Q)});return ue}async resolveCodeLens(U,G){const te=U.cacheId&&this._cache.get(...U.cacheId);if(!te)return;let re;if(typeof this._provider.resolveCodeLens!="function"||te.isResolved?re=te:re=await this._provider.resolveCodeLens(te,G),re||(re=te),G.isCancellationRequested)return;const pe=U.cacheId&&this._disposables.get(U.cacheId[0]);if(!!pe)return U.command=this._commands.toInternal(re.command??g._badCmd,pe),U}releaseCodeLenses(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}}g._badCmd={command:"missing",title:"!!MISSING: command!!"};function b(qe){return Array.isArray(qe)?qe.map(D.DefinitionLink.from):qe?[D.DefinitionLink.from(qe)]:[]}class t{constructor(U,G){this._documents=U,this._provider=G}async provideDefinition(U,G,te){const re=this._documents.getDocument(U),pe=D.Position.to(G),Q=await this._provider.provideDefinition(re,pe,te);return b(Q)}}class s{constructor(U,G){this._documents=U,this._provider=G}async provideDeclaration(U,G,te){const re=this._documents.getDocument(U),pe=D.Position.to(G),Q=await this._provider.provideDeclaration(re,pe,te);return b(Q)}}class i{constructor(U,G){this._documents=U,this._provider=G}async provideImplementation(U,G,te){const re=this._documents.getDocument(U),pe=D.Position.to(G),Q=await this._provider.provideImplementation(re,pe,te);return b(Q)}}class r{constructor(U,G){this._documents=U,this._provider=G}async provideTypeDefinition(U,G,te){const re=this._documents.getDocument(U),pe=D.Position.to(G),Q=await this._provider.provideTypeDefinition(re,pe,te);return b(Q)}}class c{constructor(U,G){this._documents=U,this._provider=G}async provideHover(U,G,te){const re=this._documents.getDocument(U),pe=D.Position.to(G),Q=await this._provider.provideHover(re,pe,te);if(!(!Q||(0,C.isFalsyOrEmpty)(Q.contents)))return Q.range||(Q.range=re.getWordRangeAtPosition(pe)),Q.range||(Q.range=new y.Range(pe,pe)),D.Hover.from(Q)}}class p{constructor(U,G){this._documents=U,this._provider=G}async provideEvaluatableExpression(U,G,te){const re=this._documents.getDocument(U),pe=D.Position.to(G),Q=await this._provider.provideEvaluatableExpression(re,pe,te);if(Q)return D.EvaluatableExpression.from(Q)}}class v{constructor(U,G){this._documents=U,this._provider=G}async provideInlineValues(U,G,te,re){const pe=this._documents.getDocument(U),Q=await this._provider.provideInlineValues(pe,D.Range.to(G),D.InlineValueContext.to(te),re);if(Array.isArray(Q))return Q.map(ue=>D.InlineValue.from(ue))}}class A{constructor(U,G){this._documents=U,this._provider=G}async provideDocumentHighlights(U,G,te){const re=this._documents.getDocument(U),pe=D.Position.to(G),Q=await this._provider.provideDocumentHighlights(re,pe,te);if(Array.isArray(Q))return Q.map(D.DocumentHighlight.from)}}class R{constructor(U,G){this._documents=U,this._provider=G}async provideLinkedEditingRanges(U,G,te){const re=this._documents.getDocument(U),pe=D.Position.to(G),Q=await this._provider.provideLinkedEditingRanges(re,pe,te);if(Q&&Array.isArray(Q.ranges))return{ranges:(0,C.coalesce)(Q.ranges.map(D.Range.from)),wordPattern:Q.wordPattern}}}class o{constructor(U,G){this._documents=U,this._provider=G}async provideReferences(U,G,te,re){const pe=this._documents.getDocument(U),Q=D.Position.to(G),ue=await this._provider.provideReferences(pe,Q,te,re);if(Array.isArray(ue))return ue.map(D.location.from)}}class P{constructor(U,G,te,re,pe,Q,ue){this._documents=U,this._commands=G,this._diagnostics=te,this._provider=re,this._logService=pe,this._extension=Q,this._apiDeprecation=ue,this._cache=new d.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(U,G,te,re){const pe=this._documents.getDocument(U),Q=k.Selection.isISelection(G)?D.Selection.to(G):D.Range.to(G),ue=[];for(const W of this._diagnostics.getDiagnostics(U))if(Q.intersection(W.range)&&ue.push(W)>P._maxCodeActionsPerFile)break;const Ie={diagnostics:ue,only:te.only?new y.CodeActionKind(te.only):void 0,triggerKind:D.CodeActionTriggerKind.to(te.trigger)},xe=await this._provider.provideCodeActions(pe,Q,Ie,re);if(!(0,C.isNonEmptyArray)(xe)||re.isCancellationRequested)return;const We=this._cache.add(xe),ve=new l.DisposableStore;this._disposables.set(We,ve);const tt=[];for(let W=0;W<xe.length;W++){const J=xe[W];!J||(P._isCommand(J)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:J.title,command:this._commands.toInternal(J,ve)})):(Ie.only&&(J.kind?Ie.only.contains(J.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ie.only.value} 'requested but returned code action is of kind '${J.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ie.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),tt.push({cacheId:[We,W],title:J.title,command:J.command&&this._commands.toInternal(J.command,ve),diagnostics:J.diagnostics&&J.diagnostics.map(D.Diagnostic.from),edit:J.edit&&D.WorkspaceEdit.from(J.edit),kind:J.kind&&J.kind.value,isPreferred:J.isPreferred,disabled:J.disabled?.reason})))}return{cacheId:We,actions:tt}}async resolveCodeAction(U,G){const[te,re]=U,pe=this._cache.get(te,re);if(!pe||P._isCommand(pe)||!this._provider.resolveCodeAction)return;const Q=await this._provider.resolveCodeAction(pe,G)??pe;return Q?.edit?D.WorkspaceEdit.from(Q.edit):void 0}releaseCodeActions(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}static _isCommand(U){return typeof U.command=="string"&&typeof U.title=="string"}}P._maxCodeActionsPerFile=1e3;class N{constructor(U,G){this._documents=U,this._provider=G}async provideDocumentFormattingEdits(U,G,te){const re=this._documents.getDocument(U),pe=await this._provider.provideDocumentFormattingEdits(re,G,te);if(Array.isArray(pe))return pe.map(D.TextEdit.from)}}class ${constructor(U,G){this._documents=U,this._provider=G}async provideDocumentRangeFormattingEdits(U,G,te,re){const pe=this._documents.getDocument(U),Q=D.Range.to(G),ue=await this._provider.provideDocumentRangeFormattingEdits(pe,Q,te,re);if(Array.isArray(ue))return ue.map(D.TextEdit.from)}}class ie{constructor(U,G){this._documents=U,this._provider=G,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,G,te,re,pe){const Q=this._documents.getDocument(U),ue=D.Position.to(G),Ie=await this._provider.provideOnTypeFormattingEdits(Q,ue,te,re,pe);if(Array.isArray(Ie))return Ie.map(D.TextEdit.from)}}class ce{constructor(U,G){this._provider=U,this._logService=G,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(U,G){const te=I.IdObject.mixin({symbols:[]}),re=await this._provider.provideWorkspaceSymbols(U,G);if((0,C.isNonEmptyArray)(re))for(const pe of re){if(!pe)continue;if(!pe.name){this._logService.warn("INVALID SymbolInformation, lacks name",pe);continue}const Q=I.IdObject.mixin(D.WorkspaceSymbol.from(pe));this._symbolCache.set(Q._id,pe),te.symbols.push(Q)}return te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te}async resolveWorkspaceSymbol(U,G){if(typeof this._provider.resolveWorkspaceSymbol!="function")return U;const te=this._symbolCache.get(U._id);if(te){const re=await this._provider.resolveWorkspaceSymbol(te,G);return re&&(0,F.mixin)(U,D.WorkspaceSymbol.from(re),!0)}}releaseWorkspaceSymbols(U){const G=this._resultCache.get(U);if(G){for(let[te,re]=G;te<=re;te++)this._symbolCache.delete(te);this._resultCache.delete(U)}}}class K{constructor(U,G,te){this._documents=U,this._provider=G,this._logService=te}static supportsResolving(U){return typeof U.prepareRename=="function"}async provideRenameEdits(U,G,te,re){const pe=this._documents.getDocument(U),Q=D.Position.to(G);try{const ue=await this._provider.provideRenameEdits(pe,Q,te,re);return ue?D.WorkspaceEdit.from(ue):void 0}catch(ue){const Ie=K._asMessage(ue);return Ie?{rejectReason:Ie,edits:void 0}:Promise.reject(ue)}}async resolveRenameLocation(U,G,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const re=this._documents.getDocument(U),pe=D.Position.to(G);try{const Q=await this._provider.prepareRename(re,pe,te);let ue,Ie;if(y.Range.isRange(Q)?(ue=Q,Ie=re.getText(Q)):(0,n.isObject)(Q)&&(ue=Q.range,Ie=Q.placeholder),!ue||!Ie)return;if(ue.start.line>pe.line||ue.end.line<pe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(ue),text:Ie}}catch(Q){const ue=K._asMessage(Q);return ue?{rejectReason:ue,range:void 0,text:void 0}:Promise.reject(Q)}}static _asMessage(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class H{constructor(U,G){this.resultId=U,this.tokens=G}}class z{constructor(U,G){this._documents=U,this._provider=G,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(U,G,te){const re=this._documents.getDocument(U),pe=G!==0?this._previousResults.get(G):null;let Q=typeof pe?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(re,pe.resultId,te):await this._provider.provideDocumentSemanticTokens(re,te);return pe&&this._previousResults.delete(G),Q?(Q=z._fixProvidedSemanticTokens(Q),this._send(z._convertToEdits(pe,Q),Q)):null}async releaseDocumentSemanticColoring(U){this._previousResults.delete(U)}static _fixProvidedSemanticTokens(U){return z._isSemanticTokens(U)?z._isCorrectSemanticTokens(U)?U:new y.SemanticTokens(new Uint32Array(U.data),U.resultId):z._isSemanticTokensEdits(U)?z._isCorrectSemanticTokensEdits(U)?U:new y.SemanticTokensEdits(U.edits.map(G=>new y.SemanticTokensEdit(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),U.resultId):U}static _isSemanticTokens(U){return U&&!!U.data}static _isCorrectSemanticTokens(U){return U.data instanceof Uint32Array}static _isSemanticTokensEdits(U){return U&&Array.isArray(U.edits)}static _isCorrectSemanticTokensEdits(U){for(const G of U.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(U,G){if(!z._isSemanticTokens(G)||!U||!U.tokens)return G;const te=U.tokens,re=te.length,pe=G.data,Q=pe.length;let ue=0;const Ie=Math.min(re,Q);for(;ue<Ie&&te[ue]===pe[ue];)ue++;if(ue===re&&ue===Q)return new y.SemanticTokensEdits([],G.resultId);let xe=0;const We=Ie-ue;for(;xe<We&&te[re-xe-1]===pe[Q-xe-1];)xe++;return new y.SemanticTokensEdits([{start:ue,deleteCount:re-ue-xe,data:pe.subarray(ue,Q-xe)}],G.resultId)}_send(U,G){if(z._isSemanticTokens(U)){const te=this._nextResultId++;return this._previousResults.set(te,new H(U.resultId,U.data)),(0,h.encodeSemanticTokensDto)({id:te,type:"full",data:U.data})}if(z._isSemanticTokensEdits(U)){const te=this._nextResultId++;return z._isSemanticTokens(G)?this._previousResults.set(te,new H(G.resultId,G.data)):this._previousResults.set(te,new H(U.resultId)),(0,h.encodeSemanticTokensDto)({id:te,type:"delta",deltas:(U.edits||[]).map(re=>({start:re.start,deleteCount:re.deleteCount,data:re.data}))})}return null}}e.DocumentSemanticTokensAdapter=z;class T{constructor(U,G){this._documents=U,this._provider=G}async provideDocumentRangeSemanticTokens(U,G,te){const re=this._documents.getDocument(U),pe=await this._provider.provideDocumentRangeSemanticTokens(re,D.Range.to(G),te);return pe?this._send(pe):null}_send(U){return(0,h.encodeSemanticTokensDto)({id:0,type:"full",data:U.data})}}e.DocumentRangeSemanticTokensAdapter=T;class q{constructor(U,G,te,re,pe){this._documents=U,this._commands=G,this._provider=te,this._apiDeprecation=re,this._extension=pe,this._cache=new d.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}async provideCompletionItems(U,G,te,re){const pe=this._documents.getDocument(U),Q=D.Position.to(G),ue=pe.getWordRangeAtPosition(Q)||new y.Range(Q,Q),Ie=ue.with({end:Q}),xe=new f.StopWatch(!0),We=await this._provider.provideCompletionItems(pe,Q,re,D.CompletionContext.to(te));if(!We||re.isCancellationRequested)return;const ve=Array.isArray(We)?new y.CompletionList(We):We,tt=q.supportsResolving(this._provider)?this._cache.add(ve.items):this._cache.add([]),W=new l.DisposableStore;this._disposables.set(tt,W);const J=[],fe={x:tt,b:J,a:{replace:D.Range.from(ue),insert:D.Range.from(Ie)},c:ve.isIncomplete||void 0,d:xe.elapsed()};for(let Oe=0;Oe<ve.items.length;Oe++){const Ue=ve.items[Oe],et=this._convertCompletionItem(Ue,[tt,Oe],Ie,ue);J.push(et)}return fe}async resolveCompletionItem(U,G){if(typeof this._provider.resolveCompletionItem!="function")return;const te=this._cache.get(...U);if(!te)return;const re=await this._provider.resolveCompletionItem(te,G);if(!!re)return this._convertCompletionItem(re,U)}releaseCompletionItems(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}_convertCompletionItem(U,G,te,re){const pe=this._disposables.get(G[0]);if(!pe)throw Error("DisposableStore is missing...");const Q={x:G,a:U.label,b:U.kind!==void 0?D.CompletionItemKind.from(U.kind):void 0,n:U.tags&&U.tags.map(D.CompletionItemTag.from),c:U.detail,d:typeof U.documentation=="undefined"?void 0:D.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters,l:U.additionalTextEdits&&U.additionalTextEdits.map(D.TextEdit.from),m:this._commands.toInternal(U.command,pe)};U.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Q.h=U.textEdit.newText):typeof U.insertText=="string"?Q.h=U.insertText:U.insertText instanceof y.SnippetString&&(Q.h=U.insertText.value,Q.i|=4);let ue;return U.textEdit?ue=U.textEdit.range:U.range&&(ue=U.range),y.Range.isRange(ue)?Q.j=D.Range.from(ue):ue&&(!te?.isEqual(ue.inserting)||!re?.isEqual(ue.replacing))&&(Q.j={insert:D.Range.from(ue.inserting),replace:D.Range.from(ue.replacing)}),Q}}class L{constructor(U,G,te){this._documents=U,this._provider=G,this._commands=te,this._cache=new d.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(U,G,te,re){const pe=this._documents.getDocument(U),Q=D.Position.to(G),ue=await this._provider.provideInlineCompletionItems(pe,Q,te,re);if(!ue||re.isCancellationRequested)return;const Ie=(0,n.isArray)(ue)?{items:ue}:ue,xe=this._cache.add(Ie.items);let We;return{pid:xe,items:Ie.items.map((ve,tt)=>{let W;return ve.command&&(We||(We=new l.DisposableStore,this._disposables.set(xe,We)),W=this._commands.toInternal(ve.command,We)),{text:ve.text,range:ve.range?D.Range.from(ve.range):void 0,command:W,idx:tt}})}}disposeCompletions(U){this._cache.delete(U);const G=this._disposables.get(U);G&&G.clear(),this._disposables.delete(U)}handleDidShowCompletionItem(U,G){const te=this._cache.get(U,G);te&&B.get(this._provider).fireOnDidShowCompletionItem({completionItem:te})}}class B{constructor(){this._onDidShowCompletionItemEmitter=new w.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(U){let G=B.map.get(U);return G||(G=new B,B.map.set(U,G)),G}fireOnDidShowCompletionItem(U){this._onDidShowCompletionItemEmitter.fire(U)}}e.InlineCompletionController=B,B.map=new WeakMap;class Y{constructor(U,G){this._documents=U,this._provider=G,this._cache=new d.Cache("SignatureHelp")}async provideSignatureHelp(U,G,te,re){const pe=this._documents.getDocument(U),Q=D.Position.to(G),ue=this.reviveContext(te),Ie=await this._provider.provideSignatureHelp(pe,Q,re,ue);if(Ie){const xe=this._cache.add([Ie]);return{...D.SignatureHelp.from(Ie),id:xe}}}reviveContext(U){let G;if(U.activeSignatureHelp){const te=D.SignatureHelp.to(U.activeSignatureHelp),re=this._cache.get(U.activeSignatureHelp.id,0);re?(G=re,G.activeSignature=te.activeSignature,G.activeParameter=te.activeParameter):G=te}return{...U,activeSignatureHelp:G}}releaseSignatureHelp(U){this._cache.delete(U)}}class j{constructor(U,G){this._documents=U,this._provider=G}async provideInlayHints(U,G,te){const re=this._documents.getDocument(U),pe=await this._provider.provideInlayHints(re,D.Range.to(G),te);return pe?{hints:pe.map(D.InlayHint.from)}:void 0}}class se{constructor(U,G){this._documents=U,this._provider=G,this._cache=new d.Cache("DocumentLink")}async provideLinks(U,G){const te=this._documents.getDocument(U),re=await this._provider.provideDocumentLinks(te,G);if(!(!Array.isArray(re)||re.length===0)&&!G.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:re.filter(se._validateLink).map(D.DocumentLink.from)};{const pe=this._cache.add(re),Q={links:[],id:pe};for(let ue=0;ue<re.length;ue++){if(!se._validateLink(re[ue]))continue;const Ie=D.DocumentLink.from(re[ue]);Ie.cacheId=[pe,ue],Q.links.push(Ie)}return Q}}}static _validateLink(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,G){if(typeof this._provider.resolveDocumentLink!="function")return;const te=this._cache.get(...U);if(!te)return;const re=await this._provider.resolveDocumentLink(te,G);if(!(!re||!se._validateLink(re)))return D.DocumentLink.from(re)}releaseLinks(U){this._cache.delete(U)}}class Se{constructor(U,G){this._documents=U,this._provider=G}async provideColors(U,G){const te=this._documents.getDocument(U),re=await this._provider.provideDocumentColors(te,G);return Array.isArray(re)?re.map(Q=>({color:D.Color.from(Q.color),range:D.Range.from(Q.range)})):[]}async provideColorPresentations(U,G,te){const re=this._documents.getDocument(U),pe=D.Range.to(G.range),Q=D.Color.to(G.color),ue=await this._provider.provideColorPresentations(Q,{document:re,range:pe},te);if(!!Array.isArray(ue))return ue.map(D.ColorPresentation.from)}}class Re{constructor(U,G){this._documents=U,this._provider=G}async provideFoldingRanges(U,G,te){const re=this._documents.getDocument(U),pe=await this._provider.provideFoldingRanges(re,G,te);if(!!Array.isArray(pe))return pe.map(D.FoldingRange.from)}}class $e{constructor(U,G,te){this._documents=U,this._provider=G,this._logService=te}async provideSelectionRanges(U,G,te){const re=this._documents.getDocument(U),pe=G.map(D.Position.to),Q=await this._provider.provideSelectionRanges(re,pe,te);if(!(0,C.isNonEmptyArray)(Q))return[];if(Q.length!==pe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ue=[];for(let Ie=0;Ie<pe.length;Ie++){const xe=[];ue.push(xe);let We=pe[Ie],ve=Q[Ie];for(;;){if(!ve.range.contains(We))throw new Error("INVALID selection range, must contain the previous range");if(xe.push(D.SelectionRange.from(ve)),!ve.parent)break;We=ve.range,ve=ve.parent}}return ue}}class Ne{constructor(U,G){this._documents=U,this._provider=G,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(U,G,te){const re=this._documents.getDocument(U),pe=D.Position.to(G),Q=await this._provider.prepareCallHierarchy(re,pe,te);if(!Q)return;const ue=this._idPool.nextId();return this._cache.set(ue,new Map),Array.isArray(Q)?Q.map(Ie=>this._cacheAndConvertItem(ue,Ie)):[this._cacheAndConvertItem(ue,Q)]}async provideCallsTo(U,G,te){const re=this._itemFromCache(U,G);if(!re)throw new Error("missing call hierarchy item");const pe=await this._provider.provideCallHierarchyIncomingCalls(re,te);if(!!pe)return pe.map(Q=>({from:this._cacheAndConvertItem(U,Q.from),fromRanges:Q.fromRanges.map(ue=>D.Range.from(ue))}))}async provideCallsFrom(U,G,te){const re=this._itemFromCache(U,G);if(!re)throw new Error("missing call hierarchy item");const pe=await this._provider.provideCallHierarchyOutgoingCalls(re,te);if(!!pe)return pe.map(Q=>({to:this._cacheAndConvertItem(U,Q.to),fromRanges:Q.fromRanges.map(ue=>D.Range.from(ue))}))}releaseSession(U){this._cache.delete(U)}_cacheAndConvertItem(U,G){const te=this._cache.get(U),re={_sessionId:U,_itemId:te.size.toString(36),name:G.name,detail:G.detail,kind:D.SymbolKind.from(G.kind),uri:G.uri,range:D.Range.from(G.range),selectionRange:D.Range.from(G.selectionRange),tags:G.tags?.map(D.SymbolTag.from)};return te.set(re._itemId,G),re}_itemFromCache(U,G){return this._cache.get(U)?.get(G)}}class Ge{constructor(U,G){this.adapter=U,this.extension=G}}class Ke{constructor(U,G,te,re,pe,Q,ue){this._adapter=new Map,this._uriTransformer=G,this._proxy=U.getProxy(I.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=re,this._diagnostics=pe,this._logService=Q,this._apiDeprecation=ue}_transformDocumentSelector(U){return(0,C.coalesce)((0,C.asArray)(U).map(G=>this._doTransformDocumentSelector(G)))}_doTransformDocumentSelector(U){if(typeof U=="string")return{$serialized:!0,language:U};if(U)return{$serialized:!0,language:U.language,scheme:this._transformScheme(U.scheme),pattern:typeof U.pattern=="undefined"?void 0:D.GlobPattern.from(U.pattern),exclusive:U.exclusive}}_transformScheme(U){return this._uriTransformer&&typeof U=="string"?this._uriTransformer.transformOutgoingScheme(U):U}_createDisposable(U){return new y.Disposable(()=>{this._adapter.delete(U),this._proxy.$unregister(U)})}_nextHandle(){return Ke._handlePool++}_withAdapter(U,G,te,re,pe=!1){const Q=this._adapter.get(U);if(!Q)return Promise.resolve(re);if(Q.adapter instanceof G){let ue;Q.extension&&(ue=Date.now(),this._logService.trace(`[${Q.extension.identifier.value}] INVOKE provider '${G.name}'`));const Ie=te(Q.adapter,Q.extension),xe=Q.extension;return xe&&Promise.resolve(Ie).then(()=>this._logService.trace(`[${xe.identifier.value}] provider DONE after ${Date.now()-ue}ms`),We=>{pe&&We instanceof E.CancellationError||(this._logService.error(`[${xe.identifier.value}] provider FAILED`),this._logService.error(We))}),Ie}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(U,G){const te=this._nextHandle();return this._adapter.set(te,new Ge(U,G)),te}static _extLabel(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,G,te,re){const pe=this._addNewAdapter(new u(this._documents,te),U),Q=re&&re.label||Ke._extLabel(U);return this._proxy.$registerDocumentSymbolProvider(pe,this._transformDocumentSelector(G),Q),this._createDisposable(pe)}$provideDocumentSymbols(U,G,te){return this._withAdapter(U,u,re=>re.provideDocumentSymbols(m.URI.revive(G),te),void 0)}registerCodeLensProvider(U,G,te){const re=this._nextHandle(),pe=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(re,new Ge(new g(this._documents,this._commands.converter,te),U)),this._proxy.$registerCodeLensSupport(re,this._transformDocumentSelector(G),pe);let Q=this._createDisposable(re);if(pe!==void 0){const ue=te.onDidChangeCodeLenses(Ie=>this._proxy.$emitCodeLensEvent(pe));Q=y.Disposable.from(Q,ue)}return Q}$provideCodeLenses(U,G,te){return this._withAdapter(U,g,re=>re.provideCodeLenses(m.URI.revive(G),te),void 0)}$resolveCodeLens(U,G,te){return this._withAdapter(U,g,re=>re.resolveCodeLens(G,te),void 0)}$releaseCodeLenses(U,G){this._withAdapter(U,g,te=>Promise.resolve(te.releaseCodeLenses(G)),void 0)}registerDefinitionProvider(U,G,te){const re=this._addNewAdapter(new t(this._documents,te),U);return this._proxy.$registerDefinitionSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideDefinition(U,G,te,re){return this._withAdapter(U,t,pe=>pe.provideDefinition(m.URI.revive(G),te,re),[])}registerDeclarationProvider(U,G,te){const re=this._addNewAdapter(new s(this._documents,te),U);return this._proxy.$registerDeclarationSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideDeclaration(U,G,te,re){return this._withAdapter(U,s,pe=>pe.provideDeclaration(m.URI.revive(G),te,re),[])}registerImplementationProvider(U,G,te){const re=this._addNewAdapter(new i(this._documents,te),U);return this._proxy.$registerImplementationSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideImplementation(U,G,te,re){return this._withAdapter(U,i,pe=>pe.provideImplementation(m.URI.revive(G),te,re),[])}registerTypeDefinitionProvider(U,G,te){const re=this._addNewAdapter(new r(this._documents,te),U);return this._proxy.$registerTypeDefinitionSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideTypeDefinition(U,G,te,re){return this._withAdapter(U,r,pe=>pe.provideTypeDefinition(m.URI.revive(G),te,re),[])}registerHoverProvider(U,G,te,re){const pe=this._addNewAdapter(new c(this._documents,te),U);return this._proxy.$registerHoverProvider(pe,this._transformDocumentSelector(G)),this._createDisposable(pe)}$provideHover(U,G,te,re){return this._withAdapter(U,c,pe=>pe.provideHover(m.URI.revive(G),te,re),void 0)}registerEvaluatableExpressionProvider(U,G,te,re){const pe=this._addNewAdapter(new p(this._documents,te),U);return this._proxy.$registerEvaluatableExpressionProvider(pe,this._transformDocumentSelector(G)),this._createDisposable(pe)}$provideEvaluatableExpression(U,G,te,re){return this._withAdapter(U,p,pe=>pe.provideEvaluatableExpression(m.URI.revive(G),te,re),void 0)}registerInlineValuesProvider(U,G,te,re){const pe=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Q=this._addNewAdapter(new v(this._documents,te),U);this._proxy.$registerInlineValuesProvider(Q,this._transformDocumentSelector(G),pe);let ue=this._createDisposable(Q);if(pe!==void 0){const Ie=te.onDidChangeInlineValues(xe=>this._proxy.$emitInlineValuesEvent(pe));ue=y.Disposable.from(ue,Ie)}return ue}$provideInlineValues(U,G,te,re,pe){return this._withAdapter(U,v,Q=>Q.provideInlineValues(m.URI.revive(G),te,re,pe),void 0)}registerDocumentHighlightProvider(U,G,te){const re=this._addNewAdapter(new A(this._documents,te),U);return this._proxy.$registerDocumentHighlightProvider(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideDocumentHighlights(U,G,te,re){return this._withAdapter(U,A,pe=>pe.provideDocumentHighlights(m.URI.revive(G),te,re),void 0)}registerLinkedEditingRangeProvider(U,G,te){const re=this._addNewAdapter(new R(this._documents,te),U);return this._proxy.$registerLinkedEditingRangeProvider(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideLinkedEditingRanges(U,G,te,re){return this._withAdapter(U,R,async pe=>{const Q=await pe.provideLinkedEditingRanges(m.URI.revive(G),te,re);if(Q)return{ranges:Q.ranges,wordPattern:Q.wordPattern?Ke._serializeRegExp(Q.wordPattern):void 0}},void 0)}registerReferenceProvider(U,G,te){const re=this._addNewAdapter(new o(this._documents,te),U);return this._proxy.$registerReferenceSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideReferences(U,G,te,re,pe){return this._withAdapter(U,o,Q=>Q.provideReferences(m.URI.revive(G),te,re,pe),void 0)}registerCodeActionProvider(U,G,te,re){const pe=new l.DisposableStore,Q=this._addNewAdapter(new P(this._documents,this._commands.converter,this._diagnostics,te,this._logService,U,this._apiDeprecation),U);return this._proxy.$registerQuickFixSupport(Q,this._transformDocumentSelector(G),{providedKinds:re?.providedCodeActionKinds?.map(ue=>ue.value),documentation:re?.documentation?.map(ue=>({kind:ue.kind.value,command:this._commands.converter.toInternal(ue.command,pe)}))},Ke._extLabel(U),Boolean(te.resolveCodeAction)),pe.add(this._createDisposable(Q)),pe}$provideCodeActions(U,G,te,re,pe){return this._withAdapter(U,P,Q=>Q.provideCodeActions(m.URI.revive(G),te,re,pe),void 0)}$resolveCodeAction(U,G,te){return this._withAdapter(U,P,re=>re.resolveCodeAction(G,te),void 0)}$releaseCodeActions(U,G){this._withAdapter(U,P,te=>Promise.resolve(te.releaseCodeActions(G)),void 0)}registerDocumentFormattingEditProvider(U,G,te){const re=this._addNewAdapter(new N(this._documents,te),U);return this._proxy.$registerDocumentFormattingSupport(re,this._transformDocumentSelector(G),U.identifier,U.displayName||U.name),this._createDisposable(re)}$provideDocumentFormattingEdits(U,G,te,re){return this._withAdapter(U,N,pe=>pe.provideDocumentFormattingEdits(m.URI.revive(G),te,re),void 0)}registerDocumentRangeFormattingEditProvider(U,G,te){const re=this._addNewAdapter(new $(this._documents,te),U);return this._proxy.$registerRangeFormattingSupport(re,this._transformDocumentSelector(G),U.identifier,U.displayName||U.name),this._createDisposable(re)}$provideDocumentRangeFormattingEdits(U,G,te,re,pe){return this._withAdapter(U,$,Q=>Q.provideDocumentRangeFormattingEdits(m.URI.revive(G),te,re,pe),void 0)}registerOnTypeFormattingEditProvider(U,G,te,re){const pe=this._addNewAdapter(new ie(this._documents,te),U);return this._proxy.$registerOnTypeFormattingSupport(pe,this._transformDocumentSelector(G),re,U.identifier),this._createDisposable(pe)}$provideOnTypeFormattingEdits(U,G,te,re,pe,Q){return this._withAdapter(U,ie,ue=>ue.provideOnTypeFormattingEdits(m.URI.revive(G),te,re,pe,Q),void 0)}registerWorkspaceSymbolProvider(U,G){const te=this._addNewAdapter(new ce(G,this._logService),U);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols(U,G,te){return this._withAdapter(U,ce,re=>re.provideWorkspaceSymbols(G,te),{symbols:[]})}$resolveWorkspaceSymbol(U,G,te){return this._withAdapter(U,ce,re=>re.resolveWorkspaceSymbol(G,te),void 0)}$releaseWorkspaceSymbols(U,G){this._withAdapter(U,ce,te=>te.releaseWorkspaceSymbols(G),void 0)}registerRenameProvider(U,G,te){const re=this._addNewAdapter(new K(this._documents,te,this._logService),U);return this._proxy.$registerRenameSupport(re,this._transformDocumentSelector(G),K.supportsResolving(te)),this._createDisposable(re)}$provideRenameEdits(U,G,te,re,pe){return this._withAdapter(U,K,Q=>Q.provideRenameEdits(m.URI.revive(G),te,re,pe),void 0)}$resolveRenameLocation(U,G,te,re){return this._withAdapter(U,K,pe=>pe.resolveRenameLocation(m.URI.revive(G),te,re),void 0)}registerDocumentSemanticTokensProvider(U,G,te,re){const pe=this._nextHandle(),Q=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(pe,new Ge(new z(this._documents,te),U)),this._proxy.$registerDocumentSemanticTokensProvider(pe,this._transformDocumentSelector(G),re,Q);let ue=this._createDisposable(pe);if(Q){const Ie=te.onDidChangeSemanticTokens(xe=>this._proxy.$emitDocumentSemanticTokensEvent(Q));ue=y.Disposable.from(ue,Ie)}return ue}$provideDocumentSemanticTokens(U,G,te,re){return this._withAdapter(U,z,pe=>pe.provideDocumentSemanticTokens(m.URI.revive(G),te,re),null,!0)}$releaseDocumentSemanticTokens(U,G){this._withAdapter(U,z,te=>te.releaseDocumentSemanticColoring(G),void 0)}registerDocumentRangeSemanticTokensProvider(U,G,te,re){const pe=this._addNewAdapter(new T(this._documents,te),U);return this._proxy.$registerDocumentRangeSemanticTokensProvider(pe,this._transformDocumentSelector(G),re),this._createDisposable(pe)}$provideDocumentRangeSemanticTokens(U,G,te,re){return this._withAdapter(U,T,pe=>pe.provideDocumentRangeSemanticTokens(m.URI.revive(G),te,re),null,!0)}registerCompletionItemProvider(U,G,te,re){const pe=this._addNewAdapter(new q(this._documents,this._commands.converter,te,this._apiDeprecation,U),U);return this._proxy.$registerSuggestSupport(pe,this._transformDocumentSelector(G),re,q.supportsResolving(te),`${U.identifier.value}(${re.join("")})`),this._createDisposable(pe)}$provideCompletionItems(U,G,te,re,pe){return this._withAdapter(U,q,Q=>Q.provideCompletionItems(m.URI.revive(G),te,re,pe),void 0)}$resolveCompletionItem(U,G,te){return this._withAdapter(U,q,re=>re.resolveCompletionItem(G,te),void 0)}$releaseCompletionItems(U,G){this._withAdapter(U,q,te=>te.releaseCompletionItems(G),void 0)}registerInlineCompletionsProvider(U,G,te){const re=this._addNewAdapter(new L(this._documents,te,this._commands.converter),U);return this._proxy.$registerInlineCompletionsSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideInlineCompletions(U,G,te,re,pe){return this._withAdapter(U,L,Q=>Q.provideInlineCompletions(m.URI.revive(G),te,re,pe),void 0)}$handleInlineCompletionDidShow(U,G,te){this._withAdapter(U,L,async re=>{re.handleDidShowCompletionItem(G,te)},void 0)}$freeInlineCompletionsList(U,G){this._withAdapter(U,L,async te=>{te.disposeCompletions(G)},void 0)}registerSignatureHelpProvider(U,G,te,re){const pe=Array.isArray(re)?{triggerCharacters:re,retriggerCharacters:[]}:re,Q=this._addNewAdapter(new Y(this._documents,te),U);return this._proxy.$registerSignatureHelpProvider(Q,this._transformDocumentSelector(G),pe),this._createDisposable(Q)}$provideSignatureHelp(U,G,te,re,pe){return this._withAdapter(U,Y,Q=>Q.provideSignatureHelp(m.URI.revive(G),te,re,pe),void 0)}$releaseSignatureHelp(U,G){this._withAdapter(U,Y,te=>te.releaseSignatureHelp(G),void 0)}registerInlayHintsProvider(U,G,te){const re=typeof te.onDidChangeInlayHints=="function"?this._nextHandle():void 0,pe=this._addNewAdapter(new j(this._documents,te),U);this._proxy.$registerInlayHintsProvider(pe,this._transformDocumentSelector(G),re);let Q=this._createDisposable(pe);if(re!==void 0){const ue=te.onDidChangeInlayHints(Ie=>this._proxy.$emitInlayHintsEvent(re));Q=y.Disposable.from(Q,ue)}return Q}$provideInlayHints(U,G,te,re){return this._withAdapter(U,j,pe=>pe.provideInlayHints(m.URI.revive(G),te,re),void 0)}registerDocumentLinkProvider(U,G,te){const re=this._addNewAdapter(new se(this._documents,te),U);return this._proxy.$registerDocumentLinkProvider(re,this._transformDocumentSelector(G),typeof te.resolveDocumentLink=="function"),this._createDisposable(re)}$provideDocumentLinks(U,G,te){return this._withAdapter(U,se,re=>re.provideLinks(m.URI.revive(G),te),void 0)}$resolveDocumentLink(U,G,te){return this._withAdapter(U,se,re=>re.resolveLink(G,te),void 0)}$releaseDocumentLinks(U,G){this._withAdapter(U,se,te=>te.releaseLinks(G),void 0)}registerColorProvider(U,G,te){const re=this._addNewAdapter(new Se(this._documents,te),U);return this._proxy.$registerDocumentColorProvider(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideDocumentColors(U,G,te){return this._withAdapter(U,Se,re=>re.provideColors(m.URI.revive(G),te),[])}$provideColorPresentations(U,G,te,re){return this._withAdapter(U,Se,pe=>pe.provideColorPresentations(m.URI.revive(G),te,re),void 0)}registerFoldingRangeProvider(U,G,te){const re=this._nextHandle(),pe=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(re,new Ge(new Re(this._documents,te),U)),this._proxy.$registerFoldingRangeProvider(re,this._transformDocumentSelector(G),pe);let Q=this._createDisposable(re);if(pe!==void 0){const ue=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(pe));Q=y.Disposable.from(Q,ue)}return Q}$provideFoldingRanges(U,G,te,re){return this._withAdapter(U,Re,pe=>pe.provideFoldingRanges(m.URI.revive(G),te,re),void 0)}registerSelectionRangeProvider(U,G,te){const re=this._addNewAdapter(new $e(this._documents,te,this._logService),U);return this._proxy.$registerSelectionRangeProvider(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideSelectionRanges(U,G,te,re){return this._withAdapter(U,$e,pe=>pe.provideSelectionRanges(m.URI.revive(G),te,re),[])}registerCallHierarchyProvider(U,G,te){const re=this._addNewAdapter(new Ne(this._documents,te),U);return this._proxy.$registerCallHierarchyProvider(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$prepareCallHierarchy(U,G,te,re){return this._withAdapter(U,Ne,pe=>Promise.resolve(pe.prepareSession(m.URI.revive(G),te,re)),void 0)}$provideCallHierarchyIncomingCalls(U,G,te,re){return this._withAdapter(U,Ne,pe=>pe.provideCallsTo(G,te,re),void 0)}$provideCallHierarchyOutgoingCalls(U,G,te,re){return this._withAdapter(U,Ne,pe=>pe.provideCallsFrom(G,te,re),void 0)}$releaseCallHierarchy(U,G){this._withAdapter(U,Ne,te=>Promise.resolve(te.releaseSession(G)),void 0)}static _serializeRegExp(U){return{pattern:U.source,flags:(0,S.regExpFlags)(U)}}static _serializeIndentationRule(U){return{decreaseIndentPattern:Ke._serializeRegExp(U.decreaseIndentPattern),increaseIndentPattern:Ke._serializeRegExp(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?Ke._serializeRegExp(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?Ke._serializeRegExp(U.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(U){return{beforeText:Ke._serializeRegExp(U.beforeText),afterText:U.afterText?Ke._serializeRegExp(U.afterText):void 0,previousLineText:U.previousLineText?Ke._serializeRegExp(U.previousLineText):void 0,action:U.action}}static _serializeOnEnterRules(U){return U.map(Ke._serializeOnEnterRule)}setLanguageConfiguration(U,G,te){let{wordPattern:re}=te;if(re&&(0,S.regExpLeadsToEndlessLoop)(re))throw new Error(`Invalid language configuration: wordPattern '${re}' is not allowed to match the empty string.`);re?this._documents.setWordDefinitionFor(G,re):this._documents.setWordDefinitionFor(G,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const pe=this._nextHandle(),Q={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?Ke._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?Ke._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?Ke._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(pe,G,Q),this._createDisposable(pe)}$setWordDefinitions(U){for(const G of U)this._documents.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.ExtHostLanguageFeatures=Ke,Ke._handlePool=0}),define(_e[195],ye([0,1,5,9,6]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(S,_){this._proxy=S.getProxy(m.MainContext.MainThreadLanguages),this._documents=_}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(S,_){await this._proxy.$changeLanguage(S,_);const C=this._documents.getDocumentData(S);if(!C)throw new Error(`document '${S.toString}' NOT found`);return C.document}async tokenAtPosition(S,_){const C=S.version,n=F.Position.from(_),k=await this._proxy.$tokensAtPosition(S.uri,n),l={type:D.StandardTokenType.Other,range:S.getWordRangeAtPosition(_)??new D.Range(_.line,_.character,_.line,_.character)};if(!k)return l;const h={range:F.Range.to(k.range),type:F.TokenType.to(k.type)};return!h.range.contains(_)||C!==S.version?l:h}}e.ExtHostLanguages=y}),define(_e[196],ye([0,1,5,15,29]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function y(S){return S&&S.title}let I=class{constructor(_,C){this._logService=C,this._proxy=_.getProxy(m.MainContext.MainThreadMessageService)}showMessage(_,C,n,k,l){const h={extension:_};let a;typeof k=="string"||y(k)?a=[k,...l]:(h.modal=k?.modal,h.useCustom=k?.useCustom,h.detail=k?.detail,a=l),h.useCustom&&(0,D.checkProposedApiEnabled)(_);const d=[];for(let f=0;f<a.length;f++){const E=a[f];if(typeof E=="string")d.push({title:E,handle:f,isCloseAffordance:!1});else if(typeof E=="object"){let{title:w,isCloseAffordance:u}=E;d.push({title:w,isCloseAffordance:!!u,handle:f})}else this._logService.warn("Invalid message item:",E)}return this._proxy.$showMessage(C,n,h,d).then(f=>{if(typeof f=="number")return a[f]})}};I=ze([je(1,F.ILogService)],I),e.ExtHostMessageService=I}),define(_e[197],ye([0,1,23,3,41,7,22,8,10,2,63,5,9,6,174,98]),function(ee,e,m,F,D,y,I,S,_,C,n,k,l,h,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class f{constructor(w,u,g,b,t){this._textDocumentsAndEditors=g,this._textDocuments=b,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new I.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new F.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new F.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new F.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new F.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new F.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new F.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new F.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new F.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new n.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=w.getProxy(k.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=w.getProxy(k.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=w.getProxy(k.MainContext.MainThreadNotebookEditors),this._commandsConverter=u.converter,u.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const i=s.notebookEditor?.notebookUri,r=s.cell.handle,p=this._documents.get(i)?.getCell(r);if(p)return p.apiCell}return s}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(w=>w.apiEditor)}getEditorById(w){const u=this._editors.get(w);if(!u)throw new Error(`unknown text editor: ${w}. known editors: ${[...this._editors.keys()]} `);return u}getIdByEditor(w){for(const[u,g]of this._editors)if(g.apiEditor===w)return u}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(w,u){const g=this._documents.get(w);if(!g&&!u)throw new Error(`NO notebook document for '${w}'`);return g}_getProviderData(w){const u=this._notebookContentProviders.get(w);if(!u)throw new Error(`NO provider for '${w}'`);return u}registerNotebookContentProvider(w,u,g,b,t){if((0,S.isFalsyOrWhitespace)(u))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(u))throw new Error(`Notebook provider for '${u}' already registered`);this._notebookContentProviders.set(u,{extension:w,provider:g});let s;return g.onDidChangeNotebookContentOptions&&(s=g.onDidChangeNotebookContentOptions(()=>{const i=l.NotebookDocumentContentOptions.from(g.options);this._notebookProxy.$updateNotebookProviderOptions(u,i)})),this._notebookProxy.$registerNotebookProvider({id:w.identifier,location:w.extensionLocation},u,l.NotebookDocumentContentOptions.from(b),f._convertNotebookRegistrationData(w,t)),new h.Disposable(()=>{s?.dispose(),this._notebookContentProviders.delete(u),this._notebookProxy.$unregisterNotebookProvider(u)})}static _convertNotebookRegistrationData(w,u){if(!u)return;const g=u.filenamePattern.map(b=>l.NotebookExclusiveDocumentPattern.from(b)).filter(b=>b!==void 0);if(u.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${u.filenamePattern}`);return}return{extension:w.identifier,providerDisplayName:w.displayName||w.name,displayName:u.displayName,filenamePattern:g,exclusive:u.exclusive||!1}}registerNotebookCellStatusBarItemProvider(w,u,g){const b=f._notebookStatusBarItemProviderHandlePool++,t=typeof g.onDidChangeCellStatusBarItems=="function"?f._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(b,g),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(b,t,u);let s;return t!==void 0&&(s=g.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(t))),new h.Disposable(()=>{this._notebookStatusBarItemProviders.delete(b),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(b,t),s&&s.dispose()})}async createNotebookDocument(w){const u=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:w.viewType,content:w.content&&l.NotebookData.from(w.content)});return C.URI.revive(u)}async openNotebookDocument(w){const u=this._documents.get(w);if(u)return u.apiNotebook;const g=await this._notebookDocumentsProxy.$tryOpenNotebook(w),b=this._documents.get(C.URI.revive(g));return(0,_.assertIsDefined)(b?.apiNotebook)}async showNotebookDocument(w,u){C.URI.isUri(w)&&(w=await this.openNotebookDocument(w));let g;typeof u=="object"?g={position:l.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selections:u.selections&&u.selections.map(l.NotebookRange.from),pinned:typeof u.preview=="boolean"?!u.preview:void 0}:g={preserveFocus:!1};const b=await this._notebookEditorsProxy.$tryShowNotebookDocument(w.uri,w.notebookType,g),t=b&&this._editors.get(b)?.apiEditor;if(t)return t;throw b?new Error(`Could NOT open editor for "${w.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${w.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(w,u,g,b){const t=this._notebookStatusBarItemProviders.get(w),s=C.URI.revive(u),i=this._documents.get(s);if(!i||!t)return;const r=i.getCellFromIndex(g);if(!r)return;const c=await t.provideCellStatusBarItems(r.apiCell,b);if(!c)return;const p=new y.DisposableStore,v=this._statusBarCache.add([p]),R=(Array.isArray(c)?c:[c]).map(o=>l.NotebookStatusBarItem.from(o,this._commandsConverter,p));return{cacheId:v,items:R}}$releaseNotebookCellStatusBarItems(w){this._statusBarCache.delete(w)}registerNotebookSerializer(w,u,g,b,t){if((0,S.isFalsyOrWhitespace)(u))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,g),this._notebookProxy.$registerNotebookSerializer(s,{id:w.identifier,location:w.extensionLocation},u,l.NotebookDocumentContentOptions.from(b),f._convertNotebookRegistrationData(w,t)),(0,y.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(w,u,g){const b=this._notebookSerializer.get(w);if(!b)throw new Error("NO serializer found");const t=await b.deserializeNotebook(u.buffer,g);return l.NotebookData.from(t)}async $notebookToData(w,u,g){const b=this._notebookSerializer.get(w);if(!b)throw new Error("NO serializer found");const t=await b.serializeNotebook(l.NotebookData.to(u),g);return m.VSBuffer.wrap(t)}async $openNotebook(w,u,g,b,t){const{provider:s}=this._getProviderData(w),i=await s.openNotebook(C.URI.revive(u),{backupId:g,untitledDocumentData:b?.buffer},t);return{metadata:i.metadata??Object.create(null),cells:i.cells.map(l.NotebookCellData.from)}}async $saveNotebook(w,u,g){const b=this.getNotebookDocument(C.URI.revive(u)),{provider:t}=this._getProviderData(w);return await t.saveNotebook(b.apiNotebook,g),!0}async $saveNotebookAs(w,u,g,b){const t=this.getNotebookDocument(C.URI.revive(u)),{provider:s}=this._getProviderData(w);return await s.saveNotebookAs(C.URI.revive(g),t.apiNotebook,b),!0}async $backupNotebook(w,u,g){const b=this.getNotebookDocument(C.URI.revive(u)),t=this._getProviderData(w),s=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension),i=String((0,D.hash)([b.uri.toString(),this._backupIdPool++])),r=C.URI.joinPath(s,i),c=await t.provider.backupNotebook(b.apiNotebook,{destination:r},g);return b.updateBackup(c),c.id}_createExtHostEditor(w,u,g){if(this._editors.has(u))throw new Error(`editor with id ALREADY EXSIST: ${u}`);const b=new d.ExtHostNotebookEditor(u,this._notebookEditorsProxy,w,g.visibleRanges.map(l.NotebookRange.to),g.selections.map(l.NotebookRange.to),typeof g.viewColumn=="number"?l.ViewColumn.to(g.viewColumn):void 0);this._editors.set(u,b)}$acceptDocumentAndEditorsDelta(w){if(w.removedDocuments)for(const g of w.removedDocuments){const b=C.URI.revive(g),t=this._documents.get(b);t&&(t.dispose(),this._documents.delete(b),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:t.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(t.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===b.toString()&&this._editors.delete(s.id)}if(w.addedDocuments){const g=[];for(const b of w.addedDocuments){const t=C.URI.revive(b.uri);if(this._documents.has(t))throw new Error(`adding EXISTING notebook ${t} `);const s=this,i=new a.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(r){s._onDidChangeNotebookCells.fire(r)},emitCellOutputsChange(r){s._onDidChangeCellOutputs.fire(r)},emitCellMetadataChange(r){s._onDidChangeCellMetadata.fire(r)},emitCellExecutionStateChange(r){s._onDidChangeCellExecutionState.fire(r)}},t,b);g.push(...b.cells.map(r=>a.ExtHostCell.asModelAddData(i.apiNotebook,r))),this._documents.get(t)?.dispose(),this._documents.set(t,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(w.addedEditors)for(const g of w.addedEditors){if(this._editors.has(g.id))return;const b=C.URI.revive(g.documentUri),t=this._documents.get(b);t&&this._createExtHostEditor(t,g.id,g)}const u=[];if(w.removedEditors)for(const g of w.removedEditors){const b=this._editors.get(g);b&&(this._editors.delete(g),this._activeNotebookEditor?.id===b.id&&(this._activeNotebookEditor=void 0),u.push(b))}if(w.visibleEditors){this._visibleNotebookEditors=w.visibleEditors.map(b=>this._editors.get(b)).filter(b=>!!b);const g=new Set;this._visibleNotebookEditors.forEach(b=>g.add(b.id));for(const b of this._editors.values()){const t=g.has(b.id);b._acceptVisibility(t)}this._visibleNotebookEditors=[...this._editors.values()].map(b=>b).filter(b=>b.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}w.newActiveEditor===null?this._activeNotebookEditor=void 0:w.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(w.newActiveEditor)),w.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=f,f._notebookStatusBarItemProviderHandlePool=0}),define(_e[198],ye([0,1,3,50,15,5,13,9]),function(ee,e,m,F,D,y,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class _{constructor(k,l){const h=_._Keys.nextId();k.$registerNotebookEditorDecorationType(h,S.NotebookDecorationRenderOptions.from(l)),this.value={key:h,dispose(){k.$removeNotebookEditorDecorationType(h)}}}}_._Keys=new F.IdGenerator("NotebookEditorDecorationType");let C=class{constructor(k,l,h){this._logService=k,this._extHostRpc=l,this._notebooksAndEditors=h,this._onDidChangeNotebookEditorSelection=new m.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new m.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(k){return new _(this._extHostRpc.getProxy(y.MainContext.MainThreadNotebookEditors),k).value}$acceptEditorPropertiesChanged(k,l){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",k,l);const h=this._notebooksAndEditors.getEditorById(k);l.visibleRanges&&h._acceptVisibleRanges(l.visibleRanges.ranges.map(S.NotebookRange.to)),l.selections&&h._acceptSelections(l.selections.selections.map(S.NotebookRange.to)),l.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:h.apiEditor,visibleRanges:h.apiEditor.visibleRanges}),l.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:h.apiEditor,selections:h.apiEditor.selections}))}$acceptEditorViewColumns(k){for(const l in k)this._notebooksAndEditors.getEditorById(l)._acceptViewColumn(S.ViewColumn.to(k[l]))}};C=ze([je(0,D.ILogService),je(1,I.IExtHostRpcService)],C),e.ExtHostNotebookEditors=C}),define(_e[199],ye([0,1,3,7,5,26,2,9,68,22,16,69,18,17,15,6,29]),function(ee,e,m,F,D,y,I,S,_,C,n,k,l,h,a,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let E=class{constructor(t,s,i,r){this._initData=s,this._extHostNotebook=i,this._logService=r,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(D.MainContext.MainThreadNotebookKernels)}createNotebookController(t,s,i,r,c,p){for(let L of this._kernelData.values())if(L.controller.id===s&&y.ExtensionIdentifier.equals(t.identifier,L.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const v=this._handlePool++,A=this;this._logService.trace(`NotebookController[${v}], CREATED by ${t.identifier.value}, ${s}`);const R=()=>console.warn(`NO execute handler from notebook controller '${ie.id}' of extension: '${t.identifier}'`);let o=!1;const P=new F.DisposableStore,N=new m.Emitter,$=new m.Emitter,ie={id:`${t.identifier.value}/${s}`,notebookType:i,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:r||t.identifier.value,preloads:p?p.map(S.NotebookRendererScript.from):[]};let ce=c??R,K;this._proxy.$addKernel(v,ie).catch(L=>{console.log(L),o=!0});let H=0;const z=()=>{if(o)return;const L=++H;Promise.resolve().then(()=>{L===H&&this._proxy.$updateKernel(v,ie)})},T=new C.ResourceMap,q={get id(){return s},get notebookType(){return ie.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return ie.label},set label(L){ie.label=L??t.displayName??t.name,z()},get detail(){return ie.detail??""},set detail(L){ie.detail=L,z()},get description(){return ie.description??""},set description(L){ie.description=L,z()},get supportedLanguages(){return ie.supportedLanguages},set supportedLanguages(L){ie.supportedLanguages=L,z()},get supportsExecutionOrder(){return ie.supportsExecutionOrder??!1},set supportsExecutionOrder(L){ie.supportsExecutionOrder=L,z()},get rendererScripts(){return ie.preloads?ie.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return ce},set executeHandler(L){ce=L??R},get interruptHandler(){return K},set interruptHandler(L){K=L,ie.supportsInterrupt=Boolean(L),z()},createNotebookCellExecution(L){if(o)throw new Error("notebook controller is DISPOSED");if(!T.has(L.notebook.uri))throw A._logService.trace(`NotebookController[${v}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(T.keys()).map(B=>B.toString())),new Error(`notebook controller is NOT associated to notebook: ${L.notebook.uri.toString()}`);return A._createNotebookCellExecution(L)},dispose:()=>{o||(this._logService.trace(`NotebookController[${v}], DISPOSED`),o=!0,this._kernelData.delete(v),P.dispose(),N.dispose(),$.dispose(),this._proxy.$removeKernel(v))},updateNotebookAffinity(L,B){A._proxy.$updateNotebookPriority(v,L.uri,B)},onDidReceiveMessage:$.event,postMessage(L,B){return(0,f.checkProposedApiEnabled)(t),A._proxy.$postMessage(v,B&&A._extHostNotebook.getIdByEditor(B),L)},asWebviewUri(L){return(0,f.checkProposedApiEnabled)(t),(0,_.asWebviewUri)(L,A._initData.remote)}};return this._kernelData.set(v,{extensionId:t.identifier,controller:q,onDidReceiveMessage:$,onDidChangeSelection:N,associatedNotebooks:T}),q}$acceptNotebookAssociation(t,s,i){const r=this._kernelData.get(t);if(r){const c=this._extHostNotebook.getNotebookDocument(I.URI.revive(s));i?r.associatedNotebooks.set(c.uri,!0):r.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,c.uri.toString(),i),r.onDidChangeSelection.fire({selected:i,notebook:c.apiNotebook})}}async $executeCells(t,s,i){const r=this._kernelData.get(t);if(!r)return;const c=this._extHostNotebook.getNotebookDocument(I.URI.revive(s)),p=[];for(let v of i){const A=c.getCell(v);A&&p.push(A.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,c.uri.toString(),p.length),await r.controller.executeHandler.call(r.controller,p,c.apiNotebook,r.controller)}catch(v){this._logService.error(`NotebookController[${t}] execute cells FAILED`,v),console.error(v)}}async $cancelCells(t,s,i){const r=this._kernelData.get(t);if(!r)return;const c=this._extHostNotebook.getNotebookDocument(I.URI.revive(s));if(r.controller.interruptHandler)await r.controller.interruptHandler.call(r.controller,c.apiNotebook);else for(let p of i){const v=c.getCell(p);v&&this._activeExecutions.get(v.uri)?.cancel()}}$acceptKernelMessageFromRenderer(t,s,i){const r=this._kernelData.get(t);if(!r)return;const c=this._extHostNotebook.getEditorById(s);r.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:i}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const i=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!i)throw new Error("invalid cell");if(this._activeExecutions.has(i.uri))throw new Error(`duplicate execution for ${i.uri}`);const r=new u(i.notebook,i,this._proxy);this._activeExecutions.set(i.uri,r);const c=r.onDidChangeState(()=>{r.state===w.Resolved&&(r.dispose(),c.dispose(),this._activeExecutions.delete(i.uri))});return r.asApiObject()}};E=ze([je(3,a.ILogService)],E),e.ExtHostNotebookKernels=E;var w;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(w||(w={}));class u extends F.Disposable{constructor(t,s,i){super();this._document=t,this._cell=s,this._proxy=i,this._onDidChangeState=new m.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=w.Init,this._tokenSource=this._register(new l.CancellationTokenSource),this._collector=new g(10,r=>this.applyEdits(r)),this._executionOrder=s.internalMetadata.executionOrder,this.mixinMetadata({runState:k.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyExecutionEdits(this._document.uri,t)}verifyStateForOutput(){if(this._state===w.Init)throw new Error("Must call start before modifying cell output");if(this._state===w.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){this.applyEdits([{editType:9,handle:this._cell.handle,internalMetadata:t}])}cellIndexToHandle(t){let s=this._cell;if(t&&(s=this._document.getCellFromApiCell(t)),!s)throw new Error("INVALID cell");return s.handle}validateAndConvertOutputs(t){return t.map(s=>{const i=d.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return i===s.items?S.NotebookCellOutput.from(s):S.NotebookCellOutput.from({items:i,id:s.id,metadata:s.metadata})})}async updateOutputs(t,s,i){const r=this.cellIndexToHandle(s),c=this.validateAndConvertOutputs((0,h.asArray)(t));return this.applyEditSoon({editType:2,handle:r,append:i,outputs:c})}async updateOutputItems(t,s,i){return t=d.NotebookCellOutput.ensureUniqueMimeTypes((0,h.asArray)(t),!0),this.applyEditSoon({editType:7,items:t.map(S.NotebookCellOutputItem.from),outputId:s.id,append:i})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(i){t._executionOrder=i,t.mixinMetadata({executionOrder:i})},start(i){if(t._state===w.Resolved||t._state===w.Started)throw new Error("Cannot call start again");t._state=w.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:k.NotebookCellExecutionState.Executing,runStartTime:i??null})},end(i,r){if(t._state===w.Resolved)throw new Error("Cannot call resolve twice");t._state=w.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:i??null,runEndTime:r??null})},clearOutput(i){return t.verifyStateForOutput(),t.updateOutputs([],i,!1)},appendOutput(i,r){return t.verifyStateForOutput(),t.updateOutputs(i,r,!0)},replaceOutput(i,r){return t.verifyStateForOutput(),t.updateOutputs(i,r,!1)},appendOutputItems(i,r){return t.verifyStateForOutput(),t.updateOutputItems(i,r,!0)},replaceOutputItems(i,r){return t.verifyStateForOutput(),t.updateOutputItems(i,r,!1)}})}}class g{constructor(t,s){this.delay=t,this.callback=s,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=(0,n.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const s=this.batch;return this.batch=[],this.callback(s)})),this.waitPromise}}}),define(_e[200],ye([0,1,3,5,98]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class y{constructor(S,_){this._extHostNotebook=_,this._rendererMessageEmitters=new Map,this.proxy=S.getProxy(F.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(S,_,C){const n=this._extHostNotebook.getEditorById(S);this._rendererMessageEmitters.get(_)?.fire({editor:n.apiEditor,message:C})}createRendererMessaging(S){return{onDidReceiveMessage:(...C)=>this.getOrCreateEmitterFor(S).event(...C),postMessage:(C,n)=>{const k=D.ExtHostNotebookEditor.apiEditorsToExtHost.get(C);if(!k)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(k.id,S,n)}}}getOrCreateEmitterFor(S){let _=this._rendererMessageEmitters.get(S);return _||(_=new m.Emitter({onLastListenerRemove:()=>{_?.dispose(),this._rendererMessageEmitters.delete(S)}}),this._rendererMessageEmitters.set(S,_),_)}}e.ExtHostNotebookRenderers=y}),define(_e[102],ye([0,1,5,3,7,23,4,13]),function(ee,e,m,F,D,y,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class _ extends D.Disposable{constructor(a,d,f,E,w){super();this._onDidAppend=this._register(new F.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=a,this._proxy=w,this._id=w.$register(this.name,d,f,E),this._disposed=!1,this._offset=0}get name(){return this._name}append(a){this.validate(),this._offset+=a?y.VSBuffer.fromString(a).byteLength:0}update(){this._id.then(a=>this._proxy.$update(a))}appendLine(a){this.validate(),this.append(a+`
`)}clear(){this.validate();const a=this._offset;this._id.then(d=>this._proxy.$clear(d,a))}show(a,d){this.validate(),this._id.then(f=>this._proxy.$reveal(f,!!(typeof a=="boolean"?a:d)))}hide(){this.validate(),this._id.then(a=>this._proxy.$close(a))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(a=>this._proxy.$dispose(a)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=_;class C extends _{constructor(a,d,f){super(a,!1,void 0,d,f)}append(a){super.append(a),this._id.then(d=>this._proxy.$append(d,a)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=C;class n extends _{constructor(a,d,f){super(a,!0,d,void 0,f)}append(a){throw new Error("Not supported")}}class k{constructor(a,d){this.name=a,this._channel=d}append(a){this._channel.then(d=>d.append(a))}appendLine(a){this._channel.then(d=>d.appendLine(a))}clear(){this._channel.then(a=>a.clear())}show(a,d){this._channel.then(f=>f.show(a,d))}hide(){this._channel.then(a=>a.hide())}dispose(){this._channel.then(a=>a.dispose())}}e.LazyOutputChannel=k;let l=class{constructor(a){this._proxy=a.getProxy(m.MainContext.MainThreadOutputService)}$setVisibleChannel(a){}createOutputChannel(a,d){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");return new C(d.identifier.value,a,this._proxy)}createOutputChannelFromLogFile(a,d){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");if(!d)throw new Error("illegal argument `file`. must not be falsy");return new n(a,d,this._proxy)}};l=ze([je(0,S.IExtHostRpcService)],l),e.ExtHostOutputService=l,e.IExtHostOutputService=(0,I.createDecorator)("IExtHostOutputService")}),define(_e[201],ye([0,1,16,18,3,7,5,2,6,12,17,42]),function(ee,e,m,F,D,y,I,S,_,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function l(h,a,d){const f=h.getProxy(I.MainContext.MainThreadQuickOpen);class E{constructor(r,c){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=c}showQuickPick(r,c,p,v=F.CancellationToken.None){this._onDidSelectItem=void 0;const A=Promise.resolve(r),R=++this._instances,o=f.$show(R,{title:p?.title,placeHolder:p?.placeHolder,matchOnDescription:p?.matchOnDescription,matchOnDetail:p?.matchOnDetail,ignoreFocusLost:p?.ignoreFocusOut,canPickMany:p?.canPickMany},v),P={},N=o.then(()=>P);return Promise.race([N,A]).then($=>{if($!==P)return A.then(ie=>{const ce=[];for(let K=0;K<ie.length;K++){const H=ie[K];let z,T,q,L,B;typeof H=="string"?z=H:(z=H.label,T=H.description,q=H.detail,L=H.picked,B=H.alwaysShow),ce.push({label:z,description:T,handle:K,detail:q,picked:L,alwaysShow:B})}return p&&typeof p.onDidSelectItem=="function"&&(this._onDidSelectItem=K=>{p.onDidSelectItem(ie[K])}),f.$setItems(R,ce),o.then(K=>{if(typeof K=="number")return ie[K];if(Array.isArray(K))return K.map(H=>ie[H])})})}).then(void 0,$=>{if(!(0,C.isPromiseCanceledError)($))return f.$setError(R,$),Promise.reject($)})}$onItemSelected(r){this._onDidSelectItem&&this._onDidSelectItem(r)}showInput(r,c=F.CancellationToken.None){return this._validateInput=r?r.validateInput:void 0,f.$input(r,typeof this._validateInput=="function",c).then(void 0,p=>{if(!(0,C.isPromiseCanceledError)(p))return Promise.reject(p)})}$validateInput(r){return this._validateInput?(0,m.asPromise)(()=>this._validateInput(r)):Promise.resolve(void 0)}async showWorkspaceFolderPick(r,c=F.CancellationToken.None){const p=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!p)return;const v=await this._workspace.getWorkspaceFolders2();if(!!v)return v.find(A=>A.uri.toString()===p.uri.toString())}createQuickPick(r,c){const p=new t(r,c,()=>this._sessions.delete(p._id));return this._sessions.set(p._id,p),p}createInputBox(r){const c=new s(r,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}$onDidChangeValue(r,c){const p=this._sessions.get(r);p&&p._fireDidChangeValue(c)}$onDidAccept(r){const c=this._sessions.get(r);c&&c._fireDidAccept()}$onDidChangeActive(r,c){const p=this._sessions.get(r);p instanceof t&&p._fireDidChangeActive(c)}$onDidChangeSelection(r,c){const p=this._sessions.get(r);p instanceof t&&p._fireDidChangeSelection(c)}$onDidTriggerButton(r,c){const p=this._sessions.get(r);p&&p._fireDidTriggerButton(c)}$onDidHide(r){const c=this._sessions.get(r);c&&c._fireDidHide()}}class w{constructor(r,c){this._extensionId=r,this._onDidDispose=c,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new D.Emitter,this._onDidChangeValueEmitter=new D.Emitter,this._onDidTriggerButtonEmitter=new D.Emitter,this._onDidHideEmitter=new D.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((c,p)=>{const v=c===_.QuickInputButtons.Back?-1:p;this._handlesToButtons.set(v,c)}),this.update({buttons:r.map((c,p)=>({iconPath:u(c.iconPath),tooltip:c.tooltip,handle:c===_.QuickInputButtons.Back?-1:p}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const c=this._handlesToButtons.get(r);c&&this._onDidTriggerButtonEmitter.fire(c)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,y.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),f.$dispose(this._id))}update(r){if(!this._disposed){for(const c of Object.keys(r)){const p=r[c];this._pendingUpdate[c]=p===void 0?null:p}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){f.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}w._nextId=1;function u(i){if(i instanceof _.ThemeIcon)return{id:i.id};const r=b(i),c=g(i);return{dark:typeof r=="string"?S.URI.file(r):r,light:typeof c=="string"?S.URI.file(c):c}}function g(i){return typeof i=="object"&&"light"in i?i.light:i}function b(i){return typeof i=="object"&&"dark"in i?i.dark:i}class t extends w{constructor(r,c,p){super(r,p);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new D.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new D.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((c,p)=>{this._handlesToItems.set(p,c),this._itemsToHandles.set(c,p)}),this.update({items:r.map((c,p)=>({label:c.label,description:c.description,handle:p,detail:c.detail,picked:c.picked,alwaysShow:c.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(c=>this._itemsToHandles.has(c)),this.update({activeItems:this._activeItems.map(c=>this._itemsToHandles.get(c))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(c=>this._itemsToHandles.has(c)),this.update({selectedItems:this._selectedItems.map(c=>this._itemsToHandles.get(c))})}_fireDidChangeActive(r){const c=(0,n.coalesce)(r.map(p=>this._handlesToItems.get(p)));this._activeItems=c,this._onDidChangeActiveEmitter.fire(c)}_fireDidChangeSelection(r){const c=(0,n.coalesce)(r.map(p=>this._handlesToItems.get(p)));this._selectedItems=c,this._onDidChangeSelectionEmitter.fire(c)}}class s extends w{constructor(r,c){super(r,c);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,this.update({validationMessage:r,severity:r?k.default.Error:k.default.Ignore})}}return new E(a,d)}e.createExtHostQuickOpen=l}),define(_e[202],ye([0,1,2,3,48,7,16,5,17,113,15,26,29,156]),function(ee,e,m,F,D,y,I,S,_,C,n,k,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function a(c){if(c)return typeof c.iconPath=="string"?m.URI.file(c.iconPath):m.URI.isUri(c.iconPath)||h.ThemeIcon.isThemeIcon(c.iconPath)?c.iconPath:void 0}function d(c,p){if(!c.iconPath&&!p.iconPath)return 0;if(c.iconPath){if(!p.iconPath)return 1}else return-1;const v=typeof c.iconPath=="string"?c.iconPath:m.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id,A=typeof p.iconPath=="string"?p.iconPath:m.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id;return(0,C.comparePaths)(v,A)}function f(c,p){let v=0;if(c.strikeThrough!==p.strikeThrough)return c.strikeThrough?1:-1;if(c.faded!==p.faded)return c.faded?1:-1;if(c.tooltip!==p.tooltip)return(c.tooltip||"").localeCompare(p.tooltip||"");if(v=d(c,p),v!==0)return v;if(c.light&&p.light)v=d(c.light,p.light);else{if(c.light)return 1;if(p.light)return-1}if(v!==0)return v;if(c.dark&&p.dark)v=d(c.dark,p.dark);else{if(c.dark)return 1;if(p.dark)return-1}return v}function E(c,p){if(c.command!==p.command)return c.command<p.command?-1:1;if(c.title!==p.title)return c.title<p.title?-1:1;if(c.tooltip!==p.tooltip){if(c.tooltip!==void 0&&p.tooltip!==void 0)return c.tooltip<p.tooltip?-1:1;if(c.tooltip!==void 0)return 1;if(p.tooltip!==void 0)return-1}if(c.arguments===p.arguments)return 0;if(c.arguments)if(p.arguments){if(c.arguments.length!==p.arguments.length)return c.arguments.length-p.arguments.length}else return 1;else return-1;for(let v=0;v<c.arguments.length;v++){const A=c.arguments[v],R=p.arguments[v];if(A!==R)return A<R?-1:1}return 0}function w(c,p){let v=(0,C.comparePaths)(c.resourceUri.fsPath,p.resourceUri.fsPath,!0);if(v!==0)return v;if(c.command&&p.command)v=E(c.command,p.command);else{if(c.command)return 1;if(p.command)return-1}if(v!==0)return v;if(c.decorations&&p.decorations)v=f(c.decorations,p.decorations);else{if(c.decorations)return 1;if(p.decorations)return-1}return v}function u(c,p){for(let v=0;v<c.length;v++)if(c[v]!==p[v])return!1;return!0}function g(c,p){return c.command===p.command&&c.title===p.title&&c.tooltip===p.tooltip&&(c.arguments&&p.arguments?u(c.arguments,p.arguments):c.arguments===p.arguments)}function b(c,p){return(0,_.equals)(c,p,g)}class t{constructor(p,v,A){this._extension=p,this._proxy=v,this._sourceControlHandle=A,this._value="",this._onDidChange=new F.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(p){this._proxy.$setInputBoxValue(this._sourceControlHandle,p),this.updateValue(p)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(p){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,p),this._placeholder=p}get validateInput(){return(0,l.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(p){if((0,l.checkProposedApiEnabled)(this._extension),p&&typeof p!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=p,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!p)}get visible(){return this._visible}set visible(p){p=!!p,this._visible!==p&&(this._visible=p,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,p))}focus(){(0,l.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(p,v){(0,l.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,p,v)}$onInputBoxValueChange(p){this.updateValue(p)}updateValue(p){this._value=p,this._onDidChange.fire(p)}}e.ExtHostSCMInputBox=t;class s{constructor(p,v,A,R,o){this._proxy=p,this._commands=v,this._sourceControlHandle=A,this._id=R,this._label=o,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new F.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=s._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(p){this._label=p,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,p)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(p){this._hideWhenEmpty=p,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(p){this._resourceStates=[...p],this._onDidUpdateResourceStates.fire()}getResourceState(p){return this._resourceStatesMap.get(p)}$executeResourceCommand(p,v){const A=this._resourceStatesCommandsMap.get(p);return A?(0,I.asPromise)(()=>this._commands.executeCommand(A.command,...A.arguments||[],v)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const p=[...this._resourceStates].sort(w),A=(0,_.sortedDiff)(this._resourceSnapshot,p,w).map(P=>{const N=P.toInsert.map($=>{const ie=this._resourceHandlePool++;this._resourceStatesMap.set(ie,$);const ce=$.resourceUri;let K;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const Se=new y.DisposableStore;K=this._commands.converter.toInternal($.command,Se),this._resourceStatesDisposablesMap.set(ie,Se)}else this._resourceStatesCommandsMap.set(ie,$.command);const H=a($.decorations),z=$.decorations&&a($.decorations.light)||H,T=$.decorations&&a($.decorations.dark)||H,q=[z,T],L=$.decorations&&$.decorations.tooltip||"",B=$.decorations&&!!$.decorations.strikeThrough,Y=$.decorations&&!!$.decorations.faded,j=$.contextValue||"";return{rawResource:[ie,ce,q,L,B,Y,j,K],handle:ie}});return{start:P.start,deleteCount:P.deleteCount,toInsert:N}}),R=A.map(({start:P,deleteCount:N,toInsert:$})=>[P,N,$.map(ie=>ie.rawResource)]),o=A.reverse();for(const{start:P,deleteCount:N,toInsert:$}of o){const ie=$.map(K=>K.handle),ce=this._handlesSnapshot.splice(P,N,...ie);for(const K of ce)this._resourceStatesMap.delete(K),this._resourceStatesCommandsMap.delete(K),this._resourceStatesDisposablesMap.get(K)?.dispose(),this._resourceStatesDisposablesMap.delete(K)}return this._resourceSnapshot=p,R}dispose(){this._disposed=!0,this._onDidDispose.fire()}}s._handlePool=0;class i{constructor(p,v,A,R,o,P){this._proxy=v,this._commands=A,this._id=R,this._label=o,this._rootUri=P,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new y.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new F.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new t(p,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,R,o,P)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(p){this._count!==p&&(this._count=p,this._proxy.$updateSourceControl(this.handle,{count:p}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(p){this._quickDiffProvider=p,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!p})}get commitTemplate(){return this._commitTemplate}set commitTemplate(p){p!==this._commitTemplate&&(this._commitTemplate=p,this._proxy.$updateSourceControl(this.handle,{commitTemplate:p}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(p){this._acceptInputDisposables.value=new y.DisposableStore,this._acceptInputCommand=p;const v=this._commands.converter.toInternal(p,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:v})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(p){if(this._statusBarCommands&&p&&b(this._statusBarCommands,p))return;this._statusBarDisposables.value=new y.DisposableStore,this._statusBarCommands=p;const v=(p||[]).map(A=>this._commands.converter.toInternal(A,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:v})}get selected(){return this._selected}createResourceGroup(p,v){const A=new s(this._proxy,this._commands,this.handle,p,v),R=F.Event.once(A.onDidDispose)(()=>this.createdResourceGroups.delete(A));return this.createdResourceGroups.set(A,R),this.eventuallyAddResourceGroups(),A}eventuallyAddResourceGroups(){const p=[],v=[];for(const[A,R]of this.createdResourceGroups){R.dispose();const o=A.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(A),this.eventuallyUpdateResourceStates()});F.Event.once(A.onDidDispose)(()=>{this.updatedResourceGroups.delete(A),o.dispose(),this._groups.delete(A.handle),this._proxy.$unregisterGroup(this.handle,A.handle)}),p.push([A.handle,A.id,A.label,A.features]);const P=A._takeResourceStateSnapshot();P.length>0&&v.push([A.handle,P]),this._groups.set(A.handle,A)}this._proxy.$registerGroups(this.handle,p,v),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const p=[];this.updatedResourceGroups.forEach(v=>{const A=v._takeResourceStateSnapshot();A.length!==0&&p.push([v.handle,A])}),p.length>0&&this._proxy.$spliceResourceStates(this.handle,p),this.updatedResourceGroups.clear()}getResourceGroup(p){return this._groups.get(p)}setSelectionState(p){this._selected=p,this._onDidChangeSelection.fire(p)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(p=>p.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,ze([(0,D.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),ze([(0,D.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let r=class Un{constructor(p,v,A){this._commands=v,this.logService=A,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new F.Emitter,this._proxy=p.getProxy(S.MainContext.MainThreadSCM),this._telemetry=p.getProxy(S.MainContext.MainThreadTelemetry),v.registerArgumentProcessor({processArgument:R=>{if(R&&R.$mid===3){const o=this._sourceControls.get(R.sourceControlHandle);if(!o)return R;const P=o.getResourceGroup(R.groupHandle);return P?P.getResourceState(R.handle):R}else if(R&&R.$mid===4){const o=this._sourceControls.get(R.sourceControlHandle);return o?o.getResourceGroup(R.groupHandle):R}else if(R&&R.$mid===5){const o=this._sourceControls.get(R.handle);return o||R}return R}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(p,v,A,R){this.logService.trace("ExtHostSCM#createSourceControl",p.identifier.value,v,A,R),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:p.identifier.value});const o=Un._handlePool++,P=new i(p,this._proxy,this._commands,v,A,R);this._sourceControls.set(o,P);const N=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(p.identifier))||[];return N.push(P),this._sourceControlsByExtension.set(k.ExtensionIdentifier.toKey(p.identifier),N),P}getLastInputBox(p){this.logService.trace("ExtHostSCM#getLastInputBox",p.identifier.value);const v=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(p.identifier)),A=v&&v[v.length-1];return A&&A.inputBox}$provideOriginalResource(p,v,A){const R=m.URI.revive(v);this.logService.trace("ExtHostSCM#$provideOriginalResource",p,R.toString());const o=this._sourceControls.get(p);return!o||!o.quickDiffProvider||!o.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,I.asPromise)(()=>o.quickDiffProvider.provideOriginalResource(R,A)).then(P=>P||null)}$onInputBoxValueChange(p,v){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",p);const A=this._sourceControls.get(p);return A&&A.inputBox.$onInputBoxValueChange(v),Promise.resolve(void 0)}$executeResourceCommand(p,v,A,R){this.logService.trace("ExtHostSCM#$executeResourceCommand",p,v,A);const o=this._sourceControls.get(p);if(!o)return Promise.resolve(void 0);const P=o.getResourceGroup(v);return P?P.$executeResourceCommand(A,R):Promise.resolve(void 0)}$validateInput(p,v,A){this.logService.trace("ExtHostSCM#$validateInput",p);const R=this._sourceControls.get(p);return!R||!R.inputBox.validateInput?Promise.resolve(void 0):(0,I.asPromise)(()=>R.inputBox.validateInput(v,A)).then(o=>o?Promise.resolve([o.message,o.type]):Promise.resolve(void 0))}$setSelectedSourceControl(p){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",p),p!==void 0&&this._sourceControls.get(p)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=p,Promise.resolve(void 0)}};r._handlePool=0,r=ze([je(2,n.ILogService)],r),e.ExtHostSCM=r});var nt=this&&this.__classPrivateFieldSet||function(ee,e,m,F,D){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?D.call(ee,m):D?D.value=m:e.set(ee,m),m},Le=this&&this.__classPrivateFieldGet||function(ee,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(ee):F?F.value:e.get(ee)};define(_e[203],ye([0,1,6,5,132,7,9]),function(ee,e,m,F,D,y,I){"use strict";var S,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class C{constructor(h,a,d,f,E=m.StatusBarAlignment.Left,w){S.set(this,void 0),_.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new y.DisposableStore,nt(this,S,h,"f"),nt(this,_,a,"f"),this._entryId=C.ID_GEN++,this._extension=d,this._id=f,this._alignment=E,this._priority=w}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!C.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){this._command?.fromApi!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:Le(this,_,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:Le(this,_,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Le(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let h;this._extension?this._id?h=`${this._extension.identifier.value}.${this._id}`:h=this._extension.identifier.value:h=this._id;let a;this._name?a=this._name:a=(0,D.localize)(0,null,this._extension.displayName||this._extension.name);let d=this._color;this._backgroundColor&&(d=C.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const f=this._tooltip?I.MarkdownString.fromStrict(this._tooltip):void 0;Le(this,S,"f").$setEntry(this._entryId,h,a,this._text,f,this._command?.internal,d,this._backgroundColor,this._alignment===m.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=C,S=new WeakMap,_=new WeakMap,C.ID_GEN=0,C.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new m.ThemeColor("statusBarItem.errorForeground")]]);class n{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",m.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,D.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const a={message:h};return this._messages.unshift(a),this._update(),new m.Disposable(()=>{const d=this._messages.indexOf(a);d>=0&&(this._messages.splice(d,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class k{constructor(h,a){this._proxy=h.getProxy(F.MainContext.MainThreadStatusBar),this._commands=a,this._statusMessage=new n(this)}createStatusBarEntry(h,a,d,f){return new C(this._proxy,this._commands,h,a,d,f)}setStatusBarMessage(h,a){const d=this._statusMessage.setMessage(h);let f;return typeof a=="number"?f=setTimeout(()=>d.dispose(),a):typeof a!="undefined"&&a.then(()=>d.dispose(),()=>d.dispose()),new m.Disposable(()=>{d.dispose(),clearTimeout(f)})}}e.ExtHostStatusBar=k}),define(_e[74],ye([0,1,5,3,4]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class y{constructor(S){this._onDidChangeStorage=new F.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=S.getProxy(m.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(S,_){this._proxy.$registerExtensionStorageKeysToSync(S,_)}getValue(S,_,C){return this._proxy.$getValue(S,_).then(n=>n||C)}setValue(S,_,C){return this._proxy.$setValue(S,_,C)}$acceptValue(S,_,C){this._onDidChangeStorage.fire({shared:S,key:_,value:C})}}e.ExtHostStorage=y,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(_e[75],ye([0,1,4,28,15,73,2]),function(ee,e,m,F,D,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,m.createDecorator)("IExtensionStoragePaths");let S=class{constructor(C,n,k){this._logService=n,this._extHostFileSystem=k,this._workspace=C.workspace??void 0,this._environment=C.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(l=>this._value=l)}async _getWorkspaceStorageURI(C){return I.URI.joinPath(this._environment.workspaceStorageHome,C)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const C=this._workspace.id,n=await this._getWorkspaceStorageURI(C);try{return await this._extHostFileSystem.value.stat(n),this._logService.trace("[ExtHostStorage] storage dir already exists",n),n}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",n),await this._extHostFileSystem.value.createDirectory(n),await this._extHostFileSystem.value.writeFile(I.URI.joinPath(n,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:I.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),n}catch(k){this._logService.error("[ExtHostStorage]",k);return}}workspaceValue(C){if(this._value)return I.URI.joinPath(this._value,C.identifier.value)}globalValue(C){return I.URI.joinPath(this._environment.globalStorageHome,C.identifier.value.toLowerCase())}onWillDeactivateAll(){}};S=ze([je(0,F.IExtHostInitDataService),je(1,D.ILogService),je(2,y.IExtHostConsumerFileSystem)],S),e.ExtensionStoragePaths=S}),define(_e[37],ye([0,1,3,5,4,2,13,7,6,133,12,169,18,35,154,10]),function(ee,e,m,F,D,y,I,S,_,C,n,k,l,h,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class f{constructor(i,r,c,p){this._proxy=i,this._id=r,this._creationOptions=c,this._name=p,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(A=>this._pidPromiseComplete=A);const v=this;this.value={get name(){return v._name||""},get processId(){return v._pidPromise},get creationOptions(){return v._creationOptions},get exitStatus(){return v._exitStatus},sendText(A,R=!0){v._checkDisposed(),v._proxy.$sendText(v._id,A,R)},show(A){v._checkDisposed(),v._proxy.$show(v._id,A)},hide(){v._checkDisposed(),v._proxy.$hide(v._id)},dispose(){v._disposed||(v._disposed=!0,v._proxy.$dispose(v._id))},get dimensions(){if(!(v._cols===void 0||v._rows===void 0))return{columns:v._cols,rows:v._rows}}}}async create(i,r){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:i.name,shellPath:(0,d.withNullAsUndefined)(i.shellPath),shellArgs:(0,d.withNullAsUndefined)(i.shellArgs),cwd:(0,d.withNullAsUndefined)(i.cwd),env:(0,d.withNullAsUndefined)(i.env),icon:(0,d.withNullAsUndefined)(t(i.iconPath)),initialText:(0,d.withNullAsUndefined)(i.message),strictEnv:(0,d.withNullAsUndefined)(i.strictEnv),hideFromUser:(0,d.withNullAsUndefined)(i.hideFromUser),isFeatureTerminal:(0,d.withNullAsUndefined)(r?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,d.withNullAsUndefined)(r?.useShellEnvironment),isSplitTerminal:r?.isSplitTerminal,target:r?.target})}async createExtensionTerminal(i,r,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:c,isSplitTerminal:i,target:r}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(i){this._name=i}setExitCode(i){this._exitStatus=Object.freeze({code:i})}setDimensions(i,r){return i===this._cols&&r===this._rows||i===0||r===0?!1:(this._cols=i,this._rows=r,!0)}_setProcessId(i){this._pidPromiseComplete?(this._pidPromiseComplete(i),this._pidPromiseComplete=void 0):this._pidPromise.then(r=>{r!==i&&(this._pidPromise=Promise.resolve(i))})}}e.ExtHostTerminal=f;class E{constructor(i){this._pty=i,this.id=0,this.shouldPersist=!1,this._onProcessData=new m.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new m.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new m.Emitter,this._onProcessTitleChanged=new m.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new m.Emitter,this._onProcessShellTypeChanged=new m.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(i){this._pty.handleInput&&this._pty.handleInput(i)}resize(i,r){this._pty.setDimensions&&this._pty.setDimensions({columns:i,rows:r})}async processBinary(i){}acknowledgeDataEvent(i){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(i){this._pty.onDidWrite(r=>this._onProcessData.fire(r)),this._pty.onDidClose&&this._pty.onDidClose((r=void 0)=>{this._onProcessExit.fire(r===void 0?void 0:r)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r&&{cols:r.columns,rows:r.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(r=>this._onProcessTitleChanged.fire(r)),this._pty.open(i||void 0),this._pty.setDimensions&&i&&this._pty.setDimensions(i),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=E;let w=1,u=class extends S.Disposable{constructor(i,r){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new m.Emitter,this._onDidOpenTerminal=new m.Emitter,this._onDidChangeActiveTerminal=new m.Emitter,this._onDidChangeTerminalDimensions=new m.Emitter,this._proxy=r.getProxy(F.MainContext.MainThreadTerminalService),this._bufferer=new a.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new m.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(i),this._register({dispose:()=>{for(const[c,p]of this._terminalProcesses)p.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(i=>i.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(i){return(i?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(i){return(i?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(i,r){const c=new f(this._proxy,(0,h.generateUuid)(),i,i.name),p=new E(i.pty);return c.createExtensionTerminal(r?.isSplitTerminal,r?.target,t(i.iconPath)).then(v=>{const A=this._setupExtHostProcessListeners(v,p);this._terminalProcessDisposables[v]=A}),this._terminals.push(c),c.value}attachPtyToTerminal(i,r){if(!this._getTerminalById(i))throw new Error(`Cannot resolve terminal with id ${i} for virtual process`);const p=new E(r),v=this._setupExtHostProcessListeners(i,p);this._terminalProcessDisposables[i]=v}async $acceptActiveTerminalChanged(i){const r=this._activeTerminal;if(i===null){this._activeTerminal=void 0,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const c=this._getTerminalById(i);c&&(this._activeTerminal=c,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(i,r){const c=this._getTerminalById(i);c&&this._onDidWriteTerminalData.fire({terminal:c.value,data:r})}async $acceptTerminalDimensions(i,r,c){const p=this._getTerminalById(i);p&&p.setDimensions(r,c)&&this._onDidChangeTerminalDimensions.fire({terminal:p.value,dimensions:p.value.dimensions})}async $acceptTerminalMaximumDimensions(i,r,c){this._terminalProcesses.get(i)?.resize(r,c)}async $acceptTerminalTitleChange(i,r){const c=this._getTerminalById(i);c&&(c.name=r)}async $acceptTerminalClosed(i,r){const c=this._getTerminalObjectIndexById(this._terminals,i);if(c!==null){const p=this._terminals.splice(c,1)[0];p.setExitCode(r),this._onDidCloseTerminal.fire(p.value)}}$acceptTerminalOpened(i,r,c,p){if(r){const R=this._getTerminalObjectIndexById(this._terminals,r);if(R!==null){this._terminals[R]._id=i,this._onDidOpenTerminal.fire(this.terminals[R]),this._terminals[R].isOpen=!0;return}}const v={name:p.name,shellPath:p.executable,shellArgs:p.args,cwd:typeof p.cwd=="string"?p.cwd:y.URI.revive(p.cwd),env:p.env,hideFromUser:p.hideFromUser},A=new f(this._proxy,i,v,c);this._terminals.push(A),this._onDidOpenTerminal.fire(A.value),A.isOpen=!0}async $acceptTerminalProcessId(i,r){const c=this._getTerminalById(i);c&&c._setProcessId(r)}async $startExtensionTerminal(i,r){const c=this._getTerminalById(i);if(!c)return{message:(0,C.localize)(0,null,i)};c.isOpen||await new Promise(v=>{const A=this.onDidOpenTerminal(async R=>{R===c.value&&(A.dispose(),v())})});const p=this._terminalProcesses.get(i);p?p.startSendingEvents(r):this._extensionTerminalAwaitingStart[i]={initialDimensions:r}}_setupExtHostProcessListeners(i,r){const c=new S.DisposableStore;c.add(r.onProcessReady(v=>this._proxy.$sendProcessReady(i,v.pid,v.cwd))),c.add(r.onProcessTitleChanged(v=>this._proxy.$sendProcessTitle(i,v))),this._bufferer.startBuffering(i,r.onProcessData),c.add(r.onProcessExit(v=>this._onProcessExit(i,v))),r.onProcessOverrideDimensions&&c.add(r.onProcessOverrideDimensions(v=>this._proxy.$sendOverrideDimensions(i,v))),this._terminalProcesses.set(i,r);const p=this._extensionTerminalAwaitingStart[i];return p&&r instanceof E&&(r.startSendingEvents(p.initialDimensions),delete this._extensionTerminalAwaitingStart[i]),c}$acceptProcessAckDataEvent(i,r){this._terminalProcesses.get(i)?.acknowledgeDataEvent(r)}$acceptProcessInput(i,r){this._terminalProcesses.get(i)?.input(r)}$acceptProcessResize(i,r,c){try{this._terminalProcesses.get(i)?.resize(r,c)}catch(p){if(p.code!=="EPIPE"&&p.code!=="ERR_IPC_CHANNEL_CLOSED")throw p}}$acceptProcessShutdown(i,r){this._terminalProcesses.get(i)?.shutdown(r)}$acceptProcessRequestInitialCwd(i){this._terminalProcesses.get(i)?.getInitialCwd().then(r=>this._proxy.$sendProcessInitialCwd(i,r))}$acceptProcessRequestCwd(i){this._terminalProcesses.get(i)?.getCwd().then(r=>this._proxy.$sendProcessCwd(i,r))}$acceptProcessRequestLatency(i){return i}registerLinkProvider(i){return this._linkProviders.add(i),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(i),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(i,r,c){if(this._profileProviders.has(r))throw new Error(`Terminal profile provider "${r}" already registered`);return this._profileProviders.set(r,c),this._proxy.$registerProfileProvider(r,i.identifier.value),new _.Disposable(()=>{this._profileProviders.delete(r),this._proxy.$unregisterProfileProvider(r)})}async $createContributedProfileTerminal(i,r){const c=new l.CancellationTokenSource().token,p=await this._profileProviders.get(i)?.provideTerminalProfile(c);if(!c.isCancellationRequested){if(!p||!("options"in p))throw new Error(`No terminal profile options provided for id "${i}"`);if("pty"in p.options){this.createExtensionTerminal(p.options,r);return}this.createTerminalFromOptions(p.options,r)}}async $provideLinks(i,r){const c=this._getTerminalById(i);if(!c)return[];this._terminalLinkCache.delete(i);const p=this._terminalLinkCancellationSource.get(i);p&&p.dispose(!0);const v=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(i,v);const A=[],R={terminal:c.value,line:r},o=[];for(const $ of this._linkProviders)o.push(new Promise(async ie=>{v.token.onCancellationRequested(()=>ie({provider:$,links:[]}));const ce=await $.provideTerminalLinks(R,v.token)||[];v.token.isCancellationRequested||ie({provider:$,links:ce})}));const P=await Promise.all(o);if(v.token.isCancellationRequested)return[];const N=new Map;for(const $ of P)$&&$.links.length>0&&A.push(...$.links.map(ie=>{const ce={id:w++,startIndex:ie.startIndex,length:ie.length,label:ie.tooltip};return N.set(ce.id,{provider:$.provider,link:ie}),ce}));return this._terminalLinkCache.set(i,N),A}$activateLink(i,r){const c=this._terminalLinkCache.get(i)?.get(r);!c||c.provider.handleTerminalLink(c.link)}_onProcessExit(i,r){this._bufferer.stopBuffering(i),this._terminalProcesses.delete(i),delete this._extensionTerminalAwaitingStart[i];const c=this._terminalProcessDisposables[i];c&&(c.dispose(),delete this._terminalProcessDisposables[i]),this._proxy.$sendProcessExit(i,r)}_getTerminalById(i){return this._getTerminalObjectById(this._terminals,i)}_getTerminalObjectById(i,r){const c=this._getTerminalObjectIndexById(i,r);return c!==null?i[c]:null}_getTerminalObjectIndexById(i,r){let c=null;return i.some((p,v)=>p._id===r?(c=v,!0):!1),c}getEnvironmentVariableCollection(i){let r=this._environmentVariableCollections.get(i.identifier.value);return r||(r=new g,this._setEnvironmentVariableCollection(i.identifier.value,r)),r}_syncEnvironmentVariableCollection(i,r){const c=(0,k.serializeEnvironmentVariableCollection)(r.map);this._proxy.$setEnvironmentVariableCollection(i,r.persistent,c.length===0?void 0:c)}$initEnvironmentVariableCollections(i){i.forEach(r=>{const c=r[0],p=new g(r[1]);this._setEnvironmentVariableCollection(c,p)})}$acceptDefaultProfile(i,r){this._defaultProfile=i,this._defaultAutomationProfile=r}_setEnvironmentVariableCollection(i,r){this._environmentVariableCollections.set(i,r),r.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(i,r)})}};u=ze([je(1,I.IExtHostRpcService)],u),e.BaseExtHostTerminalService=u;class g{constructor(i){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new m.Emitter,this.map=new Map(i)}get persistent(){return this._persistent}set persistent(i){this._persistent=i,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(i,r){this._setIfDiffers(i,{value:r,type:_.EnvironmentVariableMutatorType.Replace})}append(i,r){this._setIfDiffers(i,{value:r,type:_.EnvironmentVariableMutatorType.Append})}prepend(i,r){this._setIfDiffers(i,{value:r,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(i,r){const c=this.map.get(i);(!c||c.value!==r.value||c.type!==r.type)&&(this.map.set(i,r),this._onDidChangeCollection.fire())}get(i){return this.map.get(i)}forEach(i,r){this.map.forEach((c,p)=>i.call(r,p,c,this))}delete(i){this.map.delete(i),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=g;let b=class extends u{constructor(i){super(!1,i)}createTerminal(i,r,c){throw new n.NotSupportedError}createTerminalFromOptions(i,r){throw new n.NotSupportedError}};b=ze([je(0,I.IExtHostRpcService)],b),e.WorkerExtHostTerminalService=b;function t(s){if(!(!s||typeof s=="string"))return"id"in s?{id:s.id,color:s.color}:s}});var nt=this&&this.__classPrivateFieldSet||function(ee,e,m,F,D){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?D.call(ee,m):D?D.value=m:e.set(ee,m),m},Le=this&&this.__classPrivateFieldGet||function(ee,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(ee):F?F.value:e.get(ee)};define(_e[204],ye([0,1,16,23,18,3,49,41,51,7,24,10,35,5,13,65,9,6,177,96]),function(ee,e,m,F,D,y,I,S,_,C,n,k,l,h,a,d,f,E,w,u){"use strict";var g,b,t,s,i,r,c;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunConfigurationImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let p=class{constructor(T,q){this.resultsChangedEmitter=new y.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=T.getProxy(h.MainContext.MainThreadTesting),this.observer=new ce(this.proxy),this.runTracker=new A(this.proxy),q.registerArgumentProcessor({processArgument:L=>L?.$mid===13?f.TestItem.toItemFromContext(L):L})}createTestController(T,q){const L=new C.DisposableStore,B=L.add(new w.SingleUseTestCollection(T)),Y=L.add(new m.RunOnceScheduler(()=>B.expand(B.root.id,0),0)),j=new Map,se=this.proxy,Se={items:B.root.children,get label(){return q},set label($e){q=$e,B.root.label=$e,se.$updateControllerLabel(T,q)},get id(){return T},createRunConfiguration:($e,Ne,Ge,Ke)=>{let qe=(0,S.hash)($e);for(;j.has(qe);)qe++;const U=new K(this.proxy,T,qe,$e,Ne,Ge,Ke);return j.set(qe,U),U},createTestRun:($e,Ne,Ge=!0)=>this.runTracker.createTestRun(T,B,$e,Ne,Ge),set resolveChildrenHandler($e){B.resolveHandler=$e,$e&&Y.schedule()},get resolveChildrenHandler(){return B.resolveHandler},dispose:()=>{L.dispose()}};Se.createTestITem=this.createTestItem.bind(this),se.$registerTestController(T,q),L.add((0,C.toDisposable)(()=>se.$unregisterTestController(T)));const Re={controller:Se,collection:B,configurations:j};return this.controllers.set(T,Re),L.add((0,C.toDisposable)(()=>this.controllers.delete(T))),L.add(B.onDidGenerateDiff($e=>se.$publishDiff(T,$e))),Se}createTestItem(T,q,L){return new d.TestItemImpl(T,q,L)}createTestObserver(){return this.observer.checkout()}async runTests(T,q=D.CancellationToken.None){const L=R(T);if(!L)throw new Error("The request passed to `vscode.test.runTests` must include a configuration");const B=this.controllers.get(L.controllerId);if(!B)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:T.include?.map(Y=>Y.id)??[B.collection.root.id],profileGroup:H[L.group],profileId:L.configId,controllerId:L.controllerId}],exclude:T.exclude?.map(Y=>({testId:Y.id,controllerId:L.controllerId}))},q)}$provideFileCoverage(T,q,L){return _.Iterable.find(this.runTracker.trackers,B=>B.id===T)?.getCoverage(q)?.provideFileCoverage(L)??Promise.resolve([])}$resolveFileCoverage(T,q,L,B){return _.Iterable.find(this.runTracker.trackers,Y=>Y.id===T)?.getCoverage(q)?.resolveFileCoverage(L,B)??Promise.resolve([])}$configureRunConfig(T,q){this.controllers.get(T)?.configurations.get(q)?.configureHandler?.()}$publishTestResults(T){this.results=Object.freeze(T.map(q=>(0,n.deepFreeze)(f.TestResults.to(q))).concat(this.results).sort((q,L)=>L.completedAt-q.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest({controllerId:T,testId:q},L){const B=this.controllers.get(T)?.collection;B&&(await B.expand(q,L<0?Infinity:L),B.flushDiff())}$acceptDiff(T){this.observer.applyDiff(T)}async $runControllerTests(T,q){const L=this.controllers.get(T.controllerId);if(!L)return;const{collection:B,configurations:Y}=L,j=Y.get(T.configId);if(!j)return;const se=T.testIds.map(Ne=>B.tree.get(Ne)).filter(k.isDefined),Se=T.excludeExtIds.map(Ne=>L.collection.tree.get(Ne)).filter(k.isDefined).filter(Ne=>se.some(Ge=>B.tree.comparePositions(Ge,Ne)===1));if(!se.length)return;const Re=new E.TestRunRequest(se.map(Ne=>Ne.actual),Se.map(Ne=>Ne.actual),j),$e=this.runTracker.prepareForMainThreadTestRun(Re,o.fromInternal(T,L.collection),q);try{await j.runHandler(Re,q)}finally{$e.isRunning&&!q.isCancellationRequested&&await y.Event.toPromise($e.onEnd),this.runTracker.cancelRunById(T.runId)}}$cancelExtensionTestRun(T){T===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(T)}};p=ze([je(0,a.IExtHostRpcService)],p),e.ExtHostTesting=p;class v extends C.Disposable{constructor(T,q,L){super();this.dto=T,this.proxy=q,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new y.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new D.CancellationTokenSource(L)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:B}of this.tasks.values())B.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(T){return this.tasks.get(T)?.coverage}createRun(T){const q=(0,l.generateUuid)(),L=new P(this.proxy,this.dto.id,q),B=new N(T,this.cts.token,q,L,this.dto,this.sharedTestIds,this.proxy,()=>{this.tasks.delete(B.taskId),this.isRunning||this.dispose()});return this.tasks.set(B.taskId,{run:B,coverage:L}),B}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}}class A{constructor(T){this.proxy=T,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(T,q,L){return this.getTracker(T,q,L)}cancelRunById(T){for(const q of this.tracked.values())if(q.id===T){q.dispose();return}}cancelAllRuns(){for(const T of this.tracked.values())T.dispose()}createTestRun(T,q,L,B,Y){const j=this.tracked.get(L);if(j)return j.createRun(B);const se=o.fromPublic(T,q,L),Se=R(L);this.proxy.$startedExtensionTestRun({controllerId:T,config:Se&&{group:H[Se.group],id:Se.configId},exclude:L.exclude?.map($e=>$e.id)??[],id:se.id,include:L.include?.map($e=>$e.id)??[q.root.id],persist:Y});const Re=this.getTracker(L,se);return Re.onEnd(()=>this.proxy.$finishedExtensionTestRun(se.id)),Re.createRun(B)}getTracker(T,q,L){const B=new v(q,this.proxy,L);return this.tracked.set(T,B),B.onEnd(()=>this.tracked.delete(T)),B}}e.TestRunCoordinator=A;const R=z=>{if(!!z.configuration){if(!(z.configuration instanceof K))throw new Error("TestRunRequest.configuration is not an instance created from TestController.createRunConfiguration");return z.configuration}};class o{constructor(T,q,L,B,Y){this.controllerId=T,this.id=q,this.include=L,this.exclude=B,this.colllection=Y}static fromPublic(T,q,L){return new o(T,(0,l.generateUuid)(),L.include&&new Set(L.include.map(B=>B.id)),new Set(L.exclude?.map(B=>B.id)??_.Iterable.empty()),q)}static fromInternal(T,q){return new o(T.controllerId,T.runId,T.testIds.includes(q.root.id)?void 0:new Set(T.testIds),new Set(T.excludeExtIds),q)}isIncluded(T){for(let q=T;q;q=q.parent){if(this.include?.has(q.id))return!0;if(this.exclude.has(q.id))return!1}return this.include===void 0}}e.TestRunDto=o;class P{constructor(T,q,L){this.proxy=T,this.runId=q,this.taskId=L}set coverageProvider(T){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!T||(this._coverageProvider=T,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(T){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(T))());try{return(await this.fileCoverage)?.map(f.TestCoverage.fromFile)??[]}catch(q){throw this.fileCoverage=void 0,q}}async resolveFileCoverage(T,q){const L=await this.fileCoverage;let B=L?.[T];return!this._coverageProvider||!L||!B?[]:(B.detailedCoverage||(B=L[T]=await this._coverageProvider.resolveFileCoverage?.(B,q)??B),B.detailedCoverage?.map(f.TestCoverage.fromDetailed)??[])}}class N{constructor(T,q,L,B,Y,j,se,Se){this.name=T,this.token=q,this.taskId=L,g.set(this,void 0),b.set(this,void 0),t.set(this,void 0),s.set(this,void 0),i.set(this,void 0),r.set(this,!1),nt(this,s,Se,"f"),nt(this,g,se,"f"),nt(this,b,Y,"f"),nt(this,i,B,"f"),nt(this,t,j,"f"),se.$startedTestRunTask(Y.id,{id:this.taskId,name:T,running:!0})}set coverageProvider(T){Le(this,i,"f").coverageProvider=T}get coverageProvider(){return Le(this,i,"f").coverageProvider}setState(T,q,L){!Le(this,r,"f")&&Le(this,b,"f").isIncluded(T)&&(this.ensureTestIsKnown(T),Le(this,g,"f").$updateTestStateInRun(Le(this,b,"f").id,this.taskId,T.id,q,L))}appendMessage(T,q){!Le(this,r,"f")&&Le(this,b,"f").isIncluded(T)&&(this.ensureTestIsKnown(T),Le(this,g,"f").$appendTestMessageInRun(Le(this,b,"f").id,this.taskId,T.id,f.TestMessage.from(q)))}appendOutput(T){Le(this,r,"f")||Le(this,g,"f").$appendOutputToRun(Le(this,b,"f").id,this.taskId,F.VSBuffer.fromString(T))}end(){Le(this,r,"f")||(nt(this,r,!0,"f"),Le(this,g,"f").$finishedTestRunTask(Le(this,b,"f").id,this.taskId),Le(this,s,"f").call(this))}ensureTestIsKnown(T){const q=Le(this,t,"f");if(q.has(T.id))return;const L=[];for(;L.unshift(f.TestItem.from(T)),!(q.has(T.id)||(q.add(T.id),!T.parent));)T=T.parent;const B=Le(this,b,"f").colllection.root;q.has(B.id)||(q.add(B.id),L.unshift(f.TestItem.from(B))),Le(this,g,"f").$addTestsToRun(Le(this,b,"f").controllerId,Le(this,b,"f").id,L)}}g=new WeakMap,b=new WeakMap,t=new WeakMap,s=new WeakMap,i=new WeakMap,r=new WeakMap;class $ extends u.IncrementalChangeCollector{constructor(T){super();this.emitter=T,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(T){this.added.add(T)}update(T){Object.assign(T.revived,f.TestItem.toPlain(T.item)),this.added.has(T)||this.updated.add(T)}remove(T){if(this.added.has(T)){this.added.delete(T);return}if(this.updated.delete(T),T.parent&&this.alreadyRemoved.has(T.parent)){this.alreadyRemoved.add(T.item.extId);return}this.removed.add(T)}getChangeEvent(){const{added:T,updated:q,removed:L}=this;return{get added(){return[...T].map(B=>B.revived)},get updated(){return[...q].map(B=>B.revived)},get removed(){return[...L].map(B=>B.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class ie extends u.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new y.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(T){return this.items.get(T)}getMirroredTestDataByReference(T){return this.items.get(T.id)}createItem(T,q){return{...T,revived:f.TestItem.toPlain(T.item),depth:q?q.depth+1:0,children:new Set}}createChangeCollector(){return new $(this.changeEmitter)}}e.MirroredTestCollection=ie;class ce{constructor(T){this.proxy=T}checkout(){this.current||(this.current=this.createObserverData());const T=this.current;return T.observers++,{onDidChangeTest:T.tests.onDidChangeTests,get tests(){return[...T.tests.rootTests].map(q=>q.revived)},dispose:(0,I.once)(()=>{--T.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(T){return this.current?.tests.getMirroredTestDataByReference(T)}applyDiff(T){this.current?.tests.apply(T)}createObserverData(){const T=new ie;return this.proxy.$subscribeToDiffs(),{observers:0,tests:T}}}class K{constructor(T,q,L,B,Y,j,se=!1){this.controllerId=q,this.configId=L,this._label=B,this.group=Y,this.runHandler=j,this._isDefault=se,c.set(this,void 0),nt(this,c,T,"f");const Se=H[Y];if(typeof Se!="number")throw new Error(`Unknown TestRunConfiguration.group ${Y}`);Le(this,c,"f").$publishTestRunConfig({profileId:L,controllerId:q,label:B,group:Se,isDefault:se,hasConfigurationHandler:!1})}get label(){return this._label}set label(T){T!==this._label&&(this._label=T,Le(this,c,"f").$updateTestRunConfig(this.controllerId,this.configId,{label:T}))}get isDefault(){return this._isDefault}set isDefault(T){T!==this._isDefault&&(this._isDefault=T,Le(this,c,"f").$updateTestRunConfig(this.controllerId,this.configId,{isDefault:T}))}get configureHandler(){return this._configureHandler}set configureHandler(T){T!==this._configureHandler&&(this._configureHandler=T,Le(this,c,"f").$updateTestRunConfig(this.controllerId,this.configId,{hasConfigurationHandler:!!T}))}dispose(){Le(this,c,"f").$removeTestRunConfig(this.controllerId,this.configId)}}e.TestRunConfigurationImpl=K,c=new WeakMap;const H={[E.TestRunConfigurationGroup.Coverage]:8,[E.TestRunConfigurationGroup.Debug]:4,[E.TestRunConfigurationGroup.Run]:2}}),define(_e[205],ye([0,1,3,17,5,99,9,6]),function(ee,e,m,F,D,y,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(n,k){this._extHostDocumentsAndEditors=k,this._onDidChangeTextEditorSelection=new m.Emitter,this._onDidChangeTextEditorOptions=new m.Emitter,this._onDidChangeTextEditorVisibleRanges=new m.Emitter,this._onDidChangeTextEditorViewColumn=new m.Emitter,this._onDidChangeActiveTextEditor=new m.Emitter,this._onDidChangeVisibleTextEditors=new m.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(D.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(l=>this._onDidChangeVisibleTextEditors.fire(l)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(l=>this._onDidChangeActiveTextEditor.fire(l))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const k=this._extHostDocumentsAndEditors.allEditors();return n?k:k.map(l=>l.value)}async showTextDocument(n,k,l){let h;typeof k=="number"?h={position:I.ViewColumn.from(k),preserveFocus:l}:typeof k=="object"?h={position:I.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?I.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:h={preserveFocus:!1};const a=await this._proxy.$tryShowTextDocument(n.uri,h),d=a&&this._extHostDocumentsAndEditors.getEditor(a);if(d)return d.value;throw a?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n,k){return new y.TextEditorDecorationType(this._proxy,n,k).value}$acceptEditorPropertiesChanged(n,k){const l=this._extHostDocumentsAndEditors.getEditor(n);if(!l)throw new Error("unknown text editor");if(k.options&&l._acceptOptions(k.options),k.selections){const h=k.selections.selections.map(I.Selection.to);l._acceptSelections(h)}if(k.visibleRanges){const h=F.coalesce(k.visibleRanges.map(I.Range.to));l._acceptVisibleRanges(h)}if(k.options&&this._onDidChangeTextEditorOptions.fire({textEditor:l.value,options:{...k.options,lineNumbers:I.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const h=S.TextEditorSelectionChangeKind.fromValue(k.selections.source),a=k.selections.selections.map(I.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:l.value,selections:a,kind:h})}if(k.visibleRanges){const h=F.coalesce(k.visibleRanges.map(I.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:l.value,visibleRanges:h})}}$acceptEditorPositionData(n){for(const k in n){const l=this._extHostDocumentsAndEditors.getEditor(k);if(!l)throw new Error("Unknown text editor");const h=I.ViewColumn.to(n[k]);l.value.viewColumn!==h&&(l._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:l.value,viewColumn:h}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=_}),define(_e[206],ye([0,1,2,4,5,7,6]),function(ee,e,m,F,D,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,F.createDecorator)("IExtHostTimeline");class S{constructor(n,k){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(D.MainContext.MainThreadTimeline),k.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===11){const h=l.uri===void 0?void 0:m.URI.revive(l.uri);return this._itemsBySourceAndUriMap.get(l.source)?.get(_(h))?.get(l.handle)}return l}})}async $getTimeline(n,k,l,h,a){return this._providers.get(n)?.provideTimeline(m.URI.revive(k),l,h,a)}registerTimelineProvider(n,k,l,h){const a=new y.DisposableStore,d=this.convertTimelineItem(k.id,h,a).bind(this);let f;k.onDidChange&&(f=k.onDidChange(w=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...w,id:k.id}),this));const E=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...k,scheme:n,onDidChange:void 0,async provideTimeline(w,u,g,b){b?.resetCache&&(a.clear(),E.get(k.id)?.clear());const t=await k.provideTimeline(w,u,g);if(t==null)return;const s=d(w,b);return{...t,source:k.id,items:t.items.map(s)}},dispose(){for(const w of E.values())w.get(k.id)?.clear();f?.dispose(),a.dispose()}})}convertTimelineItem(n,k,l){return(h,a)=>{let d;if(a?.cacheResults){let f=this._itemsBySourceAndUriMap.get(n);f===void 0&&(f=new Map,this._itemsBySourceAndUriMap.set(n,f));const E=_(h);d=f.get(E),d===void 0&&(d=new Map,f.set(E,d))}return f=>{const{iconPath:E,...w}=f,u=`${n}|${f.id??f.timestamp}`;d?.set(u,f);let g,b,t;return f.iconPath&&(E instanceof I.ThemeIcon?t={id:E.id,color:E.color}:m.URI.isUri(E)?(g=E,b=E):{light:g,dark:b}=E),{...w,id:w.id??void 0,handle:u,source:n,command:f.command?k.toInternal(f.command,l):void 0,icon:g,iconDark:b,themeIcon:t,accessibilityInformation:f.accessibilityInformation}}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),(0,y.toDisposable)(()=>{for(const l of this._itemsBySourceAndUriMap.values())l.get(n.id)?.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=S;function _(C){return C?.toString()}}),define(_e[207],ye([0,1,7,11,2,5]),function(ee,e,m,F,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class I{constructor(_){this._openers=new Map,this._proxy=_.getProxy(y.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,C,n,k){if(this._openers.has(C))throw new Error(`Opener with id '${C}' already registered`);const l=k.schemes.find(h=>!I.supportedSchemes.has(h));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(C,n),this._proxy.$registerUriOpener(C,k.schemes,_,k.label),(0,m.toDisposable)(()=>{this._openers.delete(C),this._proxy.$unregisterUriOpener(C)})}async $canOpenUri(_,C,n){const k=this._openers.get(_);if(!k)throw new Error(`Unknown opener with id: ${_}`);const l=D.URI.revive(C);return k.canOpenExternalUri(l,n)}async $openUri(_,C,n){const k=this._openers.get(_);if(!k)throw new Error(`Unknown opener id: '${_}'`);return k.openExternalUri(D.URI.revive(C.resolvedUri),{sourceUri:D.URI.revive(C.sourceUri)},n)}}e.ExtHostUriOpeners=I,I.supportedSchemes=new Set([F.Schemas.http,F.Schemas.https])}),define(_e[208],ye([0,1,5,2,7,12,26]),function(ee,e,m,F,D,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class S{constructor(C){this.handles=new Set,this.handlers=new Map,this._proxy=C.getProxy(m.MainContext.MainThreadUrls)}registerUriHandler(C,n){if(this.handles.has(I.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const k=S.HandlePool++;return this.handles.add(I.ExtensionIdentifier.toKey(C)),this.handlers.set(k,n),this._proxy.$registerUriHandler(k,C),(0,D.toDisposable)(()=>{this.handles.delete(I.ExtensionIdentifier.toKey(C)),this.handlers.delete(k),this._proxy.$unregisterUriHandler(k)})}$handleExternalUri(C,n){const k=this.handlers.get(C);if(!k)return Promise.resolve(void 0);try{k.handleUri(F.URI.revive(n))}catch(l){(0,y.onUnexpectedError)(l)}return Promise.resolve(void 0)}async createAppUri(C){return F.URI.revive(await this._proxy.$createAppUri(C))}}e.ExtHostUrls=S,S.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(ee,e,m,F,D){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?D.call(ee,m):D?D.value=m:e.set(ee,m),m},Le=this&&this.__classPrivateFieldGet||function(ee,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(ee):F?F.value:e.get(ee)};define(_e[47],ye([0,1,3,2,142,163,68,5]),function(ee,e,m,F,D,y,I,S){"use strict";var _,C,n,k,l,h,a,d,f,E,w,u;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class g{constructor(v,A,R,o,P,N,$){_.set(this,void 0),C.set(this,void 0),n.set(this,void 0),k.set(this,void 0),l.set(this,void 0),h.set(this,void 0),a.set(this,""),d.set(this,void 0),f.set(this,!1),E.set(this,!1),w.set(this,!1),this._onMessageEmitter=new m.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,u.set(this,new m.Emitter),this._onDidDispose=Le(this,u,"f").event,nt(this,_,v,"f"),nt(this,C,A,"f"),nt(this,d,R,"f"),nt(this,k,o,"f"),nt(this,l,P,"f"),nt(this,h,N,"f"),nt(this,w,b(N),"f"),nt(this,n,$,"f")}dispose(){nt(this,f,!0,"f"),Le(this,u,"f").fire(),Le(this,u,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(v){return nt(this,E,!0,"f"),(0,I.asWebviewUri)(v,Le(this,k,"f").remote)}get cspSource(){return I.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Le(this,a,"f")}set html(v){this.assertNotDisposed(),Le(this,a,"f")!==v&&(nt(this,a,v,"f"),!Le(this,E,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(v)&&(nt(this,E,!0,"f"),Le(this,n,"f").report("Webview vscode-resource: uris",Le(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Le(this,C,"f").$setHtml(Le(this,_,"f"),v))}get options(){return this.assertNotDisposed(),Le(this,d,"f")}set options(v){this.assertNotDisposed(),Le(this,C,"f").$setOptions(Le(this,_,"f"),i(Le(this,h,"f"),Le(this,l,"f"),v)),nt(this,d,v,"f")}async postMessage(v){if(Le(this,f,"f"))return!1;const A=(0,y.serializeWebviewMessage)(v,{serializeBuffersForPostMessage:Le(this,w,"f")});return Le(this,C,"f").$postMessage(Le(this,_,"f"),A.message,...A.buffers)}assertNotDisposed(){if(Le(this,f,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=g,_=new WeakMap,C=new WeakMap,n=new WeakMap,k=new WeakMap,l=new WeakMap,h=new WeakMap,a=new WeakMap,d=new WeakMap,f=new WeakMap,E=new WeakMap,w=new WeakMap,u=new WeakMap;function b(p){try{const v=(0,D.normalizeVersion)((0,D.parseVersion)(p.engines.vscode));return!!v&&v.majorBase>=1&&v.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=b;class t{constructor(v,A,R,o,P){this.initData=A,this.workspace=R,this._logService=o,this._deprecationService=P,this._webviews=new Map,this._webviewProxy=v.getProxy(S.MainContext.MainThreadWebviews)}$onMessage(v,A,...R){const o=this.getWebview(v);if(o){const{message:P}=(0,y.deserializeWebviewMessage)(A,R);o._onMessageEmitter.fire(P)}}$onMissingCsp(v,A){this._logService.warn(`${A} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(v,A,R){const o=new g(v,this._webviewProxy,r(A),this.initData,this.workspace,R,this._deprecationService);return this._webviews.set(v,o),o._onDidDispose(()=>{this._webviews.delete(v)}),o}deleteWebview(v){this._webviews.delete(v)}getWebview(v){return this._webviews.get(v)}}e.ExtHostWebviews=t;function s(p){return{id:p.identifier,location:p.extensionLocation}}e.toExtensionData=s;function i(p,v,A){return{enableCommandUris:A.enableCommandUris,enableScripts:A.enableScripts,portMapping:A.portMapping,localResourceRoots:A.localResourceRoots||c(p,v)}}e.serializeWebviewOptions=i;function r(p){return{enableCommandUris:p.enableCommandUris,enableScripts:p.enableScripts,portMapping:p.portMapping,localResourceRoots:p.localResourceRoots?.map(v=>F.URI.from(v))}}e.reviveOptions=r;function c(p,v){return[...(v?.getWorkspaceFolders()||[]).map(A=>A.uri),p.extensionLocation]}}),define(_e[209],ye([0,1,18,41,7,11,25,2,9,47,63,5,6]),function(ee,e,m,F,D,y,I,S,_,C,n,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(t,s){this.document=t,this._storagePath=s,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,s){await this.getEdit(t).undo(),s||this.disposeBackup()}async redo(t,s){await this.getEdit(t).redo(),s||this.disposeBackup()}disposeEdits(t){for(const s of t)this._edits.delete(s)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=g(this.document.uri)+this._backupCounter++;return(0,I.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const s=this._edits.get(t,0);if(!s)throw new Error("No edit found");return s}}class a{constructor(){this._documents=new Map}get(t,s){return this._documents.get(this.key(t,s))}add(t,s,i){const r=this.key(t,s.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${t} resource:${s.uri}`);const c=new h(s,i);return this._documents.set(r,c),c}delete(t,s){const i=this.key(t,s.uri);this._documents.delete(i)}key(t,s){return`${t}@@@${s}`}}var d;(function(b){b[b.Text=0]="Text",b[b.Custom=1]="Custom"})(d||(d={}));class f{constructor(){this._providers=new Map}addTextProvider(t,s,i){return this.add(0,t,s,i)}addCustomProvider(t,s,i){return this.add(1,t,s,i)}get(t){return this._providers.get(t)}add(t,s,i,r){if(this._providers.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this._providers.set(s,{type:t,extension:i,provider:r}),new l.Disposable(()=>this._providers.delete(s))}}class E{constructor(t,s,i,r,c){this._extHostDocuments=s,this._extensionStoragePaths=i,this._extHostWebview=r,this._extHostWebviewPanels=c,this._editorProviders=new f,this._documents=new a,this._proxy=t.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,s,i,r){const c=new D.DisposableStore;return w(i)?(c.add(this._editorProviders.addTextProvider(s,t,i)),this._proxy.$registerTextEditorProvider((0,C.toExtensionData)(t),s,r.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,C.shouldSerializeBuffersForPostMessage)(t))):(c.add(this._editorProviders.addCustomProvider(s,t,i)),this.supportEditing(i)&&c.add(i.onDidChangeCustomDocument(p=>{const v=this.getCustomDocumentEntry(s,p.document.uri);if(u(p)){const A=v.addEdit(p);this._proxy.$onDidEdit(p.document.uri,s,A,p.label)}else this._proxy.$onContentChange(p.document.uri,s)})),this._proxy.$registerCustomEditorProvider((0,C.toExtensionData)(t),s,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,C.shouldSerializeBuffersForPostMessage)(t))),l.Disposable.from(c,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(s)}))}async $createCustomDocument(t,s,i,r,c){const p=this._editorProviders.get(s);if(!p)throw new Error(`No provider found for '${s}'`);if(p.type!==1)throw new Error(`Invalid provide type for '${s}'`);const v=S.URI.revive(t),A=await p.provider.openCustomDocument(v,{backupId:i,untitledDocumentData:r?.buffer},c);let R;return this.supportEditing(p.provider)&&this._extensionStoragePaths&&(R=this._extensionStoragePaths.workspaceValue(p.extension)??this._extensionStoragePaths.globalValue(p.extension)),this._documents.add(s,A,R),{editable:this.supportEditing(p.provider)}}async $disposeCustomDocument(t,s){const i=this._editorProviders.get(s);if(!i)throw new Error(`No provider found for '${s}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${s}'`);const r=S.URI.revive(t),{document:c}=this.getCustomDocumentEntry(s,r);this._documents.delete(s,c),c.dispose()}async $resolveWebviewEditor(t,s,i,r,c,p){const v=this._editorProviders.get(i);if(!v)throw new Error(`No provider found for '${i}'`);const A=_.ViewColumn.to(c),R=this._extHostWebview.createNewWebview(s,r.webviewOptions,v.extension),o=this._extHostWebviewPanels.createNewWebviewPanel(s,i,r.title,A,r.panelOptions,R),P=S.URI.revive(t);switch(v.type){case 1:{const{document:N}=this.getCustomDocumentEntry(i,P);return v.provider.resolveCustomEditor(N,o,p)}case 0:{const N=this._extHostDocuments.getDocument(P);return v.provider.resolveCustomTextEditor(N,o,p)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,s,i){this.getCustomDocumentEntry(s,t).disposeEdits(i)}async $onMoveCustomEditor(t,s,i){const r=this._editorProviders.get(i);if(!r)throw new Error(`No provider found for '${i}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const c=this._extHostWebviewPanels.getWebviewPanel(t);if(!c)throw new Error("No webview found");const p=S.URI.revive(s),v=this._extHostDocuments.getDocument(p);await r.provider.moveCustomTextEditor(v,c,m.CancellationToken.None)}async $undo(t,s,i,r){return this.getCustomDocumentEntry(s,t).undo(i,r)}async $redo(t,s,i,r){return this.getCustomDocumentEntry(s,t).redo(i,r)}async $revert(t,s,i){const r=this.getCustomDocumentEntry(s,t);await this.getCustomEditorProvider(s).revertCustomDocument(r.document,i),r.disposeBackup()}async $onSave(t,s,i){const r=this.getCustomDocumentEntry(s,t);await this.getCustomEditorProvider(s).saveCustomDocument(r.document,i),r.disposeBackup()}async $onSaveAs(t,s,i,r){const c=this.getCustomDocumentEntry(s,t);return this.getCustomEditorProvider(s).saveCustomDocumentAs(c.document,S.URI.revive(i),r)}async $backup(t,s,i){const r=this.getCustomDocumentEntry(s,t),p=await this.getCustomEditorProvider(s).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},i);return r.updateBackup(p),p.id}getCustomDocumentEntry(t,s){const i=this._documents.get(t,S.URI.revive(s));if(!i)throw new Error("No custom document found");return i}getCustomEditorProvider(t){const i=this._editorProviders.get(t)?.provider;if(!i||!this.supportEditing(i))throw new Error("Custom document is not editable");return i}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=E;function w(b){return typeof b.resolveCustomTextEditor=="function"}function u(b){return typeof b.undo=="function"&&typeof b.redo=="function"}function g(b){const t=b.scheme===y.Schemas.file||b.scheme===y.Schemas.untitled?b.fsPath:b.toString();return(0,F.hash)(t)+""}});var nt=this&&this.__classPrivateFieldSet||function(ee,e,m,F,D){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?D.call(ee,m):D?D.value=m:e.set(ee,m),m},Le=this&&this.__classPrivateFieldGet||function(ee,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(ee):F?F.value:e.get(ee)};define(_e[210],ye([0,1,3,7,2,35,9,47,5,6]),function(ee,e,m,F,D,y,I,S,_,C){"use strict";var n,k,l,h,a,d,f,E,w,u,g,b,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class s extends F.Disposable{constructor(p,v,A,R,o,P,N){super();n.set(this,void 0),k.set(this,void 0),l.set(this,void 0),h.set(this,void 0),a.set(this,void 0),d.set(this,void 0),f.set(this,void 0),E.set(this,void 0),w.set(this,!0),u.set(this,!0),g.set(this,!1),b.set(this,this._register(new m.Emitter)),this.onDidDispose=Le(this,b,"f").event,t.set(this,this._register(new m.Emitter)),this.onDidChangeViewState=Le(this,t,"f").event,nt(this,n,p,"f"),nt(this,k,v,"f"),nt(this,l,A,"f"),nt(this,a,P,"f"),nt(this,E,o,"f"),nt(this,d,R,"f"),nt(this,h,N,"f")}dispose(){Le(this,g,"f")||(nt(this,g,!0,"f"),Le(this,b,"f").fire(),Le(this,k,"f").$disposeWebview(Le(this,n,"f")),Le(this,h,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Le(this,h,"f")}get viewType(){return this.assertNotDisposed(),Le(this,l,"f")}get title(){return this.assertNotDisposed(),Le(this,d,"f")}set title(p){this.assertNotDisposed(),Le(this,d,"f")!==p&&(nt(this,d,p,"f"),Le(this,k,"f").$setTitle(Le(this,n,"f"),p))}get iconPath(){return this.assertNotDisposed(),Le(this,f,"f")}set iconPath(p){this.assertNotDisposed(),Le(this,f,"f")!==p&&(nt(this,f,p,"f"),Le(this,k,"f").$setIconPath(Le(this,n,"f"),D.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return Le(this,a,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Le(this,E,"f")=="number"&&Le(this,E,"f")<0))return Le(this,E,"f")}get active(){return this.assertNotDisposed(),Le(this,u,"f")}get visible(){return this.assertNotDisposed(),Le(this,w,"f")}_updateViewState(p){Le(this,g,"f")||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(nt(this,u,p.active,"f"),nt(this,w,p.visible,"f"),nt(this,E,p.viewColumn,"f"),Le(this,t,"f").fire({webviewPanel:this}))}reveal(p,v){this.assertNotDisposed(),Le(this,k,"f").$reveal(Le(this,n,"f"),{viewColumn:p?I.ViewColumn.from(p):void 0,preserveFocus:!!v})}assertNotDisposed(){if(Le(this,g,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,k=new WeakMap,l=new WeakMap,h=new WeakMap,a=new WeakMap,d=new WeakMap,f=new WeakMap,E=new WeakMap,w=new WeakMap,u=new WeakMap,g=new WeakMap,b=new WeakMap,t=new WeakMap;class i{constructor(p,v,A){this.webviews=v,this.workspace=A,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=p.getProxy(_.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,y.generateUuid)()}createWebviewPanel(p,v,A,R,o={}){const P=typeof R=="object"?R.viewColumn:R,N={viewColumn:I.ViewColumn.from(P),preserveFocus:typeof R=="object"&&!!R.preserveFocus},$=(0,S.shouldSerializeBuffersForPostMessage)(p),ie=i.newHandle();this._proxy.$createWebviewPanel((0,S.toExtensionData)(p),ie,v,{title:A,panelOptions:r(o),webviewOptions:(0,S.serializeWebviewOptions)(p,this.workspace,o),serializeBuffersForPostMessage:$},N);const ce=this.webviews.createNewWebview(ie,o,p);return this.createNewWebviewPanel(ie,v,A,P,o,ce)}$onDidChangeWebviewPanelViewStates(p){const v=Object.keys(p);v.sort((A,R)=>{const o=p[A],P=p[R];return o.active?1:P.active?-1:+o.visible-+P.visible});for(const A of v){const R=this.getWebviewPanel(A);if(!R)continue;const o=p[A];R._updateViewState({active:o.active,visible:o.visible,viewColumn:I.ViewColumn.to(o.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this._webviewPanels.delete(p),this.webviews.deleteWebview(p)}registerWebviewPanelSerializer(p,v,A){if(this._serializers.has(v))throw new Error(`Serializer for '${v}' already registered`);return this._serializers.set(v,{serializer:A,extension:p}),this._proxy.$registerSerializer(v,{serializeBuffersForPostMessage:(0,S.shouldSerializeBuffersForPostMessage)(p)}),new C.Disposable(()=>{this._serializers.delete(v),this._proxy.$unregisterSerializer(v)})}async $deserializeWebviewPanel(p,v,A,R){const o=this._serializers.get(v);if(!o)throw new Error(`No serializer found for '${v}'`);const{serializer:P,extension:N}=o,$=this.webviews.createNewWebview(p,A.webviewOptions,N),ie=this.createNewWebviewPanel(p,v,A.title,R,A.panelOptions,$);await P.deserializeWebviewPanel(ie,A.state)}createNewWebviewPanel(p,v,A,R,o,P){const N=new s(p,this._proxy,v,A,R,o,P);return this._webviewPanels.set(p,N),N}getWebviewPanel(p){return this._webviewPanels.get(p)}}e.ExtHostWebviewPanels=i;function r(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(ee,e,m,F,D){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?D.call(ee,m):D?D.value=m:e.set(ee,m),m},Le=this&&this.__classPrivateFieldGet||function(ee,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(ee):F?F.value:e.get(ee)};define(_e[211],ye([0,1,3,7,47,5,6]),function(ee,e,m,F,D,y,I){"use strict";var S,_,C,n,k,l,h,a,d,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class E extends F.Disposable{constructor(g,b,t,s,i,r){super();S.set(this,void 0),_.set(this,void 0),C.set(this,void 0),n.set(this,void 0),k.set(this,!1),l.set(this,void 0),h.set(this,void 0),a.set(this,void 0),d.set(this,this._register(new m.Emitter)),this.onDidChangeVisibility=Le(this,d,"f").event,f.set(this,this._register(new m.Emitter)),this.onDidDispose=Le(this,f,"f").event,nt(this,C,t,"f"),nt(this,h,s,"f"),nt(this,S,g,"f"),nt(this,_,b,"f"),nt(this,n,i,"f"),nt(this,l,r,"f")}dispose(){Le(this,k,"f")||(nt(this,k,!0,"f"),Le(this,f,"f").fire(),Le(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Le(this,h,"f")}set title(g){this.assertNotDisposed(),Le(this,h,"f")!==g&&(nt(this,h,g,"f"),Le(this,_,"f").$setWebviewViewTitle(Le(this,S,"f"),g))}get description(){return this.assertNotDisposed(),Le(this,a,"f")}set description(g){this.assertNotDisposed(),Le(this,a,"f")!==g&&(nt(this,a,g,"f"),Le(this,_,"f").$setWebviewViewDescription(Le(this,S,"f"),g))}get visible(){return Le(this,l,"f")}get webview(){return Le(this,n,"f")}get viewType(){return Le(this,C,"f")}_setVisible(g){g===Le(this,l,"f")||Le(this,k,"f")||(nt(this,l,g,"f"),Le(this,d,"f").fire())}show(g){this.assertNotDisposed(),Le(this,_,"f").$show(Le(this,S,"f"),!!g)}assertNotDisposed(){if(Le(this,k,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,_=new WeakMap,C=new WeakMap,n=new WeakMap,k=new WeakMap,l=new WeakMap,h=new WeakMap,a=new WeakMap,d=new WeakMap,f=new WeakMap;class w{constructor(g,b){this._extHostWebview=b,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=g.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(g,b,t,s){if(this._viewProviders.has(b))throw new Error(`View provider for '${b}' already registered`);return this._viewProviders.set(b,{provider:t,extension:g}),this._proxy.$registerWebviewViewProvider((0,D.toExtensionData)(g),b,{retainContextWhenHidden:s?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new I.Disposable(()=>{this._viewProviders.delete(b),this._proxy.$unregisterWebviewViewProvider(b)})}async $resolveWebviewView(g,b,t,s,i){const r=this._viewProviders.get(b);if(!r)throw new Error(`No view provider found for '${b}'`);const{provider:c,extension:p}=r,v=this._extHostWebview.createNewWebview(g,{},p),A=new E(g,this._proxy,b,t,v,!0);this._webviewViews.set(g,A),await c.resolveWebviewView(A,{state:s},i)}async $onDidChangeWebviewViewVisibility(g,b){this.getWebviewView(g)._setVisible(b)}async $disposeWebviewView(g){const b=this.getWebviewView(g);this._webviewViews.delete(g),b.dispose(),this._extHostWebview.deleteWebview(g)}getWebviewView(g){const b=this._webviewViews.get(g);if(!b)throw new Error("No webview found");return b}}e.ExtHostWebviewViews=w}),define(_e[103],ye([0,1,3,5,2,11,8,4,13]),function(ee,e,m,F,D,y,I,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class xn{constructor(k){this._onDidChangeWindowState=new m.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=xn.InitialState,this._proxy=k.getProxy(F.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(l=>this.$onDidChangeWindowFocus(l))}get state(){return this._state}$onDidChangeWindowFocus(k){k!==this._state.focused&&(this._state={...this._state,focused:k},this._onDidChangeWindowState.fire(this._state))}openUri(k,l){let h;if(typeof k=="string"){h=k;try{k=D.URI.parse(k)}catch(a){return Promise.reject(`Invalid uri - '${k}'`)}}return(0,I.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===y.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this._proxy.$openUri(k,h,l)}async asExternalUri(k,l){if((0,I.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this._proxy.$asExternalUri(k,l);return D.URI.from(h)}};C.InitialState={focused:!0},C=ze([je(0,_.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=(0,S.createDecorator)("IExtHostWindow")}),define(_e[212],ye([0,1,15,5,28,13]),function(ee,e,m,F,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let I=class extends m.AbstractLogger{constructor(_,C){super();this._proxy=_.getProxy(F.MainContext.MainThreadLog),this._logFile=C.logFile.toJSON(),this.setLevel(C.logLevel)}$setLevel(_){this.setLevel(_)}trace(_,...C){this.getLevel()<=m.LogLevel.Trace&&this._proxy.$log(this._logFile,m.LogLevel.Trace,Array.from(arguments))}debug(_,...C){this.getLevel()<=m.LogLevel.Debug&&this._proxy.$log(this._logFile,m.LogLevel.Debug,Array.from(arguments))}info(_,...C){this.getLevel()<=m.LogLevel.Info&&this._proxy.$log(this._logFile,m.LogLevel.Info,Array.from(arguments))}warn(_,...C){this.getLevel()<=m.LogLevel.Warning&&this._proxy.$log(this._logFile,m.LogLevel.Warning,Array.from(arguments))}error(_,...C){this.getLevel()<=m.LogLevel.Error&&this._proxy.$log(this._logFile,m.LogLevel.Error,Array.from(arguments))}critical(_,...C){this.getLevel()<=m.LogLevel.Critical&&this._proxy.$log(this._logFile,m.LogLevel.Critical,Array.from(arguments))}flush(){}};I=ze([je(0,y.IExtHostRpcService),je(1,D.IExtHostInitDataService)],I),e.ExtHostLogService=I}),define(_e[213],ye([0,1,16,18,12,3,7,114,182,100,23]),function(ee,e,m,F,D,y,I,S,_,C,n){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function l(r,c){try{return JSON.stringify(r,c)}catch(p){return"null"}}function h(r,c){return JSON.stringify(r,c)}function a(r){return r?(c,p)=>p&&p.$mid===1?r.transformOutgoing(p):p:null}var d;(function(r){r[r.LocalSide=0]="LocalSide",r[r.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));var f;(function(r){r[r.Responsive=0]="Responsive",r[r.Unresponsive=1]="Unresponsive"})(f=e.ResponsiveState||(e.ResponsiveState={}));const E=()=>{},w=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class g extends I.Disposable{constructor(c,p=null,v=null){super();this[k]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=c,this._logger=p,this._uriTransformer=v,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let A=0,R=C.ProxyIdentifier.count;A<R;A++)this._locals[A]=null,this._proxies[A]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new m.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(A=>this._receiveOneMessage(A))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(c=>{this._pendingRPCReplies[c].resolveErr(D.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(c){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+g.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(c){this._unresponsiveTime=Date.now()+g.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(c){this._responsiveState!==c&&(this._responsiveState=c,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(c){return this._uriTransformer?(0,S.transformIncomingURIs)(c,this._uriTransformer):c}getProxy(c){const{nid:p,sid:v}=c;return this._proxies[p]||(this._proxies[p]=this._createProxy(p,v)),this._proxies[p]}_createProxy(c,p){let v={get:(A,R)=>(typeof R=="string"&&!A[R]&&R.charCodeAt(0)===36&&(A[R]=(...o)=>this._remoteCall(c,R,o)),R===u?p:A[R])};return new Proxy(Object.create(null),v)}set(c,p){return this._locals[c.nid]=p,p}assertRegistered(c){for(let p=0,v=c.length;p<v;p++){const A=c[p];if(!this._locals[A.nid])throw new Error(`Missing actor ${A.sid} (isMain: ${A.isMain})`)}}_receiveOneMessage(c){if(this._isDisposed)return;const p=c.byteLength,v=b.read(c,0),A=v.readUInt8(),R=v.readUInt32();switch(A){case 1:case 2:{let{rpcId:o,method:P,args:N}=t.deserializeRequestJSONArgs(v);this._uriTransformer&&(N=(0,S.transformIncomingURIs)(N,this._uriTransformer)),this._receiveRequest(p,R,o,P,N,A===2);break}case 3:case 4:{let{rpcId:o,method:P,args:N}=t.deserializeRequestMixedArgs(v);this._uriTransformer&&(N=(0,S.transformIncomingURIs)(N,this._uriTransformer)),this._receiveRequest(p,R,o,P,N,A===4);break}case 5:{this._logger&&this._logger.logIncoming(p,R,0,"ack"),this._onDidReceiveAcknowledge(R);break}case 6:{this._receiveCancel(p,R);break}case 7:{this._receiveReply(p,R,void 0);break}case 9:{let o=t.deserializeReplyOKJSON(v);this._uriTransformer&&(o=(0,S.transformIncomingURIs)(o,this._uriTransformer)),this._receiveReply(p,R,o);break}case 8:{let o=t.deserializeReplyOKVSBuffer(v);this._receiveReply(p,R,o);break}case 10:{let o=t.deserializeReplyErrError(v);this._uriTransformer&&(o=(0,S.transformIncomingURIs)(o,this._uriTransformer)),this._receiveReplyErr(p,R,o);break}case 11:{this._receiveReplyErr(p,R,void 0);break}default:console.error("received unexpected message"),console.error(c)}}_receiveRequest(c,p,v,A,R,o){this._logger&&this._logger.logIncoming(c,p,1,`receiveRequest ${(0,C.getStringIdentifierForProxy)(v)}.${A}(`,R);const P=String(p);let N,$;if(o){const ce=new F.CancellationTokenSource;R.push(ce.token),N=this._invokeHandler(v,A,R),$=()=>ce.cancel()}else N=this._invokeHandler(v,A,R),$=E;this._cancelInvokedHandlers[P]=$;const ie=t.serializeAcknowledged(p);this._logger&&this._logger.logOutgoing(ie.byteLength,p,1,"ack"),this._protocol.send(ie),N.then(ce=>{delete this._cancelInvokedHandlers[P];const K=t.serializeReplyOK(p,ce,this._uriReplacer);this._logger&&this._logger.logOutgoing(K.byteLength,p,1,"reply:",ce),this._protocol.send(K)},ce=>{delete this._cancelInvokedHandlers[P];const K=t.serializeReplyErr(p,ce);this._logger&&this._logger.logOutgoing(K.byteLength,p,1,"replyErr:",ce),this._protocol.send(K)})}_receiveCancel(c,p){this._logger&&this._logger.logIncoming(c,p,1,"receiveCancel");const v=String(p);this._cancelInvokedHandlers[v]&&this._cancelInvokedHandlers[v]()}_receiveReply(c,p,v){this._logger&&this._logger.logIncoming(c,p,0,"receiveReply:",v);const A=String(p);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const R=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A],R.resolveOk(v)}_receiveReplyErr(c,p,v){this._logger&&this._logger.logIncoming(c,p,0,"receiveReplyErr:",v);const A=String(p);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const R=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A];let o;v&&(v.$isError?(o=new Error,o.name=v.name,o.message=v.message,o.stack=v.stack):o=v),R.resolveErr(o)}_invokeHandler(c,p,v){try{return Promise.resolve(this._doInvokeHandler(c,p,v))}catch(A){return Promise.reject(A)}}_doInvokeHandler(c,p,v){const A=this._locals[c];if(!A)throw new Error("Unknown actor "+(0,C.getStringIdentifierForProxy)(c));let R=A[p];if(typeof R!="function")throw new Error("Unknown method "+p+" on actor "+(0,C.getStringIdentifierForProxy)(c));return R.apply(A,v)}_remoteCall(c,p,v){if(this._isDisposed)return Promise.reject(D.canceled());let A=null;if(v.length>0&&F.CancellationToken.isCancellationToken(v[v.length-1])&&(A=v.pop()),A&&A.isCancellationRequested)return Promise.reject(D.canceled());const R=t.serializeRequestArguments(v,this._uriReplacer),o=++this._lastMessageId,P=String(o),N=new _.LazyPromise;A&&A.onCancellationRequested(()=>{const ie=t.serializeCancel(o);this._logger&&this._logger.logOutgoing(ie.byteLength,o,0,"cancel"),this._protocol.send(t.serializeCancel(o))}),this._pendingRPCReplies[P]=N,this._onWillSendRequest(o);const $=t.serializeRequest(o,c,p,R,!!A);return this._logger&&this._logger.logOutgoing($.byteLength,o,0,`request: ${(0,C.getStringIdentifierForProxy)(c)}.${p}(`,v),this._protocol.send($),N}}e.RPCProtocol=g,k=w,g.UNRESPONSIVE_TIME=3*1e3;class b{constructor(c,p){this._buff=c,this._offset=p}static alloc(c,p,v){let A=new b(n.VSBuffer.alloc(v+1+4),0);return A.writeUInt8(c),A.writeUInt32(p),A}static read(c,p){return new b(c,p)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(c){this._buff.writeUInt8(c,this._offset),this._offset+=1}readUInt8(){const c=this._buff.readUInt8(this._offset);return this._offset+=1,c}writeUInt32(c){this._buff.writeUInt32BE(c,this._offset),this._offset+=4}readUInt32(){const c=this._buff.readUInt32BE(this._offset);return this._offset+=4,c}static sizeShortString(c){return 1+c.byteLength}writeShortString(c){this._buff.writeUInt8(c.byteLength,this._offset),this._offset+=1,this._buff.set(c,this._offset),this._offset+=c.byteLength}readShortString(){const c=this._buff.readUInt8(this._offset);this._offset+=1;const v=this._buff.slice(this._offset,this._offset+c).toString();return this._offset+=c,v}static sizeLongString(c){return 4+c.byteLength}writeLongString(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}readLongString(){const c=this._buff.readUInt32BE(this._offset);this._offset+=4;const v=this._buff.slice(this._offset,this._offset+c).toString();return this._offset+=c,v}writeBuffer(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}static sizeVSBuffer(c){return 4+c.byteLength}writeVSBuffer(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}readVSBuffer(){const c=this._buff.readUInt32BE(this._offset);this._offset+=4;const p=this._buff.slice(this._offset,this._offset+c);return this._offset+=c,p}static sizeMixedArray(c,p){let v=0;v+=1;for(let A=0,R=c.length;A<R;A++){const o=c[A],P=p[A];switch(v+=1,P){case 1:v+=this.sizeLongString(o);break;case 2:v+=this.sizeVSBuffer(o);break;case 3:break}}return v}writeMixedArray(c,p){this._buff.writeUInt8(c.length,this._offset),this._offset+=1;for(let v=0,A=c.length;v<A;v++){const R=c[v];switch(p[v]){case 1:this.writeUInt8(1),this.writeLongString(R);break;case 2:this.writeUInt8(2),this.writeVSBuffer(R);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const c=this._buff.readUInt8(this._offset);this._offset+=1;let p=new Array(c);for(let v=0;v<c;v++)switch(this.readUInt8()){case 1:p[v]=this.readLongString();break;case 2:p[v]=this.readVSBuffer();break;case 3:p[v]=void 0;break}return p}}class t{static _arrayContainsBufferOrUndefined(c){for(let p=0,v=c.length;p<v;p++)if(c[p]instanceof n.VSBuffer||typeof c[p]=="undefined")return!0;return!1}static serializeRequestArguments(c,p){if(this._arrayContainsBufferOrUndefined(c)){let v=[],A=[];for(let R=0,o=c.length;R<o;R++){const P=c[R];P instanceof n.VSBuffer?(v[R]=P,A[R]=2):typeof P=="undefined"?(v[R]=n.VSBuffer.alloc(0),A[R]=3):(v[R]=n.VSBuffer.fromString(h(P,p)),A[R]=1)}return{type:"mixed",args:v,argsType:A}}return{type:"simple",args:h(c,p)}}static serializeRequest(c,p,v,A,R){return A.type==="mixed"?this._requestMixedArgs(c,p,v,A.args,A.argsType,R):this._requestJSONArgs(c,p,v,A.args,R)}static _requestJSONArgs(c,p,v,A,R){const o=n.VSBuffer.fromString(v),P=n.VSBuffer.fromString(A);let N=0;N+=b.sizeUInt8(),N+=b.sizeShortString(o),N+=b.sizeLongString(P);let $=b.alloc(R?2:1,c,N);return $.writeUInt8(p),$.writeShortString(o),$.writeLongString(P),$.buffer}static deserializeRequestJSONArgs(c){const p=c.readUInt8(),v=c.readShortString(),A=c.readLongString();return{rpcId:p,method:v,args:JSON.parse(A)}}static _requestMixedArgs(c,p,v,A,R,o){const P=n.VSBuffer.fromString(v);let N=0;N+=b.sizeUInt8(),N+=b.sizeShortString(P),N+=b.sizeMixedArray(A,R);let $=b.alloc(o?4:3,c,N);return $.writeUInt8(p),$.writeShortString(P),$.writeMixedArray(A,R),$.buffer}static deserializeRequestMixedArgs(c){const p=c.readUInt8(),v=c.readShortString(),A=c.readMixedArray(),R=new Array(A.length);for(let o=0,P=A.length;o<P;o++){const N=A[o];typeof N=="string"?R[o]=JSON.parse(N):R[o]=N}return{rpcId:p,method:v,args:R}}static serializeAcknowledged(c){return b.alloc(5,c,0).buffer}static serializeCancel(c){return b.alloc(6,c,0).buffer}static serializeReplyOK(c,p,v){return typeof p=="undefined"?this._serializeReplyOKEmpty(c):p instanceof n.VSBuffer?this._serializeReplyOKVSBuffer(c,p):this._serializeReplyOKJSON(c,l(p,v))}static _serializeReplyOKEmpty(c){return b.alloc(7,c,0).buffer}static _serializeReplyOKVSBuffer(c,p){let v=0;v+=b.sizeVSBuffer(p);let A=b.alloc(8,c,v);return A.writeVSBuffer(p),A.buffer}static deserializeReplyOKVSBuffer(c){return c.readVSBuffer()}static _serializeReplyOKJSON(c,p){const v=n.VSBuffer.fromString(p);let A=0;A+=b.sizeLongString(v);let R=b.alloc(9,c,A);return R.writeLongString(v),R.buffer}static deserializeReplyOKJSON(c){const p=c.readLongString();return JSON.parse(p)}static serializeReplyErr(c,p){return p?this._serializeReplyErrEror(c,p):this._serializeReplyErrEmpty(c)}static _serializeReplyErrEror(c,p){const v=n.VSBuffer.fromString(l(D.transformErrorForSerialization(p),null));let A=0;A+=b.sizeLongString(v);let R=b.alloc(10,c,A);return R.writeLongString(v),R.buffer}static deserializeReplyErrError(c){const p=c.readLongString();return JSON.parse(p)}static _serializeReplyErrEmpty(c){return b.alloc(11,c,0).buffer}}var s;(function(r){r[r.RequestJSONArgs=1]="RequestJSONArgs",r[r.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",r[r.RequestMixedArgs=3]="RequestMixedArgs",r[r.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",r[r.Acknowledged=5]="Acknowledged",r[r.Cancel=6]="Cancel",r[r.ReplyOKEmpty=7]="ReplyOKEmpty",r[r.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",r[r.ReplyOKJSON=9]="ReplyOKJSON",r[r.ReplyErrError=10]="ReplyErrError",r[r.ReplyErrEmpty=11]="ReplyErrEmpty"})(s||(s={}));var i;(function(r){r[r.String=1]="String",r[r.VSBuffer=2]="VSBuffer",r[r.Undefined=3]="Undefined"})(i||(i={}))}),define(_e[214],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const m=function(y){const I=S=>{self.removeEventListener("message",I);const _=S.data;Object.defineProperties(self,{postMessage:{value(C,n){_.postMessage(C,n)}},onmessage:{get(){return _.onmessage},set(C){_.onmessage=C}}}),_.addEventListener("message",C=>{self.dispatchEvent(new MessageEvent("message",{data:C.data}))}),_.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(y)};self.addEventListener("message",I)}.toString();class F extends EventTarget{constructor(y,I,S){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const _=`((${m})('${I}'))`,C=new Blob([_],{type:"application/javascript"}),n=URL.createObjectURL(C),k=new MessageChannel,l=n,h={type:"_newWorker",id:l,port:k.port2,url:n,options:S};y(h,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{const a={type:"_terminateWorker",id:l};k.port1.postMessage(a),URL.revokeObjectURL(n),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(a){k.port1.onmessage=a}},onmessageerror:{get(){return k.port1.onmessageerror},set(a){k.port1.onmessageerror=a}}}),k.port1.addEventListener("messageerror",a=>{const d=new MessageEvent("messageerror",{data:a.data});this.dispatchEvent(d)}),k.port1.addEventListener("message",a=>{const d=new MessageEvent("message",{data:a.data});this.dispatchEvent(d)}),k.port1.start()}}e.NestedWorker=F}),define(_e[215],ye([0,1,4]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,m.createDecorator)("remoteAgentService")}),define(_e[216],ye([0,1,11,14,21,2,4,93,44,178,215]),function(ee,e,m,F,D,y,I,S,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,I.createDecorator)("pathService");let k=class Bn{constructor(h,a,d,f){this.localUserHome=h,this.remoteAgentService=a,this.environmentService=d,this.contextService=f,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||D.OS)(),this.resolveUserHome=(async()=>{const E=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=E?.userHome||h})()}get defaultUriScheme(){return Bn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(h,a){if(h.remoteAuthority)return m.Schemas.vscodeRemote;const d=(0,S.getVirtualWorkspaceScheme)(a.getWorkspace());if(d)return d;const f=a.getWorkspace().folders[0];if(f)return f.uri.scheme;const E=a.getWorkspace().configuration;return E?E.scheme:m.Schemas.file}async userHome(h){return h?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(h=>h===1?F.win32:F.posix)}async fileURI(h){let a="";if(await this.resolveOS===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const f=h.indexOf("/",2);f===-1?(a=h.substring(2),h="/"):(a=h.substring(2,f),h=h.substring(f)||"/")}return y.URI.from({scheme:m.Schemas.file,authority:a,path:h,query:"",fragment:""})}};k=ze([je(1,n.IRemoteAgentService),je(2,C.IWorkbenchEnvironmentService),je(3,_.IWorkspaceContextService)],k),e.AbstractPathService=k}),define(_e[104],ye([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class m{constructor(I,S){this.line=I,this.character=S}isBefore(I){return!1}isBeforeOrEqual(I){return!1}isAfter(I){return!1}isAfterOrEqual(I){return!1}isEqual(I){return!1}compareTo(I){return 0}translate(I,S){return new m(0,0)}with(I){return new m(0,0)}}e.Position=m;class F{constructor(I,S,_,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new m(I,S),this.end=new m(_,C)}contains(I){return!1}isEqual(I){return!1}intersection(I){}union(I){return new F(0,0,0,0)}with(I){return new F(0,0,0,0)}}e.Range=F;var D;(function(y){y[y.Information=1]="Information",y[y.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(_e[38],ye([0,1,17,27,24,43,8,4,14,12,104]),function(ee,e,m,F,D,y,I,S,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const k="\u27EA ",l=" characters skipped \u27EB",h=(k.length+l.length+5)*2;e.ISearchService=(0,S.createDecorator)("searchService");var a;(function(T){T[T.file=0]="file",T[T.text=1]="text"})(a=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(T){T[T.File=1]="File",T[T.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function f(T){return!!T.preview}e.resultIsMatch=f;function E(T){return!!T.resource}e.isFileMatch=E;function w(T){return!!T.message}e.isProgressMessage=w;var u;(function(T){T[T.Normal=0]="Normal",T[T.NewSearchStarted=1]="NewSearchStarted"})(u=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(q){this.resource=q,this.results=[]}}e.FileMatch=g;class b{constructor(q,L,B){this.ranges=L;const Y=Array.isArray(L)?L:[L];if(B&&B.matchLines===1&&t(Y)){q=(0,I.getNLines)(q,B.matchLines);let j="",se=0,Se=0;const Re=Math.floor(B.charsPerLine/5),$e=[];for(const Ne of Y){const Ge=Math.max(Ne.startColumn-Re,0),Ke=Ne.startColumn+B.charsPerLine;if(Ge>Se+Re+h){const qe=k+(Ge-Se)+l;j+=qe+q.slice(Ge,Ke),se+=Ge-(Se+qe.length)}else j+=q.slice(Se,Ke);$e.push(new i(0,Ne.startColumn-se,Ne.endColumn-se)),Se=Ke}this.preview={text:j,matches:Array.isArray(this.ranges)?$e:$e[0]}}else{const j=Array.isArray(L)?L[0].startLineNumber:L.startLineNumber;this.preview={text:q,matches:(0,m.mapArrayOrNot)(L,se=>new s(se.startLineNumber-j,se.startColumn,se.endLineNumber-j,se.endColumn))}}}}e.TextSearchMatch=b;function t(T){const q=T[0].startLineNumber;for(const L of T)if(L.startLineNumber!==q||L.endLineNumber!==q)return!1;return!0}class s{constructor(q,L,B,Y){this.startLineNumber=q,this.startColumn=L,this.endLineNumber=B,this.endColumn=Y}}e.SearchRange=s;class i extends s{constructor(q,L,B){super(q,L,q,B)}}e.OneLineRange=i;var r;(function(T){T.Default="default",T.FileNames="fileNames",T.Type="type",T.Modified="modified",T.CountDescending="countDescending",T.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function c(T,q=!0){const L=T&&T.files&&T.files.exclude,B=q&&T&&T.search&&T.search.exclude;if(!L&&!B)return;if(!L||!B)return L||B;let Y=Object.create(null);return Y=D.mixin(Y,D.deepClone(L)),Y=D.mixin(Y,D.deepClone(B),!0),Y}e.getExcludes=c;function p(T,q){return T.excludePattern&&F.match(T.excludePattern,q)?!1:T.includePattern||T.usingSearchPaths?T.includePattern&&F.match(T.includePattern,q)?!0:T.usingSearchPaths?!!T.folderQueries&&T.folderQueries.some(L=>{const B=L.folder.fsPath;if(y.isEqualOrParent(q,B)){const Y=_.relative(B,q);return!L.includePattern||!!F.match(L.includePattern,Y)}else return!1}):!1:!0}e.pathIncludedInQuery=p;var v;(function(T){T[T.unknownEncoding=1]="unknownEncoding",T[T.regexParseError=2]="regexParseError",T[T.globParseError=3]="globParseError",T[T.invalidLiteral=4]="invalidLiteral",T[T.rgProcessError=5]="rgProcessError",T[T.other=6]="other",T[T.canceled=7]="canceled"})(v=e.SearchErrorCode||(e.SearchErrorCode={}));class A extends Error{constructor(q,L){super(q);this.code=L}}e.SearchError=A;function R(T){const q=T.message;if((0,C.isPromiseCanceledError)(T))return new A(q,v.canceled);try{const L=JSON.parse(q);return new A(L.message,L.code)}catch(L){return new A(q,v.other)}}e.deserializeSearchError=R;function o(T){const q={message:T.message,code:T.code};return new Error(JSON.stringify(q))}e.serializeSearchError=o;function P(T){return T.type==="error"?!0:T.type==="success"}e.isSerializedSearchComplete=P;function N(T){return T.type==="success"}e.isSerializedSearchSuccess=N;function $(T){return!!T.path}e.isSerializedFileMatch=$;function ie(T,q){const L=T.searchPath?T.searchPath:T.relativePath;return(0,I.fuzzyContains)(L,q)}e.isFilePatternMatch=ie;class ce{constructor(q){this.path=q,this.results=[]}addMatch(q){this.results.push(q)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=ce;function K(T,q){const L={...T||{},...q||{}};return Object.keys(L).filter(B=>{const Y=L[B];return typeof Y=="boolean"&&Y})}e.resolvePatternsForProvider=K;class H{constructor(q,L){this._parsedIncludeExpression=null,this._excludeExpression={...q.excludePattern||{},...L.excludePattern||{}},this._parsedExcludeExpression=F.parse(this._excludeExpression);let B=q.includePattern;L.includePattern&&(B?B={...B,...L.includePattern}:B=L.includePattern),B&&(this._parsedIncludeExpression=F.parse(B))}includedInQuerySync(q,L,B){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(q,L,B)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(q,L,B))}includedInQuery(q,L,B){return Promise.resolve(this._parsedExcludeExpression(q,L,B)).then(j=>!!j).then(j=>j?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(q,L,B)).then(se=>!!se):Promise.resolve(!0)).then(j=>j)}hasSiblingExcludeClauses(){return z(this._excludeExpression)}}e.QueryGlobTester=H;function z(T){for(const q in T)if(typeof T[q]!="boolean")return!0;return!1}}),define(_e[32],ye([0,1,17,16,18,3,22,11,79,25,8,10,2,135,4,15,149,44,45,28,13,6,38,5]),function(ee,e,m,F,D,y,I,S,_,C,n,k,l,h,a,d,f,E,w,u,g,b,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i(P,N,$){return new C.ExtUri(ie=>v(ie,$)).isEqual(P,N)}function r(P,N,$){return i(P.uri,N.uri,$)?0:(0,n.compare)(P.uri.toString(),N.uri.toString())}function c(P,N,$){return P.index!==N.index?P.index<N.index?-1:1:i(P.uri,N.uri,$)?(0,n.compare)(P.name,N.name):(0,n.compare)(P.uri.toString(),N.uri.toString())}function p(P,N,$,ie){const ce=P.slice(0).sort((H,z)=>$(H,z,ie)),K=N.slice(0).sort((H,z)=>$(H,z,ie));return(0,m.delta)(ce,K,(H,z)=>$(H,z,ie))}function v(P,N){const $=N.getCapabilities(P.scheme);return!($&&$&1024)}class A extends E.Workspace{constructor(N,$,ie,ce,K,H){super(N,ie.map(z=>new E.WorkspaceFolder(z)),ce,H);this._name=$,this._isUntitled=K,this._workspaceFolders=[],this._structure=I.TernarySearchTree.forUris(H),ie.forEach(z=>{this._workspaceFolders.push(z),this._structure.set(z.uri,z)})}static toExtHostWorkspace(N,$,ie,ce){if(!N)return{workspace:null,added:[],removed:[]};const{id:K,name:H,folders:z,configuration:T,isUntitled:q}=N,L=[],B=$;$?z.forEach((Se,Re)=>{const $e=l.URI.revive(Se.uri),Ne=A._findFolder(ie||$,$e,ce);Ne?(Ne.name=Se.name,Ne.index=Se.index,L.push(Ne)):L.push({uri:$e,name:Se.name,index:Re})}):L.push(...z.map(({uri:Se,name:Re,index:$e})=>({uri:l.URI.revive(Se),name:Re,index:$e}))),L.sort((Se,Re)=>Se.index<Re.index?-1:1);const Y=new A(K,H,L,T?l.URI.revive(T):null,!!q,Se=>v(Se,ce)),{added:j,removed:se}=p(B?B.workspaceFolders:[],Y.workspaceFolders,r,ce);return{workspace:Y,added:j,removed:se}}static _findFolder(N,$,ie){for(let ce=0;ce<N.folders.length;ce++){const K=N.workspaceFolders[ce];if(i(K.uri,$,ie))return K}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(N,$){return $&&this._structure.get(N)&&(N=(0,C.dirname)(N)),this._structure.findSubstr(N)}resolveWorkspaceFolder(N){return this._structure.get(N)}}let R=class{constructor(N,$,ie,ce){this._onDidChangeWorkspace=new y.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new y.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=ce,this._extHostFileSystemInfo=ie,this._requestIdProvider=new _.Counter,this._barrier=new F.Barrier,this._proxy=N.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=N.getProxy(s.MainContext.MainThreadMessageService);const K=$.workspace;this._confirmedWorkspace=K?new A(K.id,K.name,[],K.configuration?l.URI.revive(K.configuration):null,!!K.isUntitled,H=>v(H,ie)):void 0}$initializeWorkspace(N,$){this._trusted=$,this.$acceptWorkspaceData(N),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:S.Schemas.untitled,path:(0,C.basename)((0,C.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(N,$,ie,...ce){const K=[];if(Array.isArray(ce)&&ce.forEach(L=>{l.URI.isUri(L.uri)&&!K.some(B=>i(B.uri,L.uri,this._extHostFileSystemInfo))&&K.push({uri:L.uri,name:L.name||(0,C.basenameOrAuthority)(L.uri)})}),this._unconfirmedWorkspace||[$,ie].some(L=>typeof L!="number"||L<0)||ie===0&&K.length===0)return!1;const H=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if($+ie>H.length)return!1;const z=H.slice(0);z.splice($,ie,...K.map(L=>({uri:L.uri,name:L.name||(0,C.basenameOrAuthority)(L.uri),index:void 0})));for(let L=0;L<z.length;L++){const B=z[L];if(z.some((Y,j)=>j!==L&&i(B.uri,Y.uri,this._extHostFileSystemInfo)))return!1}z.forEach((L,B)=>L.index=B);const{added:T,removed:q}=p(H,z,c,this._extHostFileSystemInfo);if(T.length===0&&q.length===0)return!1;if(this._proxy){const L=N.displayName||N.name;this._proxy.$updateWorkspaceFolders(L,$,ie,K).then(void 0,B=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(f.Severity.Error,(0,h.localize)(0,null,L,B.toString()),{extension:N},[])})}return this.trySetWorkspaceFolders(z),!0}getWorkspaceFolder(N,$){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,$)}async getWorkspaceFolder2(N,$){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,$)}async resolveWorkspaceFolder(N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(N)}getPath(){if(!this._actualWorkspace)return;const{folders:N}=this._actualWorkspace;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,$){let ie,ce="";if(typeof N=="string"?(ie=l.URI.file(N),ce=N):typeof N!="undefined"&&(ie=N,ce=N.fsPath),!ie)return ce;const K=this.getWorkspaceFolder(ie,!0);if(!K)return ce;typeof $=="undefined"&&this._actualWorkspace&&($=this._actualWorkspace.folders.length>1);let H=(0,C.relativePath)(K.uri,ie);return $&&K.name&&(H=`${K.name}/${H}`),H}trySetWorkspaceFolders(N){this._actualWorkspace&&(this._unconfirmedWorkspace=A.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:N,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:$,added:ie,removed:ce}=A.toExtHostWorkspace(N,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=$||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:ie,removed:ce}))}findFiles(N,$,ie,ce,K=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${ce.value}, entryPoint: findFiles`);let H;if($===null?H=!1:$&&(typeof $=="string"?H=$:H=$.pattern),K&&K.isCancellationRequested)return Promise.resolve([]);const{includePattern:z,folder:T}=o(N);return this._proxy.$startFileSearch((0,k.withUndefinedAsNull)(z),(0,k.withUndefinedAsNull)(T),(0,k.withUndefinedAsNull)(H),(0,k.withUndefinedAsNull)(ie),K).then(q=>Array.isArray(q)?q.map(L=>l.URI.revive(L)):[])}async findTextInFiles(N,$,ie,ce,K=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${ce.value}, entryPoint: findTextInFiles`);const H=this._requestIdProvider.getNext(),z=typeof $.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:T,folder:q}=o($.include),L=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,B={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:z,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:T,excludePattern:L},Y=!1;if(this._activeSearchCallbacks[H]=j=>{if(Y)return;const se=l.URI.revive(j.resource);j.results.forEach(Se=>{(0,t.resultIsMatch)(Se)?ie({uri:se,preview:{text:Se.preview.text,matches:(0,m.mapArrayOrNot)(Se.preview.matches,Re=>new b.Range(Re.startLineNumber,Re.startColumn,Re.endLineNumber,Re.endColumn))},ranges:(0,m.mapArrayOrNot)(Se.ranges,Re=>new b.Range(Re.startLineNumber,Re.startColumn,Re.endLineNumber,Re.endColumn))}):ie({uri:se,text:Se.text,lineNumber:Se.lineNumber})})},K.isCancellationRequested)return{};try{const j=await this._proxy.$startTextSearch(N,(0,k.withUndefinedAsNull)(q),B,H,K);return delete this._activeSearchCallbacks[H],j||{}}catch(j){throw delete this._activeSearchCallbacks[H],j}}$handleTextSearchResult(N,$){this._activeSearchCallbacks[$]&&this._activeSearchCallbacks[$](N)}saveAll(N){return this._proxy.$saveAll(N)}resolveProxy(N){return this._proxy.$resolveProxy(N)}get trusted(){return this._trusted}requestWorkspaceTrust(N){return this._proxy.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};R=ze([je(0,g.IExtHostRpcService),je(1,u.IExtHostInitDataService),je(2,w.IExtHostFileSystemInfo),je(3,d.ILogService)],R),e.ExtHostWorkspace=R,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function o(P){let N,$;return P&&(typeof P=="string"?N=P:(N=P.pattern,$=P.baseFolder||l.URI.file(P.base))),{includePattern:N,folder:$}}}),define(_e[33],ye([0,1,24,3,32,5,6,153,62,10,16,4,13,15,2]),function(ee,e,m,F,D,y,I,S,_,C,n,k,l,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(s,i){if(i){const r=i.split(".");let c=s;for(let p=0;c&&p<r.length;p++)c=c[r[p]];return c}}function f(s){return s instanceof a.URI}function E(s){return s&&s.uri instanceof a.URI&&s.languageId&&typeof s.languageId=="string"}function w(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function u(s){return s&&s.uri instanceof a.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function g(s){if(f(s))return{resource:s};if(E(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(w(s))return{overrideIdentifier:s.languageId};if(u(s))return{resource:s.uri};if(s===null)return{resource:null}}let b=class{constructor(i,r,c){this._proxy=i.getProxy(y.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=c,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(i=>this._actual)}$initializeConfiguration(i){this._actual=new t(this._proxy,this._extHostWorkspace,i,this._logService),this._barrier.open()}$acceptConfigurationChanged(i,r){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(i,r))}};b=ze([je(0,l.IExtHostRpcService),je(1,D.IExtHostWorkspace),je(2,h.ILogService)],b),e.ExtHostConfiguration=b;class t{constructor(i,r,c,p){this._onDidChangeConfiguration=new F.Emitter,this._proxy=i,this._logService=p,this._extHostWorkspace=r,this._configuration=S.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(i,r){const c={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=S.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,c))}getConfiguration(i,r,c){const p=g(r)||{},v=this._toReadonlyValue(i?d(this._configuration.getValue(void 0,p,this._extHostWorkspace.workspace),i):this._configuration.getValue(void 0,p,this._extHostWorkspace.workspace));i&&this._validateConfigurationAccess(i,p,c?.identifier);function A(o){if(o==null)return null;if(typeof o=="boolean")return o?1:4;switch(o){case I.ConfigurationTarget.Global:return 1;case I.ConfigurationTarget.Workspace:return 4;case I.ConfigurationTarget.WorkspaceFolder:return 5}}const R={has(o){return typeof d(v,o)!="undefined"},get:(o,P)=>{this._validateConfigurationAccess(i?`${i}.${o}`:o,p,c?.identifier);let N=d(v,o);if(typeof N=="undefined")N=P;else{let $;const ie=(ce,K)=>{let H;const z=()=>{$=$||(0,m.deepClone)(v),H=H||d($,K)};return(0,C.isObject)(ce)?new Proxy(ce,{get:(T,q)=>{if(typeof q=="string"&&q.toLowerCase()==="tojson")return z(),()=>H;if($)return H=H||d($,K),H[q];const L=T[q];return typeof q=="string"?ie(L,`${K}.${q}`):L},set:(T,q,L)=>(z(),H&&(H[q]=L),!0),deleteProperty:(T,q)=>(z(),H&&delete H[q],!0),defineProperty:(T,q,L)=>(z(),H&&Object.defineProperty(H,q,L),!0)}):ce};N=ie(N,o)}return N},update:(o,P,N,$)=>{o=i?`${i}.${o}`:o;const ie=A(N);return P!==void 0?this._proxy.$updateConfigurationOption(ie,o,P,p,$):this._proxy.$removeConfigurationOption(ie,o,p,$)},inspect:o=>{o=i?`${i}.${o}`:o;const P=(0,m.deepClone)(this._configuration.inspect(o,p,this._extHostWorkspace.workspace));if(P)return{key:o,defaultValue:P.default?.value,globalValue:P.user?.value,workspaceValue:P.workspace?.value,workspaceFolderValue:P.workspaceFolder?.value,defaultLanguageValue:P.default?.override,globalLanguageValue:P.user?.override,workspaceLanguageValue:P.workspace?.override,workspaceFolderLanguageValue:P.workspaceFolder?.override,languageIds:P.overrideIdentifiers}}};return typeof v=="object"&&(0,m.mixin)(R,v,!1),Object.freeze(R)}_toReadonlyValue(i){const r=c=>(0,C.isObject)(c)?new Proxy(c,{get:(p,v)=>r(p[v]),set:(p,v,A)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:(p,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:(p,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:p=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return r(i)}_validateConfigurationAccess(i,r,c){const p=_.OVERRIDE_PROPERTY_PATTERN.test(i)?4:this._configurationScopes.get(i),v=c?`[${c.value}] `:"";if(p===4){typeof r?.resource=="undefined"&&this._logService.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if(p===3){r?.resource&&this._logService.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(i,r){const c=new S.ConfigurationChangeEvent(i,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(p,v)=>c.affectsConfiguration(p,g(v))})}_toMap(i){return i.reduce((r,c)=>(r.set(c[0],c[1]),r),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(ee,e,m,F,D){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?D.call(ee,m):D?D.value=m:e.set(ee,m),m},Le=this&&this.__classPrivateFieldGet||function(ee,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(ee):F?F.value:e.get(ee)};define(_e[105],ye([0,1,2,16,3,5,6,32,46,33,18,37,13,28,4,11,21,15,71,168,12]),function(ee,e,m,F,D,y,I,S,_,C,n,k,l,h,a,d,f,E,w,u,g){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(ce){function K(z){if(z!=null)return z}ce.from=K;function H(z){if(z!=null)return z}ce.to=H})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var s;(function(ce){function K(z){if(z!=null)return z}ce.from=K;function H(z){if(z!=null)return z}ce.to=H})(s=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var i;(function(ce){function K(z){if(z!=null)return z}ce.from=K;function H(z){if(z!=null)return z}ce.to=H})(i=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(ce){function K(T){if(T){const q=T;return q&&!!q.process}else return!1}ce.is=K;function H(T){if(T==null)return;const q={process:T.process,args:T.args};return T.options&&(q.options=i.from(T.options)),q}ce.from=H;function z(T){if(T!=null)return new I.ProcessExecution(T.process,T.args,T.options)}ce.to=z})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var c;(function(ce){function K(z){if(z!=null)return z}ce.from=K;function H(z){if(z!=null)return z}ce.to=H})(c=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var p;(function(ce){function K(T){if(T){const q=T;return q&&(!!q.commandLine||!!q.command)}else return!1}ce.is=K;function H(T){if(T==null)return;const q={};return T.commandLine!==void 0?q.commandLine=T.commandLine:(q.command=T.command,q.args=T.args),T.options&&(q.options=c.from(T.options)),q}ce.from=H;function z(T){if(!(T==null||T.command===void 0&&T.commandLine===void 0))return T.commandLine?new I.ShellExecution(T.commandLine,T.options):new I.ShellExecution(T.command,T.args?T.args:[],T.options)}ce.to=z})(p=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var v;(function(ce){function K(T){if(T){let q=T;return q&&q.customExecution==="customExecution"}else return!1}ce.is=K;function H(T){return{customExecution:"customExecution"}}ce.from=H;function z(T,q){return q.get(T)}ce.to=z})(v=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var A;(function(ce){function K(H,z){let T;return H.scope!==void 0&&typeof H.scope!="number"?T=H.scope.uri:H.scope!==void 0&&typeof H.scope=="number"&&(H.scope===I.TaskScope.Workspace&&z&&z.workspaceFile?T=z.workspaceFile:T=u.USER_TASKS_GROUP_KEY),{id:H._id,workspaceFolder:T}}ce.from=K})(A=e.TaskHandleDTO||(e.TaskHandleDTO={}));var R;(function(ce){function K(T,q){if(T==null)return[];const L=[];for(let B of T){const Y=H(B,q);Y&&L.push(Y)}return L}ce.fromMany=K;function H(T,q){if(T==null)return;let L;T.execution instanceof I.ProcessExecution?L=r.from(T.execution):T.execution instanceof I.ShellExecution?L=p.from(T.execution):T.execution&&T.execution instanceof I.CustomExecution&&(L=v.from(T.execution));const B=t.from(T.definition);let Y;if(T.scope?typeof T.scope=="number"?Y=T.scope:Y=T.scope.uri:Y=I.TaskScope.Workspace,!B||!Y)return;const j=T.group?T.group.id:void 0;return{_id:T._id,definition:B,name:T.name,source:{extensionId:q.identifier.value,label:T.source,scope:Y},execution:L,isBackground:T.isBackground,group:j,presentationOptions:s.from(T.presentationOptions),problemMatchers:T.problemMatchers,hasDefinedMatchers:T.hasDefinedMatchers,runOptions:T.runOptions?T.runOptions:{reevaluateOnRerun:!0},detail:T.detail}}ce.from=H;async function z(T,q,L){if(T==null)return;let B;r.is(T.execution)?B=r.to(T.execution):p.is(T.execution)?B=p.to(T.execution):v.is(T.execution)&&(B=v.to(T._id,L));const Y=t.to(T.definition);let j;if(T.source&&(T.source.scope!==void 0?typeof T.source.scope=="number"?j=T.source.scope:j=await q.resolveWorkspaceFolder(m.URI.revive(T.source.scope)):j=I.TaskScope.Workspace),!Y||!j)return;const se=new I.Task(Y,j,T.name,T.source.label,B,T.problemMatchers);return T.isBackground!==void 0&&(se.isBackground=T.isBackground),T.group!==void 0&&(se.group=I.TaskGroup.from(T.group)),T.presentationOptions&&(se.presentationOptions=s.to(T.presentationOptions)),T._id&&(se._id=T._id),T.detail&&(se.detail=T.detail),se}ce.to=z})(R=e.TaskDTO||(e.TaskDTO={}));var o;(function(ce){function K(z){return z}ce.from=K;function H(z){if(!!z)return Object.assign(Object.create(null),z)}ce.to=H})(o=e.TaskFilterDTO||(e.TaskFilterDTO={}));class P{constructor(K,H,z){this._id=H,this._task=z,b.set(this,void 0),nt(this,b,K,"f")}get task(){return this._task}terminate(){Le(this,b,"f").terminateTask(this)}fireDidStartProcess(K){}fireDidEndProcess(K){}}b=new WeakMap;var N;(function(ce){function K(H){return{id:H._id,task:void 0}}ce.from=K})(N=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let $=class{constructor(K,H,z,T,q,L,B,Y){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=K.getProxy(y.MainContext.MainThreadTask),this._workspaceProvider=z,this._editorService=T,this._configurationService=q,this._terminalService=L,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=B,this._deprecationService=Y,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(K,H,z){if(!z)return new I.Disposable(()=>{});const T=this.nextHandle();return this._handlers.set(T,{type:H,provider:z,extension:K}),this._proxy.$registerTaskProvider(T,H),new I.Disposable(()=>{this._handlers.delete(T),this._proxy.$unregisterTaskProvider(T)})}registerTaskSystem(K,H){this._proxy.$registerTaskSystem(K,H)}fetchTasks(K){return this._proxy.$fetchTasks(o.from(K)).then(async H=>{const z=[];for(let T of H){const q=await R.to(T,this._workspaceProvider,this._providedCustomExecutions2);q&&z.push(q)}return z})}get taskExecutions(){const K=[];return this._taskExecutions.forEach(H=>K.push(H)),K}terminateTask(K){if(!(K instanceof P))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(K._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(K,H,z){const T=this._providedCustomExecutions2.get(K.id);if(T){if(this._activeCustomExecutions2.get(K.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(K.id,T),this._terminalService.attachPtyToTerminal(H,await T.callback(z))}this._lastStartedTask=K.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(K)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(K){const H=await this.getTaskExecution(K);this._taskExecutionPromises.delete(K.id),this._taskExecutions.delete(K.id),this.customExecutionComplete(K),this._onDidTerminateTask.fire({execution:H})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(K){const H=await this.getTaskExecution(K.id);this._onDidTaskProcessStarted.fire({execution:H,processId:K.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(K){const H=await this.getTaskExecution(K.id);this._onDidTaskProcessEnded.fire({execution:H,exitCode:K.exitCode})}$provideTasks(K,H){const z=this._handlers.get(K);if(!z)return Promise.reject(new Error("no handler found"));const T=[],q=(0,F.asPromise)(()=>z.provider.provideTasks(n.CancellationToken.None)).then(L=>this.provideTasksInternal(H,T,z,L));return new Promise(L=>{q.then(B=>{Promise.all(T).then(()=>{L(B)})})})}async $resolveTask(K,H){const z=this._handlers.get(K);if(!z)return Promise.reject(new Error("no handler found"));if(H.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${H.definition.type}] cannot be resolved by provider of type [${z.type}].`);const T=await R.to(H,this._workspaceProvider,this._providedCustomExecutions2);if(!T)throw new Error("Unexpected: Task cannot be resolved.");const q=await z.provider.resolveTask(T,n.CancellationToken.None);if(!q)return;this.checkDeprecation(q,z);const L=R.from(q,z.extension);if(!L)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==T.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return v.is(L.execution)&&await this.addCustomExecution(L,q,!0),await this.resolveTaskInternal(L)}nextHandle(){return this._handleCounter++}async addCustomExecution(K,H,z){const T=await this._proxy.$createTaskId(K);!z&&!this._providedCustomExecutions2.has(T)&&this._notProvidedCustomExecutions.add(T),this._providedCustomExecutions2.set(T,H.execution)}async getTaskExecution(K,H){if(typeof K=="string"){const q=this._taskExecutionPromises.get(K);if(!q)throw new Error("Unexpected: The specified task is missing an execution");return q}let z=this._taskExecutionPromises.get(K.id);if(z)return z;const T=new Promise(async(q,L)=>{const B=H||await R.to(K.task,this._workspaceProvider,this._providedCustomExecutions2);B?q(new P(this,K.id,B)):L("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(K.id,T),T.then(q=>(this._taskExecutions.set(K.id,q),q),q=>Promise.reject(q))}checkDeprecation(K,H){K._deprecated&&this._deprecationService.report("Task.constructor",H.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(K){this._activeCustomExecutions2.get(K.id)&&this._activeCustomExecutions2.delete(K.id),this._notProvidedCustomExecutions.has(K.id)&&this._lastStartedTask!==K.id&&(this._providedCustomExecutions2.delete(K.id),this._notProvidedCustomExecutions.delete(K.id));let z=this._notProvidedCustomExecutions.values(),T=z.next();for(;!T.done;)!this._activeCustomExecutions2.has(T.value)&&this._lastStartedTask!==T.value&&(this._providedCustomExecutions2.delete(T.value),this._notProvidedCustomExecutions.delete(T.value)),T=z.next()}};$=ze([je(0,l.IExtHostRpcService),je(1,h.IExtHostInitDataService),je(2,S.IExtHostWorkspace),je(3,_.IExtHostDocumentsAndEditors),je(4,C.IExtHostConfiguration),je(5,k.IExtHostTerminalService),je(6,E.ILogService),je(7,w.IExtHostApiDeprecationService)],$),e.ExtHostTaskBase=$;let ie=class extends ${constructor(K,H,z,T,q,L,B,Y){super(K,H,z,T,q,L,B,Y);this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:f.PlatformToString(0)})}async executeTask(K,H){if(!H.execution)throw new Error("Tasks to execute must include an execution");const z=R.from(H,K);if(z===void 0)throw new Error("Task is not valid");if(v.is(z.execution))await this.addCustomExecution(z,H,!1);else throw new g.NotSupportedError;const T=await this.getTaskExecution(await this._proxy.$getTaskExecution(z),H);return this._proxy.$executeTask(z).catch(q=>{throw new Error(q)}),T}provideTasksInternal(K,H,z,T){const q=[];if(T)for(let L of T){this.checkDeprecation(L,z),(!L.definition||!K[L.definition.type])&&this._logService.warn(`The task [${L.source}, ${L.name}] uses an undefined task type. The task will be ignored in the future.`);const B=R.from(L,z.extension);B&&v.is(B.execution)?(q.push(B),H.push(this.addCustomExecution(B,L,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:q,extension:z.extension}}async resolveTaskInternal(K){if(v.is(K.execution))return K;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(K,H){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(K,H,z){}};ie=ze([je(0,l.IExtHostRpcService),je(1,h.IExtHostInitDataService),je(2,S.IExtHostWorkspace),je(3,_.IExtHostDocumentsAndEditors),je(4,C.IExtHostConfiguration),je(5,k.IExtHostTerminalService),je(6,E.ILogService),je(7,w.IExtHostApiDeprecationService)],ie),e.WorkerExtHostTask=ie,e.IExtHostTask=(0,a.createDecorator)("IExtHostTask")}),define(_e[217],ye([0,1,17,77,27,82,22,11,14,25,8,10,2,117,138,91,44,97,216,38]),function(ee,e,m,F,D,y,I,S,_,C,n,k,l,h,a,d,f,E,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let g=class{constructor(A,R,o,P){this.configurationService=A,this.workspaceContextService=R,this.editorGroupsService=o,this.pathService=P}text(A,R,o={}){A=this.getContentPattern(A,o);const P=this.configurationService.getValue(),N=R&&R.some(ie=>!this.configurationService.getValue({resource:ie}).search.useRipgrep);return{...this.commonQuery(R?.map(f.toWorkspaceFolder),o),type:2,contentPattern:A,previewOptions:o.previewOptions,maxFileSize:o.maxFileSize,usePCRE2:P.search.usePCRE2||N||!1,beforeContext:o.beforeContext,afterContext:o.afterContext,userDisabledExcludesAndIgnoreFiles:o.disregardExcludeSettings&&o.disregardIgnoreFiles}}getContentPattern(A,R){const o=this.configurationService.getValue();A.isRegExp&&(A.pattern=A.pattern.replace(/\r?\n/g,"\\n"));const P={...A,wordSeparators:o.editor.wordSeparators};return this.isCaseSensitive(A,R)&&(P.isCaseSensitive=!0),this.isMultiline(A)&&(P.isMultiline=!0),P}file(A,R={}){return{...this.commonQuery(A,R),type:1,filePattern:R.filePattern?R.filePattern.trim():R.filePattern,exists:R.exists,sortByScore:R.sortByScore,cacheKey:R.cacheKey}}handleIncludeExclude(A,R){return A?(A=Array.isArray(A)?A.map(r):r(A),R?this.parseSearchPaths(A):{pattern:t(...Array.isArray(A)?A:[A])}):{}}commonQuery(A=[],R={}){const o=this.handleIncludeExclude(R.includePattern,R.expandPatterns),P=this.handleIncludeExclude(R.excludePattern,R.expandPatterns),N=A.length>1,$=(o.searchPaths&&o.searchPaths.length?o.searchPaths.map(K=>this.getFolderQueryForSearchPath(K,R,P)):A.map(K=>this.getFolderQueryForRoot(K,R,P,N))).filter(K=>!!K),ie={_reason:R._reason,folderQueries:$,usingSearchPaths:!!(o.searchPaths&&o.searchPaths.length),extraFileResources:R.extraFileResources,excludePattern:P.pattern,includePattern:o.pattern,onlyOpenEditors:R.onlyOpenEditors,maxResults:R.maxResults};if(R.onlyOpenEditors){const H=m.coalesce(m.flatten(this.editorGroupsService.groups.map(T=>T.editors.map(q=>q.resource)))).filter(T=>(0,u.pathIncludedInQuery)(ie,T.fsPath)),z=this.commonQueryFromFileList(H);return{...ie,...z}}const ce=R.extraFileResources&&R.extraFileResources.filter(K=>(0,u.pathIncludedInQuery)(ie,K.fsPath));return ie.extraFileResources=ce&&ce.length?ce:void 0,ie}commonQueryFromFileList(A){const R=[],o=new I.ResourceMap,P={};let N=!1;return A.forEach($=>{if($.scheme===S.Schemas.walkThrough)return;if((0,C.isAbsolutePath)($)){const ce=this.workspaceContextService.getWorkspaceFolder($)?.uri??$.with({path:_.dirname($.fsPath)});let K=o.get(ce);K||(N=!0,K={folder:ce,includePattern:{}},R.push(K),o.set(ce,K));const H=_.relative(ce.fsPath,$.fsPath);(0,k.assertIsDefined)(K.includePattern)[H.replace(/\\/g,"/")]=!0}else $.fsPath&&(N=!0,P[$.fsPath]=!0)}),{folderQueries:R,includePattern:P,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}isCaseSensitive(A,R){if(R.isSmartCase){if(A.isRegExp){if(n.containsUppercaseCharacter(A.pattern,!0))return!0}else if(n.containsUppercaseCharacter(A.pattern))return!0}return!!A.isCaseSensitive}isMultiline(A){return A.isMultiline||A.isRegExp&&(0,h.isMultilineRegexSource)(A.pattern)||A.pattern.indexOf(`
`)>=0?!0:!!A.isMultiline}parseSearchPaths(A){const R=z=>_.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),P=(Array.isArray(A)?A:s(A)).map(z=>{const T=this.pathService.resolvedUserHome;return T?(0,y.untildify)(z,T.scheme===S.Schemas.file?T.fsPath:T.path):z}),N=F.groupBy(P,z=>R(z)?"searchPaths":"exprSegments"),$=(N.exprSegments||[]).map(z=>n.rtrim(z,"/")).map(z=>n.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),i(z))),ie={},ce=this.expandSearchPathPatterns(N.searchPaths||[]);ce&&ce.length&&(ie.searchPaths=ce);const K=m.flatten($),H=t(...K);return H&&(ie.pattern=H),ie}getExcludesForFolder(A,R){return R.disregardExcludeSettings?void 0:(0,u.getExcludes)(A,!R.disregardSearchExcludeSettings)}expandSearchPathPatterns(A){if(!A||!A.length)return[];const R=m.flatten(A.map(P=>{let{pathPortion:N,globPortion:$}=b(P);$&&($=c($));const ie=this.expandOneSearchPath(N);return m.flatten(ie.map(ce=>this.resolveOneSearchPathPattern(ce,$)))})),o=new Map;return R.forEach(P=>{const N=P.searchPath.toString(),$=o.get(N);$?P.pattern&&($.pattern=$.pattern||{},$.pattern[P.pattern]=!0):o.set(N,{searchPath:P.searchPath,pattern:P.pattern?t(P.pattern):void 0})}),Array.from(o.values())}expandOneSearchPath(A){if(_.isAbsolute(A)){const R=this.workspaceContextService.getWorkspace().folders;return R[0]&&R[0].uri.scheme!==S.Schemas.file?[{searchPath:R[0].uri.with({path:A})}]:[{searchPath:l.URI.file(_.normalize(A))}]}if(this.workspaceContextService.getWorkbenchState()===2){const R=this.workspaceContextService.getWorkspace().folders[0].uri;if(A=r(A),A.startsWith("../")||A===".."){const P=_.posix.resolve(R.path,A);return[{searchPath:R.with({path:P})}]}const o=c(A);return[{searchPath:R,pattern:o}]}else{if(A==="./"||A===".\\")return[];{const R=A.replace(/^\.[\/\\]/,""),P=this.workspaceContextService.getWorkspace().folders.map(N=>{const $=R.match(new RegExp(`^${n.escapeRegExpCharacters(N.name)}(?:/(.*)|$)`));return $?{match:$,folder:N}:null}).filter(k.isDefined);if(P.length)return P.map(N=>{const $=N.match[1];return{searchPath:N.folder.uri,pattern:$&&c($)}});{const N=A.match(/\.[\/\\](.+)[\/\\]?/),$=N?N[1]:A,ie=a.localize(0,null,$);throw new Error(ie)}}}}resolveOneSearchPathPattern(A,R){const o=A.pattern&&R?`${A.pattern}/${R}`:A.pattern||R,P=[{searchPath:A.searchPath,pattern:o}];return o&&!o.endsWith("**")&&P.push({searchPath:A.searchPath,pattern:o+"/**"}),P}getFolderQueryForSearchPath(A,R,o){const P=this.getFolderQueryForRoot((0,f.toWorkspaceFolder)(A.searchPath),R,o,!1);return P?{...P,includePattern:A.pattern}:null}getFolderQueryForRoot(A,R,o,P){let N;const $=l.URI.isUri(A)?A:A.uri;if(o.searchPaths){const z=o.searchPaths.filter(T=>(0,C.isEqual)(T.searchPath,$))[0];if(z&&!z.pattern)return null;z&&(N=z.pattern)}const ie=this.configurationService.getValue({resource:$}),K={...this.getExcludesForFolder(ie,R)||{},...N||{}},H=l.URI.isUri(A)?(0,C.basename)(A):A.name;return{folder:$,folderName:P?H:void 0,excludePattern:Object.keys(K).length>0?K:void 0,fileEncoding:ie.files&&ie.files.encoding,disregardIgnoreFiles:typeof R.disregardIgnoreFiles=="boolean"?R.disregardIgnoreFiles:!ie.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof R.disregardGlobalIgnoreFiles=="boolean"?R.disregardGlobalIgnoreFiles:!ie.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof R.ignoreSymlinks=="boolean"?R.ignoreSymlinks:!ie.search.followSymlinks}}};g=ze([je(0,d.IConfigurationService),je(1,f.IWorkspaceContextService),je(2,E.IEditorGroupsService),je(3,w.IPathService)],g),e.QueryBuilder=g;function b(v){const A=v.match(/[\*\{\}\(\)\[\]\?]/);if(A){const R=A.index,o=v.substr(0,R).match(/[/|\\][^/\\]*$/);if(o){let P=v.substr(0,o.index);return P.match(/[/\\]/)||(P+="/"),{pathPortion:P,globPortion:v.substr((o.index||0)+1)}}}return{pathPortion:v}}function t(...v){return v.length?v.reduce((A,R)=>(A[R]=!0,A),Object.create(null)):void 0}function s(v){return D.splitGlobAware(v,",").map(A=>A.trim()).filter(A=>!!A.length)}function i(v){return[`**/${v}/**`,`**/${v}`].map(R=>R.replace(/\*\*\/\*\*/g,"**"))}function r(v){return v.replace(/\\/g,"/")}function c(v){return r(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function p(v,A){v=m.distinct(v,P=>P.toString());const R=[],o=A.getWorkspace();return v&&v.forEach(P=>{let N;if(A.getWorkbenchState()===2)N=(0,C.relativePath)(o.folders[0].uri,P),N&&N!=="."&&(N="./"+N);else{const $=A.getWorkspaceFolder(P);if($){const ie=$.name;if(o.folders.filter(K=>K.name===ie).length===1){const K=(0,C.relativePath)($.uri,P);K===""?N=`./${$.name}`:N=`./${$.name}/${K}`}else N=P.fsPath}}N&&R.push(N)}),R}e.resolveResourcesForSearchIncludes=p}),define(_e[218],ye([0,1,25,2,18,12,4,217,38,44]),function(ee,e,m,F,D,y,I,S,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function k(d,f){const E=f.activationEvents;if(!E)return Promise.resolve(void 0);const w=[],u=[];for(const r of E)if(/^workspaceContains:/.test(r)){const c=r.substr("workspaceContains:".length);c.indexOf("*")>=0||c.indexOf("?")>=0||d.forceUsingSearch?u.push(c):w.push(c)}if(w.length===0&&u.length===0)return Promise.resolve(void 0);let g;const b=new Promise((r,c)=>{g=r}),t=r=>g({activationEvent:r}),s=Promise.all(w.map(r=>l(d,r,t))).then(()=>{}),i=h(d,f.identifier,u,t);return Promise.all([s,i]).then(()=>{g(void 0)}),b}e.checkActivateWorkspaceContainsExtension=k;async function l(d,f,E){for(const w of d.folders)if(await d.exists(m.joinPath(F.URI.revive(w),f))){E(`workspaceContains:${f}`);return}}async function h(d,f,E,w){if(E.length===0)return Promise.resolve(void 0);const u=new D.CancellationTokenSource,g=d.checkExists(d.folders,E,u.token),b=setTimeout(async()=>{u.cancel(),w(`workspaceContainsTimeout:${E.join(",")}`)},n);let t=!1;try{t=await g}catch(s){y.isPromiseCanceledError(s)||y.onUnexpectedError(s)}u.dispose(),clearTimeout(b),t&&w(`workspaceContains:${E.join(",")}`)}function a(d,f,E,w){const u=d.get(I.IInstantiationService),g=d.get(_.ISearchService),t=u.createInstance(S.QueryBuilder).file(f.map(s=>(0,C.toWorkspaceFolder)(F.URI.revive(s))),{_reason:"checkExists",includePattern:E,exists:!0});return g.fileSearch(t,w).then(s=>!!s.limitHit,s=>y.isPromiseCanceledError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=a});var nt=this&&this.__classPrivateFieldSet||function(ee,e,m,F,D){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?D.call(ee,m):D?D.value=m:e.set(ee,m),m},Le=this&&this.__classPrivateFieldGet||function(ee,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(ee):F?F.value:e.get(ee)};define(_e[34],ye([0,1,130,14,76,25,16,7,22,2,15,5,33,181,74,32,29,179,12,26,23,158,6,92,4,28,75,13,61,66,37,3,218,70,160]),function(ee,e,m,F,D,y,I,S,_,C,n,k,l,h,a,d,f,E,w,u,g,b,t,s,i,r,c,p,v,A,R,o,P,N,$){"use strict";var ie,ce,K;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,i.createDecorator)("IHostUtils");let H=class $n extends S.Disposable{constructor(L,B,Y,j,se,Se,Re,$e,Ne,Ge){super();this._onDidChangeRemoteConnectionData=this._register(new o.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=B,this._extHostContext=Y,this._initData=Re,this._extHostWorkspace=j,this._extHostConfiguration=se,this._logService=Se,this._extHostTunnelService=Ne,this._extHostTerminalService=Ge,this._disposables=new S.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new I.Barrier,this._readyToStartExtensionHost=new I.Barrier,this._readyToRunExtensions=new I.Barrier,this._eagerExtensionsActivated=new I.Barrier,this._registry=new E.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new a.ExtHostStorage(this._extHostContext),this._secretState=new N.ExtHostSecretState(this._extHostContext),this._storagePath=$e,this._instaService=L.createChild(new v.ServiceCollection([a.IExtHostStorage,this._storage],[N.IExtHostSecretState,this._secretState]));const Ke=new Set;this._initData.hostExtensions.forEach(qe=>Ke.add(u.ExtensionIdentifier.toKey(qe))),this._activator=new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(qe,U,G)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(qe,w.transformErrorForSerialization(U),G)},actualActivateExtension:async(qe,U)=>{if(Ke.has(u.ExtensionIdentifier.toKey(qe)))return await this._mainThreadExtensionsProxy.$activateExtension(qe,U),new h.HostExtension;const G=this._registry.getExtensionDescription(qe);return this._activateExtension(G,U)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(L){w.onUnexpectedError(L)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let L=[];try{L=this._registry.getAllExtensionDescriptions().map(se=>se.identifier).filter(se=>this.isActivated(se)).map(se=>this._deactivate(se))}catch(B){}await Promise.all(L)}isActivated(L){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(L):!1}_activateByEvent(L,B){return this._activator.activateByEvent(L,B)}_activateById(L,B){return this._activator.activateById(L,B)}activateByIdWithErrors(L,B){return this._activateById(L,B).then(()=>{const Y=this._activator.getActivatedExtension(L);if(Y.activationFailed)return Promise.reject(Y.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(L=>this._registry)}getExtensionExports(L){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(L).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const L=_.TernarySearchTree.forPaths(),B=this._registry.getAllExtensionDescriptions().map(Y=>{if(!!this._getEntryPoint(Y))return this._hostUtils.realpath(Y.extensionLocation.fsPath).then(j=>L.set(C.URI.file(j).fsPath,Y))});this._extensionPathIndex=Promise.all(B).then(()=>L)}return this._extensionPathIndex}_deactivate(L){let B=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(L))return B;const Y=this._activator.getActivatedExtension(L);if(!Y)return B;try{typeof Y.module.deactivate=="function"&&(B=Promise.resolve(Y.module.deactivate()).then(void 0,j=>(this._logService.error(j),Promise.resolve(void 0))))}catch(j){this._logService.error(j)}try{(0,S.dispose)(Y.subscriptions)}catch(j){this._logService.error(j)}return B}async _activateExtension(L,B){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(L.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(L.identifier),this._doActivateExtension(L,B).then(Y=>{const j=Y.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(L.identifier,j.codeLoadingTime,j.activateCallTime,j.activateResolvedTime,B),this._logExtensionActivationTimes(L,B,"success",j),Y},Y=>{throw this._logExtensionActivationTimes(L,B,"failure"),Y})}_logExtensionActivationTimes(L,B,Y,j){const se=z(L,B);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...se,...j||{},outcome:Y})}_doActivateExtension(L,B){const Y=z(L,B);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Y);const j=this._getEntryPoint(L);if(!j)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${L.identifier.value} ${JSON.stringify(B)}`),this._logService.flush();const se=new h.ExtensionActivationTimesBuilder(B.startup);return Promise.all([this._loadCommonJSModule(L.identifier,(0,y.joinPath)(L.extensionLocation,j),se),this._loadExtensionContext(L)]).then(Se=>(D.mark(`code/extHost/willActivateExtension/${L.identifier.value}`),$n._callActivate(this._logService,L.identifier,Se[0],Se[1],se))).then(Se=>(D.mark(`code/extHost/didActivateExtension/${L.identifier.value}`),Se))}_loadExtensionContext(L){const B=new b.ExtensionGlobalMemento(L,this._storage),Y=new b.ExtensionMemento(L.identifier.value,!1,this._storage),j=new $.ExtensionSecrets(L,this._secretState),se=L.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Se=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${L.identifier.value}`),Promise.all([B.whenReady,Y.whenReady,this._storagePath.whenReady]).then(()=>{const Re=this;let $e;return Object.freeze({globalState:B,workspaceState:Y,secrets:j,subscriptions:[],get extensionUri(){return L.extensionLocation},get extensionPath(){return L.extensionLocation.fsPath},asAbsolutePath(Ne){return F.join(L.extensionLocation.fsPath,Ne)},get storagePath(){return Re._storagePath.workspaceValue(L)?.fsPath},get globalStoragePath(){return Re._storagePath.globalValue(L).fsPath},get logPath(){return F.join(Re._initData.logsLocation.fsPath,L.identifier.value)},get logUri(){return C.URI.joinPath(Re._initData.logsLocation,L.identifier.value)},get storageUri(){return Re._storagePath.workspaceValue(L)},get globalStorageUri(){return Re._storagePath.globalValue(L)},get extensionMode(){return se},get extension(){return $e===void 0&&($e=new T(Re,L.identifier,L,Se)),$e},get extensionRuntime(){return(0,f.checkProposedApiEnabled)(L),Re.extensionRuntime},get environmentVariableCollection(){return Re._extHostTerminalService.getEnvironmentVariableCollection(L)}})})}static _callActivate(L,B,Y,j,se){return Y=Y||{activate:void 0,deactivate:void 0},this._callActivateOptional(L,B,Y,j,se).then(Se=>new h.ActivatedExtension(!1,null,se.build(),Y,Se,j.subscriptions))}static _callActivateOptional(L,B,Y,j,se){if(typeof Y.activate=="function")try{se.activateCallStart(),L.trace(`ExtensionService#_callActivateOptional ${B.value}`);const Se=typeof global=="object"?global:self,Re=Y.activate.apply(Se,[j]);return se.activateCallStop(),se.activateResolveStart(),Promise.resolve(Re).then($e=>(se.activateResolveStop(),$e))}catch(Se){return Promise.reject(Se)}else return Promise.resolve(Y)}_activateOneStartupFinished(L,B){this._activateById(L.identifier,{startup:!1,extensionId:L.identifier,activationEvent:B}).then(void 0,Y=>{this._logService.error(Y)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks());for(const L of this._registry.getAllExtensionDescriptions())if(L.activationEvents)for(const B of L.activationEvents)B==="onStartupFinished"&&this._activateOneStartupFinished(L,B)}_handleEagerExtensions(){const L=this._activateByEvent("*",!0).then(void 0,se=>{this._logService.error(se)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(se=>this._handleWorkspaceContainsEagerExtensions(se.added)));const B=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Y=this._handleWorkspaceContainsEagerExtensions(B),j=Promise.all([L,Y]).then(()=>{});return Promise.race([j,(0,I.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),j}_handleWorkspaceContainsEagerExtensions(L){return L.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(B=>this._handleWorkspaceContainsEagerExtension(L,B))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(L,B){if(this.isActivated(B.identifier))return;const Y=!this._initData.remote.isRemote&&!!this._initData.remote.authority,j={folders:L.map(Se=>Se.uri),forceUsingSearch:Y,exists:Se=>this._hostUtils.exists(Se.fsPath),checkExists:(Se,Re,$e)=>this._mainThreadWorkspaceProxy.$checkExists(Se,Re,$e)},se=await(0,P.checkActivateWorkspaceContainsExtension)(j,B);if(!!se)return this._activateById(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:se.activationEvent}).then(void 0,Se=>this._logService.error(Se))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(L){throw console.error(L),L}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:L,extensionTestsLocationURI:B}=this._initData.environment;if(!L||!B)throw new Error(m.localize(0,null));const Y=await this._loadCommonJSModule(null,B,new h.ExtensionActivationTimesBuilder(!1));if(!Y||typeof Y.run!="function")throw new Error(m.localize(1,null,B.toString()));return new Promise((j,se)=>{const Se=(Ne,Ge)=>{Ne?se(Ne):j(typeof Ge=="number"&&Ge>0?1:0)},Re=(0,y.originalFSPath)(B),$e=Y.run(Re,Se);$e&&$e.then&&$e.then(()=>{j(0)}).catch(Ne=>{se(Ne.toString())})})}async $extensionTestsExit(L){this._logService.info(`extension host terminating: test runner requested exit with code ${L}`),this._logService.info(`exiting with code ${L}`),this._logService.flush(),this._hostUtils.exit(L)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(L,B){return this._resolvers[L]=B,(0,S.toDisposable)(()=>{delete this._resolvers[L]})}async _activateAndGetResolver(L){const B=L.indexOf("+");if(B===-1)throw new Error("Not an authority that can be resolved!");const Y=L.substr(0,B);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Y}`,!1),{authorityPrefix:Y,resolver:this._resolvers[Y]}}async $resolveAuthority(L,B){const{authorityPrefix:Y,resolver:j}=await this._activateAndGetResolver(L);if(!j)return{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Y}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(j)),D.mark(`code/extHost/willResolveAuthority/${Y}`);const se=await j.resolve(L,{resolveAttempt:B});D.mark(`code/extHost/didResolveAuthorityOK/${Y}`);const Se={authority:L,host:se.host,port:se.port,connectionToken:se.connectionToken},Re={extensionHostEnv:se.extensionHostEnv,isTrusted:se.isTrusted};return{type:"ok",value:{authority:Se,options:Re,tunnelInformation:{environmentTunnels:se.environmentTunnels}}}}catch(se){if(D.mark(`code/extHost/didResolveAuthorityError/${Y}`),se instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:se._code,message:se._message,detail:se._detail}};throw se}}async $getCanonicalURI(L,B){const{authorityPrefix:Y,resolver:j}=await this._activateAndGetResolver(L);if(!j)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${Y}`);const se=C.URI.revive(B);if(typeof j.getCanonicalURI=="undefined")return se;const Se=await(0,I.asPromise)(()=>j.getCanonicalURI(se));return Se||se}$startExtensionHost(L){return this._registry.keepOnly(L),this._startExtensionHost()}$activateByEvent(L,B){return B===1?this._activateByEvent(L,!1):this._readyToRunExtensions.wait().then(Y=>this._activateByEvent(L,!1))}async $activate(L,B){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(L)?(await this._activateById(L,B),!0):!1}async $deltaExtensions(L,B){L.forEach(j=>j.extensionLocation=C.URI.revive(j.extensionLocation));const Y=await this.getExtensionPathIndex();return await Promise.all(B.map(async j=>{const se=this._registry.getExtensionDescription(j);if(!se)return;const Se=await this._hostUtils.realpath(se.extensionLocation.fsPath);Y.delete(C.URI.file(Se).fsPath)})),await Promise.all(L.map(async j=>{const se=await this._hostUtils.realpath(j.extensionLocation.fsPath);Y.set(C.URI.file(se).fsPath,j)})),this._registry.deltaExtensions(L,B),Promise.resolve(void 0)}async $test_latency(L){return L}async $test_up(L){return L.byteLength}async $test_down(L){let B=g.VSBuffer.alloc(L),Y=Math.random()%256;for(let j=0;j<L;j++)B.writeUInt8(Y,j);return B}async $updateRemoteConnectionData(L){this._remoteConnectionData=L,this._onDidChangeRemoteConnectionData.fire()}};H=ze([je(0,i.IInstantiationService),je(1,e.IHostUtils),je(2,p.IExtHostRpcService),je(3,d.IExtHostWorkspace),je(4,l.IExtHostConfiguration),je(5,n.ILogService),je(6,r.IExtHostInitDataService),je(7,c.IExtensionStoragePaths),je(8,A.IExtHostTunnelService),je(9,R.IExtHostTerminalService)],H),e.AbstractExtHostExtensionService=H;function z(q,L){return{id:q.identifier.value,name:q.name,extensionVersion:q.version,publisherDisplayName:q.publisher,activationEvents:q.activationEvents?q.activationEvents.join(","):null,isBuiltin:q.isBuiltin,reason:L.activationEvent,reasonId:L.extensionId.value}}e.IExtHostExtensionService=(0,i.createDecorator)("IExtHostExtensionService");class T{constructor(L,B,Y,j){ie.set(this,void 0),ce.set(this,void 0),K.set(this,void 0),nt(this,ie,L,"f"),nt(this,ce,B,"f"),nt(this,K,Y.identifier,"f"),this.id=Y.identifier.value,this.extensionUri=Y.extensionLocation,this.extensionPath=F.normalize((0,y.originalFSPath)(Y.extensionLocation)),this.packageJSON=Y,this.extensionKind=j}get isActive(){return Le(this,ie,"f").isActivated(Le(this,K,"f"))}get exports(){if(this.packageJSON.api!=="none")return Le(this,ie,"f").getExtensionExports(Le(this,K,"f"))}activate(){return Le(this,ie,"f").activateByIdWithErrors(Le(this,K,"f"),{startup:!1,extensionId:Le(this,ce,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=T,ie=new WeakMap,ce=new WeakMap,K=new WeakMap}),define(_e[106],ye([0,1,14,2,3,16,5,6,166,32,34,46,170,33,167,13,4,10,40,64]),function(ee,e,m,F,D,y,I,S,_,C,n,k,l,h,a,d,f,E,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,f.createDecorator)("IExtHostDebugService");let g=class{constructor(v,A,R,o,P,N){this._workspaceService=A,this._extensionService=R,this._editorsService=o,this._configurationService=P,this._editorTabs=N,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new D.Emitter,this._onDidTerminateDebugSession=new D.Emitter,this._onDidChangeActiveDebugSession=new D.Emitter,this._onDidReceiveDebugSessionCustomEvent=new D.Emitter,this._debugServiceProxy=v.getProxy(I.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new D.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then($=>{$.onDidChange(ie=>{this.registerAllDebugTypes($)}),this.registerAllDebugTypes($)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(v,A){const R=v;if(typeof R.sourceReference=="number"&&R.sourceReference>0){let o=`debug:${encodeURIComponent(R.path||"")}`,P="?";return A&&(o+=`${P}session=${encodeURIComponent(A.id)}`,P="&"),o+=`${P}ref=${R.sourceReference}`,F.URI.parse(o)}else{if(R.path)return F.URI.file(R.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(v){const A=[];for(const R of v.getAllExtensionDescriptions())if(R.contributes){const o=R.contributes.debuggers;if(o&&o.length>0)for(const P of o)(0,a.isDebuggerMainContribution)(P)&&A.push(P.type)}this._debugServiceProxy.$registerDebugTypes(A)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const v=[];return this._breakpoints.forEach(A=>v.push(A)),v}addBreakpoints(v){this.startBreakpoints();const A=v.filter(P=>{const N=P.id;return this._breakpoints.has(N)?!1:(this._breakpoints.set(N,P),!0)});this.fireBreakpointChanges(A,[],[]);const R=[],o=new Map;for(const P of A)if(P instanceof S.SourceBreakpoint){let N=o.get(P.location.uri.toString());N||(N={type:"sourceMulti",uri:P.location.uri,lines:[]},o.set(P.location.uri.toString(),N),R.push(N)),N.lines.push({id:P.id,enabled:P.enabled,condition:P.condition,hitCondition:P.hitCondition,logMessage:P.logMessage,line:P.location.range.start.line,character:P.location.range.start.character})}else P instanceof S.FunctionBreakpoint&&R.push({type:"function",id:P.id,enabled:P.enabled,hitCondition:P.hitCondition,logMessage:P.logMessage,condition:P.condition,functionName:P.functionName});return this._debugServiceProxy.$registerBreakpoints(R)}removeBreakpoints(v){this.startBreakpoints();const A=v.filter(N=>this._breakpoints.delete(N.id));this.fireBreakpointChanges([],A,[]);const R=A.filter(N=>N instanceof S.SourceBreakpoint).map(N=>N.id),o=A.filter(N=>N instanceof S.FunctionBreakpoint).map(N=>N.id),P=A.filter(N=>N instanceof S.DataBreakpoint).map(N=>N.id);return this._debugServiceProxy.$unregisterBreakpoints(R,o,P)}startDebugging(v,A,R){return this._debugServiceProxy.$startDebugging(v?v.uri:void 0,A,{parentSessionID:R.parentSession?R.parentSession.id:void 0,repl:R.consoleMode===S.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:R.noDebug,compact:R.compact})}stopDebugging(v){return this._debugServiceProxy.$stopDebugging(v?v.id:void 0)}registerDebugConfigurationProvider(v,A,R){if(!A)return new S.Disposable(()=>{});const o=this._configProviderHandleCounter++;return this._configProviders.push({type:v,handle:o,provider:A}),this._debugServiceProxy.$registerDebugConfigurationProvider(v,R,!!A.provideDebugConfigurations,!!A.resolveDebugConfiguration,!!A.resolveDebugConfigurationWithSubstitutedVariables,o),new S.Disposable(()=>{this._configProviders=this._configProviders.filter(P=>P.provider!==A),this._debugServiceProxy.$unregisterDebugConfigurationProvider(o)})}registerDebugAdapterDescriptorFactory(v,A,R){if(!R)return new S.Disposable(()=>{});if(!this.definesDebugType(v,A))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${A}' debugger.`);if(this.getAdapterDescriptorFactoryByType(A))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const o=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:A,handle:o,factory:R}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(A,o),new S.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(P=>P.factory!==R),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(o)})}registerDebugAdapterTrackerFactory(v,A){if(!A)return new S.Disposable(()=>{});const R=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:v,handle:R,factory:A}),new S.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(o=>o.factory!==A)})}async $runInTerminal(v,A){return Promise.resolve(void 0)}async $substituteVariables(v,A){if(!this._variableResolver){const[P,N]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(P||[],this._editorsService,N)}let R;const o=await this.getFolder(v);return o&&(R={uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(R,A)}createDebugAdapter(v,A){if(v.type==="implementation")return new r(v.implementation)}createSignService(){}async $startDASession(v,A){const R=this,o=await this.getSession(A);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(o.type),o).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}' (extension might have failed to activate)`);const N=this.convertToDto(P),$=this.createDebugAdapter(N,o);if(!$)throw new Error(`Couldn't create a debug adapter for type '${o.type}'.`);const ie=$;return this._debugAdapters.set(v,ie),this.getDebugAdapterTrackers(o).then(ce=>(ce&&this._debugAdaptersTrackers.set(v,ce),ie.onMessage(async K=>{if(K.type==="request"&&K.command==="handshake"){const H=K,z={type:"response",seq:0,command:H.command,request_seq:H.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const T=await this._signService.sign(H.arguments.value);z.body={signature:T},ie.sendResponse(z)}else throw new Error("no signer")}catch(T){z.success=!1,z.message=T.message,ie.sendResponse(z)}}else ce&&ce.onDidSendMessage&&ce.onDidSendMessage(K),K=(0,a.convertToVSCPaths)(K,!0),R._debugServiceProxy.$acceptDAMessage(v,K)}),ie.onError(K=>{ce&&ce.onError&&ce.onError(K),this._debugServiceProxy.$acceptDAError(v,K.name,K.message,K.stack)}),ie.onExit(K=>{ce&&ce.onExit&&ce.onExit((0,E.withNullAsUndefined)(K),void 0),this._debugServiceProxy.$acceptDAExit(v,(0,E.withNullAsUndefined)(K),void 0)}),ce&&ce.onWillStartSession&&ce.onWillStartSession(),ie.startSession()))})}$sendDAMessage(v,A){A=(0,a.convertToDAPaths)(A,!1);const R=this._debugAdaptersTrackers.get(v);R&&R.onWillReceiveMessage&&R.onWillReceiveMessage(A);const o=this._debugAdapters.get(v);o&&o.sendMessage(A)}$stopDASession(v){const A=this._debugAdaptersTrackers.get(v);this._debugAdaptersTrackers.delete(v),A&&A.onWillStopSession&&A.onWillStopSession();const R=this._debugAdapters.get(v);return this._debugAdapters.delete(v),R?R.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(v){const A=[],R=[],o=[];if(v.added)for(const P of v.added){const N=P.id;if(N&&!this._breakpoints.has(N)){let $;if(P.type==="function")$=new S.FunctionBreakpoint(P.functionName,P.enabled,P.condition,P.hitCondition,P.logMessage);else if(P.type==="data")$=new S.DataBreakpoint(P.label,P.dataId,P.canPersist,P.enabled,P.hitCondition,P.condition,P.logMessage);else{const ie=F.URI.revive(P.uri);$=new S.SourceBreakpoint(new S.Location(ie,new S.Position(P.line,P.character)),P.enabled,P.condition,P.hitCondition,P.logMessage)}$._id=N,this._breakpoints.set(N,$),A.push($)}}if(v.removed)for(const P of v.removed){const N=this._breakpoints.get(P);N&&(this._breakpoints.delete(P),R.push(N))}if(v.changed){for(const P of v.changed)if(P.id){const N=this._breakpoints.get(P.id);if(N){if(N instanceof S.FunctionBreakpoint&&P.type==="function"){const $=N;$.enabled=P.enabled,$.condition=P.condition,$.hitCondition=P.hitCondition,$.logMessage=P.logMessage,$.functionName=P.functionName}else if(N instanceof S.SourceBreakpoint&&P.type==="source"){const $=N;$.enabled=P.enabled,$.condition=P.condition,$.hitCondition=P.hitCondition,$.logMessage=P.logMessage,$.location=new S.Location(F.URI.revive(P.uri),new S.Position(P.line,P.character))}o.push(N)}}}this.fireBreakpointChanges(A,R,o)}$provideDebugConfigurations(v,A,R){return(0,y.asPromise)(async()=>{const o=this.getConfigProviderByHandle(v);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const P=await this.getFolder(A);return o.provideDebugConfigurations(P,R)}).then(o=>{if(!o)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return o})}$resolveDebugConfiguration(v,A,R,o){return(0,y.asPromise)(async()=>{const P=this.getConfigProviderByHandle(v);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const N=await this.getFolder(A);return P.resolveDebugConfiguration(N,R,o)})}$resolveDebugConfigurationWithSubstitutedVariables(v,A,R,o){return(0,y.asPromise)(async()=>{const P=this.getConfigProviderByHandle(v);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const N=await this.getFolder(A);return P.resolveDebugConfigurationWithSubstitutedVariables(N,R,o)})}async $provideDebugAdapter(v,A){const R=this.getAdapterDescriptorFactoryByHandle(v);if(!R)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const o=await this.getSession(A);return this.getAdapterDescriptor(R,o).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}'`);return this.convertToDto(P)})}async $acceptDebugSessionStarted(v){const A=await this.getSession(v);this._onDidStartDebugSession.fire(A)}async $acceptDebugSessionTerminated(v){const A=await this.getSession(v);A&&(this._onDidTerminateDebugSession.fire(A),this._debugSessions.delete(A.id))}async $acceptDebugSessionActiveChanged(v){this._activeDebugSession=v?await this.getSession(v):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(v,A){const R=await this.getSession(v);R&&R._acceptNameChanged(A)}async $acceptDebugSessionCustomEvent(v,A){const o={session:await this.getSession(v),event:A.event,body:A.body};this._onDidReceiveDebugSessionCustomEvent.fire(o)}convertToDto(v){if(v instanceof S.DebugAdapterExecutable)return{type:"executable",command:v.command,args:v.args,options:v.options};if(v instanceof S.DebugAdapterServer)return{type:"server",port:v.port,host:v.host};if(v instanceof S.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:v.path};if(v instanceof S.DebugAdapterInlineImplementation)return{type:"implementation",implementation:v.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(v){const A=this._adapterFactories.filter(R=>R.type===v);if(A.length>0)return A[0].factory}getAdapterDescriptorFactoryByHandle(v){const A=this._adapterFactories.filter(R=>R.handle===v);if(A.length>0)return A[0].factory}getConfigProviderByHandle(v){const A=this._configProviders.filter(R=>R.handle===v);if(A.length>0)return A[0].provider}definesDebugType(v,A){if(v.contributes){const R=v.contributes.debuggers;if(R&&R.length>0){for(const o of R)if(o.label&&o.type&&o.type===A)return!0}}return!1}getDebugAdapterTrackers(v){const R=v.configuration.type,o=this._trackerFactories.filter(P=>P.type===R||P.type==="*").map(P=>(0,y.asPromise)(()=>P.factory.createDebugAdapterTracker(v)).then(N=>N,N=>null));return Promise.race([Promise.all(o).then(P=>{const N=P.filter($=>!!$);if(N.length>0)return new i(N)}),new Promise((P,N)=>{const $=setTimeout(()=>{clearTimeout($),N(new Error("timeout"))},1e3)})]).catch(P=>{})}async getAdapterDescriptor(v,A){const R=A.configuration.debugServer;if(typeof R=="number")return Promise.resolve(new S.DebugAdapterServer(R));if(v){const P=await this._extensionService.getExtensionRegistry();return(0,y.asPromise)(()=>v.createDebugAdapterDescriptor(A,this.daExecutableFromPackage(A,P))).then(N=>{if(N)return N})}const o=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(A,o))}daExecutableFromPackage(v,A){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(v,A,R){(v.length>0||A.length>0||R.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:v,removed:A,changed:R}))}async getSession(v){if(v)if(typeof v=="string"){const A=this._debugSessions.get(v);if(A)return A}else{let A=this._debugSessions.get(v.id);if(!A){const R=await this.getFolder(v.folderUri),o=v.parent?this._debugSessions.get(v.parent):void 0;A=new b(this._debugServiceProxy,v.id,v.type,v.name,R,v.configuration,o),this._debugSessions.set(A.id,A),this._debugServiceProxy.$sessionCached(A.id)}return A}throw new Error("cannot find session")}getFolder(v){if(v){const A=F.URI.revive(v);return this._workspaceService.resolveWorkspaceFolder(A)}return Promise.resolve(void 0)}};g=ze([je(0,d.IExtHostRpcService),je(1,C.IExtHostWorkspace),je(2,n.IExtHostExtensionService),je(3,k.IExtHostDocumentsAndEditors),je(4,h.IExtHostConfiguration),je(5,u.IExtHostEditorTabs)],g),e.ExtHostDebugServiceBase=g;class b{constructor(v,A,R,o,P,N,$){this._debugServiceProxy=v,this._id=A,this._type=R,this._name=o,this._workspaceFolder=P,this._configuration=N,this._parentSession=$}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(v){this._name=v,this._debugServiceProxy.$setDebugSessionName(this._id,v)}get parentSession(){return this._parentSession}_acceptNameChanged(v){this._name=v}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(v,A){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,v,A)}getDebugProtocolBreakpoint(v){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,v.id)}}e.ExtHostDebugSession=b;class t{constructor(v){this.value=Object.freeze({append(A){v.$appendDebugConsole(A)},appendLine(A){this.append(A+`
`)}})}}e.ExtHostDebugConsole=t;class s extends l.AbstractVariableResolverService{constructor(v,A,R,o,P){function N(){if(A){const $=A.activeEditor();if($)return $.document.uri;const ie=o.tabs.filter(ce=>ce.isActive);if(ie.length>0)return ie[0].resource}}super({getFolderUri:$=>{const ie=v.filter(ce=>ce.name===$);if(ie&&ie.length>0)return ie[0].uri},getWorkspaceFolderCount:()=>v.length,getConfigurationValue:($,ie)=>R.getConfiguration(void 0,$).get(ie),getAppRoot:()=>w.cwd(),getExecPath:()=>w.env.VSCODE_EXEC_PATH,getFilePath:()=>{const $=N();if($)return m.normalize($.fsPath)},getWorkspaceFolderPathForFile:()=>{if(P){const $=N();if($){const ie=P.getWorkspaceFolder($);if(ie)return m.normalize(ie.uri.fsPath)}}},getSelectedText:()=>{if(A){const $=A.activeEditor();if($&&!$.selection.isEmpty)return $.document.getText($.selection)}},getLineNumber:()=>{if(A){const $=A.activeEditor();if($)return String($.selection.end.line+1)}}},void 0,Promise.resolve(w.env))}}e.ExtHostVariableResolverService=s;class i{constructor(v){this.trackers=v}onWillStartSession(){this.trackers.forEach(v=>v.onWillStartSession?v.onWillStartSession():void 0)}onWillReceiveMessage(v){this.trackers.forEach(A=>A.onWillReceiveMessage?A.onWillReceiveMessage(v):void 0)}onDidSendMessage(v){this.trackers.forEach(A=>A.onDidSendMessage?A.onDidSendMessage(v):void 0)}onWillStopSession(){this.trackers.forEach(v=>v.onWillStopSession?v.onWillStopSession():void 0)}onError(v){this.trackers.forEach(A=>A.onError?A.onError(v):void 0)}onExit(v,A){this.trackers.forEach(R=>R.onExit?R.onExit(v,A):void 0)}}class r extends _.AbstractDebugAdapter{constructor(v){super();this.implementation=v,v.onDidSendMessage(A=>{this.acceptMessage(A)})}startSession(){return Promise.resolve(void 0)}sendMessage(v){this.implementation.handleMessage(v)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let c=class extends g{constructor(v,A,R,o,P,N){super(v,A,R,o,P,N)}createVariableResolver(v,A,R){return new s(v,A,R,this._editorTabs)}};c=ze([je(0,d.IExtHostRpcService),je(1,C.IExtHostWorkspace),je(2,n.IExtHostExtensionService),je(3,k.IExtHostDocumentsAndEditors),je(4,h.IExtHostConfiguration),je(5,u.IExtHostEditorTabs)],c),e.WorkerExtHostDebugService=c}),define(_e[219],ye([0,1,76,2,5,33,29,26,13,28,4,34,40,15]),function(ee,e,m,F,D,y,I,S,_,C,n,k,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(u,g,b,t,s,i,r){this._apiFactory=u,this._extensionRegistry=g,this._instaService=b,this._extHostConfiguration=t,this._extHostExtensionService=s,this._initData=i,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),m.mark("code/extHost/willWaitForConfig");const u=await this._extHostConfiguration.getConfigProvider();m.mark("code/extHost/didWaitForConfig");const g=await this._extHostExtensionService.getExtensionPathIndex();this.register(new d(this._apiFactory,g,this._extensionRegistry,u,this._logService)),this.register(this._instaService.createInstance(f)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(E,g,this._initData.environment.appUriScheme))}register(u){if(Array.isArray(u.nodeModuleName))for(let g of u.nodeModuleName)this._factories.set(g,u);else this._factories.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this._alternatives.push(g=>u.alternativeModuleName(g))}};a=ze([je(2,n.IInstantiationService),je(3,y.IExtHostConfiguration),je(4,k.IExtHostExtensionService),je(5,C.IExtHostInitDataService),je(6,h.ILogService)],a),e.RequireInterceptor=a;class d{constructor(u,g,b,t,s){this._apiFactory=u,this._extensionPaths=g,this._extensionRegistry=b,this._configProvider=t,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(u,g){const b=this._extensionPaths.findSubstr(g.fsPath);if(b){let t=this._extApiImpl.get(S.ExtensionIdentifier.toKey(b.identifier));return t||(t=this._apiFactory(b,this._extensionRegistry,this._configProvider),this._extApiImpl.set(S.ExtensionIdentifier.toKey(b.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((s,i)=>t+=`	${i} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${g.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(I.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let f=class{constructor(u,g){this.nodeModuleName="keytar";const{environment:b}=g,t=u.getProxy(D.MainContext.MainThreadKeytar);if(b.appRoot){let s=b.appRoot.fsPath;l.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${s}/node_modules.asar/keytar`),this.alternativeNames.add(`${s}/node_modules/keytar`)}this._impl={getPassword:(s,i)=>t.$getPassword(s,i),setPassword:(s,i,r)=>t.$setPassword(s,i,r),deletePassword:(s,i)=>t.$deletePassword(s,i),findPassword:s=>t.$findPassword(s),findCredentials(s){return t.$findCredentials(s)}}}load(u,g){return this._impl}alternativeModuleName(u){const g=u.length;if(g<=7||!this.alternativeNames)return;const b=g-7;if((u.charAt(b)==="/"||u.charAt(b)==="\\")&&u.endsWith("keytar")&&(u=u.replace(/\\/g,"/"),this.alternativeNames.has(u)))return"keytar"}};f=ze([je(0,_.IExtHostRpcService),je(1,C.IExtHostInitDataService)],f);let E=class{constructor(u,g,b){this._extensionPaths=u,this._appUriScheme=g,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=b.getProxy(D.MainContext.MainThreadTelemetry);const t=b.getProxy(D.MainContext.MainThreadWindow);this._impl=(s,i)=>{const r=F.URI.parse(s);return i?this.callOriginal(s,i):r.scheme==="http"||r.scheme==="https"?t.$openUri(r,s,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?t.$openUri(r,s,{}):this.callOriginal(s,i)}}load(u,g,b){const t=this._extensionPaths.findSubstr(g.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=b(u),this._impl}callOriginal(u,g){return this.sendNoForwardTelemetry(),this._original(u,g)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};E=ze([je(2,_.IExtHostRpcService)],E)}),define(_e[220],ye([0,1,16,12,76,7,2,5,213,15,57,61,28,148,13,67,34,37]),function(ee,e,m,F,D,y,I,S,_,C,n,k,l,h,a,d,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class w{constructor(g,b,t,s){this._disposables=new y.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new _.RPCProtocol(g,null,s),b=w._transform(b,this._rpcProtocol);const i=new k.ServiceCollection(...(0,n.getSingletonServiceDescriptors)());i.set(l.IExtHostInitDataService,{_serviceBrand:void 0,...b}),i.set(a.IExtHostRpcService,new a.ExtHostRpcService(this._rpcProtocol)),i.set(d.IURITransformerService,new d.URITransformerService(s)),i.set(f.IHostUtils,t);const r=new h.InstantiationService(i,!0),c=r.invokeFunction(R=>R.get(E.IExtHostTerminalService));this._disposables.add(c),this._logService=r.invokeFunction(R=>R.get(C.ILogService)),D.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",b),this._extensionService=r.invokeFunction(R=>R.get(f.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const p=new WeakMap;this._extensionService.getExtensionPathIndex().then(R=>{Error.prepareStackTrace=(o,P)=>{let N="",$,ie;for(const ce of P)N+=`
	at ${ce.toString()}`,ie=ce.getFileName(),!$&&ie&&($=R.findSubstr(ie));return p.set(o,$),`${o.name||"Error"}: ${o.message||""}${N}`}});const v=this._rpcProtocol.getProxy(S.MainContext.MainThreadExtensionService),A=this._rpcProtocol.getProxy(S.MainContext.MainThreadErrors);F.setUnexpectedErrorHandler(R=>{const o=F.transformErrorForSerialization(R),P=p.get(R);P?v.$onExtensionRuntimeError(P.identifier,o):A.$onUnexpectedError(o)})}terminate(g){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${g}`),this._logService.flush(),this._disposables.dispose(),F.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const b=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,m.timeout)(4e3),b]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(g,b){g.extensions.forEach(s=>s.extensionLocation=I.URI.revive(b.transformIncomingURIs(s.extensionLocation))),g.environment.appRoot=I.URI.revive(b.transformIncomingURIs(g.environment.appRoot));const t=g.environment.extensionDevelopmentLocationURI;return t&&(g.environment.extensionDevelopmentLocationURI=t.map(s=>I.URI.revive(b.transformIncomingURIs(s)))),g.environment.extensionTestsLocationURI=I.URI.revive(b.transformIncomingURIs(g.environment.extensionTestsLocationURI)),g.environment.globalStorageHome=I.URI.revive(b.transformIncomingURIs(g.environment.globalStorageHome)),g.environment.workspaceStorageHome=I.URI.revive(b.transformIncomingURIs(g.environment.workspaceStorageHome)),g.logsLocation=I.URI.revive(b.transformIncomingURIs(g.logsLocation)),g.logFile=I.URI.revive(b.transformIncomingURIs(g.logFile)),g.workspace=b.transformIncomingURIs(g.workspace),g}}e.ExtensionHostMain=w}),define(_e[221],ye([0,1,14,18,56,27,25,52,38]),function(ee,e,m,F,D,y,I,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(l,h,a){this.config=l,this.provider=h,this.sessionToken=a,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&y.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&y.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const h=this.config.folderQueries||[];return new Promise((a,d)=>{const f=E=>{this.resultCount++,l(E)};if(this.isCanceled)return a({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(E=>{const w=E.toString(),u=m.basename(w);this.globalExcludePattern&&this.globalExcludePattern(w,u)||this.matchFile(f,{base:E,basename:u})}),Promise.all(h.map(E=>this.searchInFolder(E,f))).then(E=>{a({limitHit:this.isLimitHit,stats:E[0]||void 0})},E=>{d(new Error((0,D.toErrorMessage)(E)))})})}async searchInFolder(l,h){const a=new F.CancellationTokenSource,d=this.getSearchOptionsForFolder(l),f=this.initDirectoryTree(),E=new _.QueryGlobTester(this.config,l),w=!E.hasSiblingExcludeClauses();let u;try{this.activeCancellationTokens.add(a),u=S.StopWatch.create();const g=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},d,a.token),b=u.elapsed(),t=S.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(g&&g.forEach(s=>{const i=m.posix.relative(l.folder.path,s.path);if(w){const r=m.basename(s.path);this.matchFile(h,{base:l.folder,relativePath:i,basename:r});return}this.addDirectoryEntries(f,l.folder,i,h)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(f,E,h),{providerTime:b,postProcessTime:t.elapsed()})}finally{a.dispose(),this.activeCancellationTokens.delete(a)}}getSearchOptionsForFolder(l){const h=(0,_.resolvePatternsForProvider)(this.config.includePattern,l.includePattern),a=(0,_.resolvePatternsForProvider)(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:a,includes:h,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},h,a,d){if(a===this.filePattern){const E=m.basename(this.filePattern);this.matchFile(d,{base:h,relativePath:this.filePattern,basename:E})}function f(E){const w=m.basename(E),u=m.dirname(E);let g=l[u];g||(g=l[u]=[],f(u)),g.push({base:h,relativePath:E,basename:w})}f(a)}matchDirectoryTree({rootEntries:l,pathToEntries:h},a,d){const f=this,E=this.filePattern;function w(u){const g=y.hasSiblingFn(()=>u.map(b=>b.basename));for(let b=0,t=u.length;b<t;b++){const s=u[b],{relativePath:i,basename:r}=s;if(!a.includedInQuerySync(i,r,E!==r?g:void 0))continue;const c=h[i];if(c)w(c);else{if(i===E)continue;f.matchFile(d,s)}if(f.isLimitHit)break}}w(l)}matchFile(l,h){(!this.includePattern||h.relativePath&&this.includePattern(h.relativePath,h.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(h))}}class n{constructor(){this.sessions=new Map}fileSearch(l,h,a,d){const f=this.getSessionTokenSource(l.cacheKey),E=new C(l,h,f&&f.token);let w=0;const u=g=>{w+=g.length,a(g.map(b=>this.rawMatchToSearchItem(b)))};return this.doSearch(E,n.BATCH_SIZE,u,d).then(g=>({limitHit:g.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:w,detailStats:g.stats}}))}clearCache(l){const h=this.getSessionTokenSource(l);h&&h.cancel()}getSessionTokenSource(l){if(!!l)return this.sessions.has(l)||this.sessions.set(l,new F.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:I.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,h,a,d){d.onCancellationRequested(()=>{l.cancel()});const f=w=>{w&&(E.push(w),h>0&&E.length>=h&&(a(E),E=[]))};let E=[];return l.search(f).then(w=>(E.length&&a(E),w),w=>(E.length&&a(E),Promise.reject(w)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(_e[222],ye([0,1,14,17,18,56,25,27,2,38,11,10]),function(ee,e,m,F,D,y,I,S,_,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class l{constructor(u,g,b){this.query=u,this.provider=g,this.fileUtils=b,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(u,g){const b=this.query.folderQueries||[],t=new D.CancellationTokenSource;return g.onCancellationRequested(()=>t.cancel()),new Promise((s,i)=>{this.collector=new a(u);let r=!1;const c=(p,v)=>{if(!r&&!this.isLimitHit){const A=this.resultSize(p);f(p)&&typeof this.query.maxResults=="number"&&this.resultCount+A>this.query.maxResults&&(this.isLimitHit=!0,r=!0,t.cancel(),p=this.trimResultToSize(p,this.query.maxResults-this.resultCount));const R=this.resultSize(p);this.resultCount+=R,(R>0||!f(p))&&this.collector.add(p,v)}};Promise.all(b.map((p,v)=>this.searchInFolder(p,A=>c(A,v),t.token))).then(p=>{t.dispose(),this.collector.flush();const v=p.some(A=>!!A&&!!A.limitHit);s({limitHit:this.isLimitHit||v,messages:(0,F.flatten)(p.map(A=>A?.message?(0,k.isArray)(A.message)?A.message:[A.message]:[])),stats:{type:"textSearchProvider"}})},p=>{t.dispose();const v=(0,y.toErrorMessage)(p);i(new Error(v))})})}resultSize(u){return f(u)?Array.isArray(u.ranges)?u.ranges.length:1:0}trimResultToSize(u,g){const b=Array.isArray(u.ranges)?u.ranges:[u.ranges],t=Array.isArray(u.preview.matches)?u.preview.matches:[u.preview.matches];return{ranges:b.slice(0,g),preview:{matches:t.slice(0,g),text:u.preview.text},uri:u.uri}}async searchInFolder(u,g,b){const t=new C.QueryGlobTester(this.query,u),s=[],i={report:p=>{if(!this.validateProviderResult(p))return;const v=u.folder.scheme===n.Schemas.file?S.hasSiblingPromiseFn(()=>this.fileUtils.readdir(I.dirname(p.uri))):void 0,A=I.relativePath(u.folder,p.uri);A&&s.push(t.includedInQuery(A,m.basename(A),v).then(R=>{R&&g(p)}))}},r=this.getSearchOptionsForFolder(u),c=await this.provider.provideTextSearchResults(h(this.query.contentPattern),r,i,b);return await Promise.all(s),c}validateProviderResult(u){if(f(u)){if(Array.isArray(u.ranges)){if(!Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(u.preview.matches.length!==u.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(u){const g=(0,C.resolvePatternsForProvider)(this.query.includePattern,u.includePattern),b=(0,C.resolvePatternsForProvider)(this.query.excludePattern,u.excludePattern),t={folder:_.URI.from(u.folder),excludes:b,includes:g,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,followSymlinks:!u.ignoreSymlinks,encoding:u.fileEncoding&&this.fileUtils.toCanonicalName(u.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=l;function h(w){return{isCaseSensitive:w.isCaseSensitive||!1,isRegExp:w.isRegExp||!1,isWordMatch:w.isWordMatch||!1,isMultiline:w.isMultiline||!1,pattern:w.pattern}}class a{constructor(u){this._onResult=u,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new E(512,g=>this.sendItems(g))}add(u,g){this._currentFileMatch&&(this._currentFolderIdx!==g||!I.isEqual(this._currentUri,u.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=g,this._currentFileMatch={resource:u.uri,results:[]}),this._currentFileMatch.results.push(d(u))}pushToCollector(){const u=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,u)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(u){this._onResult(u)}}e.TextSearchResultsCollector=a;function d(w){return f(w)?{preview:{matches:(0,F.mapArrayOrNot)(w.preview.matches,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character})),text:w.preview.text},ranges:(0,F.mapArrayOrNot)(w.ranges,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character}))}:{text:w.text,lineNumber:w.lineNumber}}function f(w){return!!w.preview}e.extensionResultIsMatch=f;class E{constructor(u,g){this.maxBatchSize=u,this.cb=g,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(u,g){!u||this.addItemToBatch(u,g)}addItems(u,g){!u||this.addItemsToBatch(u,g)}addItemToBatch(u,g){this.batch.push(u),this.batchSize+=g,this.onUpdate()}addItemsToBatch(u,g){this.batch=this.batch.concat(u),this.batchSize+=g,this.onUpdate()}onUpdate(){this.totalNumberCompleted<E.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},E.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=E,E.TIMEOUT=4e3,E.START_BATCH_AFTER_COUNT=50}),define(_e[107],ye([0,1,7,5,4,221,13,67,15,2,222]),function(ee,e,m,F,D,y,I,S,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let k=class{constructor(d,f,E){this.extHostRpc=d,this._uriTransformer=f,this._logService=E,this._proxy=this.extHostRpc.getProxy(F.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new y.FileSearchManager}_transformScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}registerTextSearchProvider(d,f){if(this._textSearchUsedSchemes.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this._textSearchUsedSchemes.add(d);const E=this._handlePool++;return this._textSearchProvider.set(E,f),this._proxy.$registerTextSearchProvider(E,this._transformScheme(d)),(0,m.toDisposable)(()=>{this._textSearchUsedSchemes.delete(d),this._textSearchProvider.delete(E),this._proxy.$unregisterProvider(E)})}registerFileSearchProvider(d,f){if(this._fileSearchUsedSchemes.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this._fileSearchUsedSchemes.add(d);const E=this._handlePool++;return this._fileSearchProvider.set(E,f),this._proxy.$registerFileSearchProvider(E,this._transformScheme(d)),(0,m.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(d),this._fileSearchProvider.delete(E),this._proxy.$unregisterProvider(E)})}$provideFileSearchResults(d,f,E,w){const u=l(E),g=this._fileSearchProvider.get(d);if(g)return this._fileSearchManager.fileSearch(u,g,b=>{this._proxy.$handleFileMatch(d,f,b.map(t=>t.resource))},w);throw new Error("unknown provider: "+d)}$clearCache(d){return this._fileSearchManager.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,f,E,w){const u=this._textSearchProvider.get(d);if(!u||!u.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const g=l(E);return this.createTextSearchManager(g,u).search(t=>this._proxy.$handleTextMatch(d,f,t),w)}createTextSearchManager(d,f){return new n.TextSearchManager(d,f,{readdir:E=>Promise.resolve([]),toCanonicalName:E=>E})}};k=ze([je(0,I.IExtHostRpcService),je(1,S.IURITransformerService),je(2,_.ILogService)],k),e.ExtHostSearch=k;function l(a){return{...a,folderQueries:a.folderQueries&&a.folderQueries.map(h),extraFileResources:a.extraFileResources&&a.extraFileResources.map(d=>C.URI.revive(d))}}e.reviveQuery=l;function h(a){return{...a,folder:C.URI.revive(a.folder)}}}),define(_e[223],ye([0,1,18,12,3,42,2,124,85,118,55,60,5,186,185,72,187,33,188,189,190,172,191,46,34,192,173,194,195,196,102,175,201,202,203,74,37,205,176,9,6,208,47,103,32,29,77,164,193,93,101,105,106,107,15,67,13,28,197,162,66,71,183,206,161,75,73,211,209,210,184,45,204,207,70,64,94,199,104,200,11,150,198,159,157]),function(ee,e,m,F,D,y,I,S,_,C,n,k,l,h,a,d,f,E,w,u,g,b,t,s,i,r,c,p,v,A,R,o,P,N,$,ie,ce,K,H,z,T,q,L,B,Y,j,se,Se,Re,$e,Ne,Ge,Ke,qe,U,G,te,re,pe,Q,ue,Ie,xe,We,ve,tt,W,J,fe,Oe,Ue,et,Ce,De,Ae,ne,oe,de,ge,x,he,we,Pe,Fe,He){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ze(Qe){const Ye=Qe.get(re.IExtHostInitDataService),at=Qe.get(et.IExtHostFileSystemInfo),ct=Qe.get(W.IExtHostConsumerFileSystem),wt=Qe.get(i.IExtHostExtensionService),me=Qe.get(Y.IExtHostWorkspace),Ee=Qe.get(oe.IExtHostTelemetry),ae=Qe.get(E.IExtHostConfiguration),V=Qe.get(G.IURITransformerService),be=Qe.get(te.IExtHostRpcService),Be=Qe.get(ie.IExtHostStorage),Xe=Qe.get(tt.IExtensionStoragePaths),Ve=Qe.get(U.ILogService),lt=Qe.get(ue.IExtHostTunnelService),ht=Qe.get(Ie.IExtHostApiDeprecationService),St=Qe.get(B.IExtHostWindow),Ct=Qe.get(Ae.IExtHostSecretState),Et=Qe.get(ne.IExtHostEditorTabs);be.set(l.ExtHostContext.ExtHostFileSystemInfo,at),be.set(l.ExtHostContext.ExtHostLogService,Ve),be.set(l.ExtHostContext.ExtHostWorkspace,me),be.set(l.ExtHostContext.ExtHostConfiguration,ae),be.set(l.ExtHostContext.ExtHostExtensionService,wt),be.set(l.ExtHostContext.ExtHostStorage,Be),be.set(l.ExtHostContext.ExtHostTunnelService,lt),be.set(l.ExtHostContext.ExtHostWindow,St),be.set(l.ExtHostContext.ExtHostSecretState,Ct),be.set(l.ExtHostContext.ExtHostTelemetry,Ee),be.set(l.ExtHostContext.ExtHostEditorTabs,Et);const vt=be.set(l.ExtHostContext.ExtHostDecorations,Qe.get(Ne.IExtHostDecorations)),_t=be.set(l.ExtHostContext.ExtHostDocumentsAndEditors,Qe.get(s.IExtHostDocumentsAndEditors)),dt=be.set(l.ExtHostContext.ExtHostCommands,Qe.get(d.IExtHostCommands)),bt=be.set(l.ExtHostContext.ExtHostTerminalService,Qe.get(ce.IExtHostTerminalService)),ft=be.set(l.ExtHostContext.ExtHostDebugService,Qe.get(Ke.IExtHostDebugService)),Ot=be.set(l.ExtHostContext.ExtHostSearch,Qe.get(qe.IExtHostSearch)),Pt=be.set(l.ExtHostContext.ExtHostTask,Qe.get(Ge.IExtHostTask)),Kt=be.set(l.ExtHostContext.ExtHostOutputService,Qe.get(R.IExtHostOutputService)),Ut=be.set(l.ExtHostContext.ExtHostUrls,new q.ExtHostUrls(be)),kt=be.set(l.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(be,_t)),Qt=be.set(l.ExtHostContext.ExtHostDocumentContentProviders,new g.ExtHostDocumentContentProvider(be,_t,Ve)),Yt=be.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new b.ExtHostDocumentSaveParticipant(Ve,kt,be.getProxy(l.MainContext.MainThreadBulkEdits))),mt=be.set(l.ExtHostContext.ExtHostNotebook,new pe.ExtHostNotebookController(be,dt,_t,kt,Xe)),qt=be.set(l.ExtHostContext.ExtHostNotebookDocuments,new Fe.ExtHostNotebookDocuments(Ve,mt)),zt=be.set(l.ExtHostContext.ExtHostNotebookEditors,new Pe.ExtHostNotebookEditors(Ve,be,mt)),Jt=be.set(l.ExtHostContext.ExtHostNotebookKernels,new de.ExtHostNotebookKernels(be,Ye,mt,Ve)),Xt=be.set(l.ExtHostContext.ExtHostNotebookRenderers,new x.ExtHostNotebookRenderers(be,mt)),At=be.set(l.ExtHostContext.ExtHostEditors,new K.ExtHostEditors(be,_t)),jt=be.set(l.ExtHostContext.ExtHostTreeViews,new H.ExtHostTreeViews(be.getProxy(l.MainContext.MainThreadTreeViews),dt,Ve)),Zt=be.set(l.ExtHostContext.ExtHostEditorInsets,new Se.ExtHostEditorInsets(be.getProxy(l.MainContext.MainThreadEditorInsets),At,Ye)),Ht=be.set(l.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(be,Ve)),ut=be.set(l.ExtHostContext.ExtHostLanguageFeatures,new p.ExtHostLanguageFeatures(be,V,kt,dt,Ht,Ve,ht)),En=be.set(l.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(be,ut)),Rt=be.set(l.ExtHostContext.ExtHostFileSystemEventService,new c.ExtHostFileSystemEventService(be,Ve,_t)),xt=be.set(l.ExtHostContext.ExtHostQuickOpen,(0,P.createExtHostQuickOpen)(be,me,dt)),cn=be.set(l.ExtHostContext.ExtHostSCM,new N.ExtHostSCM(be,dt,Ve)),_n=be.set(l.ExtHostContext.ExtHostComments,(0,f.createExtHostComments)(be,dt,kt)),dn=be.set(l.ExtHostContext.ExtHostProgress,new o.ExtHostProgress(be.getProxy(l.MainContext.MainThreadProgress))),yn=be.set(l.ExtHostContext.ExtHosLabelService,new Re.ExtHostLabelService(be)),hn=be.set(l.ExtHostContext.ExtHostTheming,new Q.ExtHostTheming(be)),Vt=be.set(l.ExtHostContext.ExtHostAuthentication,new xe.ExtHostAuthentication(be)),en=be.set(l.ExtHostContext.ExtHostTimeline,new We.ExtHostTimeline(be,dt)),tn=be.set(l.ExtHostContext.ExtHostWebviews,new L.ExtHostWebviews(be,{remote:Ye.remote},me,Ve,ht)),nn=be.set(l.ExtHostContext.ExtHostWebviewPanels,new Oe.ExtHostWebviewPanels(be,tn,me)),Sn=be.set(l.ExtHostContext.ExtHostCustomEditors,new fe.ExtHostCustomEditors(be,kt,Xe,tn,nn)),Dn=be.set(l.ExtHostContext.ExtHostWebviewViews,new J.ExtHostWebviewViews(be,tn)),Ft=be.set(l.ExtHostContext.ExtHostTesting,new Ce.ExtHostTesting(be,dt)),Cn=be.set(l.ExtHostContext.ExtHostUriOpeners,new De.ExtHostUriOpeners(be));be.set(l.ExtHostContext.ExtHostInteractive,new He.ExtHostInteractive(be,mt,_t));const kn=(0,se.values)(l.ExtHostContext);be.assertRegistered(kn);const rn=new Ue.ExtHostBulkEdits(be,_t),In=new a.ExtHostClipboard(be),Bt=new A.ExtHostMessageService(be,Ve),Lt=new u.ExtHostDialogs(be),fn=new $.ExtHostStatusBar(be,dt.converter),Tt=new v.ExtHostLanguages(be,kt);return h.ExtHostApiCommands.register(dt),function(Me,sn,mn){const gt=function(){let X=!Me.isUnderDevelopment;function le(Te){X||(Ve.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function Te(rt){if(Array.isArray(rt))rt.forEach(Te);else if(typeof rt=="string")le(rt);else{const pt=rt;typeof pt.scheme=="undefined"&&le(rt),!Me.enableProposedApi&&typeof pt.exclusive=="boolean"&&(0,j.throwProposedApiError)(Me)}return rt}}(),Pn={getSession(X,le,Te){return Vt.getSession(Me,X,le,Te)},get onDidChangeSessions(){return Vt.onDidChangeSessions},registerAuthenticationProvider(X,le,Te,rt){return Vt.registerAuthenticationProvider(X,le,Te,rt)}},An={registerCommand(X,le,Te){return dt.registerCommand(!0,X,le,Te)},registerTextEditorCommand(X,le,Te){return dt.registerCommand(!0,X,(...rt)=>{const pt=At.getActiveTextEditor();if(!pt){Ve.warn("Cannot execute "+X+" because there is no active text editor.");return}return pt.edit(Dt=>{le.apply(Te,[pt,Dt,...rt])}).then(Dt=>{Dt||Ve.warn("Edits from command "+X+" were not applied.")},Dt=>{Ve.warn("An error occurred while running command "+X,Dt)})})},registerDiffInformationCommand:(X,le,Te)=>((0,j.checkProposedApiEnabled)(Me),dt.registerCommand(!0,X,async(...rt)=>{const pt=_t.activeEditor(!0);if(!pt){Ve.warn("Cannot execute "+X+" because there is no active text editor.");return}const Dt=await At.getDiffInformation(pt.id);le.apply(Te,[Dt,...rt])})),executeCommand(X,...le){return dt.executeCommand(X,...le)},getCommands(X=!1){return dt.getCommands(X)}},gn={get machineId(){return Ye.telemetryInfo.machineId},get sessionId(){return Ye.telemetryInfo.sessionId},get language(){return Ye.environment.appLanguage},get appName(){return Ye.environment.appName},get appRoot(){return Ye.environment.appRoot?.fsPath??""},get uriScheme(){return Ye.environment.appUriScheme},get clipboard(){return In.value},get shell(){return bt.getDefaultShell(!1)},get isTelemetryEnabled(){return Ee.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Ee.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(Ye.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,le){return St.openUri(X,{allowTunneling:!!Ye.remote.authority,allowContributedOpeners:le?.allowContributedOpeners})},async asExternalUri(X){if(X.scheme===Ye.environment.appUriScheme)return Ut.createAppUri(X);try{return await St.asExternalUri(X,{allowTunneling:!!Ye.remote.authority})}catch(le){if((0,we.matchesScheme)(X,he.Schemas.http)||(0,we.matchesScheme)(X,he.Schemas.https))return X;throw le}},get remoteName(){return(0,$e.getRemoteName)(Ye.remote.authority)},get uiKind(){return Ye.uiKind}};Ye.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=Ye.remote.isRemote?T.ExtensionKind.Workspace:T.ExtensionKind.UI,on={createTestController(X,le){return(0,j.checkProposedApiEnabled)(Me),Ft.createTestController(X,le)},createTestItem(X,le,Te){return(0,j.checkProposedApiEnabled)(Me),Ft.createTestItem(X,le,Te)},createTestObserver(){return(0,j.checkProposedApiEnabled)(Me),Ft.createTestObserver()},runTests(X){return(0,j.checkProposedApiEnabled)(Me),Ft.runTests(X)},get onDidChangeTestResults(){return(0,j.checkProposedApiEnabled)(Me),Ft.onResultsChanged},get testResults(){return(0,j.checkProposedApiEnabled)(Me),Ft.results}},Tn={getExtension(X){const le=sn.getExtensionDescription(X);if(le)return new i.Extension(wt,Me.identifier,le,pn)},get all(){return sn.getAllExtensionDescriptions().map(X=>new i.Extension(wt,Me.identifier,X,pn))},get onDidChange(){return sn.onDidChange}},Rn={createDiagnosticCollection(X){return Ht.createDiagnosticCollection(Me.identifier,X)},get onDidChangeDiagnostics(){return Ht.onDidChangeDiagnostics},getDiagnostics:X=>Ht.getDiagnostics(X),getLanguages(){return Tt.getLanguages()},setTextDocumentLanguage(X,le){return Tt.changeLanguage(X.uri,le)},match(X,le){return(0,n.score)(z.LanguageSelector.from(X),le.uri,le.languageId,!0)},registerCodeActionsProvider(X,le,Te){return ut.registerCodeActionProvider(Me,gt(X),le,Te)},registerCodeLensProvider(X,le){return ut.registerCodeLensProvider(Me,gt(X),le)},registerDefinitionProvider(X,le){return ut.registerDefinitionProvider(Me,gt(X),le)},registerDeclarationProvider(X,le){return ut.registerDeclarationProvider(Me,gt(X),le)},registerImplementationProvider(X,le){return ut.registerImplementationProvider(Me,gt(X),le)},registerTypeDefinitionProvider(X,le){return ut.registerTypeDefinitionProvider(Me,gt(X),le)},registerHoverProvider(X,le){return ut.registerHoverProvider(Me,gt(X),le,Me.identifier)},registerEvaluatableExpressionProvider(X,le){return ut.registerEvaluatableExpressionProvider(Me,gt(X),le,Me.identifier)},registerInlineValuesProvider(X,le){return ut.registerInlineValuesProvider(Me,gt(X),le,Me.identifier)},registerDocumentHighlightProvider(X,le){return ut.registerDocumentHighlightProvider(Me,gt(X),le)},registerLinkedEditingRangeProvider(X,le){return ut.registerLinkedEditingRangeProvider(Me,gt(X),le)},registerReferenceProvider(X,le){return ut.registerReferenceProvider(Me,gt(X),le)},registerRenameProvider(X,le){return ut.registerRenameProvider(Me,gt(X),le)},registerDocumentSymbolProvider(X,le,Te){return ut.registerDocumentSymbolProvider(Me,gt(X),le,Te)},registerWorkspaceSymbolProvider(X){return ut.registerWorkspaceSymbolProvider(Me,X)},registerDocumentFormattingEditProvider(X,le){return ut.registerDocumentFormattingEditProvider(Me,gt(X),le)},registerDocumentRangeFormattingEditProvider(X,le){return ut.registerDocumentRangeFormattingEditProvider(Me,gt(X),le)},registerOnTypeFormattingEditProvider(X,le,Te,...rt){return ut.registerOnTypeFormattingEditProvider(Me,gt(X),le,[Te].concat(rt))},registerDocumentSemanticTokensProvider(X,le,Te){return ut.registerDocumentSemanticTokensProvider(Me,gt(X),le,Te)},registerDocumentRangeSemanticTokensProvider(X,le,Te){return ut.registerDocumentRangeSemanticTokensProvider(Me,gt(X),le,Te)},registerSignatureHelpProvider(X,le,Te,...rt){return typeof Te=="object"?ut.registerSignatureHelpProvider(Me,gt(X),le,Te):ut.registerSignatureHelpProvider(Me,gt(X),le,typeof Te=="undefined"?[]:[Te,...rt])},registerCompletionItemProvider(X,le,...Te){return ut.registerCompletionItemProvider(Me,gt(X),le,Te)},registerInlineCompletionItemProvider(X,le){return(0,j.checkProposedApiEnabled)(Me),ut.registerInlineCompletionsProvider(Me,gt(X),le)},registerDocumentLinkProvider(X,le){return ut.registerDocumentLinkProvider(Me,gt(X),le)},registerColorProvider(X,le){return ut.registerColorProvider(Me,gt(X),le)},registerFoldingRangeProvider(X,le){return ut.registerFoldingRangeProvider(Me,gt(X),le)},registerSelectionRangeProvider(X,le){return ut.registerSelectionRangeProvider(Me,X,le)},registerCallHierarchyProvider(X,le){return ut.registerCallHierarchyProvider(Me,X,le)},setLanguageConfiguration:(X,le)=>ut.setLanguageConfiguration(Me,X,le),getTokenInformationAtPosition(X,le){return(0,j.checkProposedApiEnabled)(Me),Tt.tokenAtPosition(X,le)},registerInlayHintsProvider(X,le){return(0,j.checkProposedApiEnabled)(Me),ut.registerInlayHintsProvider(Me,X,le)}},Fn={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(X,le,Te){const rt=await(I.URI.isUri(X)?Promise.resolve(vn.openTextDocument(X)):Promise.resolve(X));return At.showTextDocument(rt,le,Te)},createTextEditorDecorationType(X){return At.createTextEditorDecorationType(Me,X)},onDidChangeActiveTextEditor(X,le,Te){return At.onDidChangeActiveTextEditor(X,le,Te)},onDidChangeVisibleTextEditors(X,le,Te){return At.onDidChangeVisibleTextEditors(X,le,Te)},onDidChangeTextEditorSelection(X,le,Te){return At.onDidChangeTextEditorSelection(X,le,Te)},onDidChangeTextEditorOptions(X,le,Te){return At.onDidChangeTextEditorOptions(X,le,Te)},onDidChangeTextEditorVisibleRanges(X,le,Te){return At.onDidChangeTextEditorVisibleRanges(X,le,Te)},onDidChangeTextEditorViewColumn(X,le,Te){return At.onDidChangeTextEditorViewColumn(X,le,Te)},onDidCloseTerminal(X,le,Te){return bt.onDidCloseTerminal(X,le,Te)},onDidOpenTerminal(X,le,Te){return bt.onDidOpenTerminal(X,le,Te)},onDidChangeActiveTerminal(X,le,Te){return bt.onDidChangeActiveTerminal(X,le,Te)},onDidChangeTerminalDimensions(X,le,Te){return(0,j.checkProposedApiEnabled)(Me),bt.onDidChangeTerminalDimensions(X,le,Te)},onDidWriteTerminalData(X,le,Te){return(0,j.checkProposedApiEnabled)(Me),bt.onDidWriteTerminalData(X,le,Te)},get state(){return St.state},onDidChangeWindowState(X,le,Te){return St.onDidChangeWindowState(X,le,Te)},showInformationMessage(X,...le){return Bt.showMessage(Me,y.default.Info,X,le[0],le.slice(1))},showWarningMessage(X,...le){return Bt.showMessage(Me,y.default.Warning,X,le[0],le.slice(1))},showErrorMessage(X,...le){return Bt.showMessage(Me,y.default.Error,X,le[0],le.slice(1))},showQuickPick(X,le,Te){return xt.showQuickPick(X,!!Me.enableProposedApi,le,Te)},showWorkspaceFolderPick(X){return xt.showWorkspaceFolderPick(X)},showInputBox(X,le){return xt.showInput(X,le)},showOpenDialog(X){return Lt.showOpenDialog(X)},showSaveDialog(X){return Lt.showSaveDialog(X)},createStatusBarItem(X,le,Te){let rt,pt,Dt;return typeof X=="string"?(rt=X,pt=le,Dt=Te):(pt=X,Dt=le),fn.createStatusBarEntry(Me,rt,pt,Dt)},setStatusBarMessage(X,le){return fn.setStatusBarMessage(X,le)},withScmProgress(X){return ht.report("window.withScmProgress",Me,"Use 'withProgress' instead."),dn.withProgress(Me,{location:T.ProgressLocation.SourceControl},(le,Te)=>X({report(rt){}}))},withProgress(X,le){return dn.withProgress(Me,X,le)},createOutputChannel(X){return Kt.createOutputChannel(X,Me)},createWebviewPanel(X,le,Te,rt){return nn.createWebviewPanel(Me,X,le,Te,rt)},createWebviewTextEditorInset(X,le,Te,rt){return(0,j.checkProposedApiEnabled)(Me),Zt.createWebviewEditorInset(X,le,Te,rt,Me)},createTerminal(X,le,Te){return typeof X=="object"?"pty"in X?bt.createExtensionTerminal(X):bt.createTerminalFromOptions(X):bt.createTerminal(X,le,Te)},registerTerminalLinkProvider(X){return bt.registerLinkProvider(X)},registerTerminalProfileProvider(X,le){return bt.registerProfileProvider(Me,X,le)},registerTreeDataProvider(X,le){return jt.registerTreeDataProvider(X,le,Me)},createTreeView(X,le){return jt.createTreeView(X,le,Me)},registerWebviewPanelSerializer:(X,le)=>nn.registerWebviewPanelSerializer(Me,X,le),registerCustomEditorProvider:(X,le,Te={})=>Sn.registerCustomEditorProvider(Me,X,le,Te),registerFileDecorationProvider(X){return vt.registerFileDecorationProvider(X,Me.identifier)},registerUriHandler(X){return Ut.registerUriHandler(Me.identifier,X)},createQuickPick(){return xt.createQuickPick(Me.identifier,!!Me.enableProposedApi)},createInputBox(){return xt.createInputBox(Me.identifier)},get activeColorTheme(){return hn.activeColorTheme},onDidChangeActiveColorTheme(X,le,Te){return hn.onDidChangeActiveColorTheme(X,le,Te)},registerWebviewViewProvider(X,le,Te){return Dn.registerWebviewViewProvider(Me,X,le,Te?.webviewOptions)},get activeNotebookEditor(){return(0,j.checkProposedApiEnabled)(Me),mt.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,le,Te){return(0,j.checkProposedApiEnabled)(Me),mt.onDidChangeActiveNotebookEditor(X,le,Te)},get visibleNotebookEditors(){return(0,j.checkProposedApiEnabled)(Me),mt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,j.checkProposedApiEnabled)(Me),mt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,le,Te){return(0,j.checkProposedApiEnabled)(Me),zt.onDidChangeNotebookEditorSelection(X,le,Te)},onDidChangeNotebookEditorVisibleRanges(X,le,Te){return(0,j.checkProposedApiEnabled)(Me),zt.onDidChangeNotebookEditorVisibleRanges(X,le,Te)},showNotebookDocument(X,le){return(0,j.checkProposedApiEnabled)(Me),mt.showNotebookDocument(X,le)},registerExternalUriOpener(X,le,Te){return(0,j.checkProposedApiEnabled)(Me),Cn.registerExternalUriOpener(Me.identifier,X,le,Te)},get openEditors(){return(0,j.checkProposedApiEnabled)(Me),Et.tabs},get onDidChangeOpenEditors(){return(0,j.checkProposedApiEnabled)(Me),Et.onDidChangeTabs},getInlineCompletionItemController(X){return(0,j.checkProposedApiEnabled)(Me),p.InlineCompletionController.get(X)}},vn={get rootPath(){return ht.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),me.getPath()},set rootPath(X){throw F.readonly()},getWorkspaceFolder(X){return me.getWorkspaceFolder(X)},get workspaceFolders(){return me.getWorkspaceFolders()},get name(){return me.name},set name(X){throw F.readonly()},get workspaceFile(){return me.workspaceFile},set workspaceFile(X){throw F.readonly()},updateWorkspaceFolders:(X,le,...Te)=>me.updateWorkspaceFolders(Me,X,le||0,...Te),onDidChangeWorkspaceFolders:function(X,le,Te){return me.onDidChangeWorkspace(X,le,Te)},asRelativePath:(X,le)=>me.getRelativePath(X,le),findFiles:(X,le,Te,rt)=>me.findFiles(z.GlobPattern.from(X),z.GlobPattern.from(le),Te,Me.identifier,rt),findTextInFiles:(X,le,Te,rt)=>{let pt,Dt;return typeof le=="object"?(pt=le,Dt=Te):(pt={},Dt=le,rt=Te),me.findTextInFiles(X,pt||{},Dt,Me.identifier,rt)},saveAll:X=>me.saveAll(X),applyEdit(X){return rn.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,le,Te,rt)=>Rt.createFileSystemWatcher(z.GlobPattern.from(X),le,Te,rt),get textDocuments(){return kt.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw F.readonly()},openTextDocument(X){let le;const Te=X;if(typeof X=="string")le=Promise.resolve(I.URI.file(X));else if(I.URI.isUri(X))le=Promise.resolve(X);else if(!Te||typeof Te=="object")le=kt.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return le.then(rt=>kt.ensureDocumentData(rt).then(pt=>pt.document))},onDidOpenTextDocument:(X,le,Te)=>kt.onDidAddDocument(X,le,Te),onDidCloseTextDocument:(X,le,Te)=>kt.onDidRemoveDocument(X,le,Te),onDidChangeTextDocument:(X,le,Te)=>kt.onDidChangeDocument(X,le,Te),onDidSaveTextDocument:(X,le,Te)=>kt.onDidSaveDocument(X,le,Te),onWillSaveTextDocument:(X,le,Te)=>Yt.getOnWillSaveTextDocumentEvent(Me)(X,le,Te),get notebookDocuments(){return mt.notebookDocuments.map(X=>X.apiNotebook)},async openNotebookDocument(X,le){let Te;if(I.URI.isUri(X))Te=X,await mt.openNotebookDocument(X);else if(typeof X=="string")Te=I.URI.revive(await mt.createNotebookDocument({viewType:X,content:le}));else throw new Error("Invalid arguments");return mt.getNotebookDocument(Te).apiNotebook},get onDidOpenNotebookDocument(){return mt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return mt.onDidCloseNotebookDocument},registerNotebookSerializer(X,le,Te,rt){return mt.registerNotebookSerializer(Me,X,le,Te,Me.enableProposedApi?rt:void 0)},registerNotebookContentProvider:(X,le,Te,rt)=>((0,j.checkProposedApiEnabled)(Me),mt.registerNotebookContentProvider(Me,X,le,Te,Me.enableProposedApi?rt:void 0)),onDidChangeConfiguration:(X,le,Te)=>mn.onDidChangeConfiguration(X,le,Te),getConfiguration(X,le){return le=arguments.length===1?void 0:le,mn.getConfiguration(X,le,Me)},registerTextDocumentContentProvider(X,le){return Qt.registerTextDocumentContentProvider(X,le)},registerTaskProvider:(X,le)=>(ht.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),Pt.registerTaskProvider(Me,X,le)),registerFileSystemProvider(X,le,Te){return En.registerFileSystemProvider(Me.identifier,X,le,Te,Me.enableProposedApi)},get fs(){return ct.value},registerFileSearchProvider:(X,le)=>((0,j.checkProposedApiEnabled)(Me),Ot.registerFileSearchProvider(X,le)),registerTextSearchProvider:(X,le)=>((0,j.checkProposedApiEnabled)(Me),Ot.registerTextSearchProvider(X,le)),registerRemoteAuthorityResolver:(X,le)=>((0,j.checkProposedApiEnabled)(Me),wt.registerRemoteAuthorityResolver(X,le)),registerResourceLabelFormatter:X=>((0,j.checkProposedApiEnabled)(Me),yn.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,le,Te)=>Rt.onDidCreateFile(X,le,Te),onDidDeleteFiles:(X,le,Te)=>Rt.onDidDeleteFile(X,le,Te),onDidRenameFiles:(X,le,Te)=>Rt.onDidRenameFile(X,le,Te),onWillCreateFiles:(X,le,Te)=>Rt.getOnWillCreateFileEvent(Me)(X,le,Te),onWillDeleteFiles:(X,le,Te)=>Rt.getOnWillDeleteFileEvent(Me)(X,le,Te),onWillRenameFiles:(X,le,Te)=>Rt.getOnWillRenameFileEvent(Me)(X,le,Te),openTunnel:X=>((0,j.checkProposedApiEnabled)(Me),lt.openTunnel(Me,X).then(le=>{if(!le)throw new Error("cannot open tunnel");return le})),get tunnels(){return(0,j.checkProposedApiEnabled)(Me),lt.getTunnels()},onDidChangeTunnels:(X,le,Te)=>((0,j.checkProposedApiEnabled)(Me),lt.onDidChangeTunnels(X,le,Te)),registerPortAttributesProvider:(X,le)=>((0,j.checkProposedApiEnabled)(Me),lt.registerPortsAttributesProvider(X,le)),registerTimelineProvider:(X,le)=>((0,j.checkProposedApiEnabled)(Me),en.registerTimelineProvider(X,le,Me.identifier,dt.converter)),get isTrusted(){return me.trusted},requestWorkspaceTrust:X=>((0,j.checkProposedApiEnabled)(Me),me.requestWorkspaceTrust(X)),onDidGrantWorkspaceTrust:(X,le,Te)=>me.onDidGrantWorkspaceTrust(X,le,Te)},Mn={get inputBox(){return ht.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),cn.getLastInputBox(Me)},createSourceControl(X,le,Te){return cn.createSourceControl(Me,X,le,Te)}},Ln={createCommentController(X,le){return _n.createCommentController(Me,X,le)}},bn={get activeDebugSession(){return ft.activeDebugSession},get activeDebugConsole(){return ft.activeDebugConsole},get breakpoints(){return ft.breakpoints},onDidStartDebugSession(X,le,Te){return ft.onDidStartDebugSession(X,le,Te)},onDidTerminateDebugSession(X,le,Te){return ft.onDidTerminateDebugSession(X,le,Te)},onDidChangeActiveDebugSession(X,le,Te){return ft.onDidChangeActiveDebugSession(X,le,Te)},onDidReceiveDebugSessionCustomEvent(X,le,Te){return ft.onDidReceiveDebugSessionCustomEvent(X,le,Te)},onDidChangeBreakpoints(X,le,Te){return ft.onDidChangeBreakpoints(X,le,Te)},registerDebugConfigurationProvider(X,le,Te){return ft.registerDebugConfigurationProvider(X,le,Te||T.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,le){return ft.registerDebugAdapterDescriptorFactory(Me,X,le)},registerDebugAdapterTrackerFactory(X,le){return ft.registerDebugAdapterTrackerFactory(X,le)},startDebugging(X,le,Te){return!Te||typeof Te=="object"&&"configuration"in Te?ft.startDebugging(X,le,{parentSession:Te}):ft.startDebugging(X,le,Te||{})},stopDebugging(X){return ft.stopDebugging(X)},addBreakpoints(X){return ft.addBreakpoints(X)},removeBreakpoints(X){return ft.removeBreakpoints(X)},asDebugSourceUri(X,le){return ft.asDebugSourceUri(X,le)}},Nn={registerTaskProvider:(X,le)=>Pt.registerTaskProvider(Me,X,le),fetchTasks:X=>Pt.fetchTasks(X),executeTask:X=>Pt.executeTask(Me,X),get taskExecutions(){return Pt.taskExecutions},onDidStartTask:(X,le,Te)=>Pt.onDidStartTask(X,le,Te),onDidEndTask:(X,le,Te)=>Pt.onDidEndTask(X,le,Te),onDidStartTaskProcess:(X,le,Te)=>Pt.onDidStartTaskProcess(X,le,Te),onDidEndTaskProcess:(X,le,Te)=>Pt.onDidEndTaskProcess(X,le,Te)},an={createNotebookController(X,le,Te,rt,pt){return Jt.createNotebookController(Me,X,le,Te,rt,Me.enableProposedApi?pt:void 0)},registerNotebookCellStatusBarItemProvider:(X,le)=>mt.registerNotebookCellStatusBarItemProvider(Me,X,le),get onDidSaveNotebookDocument(){return(0,j.checkProposedApiEnabled)(Me),qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(X){return(0,j.checkProposedApiEnabled)(Me),zt.createNotebookEditorDecorationType(X)},createRendererMessaging(X){return(0,j.checkProposedApiEnabled)(Me),Xt.createRendererMessaging(X)},onDidChangeNotebookDocumentMetadata(X,le,Te){return(0,j.checkProposedApiEnabled)(Me),qt.onDidChangeNotebookDocumentMetadata(X,le,Te)},onDidChangeNotebookCells(X,le,Te){return(0,j.checkProposedApiEnabled)(Me),mt.onDidChangeNotebookCells(X,le,Te)},onDidChangeNotebookCellExecutionState(X,le,Te){return(0,j.checkProposedApiEnabled)(Me),mt.onDidChangeNotebookCellExecutionState(X,le,Te)},onDidChangeCellOutputs(X,le,Te){return(0,j.checkProposedApiEnabled)(Me),mt.onDidChangeCellOutputs(X,le,Te)},onDidChangeCellMetadata(X,le,Te){return(0,j.checkProposedApiEnabled)(Me),mt.onDidChangeCellMetadata(X,le,Te)},createConcatTextDocument(X,le){return(0,j.checkProposedApiEnabled)(Me),new ve.ExtHostNotebookConcatDocument(mt,kt,X,le)}};return{version:Ye.version,authentication:Pn,commands:An,comments:Ln,debug:bn,env:gn,extensions:Tn,languages:Rn,notebooks:an,scm:Mn,tasks:Nn,test:on,window:Fn,workspace:vn,Breakpoint:T.Breakpoint,CallHierarchyIncomingCall:T.CallHierarchyIncomingCall,CallHierarchyItem:T.CallHierarchyItem,CallHierarchyOutgoingCall:T.CallHierarchyOutgoingCall,CancellationError:F.CancellationError,CancellationTokenSource:m.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:T.CodeAction,CodeActionKind:T.CodeActionKind,CodeActionTriggerKind:T.CodeActionTriggerKind,CodeLens:T.CodeLens,Color:T.Color,ColorInformation:T.ColorInformation,ColorPresentation:T.ColorPresentation,ColorThemeKind:T.ColorThemeKind,CommentMode:T.CommentMode,CommentThreadCollapsibleState:T.CommentThreadCollapsibleState,CompletionItem:T.CompletionItem,CompletionItemKind:T.CompletionItemKind,CompletionItemTag:T.CompletionItemTag,CompletionList:T.CompletionList,CompletionTriggerKind:T.CompletionTriggerKind,ConfigurationTarget:T.ConfigurationTarget,CustomExecution:T.CustomExecution,DebugAdapterExecutable:T.DebugAdapterExecutable,DebugAdapterInlineImplementation:T.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:T.DebugAdapterNamedPipeServer,DebugAdapterServer:T.DebugAdapterServer,DebugConfigurationProviderTriggerKind:T.DebugConfigurationProviderTriggerKind,DebugConsoleMode:T.DebugConsoleMode,DecorationRangeBehavior:T.DecorationRangeBehavior,Diagnostic:T.Diagnostic,DiagnosticRelatedInformation:T.DiagnosticRelatedInformation,DiagnosticSeverity:T.DiagnosticSeverity,DiagnosticTag:T.DiagnosticTag,Disposable:T.Disposable,DocumentHighlight:T.DocumentHighlight,DocumentHighlightKind:T.DocumentHighlightKind,DocumentLink:T.DocumentLink,DocumentSymbol:T.DocumentSymbol,EndOfLine:T.EndOfLine,EnvironmentVariableMutatorType:T.EnvironmentVariableMutatorType,EvaluatableExpression:T.EvaluatableExpression,InlineValueText:T.InlineValueText,InlineValueVariableLookup:T.InlineValueVariableLookup,InlineValueEvaluatableExpression:T.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:T.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:T.ExtensionKind,ExtensionMode:T.ExtensionMode,ExternalUriOpenerPriority:T.ExternalUriOpenerPriority,FileChangeType:T.FileChangeType,FileDecoration:T.FileDecoration,FileSystemError:T.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:T.FoldingRange,FoldingRangeKind:T.FoldingRangeKind,FunctionBreakpoint:T.FunctionBreakpoint,InlineCompletionItem:T.InlineSuggestion,InlineCompletionList:T.InlineSuggestions,Hover:T.Hover,IndentAction:C.IndentAction,Location:T.Location,MarkdownString:T.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:T.ParameterInformation,PortAutoForwardAction:T.PortAutoForwardAction,Position:T.Position,ProcessExecution:T.ProcessExecution,ProgressLocation:T.ProgressLocation,QuickInputButtons:T.QuickInputButtons,Range:T.Range,RelativePattern:T.RelativePattern,Selection:T.Selection,SelectionRange:T.SelectionRange,SemanticTokens:T.SemanticTokens,SemanticTokensBuilder:T.SemanticTokensBuilder,SemanticTokensEdit:T.SemanticTokensEdit,SemanticTokensEdits:T.SemanticTokensEdits,SemanticTokensLegend:T.SemanticTokensLegend,ShellExecution:T.ShellExecution,ShellQuoting:T.ShellQuoting,SignatureHelp:T.SignatureHelp,SignatureHelpTriggerKind:T.SignatureHelpTriggerKind,SignatureInformation:T.SignatureInformation,SnippetString:T.SnippetString,SourceBreakpoint:T.SourceBreakpoint,StandardTokenType:T.StandardTokenType,StatusBarAlignment:T.StatusBarAlignment,SymbolInformation:T.SymbolInformation,SymbolKind:T.SymbolKind,SymbolTag:T.SymbolTag,Task:T.Task,TaskGroup:T.TaskGroup,TaskPanelKind:T.TaskPanelKind,TaskRevealKind:T.TaskRevealKind,TaskScope:T.TaskScope,TerminalLink:T.TerminalLink,TerminalProfile:T.TerminalProfile,TextDocumentSaveReason:T.TextDocumentSaveReason,TextEdit:T.TextEdit,TextEditorCursorStyle:S.TextEditorCursorStyle,TextEditorLineNumbersStyle:T.TextEditorLineNumbersStyle,TextEditorRevealType:T.TextEditorRevealType,TextEditorSelectionChangeKind:T.TextEditorSelectionChangeKind,TextDocumentChangeReason:T.TextDocumentChangeReason,ThemeColor:T.ThemeColor,ThemeIcon:T.ThemeIcon,TreeItem:T.TreeItem,TreeItemCollapsibleState:T.TreeItemCollapsibleState,UIKind:l.UIKind,Uri:I.URI,ViewColumn:T.ViewColumn,WorkspaceEdit:T.WorkspaceEdit,InlayHint:T.InlayHint,InlayHintKind:T.InlayHintKind,RemoteAuthorityResolverError:T.RemoteAuthorityResolverError,ResolvedAuthority:T.ResolvedAuthority,SourceControlInputBoxValidationType:T.SourceControlInputBoxValidationType,ExtensionRuntime:T.ExtensionRuntime,TimelineItem:T.TimelineItem,NotebookRange:T.NotebookRange,NotebookCellKind:T.NotebookCellKind,NotebookCellExecutionState:T.NotebookCellExecutionState,NotebookCellData:T.NotebookCellData,NotebookData:T.NotebookData,NotebookRendererScript:T.NotebookRendererScript,NotebookCellStatusBarAlignment:T.NotebookCellStatusBarAlignment,NotebookEditorRevealType:T.NotebookEditorRevealType,NotebookCellOutput:T.NotebookCellOutput,NotebookCellOutputItem:T.NotebookCellOutputItem,NotebookCellStatusBarItem:T.NotebookCellStatusBarItem,NotebookControllerAffinity:T.NotebookControllerAffinity,PortAttributes:T.PortAttributes,LinkedEditingRanges:T.LinkedEditingRanges,TestResultState:T.TestResultState,TestRunRequest:T.TestRunRequest,TestMessage:T.TestMessage,TestRunConfigurationGroup:T.TestRunConfigurationGroup,TextSearchCompleteMessageType:ge.TextSearchCompleteMessageType,TestMessageSeverity:T.TestMessageSeverity,CoveredCount:T.CoveredCount,FileCoverage:T.FileCoverage,StatementCoverage:T.StatementCoverage,BranchCoverage:T.BranchCoverage,FunctionCoverage:T.FunctionCoverage,WorkspaceTrustState:T.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Ze}),define(_e[224],ye([0,1,57,102,32,101,33,72,46,37,105,106,107,74,66,71,103,73,45,70,94,64]),function(ee,e,m,F,D,y,I,S,_,C,n,k,l,h,a,d,f,E,w,u,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(d.IExtHostApiDeprecationService,d.ExtHostApiDeprecationService),(0,m.registerSingleton)(S.IExtHostCommands,S.ExtHostCommands),(0,m.registerSingleton)(I.IExtHostConfiguration,I.ExtHostConfiguration),(0,m.registerSingleton)(E.IExtHostConsumerFileSystem,E.ExtHostConsumerFileSystem),(0,m.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService),(0,m.registerSingleton)(y.IExtHostDecorations,y.ExtHostDecorations),(0,m.registerSingleton)(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors),(0,m.registerSingleton)(w.IExtHostFileSystemInfo,w.ExtHostFileSystemInfo),(0,m.registerSingleton)(F.IExtHostOutputService,F.ExtHostOutputService),(0,m.registerSingleton)(l.IExtHostSearch,l.ExtHostSearch),(0,m.registerSingleton)(h.IExtHostStorage,h.ExtHostStorage),(0,m.registerSingleton)(n.IExtHostTask,n.WorkerExtHostTask),(0,m.registerSingleton)(C.IExtHostTerminalService,C.WorkerExtHostTerminalService),(0,m.registerSingleton)(a.IExtHostTunnelService,a.ExtHostTunnelService),(0,m.registerSingleton)(f.IExtHostWindow,f.ExtHostWindow),(0,m.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace),(0,m.registerSingleton)(u.IExtHostSecretState,u.ExtHostSecretState),(0,m.registerSingleton)(g.IExtHostTelemetry,g.ExtHostTelemetry),(0,m.registerSingleton)(b.IExtHostEditorTabs,b.ExtHostEditorTabs)}),define(_e[225],ye([0,1,223,34,219,6,16,5,11]),function(ee,e,m,F,D,y,I,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var C;(function(a){const d=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(E,...w)=>{w.forEach(t=>{if(!self.trustedTypes?.isScript(t))throw new Error("TrustedScripts only, please")});const u=w.slice(0,-1).join(","),g=w.pop().toString();return`(function anonymous(${u}) {
${g}
})`}});function f(...E){return d?self.eval(d.createScript("",...E)):new Function(...E)}a.create=f})(C||(C={}));class n extends D.RequireInterceptor{_installInterceptor(){}getModule(d,f){for(let E of this._alternatives){let w=E(d);if(w){d=w;break}}if(this._factories.has(d))return this._factories.get(d).load(d,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class k extends F.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=y.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const d=this._extHostContext.getProxy(S.MainContext.MainThreadConsole);h(d,this._initData.environment.isExtensionDevelopmentDebug);const f=this._instaService.invokeFunction(m.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(n,f,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(d){return d.browser}async _loadCommonJSModule(d,f,E){f=f.with({path:l(f.path,".js")}),d&&performance.mark(`code/extHost/willFetchExtensionCode/${d.value}`);const w=await fetch(_.FileAccess.asBrowserUri(f).toString(!0));if(d&&performance.mark(`code/extHost/didFetchExtensionCode/${d.value}`),w.status!==200)throw new Error(w.statusText);const u=await w.text(),g=`${f.toString(!0)}#vscode-extension`,b=`${u}
//# sourceURL=${g}`;let t;try{t=C.create(k._ttpExtensionScripts?.createScript("module")??"module",k._ttpExtensionScripts?.createScript("exports")??"exports",k._ttpExtensionScripts?.createScript("require")??"require",k._ttpExtensionScripts?.createScript(b)??b)}catch(c){throw console.error(d?`Loading code for extension ${d.value} failed: ${c.message}`:`Loading code failed: ${c.message}`),console.error(`${f.toString(!0)}${typeof c.line=="number"?` line ${c.line}`:""}${typeof c.column=="number"?` column ${c.column}`:""}`),console.error(c),c}const s={},i={exports:s},r=c=>{const p=this._fakeModules.getModule(c,f);if(p===void 0)throw new Error(`Cannot load module '${c}'`);return p};try{return E.codeLoadingStart(),d&&performance.mark(`code/extHost/willLoadExtensionCode/${d.value}`),t(i,s,r),i.exports!==s?i.exports:s}finally{d&&performance.mark(`code/extHost/didLoadExtensionCode/${d.value}`),E.codeLoadingStop()}}async $setRemoteEnvironment(d){throw new Error("Not supported")}async _waitForDebuggerAttachment(d=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+d;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,I.timeout)(10)}}e.ExtHostExtensionService=k,k._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:a=>a});function l(a,d){return a.endsWith(d)?a:a+d}function h(a,d){f("info","log"),f("log","log"),f("warn","warn"),f("error","error");function f(u,g){const b=console[u];console[u]=function(){a.$logExtensionHostMessage({type:"__$console",severity:g,arguments:w(arguments)}),d&&b.apply(console,arguments)}}const E=1e5;function w(u){const g=[],b=[];if(u.length)for(let t=0;t<u.length;t++){if(typeof u[t]=="undefined")u[t]="undefined";else if(u[t]instanceof Error){const s=u[t];s.stack?u[t]=s.stack:u[t]=s.toString()}b.push(u[t])}try{const t=JSON.stringify(b,function(s,i){if(i&&typeof i=="object"){if(g.indexOf(i)!==-1)return"[Circular]";g.push(i)}return i});return t.length>E?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(_e[226],ye([0,1,57,15,34,75,225,212]),function(ee,e,m,F,D,y,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(D.IExtHostExtensionService,I.ExtHostExtensionService),(0,m.registerSingleton)(F.ILogService,S.ExtHostLogService),(0,m.registerSingleton)(y.IExtensionStoragePaths,y.ExtensionStoragePaths)}),define(_e[228],ye([0,1,23,3,180,220,214,14,76,11,2,224,226]),function(ee,e,m,F,D,y,I,S,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const w=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:g=>g}),u=self.Worker;Worker=function(g,b){/^file:/i.test(g.toString())&&(g=C.FileAccess.asBrowserUri(n.URI.parse(g.toString())).toString(!0));const t=`(function() {
	const ttPolicy = self.trustedTypes ? self.trustedTypes.createPolicy('extensionHostWorker', { createScriptURL: (value) => value }) : undefined;
	const stringUrl = '${g}';
	importScripts(ttPolicy ? ttPolicy.createScriptURL(stringUrl) : stringUrl);
})();
`;b=b||{},b.name=b.name||S.basename(g.toString());const s=new Blob([t],{type:"application/javascript"}),i=URL.createObjectURL(s);return new u(w?w.createScriptURL(i):i,b)}}else self.Worker=class extends I.NestedWorker{constructor(w,u){super(l,w,{name:S.basename(w.toString()),...u})}};const h=new class{exit(w){k()}async exists(w){return!0}async realpath(w){return w}};class a{constructor(){const u=new MessageChannel,g=new F.Emitter;let b=!1;l(u.port2,[u.port2]),u.port1.onmessage=t=>{const{data:s}=t;if(!(s instanceof ArrayBuffer)){console.warn("UNKNOWN data received",s);return}const i=m.VSBuffer.wrap(new Uint8Array(s,0,s.byteLength));if((0,D.isMessageOfType)(i,2)){b=!0,f("received terminate message from renderer");return}g.fire(i)},this.protocol={onMessage:g.event,send:t=>{if(!b){const s=t.buffer.buffer.slice(t.buffer.byteOffset,t.buffer.byteOffset+t.buffer.byteLength);u.port1.postMessage(s,[s])}}}}}function d(w){return new Promise(u=>{const g=w.onMessage(b=>{g.dispose();const t=JSON.parse(b.toString());w.send((0,D.createMessageOfType)(0)),u({protocol:w,initData:t})});w.send((0,D.createMessageOfType)(1))})}let f=w=>k();function E(){const w=new a;_.mark("code/extHost/willConnectToRenderer"),d(w.protocol).then(u=>{_.mark("code/extHost/didWaitForInitData");const g=new y.ExtensionHostMain(u.protocol,u.initData,h,null);f=b=>g.terminate(b)})}e.create=E})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/50b3811fdc5b5c80ca516a2edfffedcbd464b033/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
